/* 20080816 */
/* agregar grupo, subg y marca a la revisin para filtrar */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE REVISA_PRECIOS(
    LISTA INTEGER,
    FECHA DATE)
RETURNS (
    ARTICULO VARCHAR(20),
    DESCR VARCHAR(60),
    GRUPO VARCHAR(2),
    SUBGRUPO VARCHAR(3),
    MARCA VARCHAR(3),
    FIJO NUMERIC(18,2),
    UNIDAD VARCHAR(8),
    PORC NUMERIC(9,4),
    SUGERIDO NUMERIC(18,2),
    DIFER NUMERIC(18,2),
    NUEVO NUMERIC(18,2),
    OK CHAR(1))
AS
declare variable marg numeric(9,4);
declare variable UOM VARCHAR(10);
declare variable BASE VARCHAR(10);
declare variable CAMBIO VARCHAR(10);
declare variable COSTO numeric(18,2);
declare variable COSTOP numeric(18,2);
declare variable COSTOU numeric(18,2);
declare variable DIFMAX numeric(18,2);
declare variable DIG INTEGER;
declare variable TARIVA NUMERIC(9,4);
declare variable IVAINC CHAR(1);
declare variable LISTAREF INTEGER;
begin
execute procedure lee_configuracion ('FACTURACION', 'ARTICULOS', 'SUGERIR PRECIOS CON PORCENTAJE DE MARGEN O UTILIDAD') returning_values (:UOM);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'ARTICULOS', 'REDONDEO AL MULTIPLO DE DIEZ EN PRECIOS') RETURNING_VALUES (:DIG);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','CAMBIO DE PRECIOS AUTOMATICO AL CAMBIAR COSTO O PRECIO') returning_values (CAMBIO);
EXECUTE PROCEDURE lee_configuracion('FACTURACION','ARTICULOS','COSTO BASE PARA CALCULO DE PRECIOS DE VENTA AUTOMATICOS') returning_values (:BASE);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','CODIGO DE LA LISTA DE PRECIOS BASE PARA CAMBIO DE PRECIOS AUTOMATICO') returning_values (LISTAREF);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','DIFERENCIA EN PESOS MAXIMA A PERMITIR PARA CAMBIAR PRECIOS') returning_values (DIFMAX);
for select A.arti_cod, A.arti_des, A.grup_cod, A.subg_cod, A.marc_cod, A.arti_unidad, prar_fijo, prar_margen, prar_util, TAIV_PORC
    from precios_articulo p, articulo a, tarifa_iva T
    where a.arti_cod = p.arti_cod and lipr_cod = :lista and a.taiv_cod = t.taiv_cod order by A.arti_cod
    into :articulo, descr, :grupo, :subgrupo, :marca, :unidad, :fijo, :marg, :porc, :tariva
    do
    begin
    if (UOM <> 'UTILIDAD') then
        PORC = MARG;
    if (CAMBIO = 'COSTO') then
        BEGIN
        EXECUTE PROCEDURE COSTO_PROMEDIO (:ARTICULO, :FECHA) RETURNING_VALUES(:COSTOP);
        EXECUTE PROCEDURE ULTIMO_COSTO (:ARTICULO, :FECHA, :UNIDAD) RETURNING_VALUES(:COSTOU);
        if (base = 'ULTIMO') then
            COSTO = COSTOU;
        ELSE
            BEGIN
            COSTO = COSTOP;
            if (base = 'MAYOR') then
                if (COSTOP < COSTOU) then
                    COSTO = COSTOU;
            END
        SELECT LIPR_MODIF FROM LISTA_PRECIOS WHERE LIPR_COD = :lista INTO :IVAINC;
        if (IVAINC = 'S') then
            COSTO = COSTO * (1 + TARIVA/100);
        if (UOM = 'UTILIDAD') then
            SUGERIDO = COSTO * (1 + :PORC/100);
        ELSE
            SUGERIDO = COSTO / (1 - :PORC/100);
        END
    ELSE
        if (LISTA <> LISTAREF) then
            BEGIN
            SELECT PRAR_FIJO FROM PRECIOS_ARTICULO WHERE ARTI_COD = :articulo AND LIPR_COD = :LISTAREF INTO :SUGERIDO;
            if (IVAINC = 'S') then
                SUGERIDO = SUGERIDO / (1 + TARIVA/100);
            if (UOM = 'UTILIDAD') then
                SUGERIDO = SUGERIDO * (1 + :PORC/100);
            ELSE
                SUGERIDO = SUGERIDO / (1 - :PORC/100);
            END
    EXECUTE PROCEDURE REDONDEE (SUGERIDO, DIG) returning_values (SUGERIDO);
    DIFER = SUGERIDO - FIJO;
    NUEVO = SUGERIDO;
    OK = 'S';
    if ((abs(DIFER) > DIFMAX) and (sugerido <> 0)) then
        suspend;
    end
end
^

SET TERM ; ^

GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO PROCEDURE REVISA_PRECIOS;
GRANT SELECT ON PRECIOS_ARTICULO TO PROCEDURE REVISA_PRECIOS;
GRANT SELECT ON ARTICULO TO PROCEDURE REVISA_PRECIOS;
GRANT SELECT ON TARIFA_IVA TO PROCEDURE REVISA_PRECIOS;
GRANT EXECUTE ON PROCEDURE COSTO_PROMEDIO TO PROCEDURE REVISA_PRECIOS;
GRANT EXECUTE ON PROCEDURE ULTIMO_COSTO TO PROCEDURE REVISA_PRECIOS;
GRANT SELECT ON LISTA_PRECIOS TO PROCEDURE REVISA_PRECIOS;
GRANT EXECUTE ON PROCEDURE REDONDEE TO PROCEDURE REVISA_PRECIOS;

/* AGREGAR IMPOCONSUMO A IMPORTACION DE INVENTARIO */
INSERT INTO IMPORTACION_INVENTARIO (IMIN_TIPO, IMIN_DATO, IMIN_COLUMNA, IMIN_ANCHO) VALUES (3, 'ENDE_CONSUMO', 8, 20);
COMMIT WORK;
INSERT INTO NOMBRES_CAMPOS (NOMBRE, DESCRIPCION) VALUES ('ENDE_CONSUMO', 'Impuesto al consumo');
commit work;

/* busquedas de clientes */
INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('CARTERA', 'GENERAL', 'FORMA DE HACER LAS BUSQUEDAS DE CLIENTES DE VARIAS PALABRAS', 'TODAS', 'EXACTA,TODAS,CUALQUIERA', 'EXACTA: Trae los clientes con exactamente las palabras en el orden dado. TODAS: Trae los clientes con todas las palabras sin importar el orden. CUALQUIERA: Trae los clientes que tengan al menos una de las palabras');
COMMIT WORK;

/* INICIALIZAR DEVT_REMID = 0 PARA QUE LOS REPORTES DE VENTAS NO INCLUYAN LAS DEV. DE REMISIONES */
SET TERM ^ ;

CREATE OR ALTER TRIGGER DEVOLUCIONES_VENTAS_BI FOR DEVOLUCIONES_VENTAS
ACTIVE BEFORE INSERT POSITION 0
AS
declare variable NUMERO VARCHAR(6);
declare variable AUTOM CHAR(1);
declare variable EXISTE CHAR(1);
declare variable SITOT CHAR(2);
declare variable CODCOBR INTEGER;
declare variable CODVEND INTEGER;
BEGIN
if (new.devt_remid is null) then
    NEW.devt_remid = 0;
execute procedure LEE_CONFIGURACION ('FACTURACION','DEVOLUCIONES','PERMITIR DEVOLVER ITEMS NO FACTURADOS') returning_values (:SITOT);
if ((SITOT = 'NO') AND (NEW.devt_factid = 0)) then
    exception factura_no_existe;
/* CALCULE LA COMISION CON BASE EN LA FACTURA */
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'VENDEDORES', 'COMISIONES EN VENTA INCLUYENDO IMPUESTOS') returning_values (:SITOT);
SELECT FACT_COMIPORC FROM FACTURAS WHERE FACT_ID = NEW.devt_factid INTO NEW.devt_comiporc;
if (NEW.devt_comiporc IS NULL) then
    NEW.devt_comiporc = 0;

if (SITOT = 'SI') then
    NEW.devt_comimonto = NEW.devt_total * NEW.devt_comiporc / 100;
ELSE
    NEW.devt_comimonto = (NEW.devt_total - NEW.devt_ivamonto) * NEW.devt_comiporc / 100;

if (NEW.numok = 'N') then
  BEGIN
  /* Actualice el contador del prefijo */
  SELECT PREF_ACTUAL, PREF_AUTO FROM PREFIJOS WHERE TIDO_COD = 33 AND PREF_PRE = NEW.PREF_PRE INTO :NUMERO, :AUTOM;
  /* ACTUALICE EL NUMERO EN COMPROBANTE_ENCABEZADO  */
  if (AUTOM = 'S') then
    BEGIN
    NEW.DEVT_NUMERO = NUMERO;
    NUMERO = CAST((CAST(NUMERO AS INTEGER) + 1) AS CHAR(6));
    UPDATE PREFIJOS
      SET PREF_ACTUAL = :NUMERO
    WHERE TIDO_COD = 33 AND PREF_PRE = NEW.PREF_PRE;
    END
  ELSE
    BEGIN
    if (CAST(NUMERO AS INTEGER) = CAST(NEW.DEVT_NUMERO AS INTEGER)) then
        UPDATE PREFIJOS
          SET PREF_ACTUAL = CAST((CAST(PREF_ACTUAL AS INTEGER) + 1) AS CHAR(6))
        WHERE TIDO_COD = 33 AND PREF_PRE = NEW.PREF_PRE;
    END
  EXECUTE PROCEDURE COMPLETA_CEROS (NEW.DEVT_numero) returning_values (NEW.DEVT_numero);
  NEW.numok = 'S';
  END
/* Verifique que el numero no existe previamente */
EXISTE = 'N';
SELECT 'S' FROM DEVOLUCIONES_VENTAS WHERE PREF_PRE = NEW.PREF_PRE AND DEVT_NUMERO = NEW.DEVT_NUMERO INTO :EXISTE;
if (EXISTE = 'S') then
    EXCEPTION DOCUMENTO_REGISTRADO;
select COBR_COD, VEND_COD FROM CLIENTES WHERE TERC_NIT = NEW.terc_nit INTO :CODCOBR, CODVEND;
if (NEW.cobr_cod IS NULL) then
    NEW.cobr_cod = :CODCOBR;
if (NEW.vend_cod IS NULL) then
    NEW.vend_cod = :CODVEND;
if ((new.DEVT_TOTAL-new.DEVT_IVAMONTO+new.DEVT_DTOMONTO-new.DEVT_ADICIONAL) = 0) then
    NEW.DEVT_FACTOR = 1;
else
    NEW.DEVT_FACTOR = (new.DEVT_TOTAL-new.DEVT_IVAMONTO)/(new.DEVT_TOTAL-new.DEVT_IVAMONTO+new.DEVT_DTOMONTO-new.DEVT_ADICIONAL);
END
^

SET TERM ; ^

GRANT SELECT,UPDATE,REFERENCES ON DEVOLUCIONES_VENTAS TO TRIGGER DEVOLUCIONES_VENTAS_BI;
GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO TRIGGER DEVOLUCIONES_VENTAS_BI;
GRANT SELECT ON FACTURAS TO TRIGGER DEVOLUCIONES_VENTAS_BI;
GRANT SELECT,UPDATE ON PREFIJOS TO TRIGGER DEVOLUCIONES_VENTAS_BI;
GRANT EXECUTE ON PROCEDURE COMPLETA_CEROS TO TRIGGER DEVOLUCIONES_VENTAS_BI;
GRANT SELECT ON CLIENTES TO TRIGGER DEVOLUCIONES_VENTAS_BI;

/* AGREGAR CONTACTO A CONSULTA DE CARTERA PARA PODER UBICAR POR RAZON SOCIAL */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE MOVIMIENTO_CARTERA_MES(
    FECINI DATE,
    FECFIN DATE,
    SUBEMPRESA INTEGER,
    CONTADO CHAR(1))
RETURNS (
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    CONTACTO VARCHAR(60),
    INICIAL NUMERIC(18,2),
    DEBITOS NUMERIC(18,2),
    CREDITOS NUMERIC(18,2),
    ABONOS NUMERIC(18,2),
    FINAL NUMERIC(18,2))
AS
declare variable RETES CHAR(2);
declare variable TIPODOC INTEGER;
declare variable IDDOC INTEGER;
declare variable SALDO NUMERIC(18,2);
declare variable NUMROWS INTEGER;
BEGIN
  for select TERC_NIT, TERC_NOM, TERC_CONTACTO from TERCEROS WHERE TERC_CLIE = 'S' into :NIT, :NOMBRE, :CONTACTO
  DO
    BEGIN
    SELECT COUNT(*) FROM AUTORIZACIONES WHERE AUTO_NITCONTADO = :NIT INTO :numrows;
    IF ((CONTADO = 'S') or (numrows = 0)) THEN
        BEGIN
        FECINI = FECINI - 1;
        INICIAL = 0;
        FOR SELECT MVCL_TIPOREF, MVCL_IDREF FROM MOVIMIENTO_CLIENTES
            WHERE TERC_NIT = :NIT AND MVCL_FECHA <= :FECINI AND
            MVCL_ABONO = 'N' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
            INTO :TIPODOC, :IDDOC
            DO
            BEGIN
            EXECUTE PROCEDURE saldo_doc_cartera(TIPODOC, IDDOC, FECINI) returning_values (SALDO);
            INICIAL = INICIAL + SALDO;
            END
        EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'DESCONTAR RETENCIONES POR CAUSACION') returning_values(:RETES);
        FECINI = FECINI + 1;
        if (RETES = 'SI') then
            BEGIN
            SELECT SUM(MVCL_MONTO-MVCL_RTEFTE-MVCL_RTEIVA-MVCL_RTEICA) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_DEBITO = 'S' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :DEBITOS;
            SELECT SUM(MVCL_MONTO-MVCL_RTEFTE-MVCL_RTEIVA-MVCL_RTEICA) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_DEBITO = 'N' AND MVCL_ABONO = 'N' and MVCL_TIPOREF <> 45 AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :CREDITOS;
            SELECT SUM(MVCL_MONTO) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_ABONO = 'S' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :ABONOS;
            END
        ELSE
            BEGIN
            SELECT SUM(MVCL_MONTO) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_DEBITO = 'S' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :DEBITOS;
            SELECT SUM(MVCL_MONTO) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_DEBITO = 'N' AND MVCL_ABONO = 'N' and MVCL_TIPOREF <> 45 AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :CREDITOS;
            SELECT SUM(MVCL_MONTO+MVCL_RTEFTE+MVCL_RTEIVA+MVCL_RTEICA) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_ABONO = 'S' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :ABONOS;
            END
        if (DEBITOS IS NULL) then
            DEBITOS = 0;
        if (CREDITOS IS NULL) then
            CREDITOS = 0;
        if (ABONOS IS NULL) then
            ABONOS = 0;
        FINAL = INICIAL + DEBITOS - CREDITOS - ABONOS;
        SUSPEND;
        END
    END
END
^

SET TERM ; ^

GRANT SELECT ON TERCEROS TO PROCEDURE MOVIMIENTO_CARTERA_MES;
GRANT SELECT ON AUTORIZACIONES TO PROCEDURE MOVIMIENTO_CARTERA_MES;
GRANT SELECT ON MOVIMIENTO_CLIENTES TO PROCEDURE MOVIMIENTO_CARTERA_MES;
GRANT EXECUTE ON PROCEDURE SALDO_DOC_CARTERA TO PROCEDURE MOVIMIENTO_CARTERA_MES;
GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO PROCEDURE MOVIMIENTO_CARTERA_MES;

/* no permitir cantidades mayores a las ordenadas */

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('COMPRAS', 'FACTURAS', 'PERMITIR CANTIDADES MAYORES A LAS ORDENADAS', 'NO', 'SI,NO', 'NO: Impide que se digiten cantidades mayores a las unidades perviamente ordenadas.');
commit work;

/* INACTIVAR CODIGOS DE BARRAS */
ALTER TABLE BARRAS_ARTICULO ADD COBA_ACTIVO T_BOOLEANO;

update barras_articulo set COBA_ACTIVO = 'S';
COMMIT WORK;

SET TERM ^ ;

CREATE OR ALTER TRIGGER TI_BARRAS_ARTICULO FOR BARRAS_ARTICULO
ACTIVE BEFORE INSERT POSITION 0
AS
DECLARE VARIABLE NUMROWS INTEGER;
BEGIN
if (NEW.coba_activo IS NULL) then
    NEW.coba_activo = 'S';
    /*  PARENT 'ARTICULO' MUST EXIST WHEN INSERTING A CHILD IN 'BARRAS_ARTICULO'  */
    IF (NEW.ARTI_COD IS NOT NULL) THEN
    BEGIN
       SELECT COUNT(*)
       FROM   ARTICULO
       WHERE  ARTICULO.ARTI_COD = NEW.ARTI_COD
       INTO   :NUMROWS;
       IF (NUMROWS = 0) THEN
       BEGIN
          EXCEPTION ARTICULO_NO_EXISTE;
       END
    END
END
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON BARRAS_ARTICULO TO TRIGGER TI_BARRAS_ARTICULO;
GRANT SELECT ON ARTICULO TO TRIGGER TI_BARRAS_ARTICULO;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE VALIDE_ARTICULO(
    CODIGO VARCHAR(15))
RETURNS (
    TIPO CHAR(1),
    DESCRIPCION VARCHAR(60),
    UNIDAD VARCHAR(8),
    ID VARCHAR(15),
    LOTE CHAR(1))
AS
BEGIN
  TIPO = '0';
  DESCRIPCION = '';
  UNIDAD = '';
  LOTE = '';
  /* Busquelo como cdigo de barras */
  SELECT FIRST 1 '1', B.ARTI_COD, COBA_DES,COBA_UNIDAD, ARTI_EXIST
        from BARRAS_ARTICULO B, ARTICULO A
        WHERE B.ARTI_COD = A.ARTI_COD AND COBA_COD = :CODIGO AND COBA_ACTIVO = 'S'
        INTO :TIPO, :ID, :DESCRIPCION, :UNIDAD, :LOTE;
  if (TIPO <> '1') then
    SELECT '2', ARTI_COD, ARTI_DES, ARTI_UNIDAD, ARTI_EXIST
        FROM ARTICULO
        WHERE ARTI_COD = :CODIGO
        INTO :TIPO, :ID, :DESCRIPCION, :UNIDAD, :LOTE;
  SUSPEND;
END
^

SET TERM ; ^

GRANT SELECT ON BARRAS_ARTICULO TO PROCEDURE VALIDE_ARTICULO;
GRANT SELECT ON ARTICULO TO PROCEDURE VALIDE_ARTICULO;

/* ORDEN SUGERIDA CON F7 */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE ORDEN_SUGERIDA(
    PROVEEDOR VARCHAR(20),
    FECHA DATE)
RETURNS (
    ARTICULO VARCHAR(15),
    BODEGA VARCHAR(2),
    CANT NUMERIC(18,4),
    UNIDAD VARCHAR(8),
    COSTO NUMERIC(18,2))
AS
declare variable FACTOR NUMERIC(15,4);
declare variable DIAS INTEGER;
declare variable EXISTENCIA NUMERIC(18,4);
declare variable PROMEDIO NUMERIC(18,4);
declare variable AGENCIA INTEGER;
declare variable DIA_ART VARCHAR(2) CHARACTER SET NONE;
declare variable DIASC VARCHAR(255);
declare variable SALIDAS NUMERIC(18,4);
BEGIN
FOR SELECT ARTI_COD, PVAR_COSTO FROM proveedor_articulo WHERE TERC_NIT = :proveedor INTO :articulo, :costo
  DO BEGIN
  for select bode_cod, SUCU_ID from bodega into :bodega, :agencia
    do
    begin
    SELECT ARTI_UNIDAD FROM ARTICULO WHERE ARTI_COD = :articulo INTO :unidad;
    execute procedure saldo_inventario (:articulo, :bodega, :fecha) returning_values (:Existencia);
    EXECUTE PROCEDURE FACTOR_UNIDAD_CANT(:ARTICULO, :UNIDAD) returning_values (:FACTOR);
    if (FACTOR <> 0) then
        EXISTENCIA = EXISTENCIA / FACTOR;
    else
        EXISTENCIA = 0;
    EXECUTE PROCEDURE promedio_salidas_articulo (:ARTICULO, :FECHA, :BODEGA) returning_values (:PROMEDIO, :SALIDAS);
    EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'PROMEDIAR LAS SALIDAS DEL INVENTARIO CON EL NUMERO DE DIAS ASIGNADO A CADA ARTICULO') returning_values (:DIA_ART);
    if (DIA_ART = 'NO') then
        BEGIN
        EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'NUMERO DE DIAS PARA PROMEDIO DE SALIDAS POR ARTICULO') returning_values (DIASC);
        DIAS = CAST(DIASC AS INTEGER);
        END
    ELSE
        SELECT ARTI_DIAS FROM ARTICULO WHERE ARTI_COD = :ARTICULO INTO :DIAS;
    if (DIAS is null) then
        DIAS = 0;
    PROMEDIO = DIAS * PROMEDIO;
    if (FACTOR <> 0) then
        PROMEDIO = PROMEDIO / FACTOR;
    CANT = PROMEDIO - EXISTENCIA;
    if (CANT > 0) then
        SUSPEND;
    end
  END
END
^

SET TERM ; ^

GRANT SELECT ON PROVEEDOR_ARTICULO TO PROCEDURE ORDEN_SUGERIDA;
GRANT SELECT ON BODEGA TO PROCEDURE ORDEN_SUGERIDA;
GRANT SELECT ON ARTICULO TO PROCEDURE ORDEN_SUGERIDA;
GRANT EXECUTE ON PROCEDURE SALDO_INVENTARIO TO PROCEDURE ORDEN_SUGERIDA;
GRANT EXECUTE ON PROCEDURE FACTOR_UNIDAD_CANT TO PROCEDURE ORDEN_SUGERIDA;
GRANT EXECUTE ON PROCEDURE PROMEDIO_SALIDAS_ARTICULO TO PROCEDURE ORDEN_SUGERIDA;
GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO PROCEDURE ORDEN_SUGERIDA;
grant EXECUTE on PROCEDURE ORDEN_SUGERIDA to PUBLIC;

/* 20080819 */
CREATE TABLE CONCILIACION_ENCABEZADO (
    COBN_ID T_ID NOT NULL,
    COBN_PREFIJO VARCHAR(4),
    COBN_NUMERO T_NUMDOC,
    COBN_FECHA DATE,
    COBN_CONCEPTO T_CONCEPTO);
alter table CONCILIACION_ENCABEZADO add constraint PK_CONCILIACION_ENCABEZADO primary key (COBN_ID);
ALTER TABLE CONCILIACION_ENCABEZADO ADD CUBA_COD T_ID;
ALTER TABLE CONCILIACION_ENCABEZADO ADD COBN_ANULADO T_BOOLEANO;
ALTER TABLE CONCILIACION_ENCABEZADO ADD COBN_FECINI DATE;
ALTER TABLE CONCILIACION_ENCABEZADO ADD COBN_FECFIN DATE;

CREATE TABLE CONCILIACION_BANCARIA (
    CUBA_COD T_ID NOT NULL,
    COBN_ITEM T_ID NOT NULL,
    COBN_OPER VARCHAR(20),
    COBN_FEC DATE,
    COBN_CONC T_CONCEPTO,
    COBN_PREFIJO VARCHAR(4),
    COBN_NUMERO T_NUMDOC,
    COBN_REF VARCHAR(20),
    COBN_MONTO T_MONTO,
    COBN_TIPODOC INTEGER,
    COBN_OK T_BOOLEANO,
    COBN_CONCEPTO T_CONCEPTO,
    COBN_EXPLICA BLOB SUB_TYPE 1 SEGMENT SIZE 80);
ALTER TABLE CONCILIACION_BANCARIA ADD COBN_ID T_ID NOT NULL ;
alter table CONCILIACION_BANCARIA add constraint PK_CONCILIACION_BANCARIA primary key (COBN_ID,COBN_ITEM);
ALTER TABLE CONCILIACION_BANCARIA ADD COBN_ANULADO T_BOOLEANO;

CREATE TABLE CONCILIACION_OPERACIONES (
    CUBA_COD T_ID NOT NULL,
    COOP_OPER VARCHAR(20) NOT NULL,
    COOP_TIPODOC T_ID);
alter table CONCILIACION_OPERACIONES
add constraint PK_CONCILIACION_OPERACIONES primary key (CUBA_COD,COOP_OPER);

ALTER TABLE CONCILIACION_BANCARIA ADD COBN_IDDOC T_ID;
ALTER TABLE CONCILIACION_BANCARIA ADD COBN_DB T_BOOLEANO;
ALTER TABLE CONCILIACION_OPERACIONES ADD COOP_DB T_BOOLEANO;

grant select, delete, insert, update on conciliacion_bancaria to PUBLIC;
grant select, delete, insert, update on conciliacion_operaciones to PUBLIC;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE CONCILIA_BANCO(
    ID INTEGER)
RETURNS (
    GRUPO INTEGER,
    TIPODOC INTEGER,
    OPER VARCHAR(20),
    IDDOC INTEGER,
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    CONCEPTO VARCHAR(60),
    MONTO NUMERIC(18,2))
AS
declare variable FECINI DATE;
declare variable FECFIN DATE;
declare variable ITEM INTEGER;
declare variable DB CHAR(1);
begin
select COBN_FECINI, COBN_FECFIN FROM conciliacion_encabezado WHERE COBN_ID = :ID INTO :FECINI, :FECFIN;
/* COMPARE LA TABLA CON LOS MOVIMIENTOS DEL BANCO */
FOR SELECT COBN_ITEM, ABS(COBN_MONTO), COBN_FEC, COBN_TIPODOC, COBN_DB, COBN_CONC
    FROM CONCILIACION_BANCARIA
    WHERE COBN_ID = :ID
    INTO :ITEM, :MONTO, :FECHA, :TIPODOC, :DB, :concepto
    DO
    BEGIN
    /* BUSQUE LA OPERACION  */
    if (TIPODOC <> 0) then
        BEGIN
        PREFIJO = '';
        SELECT FIRST 1 MOBA_PREF, MOBA_NUMERO, MOBA_IDREF
            FROM movimiento_banco M WHERE MOBA_TIPODOC = :tipodoc AND MOBA_TOTAL = :MONTO AND
                NOT EXISTS (SELECT COBN_ITEM FROM CONCILIACION_BANCARIA WHERE COBN_IDDOC = m.moba_idref AND COBN_TIPODOC = :tipodoc)
            ORDER BY ABS(MOBA_FECHA - :FECHA)
            INTO :prefijo, :numero, :IDDOC;
        if (PREFIJO <> '') then
            BEGIN
            GRUPO = 1;
            UPDATE conciliacion_bancaria SET COBN_PREFIJO = :PREFIJO, COBN_NUMERO = :NUMERO, COBN_IDDOC = :iddoc    
                WHERE COBN_ID = :ID AND COBN_ITEM = :ITEM;
            suspend;
            END
        ELSE
            BEGIN
            /* BUSQUELO COMO DEBITO O CREDITO SIN IMPORTAR EL TIPO */
            SELECT FIRST 1 MOBA_PREF, MOBA_NUMERO, MOBA_IDREF
                FROM movimiento_banco M WHERE MOBA_DB = :DB AND MOBA_TOTAL = :MONTO AND
                    NOT EXISTS (SELECT COBN_ITEM FROM CONCILIACION_BANCARIA WHERE COBN_IDDOC = m.moba_idref AND COBN_TIPODOC = :tipodoc)
                ORDER BY ABS(MOBA_FECHA - :FECHA)
                INTO :prefijo, :numero, :IDDOC;
            if (PREFIJO <> '') then
                BEGIN
                GRUPO = 1;
                UPDATE conciliacion_bancaria SET COBN_PREFIJO = :PREFIJO, COBN_NUMERO = :NUMERO, COBN_IDDOC = :iddoc    
                    WHERE COBN_ID = :ID AND COBN_ITEM = :ITEM;
                suspend;
                END
            ELSE
                BEGIN
                GRUPO = 2;
                suspend;
                END
            END
        END
    ELSE
        BEGIN
        /* BUSQUELO COMO DEBITO O CREDITO SIN IMPORTAR EL TIPO */
        SELECT FIRST 1 MOBA_PREF, MOBA_NUMERO, MOBA_IDREF
            FROM movimiento_banco M WHERE MOBA_DB = :DB AND MOBA_TOTAL = :MONTO AND
                NOT EXISTS (SELECT COBN_ITEM FROM CONCILIACION_BANCARIA WHERE COBN_IDDOC = m.moba_idref AND COBN_TIPODOC = :tipodoc)
            ORDER BY ABS(MOBA_FECHA - :FECHA)
            INTO :prefijo, :numero, :IDDOC;
        if (PREFIJO <> '') then
            BEGIN
            GRUPO = 1;
            UPDATE conciliacion_bancaria SET COBN_PREFIJO = :PREFIJO, COBN_NUMERO = :NUMERO, COBN_IDDOC = :iddoc
                WHERE COBN_ID = :ID AND COBN_ITEM = :ITEM;
            suspend;
            END
        END
    /* AGREGUE LOS DOCUMENTOS SIN UBICAR */
    GRUPO = 3;
    FOR SELECT MOBA_PREF, MOBA_NUMERO, MOBA_FECHA, MOBA_TOTAL, TIDO_NOMCORTO, MOBA_CONCEPTO
        FROM MOVIMIENTO_BANCO M, tipo_documento T
        WHERE T.tido_cod = M.moba_tipodoc AND MOBA_FECHA >= :FECINI AND MOBA_FECHA <= :FECFIN AND
            NOT EXISTS (SELECT COBN_ITEM FROM conciliacion_bancaria WHERE COBN_TIPODOC = M.moba_tipodoc AND COBN_IDDOC = M.moba_idref)
        INTO :prefijo, :numero, :fecha, :monto, :oper, :concepto
        DO
        SUSPEND;
    END
end
^

SET TERM ; ^

GRANT SELECT ON CONCILIACION_ENCABEZADO TO PROCEDURE CONCILIA_BANCO;
GRANT SELECT,UPDATE ON CONCILIACION_BANCARIA TO PROCEDURE CONCILIA_BANCO;
GRANT SELECT ON MOVIMIENTO_BANCO TO PROCEDURE CONCILIA_BANCO;
GRANT SELECT ON TIPO_DOCUMENTO TO PROCEDURE CONCILIA_BANCO;
grant EXECUTE on procedure concilia_banco to PUBLIC;

CREATE SEQUENCE ID_CONCILIAB;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE CAMBIE_ID_CONCILIAB
RETURNS (
    ID INTEGER)
AS
declare variable NUMROWS INTEGER;
BEGIN
/* TRAE EL ID NUEVO Y LO ACTUALIZA */
NUMROWS = 1;
while (NUMROWS > 0) DO
    BEGIN
    ID = GEN_ID(id_conciliab, 1);
    /* VERIFIQUE SI YA EXISTE */
    SELECT COUNT(*) FROM conciliacion_bancaria WHERE COBN_ID = :ID INTO :NUMROWS;
    END
SUSPEND;
END
^

SET TERM ; ^

GRANT SELECT ON CONCILIACION_BANCARIA TO PROCEDURE CAMBIE_ID_CONCILIAB;
GRANT EXECUTE ON PROCEDURE CAMBIE_ID_CONCILIAB TO PUBLIC;


INSERT INTO IMPORTACION_INVENTARIO (IMIN_TIPO, IMIN_DATO, IMIN_COLUMNA, IMIN_ANCHO) VALUES (22, 'COBN_CONC', 3, 60);
INSERT INTO IMPORTACION_INVENTARIO (IMIN_TIPO, IMIN_DATO, IMIN_COLUMNA, IMIN_ANCHO) VALUES (22, 'COBN_FEC', 1, 10);
INSERT INTO IMPORTACION_INVENTARIO (IMIN_TIPO, IMIN_DATO, IMIN_COLUMNA, IMIN_ANCHO) VALUES (22, 'COBN_MONTO', 4, 20);
INSERT INTO IMPORTACION_INVENTARIO (IMIN_TIPO, IMIN_DATO, IMIN_COLUMNA, IMIN_ANCHO) VALUES (22, 'COBN_REF', 2, 20);
COMMIT WORK;

INSERT INTO NOMBRES_CAMPOS (NOMBRE, DESCRIPCION) VALUES ('COBN_CONC', 'Concepto movimiento extracto');
INSERT INTO NOMBRES_CAMPOS (NOMBRE, DESCRIPCION) VALUES ('COBN_FEC', 'Fecha movimiento extracto');
INSERT INTO NOMBRES_CAMPOS (NOMBRE, DESCRIPCION) VALUES ('COBN_MONTO', 'Monto movimiento extracto');
INSERT INTO NOMBRES_CAMPOS (NOMBRE, DESCRIPCION) VALUES ('COBN_REF', 'Nmero referencia movimiento extracto');
commit work;

alter table CONCILIACION_BANCARIA add constraint FK_CONCILIACION_BANCARIA_1
foreign key (COBN_ID) references CONCILIACION_ENCABEZADO(COBN_ID) on delete CASCADE on update CASCADE;

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('BANCOS', 'DOCUMENTOS', 'NUMERO DE CARACTERES A LEER COMO OPERACION EN CONCILIACION', '5', '4,5,6,7,8,9,10', 'Indique el nmero de caracteres iniciales del concepto a traducir como operacin del banco al hacer la conciliacin bancaria');
commit work;

INSERT INTO TIPO_DOCUMENTO (TIDO_COD, TIDO_NOMCORTO, TIDO_NOMLARGO, TIDO_MODULO, TIDO_INVE, TIDO_CART, TIDO_CXP, TIDO_CAJA, TIDO_BCOS) VALUES (80, 'CONCILIA', 'CONCILIACION BANCARIA', 'BANCOS', 'N', 'N', 'N', 'N', 'N');
COMMIT WORK;

SET TERM ^ ;

create trigger CONCILIACION_ENCABEZADO_BI for CONCILIACION_ENCABEZADO
active BEFORE INSERT position 0
as
declare variable NUMERO VARCHAR(6);
declare variable AUTOM CHAR(1);
declare variable EXISTE CHAR(1);
BEGIN
/* Actualice el contador del prefijo */
SELECT PRBA_NUMERO, PRBA_AUTO FROM PREFIJOS_BANCOS
    WHERE TIDO_COD = 80 AND CUBA_COD = NEW.CUBA_COD AND PRBA_PREF = NEW.cobn_prefijo INTO :NUMERO, :AUTOM;
/* ACTUALICE EL NUMERO EN COMPROBANTE_ENCABEZADO */
if (AUTOM = 'S') then
    BEGIN
    NEW.cobn_numero = NUMERO;
    NUMERO = CAST((CAST(NUMERO AS INTEGER) + 1) AS CHAR(6));
    UPDATE PREFIJOS_BANCOS
      SET PRBA_NUMERO = :NUMERO
    WHERE TIDO_COD = 80 AND CUBA_COD = NEW.CUBA_COD AND PRBA_PREF = NEW.cobn_prefijo;
    END
ELSE
    BEGIN
    if (CAST(NUMERO AS INTEGER) = CAST(NEW.cobn_numero AS INTEGER)) then
        UPDATE PREFIJOS_BANCOS
          SET PRBA_NUMERO = CAST((CAST(PRBA_NUMERO AS INTEGER) + 1) AS CHAR(6))
        WHERE TIDO_COD = 80 AND CUBA_COD = NEW.CUBA_COD AND PRBA_PREF = NEW.cobn_prefijo;
    END
EXECUTE PROCEDURE COMPLETA_CEROS (NEW.cobn_numero) returning_values (NEW.cobn_numero);
/* Verifique que el numero no existe previamente */
EXISTE = 'N';
SELECT 'S' FROM conciliacion_encabezado
    WHERE CUBA_COD = NEW.CUBA_COD AND COBN_PREFIJO = NEW.cobn_prefijo AND COBN_NUMERO = NEW.cobn_numero INTO :EXISTE;
if (EXISTE = 'S') then
    EXCEPTION DOCUMENTO_REGISTRADO;
end
^

SET TERM ; ^

GRANT SELECT,UPDATE,REFERENCES ON CONCILIACION_ENCABEZADO TO TRIGGER CONCILIACION_ENCABEZADO_BI;
GRANT SELECT,UPDATE ON PREFIJOS_BANCOS TO TRIGGER CONCILIACION_ENCABEZADO_BI;
GRANT EXECUTE ON PROCEDURE COMPLETA_CEROS TO TRIGGER CONCILIACION_ENCABEZADO_BI;

SET TERM ^ ;

CREATE OR ALTER TRIGGER CONCILIACION_ENCABEZADO_AI FOR CONCILIACION_ENCABEZADO
ACTIVE AFTER INSERT POSITION 0
as
begin
INSERT INTO AUDITORIA (AUDI_USUARIO, TIDO_COD, AUDI_IDDOC, AUDI_OPER, AUDI_COD, AUDI_TICO)
    VALUES (USER, 80, NEW.cobn_id, 'I', NEW.cobn_prefijo || NEW.cobn_numero, NEW.cuba_cod);
end
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON CONCILIACION_ENCABEZADO TO TRIGGER CONCILIACION_ENCABEZADO_AI;
GRANT INSERT ON AUDITORIA TO TRIGGER CONCILIACION_ENCABEZADO_AI;

SET TERM ^ ;

CREATE OR ALTER TRIGGER CONCILIACION_ENCABEZADO_AU FOR CONCILIACION_ENCABEZADO
ACTIVE AFTER UPDATE POSITION 0
as
begin
IF (NEW.cobn_anulado = 'S') then
    INSERT INTO AUDITORIA (AUDI_USUARIO, TIDO_COD, AUDI_IDDOC, AUDI_OPER, AUDI_COD, AUDI_TICO)
        VALUES (USER, 80, new.cobn_id, 'A', NEW.cobn_prefijo || NEW.cobn_numero, NEW.cuba_cod);
ELSE
    INSERT INTO AUDITORIA (AUDI_USUARIO, TIDO_COD, AUDI_IDDOC, AUDI_OPER, AUDI_COD, AUDI_TICO)
        VALUES (USER, 80, new.cobn_id, 'U', NEW.cobn_prefijo || NEW.cobn_numero, NEW.cuba_cod);
end
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON CONCILIACION_ENCABEZADO TO TRIGGER CONCILIACION_ENCABEZADO_AU;
GRANT INSERT ON AUDITORIA TO TRIGGER CONCILIACION_ENCABEZADO_AU;

SET TERM ^ ;

create trigger CONCILIACION_ENCABEZADO_AD for CONCILIACION_ENCABEZADO
active AFTER DELETE position 0
as
begin
INSERT INTO AUDITORIA(AUDI_USUARIO, TIDO_COD, AUDI_IDDOC, AUDI_OPER, AUDI_COD, AUDI_TICO)
    VALUES (USER, 80, OLD.cobn_id, 'D', OLD.cobn_prefijo || OLD.cobn_numero, OLD.cuba_cod);
end
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON CONCILIACION_ENCABEZADO TO TRIGGER CONCILIACION_ENCABEZADO_AD;
GRANT INSERT ON AUDITORIA TO TRIGGER CONCILIACION_ENCABEZADO_AD;

ALTER TABLE CONCILIACION_BANCARIA ADD COBN_CLASE CHAR(1);

SET TERM ^ ;

CREATE OR ALTER PROCEDURE CONCILIA_BANCO(
    ID INTEGER)
AS
declare variable FECINI DATE;
declare variable FECFIN DATE;
declare variable ITEM INTEGER;
declare variable DB CHAR(1);
declare variable CUENTA INTEGER;
declare variable TIPODOC INTEGER;
declare variable IDDOC INTEGER;
declare variable PREFIJO VARCHAR(4);
declare variable NUMERO VARCHAR(6);
declare variable FECHA DATE;
declare variable CONCEPTO VARCHAR(60);
declare variable MONTO NUMERIC(18,2);
begin
select CUBA_COD, COBN_FECINI, COBN_FECFIN FROM conciliacion_encabezado WHERE COBN_ID = :ID INTO :CUENTA, :FECINI, :FECFIN;
/* COMPARE LA TABLA CON LOS MOVIMIENTOS DEL BANCO */
FOR SELECT COBN_ITEM, ABS(COBN_MONTO), COBN_FEC, COBN_TIPODOC, COBN_DB, COBN_CONC
    FROM CONCILIACION_BANCARIA
    WHERE COBN_ID = :ID AND ((COBN_IDDOC = 0) or (cobn_iddoc is null))
    INTO :ITEM, :MONTO, :FECHA, :TIPODOC, :DB, :concepto
    DO
    BEGIN
    PREFIJO = '';
    NUMERO = '';
    IDDOC = 0;
    /* BUSQUE LA OPERACION  */
    if (TIPODOC <> 0) then
        BEGIN
        SELECT FIRST 1 MOBA_PREF, MOBA_NUMERO, MOBA_IDREF
            FROM movimiento_banco M WHERE MOBA_TIPODOC = :tipodoc AND MOBA_TOTAL = :MONTO AND
                NOT EXISTS (SELECT COBN_ITEM FROM CONCILIACION_BANCARIA WHERE COBN_IDDOC = m.moba_idref AND COBN_TIPODOC = :tipodoc)
            ORDER BY ABS(MOBA_FECHA - :FECHA)
            INTO :prefijo, :numero, :IDDOC;
        if (PREFIJO <> '') then
            BEGIN
            UPDATE conciliacion_bancaria SET COBN_PREFIJO = :PREFIJO, COBN_NUMERO = :NUMERO, COBN_IDDOC = :iddoc, COBN_OK = 'S', COBN_CLASE = '0'
                WHERE COBN_ID = :ID AND COBN_ITEM = :ITEM;
            END
        ELSE
            BEGIN
            /* BUSQUELO COMO DEBITO O CREDITO SIN IMPORTAR EL TIPO */
            SELECT FIRST 1 MOBA_PREF, MOBA_NUMERO, MOBA_IDREF
                FROM movimiento_banco M WHERE MOBA_DB = :DB AND MOBA_TOTAL = :MONTO AND
                    NOT EXISTS (SELECT COBN_ITEM FROM CONCILIACION_BANCARIA WHERE COBN_IDDOC = m.moba_idref AND COBN_TIPODOC = :tipodoc)
                ORDER BY ABS(MOBA_FECHA - :FECHA)
                INTO :prefijo, :numero, :IDDOC;
            if (PREFIJO <> '') then
                BEGIN
                UPDATE conciliacion_bancaria SET COBN_PREFIJO = :PREFIJO, COBN_NUMERO = :NUMERO, COBN_IDDOC = :iddoc, COBN_OK = 'S', COBN_CLASE = '0'
                    WHERE COBN_ID = :ID AND COBN_ITEM = :ITEM;
                END
            ELSE
                BEGIN
                if (DB = 'N') then
                    UPDATE conciliacion_bancaria SET COBN_OK = 'N', COBN_CLASE = '2'
                        WHERE COBN_ID = :ID AND COBN_ITEM = :ITEM;
                else
                    UPDATE conciliacion_bancaria SET COBN_OK = 'N', COBN_CLASE = '1'
                        WHERE COBN_ID = :ID AND COBN_ITEM = :ITEM;
                END
            END
        END
    ELSE
        BEGIN
        /* BUSQUELO COMO DEBITO O CREDITO SIN IMPORTAR EL TIPO */
        SELECT FIRST 1 MOBA_PREF, MOBA_NUMERO, MOBA_IDREF, MOBA_TIPODOC
            FROM movimiento_banco M WHERE MOBA_DB = :DB AND MOBA_TOTAL = :MONTO AND
                NOT EXISTS (SELECT COBN_ITEM FROM CONCILIACION_BANCARIA WHERE COBN_IDDOC = m.moba_idref AND COBN_DB = :DB)
            ORDER BY ABS(MOBA_FECHA - :FECHA)
            INTO :prefijo, :numero, :IDDOC, :TIPODOC;
        if (PREFIJO <> '') then
            BEGIN
            UPDATE conciliacion_bancaria SET COBN_PREFIJO = :PREFIJO, COBN_NUMERO = :NUMERO, COBN_IDDOC = :iddoc, COBN_TIPODOC = :TIPODOC, COBN_OK = 'S', COBN_CLASE = '0'
                WHERE COBN_ID = :ID AND COBN_ITEM = :ITEM;
            END
        ELSE
            BEGIN
            if (DB = 'N') then
                UPDATE conciliacion_bancaria SET COBN_OK = 'N', COBN_CLASE = '2'
                    WHERE COBN_ID = :ID AND COBN_ITEM = :ITEM;
            else
                UPDATE conciliacion_bancaria SET COBN_OK = 'N', COBN_CLASE = '1'
                    WHERE COBN_ID = :ID AND COBN_ITEM = :ITEM;
            END
        END
    END
/* AGREGUE LOS DOCUMENTOS SIN UBICAR */
SELECT MAX(COBN_ITEM) FROM conciliacion_bancaria WHERE COBN_ID = :ID INTO :item;
FOR SELECT MOBA_PREF, MOBA_NUMERO, MOBA_FECHA, MOBA_TOTAL, MOBA_CONCEPTO, MOBA_TIPODOC, MOBA_IDREF, MOBA_DB
    FROM MOVIMIENTO_BANCO M
    WHERE MOBA_FECHA >= :FECINI AND MOBA_FECHA <= :FECFIN AND
        NOT EXISTS (SELECT COBN_ITEM FROM conciliacion_bancaria WHERE COBN_TIPODOC = M.moba_tipodoc AND COBN_IDDOC = M.moba_idref)
    INTO :prefijo, :numero, :fecha, :monto, :concepto, :tipodoc, :iddoc, :DB
    DO
    BEGIN
    ITEM = ITEM + 1;
    if (DB = 'N') then
        INSERT INTO conciliacion_bancaria (CUBA_COD, COBN_ID, COBN_ITEM, COBN_FEC, COBN_PREFIJO, COBN_NUMERO, COBN_MONTO, COBN_TIPODOC, COBN_ANULADO, COBN_OK, COBN_CONC, COBN_IDDOC, COBN_DB, COBN_CLASE)
            VALUES (:CUENTA, :ID, :ITEM, :FECHA, :PREFIJO, :NUMERO, :monto, :TIPODOC, 'N', 'N', :concepto, :iddoc, :DB, '4');
    else
        INSERT INTO conciliacion_bancaria (CUBA_COD, COBN_ID, COBN_ITEM, COBN_FEC, COBN_PREFIJO, COBN_NUMERO, COBN_MONTO, COBN_TIPODOC, COBN_ANULADO, COBN_OK, COBN_CONC, COBN_IDDOC, COBN_DB, COBN_CLASE)
            VALUES (:CUENTA, :ID, :ITEM, :FECHA, :PREFIJO, :NUMERO, :monto, :TIPODOC, 'N', 'N', :concepto, :iddoc, :DB, '3');
    END
end
^

SET TERM ; ^

GRANT SELECT ON CONCILIACION_ENCABEZADO TO PROCEDURE CONCILIA_BANCO;
GRANT SELECT,INSERT,UPDATE ON CONCILIACION_BANCARIA TO PROCEDURE CONCILIA_BANCO;
GRANT SELECT ON MOVIMIENTO_BANCO TO PROCEDURE CONCILIA_BANCO;

ALTER TABLE CONCILIACION_ENCABEZADO ADD COBN_EXTRACTOINI T_MONTO;
ALTER TABLE CONCILIACION_ENCABEZADO ADD COBN_EXTRACTOFIN T_MONTO;

/* 20080820 */

UPDATE CONFIGURACION
SET CONF_CATEGORIA = 'DOCUMENTOS'
WHERE (CONF_MODULO = 'COMPRAS') AND (CONF_CATEGORIA = 'FACTURAS') AND (CONF_PROPIEDAD = 'PERMITIR CANTIDADES MAYORES A LAS ORDENADAS');
COMMIT WORK;




/* 20080821 */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE COMPRAS_ARTICULO_MES(
    fecini date,
    fecfin date,
    SUCURSAL INTEGER)
RETURNS (
    ARTICULO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    UNIDAD VARCHAR(8),
    CANTVTAS NUMERIC(18,4),
    BASEVTAS NUMERIC(18,2),
    IVAVTAS NUMERIC(18,2),
    CANTDEV NUMERIC(18,4),
    BASEDEV NUMERIC(18,2),
    IVADEV NUMERIC(18,2))
AS
BEGIN
  FOR SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD FROM ARTICULO A
      INTO :ARTICULO, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
  DO
    BEGIN
    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
    EXECUTE PROCEDURE COMPRAS_ARTICULO (:ARTICULO, :FECINI, :FECFIN, :SUCURSAL) returning_values (CANTVTAS, BASEVTAS, CANTDEV, BASEDEV, IVAVTAS, IVADEV);
    if ((CANTVTAS <> 0) or (CANTDEV <> 0)) then
        SUSPEND;
    END
END
^

SET TERM ; ^

GRANT SELECT ON ARTICULO TO PROCEDURE COMPRAS_ARTICULO_MES;
GRANT SELECT ON GRUPO TO PROCEDURE COMPRAS_ARTICULO_MES;
GRANT SELECT ON MARCAS TO PROCEDURE COMPRAS_ARTICULO_MES;
GRANT SELECT ON SUBGRUPO TO PROCEDURE COMPRAS_ARTICULO_MES;
GRANT EXECUTE ON PROCEDURE COMPRAS_ARTICULO TO PROCEDURE COMPRAS_ARTICULO_MES;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE COMPRAS_PROVEEDOR_MES(
    FECINI DATE,
    FECFIN DATE,
    SUCURSAL INTEGER)
RETURNS (
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    FACTURAS INTEGER,
    MFACTURAS NUMERIC(18,2),
    DEVOLUCIONES INTEGER,
    MDEVOLUCIONES NUMERIC(18,2),
    IVAFACT NUMERIC(18,2),
    IVADEV NUMERIC(18,2))
AS
BEGIN
  for select TERC_NIT, TERC_NOM from TERCEROS WHERE TERC_PROV = 'S' into :NIT, :NOMBRE
  DO
    BEGIN
    EXECUTE PROCEDURE COMPRAS_PROVEEDOR (NIT, FECINI, FECFIN, SUCURSAL) returning_values (FACTURAS, MFACTURAS, DEVOLUCIONES, MDEVOLUCIONES, IVAFACT, IVADEV);
    SUSPEND;
    END
END
^

SET TERM ; ^

GRANT SELECT ON TERCEROS TO PROCEDURE COMPRAS_PROVEEDOR_MES;
GRANT EXECUTE ON PROCEDURE COMPRAS_PROVEEDOR TO PROCEDURE COMPRAS_PROVEEDOR_MES;

/* 20080822 */
/* mostraban los articulos .t */

SET TERM ^ ;

CREATE OR ALTER PROCEDURE MOVIMIENTO_ARTICULO_DESDE_HASTA(
    FECINI DATE,
    FECFIN DATE,
    SUCURSAL INTEGER)
RETURNS (
    INICIAL NUMERIC(18,4),
    ENTRADAS NUMERIC(18,4),
    SALIDAS NUMERIC(18,4),
    FINAL NUMERIC(18,4),
    CODIGO VARCHAR(15),
    NOMBRE VARCHAR(60),
    UNIDAD VARCHAR(8),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(17),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    CODBOD VARCHAR(2),
    NOMBOD VARCHAR(30))
AS
BEGIN
  FOR
    SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, BODE_COD, BODE_NOM
        FROM ARTICULO A, BODEGA B
        WHERE (SUCU_ID = :SUCURSAL) or (:SUCURSAL = 0)
      INTO :CODIGO, :NOMBRE, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :CODBOD, NOMBOD
      DO
        BEGIN
        NOMMARC = '';
        NOMSUBG = '';
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
        EXECUTE PROCEDURE SALDO_INICIAL_INVENTARIO(CODIGO, FECINI, :CODBOD) returning_values (INICIAL);
        SELECT SUM(MVAR_CANT) FROM MOVIMIENTO_ARTICULO
          WHERE (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA < :FECFIN) AND
          (ARTI_COD = :codigo) AND (BODE_COD = :CODBOD) AND (MVAR_ENTRADA = 'S') INTO :ENTRADAS;
        if (ENTRADAS IS NULL) then
          ENTRADAS = 0;
        SELECT SUM(MVAR_CANT) FROM MOVIMIENTO_ARTICULO
          WHERE (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA < :FECFIN) AND
          (ARTI_COD = :CODIGO) AND (BODE_COD = :CODBOD) AND (MVAR_ENTRADA = 'N') INTO :SALIDAS;
        if (SALIDAS IS NULL) then
          SALIDAS = 0;
        FINAL = INICIAL + ENTRADAS - SALIDAS;
        SUSPEND;
        END
END
^

SET TERM ; ^

GRANT SELECT ON ARTICULO TO PROCEDURE MOVIMIENTO_ARTICULO_DESDE_HASTA;
GRANT SELECT ON BODEGA TO PROCEDURE MOVIMIENTO_ARTICULO_DESDE_HASTA;
GRANT SELECT ON GRUPO TO PROCEDURE MOVIMIENTO_ARTICULO_DESDE_HASTA;
GRANT SELECT ON MARCAS TO PROCEDURE MOVIMIENTO_ARTICULO_DESDE_HASTA;
GRANT SELECT ON SUBGRUPO TO PROCEDURE MOVIMIENTO_ARTICULO_DESDE_HASTA;
GRANT EXECUTE ON PROCEDURE SALDO_INICIAL_INVENTARIO TO PROCEDURE MOVIMIENTO_ARTICULO_DESDE_HASTA;
GRANT SELECT ON MOVIMIENTO_ARTICULO TO PROCEDURE MOVIMIENTO_ARTICULO_DESDE_HASTA;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE MOVIMIENTO_INVENTARIO_MES(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    CODIGO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    INICIAL NUMERIC(18,4),
    ENTRADA NUMERIC(18,4),
    SALIDA NUMERIC(18,4),
    FINAL NUMERIC(18,4))
AS
BEGIN
  for select arti_cod, arti_des from articulo where substring(arti_cod from 1 FOR 2) <> '.t' order by arti_des into :CODIGO, :DESCRIPCION
  DO
    BEGIN
    EXECUTE PROCEDURE MOVIMIENTO_TOTAL_ARTICULO_MES(CODIGO, FECINI, FECFIN) returning_values (:INICIAL, :ENTRADA, :SALIDA);
    FINAL = INICIAL + ENTRADA - SALIDA;
    SUSPEND;
    END
END
^

SET TERM ; ^

GRANT SELECT ON ARTICULO TO PROCEDURE MOVIMIENTO_INVENTARIO_MES;
GRANT EXECUTE ON PROCEDURE MOVIMIENTO_TOTAL_ARTICULO_MES TO PROCEDURE MOVIMIENTO_INVENTARIO_MES;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE KARDEX_INVENTARIO_MES(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    CODIGO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    INICIAL NUMERIC(18,2),
    ENTRADA NUMERIC(18,2),
    SALIDA NUMERIC(18,2),
    FINAL NUMERIC(18,2))
AS
BEGIN
  for select arti_cod, arti_des from articulo where substring(arti_cod from 1 FOR 2) <> '.t' into :CODIGO, :DESCRIPCION
  DO
    BEGIN
    EXECUTE PROCEDURE KARDEX_ARTICULO_MES(CODIGO, FECINI, FECFIN) returning_values (:INICIAL, :ENTRADA, :SALIDA);
    FINAL = INICIAL + ENTRADA - SALIDA;
    SUSPEND;
    END
END
^

SET TERM ; ^

GRANT SELECT ON ARTICULO TO PROCEDURE KARDEX_INVENTARIO_MES;
GRANT EXECUTE ON PROCEDURE KARDEX_ARTICULO_MES TO PROCEDURE KARDEX_INVENTARIO_MES;

/* TRASLADOS ENTRE BODEGAS LLAMANDO UNA ORDEN PREVIA */
ALTER TABLE TRASFERENCIAS
ADD TRAN_ORDEN VARCHAR(10);
ALTER TABLE TRASFERENCIAS
ADD TRAN_ORDENID T_ID;

SET TERM ^ ;

CREATE OR ALTER TRIGGER TRASFERENCIAS_AI FOR TRASFERENCIAS
ACTIVE AFTER INSERT POSITION 0
as
begin
IF (NEW.TRAN_ID <> 0) THEN
  BEGIN
  /* ANULE LA ORDEN SI LA HAY*/
  if ((new.tran_ordenid <> 0) and (new.tran_ordenid is not null)) then
     update ordenes_inventario set ORIN_ANULADO = 'S' where ORIN_ID = new.tran_ordenid;
  INSERT INTO AUDITORIA(AUDI_USUARIO, TIDO_COD, AUDI_IDDOC, AUDI_OPER, AUDI_COD)
    VALUES (USER, 13, NEW.tran_id, 'I', NEW.pref_pre || NEW.tran_numero);
  END
end
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON TRASFERENCIAS TO TRIGGER TRASFERENCIAS_AI;
GRANT SELECT,UPDATE ON ORDENES_INVENTARIO TO TRIGGER TRASFERENCIAS_AI;
GRANT INSERT ON AUDITORIA TO TRIGGER TRASFERENCIAS_AI;

SET TERM ^ ;

CREATE OR ALTER TRIGGER TRASFERENCIAS_AU FOR TRASFERENCIAS
ACTIVE AFTER UPDATE POSITION 0
AS
declare variable consec INTEGER;
BEGIN
/* borre la contabilizacion */
if (new.tran_anulado = 'S') then
    begin
    if ((old.tran_ordenid <> 0) and (old.tran_ordenid is not null)) then
        update ordenes_inventario set ORIN_ANULADO = 'N' where ORIN_ID = old.tran_ordenid;
    select enco_consec from comprobante_encabezado where enco_tiporef = 13 and enco_idref = old.tran_id into :consec;
    if (NOT consec is null) then
     delete from comprobante_detalle where enco_consec = :consec;
    delete from comprobante_encabezado where enco_tiporef = 13 and enco_idref = old.tran_id;
    INSERT INTO AUDITORIA (AUDI_USUARIO, TIDO_COD, AUDI_IDDOC, AUDI_OPER, AUDI_COD)
        VALUES (USER, 13, new.tran_id, 'A', NEW.pref_pre || NEW.tran_numero);
    end
ELSE
    INSERT INTO AUDITORIA(AUDI_USUARIO, TIDO_COD, AUDI_IDDOC, AUDI_OPER, AUDI_COD)
        VALUES (USER, 13, NEW.tran_id, 'U', NEW.pref_pre || NEW.tran_numero);

if ((OLD.pref_pre <> NEW.pref_pre) or
    (OLD.tran_numero <> NEW.tran_numero) or
    (OLD.tran_fecha <> NEW.tran_fecha) or
    (OLD.tran_confirma <> NEW.tran_confirma)) then
    UPDATE TRASFERENCIAS_DETALLE SET TRAS_CONFIRMA = NEW.tran_confirma
        WHERE TRAN_ID = NEW.TRAN_ID;
if (OLD.tran_anulado <> NEW.tran_anulado) then
    UPDATE TRASFERENCIAS_DETALLE SET TRAS_ANULADO = NEW.TRAN_anulado
        WHERE TRAN_ID = NEW.TRAN_ID;
if (OLD.tran_transmit <> NEW.tran_transmit) then
    UPDATE TRASFERENCIAS_DETALLE SET TRAS_TRANSMIT = NEW.tran_transmit
        WHERE TRAN_ID = NEW.TRAN_ID;
END
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON TRASFERENCIAS TO TRIGGER TRASFERENCIAS_AU;
GRANT SELECT,UPDATE ON ORDENES_INVENTARIO TO TRIGGER TRASFERENCIAS_AU;
GRANT SELECT,DELETE ON COMPROBANTE_ENCABEZADO TO TRIGGER TRASFERENCIAS_AU;
GRANT SELECT,DELETE ON COMPROBANTE_DETALLE TO TRIGGER TRASFERENCIAS_AU;
GRANT INSERT ON AUDITORIA TO TRIGGER TRASFERENCIAS_AU;
GRANT SELECT,UPDATE ON TRASFERENCIAS_DETALLE TO TRIGGER TRASFERENCIAS_AU;

SET TERM ^ ;

CREATE OR ALTER TRIGGER TRASFERENCIAS_AD FOR TRASFERENCIAS
ACTIVE AFTER DELETE POSITION 0
as
declare variable consec INTEGER;
begin
if ((old.tran_ordenid <> 0) and (old.tran_ordenid is not null)) then
    update ordenes_inventario set ORIN_ANULADO = 'N' where ORIN_ID = old.tran_ordenid;
select enco_consec from comprobante_encabezado where enco_tiporef = 13 and enco_idref = old.tran_id into :consec;
if (NOT consec is null) then
 delete from comprobante_detalle where enco_consec = :consec;
delete from comprobante_encabezado where enco_tiporef = 13 and enco_idref = old.tran_id;

INSERT INTO AUDITORIA(AUDI_USUARIO, TIDO_COD, AUDI_IDDOC, AUDI_OPER, AUDI_COD)
    VALUES (USER, 13, OLD.tran_id, 'D', OLD.pref_pre || OLD.tran_numero);
end
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON TRASFERENCIAS TO TRIGGER TRASFERENCIAS_AD;
GRANT SELECT,UPDATE ON ORDENES_INVENTARIO TO TRIGGER TRASFERENCIAS_AD;
GRANT SELECT,DELETE ON COMPROBANTE_ENCABEZADO TO TRIGGER TRASFERENCIAS_AD;
GRANT SELECT,DELETE ON COMPROBANTE_DETALLE TO TRIGGER TRASFERENCIAS_AD;
GRANT INSERT ON AUDITORIA TO TRIGGER TRASFERENCIAS_AD;

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('INVENTARIO', 'TRASLADOS', 'VERIFICAR CODIGOS DE LA ORDEN', 'NO', 'SI,NO', 'SI: Al hacer la entrada con base en una orden no se copian automticamente los cdigos pero si se verifica que corresponda a lo ordenado. NO: Trae automticamente el contenido de la orden al traslado');
COMMIT WORK;

/* 20080823 */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE BUSCA_ID_DOC(
    TIPO INTEGER,
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6))
RETURNS (
    ID INTEGER)
AS
BEGIN
ID = 0;
EXECUTE PROCEDURE COMPLETA_CEROS(NUMERO) returning_values (NUMERO);
if (TIPO = 11) then
    SELECT ENTR_ID FROM entradas WHERE PREF_PRE = :PREFIJO AND ENTR_NUMERO = :NUMERO INTO :ID;
if (TIPO = 12) then
    SELECT SALI_ID FROM SALIDAS WHERE PREF_PRE = :PREFIJO AND SALI_NUMERO = :NUMERO INTO :ID;
if (TIPO = 13) then
    SELECT TRAN_ID FROM trasferencias WHERE PREF_PRE = :PREFIJO AND TRAN_NUMERO = :NUMERO INTO :ID;
if (TIPO = 14) then
    SELECT AJUS_ID FROM ajustes WHERE PREF_PRE = :PREFIJO AND AJUS_NUMERO = :NUMERO INTO :ID;
if (TIPO = 15) then
    SELECT ENSA_ID FROM ensambles WHERE PREF_PRE = :PREFIJO AND ENSA_NUMERO = :NUMERO INTO :ID;
if (TIPO = 16) then
    SELECT DESE_ID FROM desensambles WHERE PREF_PRE = :PREFIJO AND DESE_NUMERO = :NUMERO INTO :ID;
if (TIPO = 21) then
    SELECT FACO_ID FROM FACTURAS_COMPRA WHERE PREF_PRE = :PREFIJO AND FACO_NUMERO = :NUMERO INTO :ID;
if (TIPO = 24) then
    SELECT DVCO_ID FROM devoluciones_compras WHERE PREF_PRE = :PREFIJO AND DVCO_NUMERO = :NUMERO INTO :ID;
if (TIPO = 31) then
    SELECT FACT_ID FROM FACTURAS WHERE PREF_PRE = :PREFIJO AND FACT_NUMERO = :NUMERO INTO :ID;
if (TIPO = 33) then
    SELECT DEVT_ID FROM devoluciones_ventas WHERE PREF_PRE = :PREFIJO AND DEVT_NUMERO = :NUMERO INTO :ID;
if (TIPO = 41) then
    SELECT NDCL_ID FROM NOTAS_DEBITO_CLIENTES WHERE PREF_PRE = :PREFIJO AND NDCL_NUMERO = :NUMERO INTO :ID;
if (TIPO = 42) then
    SELECT NCCL_ID FROM NOTAS_CREDITO_CLIENTES WHERE PREF_PRE = :PREFIJO AND NCCL_NUMERO = :NUMERO INTO :ID;
if (TIPO = 43) then
    SELECT APCL_ID FROM aplicacion_cliente WHERE PREF_PRE = :PREFIJO AND APCL_NUMERO = :NUMERO INTO :ID;
if (TIPO = 45) then
    SELECT ANCL_ID FROM ANTICIPOS_CLIENTE WHERE PREF_PRE = :PREFIJO AND ANCL_NUMERO = :NUMERO INTO :ID;
if (TIPO = 77) then
    SELECT DVCH_ID FROM devolucion_cheques WHERE PRBA_PREf = :PREFIJO AND DVCH_NUMDOC = :NUMERO INTO :ID;
if (TIPO = 51) then
    SELECT NDPR_ID FROM NOTAS_DEBITO_PROVEEDOR WHERE PREF_PRE = :PREFIJO AND NDPR_NUMERO = :NUMERO INTO :ID;
if (TIPO = 52) then
    SELECT NCPR_ID FROM NOTAS_CREDITO_PROVEEDOR WHERE PREF_PRE = :PREFIJO AND NCPR_NUMERO = :NUMERO INTO :ID;
if (TIPO = 53) then
    SELECT APPR_ID FROM aplicacion_provedor WHERE PREF_PRE = :PREFIJO AND APPR_NUMERO = :NUMERO INTO :ID;
if (TIPO = 55) then
    SELECT ANPR_ID FROM ANTICIPOS_PROVEEDOR WHERE PREF_PRE = :PREFIJO AND ANPR_NUMERO = :NUMERO INTO :ID;
if (TIPO = 61) then
    SELECT RECA_ID FROM recibos_caja WHERE PREF_PRE = :PREFIJO AND RECA_NUMERO = :NUMERO INTO :ID;
if (TIPO = 62) then
    SELECT EGRE_ID FROM EGRESOS WHERE PREF_PRE = :PREFIJO AND EGRE_NUMERO = :NUMERO INTO :ID;
if (TIPO = 64) then
    SELECT COTJ_ID FROM consigna_tarjetas WHERE PREF_PRE = :PREFIJO AND COTJ_NUMERO = :NUMERO INTO :ID;
if (TIPO = 66) then
    SELECT TRCJ_ID FROM traslados_caja WHERE PREF_PRE = :PREFIJO AND TRCJ_NUMERO = :NUMERO INTO :ID;
if (TIPO = 71) then
    SELECT FIRST 1 CONS_ID FROM CONSIGNA WHERE PRBA_PREF = :PREFIJO AND CONS_NUMERO = :NUMERO INTO :ID;
if (TIPO = 72) then
    SELECT CHEQ_ID FROM CHEQUES WHERE PRBA_PREF = :PREFIJO AND CHEQ_NUMERO = :NUMERO INTO :ID;
if (TIPO = 73) then
    SELECT FIRST 1 RETI_ID FROM RETIROS WHERE PRBA_PREF = :PREFIJO AND RETI_NUMERO = :NUMERO INTO :ID;
if (TIPO = 74) then
    SELECT FIRST 1 NDBC_ID FROM notas_debito WHERE PRBA_PREF = :PREFIJO AND NDBC_NUMERO = :NUMERO INTO :ID;
if (TIPO = 75) then
    SELECT FIRST 1 NCBC_ID FROM notas_credito WHERE PRBA_PREF = :PREFIJO AND NCBC_NUMERO = :NUMERO INTO :ID;
if (TIPO = 76) then
    SELECT FIRST 1 TRAS_ID FROM traslados WHERE PRBA_PREF = :PREFIJO AND TRAS_NUMERO = :NUMERO INTO :ID;
if (TIPO = 77) then
    SELECT FIRST 1 DVCH_ID FROM devolucion_cheques WHERE PRBA_PREF = :PREFIJO AND DVCH_NUMDOC = :NUMERO INTO :ID;
SUSPEND;
END
^

SET TERM ; ^

GRANT EXECUTE ON PROCEDURE COMPLETA_CEROS TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON ENTRADAS TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON SALIDAS TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON TRASFERENCIAS TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON AJUSTES TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON ENSAMBLES TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON DESENSAMBLES TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON FACTURAS_COMPRA TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON DEVOLUCIONES_COMPRAS TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON FACTURAS TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON DEVOLUCIONES_VENTAS TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON NOTAS_DEBITO_CLIENTES TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON NOTAS_CREDITO_CLIENTES TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON APLICACION_CLIENTE TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON ANTICIPOS_CLIENTE TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON DEVOLUCION_CHEQUES TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON NOTAS_DEBITO_PROVEEDOR TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON NOTAS_CREDITO_PROVEEDOR TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON APLICACION_PROVEDOR TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON ANTICIPOS_PROVEEDOR TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON RECIBOS_CAJA TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON EGRESOS TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON CONSIGNA_TARJETAS TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON TRASLADOS_CAJA TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON CONSIGNA TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON CHEQUES TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON RETIROS TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON NOTAS_DEBITO TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON NOTAS_CREDITO TO PROCEDURE BUSCA_ID_DOC;
GRANT SELECT ON TRASLADOS TO PROCEDURE BUSCA_ID_DOC;
grant EXECUTE on PROCEDURE BUSCA_ID_DOC to PUBLIC;


/* 20080824 */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE MOVIMIENTO_CARTERA_MES(
    FECINI DATE,
    FECFIN DATE,
    SUBEMPRESA INTEGER,
    CONTADO CHAR(1))
RETURNS (
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    CONTACTO VARCHAR(60),
    DIASMAX INTEGER,
    TELEFONO VARCHAR(40),
    INICIAL NUMERIC(18,2),
    DEBITOS NUMERIC(18,2),
    CREDITOS NUMERIC(18,2),
    ABONOS NUMERIC(18,2),
    FINAL NUMERIC(18,2))
AS
declare variable RETES CHAR(2);
declare variable TIPODOC INTEGER;
declare variable IDDOC INTEGER;
declare variable SALDO NUMERIC(18,2);
declare variable NUMROWS INTEGER;
BEGIN
  for select TERC_NIT, TERC_NOM, TERC_CONTACTO, TERC_TEL from TERCEROS WHERE TERC_CLIE = 'S' into :NIT, :NOMBRE, :CONTACTO, :TELEFONO
  DO
    BEGIN
    diasmax = 0;
    SELECT COUNT(*) FROM AUTORIZACIONES WHERE AUTO_NITCONTADO = :NIT INTO :numrows;
    IF ((CONTADO = 'S') or (numrows = 0)) THEN
        BEGIN
        FECINI = FECINI - 1;
        INICIAL = 0;
        FOR SELECT MVCL_TIPOREF, MVCL_IDREF FROM MOVIMIENTO_CLIENTES
            WHERE TERC_NIT = :NIT AND MVCL_FECHA <= :FECINI AND
            MVCL_ABONO = 'N' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
            INTO :TIPODOC, :IDDOC
            DO
            BEGIN
            EXECUTE PROCEDURE saldo_doc_cartera(TIPODOC, IDDOC, FECINI) returning_values (SALDO);
            INICIAL = INICIAL + SALDO;
            END
        EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'DESCONTAR RETENCIONES POR CAUSACION') returning_values(:RETES);
        FECINI = FECINI + 1;
        if (RETES = 'SI') then
            BEGIN
            SELECT SUM(MVCL_MONTO-MVCL_RTEFTE-MVCL_RTEIVA-MVCL_RTEICA), MAX(MVCL_VENCE-MVCL_FECHA) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_DEBITO = 'S' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :DEBITOS, :diasmax;
            SELECT SUM(MVCL_MONTO-MVCL_RTEFTE-MVCL_RTEIVA-MVCL_RTEICA) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_DEBITO = 'N' AND MVCL_ABONO = 'N' and MVCL_TIPOREF <> 45 AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :CREDITOS;
            SELECT SUM(MVCL_MONTO) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_ABONO = 'S' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :ABONOS;
            END
        ELSE
            BEGIN
            SELECT SUM(MVCL_MONTO), MAX(MVCL_VENCE-MVCL_FECHA) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_DEBITO = 'S' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :DEBITOS, :DIASMAX;
            SELECT SUM(MVCL_MONTO) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_DEBITO = 'N' AND MVCL_ABONO = 'N' and MVCL_TIPOREF <> 45 AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :CREDITOS;
            SELECT SUM(MVCL_MONTO+MVCL_RTEFTE+MVCL_RTEIVA+MVCL_RTEICA) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_ABONO = 'S' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :ABONOS;
            END
        if (DEBITOS IS NULL) then
            DEBITOS = 0;
        if (CREDITOS IS NULL) then
            CREDITOS = 0;
        if (ABONOS IS NULL) then
            ABONOS = 0;
        FINAL = INICIAL + DEBITOS - CREDITOS - ABONOS;
        SUSPEND;
        END
    END
END
^

SET TERM ; ^

GRANT SELECT ON TERCEROS TO PROCEDURE MOVIMIENTO_CARTERA_MES;
GRANT SELECT ON AUTORIZACIONES TO PROCEDURE MOVIMIENTO_CARTERA_MES;
GRANT SELECT ON MOVIMIENTO_CLIENTES TO PROCEDURE MOVIMIENTO_CARTERA_MES;
GRANT EXECUTE ON PROCEDURE SALDO_DOC_CARTERA TO PROCEDURE MOVIMIENTO_CARTERA_MES;
GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO PROCEDURE MOVIMIENTO_CARTERA_MES;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE DETALLE_VENTAS_ARTICULO_VEND(
    ARTICULO VARCHAR(15),
    FECINI DATE,
    FECFIN DATE,
    VEND INTEGER)
RETURNS (
    TIPO VARCHAR(8),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    ID INTEGER,
    FECDOC DATE,
    CANTIDAD NUMERIC(18,4),
    PRUNIT NUMERIC(18,2),
    DTO NUMERIC(9,2),
    IVA NUMERIC(18,2),
    TOTAL NUMERIC(18,2))
AS
BEGIN
  TIPO = 'FACTVENT';
  if ((VEND = 0) or (VEND IS NULL)) then
      FOR SELECT F.FACT_ID, PREF_PRE, FACT_NUMERO, FACT_FECHA, FADE_CANT * FADE_FACTOR, FADE_PRUNIT / FADE_FACTOR, FADE_DTOPORC, FADE_IVAMONTO, FADE_TOTAL
        FROM FACTURAS F, FACTURAS_DETALLE D
        WHERE F.FACT_ID = D.FACT_ID AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND ARTI_COD = :ARTICULO AND FACT_ANULADO = 'N'
        INTO :ID, :PREFIJO, :NUMERO, :FECDOC, :CANTIDAD, :PRUNIT, :DTO, :IVA, :TOTAL
        DO
        SUSPEND;
  ELSE
      FOR SELECT F.FACT_ID, PREF_PRE, FACT_NUMERO, FACT_FECHA, FADE_CANT * FADE_FACTOR, FADE_PRUNIT / FADE_FACTOR, FADE_DTOPORC, FADE_IVAMONTO, FADE_TOTAL
        FROM FACTURAS F, FACTURAS_DETALLE D
        WHERE F.FACT_ID = D.FACT_ID AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND ARTI_COD = :ARTICULO AND VEND_COD = :VEND AND FACT_ANULADO = 'N'
        INTO :ID, :PREFIJO, :NUMERO, :FECDOC, :CANTIDAD, :PRUNIT, :DTO, :IVA, :TOTAL
        DO
        SUSPEND;
    
  TIPO = 'DEVOLCLI';
  if ((VEND = 0) or (VEND IS NULL)) then
      FOR SELECT V.DEVT_ID, PREF_PRE, DEVT_NUMERO, DEVT_FECHA, DVDE_CANT * DVDE_FACTOR, DVDE_PRUNIT / DVDE_FACTOR, DVDE_DTOPORC, DVDE_IVAMONTO, DVDE_TOTAL
        FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D
        WHERE V.DEVT_ID = D.DEVT_ID AND ARTI_COD = :ARTICULO AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND DEVT_ANULADO = 'N'
        INTO :ID, :PREFIJO, :NUMERO, :FECDOC, :CANTIDAD, :PRUNIT, :DTO, :IVA, :TOTAL
        DO
        BEGIN
        CANTIDAD = CANTIDAD * -1;
        IVA = IVA * -1;
        TOTAL = TOTAL * -1;
        SUSPEND;
        END
  ELSE
      FOR SELECT V.DEVT_ID, PREF_PRE, DEVT_NUMERO, DEVT_FECHA, DVDE_CANT * DVDE_FACTOR, DVDE_PRUNIT / DVDE_FACTOR, DVDE_DTOPORC, DVDE_IVAMONTO, DVDE_TOTAL
        FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D
        WHERE V.DEVT_ID = D.DEVT_ID AND ARTI_COD = :ARTICULO AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND VEND_COD = :VEND AND DEVT_ANULADO = 'N'
        INTO :ID, :PREFIJO, :NUMERO, :FECDOC, :CANTIDAD, :PRUNIT, :DTO, :IVA, :TOTAL
        DO
        BEGIN
        CANTIDAD = CANTIDAD * -1;
        IVA = IVA * -1;
        TOTAL = TOTAL * -1;
        SUSPEND;
        END
END
^

SET TERM ; ^

GRANT SELECT ON FACTURAS TO PROCEDURE DETALLE_VENTAS_ARTICULO_VEND;
GRANT SELECT ON FACTURAS_DETALLE TO PROCEDURE DETALLE_VENTAS_ARTICULO_VEND;
GRANT SELECT ON DEVOLUCIONES_VENTAS TO PROCEDURE DETALLE_VENTAS_ARTICULO_VEND;
GRANT SELECT ON DEVOLUCIONES_VENTAS_DETALLE TO PROCEDURE DETALLE_VENTAS_ARTICULO_VEND;
grant EXECUTE on PROCEDURE DETALLE_VENTAS_ARTICULO_VEND to PUBLIC;

/* 20080825 */

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('FACTURACION', 'DOCUMENTOS', 'FILTRAR PUNTOS DE VENTA SEGUN EL PREFIJO', 'NO', 'SI,NO', 'SI: Permite usar solamente los puntos de venta asociados al prefijo. NO: Premite escoger cualquier punto de venta activo');
commit work;


SET TERM ^ ;

ALTER PROCEDURE CRUCES_DOCUMENTOS(
    TIPOORI INTEGER,
    IDORI INTEGER)
RETURNS (
    TIPODES INTEGER,
    ID INTEGER,
    NOMTIPO VARCHAR(8),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE)
AS
declare variable IDC INTEGER;
declare variable PEDAUTO CHAR(2);
begin
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','FACTURAS','GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') RETURNING_VALUES (PEDAUTO);
FOR SELECT DISTINCT COFA_TIPODES, COFA_ID FROM CONSOLIDADO_FALTANTES
    WHERE COFA_TIPOORI = :TIPOORI AND COFA_IDORI = :IDORI AND COFA_OK = 'S' INTO :TIPODES, :IDC
    DO
    BEGIN
    SELECT TIDO_NOMCORTO FROM tipo_documento WHERE TIDO_COD = :tipodes INTO :nomtipo;
    if (TIPODES = 21) then
        SELECT FACO_ID, PREF_PRE, FACO_NUMERO, FACO_FECHA FROM FACTURAS_COMPRA WHERE FACO_CONSOLIDA = :IDC AND FACO_ANULADO = 'N' INTO :ID, :PREFIJO, :NUMERO, :FECHA;
    if (TIPODES = 22) then
        SELECT REPR_ID, PREF_PRE, REPR_NUMERO, REPR_FECHA FROM remision_proveedor WHERE REPR_CONSOLIDA = :IDC AND REPR_ANULADO = 'N' INTO :ID, :PREFIJO, :NUMERO, :FECHA;
    if (TIPODES = 23) then
        SELECT ORDC_ID, PREF_PRE, ORDC_NUMERO, ORDC_FECHA FROM ORDENES_COMPRA WHERE ORDC_CONSOLIDA = :IDC AND ORDC_ANULADO = 'N' INTO :ID, :PREFIJO, :NUMERO, :FECHA;
    if (TIPODES = 31) then
        SELECT FACT_ID, PREF_PRE, FACT_NUMERO, FACT_FECHA FROM FACTURAS WHERE FACT_CONSOLIDA = :IDC AND FACT_ANULADO = 'N' INTO :ID, :PREFIJO, :NUMERO, :FECHA;
    if (TIPODES = 32) then
        SELECT REVT_ID, PREF_PRE, REVT_NUMERO, REVT_FECHA FROM remisiones_venta WHERE REVT_CONSOLIDA = :IDC AND REVT_ANULADO = 'N' INTO :ID, :PREFIJO, :NUMERO, :FECHA;
    if (TIPODES = 34) then
        SELECT PEDI_ID, PREF_PRE, PEDI_NUMERO, PEDI_FECHA FROM PEDIDOS WHERE PEDI_CONSOLIDA = :IDC AND PEDI_ANULADO = 'N' INTO :ID, :PREFIJO, :NUMERO, :FECHA;
    suspend;
    END

if (tipoori = 31) then
    BEGIN
    tipodes = 33;
    SELECT TIDO_NOMCORTO FROM tipo_documento WHERE TIDO_COD = :tipodes INTO :nomtipo;
    for select devt_id, pref_pre, devt_numero, devt_fecha from devoluciones_ventas where devt_factid = :idori and devt_anulado = 'N'
        into :ID, :PREFIJO, :NUMERO, :FECHA
        do
        suspend;

    tipodes = 34;
    if (PEDAUTO = 'SI') then
        BEGIN
        SELECT PEDI_ID FROM PEDIDOS P, FACTURAS F WHERE P.PREF_PRE = F.pref_pre AND PEDI_NUMERO = FACT_NUMERO AND fact_id = :idori into :idori;
        FOR SELECT DISTINCT COFA_TIPODES, COFA_ID FROM CONSOLIDADO_FALTANTES
            WHERE COFA_TIPOORI = 34 AND COFA_IDORI = :IDORI AND COFA_OK = 'S'
            INTO :TIPODES, :IDC
            DO
            BEGIN
            if (TIPODES = 32) then
                BEGIN
                SELECT TIDO_NOMCORTO FROM tipo_documento WHERE TIDO_COD = :tipodes INTO :nomtipo;
                SELECT REVT_ID, PREF_PRE, REVT_NUMERO, REVT_FECHA FROM remisiones_venta
                    WHERE REVT_CONSOLIDA = :IDC AND REVT_ANULADO = 'N'
                    INTO :ID, :PREFIJO, :NUMERO, :FECHA;
                SUSPEND;
                END
            END
        END
    END
if (tipoori = 32) then
    BEGIN
    tipodes = 33;
    SELECT TIDO_NOMCORTO FROM tipo_documento WHERE TIDO_COD = :tipodes INTO :nomtipo;
    for select devt_id, pref_pre, devt_numero, devt_fecha from devoluciones_ventas where devt_remid = :idori and devt_anulado = 'N'
        into :ID, :PREFIJO, :NUMERO, :FECHA
        do
        suspend;
    END
end
^

SET TERM ; ^

/* PROCEDIMIENTO PARA CAMBIAR EL AO A MOVIMIENTOS CONTABLES */

SET TERM ^ ;

CREATE OR ALTER procedure cambio_ano_conta(anoa char(4), anon char(4)) returns (id integer, fecha char(8))
as
begin
for select enco_consec, substring(enco_fecha from 5 for 4) from comprobante_encabezado where substring(enco_fecha from 1 for 4) = :anoa
into :id, :fecha
    do
    begin
    update comprobante_encabezado set enco_fecha = :anon || :fecha where enco_consec = :id;
    fecha = anon || fecha;
    suspend;
    end
end    

^

SET TERM ; ^

GRANT SELECT,UPDATE ON COMPROBANTE_ENCABEZADO TO PROCEDURE CAMBIO_ANO_CONTA;


/* 20080830 REP. UTILIDAD ERROR */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_UTILIDAD_VENTAS(
    TIPO INTEGER,
    DETALLE CHAR(1),
    FECINI DATE,
    FECFIN DATE,
    ARTINI VARCHAR(15),
    ARTFIN VARCHAR(15),
    GRPINI VARCHAR(3),
    GRPFIN VARCHAR(3),
    ORDEN CHAR(1),
    AGRUPA CHAR(1),
    CEROS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    ARTICULO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    UNIDAD VARCHAR(8),
    CANTIDAD NUMERIC(18,4),
    BASE NUMERIC(18,4),
    COSTO NUMERIC(18,4),
    UTILIDAD NUMERIC(18,4),
    PORC NUMERIC(9,2),
    IVA NUMERIC(18,4),
    CONSUMO NUMERIC(18,4),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    TIPODOC INTEGER)
AS
DECLARE VARIABLE COSTOUNIT NUMERIC(18,4);
declare variable CODINI VARCHAR(15);
declare variable CODFIN VARCHAR(15);
declare variable DESINI VARCHAR(15);
declare variable DESFIN VARCHAR(15);
declare variable MARINI VARCHAR(3);
declare variable MARFIN VARCHAR(3);
declare variable UOM VARCHAR(20);
declare variable NUMROWS INTEGER;
BEGIN
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END
if (AGRUPA = 'G') then
    BEGIN
    MARINI = '';
    MARFIN = 'zz';
    END
ELSE
    if (AGRUPA = 'M') then
        BEGIN
        MARINI = GRPINI;
        MARFIN = GRPFIN;
        GRPINI = '';
        GRPFIN = 'zz';
        END
    ELSE
        BEGIN
        MARINI = '';
        MARFIN = 'zz';
        GRPINI = '';
        GRPFIN = 'zz';
        END
EXECUTE PROCEDURE lee_configuracion ('FACTURACION', 'ARTICULOS', 'SUGERIR PRECIOS CON PORCENTAJE DE MARGEN O UTILIDAD') returning_values (:UOM);
if (DETALLE = 'N') then
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        TIPODOC = 31;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 2 AND REPA_USER = USER;

        FOR SELECT MAX(D.ARTI_COD), SUM(FADE_CANT * FADE_FACTOR), SUM((FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR), SUM(FADE_IVAMONTO*FACT_FACTOR), SUM(FADE_CONSUMO),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), SUM(COST_SALP)
            FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P, ARTICULO A, movimiento_articulo m, costos c
            WHERE F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND D.ARTI_COD = A.arti_cod AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            F.fact_id = M.mvar_idref AND M.mvar_tipodoc = 31 AND M.mvar_item = D.fade_item AND M.mvar_cons = C.cost_idmov AND
            FACT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY D.ARTI_COD
            INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :COSTO
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
/*            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);*/
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
/*            COSTO = cantidad * COSTOUNIT;*/
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (2, USER, :ARTICULO);
            SUSPEND;
            END /* FOR */
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND
                    A.ARTI_DES <= :DESFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND
                    (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN)))
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,:DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 2 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        TIPODOC = 32;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 2 AND REPA_USER = USER;

        FOR SELECT MAX(D.ARTI_COD), SUM(RVDE_CANT * RVDE_FACTOR), SUM(RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO), SUM(RVDE_IVAMONTO), SUM(RVDE_CONSUMO),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), SUM(COST_SALP)
            FROM REMISIONES_VENTA_DETALLE D, REMISIONES_VENTA R, PREFIJOS P, ARTICULO A, movimiento_articulo m, costos c
            WHERE R.REVT_ID = D.REVT_ID AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND D.ARTI_COD = A.arti_cod AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            R.revt_id = M.mvar_idref AND M.mvar_tipodoc = 32 AND M.mvar_item = D.rvde_item AND M.mvar_cons = C.cost_idmov AND
            REVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY D.ARTI_COD
            INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :COSTO
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
/*            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT); */
/*            COSTO = cantidad * COSTOUNIT;*/
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (2, USER, :ARTICULO);
            SUSPEND;
            END /* FOR */
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND
                    A.ARTI_DES <= :DESFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND
                    (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN)))
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,:DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 2 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        TIPODOC = 33;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 2 AND REPA_USER = USER;

        FOR SELECT MAX(D.ARTI_COD), SUM(DVDE_CANT * DVDE_FACTOR), SUM((DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR), SUM(DVDE_IVAMONTO*DEVT_FACTOR), SUM(DVDE_CONSUMO),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), SUM(COST_ENTP)
            FROM devoluciones_ventas_detalle D, DEVOLUCIONES_VENTAS V, PREFIJOS P, ARTICULO A, MOVIMIENTO_ARTICULO M, COSTOS C
            WHERE V.DEVT_ID = D.DEVT_ID AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND D.ARTI_COD = A.arti_cod AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            V.devt_id = M.mvar_idref AND M.mvar_tipodoc = 33 AND M.mvar_item = D.dvde_item AND M.mvar_cons = C.cost_idmov AND
            DEVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY D.ARTI_COD
            INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :COSTO
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            else
                CANTIDAD = CANTIDAD * -1;
            if (BASE IS NULL) then
                BASE = 0;
            else
                BASE = BASE * -1;
            if (IVA IS NULL) then
                IVA = 0;
            else
                IVA = IVA * -1;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            else
                CONSUMO = CONSUMO * -1;
/*            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);*/
/*            COSTO = cantidad * COSTOUNIT;*/
            COSTO = costo * -1;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (2, USER, :ARTICULO);
            SUSPEND;
            END /* FOR */
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND
                    A.ARTI_DES <= :DESFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND
                    (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN)))
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,:DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 2 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        TIPODOC = 34;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 2 AND REPA_USER = USER;

        FOR SELECT MAX(D.ARTI_COD), SUM(PEDE_CANT * PEDE_FACTOR), SUM((PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR), SUM(PEDE_IVAMONTO*PEDI_FACTOR), SUM(PEDE_CONSUMO),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM PEDIDOS_DETALLE D, PEDIDOS P, PREFIJOS R, ARTICULO A
            WHERE P.PEDI_ID = D.PEDI_ID AND P.PREF_PRE = R.PREF_PRE AND R.TIDO_COD = 34 AND D.ARTI_COD = A.arti_cod AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            PEDI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY D.ARTI_COD
            INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
            COSTO = cantidad * COSTOUNIT;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (2, USER, :ARTICULO);
            SUSPEND;
            END /* FOR */
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND
                    A.ARTI_DES <= :DESFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND
                    (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN)))
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,:DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 2 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        TIPODOC = 35;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 2 AND REPA_USER = USER;

        FOR SELECT MAX(D.ARTI_COD), SUM(CTDE_CANT * CTDE_FACTOR), SUM((CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR), SUM(CTDE_IVAMONTO), SUM(CTDE_CONSUMO),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM COTIZACIONES_DETALLE D, COTIZACIONES C, PREFIJOS P, ARTICULO A
            WHERE C.COTI_ID = D.COTI_ID AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND D.ARTI_COD = A.arti_cod AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            COTI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY D.ARTI_COD
            INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
            COSTO = cantidad * COSTOUNIT;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (2, USER, :ARTICULO);
            SUSPEND;
            END /* FOR */
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND
                    A.ARTI_DES <= :DESFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND
                    (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN)))
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,:DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 2 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    END
ELSE
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        TIPODOC = 31;
        FOR SELECT F.PREF_PRE, FACT_NUMERO, FACT_FECHA, D.ARTI_COD, FADE_CANT * FADE_FACTOR, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR, FADE_IVAMONTO*FACT_FACTOR, FADE_CONSUMO,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, COST_SALP
            FROM FACTURAS F, FACTURAS_DETALLE D, PREFIJOS P, ARTICULO A, MOVIMIENTO_ARTICULO M, COSTOS C
            WHERE F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND D.ARTI_COD = A.arti_cod AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND FACT_FECHA >= :FECINI AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                F.fact_id = M.mvar_idref AND M.mvar_tipodoc = 31 AND M.mvar_item = D.fade_item AND M.mvar_cons = C.cost_idmov AND
                FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY D.ARTI_COD, FACT_FECHA, F.FACT_ID, FADE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :COSTO
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
/*            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);*/
/*            COSTO = COSTOUNIT * CANTIDAD;*/
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        TIPODOC = 32;
        FOR SELECT R.PREF_PRE, REVT_NUMERO, REVT_FECHA, D.ARTI_COD, RVDE_CANT * RVDE_FACTOR, RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO, RVDE_IVAMONTO, RVDE_CONSUMO,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, COST_SALP
            FROM REMISIONES_VENTA R, REMISIONES_VENTA_DETALLE D, PREFIJOS P, ARTICULO A, MOVIMIENTO_ARTICULO M, COSTOS C
            WHERE R.REVT_ID = D.REVT_ID AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND D.ARTI_COD = A.arti_cod AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND
                R.revt_id = M.mvar_idref AND M.mvar_tipodoc = 32 AND M.mvar_item = D.rvde_item AND M.mvar_cons = C.cost_idmov AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                REVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY D.ARTI_COD, REVT_FECHA, R.REVT_ID, RVDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :COSTO
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
            COSTO = COSTOUNIT * CANTIDAD;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        TIPODOC = 33;
        FOR SELECT V.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, D.ARTI_COD, DVDE_CANT * DVDE_FACTOR, (DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR, DVDE_IVAMONTO*DEVT_FACTOR, DVDE_CONSUMO,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, COST_ENTP
            FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D, PREFIJOS P, ARTICULO A, MOVIMIENTO_ARTICULO M, COSTOS C
            WHERE V.DEVT_ID = D.DEVT_ID AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND D.ARTI_COD = A.arti_cod AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                V.devt_id = M.mvar_idref AND M.mvar_tipodoc = 33 AND M.mvar_item = D.dvde_item AND M.mvar_cons = C.cost_idmov AND
                DEVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY D.ARTI_COD, DEVT_FECHA, V.DEVT_ID, DVDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :COSTO
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
            BASE = BASE * -1;
            CANTIDAD = CANTIDAD * -1;
            IVA = IVA * -1;
            CONSUMO = CONSUMO * -1;
            COSTO = COSTOUNIT * CANTIDAD;
            COSTO = COSTO * -1;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        TIPODOC = 34;
        FOR SELECT P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, D.ARTI_COD, PEDE_CANT * PEDE_FACTOR, (PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR, PEDE_IVAMONTO*PEDI_FACTOR, PEDE_CONSUMO,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD 
            FROM PEDIDOS P, PEDIDOS_DETALLE D, PREFIJOS R, ARTICULO A
            WHERE P.PEDI_ID = D.PEDI_ID AND P.PREF_PRE = R.PREF_PRE AND R.TIDO_COD = 34 AND D.ARTI_COD = A.arti_cod AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                PEDI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY D.ARTI_COD, PEDI_FECHA, P.PEDI_ID, PEDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
            COSTO = COSTOUNIT * CANTIDAD;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        TIPODOC = 35;
        FOR SELECT C.PREF_PRE, COTI_NUMERO, COTI_FECHA, D.ARTI_COD, CTDE_CANT * CTDE_FACTOR, (CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR, CTDE_IVAMONTO*COTI_FACTOR, CTDE_CONSUMO,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD 
            FROM COTIZACIONES C, COTIZACIONES_DETALLE D, PREFIJOS P, ARTICULO A
            WHERE C.COTI_ID = D.COTI_ID AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND D.ARTI_COD = A.arti_cod AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                COTI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY D.ARTI_COD, COTI_FECHA, C.COTI_ID, CTDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
            COSTO = COSTOUNIT * CANTIDAD;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            SUSPEND;
            END
        END
    END
END
^

SET TERM ; ^

GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO PROCEDURE REP_UTILIDAD_VENTAS;
GRANT SELECT,INSERT,DELETE ON REPORTES_AUX TO PROCEDURE REP_UTILIDAD_VENTAS;
GRANT SELECT ON FACTURAS_DETALLE TO PROCEDURE REP_UTILIDAD_VENTAS;
GRANT SELECT ON FACTURAS TO PROCEDURE REP_UTILIDAD_VENTAS;
GRANT SELECT ON PREFIJOS TO PROCEDURE REP_UTILIDAD_VENTAS;
GRANT SELECT ON ARTICULO TO PROCEDURE REP_UTILIDAD_VENTAS;
GRANT SELECT ON MOVIMIENTO_ARTICULO TO PROCEDURE REP_UTILIDAD_VENTAS;
GRANT SELECT ON COSTOS TO PROCEDURE REP_UTILIDAD_VENTAS;
GRANT SELECT ON GRUPO TO PROCEDURE REP_UTILIDAD_VENTAS;
GRANT SELECT ON MARCAS TO PROCEDURE REP_UTILIDAD_VENTAS;
GRANT SELECT ON SUBGRUPO TO PROCEDURE REP_UTILIDAD_VENTAS;
GRANT SELECT ON REMISIONES_VENTA_DETALLE TO PROCEDURE REP_UTILIDAD_VENTAS;
GRANT SELECT ON REMISIONES_VENTA TO PROCEDURE REP_UTILIDAD_VENTAS;
GRANT SELECT ON DEVOLUCIONES_VENTAS_DETALLE TO PROCEDURE REP_UTILIDAD_VENTAS;
GRANT SELECT ON DEVOLUCIONES_VENTAS TO PROCEDURE REP_UTILIDAD_VENTAS;
GRANT SELECT ON PEDIDOS_DETALLE TO PROCEDURE REP_UTILIDAD_VENTAS;
GRANT SELECT ON PEDIDOS TO PROCEDURE REP_UTILIDAD_VENTAS;
GRANT EXECUTE ON PROCEDURE COSTO_PROMEDIO TO PROCEDURE REP_UTILIDAD_VENTAS;
GRANT SELECT ON COTIZACIONES_DETALLE TO PROCEDURE REP_UTILIDAD_VENTAS;
GRANT SELECT ON COTIZACIONES TO PROCEDURE REP_UTILIDAD_VENTAS;


/* ARTICULOS VENDIDOS POR VENDEDOR NO RESTA LAS DEVOLUCIONES */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_ARTICULOS_VENDEDOR(
    TIPO INTEGER,
    DETALLE CHAR(1),
    DESDE VARCHAR(20),
    HASTA VARCHAR(20),
    FECINI DATE,
    FECFIN DATE,
    ARTINI VARCHAR(15),
    ARTFIN VARCHAR(15),
    GRPINI VARCHAR(3),
    GRPFIN VARCHAR(3),
    ORDEN CHAR(1),
    AGRUPA CHAR(1),
    ZONA CHAR(1),
    CEROS CHAR(1),
    SUBEMPRESA INTEGER,
    ZONAINI CHAR(2),
    ZONAFIN CHAR(2))
RETURNS (
    CODVEND VARCHAR(20),
    NOMVEND VARCHAR(60),
    NOMTIPO VARCHAR(50),
    ARTICULO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    UNIDAD VARCHAR(8),
    CANTIDAD NUMERIC(18,4),
    BASE NUMERIC(18,2),
    IVA NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    DTO NUMERIC(9,2),
    NIT VARCHAR(20),
    NOMCLIENTE VARCHAR(60),
    CODZONA VARCHAR(2),
    NOMZONA VARCHAR(60))
AS
declare variable codini varchar(15);
declare variable codfin varchar(15);
declare variable desini varchar(15);
declare variable desfin varchar(15);
declare variable marini varchar(3);
declare variable marfin varchar(3);
BEGIN
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END
if (AGRUPA = 'G') then
    BEGIN
    MARINI = '';
    MARFIN = 'zz';
    END
ELSE
    if (AGRUPA = 'M') then
        BEGIN
        MARINI = GRPINI;
        MARFIN = GRPFIN;
        GRPINI = '';
        GRPFIN = 'zz';
        END
    ELSE
        BEGIN
        MARINI = '';
        MARFIN = 'zz';
        END
if (DETALLE = 'N') then
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(FADE_CANT * FADE_FACTOR), SUM((FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR), SUM(FADE_IVAMONTO*FACT_FACTOR), SUM(FADE_CONSUMO), SUM(FADE_TOTAL*FACT_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P, ARTICULO A
            WHERE F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            FACT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY VEND_COD, D.ARTI_COD
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(RVDE_CANT * RVDE_FACTOR), SUM(RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO), SUM(RVDE_IVAMONTO), SUM(RVDE_CONSUMO), SUM(RVDE_TOTAL),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM REMISIONES_VENTA_DETALLE D, REMISIONES_VENTA R, PREFIJOS P, ARTICULO A
            WHERE R.REVT_ID = D.REVT_ID AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            REVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY R.vend_cod, D.ARTI_COD
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(DVDE_CANT * DVDE_FACTOR), SUM((DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR), SUM(DVDE_IVAMONTO*DEVT_FACTOR), SUM(DVDE_CONSUMO), SUM(DVDE_TOTAL*DEVT_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM devoluciones_ventas_detalle D, DEVOLUCIONES_VENTAS V, PREFIJOS P, ARTICULO A
            WHERE V.DEVT_ID = D.DEVT_ID AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            DEVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY V.vend_cod, D.ARTI_COD
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    BEGIN
                    BASE = BASE * -1;
                    IVA = IVA * -1;
                    CANTIDAD = CANTIDAD * -1;
                    TOTAL = TOTAL * -1;
                    SUSPEND;
                    END
            END /* FOR */
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(PEDE_CANT * PEDE_FACTOR), SUM((PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR), SUM(PEDE_IVAMONTO*PEDI_FACTOR), SUM(PEDE_CONSUMO), SUM(PEDE_TOTAL*PEDI_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM PEDIDOS_DETALLE D, PEDIDOS P, PREFIJOS R, ARTICULO A
            WHERE P.PEDI_ID = D.PEDI_ID AND P.PREF_PRE = R.PREF_PRE AND R.TIDO_COD = 34 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            PEDI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY P.vend_cod, D.ARTI_COD
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(CTDE_CANT * CTDE_FACTOR), SUM((CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR), SUM(CTDE_IVAMONTO*COTI_FACTOR), SUM(CTDE_CONSUMO), SUM(CTDE_TOTAL*COTI_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM COTIZACIONES_DETALLE D, COTIZACIONES C, PREFIJOS P, ARTICULO A
            WHERE C.COTI_ID = D.COTI_ID AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            COTI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY C.vend_cod, D.ARTI_COD
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    END
ELSE
  if (DETALLE = 'S') then
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
        FOR SELECT F.PREF_PRE, FACT_NUMERO, FACT_FECHA, VEND_COD, D.ARTI_COD, FADE_CANT * FADE_FACTOR, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR, FADE_IVAMONTO*FACT_FACTOR, FADE_CONSUMO, FADE_DTOPORC, FADE_TOTAL*FACT_FACTOR,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD , F.TERC_NIT, F.fact_nomcliente
            FROM FACTURAS F, FACTURAS_DETALLE D, PREFIJOS P, ARTICULO A
            WHERE F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND D.ARTI_COD = A.arti_cod AND
                VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND FACT_FECHA >= :FECINI AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY VEND_COD, D.ARTI_COD, FACT_FECHA, F.FACT_ID, FADE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :CODVEND, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO, :DTO, :TOTAL,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT, :nomcliente
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
        FOR SELECT R.PREF_PRE, REVT_NUMERO, REVT_FECHA, VEND_COD, D.ARTI_COD, RVDE_CANT * RVDE_FACTOR, (RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO), RVDE_IVAMONTO, RVDE_CONSUMO, RVDE_DTOPORC, RVDE_TOTAL,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, R.terc_nit, R.revt_nomterc
            FROM REMISIONES_VENTA R, REMISIONES_VENTA_DETALLE D, PREFIJOS P, ARTICULO A
            WHERE R.REVT_ID = D.REVT_ID AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND D.ARTI_COD = A.arti_cod AND
                VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                REVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY VEND_COD, D.ARTI_COD, REVT_FECHA, R.REVT_ID, RVDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :CODVEND, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO, :DTO, :TOTAL,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT, :nomcliente
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
        FOR SELECT V.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, VEND_COD, D.ARTI_COD, DVDE_CANT * DVDE_FACTOR, (DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR, DVDE_IVAMONTO*DEVT_FACTOR, DVDE_CONSUMO, DVDE_DTOPORC, DVDE_TOTAL*DEVT_FACTOR,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, V.terc_nit, V.devt_nomterc
            FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D, PREFIJOS P, ARTICULO A
            WHERE V.DEVT_ID = D.DEVT_ID AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND D.ARTI_COD = A.arti_cod AND
                VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                DEVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY VEND_COD, D.ARTI_COD, DEVT_FECHA, V.DEVT_ID, DVDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :CODVEND, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO, :DTO, :TOTAL,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT, :nomcliente
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
        FOR SELECT P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, VEND_COD, D.ARTI_COD, PEDE_CANT * PEDE_FACTOR, (PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR, PEDE_IVAMONTO*PEDI_FACTOR, PEDE_CONSUMO, PEDE_DTOPORC, PEDE_TOTAL*PEDI_FACTOR,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, P.terc_nit, P.pedi_nomterc
            FROM PEDIDOS P, PEDIDOS_DETALLE D, PREFIJOS R, ARTICULO A
            WHERE P.PEDI_ID = D.PEDI_ID AND P.PREF_PRE = R.PREF_PRE AND R.TIDO_COD = 34 AND D.ARTI_COD = A.arti_cod AND
                VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                PEDI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY VEND_COD, D.ARTI_COD, PEDI_FECHA, P.PEDI_ID, PEDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :CODVEND, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO, :DTO, :TOTAL,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT, :nomcliente
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
        FOR SELECT C.PREF_PRE, COTI_NUMERO, COTI_FECHA, VEND_COD, D.ARTI_COD, CTDE_CANT * CTDE_FACTOR, (CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR, CTDE_IVAMONTO*COTI_FACTOR, CTDE_CONSUMO, CTDE_DTOPORC, CTDE_TOTAL*COTI_FACTOR,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, C.terc_nit, C.coti_nomterc
            FROM COTIZACIONES C, COTIZACIONES_DETALLE D, PREFIJOS P, ARTICULO A
            WHERE C.COTI_ID = D.COTI_ID AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND D.ARTI_COD = A.arti_cod AND
                VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                COTI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY VEND_COD, D.ARTI_COD, COTI_FECHA, C.COTI_ID, CTDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :CODVEND, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO, :DTO, :TOTAL,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT, :nomcliente
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SUSPEND;
            END
        END
    END
  ELSE
if (DETALLE = 'C') then
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(FADE_CANT * FADE_FACTOR), SUM((FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR), SUM(FADE_IVAMONTO*FACT_FACTOR), SUM(FADE_CONSUMO), SUM(FADE_TOTAL*FACT_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(F.terc_nit), MAX(F.fact_nomcliente)
            FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P, ARTICULO A
            WHERE F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            FACT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY F.VEND_COD, F.TERC_NIT, D.ARTI_COD
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit INTO :codzona, :nomzona;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(RVDE_CANT * RVDE_FACTOR), SUM(RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO), SUM(RVDE_IVAMONTO), SUM(RVDE_CONSUMO), SUM(RVDE_TOTAL),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(R.terc_nit), MAX(R.revt_nomterc)
            FROM REMISIONES_VENTA_DETALLE D, REMISIONES_VENTA R, PREFIJOS P, ARTICULO A
            WHERE R.REVT_ID = D.REVT_ID AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            REVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY R.vend_cod, R.terc_nit, D.arti_cod
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit INTO :codzona, :nomzona;
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(DVDE_CANT * DVDE_FACTOR), SUM((DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR), SUM(DVDE_IVAMONTO*DEVT_FACTOR), SUM(DVDE_CONSUMO), SUM(DVDE_TOTAL*DEVT_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(V.terc_nit), MAX(V.devt_nomterc)
            FROM devoluciones_ventas_detalle D, DEVOLUCIONES_VENTAS V, PREFIJOS P, ARTICULO A
            WHERE V.DEVT_ID = D.DEVT_ID AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            DEVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY V.vend_cod, V.terc_nit, D.arti_cod
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit INTO :codzona, :nomzona;
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(PEDE_CANT * PEDE_FACTOR), SUM((PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR), SUM(PEDE_IVAMONTO*PEDI_FACTOR), SUM(PEDE_CONSUMO), SUM(PEDE_TOTAL*PEDI_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(P.terc_nit), MAX(P.pedi_nomterc)
            FROM PEDIDOS_DETALLE D, PEDIDOS P, PREFIJOS R, ARTICULO A
            WHERE P.PEDI_ID = D.PEDI_ID AND P.PREF_PRE = R.PREF_PRE AND R.TIDO_COD = 34 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            PEDI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY P.vend_cod, P.terc_nit, D.arti_cod
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit INTO :codzona, :nomzona;
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(CTDE_CANT * CTDE_FACTOR), SUM((CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR), SUM(CTDE_IVAMONTO*COTI_FACTOR), SUM(CTDE_CONSUMO), SUM(CTDE_TOTAL*COTI_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(C.terc_nit), MAX(C.coti_nomterc)
            FROM COTIZACIONES_DETALLE D, COTIZACIONES C, PREFIJOS P, ARTICULO A
            WHERE C.COTI_ID = D.COTI_ID AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            COTI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY C.vend_cod, C.terc_nit, D.arti_cod
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit INTO :codzona, :nomzona;
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    END
if (zona = 'S') then
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(F.VEND_COD), SUM(FADE_CANT * FADE_FACTOR), SUM((FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR), SUM(FADE_IVAMONTO*FACT_FACTOR), SUM(FADE_CONSUMO), SUM(FADE_TOTAL*FACT_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(F.terc_nit), MAX(F.fact_nomcliente)
            FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P, ARTICULO A, clientes C, ZONAS Z
            WHERE F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND D.ARTI_COD = A.arti_cod AND
            F.VEND_COD >= :DESDE AND F.VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            FACT_ANULADO = 'N' AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) AND F.terc_nit = C.terc_nit AND
            Z.zona_cod = C.zona_cod AND C.zona_cod >= :zonaini AND C.zona_cod <= :zonafin
            GROUP BY F.VEND_COD, C.zona_cod ,D.ARTI_COD , C.terc_nit
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit /*AND Z.zona_cod >= :zonaini AND Z.zona_cod >= :zonafin*/ INTO :codzona, :nomzona;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(R.VEND_COD), SUM(RVDE_CANT * RVDE_FACTOR), SUM(RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO), SUM(RVDE_IVAMONTO), SUM(RVDE_CONSUMO), SUM(RVDE_TOTAL),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(R.terc_nit), MAX(R.revt_nomterc)
            FROM REMISIONES_VENTA_DETALLE D, REMISIONES_VENTA R, PREFIJOS P, ARTICULO A, clientes C, ZONAS Z
            WHERE R.REVT_ID = D.REVT_ID AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND D.ARTI_COD = A.arti_cod AND
            R.VEND_COD >= :DESDE AND R.VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            REVT_ANULADO = 'N' AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))AND R.terc_nit = C.terc_nit AND
            Z.zona_cod = C.zona_cod AND C.zona_cod >= :zonaini AND C.zona_cod <= :zonafin
            GROUP BY R.vend_cod, c.zona_cod, D.arti_cod , R.terc_nit
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit INTO :codzona, :nomzona;
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(V.VEND_COD), SUM(DVDE_CANT * DVDE_FACTOR), SUM((DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR), SUM(DVDE_IVAMONTO*DEVT_FACTOR), SUM(DVDE_CONSUMO), SUM(DVDE_TOTAL*DEVT_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(V.terc_nit), MAX(V.devt_nomterc)
            FROM devoluciones_ventas_detalle D, DEVOLUCIONES_VENTAS V, PREFIJOS P, ARTICULO A, clientes C, ZONAS Z
            WHERE V.DEVT_ID = D.DEVT_ID AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND D.ARTI_COD = A.arti_cod AND
            V.VEND_COD >= :DESDE AND V.VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            DEVT_ANULADO = 'N' AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))AND V.terc_nit = C.terc_nit AND
            Z.zona_cod = C.zona_cod AND C.zona_cod >= :zonaini AND C.zona_cod <= :zonafin
            GROUP BY V.vend_cod, c.zona_cod, D.arti_cod , V.terc_nit
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit INTO :codzona, :nomzona;
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(P.VEND_COD), SUM(PEDE_CANT * PEDE_FACTOR), SUM((PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR), SUM(PEDE_IVAMONTO*PEDI_FACTOR), SUM(PEDE_CONSUMO), SUM(PEDE_TOTAL*PEDI_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(P.terc_nit), MAX(P.pedi_nomterc)
            FROM PEDIDOS_DETALLE D, PEDIDOS P, PREFIJOS R, ARTICULO A, clientes C, ZONAS Z
            WHERE P.PEDI_ID = D.PEDI_ID AND P.PREF_PRE = R.PREF_PRE AND R.TIDO_COD = 34 AND D.ARTI_COD = A.arti_cod AND
            P.VEND_COD >= :DESDE AND P.VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            PEDI_ANULADO = 'N' AND ((R.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))AND P.terc_nit = C.terc_nit AND
            Z.zona_cod = C.zona_cod AND C.zona_cod >= :zonaini AND C.zona_cod <= :zonafin
            GROUP BY P.vend_cod, c.zona_cod, D.arti_cod , P.terc_nit
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit INTO :codzona, :nomzona;
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(C.VEND_COD), SUM(CTDE_CANT * CTDE_FACTOR), SUM((CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR), SUM(CTDE_IVAMONTO*COTI_FACTOR), SUM(CTDE_CONSUMO), SUM(CTDE_TOTAL*COTI_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(C.terc_nit), MAX(C.coti_nomterc)
            FROM COTIZACIONES_DETALLE D, COTIZACIONES C, PREFIJOS P, ARTICULO A, clientes T, ZONAS Z
            WHERE C.COTI_ID = D.COTI_ID AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND D.ARTI_COD = A.arti_cod AND
            C.VEND_COD >= :DESDE AND C.VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            COTI_ANULADO = 'N' AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))AND C.terc_nit = T.terc_nit AND
            Z.zona_cod = T.zona_cod AND T.zona_cod >= :zonaini AND T.zona_cod <= :zonafin
            GROUP BY C.vend_cod, t.zona_cod, D.arti_cod , C.terc_nit
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit INTO :codzona, :nomzona;
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    END
END
^

SET TERM ; ^

GRANT SELECT ON TIPO_DOCUMENTO TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON FACTURAS_DETALLE TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON FACTURAS TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON PREFIJOS TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON ARTICULO TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON VENDEDORES TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON GRUPO TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON MARCAS TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON SUBGRUPO TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON REMISIONES_VENTA_DETALLE TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON REMISIONES_VENTA TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON DEVOLUCIONES_VENTAS_DETALLE TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON DEVOLUCIONES_VENTAS TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON PEDIDOS_DETALLE TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON PEDIDOS TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON COTIZACIONES_DETALLE TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON COTIZACIONES TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON CLIENTES TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON ZONAS TO PROCEDURE REP_ARTICULOS_VENDEDOR;


update revision set revi_FECHA = '2008/08/31';
COMMIT WORK;

