/* consulta ventas con fecini y fecfin */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE VENTAS_ARTICULO_MES(
    FECINI DATE,
    FECFIN DATE,
    SUBEMPRESA INTEGER)
RETURNS (
    ARTICULO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    UNIDAD VARCHAR(8),
    CANTVTAS NUMERIC(18,4),
    BASEVTAS NUMERIC(18,2),
    IVAVTAS NUMERIC(18,2),
    CANTDEV NUMERIC(18,4),
    BASEDEV NUMERIC(18,2),
    IVADEV NUMERIC(18,2))
AS
BEGIN
FOR SELECT MAX(ARTI_COD), SUM(FADE_CANT * FADE_FACTOR), SUM((cast(FADE_TOTAL as double precision)-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR),
    SUM(FADE_IVAMONTO*FACT_FACTOR)
    FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P
    WHERE F.FACT_ID = D.FACT_ID AND FACT_FECHA >= :FECINI AND FACT_FECHA < :FECFIN AND FACT_ANULADO = 'N'
       AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    GROUP BY ARTI_COD
    INTO :ARTICULO, :CANTVTAS, :BASEVTAS, :IVAVTAS
    DO
    BEGIN
    SELECT ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD, GRUP_NOM 
        FROM ARTICULO A, GRUPO G WHERE A.ARTI_COD = :articulo AND A.GRUP_COD = G.grup_cod
        INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NOMGRUPO;
    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
    SELECT SUM(DVDE_CANT * DVDE_FACTOR), SUM((cast(DVDE_TOTAL as double precision)-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR),
        SUM(DVDE_IVAMONTO*DEVT_FACTOR)
        FROM DEVOLUCIONES_VENTAS F, devoluciones_ventas_DETALLE D, PREFIJOS P
        WHERE F.DEVT_ID = D.DEVT_ID AND ARTI_COD = :ARTICULO AND DEVT_FECHA >= :FECINI AND DEVT_FECHA < :FECFIN AND DEVT_ANULADO = 'N'
        AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 33 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        INTO :CANTDEV, :BASEDEV, :IVADEV;
    if (cantvtas IS NULL) then
        cantvtas = 0;
    if (cantdev IS NULL) then
        cantdev = 0;
    if (ivavtas IS NULL) then
        ivavtas = 0;
    if (IVADEV IS NULL) then
        IVADEV = 0;
    if (basevtas IS NULL) then
        basevtas = 0;
    if (basedev IS NULL) then
        basedev = 0;
    if ((CANTVTAS <> 0) or (CANTDEV <> 0)) then
        SUSPEND;
    END
END
^

SET TERM ; ^


SET TERM ^ ;

CREATE OR ALTER PROCEDURE VENTAS_CLIENTE_MES(
    FECINI DATE,
    FECFIN DATE,
    SUBEMPRESA INTEGER)
RETURNS (
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    FACTURAS INTEGER,
    MFACTURAS NUMERIC(18,2),
    DEVOLUCIONES INTEGER,
    MDEVOLUCIONES NUMERIC(18,2),
    IVAFACT NUMERIC(18,2),
    IVADEV NUMERIC(18,2),
    CONSUMOF NUMERIC(18,2),
    CONSUMOD NUMERIC(18,2))
AS
BEGIN
  for select TERC_NIT, TERC_NOM from TERCEROS WHERE TERC_CLIE = 'S' into :NIT, :NOMBRE
  DO
    BEGIN
    EXECUTE PROCEDURE VENTAS_CLIENTE (NIT, FECINI, FECFIN, SUBEMPRESA) returning_values (FACTURAS, MFACTURAS, DEVOLUCIONES, MDEVOLUCIONES, IVAFACT, IVADEV, CONSUMOF, CONSUMOD);
    SUSPEND;
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE VENTAS_VENDEDOR_MES(
    FECINI DATE,
    FECFIN DATE,
    SUBEMPRESA INTEGER)
RETURNS (
    CODIGO INTEGER,
    NOMBRE VARCHAR(60),
    FACTURAS INTEGER,
    MFACTURAS NUMERIC(18,2),
    DEVOLUCIONES INTEGER,
    MDEVOLUCIONES NUMERIC(18,2),
    IVAFACT NUMERIC(18,2),
    IVADEV NUMERIC(18,2),
    CONSUMOF NUMERIC(18,2),
    CONSUMOD NUMERIC(18,2))
AS
BEGIN
  for select VEND_COD, VEND_NOMBRE from VENDEDORES into :CODIGO, :NOMBRE
  DO
    BEGIN
    EXECUTE PROCEDURE VENTAS_VENDEDOR (CODIGO, FECINI, FECFIN, SUBEMPRESA) returning_values (FACTURAS, MFACTURAS, DEVOLUCIONES, MDEVOLUCIONES, IVAFACT, IVADEV, CONSUMOF, CONSUMOD);
    SUSPEND;
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE MOVIMIENTO_INVENTARIO_MES(
    ANO CHAR(4),
    MES INTEGER)
RETURNS (
    CODIGO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    INICIAL NUMERIC(18,4),
    ENTRADA NUMERIC(18,4),
    SALIDA NUMERIC(18,4),
    FINAL NUMERIC(18,4))
AS
BEGIN
/*   for select arti_cod, arti_des from articulo into :CODIGO, :DESCRIPCION
  DO
    BEGIN
    EXECUTE PROCEDURE MOVIMIENTO_TOTAL_ARTICULO_MES(CODIGO, ANO, MES) returning_values (:INICIAL, :ENTRADA, :SALIDA);
    FINAL = INICIAL + ENTRADA - SALIDA;
    SUSPEND;
    END */
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE MOVIMIENTO_TOTAL_ARTICULO_MES(
    ARTICULO VARCHAR(15),
    ANO CHAR(4),
    MES INTEGER)
RETURNS (
    INICIAL NUMERIC(18,4),
    ENTRADA NUMERIC(18,4),
    SALIDA NUMERIC(18,4))
AS
declare variable BOD CHAR(2);
declare variable INI NUMERIC(15,4);
declare variable ENTC NUMERIC(15,4);
declare variable SALC NUMERIC(15,4);
BEGIN
/*  INICIAL = 0;
  ENTRADA = 0;
  SALIDA = 0;
  FOR SELECT BODE_COD FROM BODEGA INTO :BOD
  DO
    BEGIN
    EXECUTE PROCEDURE MOVIMIENTO_ARTICULO_MES(:ARTICULO, :ANO, :MES, :BOD) returning_values (INI, ENTC, SALC);
    INICIAL = INICIAL + INI;
    ENTRADA = ENTRADA + ENTC;
    SALIDA = SALIDA + SALC;
    END
  SUSPEND; */
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE MOVIMIENTO_ARTICULO_MES(
    ARTICULO VARCHAR(15),
    FECINI DATE,
    FECFIN DATE,
    BODEGA CHAR(2))
RETURNS (
    INICIAL NUMERIC(18,4),
    ENTC NUMERIC(18,4),
    SALC NUMERIC(18,4))
AS
BEGIN
  EXECUTE PROCEDURE SALDO_INICIAL_INVENTARIO(ARTICULO, FECINI, BODEGA) returning_values (INICIAL);
  SELECT SUM(MVAR_CANT) FROM MOVIMIENTO_ARTICULO
    WHERE (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA < :FECFIN) AND
          (ARTI_COD = :ARTICULO) AND (BODE_COD = :BODEGA) AND (MVAR_ENTRADA = 'S') INTO :ENTC;
  if (ENTC IS NULL) then
    ENTC = 0;
  SELECT SUM(MVAR_CANT) FROM MOVIMIENTO_ARTICULO
    WHERE (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA < :FECFIN) AND
          (ARTI_COD = :ARTICULO) AND (BODE_COD = :BODEGA) AND (MVAR_ENTRADA = 'N') INTO :SALC;
  if (SALC IS NULL) then
    SALC = 0;
  SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE MOVIMIENTO_TOTAL_ARTICULO_MES(
    ARTICULO VARCHAR(15),
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    INICIAL NUMERIC(18,4),
    ENTRADA NUMERIC(18,4),
    SALIDA NUMERIC(18,4))
AS
declare variable BOD CHAR(2);
declare variable INI NUMERIC(15,4);
declare variable ENTC NUMERIC(15,4);
declare variable SALC NUMERIC(15,4);
BEGIN
  INICIAL = 0;
  ENTRADA = 0;
  SALIDA = 0;
  FOR SELECT BODE_COD FROM BODEGA INTO :BOD
  DO
    BEGIN
    EXECUTE PROCEDURE MOVIMIENTO_ARTICULO_MES(:ARTICULO, :FECINI, :FECFIN, :BOD) returning_values (INI, ENTC, SALC);
    INICIAL = INICIAL + INI;
    ENTRADA = ENTRADA + ENTC;
    SALIDA = SALIDA + SALC;
    END
  SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE MOVIMIENTO_INVENTARIO_MES(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    CODIGO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    INICIAL NUMERIC(18,4),
    ENTRADA NUMERIC(18,4),
    SALIDA NUMERIC(18,4),
    FINAL NUMERIC(18,4))
AS
BEGIN
  for select arti_cod, arti_des from articulo into :CODIGO, :DESCRIPCION
  DO
    BEGIN
    EXECUTE PROCEDURE MOVIMIENTO_TOTAL_ARTICULO_MES(CODIGO, FECINI, FECFIN) returning_values (:INICIAL, :ENTRADA, :SALIDA);
    FINAL = INICIAL + ENTRADA - SALIDA;
    SUSPEND;
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE MOVIMIENTO_CARTERA_MES(
    FECINI DATE,
    FECFIN DATE,
    SUBEMPRESA INTEGER,
    CONTADO CHAR(1))
RETURNS (
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    INICIAL NUMERIC(18,2),
    DEBITOS NUMERIC(18,2),
    CREDITOS NUMERIC(18,2),
    ABONOS NUMERIC(18,2),
    FINAL NUMERIC(18,2))
AS
declare variable RETES CHAR(2);
declare variable TIPODOC INTEGER;
declare variable IDDOC INTEGER;
declare variable SALDO NUMERIC(18,2);
declare variable NUMROWS INTEGER;
BEGIN
  for select TERC_NIT, TERC_NOM from TERCEROS WHERE TERC_CLIE = 'S' into :NIT, :NOMBRE
  DO
    BEGIN
    SELECT COUNT(*) FROM AUTORIZACIONES WHERE AUTO_NITCONTADO = :NIT INTO :numrows;
    IF ((CONTADO = 'S') or (numrows = 0)) THEN
        BEGIN
        FECINI = FECINI - 1;
        INICIAL = 0;
        FOR SELECT MVCL_TIPOREF, MVCL_IDREF FROM MOVIMIENTO_CLIENTES
            WHERE TERC_NIT = :NIT AND MVCL_FECHA <= :FECINI AND
            MVCL_ABONO = 'N' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
            INTO :TIPODOC, :IDDOC
            DO
            BEGIN
            EXECUTE PROCEDURE saldo_doc_cartera(TIPODOC, IDDOC, FECINI) returning_values (SALDO);
            INICIAL = INICIAL + SALDO;
            END
        EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'DESCONTAR RETENCIONES POR CAUSACION') returning_values(:RETES);
        FECINI = FECINI + 1;
        if (RETES = 'SI') then
            BEGIN
            SELECT SUM(MVCL_MONTO-MVCL_RTEFTE-MVCL_RTEIVA-MVCL_RTEICA) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_DEBITO = 'S' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :DEBITOS;
            SELECT SUM(MVCL_MONTO-MVCL_RTEFTE-MVCL_RTEIVA-MVCL_RTEICA) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_DEBITO = 'N' AND MVCL_ABONO = 'N' and MVCL_TIPOREF <> 45 AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :CREDITOS;
            SELECT SUM(MVCL_MONTO) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_ABONO = 'S' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :ABONOS;
            END
        ELSE
            BEGIN
            SELECT SUM(MVCL_MONTO) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_DEBITO = 'S' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :DEBITOS;
            SELECT SUM(MVCL_MONTO) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_DEBITO = 'N' AND MVCL_ABONO = 'N' and MVCL_TIPOREF <> 45 AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :CREDITOS;
            SELECT SUM(MVCL_MONTO+MVCL_RTEFTE+MVCL_RTEIVA+MVCL_RTEICA) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_ABONO = 'S' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :ABONOS;
            END
        if (DEBITOS IS NULL) then
            DEBITOS = 0;
        if (CREDITOS IS NULL) then
            CREDITOS = 0;
        if (ABONOS IS NULL) then
            ABONOS = 0;
        FINAL = INICIAL + DEBITOS - CREDITOS - ABONOS;
        SUSPEND;
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE MOVIMIENTO_CXPAGAR_MES(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    INICIAL NUMERIC(18,4),
    DEBITOS NUMERIC(18,4),
    CREDITOS NUMERIC(18,4),
    ABONOS NUMERIC(18,4),
    FINAL NUMERIC(18,4))
AS
declare variable RETES CHAR(2);
BEGIN
  for select TERC_NIT, TERC_NOM from TERCEROS WHERE TERC_PROV = 'S' into :NIT, :NOMBRE
  DO
    BEGIN
    EXECUTE PROCEDURE saldo_proveedor (NIT, FECINI) returning_values (INICIAL);
    EXECUTE PROCEDURE LEE_CONFIGURACION('CXPAGAR', 'SALDOS', 'DESCONTAR RETENCIONES POR CAUSACION') returning_values(:RETES);
    if (RETES = 'SI') then
        BEGIN
        SELECT SUM(MVPR_MONTO-MVPR_RTFTE-MVPR_RTIVA-MVPR_RTICA)
            FROM movimiento_proveedor
            WHERE TERC_NIT = :NIT AND MVPR_FECHA >= :FECINI AND MVPR_FECHA < :FECFIN AND MVPR_DEBITO = 'S'
            INTO :DEBITOS;
        SELECT SUM(MVPR_MONTO-MVPR_RTFTE-MVPR_RTIVA-MVPR_RTICA)
            FROM movimiento_proveedor
            WHERE TERC_NIT = :NIT AND MVPR_FECHA >= :FECINI AND MVPR_FECHA < :FECFIN AND MVPR_DEBITO = 'N' AND MVPR_ABONO = 'N' and MVPR_TIPOREF <> 55
            INTO :CREDITOS;
        SELECT SUM(MVPR_MONTO) FROM movimiento_proveedor
            WHERE TERC_NIT = :NIT AND MVPR_FECHA >= :FECINI AND MVPR_FECHA < :FECFIN AND MVPR_ABONO = 'S'
            INTO :ABONOS;
        END
    ELSE
        BEGIN
        SELECT SUM(MVPR_MONTO)
            FROM movimiento_proveedor
            WHERE TERC_NIT = :NIT AND MVPR_FECHA >= :FECINI AND MVPR_FECHA < :FECFIN AND MVPR_DEBITO = 'S'
            INTO :DEBITOS;
        SELECT SUM(MVPR_MONTO)
            FROM movimiento_proveedor
            WHERE TERC_NIT = :NIT AND MVPR_FECHA >= :FECINI AND MVPR_FECHA < :FECFIN AND MVPR_DEBITO = 'N' AND MVPR_ABONO = 'N' AND MVPR_TIPOREF <> 55
            INTO :CREDITOS;
        SELECT SUM(MVPR_MONTO+MVPR_RTFTE+MVPR_RTIVA+MVPR_RTICA)
            FROM movimiento_proveedor
            WHERE TERC_NIT = :NIT AND MVPR_FECHA >= :FECINI AND MVPR_FECHA < :FECFIN AND MVPR_ABONO = 'S'
            INTO :ABONOS;
        END
    if (DEBITOS IS NULL) then
        DEBITOS = 0;
    if (CREDITOS IS NULL) then
        CREDITOS = 0;
    if (ABONOS IS NULL) then
        ABONOS = 0;
    FINAL = INICIAL + DEBITOS - CREDITOS - ABONOS;
    SUSPEND;
    END
END
^

SET TERM ; ^


/* contabilizacin por artculo */

ALTER TABLE CONTABIL_ARTICULO
ADD COAR_CTARTFTE T_CTA_CONTABLE;
ALTER TABLE CONTABIL_ARTICULO
ADD COAR_CTARTICA T_CTA_CONTABLE;
ALTER TABLE CONTABIL_ARTICULO
ADD COAR_CTARTFTEV T_CTA_CONTABLE;
ALTER TABLE CONTABIL_ARTICULO
ADD COAR_CTARTICAV T_CTA_CONTABLE;
ALTER TABLE CONTABIL_ARTICULO
ADD COAR_RTFTE T_PORCENTAJE;
ALTER TABLE CONTABIL_ARTICULO
ADD COAR_RTICA T_PORCENTAJE;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE CUENTA_INTERFAZ(
    TIPO INTEGER,
    ID INTEGER,
    CUENTA VARCHAR(20),
    INV CHAR(1))
RETURNS (
    CTAOK VARCHAR(20),
    TIPOCUEN CHAR(1),
    ERROR INTEGER)
AS
begin
ERROR = 0;
CTAOK = NULL;
SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
    WHERE CUEN_COD = :CUENTA INTO :CTAOK, :TIPOCUEN;
if (CTAOK IS NULL) then
    begin
    EXECUTE PROCEDURE ERROR (:TIPO, :ID, :CUENTA, 2);
    CTAOK = CUENTA;
    TIPOCUEN = 'N';
    ERROR = 1;
    end
if ((INV <> 'S') and (TIPOCUEN = 'I')) then
    begin
    EXECUTE PROCEDURE ERROR (:TIPO, :ID, :CUENTA, 3);
    TIPOCUEN = 'N';
    ERROR = 1;
    end
suspend;
end
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE CONTABIL_FACTURA(
    IDDOC INTEGER,
    IDINTER INTEGER)
RETURNS (
    ERROR INTEGER,
    VER CHAR(1),
    IDC INTEGER)
AS
declare variable pref varchar(4);
declare variable num varchar(6);
declare variable numero varchar(10);
declare variable fecaux date;
declare variable fecha char(8);
declare variable conc varchar(60);
declare variable venceaux date;
declare variable vence char(8);
declare variable vrdto numeric(18,2);
declare variable vradic numeric(18,2);
declare variable vrsubt numeric(18,2);
declare variable vriva numeric(18,2);
declare variable prtfte numeric(9,2);
declare variable vrrtfte numeric(18,2);
declare variable vrrtiva numeric(18,2);
declare variable prtica numeric(9,2);
declare variable vrrtica numeric(18,2);
declare variable vrtotal numeric(18,2);
declare variable vrextra numeric(18,2);
declare variable tipocomp varchar(3);
declare variable prefcont varchar(4);
declare variable ventas char(1);
declare variable ctaventas varchar(20);
declare variable iva char(1);
declare variable ctaiva varchar(20);
declare variable consumo char(1);
declare variable ctaconsumo varchar(20);
declare variable cartera char(1);
declare variable ctacartera varchar(20);
declare variable rtfte char(1);
declare variable ctartfte varchar(20);
declare variable rtiva char(1);
declare variable ctartiva varchar(20);
declare variable rtica char(1);
declare variable ctartica varchar(20);
declare variable inven char(1);
declare variable ctainven varchar(20);
declare variable costos char(1);
declare variable ctacostos varchar(20);
declare variable ctadto varchar(20);
declare variable ctaadic varchar(20);
declare variable ctaextra varchar(20);
declare variable existe char(1);
declare variable cuenta varchar(20);
declare variable monto numeric(18,2);
declare variable tipocuen char(1);
declare variable nit varchar(20);
declare variable nombre varchar(60);
declare variable proy varchar(4);
declare variable centro varchar(4);
declare variable porc numeric(5,2);
declare variable debito numeric(18,2);
declare variable credito numeric(18,2);
declare variable nroi integer;
declare variable art varchar(15);
declare variable imptos numeric(18,2);
declare variable suma numeric(18,2);
declare variable porciva numeric(9,2);
declare variable tctaclien varchar(20);
declare variable tctaventa varchar(20);
declare variable tctartfte varchar(20);
declare variable tctartiva varchar(20);
declare variable tctartica varchar(20);
declare variable ctadic varchar(20);
declare variable baseadic varchar(20);
declare variable porcadic numeric(5,2);
declare variable valoradic numeric(18,2);
declare variable dbadic char(1);
declare variable ptovta integer;
declare variable anulado char(1);
declare variable dig integer;
declare variable mercancia numeric(18,2);
declare variable fomento varchar(2);
declare variable DTOXIT varchar(2);
declare variable vrconsumo numeric(18,2);
declare variable factor double precision;
declare variable cent char(1);
declare variable AUTORET VARCHAR(10);
declare variable FAUTORET DATE;
declare variable ERRORC INTEGER;
BEGIN
EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'USAR IMPOCONSUMO COMO PORCENTAJE DE FOMENTO') returning_values (FOMENTO);
EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'FECHA AUTORETENEDOR NO DESCONTAR RETENCIONES DEL SALDO PERO SI CONTABILIZARLAS') returning_values (AUTORET);
if (AUTORET <> '') then
    FAUTORET = CAST(AUTORET AS DATE);
else
    FAUTORET = '9999/12/31';
/* BUSQUE LA INTERFACE */
EXISTE = 'N';
SELECT 'S', TICO_COD, PRCO_PRE, INVE_VENTAS, INVE_IVA, INVE_CONSUMO, INVE_CARTERA, INVE_RTFTE, INVE_RTIVA, INVE_RTICA, INVE_COSTO, INVE_INVEN, INVE_CTAVENTAS, INVE_CTAIVA, INVE_CTACONSUMO, INVE_CTADTO, INVE_CTAADIC, INVE_CTAEXTRA, INVE_CTACARTERA, INVE_CTARTFTE, INVE_CTARTIVA, INVE_CTARTICA, INVE_CTAINVEN, INVE_CTACOSTOS, INVE_CONFIRMAR, INVE_CENTRO
    FROM INTERFAZ_VENTAS
    WHERE INVE_ID = :IDINTER
    INTO :EXISTE, :TIPOCOMP, :PREFCONT, :VENTAS, :IVA, :CONSUMO, :CARTERA, :RTFTE, :RTIVA, :RTICA, :COSTOS, :INVEN, :CTAVENTAS, :CTAIVA, :CTACONSUMO, :CTADTO, :CTAADIC, :CTAEXTRA, :CTACARTERA, :CTARTFTE, :CTARTIVA, :CTARTICA, :CTAINVEN, :CTACOSTOS, :VER, :CENT;
if (EXISTE = 'S') then
  BEGIN
    /* BORRE CUALQUEIR CONTABILIZACION PREVIA */
    DELETE FROM CONTABILIZACION WHERE CNTB_TIPOREF = 31 AND CNTB_IDREF = :IDDOC;

  /* TRAIGA EL ENCABEZADO DE LA FACTURA */
  SELECT PREF_PRE, FACT_NUMERO, FACT_FECHA, F.TERC_NIT, PTVT_ID, FACT_VENCE, FACT_DTOMONTO, FACT_ADICIONAL, FACT_IVAMONTO, FACT_EXTRA, FACT_TOTAL, FACT_RTFTEPOR, FACT_RTFTEMONTO, FACT_RTIVAPOR, FACT_RTIVAMONTO, FACT_RTICAPOR, FACT_RTICAMONTO, FACT_NOMCLIENTE, TERC_CTARTFTE, TERC_CTARTIVA, TERC_CTARTICA, TERC_CTAVENTA, TERC_CTACLIENTE, FACT_ANULADO
        FROM FACTURAS F, TERCEROS T
        WHERE FACT_ID = :IDDOC AND F.TERC_NIT = T.TERC_NIT
        INTO :PREF, :NUM, :FECAUX, :NIT, :PTOVTA, :VENCEAUX, :VRDTO, :VRADIC, :VRIVA, :VREXTRA, :VRTOTAL, :PRTFTE, :VRRTFTE, :PORC, :VRRTIVA, :PRTICA, :VRRTICA, :NOMBRE, TCTARTFTE, TCTARTIVA, TCTARTICA, TCTAVENTA, TCTACLIEN, ANULADO;
  if (ANULADO = 'N') then
    BEGIN
    /* BUSQUE EL CENTRO DEL PUNTO, LA BODEGA, O EL PREFIJO  */
    IF (CENT = 'B') THEN
        SELECT B.BODE_CENTRO, B.BODE_PROY FROM BODEGA B, FACTURAS F
            WHERE B.BODE_COD = F.BODE_COD AND F.FACT_ID = :IDDOC INTO :CENTRO, :PROY;
    IF (CENT = 'V') THEN
        SELECT V.CENT_COD, V.PROY_COD FROM VENDEDORES V, FACTURAS F
            WHERE V.VEND_COD = F.VEND_COD AND F.FACT_ID = :IDDOC INTO :CENTRO, :PROY;
    IF (CENT = 'P') THEN
        SELECT P.PREF_CENTRO,P.PREF_PROY  FROM PREFIJOS P, FACTURAS F
            WHERE P.PREF_PRE = F.PREF_PRE AND F.FACT_ID = :IDDOC AND P.TIDO_COD = 31 INTO :CENTRO, :PROY;
    NUMERO = PREF || NUM;
    SELECT SUM (FADE_CONSUMO) FROM FACTURAS_DETALLE WHERE FACT_ID = :IDDOC INTO MERCANCIA;
    VRSUBT = VRTOTAL - VREXTRA - VRIVA - MERCANCIA; /* BASE DE RETEFTE Y RETEICA */

    EXECUTE PROCEDURE lee_configuracion ('FACTURACION', 'FACTURAS', 'DESCUENTO PIE FACTURA IGUAL A SUMA DE DESCUENTOS POR ITEM') returning_values (:DTOXIT);
    if (DTOXIT = 'SI') then
        VRDTO = 0;
    MERCANCIA = VRSUBT - VRADIC + VRDTO;
    EXECUTE PROCEDURE FECHA_A_CONTA(:FECAUX) returning_values (:FECHA);
    EXECUTE PROCEDURE FECHA_A_CONTA(:VENCEAUX) returning_values (:VENCE);
    /* REGISTRE EL ENCABEZADO CONTABLE */
    IDC = GEN_ID(ID_CONTABILIZA, 1);
    if (STRLEN(NOMBRE)> 43 ) then
      CONC = 'FV No.' || NUMERO || '-' || SUBSTR(NOMBRE,1,43);
    ELSE
      CONC = 'FV No.' || NUMERO || '-' || NOMBRE;
    INSERT INTO CONTABILIZACION (CNTB_ID, CNTB_TIPOCOMP, CNTB_PREFCNT, CNTB_NUMERO, CNTB_FECHA, CNTB_CONCEPTO, CNTB_REF, CNTB_TIPOREF, CNTB_IDREF, CNTB_PREFREF, CNTB_NUMREF, CNTB_PROCESADO)
        VALUES (:IDC, :TIPOCOMP, :PREFCONT, :NUM, :FECHA, :CONC, '', 31, :IDDOC, :PREF, :NUM, 'N');
    NROI = 0;
    SUMA = 0;
    ERROR = 0;
    /* SI NO HAY CUENTA DE DESCUENTO NI ADICIONAL CALCULE UN FACTOR PARA LAS VENTAS Y EL IVA */
    if (MERCANCIA <> 0) then
        FACTOR = CAST(VRSUBT AS DOUBLE PRECISION) / CAST(MERCANCIA AS DOUBLE PRECISION);
    ELSE
        FACTOR = 1;
    /* TRAIGA EL NUMERO DE DIGITOS PARA EL REDONDEO */
    SELECT CAST(CONF_VALOR AS INTEGER) FROM CONFIGURACION WHERE CONF_MODULO = 'FACTURACION' AND
        CONF_CATEGORIA = 'GENERAL' AND CONF_PROPIEDAD = 'REDONDEO AL MULTIPLO DE DIEZ EN TOTALES' INTO :DIG;
    /* CUENTAS DE VENTAS */
    if (VENTAS = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTAVNT), SUM(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), SUM(FADE_IVAMONTO), SUM(FADE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTAVNT
            INTO :CTAVENTAS, :MONTO, :IMPTOS, :VRCONSUMO
            DO
            BEGIN
            if (FOMENTO = 'SI') then
                MONTO = MONTO + VRCONSUMO;
            if ((CTADTO IS NULL) OR (CTADTO = '')) then
                MONTO = MONTO * FACTOR;
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAVENTAS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), FADE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
                        WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAINV = :CUENTA
                        INTO :ART, :MONTO, :IMPTOS
                    DO
                        BEGIN
                        if (FOMENTO = 'SI') then
                            MONTO = MONTO + IMPTOS;
                        if ((CTADTO IS NULL) OR (CTADTO = '')) then
                            MONTO = MONTO * FACTOR;
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        if (MONTO <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            SUMA = SUMA - MONTO;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    SUMA = SUMA - MONTO;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - MONTO;
                    END
                END /* MONTO <> 0 */
            END /* FOR */
        END /* VENTAS X ARTICULO */
     IF ((VENTAS = 'C') OR (VENTAS = 'K')) THEN
        BEGIN
        IF (VENTAS = 'C') THEN
            CTAVENTAS = TCTAVENTA;
        SELECT SUM(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), SUM(FADE_IVAMONTO), SUM (FADE_CONSUMO)
            FROM FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC 
            INTO :MONTO, :IMPTOS, :VRCONSUMO;
        if (FOMENTO = 'SI') then
            MONTO = MONTO + VRCONSUMO;
        if ((CTADTO IS NULL) OR (CTADTO = '')) then
            MONTO = MONTO * FACTOR;
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAVENTAS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), FADE_CONSUMO
                    FROM ARTICULO A, FACTURAS_DETALLE F
                    WHERE F.FACT_ID = :IDDOC 
                    INTO :ART, :MONTO, :IMPTOS
                    DO
                    BEGIN
                    if (FOMENTO = 'SI') then
                        MONTO = MONTO + VRCONSUMO;
                    if ((CTADTO IS NULL) OR (CTADTO = '')) then
                        MONTO = MONTO * FACTOR;
                    execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                    if (MONTO <> 0) then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA - MONTO;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - MONTO;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - MONTO;
                END
            END /* MONTO <> 0 */
        END /* VENTAS DE CLIENTE O CONSTANTE */
    /* EL IVA EN VENTAS */
    if (IVA = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTAIVAV), SUM(FADE_IVAMONTO), SUM(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), sum(FADE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTAIVAV
            INTO :CTAIVA, :IMPTOS, :MONTO, :VALORADIC
        DO
            BEGIN
            if (FOMENTO = 'SI') then
                MONTO = MONTO + VALORADIC;
            MONTO = MONTO * -1;
            MONTO = MONTO * FACTOR;
            IMPTOS = IMPTOS * FACTOR;
            execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (IMPTOS <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, FADE_IVAMONTO, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), TAIV_PORC, FADE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F, TARIFA_IVA T
                        WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAIVAV = :CUENTA AND A.TAIV_COD = T.TAIV_COD
                        INTO :ART, :IMPTOS, :MONTO, :PORCIVA, :VALORADIC
                    DO
                        BEGIN
                        if (FOMENTO = 'SI') then
                            MONTO = MONTO + VALORADIC;
                        MONTO = MONTO * -1;
                        MONTO = MONTO * FACTOR;
                        IMPTOS = IMPTOS * FACTOR;
                        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        if (IMPTOS <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            SUMA = SUMA + DEBITO - CREDITO;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                END   /* IMPTOS <> 0 */
            END /* FOR */
        END /* IVA X ARTICULO */
    if (IVA = 'K') then /* IVA EN CTA CONSTANTE */
        BEGIN
        SELECT SUM(FADE_IVAMONTO), SUM(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), SUM(FADE_CONSUMO)
            FROM FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC and FADE_IVAMONTO <> 0
            INTO :IMPTOS, :MONTO, :valoradic;
        if (FOMENTO = 'SI') then
            MONTO = MONTO + VALORADIC;
        MONTO = MONTO * -1;
        MONTO = MONTO * FACTOR;
        IMPTOS = IMPTOS * FACTOR;
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
        if (IMPTOS <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), FADE_IVAMONTO, TAIV_PORC, FADE_CONSUMO
                    FROM ARTICULO A, FACTURAS_DETALLE F, TARIFA_IVA T
                    WHERE F.FACT_ID = :IDDOC AND A.TAIV_COD = T.TAIV_COD
                    INTO :ART, :MONTO, :IMPTOS, :PORCIVA, :VALORADIC
                    DO
                    BEGIN
                    if (FOMENTO = 'SI') then
                        MONTO = MONTO + VALORADIC;
                    MONTO = MONTO * -1;
                    MONTO = MONTO * FACTOR;
                    IMPTOS = IMPTOS * FACTOR;
                    execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                    execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                    if (IMPTOS <> 0) then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', 0, :IMPTOS, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA - IMPTOS;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            END /* IMPTOS <> 0 */
        END /* IVA EN CTA CONSTANTE */
    /* EL IMPOCONSUMO */
    if ((CONSUMO = 'A') AND (FOMENTO <> 'SI')) then
        BEGIN
        FOR SELECT MAX(COAR_CTACONS), SUM(FADE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTACONS
            INTO :CTACONSUMO, :IMPTOS
        DO
            BEGIN
            execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
            if (IMPTOS <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, FADE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
                        WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTACONS = :CUENTA
                        INTO :ART, :IMPTOS
                    DO
                        BEGIN
                        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                        if (IMPTOS <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            SUMA = SUMA - IMPTOS;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                END /* IMPTOS <> 0 */
            END /* FOR */
        END /* CONSUMO X ARTICULO */
    if ((CONSUMO = 'K') AND (FOMENTO <> 'SI')) then /* CONSUMO EN CTA CONSTANTE */
        BEGIN
        SELECT SUM(FADE_CONSUMO)
            FROM FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC 
            INTO :IMPTOS;
        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
        if (IMPTOS <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, FADE_CONSUMO
                    FROM ARTICULO A, FACTURAS_DETALLE F
                    WHERE F.FACT_ID = :IDDOC 
                    INTO :ART, :IMPTOS
                    DO
                    BEGIN
                    execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                    if (IMPTOS <> 0) then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA - IMPTOS;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            END /* IMPTOS <> 0 */
        END /* CONSUMO EN CTA CONSTANTE */
    /* DESCUENTO */
    if ((CTADTO IS NOT NULL) AND (CTADTO <> '')) then
        BEGIN
        execute procedure redondee(VRDTO, DIG) returning_values (VRDTO);
        if (VRDTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTADTO, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRDTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA + VRDTO;
                END
            if (TIPOCUEN = 'N') then
                    BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRDTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA + VRDTO;
                END
            END
        END /* DESCUENTO */
    /* VALOR ADIC */
    if ((CTAADIC IS NOT NULL) AND (CTAADIC <> '')) then
        BEGIN
        execute procedure redondee(VRADIC, DIG) returning_values (VRADIC);
        if (VRADIC <> 0) THEN
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRADIC, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VRADIC;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRADIC, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VRADIC;
                END
            END
        END /* VR. ADIC */
    /* VALOR EXTRA */
    if ((CTAEXTRA IS NOT NULL) AND (CTAEXTRA <> '')) THEN
        BEGIN
        execute procedure redondee(VREXTRA, DIG) returning_values (VREXTRA);
        if (VREXTRA <> 0) THEN
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAEXTRA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VREXTRA, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VREXTRA;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VREXTRA, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VREXTRA;
                END
            END
        END /* VR. EXTRA */
    /* DESCUENTE EL IMPOCONSUMO */
    SELECT SUM(FADE_CONSUMO)
        FROM FACTURAS_DETALLE F WHERE F.FACT_ID = :IDDOC INTO :IMPTOS;
    vrsubt = vrsubt - IMPTOS;
    /* RETENCION FUENTE */
    if ((RTFTE = 'C') or (RTFTE = 'K')) then
      BEGIN
      execute procedure redondee(VRRTFTE, DIG) returning_values (VRRTFTE);
      if (VRRTFTE <> 0) then
        BEGIN
        if (RTFTE = 'C') then
            CTARTFTE = TCTARTFTE;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTFTE;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTFTE;
            END
        /* AUTORETENCION */
        if (FAUTORET <= fecaux) then
            BEGIN
            EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'CUENTA DE AUTORETENCION EN LA FUENTE') returning_values (CTARTFTE);
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTARTFTE INTO :CUENTA, :TIPOCUEN;
            if (CUENTA IS NULL) then
                begin
                EXECUTE PROCEDURE ERROR (31, :IDDOC, :CTARTFTE, 2);
                CUENTA = CTARTFTE;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                begin
                EXECUTE PROCEDURE ERROR (31, :IDDOC, :CUENTA, 3);
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:VRSUBT*-1), :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VRRTFTE;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:VRSUBT*-1), :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - VRRTFTE;
                END
            END
        END /* RTFTE */
      END
    if (RTFTE = 'A') then
      BEGIN
      FOR SELECT MAX(COAR_CTARTFTEV), MAX(COAR_RTFTE), SUM(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), SUM((FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*COAR_RTFTE)
        FROM CONTABIL_ARTICULO C, FACTURAS_DETALLE F
        WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = C.ARTI_COD
        GROUP BY COAR_CTARTFTEV
        INTO :CTARTFTE, :PRTFTE, :MONTO, :VRRTFTE
        DO
        BEGIN
        MONTO = MONTO * FACTOR;
        VRRTFTE = VRRTFTE * FACTOR / 100;
        execute procedure redondee(VRRTFTE, DIG) returning_values (VRRTFTE);
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        if (VRRTFTE <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :MONTO, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA + VRRTFTE;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :MONTO, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA + VRRTFTE;
                END
            /* AUTORETENCION */
            if (FAUTORET <= fecaux) then
                BEGIN
                EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'CUENTA DE AUTORETENCION EN LA FUENTE') returning_values (CTARTFTE);
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:MONTO*-1), :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    SUMA = SUMA - VRRTFTE;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:MONTO*-1), :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - VRRTFTE;
                    END
                END
            END
        END /* RTFTE */
      END
    /* RETENCION IVA */
    if ((RTIVA = 'C') or (RTIVA = 'K')) then
      BEGIN
      execute procedure redondee(VRRTIVA, DIG) returning_values (VRRTIVA);
      if (VRRTIVA <> 0) then
        BEGIN
        if (RTIVA = 'C') then
            CTARTIVA = TCTARTIVA;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTARTIVA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTIVA, 0, :VRIVA, :PORC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTIVA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTIVA, 0, :VRIVA, :PORC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTIVA;
            END
        END /* RTIVA */
      END
    /* RETENCION DE ICA */
    if ((RTICA = 'C') or (RTICA = 'K')) then
      BEGIN
      execute procedure redondee(VRRTICA, DIG) returning_values (VRRTICA);
      if (VRRTICA <> 0) then
        BEGIN
        if (RTICA = 'C') then
            CTARTICA = TCTARTICA;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTARTICA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTICA, 0, :VRSUBT, :PRTICA, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTICA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTICA, 0, :VRSUBT, :PRTICA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTICA;
            END
        END /* RTICA */
      END
    if (RTICA = 'A') then
      BEGIN
      FOR SELECT MAX(COAR_CTARTICAV), MAX(COAR_RTICA), SUM(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), SUM((FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*COAR_RTICA)
        FROM CONTABIL_ARTICULO C, FACTURAS_DETALLE F
        WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = C.ARTI_COD
        GROUP BY COAR_CTARTFTEV
        INTO :CTARTICA, :PRTICA, :MONTO, :VRRTICA
        DO
        BEGIN
        MONTO = MONTO * FACTOR;
        VRRTICA = VRRTICA * FACTOR / 100;
        execute procedure redondee(VRRTICA, DIG) returning_values (VRRTICA);
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        if (VRRTICA <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTARTICA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTICA, 0, :MONTO, :PRTICA, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTICA;
            END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTICA, 0, :MONTO, :PRTICA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA + VRRTICA;
                END
            END
          END
        END   /* RTICA */
    /* CIERRE EL COMPROBANTE CONTRA LA CUENTA DEL TERCERO O LA CONSTANTE */
    if ((SUMA <> 0) and ((CARTERA = 'C') or (CARTERA = 'K') or (CARTERA = 'J'))) then
        BEGIN
        if (SUMA < 0) then
            BEGIN
            DEBITO = SUMA * -1;
            CREDITO = 0;
            END
        ELSE
            BEGIN
            DEBITO = 0;
            CREDITO = SUMA;
            END
        if (CARTERA = 'C') then
            CTACARTERA = TCTACLIEN;
        if (CARTERA = 'J') then
            BEGIN
            /* BUSQUE LA CUENTA DE LA CAJA */
            SELECT CAJA_CUENTA FROM CAJAS C, PUNTO_VENTA P
                WHERE P.CAJA_ID = C.CAJA_ID AND PTVT_ID = :PTOVTA
                INTO :CTACARTERA;
            END
        EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTACARTERA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
        if (TIPOCUEN = 'N') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
        NROI = NROI + 1;
        END /* SUMA EN CARTERA */
    /* CALCULE COSTOS EN VENTAS */
    EXECUTE PROCEDURE COSTO_EN_VENTAS(31, :IDDOC);
    if (COSTOS = 'A') then
        BEGIN
        FOR SELECT MAX(CTACOS), SUM(CAST(CANT AS DOUBLE PRECISION) * COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTACOS
            INTO :CTACOSTOS, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTACOSTOS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT ARTI_COD, CANT * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTACOS = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                END /* MONTO <> 0 */
            END /* FOR */
        END /* COSTOS */
    if (COSTOS = 'K') then
        BEGIN
        SELECT SUM(CAST(CANT AS DOUBLE PRECISION) * COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTACOSTOS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT ARTI_COD, CANT * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            END /* MONTO <> 0 */
        END /* COSTOS = K */
    if (INVEN = 'A') then
        BEGIN
        FOR SELECT MAX(CTAINV), SUM(CAST(CANT AS DOUBLE PRECISION) * COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTAINV
            INTO :CTAINVEN, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT ARTI_COD, CANT * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTAINV = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                END /* MONTO <> 0 */
            END /* FOR */
        END /* INVEN = A */
    if (INVEN = 'K') then
        BEGIN
        SELECT SUM(CAST(CANT AS DOUBLE PRECISION) * COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT ARTI_COD, CANT * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            END /* MONTO <> 0 */
        END /* INVEN = K */
    /* recorra las cuentas adicionales */
    FOR SELECT INVC_CUENTA, INVC_BASE, INVC_PORC, INVC_VALOR, INVC_DB
        FROM INTERFAZ_VENTAS_CTAS
        WHERE INVE_ID = :IDINTER
        INTO :CTADIC, :BASEADIC, :PORCADIC, :VALORADIC, :DBADIC
        DO
        BEGIN
        if (VALORADIC <> 0) then
            MONTO = VALORADIC;
        ELSE
            BEGIN
            if (:BASEADIC = 'SUBTOTAL') then
                VALORADIC = vrsubt;
            if (:BASEADIC = 'DESCUENTO') then
                VALORADIC = VRDTO;
            if (:BASEADIC = 'IVA') then
                VALORADIC = VRIVA;
            if (:BASEADIC = 'ADICIONAL') then
                VALORADIC = VRADIC;
            if (:BASEADIC = 'EXTRA') then
                VALORADIC = VREXTRA;
            if (:BASEADIC = 'TOTAL') then
                VALORADIC = VRTOTAL;
            MONTO = VALORADIC * PORCADIC / 100;
            END
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                if (DBADIC = 'S') then
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                ELSE
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                if (DBADIC = 'S') then
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                ELSE
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            NROI = NROI + 1;
            END
        END
    if (ERROR > 0) then
        VER = 'S';
    SUSPEND;
    END /* NO ANULADO */
  END /* EXISTE LA INTERFAZ */
ELSE
    BEGIN
    EXECUTE PROCEDURE ERROR (31, :IDDOC, :PREF, 1);
    ERROR = ERROR + 1;
    VER = 'S';
    SUSPEND;
    END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE FACTURAS_SIN_CONTABILIDAD(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDI INTEGER,
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable FECICNT VARCHAR(10);
declare variable FECFCNT VARCHAR(10);
declare variable ERROR INTEGER;
declare variable idref INTEGER;
BEGIN /*$$IBE$$ 
EXECUTE PROCEDURE fecha_a_conta(FECINI) returning_values (FECICNT);
EXECUTE PROCEDURE fecha_a_conta(FECFIN) returning_values (FECFCNT);
FOR SELECT FACT_ID, PREF_PRE, FACT_NUMERO FROM FACTURAS WHERE FACT_ANULADO = 'N' AND
    FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  idref = null;
  SELECT ENCO_IDREF FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 31 AND ENCO_FECHA >= :FECICNT AND ENCO_FECHA <= :FECFCNT and ENCO_IDREF = :ID into :idref;
  if (idref IS NULL) then
  begin
   ESTADO = 'PROCESANDO';
   ERROR = NULL;
   SUSPEND;
   SELECT MAX(INVE_ID) FROM INTERFAZ_VENTAS WHERE PREF_PRE = :PREF AND TIDO_COD = 31 INTO :IDI;
   EXECUTE PROCEDURE CONTABIL_FACTURA (:ID, :IDI) RETURNING_VALUES (:ERROR, VER, :IDC);
   if ((ERROR = 0) or (error IS NULL)) then
    BEGIN
    EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC);
    ESTADO = 'OK';
    END
   ELSE
    ESTADO = 'ERROR';
   suspend;
  end
  END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE FACTURAS_SIN_CONTABILIDAD(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDI INTEGER,
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable FECICNT VARCHAR(10);
declare variable FECFCNT VARCHAR(10);
declare variable ERROR INTEGER;
declare variable idref INTEGER;
BEGIN
EXECUTE PROCEDURE fecha_a_conta(FECINI) returning_values (FECICNT);
EXECUTE PROCEDURE fecha_a_conta(FECFIN) returning_values (FECFCNT);
FOR SELECT FACT_ID, PREF_PRE, FACT_NUMERO FROM FACTURAS WHERE FACT_ANULADO = 'N' AND
    FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  idref = null;
  SELECT ENCO_IDREF FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 31 AND ENCO_FECHA >= :FECICNT AND ENCO_FECHA <= :FECFCNT and ENCO_IDREF = :ID into :idref;
  if (idref IS NULL) then
  begin
   ESTADO = 'PROCESANDO';
   ERROR = NULL;
   SUSPEND;
   SELECT MAX(INVE_ID) FROM INTERFAZ_VENTAS WHERE PREF_PRE = :PREF AND TIDO_COD = 31 INTO :IDI;
   EXECUTE PROCEDURE CONTABIL_FACTURA (:ID, :IDI) RETURNING_VALUES (:ERROR, VER, :IDC);
   if ((ERROR = 0) or (error IS NULL)) then
    BEGIN
    EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC);
    ESTADO = 'OK';
    END
   ELSE
    ESTADO = 'ERROR';
   suspend;
  end
  END
END

^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE CONTABIL_DEVOLCLI(
    IDDOC INTEGER,
    IDINTER INTEGER)
RETURNS (
    ERROR INTEGER,
    VER CHAR(1),
    IDC INTEGER)
AS
declare variable PREF VARCHAR(4);
declare variable NUM VARCHAR(6);
declare variable NUMERO VARCHAR(10);
declare variable FECAUX DATE;
declare variable FECHA CHAR(8);
declare variable CONC CHAR(120);
declare variable NUMFAC VARCHAR(10);
declare variable VRDTO NUMERIC(18, 2);
declare variable VRADIC NUMERIC(18, 2);
declare variable VRSUBT NUMERIC(18, 2);
declare variable VRIVA NUMERIC(18, 2);
declare variable PRTFTE NUMERIC(9, 2);
declare variable VRRTFTE NUMERIC(18, 2);
declare variable VRRTIVA NUMERIC(18, 2);
declare variable PRTICA NUMERIC(9, 2);
declare variable VRRTICA NUMERIC(18, 2);
declare variable VRTOTAL NUMERIC(18, 2);
declare variable VREXTRA NUMERIC(18, 2);
declare variable TIPOCOMP VARCHAR(3);
declare variable PREFCONT VARCHAR(4);
declare variable VENTAS CHAR(1);
declare variable CTAVENTAS VARCHAR(20);
declare variable IVA CHAR(1);
declare variable CTAIVA VARCHAR(20);
declare variable CONSUMO CHAR(1);
declare variable CTACONSUMO VARCHAR(20);
declare variable CARTERA CHAR(1);
declare variable CTACARTERA VARCHAR(20);
declare variable RTFTE CHAR(1);
declare variable CTARTFTE VARCHAR(20);
declare variable RTIVA CHAR(1);
declare variable CTARTIVA VARCHAR(20);
declare variable RTICA CHAR(1);
declare variable CTARTICA VARCHAR(20);
declare variable INVEN CHAR(1);
declare variable CTAINVEN VARCHAR(20);
declare variable COSTOS CHAR(1);
declare variable CTACOSTOS VARCHAR(20);
declare variable CTADTO VARCHAR(20);
declare variable CTAADIC VARCHAR(20);
declare variable CTAEXTRA VARCHAR(20);
declare variable EXISTE CHAR(1);
declare variable CUENTA VARCHAR(20);
declare variable MONTO NUMERIC(18,2);
declare variable TIPOCUEN CHAR(1);
declare variable NIT VARCHAR(20);
declare variable PROY VARCHAR(4);
declare variable CENTRO VARCHAR(4);
declare variable PORC NUMERIC(5,2);
declare variable DEBITO NUMERIC(18,2);
declare variable CREDITO NUMERIC(18,2);
declare variable NROI INTEGER;
declare variable ART VARCHAR(15);
declare variable IMPINC CHAR(1);
declare variable IMPTOS NUMERIC(18, 2);
declare variable SUMA NUMERIC(18,2);
declare variable PORCIVA NUMERIC(9,2);
declare variable TCTACLIEN VARCHAR(20);
declare variable TCTAVENTA VARCHAR(20);
declare variable TCTARTFTE VARCHAR(20);
declare variable TCTARTIVA VARCHAR(20);
declare variable TCTARTICA VARCHAR(20);
declare variable CTADIC VARCHAR(20);
declare variable BASEADIC VARCHAR(20);
declare variable PORCADIC NUMERIC(5,2);
declare variable VALORADIC NUMERIC(18,2);
declare variable DBADIC CHAR(1);
declare variable PTOVTA INTEGER;
declare variable ANULADO CHAR(1);
declare variable CENT CHAR(1);
DECLARE VARIABLE MERCANCIA NUMERIC(18,2);
declare variable FACTOR DOUBLE PRECISION;
declare variable DIG INTEGER;
DECLARE VARIABLE FOMENTO VARCHAR(2);
DECLARE VARIABLE VRCONSUMO NUMERIC(18,2);
declare variable AUTORET VARCHAR(10);
declare variable FAUTORET DATE;
declare variable IDREM INTEGER;
declare variable DTOXIT CHAR(2);
declare variable ERRORC INTEGER;
BEGIN
EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'USAR IMPOCONSUMO COMO PORCENTAJE DE FOMENTO') returning_values (FOMENTO);
EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'FECHA AUTORETENEDOR NO DESCONTAR RETENCIONES DEL SALDO PERO SI CONTABILIZARLAS') returning_values (AUTORET);
if (AUTORET <> '') then
    FAUTORET = CAST(AUTORET AS DATE);
else
    FAUTORET = '9999/12/31';
  /* BUSQUE LA INTERFACE */
  EXISTE = 'N';
  SELECT 'S', TICO_COD, PRCO_PRE, INVE_VENTAS, INVE_IVA, INVE_CONSUMO, INVE_CARTERA, INVE_RTFTE, INVE_RTIVA, INVE_RTICA, INVE_COSTO, INVE_INVEN, INVE_CTAVENTAS, INVE_CTAIVA, INVE_CTACONSUMO, INVE_CTADTO, INVE_CTAADIC, INVE_CTAEXTRA, INVE_CTACARTERA, INVE_CTARTFTE, INVE_CTARTIVA, INVE_CTARTICA, INVE_CTAINVEN, INVE_CTACOSTOS, INVE_CONFIRMAR, INVE_CENTRO
    FROM INTERFAZ_VENTAS
    WHERE INVE_ID = :IDINTER
    INTO :EXISTE, :TIPOCOMP, :PREFCONT, :VENTAS, :IVA, :CONSUMO, :CARTERA, :RTFTE, :RTIVA, :RTICA, :COSTOS, :INVEN, :CTAVENTAS, :CTAIVA, :CTACONSUMO, :CTADTO, :CTAADIC, :CTAEXTRA, :CTACARTERA, :CTARTFTE, :CTARTIVA, :CTARTICA, :CTAINVEN, :CTACOSTOS, :VER, :CENT;
  if (EXISTE = 'S') then
   BEGIN
    /* BORRE CUALQUEIR CONTABILIZACION PREVIA */
    DELETE FROM CONTABILIZACION WHERE CNTB_TIPOREF = 33 AND CNTB_IDREF = :IDDOC;
    /* TRAIGA EL ENCABEZADO DE LA DEVOLUCION */
   SELECT PREF_PRE, DEVT_NUMERO, DEVT_FECHA, F.TERC_NIT, DEVT_IVAINC, PTVT_ID, DEVT_FACTURA, DEVT_DTOMONTO, DEVT_ADICIONAL, DEVT_IVAMONTO, DEVT_EXTRA, DEVT_TOTAL, DEVT_RTFTEPORC, DEVT_RTFTEMONTO, DEVT_RTIVAPORC, DEVT_RTIVAMONTO, DEVT_RTICAPORC, DEVT_RTICAMONTO, TERC_CTARTFTE, TERC_CTARTIVA, TERC_CTARTICA, TERC_CTAVENTA, TERC_CTACLIENTE, DEVT_ANULADO, DEVT_REMID
        FROM DEVOLUCIONES_VENTAS F, TERCEROS T
        WHERE DEVT_ID = :IDDOC AND F.TERC_NIT = T.TERC_NIT
        INTO :PREF, :NUM, :FECAUX, :NIT, :IMPINC, :PTOVTA, :NUMFAC, :VRDTO, :VRADIC, :VRIVA, :VREXTRA, :VRTOTAL, :PRTFTE, :VRRTFTE, :PORC, :VRRTIVA, :PRTICA, :VRRTICA, :TCTARTFTE, TCTARTIVA, TCTARTICA, TCTAVENTA, TCTACLIEN, ANULADO, :IDREM;
   if (idrem is null) Then
    IDREM = 0;
   if ((ANULADO = 'N') AND (IDREM = 0)) then
    BEGIN
    NUMERO = PREF || NUM;
    SELECT SUM(DVDE_CONSUMO) FROM devoluciones_ventas_detalle WHERE DEVT_ID = :iddoc INTO :MERCANCIA;
    VRSUBT = VRTOTAL - VREXTRA - VRIVA - MERCANCIA; /* BASE DE RETEFTE Y RETEICA */
    EXECUTE PROCEDURE lee_configuracion ('FACTURACION', 'DEVOLUCIONES', 'DESCUENTO PIE DEVOLUCION IGUAL A SUMA DE DESCUENTOS POR ITEM') returning_values (:DTOXIT);
    if (DTOXIT = 'SI') then
        VRDTO = 0;
    MERCANCIA = VRSUBT - VRADIC + VRDTO;
    IF (CENT = 'B') THEN
        SELECT B.BODE_CENTRO, B.BODE_PROY FROM BODEGA B, DEVOLUCIONES_VENTAS F
            WHERE B.BODE_COD = F.BODE_COD AND F.DEVT_ID = :IDDOC INTO :CENTRO, :PROY;
    IF (CENT = 'V') THEN
        SELECT V.CENT_COD, V.PROY_COD FROM VENDEDORES V, DEVOLUCIONES_VENTAS F
            WHERE V.VEND_COD = F.VEND_COD AND F.DEVT_ID = :IDDOC INTO :CENTRO, :PROY;
    IF (CENT = 'P') THEN
        SELECT P.PREF_CENTRO,P.PREF_PROY  FROM PREFIJOS P, DEVOLUCIONES_VENTAS F
            WHERE P.PREF_PRE = F.PREF_PRE AND F.DEVT_ID = :IDDOC AND P.TIDO_COD = 33 INTO :CENTRO, :PROY;
    EXECUTE PROCEDURE FECHA_A_CONTA(:FECAUX) returning_values (:FECHA);
    /* REGISTRE EL ENCABEZADO CONTABLE */
    IDC = GEN_ID(ID_CONTABILIZA, 1);
    CONC = 'DEVOLUCION VENTAS No. ' || NUMERO || ' EN FACTURA ' || NUMFAC;
    CONC = SUBSTR(CONC, 1, 60);
    INSERT INTO CONTABILIZACION (CNTB_ID, CNTB_TIPOCOMP, CNTB_PREFCNT, CNTB_NUMERO, CNTB_FECHA, CNTB_CONCEPTO, CNTB_REF, CNTB_TIPOREF, CNTB_IDREF, CNTB_PREFREF, CNTB_NUMREF, CNTB_PROCESADO)
        VALUES (:IDC, :TIPOCOMP, :PREFCONT, :NUM, :FECHA, :CONC, '', 33, :IDDOC, :PREF, :NUM, 'N');
    NROI = 0;
    SUMA = 0;
    ERROR = 0;
    /* SI NO HAY CUENTA DE DESCUENTO NI ADICIONAL CALCULE UN FACTOR PARA LAS VENTAS Y EL IVA */
    if (MERCANCIA <> 0) then
        FACTOR = CAST(VRSUBT AS DOUBLE PRECISION) / CAST(MERCANCIA AS DOUBLE PRECISION);
    ELSE
        FACTOR = 1;
    /* TRAIGA EL NUMERO DE DIGITOS PARA EL REDONDEO */
    SELECT CAST(CONF_VALOR AS INTEGER) FROM CONFIGURACION WHERE CONF_MODULO = 'FACTURACION' AND
        CONF_CATEGORIA = 'GENERAL' AND CONF_PROPIEDAD = 'REDONDEO AL MULTIPLO DE DIEZ EN TOTALES' INTO :DIG;
    /* CUENTAS DE VENTAS */
    if (VENTAS = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTADEV), SUM(cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), SUM(DVDE_IVAMONTO), SUM(DVDE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTADEV
            INTO :CTAVENTAS, :MONTO, :IMPTOS, :VRCONSUMO
            DO
            BEGIN
            if (IMPINC = 'S') then
                if (FOMENTO = 'SI') then
                    MONTO = MONTO - IMPTOS;
                ELSE
                    MONTO = MONTO - IMPTOS - VRCONSUMO;
            ELSE
            if (FOMENTO = 'SI') then
            MONTO = MONTO + VRCONSUMO;
            if ((CTADTO IS NULL) OR (CTADTO = '')) then
                MONTO = MONTO * FACTOR;
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAVENTAS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, (cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), (DVDE_IVAMONTO+DVDE_CONSUMO)
                        FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F
                        WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAINV = :CUENTA
                        INTO :ART, :MONTO, :IMPTOS
                    DO
                        BEGIN
                        if (IMPINC = 'S') then
                            MONTO = MONTO - IMPTOS;
                        if ((CTADTO IS NULL) OR (CTADTO = '')) then
                            MONTO = MONTO * FACTOR;
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA + MONTO;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    SUMA = SUMA + MONTO;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + MONTO;
                    END
                END /* MONTO <> 0 */
            END /* FOR */
        END /* VENTAS X ARTICULO */
     IF ((VENTAS = 'C') OR (VENTAS = 'K')) THEN
        BEGIN
        IF (VENTAS = 'C') THEN
            CTAVENTAS = TCTAVENTA;
        SELECT SUM(cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), SUM(DVDE_IVAMONTO), SUM(DVDE_CONSUMO)
            FROM DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC 
            INTO :MONTO, :IMPTOS, :VRCONSUMO;
        if (IMPINC = 'S') then
            if (FOMENTO = 'SI') then
               MONTO = MONTO - IMPTOS;
            ELSE
               MONTO = MONTO - IMPTOS - VRCONSUMO;
        ELSE
         if (FOMENTO = 'SI') then
          MONTO = MONTO + VRCONSUMO;
        if ((CTADTO IS NULL) OR (CTADTO = '')) then
            MONTO = MONTO * FACTOR;
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAVENTAS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, (cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), (DVDE_IVAMONTO+DVDE_CONSUMO)
                    FROM ARTICULO A, DEVOLUCIONES_VENTAS_DETALLE F
                    WHERE F.DEVT_ID = :IDDOC
                    INTO :ART, :MONTO, :IMPTOS
                    DO
                    BEGIN
                    if (IMPINC = 'S') then
                        MONTO = MONTO - IMPTOS;
                    if ((CTADTO IS NULL) OR (CTADTO = '')) then
                        MONTO = MONTO * FACTOR;
                    execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + MONTO;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                SUMA = SUMA + MONTO;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA + MONTO;
                END
            END /* MONTO <> 0 */
        END /* VENTAS DE CLIENTE O CONSTANTE */
    /* EL IVA EN VENTAS */
    if (IVA = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTAIVAV), SUM(DVDE_IVAMONTO), SUM(DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO), SUM(DVDE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTAIVAV
            INTO :CTAIVA, :IMPTOS, :MONTO, :VALORADIC
        DO
            BEGIN
            if (FOMENTO = 'SI') then
                MONTO = MONTO + VALORADIC;
            MONTO = MONTO * -1;
            MONTO = MONTO * FACTOR;
            IMPTOS = IMPTOS * FACTOR;
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
            if (IMPTOS <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, DVDE_IVAMONTO, (cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), TAIV_PORC, DVDE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F, TARIFA_IVA T
                        WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND A.TAIV_COD = T.TAIV_COD AND COAR_CTAIVAV = :CUENTA
                        INTO :ART, :IMPTOS, :MONTO, :PORCIVA, :VALORADIC
                    DO
                        BEGIN
                        if (IMPINC = 'S') then
                            MONTO = MONTO - IMPTOS - VALORADIC;
                        MONTO = MONTO * -1;
                        MONTO = MONTO * FACTOR;
                        IMPTOS = IMPTOS * FACTOR;
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                        if (IMPTOS <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            SUMA = SUMA + IMPTOS;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                END   /* IMPTOS <> 0 */
            END /* FOR */
        END /* IVA X ARTICULO */
    if (IVA = 'K') then /* IVA EN CTA CONSTANTE */
        BEGIN
        SELECT SUM(DVDE_IVAMONTO), SUM(DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO), SUM(DVDE_CONSUMO)
            FROM DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC 
            INTO :IMPTOS, :MONTO, :VALORADIC;
        if (FOMENTO = 'SI') then
            MONTO = MONTO + VALORADIC;
        MONTO = MONTO * -1;
        MONTO = MONTO * FACTOR;
        IMPTOS = IMPTOS * FACTOR;
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
        if (IMPTOS <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, (cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), DVDE_IVAMONTO, TAIV_PORC, DVDE_CONSUMO
                    FROM ARTICULO A, DEVOLUCIONES_VENTAS_DETALLE F, TARIFA_IVA T
                    WHERE F.DEVT_ID = :IDDOC AND A.TAIV_COD = T.TAIV_COD
                    INTO :ART, :MONTO, :IMPTOS, :PORCIVA, :VALORADIC
                    DO
                    BEGIN
                    if (IMPINC = 'S') then
                        MONTO = MONTO - IMPTOS - VALORADIC;
                    MONTO = MONTO * -1;
                    MONTO = MONTO * FACTOR;
                    IMPTOS = IMPTOS * FACTOR;
                    execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                    execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                    if (IMPTOS <> 0) then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', :IMPTOS, 0, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA + IMPTOS;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                SUMA = SUMA + IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA + IMPTOS;
                END
            END /* IMPTOS <> 0 */
        END /* IVA EN CTA CONSTANTE */
    /* EL IMPOCONSUMO */
    if ((CONSUMO = 'A') AND (FOMENTO <> 'SI')) then
        BEGIN
        FOR SELECT MAX(COAR_CTACONS), SUM(DVDE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTACONS
            INTO :CTACONSUMO, :IMPTOS
        DO
            BEGIN
            if (IMPTOS <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, DVDE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F
                        WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTACONS = :CUENTA
                        INTO :ART, :IMPTOS
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA + IMPTOS;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                END /* IMPTOS <> 0 */
            END /* FOR */
        END /* CONSUMO X ARTICULO */
    if ((CONSUMO = 'K') AND (FOMENTO <> 'SI')) then
        BEGIN
        SELECT SUM(DVDE_CONSUMO)
            FROM DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC 
            INTO :IMPTOS;
        if (IMPTOS <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, DVDE_CONSUMO
                    FROM ARTICULO A, DEVOLUCIONES_VENTAS_DETALLE F
                    WHERE F.DEVT_ID = :IDDOC 
                    INTO :ART, :IMPTOS
                    DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA + IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA + IMPTOS;
                END
            END /* IMPTOS <> 0 */
        END /* CONSUMO EN CTA CONSTANTE */
    /* DESCUENTO */
    if ((CTADTO IS NOT NULL) AND
        (CTADTO <> '') AND
        (VRDTO <> 0)) THEN
        BEGIN
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTADTO, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRDTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA - VRDTO;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRDTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA - VRDTO;
            END
        END /* DESCUENTO */
    /* VALOR ADIC */
    if ((CTAADIC IS NOT NULL) AND
        (CTAADIC <> '') AND
        (VRADIC <> 0)) THEN
        BEGIN
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRADIC, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA + VRADIC;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRADIC, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA + VRADIC;
            END
        END /* VR. ADIC */
    /* VALOR EXTRA */
    if ((CTAEXTRA IS NOT NULL) AND
        (CTAEXTRA <> '') AND
        (VREXTRA <> 0)) THEN
        BEGIN
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAEXTRA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VREXTRA, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA + VREXTRA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VREXTRA, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA + VREXTRA;
            END
        END /* VR. EXTRA */
    /* RETENCION FUENTE */
    if ((RTFTE = 'C') or (RTFTE = 'K')) then
      if (VRRTFTE <> 0) then
        BEGIN
        if (RTFTE = 'C') then
            CTARTFTE = TCTARTFTE;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:VRSUBT*-1), :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTFTE;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:VRSUBT*-1), :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTFTE;
            END
        /* AUTORETENCION */
        if (FAUTORET <= fecaux) then
            BEGIN
            EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'CUENTA DE AUTORETENCION EN LA FUENTE') returning_values (CTARTFTE);
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                SUMA = SUMA + VRRTFTE;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA + VRRTFTE;
                END
            END
        END /* RTFTE */
    if (RTFTE = 'A') then
      BEGIN
      FOR SELECT MAX(COAR_CTARTFTEV), MAX(COAR_RTFTE), SUM(DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO), SUM((DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*COAR_RTFTE)
        FROM CONTABIL_ARTICULO C, devoluciones_ventas_detalle F
        WHERE F.devt_id = :IDDOC AND F.ARTI_COD = C.ARTI_COD
        GROUP BY COAR_CTARTFTEV
        INTO :CTARTFTE, :PRTFTE, :MONTO, :VRRTFTE
        DO
        BEGIN
        MONTO = MONTO * FACTOR;
        VRRTFTE = VRRTFTE * FACTOR / 100;
        execute procedure redondee(VRRTFTE, DIG) returning_values (VRRTFTE);
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        if (VRRTFTE <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:MONTO*-1), :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                SUMA = SUMA - VRRTFTE;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:MONTO*-1), :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - VRRTFTE;
                END
            /* AUTORETENCION */
            if (FAUTORET <= fecaux) then
                BEGIN
                EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'CUENTA DE AUTORETENCION EN LA FUENTE') returning_values (CTARTFTE);
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :MONTO, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    SUMA = SUMA + VRRTFTE;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :MONTO, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + VRRTFTE;
                    END
                END
            END
        END /* RTFTE */
      END
    /* RETENCION IVA */
    if ((RTIVA = 'C') or (RTIVA = 'K')) then
      if (VRRTIVA <> 0) then
        BEGIN
        if (RTIVA = 'C') then
            CTARTIVA = TCTARTIVA;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTIVA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTIVA, (:VRIVA*-1), :PORC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTIVA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTIVA, (:VRIVA*-1), :PORC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTIVA;
            END
        END /* RTIVA */
    /* RETENCION DE ICA */
    if ((RTICA = 'C') or (RTICA = 'K')) then
      if (VRRTICA <> 0) then
        BEGIN
        if (RTICA = 'C') then
            CTARTICA = TCTARTICA;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTICA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTICA, (:VRSUBT*-1), :PRTICA, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTICA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTICA, (:VRSUBT*-1), :PRTICA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTICA;
            END
        END /* RTICA */
    if (RTICA = 'A') then
      BEGIN
      FOR SELECT MAX(COAR_CTARTICAV), MAX(COAR_RTICA), SUM(DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO), SUM((DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*COAR_RTICA)
        FROM CONTABIL_ARTICULO C, devoluciones_ventas_detalle F
        WHERE F.devt_id = :IDDOC AND F.ARTI_COD = C.ARTI_COD
        GROUP BY COAR_CTARTICAV
        INTO :CTARTICA, :PRTICA, :MONTO, :VRRTICA
        DO
        BEGIN
        MONTO = MONTO * FACTOR * -1;
        VRRTICA = VRRTICA * FACTOR / 100;
        execute procedure redondee(VRRTICA, DIG) returning_values (VRRTICA);
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        if (VRRTICA <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTICA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTICA, :MONTO, :PRTICA, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                SUMA = SUMA - VRRTICA;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTICA, :MONTO, :PRTICA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - VRRTICA;
                END
            END
        END
      END
    /* CIERRE EL COMPROBANTE CONTRA LA CUENTA DEL TERCERO O LA CONSTANTE */
    if ((SUMA <> 0) and ((CARTERA = 'C') or (CARTERA = 'K') or (CARTERA = 'J'))) then
        BEGIN
        if (SUMA < 0) then
            BEGIN
            DEBITO = SUMA * -1;
            CREDITO = 0;
            END
        ELSE
            BEGIN
            DEBITO = 0;
            CREDITO = SUMA;
            END
        if (CARTERA = 'C') then
            CTACARTERA = TCTACLIEN;
        if (CARTERA = 'J') then
            BEGIN
            /* BUSQUE LA CUENTA DE LA CAJA */
            SELECT CAJA_CUENTA FROM CAJAS C, PUNTO_VENTA P
                WHERE P.CAJA_ID = C.CAJA_ID AND PTVT_ID = :PTOVTA
                INTO :CTACARTERA;
            END
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTACARTERA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
        if (TIPOCUEN = 'N') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
        NROI = NROI + 1;
        END /* SUMA EN CARTERA */
    /* CALCULE COSTOS EN VENTAS */
    EXECUTE PROCEDURE COSTO_EN_VENTAS(33, :IDDOC);
    if (COSTOS = 'A') then
        BEGIN
        FOR SELECT MAX(CTACOS), SUM(cast(CANT as double precision) * COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTACOS
            INTO :CTACOSTOS, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTACOSTOS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT ARTI_COD, cast(CANT as double precision) * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTACOS = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                END /* MONTO <> 0 */
            END /* FOR */
        END /* COSTOS */
    if (COSTOS = 'K') then
        BEGIN
        SELECT SUM(cast(CANT as double precision) * COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTACOSTOS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT ARTI_COD, cast(CANT as double precision) * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            END /* MONTO <> 0 */
        END /* COSTOS = K */
    if (INVEN = 'A') then
        BEGIN
        FOR SELECT MAX(CTAINV), SUM(cast(CANT as double precision) * COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTAINV
            INTO :CTAINVEN, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT ARTI_COD, cast(CANT as double precision) * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTAINV = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                END /* MONTO <> 0 */
            END /* FOR */
        END /* INVEN = A */
    if (INVEN = 'K') then
        BEGIN
        SELECT SUM(cast(CANT as double precision) * COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT ARTI_COD, cast(CANT as double precision) * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            END /* MONTO <> 0 */
        END /* INVEN = K */
    /* recorra las cuentas adicionales */
    FOR SELECT INVC_CUENTA, INVC_BASE, INVC_PORC, INVC_VALOR, INVC_DB
        FROM INTERFAZ_VENTAS_CTAS WHERE INVE_ID = :IDINTER
        INTO :CTADIC, :BASEADIC, :PORCADIC, :VALORADIC, :DBADIC
        DO
        BEGIN
        if (valoradic <> 0) then
            monto = valoradic;
        else
            BEGIN
            if (:BASEADIC = 'SUBTOTAL') then
                VALORADIC = vrsubt;
            if (:BASEADIC = 'DESCUENTO') then
                VALORADIC = VRDTO;
            if (:BASEADIC = 'IVA') then
                VALORADIC = VRIVA;
            if (:BASEADIC = 'ADICIONAL') then
                VALORADIC = VRADIC;
            if (:BASEADIC = 'EXTRA') then
                VALORADIC = VREXTRA;
            if (:BASEADIC = 'TOTAL') then
                VALORADIC = VRTOTAL;
            MONTO = VALORADIC * PORCADIC;
            END
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                if (DBADIC = 'S') then
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                ELSE
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                if (DBADIC = 'S') then
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                ELSE
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            NROI = NROI + 1;
            END
        END
    if (error > 0) then
        ver = 'S';
    SUSPEND;
    END
   END /* EXISTE LA INTERFAZ */
  ELSE
    BEGIN
    EXECUTE PROCEDURE ERROR (33, :IDDOC, :PREF, 1);
    ERROR = ERROR + 1;
    VER = 'S';
    SUSPEND;
    END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE DEVOLUCIONES_SIN_CONTABILIDAD(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDI INTEGER,
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable FECICNT VARCHAR(10);
declare variable FECFCNT VARCHAR(10);
declare variable ERROR INTEGER;
declare variable idref INTEGER;
BEGIN /*$$IBE$$ 
EXECUTE PROCEDURE fecha_a_conta(FECINI) returning_values (FECICNT);
EXECUTE PROCEDURE fecha_a_conta(FECFIN) returning_values (FECFCNT);
FOR SELECT DEVT_ID, PREF_PRE, DEVT_NUMERO FROM devoluciones_ventas WHERE DEVT_ANULADO = 'N' AND
    DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN
    INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  idref = null;
  SELECT ENCO_IDREF FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 33 AND ENCO_FECHA >= :FECICNT AND ENCO_FECHA <= :FECFCNT and ENCO_IDREF = :id into :idref;
  if (idref IS NULL) then
  begin
   ESTADO = 'PROCESANDO';
   SUSPEND;
   SELECT MAX(INVE_ID) FROM INTERFAZ_VENTAS WHERE PREF_PRE = :PREF AND TIDO_COD = 33 INTO :IDI;
   EXECUTE PROCEDURE contabil_devolcli (:ID, :IDI) RETURNING_VALUES (:ERROR, :VER, :IDC);
   if (ERROR = 0) then
    BEGIN
    EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC);
    ESTADO = 'OK';
    END
   ELSE
    ESTADO = 'ERROR';
   suspend;
  End
  END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE DEVOLUCIONES_SIN_CONTABILIDAD(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDI INTEGER,
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable FECICNT VARCHAR(10);
declare variable FECFCNT VARCHAR(10);
declare variable ERROR INTEGER;
declare variable idref INTEGER;
BEGIN
EXECUTE PROCEDURE fecha_a_conta(FECINI) returning_values (FECICNT);
EXECUTE PROCEDURE fecha_a_conta(FECFIN) returning_values (FECFCNT);
FOR SELECT DEVT_ID, PREF_PRE, DEVT_NUMERO FROM devoluciones_ventas WHERE DEVT_ANULADO = 'N' AND
    DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN
    INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  idref = null;
  SELECT ENCO_IDREF FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 33 AND ENCO_FECHA >= :FECICNT AND ENCO_FECHA <= :FECFCNT and ENCO_IDREF = :id into :idref;
  if (idref IS NULL) then
  begin
   ESTADO = 'PROCESANDO';
   SUSPEND;
   SELECT MAX(INVE_ID) FROM INTERFAZ_VENTAS WHERE PREF_PRE = :PREF AND TIDO_COD = 33 INTO :IDI;
   EXECUTE PROCEDURE contabil_devolcli (:ID, :IDI) RETURNING_VALUES (:ERROR, :VER, :IDC);
   if (ERROR = 0) then
    BEGIN
    EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC);
    ESTADO = 'OK';
    END
   ELSE
    ESTADO = 'ERROR';
   suspend;
  End
  END
END

^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE CONTABIL_FACTCOMP(
    IDDOC INTEGER,
    IDINTER INTEGER)
RETURNS (
    ERROR INTEGER,
    VER CHAR(1),
    IDC INTEGER)
AS
DECLARE VARIABLE PREFIJO VARCHAR(4);
DECLARE VARIABLE NUM VARCHAR(6);
DECLARE VARIABLE NUMERO VARCHAR(10);
DECLARE VARIABLE FECAUX DATE;
DECLARE VARIABLE FECHA CHAR(8);
DECLARE VARIABLE CONCEPTO CHAR(60);
DECLARE VARIABLE VENCEAUX DATE;
DECLARE VARIABLE VENCE CHAR(8);
DECLARE VARIABLE VRDTO NUMERIC(18,2);
DECLARE VARIABLE VRADIC NUMERIC(18,2);
DECLARE VARIABLE VRSUBT NUMERIC(18,2);
DECLARE VARIABLE VRIVA NUMERIC(18,2);
DECLARE VARIABLE PRTFTE NUMERIC(9,2);
DECLARE VARIABLE VRRTFTE NUMERIC(18,2);
DECLARE VARIABLE VRRTIVA NUMERIC(18,2);
DECLARE VARIABLE PRTICA NUMERIC(9,2);
DECLARE VARIABLE VRRTICA NUMERIC(18,2);
DECLARE VARIABLE VRTOTAL NUMERIC(18,2);
DECLARE VARIABLE VREXTRA NUMERIC(18,2);
DECLARE VARIABLE TIPOCOMP VARCHAR(3);
DECLARE VARIABLE PREFCONT VARCHAR(4);
DECLARE VARIABLE INVEN CHAR(1);
DECLARE VARIABLE CTAINVEN VARCHAR(20);
DECLARE VARIABLE IVA CHAR(1);
DECLARE VARIABLE CTAIVA VARCHAR(20);
DECLARE VARIABLE CONSUMO CHAR(1);
DECLARE VARIABLE CTACONSUMO VARCHAR(20);
DECLARE VARIABLE CXP CHAR(1);
DECLARE VARIABLE CTACXP VARCHAR(20);
DECLARE VARIABLE RTFTE CHAR(1);
DECLARE VARIABLE CTARTFTE VARCHAR(20);
DECLARE VARIABLE RTIVA CHAR(1);
DECLARE VARIABLE CTARTIVA VARCHAR(20);
DECLARE VARIABLE RTICA CHAR(1);
DECLARE VARIABLE CTARTICA VARCHAR(20);
DECLARE VARIABLE CTADTO VARCHAR(20);
DECLARE VARIABLE CTAADIC VARCHAR(20);
DECLARE VARIABLE CTAEXTRA VARCHAR(20);
DECLARE VARIABLE EXISTE CHAR(1);
DECLARE VARIABLE CUENTA VARCHAR(20);
DECLARE VARIABLE MONTO NUMERIC(18,2);
DECLARE VARIABLE TIPOCUEN CHAR(1);
DECLARE VARIABLE NIT VARCHAR(20);
DECLARE VARIABLE NOMBRE VARCHAR(60);
DECLARE VARIABLE PROY VARCHAR(4);
DECLARE VARIABLE CENTRO VARCHAR(4);
DECLARE VARIABLE PROYDET VARCHAR(4);
DECLARE VARIABLE CENTRODET VARCHAR(4);
DECLARE VARIABLE PORC NUMERIC(5,2);
DECLARE VARIABLE NUMITEMS INTEGER;
DECLARE VARIABLE ARTICULO VARCHAR(15);
DECLARE VARIABLE IMPINC CHAR(1);
DECLARE VARIABLE IMPTOS NUMERIC(18,2);
DECLARE VARIABLE SUMA NUMERIC(18,2);
DECLARE VARIABLE PORCIVA NUMERIC(9,2);
DECLARE VARIABLE TCTAPROV VARCHAR(20);
DECLARE VARIABLE TCTARTFTE VARCHAR(20);
DECLARE VARIABLE TCTARTIVA VARCHAR(20);
DECLARE VARIABLE TCTARTICA VARCHAR(20);
DECLARE VARIABLE CUENTAADIC VARCHAR(20);
DECLARE VARIABLE BASEADIC VARCHAR(20);
DECLARE VARIABLE PORCADIC NUMERIC(5,2);
DECLARE VARIABLE VALORADIC NUMERIC(18,2);
DECLARE VARIABLE DBADIC CHAR(1);
DECLARE VARIABLE FOMENTO CHAR(2);
DECLARE VARIABLE BODE_DET CHAR(2);
DECLARE VARIABLE NUMPROV VARCHAR(10);
DECLARE VARIABLE MERCANCIA NUMERIC(18,2);
declare variable FACTOR DOUBLE PRECISION;
DECLARE VARIABLE MENORV CHAR(2);
declare variable DIG INTEGER;
declare variable NETO NUMERIC(18,2);
declare variable CENT CHAR(1);
declare variable ANULADO CHAR(1);
declare variable ERRORC INTEGER;
BEGIN
  /* INTERFACE */
  EXISTE = 'N';
  SELECT 'S', TICO_COD, PRCO_PRE, INCO_INVEN, INCO_IVA, INCO_CONSUMO, INCO_CXP, INCO_RTFTE, INCO_RTIVA, INCO_RTICA, INCO_CTAINVEN, INCO_CTAIVA, INCO_CTACONSUMO, INCO_CTADTO, INCO_CTAADIC, INCO_CTAEXTRA, INCO_CTACXP, INCO_CTARTFTE, INCO_CTARTIVA, INCO_CTARTICA, INCO_CONFIRMAR, INCO_CENTRO
    FROM INTERFAZ_COMPRAS WHERE INCO_ID = :IDINTER INTO :EXISTE, :TIPOCOMP, :PREFCONT, :INVEN, :IVA, :CONSUMO, :CXP, :RTFTE, :RTIVA, :RTICA, :CTAINVEN, :CTAIVA, :CTACONSUMO, :CTADTO, :CTAADIC, :CTAEXTRA, :CTACXP, :CTARTFTE, :CTARTIVA, :CTARTICA, :VER, :CENT;
  if (EXISTE = 'S') then
    BEGIN
    /* BORRE CONTABILIZACION PREVIA */
    DELETE FROM CONTABILIZACION WHERE CNTB_TIPOREF = 21 AND CNTB_IDREF = :IDDOC;
    /* ENCABEZADO DE LA FACTURA */
    SELECT PREF_PRE, FACO_NUMERO, FACO_FECHA, F.TERC_NIT, FACO_IMPTOS, FACO_VENCE, FACO_DTOMONTO, FACO_ADICIONAL, FACO_IVAMONTO, FACO_EXTRA, FACO_TOTAL, FACO_RTFTEPORC, FACO_RTFTEMONTO, FACO_RTIVAPOR, FACO_RTIVAMONTO, FACO_RTICAPOR, FACO_RTICAMONTO, TERC_NOM, PROV_CTARTFTE, PROV_CTARTIVA, PROV_CTARTICA, PROV_CTAPAGAR, FACO_NUMPROV, FACO_ANULADO
        FROM FACTURAS_COMPRA F, TERCEROS T, PROVEEDORES P WHERE FACO_ID = :IDDOC AND F.TERC_NIT = T.TERC_NIT AND T.TERC_NIT = P.TERC_NIT
        INTO :PREFIJO, :NUM, :FECAUX, :NIT, :IMPINC, :VENCEAUX, :VRDTO, :VRADIC, :VRIVA, :VREXTRA, :VRTOTAL, :PRTFTE, :VRRTFTE, :PORC, :VRRTIVA, :PRTICA, :VRRTICA, :NOMBRE, TCTARTFTE, TCTARTIVA, TCTARTICA, TCTAPROV, :NUMPROV, :ANULADO;
    /* CENTRO DE LA BODEGA */
    IF (CENT = 'B') THEN
        SELECT BODE_CENTRO, BODE_PROY FROM BODEGA B, FACTURAS_COMPRA F WHERE B.BODE_COD = F.BODE_COD AND F.FACO_ID = :IDDOC INTO :CENTRO, :PROY;
    ELSE
        SELECT PREF_CENTRO,PREF_PROY  FROM PREFIJOS P, FACTURAS_COMPRA F WHERE P.PREF_PRE = F.PREF_PRE AND F.FACO_ID = :IDDOC AND P.TIDO_COD = 21 INTO :CENTRO, :PROY;
    if (ANULADO = 'N') then
        BEGIN
        NUMERO = PREFIJO || NUM;
        VRSUBT = VRTOTAL - VREXTRA - VRIVA;
        MERCANCIA = VRSUBT - VRADIC + VRDTO;
        EXECUTE PROCEDURE FECHA_A_CONTA(:FECAUX) returning_values (:FECHA);
        EXECUTE PROCEDURE FECHA_A_CONTA(:VENCEAUX) returning_values (:VENCE);
        if (NUMPROV IS NULL) then
            NUMPROV = NUMERO;
        CONCEPTO = 'FC No.' || NUMERO || '-' || SUBSTR(NOMBRE,1,26) || '-NPROV.' || NUMPROV;
        IDC = GEN_ID(ID_CONTABILIZA, 1);
        INSERT INTO CONTABILIZACION (CNTB_ID, CNTB_TIPOCOMP, CNTB_PREFCNT, CNTB_NUMERO, CNTB_FECHA, CNTB_CONCEPTO, CNTB_REF, CNTB_TIPOREF, CNTB_IDREF, CNTB_PREFREF, CNTB_NUMREF, CNTB_PROCESADO)
            VALUES (:IDC, :TIPOCOMP, :PREFCONT, :NUM, :FECHA, :CONCEPTO, '', 21, :IDDOC, :PREFIJO, :NUM, 'N');
        NUMITEMS = 0;
        SUMA = 0;
        NETO = 0;
        ERROR = 0;
        EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'USAR IMPOCONSUMO COMO PORCENTAJE DE FOMENTO') RETURNING_VALUES (FOMENTO);
        EXECUTE PROCEDURE lee_configuracion('COMPRAS','FACTURAS','DESCUENTO Y VALOR ADICIONAL DEL DOCUMENTO COMO MENOR VALOR DEL COSTO') returning_values (:MENORV);
        SELECT SUM(FCDE_consumo) from facturas_compras_detalle where faco_id = :IDDOC into :valoradic;
        if (MENORV = 'SI') then
            if (MERCANCIA <> 0) then
                FACTOR = (CAST(VRSUBT AS DOUBLE PRECISION) - VALORADIC) / (CAST(MERCANCIA AS DOUBLE PRECISION) - VALORADIC);
            ELSE
                FACTOR = 1;
        ELSE
           FACTOR = 1;
        SELECT CAST(CONF_VALOR AS INTEGER) FROM CONFIGURACION WHERE CONF_MODULO = 'COMPRAS' AND CONF_CATEGORIA = 'GENERAL' AND CONF_PROPIEDAD = 'REDONDEO AL MULTIPLO DE DIEZ EN TOTALES' INTO :DIG;
        if (INVEN = 'A') then
            BEGIN
            FOR SELECT MAX(COAR_CTAINV), SUM(CAST(FCDE_CANT AS DOUBLE PRECISION) * (FCDE_PRUNIT-FCDE_DTOMONTO)), SUM(FCDE_IVAMONTO), SUM(FCDE_CONSUMO), MAX(F.BODE_COD)
                FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_COMPRAS_DETALLE F WHERE F.FACO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
                GROUP BY COAR_CTAINV, F.BODE_COD INTO :CTAINVEN, :MONTO, :IMPTOS, :VALORADIC, :BODE_DET DO
                BEGIN
                IF (CENT = 'B') THEN
                  SELECT BODE_CENTRO, BODE_PROY FROM BODEGA WHERE BODE_COD = :BODE_DET INTO :CENTRODET, :PROYDET;
                if (IMPINC = 'S') then
                    BEGIN
                    MONTO = MONTO - IMPTOS;
                    if (FOMENTO <> 'SI' ) then
                        MONTO = MONTO - VALORADIC;
                    END
                MONTO = MONTO * FACTOR;
                execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    FOR SELECT F.ARTI_COD, (FCDE_CANT * (FCDE_PRUNIT-FCDE_DTOMONTO)), FCDE_IVAMONTO, FCDE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_COMPRAS_DETALLE F WHERE F.FACO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAINV = :CUENTA
                        INTO :ARTICULO, :MONTO, :IMPTOS, :VALORADIC DO
                        BEGIN
                        if (IMPINC = 'S') then
                            BEGIN
                            MONTO = MONTO - IMPTOS;
                            if (FOMENTO <> 'SI' ) then
                                MONTO = MONTO - VALORADIC;
                            END
                        MONTO = MONTO * FACTOR;
                        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        IF (CENT = 'B') THEN
                           INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                               VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROYDET, :CENTRODET, NULL, NULL, NULL, :ARTICULO, 0, 0);
                        ELSE
                           INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                               VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                        NUMITEMS = NUMITEMS + 1;
                        NETO = NETO + MONTO;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    IF (CENT = 'B') THEN
                       INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                           VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROYDET, :CENTRODET, :NUMERO, NULL, :VENCE, NULL, 0, 21);
                    ELSE
                       INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                           VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 21);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO + MONTO;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    IF (CENT = 'B') THEN
                       INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                           VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROYDET, :CENTRODET, NULL, NULL, NULL, NULL, 0, 0);
                    ELSE
                       INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                           VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO + MONTO;
                    END
                END
            END
        if (INVEN = 'K') then
            BEGIN
            FOR SELECT SUM(CAST(FCDE_CANT AS DOUBLE PRECISION) * (FCDE_PRUNIT-FCDE_DTOMONTO)), SUM(FCDE_IVAMONTO), SUM(FCDE_CONSUMO), MAX(BODE_COD)
                FROM FACTURAS_COMPRAS_DETALLE WHERE FACO_ID = :IDDOC GROUP BY BODE_COD INTO :MONTO, :IMPTOS, :VALORADIC, :BODE_DET Do
                BEGIN
                  IF (CENT = 'B') THEN
                    SELECT BODE_CENTRO, BODE_PROY FROM BODEGA WHERE BODE_COD = :BODE_DET INTO :CENTRODET, :PROYDET;
                  if (IMPINC = 'S') then
                   BEGIN
                    MONTO = MONTO - IMPTOS;
                    if (FOMENTO <> 'SI' ) then
                      MONTO = MONTO - VALORADIC;
                   END
                  MONTO = MONTO * FACTOR;
                  execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                  execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                  EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                  if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                  if (TIPOCUEN = 'I') then
                   BEGIN
                    FOR SELECT ARTI_COD, (FCDE_CANT * (FCDE_PRUNIT-FCDE_DTOMONTO)), FCDE_IVAMONTO, FCDE_CONSUMO
                      FROM FACTURAS_COMPRAS_DETALLE WHERE FACO_ID = :IDDOC INTO :ARTICULO, :MONTO, :IMPTOS, :VALORADIC DO
                       BEGIN
                       if (IMPINC = 'S') then
                        BEGIN
                         MONTO = MONTO - IMPTOS;
                         if (FOMENTO <> 'SI' ) then
                            MONTO = MONTO - VALORADIC;
                        END
                       MONTO = MONTO * FACTOR;
                       execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                       execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                       IF (CENT = 'B') THEN
                          INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                             VALUES (:IDC, :NUMITEMS, :CTAINVEN, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROYDET, :CENTRODET, NULL, NULL, NULL, :ARTICULO, 0, 0);
                       ELSE
                          INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                             VALUES (:IDC, :NUMITEMS, :CTAINVEN, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                       NUMITEMS = NUMITEMS + 1;
                       NETO = NETO + MONTO;
                       END
                   END
                  if (TIPOCUEN = 'C') then
                   BEGIN
                    IF (CENT = 'B') THEN
                       INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                         VALUES (:IDC, :NUMITEMS, :CTAINVEN, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROYDET, :CENTRODET, :NUMERO, NULL, :VENCE, NULL, 0, 21);
                    ELSE
                       INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                         VALUES (:IDC, :NUMITEMS, :CTAINVEN, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 21);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO + MONTO;
                   END
                  if (TIPOCUEN = 'N') then
                   BEGIN
                    IF (CENT = 'B') THEN
                       INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                          VALUES (:IDC, :NUMITEMS, :CTAINVEN, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROYDET, :CENTRODET, NULL, NULL, NULL, NULL, 0, 0);
                    ELSE
                       INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                          VALUES (:IDC, :NUMITEMS, :CTAINVEN, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO + MONTO;
                   END
                END
            END
        /* EL IVA */
        if (IVA = 'A') then
            BEGIN
            FOR SELECT MAX(COAR_CTAIVAC), SUM(FCDE_IVAMONTO), SUM(CAST(FCDE_CANT AS DOUBLE PRECISION) * (FCDE_PRUNIT-FCDE_DTOMONTO)), SUM(FCDE_CONSUMO)
                FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_COMPRAS_DETALLE F WHERE F.FACO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD GROUP BY COAR_CTAIVAC
                INTO :CTAIVA, :IMPTOS, :MONTO, :VALORADIC DO
              if (IMPTOS <> 0) then
                BEGIN
                IMPTOS = CAST(IMPTOS AS DOUBLE PRECISION) * VRSUBT / MERCANCIA;
                if (IMPINC = 'S') then
                    BEGIN
                    MONTO = MONTO - IMPTOS;
                    if (FOMENTO <> 'SI' ) then
                        MONTO = MONTO - VALORADIC;
                    END
                MONTO = CAST(MONTO AS DOUBLE PRECISION) * VRSUBT / MERCANCIA;
                execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    FOR SELECT F.ARTI_COD, FCDE_IVAMONTO, (FCDE_CANT * (FCDE_PRUNIT-FCDE_DTOMONTO)), TAIV_PORC, FCDE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_COMPRAS_DETALLE F, TARIFA_IVA T WHERE F.FACO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAIVAV = :CUENTA AND A.TAIV_COD = T.TAIV_COD
                        INTO :ARTICULO, :IMPTOS, :MONTO, :PORCIVA, :VALORADIC
                    DO
                        BEGIN
                        IMPTOS = CAST(IMPTOS AS DOUBLE PRECISION) * VRSUBT / MERCANCIA;
                        if (IMPINC = 'S') then
                            BEGIN
                            MONTO = MONTO - IMPTOS;
                            if (FOMENTO <> 'SI' ) then
                                MONTO = MONTO - VALORADIC;
                            END
                        MONTO = CAST(MONTO AS DOUBLE PRECISION) * VRSUBT / MERCANCIA;
                        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :IMPTOS, 0, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                        NUMITEMS = NUMITEMS + 1;
                        NETO = NETO + IMPTOS;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :IMPTOS, 0, :MONTO, :IMPTOS*100/:MONTO, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 21);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO + IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :IMPTOS, 0, :MONTO, CAST(:IMPTOS AS DOUBLE PRECISION)*100/CAST(:MONTO AS DOUBLE PRECISION), :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO + IMPTOS;
                    END
                END
            END
        if (IVA = 'K') then /* IVA EN CTA CONSTANTE */
            BEGIN
            SELECT SUM(FCDE_IVAMONTO), SUM(CAST(FCDE_CANT AS DOUBLE PRECISION) * (FCDE_PRUNIT-FCDE_DTOMONTO)), SUM(FCDE_CONSUMO)
                FROM FACTURAS_COMPRAS_DETALLE F WHERE F.FACO_ID = :IDDOC INTO :IMPTOS, :MONTO, :VALORADIC;
            if (IMPTOS <> 0) then
                BEGIN
                IMPTOS = CAST(IMPTOS AS DOUBLE PRECISION) * VRSUBT / MERCANCIA;
                if (IMPINC = 'S') then
                    BEGIN
                    MONTO = MONTO - IMPTOS;
                    if (FOMENTO <> 'SI' ) then
                        MONTO = MONTO - VALORADIC;
                    END
                MONTO = CAST(MONTO AS DOUBLE PRECISION) * VRSUBT / MERCANCIA;
                execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    FOR SELECT F.ARTI_COD, (FCDE_CANT * (FCDE_PRUNIT-FCDE_DTOMONTO)), FCDE_IVAMONTO, TAIV_PORC, FCDE_CONSUMO
                        FROM ARTICULO A, FACTURAS_COMPRAS_DETALLE F, TARIFA_IVA T WHERE F.FACO_ID = :IDDOC AND A.TAIV_COD = T.TAIV_COD
                        INTO :ARTICULO, :MONTO, :IMPTOS, :PORCIVA, :VALORADIC DO
                        BEGIN
                        IMPTOS = CAST(IMPTOS AS DOUBLE PRECISION) * VRSUBT / MERCANCIA;
                        if (IMPINC = 'S') then
                            BEGIN
                            MONTO = MONTO - IMPTOS;
                            if (FOMENTO <> 'SI' ) then
                                MONTO = MONTO - VALORADIC;
                            END
                        MONTO = CAST(MONTO AS DOUBLE PRECISION) * VRSUBT / MERCANCIA;
                        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        if (IMPTOS <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NUMITEMS, :CTAIVA, :CONCEPTO, '', :IMPTOS, 0, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                            NUMITEMS = NUMITEMS + 1;
                            NETO = NETO + IMPTOS;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CTAIVA, :CONCEPTO, '', :IMPTOS, 0, :MONTO, :IMPTOS*100/:MONTO, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 21);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO + IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CTAIVA, :CONCEPTO, '', :IMPTOS, 0, :MONTO, :IMPTOS*100/:MONTO, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO + IMPTOS;
                    END
                END
            END
        /* EL IMPOCONSUMO */
        if (CONSUMO = 'A') then
            BEGIN
            FOR SELECT MAX(COAR_CTACONS), SUM(FCDE_CONSUMO) FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_COMPRAS_DETALLE F
                WHERE F.FACO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD GROUP BY COAR_CTACONS INTO :CTACONSUMO, :IMPTOS
            DO
              if (IMPTOS <> 0) then
                BEGIN
                execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (FOMENTO <> 'SI') then
                    BEGIN
                    if (TIPOCUEN = 'I') then
                        BEGIN
                        FOR SELECT F.ARTI_COD, FCDE_CONSUMO FROM ARTICULO A, FACTURAS_COMPRAS_DETALLE F WHERE F.FACO_ID = :IDDOC INTO :ARTICULO, :IMPTOS
                            DO
                            BEGIN
                            if (IMPTOS <> 0) then
                                BEGIN
                                execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                    VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                                NUMITEMS = NUMITEMS + 1;
                                NETO = NETO + IMPTOS;
                                END
                            END
                        END
                    if (TIPOCUEN = 'C') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                        NUMITEMS = NUMITEMS + 1;
                        NETO = NETO + IMPTOS;
                        END
                    if (TIPOCUEN = 'N') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        NUMITEMS = NUMITEMS + 1;
                        NETO = NETO + IMPTOS;
                        END
                    END
                ELSE
                    BEGIN
                    if (TIPOCUEN = 'I') then
                        BEGIN
                        FOR SELECT F.ARTI_COD, FCDE_CONSUMO FROM ARTICULO A, FACTURAS_COMPRAS_DETALLE F WHERE F.FACO_ID = :IDDOC INTO :ARTICULO, :IMPTOS
                            DO
                            BEGIN
                            if (IMPTOS <> 0) then
                                BEGIN
                                execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                    VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                                NUMITEMS = NUMITEMS + 1;
                                NETO = NETO - IMPTOS;
                                END
                            END
                        END
                    if (TIPOCUEN = 'C') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                        NUMITEMS = NUMITEMS + 1;
                        NETO = NETO - IMPTOS;
                        END
                    if (TIPOCUEN = 'N') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        NUMITEMS = NUMITEMS + 1;
                        NETO = NETO - IMPTOS;
                        END
                    END
                END
            END
        if (CONSUMO = 'K') then /* CONSUMO EN CTA CONSTANTE */
            BEGIN
            SELECT SUM(FCDE_CONSUMO) FROM FACTURAS_COMPRAS_DETALLE F WHERE F.FACO_ID = :IDDOC INTO :IMPTOS;
            if (IMPTOS <> 0) then
              BEGIN
              execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
              /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
              EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
              if (ERRORC <> 0) then
                ERROR = ERROR + 1;
              if (FOMENTO <> 'SI') then
                BEGIN
                /* DEPENDE DEL TIPO DE CUENTA */
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, FCDE_CONSUMO FROM ARTICULO A, FACTURAS_COMPRAS_DETALLE F WHERE F.FACO_ID = :IDDOC INTO :ARTICULO, :IMPTOS
                        DO
                        BEGIN
                        if (IMPTOS <> 0) then
                            BEGIN
                            execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                            NUMITEMS = NUMITEMS + 1;
                            NETO = NETO + IMPTOS;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    /* INSERTE EL REGISTRO DE LA BASE */
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO + IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO + IMPTOS;
                    END
                END
              ELSE
                BEGIN
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, FCDE_CONSUMO FROM ARTICULO A, FACTURAS_COMPRAS_DETALLE F WHERE F.FACO_ID = :IDDOC INTO :ARTICULO, :IMPTOS
                        DO
                        BEGIN
                        if (IMPTOS <> 0) then
                            BEGIN
                           execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                           INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                            NUMITEMS = NUMITEMS + 1;
                            NETO = NETO - IMPTOS;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    /* INSERTE EL REGISTRO DE LA BASE */
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO - IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO - IMPTOS;
                    END
                END
              end
            END
        /* DESCUENTO */
        if ((CTADTO IS NOT NULL) AND
            (CTADTO <> '')) THEN
          BEGIN
          execute procedure redondee(VRDTO, DIG) returning_values (VRDTO);
          if (VRDTO <> 0) then
            begin
            /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
            EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTADTO, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRDTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 21);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO - VRDTO;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                /* INSERTE EL REGISTRO DE LA BASE */
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRDTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO - VRDTO;
                END
            end
          END
        /* VALOR ADIC */
        if ((CTAADIC IS NOT NULL) AND
            (CTAADIC <> '')) THEN
          BEGIN
          execute procedure redondee(VRADIC, DIG) returning_values (VRADIC);
          if (VRADIC <> 0) then
            begin
            /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
            EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTAADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRADIC, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 21);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO + VRADIC;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRADIC, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO + VRADIC;
                END
            end
          END
        /* VALOR EXTRA */
        if ((CTAEXTRA IS NOT NULL) AND
            (CTAEXTRA <> '')) THEN
          BEGIN
          execute procedure redondee(VREXTRA, DIG) returning_values (VREXTRA);
          if (VREXTRA <> 0) then
            begin
            /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
            EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTAEXTRA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VREXTRA, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 21);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO + VREXTRA;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VREXTRA, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO + VREXTRA;
                END
            end
          END

        /* DESCUENTE EL IMPOCONSUMO */
        SELECT SUM(FCDE_CONSUMO) FROM FACTURAS_COMPRAS_DETALLE F WHERE F.FACO_ID = :IDDOC INTO :IMPTOS;
        if (IMPTOS IS NULL) then
            IMPTOS = 0;
        vrsubt = vrsubt - IMPTOS;
        /* RETENCION FUENTE */
        if ((RTFTE = 'P') or (RTFTE = 'K')) then
          BEGIN
          execute procedure redondee(VRRTFTE, DIG) returning_values (VRRTFTE);
          if (VRRTFTE <> 0) then
            begin
            if (RTFTE = 'P') then
                CTARTFTE = TCTARTFTE;
            EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRRTFTE, (:VRSUBT*-1), :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO - VRRTFTE;
                SUMA = VRRTFTE;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRRTFTE, (:VRSUBT*-1), :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO - VRRTFTE;
                SUMA = VRRTFTE;
                END
            end
          END
        if (RTFTE = 'A') then
          BEGIN
          FOR SELECT MAX(COAR_CTARTFTE), MAX(COAR_RTFTE), SUM(FCDE_TOTAL-FCDE_IVAMONTO-FCDE_CONSUMO), SUM((FCDE_TOTAL-FCDE_IVAMONTO-FCDE_CONSUMO)*COAR_RTFTE)
            FROM CONTABIL_ARTICULO C, FACTURAS_COMPRAS_DETALLE F
            WHERE F.faco_id = :IDDOC AND F.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTARTFTE
            INTO :CTARTFTE, :PRTFTE, :MONTO, :VRRTFTE
            DO
            BEGIN
            MONTO = MONTO * FACTOR * -1;
            VRRTFTE = VRRTFTE * FACTOR / 100;
            execute procedure redondee(VRRTFTE, DIG) returning_values (VRRTFTE);
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (VRRTFTE <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRRTFTE, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO - VRRTFTE;
                    SUMA = VRRTFTE;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRRTFTE, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO - VRRTFTE;
                    SUMA = VRRTFTE;
                    END
                end
            end
          END
        /* RETENCION IVA */
        if ((RTIVA = 'P') or (RTIVA = 'K')) then
          BEGIN
          execute procedure redondee(VRRTIVA, DIG) returning_values (VRRTIVA);
          if (VRRTIVA <> 0) then
            begin
            if (RTIVA = 'P') then
                CTARTIVA = TCTARTIVA;
            EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTARTIVA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRRTIVA, (:VRIVA*-1), :PORC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 21);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO - VRRTIVA;
                SUMA = SUMA + VRRTIVA;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRRTIVA, (:VRIVA*-1), :PORC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO - VRRTIVA;
                SUMA = SUMA + VRRTIVA;
                END
            end
          END
        /* RETENCION DE ICA */
        if ((RTICA = 'P') or (RTICA = 'K')) then
          BEGIN
          execute procedure redondee(VRRTICA, DIG) returning_values (VRRTICA);
          if (VRRTICA <> 0) then
            begin
            if (RTICA = 'P') then
                CTARTICA = TCTARTICA;
            EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTARTICA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRRTICA, (:VRSUBT*-1), :PRTICA, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 21);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO - VRRTICA;
                SUMA = SUMA + VRRTICA;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRRTICA, (:VRSUBT*-1), :PRTICA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO - VRRTICA;
                SUMA = SUMA + VRRTICA;
                END
            end
          END
        if (RTICA = 'A') then
          BEGIN
          FOR SELECT MAX(COAR_CTARTICA), MAX(COAR_RTICA), SUM(FCDE_TOTAL-FCDE_IVAMONTO-FCDE_CONSUMO), SUM((FCDE_TOTAL-FCDE_IVAMONTO-FCDE_CONSUMO)*COAR_RTICA)
            FROM CONTABIL_ARTICULO C, FACTURAS_COMPRAS_DETALLE F
            WHERE F.faco_id = :IDDOC AND F.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTARTICA
            INTO :CTARTICA, :PRTICA, :MONTO, :VRRTICA
            DO
            BEGIN
            MONTO = MONTO * FACTOR * -1;
            VRRTICA = VRRTICA * FACTOR / 100;
            execute procedure redondee(VRRTICA, DIG) returning_values (VRRTICA);
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (VRRTICA <> 0) then
                begin
                EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTARTICA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRRTICA, (:MONTO*-1), :PRTICA, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 21);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO - VRRTICA;
                    SUMA = SUMA + VRRTICA;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRRTICA, (:MONTO*-1), :PRTICA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO - VRRTICA;
                    SUMA = SUMA + VRRTICA;
                    END
                END
            end
          END
        /* CIERRE EL COMPROBANTE CONTRA LA CUENTA DEL TERCERO O LA CONSTANTE */
        if ((CXP = 'P') or (CXP = 'K')) then
            BEGIN
            SUMA = VRTOTAL - SUMA;
            execute procedure redondee(SUMA, DIG) returning_values (SUMA);
            if (CXP = 'P') then
                CTACXP = TCTAPROV;
            EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTACXP, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :SUMA, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 21);
            if (TIPOCUEN = 'N') then
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :SUMA, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NETO = NETO - SUMA;
            NUMITEMS = NUMITEMS + 1;
            END
        /* recorra las cuentas adicionales */
        FOR SELECT INCC_CUENTA, INCC_BASE, INCC_PORC, INCC_VALOR, INCC_DB FROM INTERFAZ_COMPRAS_CTAS
            WHERE INCO_ID = :IDINTER INTO :CUENTAADIC, :BASEADIC, :PORCADIC, :VALORADIC, :DBADIC
            DO
            BEGIN
            if (VALORADIC <> 0) then
                MONTO = VALORADIC;
            ELSE
                BEGIN
                if (:BASEADIC = 'SUBTOTAL') then
                    VALORADIC = VRTOTAL - VREXTRA - VRIVA - VRADIC + VRDTO;
                if (:BASEADIC = 'DESCUENTO') then
                    VALORADIC = VRDTO;
                if (:BASEADIC = 'IVA') then
                    VALORADIC = VRIVA;
                if (:BASEADIC = 'CONSUMO') then
                    SELECT SUM(FCDE_CONSUMO) FROM FACTURAS_COMPRAS_DETALLE F WHERE F.FACO_ID = :IDDOC INTO :VALORADIC;
                if (:BASEADIC = 'ADICIONAL') then
                    VALORADIC = VRADIC;
                if (:BASEADIC = 'EXTRA') then
                    VALORADIC = VREXTRA;
                if (:BASEADIC = 'TOTAL') then
                    VALORADIC = VRTOTAL;
                MONTO = CAST(VALORADIC AS DOUBLE PRECISION) * PORCADIC / 100;
                END
            if (MONTO <> 0) then
                BEGIN
                execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CUENTAADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'C') then
                    BEGIN
                    if (DBADIC = 'S') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTAADIC, :CONCEPTO, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                        SUMA = SUMA + MONTO;
                        NETO = NETO + MONTO;
                        END
                    ELSE
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTAADIC, :CONCEPTO, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                        SUMA = SUMA - MONTO;
                        NETO = NETO - MONTO;
                        END
                    NUMITEMS = NUMITEMS + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    if (DBADIC = 'S') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTAADIC, :CONCEPTO, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        SUMA = SUMA + MONTO;
                        NETO = NETO + MONTO;
                        END
                    ELSE
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTAADIC, :CONCEPTO, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        SUMA = SUMA - MONTO;
                        NETO = NETO - MONTO;
                        END
                    NUMITEMS = NUMITEMS + 1;
                    END
                END
            END
        if (NETO <> 0) then
            BEGIN
            EXECUTE PROCEDURE lee_configuracion ('CONTABILIDAD','GENERAL','CUENTA PARA CUADRAR COMPROBANTES DESCUADRADOS DE INTERFAZ') returning_values (:ctaadic);
            if (ctaadic <> '') then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTAADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'C') then
                    BEGIN
                    if (NETO < 0) then
                        BEGIN
                        NETO = NETO * -1;
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :NETO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                        END
                    ELSE
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :NETO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                        END
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    if (NETO < 0) then
                        BEGIN
                        NETO = NETO * -1;
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :NETO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        END
                    ELSE
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :NETO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        END
                    END
                END
            END
        END
    if (ERROR > 0) then
        VER = 'S';
    SUSPEND;
    END
ELSE
    BEGIN
    EXECUTE PROCEDURE ERROR (21, :IDDOC, :PREFIJO, 1);
    ERROR = ERROR + 1;
    VER = 'S';
    SUSPEND;
    END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE CONTABILICE_COMP_SIMPLIFICADO(
    IDI INTEGER)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable ERROR INTEGER;
BEGIN /*$$IBE$$ 
FOR SELECT FACO_ID, PREF_PRE, FACO_NUMERO FROM FACTURAS_COMPRA C, PROVEEDORES P WHERE
    C.TERC_NIT = P.TERC_NIT AND PROV_SIMPLIFICADO = 'S' AND FACO_ANULADO = 'N'
    ORDER BY FACO_ID INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  ESTADO = 'PROCESANDO';
  SUSPEND;
   $$IBE$$*/ /* BORRE LA CONTABILIZACION */
/*  delete FROM comprobante_detalle WHERE ENCO_CONSEC IN (SELECT ENCO_CONSEC FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 21 AND ENCO_IDREF = :ID);
  DELETE FROM comprobante_encabezado  WHERE ENCO_TIPOREF = 21 AND ENCO_IDREF = :ID; */ /*$$IBE$$ 
  EXECUTE PROCEDURE CONTABIL_FACTCOMP (:ID, :IDI) RETURNING_VALUES (:ERROR, VER, :IDC);
  if (ERROR = 0) then
    BEGIN
 $$IBE$$*/ /*    EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC); */ /*$$IBE$$ 
    ESTADO = 'OK';
    END
  ELSE
    ESTADO = 'ERROR';
  suspend;
  END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE FACTCOMP_SIN_CONTABILIDAD(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDI INTEGER,
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable FECICNT VARCHAR(10);
declare variable FECFCNT VARCHAR(10);
declare variable ERROR INTEGER;
declare variable idref INTEGER;
BEGIN /*$$IBE$$ 
EXECUTE PROCEDURE fecha_a_conta(FECINI) returning_values (FECICNT);
EXECUTE PROCEDURE fecha_a_conta(FECFIN) returning_values (FECFCNT);
FOR SELECT FACO_ID, PREF_PRE, FACO_NUMERO FROM FACTURAS_COMPRA WHERE FACO_ANULADO = 'N' AND
    FACO_FECHA >= :FECINI AND FACO_FECHA <= :FECFIN ORDER BY FACO_ID
    INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  idref = null;
  SELECT ENCO_IDREF FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 21 AND ENCO_FECHA >= :FECICNT AND ENCO_FECHA <= :FECFCNT and ENCO_IDREF = :id into :idref;
  if (idref IS NULL) then
  begin
   ESTADO = 'PROCESANDO';
   SUSPEND;
   SELECT MAX(INCO_ID) FROM INTERFAZ_COMPRAS WHERE PREF_PRE = :PREF AND TIDO_COD = 21 INTO :IDI;
   EXECUTE PROCEDURE CONTABIL_FACTCOMP (:ID, :IDI) RETURNING_VALUES (:ERROR, VER, :IDC);
   if (ERROR = 0) then
    BEGIN
    EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC);
    ESTADO = 'OK';
    END
   ELSE
    ESTADO = 'ERROR';
   suspend;
  End
  END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE CONTABILICE_COMP_SIMPLIFICADO(
    IDI INTEGER)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable ERROR INTEGER;
BEGIN
FOR SELECT FACO_ID, PREF_PRE, FACO_NUMERO FROM FACTURAS_COMPRA C, PROVEEDORES P WHERE
    C.TERC_NIT = P.TERC_NIT AND PROV_SIMPLIFICADO = 'S' AND FACO_ANULADO = 'N'
    ORDER BY FACO_ID INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  ESTADO = 'PROCESANDO';
  SUSPEND;
  /* BORRE LA CONTABILIZACION */
/*  delete FROM comprobante_detalle WHERE ENCO_CONSEC IN (SELECT ENCO_CONSEC FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 21 AND ENCO_IDREF = :ID);
  DELETE FROM comprobante_encabezado  WHERE ENCO_TIPOREF = 21 AND ENCO_IDREF = :ID; */
  EXECUTE PROCEDURE CONTABIL_FACTCOMP (:ID, :IDI) RETURNING_VALUES (:ERROR, VER, :IDC);
  if (ERROR = 0) then
    BEGIN
/*    EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC); */
    ESTADO = 'OK';
    END
  ELSE
    ESTADO = 'ERROR';
  suspend;
  END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE FACTCOMP_SIN_CONTABILIDAD(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDI INTEGER,
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable FECICNT VARCHAR(10);
declare variable FECFCNT VARCHAR(10);
declare variable ERROR INTEGER;
declare variable idref INTEGER;
BEGIN
EXECUTE PROCEDURE fecha_a_conta(FECINI) returning_values (FECICNT);
EXECUTE PROCEDURE fecha_a_conta(FECFIN) returning_values (FECFCNT);
FOR SELECT FACO_ID, PREF_PRE, FACO_NUMERO FROM FACTURAS_COMPRA WHERE FACO_ANULADO = 'N' AND
    FACO_FECHA >= :FECINI AND FACO_FECHA <= :FECFIN ORDER BY FACO_ID
    INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  idref = null;
  SELECT ENCO_IDREF FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 21 AND ENCO_FECHA >= :FECICNT AND ENCO_FECHA <= :FECFCNT and ENCO_IDREF = :id into :idref;
  if (idref IS NULL) then
  begin
   ESTADO = 'PROCESANDO';
   SUSPEND;
   SELECT MAX(INCO_ID) FROM INTERFAZ_COMPRAS WHERE PREF_PRE = :PREF AND TIDO_COD = 21 INTO :IDI;
   EXECUTE PROCEDURE CONTABIL_FACTCOMP (:ID, :IDI) RETURNING_VALUES (:ERROR, VER, :IDC);
   if (ERROR = 0) then
    BEGIN
    EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC);
    ESTADO = 'OK';
    END
   ELSE
    ESTADO = 'ERROR';
   suspend;
  End
  END
END

^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE CONTABIL_DEVOLCOMP(
    IDDOC INTEGER,
    IDINTER INTEGER)
RETURNS (
    ERROR INTEGER,
    VER CHAR(1),
    IDC INTEGER)
AS
declare variable PREFIJO VARCHAR(4);
declare variable NUM VARCHAR(6);
declare variable NUMERO VARCHAR(10);
declare variable FECAUX DATE;
declare variable FECHA CHAR(8);
declare variable CONCEPTO CHAR(100);
declare variable NUMFAC VARCHAR(10);
declare variable VRDTO NUMERIC(18, 2);
declare variable VRADIC NUMERIC(18, 2);
declare variable VRSUBT NUMERIC(18, 2);
declare variable VRIVA NUMERIC(18, 2);
declare variable PRTFTE NUMERIC(9, 2);
declare variable VRRTFTE NUMERIC(18, 2);
declare variable VRRTIVA NUMERIC(18, 2);
declare variable PRTICA NUMERIC(9, 2);
declare variable VRRTICA NUMERIC(18, 2);
declare variable VRTOTAL NUMERIC(18, 2);
declare variable VREXTRA NUMERIC(18, 2);
declare variable TIPOCOMP VARCHAR(3);
declare variable PREFCONT VARCHAR(4);
declare variable INVEN CHAR(1);
declare variable CTAINVEN VARCHAR(20);
declare variable IVA CHAR(1);
declare variable CTAIVA VARCHAR(20);
declare variable CONSUMO CHAR(1);
declare variable CTACONSUMO VARCHAR(20);
declare variable CXP CHAR(1);
declare variable CTACXP VARCHAR(20);
declare variable RTFTE CHAR(1);
declare variable CTARTFTE VARCHAR(20);
declare variable RTIVA CHAR(1);
declare variable CTARTIVA VARCHAR(20);
declare variable RTICA CHAR(1);
declare variable CTARTICA VARCHAR(20);
declare variable CTADTO VARCHAR(20);
declare variable CTAADIC VARCHAR(20);
declare variable CTAEXTRA VARCHAR(20);
declare variable EXISTE CHAR(1);
declare variable CUENTA VARCHAR(20);
declare variable MONTO NUMERIC(18,2);
declare variable TIPOCUEN CHAR(1);
declare variable NIT VARCHAR(20);
declare variable PROY VARCHAR(4);
declare variable CENTRO VARCHAR(4);
declare variable PORC NUMERIC(5,2);
declare variable DEBITO NUMERIC(18,2);
declare variable CREDITO NUMERIC(18,2);
declare variable NUMITEMS INTEGER;
declare variable ARTICULO VARCHAR(15);
declare variable IMPINC CHAR(1);
declare variable IMPTOS NUMERIC(18, 2);
declare variable SUMA NUMERIC(18,2);
declare variable PORCIVA NUMERIC(9,2);
declare variable TCTAPROV VARCHAR(20);
declare variable TCTARTFTE VARCHAR(20);
declare variable TCTARTIVA VARCHAR(20);
declare variable TCTARTICA VARCHAR(20);
declare variable CUENTAADIC VARCHAR(20);
declare variable BASEADIC VARCHAR(20);
declare variable PORCADIC NUMERIC(5,2);
declare variable VALORADIC NUMERIC(18,2);
declare variable DBADIC CHAR(1);
declare variable FOMENTO CHAR(2);
declare variable ANULADO CHAR(1);
declare variable CENT CHAR(1);
declare variable ERRORC INTEGER;
DECLARE VARIABLE MENORV CHAR(2);
DECLARE VARIABLE MERCANCIA NUMERIC(18,2);
declare variable FACTOR DOUBLE PRECISION;
declare variable DIG INTEGER;
BEGIN
/* BUSQUE LA INTERFACE */
EXISTE = 'N';
SELECT 'S', TICO_COD, PRCO_PRE, INCO_INVEN, INCO_IVA, INCO_CONSUMO, INCO_CXP, INCO_RTFTE, INCO_RTIVA, INCO_RTICA, INCO_CTAINVEN, INCO_CTAIVA, INCO_CTACONSUMO, INCO_CTADTO, INCO_CTAADIC, INCO_CTAEXTRA, INCO_CTACXP, INCO_CTARTFTE, INCO_CTARTIVA, INCO_CTARTICA, INCO_CONFIRMAR, INCO_CENTRO
    FROM INTERFAZ_COMPRAS
    WHERE INCO_ID = :IDINTER
    INTO :EXISTE, :TIPOCOMP, :PREFCONT, :INVEN, :IVA, :CONSUMO, :CXP, :RTFTE, :RTIVA, :RTICA, :CTAINVEN, :CTAIVA, :CTACONSUMO, :CTADTO, :CTAADIC, :CTAEXTRA, :CTACXP, :CTARTFTE, :CTARTIVA, :CTARTICA, :VER, :CENT;
if (EXISTE = 'S') then
   BEGIN
    /* BORRE CUALQUEIR CONTABILIZACION PREVIA */
    DELETE FROM CONTABILIZACION WHERE CNTB_TIPOREF = 24 AND CNTB_IDREF = :IDDOC;
   /* TRAIGA EL ENCABEZADO DE LA DEVOLUCION */
   SELECT PREF_PRE, DVCO_NUMERO, DVCO_FECHA, D.TERC_NIT, DVCO_FACTURA, DVCO_IMPTOS, DVCO_DTOMONTO, DVCO_ADICIONAL, DVCO_IVAMONTO, DVCO_EXTRA, DVCO_TOTAL, DVCO_RTFTEPORC, DVCO_RTFTEMONTO, DVCO_RTIVAPORC, DVCO_RTIVAMONTO, DVCO_RTICAPORC, DVCO_RTICAMONTO, PROV_CTARTFTE, PROV_CTARTIVA, PROV_CTARTICA, PROV_CTAPAGAR, DVCO_ANULADO
        FROM DEVOLUCIONES_COMPRAS D, TERCEROS T, PROVEEDORES P
        WHERE DVCO_ID = :IDDOC AND D.TERC_NIT = T.TERC_NIT AND T.TERC_NIT = P.TERC_NIT
        INTO :PREFIJO, :NUM, :FECAUX, :NIT, :NUMFAC, :IMPINC, :VRDTO, :VRADIC, :VRIVA, :VREXTRA, :VRTOTAL, :PRTFTE, :VRRTFTE, :PORC, :VRRTIVA, :PRTICA, :VRRTICA, :TCTARTFTE, TCTARTIVA, TCTARTICA, TCTAPROV, ANULADO;
   if (ANULADO = 'N') then
    BEGIN
    NUMERO = PREFIJO || NUM;
    VRSUBT = VRTOTAL - VREXTRA - VRIVA; /* BASE DE RETEFTE Y RETEICA */
    IF (CENT = 'B') THEN
        SELECT BODE_CENTRO, BODE_PROY FROM BODEGA B, DEVOLUCIONES_COMPRAS F
            WHERE B.BODE_COD = F.BODE_COD AND F.DVCO_ID = :IDDOC INTO :CENTRO, :PROY;
    ELSE
        SELECT PREF_CENTRO,PREF_PROY FROM PREFIJOS P, DEVOLUCIONES_COMPRAS F
            WHERE P.PREF_PRE = F.PREF_PRE AND F.DVCO_ID = :IDDOC AND P.TIDO_COD = 24 INTO :CENTRO, :PROY;
    /* CONVIERTA LA FECHA A CADENA */
    EXECUTE PROCEDURE FECHA_A_CONTA(:FECAUX) returning_values (:FECHA);
    EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'USAR IMPOCONSUMO COMO PORCENTAJE DE FOMENTO') RETURNING_VALUES (FOMENTO);
    EXECUTE PROCEDURE lee_configuracion('COMPRAS','FACTURAS','DESCUENTO Y VALOR ADICIONAL DEL DOCUMENTO COMO MENOR VALOR DEL COSTO') returning_values (:MENORV);
    SELECT CAST(CONF_VALOR AS INTEGER) FROM CONFIGURACION WHERE CONF_MODULO = 'COMPRAS' AND CONF_CATEGORIA = 'GENERAL' AND CONF_PROPIEDAD = 'REDONDEO AL MULTIPLO DE DIEZ EN TOTALES' INTO :DIG;
    VRSUBT = VRTOTAL - VREXTRA - VRIVA;
    MERCANCIA = VRSUBT - VRADIC + VRDTO;
    SELECT SUM(DVCD_consumo) from devoluciones_compras_det where dvco_id = :IDDOC into :valoradic;
    if (MENORV = 'SI') then
        if (MERCANCIA <> 0) then
            FACTOR = (CAST(VRSUBT AS DOUBLE PRECISION) - VALORADIC) / (CAST(MERCANCIA AS DOUBLE PRECISION) - VALORADIC);
        ELSE
            FACTOR = 1;
    ELSE
        FACTOR = 1;

    /* REGISTRE EL ENCABEZADO CONTABLE */
    CONCEPTO = 'DEVOLUCION COMPRA No. ' || NUMERO || ' EN FACTURA ' || NUMFAC;
    IDC = GEN_ID(ID_CONTABILIZA, 1);
    INSERT INTO CONTABILIZACION (CNTB_ID, CNTB_TIPOCOMP, CNTB_PREFCNT, CNTB_NUMERO, CNTB_FECHA, CNTB_CONCEPTO, CNTB_REF, CNTB_TIPOREF, CNTB_IDREF, CNTB_PREFREF, CNTB_NUMREF, CNTB_PROCESADO)
        VALUES (:IDC, :TIPOCOMP, :PREFCONT, :NUM, :FECHA, :CONCEPTO, '', 24, :IDDOC, :PREFIJO, :NUM, 'N');

    NUMITEMS = 0;
    SUMA = 0;
    ERROR = 0;
    /* CUENTAS DE INVENTARIO */
    if (INVEN = 'A') then
        BEGIN
        /* SUME LAS BASES DE LOS ARTICULOS DEL DOCUMENTO */
        FOR SELECT MAX(COAR_CTACOMP), SUM(cast(DVCD_CANT as double precision) * (DVCD_PRUNIT-DVCD_DTOMONTO)), SUM(DVCD_IVAMONTO), SUM(DVCD_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_COMPRAS_DET F
            WHERE F.DVCO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTAINV
            INTO :CTAINVEN, :MONTO, :IMPTOS, :VALORADIC
            DO
            BEGIN
            if (IMPINC = 'S') then
                BEGIN
                MONTO = MONTO - IMPTOS;
                if (FOMENTO <> 'SI') then
                    MONTO = MONTO - VALORADIC;
                END
            /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
            EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            /* DEPENDE DEL TIPO DE CUENTA */
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, (cast(DVCD_CANT as double precision) * (DVCD_PRUNIT-DVCD_DTOMONTO)), DVCD_IVAMONTO, DVCD_CONSUMO
                    FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_COMPRAS_DET F
                    WHERE F.DVCO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAINV = :CUENTA
                    INTO :ARTICULO, :MONTO, :IMPTOS, :VALORADIC
                DO
                    BEGIN
                    if (IMPINC = 'S') then
                        BEGIN
                        MONTO = MONTO - IMPTOS;
                        if (FOMENTO <> 'SI') then
                            MONTO = MONTO - VALORADIC;
                        END
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    SUMA = SUMA - MONTO;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                /* INSERTE EL REGISTRO DE LA BASE */
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
                NUMITEMS = NUMITEMS + 1;
                SUMA = SUMA - MONTO;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                /* INSERTE EL REGISTRO DE LA BASE */
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NUMITEMS = NUMITEMS + 1;
                SUMA = SUMA - MONTO;
                END
            END /* FOR */
        END /* INVENTARIO X ARTICULO */

    if (INVEN = 'K') then
        BEGIN
        /* SUME LAS BASES DE LOS ARTICULOS DEL DOCUMENTO */
        SELECT SUM(cast(DVCD_CANT as double precision) * (DVCD_PRUNIT-DVCD_DTOMONTO)), SUM(DVCD_IVAMONTO), SUM(DVCD_CONSUMO)
            FROM DEVOLUCIONES_COMPRAS_DET WHERE DVCO_ID = :IDDOC
            INTO :MONTO, :IMPTOS, :VALORADIC;
        if (IMPINC = 'S') then
            BEGIN
            MONTO = MONTO - IMPTOS;
            if (FOMENTO <> 'SI') then
                MONTO = MONTO - VALORADIC;
            END
        /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
        EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        /* DEPENDE DEL TIPO DE CUENTA */
        if (TIPOCUEN = 'I') then
            BEGIN
            /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
            FOR SELECT ARTI_COD, (cast(DVCD_CANT as double precision) * (DVCD_PRUNIT-DVCD_DTOMONTO)), DVCD_IVAMONTO, DVCD_CONSUMO
                FROM DEVOLUCIONES_COMPRAS_DET
                WHERE DVCO_ID = :IDDOC
                INTO :ARTICULO, :MONTO, :IMPTOS, :VALORADIC
                DO
                BEGIN
                if (IMPINC = 'S') then
                    BEGIN
                    MONTO = MONTO - IMPTOS;
                    if (FOMENTO <> 'SI') then
                        MONTO = MONTO - VALORADIC;
                    END
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CTAINVEN, :CONCEPTO, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                NUMITEMS = NUMITEMS + 1;
                SUMA = SUMA - MONTO;
                END
            END
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CTAINVEN, :CONCEPTO, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA - MONTO;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CTAINVEN, :CONCEPTO, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA - MONTO;
            END
        END /* INVEN = K */
        
    /* EL IVA */
    if (IVA = 'A') then
        BEGIN
        /* SUME LAS BASES DE LOS ARTICULOS DEL DOCUMENTO */
        FOR SELECT MAX(COAR_CTAIVAC), SUM(DVCD_IVAMONTO), SUM(cast(DVCD_CANT as double precision) * (DVCD_PRUNIT-DVCD_DTOMONTO)), SUM(DVCD_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_COMPRAS_DET F
            WHERE F.DVCO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTAIVAC
            INTO :CTAIVA, :IMPTOS, :MONTO, :VALORADIC
        DO
          if (IMPTOS <> 0) then
            BEGIN
            if (IMPINC = 'S') then
                BEGIN
                MONTO = MONTO - IMPTOS;
                if (FOMENTO <> 'SI') then
                    MONTO = MONTO - VALORADIC;
                END

            /* TRAIGA LAS CARCATERISTICAS DE LA CUENTA */
            EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            /* DEPENDE DEL TIPO DE CUENTA */
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, DVCD_IVAMONTO, (cast(DVCD_CANT as double precision) * (DVCD_PRUNIT-DVCD_DTOMONTO)), TAIV_PORC, DVCD_CONSUMO
                    FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_COMPRAS_DET F, TARIFA_IVA T
                    WHERE F.DVCO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAIVAV = :CUENTA AND A.TAIV_COD = T.TAIV_COD
                    INTO :ARTICULO, :IMPTOS, :MONTO, :PORCIVA, :VALORADIC
                DO
                    BEGIN
                    if (IMPINC = 'S') then
                        BEGIN
                        MONTO = MONTO - IMPTOS;
                        if (FOMENTO <> 'SI') then
                            MONTO = MONTO - VALORADIC;
                        END
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :IMPTOS, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
                NUMITEMS = NUMITEMS + 1;
                SUMA = SUMA - IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NUMITEMS = NUMITEMS + 1;
                SUMA = SUMA - IMPTOS;
                END
            END /* FOR */
        END /* IVA X ARTICULO */
        
    if (IVA = 'K') then /* IVA EN CTA CONSTANTE */
        BEGIN
        SELECT SUM(DVCD_IVAMONTO), SUM(cast(DVCD_CANT as double precision) * (DVCD_PRUNIT-DVCD_DTOMONTO)), SUM(DVCD_CONSUMO)
            FROM DEVOLUCIONES_COMPRAS_DET F
            WHERE F.DVCO_ID = :IDDOC 
            INTO :IMPTOS, :MONTO, :VALORADIC;
            
        if (IMPTOS <> 0) then
            BEGIN
            if (IMPINC = 'S') then
                BEGIN
                MONTO = MONTO - IMPTOS;
                if (FOMENTO <> 'SI') then
                    MONTO = MONTO - VALORADIC;
                END
            /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
            EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            /* DEPENDE DEL TIPO DE CUENTA */
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, (cast(DVCD_CANT as double precision) * (DVCD_PRUNIT-DVCD_DTOMONTO)), DVCD_IVAMONTO, TAIV_PORC, DVCD_CONSUMO
                    FROM ARTICULO A, DEVOLUCIONES_COMPRAS_DET F, TARIFA_IVA T
                    WHERE F.DVCO_ID = :IDDOC AND A.TAIV_COD = T.TAIV_COD
                    INTO :ARTICULO, :MONTO, :IMPTOS, :PORCIVA, :VALORADIC
                    DO
                    BEGIN
                    if (IMPTOS <> 0) then
                        BEGIN
                        if (IMPINC = 'S') then
                            BEGIN
                            MONTO = MONTO - IMPTOS;
                            if (FOMENTO <> 'SI') then
                                MONTO = MONTO - VALORADIC;
                            END
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CTAIVA, :CONCEPTO, '', 0, :IMPTOS, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                        NUMITEMS = NUMITEMS + 1;
                        SUMA = SUMA - IMPTOS;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                /* INSERTE EL REGISTRO DE LA BASE */
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CTAIVA, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
                NUMITEMS = NUMITEMS + 1;
                SUMA = SUMA - IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                /* INSERTE EL REGISTRO DE LA BASE */
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CTAIVA, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NUMITEMS = NUMITEMS + 1;
                SUMA = SUMA - IMPTOS;
                END
            END /* <> 0 */
        END /* IVA EN CTA CONSTANTE */
        
    /* EL IMPOCONSUMO */
    if (CONSUMO = 'A') then
        BEGIN
        /* SUME LAS BASES DE LOS ARTICULOS DEL DOCUMENTO */
        FOR SELECT MAX(COAR_CTACONS), SUM(DVCD_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_COMPRAS_DET F
            WHERE F.DVCO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTACONS
            INTO :CTACONSUMO, :IMPTOS
        DO
            BEGIN
            if (IMPTOS <> 0) then
                BEGIN
                /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
                EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (FOMENTO <> 'SI') then
                    BEGIN
                    /* DEPENDE DEL TIPO DE CUENTA */
                    if (TIPOCUEN = 'I') then
                        BEGIN
                        /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                        FOR SELECT F.ARTI_COD, DVCD_CONSUMO
                            FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_COMPRAS_DET F
                            WHERE F.DVCO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTACONS = :CUENTA
                            INTO :ARTICULO, :IMPTOS
                            DO
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                            NUMITEMS = NUMITEMS + 1;
                            SUMA = SUMA - IMPTOS;
                            END
                        END
                    if (TIPOCUEN = 'C') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
                        NUMITEMS = NUMITEMS + 1;
                        SUMA = SUMA - IMPTOS;
                        END
                    if (TIPOCUEN = 'N') then
                        BEGIN
                        /* INSERTE EL REGISTRO DE LA BASE */
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        NUMITEMS = NUMITEMS + 1;
                        SUMA = SUMA - IMPTOS;
                        END
                    END
                ELSE
                    BEGIN
                    if (TIPOCUEN = 'I') then
                        BEGIN
                        /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                        FOR SELECT F.ARTI_COD, DVCD_CONSUMO
                            FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_COMPRAS_DET F
                            WHERE F.DVCO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTACONS = :CUENTA
                            INTO :ARTICULO, :IMPTOS
                            DO
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                            NUMITEMS = NUMITEMS + 1;
                            SUMA = SUMA + IMPTOS;
                            END
                        END
                    if (TIPOCUEN = 'C') then
                        BEGIN
                        /* INSERTE EL REGISTRO DE LA BASE */
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
                        NUMITEMS = NUMITEMS + 1;
                        SUMA = SUMA + IMPTOS;
                        END
                    if (TIPOCUEN = 'N') then
                        BEGIN
                        /* INSERTE EL REGISTRO DE LA BASE */
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        NUMITEMS = NUMITEMS + 1;
                        SUMA = SUMA + IMPTOS;
                        END
                    END
                END
            END /* FOR */
        END /* CONSUMO X ARTICULO */
        
    if (CONSUMO = 'K') then /* CONSUMO EN CTA CONSTANTE */
        BEGIN
        SELECT SUM(DVCD_CONSUMO)
            FROM DEVOLUCIONES_COMPRAS_DET F
            WHERE F.DVCO_ID = :IDDOC 
            INTO :IMPTOS;
            
        if (IMPTOS <> 0) then
            BEGIN
            /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
            EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (FOMENTO <> 'SI') then
                BEGIN
                /* DEPENDE DEL TIPO DE CUENTA */
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, DVCD_CONSUMO
                        FROM ARTICULO A, DEVOLUCIONES_COMPRAS_DET F
                        WHERE F.DVCO_ID = :IDDOC
                        INTO :ARTICULO, :IMPTOS
                        DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                        NUMITEMS = NUMITEMS + 1;
                        SUMA = SUMA - IMPTOS;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    /* INSERTE EL REGISTRO DE LA BASE */
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
                    NUMITEMS = NUMITEMS + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    /* INSERTE EL REGISTRO DE LA BASE */
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                END
            ELSE
                BEGIN
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, DVCD_CONSUMO
                        FROM ARTICULO A, DEVOLUCIONES_COMPRAS_DET F
                        WHERE F.DVCO_ID = :IDDOC
                        INTO :ARTICULO, :IMPTOS
                        DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                        NUMITEMS = NUMITEMS + 1;
                        SUMA = SUMA + IMPTOS;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    /* INSERTE EL REGISTRO DE LA BASE */
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
                    NUMITEMS = NUMITEMS + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    /* INSERTE EL REGISTRO DE LA BASE */
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                END
            END
        END /* CONSUMO EN CTA CONSTANTE */
        
    /* DESCUENTO */
    if ((CTADTO IS NOT NULL) AND
        (CTADTO <> '') AND
        (VRDTO <> 0)) THEN
        BEGIN
        /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
        EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTADTO, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRDTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA + VRDTO;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            /* INSERTE EL REGISTRO DE LA BASE */
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRDTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA + VRDTO;
            END
        END /* DESCUENTO */
        
    /* VALOR ADIC */
    if ((CTAADIC IS NOT NULL) AND
        (CTAADIC <> '') AND
        (VRADIC <> 0)) THEN
        BEGIN
        /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
        EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTAADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRADIC, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA - VRADIC;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            /* INSERTE EL REGISTRO DE LA BASE */
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRADIC, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA - VRADIC;
            END
        END /* VR. ADIC */
        
    /* VALOR EXTRA */
    if ((CTAEXTRA IS NOT NULL) AND
        (CTAEXTRA <> '') AND
        (VREXTRA <> 0)) THEN
        BEGIN
        /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
        EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTAEXTRA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VREXTRA, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA + VREXTRA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            /* INSERTE EL REGISTRO DE LA BASE */
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VREXTRA, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA + VREXTRA;
            END
        END /* VR. EXTRA */
        
    if (fomento <> 'SI') then
        BEGIN
        /* DESCUENTE EL IMPOCONSUMO */
        SELECT SUM(DVCD_CONSUMO)
            FROM devoluciones_compras_det WHERE DVCO_ID = :IDDOC INTO :IMPTOS;
        if (IMPTOS IS NULL) then
            IMPTOS = 0;
        vrsubt = vrsubt - IMPTOS;
        END
    /* RETENCION FUENTE */
    if ((RTFTE = 'P') or (RTFTE = 'K')) then
      if (VRRTFTE <> 0) then
        BEGIN
        if (RTFTE = 'P') then
            CTARTFTE = TCTARTFTE;
            
        /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
        EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA + VRRTFTE;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            /* INSERTE EL REGISTRO DE LA BASE */
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA + VRRTFTE;
            END
        END /* RTFTE */
    if (RTFTE = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTARTFTE), MAX(COAR_RTFTE), SUM(DVCD_TOTAL-DVCD_IVAMONTO-DVCD_CONSUMO), SUM((DVCD_TOTAL-DVCD_IVAMONTO-DVCD_CONSUMO)*COAR_RTFTE)
            FROM CONTABIL_ARTICULO C, DEVOLUCIONES_COMPRAS_DET F
            WHERE F.dvco_id = :IDDOC AND F.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTARTFTE
            INTO :CTARTFTE, :PRTFTE, :MONTO, :VRRTFTE
            DO
            BEGIN
            MONTO = MONTO * FACTOR;
            VRRTFTE = VRRTFTE * FACTOR / 100;
            execute procedure redondee(VRRTFTE, DIG) returning_values (VRRTFTE);
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (VRRTFTE <> 0) then
                BEGIN
                /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
                EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
                    NUMITEMS = NUMITEMS + 1;
                    SUMA = SUMA + VRRTFTE;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    /* INSERTE EL REGISTRO DE LA BASE */
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    SUMA = SUMA + VRRTFTE;
                    END
                END
            END
        END /* RTFTE */
    /* RETENCION IVA */
    if ((RTIVA = 'P') or (RTIVA = 'K')) then
      if (VRRTIVA <> 0) then
        BEGIN
        if (RTIVA = 'P') then
            CTARTIVA = TCTARTIVA;
            
        /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
        EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTARTIVA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRRTIVA, 0, :VRIVA, :PORC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA + VRRTIVA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            /* INSERTE EL REGISTRO DE LA BASE */
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRRTIVA, 0, :VRIVA, :PORC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA + VRRTIVA;
            END
        END /* RTIVA */
        
    /* RETENCION DE ICA */
    if ((RTICA = 'P') or (RTICA = 'K')) then
      if (VRRTICA <> 0) then
        BEGIN
        if (RTICA = 'P') then
            CTARTICA = TCTARTICA;
            
        /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
        EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTARTICA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRRTICA, 0, :VRSUBT, :PRTICA, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA + VRRTICA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            /* INSERTE EL REGISTRO DE LA BASE */
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRRTICA, 0, :VRSUBT, :PRTICA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA + VRRTICA;
            END
        END /* RTICA */
    if (RTICA = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTARTICA), MAX(COAR_RTICA), SUM(DVCD_TOTAL-DVCD_IVAMONTO-DVCD_CONSUMO), SUM((DVCD_TOTAL-DVCD_IVAMONTO-DVCD_CONSUMO)*COAR_RTICA)
            FROM CONTABIL_ARTICULO C, DEVOLUCIONES_COMPRAS_DET F
            WHERE F.dvco_id = :IDDOC AND F.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTARTICA
            INTO :CTARTICA, :PRTICA, :MONTO, :VRRTICA
            DO
            BEGIN
            MONTO = MONTO * FACTOR;
            VRRTICA = VRRTICA * FACTOR / 100;
            execute procedure redondee(VRRTICA, DIG) returning_values (VRRTICA);
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (VRRTICA <> 0) then
                BEGIN
                /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
                EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTARTICA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRRTICA, 0, :VRSUBT, :PRTICA, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
                    NUMITEMS = NUMITEMS + 1;
                    SUMA = SUMA + VRRTICA;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    /* INSERTE EL REGISTRO DE LA BASE */
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRRTICA, 0, :VRSUBT, :PRTICA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    SUMA = SUMA + VRRTICA;
                    END
                END
            END
        END /* RTICA A */
        
    /* recorra las cuentas adicionales */
    FOR SELECT INCC_CUENTA, INCC_BASE, INCC_PORC, INCC_VALOR, INCC_DB
        FROM INTERFAZ_COMPRAS_CTAS
        WHERE INCO_ID = :IDINTER
        INTO :CUENTAADIC, :BASEADIC, :PORCADIC, :VALORADIC, :DBADIC
        DO
        BEGIN
        if (VALORADIC <> 0) then
            MONTO = VALORADIC;
        ELSE
            BEGIN
            if (:BASEADIC = 'SUBTOTAL') then
                VALORADIC = VRTOTAL - VREXTRA - VRIVA - VRADIC + VRDTO;
            if (:BASEADIC = 'DESCUENTO') then
                VALORADIC = VRDTO;
            if (:BASEADIC = 'IVA') then
                VALORADIC = VRIVA;
            if (:BASEADIC = 'CONSUMO') then
                SELECT SUM(DVCD_CONSUMO)
                    FROM DEVOLUCIONES_COMPRAS_DET F
                    WHERE F.DVCO_ID = :IDDOC 
                    INTO :VALORADIC;
            if (:BASEADIC = 'ADICIONAL') then
                VALORADIC = VRADIC;
            if (:BASEADIC = 'EXTRA') then
                VALORADIC = VREXTRA;
            if (:BASEADIC = 'TOTAL') then
                VALORADIC = VRTOTAL;
            MONTO = VALORADIC * PORCADIC;
            END
        if (MONTO <> 0) then
            BEGIN
            /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
            EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CUENTAADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                if (DBADIC = 'S') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTAADIC, :CONCEPTO, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
                    SUMA = SUMA + MONTO;
                    END
                ELSE
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTAADIC, :CONCEPTO, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
                    SUMA = SUMA - MONTO;
                    END
                NUMITEMS = NUMITEMS + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                if (DBADIC = 'S') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTAADIC, :CONCEPTO, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    SUMA = SUMA + MONTO;
                    END
                ELSE
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTAADIC, :CONCEPTO, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    SUMA = SUMA - MONTO;
                    END
                NUMITEMS = NUMITEMS + 1;
                END
            NUMITEMS = NUMITEMS + 1;
            END
        END
    /* CIERRE EL COMPROBANTE CONTRA LA CUENTA DEL TERCERO O LA CONSTANTE */
    if ((SUMA <> 0) and ((CXP = 'P') or (CXP = 'K'))) then
        BEGIN
        if (SUMA < 0) then
            BEGIN
            DEBITO = SUMA * -1;
            CREDITO = 0;
            END
        ELSE
            BEGIN
            DEBITO = 0;
            CREDITO = SUMA;
            END
        if (CXP = 'P') then
            CTACXP = TCTAPROV;

        /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
        EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTACXP, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
        if (TIPOCUEN = 'N') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
        END /* SUMA EN CXP */
     end
    if (ERROR > 0) then
        VER = 'S';
    SUSPEND;
    END /* EXISTE */
ELSE
    BEGIN
    EXECUTE PROCEDURE ERROR (24, :IDDOC, :PREFIJO, 1);
    ERROR = ERROR + 1;
    VER = 'S';
    SUSPEND;
    END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE DEVCOMPRA_SIN_CONTABILIDAD(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDI INTEGER,
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable FECICNT VARCHAR(10);
declare variable FECFCNT VARCHAR(10);
declare variable ERROR INTEGER;
declare variable idref INTEGER;
BEGIN /*$$IBE$$ 
EXECUTE PROCEDURE fecha_a_conta(FECINI) returning_values (FECICNT);
EXECUTE PROCEDURE fecha_a_conta(FECFIN) returning_values (FECFCNT);
FOR SELECT DVCO_ID, PREF_PRE, DVCO_NUMERO FROM DEVOLUCIONES_COMPRAS WHERE DVCO_ANULADO = 'N' AND
    DVCO_FECHA >= :FECINI AND DVCO_FECHA <= :FECFIN
    INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  idref = null;
  SELECT ENCO_IDREF FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 24 AND ENCO_FECHA >= :FECICNT AND ENCO_FECHA <= :FECFCNT and ENCO_IDREF = :id into :idref;
  if (idref IS NULL) then
  begin
   ESTADO = 'PROCESANDO';
   SUSPEND;
   SELECT MAX(INCO_ID) FROM INTERFAZ_COMPRAS WHERE PREF_PRE = :PREF AND TIDO_COD = 24 INTO :IDI;
   EXECUTE PROCEDURE CONTABIL_DEVOLCOMP (:ID, :IDI) RETURNING_VALUES (:ERROR, :VER, :IDC);
   if (ERROR = 0) then
    BEGIN
      EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC);
      ESTADO = 'OK';
    end
   ELSE
    ESTADO = 'ERROR';
   suspend;
  End
  END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE DEVCOMPRA_SIN_CONTABILIDAD(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDI INTEGER,
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable FECICNT VARCHAR(10);
declare variable FECFCNT VARCHAR(10);
declare variable ERROR INTEGER;
declare variable idref INTEGER;
BEGIN
EXECUTE PROCEDURE fecha_a_conta(FECINI) returning_values (FECICNT);
EXECUTE PROCEDURE fecha_a_conta(FECFIN) returning_values (FECFCNT);
FOR SELECT DVCO_ID, PREF_PRE, DVCO_NUMERO FROM DEVOLUCIONES_COMPRAS WHERE DVCO_ANULADO = 'N' AND
    DVCO_FECHA >= :FECINI AND DVCO_FECHA <= :FECFIN
    INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  idref = null;
  SELECT ENCO_IDREF FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 24 AND ENCO_FECHA >= :FECICNT AND ENCO_FECHA <= :FECFCNT and ENCO_IDREF = :id into :idref;
  if (idref IS NULL) then
  begin
   ESTADO = 'PROCESANDO';
   SUSPEND;
   SELECT MAX(INCO_ID) FROM INTERFAZ_COMPRAS WHERE PREF_PRE = :PREF AND TIDO_COD = 24 INTO :IDI;
   EXECUTE PROCEDURE CONTABIL_DEVOLCOMP (:ID, :IDI) RETURNING_VALUES (:ERROR, :VER, :IDC);
   if (ERROR = 0) then
    BEGIN
      EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC);
      ESTADO = 'OK';
    end
   ELSE
    ESTADO = 'ERROR';
   suspend;
  End
  END
END

^

SET TERM ; ^


/* busqueda remisiones y cruces de documentos */
SET TERM ^ ;

CREATE OR ALTER procedure BUSQUEDA_REMISIONES (
    SUBEMPRESA INTEGER)
returns (
    REVT_ID INTEGER,
    PREF_PRE VARCHAR(4),
    REVT_NUMERO VARCHAR(6),
    REVT_FECHA DATE,
    REVT_NOMTERC VARCHAR(60),
    REVT_TOTAL NUMERIC(18,2),
    REVT_IVAMONTO NUMERIC(18,2),
    VEND_COD INTEGER,
    REVT_ANULADO CHAR(1),
    USADO CHAR(1))
as
declare variable numrows integer;
begin
for select revt_id, p.pref_pre, revt_numero, revt_fecha, revt_nomterc, revt_total, revt_ivamonto, vend_cod, revt_anulado
    from remisiones_venta r,prefijos p where r.pref_pre= p.pref_pre and p.tido_cod = 32 and ((p.sucu_id= :SUBEMPRESA) or (:subempresa = 0))
    INTO revt_id, pref_pre, revt_numero, revt_fecha, revt_nomterc, revt_total, revt_ivamonto, vend_cod, revt_anulado
    DO
    BEGIN
    select count(cofa_id) from consolidado_faltantes where cofa_ok = 'S' and cofa_tipoori = 32 and cofa_idori = :revt_id into :numrows;
    if (numrows > 1) then
        usado = 'S';
    else
        begin
        select count(devt_id) from devoluciones_ventas where devt_remid = :revt_id and devt_anulado = 'N' into numrows;
        if (numrows > 1) then
            usado = 'S';
        else
            usado = 'N';
        end
    suspend;
    END
end
^

SET TERM ; ^


SET TERM ^ ;

CREATE OR ALTER PROCEDURE CRUCES_DOCUMENTOS(
    TIPOORI INTEGER,
    IDORI INTEGER)
RETURNS (
    TIPODES INTEGER,
    ID INTEGER,
    NOMTIPO VARCHAR(8),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE)
AS
declare variable IDC INTEGER;
begin
FOR SELECT DISTINCT COFA_TIPODES, COFA_ID FROM CONSOLIDADO_FALTANTES
    WHERE COFA_TIPOORI = :TIPOORI AND COFA_IDORI = :IDORI AND COFA_OK = 'S' INTO :TIPODES, :IDC
    DO
    BEGIN
    SELECT TIDO_NOMCORTO FROM tipo_documento WHERE TIDO_COD = :tipodes INTO :nomtipo;
    if (TIPODES = 21) then
        SELECT FACO_ID, PREF_PRE, FACO_NUMERO, FACO_FECHA FROM FACTURAS_COMPRA WHERE FACO_CONSOLIDA = :IDC AND FACO_ANULADO = 'N' INTO :ID, :PREFIJO, :NUMERO, :FECHA;
    if (TIPODES = 22) then
        SELECT REPR_ID, PREF_PRE, REPR_NUMERO, REPR_FECHA FROM remision_proveedor WHERE REPR_CONSOLIDA = :IDC AND REPR_ANULADO = 'N' INTO :ID, :PREFIJO, :NUMERO, :FECHA;
    if (TIPODES = 23) then
        SELECT ORDC_ID, PREF_PRE, ORDC_NUMERO, ORDC_FECHA FROM ORDENES_COMPRA WHERE ORDC_CONSOLIDA = :IDC AND ORDC_ANULADO = 'N' INTO :ID, :PREFIJO, :NUMERO, :FECHA;
    if (TIPODES = 31) then
        SELECT FACT_ID, PREF_PRE, FACT_NUMERO, FACT_FECHA FROM FACTURAS WHERE FACT_CONSOLIDA = :IDC AND FACT_ANULADO = 'N' INTO :ID, :PREFIJO, :NUMERO, :FECHA;
    if (TIPODES = 32) then
        SELECT REVT_ID, PREF_PRE, REVT_NUMERO, REVT_FECHA FROM remisiones_venta WHERE REVT_CONSOLIDA = :IDC AND REVT_ANULADO = 'N' INTO :ID, :PREFIJO, :NUMERO, :FECHA;
    if (TIPODES = 34) then
        SELECT PEDI_ID, PREF_PRE, PEDI_NUMERO, PEDI_FECHA FROM PEDIDOS WHERE PEDI_CONSOLIDA = :IDC AND PEDI_ANULADO = 'N' INTO :ID, :PREFIJO, :NUMERO, :FECHA;
    suspend;
    END
tipodes = 33;
SELECT TIDO_NOMCORTO FROM tipo_documento WHERE TIDO_COD = :tipodes INTO :nomtipo;

if (tipoori = 31) then
    for select devt_id, pref_pre, devt_numero, devt_fecha from devoluciones_ventas where devt_factid = :idori and devt_anulado = 'N'
        into :ID, :PREFIJO, :NUMERO, :FECHA
        do
        suspend;
if (tipoori = 32) then
    for select devt_id, pref_pre, devt_numero, devt_fecha from devoluciones_ventas where devt_remid = :idori and devt_anulado = 'N'
        into :ID, :PREFIJO, :NUMERO, :FECHA
        do
        suspend;
end
^

SET TERM ; ^


/* devolucviones sobre remisiones */
SET TERM ^ ;

ALTER TRIGGER DEVOLUCIONES_VENTAS_DETALLE_AI
ACTIVE AFTER INSERT POSITION 0
AS
declare variable fec date;
declare variable CONC VARCHAR(60);
declare variable factor numeric(18,4);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Nit varchar(20);
declare variable ID INTEGER;
declare variable ITEM INTEGER;
declare variable DEVUELTO NUMERIC(18,4);
declare variable CANT NUMERIC(18, 4);
declare variable CANTAUX NUMERIC(18, 4);
declare variable FACT VARCHAR(10);
declare variable COSTO NUMERIC(18,2);
declare variable devnof CHAR(2);
declare variable numrows INTEGER;
declare variable OK CHAR(1);
declare variable PEDAUTO CHAR(2);
declare variable IDPED INTEGER;
declare variable IDREM INTEGER;
declare variable devrem CHAR(2);
BEGIN
execute procedure lee_configuracion ('FACTURACION', 'DEVOLUCIONES', 'HACER DEVOLUCIONES SOBRE REMISIONES') returning_values (:devrem);
if ((NEW.devt_id <> 0) and (new.dvde_anulado = 'N')) then
    BEGIN
    ID = 0;
    select devt_fecha, pref_pre, devt_numero, terc_nit, devt_factura, devt_remid, DEVT_FACTID 
        from devoluciones_ventas where devt_id = new.devt_id into :fec, :Pref, :Num, :Nit, :Fact, :idrem, :ID;
    execute procedure factor_unidad_cant(new.arti_cod, new.dvde_unidad) returning_values(factor);
    CONC = 'DEVOLUCION VENTA No.' || PREF || NUM || ' - FACTURA ' || FACT;
    /* si la factura afecto el inventario, afectelo */
    execute procedure lee_configuracion ('FACTURACION', 'DEVOLUCIONES', 'PERMITIR DEVOLVER ITEMS NO FACTURADOS') returning_values (:devnof);
    if (devnof = 'SI') then
        OK = 'S';
    else
        BEGIN
        if (id <> 0) then
            begin
            /* verifique si afecto el inventario */
            select count(mvar_cons) from movimiento_articulo where mvar_tipodoc = 31 and mvar_idref = :id and arti_cod = new.arti_cod into :numrows;
            if (numrows > 0) then
                OK = 'S';
            else
                BEGIN
                /* busque remisiones que pudieron afectarlo */
                select sum(cofa_cant * cofa_factor) from consolidado_faltantes where cofa_tipoori = 32 and cofa_iddes = :id and cofa_tipodes = 31 and arti_cod = new.arti_cod and cofa_ok = 'S' into :cantaux;
                if (cantaux <> 0) then
                    OK = 'S';
                else
                    BEGIN
                    EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','FACTURAS','GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') RETURNING_VALUES (PEDAUTO);
                    if (PEDAUTO = 'SI') then
                        BEGIN
                        SELECT PEDI_ID FROM PEDIDOS P, FACTURAS F WHERE P.PREF_PRE = F.pref_pre AND P.pedi_numero = F.fact_numero AND F.fact_id = :id INTO :IDped;
                        select sum(cofa_cant * cofa_factor) from consolidado_faltantes where cofa_tipoori = 34 and cofa_idori = :idped and cofa_tipodes = 32 and arti_cod = new.arti_cod and cofa_ok = 'S' into :cantaux;
                        if (cantaux <> 0) then
                            OK = 'S';
                        else
                            OK = 'N';
                        END
                    ELSE
                        OK = 'N';
                    END
                END
            end
        else
          if ((idrem <> 0) and (devrem = 'SI')) then
            begin
            /* verifique si afecto el inventario */
            select count(mvar_cons) from movimiento_articulo where mvar_tipodoc = 32 and mvar_idref = :idrem and arti_cod = new.arti_cod into :numrows;
            if (numrows > 0) then
                OK = 'S';
            else
                OK = 'N';
            end
        END
    if (OK = 'S') then
        begin
        /* calcule el costo al que salio o el promedio */
        execute procedure costo_promedio(new.arti_cod, :FEC) returning_values (:COSTO);
        INSERT INTO MOVIMIENTO_ARTICULO
            (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF,
            MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
            VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 33, NEW.devt_id,
            :CONC, :factor * new.dvde_cant, :COSTO, 'S', new.dvde_lote, :Pref, :Num, new.dvde_item, :Nit);
        end
    /* ACTUALICE LO DEVUELTO EN LA FACTURA */
    if (ID <> 0) then
        BEGIN
        CANTAUX = NEW.dvde_cant * NEW.dvde_factor;
        FOR SELECT FADE_ITEM, FADE_CANT, FADE_FACTOR, FADE_DEVUELTO
            FROM FACTURAS_DETALLE
            WHERE FACT_ID = :ID AND ARTI_COD = NEW.ARTI_COD
            INTO :ITEM, :CANT, :FACTOR, :DEVUELTO
            DO
                BEGIN
                if (CANTAUX > 0) then
                    if ((CANT * FACTOR - DEVUELTO) < CANTAUX) then
                      BEGIN
                      UPDATE FACTURAS_DETALLE
                        SET FADE_DEVUELTO = (:CANT * :FACTOR)
                        WHERE FACT_ID = :ID AND FADE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                      CANTAUX = CANTAUX - (CANT * FACTOR - DEVUELTO);
                      END
                    ELSE
                      BEGIN
                      UPDATE FACTURAS_DETALLE
                        SET FADE_DEVUELTO = FADE_DEVUELTO + :CANTAUX
                        WHERE FACT_ID = :ID AND FADE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                      CANTAUX = 0;
                      END
                END
        if (CANTAUX > 0) then
            EXCEPTION DEVOLUCION_MAYOR 'Esta devolviendo una cantidad mayor a la facturada del articulo ' || new.arti_cod;
        END
    if ((idrem <> 0) and (devrem = 'SI')) then
        BEGIN
        CANTAUX = NEW.dvde_cant * NEW.dvde_factor;
        FOR SELECT RVDE_ITEM, RVDE_CANT, RVDE_FACTOR, RVDE_DEVUELTO
            FROM remisiones_venta_detalle
            WHERE REVT_ID = :idrem AND ARTI_COD = NEW.ARTI_COD
            INTO :ITEM, :CANT, :FACTOR, :DEVUELTO
            DO
                BEGIN
                if (CANTAUX > 0) then
                    if ((CANT * FACTOR - DEVUELTO) < CANTAUX) then
                      BEGIN
                      UPDATE remisiones_venta_detalle
                        SET RVDE_DEVUELTO = (:CANT * :FACTOR)
                        WHERE REVT_ID = :IDREM AND RVDE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                      CANTAUX = CANTAUX - (CANT * FACTOR - DEVUELTO);
                      END
                    ELSE
                      BEGIN
                      UPDATE remisiones_venta_detalle
                        SET RVDE_DEVUELTO = RVDE_DEVUELTO + :CANTAUX
                        WHERE REVT_ID = :IDREM AND RVDE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                      CANTAUX = 0;
                      END
                END
        if (CANTAUX > 0) then
            EXCEPTION DEVOLUCION_MAYOR 'Esta devolviendo una cantidad mayor a la remisionada del articulo ' || new.arti_cod;
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE PROCEDURE RECALCULO_DEV_REMISION
as
declare variable ID INTEGER;
declare variable IDREM INTEGER;
declare variable ART VARCHAR(20);
declare variable ITEM INTEGER;
declare variable DEVUELTO NUMERIC(18,4);
declare variable CANT NUMERIC(18, 4);
declare variable CANTAUX NUMERIC(18, 4);
declare variable factor numeric(18,4);
begin
UPDATE REMISIONES_VENTA_DETALLE SET RVDE_DEVUELTO = 0 WHERE RVDE_DEVUELTO <> 0;
FOR SELECT V.DEVT_ID, DEVT_REMID, ARTI_COD, dvde_cant * dvde_factor
    FROM devoluciones_ventas V, devoluciones_ventas_detalle D
    WHERE V.devt_id = D.devt_id AND DEVT_REMID <> 0
    ORDER BY DEVT_FECHA, V.DEVT_ID
    INTO :ID, :IDREM, :ART, :CANTAUX
    DO
    BEGIN
    FOR SELECT RVDE_ITEM, RVDE_CANT, RVDE_FACTOR, RVDE_DEVUELTO
        FROM remisiones_venta_detalle
        WHERE REVT_ID = :idrem AND ARTI_COD = :ART
        INTO :ITEM, :CANT, :FACTOR, :DEVUELTO
        DO
        BEGIN
        if (CANTAUX > 0) then
            if ((CANT * FACTOR - DEVUELTO) < CANTAUX) then
                BEGIN
                UPDATE remisiones_venta_detalle
                    SET RVDE_DEVUELTO = (:CANT * :FACTOR)
                    WHERE REVT_ID = :IDREM AND RVDE_ITEM = :ITEM AND ARTI_COD = :ART;
                CANTAUX = CANTAUX - (CANT * FACTOR - DEVUELTO);
                END
            ELSE
                BEGIN
                UPDATE remisiones_venta_detalle
                    SET RVDE_DEVUELTO = RVDE_DEVUELTO + :CANTAUX
                    WHERE REVT_ID = :IDREM AND RVDE_ITEM = :ITEM AND ARTI_COD = :ART;
                CANTAUX = 0;
                END
        END
    END
end
^

SET TERM ; ^



/* previsualizacion por mdulo*/

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('FACTURACION', 'GENERAL', 'PREVISUALIZAR IMPRESION DE DOCUMENTOS', 'NO', 'SI,NO', 'SI:Al imprimir cualquier documento aparece la opcin preguntando el destino. NO:Imprime directamente a la impresora predeterminada.');
INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('COMPRAS', 'GENERAL', 'PREVISUALIZAR IMPRESION DE DOCUMENTOS', 'NO', 'SI,NO', 'SI:Al imprimir cualquier documento aparece la opcin preguntando el destino. NO:Imprime directamente a la impresora predeterminada.');
INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('INVENTARIO', 'GENERAL', 'PREVISUALIZAR IMPRESION DE DOCUMENTOS', 'NO', 'SI,NO', 'SI:Al imprimir cualquier documento aparece la opcin preguntando el destino. NO:Imprime directamente a la impresora predeterminada.');
INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('CARTERA', 'GENERAL', 'PREVISUALIZAR IMPRESION DE DOCUMENTOS', 'NO', 'SI,NO', 'SI:Al imprimir cualquier documento aparece la opcin preguntando el destino. NO:Imprime directamente a la impresora predeterminada.');
INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('CXPAGAR', 'GENERAL', 'PREVISUALIZAR IMPRESION DE DOCUMENTOS', 'NO', 'SI,NO', 'SI:Al imprimir cualquier documento aparece la opcin preguntando el destino. NO:Imprime directamente a la impresora predeterminada.');
INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('BANCOS', 'GENERAL', 'PREVISUALIZAR IMPRESION DE DOCUMENTOS', 'NO', 'SI,NO', 'SI:Al imprimir cualquier documento aparece la opcin preguntando el destino. NO:Imprime directamente a la impresora predeterminada.');
INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('CAJA', 'GENERAL', 'PREVISUALIZAR IMPRESION DE DOCUMENTOS', 'NO', 'SI,NO', 'SI:Al imprimir cualquier documento aparece la opcin preguntando el destino. NO:Imprime directamente a la impresora predeterminada.');

DELETE FROM CONFIGURACION WHERE (CONF_MODULO = 'GENERAL') AND (CONF_CATEGORIA = 'GENERAL') AND (CONF_PROPIEDAD = 'PREVISUALIZAR IMPRESION DE DOCUMENTOS');
COMMIT WORK;

/* mover formato */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE MOVER_FORMATO(
    TIPO INTEGER,
    PREFI VARCHAR(4),
    POSICIONES INTEGER,
    DESDE INTEGER,
    HASTA INTEGER,
    ACCION CHAR(1))
AS
begin
    if (accion = 'R') THEN
    begin
    UPDATE FORMATO_DATOS SET DAFO_POSX = DAFO_POSX + :posiciones WHERE TIDO_COD = :tipo AND PREF_PRE = :prefi AND DAFO_POSX >= :DESDE AND DAFO_POSX <= :HASTA;
    UPDATE FORMATO_LINEAS SET FOLI_POSX = FOLI_POSX + :posiciones WHERE TIDO_COD = :tipo AND PREF_PRE = :prefi AND FOLI_POSX >= :DESDE AND FOLI_POSX <= :HASTA;
    end

    if (accion = 'L') THEN
    begin
    UPDATE FORMATO_DATOS SET DAFO_POSX = DAFO_POSX - :posiciones WHERE TIDO_COD = :tipo AND PREF_PRE = :prefi AND DAFO_POSX >= :DESDE AND DAFO_POSX <= :HASTA;
    UPDATE FORMATO_LINEAS SET FOLI_POSX = FOLI_POSX - :posiciones WHERE TIDO_COD = :tipo AND PREF_PRE = :prefi AND FOLI_POSX >= :DESDE AND FOLI_POSX <= :HASTA;
    end

    if (accion = 'U') THEN
    begin
    UPDATE FORMATO_DATOS SET DAFO_POSY = DAFO_POSY - :posiciones WHERE TIDO_COD = :tipo AND PREF_PRE = :prefi AND DAFO_POSY >= :DESDE AND DAFO_POSY <= :HASTA;
    UPDATE FORMATO_LINEAS SET FOLI_POSY = FOLI_POSY - :posiciones WHERE TIDO_COD = :tipo AND PREF_PRE = :prefi AND FOLI_POSY >= :DESDE AND FOLI_POSY <= :HASTA;
    end

    if (accion = 'D') THEN
    begin
    UPDATE FORMATO_DATOS SET DAFO_POSY = DAFO_POSY + :posiciones WHERE TIDO_COD = :tipo AND PREF_PRE = :prefi AND DAFO_POSY >= :DESDE AND DAFO_POSY <= :HASTA;
    UPDATE FORMATO_LINEAS SET FOLI_POSY = FOLI_POSY + :posiciones WHERE TIDO_COD = :tipo AND PREF_PRE = :prefi AND FOLI_POSY >= :DESDE AND FOLI_POSY <= :HASTA;
    end

    if (accion = 'C') THEN
    begin
    UPDATE FORMATO_DATOS SET DAFO_POSY = DAFO_POSY *2 WHERE TIDO_COD = :tipo AND PREF_PRE = :prefi AND DAFO_POSY >= :DESDE AND DAFO_POSY <= :HASTA;
    UPDATE FORMATO_LINEAS SET FOLI_POSY = FOLI_POSY *2 WHERE TIDO_COD = :tipo AND PREF_PRE = :prefi AND FOLI_POSY >= :DESDE AND FOLI_POSY <= :HASTA;
    end

    if (accion = 'X') THEN
    begin
    UPDATE FORMATO_DATOS SET DAFO_POSX = DAFO_POSX *2 WHERE TIDO_COD = :tipo AND PREF_PRE = :prefi AND DAFO_POSX >= :DESDE AND DAFO_POSX <= :HASTA;
    UPDATE FORMATO_LINEAS SET FOLI_POSX = FOLI_POSX *2 WHERE TIDO_COD = :tipo AND PREF_PRE = :prefi AND FOLI_POSX >= :DESDE AND FOLI_POSX <= :HASTA;
    end

    if (accion = 'M') THEN
    begin
    UPDATE FORMATO_DATOS SET DAFO_POSY = DAFO_POSY /2 WHERE TIDO_COD = :tipo AND PREF_PRE = :prefi AND DAFO_POSY >= :DESDE AND DAFO_POSY <= :HASTA;
    UPDATE FORMATO_LINEAS SET FOLI_POSY = FOLI_POSY /2 WHERE TIDO_COD = :tipo AND PREF_PRE = :prefi AND FOLI_POSY >= :DESDE AND FOLI_POSY <= :HASTA;
    end

    if (accion = 'Y') THEN
    begin
    UPDATE FORMATO_DATOS SET DAFO_POSX = DAFO_POSX /2 WHERE TIDO_COD = :tipo AND PREF_PRE = :prefi AND DAFO_POSX >= :DESDE AND DAFO_POSX <= :HASTA;
    UPDATE FORMATO_LINEAS SET FOLI_POSX = FOLI_POSX /2 WHERE TIDO_COD = :tipo AND PREF_PRE = :prefi AND FOLI_POSX >= :DESDE AND FOLI_POSX <= :HASTA;
    end
end
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE IMPR_EGRESO(
    ID INTEGER)
RETURNS (
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    DIR VARCHAR(60),
    CIU VARCHAR(40),
    TEL VARCHAR(40),
    CONCEPTO VARCHAR(60),
    MONTO NUMERIC(18,2),
    RTFTE NUMERIC(18,2),
    RTIVA NUMERIC(18,2),
    RTICA NUMERIC(18,2),
    DSCTO NUMERIC(18,2),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEMDOC INTEGER,
    TIPODOC VARCHAR(8),
    PREFDOC VARCHAR(4),
    NUMDOC VARCHAR(6),
    NUMPRV VARCHAR(10),
    ABONODOC NUMERIC(18,2),
    RTFTEDOC NUMERIC(18,2),
    RTIVADOC NUMERIC(18,2),
    RTICADOC NUMERIC(18,2),
    DSCTODOC NUMERIC(18,2),
    SALDODOC NUMERIC(18,2),
    SALDOPROV NUMERIC(18,2),
    ANTERDOC NUMERIC(18,2))
AS
declare variable NUMROWS INTEGER;
declare variable TIPO integer;
declare variable IDDOC INTEGER;
BEGIN
  SELECT PREF_PRE, EGRE_NUMERO, EGRE_FECHA, EGRE_CONC,
        E.TERC_NIT, EGRE_NOMTERC, TERC_DIR, TERC_CIU, TERC_TEL,
        EGRE_MONTO, EGRE_RTFTEMONTO, EGRE_RTIVAMONTO, EGRE_RTICAMONTO, EGRE_DTOF,
        EGRE_OBS
    FROM EGRESOS E, TERCEROS T
    WHERE E.TERC_NIT = T.TERC_NIT AND E.EGRE_ID = :ID
    INTO :PREFIJO, :NUMERO, :FECHA, :CONCEPTO, 
        :NIT, :NOMBRE, :DIR, :CIU, :TEL,
        :MONTO, :RTFTE, :RTIVA, :RTICA, :DSCTO,
        :OBS;
  select SALDO from saldo_proveedor(:NIT, :FECHA+1) into :SALDOPROV;
  /*EXECUTE PROCEDURE saldo_proveedor(:NIT, (CAST('FECHA'+1 AS DATE))) returning_values (:SALDOPROV);*/
  SELECT COUNT(EGDE_ITEM) FROM EGRESOS_DETALLE
    WHERE EGRE_ID = :ID INTO :NUMROWS;
  if (NUMROWS > 0) then
    FOR SELECT EGDE_ITEM, EGDE_TIPODOC, TIDO_NOMCORTO, EGDE_IDDOC, EGDE_PREFIJO, EGDE_NUMERO, EGDE_ABONO, EGDE_RTFTE, EGDE_RTIVA, EGDE_RTICA, EGDE_DTOF
        FROM EGRESOS_DETALLE ED, TIPO_DOCUMENTO TD
        WHERE TD.TIDO_COD = ED.EGDE_TIPODOC AND ED.EGRE_ID = :ID
        order by egde_item
        INTO :ITEMDOC, :TIPO, :TIPODOC, :IDDOC, :PREFDOC, :NUMDOC, :ABONODOC, :RTFTEDOC, :RTIVADOC, :RTICADOC, :DSCTODOC
        DO
            BEGIN
            if (TIPO = 21) then
                SELECT FACO_NUMPROV FROM FACTURAS_COMPRA WHERE FACO_ID = :iddoc INTO :numprv;
            ELSE
                if (TIPO = 51) then
                    SELECT NDPR_NUMPROV FROM NOTAS_DEBITO_PROVEEDOR WHERE NDPR_ID = :iddoc INTO :numprv;
                ELSE
                    numprv = numdoc;
            EXECUTE PROCEDURE saldo_doc_cxpagar(:TIPO, :IDDOC, :FECHA) returning_values (:SALDODOC);
            ANTERDOC = SALDODOC + RTFTEDOC + RTIVADOC + RTICADOC + ABONODOC + DSCTODOC;
            SUSPEND;
            END
  else
    BEGIN
    SALDOPROV = 0;
    ANTERDOC = 0;
    SALDODOC = 0;
    RTFTEDOC = 0;
    RTIVADOC = 0;
    RTICADOC = 0;
    ABONODOC = 0;
    DSCTODOC = 0;
    numprv = '';
    SUSPEND;
    END
END
^

SET TERM ; ^


/* configuracion del tamao del paquete de datos */

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('GENERAL', 'GENERAL', 'NUMERO DE REGISTROS A TRANSMITIR SIMULTANEAMENTE', '500', '100,250,500,1000,2000', 'Indique el tamao del paquete de registros que se transmiten entre el servidor y las terminales');
commit work;

/* inactivar terceros */
ALTER TABLE TERCEROS
ADD TERC_ESTADO CHAR(1);

SET TERM ^ ;

CREATE OR ALTER TRIGGER TERCEROS_BI FOR TERCEROS
ACTIVE BEFORE INSERT POSITION 0
as
begin
if (NEW.terc_tipoid IS NULL) then
    NEW.terc_tipoid = 'J';
if (NEW.terc_clie IS NULL) then
    NEW.terc_clie = 'N';
if (NEW.terc_prov IS NULL) then
    NEW.terc_prov = 'N';
if (NEW.terc_empl IS NULL) then
    NEW.terc_empl = 'N';
if (NEW.terc_estado IS NULL) then
    NEW.terc_estado = 'S';
SELECT SUBSTR(CIUD_NOM,1,40) FROM CIUDADES WHERE CIUD_COD = NEW.ciud_cod INTO NEW.terc_ciu;
end
^

SET TERM ; ^


UPDATE TERCEROS SET TERC_ESTADO = 'S';
COMMIT WORK;

SET TERM ^ ;

CREATE OR ALTER TRIGGER TERCEROS_AU FOR TERCEROS
ACTIVE AFTER UPDATE POSITION 0
as
declare variable NUMROWS INTEGER;
begin
/* SI ES CLIENTE Y SE INACTIVA LO INACTIVA COMO CLIENTE */
if ((NEW.terc_estado = 'N') AND (OLD.terc_estado = 'S')) then
    UPDATE CLIENTES SET CLIE_ESTADO = 'I' WHERE TERC_NIT = NEW.terc_nit;

/* SI TIENE UNA SOLA SUCURSAL ACTUALICELA AL CAMBIAR EL PRINCIPAL */
SELECT COUNT(CLCU_COD) FROM CLIENTE_SUCURSALES WHERE TERC_NIT = NEW.terc_nit INTO :NUMROWS;
if (NUMROWS = 1) then
    BEGIN
    UPDATE cliente_sucursales
        SET CLSU_NOMBRE = new.terc_nom,
            CLSU_DIR = new.terc_dir,
            CLSU_CIUDAD = new.terc_ciu,
            CLSU_TEL = new.terc_tel
        WHERE TERC_NIT = NEW.TERC_NIT AND CLCU_COD = '01';
    END
  INSERT INTO AUDITORIA(AUDI_USUARIO, TIDO_COD, AUDI_IDDOC, AUDI_OPER, AUDI_COD)
    VALUES (USER, 102, 1, 'U', NEW.terc_nit);
end
^

SET TERM ; ^


/* inactivar ciudades */
ALTER TABLE CIUDADES
ADD CIUD_ACTIVA T_BOOLEANO;

UPDATE CIUDADES SET CIUD_ACTIVA = 'S';
COMMIT WORK;

/* 1 autorizacion varios prefijos */
SET TERM ^ ;

CREATE OR ALTER TRIGGER AUTORIZACIONES_BI FOR AUTORIZACIONES
ACTIVE BEFORE INSERT POSITION 0
AS
declare variable numrows integer;
BEGIN
  execute procedure COMPLETA_CEROS(NEW.auto_inicial) returning_values (NEW.auto_inicial);
  execute procedure COMPLETA_CEROS(NEW.auto_final) returning_values (NEW.auto_final);
  if (new.auto_contado is null) then
    new.auto_contado = 'N';
  select count(*) from autorizaciones where pref_pre = new.pref_pre and auto_numero = new.auto_numero into :numrows;
  if (numrows > 0) then
    exception autorizacion_ya_existe 'Ya existe una autorizacin con el No. ' || new.auto_numero || ' para el prefijo ' || new.pref_pre;
END
^

SET TERM ; ^


/* validar numero del documento relacionado */

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('FACTURACION', 'FACTURAS', 'VALIDAR NUMERO DEL PEDIDO', 'NO', 'SI,NO', 'SI: El nmero de pedido digitado debe estar previamente registrado obligatoriamente. NO: El dato pedido puede digitarse de manera informativa');
INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('FACTURACION', 'FACTURAS', 'VALIDAR NUMERO DE LA REMISION', 'NO', 'SI,NO', 'SI: El nmero de remisin digitado debe estar previamente registrado obligatoriamente. NO: El dato pedido puede digitarse de manera informativa');
INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('FACTURACION', 'REMISIONES', 'VALIDAR NUMERO DEL PEDIDO', 'NO', 'SI,NO', 'SI: El nmero de pedido digitado debe estar previamente registrado obligatoriamente. NO: El dato pedido puede digitarse de manera informativa');
INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('FACTURACION', 'REMISIONES', 'VALIDAR NUMERO DE LA FACTURA', 'NO', 'SI,NO', 'SI: El nmero de factura digitado debe estar previamente registrado obligatoriamente. NO: El dato pedido puede digitarse de manera informativa');

/* aviso de cambio de precios */

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('FACTURACION', 'ARTICULOS', 'DIFERENCIA EN PESOS MAXIMA A PERMITIR PARA CAMBIAR PRECIOS', '1', '1,10,50,100', 'Indique el monto de la diferencia en pesos entre el precio calculado y el vigente que permitira el sistema antes de sugerir cambiar un precio');
COMMIT WORK;

/* contabilizacion de retencion por articulo */
ALTER TABLE CONTABIL_ARTICULO
ADD COAR_RTBASE T_MONTO;

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('FACTURACION', 'DOCUMENTOS', 'CALCULAR RETENCIONES POR ARTICULO', 'NO', 'SI,NO', 'SI: Calcula la retencin en la fuente y de ICA con base en los artculos sin usar el porcentaje del pie del documento ni la tareifa y base del cliente. NO: Calcula las retenciones de acuerdo a las tarifas y bases del cliente');
commit work;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE CONTABIL_FACTURA(
    IDDOC INTEGER,
    IDINTER INTEGER)
RETURNS (
    ERROR INTEGER,
    VER CHAR(1),
    IDC INTEGER)
AS
declare variable pref varchar(4);
declare variable num varchar(6);
declare variable numero varchar(10);
declare variable fecaux date;
declare variable fecha char(8);
declare variable conc varchar(60);
declare variable venceaux date;
declare variable vence char(8);
declare variable vrdto numeric(18,2);
declare variable vradic numeric(18,2);
declare variable vrsubt numeric(18,2);
declare variable vriva numeric(18,2);
declare variable prtfte numeric(9,2);
declare variable vrrtfte numeric(18,2);
declare variable vrrtiva numeric(18,2);
declare variable prtica numeric(9,2);
declare variable vrrtica numeric(18,2);
declare variable vrtotal numeric(18,2);
declare variable vrextra numeric(18,2);
declare variable tipocomp varchar(3);
declare variable prefcont varchar(4);
declare variable ventas char(1);
declare variable ctaventas varchar(20);
declare variable iva char(1);
declare variable ctaiva varchar(20);
declare variable consumo char(1);
declare variable ctaconsumo varchar(20);
declare variable cartera char(1);
declare variable ctacartera varchar(20);
declare variable rtfte char(1);
declare variable ctartfte varchar(20);
declare variable rtiva char(1);
declare variable ctartiva varchar(20);
declare variable rtica char(1);
declare variable ctartica varchar(20);
declare variable inven char(1);
declare variable ctainven varchar(20);
declare variable costos char(1);
declare variable ctacostos varchar(20);
declare variable ctadto varchar(20);
declare variable ctaadic varchar(20);
declare variable ctaextra varchar(20);
declare variable existe char(1);
declare variable cuenta varchar(20);
declare variable monto numeric(18,2);
declare variable tipocuen char(1);
declare variable nit varchar(20);
declare variable nombre varchar(60);
declare variable proy varchar(4);
declare variable centro varchar(4);
declare variable porc numeric(5,2);
declare variable debito numeric(18,2);
declare variable credito numeric(18,2);
declare variable nroi integer;
declare variable art varchar(15);
declare variable imptos numeric(18,2);
declare variable suma numeric(18,2);
declare variable porciva numeric(9,2);
declare variable tctaclien varchar(20);
declare variable tctaventa varchar(20);
declare variable tctartfte varchar(20);
declare variable tctartiva varchar(20);
declare variable tctartica varchar(20);
declare variable ctadic varchar(20);
declare variable baseadic varchar(20);
declare variable porcadic numeric(5,2);
declare variable valoradic numeric(18,2);
declare variable dbadic char(1);
declare variable ptovta integer;
declare variable anulado char(1);
declare variable dig integer;
declare variable mercancia numeric(18,2);
declare variable fomento varchar(2);
declare variable DTOXIT varchar(2);
declare variable vrconsumo numeric(18,2);
declare variable factor double precision;
declare variable cent char(1);
declare variable AUTORET VARCHAR(10);
declare variable FAUTORET DATE;
declare variable ERRORC INTEGER;
BEGIN
EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'USAR IMPOCONSUMO COMO PORCENTAJE DE FOMENTO') returning_values (FOMENTO);
EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'FECHA AUTORETENEDOR NO DESCONTAR RETENCIONES DEL SALDO PERO SI CONTABILIZARLAS') returning_values (AUTORET);
if (AUTORET <> '') then
    FAUTORET = CAST(AUTORET AS DATE);
else
    FAUTORET = '9999/12/31';
/* BUSQUE LA INTERFACE */
EXISTE = 'N';
SELECT 'S', TICO_COD, PRCO_PRE, INVE_VENTAS, INVE_IVA, INVE_CONSUMO, INVE_CARTERA, INVE_RTFTE, INVE_RTIVA, INVE_RTICA, INVE_COSTO, INVE_INVEN, INVE_CTAVENTAS, INVE_CTAIVA, INVE_CTACONSUMO, INVE_CTADTO, INVE_CTAADIC, INVE_CTAEXTRA, INVE_CTACARTERA, INVE_CTARTFTE, INVE_CTARTIVA, INVE_CTARTICA, INVE_CTAINVEN, INVE_CTACOSTOS, INVE_CONFIRMAR, INVE_CENTRO
    FROM INTERFAZ_VENTAS
    WHERE INVE_ID = :IDINTER
    INTO :EXISTE, :TIPOCOMP, :PREFCONT, :VENTAS, :IVA, :CONSUMO, :CARTERA, :RTFTE, :RTIVA, :RTICA, :COSTOS, :INVEN, :CTAVENTAS, :CTAIVA, :CTACONSUMO, :CTADTO, :CTAADIC, :CTAEXTRA, :CTACARTERA, :CTARTFTE, :CTARTIVA, :CTARTICA, :CTAINVEN, :CTACOSTOS, :VER, :CENT;
if (EXISTE = 'S') then
  BEGIN
    /* BORRE CUALQUEIR CONTABILIZACION PREVIA */
    DELETE FROM CONTABILIZACION WHERE CNTB_TIPOREF = 31 AND CNTB_IDREF = :IDDOC;

  /* TRAIGA EL ENCABEZADO DE LA FACTURA */
  SELECT PREF_PRE, FACT_NUMERO, FACT_FECHA, F.TERC_NIT, PTVT_ID, FACT_VENCE, FACT_DTOMONTO, FACT_ADICIONAL, FACT_IVAMONTO, FACT_EXTRA, FACT_TOTAL, FACT_RTFTEPOR, FACT_RTFTEMONTO, FACT_RTIVAPOR, FACT_RTIVAMONTO, FACT_RTICAPOR, FACT_RTICAMONTO, FACT_NOMCLIENTE, TERC_CTARTFTE, TERC_CTARTIVA, TERC_CTARTICA, TERC_CTAVENTA, TERC_CTACLIENTE, FACT_ANULADO
        FROM FACTURAS F, TERCEROS T
        WHERE FACT_ID = :IDDOC AND F.TERC_NIT = T.TERC_NIT
        INTO :PREF, :NUM, :FECAUX, :NIT, :PTOVTA, :VENCEAUX, :VRDTO, :VRADIC, :VRIVA, :VREXTRA, :VRTOTAL, :PRTFTE, :VRRTFTE, :PORC, :VRRTIVA, :PRTICA, :VRRTICA, :NOMBRE, TCTARTFTE, TCTARTIVA, TCTARTICA, TCTAVENTA, TCTACLIEN, ANULADO;
  if (ANULADO = 'N') then
    BEGIN
    /* BUSQUE EL CENTRO DEL PUNTO, LA BODEGA, O EL PREFIJO  */
    IF (CENT = 'B') THEN
        SELECT B.BODE_CENTRO, B.BODE_PROY FROM BODEGA B, FACTURAS F
            WHERE B.BODE_COD = F.BODE_COD AND F.FACT_ID = :IDDOC INTO :CENTRO, :PROY;
    IF (CENT = 'V') THEN
        SELECT V.CENT_COD, V.PROY_COD FROM VENDEDORES V, FACTURAS F
            WHERE V.VEND_COD = F.VEND_COD AND F.FACT_ID = :IDDOC INTO :CENTRO, :PROY;
    IF (CENT = 'P') THEN
        SELECT P.PREF_CENTRO,P.PREF_PROY  FROM PREFIJOS P, FACTURAS F
            WHERE P.PREF_PRE = F.PREF_PRE AND F.FACT_ID = :IDDOC AND P.TIDO_COD = 31 INTO :CENTRO, :PROY;
    NUMERO = PREF || NUM;
    SELECT SUM (FADE_CONSUMO) FROM FACTURAS_DETALLE WHERE FACT_ID = :IDDOC INTO MERCANCIA;
    VRSUBT = VRTOTAL - VREXTRA - VRIVA - MERCANCIA; /* BASE DE RETEFTE Y RETEICA */

    EXECUTE PROCEDURE lee_configuracion ('FACTURACION', 'FACTURAS', 'DESCUENTO PIE FACTURA IGUAL A SUMA DE DESCUENTOS POR ITEM') returning_values (:DTOXIT);
    if (DTOXIT = 'SI') then
        VRDTO = 0;
    MERCANCIA = VRSUBT - VRADIC + VRDTO;
    EXECUTE PROCEDURE FECHA_A_CONTA(:FECAUX) returning_values (:FECHA);
    EXECUTE PROCEDURE FECHA_A_CONTA(:VENCEAUX) returning_values (:VENCE);
    /* REGISTRE EL ENCABEZADO CONTABLE */
    IDC = GEN_ID(ID_CONTABILIZA, 1);
    if (STRLEN(NOMBRE)> 43 ) then
      CONC = 'FV No.' || NUMERO || '-' || SUBSTR(NOMBRE,1,43);
    ELSE
      CONC = 'FV No.' || NUMERO || '-' || NOMBRE;
    INSERT INTO CONTABILIZACION (CNTB_ID, CNTB_TIPOCOMP, CNTB_PREFCNT, CNTB_NUMERO, CNTB_FECHA, CNTB_CONCEPTO, CNTB_REF, CNTB_TIPOREF, CNTB_IDREF, CNTB_PREFREF, CNTB_NUMREF, CNTB_PROCESADO)
        VALUES (:IDC, :TIPOCOMP, :PREFCONT, :NUM, :FECHA, :CONC, '', 31, :IDDOC, :PREF, :NUM, 'N');
    NROI = 0;
    SUMA = 0;
    ERROR = 0;
    /* SI NO HAY CUENTA DE DESCUENTO NI ADICIONAL CALCULE UN FACTOR PARA LAS VENTAS Y EL IVA */
    if (MERCANCIA <> 0) then
        FACTOR = CAST(VRSUBT AS DOUBLE PRECISION) / CAST(MERCANCIA AS DOUBLE PRECISION);
    ELSE
        FACTOR = 1;
    /* TRAIGA EL NUMERO DE DIGITOS PARA EL REDONDEO */
    SELECT CAST(CONF_VALOR AS INTEGER) FROM CONFIGURACION WHERE CONF_MODULO = 'FACTURACION' AND
        CONF_CATEGORIA = 'GENERAL' AND CONF_PROPIEDAD = 'REDONDEO AL MULTIPLO DE DIEZ EN TOTALES' INTO :DIG;
    /* CUENTAS DE VENTAS */
    if (VENTAS = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTAVNT), SUM(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), SUM(FADE_IVAMONTO), SUM(FADE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTAVNT
            INTO :CTAVENTAS, :MONTO, :IMPTOS, :VRCONSUMO
            DO
            BEGIN
            if (FOMENTO = 'SI') then
                MONTO = MONTO + VRCONSUMO;
            if ((CTADTO IS NULL) OR (CTADTO = '')) then
                MONTO = MONTO * FACTOR;
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAVENTAS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), FADE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
                        WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAINV = :CUENTA
                        INTO :ART, :MONTO, :IMPTOS
                    DO
                        BEGIN
                        if (FOMENTO = 'SI') then
                            MONTO = MONTO + IMPTOS;
                        if ((CTADTO IS NULL) OR (CTADTO = '')) then
                            MONTO = MONTO * FACTOR;
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        if (MONTO <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            SUMA = SUMA - MONTO;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    SUMA = SUMA - MONTO;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - MONTO;
                    END
                END /* MONTO <> 0 */
            END /* FOR */
        END /* VENTAS X ARTICULO */
     IF ((VENTAS = 'C') OR (VENTAS = 'K')) THEN
        BEGIN
        IF (VENTAS = 'C') THEN
            CTAVENTAS = TCTAVENTA;
        SELECT SUM(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), SUM(FADE_IVAMONTO), SUM (FADE_CONSUMO)
            FROM FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC 
            INTO :MONTO, :IMPTOS, :VRCONSUMO;
        if (FOMENTO = 'SI') then
            MONTO = MONTO + VRCONSUMO;
        if ((CTADTO IS NULL) OR (CTADTO = '')) then
            MONTO = MONTO * FACTOR;
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAVENTAS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), FADE_CONSUMO
                    FROM ARTICULO A, FACTURAS_DETALLE F
                    WHERE F.FACT_ID = :IDDOC 
                    INTO :ART, :MONTO, :IMPTOS
                    DO
                    BEGIN
                    if (FOMENTO = 'SI') then
                        MONTO = MONTO + VRCONSUMO;
                    if ((CTADTO IS NULL) OR (CTADTO = '')) then
                        MONTO = MONTO * FACTOR;
                    execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                    if (MONTO <> 0) then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA - MONTO;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - MONTO;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - MONTO;
                END
            END /* MONTO <> 0 */
        END /* VENTAS DE CLIENTE O CONSTANTE */
    /* EL IVA EN VENTAS */
    if (IVA = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTAIVAV), SUM(FADE_IVAMONTO), SUM(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), sum(FADE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTAIVAV
            INTO :CTAIVA, :IMPTOS, :MONTO, :VALORADIC
        DO
            BEGIN
            if (FOMENTO = 'SI') then
                MONTO = MONTO + VALORADIC;
            MONTO = MONTO * -1;
            MONTO = MONTO * FACTOR;
            IMPTOS = IMPTOS * FACTOR;
            execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (IMPTOS <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, FADE_IVAMONTO, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), TAIV_PORC, FADE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F, TARIFA_IVA T
                        WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAIVAV = :CUENTA AND A.TAIV_COD = T.TAIV_COD
                        INTO :ART, :IMPTOS, :MONTO, :PORCIVA, :VALORADIC
                    DO
                        BEGIN
                        if (FOMENTO = 'SI') then
                            MONTO = MONTO + VALORADIC;
                        MONTO = MONTO * -1;
                        MONTO = MONTO * FACTOR;
                        IMPTOS = IMPTOS * FACTOR;
                        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        if (IMPTOS <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            SUMA = SUMA + DEBITO - CREDITO;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                END   /* IMPTOS <> 0 */
            END /* FOR */
        END /* IVA X ARTICULO */
    if (IVA = 'K') then /* IVA EN CTA CONSTANTE */
        BEGIN
        SELECT SUM(FADE_IVAMONTO), SUM(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), SUM(FADE_CONSUMO)
            FROM FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC and FADE_IVAMONTO <> 0
            INTO :IMPTOS, :MONTO, :valoradic;
        if (FOMENTO = 'SI') then
            MONTO = MONTO + VALORADIC;
        MONTO = MONTO * -1;
        MONTO = MONTO * FACTOR;
        IMPTOS = IMPTOS * FACTOR;
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
        if (IMPTOS <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), FADE_IVAMONTO, TAIV_PORC, FADE_CONSUMO
                    FROM ARTICULO A, FACTURAS_DETALLE F, TARIFA_IVA T
                    WHERE F.FACT_ID = :IDDOC AND A.TAIV_COD = T.TAIV_COD
                    INTO :ART, :MONTO, :IMPTOS, :PORCIVA, :VALORADIC
                    DO
                    BEGIN
                    if (FOMENTO = 'SI') then
                        MONTO = MONTO + VALORADIC;
                    MONTO = MONTO * -1;
                    MONTO = MONTO * FACTOR;
                    IMPTOS = IMPTOS * FACTOR;
                    execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                    execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                    if (IMPTOS <> 0) then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', 0, :IMPTOS, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA - IMPTOS;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            END /* IMPTOS <> 0 */
        END /* IVA EN CTA CONSTANTE */
    /* EL IMPOCONSUMO */
    if ((CONSUMO = 'A') AND (FOMENTO <> 'SI')) then
        BEGIN
        FOR SELECT MAX(COAR_CTACONS), SUM(FADE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTACONS
            INTO :CTACONSUMO, :IMPTOS
        DO
            BEGIN
            execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
            if (IMPTOS <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, FADE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
                        WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTACONS = :CUENTA
                        INTO :ART, :IMPTOS
                    DO
                        BEGIN
                        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                        if (IMPTOS <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            SUMA = SUMA - IMPTOS;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                END /* IMPTOS <> 0 */
            END /* FOR */
        END /* CONSUMO X ARTICULO */
    if ((CONSUMO = 'K') AND (FOMENTO <> 'SI')) then /* CONSUMO EN CTA CONSTANTE */
        BEGIN
        SELECT SUM(FADE_CONSUMO)
            FROM FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC 
            INTO :IMPTOS;
        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
        if (IMPTOS <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, FADE_CONSUMO
                    FROM ARTICULO A, FACTURAS_DETALLE F
                    WHERE F.FACT_ID = :IDDOC 
                    INTO :ART, :IMPTOS
                    DO
                    BEGIN
                    execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                    if (IMPTOS <> 0) then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA - IMPTOS;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            END /* IMPTOS <> 0 */
        END /* CONSUMO EN CTA CONSTANTE */
    /* DESCUENTO */
    if ((CTADTO IS NOT NULL) AND (CTADTO <> '')) then
        BEGIN
        execute procedure redondee(VRDTO, DIG) returning_values (VRDTO);
        if (VRDTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTADTO, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRDTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA + VRDTO;
                END
            if (TIPOCUEN = 'N') then
                    BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRDTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA + VRDTO;
                END
            END
        END /* DESCUENTO */
    /* VALOR ADIC */
    if ((CTAADIC IS NOT NULL) AND (CTAADIC <> '')) then
        BEGIN
        execute procedure redondee(VRADIC, DIG) returning_values (VRADIC);
        if (VRADIC <> 0) THEN
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRADIC, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VRADIC;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRADIC, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VRADIC;
                END
            END
        END /* VR. ADIC */
    /* VALOR EXTRA */
    if ((CTAEXTRA IS NOT NULL) AND (CTAEXTRA <> '')) THEN
        BEGIN
        execute procedure redondee(VREXTRA, DIG) returning_values (VREXTRA);
        if (VREXTRA <> 0) THEN
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAEXTRA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VREXTRA, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VREXTRA;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VREXTRA, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VREXTRA;
                END
            END
        END /* VR. EXTRA */
    /* DESCUENTE EL IMPOCONSUMO */
    SELECT SUM(FADE_CONSUMO)
        FROM FACTURAS_DETALLE F WHERE F.FACT_ID = :IDDOC INTO :IMPTOS;
    vrsubt = vrsubt - IMPTOS;
    /* RETENCION FUENTE */
    if ((RTFTE = 'C') or (RTFTE = 'K')) then
      BEGIN
      execute procedure redondee(VRRTFTE, DIG) returning_values (VRRTFTE);
      if (VRRTFTE <> 0) then
        BEGIN
        if (RTFTE = 'C') then
            CTARTFTE = TCTARTFTE;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTFTE;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTFTE;
            END
        /* AUTORETENCION */
        if (FAUTORET <= fecaux) then
            BEGIN
            EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'CUENTA DE AUTORETENCION EN LA FUENTE') returning_values (CTARTFTE);
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTARTFTE INTO :CUENTA, :TIPOCUEN;
            if (CUENTA IS NULL) then
                begin
                EXECUTE PROCEDURE ERROR (31, :IDDOC, :CTARTFTE, 2);
                CUENTA = CTARTFTE;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                begin
                EXECUTE PROCEDURE ERROR (31, :IDDOC, :CUENTA, 3);
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:VRSUBT*-1), :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VRRTFTE;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:VRSUBT*-1), :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - VRRTFTE;
                END
            END
        END /* RTFTE */
      END
    if (RTFTE = 'A') then
      BEGIN
      FOR SELECT MAX(COAR_CTARTFTEV), MAX(COAR_RTFTE), MIN(COAR_RTBASE), SUM(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), SUM((FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*COAR_RTFTE)
        FROM CONTABIL_ARTICULO C, FACTURAS_DETALLE F
        WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = C.ARTI_COD
        GROUP BY COAR_CTARTFTEV
        INTO :CTARTFTE, :PRTFTE, :baseadic, :MONTO, :VRRTFTE
        DO
        BEGIN
        MONTO = MONTO * FACTOR;
        if (MONTO >= BASEADIC) then
            BEGIN
            VRRTFTE = VRRTFTE * FACTOR / 100;
            execute procedure redondee(VRRTFTE, DIG) returning_values (VRRTFTE);
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (VRRTFTE <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :MONTO, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    SUMA = SUMA + VRRTFTE;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :MONTO, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + VRRTFTE;
                    END
                /* AUTORETENCION */
                if (FAUTORET <= fecaux) then
                    BEGIN
                    EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'CUENTA DE AUTORETENCION EN LA FUENTE') returning_values (CTARTFTE);
                    EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                    if (ERRORC <> 0) then
                        ERROR = ERROR + 1;
                    if (TIPOCUEN = 'C') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:MONTO*-1), :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                        NROI = NROI + 1;
                        SUMA = SUMA - VRRTFTE;
                        END
                    if (TIPOCUEN = 'N') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:MONTO*-1), :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA - VRRTFTE;
                        END
                    END
                END
            END
        END /* RTFTE */
      END
    /* RETENCION IVA */
    if ((RTIVA = 'C') or (RTIVA = 'K')) then
      BEGIN
      execute procedure redondee(VRRTIVA, DIG) returning_values (VRRTIVA);
      if (VRRTIVA <> 0) then
        BEGIN
        if (RTIVA = 'C') then
            CTARTIVA = TCTARTIVA;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTARTIVA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTIVA, 0, :VRIVA, :PORC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTIVA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTIVA, 0, :VRIVA, :PORC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTIVA;
            END
        END /* RTIVA */
      END
    /* RETENCION DE ICA */
    if ((RTICA = 'C') or (RTICA = 'K')) then
      BEGIN
      execute procedure redondee(VRRTICA, DIG) returning_values (VRRTICA);
      if (VRRTICA <> 0) then
        BEGIN
        if (RTICA = 'C') then
            CTARTICA = TCTARTICA;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTARTICA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTICA, 0, :VRSUBT, :PRTICA, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTICA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTICA, 0, :VRSUBT, :PRTICA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTICA;
            END
        END /* RTICA */
      END
    /* CIERRE EL COMPROBANTE CONTRA LA CUENTA DEL TERCERO O LA CONSTANTE */
    if ((SUMA <> 0) and ((CARTERA = 'C') or (CARTERA = 'K') or (CARTERA = 'J'))) then
        BEGIN
        if (SUMA < 0) then
            BEGIN
            DEBITO = SUMA * -1;
            CREDITO = 0;
            END
        ELSE
            BEGIN
            DEBITO = 0;
            CREDITO = SUMA;
            END
        if (CARTERA = 'C') then
            CTACARTERA = TCTACLIEN;
        if (CARTERA = 'J') then
            BEGIN
            /* BUSQUE LA CUENTA DE LA CAJA */
            SELECT CAJA_CUENTA FROM CAJAS C, PUNTO_VENTA P
                WHERE P.CAJA_ID = C.CAJA_ID AND PTVT_ID = :PTOVTA
                INTO :CTACARTERA;
            END
        EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTACARTERA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
        if (TIPOCUEN = 'N') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
        NROI = NROI + 1;
        END /* SUMA EN CARTERA */
    /* CALCULE COSTOS EN VENTAS */
    EXECUTE PROCEDURE COSTO_EN_VENTAS(31, :IDDOC);
    if (COSTOS = 'A') then
        BEGIN
        FOR SELECT MAX(CTACOS), SUM(CAST(CANT AS DOUBLE PRECISION) * COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTACOS
            INTO :CTACOSTOS, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTACOSTOS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT ARTI_COD, CANT * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTACOS = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                END /* MONTO <> 0 */
            END /* FOR */
        END /* COSTOS */
    if (COSTOS = 'K') then
        BEGIN
        SELECT SUM(CAST(CANT AS DOUBLE PRECISION) * COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTACOSTOS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT ARTI_COD, CANT * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            END /* MONTO <> 0 */
        END /* COSTOS = K */
    if (INVEN = 'A') then
        BEGIN
        FOR SELECT MAX(CTAINV), SUM(CAST(CANT AS DOUBLE PRECISION) * COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTAINV
            INTO :CTAINVEN, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT ARTI_COD, CANT * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTAINV = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                END /* MONTO <> 0 */
            END /* FOR */
        END /* INVEN = A */
    if (INVEN = 'K') then
        BEGIN
        SELECT SUM(CAST(CANT AS DOUBLE PRECISION) * COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT ARTI_COD, CANT * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            END /* MONTO <> 0 */
        END /* INVEN = K */
    /* recorra las cuentas adicionales */
    FOR SELECT INVC_CUENTA, INVC_BASE, INVC_PORC, INVC_VALOR, INVC_DB
        FROM INTERFAZ_VENTAS_CTAS
        WHERE INVE_ID = :IDINTER
        INTO :CTADIC, :BASEADIC, :PORCADIC, :VALORADIC, :DBADIC
        DO
        BEGIN
        if (VALORADIC <> 0) then
            MONTO = VALORADIC;
        ELSE
            BEGIN
            if (:BASEADIC = 'SUBTOTAL') then
                VALORADIC = vrsubt;
            if (:BASEADIC = 'DESCUENTO') then
                VALORADIC = VRDTO;
            if (:BASEADIC = 'IVA') then
                VALORADIC = VRIVA;
            if (:BASEADIC = 'ADICIONAL') then
                VALORADIC = VRADIC;
            if (:BASEADIC = 'EXTRA') then
                VALORADIC = VREXTRA;
            if (:BASEADIC = 'TOTAL') then
                VALORADIC = VRTOTAL;
            MONTO = VALORADIC * PORCADIC / 100;
            END
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                if (DBADIC = 'S') then
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                ELSE
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                if (DBADIC = 'S') then
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                ELSE
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            NROI = NROI + 1;
            END
        END
    if (ERROR > 0) then
        VER = 'S';
    SUSPEND;
    END /* NO ANULADO */
  END /* EXISTE LA INTERFAZ */
ELSE
    BEGIN
    EXECUTE PROCEDURE ERROR (31, :IDDOC, :PREF, 1);
    ERROR = ERROR + 1;
    VER = 'S';
    SUSPEND;
    END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE FACTURAS_SIN_CONTABILIDAD(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDI INTEGER,
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable FECICNT VARCHAR(10);
declare variable FECFCNT VARCHAR(10);
declare variable ERROR INTEGER;
declare variable idref INTEGER;
BEGIN /*$$IBE$$ 
EXECUTE PROCEDURE fecha_a_conta(FECINI) returning_values (FECICNT);
EXECUTE PROCEDURE fecha_a_conta(FECFIN) returning_values (FECFCNT);
FOR SELECT FACT_ID, PREF_PRE, FACT_NUMERO FROM FACTURAS WHERE FACT_ANULADO = 'N' AND
    FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  idref = null;
  SELECT ENCO_IDREF FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 31 AND ENCO_FECHA >= :FECICNT AND ENCO_FECHA <= :FECFCNT and ENCO_IDREF = :ID into :idref;
  if (idref IS NULL) then
  begin
   ESTADO = 'PROCESANDO';
   ERROR = NULL;
   SUSPEND;
   SELECT MAX(INVE_ID) FROM INTERFAZ_VENTAS WHERE PREF_PRE = :PREF AND TIDO_COD = 31 INTO :IDI;
   EXECUTE PROCEDURE CONTABIL_FACTURA (:ID, :IDI) RETURNING_VALUES (:ERROR, VER, :IDC);
   if ((ERROR = 0) or (error IS NULL)) then
    BEGIN
    EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC);
    ESTADO = 'OK';
    END
   ELSE
    ESTADO = 'ERROR';
   suspend;
  end
  END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE FACTURAS_SIN_CONTABILIDAD(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDI INTEGER,
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable FECICNT VARCHAR(10);
declare variable FECFCNT VARCHAR(10);
declare variable ERROR INTEGER;
declare variable idref INTEGER;
BEGIN
EXECUTE PROCEDURE fecha_a_conta(FECINI) returning_values (FECICNT);
EXECUTE PROCEDURE fecha_a_conta(FECFIN) returning_values (FECFCNT);
FOR SELECT FACT_ID, PREF_PRE, FACT_NUMERO FROM FACTURAS WHERE FACT_ANULADO = 'N' AND
    FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  idref = null;
  SELECT ENCO_IDREF FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 31 AND ENCO_FECHA >= :FECICNT AND ENCO_FECHA <= :FECFCNT and ENCO_IDREF = :ID into :idref;
  if (idref IS NULL) then
  begin
   ESTADO = 'PROCESANDO';
   ERROR = NULL;
   SUSPEND;
   SELECT MAX(INVE_ID) FROM INTERFAZ_VENTAS WHERE PREF_PRE = :PREF AND TIDO_COD = 31 INTO :IDI;
   EXECUTE PROCEDURE CONTABIL_FACTURA (:ID, :IDI) RETURNING_VALUES (:ERROR, VER, :IDC);
   if ((ERROR = 0) or (error IS NULL)) then
    BEGIN
    EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC);
    ESTADO = 'OK';
    END
   ELSE
    ESTADO = 'ERROR';
   suspend;
  end
  END
END

^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE CONTABIL_DEVOLCLI(
    IDDOC INTEGER,
    IDINTER INTEGER)
RETURNS (
    ERROR INTEGER,
    VER CHAR(1),
    IDC INTEGER)
AS
declare variable PREF VARCHAR(4);
declare variable NUM VARCHAR(6);
declare variable NUMERO VARCHAR(10);
declare variable FECAUX DATE;
declare variable FECHA CHAR(8);
declare variable CONC CHAR(120);
declare variable NUMFAC VARCHAR(10);
declare variable VRDTO NUMERIC(18, 2);
declare variable VRADIC NUMERIC(18, 2);
declare variable VRSUBT NUMERIC(18, 2);
declare variable VRIVA NUMERIC(18, 2);
declare variable PRTFTE NUMERIC(9, 2);
declare variable VRRTFTE NUMERIC(18, 2);
declare variable VRRTIVA NUMERIC(18, 2);
declare variable PRTICA NUMERIC(9, 2);
declare variable VRRTICA NUMERIC(18, 2);
declare variable VRTOTAL NUMERIC(18, 2);
declare variable VREXTRA NUMERIC(18, 2);
declare variable TIPOCOMP VARCHAR(3);
declare variable PREFCONT VARCHAR(4);
declare variable VENTAS CHAR(1);
declare variable CTAVENTAS VARCHAR(20);
declare variable IVA CHAR(1);
declare variable CTAIVA VARCHAR(20);
declare variable CONSUMO CHAR(1);
declare variable CTACONSUMO VARCHAR(20);
declare variable CARTERA CHAR(1);
declare variable CTACARTERA VARCHAR(20);
declare variable RTFTE CHAR(1);
declare variable CTARTFTE VARCHAR(20);
declare variable RTIVA CHAR(1);
declare variable CTARTIVA VARCHAR(20);
declare variable RTICA CHAR(1);
declare variable CTARTICA VARCHAR(20);
declare variable INVEN CHAR(1);
declare variable CTAINVEN VARCHAR(20);
declare variable COSTOS CHAR(1);
declare variable CTACOSTOS VARCHAR(20);
declare variable CTADTO VARCHAR(20);
declare variable CTAADIC VARCHAR(20);
declare variable CTAEXTRA VARCHAR(20);
declare variable EXISTE CHAR(1);
declare variable CUENTA VARCHAR(20);
declare variable MONTO NUMERIC(18,2);
declare variable TIPOCUEN CHAR(1);
declare variable NIT VARCHAR(20);
declare variable PROY VARCHAR(4);
declare variable CENTRO VARCHAR(4);
declare variable PORC NUMERIC(5,2);
declare variable DEBITO NUMERIC(18,2);
declare variable CREDITO NUMERIC(18,2);
declare variable NROI INTEGER;
declare variable ART VARCHAR(15);
declare variable IMPINC CHAR(1);
declare variable IMPTOS NUMERIC(18, 2);
declare variable SUMA NUMERIC(18,2);
declare variable PORCIVA NUMERIC(9,2);
declare variable TCTACLIEN VARCHAR(20);
declare variable TCTAVENTA VARCHAR(20);
declare variable TCTARTFTE VARCHAR(20);
declare variable TCTARTIVA VARCHAR(20);
declare variable TCTARTICA VARCHAR(20);
declare variable CTADIC VARCHAR(20);
declare variable BASEADIC VARCHAR(20);
declare variable PORCADIC NUMERIC(5,2);
declare variable VALORADIC NUMERIC(18,2);
declare variable DBADIC CHAR(1);
declare variable PTOVTA INTEGER;
declare variable ANULADO CHAR(1);
declare variable CENT CHAR(1);
DECLARE VARIABLE MERCANCIA NUMERIC(18,2);
declare variable FACTOR DOUBLE PRECISION;
declare variable DIG INTEGER;
DECLARE VARIABLE FOMENTO VARCHAR(2);
DECLARE VARIABLE VRCONSUMO NUMERIC(18,2);
declare variable AUTORET VARCHAR(10);
declare variable FAUTORET DATE;
declare variable IDREM INTEGER;
declare variable DTOXIT CHAR(2);
declare variable ERRORC INTEGER;
BEGIN
EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'USAR IMPOCONSUMO COMO PORCENTAJE DE FOMENTO') returning_values (FOMENTO);
EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'FECHA AUTORETENEDOR NO DESCONTAR RETENCIONES DEL SALDO PERO SI CONTABILIZARLAS') returning_values (AUTORET);
if (AUTORET <> '') then
    FAUTORET = CAST(AUTORET AS DATE);
else
    FAUTORET = '9999/12/31';
  /* BUSQUE LA INTERFACE */
  EXISTE = 'N';
  SELECT 'S', TICO_COD, PRCO_PRE, INVE_VENTAS, INVE_IVA, INVE_CONSUMO, INVE_CARTERA, INVE_RTFTE, INVE_RTIVA, INVE_RTICA, INVE_COSTO, INVE_INVEN, INVE_CTAVENTAS, INVE_CTAIVA, INVE_CTACONSUMO, INVE_CTADTO, INVE_CTAADIC, INVE_CTAEXTRA, INVE_CTACARTERA, INVE_CTARTFTE, INVE_CTARTIVA, INVE_CTARTICA, INVE_CTAINVEN, INVE_CTACOSTOS, INVE_CONFIRMAR, INVE_CENTRO
    FROM INTERFAZ_VENTAS
    WHERE INVE_ID = :IDINTER
    INTO :EXISTE, :TIPOCOMP, :PREFCONT, :VENTAS, :IVA, :CONSUMO, :CARTERA, :RTFTE, :RTIVA, :RTICA, :COSTOS, :INVEN, :CTAVENTAS, :CTAIVA, :CTACONSUMO, :CTADTO, :CTAADIC, :CTAEXTRA, :CTACARTERA, :CTARTFTE, :CTARTIVA, :CTARTICA, :CTAINVEN, :CTACOSTOS, :VER, :CENT;
  if (EXISTE = 'S') then
   BEGIN
    /* BORRE CUALQUEIR CONTABILIZACION PREVIA */
    DELETE FROM CONTABILIZACION WHERE CNTB_TIPOREF = 33 AND CNTB_IDREF = :IDDOC;
    /* TRAIGA EL ENCABEZADO DE LA DEVOLUCION */
   SELECT PREF_PRE, DEVT_NUMERO, DEVT_FECHA, F.TERC_NIT, DEVT_IVAINC, PTVT_ID, DEVT_FACTURA, DEVT_DTOMONTO, DEVT_ADICIONAL, DEVT_IVAMONTO, DEVT_EXTRA, DEVT_TOTAL, DEVT_RTFTEPORC, DEVT_RTFTEMONTO, DEVT_RTIVAPORC, DEVT_RTIVAMONTO, DEVT_RTICAPORC, DEVT_RTICAMONTO, TERC_CTARTFTE, TERC_CTARTIVA, TERC_CTARTICA, TERC_CTAVENTA, TERC_CTACLIENTE, DEVT_ANULADO, DEVT_REMID
        FROM DEVOLUCIONES_VENTAS F, TERCEROS T
        WHERE DEVT_ID = :IDDOC AND F.TERC_NIT = T.TERC_NIT
        INTO :PREF, :NUM, :FECAUX, :NIT, :IMPINC, :PTOVTA, :NUMFAC, :VRDTO, :VRADIC, :VRIVA, :VREXTRA, :VRTOTAL, :PRTFTE, :VRRTFTE, :PORC, :VRRTIVA, :PRTICA, :VRRTICA, :TCTARTFTE, TCTARTIVA, TCTARTICA, TCTAVENTA, TCTACLIEN, ANULADO, :IDREM;
   if (idrem is null) Then
    IDREM = 0;
   if ((ANULADO = 'N') AND (IDREM = 0)) then
    BEGIN
    NUMERO = PREF || NUM;
    SELECT SUM(DVDE_CONSUMO) FROM devoluciones_ventas_detalle WHERE DEVT_ID = :iddoc INTO :MERCANCIA;
    VRSUBT = VRTOTAL - VREXTRA - VRIVA - MERCANCIA; /* BASE DE RETEFTE Y RETEICA */
    EXECUTE PROCEDURE lee_configuracion ('FACTURACION', 'DEVOLUCIONES', 'DESCUENTO PIE DEVOLUCION IGUAL A SUMA DE DESCUENTOS POR ITEM') returning_values (:DTOXIT);
    if (DTOXIT = 'SI') then
        VRDTO = 0;
    MERCANCIA = VRSUBT - VRADIC + VRDTO;
    IF (CENT = 'B') THEN
        SELECT B.BODE_CENTRO, B.BODE_PROY FROM BODEGA B, DEVOLUCIONES_VENTAS F
            WHERE B.BODE_COD = F.BODE_COD AND F.DEVT_ID = :IDDOC INTO :CENTRO, :PROY;
    IF (CENT = 'V') THEN
        SELECT V.CENT_COD, V.PROY_COD FROM VENDEDORES V, DEVOLUCIONES_VENTAS F
            WHERE V.VEND_COD = F.VEND_COD AND F.DEVT_ID = :IDDOC INTO :CENTRO, :PROY;
    IF (CENT = 'P') THEN
        SELECT P.PREF_CENTRO,P.PREF_PROY  FROM PREFIJOS P, DEVOLUCIONES_VENTAS F
            WHERE P.PREF_PRE = F.PREF_PRE AND F.DEVT_ID = :IDDOC AND P.TIDO_COD = 33 INTO :CENTRO, :PROY;
    EXECUTE PROCEDURE FECHA_A_CONTA(:FECAUX) returning_values (:FECHA);
    /* REGISTRE EL ENCABEZADO CONTABLE */
    IDC = GEN_ID(ID_CONTABILIZA, 1);
    CONC = 'DEVOLUCION VENTAS No. ' || NUMERO || ' EN FACTURA ' || NUMFAC;
    CONC = SUBSTR(CONC, 1, 60);
    INSERT INTO CONTABILIZACION (CNTB_ID, CNTB_TIPOCOMP, CNTB_PREFCNT, CNTB_NUMERO, CNTB_FECHA, CNTB_CONCEPTO, CNTB_REF, CNTB_TIPOREF, CNTB_IDREF, CNTB_PREFREF, CNTB_NUMREF, CNTB_PROCESADO)
        VALUES (:IDC, :TIPOCOMP, :PREFCONT, :NUM, :FECHA, :CONC, '', 33, :IDDOC, :PREF, :NUM, 'N');
    NROI = 0;
    SUMA = 0;
    ERROR = 0;
    /* SI NO HAY CUENTA DE DESCUENTO NI ADICIONAL CALCULE UN FACTOR PARA LAS VENTAS Y EL IVA */
    if (MERCANCIA <> 0) then
        FACTOR = CAST(VRSUBT AS DOUBLE PRECISION) / CAST(MERCANCIA AS DOUBLE PRECISION);
    ELSE
        FACTOR = 1;
    /* TRAIGA EL NUMERO DE DIGITOS PARA EL REDONDEO */
    SELECT CAST(CONF_VALOR AS INTEGER) FROM CONFIGURACION WHERE CONF_MODULO = 'FACTURACION' AND
        CONF_CATEGORIA = 'GENERAL' AND CONF_PROPIEDAD = 'REDONDEO AL MULTIPLO DE DIEZ EN TOTALES' INTO :DIG;
    /* CUENTAS DE VENTAS */
    if (VENTAS = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTADEV), SUM(cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), SUM(DVDE_IVAMONTO), SUM(DVDE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTADEV
            INTO :CTAVENTAS, :MONTO, :IMPTOS, :VRCONSUMO
            DO
            BEGIN
            if (IMPINC = 'S') then
                if (FOMENTO = 'SI') then
                    MONTO = MONTO - IMPTOS;
                ELSE
                    MONTO = MONTO - IMPTOS - VRCONSUMO;
            ELSE
            if (FOMENTO = 'SI') then
            MONTO = MONTO + VRCONSUMO;
            if ((CTADTO IS NULL) OR (CTADTO = '')) then
                MONTO = MONTO * FACTOR;
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAVENTAS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, (cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), (DVDE_IVAMONTO+DVDE_CONSUMO)
                        FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F
                        WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAINV = :CUENTA
                        INTO :ART, :MONTO, :IMPTOS
                    DO
                        BEGIN
                        if (IMPINC = 'S') then
                            MONTO = MONTO - IMPTOS;
                        if ((CTADTO IS NULL) OR (CTADTO = '')) then
                            MONTO = MONTO * FACTOR;
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA + MONTO;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    SUMA = SUMA + MONTO;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + MONTO;
                    END
                END /* MONTO <> 0 */
            END /* FOR */
        END /* VENTAS X ARTICULO */
     IF ((VENTAS = 'C') OR (VENTAS = 'K')) THEN
        BEGIN
        IF (VENTAS = 'C') THEN
            CTAVENTAS = TCTAVENTA;
        SELECT SUM(cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), SUM(DVDE_IVAMONTO), SUM(DVDE_CONSUMO)
            FROM DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC 
            INTO :MONTO, :IMPTOS, :VRCONSUMO;
        if (IMPINC = 'S') then
            if (FOMENTO = 'SI') then
               MONTO = MONTO - IMPTOS;
            ELSE
               MONTO = MONTO - IMPTOS - VRCONSUMO;
        ELSE
         if (FOMENTO = 'SI') then
          MONTO = MONTO + VRCONSUMO;
        if ((CTADTO IS NULL) OR (CTADTO = '')) then
            MONTO = MONTO * FACTOR;
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAVENTAS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, (cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), (DVDE_IVAMONTO+DVDE_CONSUMO)
                    FROM ARTICULO A, DEVOLUCIONES_VENTAS_DETALLE F
                    WHERE F.DEVT_ID = :IDDOC
                    INTO :ART, :MONTO, :IMPTOS
                    DO
                    BEGIN
                    if (IMPINC = 'S') then
                        MONTO = MONTO - IMPTOS;
                    if ((CTADTO IS NULL) OR (CTADTO = '')) then
                        MONTO = MONTO * FACTOR;
                    execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + MONTO;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                SUMA = SUMA + MONTO;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA + MONTO;
                END
            END /* MONTO <> 0 */
        END /* VENTAS DE CLIENTE O CONSTANTE */
    /* EL IVA EN VENTAS */
    if (IVA = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTAIVAV), SUM(DVDE_IVAMONTO), SUM(DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO), SUM(DVDE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTAIVAV
            INTO :CTAIVA, :IMPTOS, :MONTO, :VALORADIC
        DO
            BEGIN
            if (FOMENTO = 'SI') then
                MONTO = MONTO + VALORADIC;
            MONTO = MONTO * -1;
            MONTO = MONTO * FACTOR;
            IMPTOS = IMPTOS * FACTOR;
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
            if (IMPTOS <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, DVDE_IVAMONTO, (cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), TAIV_PORC, DVDE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F, TARIFA_IVA T
                        WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND A.TAIV_COD = T.TAIV_COD AND COAR_CTAIVAV = :CUENTA
                        INTO :ART, :IMPTOS, :MONTO, :PORCIVA, :VALORADIC
                    DO
                        BEGIN
                        if (IMPINC = 'S') then
                            MONTO = MONTO - IMPTOS - VALORADIC;
                        MONTO = MONTO * -1;
                        MONTO = MONTO * FACTOR;
                        IMPTOS = IMPTOS * FACTOR;
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                        if (IMPTOS <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            SUMA = SUMA + IMPTOS;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                END   /* IMPTOS <> 0 */
            END /* FOR */
        END /* IVA X ARTICULO */
    if (IVA = 'K') then /* IVA EN CTA CONSTANTE */
        BEGIN
        SELECT SUM(DVDE_IVAMONTO), SUM(DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO), SUM(DVDE_CONSUMO)
            FROM DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC 
            INTO :IMPTOS, :MONTO, :VALORADIC;
        if (FOMENTO = 'SI') then
            MONTO = MONTO + VALORADIC;
        MONTO = MONTO * -1;
        MONTO = MONTO * FACTOR;
        IMPTOS = IMPTOS * FACTOR;
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
        if (IMPTOS <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, (cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), DVDE_IVAMONTO, TAIV_PORC, DVDE_CONSUMO
                    FROM ARTICULO A, DEVOLUCIONES_VENTAS_DETALLE F, TARIFA_IVA T
                    WHERE F.DEVT_ID = :IDDOC AND A.TAIV_COD = T.TAIV_COD
                    INTO :ART, :MONTO, :IMPTOS, :PORCIVA, :VALORADIC
                    DO
                    BEGIN
                    if (IMPINC = 'S') then
                        MONTO = MONTO - IMPTOS - VALORADIC;
                    MONTO = MONTO * -1;
                    MONTO = MONTO * FACTOR;
                    IMPTOS = IMPTOS * FACTOR;
                    execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                    execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                    if (IMPTOS <> 0) then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', :IMPTOS, 0, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA + IMPTOS;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                SUMA = SUMA + IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA + IMPTOS;
                END
            END /* IMPTOS <> 0 */
        END /* IVA EN CTA CONSTANTE */
    /* EL IMPOCONSUMO */
    if ((CONSUMO = 'A') AND (FOMENTO <> 'SI')) then
        BEGIN
        FOR SELECT MAX(COAR_CTACONS), SUM(DVDE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTACONS
            INTO :CTACONSUMO, :IMPTOS
        DO
            BEGIN
            if (IMPTOS <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, DVDE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F
                        WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTACONS = :CUENTA
                        INTO :ART, :IMPTOS
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA + IMPTOS;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                END /* IMPTOS <> 0 */
            END /* FOR */
        END /* CONSUMO X ARTICULO */
    if ((CONSUMO = 'K') AND (FOMENTO <> 'SI')) then
        BEGIN
        SELECT SUM(DVDE_CONSUMO)
            FROM DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC 
            INTO :IMPTOS;
        if (IMPTOS <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, DVDE_CONSUMO
                    FROM ARTICULO A, DEVOLUCIONES_VENTAS_DETALLE F
                    WHERE F.DEVT_ID = :IDDOC 
                    INTO :ART, :IMPTOS
                    DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA + IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA + IMPTOS;
                END
            END /* IMPTOS <> 0 */
        END /* CONSUMO EN CTA CONSTANTE */
    /* DESCUENTO */
    if ((CTADTO IS NOT NULL) AND
        (CTADTO <> '') AND
        (VRDTO <> 0)) THEN
        BEGIN
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTADTO, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRDTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA - VRDTO;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRDTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA - VRDTO;
            END
        END /* DESCUENTO */
    /* VALOR ADIC */
    if ((CTAADIC IS NOT NULL) AND
        (CTAADIC <> '') AND
        (VRADIC <> 0)) THEN
        BEGIN
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRADIC, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA + VRADIC;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRADIC, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA + VRADIC;
            END
        END /* VR. ADIC */
    /* VALOR EXTRA */
    if ((CTAEXTRA IS NOT NULL) AND
        (CTAEXTRA <> '') AND
        (VREXTRA <> 0)) THEN
        BEGIN
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAEXTRA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VREXTRA, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA + VREXTRA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VREXTRA, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA + VREXTRA;
            END
        END /* VR. EXTRA */
    /* RETENCION FUENTE */
    if ((RTFTE = 'C') or (RTFTE = 'K')) then
      if (VRRTFTE <> 0) then
        BEGIN
        if (RTFTE = 'C') then
            CTARTFTE = TCTARTFTE;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:VRSUBT*-1), :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTFTE;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:VRSUBT*-1), :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTFTE;
            END
        /* AUTORETENCION */
        if (FAUTORET <= fecaux) then
            BEGIN
            EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'CUENTA DE AUTORETENCION EN LA FUENTE') returning_values (CTARTFTE);
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                SUMA = SUMA + VRRTFTE;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA + VRRTFTE;
                END
            END
        END /* RTFTE */
    if (RTFTE = 'A') then
      BEGIN
      FOR SELECT MAX(COAR_CTARTFTEV), MAX(COAR_RTFTE), MIN(COAR_RTBASE), SUM(DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO), SUM((DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*COAR_RTFTE)
        FROM CONTABIL_ARTICULO C, devoluciones_ventas_detalle F
        WHERE F.devt_id = :IDDOC AND F.ARTI_COD = C.ARTI_COD
        GROUP BY COAR_CTARTFTEV
        INTO :CTARTFTE, :PRTFTE, :baseadic, :MONTO, :VRRTFTE
        DO
        BEGIN
        MONTO = MONTO * FACTOR;
        if (MONTO >= BASEADIC) then
            BEGIN
            VRRTFTE = VRRTFTE * FACTOR / 100;
            execute procedure redondee(VRRTFTE, DIG) returning_values (VRRTFTE);
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (VRRTFTE <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:MONTO*-1), :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    SUMA = SUMA - VRRTFTE;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:MONTO*-1), :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - VRRTFTE;
                    END
                /* AUTORETENCION */
                if (FAUTORET <= fecaux) then
                    BEGIN
                    EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'CUENTA DE AUTORETENCION EN LA FUENTE') returning_values (CTARTFTE);
                    EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                    if (ERRORC <> 0) then
                        ERROR = ERROR + 1;
                    if (TIPOCUEN = 'C') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :MONTO, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                        NROI = NROI + 1;
                        SUMA = SUMA + VRRTFTE;
                        END
                    if (TIPOCUEN = 'N') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :MONTO, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA + VRRTFTE;
                        END
                    END
                END
            END
        END /* RTFTE */
      END
    /* RETENCION IVA */
    if ((RTIVA = 'C') or (RTIVA = 'K')) then
      if (VRRTIVA <> 0) then
        BEGIN
        if (RTIVA = 'C') then
            CTARTIVA = TCTARTIVA;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTIVA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTIVA, (:VRIVA*-1), :PORC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTIVA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTIVA, (:VRIVA*-1), :PORC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTIVA;
            END
        END /* RTIVA */
    /* RETENCION DE ICA */
    if ((RTICA = 'C') or (RTICA = 'K')) then
      if (VRRTICA <> 0) then
        BEGIN
        if (RTICA = 'C') then
            CTARTICA = TCTARTICA;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTICA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTICA, (:VRSUBT*-1), :PRTICA, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTICA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTICA, (:VRSUBT*-1), :PRTICA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTICA;
            END
        END /* RTICA */
    /* CIERRE EL COMPROBANTE CONTRA LA CUENTA DEL TERCERO O LA CONSTANTE */
    if ((SUMA <> 0) and ((CARTERA = 'C') or (CARTERA = 'K') or (CARTERA = 'J'))) then
        BEGIN
        if (SUMA < 0) then
            BEGIN
            DEBITO = SUMA * -1;
            CREDITO = 0;
            END
        ELSE
            BEGIN
            DEBITO = 0;
            CREDITO = SUMA;
            END
        if (CARTERA = 'C') then
            CTACARTERA = TCTACLIEN;
        if (CARTERA = 'J') then
            BEGIN
            /* BUSQUE LA CUENTA DE LA CAJA */
            SELECT CAJA_CUENTA FROM CAJAS C, PUNTO_VENTA P
                WHERE P.CAJA_ID = C.CAJA_ID AND PTVT_ID = :PTOVTA
                INTO :CTACARTERA;
            END
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTACARTERA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
        if (TIPOCUEN = 'N') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
        NROI = NROI + 1;
        END /* SUMA EN CARTERA */
    /* CALCULE COSTOS EN VENTAS */
    EXECUTE PROCEDURE COSTO_EN_VENTAS(33, :IDDOC);
    if (COSTOS = 'A') then
        BEGIN
        FOR SELECT MAX(CTACOS), SUM(cast(CANT as double precision) * COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTACOS
            INTO :CTACOSTOS, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTACOSTOS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT ARTI_COD, cast(CANT as double precision) * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTACOS = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                END /* MONTO <> 0 */
            END /* FOR */
        END /* COSTOS */
    if (COSTOS = 'K') then
        BEGIN
        SELECT SUM(cast(CANT as double precision) * COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTACOSTOS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT ARTI_COD, cast(CANT as double precision) * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            END /* MONTO <> 0 */
        END /* COSTOS = K */
    if (INVEN = 'A') then
        BEGIN
        FOR SELECT MAX(CTAINV), SUM(cast(CANT as double precision) * COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTAINV
            INTO :CTAINVEN, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT ARTI_COD, cast(CANT as double precision) * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTAINV = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                END /* MONTO <> 0 */
            END /* FOR */
        END /* INVEN = A */
    if (INVEN = 'K') then
        BEGIN
        SELECT SUM(cast(CANT as double precision) * COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT ARTI_COD, cast(CANT as double precision) * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            END /* MONTO <> 0 */
        END /* INVEN = K */
    /* recorra las cuentas adicionales */
    FOR SELECT INVC_CUENTA, INVC_BASE, INVC_PORC, INVC_VALOR, INVC_DB
        FROM INTERFAZ_VENTAS_CTAS WHERE INVE_ID = :IDINTER
        INTO :CTADIC, :BASEADIC, :PORCADIC, :VALORADIC, :DBADIC
        DO
        BEGIN
        if (valoradic <> 0) then
            monto = valoradic;
        else
            BEGIN
            if (:BASEADIC = 'SUBTOTAL') then
                VALORADIC = vrsubt;
            if (:BASEADIC = 'DESCUENTO') then
                VALORADIC = VRDTO;
            if (:BASEADIC = 'IVA') then
                VALORADIC = VRIVA;
            if (:BASEADIC = 'ADICIONAL') then
                VALORADIC = VRADIC;
            if (:BASEADIC = 'EXTRA') then
                VALORADIC = VREXTRA;
            if (:BASEADIC = 'TOTAL') then
                VALORADIC = VRTOTAL;
            MONTO = VALORADIC * PORCADIC;
            END
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                if (DBADIC = 'S') then
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                ELSE
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                if (DBADIC = 'S') then
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                ELSE
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            NROI = NROI + 1;
            END
        END
    if (error > 0) then
        ver = 'S';
    SUSPEND;
    END
   END /* EXISTE LA INTERFAZ */
  ELSE
    BEGIN
    EXECUTE PROCEDURE ERROR (33, :IDDOC, :PREF, 1);
    ERROR = ERROR + 1;
    VER = 'S';
    SUSPEND;
    END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE DEVOLUCIONES_SIN_CONTABILIDAD(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDI INTEGER,
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable FECICNT VARCHAR(10);
declare variable FECFCNT VARCHAR(10);
declare variable ERROR INTEGER;
declare variable idref INTEGER;
BEGIN /*$$IBE$$ 
EXECUTE PROCEDURE fecha_a_conta(FECINI) returning_values (FECICNT);
EXECUTE PROCEDURE fecha_a_conta(FECFIN) returning_values (FECFCNT);
FOR SELECT DEVT_ID, PREF_PRE, DEVT_NUMERO FROM devoluciones_ventas WHERE DEVT_ANULADO = 'N' AND
    DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN
    INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  idref = null;
  SELECT ENCO_IDREF FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 33 AND ENCO_FECHA >= :FECICNT AND ENCO_FECHA <= :FECFCNT and ENCO_IDREF = :id into :idref;
  if (idref IS NULL) then
  begin
   ESTADO = 'PROCESANDO';
   SUSPEND;
   SELECT MAX(INVE_ID) FROM INTERFAZ_VENTAS WHERE PREF_PRE = :PREF AND TIDO_COD = 33 INTO :IDI;
   EXECUTE PROCEDURE contabil_devolcli (:ID, :IDI) RETURNING_VALUES (:ERROR, :VER, :IDC);
   if (ERROR = 0) then
    BEGIN
    EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC);
    ESTADO = 'OK';
    END
   ELSE
    ESTADO = 'ERROR';
   suspend;
  End
  END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE DEVOLUCIONES_SIN_CONTABILIDAD(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDI INTEGER,
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable FECICNT VARCHAR(10);
declare variable FECFCNT VARCHAR(10);
declare variable ERROR INTEGER;
declare variable idref INTEGER;
BEGIN
EXECUTE PROCEDURE fecha_a_conta(FECINI) returning_values (FECICNT);
EXECUTE PROCEDURE fecha_a_conta(FECFIN) returning_values (FECFCNT);
FOR SELECT DEVT_ID, PREF_PRE, DEVT_NUMERO FROM devoluciones_ventas WHERE DEVT_ANULADO = 'N' AND
    DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN
    INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  idref = null;
  SELECT ENCO_IDREF FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 33 AND ENCO_FECHA >= :FECICNT AND ENCO_FECHA <= :FECFCNT and ENCO_IDREF = :id into :idref;
  if (idref IS NULL) then
  begin
   ESTADO = 'PROCESANDO';
   SUSPEND;
   SELECT MAX(INVE_ID) FROM INTERFAZ_VENTAS WHERE PREF_PRE = :PREF AND TIDO_COD = 33 INTO :IDI;
   EXECUTE PROCEDURE contabil_devolcli (:ID, :IDI) RETURNING_VALUES (:ERROR, :VER, :IDC);
   if (ERROR = 0) then
    BEGIN
    EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC);
    ESTADO = 'OK';
    END
   ELSE
    ESTADO = 'ERROR';
   suspend;
  End
  END
END

^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE CONTABIL_FACTCOMP(
    IDDOC INTEGER,
    IDINTER INTEGER)
RETURNS (
    ERROR INTEGER,
    VER CHAR(1),
    IDC INTEGER)
AS
DECLARE VARIABLE PREFIJO VARCHAR(4);
DECLARE VARIABLE NUM VARCHAR(6);
DECLARE VARIABLE NUMERO VARCHAR(10);
DECLARE VARIABLE FECAUX DATE;
DECLARE VARIABLE FECHA CHAR(8);
DECLARE VARIABLE CONCEPTO CHAR(60);
DECLARE VARIABLE VENCEAUX DATE;
DECLARE VARIABLE VENCE CHAR(8);
DECLARE VARIABLE VRDTO NUMERIC(18,2);
DECLARE VARIABLE VRADIC NUMERIC(18,2);
DECLARE VARIABLE VRSUBT NUMERIC(18,2);
DECLARE VARIABLE VRIVA NUMERIC(18,2);
DECLARE VARIABLE PRTFTE NUMERIC(9,2);
DECLARE VARIABLE VRRTFTE NUMERIC(18,2);
DECLARE VARIABLE VRRTIVA NUMERIC(18,2);
DECLARE VARIABLE PRTICA NUMERIC(9,2);
DECLARE VARIABLE VRRTICA NUMERIC(18,2);
DECLARE VARIABLE VRTOTAL NUMERIC(18,2);
DECLARE VARIABLE VREXTRA NUMERIC(18,2);
DECLARE VARIABLE TIPOCOMP VARCHAR(3);
DECLARE VARIABLE PREFCONT VARCHAR(4);
DECLARE VARIABLE INVEN CHAR(1);
DECLARE VARIABLE CTAINVEN VARCHAR(20);
DECLARE VARIABLE IVA CHAR(1);
DECLARE VARIABLE CTAIVA VARCHAR(20);
DECLARE VARIABLE CONSUMO CHAR(1);
DECLARE VARIABLE CTACONSUMO VARCHAR(20);
DECLARE VARIABLE CXP CHAR(1);
DECLARE VARIABLE CTACXP VARCHAR(20);
DECLARE VARIABLE RTFTE CHAR(1);
DECLARE VARIABLE CTARTFTE VARCHAR(20);
DECLARE VARIABLE RTIVA CHAR(1);
DECLARE VARIABLE CTARTIVA VARCHAR(20);
DECLARE VARIABLE RTICA CHAR(1);
DECLARE VARIABLE CTARTICA VARCHAR(20);
DECLARE VARIABLE CTADTO VARCHAR(20);
DECLARE VARIABLE CTAADIC VARCHAR(20);
DECLARE VARIABLE CTAEXTRA VARCHAR(20);
DECLARE VARIABLE EXISTE CHAR(1);
DECLARE VARIABLE CUENTA VARCHAR(20);
DECLARE VARIABLE MONTO NUMERIC(18,2);
DECLARE VARIABLE TIPOCUEN CHAR(1);
DECLARE VARIABLE NIT VARCHAR(20);
DECLARE VARIABLE NOMBRE VARCHAR(60);
DECLARE VARIABLE PROY VARCHAR(4);
DECLARE VARIABLE CENTRO VARCHAR(4);
DECLARE VARIABLE PROYDET VARCHAR(4);
DECLARE VARIABLE CENTRODET VARCHAR(4);
DECLARE VARIABLE PORC NUMERIC(5,2);
DECLARE VARIABLE NUMITEMS INTEGER;
DECLARE VARIABLE ARTICULO VARCHAR(15);
DECLARE VARIABLE IMPINC CHAR(1);
DECLARE VARIABLE IMPTOS NUMERIC(18,2);
DECLARE VARIABLE SUMA NUMERIC(18,2);
DECLARE VARIABLE PORCIVA NUMERIC(9,2);
DECLARE VARIABLE TCTAPROV VARCHAR(20);
DECLARE VARIABLE TCTARTFTE VARCHAR(20);
DECLARE VARIABLE TCTARTIVA VARCHAR(20);
DECLARE VARIABLE TCTARTICA VARCHAR(20);
DECLARE VARIABLE CUENTAADIC VARCHAR(20);
DECLARE VARIABLE BASEADIC VARCHAR(20);
DECLARE VARIABLE PORCADIC NUMERIC(5,2);
DECLARE VARIABLE VALORADIC NUMERIC(18,2);
DECLARE VARIABLE DBADIC CHAR(1);
DECLARE VARIABLE FOMENTO CHAR(2);
DECLARE VARIABLE BODE_DET CHAR(2);
DECLARE VARIABLE NUMPROV VARCHAR(10);
DECLARE VARIABLE MERCANCIA NUMERIC(18,2);
declare variable FACTOR DOUBLE PRECISION;
DECLARE VARIABLE MENORV CHAR(2);
declare variable DIG INTEGER;
declare variable NETO NUMERIC(18,2);
declare variable CENT CHAR(1);
declare variable ANULADO CHAR(1);
declare variable ERRORC INTEGER;
BEGIN
  /* INTERFACE */
  EXISTE = 'N';
  SELECT 'S', TICO_COD, PRCO_PRE, INCO_INVEN, INCO_IVA, INCO_CONSUMO, INCO_CXP, INCO_RTFTE, INCO_RTIVA, INCO_RTICA, INCO_CTAINVEN, INCO_CTAIVA, INCO_CTACONSUMO, INCO_CTADTO, INCO_CTAADIC, INCO_CTAEXTRA, INCO_CTACXP, INCO_CTARTFTE, INCO_CTARTIVA, INCO_CTARTICA, INCO_CONFIRMAR, INCO_CENTRO
    FROM INTERFAZ_COMPRAS WHERE INCO_ID = :IDINTER INTO :EXISTE, :TIPOCOMP, :PREFCONT, :INVEN, :IVA, :CONSUMO, :CXP, :RTFTE, :RTIVA, :RTICA, :CTAINVEN, :CTAIVA, :CTACONSUMO, :CTADTO, :CTAADIC, :CTAEXTRA, :CTACXP, :CTARTFTE, :CTARTIVA, :CTARTICA, :VER, :CENT;
  if (EXISTE = 'S') then
    BEGIN
    /* BORRE CONTABILIZACION PREVIA */
    DELETE FROM CONTABILIZACION WHERE CNTB_TIPOREF = 21 AND CNTB_IDREF = :IDDOC;
    /* ENCABEZADO DE LA FACTURA */
    SELECT PREF_PRE, FACO_NUMERO, FACO_FECHA, F.TERC_NIT, FACO_IMPTOS, FACO_VENCE, FACO_DTOMONTO, FACO_ADICIONAL, FACO_IVAMONTO, FACO_EXTRA, FACO_TOTAL, FACO_RTFTEPORC, FACO_RTFTEMONTO, FACO_RTIVAPOR, FACO_RTIVAMONTO, FACO_RTICAPOR, FACO_RTICAMONTO, TERC_NOM, PROV_CTARTFTE, PROV_CTARTIVA, PROV_CTARTICA, PROV_CTAPAGAR, FACO_NUMPROV, FACO_ANULADO
        FROM FACTURAS_COMPRA F, TERCEROS T, PROVEEDORES P WHERE FACO_ID = :IDDOC AND F.TERC_NIT = T.TERC_NIT AND T.TERC_NIT = P.TERC_NIT
        INTO :PREFIJO, :NUM, :FECAUX, :NIT, :IMPINC, :VENCEAUX, :VRDTO, :VRADIC, :VRIVA, :VREXTRA, :VRTOTAL, :PRTFTE, :VRRTFTE, :PORC, :VRRTIVA, :PRTICA, :VRRTICA, :NOMBRE, TCTARTFTE, TCTARTIVA, TCTARTICA, TCTAPROV, :NUMPROV, :ANULADO;
    /* CENTRO DE LA BODEGA */
    IF (CENT = 'B') THEN
        SELECT BODE_CENTRO, BODE_PROY FROM BODEGA B, FACTURAS_COMPRA F WHERE B.BODE_COD = F.BODE_COD AND F.FACO_ID = :IDDOC INTO :CENTRO, :PROY;
    ELSE
        SELECT PREF_CENTRO,PREF_PROY  FROM PREFIJOS P, FACTURAS_COMPRA F WHERE P.PREF_PRE = F.PREF_PRE AND F.FACO_ID = :IDDOC AND P.TIDO_COD = 21 INTO :CENTRO, :PROY;
    if (ANULADO = 'N') then
        BEGIN
        NUMERO = PREFIJO || NUM;
        VRSUBT = VRTOTAL - VREXTRA - VRIVA;
        MERCANCIA = VRSUBT - VRADIC + VRDTO;
        EXECUTE PROCEDURE FECHA_A_CONTA(:FECAUX) returning_values (:FECHA);
        EXECUTE PROCEDURE FECHA_A_CONTA(:VENCEAUX) returning_values (:VENCE);
        if (NUMPROV IS NULL) then
            NUMPROV = NUMERO;
        CONCEPTO = 'FC No.' || NUMERO || '-' || SUBSTR(NOMBRE,1,26) || '-NPROV.' || NUMPROV;
        IDC = GEN_ID(ID_CONTABILIZA, 1);
        INSERT INTO CONTABILIZACION (CNTB_ID, CNTB_TIPOCOMP, CNTB_PREFCNT, CNTB_NUMERO, CNTB_FECHA, CNTB_CONCEPTO, CNTB_REF, CNTB_TIPOREF, CNTB_IDREF, CNTB_PREFREF, CNTB_NUMREF, CNTB_PROCESADO)
            VALUES (:IDC, :TIPOCOMP, :PREFCONT, :NUM, :FECHA, :CONCEPTO, '', 21, :IDDOC, :PREFIJO, :NUM, 'N');
        NUMITEMS = 0;
        SUMA = 0;
        NETO = 0;
        ERROR = 0;
        EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'USAR IMPOCONSUMO COMO PORCENTAJE DE FOMENTO') RETURNING_VALUES (FOMENTO);
        EXECUTE PROCEDURE lee_configuracion('COMPRAS','FACTURAS','DESCUENTO Y VALOR ADICIONAL DEL DOCUMENTO COMO MENOR VALOR DEL COSTO') returning_values (:MENORV);
        SELECT SUM(FCDE_consumo) from facturas_compras_detalle where faco_id = :IDDOC into :valoradic;
        if (MENORV = 'SI') then
            if (MERCANCIA <> 0) then
                FACTOR = (CAST(VRSUBT AS DOUBLE PRECISION) - VALORADIC) / (CAST(MERCANCIA AS DOUBLE PRECISION) - VALORADIC);
            ELSE
                FACTOR = 1;
        ELSE
           FACTOR = 1;
        SELECT CAST(CONF_VALOR AS INTEGER) FROM CONFIGURACION WHERE CONF_MODULO = 'COMPRAS' AND CONF_CATEGORIA = 'GENERAL' AND CONF_PROPIEDAD = 'REDONDEO AL MULTIPLO DE DIEZ EN TOTALES' INTO :DIG;
        if (INVEN = 'A') then
            BEGIN
            FOR SELECT MAX(COAR_CTAINV), SUM(CAST(FCDE_CANT AS DOUBLE PRECISION) * (FCDE_PRUNIT-FCDE_DTOMONTO)), SUM(FCDE_IVAMONTO), SUM(FCDE_CONSUMO), MAX(F.BODE_COD)
                FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_COMPRAS_DETALLE F WHERE F.FACO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
                GROUP BY COAR_CTAINV, F.BODE_COD INTO :CTAINVEN, :MONTO, :IMPTOS, :VALORADIC, :BODE_DET DO
                BEGIN
                IF (CENT = 'B') THEN
                  SELECT BODE_CENTRO, BODE_PROY FROM BODEGA WHERE BODE_COD = :BODE_DET INTO :CENTRODET, :PROYDET;
                if (IMPINC = 'S') then
                    BEGIN
                    MONTO = MONTO - IMPTOS;
                    if (FOMENTO <> 'SI' ) then
                        MONTO = MONTO - VALORADIC;
                    END
                MONTO = MONTO * FACTOR;
                execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    FOR SELECT F.ARTI_COD, (FCDE_CANT * (FCDE_PRUNIT-FCDE_DTOMONTO)), FCDE_IVAMONTO, FCDE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_COMPRAS_DETALLE F WHERE F.FACO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAINV = :CUENTA
                        INTO :ARTICULO, :MONTO, :IMPTOS, :VALORADIC DO
                        BEGIN
                        if (IMPINC = 'S') then
                            BEGIN
                            MONTO = MONTO - IMPTOS;
                            if (FOMENTO <> 'SI' ) then
                                MONTO = MONTO - VALORADIC;
                            END
                        MONTO = MONTO * FACTOR;
                        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        IF (CENT = 'B') THEN
                           INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                               VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROYDET, :CENTRODET, NULL, NULL, NULL, :ARTICULO, 0, 0);
                        ELSE
                           INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                               VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                        NUMITEMS = NUMITEMS + 1;
                        NETO = NETO + MONTO;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    IF (CENT = 'B') THEN
                       INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                           VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROYDET, :CENTRODET, :NUMERO, NULL, :VENCE, NULL, 0, 21);
                    ELSE
                       INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                           VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 21);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO + MONTO;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    IF (CENT = 'B') THEN
                       INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                           VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROYDET, :CENTRODET, NULL, NULL, NULL, NULL, 0, 0);
                    ELSE
                       INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                           VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO + MONTO;
                    END
                END
            END
        if (INVEN = 'K') then
            BEGIN
            FOR SELECT SUM(CAST(FCDE_CANT AS DOUBLE PRECISION) * (FCDE_PRUNIT-FCDE_DTOMONTO)), SUM(FCDE_IVAMONTO), SUM(FCDE_CONSUMO), MAX(BODE_COD)
                FROM FACTURAS_COMPRAS_DETALLE WHERE FACO_ID = :IDDOC GROUP BY BODE_COD INTO :MONTO, :IMPTOS, :VALORADIC, :BODE_DET Do
                BEGIN
                  IF (CENT = 'B') THEN
                    SELECT BODE_CENTRO, BODE_PROY FROM BODEGA WHERE BODE_COD = :BODE_DET INTO :CENTRODET, :PROYDET;
                  if (IMPINC = 'S') then
                   BEGIN
                    MONTO = MONTO - IMPTOS;
                    if (FOMENTO <> 'SI' ) then
                      MONTO = MONTO - VALORADIC;
                   END
                  MONTO = MONTO * FACTOR;
                  execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                  execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                  EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                  if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                  if (TIPOCUEN = 'I') then
                   BEGIN
                    FOR SELECT ARTI_COD, (FCDE_CANT * (FCDE_PRUNIT-FCDE_DTOMONTO)), FCDE_IVAMONTO, FCDE_CONSUMO
                      FROM FACTURAS_COMPRAS_DETALLE WHERE FACO_ID = :IDDOC INTO :ARTICULO, :MONTO, :IMPTOS, :VALORADIC DO
                       BEGIN
                       if (IMPINC = 'S') then
                        BEGIN
                         MONTO = MONTO - IMPTOS;
                         if (FOMENTO <> 'SI' ) then
                            MONTO = MONTO - VALORADIC;
                        END
                       MONTO = MONTO * FACTOR;
                       execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                       execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                       IF (CENT = 'B') THEN
                          INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                             VALUES (:IDC, :NUMITEMS, :CTAINVEN, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROYDET, :CENTRODET, NULL, NULL, NULL, :ARTICULO, 0, 0);
                       ELSE
                          INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                             VALUES (:IDC, :NUMITEMS, :CTAINVEN, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                       NUMITEMS = NUMITEMS + 1;
                       NETO = NETO + MONTO;
                       END
                   END
                  if (TIPOCUEN = 'C') then
                   BEGIN
                    IF (CENT = 'B') THEN
                       INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                         VALUES (:IDC, :NUMITEMS, :CTAINVEN, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROYDET, :CENTRODET, :NUMERO, NULL, :VENCE, NULL, 0, 21);
                    ELSE
                       INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                         VALUES (:IDC, :NUMITEMS, :CTAINVEN, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 21);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO + MONTO;
                   END
                  if (TIPOCUEN = 'N') then
                   BEGIN
                    IF (CENT = 'B') THEN
                       INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                          VALUES (:IDC, :NUMITEMS, :CTAINVEN, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROYDET, :CENTRODET, NULL, NULL, NULL, NULL, 0, 0);
                    ELSE
                       INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                          VALUES (:IDC, :NUMITEMS, :CTAINVEN, :CONCEPTO, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO + MONTO;
                   END
                END
            END
        /* EL IVA */
        if (IVA = 'A') then
            BEGIN
            FOR SELECT MAX(COAR_CTAIVAC), SUM(FCDE_IVAMONTO), SUM(CAST(FCDE_CANT AS DOUBLE PRECISION) * (FCDE_PRUNIT-FCDE_DTOMONTO)), SUM(FCDE_CONSUMO)
                FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_COMPRAS_DETALLE F WHERE F.FACO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD GROUP BY COAR_CTAIVAC
                INTO :CTAIVA, :IMPTOS, :MONTO, :VALORADIC DO
              if (IMPTOS <> 0) then
                BEGIN
                IMPTOS = CAST(IMPTOS AS DOUBLE PRECISION) * VRSUBT / MERCANCIA;
                if (IMPINC = 'S') then
                    BEGIN
                    MONTO = MONTO - IMPTOS;
                    if (FOMENTO <> 'SI' ) then
                        MONTO = MONTO - VALORADIC;
                    END
                MONTO = CAST(MONTO AS DOUBLE PRECISION) * VRSUBT / MERCANCIA;
                execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    FOR SELECT F.ARTI_COD, FCDE_IVAMONTO, (FCDE_CANT * (FCDE_PRUNIT-FCDE_DTOMONTO)), TAIV_PORC, FCDE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_COMPRAS_DETALLE F, TARIFA_IVA T WHERE F.FACO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAIVAV = :CUENTA AND A.TAIV_COD = T.TAIV_COD
                        INTO :ARTICULO, :IMPTOS, :MONTO, :PORCIVA, :VALORADIC
                    DO
                        BEGIN
                        IMPTOS = CAST(IMPTOS AS DOUBLE PRECISION) * VRSUBT / MERCANCIA;
                        if (IMPINC = 'S') then
                            BEGIN
                            MONTO = MONTO - IMPTOS;
                            if (FOMENTO <> 'SI' ) then
                                MONTO = MONTO - VALORADIC;
                            END
                        MONTO = CAST(MONTO AS DOUBLE PRECISION) * VRSUBT / MERCANCIA;
                        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :IMPTOS, 0, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                        NUMITEMS = NUMITEMS + 1;
                        NETO = NETO + IMPTOS;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :IMPTOS, 0, :MONTO, :IMPTOS*100/:MONTO, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 21);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO + IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :IMPTOS, 0, :MONTO, CAST(:IMPTOS AS DOUBLE PRECISION)*100/CAST(:MONTO AS DOUBLE PRECISION), :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO + IMPTOS;
                    END
                END
            END
        if (IVA = 'K') then /* IVA EN CTA CONSTANTE */
            BEGIN
            SELECT SUM(FCDE_IVAMONTO), SUM(CAST(FCDE_CANT AS DOUBLE PRECISION) * (FCDE_PRUNIT-FCDE_DTOMONTO)), SUM(FCDE_CONSUMO)
                FROM FACTURAS_COMPRAS_DETALLE F WHERE F.FACO_ID = :IDDOC INTO :IMPTOS, :MONTO, :VALORADIC;
            if (IMPTOS <> 0) then
                BEGIN
                IMPTOS = CAST(IMPTOS AS DOUBLE PRECISION) * VRSUBT / MERCANCIA;
                if (IMPINC = 'S') then
                    BEGIN
                    MONTO = MONTO - IMPTOS;
                    if (FOMENTO <> 'SI' ) then
                        MONTO = MONTO - VALORADIC;
                    END
                MONTO = CAST(MONTO AS DOUBLE PRECISION) * VRSUBT / MERCANCIA;
                execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    FOR SELECT F.ARTI_COD, (FCDE_CANT * (FCDE_PRUNIT-FCDE_DTOMONTO)), FCDE_IVAMONTO, TAIV_PORC, FCDE_CONSUMO
                        FROM ARTICULO A, FACTURAS_COMPRAS_DETALLE F, TARIFA_IVA T WHERE F.FACO_ID = :IDDOC AND A.TAIV_COD = T.TAIV_COD
                        INTO :ARTICULO, :MONTO, :IMPTOS, :PORCIVA, :VALORADIC DO
                        BEGIN
                        IMPTOS = CAST(IMPTOS AS DOUBLE PRECISION) * VRSUBT / MERCANCIA;
                        if (IMPINC = 'S') then
                            BEGIN
                            MONTO = MONTO - IMPTOS;
                            if (FOMENTO <> 'SI' ) then
                                MONTO = MONTO - VALORADIC;
                            END
                        MONTO = CAST(MONTO AS DOUBLE PRECISION) * VRSUBT / MERCANCIA;
                        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        if (IMPTOS <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NUMITEMS, :CTAIVA, :CONCEPTO, '', :IMPTOS, 0, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                            NUMITEMS = NUMITEMS + 1;
                            NETO = NETO + IMPTOS;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CTAIVA, :CONCEPTO, '', :IMPTOS, 0, :MONTO, :IMPTOS*100/:MONTO, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 21);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO + IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CTAIVA, :CONCEPTO, '', :IMPTOS, 0, :MONTO, :IMPTOS*100/:MONTO, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO + IMPTOS;
                    END
                END
            END
        /* EL IMPOCONSUMO */
        if (CONSUMO = 'A') then
            BEGIN
            FOR SELECT MAX(COAR_CTACONS), SUM(FCDE_CONSUMO) FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_COMPRAS_DETALLE F
                WHERE F.FACO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD GROUP BY COAR_CTACONS INTO :CTACONSUMO, :IMPTOS
            DO
              if (IMPTOS <> 0) then
                BEGIN
                execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (FOMENTO <> 'SI') then
                    BEGIN
                    if (TIPOCUEN = 'I') then
                        BEGIN
                        FOR SELECT F.ARTI_COD, FCDE_CONSUMO FROM ARTICULO A, FACTURAS_COMPRAS_DETALLE F WHERE F.FACO_ID = :IDDOC INTO :ARTICULO, :IMPTOS
                            DO
                            BEGIN
                            if (IMPTOS <> 0) then
                                BEGIN
                                execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                    VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                                NUMITEMS = NUMITEMS + 1;
                                NETO = NETO + IMPTOS;
                                END
                            END
                        END
                    if (TIPOCUEN = 'C') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                        NUMITEMS = NUMITEMS + 1;
                        NETO = NETO + IMPTOS;
                        END
                    if (TIPOCUEN = 'N') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        NUMITEMS = NUMITEMS + 1;
                        NETO = NETO + IMPTOS;
                        END
                    END
                ELSE
                    BEGIN
                    if (TIPOCUEN = 'I') then
                        BEGIN
                        FOR SELECT F.ARTI_COD, FCDE_CONSUMO FROM ARTICULO A, FACTURAS_COMPRAS_DETALLE F WHERE F.FACO_ID = :IDDOC INTO :ARTICULO, :IMPTOS
                            DO
                            BEGIN
                            if (IMPTOS <> 0) then
                                BEGIN
                                execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                    VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                                NUMITEMS = NUMITEMS + 1;
                                NETO = NETO - IMPTOS;
                                END
                            END
                        END
                    if (TIPOCUEN = 'C') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                        NUMITEMS = NUMITEMS + 1;
                        NETO = NETO - IMPTOS;
                        END
                    if (TIPOCUEN = 'N') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        NUMITEMS = NUMITEMS + 1;
                        NETO = NETO - IMPTOS;
                        END
                    END
                END
            END
        if (CONSUMO = 'K') then /* CONSUMO EN CTA CONSTANTE */
            BEGIN
            SELECT SUM(FCDE_CONSUMO) FROM FACTURAS_COMPRAS_DETALLE F WHERE F.FACO_ID = :IDDOC INTO :IMPTOS;
            if (IMPTOS <> 0) then
              BEGIN
              execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
              /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
              EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
              if (ERRORC <> 0) then
                ERROR = ERROR + 1;
              if (FOMENTO <> 'SI') then
                BEGIN
                /* DEPENDE DEL TIPO DE CUENTA */
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, FCDE_CONSUMO FROM ARTICULO A, FACTURAS_COMPRAS_DETALLE F WHERE F.FACO_ID = :IDDOC INTO :ARTICULO, :IMPTOS
                        DO
                        BEGIN
                        if (IMPTOS <> 0) then
                            BEGIN
                            execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                            NUMITEMS = NUMITEMS + 1;
                            NETO = NETO + IMPTOS;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    /* INSERTE EL REGISTRO DE LA BASE */
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO + IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO + IMPTOS;
                    END
                END
              ELSE
                BEGIN
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, FCDE_CONSUMO FROM ARTICULO A, FACTURAS_COMPRAS_DETALLE F WHERE F.FACO_ID = :IDDOC INTO :ARTICULO, :IMPTOS
                        DO
                        BEGIN
                        if (IMPTOS <> 0) then
                            BEGIN
                           execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                           INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                            NUMITEMS = NUMITEMS + 1;
                            NETO = NETO - IMPTOS;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    /* INSERTE EL REGISTRO DE LA BASE */
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO - IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    NETO = NETO - IMPTOS;
                    END
                END
              end
            END
        /* DESCUENTO */
        if ((CTADTO IS NOT NULL) AND
            (CTADTO <> '')) THEN
          BEGIN
          execute procedure redondee(VRDTO, DIG) returning_values (VRDTO);
          if (VRDTO <> 0) then
            begin
            /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
            EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTADTO, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRDTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 21);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO - VRDTO;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                /* INSERTE EL REGISTRO DE LA BASE */
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRDTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO - VRDTO;
                END
            end
          END
        /* VALOR ADIC */
        if ((CTAADIC IS NOT NULL) AND
            (CTAADIC <> '')) THEN
          BEGIN
          execute procedure redondee(VRADIC, DIG) returning_values (VRADIC);
          if (VRADIC <> 0) then
            begin
            /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
            EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTAADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRADIC, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 21);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO + VRADIC;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRADIC, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO + VRADIC;
                END
            end
          END
        /* VALOR EXTRA */
        if ((CTAEXTRA IS NOT NULL) AND
            (CTAEXTRA <> '')) THEN
          BEGIN
          execute procedure redondee(VREXTRA, DIG) returning_values (VREXTRA);
          if (VREXTRA <> 0) then
            begin
            /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
            EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTAEXTRA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VREXTRA, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 21);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO + VREXTRA;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VREXTRA, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO + VREXTRA;
                END
            end
          END

        /* DESCUENTE EL IMPOCONSUMO */
        SELECT SUM(FCDE_CONSUMO) FROM FACTURAS_COMPRAS_DETALLE F WHERE F.FACO_ID = :IDDOC INTO :IMPTOS;
        if (IMPTOS IS NULL) then
            IMPTOS = 0;
        vrsubt = vrsubt - IMPTOS;
        /* RETENCION FUENTE */
        if ((RTFTE = 'P') or (RTFTE = 'K')) then
          BEGIN
          execute procedure redondee(VRRTFTE, DIG) returning_values (VRRTFTE);
          if (VRRTFTE <> 0) then
            begin
            if (RTFTE = 'P') then
                CTARTFTE = TCTARTFTE;
            EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRRTFTE, (:VRSUBT*-1), :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO - VRRTFTE;
                SUMA = VRRTFTE;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRRTFTE, (:VRSUBT*-1), :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO - VRRTFTE;
                SUMA = VRRTFTE;
                END
            end
          END
        if (RTFTE = 'A') then
          BEGIN
          FOR SELECT MAX(COAR_CTARTFTE), MAX(COAR_RTFTE), MIN(COAR_RTBASE), SUM(FCDE_TOTAL-FCDE_IVAMONTO-FCDE_CONSUMO), SUM((FCDE_TOTAL-FCDE_IVAMONTO-FCDE_CONSUMO)*COAR_RTFTE)
            FROM CONTABIL_ARTICULO C, FACTURAS_COMPRAS_DETALLE F
            WHERE F.faco_id = :IDDOC AND F.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTARTFTE
            INTO :CTARTFTE, :PRTFTE, :baseadic,  :MONTO, :VRRTFTE
            DO
            BEGIN
            MONTO = MONTO * FACTOR * -1;
            if (MONTO >= :baseadic) then
                BEGIN
                VRRTFTE = VRRTFTE * FACTOR / 100;
                execute procedure redondee(VRRTFTE, DIG) returning_values (VRRTFTE);
                execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                if (VRRTFTE <> 0) then
                    BEGIN
                    EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                    if (ERRORC <> 0) then
                        ERROR = ERROR + 1;
                    if (TIPOCUEN = 'C') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRRTFTE, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                        NUMITEMS = NUMITEMS + 1;
                        NETO = NETO - VRRTFTE;
                        SUMA = VRRTFTE;
                        END
                    if (TIPOCUEN = 'N') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRRTFTE, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        NUMITEMS = NUMITEMS + 1;
                        NETO = NETO - VRRTFTE;
                        SUMA = VRRTFTE;
                        END
                    end
                end
              END
          END
        /* RETENCION IVA */
        if ((RTIVA = 'P') or (RTIVA = 'K')) then
          BEGIN
          execute procedure redondee(VRRTIVA, DIG) returning_values (VRRTIVA);
          if (VRRTIVA <> 0) then
            begin
            if (RTIVA = 'P') then
                CTARTIVA = TCTARTIVA;
            EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTARTIVA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRRTIVA, (:VRIVA*-1), :PORC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 21);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO - VRRTIVA;
                SUMA = SUMA + VRRTIVA;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRRTIVA, (:VRIVA*-1), :PORC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO - VRRTIVA;
                SUMA = SUMA + VRRTIVA;
                END
            end
          END
        /* RETENCION DE ICA */
        if ((RTICA = 'P') or (RTICA = 'K')) then
          BEGIN
          execute procedure redondee(VRRTICA, DIG) returning_values (VRRTICA);
          if (VRRTICA <> 0) then
            begin
            if (RTICA = 'P') then
                CTARTICA = TCTARTICA;
            EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTARTICA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRRTICA, (:VRSUBT*-1), :PRTICA, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 21);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO - VRRTICA;
                SUMA = SUMA + VRRTICA;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRRTICA, (:VRSUBT*-1), :PRTICA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NUMITEMS = NUMITEMS + 1;
                NETO = NETO - VRRTICA;
                SUMA = SUMA + VRRTICA;
                END
            end
          END
        /* CIERRE EL COMPROBANTE CONTRA LA CUENTA DEL TERCERO O LA CONSTANTE */
        if ((CXP = 'P') or (CXP = 'K')) then
            BEGIN
            SUMA = VRTOTAL - SUMA;
            execute procedure redondee(SUMA, DIG) returning_values (SUMA);
            if (CXP = 'P') then
                CTACXP = TCTAPROV;
            EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTACXP, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :SUMA, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 21);
            if (TIPOCUEN = 'N') then
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :SUMA, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NETO = NETO - SUMA;
            NUMITEMS = NUMITEMS + 1;
            END
        /* recorra las cuentas adicionales */
        FOR SELECT INCC_CUENTA, INCC_BASE, INCC_PORC, INCC_VALOR, INCC_DB FROM INTERFAZ_COMPRAS_CTAS
            WHERE INCO_ID = :IDINTER INTO :CUENTAADIC, :BASEADIC, :PORCADIC, :VALORADIC, :DBADIC
            DO
            BEGIN
            if (VALORADIC <> 0) then
                MONTO = VALORADIC;
            ELSE
                BEGIN
                if (:BASEADIC = 'SUBTOTAL') then
                    VALORADIC = VRTOTAL - VREXTRA - VRIVA - VRADIC + VRDTO;
                if (:BASEADIC = 'DESCUENTO') then
                    VALORADIC = VRDTO;
                if (:BASEADIC = 'IVA') then
                    VALORADIC = VRIVA;
                if (:BASEADIC = 'CONSUMO') then
                    SELECT SUM(FCDE_CONSUMO) FROM FACTURAS_COMPRAS_DETALLE F WHERE F.FACO_ID = :IDDOC INTO :VALORADIC;
                if (:BASEADIC = 'ADICIONAL') then
                    VALORADIC = VRADIC;
                if (:BASEADIC = 'EXTRA') then
                    VALORADIC = VREXTRA;
                if (:BASEADIC = 'TOTAL') then
                    VALORADIC = VRTOTAL;
                MONTO = CAST(VALORADIC AS DOUBLE PRECISION) * PORCADIC / 100;
                END
            if (MONTO <> 0) then
                BEGIN
                execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CUENTAADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'C') then
                    BEGIN
                    if (DBADIC = 'S') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTAADIC, :CONCEPTO, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                        SUMA = SUMA + MONTO;
                        NETO = NETO + MONTO;
                        END
                    ELSE
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTAADIC, :CONCEPTO, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                        SUMA = SUMA - MONTO;
                        NETO = NETO - MONTO;
                        END
                    NUMITEMS = NUMITEMS + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    if (DBADIC = 'S') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTAADIC, :CONCEPTO, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        SUMA = SUMA + MONTO;
                        NETO = NETO + MONTO;
                        END
                    ELSE
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTAADIC, :CONCEPTO, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        SUMA = SUMA - MONTO;
                        NETO = NETO - MONTO;
                        END
                    NUMITEMS = NUMITEMS + 1;
                    END
                END
            END
        if (NETO <> 0) then
            BEGIN
            EXECUTE PROCEDURE lee_configuracion ('CONTABILIDAD','GENERAL','CUENTA PARA CUADRAR COMPROBANTES DESCUADRADOS DE INTERFAZ') returning_values (:ctaadic);
            if (ctaadic <> '') then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(21, :IDDOC, :CTAADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'C') then
                    BEGIN
                    if (NETO < 0) then
                        BEGIN
                        NETO = NETO * -1;
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :NETO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                        END
                    ELSE
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :NETO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                        END
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    if (NETO < 0) then
                        BEGIN
                        NETO = NETO * -1;
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :NETO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        END
                    ELSE
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :NETO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        END
                    END
                END
            END
        END
    if (ERROR > 0) then
        VER = 'S';
    SUSPEND;
    END
ELSE
    BEGIN
    EXECUTE PROCEDURE ERROR (21, :IDDOC, :PREFIJO, 1);
    ERROR = ERROR + 1;
    VER = 'S';
    SUSPEND;
    END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE CONTABILICE_COMP_SIMPLIFICADO(
    IDI INTEGER)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable ERROR INTEGER;
BEGIN /*$$IBE$$ 
FOR SELECT FACO_ID, PREF_PRE, FACO_NUMERO FROM FACTURAS_COMPRA C, PROVEEDORES P WHERE
    C.TERC_NIT = P.TERC_NIT AND PROV_SIMPLIFICADO = 'S' AND FACO_ANULADO = 'N'
    ORDER BY FACO_ID INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  ESTADO = 'PROCESANDO';
  SUSPEND;
   $$IBE$$*/ /* BORRE LA CONTABILIZACION */
/*  delete FROM comprobante_detalle WHERE ENCO_CONSEC IN (SELECT ENCO_CONSEC FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 21 AND ENCO_IDREF = :ID);
  DELETE FROM comprobante_encabezado  WHERE ENCO_TIPOREF = 21 AND ENCO_IDREF = :ID; */ /*$$IBE$$ 
  EXECUTE PROCEDURE CONTABIL_FACTCOMP (:ID, :IDI) RETURNING_VALUES (:ERROR, VER, :IDC);
  if (ERROR = 0) then
    BEGIN
 $$IBE$$*/ /*    EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC); */ /*$$IBE$$ 
    ESTADO = 'OK';
    END
  ELSE
    ESTADO = 'ERROR';
  suspend;
  END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE FACTCOMP_SIN_CONTABILIDAD(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDI INTEGER,
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable FECICNT VARCHAR(10);
declare variable FECFCNT VARCHAR(10);
declare variable ERROR INTEGER;
declare variable idref INTEGER;
BEGIN /*$$IBE$$ 
EXECUTE PROCEDURE fecha_a_conta(FECINI) returning_values (FECICNT);
EXECUTE PROCEDURE fecha_a_conta(FECFIN) returning_values (FECFCNT);
FOR SELECT FACO_ID, PREF_PRE, FACO_NUMERO FROM FACTURAS_COMPRA WHERE FACO_ANULADO = 'N' AND
    FACO_FECHA >= :FECINI AND FACO_FECHA <= :FECFIN ORDER BY FACO_ID
    INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  idref = null;
  SELECT ENCO_IDREF FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 21 AND ENCO_FECHA >= :FECICNT AND ENCO_FECHA <= :FECFCNT and ENCO_IDREF = :id into :idref;
  if (idref IS NULL) then
  begin
   ESTADO = 'PROCESANDO';
   SUSPEND;
   SELECT MAX(INCO_ID) FROM INTERFAZ_COMPRAS WHERE PREF_PRE = :PREF AND TIDO_COD = 21 INTO :IDI;
   EXECUTE PROCEDURE CONTABIL_FACTCOMP (:ID, :IDI) RETURNING_VALUES (:ERROR, VER, :IDC);
   if (ERROR = 0) then
    BEGIN
    EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC);
    ESTADO = 'OK';
    END
   ELSE
    ESTADO = 'ERROR';
   suspend;
  End
  END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE CONTABILICE_COMP_SIMPLIFICADO(
    IDI INTEGER)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable ERROR INTEGER;
BEGIN
FOR SELECT FACO_ID, PREF_PRE, FACO_NUMERO FROM FACTURAS_COMPRA C, PROVEEDORES P WHERE
    C.TERC_NIT = P.TERC_NIT AND PROV_SIMPLIFICADO = 'S' AND FACO_ANULADO = 'N'
    ORDER BY FACO_ID INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  ESTADO = 'PROCESANDO';
  SUSPEND;
  /* BORRE LA CONTABILIZACION */
/*  delete FROM comprobante_detalle WHERE ENCO_CONSEC IN (SELECT ENCO_CONSEC FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 21 AND ENCO_IDREF = :ID);
  DELETE FROM comprobante_encabezado  WHERE ENCO_TIPOREF = 21 AND ENCO_IDREF = :ID; */
  EXECUTE PROCEDURE CONTABIL_FACTCOMP (:ID, :IDI) RETURNING_VALUES (:ERROR, VER, :IDC);
  if (ERROR = 0) then
    BEGIN
/*    EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC); */
    ESTADO = 'OK';
    END
  ELSE
    ESTADO = 'ERROR';
  suspend;
  END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE FACTCOMP_SIN_CONTABILIDAD(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDI INTEGER,
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable FECICNT VARCHAR(10);
declare variable FECFCNT VARCHAR(10);
declare variable ERROR INTEGER;
declare variable idref INTEGER;
BEGIN
EXECUTE PROCEDURE fecha_a_conta(FECINI) returning_values (FECICNT);
EXECUTE PROCEDURE fecha_a_conta(FECFIN) returning_values (FECFCNT);
FOR SELECT FACO_ID, PREF_PRE, FACO_NUMERO FROM FACTURAS_COMPRA WHERE FACO_ANULADO = 'N' AND
    FACO_FECHA >= :FECINI AND FACO_FECHA <= :FECFIN ORDER BY FACO_ID
    INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  idref = null;
  SELECT ENCO_IDREF FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 21 AND ENCO_FECHA >= :FECICNT AND ENCO_FECHA <= :FECFCNT and ENCO_IDREF = :id into :idref;
  if (idref IS NULL) then
  begin
   ESTADO = 'PROCESANDO';
   SUSPEND;
   SELECT MAX(INCO_ID) FROM INTERFAZ_COMPRAS WHERE PREF_PRE = :PREF AND TIDO_COD = 21 INTO :IDI;
   EXECUTE PROCEDURE CONTABIL_FACTCOMP (:ID, :IDI) RETURNING_VALUES (:ERROR, VER, :IDC);
   if (ERROR = 0) then
    BEGIN
    EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC);
    ESTADO = 'OK';
    END
   ELSE
    ESTADO = 'ERROR';
   suspend;
  End
  END
END

^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE CONTABIL_DEVOLCOMP(
    IDDOC INTEGER,
    IDINTER INTEGER)
RETURNS (
    ERROR INTEGER,
    VER CHAR(1),
    IDC INTEGER)
AS
declare variable PREFIJO VARCHAR(4);
declare variable NUM VARCHAR(6);
declare variable NUMERO VARCHAR(10);
declare variable FECAUX DATE;
declare variable FECHA CHAR(8);
declare variable CONCEPTO CHAR(100);
declare variable NUMFAC VARCHAR(10);
declare variable VRDTO NUMERIC(18, 2);
declare variable VRADIC NUMERIC(18, 2);
declare variable VRSUBT NUMERIC(18, 2);
declare variable VRIVA NUMERIC(18, 2);
declare variable PRTFTE NUMERIC(9, 2);
declare variable VRRTFTE NUMERIC(18, 2);
declare variable VRRTIVA NUMERIC(18, 2);
declare variable PRTICA NUMERIC(9, 2);
declare variable VRRTICA NUMERIC(18, 2);
declare variable VRTOTAL NUMERIC(18, 2);
declare variable VREXTRA NUMERIC(18, 2);
declare variable TIPOCOMP VARCHAR(3);
declare variable PREFCONT VARCHAR(4);
declare variable INVEN CHAR(1);
declare variable CTAINVEN VARCHAR(20);
declare variable IVA CHAR(1);
declare variable CTAIVA VARCHAR(20);
declare variable CONSUMO CHAR(1);
declare variable CTACONSUMO VARCHAR(20);
declare variable CXP CHAR(1);
declare variable CTACXP VARCHAR(20);
declare variable RTFTE CHAR(1);
declare variable CTARTFTE VARCHAR(20);
declare variable RTIVA CHAR(1);
declare variable CTARTIVA VARCHAR(20);
declare variable RTICA CHAR(1);
declare variable CTARTICA VARCHAR(20);
declare variable CTADTO VARCHAR(20);
declare variable CTAADIC VARCHAR(20);
declare variable CTAEXTRA VARCHAR(20);
declare variable EXISTE CHAR(1);
declare variable CUENTA VARCHAR(20);
declare variable MONTO NUMERIC(18,2);
declare variable TIPOCUEN CHAR(1);
declare variable NIT VARCHAR(20);
declare variable PROY VARCHAR(4);
declare variable CENTRO VARCHAR(4);
declare variable PORC NUMERIC(5,2);
declare variable DEBITO NUMERIC(18,2);
declare variable CREDITO NUMERIC(18,2);
declare variable NUMITEMS INTEGER;
declare variable ARTICULO VARCHAR(15);
declare variable IMPINC CHAR(1);
declare variable IMPTOS NUMERIC(18, 2);
declare variable SUMA NUMERIC(18,2);
declare variable PORCIVA NUMERIC(9,2);
declare variable TCTAPROV VARCHAR(20);
declare variable TCTARTFTE VARCHAR(20);
declare variable TCTARTIVA VARCHAR(20);
declare variable TCTARTICA VARCHAR(20);
declare variable CUENTAADIC VARCHAR(20);
declare variable BASEADIC VARCHAR(20);
declare variable PORCADIC NUMERIC(5,2);
declare variable VALORADIC NUMERIC(18,2);
declare variable DBADIC CHAR(1);
declare variable FOMENTO CHAR(2);
declare variable ANULADO CHAR(1);
declare variable CENT CHAR(1);
declare variable ERRORC INTEGER;
DECLARE VARIABLE MENORV CHAR(2);
DECLARE VARIABLE MERCANCIA NUMERIC(18,2);
declare variable FACTOR DOUBLE PRECISION;
declare variable DIG INTEGER;
BEGIN
/* BUSQUE LA INTERFACE */
EXISTE = 'N';
SELECT 'S', TICO_COD, PRCO_PRE, INCO_INVEN, INCO_IVA, INCO_CONSUMO, INCO_CXP, INCO_RTFTE, INCO_RTIVA, INCO_RTICA, INCO_CTAINVEN, INCO_CTAIVA, INCO_CTACONSUMO, INCO_CTADTO, INCO_CTAADIC, INCO_CTAEXTRA, INCO_CTACXP, INCO_CTARTFTE, INCO_CTARTIVA, INCO_CTARTICA, INCO_CONFIRMAR, INCO_CENTRO
    FROM INTERFAZ_COMPRAS
    WHERE INCO_ID = :IDINTER
    INTO :EXISTE, :TIPOCOMP, :PREFCONT, :INVEN, :IVA, :CONSUMO, :CXP, :RTFTE, :RTIVA, :RTICA, :CTAINVEN, :CTAIVA, :CTACONSUMO, :CTADTO, :CTAADIC, :CTAEXTRA, :CTACXP, :CTARTFTE, :CTARTIVA, :CTARTICA, :VER, :CENT;
if (EXISTE = 'S') then
   BEGIN
    /* BORRE CUALQUEIR CONTABILIZACION PREVIA */
    DELETE FROM CONTABILIZACION WHERE CNTB_TIPOREF = 24 AND CNTB_IDREF = :IDDOC;
   /* TRAIGA EL ENCABEZADO DE LA DEVOLUCION */
   SELECT PREF_PRE, DVCO_NUMERO, DVCO_FECHA, D.TERC_NIT, DVCO_FACTURA, DVCO_IMPTOS, DVCO_DTOMONTO, DVCO_ADICIONAL, DVCO_IVAMONTO, DVCO_EXTRA, DVCO_TOTAL, DVCO_RTFTEPORC, DVCO_RTFTEMONTO, DVCO_RTIVAPORC, DVCO_RTIVAMONTO, DVCO_RTICAPORC, DVCO_RTICAMONTO, PROV_CTARTFTE, PROV_CTARTIVA, PROV_CTARTICA, PROV_CTAPAGAR, DVCO_ANULADO
        FROM DEVOLUCIONES_COMPRAS D, TERCEROS T, PROVEEDORES P
        WHERE DVCO_ID = :IDDOC AND D.TERC_NIT = T.TERC_NIT AND T.TERC_NIT = P.TERC_NIT
        INTO :PREFIJO, :NUM, :FECAUX, :NIT, :NUMFAC, :IMPINC, :VRDTO, :VRADIC, :VRIVA, :VREXTRA, :VRTOTAL, :PRTFTE, :VRRTFTE, :PORC, :VRRTIVA, :PRTICA, :VRRTICA, :TCTARTFTE, TCTARTIVA, TCTARTICA, TCTAPROV, ANULADO;
   if (ANULADO = 'N') then
    BEGIN
    NUMERO = PREFIJO || NUM;
    VRSUBT = VRTOTAL - VREXTRA - VRIVA; /* BASE DE RETEFTE Y RETEICA */
    IF (CENT = 'B') THEN
        SELECT BODE_CENTRO, BODE_PROY FROM BODEGA B, DEVOLUCIONES_COMPRAS F
            WHERE B.BODE_COD = F.BODE_COD AND F.DVCO_ID = :IDDOC INTO :CENTRO, :PROY;
    ELSE
        SELECT PREF_CENTRO,PREF_PROY FROM PREFIJOS P, DEVOLUCIONES_COMPRAS F
            WHERE P.PREF_PRE = F.PREF_PRE AND F.DVCO_ID = :IDDOC AND P.TIDO_COD = 24 INTO :CENTRO, :PROY;
    /* CONVIERTA LA FECHA A CADENA */
    EXECUTE PROCEDURE FECHA_A_CONTA(:FECAUX) returning_values (:FECHA);
    EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'USAR IMPOCONSUMO COMO PORCENTAJE DE FOMENTO') RETURNING_VALUES (FOMENTO);
    EXECUTE PROCEDURE lee_configuracion('COMPRAS','FACTURAS','DESCUENTO Y VALOR ADICIONAL DEL DOCUMENTO COMO MENOR VALOR DEL COSTO') returning_values (:MENORV);
    SELECT CAST(CONF_VALOR AS INTEGER) FROM CONFIGURACION WHERE CONF_MODULO = 'COMPRAS' AND CONF_CATEGORIA = 'GENERAL' AND CONF_PROPIEDAD = 'REDONDEO AL MULTIPLO DE DIEZ EN TOTALES' INTO :DIG;
    VRSUBT = VRTOTAL - VREXTRA - VRIVA;
    MERCANCIA = VRSUBT - VRADIC + VRDTO;
    SELECT SUM(DVCD_consumo) from devoluciones_compras_det where dvco_id = :IDDOC into :valoradic;
    if (MENORV = 'SI') then
        if (MERCANCIA <> 0) then
            FACTOR = (CAST(VRSUBT AS DOUBLE PRECISION) - VALORADIC) / (CAST(MERCANCIA AS DOUBLE PRECISION) - VALORADIC);
        ELSE
            FACTOR = 1;
    ELSE
        FACTOR = 1;

    /* REGISTRE EL ENCABEZADO CONTABLE */
    CONCEPTO = 'DEVOLUCION COMPRA No. ' || NUMERO || ' EN FACTURA ' || NUMFAC;
    IDC = GEN_ID(ID_CONTABILIZA, 1);
    INSERT INTO CONTABILIZACION (CNTB_ID, CNTB_TIPOCOMP, CNTB_PREFCNT, CNTB_NUMERO, CNTB_FECHA, CNTB_CONCEPTO, CNTB_REF, CNTB_TIPOREF, CNTB_IDREF, CNTB_PREFREF, CNTB_NUMREF, CNTB_PROCESADO)
        VALUES (:IDC, :TIPOCOMP, :PREFCONT, :NUM, :FECHA, :CONCEPTO, '', 24, :IDDOC, :PREFIJO, :NUM, 'N');

    NUMITEMS = 0;
    SUMA = 0;
    ERROR = 0;
    /* CUENTAS DE INVENTARIO */
    if (INVEN = 'A') then
        BEGIN
        /* SUME LAS BASES DE LOS ARTICULOS DEL DOCUMENTO */
        FOR SELECT MAX(COAR_CTACOMP), SUM(cast(DVCD_CANT as double precision) * (DVCD_PRUNIT-DVCD_DTOMONTO)), SUM(DVCD_IVAMONTO), SUM(DVCD_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_COMPRAS_DET F
            WHERE F.DVCO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTAINV
            INTO :CTAINVEN, :MONTO, :IMPTOS, :VALORADIC
            DO
            BEGIN
            if (IMPINC = 'S') then
                BEGIN
                MONTO = MONTO - IMPTOS;
                if (FOMENTO <> 'SI') then
                    MONTO = MONTO - VALORADIC;
                END
            /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
            EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            /* DEPENDE DEL TIPO DE CUENTA */
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, (cast(DVCD_CANT as double precision) * (DVCD_PRUNIT-DVCD_DTOMONTO)), DVCD_IVAMONTO, DVCD_CONSUMO
                    FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_COMPRAS_DET F
                    WHERE F.DVCO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAINV = :CUENTA
                    INTO :ARTICULO, :MONTO, :IMPTOS, :VALORADIC
                DO
                    BEGIN
                    if (IMPINC = 'S') then
                        BEGIN
                        MONTO = MONTO - IMPTOS;
                        if (FOMENTO <> 'SI') then
                            MONTO = MONTO - VALORADIC;
                        END
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    SUMA = SUMA - MONTO;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                /* INSERTE EL REGISTRO DE LA BASE */
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
                NUMITEMS = NUMITEMS + 1;
                SUMA = SUMA - MONTO;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                /* INSERTE EL REGISTRO DE LA BASE */
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NUMITEMS = NUMITEMS + 1;
                SUMA = SUMA - MONTO;
                END
            END /* FOR */
        END /* INVENTARIO X ARTICULO */

    if (INVEN = 'K') then
        BEGIN
        /* SUME LAS BASES DE LOS ARTICULOS DEL DOCUMENTO */
        SELECT SUM(cast(DVCD_CANT as double precision) * (DVCD_PRUNIT-DVCD_DTOMONTO)), SUM(DVCD_IVAMONTO), SUM(DVCD_CONSUMO)
            FROM DEVOLUCIONES_COMPRAS_DET WHERE DVCO_ID = :IDDOC
            INTO :MONTO, :IMPTOS, :VALORADIC;
        if (IMPINC = 'S') then
            BEGIN
            MONTO = MONTO - IMPTOS;
            if (FOMENTO <> 'SI') then
                MONTO = MONTO - VALORADIC;
            END
        /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
        EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        /* DEPENDE DEL TIPO DE CUENTA */
        if (TIPOCUEN = 'I') then
            BEGIN
            /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
            FOR SELECT ARTI_COD, (cast(DVCD_CANT as double precision) * (DVCD_PRUNIT-DVCD_DTOMONTO)), DVCD_IVAMONTO, DVCD_CONSUMO
                FROM DEVOLUCIONES_COMPRAS_DET
                WHERE DVCO_ID = :IDDOC
                INTO :ARTICULO, :MONTO, :IMPTOS, :VALORADIC
                DO
                BEGIN
                if (IMPINC = 'S') then
                    BEGIN
                    MONTO = MONTO - IMPTOS;
                    if (FOMENTO <> 'SI') then
                        MONTO = MONTO - VALORADIC;
                    END
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CTAINVEN, :CONCEPTO, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                NUMITEMS = NUMITEMS + 1;
                SUMA = SUMA - MONTO;
                END
            END
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CTAINVEN, :CONCEPTO, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA - MONTO;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CTAINVEN, :CONCEPTO, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA - MONTO;
            END
        END /* INVEN = K */
        
    /* EL IVA */
    if (IVA = 'A') then
        BEGIN
        /* SUME LAS BASES DE LOS ARTICULOS DEL DOCUMENTO */
        FOR SELECT MAX(COAR_CTAIVAC), SUM(DVCD_IVAMONTO), SUM(cast(DVCD_CANT as double precision) * (DVCD_PRUNIT-DVCD_DTOMONTO)), SUM(DVCD_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_COMPRAS_DET F
            WHERE F.DVCO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTAIVAC
            INTO :CTAIVA, :IMPTOS, :MONTO, :VALORADIC
        DO
          if (IMPTOS <> 0) then
            BEGIN
            if (IMPINC = 'S') then
                BEGIN
                MONTO = MONTO - IMPTOS;
                if (FOMENTO <> 'SI') then
                    MONTO = MONTO - VALORADIC;
                END

            /* TRAIGA LAS CARCATERISTICAS DE LA CUENTA */
            EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            /* DEPENDE DEL TIPO DE CUENTA */
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, DVCD_IVAMONTO, (cast(DVCD_CANT as double precision) * (DVCD_PRUNIT-DVCD_DTOMONTO)), TAIV_PORC, DVCD_CONSUMO
                    FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_COMPRAS_DET F, TARIFA_IVA T
                    WHERE F.DVCO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAIVAV = :CUENTA AND A.TAIV_COD = T.TAIV_COD
                    INTO :ARTICULO, :IMPTOS, :MONTO, :PORCIVA, :VALORADIC
                DO
                    BEGIN
                    if (IMPINC = 'S') then
                        BEGIN
                        MONTO = MONTO - IMPTOS;
                        if (FOMENTO <> 'SI') then
                            MONTO = MONTO - VALORADIC;
                        END
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :IMPTOS, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
                NUMITEMS = NUMITEMS + 1;
                SUMA = SUMA - IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NUMITEMS = NUMITEMS + 1;
                SUMA = SUMA - IMPTOS;
                END
            END /* FOR */
        END /* IVA X ARTICULO */
        
    if (IVA = 'K') then /* IVA EN CTA CONSTANTE */
        BEGIN
        SELECT SUM(DVCD_IVAMONTO), SUM(cast(DVCD_CANT as double precision) * (DVCD_PRUNIT-DVCD_DTOMONTO)), SUM(DVCD_CONSUMO)
            FROM DEVOLUCIONES_COMPRAS_DET F
            WHERE F.DVCO_ID = :IDDOC 
            INTO :IMPTOS, :MONTO, :VALORADIC;
            
        if (IMPTOS <> 0) then
            BEGIN
            if (IMPINC = 'S') then
                BEGIN
                MONTO = MONTO - IMPTOS;
                if (FOMENTO <> 'SI') then
                    MONTO = MONTO - VALORADIC;
                END
            /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
            EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            /* DEPENDE DEL TIPO DE CUENTA */
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, (cast(DVCD_CANT as double precision) * (DVCD_PRUNIT-DVCD_DTOMONTO)), DVCD_IVAMONTO, TAIV_PORC, DVCD_CONSUMO
                    FROM ARTICULO A, DEVOLUCIONES_COMPRAS_DET F, TARIFA_IVA T
                    WHERE F.DVCO_ID = :IDDOC AND A.TAIV_COD = T.TAIV_COD
                    INTO :ARTICULO, :MONTO, :IMPTOS, :PORCIVA, :VALORADIC
                    DO
                    BEGIN
                    if (IMPTOS <> 0) then
                        BEGIN
                        if (IMPINC = 'S') then
                            BEGIN
                            MONTO = MONTO - IMPTOS;
                            if (FOMENTO <> 'SI') then
                                MONTO = MONTO - VALORADIC;
                            END
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CTAIVA, :CONCEPTO, '', 0, :IMPTOS, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                        NUMITEMS = NUMITEMS + 1;
                        SUMA = SUMA - IMPTOS;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                /* INSERTE EL REGISTRO DE LA BASE */
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CTAIVA, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
                NUMITEMS = NUMITEMS + 1;
                SUMA = SUMA - IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                /* INSERTE EL REGISTRO DE LA BASE */
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NUMITEMS, :CTAIVA, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NUMITEMS = NUMITEMS + 1;
                SUMA = SUMA - IMPTOS;
                END
            END /* <> 0 */
        END /* IVA EN CTA CONSTANTE */
        
    /* EL IMPOCONSUMO */
    if (CONSUMO = 'A') then
        BEGIN
        /* SUME LAS BASES DE LOS ARTICULOS DEL DOCUMENTO */
        FOR SELECT MAX(COAR_CTACONS), SUM(DVCD_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_COMPRAS_DET F
            WHERE F.DVCO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTACONS
            INTO :CTACONSUMO, :IMPTOS
        DO
            BEGIN
            if (IMPTOS <> 0) then
                BEGIN
                /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
                EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (FOMENTO <> 'SI') then
                    BEGIN
                    /* DEPENDE DEL TIPO DE CUENTA */
                    if (TIPOCUEN = 'I') then
                        BEGIN
                        /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                        FOR SELECT F.ARTI_COD, DVCD_CONSUMO
                            FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_COMPRAS_DET F
                            WHERE F.DVCO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTACONS = :CUENTA
                            INTO :ARTICULO, :IMPTOS
                            DO
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                            NUMITEMS = NUMITEMS + 1;
                            SUMA = SUMA - IMPTOS;
                            END
                        END
                    if (TIPOCUEN = 'C') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
                        NUMITEMS = NUMITEMS + 1;
                        SUMA = SUMA - IMPTOS;
                        END
                    if (TIPOCUEN = 'N') then
                        BEGIN
                        /* INSERTE EL REGISTRO DE LA BASE */
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        NUMITEMS = NUMITEMS + 1;
                        SUMA = SUMA - IMPTOS;
                        END
                    END
                ELSE
                    BEGIN
                    if (TIPOCUEN = 'I') then
                        BEGIN
                        /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                        FOR SELECT F.ARTI_COD, DVCD_CONSUMO
                            FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_COMPRAS_DET F
                            WHERE F.DVCO_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTACONS = :CUENTA
                            INTO :ARTICULO, :IMPTOS
                            DO
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                            NUMITEMS = NUMITEMS + 1;
                            SUMA = SUMA + IMPTOS;
                            END
                        END
                    if (TIPOCUEN = 'C') then
                        BEGIN
                        /* INSERTE EL REGISTRO DE LA BASE */
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
                        NUMITEMS = NUMITEMS + 1;
                        SUMA = SUMA + IMPTOS;
                        END
                    if (TIPOCUEN = 'N') then
                        BEGIN
                        /* INSERTE EL REGISTRO DE LA BASE */
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        NUMITEMS = NUMITEMS + 1;
                        SUMA = SUMA + IMPTOS;
                        END
                    END
                END
            END /* FOR */
        END /* CONSUMO X ARTICULO */
        
    if (CONSUMO = 'K') then /* CONSUMO EN CTA CONSTANTE */
        BEGIN
        SELECT SUM(DVCD_CONSUMO)
            FROM DEVOLUCIONES_COMPRAS_DET F
            WHERE F.DVCO_ID = :IDDOC 
            INTO :IMPTOS;
            
        if (IMPTOS <> 0) then
            BEGIN
            /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
            EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (FOMENTO <> 'SI') then
                BEGIN
                /* DEPENDE DEL TIPO DE CUENTA */
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, DVCD_CONSUMO
                        FROM ARTICULO A, DEVOLUCIONES_COMPRAS_DET F
                        WHERE F.DVCO_ID = :IDDOC
                        INTO :ARTICULO, :IMPTOS
                        DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                        NUMITEMS = NUMITEMS + 1;
                        SUMA = SUMA - IMPTOS;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    /* INSERTE EL REGISTRO DE LA BASE */
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
                    NUMITEMS = NUMITEMS + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    /* INSERTE EL REGISTRO DE LA BASE */
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                END
            ELSE
                BEGIN
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, DVCD_CONSUMO
                        FROM ARTICULO A, DEVOLUCIONES_COMPRAS_DET F
                        WHERE F.DVCO_ID = :IDDOC
                        INTO :ARTICULO, :IMPTOS
                        DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ARTICULO, 0, 0);
                        NUMITEMS = NUMITEMS + 1;
                        SUMA = SUMA + IMPTOS;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    /* INSERTE EL REGISTRO DE LA BASE */
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
                    NUMITEMS = NUMITEMS + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    /* INSERTE EL REGISTRO DE LA BASE */
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CTACONSUMO, :CONCEPTO, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NUMITEMS = NUMITEMS + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                END
            END
        END /* CONSUMO EN CTA CONSTANTE */
        
    /* DESCUENTO */
    if ((CTADTO IS NOT NULL) AND
        (CTADTO <> '') AND
        (VRDTO <> 0)) THEN
        BEGIN
        /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
        EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTADTO, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRDTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA + VRDTO;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            /* INSERTE EL REGISTRO DE LA BASE */
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRDTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA + VRDTO;
            END
        END /* DESCUENTO */
        
    /* VALOR ADIC */
    if ((CTAADIC IS NOT NULL) AND
        (CTAADIC <> '') AND
        (VRADIC <> 0)) THEN
        BEGIN
        /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
        EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTAADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRADIC, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA - VRADIC;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            /* INSERTE EL REGISTRO DE LA BASE */
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', 0, :VRADIC, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA - VRADIC;
            END
        END /* VR. ADIC */
        
    /* VALOR EXTRA */
    if ((CTAEXTRA IS NOT NULL) AND
        (CTAEXTRA <> '') AND
        (VREXTRA <> 0)) THEN
        BEGIN
        /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
        EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTAEXTRA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VREXTRA, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA + VREXTRA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            /* INSERTE EL REGISTRO DE LA BASE */
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VREXTRA, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA + VREXTRA;
            END
        END /* VR. EXTRA */
        
    if (fomento <> 'SI') then
        BEGIN
        /* DESCUENTE EL IMPOCONSUMO */
        SELECT SUM(DVCD_CONSUMO)
            FROM devoluciones_compras_det WHERE DVCO_ID = :IDDOC INTO :IMPTOS;
        if (IMPTOS IS NULL) then
            IMPTOS = 0;
        vrsubt = vrsubt - IMPTOS;
        END
    /* RETENCION FUENTE */
    if ((RTFTE = 'P') or (RTFTE = 'K')) then
      if (VRRTFTE <> 0) then
        BEGIN
        if (RTFTE = 'P') then
            CTARTFTE = TCTARTFTE;
            
        /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
        EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA + VRRTFTE;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            /* INSERTE EL REGISTRO DE LA BASE */
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA + VRRTFTE;
            END
        END /* RTFTE */
    if (RTFTE = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTARTFTE), MAX(COAR_RTFTE), MIN(COAR_RTBASE), SUM(DVCD_TOTAL-DVCD_IVAMONTO-DVCD_CONSUMO), SUM((DVCD_TOTAL-DVCD_IVAMONTO-DVCD_CONSUMO)*COAR_RTFTE)
            FROM CONTABIL_ARTICULO C, DEVOLUCIONES_COMPRAS_DET F
            WHERE F.dvco_id = :IDDOC AND F.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTARTFTE
            INTO :CTARTFTE, :PRTFTE, :baseadic, :MONTO, :VRRTFTE
            DO
            BEGIN
            MONTO = MONTO * FACTOR;
            if (MONTO >= BASEADIC) then
                BEGIN
                VRRTFTE = VRRTFTE * FACTOR / 100;
                execute procedure redondee(VRRTFTE, DIG) returning_values (VRRTFTE);
                execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                if (VRRTFTE <> 0) then
                    BEGIN
                    /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
                    EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                    if (ERRORC <> 0) then
                        ERROR = ERROR + 1;
                    if (TIPOCUEN = 'C') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
                        NUMITEMS = NUMITEMS + 1;
                        SUMA = SUMA + VRRTFTE;
                        END
                    if (TIPOCUEN = 'N') then
                        BEGIN
                        /* INSERTE EL REGISTRO DE LA BASE */
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        NUMITEMS = NUMITEMS + 1;
                        SUMA = SUMA + VRRTFTE;
                        END
                    END
                END
            END
        END /* RTFTE */
    /* RETENCION IVA */
    if ((RTIVA = 'P') or (RTIVA = 'K')) then
      if (VRRTIVA <> 0) then
        BEGIN
        if (RTIVA = 'P') then
            CTARTIVA = TCTARTIVA;
            
        /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
        EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTARTIVA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRRTIVA, 0, :VRIVA, :PORC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA + VRRTIVA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            /* INSERTE EL REGISTRO DE LA BASE */
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRRTIVA, 0, :VRIVA, :PORC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA + VRRTIVA;
            END
        END /* RTIVA */
        
    /* RETENCION DE ICA */
    if ((RTICA = 'P') or (RTICA = 'K')) then
      if (VRRTICA <> 0) then
        BEGIN
        if (RTICA = 'P') then
            CTARTICA = TCTARTICA;
            
        /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
        EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTARTICA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRRTICA, 0, :VRSUBT, :PRTICA, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA + VRRTICA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            /* INSERTE EL REGISTRO DE LA BASE */
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :VRRTICA, 0, :VRSUBT, :PRTICA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NUMITEMS = NUMITEMS + 1;
            SUMA = SUMA + VRRTICA;
            END
        END /* RTICA */
    /* recorra las cuentas adicionales */
    FOR SELECT INCC_CUENTA, INCC_BASE, INCC_PORC, INCC_VALOR, INCC_DB
        FROM INTERFAZ_COMPRAS_CTAS
        WHERE INCO_ID = :IDINTER
        INTO :CUENTAADIC, :BASEADIC, :PORCADIC, :VALORADIC, :DBADIC
        DO
        BEGIN
        if (VALORADIC <> 0) then
            MONTO = VALORADIC;
        ELSE
            BEGIN
            if (:BASEADIC = 'SUBTOTAL') then
                VALORADIC = VRTOTAL - VREXTRA - VRIVA - VRADIC + VRDTO;
            if (:BASEADIC = 'DESCUENTO') then
                VALORADIC = VRDTO;
            if (:BASEADIC = 'IVA') then
                VALORADIC = VRIVA;
            if (:BASEADIC = 'CONSUMO') then
                SELECT SUM(DVCD_CONSUMO)
                    FROM DEVOLUCIONES_COMPRAS_DET F
                    WHERE F.DVCO_ID = :IDDOC 
                    INTO :VALORADIC;
            if (:BASEADIC = 'ADICIONAL') then
                VALORADIC = VRADIC;
            if (:BASEADIC = 'EXTRA') then
                VALORADIC = VREXTRA;
            if (:BASEADIC = 'TOTAL') then
                VALORADIC = VRTOTAL;
            MONTO = VALORADIC * PORCADIC;
            END
        if (MONTO <> 0) then
            BEGIN
            /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
            EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CUENTAADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                if (DBADIC = 'S') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTAADIC, :CONCEPTO, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
                    SUMA = SUMA + MONTO;
                    END
                ELSE
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTAADIC, :CONCEPTO, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
                    SUMA = SUMA - MONTO;
                    END
                NUMITEMS = NUMITEMS + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                if (DBADIC = 'S') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTAADIC, :CONCEPTO, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    SUMA = SUMA + MONTO;
                    END
                ELSE
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NUMITEMS, :CUENTAADIC, :CONCEPTO, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    SUMA = SUMA - MONTO;
                    END
                NUMITEMS = NUMITEMS + 1;
                END
            NUMITEMS = NUMITEMS + 1;
            END
        END
    /* CIERRE EL COMPROBANTE CONTRA LA CUENTA DEL TERCERO O LA CONSTANTE */
    if ((SUMA <> 0) and ((CXP = 'P') or (CXP = 'K'))) then
        BEGIN
        if (SUMA < 0) then
            BEGIN
            DEBITO = SUMA * -1;
            CREDITO = 0;
            END
        ELSE
            BEGIN
            DEBITO = 0;
            CREDITO = SUMA;
            END
        if (CXP = 'P') then
            CTACXP = TCTAPROV;

        /* TRAIGA LAS CARACTERISTICAS DE LA CUENTA */
        EXECUTE PROCEDURE CUENTA_INTERFAZ(24, :IDDOC, :CTACXP, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 24);
        if (TIPOCUEN = 'N') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NUMITEMS, :CUENTA, :CONCEPTO, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
        END /* SUMA EN CXP */
     end
    if (ERROR > 0) then
        VER = 'S';
    SUSPEND;
    END /* EXISTE */
ELSE
    BEGIN
    EXECUTE PROCEDURE ERROR (24, :IDDOC, :PREFIJO, 1);
    ERROR = ERROR + 1;
    VER = 'S';
    SUSPEND;
    END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE DEVCOMPRA_SIN_CONTABILIDAD(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDI INTEGER,
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable FECICNT VARCHAR(10);
declare variable FECFCNT VARCHAR(10);
declare variable ERROR INTEGER;
declare variable idref INTEGER;
BEGIN /*$$IBE$$ 
EXECUTE PROCEDURE fecha_a_conta(FECINI) returning_values (FECICNT);
EXECUTE PROCEDURE fecha_a_conta(FECFIN) returning_values (FECFCNT);
FOR SELECT DVCO_ID, PREF_PRE, DVCO_NUMERO FROM DEVOLUCIONES_COMPRAS WHERE DVCO_ANULADO = 'N' AND
    DVCO_FECHA >= :FECINI AND DVCO_FECHA <= :FECFIN
    INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  idref = null;
  SELECT ENCO_IDREF FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 24 AND ENCO_FECHA >= :FECICNT AND ENCO_FECHA <= :FECFCNT and ENCO_IDREF = :id into :idref;
  if (idref IS NULL) then
  begin
   ESTADO = 'PROCESANDO';
   SUSPEND;
   SELECT MAX(INCO_ID) FROM INTERFAZ_COMPRAS WHERE PREF_PRE = :PREF AND TIDO_COD = 24 INTO :IDI;
   EXECUTE PROCEDURE CONTABIL_DEVOLCOMP (:ID, :IDI) RETURNING_VALUES (:ERROR, :VER, :IDC);
   if (ERROR = 0) then
    BEGIN
      EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC);
      ESTADO = 'OK';
    end
   ELSE
    ESTADO = 'ERROR';
   suspend;
  End
  END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE DEVCOMPRA_SIN_CONTABILIDAD(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDI INTEGER,
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable FECICNT VARCHAR(10);
declare variable FECFCNT VARCHAR(10);
declare variable ERROR INTEGER;
declare variable idref INTEGER;
BEGIN
EXECUTE PROCEDURE fecha_a_conta(FECINI) returning_values (FECICNT);
EXECUTE PROCEDURE fecha_a_conta(FECFIN) returning_values (FECFCNT);
FOR SELECT DVCO_ID, PREF_PRE, DVCO_NUMERO FROM DEVOLUCIONES_COMPRAS WHERE DVCO_ANULADO = 'N' AND
    DVCO_FECHA >= :FECINI AND DVCO_FECHA <= :FECFIN
    INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  idref = null;
  SELECT ENCO_IDREF FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 24 AND ENCO_FECHA >= :FECICNT AND ENCO_FECHA <= :FECFCNT and ENCO_IDREF = :id into :idref;
  if (idref IS NULL) then
  begin
   ESTADO = 'PROCESANDO';
   SUSPEND;
   SELECT MAX(INCO_ID) FROM INTERFAZ_COMPRAS WHERE PREF_PRE = :PREF AND TIDO_COD = 24 INTO :IDI;
   EXECUTE PROCEDURE CONTABIL_DEVOLCOMP (:ID, :IDI) RETURNING_VALUES (:ERROR, :VER, :IDC);
   if (ERROR = 0) then
    BEGIN
      EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC);
      ESTADO = 'OK';
    end
   ELSE
    ESTADO = 'ERROR';
   suspend;
  End
  END
END

^

SET TERM ; ^

ALTER TABLE CONTABIL_ARTICULO DROP COAR_RTICA;


/* redencion de puntos error */
SET TERM ^ ;

CREATE OR ALTER TRIGGER FACTURAS_BI FOR FACTURAS
ACTIVE BEFORE INSERT POSITION 0
AS
declare variable NUMERO VARCHAR(6);
declare variable AUTOM CHAR(1);
declare variable EXISTE CHAR(1);
DECLARE VARIABLE VALCUPO CHAR(10);
declare variable DISPONIBLE NUMERIC(18,2);
declare variable OK CHAR(1);
declare variable SITOT CHAR(2);
declare variable CODCOBR INTEGER;
declare variable CODVEND INTEGER;
declare variable contado char(1);
BEGIN
OK = 'S';
EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'ACCION A TOMAR SI EL CUPO DE CREDITO ES INSUFICIENTE') RETURNING_VALUES (:VALCUPO);
select max(auto_contado) from autorizaciones where pref_pre = new.pref_pre and tido_cod = 31 and auto_inicial <= new.fact_numero and auto_final >= new.fact_numero into :contado;
if (contado='N') then
BEGIN
  IF (VALCUPO = 'PROHIBIR') THEN
  BEGIN
  OK = 'N';
  /* VERIFIQUE EL CUPO DE CREDITO */
  execute procedure cupo_disponible(new.TERC_NIT, NEW.fact_fecha, NEW.fact_sucursal) returning_values (:DISPONIBLE);
  if (DISPONIBLE >= NEW.FACT_TOTAL) then
    OK = 'S';
  END
END
IF (OK = 'S') THEN
  begin
  /* calcule la comision */
  EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'VENDEDORES', 'COMISIONES EN VENTA INCLUYENDO IMPUESTOS') returning_values (:SITOT);
  if ((NEW.fact_comiporc IS NULL) or (NEW.fact_comiporc = 0)) THEN
    BEGIN
    if (SITOT = 'SI') then
      SELECT MAX(COMI_PORC) FROM comisiones WHERE VEND_COD = NEW.vend_cod AND
        COMI_INICIAL <= NEW.fact_total AND COMI_FINAL >= NEW.fact_total
        INTO NEW.fact_comiporc;
    else
      SELECT MAX(COMI_PORC) FROM comisiones WHERE VEND_COD = NEW.vend_cod AND
        COMI_INICIAL <= (NEW.fact_total -NEW.fact_ivamonto) AND COMI_FINAL >= (NEW.fact_total -NEW.fact_ivamonto)
        INTO NEW.fact_comiporc;
    if (NEW.fact_comiporc IS NULL) then
        NEW.fact_comiporc = 0;
    END
  if (SITOT = 'SI') then
      NEW.fact_comimonto = NEW.fact_total * NEW.fact_comiporc / 100;
  ELSE
      NEW.fact_comimonto = (NEW.fact_total -NEW.fact_ivamonto) * NEW.fact_comiporc / 100;

  if (NEW.numok = 'N') then
    BEGIN
    /* Actualice el contador del prefijo */
    SELECT PREF_ACTUAL, PREF_AUTO FROM PREFIJOS WHERE TIDO_COD = 31 AND PREF_PRE = NEW.PREF_PRE INTO :NUMERO, :AUTOM;
    /* ACTUALICE EL NUMERO EN ENCABEZADO  */
    if (AUTOM = 'S') then
        BEGIN
        NEW.FACT_NUMERO = NUMERO;
        NUMERO = CAST((CAST(NUMERO AS INTEGER) + 1) AS CHAR(6));
        UPDATE PREFIJOS
            SET PREF_ACTUAL = :NUMERO
            WHERE TIDO_COD = 31 AND PREF_PRE = NEW.PREF_PRE;
        END
    ELSE
        BEGIN
        if (CAST(NUMERO AS INTEGER) = CAST(NEW.FACT_NUMERO AS INTEGER)) then
            UPDATE PREFIJOS
                SET PREF_ACTUAL = CAST((CAST(PREF_ACTUAL AS INTEGER) + 1) AS CHAR(6))
                WHERE TIDO_COD = 31 AND PREF_PRE = NEW.PREF_PRE;
        END
    EXECUTE PROCEDURE COMPLETA_CEROS (NEW.FACT_numero) returning_values (NEW.FACT_numero);
    NEW.numok = 'S';
    END
  /* Verifique que el numero no existe previamente */
  EXISTE = 'N';
  SELECT 'S' FROM FACTURAS WHERE PREF_PRE = NEW.PREF_PRE AND FACT_NUMERO = NEW.FACT_NUMERO INTO :EXISTE;
  if (EXISTE = 'S') then
    EXCEPTION DOCUMENTO_REGISTRADO;
  end
else
  begin
  EXCEPTION CUPO_INSUFICIENTE;
  end

select COBR_COD, VEND_COD FROM CLIENTE_SUCURSALES WHERE TERC_NIT = NEW.terc_nit AND CLCU_COD = NEW.fact_sucursal INTO :CODCOBR, CODVEND;
if (NEW.vend_cod IS NULL) then
    NEW.vend_cod = :CODVEND;
if (NEW.cobr_cod IS NULL) then
    BEGIN
    EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'COMISIONES', 'UNIFICAR CODIGOS DE VENDEDORES Y COBRADORES') returning_values (:SITOT);
    if ((SITOT = 'SI') AND (NEW.vend_cod IS NOT NULL)) then
        NEW.cobr_cod = NEW.vend_cod;
    else
        NEW.cobr_cod = :CODCOBR;
    END
if ((new.FACT_TOTAL-new.FACT_IVAMONTO+new.FACT_DTOMONTO-new.FACT_ADICIONAL) = 0) then
    NEW.FACT_FACTOR = 1;
else
    NEW.FACT_FACTOR = (new.FACT_TOTAL-new.FACT_IVAMONTO)/(new.FACT_TOTAL-new.FACT_IVAMONTO+new.FACT_DTOMONTO-new.FACT_ADICIONAL);
END
^

SET TERM ; ^


SET TERM ^ ;

CREATE OR ALTER PROCEDURE CONSULTA_PUNTOS_CLIENTE(
    IDDOC INTEGER,
    CLIENTE VARCHAR(20),
    FECHA DATE)
RETURNS (
    PTDOC INTEGER,
    PTACUM INTEGER,
    PTVENCER INTEGER)
AS
declare variable numrows integer;
declare variable anos integer;
declare variable fecaux date;
declare variable fecaux2 date;
declare variable nitcontado varchar(20);
declare variable ok integer;
declare variable ptaux integer;
begin
ptdoc = 0;
ptacum = 0;
ptvencer = 0;
ok = 1;
if (IDDOC <> 0) then
    begin
    /* verifique que no sea cliente de contado de la autorizacin */
    select max(auto_nitcontado) from facturas f, autorizaciones a
        where f.pref_pre = a.pref_pre and fact_id = :iddoc into :nitcontado;
    if (cliente = nitcontado) then
        ok = 0;

    if (ok <> 0) then
        begin
        select count(ptcl_id) from puntos_cliente where ptcl_nit = :cliente and ptcl_tipodoc = 31 and ptcl_iddoc = :iddoc into :numrows;
        if (numrows <> 0) then
            begin
            select ptcl_db-ptcl_cr from puntos_cliente where ptcl_nit = :cliente and ptcl_tipodoc = 31 and ptcl_iddoc = :iddoc into :ptdoc;
            end
        end
    end
/* los puntos totales */
numrows = 0;
select max(ptcl_fecha) from puntos_cliente where ptcl_nit = :cliente and ptcl_fecha <= :fecha into :fecaux;
if (fecaux is not null) then
    select max(ptcl_saldo), sum(ptcl_db - ptcl_cr) from puntos_cliente where ptcl_nit = :cliente and ptcl_fecha = :fecaux into :ptacum, :ptvencer;
if (ptacum is null) then
    ptacum = 0;
if (ptvencer is null) then
    ptvencer = 0;
ptacum = ptacum + ptvencer;
/* reste los vencidos */
execute procedure lee_configuracion('FACTURACION', 'FACTURAS', 'VENCIMIENTO DE PUNTOS POR CLIENTE EN AOS') returning_values (:anos);
fecaux = fecha - (anos * 365);
select max(ptcl_fecha) from puntos_cliente where ptcl_nit = :cliente and ptcl_fecha <= :fecaux into :fecaux;
if (fecaux is not null) then
    select max(ptcl_saldo), sum(ptcl_db - ptcl_cr) from puntos_cliente where ptcl_nit = :cliente and ptcl_fecha = :fecaux into :ptvencer, :ptaux;
else
    begin
    ptvencer = 0;
    ptaux = 0;
    end
if (ptvencer is null) then
    ptvencer = 0;
if (ptaux is null) then
    ptaux = 0;
ptacum = ptacum - ptvencer - ptaux;
/* los por vencer */
execute procedure lee_configuracion('FACTURACION', 'FACTURAS', 'VENCIMIENTO DE PUNTOS POR CLIENTE EN AOS') returning_values (:anos);
fecaux = fecha - (anos * 365);
fecaux2 = fecha - (anos * 365) + 30;
select sum(ptcl_db - ptcl_cr) from puntos_cliente where ptcl_nit = :cliente and ptcl_fecha >= :fecaux and ptcl_fecha <= :fecaux2 into :ptvencer;
if (ptvencer is null) then
    ptvencer = 0;
suspend;
end
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE IMPR_FACTURA(
    ID INTEGER)
RETURNS (
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    VENCE DATE,
    DIASVENCE INTEGER,
    CONTCRED CHAR(7),
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    VENDEDOR INTEGER,
    NOMVENDEDOR VARCHAR(60),
    PUNTOVTA INTEGER,
    NOMPUNTOVTA VARCHAR(30),
    CODBODEGA VARCHAR(2),
    NOMBODEGA VARCHAR(30),
    AUTORIZACION VARCHAR(20),
    DESPACHO VARCHAR(255),
    TRANSPORTADOR VARCHAR(60),
    COTIZACION VARCHAR(30),
    PEDIDO VARCHAR(30),
    REMISION VARCHAR(30),
    PACIENTE VARCHAR(20),
    NOMPACIENTE VARCHAR(60),
    COMIPORC NUMERIC(9,2),
    COMIMONTO NUMERIC(18,2),
    SUBTOTAL NUMERIC(18,2),
    DTOPORC NUMERIC(9,2),
    DTOMONTO NUMERIC(18,2),
    ADICIONAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    RTEFTEPORC NUMERIC(9,2),
    RTEFTEMONTO NUMERIC(18,2),
    RTEIVAPORC NUMERIC(9,2),
    RTEIVAMONTO NUMERIC(18,2),
    RTEICAPORC NUMERIC(9,2),
    RTEICAMONTO NUMERIC(18,2),
    EXTRA NUMERIC(18,2),
    DTOFPORC NUMERIC(9,2),
    DTOFMONTO NUMERIC(18,2),
    FECHADTO DATE,
    TOTALFAC NUMERIC(18,2),
    TOTALPAGAR NUMERIC(18,2),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    LOTE VARCHAR(15),
    VLOTE DATE,
    UNIDAD VARCHAR(8),
    FACTOR INTEGER,
    LISTAPR INTEGER,
    REFITEM VARCHAR(60),
    BODITEM VARCHAR(2),
    PRUNIT NUMERIC(18,2),
    DTOITPORC NUMERIC(9,2),
    DTOITMONTO NUMERIC(18,2),
    PRNETO NUMERIC(18,2),
    IVAPORC NUMERIC(9,2),
    IVAITMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    SUBTOTIT NUMERIC(18,2),
    SUBTOTITCON NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    CODIGOCL VARCHAR(20),
    ZONACOD VARCHAR(2),
    ZONANOM VARCHAR(60),
    DV CHAR(1),
    DIRECCION VARCHAR(60),
    CIUDAD VARCHAR(40),
    TELEFONO VARCHAR(40),
    CONTACTO VARCHAR(60),
    FAX VARCHAR(25),
    GRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    SUBGRUPO VARCHAR(3),
    NOMSUBG VARCHAR(30),
    MARCA VARCHAR(3),
    NOMMARCA VARCHAR(30),
    PESO NUMERIC(18,4),
    ANCHO NUMERIC(18,4),
    ALTO NUMERIC(18,4),
    LARGO NUMERIC(18,4),
    SUMA1 NUMERIC(18,2),
    SUMA2 NUMERIC(18,2),
    SUMA3 NUMERIC(18,2),
    IVA1 NUMERIC(18,2),
    IVA2 NUMERIC(18,2),
    IVA3 NUMERIC(18,2),
    SUMAEX NUMERIC(18,2),
    SUMAGR NUMERIC(18,2),
    TOTCONSUMO NUMERIC(18,2),
    VEHICULO VARCHAR(8),
    RECIBIDO NUMERIC(18,2),
    CAMBIO NUMERIC(18,2),
    HORA TIME,
    FORMAPAGO1 VARCHAR(30),
    MONTOPAGO1 NUMERIC(18,2),
    FORMAPAGO2 VARCHAR(30),
    MONTOPAGO2 NUMERIC(18,2),
    FORMAPAGO3 VARCHAR(30),
    MONTOPAGO3 NUMERIC(18,2),
    PUNTOS INTEGER,
    PUNTOSACUM INTEGER,
    PUNTOSVENC INTEGER)
AS
DECLARE VARIABLE IMPTOS CHAR(1);
DECLARE VARIABLE TARIFA INTEGER;
declare variable DEVUELTO NUMERIC(18,2);
/*DECLARE VARIABLE NROCOPIA INTEGER;*/
declare variable ORDENCOD CHAR(2);
declare variable IMPRDEV CHAR(2);
declare variable IMPR CHAR(1);
declare variable ITEMFP INTEGER;
declare variable FORMAP VARCHAR(30);
declare variable MONTOP NUMERIC(18,2);
declare variable SUCUR VARCHAR(10);
BEGIN /*$$IBE$$ 
  SELECT F.PREF_PRE, FACT_NUMERO, FACT_FECHA, FACT_VENCE, F.BODE_COD, BODE_NOM, F.TERC_NIT, FACT_NOMCLIENTE, F.VEND_COD, VEND_NOMBRE, F.PTVT_ID, PTVT_NOM,
    AUTO_NUMERO, FACT_DESPACHO, FACT_TRANSP, FACT_COTIZACI, FACT_PEDIDO, FACT_REMISION, FACT_COMIPORC, FACT_COMIMONTO, FACT_IVAINC, 
    FACT_DTOPOR, FACT_DTOMONTO, FACT_ADICIONAL, FACT_IVAMONTO, FACT_RTFTEPOR, FACT_RTFTEMONTO, FACT_RTIVAPOR, FACT_RTIVAMONTO, FACT_RTICAPOR, FACT_RTICAMONTO, FACT_EXTRA, FACT_DTOFPOR, FACT_DTOFMONTO, FACT_DTOFFECHA, FACT_TOTAL,
    TERC_DIR, TERC_CIU, TERC_TEL, TERC_CONTACTO, TERC_FAX, TERC_DV,
    FACT_OBS, VEHI_COD,  $$IBE$$*/ /*FACT_NROCOPIA,*/ /*$$IBE$$  FACT_RECIBIDO, FACT_SUCURSAL, FACT_DETCLI, FACT_DETCLINOM
    FROM FACTURAS F, BODEGA B, VENDEDORES V, PUNTO_VENTA P, TERCEROS T
    WHERE F.BODE_COD = B.BODE_COD AND F.VEND_COD = V.VEND_COD AND F.PTVT_ID = P.PTVT_ID AND F.TERC_NIT = T.TERC_NIT AND F.FACT_ID = :ID
    into :PREF, :NUMERO, :FECHA, :VENCE, :CODBODEGA, :NOMBODEGA, :NIT, :NOMTERCERO, :VENDEDOR, :NOMVENDEDOR, :PUNTOVTA, :NOMPUNTOVTA,
    :AUTORIZACION, :DESPACHO, :TRANSPORTADOR, :COTIZACION, :PEDIDO, :REMISION, :COMIPORC, :COMIMONTO, :IMPTOS,
    :DTOPORC, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTEFTEPORC, :RTEFTEMONTO, :RTEIVAPORC, :RTEIVAMONTO, :RTEICAPORC, :RTEICAMONTO, :EXTRA, :DTOFPORC, :DTOFMONTO, :FECHADTO, :TOTALFAC,
    :DIRECCION, :CIUDAD, :TELEFONO, :CONTACTO, :FAX, :DV, :OBS, :VEHICULO, $$IBE$$*/ /* :NROCOPIA,*/ /*$$IBE$$  :RECIBIDO, :SUCUR, :paciente, :nompaciente;

   $$IBE$$*/ /* ACUMULE LOS PUNTOS, SE HACE ACA POR SER POSTERIOR AL DETALLE */ /*$$IBE$$ 
  EXECUTE PROCEDURE acumula_puntos_cliente (31, :id, :nit, :fecha) returning_values (:PUNTOS);
  EXECUTE PROCEDURE consulta_puntos_cliente (:id, :nit, :fecha) returning_values (:puntos, :puntosacum, :puntosvenc);

  SELECT CLIE_COD, C.ZONA_COD, ZONA_NOM
    FROM CLIENTES C, ZONAS Z
    WHERE TERC_NIT = :NIT AND C.ZONA_COD = Z.ZONA_COD
    INTO :CODIGOCL, :ZONACOD, :ZONANOM;
   $$IBE$$*/ /*SELECT NOCO_NOMBRE FROM NOMBRES_COPIAS where NOCO_ID = :NROCOPIA INTO :NOMCOPIA;*/ /*$$IBE$$ 
  SELECT CLSU_DIR, CLSU_CIUDAD, CLSU_TEL FROM CLIENTE_SUCURSALES WHERE TERC_NIT = :NIT AND CLCU_COD = :SUCUR
    INTO :DIRECCION, :CIUDAD, :TELEFONO;
   $$IBE$$*/ /*if (NOMCOPIA IS NULL) then
    NOMCOPIA = 'COPIA No. ' || NROCOPIA;**/ /*$$IBE$$ 
  DIASVENCE = VENCE - FECHA;
  if (DIASVENCE > 0) then
    CONTCRED = 'CREDITO';
  ELSE
    CONTCRED = 'CONTADO';
  SUBTOTAL = TOTALFAC - EXTRA - IVAMONTO - ADICIONAL + DTOMONTO;
  TOTALPAGAR = TOTALFAC - RTEFTEMONTO - RTEIVAMONTO - RTEICAMONTO;
  if (RECIBIDO <> 0) then
      CAMBIO = RECIBIDO - totalpagar;
  ELSE
    CAMBIO = 0;
  SUMAEX = 0;
  SUMA1 = 0;
  SUMA2 = 0;
  SUMA3 = 0;
  IVA1 = 0;
  IVA2 = 0;
  IVA3 = 0;
  TOTCONSUMO = 0;
  MONTOPAGO1 = 0;
  SELECT MAX(AUDI_HORA) FROM AUDITORIA WHERE TIDO_COD = 31 AND AUDI_IDDOC = :ID AND AUDI_OPER = 'I' INTO :HORA;
   $$IBE$$*/ /* AHORA LAS FORMAS DE PAGO, BUSQUE EL ABONO DE HOY A LA FACTURA */ /*$$IBE$$ 
  ITEMFP = 1;
  MONTOPAGO1 = 0;
  MONTOPAGO2 = 0;
  MONTOPAGO3 = 0;
  FOR SELECT FOPA_NOM, RCPA_MONTO FROM RECIBOS_CAJA_PAGO P, FORMAS_PAGO F, RECIBOS_CAJA R, RECIBOS_CAJA_DETALLE D
    WHERE R.RECA_ID = P.RECA_ID AND R.RECA_ID = D.RECA_ID AND P.FOPA_ID = F.FOPA_ID AND RECA_FECHA = :FECHA AND RCDE_TIPODOC = 31 AND RCDE_IDDOC = :ID
    INTO :formap, :MONTOP
    DO
    BEGIN
    if (ITEMFP = 1) then
        BEGIN
        FORMAPAGO1 = FORMAP;
        MONTOPAGO1 = MONTOP;
        END
    if (ITEMFP = 2) then
        BEGIN
        FORMAPAGO2 = FORMAP;
        MONTOPAGO2 = MONTOP;
        END
    if (ITEMFP = 3) then
        BEGIN
        FORMAPAGO3 = FORMAP;
        MONTOPAGO3 = MONTOP;
        END
    ITEMFP = ITEMFP + 1;
    END
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','DOCUMENTOS','ORDENAR ITEMS POR CODIGO DE ARTICULO') returning_values (:ORDENCOD);
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','POS', 'IMPRIMIR DEVOLUCIONES DE ARTICULOS NEGATIVOS') returning_values (:imprdev);
  if (ORDENCOD = 'SI') then
    BEGIN
    FOR SELECT FADE_ITEM, D.ARTI_COD, FADE_CODBAR, SUBSTR(FADE_DESC,1,60), FADE_CANT, FADE_UNIDAD, FADE_FACTOR, BODE_COD, FADE_LOTE, LIPR_COD, FADE_PRUNIT, FADE_DTOPORC, FADE_DTOMONTO, FADE_IVAPORC, FADE_IVAMONTO, FADE_CONSUMO, FADE_TOTAL, FADE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, FADE_DEVUELTO
        FROM FACTURAS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.FACT_ID = :ID
        ORDER BY D.ARTI_COD
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :FACTOR, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem,
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :devuelto
        DO
          BEGIN
          if (IMPRDEV <> 'SI') then
            BEGIN
            if ((CANT >= 0) AND (DEVUELTO = 0)) then
                IMPR = 'S';
            ELSE
                IMPR = 'N';  $$IBE$$*/ /* ES DEVOLUCION */ /*$$IBE$$ 
            END
          ELSE
            IMPR = 'S';
          if (IMPR = 'S') then
            BEGIN
            if (IMPTOS = 'S') then
                if (cant <> 0) then
                    PRNETO = PRUNIT - DTOITMONTO - ((IVAITMONTO+CONSUMO) / CANT);
                else
                    PRNETO = PRUNIT - DTOITMONTO;
            ELSE
                PRNETO = PRUNIT - DTOITMONTO;
            SUBTOTIT = TOTAL - IVAITMONTO - CONSUMO;
            SUBTOTITCON = TOTAL;
            TOTCONSUMO = TOTCONSUMO + CONSUMO;
            SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO INTO :vlote;
            if (TARIFA = 0) then
                SUMAEX = SUMAEX + TOTAL;
            if (TARIFA = 1) then
                BEGIN
                SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
                IVA1 = IVA1 + IVAITMONTO;
                END
            if (TARIFA = 2) then
                BEGIN
                SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
                IVA2 = IVA2 + IVAITMONTO;
                END
            if (TARIFA = 3) then
                BEGIN
                SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
                IVA3 = IVA3 + IVAITMONTO;
                END
            SUMAGR = SUMA1 + SUMA2 + SUMA3;
            if (IMPTOS = 'N') then
                TOTAL = TOTAL - IVAITMONTO - CONSUMO;
            if (ANCHO IS NULL) then
                ANCHO = 0;
            if (ALTO IS NULL) then
                ALTO = 0;
            if (LARGO IS NULL) then
                LARGO = 0;
            if (PESO IS NULL) then
                PESO = 0;
            PESO = PESO * CANT;
            SUSPEND;
            END
          END
    END
ELSE
    BEGIN
    FOR SELECT FADE_ITEM, D.ARTI_COD, FADE_CODBAR, SUBSTR(FADE_DESC,1,60), FADE_CANT, FADE_UNIDAD, FADE_FACTOR, BODE_COD, FADE_LOTE, LIPR_COD, FADE_PRUNIT, FADE_DTOPORC, FADE_DTOMONTO, FADE_IVAPORC, FADE_IVAMONTO, FADE_CONSUMO, FADE_TOTAL, FADE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, FADE_DEVUELTO
        FROM FACTURAS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.FACT_ID = :ID
        ORDER BY FADE_ITEM
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :FACTOR, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem, 
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :devuelto
        DO
          BEGIN
          if (IMPRDEV <> 'SI') then
            BEGIN
            if ((CANT >= 0) AND (DEVUELTO = 0)) then
                IMPR = 'S';
            ELSE
                IMPR = 'N';  $$IBE$$*/ /* ES DEVOLUCION */ /*$$IBE$$ 
            END
          ELSE
            IMPR = 'S';
          if (IMPR = 'S') then
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
            if (IMPTOS = 'S') then
              PRNETO = PRUNIT - DTOITMONTO - ((IVAITMONTO+CONSUMO) / CANT);
            ELSE
              PRNETO = PRUNIT - DTOITMONTO;
            SUBTOTIT = TOTAL - IVAITMONTO - CONSUMO;
            SUBTOTITCON = TOTAL;
            TOTCONSUMO = TOTCONSUMO + CONSUMO;
            SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO INTO :vlote;
            if (IVAPORC = 0) then
                SUMAEX = SUMAEX + TOTAL;
            if (TARIFA = 1) then
                BEGIN
                SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
                IVA1 = IVA1 + IVAITMONTO;
                END
            if (TARIFA = 2) then
                BEGIN
                SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
                IVA2 = IVA2 + IVAITMONTO;
                END
            if (TARIFA = 3) then
                BEGIN
                SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
                IVA3 = IVA3 + IVAITMONTO;
                END
            SUMAGR = SUMA1 + SUMA2 + SUMA3;
            if (IMPTOS = 'N') then
                TOTAL = TOTAL - IVAITMONTO - CONSUMO;
            if (ANCHO IS NULL) then
                ANCHO = 0;
            if (ALTO IS NULL) then
                ALTO = 0;
            if (LARGO IS NULL) then
                LARGO = 0;
            if (PESO IS NULL) then
                PESO = 0;
            PESO = PESO * CANT;
            SUSPEND;
            END
          END
    END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE IMPR_REDENCION(
    ID INTEGER)
RETURNS (
    NUMERO VARCHAR(6),
    FECHA DATE,
    NIT VARCHAR(20),
    NOMCLIENTE VARCHAR(60),
    DIR VARCHAR(60),
    TEL VARCHAR(60),
    PREMIO VARCHAR(15),
    NOMPREMIO VARCHAR(60),
    PUNTOS INTEGER,
    PUNTOSACUM INTEGER,
    PUNTOSVENC INTEGER)
AS
declare variable puntosaux INTEGER;
begin /*$$IBE$$ 
SELECT PTRE_NUMERO, PTRE_FECHA, PTRE_NIT, TERC_NOM, TERC_DIR, TERC_TEL, R.PTPR_COD, PTPR_NOMBRE, PTRE_PUNTOS
    FROM PUNTOS_REDENCION R, puntos_premios P, TERCEROS T
    WHERE R.ptre_nit = T.terc_nit AND R.ptpr_cod = P.ptpr_cod AND R.ptre_id = :ID
    INTO :NUMERO, :FECHA, :NIT, :NOMCLIENTE, :DIR, :TEL, :PREMIO, :NOMPREMIO, :PUNTOS;
EXECUTE PROCEDURE consulta_puntos_cliente (0, :nit, :fecha) returning_values (:puntosaux, :puntosacum, :puntosvenc);
suspend;
 $$IBE$$*/ SUSPEND;
end
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE IMPR_FACTURA(
    ID INTEGER)
RETURNS (
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    VENCE DATE,
    DIASVENCE INTEGER,
    CONTCRED CHAR(7),
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    VENDEDOR INTEGER,
    NOMVENDEDOR VARCHAR(60),
    PUNTOVTA INTEGER,
    NOMPUNTOVTA VARCHAR(30),
    CODBODEGA VARCHAR(2),
    NOMBODEGA VARCHAR(30),
    AUTORIZACION VARCHAR(20),
    DESPACHO VARCHAR(255),
    TRANSPORTADOR VARCHAR(60),
    COTIZACION VARCHAR(30),
    PEDIDO VARCHAR(30),
    REMISION VARCHAR(30),
    PACIENTE VARCHAR(20),
    NOMPACIENTE VARCHAR(60),
    COMIPORC NUMERIC(9,2),
    COMIMONTO NUMERIC(18,2),
    SUBTOTAL NUMERIC(18,2),
    DTOPORC NUMERIC(9,2),
    DTOMONTO NUMERIC(18,2),
    ADICIONAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    RTEFTEPORC NUMERIC(9,2),
    RTEFTEMONTO NUMERIC(18,2),
    RTEIVAPORC NUMERIC(9,2),
    RTEIVAMONTO NUMERIC(18,2),
    RTEICAPORC NUMERIC(9,2),
    RTEICAMONTO NUMERIC(18,2),
    EXTRA NUMERIC(18,2),
    DTOFPORC NUMERIC(9,2),
    DTOFMONTO NUMERIC(18,2),
    FECHADTO DATE,
    TOTALFAC NUMERIC(18,2),
    TOTALPAGAR NUMERIC(18,2),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    LOTE VARCHAR(15),
    VLOTE DATE,
    UNIDAD VARCHAR(8),
    FACTOR INTEGER,
    LISTAPR INTEGER,
    REFITEM VARCHAR(60),
    BODITEM VARCHAR(2),
    PRUNIT NUMERIC(18,2),
    DTOITPORC NUMERIC(9,2),
    DTOITMONTO NUMERIC(18,2),
    PRNETO NUMERIC(18,2),
    IVAPORC NUMERIC(9,2),
    IVAITMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    SUBTOTIT NUMERIC(18,2),
    SUBTOTITCON NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    CODIGOCL VARCHAR(20),
    ZONACOD VARCHAR(2),
    ZONANOM VARCHAR(60),
    DV CHAR(1),
    DIRECCION VARCHAR(60),
    CIUDAD VARCHAR(40),
    TELEFONO VARCHAR(40),
    CONTACTO VARCHAR(60),
    FAX VARCHAR(25),
    GRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    SUBGRUPO VARCHAR(3),
    NOMSUBG VARCHAR(30),
    MARCA VARCHAR(3),
    NOMMARCA VARCHAR(30),
    PESO NUMERIC(18,4),
    ANCHO NUMERIC(18,4),
    ALTO NUMERIC(18,4),
    LARGO NUMERIC(18,4),
    SUMA1 NUMERIC(18,2),
    SUMA2 NUMERIC(18,2),
    SUMA3 NUMERIC(18,2),
    IVA1 NUMERIC(18,2),
    IVA2 NUMERIC(18,2),
    IVA3 NUMERIC(18,2),
    SUMAEX NUMERIC(18,2),
    SUMAGR NUMERIC(18,2),
    TOTCONSUMO NUMERIC(18,2),
    VEHICULO VARCHAR(8),
    RECIBIDO NUMERIC(18,2),
    CAMBIO NUMERIC(18,2),
    HORA TIME,
    FORMAPAGO1 VARCHAR(30),
    MONTOPAGO1 NUMERIC(18,2),
    FORMAPAGO2 VARCHAR(30),
    MONTOPAGO2 NUMERIC(18,2),
    FORMAPAGO3 VARCHAR(30),
    MONTOPAGO3 NUMERIC(18,2),
    PUNTOS INTEGER,
    PUNTOSACUM INTEGER,
    PUNTOSVENC INTEGER)
AS
DECLARE VARIABLE IMPTOS CHAR(1);
DECLARE VARIABLE TARIFA INTEGER;
declare variable DEVUELTO NUMERIC(18,2);
/*DECLARE VARIABLE NROCOPIA INTEGER;*/
declare variable ORDENCOD CHAR(2);
declare variable IMPRDEV CHAR(2);
declare variable IMPR CHAR(1);
declare variable ITEMFP INTEGER;
declare variable FORMAP VARCHAR(30);
declare variable MONTOP NUMERIC(18,2);
declare variable SUCUR VARCHAR(10);
BEGIN
  SELECT F.PREF_PRE, FACT_NUMERO, FACT_FECHA, FACT_VENCE, F.BODE_COD, BODE_NOM, F.TERC_NIT, FACT_NOMCLIENTE, F.VEND_COD, VEND_NOMBRE, F.PTVT_ID, PTVT_NOM,
    AUTO_NUMERO, FACT_DESPACHO, FACT_TRANSP, FACT_COTIZACI, FACT_PEDIDO, FACT_REMISION, FACT_COMIPORC, FACT_COMIMONTO, FACT_IVAINC, 
    FACT_DTOPOR, FACT_DTOMONTO, FACT_ADICIONAL, FACT_IVAMONTO, FACT_RTFTEPOR, FACT_RTFTEMONTO, FACT_RTIVAPOR, FACT_RTIVAMONTO, FACT_RTICAPOR, FACT_RTICAMONTO, FACT_EXTRA, FACT_DTOFPOR, FACT_DTOFMONTO, FACT_DTOFFECHA, FACT_TOTAL,
    TERC_DIR, TERC_CIU, TERC_TEL, TERC_CONTACTO, TERC_FAX, TERC_DV,
    FACT_OBS, VEHI_COD, /*FACT_NROCOPIA,*/ FACT_RECIBIDO, FACT_SUCURSAL, FACT_DETCLI, FACT_DETCLINOM
    FROM FACTURAS F, BODEGA B, VENDEDORES V, PUNTO_VENTA P, TERCEROS T
    WHERE F.BODE_COD = B.BODE_COD AND F.VEND_COD = V.VEND_COD AND F.PTVT_ID = P.PTVT_ID AND F.TERC_NIT = T.TERC_NIT AND F.FACT_ID = :ID
    into :PREF, :NUMERO, :FECHA, :VENCE, :CODBODEGA, :NOMBODEGA, :NIT, :NOMTERCERO, :VENDEDOR, :NOMVENDEDOR, :PUNTOVTA, :NOMPUNTOVTA,
    :AUTORIZACION, :DESPACHO, :TRANSPORTADOR, :COTIZACION, :PEDIDO, :REMISION, :COMIPORC, :COMIMONTO, :IMPTOS,
    :DTOPORC, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTEFTEPORC, :RTEFTEMONTO, :RTEIVAPORC, :RTEIVAMONTO, :RTEICAPORC, :RTEICAMONTO, :EXTRA, :DTOFPORC, :DTOFMONTO, :FECHADTO, :TOTALFAC,
    :DIRECCION, :CIUDAD, :TELEFONO, :CONTACTO, :FAX, :DV, :OBS, :VEHICULO,/* :NROCOPIA,*/ :RECIBIDO, :SUCUR, :paciente, :nompaciente;

  /* ACUMULE LOS PUNTOS, SE HACE ACA POR SER POSTERIOR AL DETALLE */
  EXECUTE PROCEDURE acumula_puntos_cliente (31, :id, :nit, :fecha) returning_values (:PUNTOS);
  EXECUTE PROCEDURE consulta_puntos_cliente (:id, :nit, :fecha) returning_values (:puntos, :puntosacum, :puntosvenc);

  SELECT CLIE_COD, C.ZONA_COD, ZONA_NOM
    FROM CLIENTES C, ZONAS Z
    WHERE TERC_NIT = :NIT AND C.ZONA_COD = Z.ZONA_COD
    INTO :CODIGOCL, :ZONACOD, :ZONANOM;
  /*SELECT NOCO_NOMBRE FROM NOMBRES_COPIAS where NOCO_ID = :NROCOPIA INTO :NOMCOPIA;*/
  SELECT CLSU_DIR, CLSU_CIUDAD, CLSU_TEL FROM CLIENTE_SUCURSALES WHERE TERC_NIT = :NIT AND CLCU_COD = :SUCUR
    INTO :DIRECCION, :CIUDAD, :TELEFONO;
  /*if (NOMCOPIA IS NULL) then
    NOMCOPIA = 'COPIA No. ' || NROCOPIA;**/
  DIASVENCE = VENCE - FECHA;
  if (DIASVENCE > 0) then
    CONTCRED = 'CREDITO';
  ELSE
    CONTCRED = 'CONTADO';
  SUBTOTAL = TOTALFAC - EXTRA - IVAMONTO - ADICIONAL + DTOMONTO;
  TOTALPAGAR = TOTALFAC - RTEFTEMONTO - RTEIVAMONTO - RTEICAMONTO;
  if (RECIBIDO <> 0) then
      CAMBIO = RECIBIDO - totalpagar;
  ELSE
    CAMBIO = 0;
  SUMAEX = 0;
  SUMA1 = 0;
  SUMA2 = 0;
  SUMA3 = 0;
  IVA1 = 0;
  IVA2 = 0;
  IVA3 = 0;
  TOTCONSUMO = 0;
  MONTOPAGO1 = 0;
  SELECT MAX(AUDI_HORA) FROM AUDITORIA WHERE TIDO_COD = 31 AND AUDI_IDDOC = :ID AND AUDI_OPER = 'I' INTO :HORA;
  /* AHORA LAS FORMAS DE PAGO, BUSQUE EL ABONO DE HOY A LA FACTURA */
  ITEMFP = 1;
  MONTOPAGO1 = 0;
  MONTOPAGO2 = 0;
  MONTOPAGO3 = 0;
  FOR SELECT FOPA_NOM, RCPA_MONTO FROM RECIBOS_CAJA_PAGO P, FORMAS_PAGO F, RECIBOS_CAJA R, RECIBOS_CAJA_DETALLE D
    WHERE R.RECA_ID = P.RECA_ID AND R.RECA_ID = D.RECA_ID AND P.FOPA_ID = F.FOPA_ID AND RECA_FECHA = :FECHA AND RCDE_TIPODOC = 31 AND RCDE_IDDOC = :ID
    INTO :formap, :MONTOP
    DO
    BEGIN
    if (ITEMFP = 1) then
        BEGIN
        FORMAPAGO1 = FORMAP;
        MONTOPAGO1 = MONTOP;
        END
    if (ITEMFP = 2) then
        BEGIN
        FORMAPAGO2 = FORMAP;
        MONTOPAGO2 = MONTOP;
        END
    if (ITEMFP = 3) then
        BEGIN
        FORMAPAGO3 = FORMAP;
        MONTOPAGO3 = MONTOP;
        END
    ITEMFP = ITEMFP + 1;
    END
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','DOCUMENTOS','ORDENAR ITEMS POR CODIGO DE ARTICULO') returning_values (:ORDENCOD);
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','POS', 'IMPRIMIR DEVOLUCIONES DE ARTICULOS NEGATIVOS') returning_values (:imprdev);
  if (ORDENCOD = 'SI') then
    BEGIN
    FOR SELECT FADE_ITEM, D.ARTI_COD, FADE_CODBAR, SUBSTR(FADE_DESC,1,60), FADE_CANT, FADE_UNIDAD, FADE_FACTOR, BODE_COD, FADE_LOTE, LIPR_COD, FADE_PRUNIT, FADE_DTOPORC, FADE_DTOMONTO, FADE_IVAPORC, FADE_IVAMONTO, FADE_CONSUMO, FADE_TOTAL, FADE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, FADE_DEVUELTO
        FROM FACTURAS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.FACT_ID = :ID
        ORDER BY D.ARTI_COD
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :FACTOR, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem,
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :devuelto
        DO
          BEGIN
          if (IMPRDEV <> 'SI') then
            BEGIN
            if ((CANT >= 0) AND (DEVUELTO = 0)) then
                IMPR = 'S';
            ELSE
                IMPR = 'N'; /* ES DEVOLUCION */
            END
          ELSE
            IMPR = 'S';
          if (IMPR = 'S') then
            BEGIN
            if (IMPTOS = 'S') then
                if (cant <> 0) then
                    PRNETO = PRUNIT - DTOITMONTO - ((IVAITMONTO+CONSUMO) / CANT);
                else
                    PRNETO = PRUNIT - DTOITMONTO;
            ELSE
                PRNETO = PRUNIT - DTOITMONTO;
            SUBTOTIT = TOTAL - IVAITMONTO - CONSUMO;
            SUBTOTITCON = TOTAL;
            TOTCONSUMO = TOTCONSUMO + CONSUMO;
            SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO INTO :vlote;
            if (TARIFA = 0) then
                SUMAEX = SUMAEX + TOTAL;
            if (TARIFA = 1) then
                BEGIN
                SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
                IVA1 = IVA1 + IVAITMONTO;
                END
            if (TARIFA = 2) then
                BEGIN
                SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
                IVA2 = IVA2 + IVAITMONTO;
                END
            if (TARIFA = 3) then
                BEGIN
                SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
                IVA3 = IVA3 + IVAITMONTO;
                END
            SUMAGR = SUMA1 + SUMA2 + SUMA3;
            if (IMPTOS = 'N') then
                TOTAL = TOTAL - IVAITMONTO - CONSUMO;
            if (ANCHO IS NULL) then
                ANCHO = 0;
            if (ALTO IS NULL) then
                ALTO = 0;
            if (LARGO IS NULL) then
                LARGO = 0;
            if (PESO IS NULL) then
                PESO = 0;
            PESO = PESO * CANT;
            SUSPEND;
            END
          END
    END
ELSE
    BEGIN
    FOR SELECT FADE_ITEM, D.ARTI_COD, FADE_CODBAR, SUBSTR(FADE_DESC,1,60), FADE_CANT, FADE_UNIDAD, FADE_FACTOR, BODE_COD, FADE_LOTE, LIPR_COD, FADE_PRUNIT, FADE_DTOPORC, FADE_DTOMONTO, FADE_IVAPORC, FADE_IVAMONTO, FADE_CONSUMO, FADE_TOTAL, FADE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, FADE_DEVUELTO
        FROM FACTURAS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.FACT_ID = :ID
        ORDER BY FADE_ITEM
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :FACTOR, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem, 
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :devuelto
        DO
          BEGIN
          if (IMPRDEV <> 'SI') then
            BEGIN
            if ((CANT >= 0) AND (DEVUELTO = 0)) then
                IMPR = 'S';
            ELSE
                IMPR = 'N'; /* ES DEVOLUCION */
            END
          ELSE
            IMPR = 'S';
          if (IMPR = 'S') then
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
            if (IMPTOS = 'S') then
              PRNETO = PRUNIT - DTOITMONTO - ((IVAITMONTO+CONSUMO) / CANT);
            ELSE
              PRNETO = PRUNIT - DTOITMONTO;
            SUBTOTIT = TOTAL - IVAITMONTO - CONSUMO;
            SUBTOTITCON = TOTAL;
            TOTCONSUMO = TOTCONSUMO + CONSUMO;
            SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO INTO :vlote;
            if (IVAPORC = 0) then
                SUMAEX = SUMAEX + TOTAL;
            if (TARIFA = 1) then
                BEGIN
                SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
                IVA1 = IVA1 + IVAITMONTO;
                END
            if (TARIFA = 2) then
                BEGIN
                SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
                IVA2 = IVA2 + IVAITMONTO;
                END
            if (TARIFA = 3) then
                BEGIN
                SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
                IVA3 = IVA3 + IVAITMONTO;
                END
            SUMAGR = SUMA1 + SUMA2 + SUMA3;
            if (IMPTOS = 'N') then
                TOTAL = TOTAL - IVAITMONTO - CONSUMO;
            if (ANCHO IS NULL) then
                ANCHO = 0;
            if (ALTO IS NULL) then
                ALTO = 0;
            if (LARGO IS NULL) then
                LARGO = 0;
            if (PESO IS NULL) then
                PESO = 0;
            PESO = PESO * CANT;
            SUSPEND;
            END
          END
    END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE IMPR_REDENCION(
    ID INTEGER)
RETURNS (
    NUMERO VARCHAR(6),
    FECHA DATE,
    NIT VARCHAR(20),
    NOMCLIENTE VARCHAR(60),
    DIR VARCHAR(60),
    TEL VARCHAR(60),
    PREMIO VARCHAR(15),
    NOMPREMIO VARCHAR(60),
    PUNTOS INTEGER,
    PUNTOSACUM INTEGER,
    PUNTOSVENC INTEGER)
AS
declare variable puntosaux INTEGER;
begin
SELECT PTRE_NUMERO, PTRE_FECHA, PTRE_NIT, TERC_NOM, TERC_DIR, TERC_TEL, R.PTPR_COD, PTPR_NOMBRE, PTRE_PUNTOS
    FROM PUNTOS_REDENCION R, puntos_premios P, TERCEROS T
    WHERE R.ptre_nit = T.terc_nit AND R.ptpr_cod = P.ptpr_cod AND R.ptre_id = :ID
    INTO :NUMERO, :FECHA, :NIT, :NOMCLIENTE, :DIR, :TEL, :PREMIO, :NOMPREMIO, :PUNTOS;
EXECUTE PROCEDURE consulta_puntos_cliente (0, :nit, :fecha) returning_values (:puntosaux, :puntosacum, :puntosvenc);
suspend;
end

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE IMPR_FACTURA(
    ID INTEGER)
RETURNS (
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    VENCE DATE,
    DIASVENCE INTEGER,
    CONTCRED CHAR(7),
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    VENDEDOR INTEGER,
    NOMVENDEDOR VARCHAR(60),
    PUNTOVTA INTEGER,
    NOMPUNTOVTA VARCHAR(30),
    CODBODEGA VARCHAR(2),
    NOMBODEGA VARCHAR(30),
    AUTORIZACION VARCHAR(20),
    DESPACHO VARCHAR(255),
    TRANSPORTADOR VARCHAR(60),
    COTIZACION VARCHAR(30),
    PEDIDO VARCHAR(30),
    REMISION VARCHAR(30),
    PACIENTE VARCHAR(20),
    NOMPACIENTE VARCHAR(60),
    COMIPORC NUMERIC(9,2),
    COMIMONTO NUMERIC(18,2),
    SUBTOTAL NUMERIC(18,2),
    DTOPORC NUMERIC(9,2),
    DTOMONTO NUMERIC(18,2),
    ADICIONAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    RTEFTEPORC NUMERIC(9,2),
    RTEFTEMONTO NUMERIC(18,2),
    RTEIVAPORC NUMERIC(9,2),
    RTEIVAMONTO NUMERIC(18,2),
    RTEICAPORC NUMERIC(9,2),
    RTEICAMONTO NUMERIC(18,2),
    EXTRA NUMERIC(18,2),
    DTOFPORC NUMERIC(9,2),
    DTOFMONTO NUMERIC(18,2),
    FECHADTO DATE,
    TOTALFAC NUMERIC(18,2),
    TOTALPAGAR NUMERIC(18,2),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    LOTE VARCHAR(15),
    VLOTE DATE,
    UNIDAD VARCHAR(8),
    FACTOR INTEGER,
    LISTAPR INTEGER,
    REFITEM VARCHAR(60),
    BODITEM VARCHAR(2),
    PRUNIT NUMERIC(18,2),
    DTOITPORC NUMERIC(9,2),
    DTOITMONTO NUMERIC(18,2),
    PRNETO NUMERIC(18,2),
    IVAPORC NUMERIC(9,2),
    IVAITMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    SUBTOTIT NUMERIC(18,2),
    SUBTOTITCON NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    CODIGOCL VARCHAR(20),
    ZONACOD VARCHAR(2),
    ZONANOM VARCHAR(60),
    DV CHAR(1),
    DIRECCION VARCHAR(60),
    CIUDAD VARCHAR(40),
    TELEFONO VARCHAR(40),
    CONTACTO VARCHAR(60),
    FAX VARCHAR(25),
    GRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    SUBGRUPO VARCHAR(3),
    NOMSUBG VARCHAR(30),
    MARCA VARCHAR(3),
    NOMMARCA VARCHAR(30),
    PESO NUMERIC(18,4),
    ANCHO NUMERIC(18,4),
    ALTO NUMERIC(18,4),
    LARGO NUMERIC(18,4),
    SUMA1 NUMERIC(18,2),
    SUMA2 NUMERIC(18,2),
    SUMA3 NUMERIC(18,2),
    IVA1 NUMERIC(18,2),
    IVA2 NUMERIC(18,2),
    IVA3 NUMERIC(18,2),
    SUMAEX NUMERIC(18,2),
    SUMAGR NUMERIC(18,2),
    TOTCONSUMO NUMERIC(18,2),
    VEHICULO VARCHAR(8),
    RECIBIDO NUMERIC(18,2),
    CAMBIO NUMERIC(18,2),
    HORA TIME,
    FORMAPAGO1 VARCHAR(30),
    MONTOPAGO1 NUMERIC(18,2),
    FORMAPAGO2 VARCHAR(30),
    MONTOPAGO2 NUMERIC(18,2),
    FORMAPAGO3 VARCHAR(30),
    MONTOPAGO3 NUMERIC(18,2),
    PUNTOS INTEGER,
    PUNTOSACUM INTEGER,
    PUNTOSVENC INTEGER)
AS
DECLARE VARIABLE IMPTOS CHAR(1);
DECLARE VARIABLE TARIFA INTEGER;
declare variable DEVUELTO NUMERIC(18,2);
/*DECLARE VARIABLE NROCOPIA INTEGER;*/
declare variable ORDENCOD CHAR(2);
declare variable IMPRDEV CHAR(2);
declare variable IMPR CHAR(1);
declare variable ITEMFP INTEGER;
declare variable FORMAP VARCHAR(30);
declare variable MONTOP NUMERIC(18,2);
declare variable SUCUR VARCHAR(10);
BEGIN /*$$IBE$$ 
  SELECT F.PREF_PRE, FACT_NUMERO, FACT_FECHA, FACT_VENCE, F.BODE_COD, BODE_NOM, F.TERC_NIT, FACT_NOMCLIENTE, F.VEND_COD, VEND_NOMBRE, F.PTVT_ID, PTVT_NOM,
    AUTO_NUMERO, FACT_DESPACHO, FACT_TRANSP, FACT_COTIZACI, FACT_PEDIDO, FACT_REMISION, FACT_COMIPORC, FACT_COMIMONTO, FACT_IVAINC, 
    FACT_DTOPOR, FACT_DTOMONTO, FACT_ADICIONAL, FACT_IVAMONTO, FACT_RTFTEPOR, FACT_RTFTEMONTO, FACT_RTIVAPOR, FACT_RTIVAMONTO, FACT_RTICAPOR, FACT_RTICAMONTO, FACT_EXTRA, FACT_DTOFPOR, FACT_DTOFMONTO, FACT_DTOFFECHA, FACT_TOTAL,
    TERC_DIR, TERC_CIU, TERC_TEL, TERC_CONTACTO, TERC_FAX, TERC_DV,
    FACT_OBS, VEHI_COD,  $$IBE$$*/ /*FACT_NROCOPIA,*/ /*$$IBE$$  FACT_RECIBIDO, FACT_SUCURSAL, FACT_DETCLI, FACT_DETCLINOM
    FROM FACTURAS F, BODEGA B, VENDEDORES V, PUNTO_VENTA P, TERCEROS T
    WHERE F.BODE_COD = B.BODE_COD AND F.VEND_COD = V.VEND_COD AND F.PTVT_ID = P.PTVT_ID AND F.TERC_NIT = T.TERC_NIT AND F.FACT_ID = :ID
    into :PREF, :NUMERO, :FECHA, :VENCE, :CODBODEGA, :NOMBODEGA, :NIT, :NOMTERCERO, :VENDEDOR, :NOMVENDEDOR, :PUNTOVTA, :NOMPUNTOVTA,
    :AUTORIZACION, :DESPACHO, :TRANSPORTADOR, :COTIZACION, :PEDIDO, :REMISION, :COMIPORC, :COMIMONTO, :IMPTOS,
    :DTOPORC, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTEFTEPORC, :RTEFTEMONTO, :RTEIVAPORC, :RTEIVAMONTO, :RTEICAPORC, :RTEICAMONTO, :EXTRA, :DTOFPORC, :DTOFMONTO, :FECHADTO, :TOTALFAC,
    :DIRECCION, :CIUDAD, :TELEFONO, :CONTACTO, :FAX, :DV, :OBS, :VEHICULO, $$IBE$$*/ /* :NROCOPIA,*/ /*$$IBE$$  :RECIBIDO, :SUCUR, :paciente, :nompaciente;

   $$IBE$$*/ /* ACUMULE LOS PUNTOS, SE HACE ACA POR SER POSTERIOR AL DETALLE */ /*$$IBE$$ 
  EXECUTE PROCEDURE acumula_puntos_cliente (31, :id, :nit, :fecha) returning_values (:PUNTOS);
  EXECUTE PROCEDURE consulta_puntos_cliente (:id, :nit, :fecha) returning_values (:puntos, :puntosacum, :puntosvenc);

  SELECT CLIE_COD, C.ZONA_COD, ZONA_NOM
    FROM CLIENTES C, ZONAS Z
    WHERE TERC_NIT = :NIT AND C.ZONA_COD = Z.ZONA_COD
    INTO :CODIGOCL, :ZONACOD, :ZONANOM;
   $$IBE$$*/ /*SELECT NOCO_NOMBRE FROM NOMBRES_COPIAS where NOCO_ID = :NROCOPIA INTO :NOMCOPIA;*/ /*$$IBE$$ 
  SELECT CLSU_DIR, CLSU_CIUDAD, CLSU_TEL FROM CLIENTE_SUCURSALES WHERE TERC_NIT = :NIT AND CLCU_COD = :SUCUR
    INTO :DIRECCION, :CIUDAD, :TELEFONO;
   $$IBE$$*/ /*if (NOMCOPIA IS NULL) then
    NOMCOPIA = 'COPIA No. ' || NROCOPIA;**/ /*$$IBE$$ 
  DIASVENCE = VENCE - FECHA;
  if (DIASVENCE > 0) then
    CONTCRED = 'CREDITO';
  ELSE
    CONTCRED = 'CONTADO';
  SUBTOTAL = TOTALFAC - EXTRA - IVAMONTO - ADICIONAL + DTOMONTO;
  TOTALPAGAR = TOTALFAC - RTEFTEMONTO - RTEIVAMONTO - RTEICAMONTO;
  if (RECIBIDO <> 0) then
      CAMBIO = RECIBIDO - totalpagar;
  ELSE
    CAMBIO = 0;
  SUMAEX = 0;
  SUMA1 = 0;
  SUMA2 = 0;
  SUMA3 = 0;
  IVA1 = 0;
  IVA2 = 0;
  IVA3 = 0;
  TOTCONSUMO = 0;
  MONTOPAGO1 = 0;
  SELECT MAX(AUDI_HORA) FROM AUDITORIA WHERE TIDO_COD = 31 AND AUDI_IDDOC = :ID AND AUDI_OPER = 'I' INTO :HORA;
   $$IBE$$*/ /* AHORA LAS FORMAS DE PAGO, BUSQUE EL ABONO DE HOY A LA FACTURA */ /*$$IBE$$ 
  ITEMFP = 1;
  MONTOPAGO1 = 0;
  MONTOPAGO2 = 0;
  MONTOPAGO3 = 0;
  FOR SELECT FOPA_NOM, RCPA_MONTO FROM RECIBOS_CAJA_PAGO P, FORMAS_PAGO F, RECIBOS_CAJA R, RECIBOS_CAJA_DETALLE D
    WHERE R.RECA_ID = P.RECA_ID AND R.RECA_ID = D.RECA_ID AND P.FOPA_ID = F.FOPA_ID AND RECA_FECHA = :FECHA AND RCDE_TIPODOC = 31 AND RCDE_IDDOC = :ID
    INTO :formap, :MONTOP
    DO
    BEGIN
    if (ITEMFP = 1) then
        BEGIN
        FORMAPAGO1 = FORMAP;
        MONTOPAGO1 = MONTOP;
        END
    if (ITEMFP = 2) then
        BEGIN
        FORMAPAGO2 = FORMAP;
        MONTOPAGO2 = MONTOP;
        END
    if (ITEMFP = 3) then
        BEGIN
        FORMAPAGO3 = FORMAP;
        MONTOPAGO3 = MONTOP;
        END
    ITEMFP = ITEMFP + 1;
    END
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','DOCUMENTOS','ORDENAR ITEMS POR CODIGO DE ARTICULO') returning_values (:ORDENCOD);
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','POS', 'IMPRIMIR DEVOLUCIONES DE ARTICULOS NEGATIVOS') returning_values (:imprdev);
  if (ORDENCOD = 'SI') then
    BEGIN
    FOR SELECT FADE_ITEM, D.ARTI_COD, FADE_CODBAR, SUBSTR(FADE_DESC,1,60), FADE_CANT, FADE_UNIDAD, FADE_FACTOR, BODE_COD, FADE_LOTE, LIPR_COD, FADE_PRUNIT, FADE_DTOPORC, FADE_DTOMONTO, FADE_IVAPORC, FADE_IVAMONTO, FADE_CONSUMO, FADE_TOTAL, FADE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, FADE_DEVUELTO
        FROM FACTURAS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.FACT_ID = :ID
        ORDER BY D.ARTI_COD
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :FACTOR, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem,
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :devuelto
        DO
          BEGIN
          if (IMPRDEV <> 'SI') then
            BEGIN
            if ((CANT >= 0) AND (DEVUELTO = 0)) then
                IMPR = 'S';
            ELSE
                IMPR = 'N';  $$IBE$$*/ /* ES DEVOLUCION */ /*$$IBE$$ 
            END
          ELSE
            IMPR = 'S';
          if (IMPR = 'S') then
            BEGIN
            if (IMPTOS = 'S') then
                if (cant <> 0) then
                    PRNETO = PRUNIT - DTOITMONTO - ((IVAITMONTO+CONSUMO) / CANT);
                else
                    PRNETO = PRUNIT - DTOITMONTO;
            ELSE
                PRNETO = PRUNIT - DTOITMONTO;
            SUBTOTIT = TOTAL - IVAITMONTO - CONSUMO;
            SUBTOTITCON = TOTAL;
            TOTCONSUMO = TOTCONSUMO + CONSUMO;
            SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO INTO :vlote;
            if (TARIFA = 0) then
                SUMAEX = SUMAEX + TOTAL;
            if (TARIFA = 1) then
                BEGIN
                SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
                IVA1 = IVA1 + IVAITMONTO;
                END
            if (TARIFA = 2) then
                BEGIN
                SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
                IVA2 = IVA2 + IVAITMONTO;
                END
            if (TARIFA = 3) then
                BEGIN
                SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
                IVA3 = IVA3 + IVAITMONTO;
                END
            SUMAGR = SUMA1 + SUMA2 + SUMA3;
            if (IMPTOS = 'N') then
                TOTAL = TOTAL - IVAITMONTO - CONSUMO;
            if (ANCHO IS NULL) then
                ANCHO = 0;
            if (ALTO IS NULL) then
                ALTO = 0;
            if (LARGO IS NULL) then
                LARGO = 0;
            if (PESO IS NULL) then
                PESO = 0;
            PESO = PESO * CANT;
            SUSPEND;
            END
          END
    END
ELSE
    BEGIN
    FOR SELECT FADE_ITEM, D.ARTI_COD, FADE_CODBAR, SUBSTR(FADE_DESC,1,60), FADE_CANT, FADE_UNIDAD, FADE_FACTOR, BODE_COD, FADE_LOTE, LIPR_COD, FADE_PRUNIT, FADE_DTOPORC, FADE_DTOMONTO, FADE_IVAPORC, FADE_IVAMONTO, FADE_CONSUMO, FADE_TOTAL, FADE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, FADE_DEVUELTO
        FROM FACTURAS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.FACT_ID = :ID
        ORDER BY FADE_ITEM
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :FACTOR, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem, 
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :devuelto
        DO
          BEGIN
          if (IMPRDEV <> 'SI') then
            BEGIN
            if ((CANT >= 0) AND (DEVUELTO = 0)) then
                IMPR = 'S';
            ELSE
                IMPR = 'N';  $$IBE$$*/ /* ES DEVOLUCION */ /*$$IBE$$ 
            END
          ELSE
            IMPR = 'S';
          if (IMPR = 'S') then
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
            if (IMPTOS = 'S') then
              PRNETO = PRUNIT - DTOITMONTO - ((IVAITMONTO+CONSUMO) / CANT);
            ELSE
              PRNETO = PRUNIT - DTOITMONTO;
            SUBTOTIT = TOTAL - IVAITMONTO - CONSUMO;
            SUBTOTITCON = TOTAL;
            TOTCONSUMO = TOTCONSUMO + CONSUMO;
            SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO INTO :vlote;
            if (IVAPORC = 0) then
                SUMAEX = SUMAEX + TOTAL;
            if (TARIFA = 1) then
                BEGIN
                SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
                IVA1 = IVA1 + IVAITMONTO;
                END
            if (TARIFA = 2) then
                BEGIN
                SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
                IVA2 = IVA2 + IVAITMONTO;
                END
            if (TARIFA = 3) then
                BEGIN
                SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
                IVA3 = IVA3 + IVAITMONTO;
                END
            SUMAGR = SUMA1 + SUMA2 + SUMA3;
            if (IMPTOS = 'N') then
                TOTAL = TOTAL - IVAITMONTO - CONSUMO;
            if (ANCHO IS NULL) then
                ANCHO = 0;
            if (ALTO IS NULL) then
                ALTO = 0;
            if (LARGO IS NULL) then
                LARGO = 0;
            if (PESO IS NULL) then
                PESO = 0;
            PESO = PESO * CANT;
            SUSPEND;
            END
          END
    END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE IMPR_REDENCION(
    ID INTEGER)
RETURNS (
    NUMERO VARCHAR(6),
    FECHA DATE,
    NIT VARCHAR(20),
    NOMCLIENTE VARCHAR(60),
    DIR VARCHAR(60),
    TEL VARCHAR(60),
    PREMIO VARCHAR(15),
    NOMPREMIO VARCHAR(60),
    PUNTOS INTEGER,
    PUNTOSACUM INTEGER,
    PUNTOSVENC INTEGER)
AS
declare variable puntosaux INTEGER;
begin /*$$IBE$$ 
SELECT PTRE_NUMERO, PTRE_FECHA, PTRE_NIT, TERC_NOM, TERC_DIR, TERC_TEL, R.PTPR_COD, PTPR_NOMBRE, PTRE_PUNTOS
    FROM PUNTOS_REDENCION R, puntos_premios P, TERCEROS T
    WHERE R.ptre_nit = T.terc_nit AND R.ptpr_cod = P.ptpr_cod AND R.ptre_id = :ID
    INTO :NUMERO, :FECHA, :NIT, :NOMCLIENTE, :DIR, :TEL, :PREMIO, :NOMPREMIO, :PUNTOS;
EXECUTE PROCEDURE consulta_puntos_cliente (0, :nit, :fecha) returning_values (:puntosaux, :puntosacum, :puntosvenc);
suspend;
 $$IBE$$*/ SUSPEND;
end
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE IMPR_FACTURA(
    ID INTEGER)
RETURNS (
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    VENCE DATE,
    DIASVENCE INTEGER,
    CONTCRED CHAR(7),
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    VENDEDOR INTEGER,
    NOMVENDEDOR VARCHAR(60),
    PUNTOVTA INTEGER,
    NOMPUNTOVTA VARCHAR(30),
    CODBODEGA VARCHAR(2),
    NOMBODEGA VARCHAR(30),
    AUTORIZACION VARCHAR(20),
    DESPACHO VARCHAR(255),
    TRANSPORTADOR VARCHAR(60),
    COTIZACION VARCHAR(30),
    PEDIDO VARCHAR(30),
    REMISION VARCHAR(30),
    PACIENTE VARCHAR(20),
    NOMPACIENTE VARCHAR(60),
    COMIPORC NUMERIC(9,2),
    COMIMONTO NUMERIC(18,2),
    SUBTOTAL NUMERIC(18,2),
    DTOPORC NUMERIC(9,2),
    DTOMONTO NUMERIC(18,2),
    ADICIONAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    RTEFTEPORC NUMERIC(9,2),
    RTEFTEMONTO NUMERIC(18,2),
    RTEIVAPORC NUMERIC(9,2),
    RTEIVAMONTO NUMERIC(18,2),
    RTEICAPORC NUMERIC(9,2),
    RTEICAMONTO NUMERIC(18,2),
    EXTRA NUMERIC(18,2),
    DTOFPORC NUMERIC(9,2),
    DTOFMONTO NUMERIC(18,2),
    FECHADTO DATE,
    TOTALFAC NUMERIC(18,2),
    TOTALPAGAR NUMERIC(18,2),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    LOTE VARCHAR(15),
    VLOTE DATE,
    UNIDAD VARCHAR(8),
    FACTOR INTEGER,
    LISTAPR INTEGER,
    REFITEM VARCHAR(60),
    BODITEM VARCHAR(2),
    PRUNIT NUMERIC(18,2),
    DTOITPORC NUMERIC(9,2),
    DTOITMONTO NUMERIC(18,2),
    PRNETO NUMERIC(18,2),
    IVAPORC NUMERIC(9,2),
    IVAITMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    SUBTOTIT NUMERIC(18,2),
    SUBTOTITCON NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    CODIGOCL VARCHAR(20),
    ZONACOD VARCHAR(2),
    ZONANOM VARCHAR(60),
    DV CHAR(1),
    DIRECCION VARCHAR(60),
    CIUDAD VARCHAR(40),
    TELEFONO VARCHAR(40),
    CONTACTO VARCHAR(60),
    FAX VARCHAR(25),
    GRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    SUBGRUPO VARCHAR(3),
    NOMSUBG VARCHAR(30),
    MARCA VARCHAR(3),
    NOMMARCA VARCHAR(30),
    PESO NUMERIC(18,4),
    ANCHO NUMERIC(18,4),
    ALTO NUMERIC(18,4),
    LARGO NUMERIC(18,4),
    SUMA1 NUMERIC(18,2),
    SUMA2 NUMERIC(18,2),
    SUMA3 NUMERIC(18,2),
    IVA1 NUMERIC(18,2),
    IVA2 NUMERIC(18,2),
    IVA3 NUMERIC(18,2),
    SUMAEX NUMERIC(18,2),
    SUMAGR NUMERIC(18,2),
    TOTCONSUMO NUMERIC(18,2),
    VEHICULO VARCHAR(8),
    RECIBIDO NUMERIC(18,2),
    CAMBIO NUMERIC(18,2),
    HORA TIME,
    FORMAPAGO1 VARCHAR(30),
    MONTOPAGO1 NUMERIC(18,2),
    FORMAPAGO2 VARCHAR(30),
    MONTOPAGO2 NUMERIC(18,2),
    FORMAPAGO3 VARCHAR(30),
    MONTOPAGO3 NUMERIC(18,2),
    PUNTOS INTEGER,
    PUNTOSACUM INTEGER,
    PUNTOSVENC INTEGER)
AS
DECLARE VARIABLE IMPTOS CHAR(1);
DECLARE VARIABLE TARIFA INTEGER;
declare variable DEVUELTO NUMERIC(18,2);
/*DECLARE VARIABLE NROCOPIA INTEGER;*/
declare variable ORDENCOD CHAR(2);
declare variable IMPRDEV CHAR(2);
declare variable IMPR CHAR(1);
declare variable ITEMFP INTEGER;
declare variable FORMAP VARCHAR(30);
declare variable MONTOP NUMERIC(18,2);
declare variable SUCUR VARCHAR(10);
BEGIN
  SELECT F.PREF_PRE, FACT_NUMERO, FACT_FECHA, FACT_VENCE, F.BODE_COD, BODE_NOM, F.TERC_NIT, FACT_NOMCLIENTE, F.VEND_COD, VEND_NOMBRE, F.PTVT_ID, PTVT_NOM,
    AUTO_NUMERO, FACT_DESPACHO, FACT_TRANSP, FACT_COTIZACI, FACT_PEDIDO, FACT_REMISION, FACT_COMIPORC, FACT_COMIMONTO, FACT_IVAINC, 
    FACT_DTOPOR, FACT_DTOMONTO, FACT_ADICIONAL, FACT_IVAMONTO, FACT_RTFTEPOR, FACT_RTFTEMONTO, FACT_RTIVAPOR, FACT_RTIVAMONTO, FACT_RTICAPOR, FACT_RTICAMONTO, FACT_EXTRA, FACT_DTOFPOR, FACT_DTOFMONTO, FACT_DTOFFECHA, FACT_TOTAL,
    TERC_DIR, TERC_CIU, TERC_TEL, TERC_CONTACTO, TERC_FAX, TERC_DV,
    FACT_OBS, VEHI_COD, /*FACT_NROCOPIA,*/ FACT_RECIBIDO, FACT_SUCURSAL, FACT_DETCLI, FACT_DETCLINOM
    FROM FACTURAS F, BODEGA B, VENDEDORES V, PUNTO_VENTA P, TERCEROS T
    WHERE F.BODE_COD = B.BODE_COD AND F.VEND_COD = V.VEND_COD AND F.PTVT_ID = P.PTVT_ID AND F.TERC_NIT = T.TERC_NIT AND F.FACT_ID = :ID
    into :PREF, :NUMERO, :FECHA, :VENCE, :CODBODEGA, :NOMBODEGA, :NIT, :NOMTERCERO, :VENDEDOR, :NOMVENDEDOR, :PUNTOVTA, :NOMPUNTOVTA,
    :AUTORIZACION, :DESPACHO, :TRANSPORTADOR, :COTIZACION, :PEDIDO, :REMISION, :COMIPORC, :COMIMONTO, :IMPTOS,
    :DTOPORC, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTEFTEPORC, :RTEFTEMONTO, :RTEIVAPORC, :RTEIVAMONTO, :RTEICAPORC, :RTEICAMONTO, :EXTRA, :DTOFPORC, :DTOFMONTO, :FECHADTO, :TOTALFAC,
    :DIRECCION, :CIUDAD, :TELEFONO, :CONTACTO, :FAX, :DV, :OBS, :VEHICULO,/* :NROCOPIA,*/ :RECIBIDO, :SUCUR, :paciente, :nompaciente;

  /* ACUMULE LOS PUNTOS, SE HACE ACA POR SER POSTERIOR AL DETALLE */
  EXECUTE PROCEDURE acumula_puntos_cliente (31, :id, :nit, :fecha) returning_values (:PUNTOS);
  EXECUTE PROCEDURE consulta_puntos_cliente (:id, :nit, :fecha) returning_values (:puntos, :puntosacum, :puntosvenc);

  SELECT CLIE_COD, C.ZONA_COD, ZONA_NOM
    FROM CLIENTES C, ZONAS Z
    WHERE TERC_NIT = :NIT AND C.ZONA_COD = Z.ZONA_COD
    INTO :CODIGOCL, :ZONACOD, :ZONANOM;
  /*SELECT NOCO_NOMBRE FROM NOMBRES_COPIAS where NOCO_ID = :NROCOPIA INTO :NOMCOPIA;*/
  SELECT CLSU_DIR, CLSU_CIUDAD, CLSU_TEL FROM CLIENTE_SUCURSALES WHERE TERC_NIT = :NIT AND CLCU_COD = :SUCUR
    INTO :DIRECCION, :CIUDAD, :TELEFONO;
  /*if (NOMCOPIA IS NULL) then
    NOMCOPIA = 'COPIA No. ' || NROCOPIA;**/
  DIASVENCE = VENCE - FECHA;
  if (DIASVENCE > 0) then
    CONTCRED = 'CREDITO';
  ELSE
    CONTCRED = 'CONTADO';
  SUBTOTAL = TOTALFAC - EXTRA - IVAMONTO - ADICIONAL + DTOMONTO;
  TOTALPAGAR = TOTALFAC - RTEFTEMONTO - RTEIVAMONTO - RTEICAMONTO;
  if (RECIBIDO <> 0) then
      CAMBIO = RECIBIDO - totalpagar;
  ELSE
    CAMBIO = 0;
  SUMAEX = 0;
  SUMA1 = 0;
  SUMA2 = 0;
  SUMA3 = 0;
  IVA1 = 0;
  IVA2 = 0;
  IVA3 = 0;
  TOTCONSUMO = 0;
  MONTOPAGO1 = 0;
  SELECT MAX(AUDI_HORA) FROM AUDITORIA WHERE TIDO_COD = 31 AND AUDI_IDDOC = :ID AND AUDI_OPER = 'I' INTO :HORA;
  /* AHORA LAS FORMAS DE PAGO, BUSQUE EL ABONO DE HOY A LA FACTURA */
  ITEMFP = 1;
  MONTOPAGO1 = 0;
  MONTOPAGO2 = 0;
  MONTOPAGO3 = 0;
  FOR SELECT FOPA_NOM, RCPA_MONTO FROM RECIBOS_CAJA_PAGO P, FORMAS_PAGO F, RECIBOS_CAJA R, RECIBOS_CAJA_DETALLE D
    WHERE R.RECA_ID = P.RECA_ID AND R.RECA_ID = D.RECA_ID AND P.FOPA_ID = F.FOPA_ID AND RECA_FECHA = :FECHA AND RCDE_TIPODOC = 31 AND RCDE_IDDOC = :ID
    INTO :formap, :MONTOP
    DO
    BEGIN
    if (ITEMFP = 1) then
        BEGIN
        FORMAPAGO1 = FORMAP;
        MONTOPAGO1 = MONTOP;
        END
    if (ITEMFP = 2) then
        BEGIN
        FORMAPAGO2 = FORMAP;
        MONTOPAGO2 = MONTOP;
        END
    if (ITEMFP = 3) then
        BEGIN
        FORMAPAGO3 = FORMAP;
        MONTOPAGO3 = MONTOP;
        END
    ITEMFP = ITEMFP + 1;
    END
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','DOCUMENTOS','ORDENAR ITEMS POR CODIGO DE ARTICULO') returning_values (:ORDENCOD);
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','POS', 'IMPRIMIR DEVOLUCIONES DE ARTICULOS NEGATIVOS') returning_values (:imprdev);
  if (ORDENCOD = 'SI') then
    BEGIN
    FOR SELECT FADE_ITEM, D.ARTI_COD, FADE_CODBAR, SUBSTR(FADE_DESC,1,60), FADE_CANT, FADE_UNIDAD, FADE_FACTOR, BODE_COD, FADE_LOTE, LIPR_COD, FADE_PRUNIT, FADE_DTOPORC, FADE_DTOMONTO, FADE_IVAPORC, FADE_IVAMONTO, FADE_CONSUMO, FADE_TOTAL, FADE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, FADE_DEVUELTO
        FROM FACTURAS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.FACT_ID = :ID
        ORDER BY D.ARTI_COD
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :FACTOR, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem,
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :devuelto
        DO
          BEGIN
          if (IMPRDEV <> 'SI') then
            BEGIN
            if ((CANT >= 0) AND (DEVUELTO = 0)) then
                IMPR = 'S';
            ELSE
                IMPR = 'N'; /* ES DEVOLUCION */
            END
          ELSE
            IMPR = 'S';
          if (IMPR = 'S') then
            BEGIN
            if (IMPTOS = 'S') then
                if (cant <> 0) then
                    PRNETO = PRUNIT - DTOITMONTO - ((IVAITMONTO+CONSUMO) / CANT);
                else
                    PRNETO = PRUNIT - DTOITMONTO;
            ELSE
                PRNETO = PRUNIT - DTOITMONTO;
            SUBTOTIT = TOTAL - IVAITMONTO - CONSUMO;
            SUBTOTITCON = TOTAL;
            TOTCONSUMO = TOTCONSUMO + CONSUMO;
            SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO INTO :vlote;
            if (TARIFA = 0) then
                SUMAEX = SUMAEX + TOTAL;
            if (TARIFA = 1) then
                BEGIN
                SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
                IVA1 = IVA1 + IVAITMONTO;
                END
            if (TARIFA = 2) then
                BEGIN
                SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
                IVA2 = IVA2 + IVAITMONTO;
                END
            if (TARIFA = 3) then
                BEGIN
                SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
                IVA3 = IVA3 + IVAITMONTO;
                END
            SUMAGR = SUMA1 + SUMA2 + SUMA3;
            if (IMPTOS = 'N') then
                TOTAL = TOTAL - IVAITMONTO - CONSUMO;
            if (ANCHO IS NULL) then
                ANCHO = 0;
            if (ALTO IS NULL) then
                ALTO = 0;
            if (LARGO IS NULL) then
                LARGO = 0;
            if (PESO IS NULL) then
                PESO = 0;
            PESO = PESO * CANT;
            SUSPEND;
            END
          END
    END
ELSE
    BEGIN
    FOR SELECT FADE_ITEM, D.ARTI_COD, FADE_CODBAR, SUBSTR(FADE_DESC,1,60), FADE_CANT, FADE_UNIDAD, FADE_FACTOR, BODE_COD, FADE_LOTE, LIPR_COD, FADE_PRUNIT, FADE_DTOPORC, FADE_DTOMONTO, FADE_IVAPORC, FADE_IVAMONTO, FADE_CONSUMO, FADE_TOTAL, FADE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, FADE_DEVUELTO
        FROM FACTURAS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.FACT_ID = :ID
        ORDER BY FADE_ITEM
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :FACTOR, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem, 
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :devuelto
        DO
          BEGIN
          if (IMPRDEV <> 'SI') then
            BEGIN
            if ((CANT >= 0) AND (DEVUELTO = 0)) then
                IMPR = 'S';
            ELSE
                IMPR = 'N'; /* ES DEVOLUCION */
            END
          ELSE
            IMPR = 'S';
          if (IMPR = 'S') then
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
            if (IMPTOS = 'S') then
              PRNETO = PRUNIT - DTOITMONTO - ((IVAITMONTO+CONSUMO) / CANT);
            ELSE
              PRNETO = PRUNIT - DTOITMONTO;
            SUBTOTIT = TOTAL - IVAITMONTO - CONSUMO;
            SUBTOTITCON = TOTAL;
            TOTCONSUMO = TOTCONSUMO + CONSUMO;
            SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO INTO :vlote;
            if (IVAPORC = 0) then
                SUMAEX = SUMAEX + TOTAL;
            if (TARIFA = 1) then
                BEGIN
                SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
                IVA1 = IVA1 + IVAITMONTO;
                END
            if (TARIFA = 2) then
                BEGIN
                SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
                IVA2 = IVA2 + IVAITMONTO;
                END
            if (TARIFA = 3) then
                BEGIN
                SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
                IVA3 = IVA3 + IVAITMONTO;
                END
            SUMAGR = SUMA1 + SUMA2 + SUMA3;
            if (IMPTOS = 'N') then
                TOTAL = TOTAL - IVAITMONTO - CONSUMO;
            if (ANCHO IS NULL) then
                ANCHO = 0;
            if (ALTO IS NULL) then
                ALTO = 0;
            if (LARGO IS NULL) then
                LARGO = 0;
            if (PESO IS NULL) then
                PESO = 0;
            PESO = PESO * CANT;
            SUSPEND;
            END
          END
    END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE IMPR_REDENCION(
    ID INTEGER)
RETURNS (
    NUMERO VARCHAR(6),
    FECHA DATE,
    NIT VARCHAR(20),
    NOMCLIENTE VARCHAR(60),
    DIR VARCHAR(60),
    TEL VARCHAR(60),
    PREMIO VARCHAR(15),
    NOMPREMIO VARCHAR(60),
    PUNTOS INTEGER,
    PUNTOSACUM INTEGER,
    PUNTOSVENC INTEGER)
AS
declare variable puntosaux INTEGER;
begin
SELECT PTRE_NUMERO, PTRE_FECHA, PTRE_NIT, TERC_NOM, TERC_DIR, TERC_TEL, R.PTPR_COD, PTPR_NOMBRE, PTRE_PUNTOS
    FROM PUNTOS_REDENCION R, puntos_premios P, TERCEROS T
    WHERE R.ptre_nit = T.terc_nit AND R.ptpr_cod = P.ptpr_cod AND R.ptre_id = :ID
    INTO :NUMERO, :FECHA, :NIT, :NOMCLIENTE, :DIR, :TEL, :PREMIO, :NOMPREMIO, :PUNTOS;
EXECUTE PROCEDURE consulta_puntos_cliente (0, :nit, :fecha) returning_values (:puntosaux, :puntosacum, :puntosvenc);
suspend;
end

^

SET TERM ; ^


/* 05-10 comisiones por lista de precios */
INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('FACTURACION', 'ARTICULOS', 'COMISIONES POR ARTICULO POR GRUPO O POR LISTA DE PRECIOS', 'GRUPO', 'GRUPO,LISTA', 'GRUPO: La comisin del artculo se lee de la tabla de grupos al que pertenece. LISTA: La comisin se lee de la tabla de precios del artculo para la lista usada en la factura');
COMMIT WORK;


SET TERM ^ ;

CREATE OR ALTER PROCEDURE COMISIONES_ARTICULO(
    DETALLE CHAR(1),
    DESDE VARCHAR(2),
    HASTA VARCHAR(2),
    FECINI DATE,
    FECFIN DATE,
    ARTINI VARCHAR(15),
    ARTFIN VARCHAR(15),
    CEROS CHAR(1),
    AGENCIA INTEGER)
RETURNS (
    CODVEND VARCHAR(2),
    NOMVEND VARCHAR(60),
    NOMTIPO VARCHAR(10),
    ARTICULO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    UNIDAD VARCHAR(8),
    CANTVTAS NUMERIC(18,4),
    CANTDEV NUMERIC(18,4),
    BASEVTAS NUMERIC(18,2),
    BASEDEV NUMERIC(18,2),
    PORC NUMERIC(18,2),
    COMISION NUMERIC(18,2),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE)
AS
declare variable COMIPOR NUMERIC(9,2);
declare variable COMIMONTO NUMERIC(18,2);
declare variable LISTA VARCHAR(6);
declare variable COMIPPOR NUMERIC(9,2);
declare variable COMIPMONTO NUMERIC(18,2);
declare variable IDFAC INTEGER;
BEGIN
EXECUTE PROCEDURE lee_configuracion ('FACTURACION', 'ARTICULOS', 'COMISIONES POR ARTICULO POR GRUPO O POR LISTA DE PRECIOS') returning_values (LISTA);
FOR select VEND_COD, VEND_NOMBRE
    from VENDEDORES
    where VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND ((:AGENCIA = 0) or (SUCU_ID = :AGENCIA))
    INTO :CODVEND, :NOMVEND
    DO  
    BEGIN
    FOR SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, GRUP_NOM, A.SUBG_COD, A.MARC_COD, GRUP_COMIPOR, GRUP_COMIMONTO
        FROM ARTICULO A, GRUPO G
        WHERE ARTI_COD >= :ARTINI AND ARTI_COD <= :ARTFIN AND A.GRUP_COD = G.GRUP_COD
      INTO :ARTICULO, :DESCRIPCION, :UNIDAD, :CODGRUPO, :NOMGRUPO, :CODSUBG, :CODMARC, :COMIPOR, :COMIMONTO
      DO
        BEGIN
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
        if (COMIMONTO IS null) then
            COMIMONTO = 0;
        if (DETALLE = 'N') then
            BEGIN
            if (LISTA = 'GRUPO') then
                BEGIN
                SELECT SUM(FADE_CANT * FADE_FACTOR), SUM(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)
                    FROM FACTURAS_DETALLE D, FACTURAS F
                    WHERE F.FACT_ID = D.FACT_ID AND ARTI_COD = :ARTICULO AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND FACT_ANULADO = 'N'
                    INTO :CANTVTAS, :BASEVTAS;
                SELECT SUM(DVDE_CANT * DVDE_FACTOR), SUM(DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)
                    FROM devoluciones_ventas_detalle D, DEVOLUCIONES_VENTAS V
                    WHERE V.DEVT_ID = D.DEVT_ID AND ARTI_COD = :ARTICULO AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND DEVT_ANULADO = 'N'
                    INTO :CANTDEV, :BASEDEV;
                if (CANTVTAS IS NULL) then
                    CANTVTAS = 0;
                if (CANTDEV IS NULL) then
                    CANTDEV = 0;
                if (BASEVTAS IS NULL) then
                    BASEVTAS = 0;
                if (BASEDEV IS NULL) then
                    BASEDEV = 0;
                if (COMIMONTO > 0) then
                    BEGIN
                    COMISION = (CANTVTAS - CANTDEV) * COMIMONTO;
                    PORC = COMISION * 100 / (BASEVTAS - BASEDEV);
                    END
                ELSE
                    BEGIN
                    COMISION = (BASEVTAS - BASEDEV) * COMIPOR / 100;
                    PORC = COMIPOR;
                    END
                if (CEROS = 'S') then
                    SUSPEND;
                ELSE
                    if ((CANTVTAS <> 0) OR (CANTDEV <> 0)) then
                        SUSPEND;
                END
            ELSE
                BEGIN
                SELECT SUM(FADE_CANT * FADE_FACTOR), SUM(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), SUM((FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*P.prar_comi/100)
                    FROM FACTURAS_DETALLE D, FACTURAS F, PRECIOS_ARTICULO P
                    WHERE F.FACT_ID = D.FACT_ID AND D.arti_cod = P.arti_cod AND D.lipr_cod = P.lipr_cod AND D.ARTI_COD = :ARTICULO AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND FACT_ANULADO = 'N'
                    INTO :CANTVTAS, :BASEVTAS, :COMISION;
                SELECT SUM(DVDE_CANT * DVDE_FACTOR), SUM(DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)
                    FROM devoluciones_ventas_detalle D, DEVOLUCIONES_VENTAS V
                    WHERE V.DEVT_ID = D.DEVT_ID AND D.ARTI_COD = :ARTICULO AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND DEVT_ANULADO = 'N'
                    INTO :CANTDEV, :BASEDEV;
                if (CANTVTAS IS NULL) then
                    CANTVTAS = 0;
                if (CANTDEV IS NULL) then
                    CANTDEV = 0;
                if (BASEVTAS IS NULL) then
                    BASEVTAS = 0;
                if (BASEDEV IS NULL) then
                    BASEDEV = 0;
                if (COMISION IS NULL) then
                    COMISION = 0;
                if (COMIMONTO IS NULL) then
                    COMIMONTO = 0;
                if (BASEVTAS <> 0) then
                    PORC = COMISION / BASEVTAS;
                else
                    PORC = 0;
                if (basedev <> 0) then
                    COMISION = (BASEVTAS - BASEDEV) * PORC;
                PORC = PORC * 100;
                if (CEROS = 'S') then
                    SUSPEND;
                ELSE
                    if ((CANTVTAS <> 0) OR (CANTDEV <> 0)) then
                        SUSPEND;
                END
            END
        ELSE
            BEGIN
            SELECT TIDO_NOMCORTO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
            FOR SELECT PREF_PRE, FACT_NUMERO, FACT_FECHA, FADE_CANT * FADE_FACTOR, FADE_TOTAL - FADE_IVAMONTO - FADE_CONSUMO, P.prar_comi, P.prar_comimonto
                FROM FACTURAS F, FACTURAS_DETALLE D, precios_articulo P
                WHERE F.FACT_ID = D.FACT_ID AND D.arti_cod = P.arti_cod AND D.lipr_cod = P.lipr_cod AND D.ARTI_COD = :ARTICULO AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND FACT_ANULADO = 'N'
                INTO :PREFIJO, :NUMERO, :FECHA, :CANTVTAS, :BASEVTAS, :comippor, :comipmonto
                DO
                BEGIN
                if (CANTVTAS IS NULL) then
                    CANTVTAS = 0;
                if (BASEVTAS IS NULL) then
                    BASEVTAS = 0;
                if (LISTA = 'GRUPO') then
                    BEGIN
                    if (COMIMONTO > 0) then
                        BEGIN
                        COMISION = CANTVTAS * COMIMONTO;
                        PORC = COMISION * 100 / BASEVTAS;
                        END
                    ELSE
                        BEGIN
                        COMISION = BASEVTAS * COMIPOR / 100;
                        PORC = COMIPOR;
                        END
                    END
                ELSE
                    BEGIN
                    if (COMIPMONTO > 0) then
                        BEGIN
                        COMISION = CANTVTAS * COMIPMONTO;
                        PORC = COMISION * 100 / BASEVTAS;
                        END
                    ELSE
                        BEGIN
                        COMISION = BASEVTAS * COMIPPOR / 100;
                        PORC = COMIPPOR;
                        END
                    END
                SUSPEND;
                END
            SELECT TIDO_NOMCORTO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
            FOR SELECT PREF_PRE, DEVT_NUMERO, DEVT_FECHA, DVDE_CANT * DVDE_FACTOR, DVDE_TOTAL - DVDE_IVAMONTO - DVDE_CONSUMO, V.devt_factid
                FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D
                WHERE V.DEVT_ID = D.DEVT_ID AND D.ARTI_COD = :ARTICULO AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND DEVT_ANULADO = 'N'
                INTO :PREFIJO, :NUMERO, :FECHA, :CANTDEV, :BASEDEV, :idfac
                DO
                BEGIN
                if (CANTDEV IS NULL) then
                    CANTDEV = 0;
                if (BASEDEV IS NULL) then
                    BASEDEV = 0;
                if (LISTA = 'GRUPO') then
                    BEGIN
                    if (COMIMONTO > 0) then
                        BEGIN
                        COMISION = CANTDEV * COMIMONTO * -1;
                        PORC = COMISION * 100 / BASEDEV;
                        END
                    ELSE
                        BEGIN
                        COMISION = BASEDEV * COMIPOR / 100 * -1;
                        PORC = COMIPOR;
                        END
                    END
                ELSE
                    BEGIN
                    /*  BUSQUE EL PRECIO DE LA FACTURA */
                    COMIPMONTO = 0;
                    COMIPPOR = 0;
                    SELECT P.prar_comi, P.prar_comimonto FROM FACTURAS_DETALLE D, PRECIOS_ARTICULO P
                        WHERE D.arti_cod = P.arti_cod AND D.lipr_cod = P.lipr_cod AND D.ARTI_COD = :articulo AND FACT_ID = :idfac INTO :comippor, :comipmonto;
                    if (COMIPMONTO > 0) then
                        BEGIN
                        COMISION = CANTDEV * COMIPMONTO * -1;
                        PORC = COMISION * 100 / BASEDEV;
                        END
                    ELSE
                        BEGIN
                        COMISION = BASEDEV * COMIPPOR / 100 * -1;
                        PORC = COMIPPOR;
                        END
                    END
                SUSPEND;
                END
            END
        END
    END
END
^

SET TERM ; ^



/* 05-11 */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE IMPR_FACTURA(
    ID INTEGER)
RETURNS (
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    VENCE DATE,
    DIASVENCE INTEGER,
    CONTCRED CHAR(17),
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    VENDEDOR INTEGER,
    NOMVENDEDOR VARCHAR(60),
    PUNTOVTA INTEGER,
    NOMPUNTOVTA VARCHAR(30),
    CODBODEGA VARCHAR(2),
    NOMBODEGA VARCHAR(30),
    AUTORIZACION VARCHAR(20),
    DESPACHO VARCHAR(255),
    TRANSPORTADOR VARCHAR(60),
    COTIZACION VARCHAR(30),
    PEDIDO VARCHAR(30),
    REMISION VARCHAR(30),
    PACIENTE VARCHAR(20),
    NOMPACIENTE VARCHAR(60),
    COMIPORC NUMERIC(9,2),
    COMIMONTO NUMERIC(18,2),
    SUBTOTAL NUMERIC(18,2),
    DTOPORC NUMERIC(9,2),
    DTOMONTO NUMERIC(18,2),
    ADICIONAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    RTEFTEPORC NUMERIC(9,2),
    RTEFTEMONTO NUMERIC(18,2),
    RTEIVAPORC NUMERIC(9,2),
    RTEIVAMONTO NUMERIC(18,2),
    RTEICAPORC NUMERIC(9,2),
    RTEICAMONTO NUMERIC(18,2),
    EXTRA NUMERIC(18,2),
    DTOFPORC NUMERIC(9,2),
    DTOFMONTO NUMERIC(18,2),
    FECHADTO DATE,
    TOTALFAC NUMERIC(18,2),
    TOTALPAGAR NUMERIC(18,2),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    LOTE VARCHAR(15),
    VLOTE DATE,
    UNIDAD VARCHAR(8),
    FACTOR INTEGER,
    LISTAPR INTEGER,
    REFITEM VARCHAR(60),
    BODITEM VARCHAR(2),
    PRUNIT NUMERIC(18,2),
    DTOITPORC NUMERIC(9,2),
    DTOITMONTO NUMERIC(18,2),
    PRNETO NUMERIC(18,2),
    IVAPORC NUMERIC(9,2),
    IVAITMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    SUBTOTIT NUMERIC(18,2),
    SUBTOTITCON NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    CODIGOCL VARCHAR(20),
    ZONACOD VARCHAR(2),
    ZONANOM VARCHAR(60),
    DV CHAR(1),
    DIRECCION VARCHAR(60),
    CIUDAD VARCHAR(40),
    TELEFONO VARCHAR(40),
    CONTACTO VARCHAR(60),
    FAX VARCHAR(25),
    GRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    SUBGRUPO VARCHAR(3),
    NOMSUBG VARCHAR(30),
    MARCA VARCHAR(3),
    NOMMARCA VARCHAR(30),
    PESO NUMERIC(18,4),
    ANCHO NUMERIC(18,4),
    ALTO NUMERIC(18,4),
    LARGO NUMERIC(18,4),
    SUMA1 NUMERIC(18,2),
    SUMA2 NUMERIC(18,2),
    SUMA3 NUMERIC(18,2),
    IVA1 NUMERIC(18,2),
    IVA2 NUMERIC(18,2),
    IVA3 NUMERIC(18,2),
    SUMAEX NUMERIC(18,2),
    SUMAGR NUMERIC(18,2),
    TOTCONSUMO NUMERIC(18,2),
    VEHICULO VARCHAR(8),
    RECIBIDO NUMERIC(18,2),
    CAMBIO NUMERIC(18,2),
    HORA TIME,
    FORMAPAGO1 VARCHAR(30),
    MONTOPAGO1 NUMERIC(18,2),
    FORMAPAGO2 VARCHAR(30),
    MONTOPAGO2 NUMERIC(18,2),
    FORMAPAGO3 VARCHAR(30),
    MONTOPAGO3 NUMERIC(18,2),
    PUNTOS INTEGER,
    PUNTOSACUM INTEGER,
    PUNTOSVENC INTEGER)
AS
DECLARE VARIABLE IMPTOS CHAR(1);
DECLARE VARIABLE TARIFA INTEGER;
declare variable DEVUELTO NUMERIC(18,2);
/*DECLARE VARIABLE NROCOPIA INTEGER;*/
declare variable ORDENCOD CHAR(2);
declare variable IMPRDEV CHAR(2);
declare variable IMPR CHAR(1);
declare variable ITEMFP INTEGER;
declare variable FORMAP VARCHAR(30);
declare variable MONTOP NUMERIC(18,2);
declare variable SUCUR VARCHAR(10);
BEGIN
  SELECT F.PREF_PRE, FACT_NUMERO, FACT_FECHA, FACT_VENCE, F.BODE_COD, BODE_NOM, F.TERC_NIT, FACT_NOMCLIENTE, F.VEND_COD, VEND_NOMBRE, F.PTVT_ID, PTVT_NOM,
    AUTO_NUMERO, FACT_DESPACHO, FACT_TRANSP, FACT_COTIZACI, FACT_PEDIDO, FACT_REMISION, FACT_COMIPORC, FACT_COMIMONTO, FACT_IVAINC, 
    FACT_DTOPOR, FACT_DTOMONTO, FACT_ADICIONAL, FACT_IVAMONTO, FACT_RTFTEPOR, FACT_RTFTEMONTO, FACT_RTIVAPOR, FACT_RTIVAMONTO, FACT_RTICAPOR, FACT_RTICAMONTO, FACT_EXTRA, FACT_DTOFPOR, FACT_DTOFMONTO, FACT_DTOFFECHA, FACT_TOTAL,
    TERC_DIR, TERC_CIU, TERC_TEL, TERC_CONTACTO, TERC_FAX, TERC_DV,
    FACT_OBS, VEHI_COD, /*FACT_NROCOPIA,*/ FACT_RECIBIDO, FACT_SUCURSAL, FACT_DETCLI, FACT_DETCLINOM
    FROM FACTURAS F, BODEGA B, VENDEDORES V, PUNTO_VENTA P, TERCEROS T
    WHERE F.BODE_COD = B.BODE_COD AND F.VEND_COD = V.VEND_COD AND F.PTVT_ID = P.PTVT_ID AND F.TERC_NIT = T.TERC_NIT AND F.FACT_ID = :ID
    into :PREF, :NUMERO, :FECHA, :VENCE, :CODBODEGA, :NOMBODEGA, :NIT, :NOMTERCERO, :VENDEDOR, :NOMVENDEDOR, :PUNTOVTA, :NOMPUNTOVTA,
    :AUTORIZACION, :DESPACHO, :TRANSPORTADOR, :COTIZACION, :PEDIDO, :REMISION, :COMIPORC, :COMIMONTO, :IMPTOS,
    :DTOPORC, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTEFTEPORC, :RTEFTEMONTO, :RTEIVAPORC, :RTEIVAMONTO, :RTEICAPORC, :RTEICAMONTO, :EXTRA, :DTOFPORC, :DTOFMONTO, :FECHADTO, :TOTALFAC,
    :DIRECCION, :CIUDAD, :TELEFONO, :CONTACTO, :FAX, :DV, :OBS, :VEHICULO,/* :NROCOPIA,*/ :RECIBIDO, :SUCUR, :paciente, :nompaciente;

  /* ACUMULE LOS PUNTOS, SE HACE ACA POR SER POSTERIOR AL DETALLE */
  EXECUTE PROCEDURE acumula_puntos_cliente (31, :id, :nit, :fecha) returning_values (:PUNTOS);
  EXECUTE PROCEDURE consulta_puntos_cliente (:id, :nit, :fecha) returning_values (:puntos, :puntosacum, :puntosvenc);

  SELECT CLIE_COD, C.ZONA_COD, ZONA_NOM
    FROM CLIENTES C, ZONAS Z
    WHERE TERC_NIT = :NIT AND C.ZONA_COD = Z.ZONA_COD
    INTO :CODIGOCL, :ZONACOD, :ZONANOM;
  /*SELECT NOCO_NOMBRE FROM NOMBRES_COPIAS where NOCO_ID = :NROCOPIA INTO :NOMCOPIA;*/
  SELECT CLSU_DIR, CLSU_CIUDAD, CLSU_TEL FROM CLIENTE_SUCURSALES WHERE TERC_NIT = :NIT AND CLCU_COD = :SUCUR
    INTO :DIRECCION, :CIUDAD, :TELEFONO;
  /*if (NOMCOPIA IS NULL) then
    NOMCOPIA = 'COPIA No. ' || NROCOPIA;**/
  DIASVENCE = VENCE - FECHA;
  if (DIASVENCE > 0) then
    CONTCRED = 'CREDITO ' || CAST(DIASVENCE AS VARCHAR(3)) || ' DIAS';
  ELSE
    CONTCRED = 'CONTADO';
  SUBTOTAL = TOTALFAC - EXTRA - IVAMONTO - ADICIONAL + DTOMONTO;
  TOTALPAGAR = TOTALFAC - RTEFTEMONTO - RTEIVAMONTO - RTEICAMONTO;
  if (RECIBIDO <> 0) then
      CAMBIO = RECIBIDO - totalpagar;
  ELSE
    CAMBIO = 0;
  SUMAEX = 0;
  SUMA1 = 0;
  SUMA2 = 0;
  SUMA3 = 0;
  IVA1 = 0;
  IVA2 = 0;
  IVA3 = 0;
  TOTCONSUMO = 0;
  MONTOPAGO1 = 0;
  SELECT MAX(AUDI_HORA) FROM AUDITORIA WHERE TIDO_COD = 31 AND AUDI_IDDOC = :ID AND AUDI_OPER = 'I' INTO :HORA;
  /* AHORA LAS FORMAS DE PAGO, BUSQUE EL ABONO DE HOY A LA FACTURA */
  ITEMFP = 1;
  MONTOPAGO1 = 0;
  MONTOPAGO2 = 0;
  MONTOPAGO3 = 0;
  FOR SELECT FOPA_NOM, RCPA_MONTO FROM RECIBOS_CAJA_PAGO P, FORMAS_PAGO F, RECIBOS_CAJA R, RECIBOS_CAJA_DETALLE D
    WHERE R.RECA_ID = P.RECA_ID AND R.RECA_ID = D.RECA_ID AND P.FOPA_ID = F.FOPA_ID AND RECA_FECHA = :FECHA AND RCDE_TIPODOC = 31 AND RCDE_IDDOC = :ID
    INTO :formap, :MONTOP
    DO
    BEGIN
    if (ITEMFP = 1) then
        BEGIN
        FORMAPAGO1 = FORMAP;
        MONTOPAGO1 = MONTOP;
        END
    if (ITEMFP = 2) then
        BEGIN
        FORMAPAGO2 = FORMAP;
        MONTOPAGO2 = MONTOP;
        END
    if (ITEMFP = 3) then
        BEGIN
        FORMAPAGO3 = FORMAP;
        MONTOPAGO3 = MONTOP;
        END
    ITEMFP = ITEMFP + 1;
    END
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','DOCUMENTOS','ORDENAR ITEMS POR CODIGO DE ARTICULO') returning_values (:ORDENCOD);
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','POS', 'IMPRIMIR DEVOLUCIONES DE ARTICULOS NEGATIVOS') returning_values (:imprdev);
  if (ORDENCOD = 'SI') then
    BEGIN
    FOR SELECT FADE_ITEM, D.ARTI_COD, FADE_CODBAR, SUBSTR(FADE_DESC,1,60), FADE_CANT, FADE_UNIDAD, FADE_FACTOR, BODE_COD, FADE_LOTE, LIPR_COD, FADE_PRUNIT, FADE_DTOPORC, FADE_DTOMONTO, FADE_IVAPORC, FADE_IVAMONTO, FADE_CONSUMO, FADE_TOTAL, FADE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, FADE_DEVUELTO
        FROM FACTURAS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.FACT_ID = :ID
        ORDER BY D.ARTI_COD
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :FACTOR, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem,
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :devuelto
        DO
          BEGIN
          if (IMPRDEV <> 'SI') then
            BEGIN
            if ((CANT >= 0) AND (DEVUELTO = 0)) then
                IMPR = 'S';
            ELSE
                IMPR = 'N'; /* ES DEVOLUCION */
            END
          ELSE
            IMPR = 'S';
          if (IMPR = 'S') then
            BEGIN
            if (IMPTOS = 'S') then
                if (cant <> 0) then
                    PRNETO = PRUNIT - DTOITMONTO - ((IVAITMONTO+CONSUMO) / CANT);
                else
                    PRNETO = PRUNIT - DTOITMONTO;
            ELSE
                PRNETO = PRUNIT - DTOITMONTO;
            SUBTOTIT = TOTAL - IVAITMONTO - CONSUMO;
            SUBTOTITCON = TOTAL;
            TOTCONSUMO = TOTCONSUMO + CONSUMO;
            SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO INTO :vlote;
            if (TARIFA = 0) then
                SUMAEX = SUMAEX + TOTAL;
            if (TARIFA = 1) then
                BEGIN
                SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
                IVA1 = IVA1 + IVAITMONTO;
                END
            if (TARIFA = 2) then
                BEGIN
                SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
                IVA2 = IVA2 + IVAITMONTO;
                END
            if (TARIFA = 3) then
                BEGIN
                SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
                IVA3 = IVA3 + IVAITMONTO;
                END
            SUMAGR = SUMA1 + SUMA2 + SUMA3;
            if (IMPTOS = 'N') then
                TOTAL = TOTAL - IVAITMONTO - CONSUMO;
            if (ANCHO IS NULL) then
                ANCHO = 0;
            if (ALTO IS NULL) then
                ALTO = 0;
            if (LARGO IS NULL) then
                LARGO = 0;
            if (PESO IS NULL) then
                PESO = 0;
            PESO = PESO * CANT;
            SUSPEND;
            END
          END
    END
ELSE
    BEGIN
    FOR SELECT FADE_ITEM, D.ARTI_COD, FADE_CODBAR, SUBSTR(FADE_DESC,1,60), FADE_CANT, FADE_UNIDAD, FADE_FACTOR, BODE_COD, FADE_LOTE, LIPR_COD, FADE_PRUNIT, FADE_DTOPORC, FADE_DTOMONTO, FADE_IVAPORC, FADE_IVAMONTO, FADE_CONSUMO, FADE_TOTAL, FADE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, FADE_DEVUELTO
        FROM FACTURAS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.FACT_ID = :ID
        ORDER BY FADE_ITEM
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :FACTOR, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem, 
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :devuelto
        DO
          BEGIN
          if (IMPRDEV <> 'SI') then
            BEGIN
            if ((CANT >= 0) AND (DEVUELTO = 0)) then
                IMPR = 'S';
            ELSE
                IMPR = 'N'; /* ES DEVOLUCION */
            END
          ELSE
            IMPR = 'S';
          if (IMPR = 'S') then
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
            if (IMPTOS = 'S') then
              PRNETO = PRUNIT - DTOITMONTO - ((IVAITMONTO+CONSUMO) / CANT);
            ELSE
              PRNETO = PRUNIT - DTOITMONTO;
            SUBTOTIT = TOTAL - IVAITMONTO - CONSUMO;
            SUBTOTITCON = TOTAL;
            TOTCONSUMO = TOTCONSUMO + CONSUMO;
            SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO INTO :vlote;
            if (IVAPORC = 0) then
                SUMAEX = SUMAEX + TOTAL;
            if (TARIFA = 1) then
                BEGIN
                SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
                IVA1 = IVA1 + IVAITMONTO;
                END
            if (TARIFA = 2) then
                BEGIN
                SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
                IVA2 = IVA2 + IVAITMONTO;
                END
            if (TARIFA = 3) then
                BEGIN
                SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
                IVA3 = IVA3 + IVAITMONTO;
                END
            SUMAGR = SUMA1 + SUMA2 + SUMA3;
            if (IMPTOS = 'N') then
                TOTAL = TOTAL - IVAITMONTO - CONSUMO;
            if (ANCHO IS NULL) then
                ANCHO = 0;
            if (ALTO IS NULL) then
                ALTO = 0;
            if (LARGO IS NULL) then
                LARGO = 0;
            if (PESO IS NULL) then
                PESO = 0;
            PESO = PESO * CANT;
            SUSPEND;
            END
          END
    END
END
^

SET TERM ; ^


/* 05-13 activacion de puntos de venta */
ALTER TABLE PUNTO_VENTA
ADD PTVT_ACTIVO T_BOOLEANO;
update punto_venta set ptvt_activo = 'S';
commit work;

DROP INDEX MOVIMIENTO_CLIENTES_IDX2;

/* 05-14 cuentas retefte por grupo */
ALTER TABLE GRUPO
ADD GRUP_CTARTFTEV T_CTA_CONTABLE;
ALTER TABLE GRUPO
ADD GRUP_CTARTFTEC T_CTA_CONTABLE;
ALTER TABLE GRUPO
ADD GRUP_RTFTEB T_MONTO;
ALTER TABLE GRUPO
ADD GRUP_RTFTEP T_PORCENTAJE;

SET TERM ^ ;

CREATE OR ALTER TRIGGER ARTICULO_AI FOR ARTICULO
ACTIVE AFTER INSERT POSITION 0
AS
declare variable OK CHAR(2);
declare variable LISTA INTEGER;
declare variable UTIL NUMERIC(9,2);
declare variable MARGEN NUMERIC(9,2);
declare variable GRUP_TIVA CHAR(10);
declare variable AUTOM CHAR(1);
BEGIN
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'ARTICULOS', 'CREAR PRECIOS AL CREAR ARTICULOS') RETURNING_VALUES (:OK);
IF (OK = 'SI') THEN
  BEGIN
  /* INSERTE PRECIOS */
  FOR SELECT LIPR_COD, LIPR_UTIL, LIPR_MARGEN, LIPR_AUTO FROM LISTA_PRECIOS
    INTO :LISTA, :UTIL, :MARGEN, :AUTOM
    do
    BEGIN
    INSERT INTO PRECIOS_ARTICULO (ARTI_COD, LIPR_COD, PRAR_AUTO, PRAR_UTIL, PRAR_MARGEN, PRAR_FIJO, PRAR_CANTMIN)
        VALUES (NEW.ARTI_COD, :LISTA, :AUTOM, :UTIL, :MARGEN, 0, 0.1);
    END
  END
/* INSERTE LA CONTABILIZACION DEL GRUPO O TARIFA DE IVA SEGUN PARAMETRO*/
EXECUTE PROCEDURE LEE_CONFIGURACION('INVENTARIO', 'ARTICULOS', 'OPCION PARA CAMBIAR AUTOMATICAMENTE LAS CTAS CONTABLES DEL ARTICULO') RETURNING_VALUES (:GRUP_TIVA);
if (GRUP_TIVA = 'GRUPOS') then
  INSERT INTO CONTABIL_ARTICULO (ARTI_COD, COAR_CTAINV, COAR_CTAIVAC, COAR_CTAIVAV, COAR_CTAVNT, COAR_CTACOS, COAR_CTADEV, COAR_CTACOMP, COAR_CTARTFTE, COAR_CTARTFTEV, COAR_RTBASE, COAR_RTFTE)
    SELECT NEW.ARTI_COD, GRUP_CTAINVENT, GRUP_CTAIVACMP, GRUP_CTAIVAVNT, GRUP_CTAVENTAS, GRUP_CTACOSTOS, GRUP_CTADEV, GRUP_CTACOMP, GRUP_CTARTFTEC, GRUP_CTARTFTEV, GRUP_RTFTEB, GRUP_RTFTEP
    FROM GRUPO G
    WHERE GRUP_COD = NEW.GRUP_COD;
if (GRUP_TIVA = 'TARIFA IVA') then
  INSERT INTO CONTABIL_ARTICULO (ARTI_COD, COAR_CTAINV, COAR_CTAIVAC, COAR_CTAIVAV, COAR_CTAVNT, COAR_CTACOS, COAR_CTADEV, COAR_CTACOMP)
    SELECT NEW.ARTI_COD, TAIV_CTAINV, TAIV_CTAIVACMP, TAIV_CTAIVAVNT, TAIV_CTAVTA, TAIV_CTACOSTO, TAIV_CTADEV, TAIV_CTACOMP
    FROM TARIFA_IVA T
    WHERE TAIV_COD = NEW.taiv_cod;
INSERT INTO AUDITORIA(AUDI_USUARIO, TIDO_COD, AUDI_IDDOC, AUDI_OPER, AUDI_COD)
    VALUES (USER, 101, 1, 'I', NEW.arti_cod);
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER TRIGGER ARTICULO_AU FOR ARTICULO
ACTIVE AFTER UPDATE POSITION 0
as
declare variable GRUP_TIVA CHAR(10);
declare variable VTA CHAR(20);
declare variable IVAC CHAR(20);
declare variable IVAV CHAR(20);
declare variable INV CHAR(20);
declare variable COSTO CHAR(20);
declare variable DEV CHAR(20);
declare variable COMP CHAR(20);
declare variable RETC CHAR(20);
declare variable RETV CHAR(20);
declare variable RETB NUMERIC(18,2);
declare variable RETP NUMERIC(9,4);
begin
EXECUTE PROCEDURE LEE_CONFIGURACION('INVENTARIO', 'ARTICULOS', 'OPCION PARA CAMBIAR AUTOMATICAMENTE LAS CTAS CONTABLES DEL ARTICULO') RETURNING_VALUES (:GRUP_TIVA);
if (new.grup_cod <> old.grup_cod) then
 begin
  if (GRUP_TIVA = 'GRUPOS') then
   BEGIN
    SELECT GRUP_CTAINVENT, GRUP_CTAIVACMP, GRUP_CTAIVAVNT, GRUP_CTAVENTAS, GRUP_CTACOSTOS, GRUP_CTADEV, GRUP_CTACOMP, GRUP_CTARTFTEC, GRUP_CTARTFTEV, GRUP_RTFTEB, GRUP_RTFTEP
      FROM GRUPO G
      WHERE GRUP_COD = NEW.GRUP_COD
      into :INV, :IVAC, :IVAV, :VTA, :COSTO, :DEV, :COMP, :retc, :retv, :retb, :retp;
      update CONTABIL_ARTICULO
       SET COAR_CTAINV = :INV,
           COAR_CTAIVAC = :IVAC,
           COAR_CTAIVAV = :IVAV,
           COAR_CTAVNT = :VTA,
           COAR_CTACOS = :COSTO,
           COAR_CTADEV = :DEV,
           COAR_CTACOMP = :COMP,
           COAR_CTARTFTE = :retc,
           COAR_CTARTFTEV = :retv,
           COAR_RTFTE = :retp,
           COAR_RTBASE = :retb
        WHERE ARTI_COD = NEW.ARTI_COD;
   END
 end
if (new.taiv_cod <> old.taiv_cod) then
 begin
  if (GRUP_TIVA = 'TARIFA IVA') then
   BEGIN
    SELECT TAIV_CTAINV, TAIV_CTAIVACMP, TAIV_CTAIVAVNT, TAIV_CTAVTA, TAIV_CTACOSTO, TAIV_CTACOMP, TAIV_CTADEV
      FROM TARIFA_IVA T
      WHERE TAIV_COD = NEW.taiv_cod
      into :INV, :IVAC, :IVAV, :VTA, :COSTO, :COMP, :DEV;
      update CONTABIL_ARTICULO
       SET COAR_CTAINV = :INV,
           COAR_CTAIVAC = :IVAC,
           COAR_CTAIVAV = :IVAV,
           COAR_CTAVNT = :VTA,
           COAR_CTACOS = :COSTO,
           COAR_CTADEV = :DEV,
           COAR_CTACOMP = :COMP
        WHERE ARTI_COD = NEW.ARTI_COD;
   END
 end
INSERT INTO AUDITORIA(AUDI_USUARIO, TIDO_COD, AUDI_IDDOC, AUDI_OPER, AUDI_COD)
    VALUES (USER, 101, 1, 'U', NEW.arti_cod);
end
^

SET TERM ; ^


/* 05-14 guarde la autorizacion con que se hizo la factura */
SET TERM ^ ;

CREATE OR ALTER TRIGGER FACTURAS_BI FOR FACTURAS
ACTIVE BEFORE INSERT POSITION 0
AS
declare variable NUMERO VARCHAR(6);
declare variable AUTOM CHAR(1);
declare variable EXISTE CHAR(1);
DECLARE VARIABLE VALCUPO CHAR(10);
declare variable DISPONIBLE NUMERIC(18,2);
declare variable OK CHAR(1);
declare variable SITOT CHAR(2);
declare variable CODCOBR INTEGER;
declare variable CODVEND INTEGER;
declare variable contado char(1);
BEGIN
OK = 'S';
EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'ACCION A TOMAR SI EL CUPO DE CREDITO ES INSUFICIENTE') RETURNING_VALUES (:VALCUPO);
select max(auto_contado) from autorizaciones where pref_pre = new.pref_pre and tido_cod = 31 and auto_inicial <= new.fact_numero and auto_final >= new.fact_numero into :contado;
if (contado='N') then
  BEGIN
  IF (VALCUPO = 'PROHIBIR') THEN
  BEGIN
  OK = 'N';
  /* VERIFIQUE EL CUPO DE CREDITO */
  execute procedure cupo_disponible(new.TERC_NIT, NEW.fact_fecha, NEW.fact_sucursal) returning_values (:DISPONIBLE);
  if (DISPONIBLE >= NEW.FACT_TOTAL) then
    OK = 'S';
  END
  END
IF (OK = 'S') THEN
  begin
  /* calcule la comision */
  EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'VENDEDORES', 'COMISIONES EN VENTA INCLUYENDO IMPUESTOS') returning_values (:SITOT);
  if ((NEW.fact_comiporc IS NULL) or (NEW.fact_comiporc = 0)) THEN
    BEGIN
    if (SITOT = 'SI') then
      SELECT MAX(COMI_PORC) FROM comisiones WHERE VEND_COD = NEW.vend_cod AND
        COMI_INICIAL <= NEW.fact_total AND COMI_FINAL >= NEW.fact_total
        INTO NEW.fact_comiporc;
    else
      SELECT MAX(COMI_PORC) FROM comisiones WHERE VEND_COD = NEW.vend_cod AND
        COMI_INICIAL <= (NEW.fact_total -NEW.fact_ivamonto) AND COMI_FINAL >= (NEW.fact_total -NEW.fact_ivamonto)
        INTO NEW.fact_comiporc;
    if (NEW.fact_comiporc IS NULL) then
        NEW.fact_comiporc = 0;
    END
  if (SITOT = 'SI') then
      NEW.fact_comimonto = NEW.fact_total * NEW.fact_comiporc / 100;
  ELSE
      NEW.fact_comimonto = (NEW.fact_total -NEW.fact_ivamonto) * NEW.fact_comiporc / 100;

  if (NEW.numok = 'N') then
    BEGIN
    /* Actualice el contador del prefijo */
    SELECT PREF_ACTUAL, PREF_AUTO FROM PREFIJOS WHERE TIDO_COD = 31 AND PREF_PRE = NEW.PREF_PRE INTO :NUMERO, :AUTOM;
    /* ACTUALICE EL NUMERO EN ENCABEZADO  */
    if (AUTOM = 'S') then
        BEGIN
        NEW.FACT_NUMERO = NUMERO;
        NUMERO = CAST((CAST(NUMERO AS INTEGER) + 1) AS CHAR(6));
        UPDATE PREFIJOS
            SET PREF_ACTUAL = :NUMERO
            WHERE TIDO_COD = 31 AND PREF_PRE = NEW.PREF_PRE;
        END
    ELSE
        BEGIN
        if (CAST(NUMERO AS INTEGER) = CAST(NEW.FACT_NUMERO AS INTEGER)) then
            UPDATE PREFIJOS
                SET PREF_ACTUAL = CAST((CAST(PREF_ACTUAL AS INTEGER) + 1) AS CHAR(6))
                WHERE TIDO_COD = 31 AND PREF_PRE = NEW.PREF_PRE;
        END
    EXECUTE PROCEDURE COMPLETA_CEROS (NEW.FACT_numero) returning_values (NEW.FACT_numero);
    NEW.numok = 'S';
    END
  /* Verifique que el numero no existe previamente */
  EXISTE = 'N';
  SELECT 'S' FROM FACTURAS WHERE PREF_PRE = NEW.PREF_PRE AND FACT_NUMERO = NEW.FACT_NUMERO INTO :EXISTE;
  if (EXISTE = 'S') then
    EXCEPTION DOCUMENTO_REGISTRADO;
  end
else
  begin
  EXCEPTION CUPO_INSUFICIENTE;
  end

select COBR_COD, VEND_COD FROM CLIENTE_SUCURSALES WHERE TERC_NIT = NEW.terc_nit AND CLCU_COD = NEW.fact_sucursal INTO :CODCOBR, CODVEND;
if (NEW.vend_cod IS NULL) then
    NEW.vend_cod = :CODVEND;
if (NEW.cobr_cod IS NULL) then
    BEGIN
    EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'COMISIONES', 'UNIFICAR CODIGOS DE VENDEDORES Y COBRADORES') returning_values (:SITOT);
    if ((SITOT = 'SI') AND (NEW.vend_cod IS NOT NULL)) then
        NEW.cobr_cod = NEW.vend_cod;
    else
        NEW.cobr_cod = :CODCOBR;
    END
if ((new.FACT_TOTAL-new.FACT_IVAMONTO+new.FACT_DTOMONTO-new.FACT_ADICIONAL) = 0) then
    NEW.FACT_FACTOR = 1;
else
    NEW.FACT_FACTOR = (new.FACT_TOTAL-new.FACT_IVAMONTO)/(new.FACT_TOTAL-new.FACT_IVAMONTO+new.FACT_DTOMONTO-new.FACT_ADICIONAL);

select auto_numero from autorizaciones where auto_inicial <= new.fact_numero and auto_final >= new.fact_numero and auto_fecha <= new.fact_fecha and auto_vence >= new.fact_fecha and pref_pre = new.pref_pre into new.auto_numero;
END
^

SET TERM ; ^



/* 05-15 colores de los modulos en formato hue-sat */

UPDATE CONFIGURACION
SET CONF_VALOR = '12000',
    CONF_POSIBLES = '00000-35999',
    CONF_AYUDA = 'Indique el color en formato RGB que quiere de fondo en la ventana principal del mdulo'
WHERE (CONF_MODULO = 'BANCOS') AND (CONF_CATEGORIA = 'GENERAL') AND (CONF_PROPIEDAD = 'COLOR VENTANA PRINCIPAL');


UPDATE CONFIGURACION
SET CONF_VALOR = '25000',
    CONF_POSIBLES = '00000-35999',
    CONF_AYUDA = 'Indique el color en formato RGB que quiere de fondo en la ventana principal del mdulo'
WHERE (CONF_MODULO = 'CAJA') AND (CONF_CATEGORIA = 'GENERAL') AND (CONF_PROPIEDAD = 'COLOR VENTANA PRINCIPAL');


UPDATE CONFIGURACION
SET CONF_VALOR = '20040',
    CONF_POSIBLES = '00000-35999',
    CONF_AYUDA = 'Indique el color en formato RGB que quiere de fondo en la ventana principal del mdulo'
WHERE (CONF_MODULO = 'CARTERA') AND (CONF_CATEGORIA = 'GENERAL') AND (CONF_PROPIEDAD = 'COLOR VENTANA PRINCIPAL');


UPDATE CONFIGURACION
SET CONF_VALOR = '08000',
    CONF_POSIBLES = '00000-35999',
    CONF_AYUDA = 'Indique el color en formato RGB que quiere de fondo en la ventana principal del mdulo'
WHERE (CONF_MODULO = 'COMPRAS') AND (CONF_CATEGORIA = 'GENERAL') AND (CONF_PROPIEDAD = 'COLOR VENTANA PRINCIPAL');


UPDATE CONFIGURACION
SET CONF_VALOR = '04000',
    CONF_POSIBLES = '00000-35999',
    CONF_AYUDA = 'Indique el color en formato RGB que quiere de fondo en la ventana principal del mdulo'
WHERE (CONF_MODULO = 'CONTABILIDAD') AND (CONF_CATEGORIA = 'GENERAL') AND (CONF_PROPIEDAD = 'COLOR VENTANA PRINCIPAL');


UPDATE CONFIGURACION
SET CONF_VALOR = '16000',
    CONF_POSIBLES = '00000-35999',
    CONF_AYUDA = 'Indique el color en formato RGB que quiere de fondo en la ventana principal del mdulo'
WHERE (CONF_MODULO = 'CXPAGAR') AND (CONF_CATEGORIA = 'GENERAL') AND (CONF_PROPIEDAD = 'COLOR VENTANA PRINCIPAL');


UPDATE CONFIGURACION
SET CONF_VALOR = '00000',
    CONF_POSIBLES = '00000-35999',
    CONF_AYUDA = 'Indique el color en formato RGB que quiere de fondo en la ventana principal del mdulo'
WHERE (CONF_MODULO = 'FACTURACION') AND (CONF_CATEGORIA = 'GENERAL') AND (CONF_PROPIEDAD = 'COLOR VENTANA PRINCIPAL');


UPDATE CONFIGURACION
SET CONF_VALOR = '22080',
    CONF_POSIBLES = '00000-35999',
    CONF_AYUDA = 'Indique el color en formato RGB que quiere de fondo en la ventana principal del mdulo'
WHERE (CONF_MODULO = 'INVENTARIO') AND (CONF_CATEGORIA = 'GENERAL') AND (CONF_PROPIEDAD = 'COLOR VENTANA PRINCIPAL');

COMMIT WORK;

/* 05-16 descargar automaticamente pendientes */

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('FACTURACION', 'DOCUMENTOS', 'DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS', 'SI', 'SI,NO', 'SI: Permite entregas parciales y el programa controla qu articulos quedaron pendientes. NO: Se descarga el documento relacionado completo sin importar cuales artculos no se entregaron');
commit work;

SET TERM ^ ;

CREATE OR ALTER TRIGGER FACTURAS_DETALLE_AI FOR FACTURAS_DETALLE
ACTIVE AFTER INSERT POSITION 0
AS
declare variable fec date;
declare variable NOMCLI VARCHAR(60);
declare variable CONC VARCHAR(60);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Nit varchar(20);
declare variable TIPO INTEGER;
declare variable INVFAC CHAR(2);
declare variable PEDAUTO CHAR(2);
declare variable CANTREL NUMERIC(18,4);
declare variable CONSO CHAR(2);
declare variable CONSOLIDA INTEGER;
BEGIN
select fact_fecha, pref_pre, fact_numero, terc_nit, fact_nomcliente, fact_consolida
    from facturas where fact_id = new.fact_id
    into :fec, :Pref, :Num, :Nit, :Nomcli, :Consolida;
if ((NEW.fact_id <> 0) and (new.fade_anulado = 'N')) then
    BEGIN
    EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','FACTURAS','GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') RETURNING_VALUES (PEDAUTO);
    SELECT MAX(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :TIPO;
    if (Tipo IS NULL) then
        Tipo = 0;
    execute procedure lee_configuracion('FACTURACION', 'FACTURAS', 'AFECTAR INVENTARIO CON LA FACTURA') returning_values (:INVFAC);
    /* si se hizo con base en una remisin no afecte inventario */
    if ((Tipo <> 32) and (INVFAC = 'SI')) then
        begin
        if (STRLEN(NOMCLI) > 42) then
            CONC = 'FV No.' || :pref || :num || '-' || SUBSTR(NOMCLI, 1, 42);
        ELSE
            CONC = 'FV No.' || :pref || :NUM || '-' || NOMCLI;
        INSERT INTO MOVIMIENTO_ARTICULO
            (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
            VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 31, NEW.fact_id,
            :CONC, new.fade_factor * new.fade_cant, 0, 'N', new.fade_lote, :Pref, :Num, new.fade_item, :Nit);
        end
    if (PEDAUTO = 'SI') then
        BEGIN
        INSERT INTO PEDIDOS_DETALLE (PEDI_ID, PEDE_ITEM, ARTI_COD, PEDE_CANT, PEDE_UNIDAD, PEDE_DTOPORC, PEDE_DTOMONTO, PEDE_IVAPORC, PEDE_IVAMONTO, PEDE_CONSUMO, PEDE_FACTOR, PEDE_DESC, PEDE_OBS, PEDE_CODBAR, PEDE_TOTAL, PEDE_ANULADO, PEDE_TRANSMIT, LIPR_COD, PEDE_REFERENCIA, PEDE_PRUNIT, PEDE_FACTURAD, PEDE_REMISIONAD, PEDE_RESERVA, BODE_COD)
            VALUES (GEN_ID(id_pedido,0), NEW.FADE_ITEM, NEW.ARTI_COD, NEW.FADE_CANT, NEW.FADE_UNIDAD, NEW.FADE_DTOPORC, NEW.FADE_DTOMONTO, NEW.FADE_IVAPORC, NEW.FADE_IVAMONTO, NEW.FADE_CONSUMO, NEW.FADE_FACTOR, NEW.FADE_DESC, NEW.FADE_OBS, NEW.FADE_CODBAR, NEW.FADE_TOTAL, 'N', 'N', NEW.LIPR_COD, NEW.FADE_REFERENCIA, NEW.FADE_PRUNIT, NEW.FADE_CANT * NEW.FADE_FACTOR, 0, NEW.FADE_CANT * NEW.FADE_FACTOR, NEW.bode_cod);
        END
    ELSE
        BEGIN
        if (CONSOLIDA <> 0) then
            BEGIN
            EXECUTE procedure LEE_CONFIGURACION ('FACTURACION','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
            if (CONSO = 'NO') then
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.fact_id, COFA_OK = 'S' WHERE COFA_ID = :consolida;
            ELSE
                BEGIN
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.fact_id, COFA_OK = 'S' WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FADE_ITEM AND ARTI_COD = NEW.arti_cod;
                /* BUSQUE EL CONSOLIDADO EN EL MISMO ITEM Y SI ES DIFERENTE ACTUALICELO */
                select COFA_CANT * COFA_FACTOR FROM consolidado_faltantes WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FADE_ITEM AND ARTI_COD = NEW.arti_cod INTO :CANTREL;
                if (NEW.FADE_CANT * NEW.FADE_FACTOR < CANTREL) then
                    UPDATE consolidado_faltantes SET COFA_IDDES = NEW.fact_id, COFA_CANT = NEW.FADE_CANT, COFA_FACTOR = NEW.FADE_FACTOR
                        WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FADE_ITEM AND ARTI_COD = NEW.arti_cod;
                END
            END
        END
    END
END
^

SET TERM ; ^


SET TERM ^ ;

CREATE OR ALTER TRIGGER FACTURAS_DETALLE_AD FOR FACTURAS_DETALLE
ACTIVE AFTER DELETE POSITION 0
AS
declare variable PEDAUTO CHAR(2);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable CONSO CHAR(2);
declare variable CONSOLIDA INTEGER;
declare variable consec INTEGER;
BEGIN
if ((OLD.fact_id <> 0) AND (OLD.fade_anulado = 'N')) then
    BEGIN
    DELETE FROM MOVIMIENTO_ARTICULO WHERE (mvar_tipodoc = 31) and (mvar_idref = OLD.fact_id) and (mvar_item = old.fade_item);

    EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','FACTURAS','GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') RETURNING_VALUES (PEDAUTO);
    if (PEDAUTO = 'SI') then
        BEGIN
        SELECT pref_pre, fact_numero from facturas where fact_id = OLD.fact_id
            into :Pref, :Num;
        SELECT PEDI_ID FROM PEDIDOS WHERE PREF_PRE = :pref AND PEDI_NUMERO = :num into :consec;
        if (consec is not null) then
          DELETE FROM PEDIDOS_DETALLE WHERE PEDE_ITEM = OLD.FADE_ITEM AND PEDI_ID = :consec;
        END
    ELSE
        BEGIN
        /* DESHAGA LOS PENDIENTES */
        SELECT fact_consolida from facturas where fact_id = OLD.fact_id into :Consolida;
        if (CONSOLIDA <> 0) then
            BEGIN
            UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida AND COFA_ITEM = OLD.FADE_ITEM AND ARTI_COD = OLD.arti_cod;
            EXECUTE procedure LEE_CONFIGURACION ('FACTURACION','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
            if (CONSO = 'NO') then
                UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida;
            END
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER TRIGGER FACTURAS_DETALLE_AU FOR FACTURAS_DETALLE
ACTIVE AFTER UPDATE POSITION 0
as
declare variable fec date;
declare variable CONC VARCHAR(60);
declare variable NOMCLI varchar(60);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Nit varchar(20);
declare variable factor numeric(18,4);
declare variable INVFAC CHAR(2);
declare variable TIPO INTEGER;
declare variable PEDAUTO CHAR(2);
declare variable CANTREL NUMERIC(18,4);
declare variable CONSO CHAR(2);
declare variable CONSOLIDA INTEGER;
declare variable consec INTEGER;
BEGIN
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','FACTURAS','GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') RETURNING_VALUES (PEDAUTO);
if ((OLD.fact_id <> 0) AND (OLD.fade_anulado = 'N')) then
    BEGIN
      if ((OLD.FADE_CANT * OLD.FADE_FACTOR <> NEW.fade_cant * NEW.fade_factor) or (OLD.fade_prunit <> NEW.fade_prunit)) then
        begin
        DELETE FROM MOVIMIENTO_ARTICULO WHERE (mvar_tipodoc = 31) and (mvar_idref = OLD.fact_id) and (mvar_item = old.fade_item);

        if (PEDAUTO = 'SI') then
            BEGIN
            SELECT pref_pre, fact_numero from facturas where fact_id = OLD.fact_id
                into :Pref, :Num;
            SELECT PEDI_ID FROM PEDIDOS WHERE PREF_PRE = :pref AND PEDI_NUMERO = :num into :consec;
            if (consec is not null) then
              DELETE FROM PEDIDOS_DETALLE WHERE PEDE_ITEM = OLD.FADE_ITEM AND PEDI_ID = :consec;
            END
        ELSE
            BEGIN
            /* DESHAGA LOS PENDIENTES */
            SELECT fact_consolida from facturas where fact_id = OLD.fact_id into :Consolida;
            if (CONSOLIDA <> 0) then
                BEGIN
                UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida AND COFA_ITEM = OLD.FADE_ITEM AND ARTI_COD = OLD.arti_cod;
                EXECUTE procedure LEE_CONFIGURACION ('FACTURACION','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
                if (CONSO = 'NO') then
                    UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida;
                END
            END
        end
    END
if (OLD.fade_anulado = NEW.fade_anulado ) then
  begin
  if ((OLD.fact_id = 0) OR (OLD.FADE_CANT * OLD.FADE_FACTOR <> NEW.fade_cant * NEW.fade_factor) or (OLD.fade_prunit <> NEW.fade_prunit)) then
    BEGIN
    if ((NEW.fact_id <> 0) and (new.fade_anulado = 'N')) then
      BEGIN
      select fact_fecha, pref_pre, fact_numero, terc_nit, fact_nomcliente, fact_consolida
            from facturas where fact_id = new.fact_id
            into :fec, :Pref, :Num, :Nit, :Nomcli, :Consolida;
      SELECT MAX(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :TIPO;
      if (Tipo IS NULL) then
        Tipo = 0;
        execute procedure lee_configuracion('FACTURACION', 'FACTURAS', 'AFECTAR INVENTARIO CON LA FACTURA') returning_values (:INVFAC);
       /* si se hizo con base en una remisin no afecte inventario */
      if ((Tipo <> 32) and (INVFAC = 'SI')) then
        begin
        if (STRLEN(NOMCLI) > 29) then
            CONC = 'FACTURA DE VENTA No.' || PREF || NUM || '-' || SUBSTR(NOMCLI,1,29);
        ELSE
            CONC = 'FACTURA DE VENTA No.' || PREF || NUM || '-' || NOMCLI;
        DELETE FROM MOVIMIENTO_ARTICULO WHERE (mvar_tipodoc = 31) and (mvar_idref = OLD.fact_id) and (mvar_item = old.fade_item);
        execute procedure factor_unidad_cant(new.arti_cod, new.fade_unidad) returning_values(factor);
        INSERT INTO MOVIMIENTO_ARTICULO
            (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
            VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 31, NEW.fact_id,
            :CONC, :factor * new.fade_cant, 0, 'N', new.fade_lote, :Pref, :Num, new.fade_item, :Nit);
        end
        if (PEDAUTO = 'SI') then
          BEGIN
          INSERT INTO PEDIDOS_DETALLE (PEDI_ID, PEDE_ITEM, ARTI_COD, PEDE_CANT, PEDE_UNIDAD, PEDE_DTOPORC, PEDE_DTOMONTO, PEDE_IVAPORC, PEDE_IVAMONTO, PEDE_CONSUMO, PEDE_FACTOR, PEDE_DESC, PEDE_OBS, PEDE_CODBAR, PEDE_TOTAL, PEDE_ANULADO, PEDE_TRANSMIT, LIPR_COD, PEDE_REFERENCIA, PEDE_PRUNIT, PEDE_FACTURAD, PEDE_REMISIONAD, PEDE_RESERVA, BODE_COD)
            VALUES (0, NEW.FADE_ITEM, NEW.ARTI_COD, NEW.FADE_CANT, NEW.FADE_UNIDAD, NEW.FADE_DTOPORC, NEW.FADE_DTOMONTO, NEW.FADE_IVAPORC, NEW.FADE_IVAMONTO, NEW.FADE_CONSUMO, NEW.FADE_FACTOR, NEW.FADE_DESC, NEW.FADE_OBS, NEW.FADE_CODBAR, NEW.FADE_TOTAL, 'N', 'N', NEW.LIPR_COD, NEW.FADE_REFERENCIA, NEW.FADE_PRUNIT, NEW.FADE_CANT * NEW.FADE_FACTOR, 0, NEW.FADE_CANT * NEW.FADE_FACTOR, NEW.bode_cod);
          END
        ELSE
          BEGIN
          if (CONSOLIDA <> 0) then
            BEGIN
            UPDATE consolidado_faltantes SET COFA_OK = 'S' WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FADE_ITEM AND ARTI_COD = NEW.arti_cod;
            EXECUTE procedure LEE_CONFIGURACION ('FACTURACION','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
            if (CONSO = 'NO') then
                UPDATE consolidado_faltantes SET COFA_OK = 'S' WHERE COFA_ID = :consolida;
            ELSE
                BEGIN
                /* BUSQUE EL CONSOLIDADO EN EL MISMO ITEM Y SI ES DIFERENTE ACTUALICELO */
                select COFA_CANT * COFA_FACTOR FROM consolidado_faltantes WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FADE_ITEM AND ARTI_COD = NEW.arti_cod INTO :CANTREL;
                if (NEW.FADE_CANT * NEW.FADE_FACTOR < CANTREL) then
                    UPDATE consolidado_faltantes SET COFA_CANT = NEW.FADE_CANT, COFA_FACTOR = NEW.FADE_FACTOR
                        WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FADE_ITEM AND ARTI_COD = NEW.arti_cod;
                END
            END
          END
        END
    end
  end
else
  if (NEW.fade_anulado = 'S') then
        BEGIN
        DELETE FROM MOVIMIENTO_ARTICULO WHERE (mvar_tipodoc = 31) and (mvar_idref = new.fact_id) and (mvar_item = old.fade_item);
        if (PEDAUTO = 'SI') then
            BEGIN
            SELECT pref_pre, fact_numero from facturas where fact_id = OLD.fact_id
                into :Pref, :Num;
            SELECT PEDI_ID FROM PEDIDOS WHERE PREF_PRE = :pref AND PEDI_NUMERO = :num into :consec;
            if (consec is not null) then
              UPDATE PEDIDOS_DETALLE SET PEDE_ANULADO = 'S' WHERE PEDE_ITEM = OLD.FADE_ITEM AND PEDI_ID = :consec;
            END
        ELSE
            BEGIN
            /* DESHAGA LOS PENDIENTES */
            SELECT fact_consolida from facturas where fact_id = OLD.fact_id into :Consolida;
            if (CONSOLIDA <> 0) then
                BEGIN
                UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida AND COFA_ITEM = OLD.FADE_ITEM AND ARTI_COD = OLD.arti_cod;
                EXECUTE procedure LEE_CONFIGURACION ('FACTURACION','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
                if (CONSO = 'NO') then
                    UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida;
                END
            END
        END
    ELSE
        BEGIN
        if (NEW.fact_id <> 0) then
          BEGIN
          select fact_fecha, pref_pre, fact_numero, terc_nit, fact_nomcliente, fact_consolida
            from facturas where fact_id = new.fact_id
            into :fec, :Pref, :Num, :Nit, :Nomcli, :Consolida;
          SELECT MAX(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :TIPO;
          if (Tipo IS NULL) then
               Tipo = 0;
          execute procedure lee_configuracion('FACTURACION', 'FACTURAS', 'AFECTAR INVENTARIO CON LA FACTURA') returning_values (:INVFAC);
          /* si se hizo con base en una remisin no afecte inventario */
          if ((Tipo <> 32) and (INVFAC = 'SI')) then
            begin
            if (STRLEN(NOMCLI) > 29) then
               CONC = 'FACTURA DE VENTA No.' || PREF || NUM || '-' || SUBSTR(NOMCLI,1,29);
            ELSE
               CONC = 'FACTURA DE VENTA No.' || PREF || NUM || '-' || NOMCLI;
            execute procedure factor_unidad_cant(new.arti_cod, new.fade_unidad) returning_values(factor);
            INSERT INTO MOVIMIENTO_ARTICULO
                   (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
               VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 31, NEW.fact_id,
                 :CONC, :factor * new.fade_cant, 0, 'N', new.fade_lote, :Pref, :Num, new.fade_item, :Nit);
            end
          if ((PEDAUTO = 'SI') and (old.fact_id = 0)) then
             BEGIN
              INSERT INTO PEDIDOS_DETALLE (PEDI_ID, PEDE_ITEM, ARTI_COD, PEDE_CANT, PEDE_UNIDAD, PEDE_DTOPORC, PEDE_DTOMONTO, PEDE_IVAPORC, PEDE_IVAMONTO, PEDE_CONSUMO, PEDE_FACTOR, PEDE_DESC, PEDE_OBS, PEDE_CODBAR, PEDE_TOTAL, PEDE_ANULADO, PEDE_TRANSMIT, LIPR_COD, PEDE_REFERENCIA, PEDE_PRUNIT, PEDE_FACTURAD, PEDE_REMISIONAD, PEDE_RESERVA, BODE_COD)
                VALUES (0, NEW.FADE_ITEM, NEW.ARTI_COD, NEW.FADE_CANT, NEW.FADE_UNIDAD, NEW.FADE_DTOPORC, NEW.FADE_DTOMONTO, NEW.FADE_IVAPORC, NEW.FADE_IVAMONTO, NEW.FADE_CONSUMO, NEW.FADE_FACTOR, NEW.FADE_DESC, NEW.FADE_OBS, NEW.FADE_CODBAR, NEW.FADE_TOTAL, 'N', 'N', NEW.LIPR_COD, NEW.FADE_REFERENCIA, NEW.FADE_PRUNIT, NEW.FADE_CANT * NEW.FADE_FACTOR, 0, NEW.FADE_CANT * NEW.FADE_FACTOR, NEW.bode_cod);
             END
          ELSE
             BEGIN
             if (CONSOLIDA <> 0) then
              BEGIN
              UPDATE consolidado_faltantes SET COFA_OK = 'S' WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FADE_ITEM AND ARTI_COD = NEW.arti_cod;
              EXECUTE procedure LEE_CONFIGURACION ('FACTURACION','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
              if (CONSO = 'NO') then
                 UPDATE consolidado_faltantes SET COFA_OK = 'S' WHERE COFA_ID = :consolida;
              ELSE
                BEGIN
                /* BUSQUE EL CONSOLIDADO EN EL MISMO ITEM Y SI ES DIFERENTE ACTUALICELO */
                select COFA_CANT * COFA_FACTOR FROM consolidado_faltantes WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FADE_ITEM AND ARTI_COD = NEW.arti_cod INTO :CANTREL;
                if (NEW.FADE_CANT * NEW.FADE_FACTOR < CANTREL) then
                    UPDATE consolidado_faltantes SET COFA_CANT = NEW.FADE_CANT, COFA_FACTOR = NEW.FADE_FACTOR
                        WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FADE_ITEM AND ARTI_COD = NEW.arti_cod;
                END
              END
             END
          END
        end
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER TRIGGER REMISIONES_VENTA_DETALLE_AI FOR REMISIONES_VENTA_DETALLE
ACTIVE AFTER INSERT POSITION 0
AS
declare variable fec date;
declare variable CONC VARCHAR(60);
declare variable NOMCLI VARCHAR(60);
declare variable factor numeric(18,4);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Nit varchar(20);
declare variable Tipo integer;
declare variable idfact integer;
declare variable numrows integer;
declare variable CANTREL NUMERIC(18,4);
declare variable CONSO CHAR(2);
declare variable CONSOLIDA INTEGER;
declare variable PEDAUTO CHAR(2);
declare variable VALPEDIDO CHAR(2);
declare variable IDPED INTEGER;
BEGIN
  if ((NEW.revt_id <> 0) and (new.rvde_anulado = 'N')) then
    BEGIN
    select revt_fecha, pref_pre, revt_numero, terc_nit, revt_nomterc, REVT_CONSOLIDA, LIPR_COD
        from remisiones_venta where revt_id = new.revt_id
        into :fec, :Pref, :Num, :Nit, :Nomcli, :consolida, :idped;
    if (strlen(nomcli) > 27) then
        CONC = 'REMISION A CLIENTE No.' || PREF || NUM || '-' ||SUBSTR(NOMCLI, 1, 27);
    else
        CONC = 'REMISION A CLIENTE No.' || PREF || NUM || '-' ||NOMCLI;

    SELECT MAX(CEFA_TIPOORI), MAX(CEFA_IDORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :TIPO, :IDFACT;
    if (Tipo is null) then
        Tipo = 0;
    if (Idfact is null) then
        Idfact = 0;
    /* si se hizo con base en una factura que afecto el inventario no afecte inventario */
    numrows = 0;
    if (Tipo = 31) Then
        begin
        select count(*) from movimiento_articulo where mvar_tipodoc = 31 and mvar_idref = :idfact into :numrows;
        if (numrows is null) then
          numrows = 0;
        end
    if (numrows = 0) then
        begin
        /* Registre el nuevo */
        execute procedure factor_unidad_cant(new.arti_cod, new.rvde_unidad) returning_values(factor);
        INSERT INTO MOVIMIENTO_ARTICULO
            (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
            VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 32, NEW.revt_id,
            :CONC, :factor * new.rvde_cant, 0, 'N', new.rvde_lote, :Pref, :Num, new.rvde_item, :Nit);
        end

    /* ACTUALICE EL PENDIENTE  */
    if ((NEW.REVT_ID <> 0) AND (CONSOLIDA <> 0)) then
        begin
        EXECUTE procedure LEE_CONFIGURACION ('FACTURACION','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
        /* IGNORELA SI SE VALIDAN CODIGOS DEL PEDIDO */
        SELECT MIN(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
        if (NUMROWS = 34) then
            BEGIN
            EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'REMISIONES', 'VERIFICAR CODIGOS DEL PEDIDO') returning_values (VALPEDIDO);
            if (VALPEDIDO = 'SI') then
                CONSO = 'SI';
            END
        SELECT COUNT(CEFA_ITEM) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
        if (CONSO = 'NO') then
            UPDATE consolidado_faltantes SET COFA_OK = 'S' WHERE COFA_ID = :consolida;
        ELSE
            BEGIN
            UPDATE consolidado_faltantes SET COFA_OK = 'S' WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.RVDE_ITEM AND ARTI_COD = NEW.arti_cod;
            /* BUSQUE EL CONSOLIDADO EN EL MISMO ITEM Y SI ES DIFERENTE ACTUALICELO */
            select COFA_CANT * COFA_FACTOR FROM consolidado_faltantes WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.RVDE_ITEM AND ARTI_COD = NEW.arti_cod INTO :CANTREL;
            if (NEW.RVDE_CANT * NEW.RVDE_FACTOR < CANTREL) then
                UPDATE consolidado_faltantes SET COFA_CANT = NEW.RVDE_CANT, COFA_FACTOR = NEW.RVDE_FACTOR
                    WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.RVDE_ITEM AND ARTI_COD = NEW.arti_cod;
            END

        /* SI HAY PEDIDO AUTOMATICO ACTUALICE EL FALTANTE DEL PEDIDO */
        EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'FACTURAS', 'GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') returning_values (pedauto);
        if (PEDAUTO = 'SI') then
            BEGIN
            if (CONSO = 'NO') then
                UPDATE consolidado_faltantes SET COFA_OK = 'S' WHERE COFA_ID = :idped;
            ELSE
                BEGIN
                UPDATE consolidado_faltantes SET COFA_OK = 'S' WHERE COFA_ID = :IDPED AND COFA_ITEM = NEW.RVDE_ITEM AND ARTI_COD = NEW.arti_cod;
                /* BUSQUE EL CONSOLIDADO EN EL MISMO ITEM Y SI ES DIFERENTE ACTUALICELO */
                select COFA_CANT * COFA_FACTOR FROM consolidado_faltantes WHERE COFA_ID = :idped AND COFA_ITEM = NEW.RVDE_ITEM AND ARTI_COD = NEW.arti_cod INTO :CANTREL;
                if (NEW.RVDE_CANT * NEW.RVDE_FACTOR < CANTREL) then
                    UPDATE consolidado_faltantes SET COFA_CANT = NEW.RVDE_CANT, COFA_FACTOR = NEW.RVDE_FACTOR
                        WHERE COFA_ID = :idped AND COFA_ITEM = NEW.RVDE_ITEM AND ARTI_COD = NEW.arti_cod;
                END
            END
        end
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER TRIGGER REMISIONES_VENTA_DETALLE_AD FOR REMISIONES_VENTA_DETALLE
ACTIVE AFTER DELETE POSITION 0
AS
declare variable CONSO CHAR(2);
declare variable CONSOLIDA INTEGER;
declare variable PEDAUTO CHAR(2);
declare variable IDPED INTEGER;
BEGIN
if ((OLD.revt_id <> 0) AND (OLD.rvde_anulado = 'N')) then
    begin
    delete from movimiento_articulo where (mvar_tipodoc = 32) and (mvar_idref = old.revt_id) and (mvar_item = old.rvde_item);
    select REVT_CONSOLIDA, lipr_cod from remisiones_venta where revt_id = old.revt_id into :CONSOLIDA, :idped;
    if (CONSOLIDA <> 0) then
        begin
        EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'FACTURAS', 'GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') returning_values (pedauto);
        EXECUTE procedure LEE_CONFIGURACION ('FACTURACION','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
        if (CONSO = 'SI') then
            begin
            UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida AND COFA_ITEM = old.RVDE_ITEM AND ARTI_COD = old.arti_cod;
            if (PEDAUTO = 'SI') then
                UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :idped AND COFA_ITEM = old.RVDE_ITEM AND ARTI_COD = old.arti_cod;
            end
        else
            begin
            UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida;
            if (PEDAUTO = 'SI') then
                UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :idped;
            end
        END
    end
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER TRIGGER REMISIONES_VENTA_DETALLE_AU FOR REMISIONES_VENTA_DETALLE
ACTIVE AFTER UPDATE POSITION 0
AS
declare variable fec date;
declare variable CONC VARCHAR(60);
declare variable NOMCLI varchar(60);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Nit varchar(20);
declare variable factor numeric(18,4);
declare variable Tipo integer;
declare variable idfact integer;
declare variable numrows integer;
declare variable CANTREL NUMERIC(18,4);
declare variable CONSO CHAR(2);
declare variable CONSOLIDA INTEGER;
declare variable PEDAUTO CHAR(2);
declare variable IDPED INTEGER;
BEGIN
/* Anule el anterior */
if ((OLD.revt_id <> 0) AND (OLD.rvde_anulado = 'N')) then
    begin
    delete from movimiento_articulo where (mvar_tipodoc = 32) and (mvar_idref = old.revt_id) and (mvar_item = old.rvde_item);
    select REVT_CONSOLIDA, LIPR_COD from remisiones_venta where revt_id = old.revt_id into :CONSOLIDA, :IDPED;
    if (CONSOLIDA <> 0) then
        begin
        EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'FACTURAS', 'GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') returning_values (pedauto);
        EXECUTE procedure LEE_CONFIGURACION ('FACTURACION','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
        if (CONSO = 'SI') then
            begin
            UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida AND COFA_ITEM = old.RVDE_ITEM AND ARTI_COD = old.arti_cod;
            if (PEDAUTO = 'SI') then
                UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :idped AND COFA_ITEM = old.RVDE_ITEM AND ARTI_COD = old.arti_cod;
            end
        else
            BEGIN
            UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida;
            if (PEDAUTO = 'SI') then
                UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :idped;
            END
        END
    end
/* Registre el nuevo */
if ((new.revt_id <> 0) AND (new.rvde_anulado = 'N')) then
    begin
    select revt_fecha, pref_pre, revt_numero, terc_nit, revt_nomterc, REVT_CONSOLIDA, lipr_cod
        from remisiones_venta where revt_id = new.revt_id
        into :fec, :Pref, :Num, :Nit, :Nomcli, :CONSOLIDA, :idped;
    CONC = 'REMISION A CLIENTE No.' || PREF || NUM;
    NOMCLI = SUBSTR(NOMCLI, 1, 24);
    conc = conc || '-' || NOMCLI;

    SELECT MAX(CEFA_TIPOORI), MAX(CEFA_IDORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :TIPO, :IDFACT;
    if (Tipo is null) then
        Tipo = 0;
    if (Idfact is null) then
        Idfact = 0;
    /* si se hizo con base en una factura que afecto el inventario no afecte inventario */
    numrows = 0;
    if (Tipo = 31) Then
        begin
        select count(*) from movimiento_articulo where mvar_tipodoc = 31 and mvar_idref = :idfact into :numrows;
        if (numrows is null) then
            numrows = 0;
        end
    if (numrows = 0) then
        begin
        /* Registre el nuevo */
        execute procedure factor_unidad_cant(new.arti_cod, new.rvde_unidad) returning_values(factor);
        INSERT INTO MOVIMIENTO_ARTICULO
            (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
            VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 32, NEW.revt_id,
            :CONC, :factor * new.rvde_cant, 0, 'N', new.rvde_lote, :Pref, :Num, new.rvde_item, :Nit);
        end
    /* ACTUALICE EL PENDIENTE  */
    if (CONSOLIDA <> 0) then
        begin
        EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'FACTURAS', 'GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') returning_values (pedauto);
        EXECUTE procedure LEE_CONFIGURACION ('FACTURACION','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
        if (CONSO = 'SI') then
            BEGIN
            /* BUSQUE EL CONSOLIDADO EN EL MISMO ITEM Y SI ES DIFERENTE ACTUALICELO */
            select COFA_CANT * COFA_FACTOR FROM consolidado_faltantes WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.RVDE_ITEM AND ARTI_COD = NEW.arti_cod INTO :CANTREL;
            if (NEW.RVDE_CANT * NEW.RVDE_FACTOR < CANTREL) then
                begin
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.revt_id, COFA_CANT = NEW.RVDE_CANT, COFA_FACTOR = NEW.RVDE_FACTOR, COFA_OK = 'S' 
                    WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.RVDE_ITEM AND ARTI_COD = NEW.arti_cod;
                if (PEDAUTO = 'SI') then
                    UPDATE consolidado_faltantes SET COFA_IDDES = NEW.revt_id, COFA_CANT = NEW.RVDE_CANT, COFA_FACTOR = NEW.RVDE_FACTOR, COFA_OK = 'S' 
                        WHERE COFA_ID = :idped AND COFA_ITEM = NEW.RVDE_ITEM AND ARTI_COD = NEW.arti_cod;
                end
            else
                begin
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.revt_id, COFA_OK = 'S' WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.RVDE_ITEM AND ARTI_COD = NEW.arti_cod;
                if (PEDAUTO = 'SI') then
                    UPDATE consolidado_faltantes SET COFA_IDDES = NEW.revt_id, COFA_OK = 'S' WHERE COFA_ID = :idped AND COFA_ITEM = NEW.RVDE_ITEM AND ARTI_COD = NEW.arti_cod;
                end
            END
        else
            begin
            UPDATE consolidado_faltantes SET COFA_IDDES = NEW.revt_id, COFA_OK = 'S' WHERE COFA_ID = :consolida;
            if (PEDAUTO = 'SI') then
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.revt_id, COFA_OK = 'S' WHERE COFA_ID = :idped;
            end
        END
    end
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER TRIGGER PEDIDOS_DETALLE_AI FOR PEDIDOS_DETALLE
ACTIVE AFTER INSERT POSITION 0
as
declare variable CANTREL NUMERIC(18,2);
declare variable CONSO CHAR(2);
declare variable CONSOLIDA INTEGER;
begin
if ((NEW.pedi_id <> 0) AND (NEW.pede_anulado = 'N')) then
    BEGIN
    SELECT PEDI_CONSOLIDA FROM PEDIDOS WHERE PEDI_ID = NEW.PEDI_ID INTO :CONSOLIDA;
    if (CONSOLIDA <> 0) then    
        begin
        UPDATE consolidado_faltantes SET COFA_OK = 'S' WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.PEDE_ITEM AND ARTI_COD = NEW.arti_cod;
        EXECUTE procedure LEE_CONFIGURACION ('FACTURACION','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
        if (CONSO = 'NO') then
            UPDATE consolidado_faltantes SET COFA_IDDES = NEW.pedi_id, COFA_OK = 'S' WHERE COFA_ID = :consolida;
        else
            BEGIN
            /* BUSQUE EL CONSOLIDADO EN EL MISMO ITEM Y SI ES DIFERENTE ACTUALICELO */
            select COFA_CANT FROM consolidado_faltantes WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.PEDE_ITEM AND ARTI_COD = NEW.arti_cod INTO :CANTREL;
            if (NEW.PEDE_CANT * NEW.PEDE_FACTOR < CANTREL) then
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.pedi_id, COFA_CANT = NEW.PEDE_CANT * NEW.PEDE_FACTOR
                    WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.PEDE_ITEM AND ARTI_COD = NEW.arti_cod;
            END
        end
    END
end
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER TRIGGER PEDIDOS_DETALLE_AU FOR PEDIDOS_DETALLE
ACTIVE AFTER UPDATE POSITION 0
as
declare variable CANTREL NUMERIC(18,2);
declare variable CONSO CHAR(2);
declare variable CONSOLIDA INTEGER;
begin
if ((OLD.pedi_id <> 0) AND (OLD.pede_anulado = 'N')) then
    BEGIN
    SELECT PEDI_CONSOLIDA FROM PEDIDOS WHERE PEDI_ID = OLD.PEDI_ID INTO :CONSOLIDA;
    if (CONSOLIDA <> 0) then
        BEGIN
        EXECUTE procedure LEE_CONFIGURACION ('FACTURACION','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
        if (CONSO = 'SI') then
            UPDATE consolidado_faltantes SET COFA_IDDES = NEW.pedi_id, COFA_OK = 'N' WHERE COFA_ID = :consolida AND COFA_ITEM = OLD.PEDE_ITEM AND ARTI_COD = OLD.arti_cod;
        ELSE
            UPDATE consolidado_faltantes SET COFA_IDDES = NEW.pedi_id, COFA_OK = 'N' WHERE COFA_ID = :consolida;
        END
    END

if ((NEW.pedi_id <> 0) AND (NEW.pede_anulado = 'N')) then
    BEGIN
    SELECT PEDI_CONSOLIDA FROM PEDIDOS WHERE PEDI_ID = NEW.PEDI_ID INTO :CONSOLIDA;
    if (CONSOLIDA <> 0) then
        begin
        EXECUTE procedure LEE_CONFIGURACION ('FACTURACION','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
        if (CONSO = 'NO') then
            UPDATE consolidado_faltantes SET COFA_IDDES = NEW.pedi_id, COFA_OK = 'S' WHERE COFA_ID = :consolida;
        else
            BEGIN
            UPDATE consolidado_faltantes SET COFA_OK = 'S' WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.PEDE_ITEM AND ARTI_COD = NEW.arti_cod;
            /* BUSQUE EL CONSOLIDADO EN EL MISMO ITEM Y SI ES DIFERENTE ACTUALICELO */
            select COFA_CANT FROM consolidado_faltantes WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.PEDE_ITEM AND ARTI_COD = NEW.arti_cod INTO :CANTREL;
            if (NEW.PEDE_CANT * NEW.PEDE_FACTOR < CANTREL) then
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.pedi_id, COFA_CANT = NEW.PEDE_CANT * NEW.PEDE_FACTOR
                    WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.PEDE_ITEM AND ARTI_COD = NEW.arti_cod;
            END
        end
    END
end
^

SET TERM ; ^

SET TERM ^ ;

create trigger PEDIDOS_DETALLE_AD for PEDIDOS_DETALLE
active AFTER DELETE position 0
as
declare variable CONSO CHAR(2);
declare variable CONSOLIDA INTEGER;
BEGIN
if ((OLD.pedi_id <> 0) AND (OLD.pede_anulado = 'N')) then
    begin
    select PEDI_CONSOLIDA from PEDIDOS where PEDI_id = old.pedi_id into :CONSOLIDA;
    if (CONSOLIDA <> 0) then
        begin
        EXECUTE procedure LEE_CONFIGURACION ('FACTURACION','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
        if (CONSO = 'SI') then
            UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida AND COFA_ITEM = old.pede_item AND ARTI_COD = old.arti_cod;
        else
            UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida;
        END
    end
end
^

SET TERM ; ^

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('COMPRAS', 'DOCUMENTOS', 'DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS', 'SI', 'SI,NO', 'SI: Permite entregas parciales y el programa controla qu articulos quedaron pendientes. NO: Se descarga el documento relacionado completo sin importar cuales artculos no se entregaron');
commit work;

SET TERM ^ ;

CREATE OR ALTER TRIGGER FACTCOMP_DETALLE_AI FOR FACTURAS_COMPRAS_DETALLE
ACTIVE AFTER INSERT POSITION 0
AS
declare variable fec date;
declare variable fecaux date;
declare variable aux varchar(90);
declare variable CONC VARCHAR(60);
declare variable factor numeric(18,4);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Nit varchar(20);
declare variable TIPO INTEGER;
declare variable INVFAC CHAR(2);
declare variable IVAINC CHAR(2);
declare variable COSTO NUMERIC(18,2);
declare variable CANTREL NUMERIC(18,4);
declare variable NUMPROV VARCHAR(10);
declare variable NUMPED VARCHAR(30);
declare variable NUMREM VARCHAR(30);
declare variable CONSO VARCHAR(2);
declare variable CONSOLIDA INTEGER;
declare variable NUMROWS INTEGER;
declare variable DTOPIE NUMERIC(18,2);
declare variable ADICIONAL NUMERIC(18,2);
declare variable TOTAL NUMERIC(18,2);
declare variable IVAMONTO NUMERIC(18,2);
declare variable EXTRA NUMERIC(18,2);
declare variable FACT NUMERIC(18,4);
declare variable MENORV CHAR(2);
BEGIN
if ((NEW.faco_id <> 0) and (new.fcde_anulado = 'N')) then
    BEGIN
    select faco_fecha, pref_pre, faco_numero, terc_nit, faco_imptos, faco_numprov, faco_remision, faco_orden, FACO_CONSOLIDA,
        FACO_TOTAL, FACO_EXTRA, FACO_IVAMONTO, FACO_ADICIONAL, FACO_DTOMONTO
        from facturas_compra where faco_id = new.faco_id
        into :fec, :Pref, :Num, :Nit, :ivainc, :numprov, :numrem, :numped, :CONSOLIDA,
        :total, :extra, :ivamonto, :adicional, :dtopie;
    conc = 'FACTURA DE COMPRA No.' || PREF || NUM || '-' || NUMPROV;
    if (NUMREM <> '') then
        BEGIN
        AUX = SUBSTR(NUMREM, 1, 15);
        conc = conc || '-REM:' || AUX;
        END
    else
        if (NUMPED <> '') then
            BEGIN
            AUX = SUBSTR(NUMPED, 1, 15);
            conc = conc || '-ORDEN ' || NUMPED;
            END
    SELECT MAX(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :TIPO;
    if (Tipo is null) then
        Tipo = 0;
    execute procedure lee_configuracion('COMPRAS', 'FACTURAS', 'AFECTAR INVENTARIO CON LA FACTURA') returning_values (:INVFAC);
    /* si se hizo con base en una remision no afecte inventario */
    if ((Tipo <> 22) and (INVFAC = 'SI')) then
        begin
        execute procedure factor_unidad_cant(new.arti_cod, new.fcde_unidad) returning_values(factor);
        COSTO = ((new.fcde_prunit - NEW.fcde_dtomonto) / :factor);
        if (IVAINC = 'S') then
            COSTO = COSTO / (1 + NEW.fcde_ivaporc/100);
        EXECUTE PROCEDURE lee_configuracion('COMPRAS','FACTURAS','DESCUENTO Y VALOR ADICIONAL DEL DOCUMENTO COMO MENOR VALOR DEL COSTO') returning_values (:MENORV);
        if (MENORV = 'SI') then
            BEGIN
            FACT = (TOTAL - EXTRA - IVAMONTO);
            if ((FACT - ADICIONAL + DTOPIE) <> 0) then
                FACT = FACT / (FACT - ADICIONAL + DTOPIE);
            ELSE
                FACT = 1;
            COSTO = COSTO * FACT;
            END
        INSERT INTO MOVIMIENTO_ARTICULO
          (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
          VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 21, NEW.faco_id,
          :CONC, :factor * new.fcde_cant, :COSTO, 'S', new.fcde_lote, :Pref, :Num, NEW.fcde_item, :Nit);

        if (COSTO > 0 ) then
         BEGIN
          /* ACTUALICE EL COSTO POR PROVEEDOR */
          SELECT PVAR_FECHA FROM PROVEEDOR_ARTICULO
            WHERE TERC_NIT = :Nit AND ARTI_COD = NEW.ARTI_COD
            INTO :FECAUX;
          if (FECAUX IS NULL) then
            INSERT INTO PROVEEDOR_ARTICULO (TERC_NIT, ARTI_COD, PVAR_COSTO, PVAR_FECHA, PVAR_COD,PVAR_DES)
                VALUES (:Nit, NEW.ARTI_COD, :COSTO, :fec, NEW.fcde_codprov,NEW.fcde_desc);
          else
            UPDATE PROVEEDOR_ARTICULO
                SET PVAR_COSTO = :COSTO, PVAR_FECHA = :fec, PVAR_COD = NEW.fcde_codprov
                WHERE ARTI_COD = NEW.ARTI_COD AND TERC_NIT = :Nit;
         END
        /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
        EXECUTE PROCEDURE CALCULA_PRECIOS(NEW.ARTI_COD, :FEC);
        END /* AFECTAR INV */

    /* ACTUALICE EL PENDIENTE  */
    if (CONSOLIDA <> 0) then
        BEGIN
        EXECUTE procedure LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
        /* IGNORE LA CONSOLIDACION SI SE VALIDAN CODIGOS DE LA ORDEN */
        SELECT MIN(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
        if (NUMROWS = 23) then
            BEGIN
            EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'VERIFICAR CODIGOS DE LA ORDEN') returning_values (MENORV);
            if (MENORV = 'SI') then
                CONSO = 'SI';
            END
        if (CONSO = 'NO') then
            UPDATE consolidado_faltantes SET COFA_IDDES = NEW.faco_id, COFA_OK = 'S' WHERE COFA_ID = :consolida;
        else
            BEGIN
            UPDATE consolidado_faltantes SET COFA_OK = 'S' WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod;
            /* BUSQUE EL CONSOLIDADO EN EL MISMO ITEM Y SI ES DIFERENTE ACTUALICELO */
            select COFA_CANT * COFA_FACTOR FROM consolidado_faltantes WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod INTO :CANTREL;
            if (NEW.FCDE_CANT * NEW.FCDE_FACTOR < CANTREL) then
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.faco_id, COFA_CANT = NEW.FCDE_CANT, COFA_FACTOR = NEW.FCDE_FACTOR
                    WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod;
            END
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER TRIGGER FACTCOMP_DETALLE_AD FOR FACTURAS_COMPRAS_DETALLE
ACTIVE AFTER DELETE POSITION 0
AS
declare variable fec date;
declare variable CONSO VARCHAR(2);
declare variable CONSOLIDA INTEGER;
declare variable NUMROWS INTEGER;
declare variable VERIF CHAR(2);
BEGIN
if ((old.fcde_anulado = 'N') and (OLD.faco_id <> 0)) then
    begin
    select faco_fecha, faco_consolida from facturas_compra where faco_id = old.faco_id into :fec, :consolida;
    DELETE FROM MOVIMIENTO_ARTICULO WHERE (mvar_tipodoc = 21) and (mvar_idref = old.faco_id) and (mvar_item = old.fcde_item);
    /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
    EXECUTE PROCEDURE CALCULA_PRECIOS(old.ARTI_COD, :FEC);
    /* LOS PENDIENTES */
    if (CONSOLIDA <> 0) then
        BEGIN
        EXECUTE procedure LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
        /* IGNORE LA CONSOLIDACION SI SE VALIDAN CODIGOS DE LA ORDEN */
        SELECT MIN(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
        if (NUMROWS = 23) then
            BEGIN
            EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'VERIFICAR CODIGOS DE LA ORDEN') returning_values (VERIF);
            if (VERIF = 'SI') then
                CONSO = 'SI';
            END
        if (CONSO = 'NO') then
            UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida;
        else
            UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida AND COFA_ITEM = old.FCDE_ITEM AND ARTI_COD = old.arti_cod;
        END
    enD
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER TRIGGER FACTCOMP_DETALLE_AU FOR FACTURAS_COMPRAS_DETALLE
ACTIVE AFTER UPDATE POSITION 0
as
declare variable fec date;
declare variable fecaux date;
declare variable AUX varchar(90);
declare variable CONC VARCHAR(60);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Nit varchar(20);
declare variable factor numeric(18,4);
declare variable TIPO INTEGER;
declare variable INVFAC CHAR(2);
declare variable IVAINC CHAR(2);
declare variable COSTO NUMERIC(18,2);
declare variable CANTREL NUMERIC(18,4);
declare variable NUMPROV VARCHAR(10);
declare variable NUMPED VARCHAR(30);
declare variable NUMREM VARCHAR(30);
declare variable CONSO VARCHAR(2);
declare variable CONSOLIDA INTEGER;
declare variable NUMROWS INTEGER;
declare variable DTOPIE NUMERIC(18,2);
declare variable ADICIONAL NUMERIC(18,2);
declare variable TOTAL NUMERIC(18,2);
declare variable IVAMONTO NUMERIC(18,2);
declare variable EXTRA NUMERIC(18,2);
declare variable FACT NUMERIC(18,4);
declare variable MENORV CHAR(2);
BEGIN
if (old.fcde_devuelto = new.fcde_devuelto) then
    begin
    /* deshaga lo viejo */
    if ((old.fcde_anulado = 'N') and (OLD.faco_id <> 0)) then
        begin
        select faco_fecha, faco_consolida from facturas_compra where faco_id = old.faco_id into :fec, :consolida;
        DELETE FROM MOVIMIENTO_ARTICULO WHERE (mvar_tipodoc = 21) and (mvar_idref = old.faco_id) and (mvar_item = old.fcde_item);
        /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
        EXECUTE PROCEDURE CALCULA_PRECIOS(old.ARTI_COD, :FEC);
        /* LOS PENDIENTES */
        if (CONSOLIDA <> 0) then
            BEGIN
            EXECUTE procedure LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
            /* IGNORE LA CONSOLIDACION SI SE VALIDAN CODIGOS DE LA ORDEN */
            SELECT MIN(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
            if (NUMROWS = 23) then
                BEGIN
                EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'VERIFICAR CODIGOS DE LA ORDEN') returning_values (MENORV);
                if (MENORV = 'SI') then
                    CONSO = 'SI';
                END
            if (CONSO = 'NO') then
                UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida;
            else
                UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida AND COFA_ITEM = old.FCDE_ITEM AND ARTI_COD = old.arti_cod;
            END
        end
    /* Registre el nuevo */
    if ((new.fcde_anulado = 'N') and (new.faco_id <> 0)) then
        BEGIN
        select faco_fecha, pref_pre, faco_numero, terc_nit, faco_imptos, faco_numprov, faco_remision, faco_orden, faco_consolida, faco_dtomonto, faco_adicional, faco_total, faco_ivamonto, faco_extra
            from facturas_compra where faco_id = new.faco_id
            into :fec, :Pref, :Num, :Nit, :ivainc, :numprov, :numrem, :numped, :consolida, :dtopie, :adicional, :total, :ivamonto, :extra;
        conc = 'FACTURA DE COMPRA No.' || PREF || NUM || '-' || NUMPROV;
        if (NUMREM <> '') then
            BEGIN
            AUX = SUBSTR(NUMREM, 1, 15);
            conc = conc || '-REM:' || AUX;
            END
        else
            if (NUMPED <> '') then
                BEGIN
                AUX = SUBSTR(NUMPED, 1, 15);
                conc = conc || '-ORDEN ' || AUX;
                END
        SELECT MAX(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :TIPO;
        if (Tipo is null) then
            Tipo = 0;
        execute procedure lee_configuracion('COMPRAS', 'FACTURAS', 'AFECTAR INVENTARIO CON LA FACTURA') returning_values (:INVFAC);
        /* si se hizo con base en una remision no afecte inventario */
        if ((Tipo <> 22) and (INVFAC = 'SI')) then
            begin
            execute procedure factor_unidad_cant(new.arti_cod, new.fcde_unidad) returning_values(factor);
            COSTO = ((new.fcde_prunit - NEW.fcde_dtomonto) / :factor);
            if (IVAINC = 'S') then
                COSTO = COSTO / (1 + NEW.fcde_ivaporc/100);
            EXECUTE PROCEDURE lee_configuracion('COMPRAS','FACTURAS','DESCUENTO Y VALOR ADICIONAL DEL DOCUMENTO COMO MENOR VALOR DEL COSTO') returning_values (:MENORV);
            if (MENORV = 'SI') then
                BEGIN
                FACT = (TOTAL - EXTRA - IVAMONTO);
                if ((FACT - ADICIONAL + DTOPIE) <> 0) then
                    FACT = FACT / (FACT - ADICIONAL + DTOPIE);
                ELSE
                    FACT = 1;
                COSTO = COSTO * FACT;
                END
            INSERT INTO MOVIMIENTO_ARTICULO
                (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
                VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 21, NEW.faco_id,
                :CONC, :factor * new.fcde_cant, :COSTO, 'S', new.fcde_lote, :Pref, :Num, NEW.fcde_item, :Nit);
            if (COSTO > 0 ) then
             BEGIN
              /* ACTUALICE EL COSTO POR PROVEEDOR */
              SELECT PVAR_FECHA FROM PROVEEDOR_ARTICULO
                WHERE TERC_NIT = :Nit AND ARTI_COD = NEW.ARTI_COD INTO :FECAUX;
              if (FECAUX IS NULL) then
                INSERT INTO PROVEEDOR_ARTICULO (TERC_NIT, ARTI_COD, PVAR_COSTO, PVAR_FECHA, PVAR_COD,PVAR_DES)
                    VALUES (:Nit, NEW.ARTI_COD, :COSTO, :fec, NEW.fcde_codprov,NEW.fcde_desc);
              else
                UPDATE PROVEEDOR_ARTICULO
                    SET PVAR_COSTO = :COSTO, PVAR_FECHA = :fec, PVAR_COD = NEW.fcde_codprov
                    WHERE ARTI_COD = NEW.ARTI_COD AND TERC_NIT = :Nit;
             END
            /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
            EXECUTE PROCEDURE CALCULA_PRECIOS(NEW.ARTI_COD, :FEC);
            end
        if (CONSOLIDA <> 0) then
            begin
            EXECUTE procedure LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
            /* IGNORE LA CONSOLIDACION SI SE VALIDAN CODIGOS DE LA ORDEN */
            SELECT MIN(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
            if (NUMROWS = 23) then
                BEGIN
                EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'VERIFICAR CODIGOS DE LA ORDEN') returning_values (MENORV);
                if (MENORV = 'SI') then
                    CONSO = 'SI';
                END
            if (CONSO = 'NO') then
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.faco_id, COFA_OK = 'S' WHERE COFA_ID = :consolida;
            else
                BEGIN
                UPDATE consolidado_faltantes SET COFA_OK = 'S' WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod;
                /* BUSQUE EL CONSOLIDADO EN EL MISMO ITEM Y SI ES DIFERENTE ACTUALICELO */
                select COFA_CANT * COFA_FACTOR FROM consolidado_faltantes WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod INTO :CANTREL;
                if (NEW.FCDE_CANT * NEW.FCDE_FACTOR < CANTREL) then
                    UPDATE consolidado_faltantes SET COFA_IDDES = NEW.faco_id, COFA_CANT = NEW.FCDE_CANT, COFA_FACTOR = NEW.FCDE_FACTOR
                        WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod;
                END
            end
        END
    end
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER TRIGGER REMISION_PROVEEDOR_DET_AI FOR REMISION_PROVEEDOR_DET
ACTIVE AFTER INSERT POSITION 0
AS
declare variable fec date;
declare variable CONC VARCHAR(60);
declare variable factor numeric(18,4);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable EXISTE CHAR(1);
declare variable NIT VARCHAR(20);
declare variable NUMPROV VARCHAR(20);
declare variable Tipo Integer;
declare variable idfact integer;
declare variable numrows integer;
declare variable IVAINC CHAR(2);
declare variable COSTO NUMERIC(18,2);
declare variable CANTREL NUMERIC(18,4);
declare variable NUMPED VARCHAR(30);
declare variable CONSO CHAR(2);
declare variable CONSOLIDA INTEGER;
declare variable DTOPIE NUMERIC(18,2);
declare variable ADICIONAL NUMERIC(18,2);
declare variable TOTAL NUMERIC(18,2);
declare variable IVAMONTO NUMERIC(18,2);
declare variable EXTRA NUMERIC(18,2);
declare variable FACT NUMERIC(18,4);
declare variable MENORV CHAR(2);
BEGIN
  if ((NEW.repr_id <> 0) and (new.rpvd_anulado = 'N')) then
    BEGIN
    select max(rprd_tiporel), max(rprd_idrel) from remision_proveedor_docrela
        where repr_id = new.repr_id into :Tipo, :idfact;
    if (Tipo is null) then
        Tipo = 0;
    /* si se hizo con base en una factura que afecto el inventario no afecte inventario */
    numrows = 0;
    if (Tipo = 21) Then
        select count(*) from movimiento_articulo where mvar_tipodoc = 21 and mvar_idref = :idfact into :numrows;
    if (numrows is null) then
        numrows = 0;
    if (numrows = 0) then
        begin
        select repr_fecha, pref_pre, repr_numero, REPR_IMPTOS, terc_nit, REPR_NUMPROV, REPR_ORDEN, REPR_CONSOLIDA, repr_dtomonto, repr_adicional, repr_total, repr_ivamonto, repr_extra
            from remision_proveedor where repr_id = new.repr_id
            into :fec, :Pref, :Num, :IVAINC, :NIT, :NUMPROV, :numped, :CONSOLIDA, :dtopie, :adicional, :total, :ivamonto, :extra;
        execute procedure factor_unidad_cant(new.arti_cod, new.rpvd_unidad) returning_values(factor);
        CONC = 'REMISION PROVEEDOR No.' || PREF || NUM || '-' || NUMPROV;
        if (numped <> '') then
            conc = conc || '-ORDEN ' || NUMPED;
        COSTO = ((new.rpvd_prunit - NEW.rpvd_dtomonto) / :factor);
        if (IVAINC = 'S') then
            COSTO = COSTO / (1 + NEW.rpvd_ivaporc/100);
        EXECUTE PROCEDURE lee_configuracion('COMPRAS','FACTURAS','DESCUENTO Y VALOR ADICIONAL DEL DOCUMENTO COMO MENOR VALOR DEL COSTO') returning_values (:MENORV);
        if (MENORV = 'SI') then
            BEGIN
            FACT = (TOTAL - EXTRA - IVAMONTO);
            if ((FACT - ADICIONAL + DTOPIE) <> 0) then
                FACT = FACT / (FACT - ADICIONAL + DTOPIE);
            ELSE
                FACT = 1;
            COSTO = COSTO * FACT;
            END
        INSERT INTO MOVIMIENTO_ARTICULO
          (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
          VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 22, NEW.repr_id,
          :CONC, :factor * new.rpvd_cant, :COSTO, 'S', new.rpvd_lote, :Pref, :Num, new.rpvd_item, :Nit);

        /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
        EXECUTE PROCEDURE CALCULA_PRECIOS(NEW.ARTI_COD, :FEC);

        if (COSTO > 0 ) then
         BEGIN
          /* GRABE PROV X ARTICULO */
          EXISTE = 'N';
          SELECT 'S' FROM PROVEEDOR_ARTICULO WHERE TERC_NIT = :NIT AND ARTI_COD = NEW.ARTI_COD INTO :EXISTE;
          if (EXISTE = 'S') then
            UPDATE PROVEEDOR_ARTICULO 
                SET PVAR_FECHA = :FEC, PVAR_COSTO = :COSTO, PVAR_COD = NEW.rpvd_codprov
                WHERE TERC_NIT = :NIT AND ARTI_COD = NEW.ARTI_COD;
          ELSE
            INSERT INTO PROVEEDOR_ARTICULO (TERC_NIT, ARTI_COD, PVAR_COSTO, PVAR_FECHA, PVAR_COD,PVAR_DES)
                VALUES (:NIT, NEW.ARTI_COD, :COSTO, :FEC, NEW.rpvd_codprov,NEW.rpvd_desc);
         END
        end

    /* ACTUALICE EL PENDIENTE  */
    if (CONSOLIDA <> 0) then
        BEGIN
        EXECUTE procedure LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
        SELECT MIN(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
        if (NUMROWS = 23) then
            BEGIN
            EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'REMISIONES', 'VERIFICAR CODIGOS DE LA ORDEN') returning_values (MENORV);
            if (MENORV = 'SI') then
                CONSO = 'SI';
            END
        if (CONSO = 'NO') then
            UPDATE consolidado_faltantes SET COFA_OK = 'S' WHERE COFA_ID = :consolida;
        ELSE
            BEGIN
            /* BUSQUE EL CONSOLIDADO EN EL MISMO ITEM Y SI ES DIFERENTE ACTUALICELO */
            select COFA_CANT * COFA_FACTOR FROM consolidado_faltantes WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.RPVD_ITEM AND ARTI_COD = NEW.arti_cod INTO :CANTREL;
            if (NEW.RPVD_CANT * NEW.RPVD_FACTOR < CANTREL) then
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.repr_id, COFA_CANT = NEW.RPVD_CANT, COFA_FACTOR = NEW.RPVD_FACTOR, COFA_OK = 'S' 
                    WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.RPVD_ITEM AND ARTI_COD = NEW.arti_cod;
            ELSE
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.repr_id, COFA_OK = 'S' WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.RPVD_ITEM AND ARTI_COD = NEW.arti_cod;
            END
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER TRIGGER REMISION_PROVEEDOR_DET_AD FOR REMISION_PROVEEDOR_DET
ACTIVE AFTER DELETE POSITION 0
AS
declare variable CONSO CHAR(2);
declare variable CONSOLIDA INTEGER;
BEGIN
if ((OLD.repr_id <> 0) AND (OLD.rpvd_anulado = 'N')) then
    begin
    delete from movimiento_articulo
      where (mvar_tipodoc = 22) and (mvar_idref = old.repr_id) and (mvar_item = old.rpvd_item);
    select REPR_CONSOLIDA from remision_proveedor where repr_id = old.repr_id into :CONSOLIDA;
    if (CONSOLIDA <> 0) then
        begin
        EXECUTE procedure LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
        if (CONSO = 'SI') then
            UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida AND COFA_ITEM = old.RPVD_ITEM AND ARTI_COD = old.arti_cod;
        else
            UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida;
        END
    end
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER TRIGGER REMISION_PROVEEDOR_DET_AU FOR REMISION_PROVEEDOR_DET
ACTIVE AFTER UPDATE POSITION 0
AS
declare variable fec date;
declare variable CONC VARCHAR(60);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable factor numeric(18,4);
declare variable EXISTE CHAR(1);
declare variable NIT VARCHAR(20);
declare variable NUMPROV VARCHAR(20);
declare variable Tipo integer;
declare variable idfact integer;
declare variable numrows integer;
declare variable IVAINC CHAR(2);
declare variable COSTO NUMERIC(18,2);
declare variable CANTREL NUMERIC(18,4);
declare variable NUMPED VARCHAR(30);
declare variable CONSO CHAR(2);
declare variable CONSOLIDA INTEGER;
declare variable DTOPIE NUMERIC(18,2);
declare variable ADICIONAL NUMERIC(18,2);
declare variable TOTAL NUMERIC(18,2);
declare variable IVAMONTO NUMERIC(18,2);
declare variable EXTRA NUMERIC(18,2);
declare variable FACT NUMERIC(18,4);
declare variable MENORV CHAR(2);
BEGIN
if ((OLD.repr_id <> 0) AND (OLD.rpvd_anulado = 'N')) then
    begin
    DELETE FROM MOVIMIENTO_ARTICULO WHERE (mvar_tipodoc = 22) and (mvar_idref = new.repr_id) and (mvar_item = old.rpvd_item);
    select REPR_CONSOLIDA from remision_proveedor where repr_id = old.repr_id into :CONSOLIDA;
    if (CONSOLIDA <> 0) then
        begin
        EXECUTE procedure LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
        if (CONSO = 'SI') then
            UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida AND COFA_ITEM = old.RPVD_ITEM AND ARTI_COD = old.arti_cod;
        else
            UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida;
        END
    end
/* Registre el nuevo */
if ((new.repr_id <> 0) AND (new.rpvd_anulado = 'N')) then
    begin
    select repr_fecha, pref_pre, repr_numero, repr_imptos, terc_nit, REPR_NUMPROV, REPR_ORDEN, REPR_CONSOLIDA, repr_dtomonto, repr_adicional, repr_total, repr_ivamonto, repr_extra
        from remision_proveedor where repr_id = new.repr_id
        into :fec, :Pref, :Num, :IVAINC, :NIT, :NUMPROV, :numped, :CONSOLIDA, :dtopie, :adicional, :total, :ivamonto, :extra;
    CONC = 'REMISION PROVEEDOR No.' || PREF || NUM || '-' || NUMPROV;
    if (numped <> '') then
        conc = conc || '-ORDEN ' || NUMPED;
    SELECT MAX(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :TIPO;
    if (Tipo is null) then
        Tipo = 0;
    select FACO_ID from FACTURAS_COMPRA WHERE FACO_CONSOLIDA = :consolida INTO :IDFACT;
    if (Idfact is null) then
        Idfact = 0;
    /* si se hizo con base en una factura que afecto el inventario no afecte inventario */
    numrows = 0;
    if (Tipo = 21) Then
        select count(*) from movimiento_articulo where mvar_tipodoc = 21 and mvar_idref = :idfact into :numrows;
    if (numrows is null) then
        numrows = 0;
    if (numrows = 0) then
        begin
        execute procedure factor_unidad_cant(new.arti_cod, new.rpvd_unidad) returning_values(factor);
        COSTO = ((new.rpvd_prunit - NEW.rpvd_dtomonto) / :factor);
        if (IVAINC = 'S') then
            COSTO = COSTO / (1 + NEW.rpvd_ivaporc/100);
        EXECUTE PROCEDURE lee_configuracion('COMPRAS','FACTURAS','DESCUENTO Y VALOR ADICIONAL DEL DOCUMENTO COMO MENOR VALOR DEL COSTO') returning_values (:MENORV);
        if (MENORV = 'SI') then
            BEGIN
            FACT = (TOTAL - EXTRA - IVAMONTO);
            if ((FACT - ADICIONAL + DTOPIE) <> 0) then
                FACT = FACT / (FACT - ADICIONAL + DTOPIE);
            ELSE
                FACT = 1;
            COSTO = COSTO * FACT;
            END
        INSERT INTO MOVIMIENTO_ARTICULO
            (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
            VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 22, NEW.repr_id,
            :CONC, :factor * new.rpvd_cant, :COSTO, 'S', new.rpvd_lote, :Pref, :Num, new.rpvd_item, :Nit);
            
        /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
        EXECUTE PROCEDURE CALCULA_PRECIOS(NEW.ARTI_COD, :FEC);
          
        if (COSTO > 0 ) then
         BEGIN
          /* GRABE PROV X ARTICULO */
          EXISTE = 'N';
          SELECT 'S' FROM PROVEEDOR_ARTICULO WHERE TERC_NIT = :NIT AND ARTI_COD = NEW.ARTI_COD INTO :EXISTE;
          if (EXISTE = 'S') then
            UPDATE PROVEEDOR_ARTICULO
                SET PVAR_FECHA = :FEC, PVAR_COSTO = :COSTO, PVAR_COD = NEW.rpvd_codprov
                WHERE TERC_NIT = :NIT AND ARTI_COD = NEW.ARTI_COD;
          ELSE
            INSERT INTO PROVEEDOR_ARTICULO (TERC_NIT, ARTI_COD, PVAR_COSTO, PVAR_FECHA, PVAR_COD,PVAR_DES)
                VALUES (:NIT, NEW.ARTI_COD, :COSTO, :FEC, NEW.rpvd_codprov,NEW.rpvd_desc);
         END
        end
    if (CONSOLIDA <> 0) then
        BEGIN
        EXECUTE procedure LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
        /* IGNORE LA CONSOLIDACION SI SE VALIDAN CODIGOS DE LA ORDEN */
        SELECT MIN(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
        if (NUMROWS = 23) then
            BEGIN
            EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'REMISIONES', 'VERIFICAR CODIGOS DE LA ORDEN') returning_values (MENORV);
            if (MENORV = 'SI') then
                CONSO = 'SI';
            END
        if (CONSO = 'NO') then
            UPDATE consolidado_faltantes SET COFA_IDDES = NEW.repr_id, COFA_OK = 'S' WHERE COFA_ID = :consolida;
        ELSE
            BEGIN
            /* BUSQUE EL CONSOLIDADO EN EL MISMO ITEM Y SI ES DIFERENTE ACTUALICELO */
            select COFA_CANT * COFA_FACTOR FROM consolidado_faltantes WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.RPVD_ITEM AND ARTI_COD = NEW.arti_cod INTO :CANTREL;
            if (NEW.RPVD_CANT * NEW.RPVD_FACTOR < CANTREL) then
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.repr_id, COFA_CANT = NEW.RPVD_CANT, COFA_FACTOR = NEW.RPVD_FACTOR, COFA_OK = 'S' 
                    WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.RPVD_ITEM AND ARTI_COD = NEW.arti_cod;
            else
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.repr_id, COFA_OK = 'S' WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.RPVD_ITEM AND ARTI_COD = NEW.arti_cod;
            END
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER TRIGGER ORDENES_COMPRA_DETALLE_AI FOR ORDENES_COMPRA_DETALLE
ACTIVE AFTER INSERT POSITION 0
as
declare variable CONSO CHAR(2);
declare variable CONSOLIDA INTEGER;
declare variable CANTREL NUMERIC(18,4);
declare variable COSTO NUMERIC(18,2);
declare variable FACTOR NUMERIC(18,4);
declare variable NIT VARCHAR(20);
declare variable FEC DATE;
declare variable IVAINC CHAR(1);
declare variable DTOPIE NUMERIC(18,2);
declare variable ADICIONAL NUMERIC(18,2);
declare variable TOTAL NUMERIC(18,2);
declare variable IVAMONTO NUMERIC(18,2);
declare variable EXTRA NUMERIC(18,2);
declare variable FACT NUMERIC(18,4);
declare variable MENORV CHAR(2);
declare variable EXISTE CHAR(1);
begin
if ((NEW.ORDC_ID <> 0) and (new.ocde_anulado = 'N')) then
    BEGIN
    SELECT ORDC_CONSOLIDA FROM ORDENES_COMPRA WHERE ORDC_ID = NEW.ordc_id INTO :CONSOLIDA;
    /* ACTUALICE EL PENDIENTE  */
    if (CONSOLIDA <> 0) then
        BEGIN
        EXECUTE procedure LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
        if (CONSO = 'NO') then
            UPDATE consolidado_faltantes SET COFA_IDDES = NEW.ordc_id, COFA_OK = 'S' WHERE COFA_ID = :consolida;
        ELSE
            BEGIN
            UPDATE consolidado_faltantes SET COFA_IDDES = NEW.ordc_id, COFA_OK = 'S' WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.OCDE_ITEM AND ARTI_COD = NEW.arti_cod;
            /* BUSQUE EL CONSOLIDADO EN EL MISMO ITEM Y SI ES DIFERENTE ACTUALICELO */
            select COFA_CANT FROM consolidado_faltantes WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.OCDE_ITEM AND ARTI_COD = NEW.arti_cod INTO :CANTREL;
            if (NEW.OCDE_CANT * NEW.OCDE_FACTOR < CANTREL) then
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.ordc_id, COFA_CANT = NEW.OCDE_CANT * NEW.OCDE_FACTOR
                    WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.OCDE_ITEM AND ARTI_COD = NEW.arti_cod;
            END
        END
    SELECT TERC_NIT, ORDC_FECHA, ORDC_IMPTOS, ORDC_DTOMONTO, ORDC_ADICIONAL, ORDC_EXTRA, ORDC_TOTAL, ORDC_IVAMONTO
        FROM ordenes_compra WHERE ORDC_ID = NEW.ordc_id
        INTO :NIT, :FEC, :IVAINC, :DTOPIE, :adicional,  :extra, :total, :ivamonto;
    execute procedure factor_unidad_cant(new.arti_cod, new.ocde_unidad) returning_values(factor);
    COSTO = ((new.ocde_prunit - NEW.ocde_dtomonto) / :factor);
    if (IVAINC = 'S') then
        COSTO = COSTO / (1 + NEW.ocde_ivaporc/100);
    EXECUTE PROCEDURE lee_configuracion('COMPRAS','FACTURAS','DESCUENTO Y VALOR ADICIONAL DEL DOCUMENTO COMO MENOR VALOR DEL COSTO') returning_values (:MENORV);
    if (MENORV = 'SI') then
        BEGIN
        FACT = (TOTAL - EXTRA - IVAMONTO);
        if ((FACT - ADICIONAL + DTOPIE) <> 0) then
            FACT = FACT / (FACT - ADICIONAL + DTOPIE);
        ELSE
            FACT = 1;
        COSTO = COSTO * FACT;
        END
    if (COSTO > 0 ) then
     BEGIN
      /* GRABE PROV X ARTICULO */
      EXISTE = 'N';
      SELECT 'S' FROM PROVEEDOR_ARTICULO WHERE TERC_NIT = :NIT AND ARTI_COD = NEW.ARTI_COD INTO :EXISTE;
      if (EXISTE = 'S') then
        UPDATE PROVEEDOR_ARTICULO
            SET PVAR_FECHA = :FEC, PVAR_COSTO = :COSTO, PVAR_COD = NEW.ocde_codprov
            WHERE TERC_NIT = :NIT AND ARTI_COD = NEW.ARTI_COD;
      ELSE
        INSERT INTO PROVEEDOR_ARTICULO (TERC_NIT, ARTI_COD, PVAR_COSTO, PVAR_FECHA, PVAR_COD,PVAR_DES)
            VALUES (:NIT, NEW.ARTI_COD, :COSTO, :FEC, NEW.ocde_codprov,NEW.ocde_desc);
     END
    END
end
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER TRIGGER ORDENES_COMPRA_DETALLE_AD FOR ORDENES_COMPRA_DETALLE
ACTIVE AFTER DELETE POSITION 0
as
declare variable CONSOLIDA INTEGER;
declare variable CONSO CHAR(2);
begin
if ((old.ORDC_ID <> 0) AND (old.ocde_anulado = 'N')) THEN
    BEGIN
    SELECT ORDC_CONSOLIDA FROM ORDENES_COMPRA WHERE ORDC_ID = old.ordc_id INTO :CONSOLIDA;
    /* ACTUALICE EL PENDIENTE  */
    if (CONSOLIDA <> 0) then
        begin
        EXECUTE procedure LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
        if (CONSO = 'SI') then
            UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida AND COFA_ITEM = old.OCDE_ITEM AND ARTI_COD = old.arti_cod;
        else
            UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida;
        end
    END
end
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER TRIGGER ORDENES_COMPRA_DETALLE_AU FOR ORDENES_COMPRA_DETALLE
ACTIVE AFTER UPDATE POSITION 0
as
declare variable CONSO CHAR(2);
declare variable CONSOLIDA INTEGER;
declare variable CANTREL NUMERIC(18,4);
declare variable COSTO NUMERIC(18,2);
declare variable FACTOR NUMERIC(18,4);
declare variable NIT VARCHAR(20);
declare variable FEC DATE;
declare variable IVAINC CHAR(1);
declare variable DTOPIE NUMERIC(18,2);
declare variable ADICIONAL NUMERIC(18,2);
declare variable TOTAL NUMERIC(18,2);
declare variable IVAMONTO NUMERIC(18,2);
declare variable EXTRA NUMERIC(18,2);
declare variable FACT NUMERIC(18,4);
declare variable MENORV CHAR(2);
declare variable EXISTE CHAR(1);
begin
if ((old.ORDC_ID <> 0) AND (old.ocde_anulado = 'N')) THEN
    BEGIN
    SELECT ORDC_CONSOLIDA FROM ORDENES_COMPRA WHERE ORDC_ID = old.ordc_id INTO :CONSOLIDA;
    /* ACTUALICE EL PENDIENTE  */
    if (CONSOLIDA <> 0) then
        begin
        EXECUTE procedure LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
        if (CONSO = 'SI') then
            UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida AND COFA_ITEM = old.OCDE_ITEM AND ARTI_COD = old.arti_cod;
        else
            UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida;
        end
    END
if ((NEW.ORDC_ID <> 0) AND (new.ocde_anulado = 'N')) THEN
    BEGIN
    SELECT ORDC_CONSOLIDA FROM ORDENES_COMPRA WHERE ORDC_ID = NEW.ordc_id INTO :CONSOLIDA;
    /* ACTUALICE EL PENDIENTE  */
    if (CONSOLIDA <> 0) then
        BEGIN
        EXECUTE procedure LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','DEJAR PENDIENTES LOS ARTICULOS NO INCLUIDOS AL TRAER DOCUMENTOS RELACIONADOS') returning_values (CONSO);
        if (CONSO = 'NO') then
            UPDATE consolidado_faltantes SET COFA_IDDES = NEW.ordc_id, COFA_OK = 'S' WHERE COFA_ID = :consolida;
        ELSE
            BEGIN
            UPDATE consolidado_faltantes SET COFA_OK = 'S' WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.OCDE_ITEM AND ARTI_COD = NEW.arti_cod;
            /* BUSQUE EL CONSOLIDADO EN EL MISMO ITEM Y SI ES DIFERENTE ACTUALICELO */
            select COFA_CANT FROM consolidado_faltantes WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.OCDE_ITEM AND ARTI_COD = NEW.arti_cod INTO :CANTREL;
            if (NEW.OCDE_CANT * NEW.OCDE_FACTOR < CANTREL) then
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.ordc_id, COFA_CANT = NEW.OCDE_CANT * NEW.OCDE_FACTOR
                    WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.OCDE_ITEM AND ARTI_COD = NEW.arti_cod;
            END
        END

    SELECT TERC_NIT, ORDC_FECHA, ORDC_IMPTOS, ORDC_DTOMONTO, ORDC_ADICIONAL, ORDC_EXTRA, ORDC_TOTAL, ORDC_IVAMONTO
        FROM ordenes_compra WHERE ORDC_ID = NEW.ordc_id
        INTO :NIT, :FEC, :IVAINC, :DTOPIE, :adicional,  :extra, :total, :ivamonto;
    execute procedure factor_unidad_cant(new.arti_cod, new.ocde_unidad) returning_values(factor);
    COSTO = ((new.ocde_prunit - NEW.ocde_dtomonto) / :factor);
    if (IVAINC = 'S') then
        COSTO = COSTO / (1 + NEW.ocde_ivaporc/100);
    EXECUTE PROCEDURE lee_configuracion('COMPRAS','FACTURAS','DESCUENTO Y VALOR ADICIONAL DEL DOCUMENTO COMO MENOR VALOR DEL COSTO') returning_values (:MENORV);
    if (MENORV = 'SI') then
        BEGIN
        FACT = (TOTAL - EXTRA - IVAMONTO);
        if ((FACT - ADICIONAL + DTOPIE) <> 0) then
            FACT = FACT / (FACT - ADICIONAL + DTOPIE);
        ELSE
            FACT = 1;
        COSTO = COSTO * FACT;
        END

    if (COSTO > 0 ) then
     BEGIN
      /* GRABE PROV X ARTICULO */
      EXISTE = 'N';
      SELECT 'S' FROM PROVEEDOR_ARTICULO WHERE TERC_NIT = :NIT AND ARTI_COD = NEW.ARTI_COD INTO :EXISTE;
      if (EXISTE = 'S') then
        UPDATE PROVEEDOR_ARTICULO
            SET PVAR_FECHA = :FEC, PVAR_COSTO = :COSTO, PVAR_COD = NEW.ocde_codprov
            WHERE TERC_NIT = :NIT AND ARTI_COD = NEW.ARTI_COD;
      ELSE
        INSERT INTO PROVEEDOR_ARTICULO (TERC_NIT, ARTI_COD, PVAR_COSTO, PVAR_FECHA, PVAR_COD,PVAR_DES)
            VALUES (:NIT, NEW.ARTI_COD, :COSTO, :FEC, NEW.ocde_codprov,NEW.ocde_desc);
     END
    END
end
^

SET TERM ; ^


/* 05-17 cuentas de cliente por zona */
SET TERM ^ ;

create PROCEDURE CAMBIA_CTAS_CLIENTES (
    cli_ini varchar(15),
    cli_fin varchar(15))
as
declare variable cliente varchar(20);
declare variable zona varchar(2);
declare variable cta1 varchar(20);
declare variable cta2 varchar(20);
declare variable cta3 varchar(20);
declare variable cta4 varchar(20);
declare variable cta5 varchar(20);
begin
FOR SELECT T.terc_nit, C.zona_cod  FROM TERCEROS T, CLIENTES C WHERE T.terc_nit >= :CLI_INI AND T.terc_nit <= :CLI_fin
    INTO :CLIENTE, :ZONA
    DO
    BEGIN
       SELECT GP.zona_ctaventas, GP.zona_ctacliente, GP.zona_ctartfte, GP.zona_ctariva, GP.zona_ctarica
        FROM ZONAS GP
         WHERE GP.zona_cod = :ZONA
         into :CTA1,:CTA2,:CTA3,:CTA4,:CTA5;
         update TERCEROS TER
         SET TER.terc_ctaventa = :CTA1,
             TER.terc_ctacliente = :CTA2,
             TER.terc_ctartfte = :CTA3,
             TER.terc_ctartiva = :CTA4,
             TER.terc_ctartica = :CTA5
         where TER.TERC_NIT = :CLIENTE;
    END
end
^

SET TERM ; ^



/* 05-18 cuentas proveedor por grupo */
SET TERM ^ ;

CREATE PROCEDURE CAMBIA_CTAS_PROVEEDOR (
    pro_ini varchar(15),
    pro_fin varchar(15))
as
declare variable prove varchar(20);
declare variable grupo varchar(2);
declare variable cta1 varchar(20);
declare variable cta2 varchar(20);
declare variable cta3 varchar(20);
declare variable cta4 varchar(20);
begin
FOR SELECT P.terc_nit, P.grpr_cod FROM PROVEEDORES P WHERE P.terc_nit >= :PRO_INI AND P.terc_nit <= :PRO_FIN
    INTO :PROVE, :GRUPO
    DO
    BEGIN
       SELECT GP.grpr_ctaprov, GP.grpr_ctartfte, GP.grpr_ctartiva, GP.grpr_ctartica
        FROM grupos_proveedores GP
         WHERE GP.grpr_cod = :GRUPO
         into :CTA1,:CTA2,:CTA3,:CTA4;
         update proveedores P
         SET P.prov_ctapagar = :CTA1,
             P.prov_ctartfte = :CTA2,
             P.prov_ctartiva = :CTA3,
             P.prov_ctartica = :CTA4
         where p.terc_nit = :prove;
    END
end
^

SET TERM ; ^


/* 05-20 reporte de precios a modificar */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE REVISA_PRECIOS(
    LISTA INTEGER,
    FECHA DATE)
RETURNS (
    ARTICULO VARCHAR(20),
    DESCR VARCHAR(60),
    FIJO NUMERIC(18,2),
    UNIDAD VARCHAR(8),
    PORC NUMERIC(9,4),
    SUGERIDO NUMERIC(18,2),
    DIFER NUMERIC(18,2))
AS
declare variable marg numeric(9,4);
declare variable UOM VARCHAR(10);
declare variable BASE VARCHAR(10);
declare variable CAMBIO VARCHAR(10);
declare variable COSTO numeric(18,2);
declare variable COSTOP numeric(18,2);
declare variable COSTOU numeric(18,2);
declare variable DIFMAX numeric(18,2);
declare variable DIG INTEGER;
declare variable TARIVA NUMERIC(9,4);
declare variable IVAINC CHAR(1);
declare variable LISTAREF INTEGER;
begin
execute procedure lee_configuracion ('FACTURACION', 'ARTICULOS', 'SUGERIR PRECIOS CON PORCENTAJE DE MARGEN O UTILIDAD') returning_values (:UOM);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'ARTICULOS', 'REDONDEO AL MULTIPLO DE DIEZ EN PRECIOS') RETURNING_VALUES (:DIG);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','CAMBIO DE PRECIOS AUTOMATICO AL CAMBIAR COSTO O PRECIO') returning_values (CAMBIO);
EXECUTE PROCEDURE lee_configuracion('FACTURACION','ARTICULOS','COSTO BASE PARA CALCULO DE PRECIOS DE VENTA AUTOMATICOS') returning_values (:BASE);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','CODIGO DE LA LISTA DE PRECIOS BASE PARA CAMBIO DE PRECIOS AUTOMATICO') returning_values (LISTAREF);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','DIFERENCIA EN PESOS MAXIMA A PERMITIR PARA CAMBIAR PRECIOS') returning_values (DIFMAX);
for select A.arti_cod, A.arti_des, A.arti_unidad, prar_fijo, prar_margen, prar_util, TAIV_PORC
    from precios_articulo p, articulo a, tarifa_iva T
    where a.arti_cod = p.arti_cod and lipr_cod = :lista and a.taiv_cod = t.taiv_cod order by A.arti_cod
    into :articulo, descr, :unidad, :fijo, :porc, :marg, :tariva
    do
    begin
    if (UOM <> 'UTILIDAD') then
        PORC = MARG;
    if (CAMBIO = 'COSTO') then
        BEGIN
        EXECUTE PROCEDURE COSTO_PROMEDIO (:ARTICULO, :FECHA) RETURNING_VALUES(:COSTOP);
        EXECUTE PROCEDURE ULTIMO_COSTO (:ARTICULO, :FECHA, :UNIDAD) RETURNING_VALUES(:COSTOU);
        if (base = 'ULTIMO') then
            COSTO = COSTOU;
        ELSE
            BEGIN
            COSTO = COSTOP;
            if (base = 'MAYOR') then
                if (COSTOP < COSTOU) then
                    COSTO = COSTOU;
            END
        SELECT LIPR_MODIF FROM LISTA_PRECIOS WHERE LIPR_COD = :lista INTO :IVAINC;
        if (IVAINC = 'S') then
            COSTO = COSTO * (1 + TARIVA/100);
        if (UOM = 'UTILIDAD') then
            SUGERIDO = COSTO * (1 + :PORC/100);
        ELSE
            SUGERIDO = COSTO / (1 - :PORC/100);
        END
    ELSE
        if (LISTA <> LISTAREF) then
            BEGIN
            SELECT PRAR_FIJO FROM PRECIOS_ARTICULO WHERE ARTI_COD = :articulo AND LIPR_COD = :LISTAREF INTO :SUGERIDO;
            if (IVAINC = 'S') then
                SUGERIDO = SUGERIDO / (1 + TARIVA/100);
            if (UOM = 'UTILIDAD') then
                SUGERIDO = SUGERIDO * (1 + :PORC/100);
            ELSE
                SUGERIDO = SUGERIDO / (1 - :PORC/100);
            END
    EXECUTE PROCEDURE REDONDEE (SUGERIDO, DIG) returning_values (SUGERIDO);
    DIFER = SUGERIDO - FIJO;
    if ((DIFER > DIFMAX) and (sugerido <> 0)) then
        suspend;
    end
end
^

SET TERM ; ^


/* 05-21 consultas inventario con fecha inicial y final */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE MOVIMIENTO_INVENTARIO_MES(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    CODIGO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    INICIAL NUMERIC(18,4),
    ENTRADA NUMERIC(18,4),
    SALIDA NUMERIC(18,4),
    FINAL NUMERIC(18,4))
AS
BEGIN
  for select arti_cod, arti_des from articulo order by arti_des into :CODIGO, :DESCRIPCION
  DO
    BEGIN
    EXECUTE PROCEDURE MOVIMIENTO_TOTAL_ARTICULO_MES(CODIGO, FECINI, FECFIN) returning_values (:INICIAL, :ENTRADA, :SALIDA);
    FINAL = INICIAL + ENTRADA - SALIDA;
    SUSPEND;
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE KARDEX_INVENTARIO_MES(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    CODIGO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    INICIAL NUMERIC(18,2),
    ENTRADA NUMERIC(18,2),
    SALIDA NUMERIC(18,2),
    FINAL NUMERIC(18,2))
AS
BEGIN
  for select arti_cod, arti_des from articulo into :CODIGO, :DESCRIPCION
  DO
    BEGIN
/*    EXECUTE PROCEDURE KARDEX_ARTICULO_MES(CODIGO, ANO, MES) returning_values (:INICIAL, :ENTRADA, :SALIDA); */
    FINAL = INICIAL + ENTRADA - SALIDA;
    SUSPEND;
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE KARDEX_ARTICULO_MES(
    ARTICULO VARCHAR(15),
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    INICIAL NUMERIC(18,2),
    ENTRADA NUMERIC(18,2),
    SALIDA NUMERIC(18,2))
AS
BEGIN
  EXECUTE PROCEDURE VALOR_INICIAL_INVENTARIO(ARTICULO, FECINI) returning_values (INICIAL);
  SELECT SUM(COST_ENTP) FROM COSTOS
    WHERE (COST_FECHA >= :FECINI) AND (COST_FECHA < :FECFIN) AND
          (ARTI_COD = :ARTICULO) INTO :ENTRADA;
  if (ENTRADA IS NULL) then
    ENTRADA = 0;
  SELECT SUM(COST_SALP) FROM COSTOS
    WHERE (COST_FECHA >= :FECINI) AND (COST_FECHA < :FECFIN) AND
          (ARTI_COD = :ARTICULO) INTO :SALIDA;
  if (SALIDA IS NULL) then
    SALIDA = 0;
  SUSPEND;
END
^

SET TERM ; ^


SET TERM ^ ;

CREATE OR ALTER PROCEDURE KARDEX_INVENTARIO_MES(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    CODIGO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    INICIAL NUMERIC(18,2),
    ENTRADA NUMERIC(18,2),
    SALIDA NUMERIC(18,2),
    FINAL NUMERIC(18,2))
AS
BEGIN
  for select arti_cod, arti_des from articulo into :CODIGO, :DESCRIPCION
  DO
    BEGIN
    EXECUTE PROCEDURE KARDEX_ARTICULO_MES(CODIGO, FECINI, FECFIN) returning_values (:INICIAL, :ENTRADA, :SALIDA);
    FINAL = INICIAL + ENTRADA - SALIDA;
    SUSPEND;
    END
END
^

SET TERM ; ^


/* 05-22 contabilizacion egresos redondeo GMF */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE CONTABIL_EGRESO(
    IDDOC INTEGER,
    IDINTER INTEGER)
RETURNS (
    ERROR INTEGER,
    VER CHAR(1),
    IDC INTEGER)
AS
declare variable PREF VARCHAR(4);
declare variable NUM VARCHAR(6);
declare variable NUMERO VARCHAR(10);
declare variable FECAUX DATE;
declare variable FECHA CHAR(8);
declare variable CONC CHAR(120);
declare variable VRDTO NUMERIC(18, 2);
declare variable VRRTFTE NUMERIC(18, 2);
declare variable VRRTIVA NUMERIC(18, 2);
declare variable VRRTICA NUMERIC(18, 2);
declare variable VRTOTAL NUMERIC(18, 2);
declare variable TIPOCOMP VARCHAR(3);
declare variable PREFCONT VARCHAR(4);
declare variable BASE CHAR(1);
declare variable CTABASE VARCHAR(20);
declare variable CAJA CHAR(1);
declare variable CTACAJA VARCHAR(20);
declare variable RTFTE CHAR(1);
declare variable CTARTFTE VARCHAR(20);
declare variable RTIVA CHAR(1);
declare variable CTARTIVA VARCHAR(20);
declare variable RTICA CHAR(1);
declare variable CTARTICA VARCHAR(20);
declare variable DTO CHAR(1);
declare variable CTADTO VARCHAR(20);
declare variable EXISTE CHAR(1);
declare variable CUENTA VARCHAR(20);
declare variable MONTO NUMERIC(18,2);
declare variable ES_RETENCION CHAR(1);
declare variable TIPOCUEN CHAR(1);
declare variable NIT VARCHAR(20);
declare variable NOMBRE VARCHAR(60);
declare variable PROY VARCHAR(4);
declare variable CENTRO VARCHAR(4);
declare variable MONTOBASE NUMERIC(18,2);
declare variable PORC NUMERIC(9,2);
declare variable DEBITO NUMERIC(18,2);
declare variable CREDITO NUMERIC(18,2);
declare variable NROI INTEGER;
declare variable SUMA NUMERIC(18,2);
declare variable TCTACLIEN VARCHAR(20);
declare variable TCTARTFTE VARCHAR(20);
declare variable TCTARTIVA VARCHAR(20);
declare variable TCTARTICA VARCHAR(20);
declare variable TIPOIT INTEGER;
declare variable PREFIT VARCHAR(4);
declare variable NUMIT VARCHAR(6);
declare variable NUMEROIT VARCHAR(10);
declare variable ABONOIT NUMERIC(18,2);
declare variable CTADIC VARCHAR(20);
declare variable BASEADIC VARCHAR(20);
declare variable PORCADIC NUMERIC(5,2);
declare variable VALORADIC NUMERIC(18,2);
declare variable DBADIC CHAR(1);
declare variable VRBASE NUMERIC(18,2);
declare variable GMF CHAR(1);
declare variable CODBCO INTEGER;
declare variable NUMCHEQ VARCHAR(20);
BEGIN
/* BUSQUE LA INTERFACE */
EXISTE = 'N';
SELECT 'S', TICO_COD, PRCO_PRE, INCJ_BASE, INCJ_DTOPP, INCJ_RTFTE, INCJ_RTIVA, INCJ_RTICA, INCJ_CAJA, INCJ_CTABASE, INCJ_CTADTO, INCJ_CTARTFTE, INCJ_CTARTIVA, INCJ_CTARTICA, INCJ_CTACAJA, INCJ_CONFIRMAR
    FROM INTERFAZ_CAJA
    WHERE INCJ_ID = :IDINTER
    INTO :EXISTE, :TIPOCOMP, :PREFCONT, :BASE, :DTO, :RTFTE, :RTIVA, :RTICA, :CAJA, :CTABASE, :CTADTO, :CTARTFTE, :CTARTIVA, :CTARTICA, :CTACAJA, :VER;
if (EXISTE = 'S') then
    BEGIN
    DELETE FROM contabilizacion WHERE CNTB_TIPOREF = 62 AND CNTB_IDREF = :IDDOC;

    /* TRAIGA EL ENCABEZADO DEL EGRESO */
    SELECT PREF_PRE, EGRE_NUMERO, EGRE_FECHA, E.TERC_NIT, EGRE_CONC, EGRE_DTOF, EGRE_MONTO, EGRE_RTFTEMONTO, EGRE_RTIVAMONTO, EGRE_RTICAMONTO, TERC_NOM, TERC_CTARTFTE, TERC_CTARTIVA, TERC_CTARTICA, TERC_CTACLIENTE
        FROM EGRESOS E, TERCEROS T
        WHERE EGRE_ID = :IDDOC AND E.TERC_NIT = T.TERC_NIT
        INTO :PREF, :NUM, :FECAUX, :NIT, :CONC, :VRDTO, :VRTOTAL, :VRRTFTE, :VRRTIVA, :VRRTICA, :NOMBRE, TCTARTFTE, TCTARTIVA, TCTARTICA, TCTACLIEN;
    /* SI ES PROVEEDOR, SOBREESCIBE LAS CUENTAS  */
    SELECT PROV_CTAPAGAR, PROV_CTARTFTE, PROV_CTARTIVA, PROV_CTARTICA
        FROM PROVEEDORES WHERE TERC_NIT = :NIT
        INTO TCTACLIEN, TCTARTFTE, TCTARTIVA, TCTARTICA;
    NUMERO = PREF || NUM;
    SELECT PREF_CENTRO, PREF_PROY FROM PREFIJOS
        WHERE PREF_PRE = :PREF AND TIDO_COD = 62 INTO :CENTRO, :PROY;
    EXECUTE PROCEDURE FECHA_A_CONTA(:FECAUX) returning_values (:FECHA);
    /* REGISTRE EL ENCABEZADO CONTABLE */
    IDC = GEN_ID(ID_CONTABILIZA, 1);
    INSERT INTO CONTABILIZACION (CNTB_ID, CNTB_TIPOCOMP, CNTB_PREFCNT, CNTB_NUMERO, CNTB_FECHA, CNTB_CONCEPTO, CNTB_REF, CNTB_TIPOREF, CNTB_IDREF, CNTB_PREFREF, CNTB_NUMREF, CNTB_PROCESADO)
        VALUES (:IDC, :TIPOCOMP, :PREFCONT, :NUM, :FECHA, :CONC, '', 62, :IDDOC, :PREF, :NUM, 'N');
    NROI = 0;
    SUMA = 0;
    ERROR = 0;
    /* EL CREDITO EN LA CAJA O EL BANCO */
    IF ((CAJA = 'K')) THEN
        BEGIN
        if (VRTOTAL <> 0) then
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTACAJA INTO :CUENTA, :TIPOCUEN;
            if (CUENTA IS NULL) then
                begin
                EXECUTE PROCEDURE ERROR (62, :IDDOC, :CTACAJA, 2);
                CUENTA = CTACAJA;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                BEGIN
                EXECUTE PROCEDURE ERROR (62, :IDDOC, :CUENTA, 3);
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                EXECUTE PROCEDURE ERROR (62, :IDDOC, :CUENTA, 4);
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRTOTAL, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - VRTOTAL;
                END
            END /* VRTOTAL <> 0 */
        END /* CAJA CONSTANTE */
    IF ((CAJA = 'F')) THEN
        BEGIN
        /* mueva la cuenta de la caja o el banco o ambas */
        /* PRIMERO LA CAJA */
        FOR SELECT CAJA_CUENTA, EGCA_MONTO FROM EGRESOS_CAJA E, CAJAS C
            WHERE C.CAJA_ID = E.CAJA_ID AND EGRE_ID = :IDDOC
            INTO :CTACAJA, :MONTO
            DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                CUENTA = NULL;
                SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                    WHERE CUEN_COD = :CTACAJA INTO :CUENTA, :TIPOCUEN;
                if (CUENTA IS NULL) then
                    begin
                    EXECUTE PROCEDURE ERROR (62, :IDDOC, :CTACAJA, 2);
                    CUENTA = CTACAJA;
                    TIPOCUEN = 'N';
                    ERROR = ERROR + 1;
                    end
                if (TIPOCUEN = 'I') then
                    BEGIN
                    EXECUTE PROCEDURE ERROR (62, :IDDOC, :CUENTA, 3);
                    TIPOCUEN = 'N';
                    ERROR = ERROR + 1;
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    EXECUTE PROCEDURE ERROR (62, :IDDOC, :CUENTA, 4);
                    TIPOCUEN = 'N';
                    ERROR = ERROR + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - MONTO;
                    END
                END /* MONTO <> 0 */
            END /* DO CAJA */
        /* AHORA EL BANCO */
        MONTO = 0;
        SELECT CUBA_CTACONTA, EGBC_MONTO, EGBC_GMF, E.CUBA_COD, CUBA_GMFPOR, EGBC_NUMERO
            FROM EGRESOS_BANCO E, CUENTAS_BANCO C
            WHERE E.CUBA_COD = C.CUBA_COD AND EGRE_ID = :IDDOC
            INTO :CTACAJA, :MONTO, :GMF, :CODBCO, :PORC, :NUMCHEQ;
        if (MONTO <> 0) then
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                CUENTA = NULL;
                SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                    WHERE CUEN_COD = :CTACAJA INTO :CUENTA, :TIPOCUEN;
                if (CUENTA IS NULL) then
                    begin
                    EXECUTE PROCEDURE ERROR (62, :IDDOC, :CTACAJA, 2);
                    CUENTA = CTACAJA;
                    TIPOCUEN = 'N';
                    ERROR = ERROR + 1;
                    end
                if (TIPOCUEN = 'I') then
                    BEGIN
                    EXECUTE PROCEDURE ERROR (62, :IDDOC, :CUENTA, 3);
                    TIPOCUEN = 'N';
                    ERROR = ERROR + 1;
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    EXECUTE PROCEDURE ERROR (62, :IDDOC, :CUENTA, 4);
                    TIPOCUEN = 'N';
                    ERROR = ERROR + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, :NUMCHEQ, 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - MONTO;
                    END
                /* EL GMF */
                if ((GMF = 'S') AND (PORC <> 0)) then
                    BEGIN
                    EXECUTE procedure REDONDEE(:MONTO * :PORC / 1000, 0) returning_values (MONTO);
                    /* REGISTRE EL GMF EN LA MISMA CUENTA DEL BANCO COMO CREDITO */
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, :NUMCHEQ, 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - MONTO;

                    /* AHORA LA CUENTA DEL GASTO */
                    SELECT CUBA_CTAGMF FROM CUENTAS_BANCO
                        where CUBA_COD = :CODBCO INTO :CTACAJA;
                    SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                        WHERE CUEN_COD = :CTACAJA INTO :CUENTA, :TIPOCUEN;
                    if (CUENTA IS NULL) then
                        begin
                        EXECUTE PROCEDURE ERROR (62, :IDDOC, :CTACAJA, 2);
                        CUENTA = CTACAJA;
                        TIPOCUEN = 'N';
                        ERROR = ERROR + 1;
                        end
                    if (TIPOCUEN = 'I') then
                        BEGIN
                        EXECUTE PROCEDURE ERROR (62, :IDDOC, :CUENTA, 3);
                        TIPOCUEN = 'N';
                        ERROR = ERROR + 1;
                        END
                    if (TIPOCUEN = 'C') then
                        BEGIN
                        EXECUTE PROCEDURE ERROR (62, :IDDOC, :CUENTA, 4);
                        TIPOCUEN = 'N';
                        ERROR = ERROR + 1;
                        END
                    if (TIPOCUEN = 'N') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, :NUMCHEQ, :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA + MONTO;
                        END
                    END /* GMF */
                END /* MONTO <> 0 */
            END /* EGRESO_BANCO */
        END /* CAJA = F */
    if (DTO = 'K') then /* DTO EN CTA CONSTANTE */
        BEGIN
        if (VRDTO <> 0) then
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTADTO INTO :CUENTA, :TIPOCUEN;
            if (CUENTA IS NULL) then
                begin
                EXECUTE PROCEDURE ERROR (62, :IDDOC, :CTADTO, 2);
                CUENTA = CTADTO;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                BEGIN
                EXECUTE PROCEDURE ERROR (62, :IDDOC, :CUENTA, 3);
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                EXECUTE PROCEDURE ERROR (62, :IDDOC, :CUENTA, 4);
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRDTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - VRDTO;
                END
            END /* VRDTO <> 0 */
        END /* DTO EN CTA CONSTANTE */
    /* RETENCION FUENTE */
    if ((RTFTE = 'T') or (RTFTE = 'K')) then
      if (VRRTFTE <> 0) then
        BEGIN
        if (RTFTE = 'T') then
            CTARTFTE = TCTARTFTE;
        CUENTA = NULL;
        SELECT CUEN_COD, CUEN_RETENCION, CUEN_TIPO FROM CUENTAS
            WHERE CUEN_COD = :CTARTFTE INTO :CUENTA, :ES_RETENCION, :TIPOCUEN;
        if (CUENTA IS NULL) then
            begin
            EXECUTE PROCEDURE ERROR (62, :IDDOC, :CTARTFTE, 2);
            CUENTA = CTARTFTE;
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            end
        if (TIPOCUEN = 'I') then
            BEGIN
            EXECUTE PROCEDURE ERROR (62, :IDDOC, :CUENTA, 3);
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            END
        if (TIPOCUEN = 'C') then
            BEGIN
            EXECUTE PROCEDURE ERROR (62, :IDDOC, :CUENTA, 4);
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            if (ES_RETENCION = 'S') then
                BEGIN
                VRBASE = VRTOTAL;
                SELECT PROV_RETEFTE from proveedores where terc_nit = :NIT INTO :PORC;
                END
            ELSE
                BEGIN
                VRBASE = 0;
                PORC = 0;
                END
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, :VRBASE, :PORC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTFTE;
            END
        END /* RTFTE */
    /* RETENCION IVA */
    if ((RTIVA = 'T') or (RTIVA = 'K')) then
      if (VRRTIVA <> 0) then
        BEGIN
        if (RTIVA = 'T') then
            CTARTIVA = TCTARTIVA;
        CUENTA = NULL;
        SELECT CUEN_COD, CUEN_RETENCION, CUEN_TIPO FROM CUENTAS
            WHERE CUEN_COD = :CTARTIVA INTO :CUENTA, :ES_RETENCION, :TIPOCUEN;
        if (CUENTA IS NULL) then
            begin
            EXECUTE PROCEDURE ERROR (62, :IDDOC, :CTARTIVA, 2);
            CUENTA = CTARTIVA;
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            end
        if (TIPOCUEN = 'I') then
            BEGIN
            EXECUTE PROCEDURE ERROR (62, :IDDOC, :CUENTA, 3);
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            END
        if (TIPOCUEN = 'C') then
            BEGIN
            EXECUTE PROCEDURE ERROR (62, :IDDOC, :CUENTA, 4);
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            if (ES_RETENCION = 'S') then
                BEGIN
                VRBASE = VRTOTAL;
                SELECT PROV_RTEIVA from proveedores where terc_nit = :NIT INTO :PORC;
                END
            ELSE
                BEGIN
                VRBASE = 0;
                PORC = 0;
                END
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTIVA, :VRBASE, :PORC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTIVA;
            END
        END /* RTIVA */
    /* RETENCION DE ICA */
    if ((RTICA = 'T') or (RTICA = 'K')) then
      if (VRRTICA <> 0) then
        BEGIN
        if (RTICA = 'T') then
            CTARTICA = TCTARTICA;
        CUENTA = NULL;
        SELECT CUEN_COD, CUEN_RETENCION, CUEN_TIPO FROM CUENTAS
            WHERE CUEN_COD = :CTARTICA INTO :CUENTA, :ES_RETENCION, :TIPOCUEN;
        if (CUENTA IS NULL) then
            begin
            EXECUTE PROCEDURE ERROR (62, :IDDOC, :CTARTICA, 2);
            CUENTA = CTARTICA;
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            end
        if (TIPOCUEN = 'I') then
            BEGIN
            EXECUTE PROCEDURE ERROR (62, :IDDOC, :CUENTA, 3);
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            END
        if (TIPOCUEN = 'C') then
            BEGIN
            EXECUTE PROCEDURE ERROR (62, :IDDOC, :CUENTA, 4);
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            if (ES_RETENCION = 'S') then
                BEGIN
                VRBASE = VRTOTAL;
                SELECT PROV_RTEICA from proveedores where terc_nit = :NIT INTO :PORC;
                END
            ELSE
                BEGIN
                VRBASE = 0;
                PORC = 0;
                END
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTICA, :VRBASE, :PORC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTICA;
            END
        END /* RTICA */
    /* RECORRA LAS CUENTAS DE EGRESOS_CONTABILIDAD */
    FOR SELECT CUEN_COD, EGCO_NIT, EGCO_PROY, EGCO_CENTRO, EGCO_CONC, EGCO_DEBITOS, EGCO_CREDITOS, EGCO_BASEM, EGCO_PORC
        FROM EGRESOS_CONTABILIDAD WHERE EGRE_ID = :IDDOC ORDER BY EGCO_ITEM
        INTO :CTABASE, :NIT, :PROY, :CENTRO, :CONC, :DEBITO, :CREDITO, :MONTOBASE, :PORC
        DO
        BEGIN
        CUENTA = NULL;
        SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
            WHERE CUEN_COD = :CTABASE INTO :CUENTA, :TIPOCUEN;
        if (CUENTA IS NULL) then
            begin
            EXECUTE PROCEDURE ERROR (62, :IDDOC, :CTABASE, 2);
            CUENTA = CTABASE;
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            end
        if (TIPOCUEN = 'I') then
            BEGIN
            EXECUTE PROCEDURE ERROR (62, :IDDOC, :CUENTA, 3);
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            END
        if (TIPOCUEN = 'C') then
            BEGIN
            EXECUTE PROCEDURE ERROR (62, :IDDOC, :CUENTA, 4);
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            END
        if (TIPOCUEN = 'N') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :DEBITO, :CREDITO, :MONTOBASE, :PORC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
        SUMA = SUMA + DEBITO - CREDITO;
        NROI = NROI + 1;
        END
    /* CIERRE EL COMPROBANTE CONTRA LA CUENTA DEL TERCERO O LA BASE CONSTANTE */
    if ((SUMA <> 0) and (BASE = 'F') or (BASE = 'T') or (BASE = 'K')) then
        BEGIN
        if (SUMA < 0) then
            BEGIN
            DEBITO = SUMA * -1;
            CREDITO = 0;
            END
        ELSE
            BEGIN
            DEBITO = 0;
            CREDITO = SUMA;
            END
        if (BASE = 'T') then
            CTABASE = TCTACLIEN;
        if (BASE = 'F') then
            BEGIN
            SELECT CAJA_CUENTA FROM EGRESOS E, CAJAS C
                WHERE C.CAJA_ID = E.CAJA_ID AND EGRE_ID = :IDDOC INTO :CTABASE;
            END
        CUENTA = NULL;
        SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
            WHERE CUEN_COD = :CTABASE INTO :CUENTA, :TIPOCUEN;
        IF (CUENTA IS NULL) then
            begin
            EXECUTE PROCEDURE ERROR (62, :IDDOC, :CTABASE, 2);
            CUENTA = CTABASE;
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            end
        if (TIPOCUEN = 'I') then
            BEGIN
            EXECUTE PROCEDURE ERROR (62, :IDDOC, :CUENTA, 3);
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            END
        if (TIPOCUEN = 'C') then
            BEGIN
            /* DEBERIA RECORRER DOCUMENTO POR DOCUMENTO */
            FOR SELECT RCDE_TIPODOC, RCDE_PREFIJO, RCDE_NUMERO, RCDE_ABONO+RCDE_RTFTE+RCDE_RTIVA+RCDE_RTICA+RCDE_DTOF
                FROM RECIBOS_CAJA_DETALLE WHERE RECA_ID = :IDDOC
                INTO :TIPOIT, PREFIT, NUMIT, ABONOIT
                DO
                BEGIN
                NUMEROIT = PREFIT || NUMIT;
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :ABONOIT, 0, 0, :NIT, :PROY, :CENTRO, NULL, :NUMEROIT, NULL, NULL, :TIPOIT, 0);
                NROI = NROI + 1;
                END
            END
        if (TIPOCUEN = 'N') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
        NROI = NROI + 1;
        END /* SUMA EN CARTERA */
    /* recorra las cuentas adicionales */
    FOR SELECT INJC_CUENTA, INJC_BASE, INJC_PORC, INJC_VALOR, INJC_DB
        FROM INTERFAZ_CAJA_CTAS
        WHERE INCJ_ID = :IDINTER
        INTO :CTADIC, :BASEADIC, :PORCADIC, :VALORADIC, :DBADIC
        DO
        BEGIN
        if (:BASEADIC = 'TOTAL') then
            VALORADIC = VRTOTAL;
        if (:BASEADIC = 'DESCUENTO') then
            VALORADIC = VRDTO;
        if (:BASEADIC = 'RTFTE') then
            VALORADIC = VRRTFTE;
        if (:BASEADIC = 'RTIVA') then
            VALORADIC = VRRTIVA;
        if (:BASEADIC = 'RTICA') then
            VALORADIC = VRRTICA;
        MONTO = VALORADIC * PORCADIC;
        CUENTA = NULL;
        SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
            WHERE CUEN_COD = :CTADIC INTO :CUENTA, :TIPOCUEN;
        IF (CUENTA IS NULL) THEN
            begin
            EXECUTE PROCEDURE ERROR (62, :IDDOC, :CTADIC, 2);
            CUENTA = CTADIC;
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            end
        if (TIPOCUEN = 'I') then
            BEGIN
            EXECUTE PROCEDURE ERROR (62, :IDDOC, :CUENTA, 3);
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            END
        if (TIPOCUEN = 'C') then
            BEGIN
            EXECUTE PROCEDURE ERROR (62, :IDDOC, :CUENTA, 4);
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            if (DBADIC = 'S') then
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTADIC, :CONC, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            ELSE
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTADIC, :CONC, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            END
        NROI = NROI + 1;
        END
    if (ERROR > 0) then
        VER = 'S';
    SUSPEND;
    END /* EXISTE LA INTERFAZ */
  ELSE
    BEGIN
    EXECUTE PROCEDURE ERROR (62, :IDDOC, :PREF, 1);
    ERROR = ERROR + 1;
    VER = 'S';
    SUSPEND;
    END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE EGRESOS_SIN_CONTABILIDAD(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    IDI INTEGER,
    IDC INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    ERROR INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable FECICNT VARCHAR(10);
declare variable FECFCNT VARCHAR(10);
declare variable idref INTEGER;
BEGIN /*$$IBE$$ 
EXECUTE PROCEDURE fecha_a_conta(FECINI) returning_values (FECICNT);
EXECUTE PROCEDURE fecha_a_conta(FECFIN) returning_values (FECFCNT);
FOR SELECT EGRE_ID, PREF_PRE, egre_numero FROM EGRESOS WHERE EGRE_ANULADO = 'N' AND PREF_PRE <> 'R004' AND
    EGRE_FECHA >= :FECINI AND EGRE_FECHA <= :FECFIN ORDER BY EGRE_ID INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  idref = null;
  SELECT ENCO_IDREF FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 62 AND ENCO_FECHA >= :FECICNT AND ENCO_FECHA <= :FECFCNT and ENCO_IDREF = :ID into :idref;
  if (idref IS NULL) then
  begin
   ESTADO = 'PROCESANDO';
   SUSPEND;
   SELECT MAX(INCJ_ID) FROM INTERFAZ_CAJA WHERE PREF_PRE = :PREF AND TIDO_COD = 62 INTO :IDI;
   EXECUTE PROCEDURE CONTABIL_EGRESO (:ID, :IDI) RETURNING_VALUES (:ERROR, :VER, :IDC);
   IF (ERROR = 0) THEN
      BEGIN
      EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC);
      ESTADO = 'OK';
      END
   ELSE
    ESTADO = 'ERROR';
   suspend;
  end
  END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE EGRESOS_SIN_CONTABILIDAD(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    IDI INTEGER,
    IDC INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    ERROR INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable FECICNT VARCHAR(10);
declare variable FECFCNT VARCHAR(10);
declare variable idref INTEGER;
BEGIN
EXECUTE PROCEDURE fecha_a_conta(FECINI) returning_values (FECICNT);
EXECUTE PROCEDURE fecha_a_conta(FECFIN) returning_values (FECFCNT);
FOR SELECT EGRE_ID, PREF_PRE, egre_numero FROM EGRESOS WHERE EGRE_ANULADO = 'N' AND PREF_PRE <> 'R004' AND
    EGRE_FECHA >= :FECINI AND EGRE_FECHA <= :FECFIN ORDER BY EGRE_ID INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  idref = null;
  SELECT ENCO_IDREF FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 62 AND ENCO_FECHA >= :FECICNT AND ENCO_FECHA <= :FECFCNT and ENCO_IDREF = :ID into :idref;
  if (idref IS NULL) then
  begin
   ESTADO = 'PROCESANDO';
   SUSPEND;
   SELECT MAX(INCJ_ID) FROM INTERFAZ_CAJA WHERE PREF_PRE = :PREF AND TIDO_COD = 62 INTO :IDI;
   EXECUTE PROCEDURE CONTABIL_EGRESO (:ID, :IDI) RETURNING_VALUES (:ERROR, :VER, :IDC);
   IF (ERROR = 0) THEN
      BEGIN
      EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC);
      ESTADO = 'OK';
      END
   ELSE
    ESTADO = 'ERROR';
   suspend;
  end
  END
END

^

SET TERM ; ^

/* 05-23 replicacion con usuario y clave fijos */

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('INVENTARIO', 'ARTICULOS', 'CLAVE DE USUARIO PARA REPLICACION DE ARTICULOS', 'REPLICA', '', 'Indique la clave asignda al usuario de replicacin que se usar para enviar la informacin a los dems servidores');
INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('INVENTARIO', 'ARTICULOS', 'NOMBRE DE USUARIO PARA REPLICACION DE ARTICULOS', 'REPLICA', '', 'Indique el nombre de usuario creado en todos los servidores a los que se conectar el sistema para replicar los artculos');
commit work;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE IMPR_FACTURA(
    ID INTEGER)
RETURNS (
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    VENCE DATE,
    DIASVENCE INTEGER,
    CONTCRED CHAR(17),
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    VENDEDOR INTEGER,
    NOMVENDEDOR VARCHAR(60),
    PUNTOVTA INTEGER,
    NOMPUNTOVTA VARCHAR(30),
    CODBODEGA VARCHAR(2),
    NOMBODEGA VARCHAR(30),
    AUTORIZACION VARCHAR(20),
    DESPACHO VARCHAR(255),
    TRANSPORTADOR VARCHAR(60),
    COTIZACION VARCHAR(30),
    PEDIDO VARCHAR(30),
    REMISION VARCHAR(30),
    PACIENTE VARCHAR(20),
    NOMPACIENTE VARCHAR(60),
    COMIPORC NUMERIC(9,2),
    COMIMONTO NUMERIC(18,2),
    SUBTOTAL NUMERIC(18,2),
    DTOPORC NUMERIC(9,2),
    DTOMONTO NUMERIC(18,2),
    ADICIONAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    RTEFTEPORC NUMERIC(9,2),
    RTEFTEMONTO NUMERIC(18,2),
    RTEIVAPORC NUMERIC(9,2),
    RTEIVAMONTO NUMERIC(18,2),
    RTEICAPORC NUMERIC(9,2),
    RTEICAMONTO NUMERIC(18,2),
    EXTRA NUMERIC(18,2),
    DTOFPORC NUMERIC(9,2),
    DTOFMONTO NUMERIC(18,2),
    FECHADTO DATE,
    TOTALFAC NUMERIC(18,2),
    TOTALPAGAR NUMERIC(18,2),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    LOTE VARCHAR(15),
    VLOTE DATE,
    UNIDAD VARCHAR(8),
    FACTOR INTEGER,
    LISTAPR INTEGER,
    REFITEM VARCHAR(60),
    BODITEM VARCHAR(2),
    PRUNIT NUMERIC(18,2),
    DTOITPORC NUMERIC(9,2),
    DTOITMONTO NUMERIC(18,2),
    PRNETO NUMERIC(18,2),
    IVAPORC NUMERIC(9,2),
    IVAITMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    SUBTOTIT NUMERIC(18,2),
    SUBTOTITCON NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    CODIGOCL VARCHAR(20),
    ZONACOD VARCHAR(2),
    ZONANOM VARCHAR(60),
    DV CHAR(1),
    DIRECCION VARCHAR(60),
    CIUDAD VARCHAR(40),
    TELEFONO VARCHAR(40),
    CONTACTO VARCHAR(60),
    FAX VARCHAR(25),
    GRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    SUBGRUPO VARCHAR(3),
    NOMSUBG VARCHAR(30),
    MARCA VARCHAR(3),
    NOMMARCA VARCHAR(30),
    PESO NUMERIC(18,4),
    ANCHO NUMERIC(18,4),
    ALTO NUMERIC(18,4),
    LARGO NUMERIC(18,4),
    SUMA1 NUMERIC(18,2),
    SUMA2 NUMERIC(18,2),
    SUMA3 NUMERIC(18,2),
    IVA1 NUMERIC(18,2),
    IVA2 NUMERIC(18,2),
    IVA3 NUMERIC(18,2),
    SUMAEX NUMERIC(18,2),
    SUMAGR NUMERIC(18,2),
    TOTCONSUMO NUMERIC(18,2),
    VEHICULO VARCHAR(8),
    RECIBIDO NUMERIC(18,2),
    CAMBIO NUMERIC(18,2),
    HORA TIME,
    FORMAPAGO1 VARCHAR(30),
    MONTOPAGO1 NUMERIC(18,2),
    FORMAPAGO2 VARCHAR(30),
    MONTOPAGO2 NUMERIC(18,2),
    FORMAPAGO3 VARCHAR(30),
    MONTOPAGO3 NUMERIC(18,2),
    PUNTOS INTEGER,
    PUNTOSACUM INTEGER,
    PUNTOSVENC INTEGER)
AS
DECLARE VARIABLE IMPTOS CHAR(1);
DECLARE VARIABLE TARIFA INTEGER;
declare variable DEVUELTO NUMERIC(18,2);
/*DECLARE VARIABLE NROCOPIA INTEGER;*/
declare variable ORDENCOD CHAR(2);
declare variable IMPRDEV CHAR(2);
declare variable IMPR CHAR(1);
declare variable ITEMFP INTEGER;
declare variable FORMAP VARCHAR(30);
declare variable MONTOP NUMERIC(18,2);
declare variable SUCUR VARCHAR(10);
BEGIN
  SELECT F.PREF_PRE, FACT_NUMERO, FACT_FECHA, FACT_VENCE, F.BODE_COD, BODE_NOM, F.TERC_NIT, FACT_NOMCLIENTE, F.VEND_COD, VEND_NOMBRE, F.PTVT_ID, PTVT_NOM,
    AUTO_NUMERO, FACT_DESPACHO, FACT_TRANSP, FACT_COTIZACI, FACT_PEDIDO, FACT_REMISION, FACT_COMIPORC, FACT_COMIMONTO, FACT_IVAINC, 
    FACT_DTOPOR, FACT_DTOMONTO, FACT_ADICIONAL, FACT_IVAMONTO, FACT_RTFTEPOR, FACT_RTFTEMONTO, FACT_RTIVAPOR, FACT_RTIVAMONTO, FACT_RTICAPOR, FACT_RTICAMONTO, FACT_EXTRA, FACT_DTOFPOR, FACT_DTOFMONTO, FACT_DTOFFECHA, FACT_TOTAL,
    TERC_DIR, TERC_CIU, TERC_TEL, TERC_CONTACTO, TERC_FAX, TERC_DV,
    FACT_OBS, VEHI_COD, /*FACT_NROCOPIA,*/ FACT_RECIBIDO, FACT_SUCURSAL, FACT_DETCLI, FACT_DETCLINOM
    FROM FACTURAS F, BODEGA B, VENDEDORES V, PUNTO_VENTA P, TERCEROS T
    WHERE F.BODE_COD = B.BODE_COD AND F.VEND_COD = V.VEND_COD AND F.PTVT_ID = P.PTVT_ID AND F.TERC_NIT = T.TERC_NIT AND F.FACT_ID = :ID
    into :PREF, :NUMERO, :FECHA, :VENCE, :CODBODEGA, :NOMBODEGA, :NIT, :NOMTERCERO, :VENDEDOR, :NOMVENDEDOR, :PUNTOVTA, :NOMPUNTOVTA,
    :AUTORIZACION, :DESPACHO, :TRANSPORTADOR, :COTIZACION, :PEDIDO, :REMISION, :COMIPORC, :COMIMONTO, :IMPTOS,
    :DTOPORC, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTEFTEPORC, :RTEFTEMONTO, :RTEIVAPORC, :RTEIVAMONTO, :RTEICAPORC, :RTEICAMONTO, :EXTRA, :DTOFPORC, :DTOFMONTO, :FECHADTO, :TOTALFAC,
    :DIRECCION, :CIUDAD, :TELEFONO, :CONTACTO, :FAX, :DV, :OBS, :VEHICULO,/* :NROCOPIA,*/ :RECIBIDO, :SUCUR, :paciente, :nompaciente;

  /* ACUMULE LOS PUNTOS, SE HACE ACA POR SER POSTERIOR AL DETALLE */
  EXECUTE PROCEDURE acumula_puntos_cliente (31, :id, :nit, :fecha) returning_values (:PUNTOS);
  EXECUTE PROCEDURE consulta_puntos_cliente (:id, :nit, :fecha) returning_values (:puntos, :puntosacum, :puntosvenc);

  SELECT CLIE_COD, C.ZONA_COD, ZONA_NOM
    FROM CLIENTES C, ZONAS Z
    WHERE TERC_NIT = :NIT AND C.ZONA_COD = Z.ZONA_COD
    INTO :CODIGOCL, :ZONACOD, :ZONANOM;
  /*SELECT NOCO_NOMBRE FROM NOMBRES_COPIAS where NOCO_ID = :NROCOPIA INTO :NOMCOPIA;*/
  SELECT CLSU_DIR, CLSU_CIUDAD, CLSU_TEL FROM CLIENTE_SUCURSALES WHERE TERC_NIT = :NIT AND CLCU_COD = :SUCUR
    INTO :DIRECCION, :CIUDAD, :TELEFONO;
  /*if (NOMCOPIA IS NULL) then
    NOMCOPIA = 'COPIA No. ' || NROCOPIA;**/
  DIASVENCE = VENCE - FECHA;
  if (DIASVENCE > 0) then
    CONTCRED = 'CREDITO ' || CAST(DIASVENCE AS VARCHAR(3)) || ' DIAS';
  ELSE
    CONTCRED = 'CONTADO';
  SUBTOTAL = TOTALFAC - EXTRA - IVAMONTO - ADICIONAL + DTOMONTO;
  TOTALPAGAR = TOTALFAC - RTEFTEMONTO - RTEIVAMONTO - RTEICAMONTO;
  if (RECIBIDO <> 0) then
      CAMBIO = RECIBIDO - totalpagar;
  ELSE
    CAMBIO = 0;
  SUMAEX = 0;
  SUMA1 = 0;
  SUMA2 = 0;
  SUMA3 = 0;
  IVA1 = 0;
  IVA2 = 0;
  IVA3 = 0;
  TOTCONSUMO = 0;
  MONTOPAGO1 = 0;
  SELECT MAX(AUDI_HORA) FROM AUDITORIA WHERE TIDO_COD = 31 AND AUDI_IDDOC = :ID AND AUDI_OPER = 'I' INTO :HORA;
  /* AHORA LAS FORMAS DE PAGO, BUSQUE EL ABONO DE HOY A LA FACTURA */
  ITEMFP = 1;
  MONTOPAGO1 = 0;
  MONTOPAGO2 = 0;
  MONTOPAGO3 = 0;
  FOR SELECT FOPA_NOM, RCPA_MONTO FROM RECIBOS_CAJA_PAGO P, FORMAS_PAGO F, RECIBOS_CAJA R, RECIBOS_CAJA_DETALLE D
    WHERE R.RECA_ID = P.RECA_ID AND R.RECA_ID = D.RECA_ID AND P.FOPA_ID = F.FOPA_ID AND RECA_FECHA = :FECHA AND RCDE_TIPODOC = 31 AND RCDE_IDDOC = :ID
    INTO :formap, :MONTOP
    DO
    BEGIN
    if (ITEMFP = 1) then
        BEGIN
        FORMAPAGO1 = FORMAP;
        MONTOPAGO1 = MONTOP;
        END
    if (ITEMFP = 2) then
        BEGIN
        FORMAPAGO2 = FORMAP;
        MONTOPAGO2 = MONTOP;
        END
    if (ITEMFP = 3) then
        BEGIN
        FORMAPAGO3 = FORMAP;
        MONTOPAGO3 = MONTOP;
        END
    ITEMFP = ITEMFP + 1;
    END
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','DOCUMENTOS','ORDENAR ITEMS POR CODIGO DE ARTICULO') returning_values (:ORDENCOD);
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','POS', 'IMPRIMIR DEVOLUCIONES DE ARTICULOS NEGATIVOS') returning_values (:imprdev);
  if (ORDENCOD = 'SI') then
    BEGIN
    FOR SELECT FADE_ITEM, D.ARTI_COD, FADE_CODBAR, SUBSTR(FADE_DESC,1,60), FADE_CANT, FADE_UNIDAD, FADE_FACTOR, BODE_COD, FADE_LOTE, LIPR_COD, FADE_PRUNIT, FADE_DTOPORC, FADE_DTOMONTO, FADE_IVAPORC, FADE_IVAMONTO, FADE_CONSUMO, FADE_TOTAL, FADE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, FADE_DEVUELTO
        FROM FACTURAS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.FACT_ID = :ID
        ORDER BY D.ARTI_COD
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :FACTOR, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem,
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :devuelto
        DO
          BEGIN
          if (ARTICULO = CODBAR) then
            SELECT FIRST 1 COBA_COD FROM barras_articulo WHERE ARTI_COD = :articulo INTO :CODBAR;
          if (IMPRDEV <> 'SI') then
            BEGIN
            if ((CANT >= 0) AND (DEVUELTO = 0)) then
                IMPR = 'S';
            ELSE
                IMPR = 'N'; /* ES DEVOLUCION */
            END
          ELSE
            IMPR = 'S';
          if (IMPR = 'S') then
            BEGIN
            if (IMPTOS = 'S') then
                if (cant <> 0) then
                    PRNETO = PRUNIT - DTOITMONTO - ((IVAITMONTO+CONSUMO) / CANT);
                else
                    PRNETO = PRUNIT - DTOITMONTO;
            ELSE
                PRNETO = PRUNIT - DTOITMONTO;
            SUBTOTIT = TOTAL - IVAITMONTO - CONSUMO;
            SUBTOTITCON = TOTAL;
            TOTCONSUMO = TOTCONSUMO + CONSUMO;
            SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO INTO :vlote;
            if (TARIFA = 0) then
                SUMAEX = SUMAEX + TOTAL;
            if (TARIFA = 1) then
                BEGIN
                SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
                IVA1 = IVA1 + IVAITMONTO;
                END
            if (TARIFA = 2) then
                BEGIN
                SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
                IVA2 = IVA2 + IVAITMONTO;
                END
            if (TARIFA = 3) then
                BEGIN
                SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
                IVA3 = IVA3 + IVAITMONTO;
                END
            SUMAGR = SUMA1 + SUMA2 + SUMA3;
            if (IMPTOS = 'N') then
                TOTAL = TOTAL - IVAITMONTO - CONSUMO;
            if (ANCHO IS NULL) then
                ANCHO = 0;
            if (ALTO IS NULL) then
                ALTO = 0;
            if (LARGO IS NULL) then
                LARGO = 0;
            if (PESO IS NULL) then
                PESO = 0;
            PESO = PESO * CANT;
            SUSPEND;
            END
          END
    END
ELSE
    BEGIN
    FOR SELECT FADE_ITEM, D.ARTI_COD, FADE_CODBAR, SUBSTR(FADE_DESC,1,60), FADE_CANT, FADE_UNIDAD, FADE_FACTOR, BODE_COD, FADE_LOTE, LIPR_COD, FADE_PRUNIT, FADE_DTOPORC, FADE_DTOMONTO, FADE_IVAPORC, FADE_IVAMONTO, FADE_CONSUMO, FADE_TOTAL, FADE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, FADE_DEVUELTO
        FROM FACTURAS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.FACT_ID = :ID
        ORDER BY FADE_ITEM
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :FACTOR, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem, 
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :devuelto
        DO
          BEGIN
          if (IMPRDEV <> 'SI') then
            BEGIN
            if ((CANT >= 0) AND (DEVUELTO = 0)) then
                IMPR = 'S';
            ELSE
                IMPR = 'N'; /* ES DEVOLUCION */
            END
          ELSE
            IMPR = 'S';
          if (IMPR = 'S') then
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
            if (IMPTOS = 'S') then
              PRNETO = PRUNIT - DTOITMONTO - ((IVAITMONTO+CONSUMO) / CANT);
            ELSE
              PRNETO = PRUNIT - DTOITMONTO;
            SUBTOTIT = TOTAL - IVAITMONTO - CONSUMO;
            SUBTOTITCON = TOTAL;
            TOTCONSUMO = TOTCONSUMO + CONSUMO;
            SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO INTO :vlote;
            if (IVAPORC = 0) then
                SUMAEX = SUMAEX + TOTAL;
            if (TARIFA = 1) then
                BEGIN
                SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
                IVA1 = IVA1 + IVAITMONTO;
                END
            if (TARIFA = 2) then
                BEGIN
                SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
                IVA2 = IVA2 + IVAITMONTO;
                END
            if (TARIFA = 3) then
                BEGIN
                SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
                IVA3 = IVA3 + IVAITMONTO;
                END
            SUMAGR = SUMA1 + SUMA2 + SUMA3;
            if (IMPTOS = 'N') then
                TOTAL = TOTAL - IVAITMONTO - CONSUMO;
            if (ANCHO IS NULL) then
                ANCHO = 0;
            if (ALTO IS NULL) then
                ALTO = 0;
            if (LARGO IS NULL) then
                LARGO = 0;
            if (PESO IS NULL) then
                PESO = 0;
            PESO = PESO * CANT;
            SUSPEND;
            END
          END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE IMPR_REMISION(
    ID INTEGER)
RETURNS (
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    VENDEDOR INTEGER,
    NOMVENDEDOR VARCHAR(60),
    PUNTOVTA INTEGER,
    NOMPUNTOVTA VARCHAR(30),
    CODBODEGA VARCHAR(2),
    NOMBODEGA VARCHAR(30),
    COTIZACION VARCHAR(30),
    PEDIDO VARCHAR(30),
    FACTURA VARCHAR(30),
    SUBTOTAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    TOTALFAC NUMERIC(18,2),
    DESPACHO VARCHAR(255),
    TRANSPORTADOR VARCHAR(60),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    LOTE VARCHAR(15),
    VLOTE DATE,
    UNIDAD VARCHAR(8),
    DEVUELTO NUMERIC(18,4),
    LISTAPR INTEGER,
    REFITEM VARCHAR(60),
    BODITEM VARCHAR(2),
    PRUNIT NUMERIC(18,2),
    DTOITPORC NUMERIC(9,2),
    DTOITMONTO NUMERIC(18,2),
    SUBTOTALITEM NUMERIC(18,2),
    PRNETOSINIVA NUMERIC(18,2),
    PRNETO NUMERIC(18,2),
    IVAPORC NUMERIC(9,2),
    IVAITMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    CODIGOCL VARCHAR(20),
    ZONACOD VARCHAR(2),
    ZONANOM VARCHAR(60),
    DV CHAR(1),
    DIRECCION VARCHAR(60),
    CIUDAD VARCHAR(40),
    TELEFONO VARCHAR(40),
    CONTACTO VARCHAR(60),
    FAX VARCHAR(25),
    GRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    SUBGRUPO VARCHAR(3),
    NOMSUBG VARCHAR(30),
    MARCA VARCHAR(3),
    NOMMARCA VARCHAR(30),
    PESO NUMERIC(9,4),
    ANCHO NUMERIC(18,4),
    ALTO NUMERIC(18,4),
    LARGO NUMERIC(18,4),
    SUMA1 NUMERIC(18,2),
    SUMA2 NUMERIC(18,2),
    SUMA3 NUMERIC(18,2),
    IVA1 NUMERIC(18,2),
    IVA2 NUMERIC(18,2),
    IVA3 NUMERIC(18,2),
    SUMAEX NUMERIC(18,2),
    SUMAGR NUMERIC(18,2))
AS
DECLARE VARIABLE IMPTOS CHAR(1);
DECLARE VARIABLE TARIFA INTEGER;
declare variable ORDENCOD CHAR(2);
declare variable SUCUR VARCHAR(10);
BEGIN
  /*  */
  SELECT F.PREF_PRE, REVT_NUMERO, REVT_FECHA, F.BODE_COD, BODE_NOM, F.TERC_NIT, REVT_NOMTERC, F.VEND_COD, VEND_NOMBRE, F.PTVT_ID, PTVT_NOM,
    REVT_COTIZACI, REVT_PEDIDO, REVT_FACTURA, REVT_IVAINC,
    REVT_IVAMONTO, REVT_TOTAL, REVT_DESPACHO, REVT_TRANSP,
    TERC_CONTACTO, TERC_FAX, TERC_DV, REVT_OBS, REVT_SUCURSAL
    FROM REMISIONES_VENTA F, BODEGA B, VENDEDORES V, PUNTO_VENTA P, TERCEROS T
    WHERE F.BODE_COD = B.BODE_COD AND F.VEND_COD = V.VEND_COD AND F.PTVT_ID = P.PTVT_ID AND F.TERC_NIT = T.TERC_NIT AND F.REVT_ID = :ID
    into :PREF, :NUMERO, :FECHA, :CODBODEGA, :NOMBODEGA, :NIT, :NOMTERCERO, :VENDEDOR, :NOMVENDEDOR, :PUNTOVTA, :NOMPUNTOVTA,
    :COTIZACION, :PEDIDO, :FACTURA, :IMPTOS,
    :IVAMONTO, :TOTALFAC, :DESPACHO, :transportador, 
    :CONTACTO, :FAX, :DV, :OBS, :SUCUR;
  SUBTOTAL = TOTALFAC - IVAMONTO;

  SELECT CLIE_COD, C.ZONA_COD, ZONA_NOM
    FROM CLIENTES C, ZONAS Z
    WHERE TERC_NIT = :NIT AND C.ZONA_COD = Z.ZONA_COD
    INTO :CODIGOCL, :ZONACOD, :ZONANOM;
  SELECT CLSU_DIR, CLSU_CIUDAD, CLSU_TEL FROM CLIENTE_SUCURSALES WHERE TERC_NIT = :NIT AND CLCU_COD = :SUCUR
    INTO :DIRECCION, :CIUDAD, :TELEFONO;
    
  SUMAEX = 0;
  SUMA1 = 0;
  SUMA2 = 0;
  SUMA3 = 0;
  IVA1 = 0;
  IVA2 = 0;
  IVA3 = 0;
  ITEM = 0;
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','DOCUMENTOS','ORDENAR ITEMS POR CODIGO DE ARTICULO') returning_values (:ORDENCOD);
  if (ORDENCOD = 'SI') then
    BEGIN
    FOR SELECT D.ARTI_COD, RVDE_CODBAR, SUBSTR(RVDE_DESC,1,60), RVDE_CANT, RVDE_UNIDAD, BODE_COD, RVDE_LOTE, LIPR_COD, RVDE_PRUNIT, RVDE_DTOPORC, RVDE_DTOMONTO, RVDE_IVAPORC, RVDE_IVAMONTO, RVDE_CONSUMO, RVDE_TOTAL, RVDE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, RVDE_DEVUELTO
        FROM REMISIONES_VENTA_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.REVT_ID = :ID
        ORDER BY RVDE_CODBAR
        INTO :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem,
            :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :DEVUELTO
        DO
        BEGIN
        if (ARTICULO = CODBAR) then
            SELECT FIRST 1 COBA_COD FROM barras_articulo WHERE ARTI_COD = :articulo INTO :CODBAR;
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
        SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO INTO :vlote;
        ITEM = ITEM + 1;
        PRNETO = PRUNIT - DTOITMONTO;
        if (IVAPORC = 0) then
            SUMAEX = SUMAEX + TOTAL;
        if (TARIFA = 1) then
            BEGIN
            SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
            IVA1 = IVA1 + IVAITMONTO;
            END
        if (TARIFA = 2) then
            BEGIN
            SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
            IVA2 = IVA2 + IVAITMONTO;
            END
        if (TARIFA = 3) then
            BEGIN
            SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
            IVA3 = IVA3 + IVAITMONTO;
            END
        SUMAGR = SUMA1 + SUMA2 + SUMA3;

        if (IMPTOS = 'N') then
            TOTAL = TOTAL - IVAITMONTO;
        ELSE
           BEGIN
           PRNETOSINIVA = PRUNIT / (1 + ivaporc/100);
           SUBTOTALITEM = PRNETOSINIVA * :CANT;
           END
        SUSPEND;
        END
    END
ELSE
    BEGIN
    FOR SELECT RVDE_ITEM, D.ARTI_COD, RVDE_CODBAR, SUBSTR(RVDE_DESC,1,60), RVDE_CANT, RVDE_UNIDAD, BODE_COD, RVDE_LOTE, LIPR_COD, RVDE_PRUNIT, RVDE_DTOPORC, RVDE_DTOMONTO, RVDE_IVAPORC, RVDE_IVAMONTO, RVDE_CONSUMO, RVDE_TOTAL, RVDE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, RVDE_DEVUELTO
        FROM REMISIONES_VENTA_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.REVT_ID = :ID
        ORDER BY RVDE_ITEM
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem,
            :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :DEVUELTO
        DO
        BEGIN
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
        ITEM = ITEM + 1;
        PRNETO = PRUNIT - DTOITMONTO;
        if (IVAPORC = 0) then
            SUMAEX = SUMAEX + TOTAL;
        if (TARIFA = 1) then
            BEGIN
            SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
            IVA1 = IVA1 + IVAITMONTO;
            END
        if (TARIFA = 2) then
            BEGIN
            SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
            IVA2 = IVA2 + IVAITMONTO;
            END
        if (TARIFA = 3) then
            BEGIN
            SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
            IVA3 = IVA3 + IVAITMONTO;
            END
        SUMAGR = SUMA1 + SUMA2 + SUMA3;
        SUBTOTALITEM = TOTAL - IVAITMONTO;
        if (IMPTOS = 'N') then
            TOTAL = TOTAL - IVAITMONTO;
        ELSE
           BEGIN
             PRNETOSINIVA = PRUNIT / (1 + ivaporc/100);
             SUBTOTALITEM = PRNETOSINIVA * :CANT;
           END
        SUSPEND;
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE IMPR_PEDIDO(
    ID INTEGER)
RETURNS (
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    VALIDEZ INTEGER,
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    VENDEDOR INTEGER,
    NOMVENDEDOR VARCHAR(60),
    PUNTOVTA INTEGER,
    NOMPUNTOVTA VARCHAR(30),
    COTIZACION VARCHAR(30),
    SUBTOTAL NUMERIC(18,2),
    DTOPORC NUMERIC(9,2),
    DTOMONTO NUMERIC(18,2),
    ADICIONAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    EXTRA NUMERIC(18,2),
    TOTALFAC NUMERIC(18,2),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    BODEGA VARCHAR(2),
    CANT NUMERIC(18,4),
    UNIDAD VARCHAR(8),
    LISTAPR INTEGER,
    REFITEM VARCHAR(60),
    PRUNIT NUMERIC(18,2),
    DTOITPORC NUMERIC(9,2),
    DTOITMONTO NUMERIC(18,2),
    PRNETO NUMERIC(18,2),
    IVAPORC NUMERIC(9,2),
    IVAITMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    CODIGOCL VARCHAR(20),
    ZONACOD VARCHAR(2),
    ZONANOM VARCHAR(60),
    DV CHAR(1),
    DIRECCION VARCHAR(60),
    CIUDAD VARCHAR(40),
    TELEFONO VARCHAR(40),
    CONTACTO VARCHAR(60),
    FAX VARCHAR(25),
    GRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    SUBGRUPO VARCHAR(3),
    NOMSUBG VARCHAR(30),
    MARCA VARCHAR(3),
    NOMMARCA VARCHAR(30),
    PESO NUMERIC(9,4),
    ANCHO NUMERIC(18,4),
    ALTO NUMERIC(18,4),
    LARGO NUMERIC(18,4),
    SUMA1 NUMERIC(18,2),
    SUMA2 NUMERIC(18,2),
    SUMA3 NUMERIC(18,2),
    IVA1 NUMERIC(18,2),
    IVA2 NUMERIC(18,2),
    IVA3 NUMERIC(18,2),
    SUMAEX NUMERIC(18,2),
    SUMAGR NUMERIC(18,2))
AS
DECLARE VARIABLE IMPTOS CHAR(1);
DECLARE VARIABLE TARIFA INTEGER;
declare variable ORDENCOD CHAR(2);
declare variable SUCUR VARCHAR(10);
BEGIN
  /*  */
  SELECT F.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, PEDI_VALIDEZ, F.TERC_NIT, PEDI_NOMTERC, F.VEND_COD, VEND_NOMBRE, F.PTVT_ID, PTVT_NOM, PEDI_COTIZACI,
    PEDI_IVAINC, PEDI_DTOPOR, PEDI_DTOMONTO, PEDI_ADICIONAL, PEDI_IVAMONTO, PEDI_EXTRA, PEDI_TOTAL,
    TERC_CONTACTO, TERC_FAX, TERC_DV, PEDI_OBS, PEDI_SUCURSAL
    FROM PEDIDOS F, VENDEDORES V, PUNTO_VENTA P, TERCEROS T
    WHERE F.VEND_COD = V.VEND_COD AND F.PTVT_ID = P.PTVT_ID AND F.TERC_NIT = T.TERC_NIT AND F.PEDI_ID = :ID
    into :PREF, :NUMERO, :FECHA, :VALIDEZ, :NIT, :NOMTERCERO, :VENDEDOR, :NOMVENDEDOR, :PUNTOVTA, :NOMPUNTOVTA, :COTIZACION,
    :IMPTOS, :DTOPORC, :DTOMONTO, :ADICIONAL, :IVAMONTO, :EXTRA, :TOTALFAC,
    :CONTACTO, :FAX, :DV, :OBS, :SUCUR;
  SUBTOTAL = TOTALFAC - EXTRA - IVAMONTO - ADICIONAL + DTOMONTO;

  SELECT CLIE_COD, C.ZONA_COD, ZONA_NOM
    FROM CLIENTES C, ZONAS Z
    WHERE TERC_NIT = :NIT AND C.ZONA_COD = Z.ZONA_COD
    INTO :CODIGOCL, :ZONACOD, :ZONANOM;
  SELECT CLSU_DIR, CLSU_CIUDAD, CLSU_TEL FROM CLIENTE_SUCURSALES WHERE TERC_NIT = :NIT AND CLCU_COD = :SUCUR
    INTO :DIRECCION, :CIUDAD, :TELEFONO;
    
  SUMAEX = 0;
  SUMA1 = 0;
  SUMA2 = 0;
  SUMA3 = 0;
  IVA1 = 0;
  IVA2 = 0;
  IVA3 = 0;
  ITEM = 0;
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','DOCUMENTOS','ORDENAR ITEMS POR CODIGO DE ARTICULO') returning_values (:ORDENCOD);
  if (ORDENCOD = 'SI') then
    BEGIN
    FOR SELECT D.ARTI_COD, PEDE_CODBAR, SUBSTR(PEDE_DESC,1,60), PEDE_CANT, PEDE_UNIDAD, LIPR_COD, PEDE_PRUNIT, PEDE_DTOPORC, PEDE_DTOMONTO, PEDE_IVAPORC, PEDE_IVAMONTO, PEDE_CONSUMO, PEDE_TOTAL, PEDE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, BODE_COD
        FROM PEDIDOS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.PEDI_ID = :ID
        ORDER BY PEDE_CODBAR
        INTO :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :REFITEM,
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :BODEGA
        DO
        BEGIN
        if (ARTICULO = CODBAR) then
            SELECT FIRST 1 COBA_COD FROM barras_articulo WHERE ARTI_COD = :articulo INTO :CODBAR;
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
        ITEM = ITEM + 1;
        PRNETO = PRUNIT - DTOITMONTO;
        if (TARIFA = 0) then
            SUMAEX = SUMAEX + TOTAL;
        if (TARIFA = 1) then
            BEGIN
            SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
            IVA1 = IVA1 + IVAITMONTO;
            END
        if (TARIFA = 2) then
            BEGIN
            SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
            IVA2 = IVA2 + IVAITMONTO;
            END
        if (TARIFA = 3) then
            BEGIN
            SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
            IVA3 = IVA3 + IVAITMONTO;
            END
        SUMAGR = SUMA1 + SUMA2 + SUMA3;
        if (IMPTOS = 'N') then
            TOTAL = TOTAL - IVAITMONTO;
        SUSPEND;
        END
    END
ELSE
    BEGIN
    FOR SELECT PEDE_ITEM, D.ARTI_COD, PEDE_CODBAR, SUBSTR(PEDE_DESC,1,60), PEDE_CANT, PEDE_UNIDAD, LIPR_COD, PEDE_PRUNIT, PEDE_DTOPORC, PEDE_DTOMONTO, PEDE_IVAPORC, PEDE_IVAMONTO, PEDE_CONSUMO, PEDE_TOTAL, PEDE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, BODE_COD
        FROM PEDIDOS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.PEDI_ID = :ID
        ORDER BY PEDE_ITEM
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :REFITEM,
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :BODEGA
        DO
        BEGIN
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
        ITEM = ITEM + 1;
        PRNETO = PRUNIT - DTOITMONTO;
        if (IVAPORC = 0) then
            SUMAEX = SUMAEX + TOTAL;
        if (TARIFA = 1) then
            BEGIN
            SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
            IVA1 = IVA1 + IVAITMONTO;
            END
        if (TARIFA = 2) then
            BEGIN
            SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
            IVA2 = IVA2 + IVAITMONTO;
            END
        if (TARIFA = 3) then
            BEGIN
            SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
            IVA3 = IVA3 + IVAITMONTO;
            END
        SUMAGR = SUMA1 + SUMA2 + SUMA3;
        if (IMPTOS = 'N') then
            TOTAL = TOTAL - IVAITMONTO;
        SUSPEND;
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE IMPR_COTIZACION(
    ID INTEGER)
RETURNS (
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    VALIDEZ INTEGER,
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    VENDEDOR INTEGER,
    NOMVENDEDOR VARCHAR(60),
    PUNTOVTA INTEGER,
    NOMPUNTOVTA VARCHAR(30),
    SUBTOTAL NUMERIC(18,2),
    DTOPORC NUMERIC(9,2),
    DTOMONTO NUMERIC(18,2),
    ADICIONAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    EXTRA NUMERIC(18,2),
    TOTALFAC NUMERIC(18,2),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    UNIDAD VARCHAR(8),
    LISTAPR INTEGER,
    REFITEM VARCHAR(60),
    PRUNIT NUMERIC(18,2),
    DTOITPORC NUMERIC(9,2),
    DTOITMONTO NUMERIC(18,2),
    PRNETO NUMERIC(18,2),
    IVAPORC NUMERIC(9,2),
    IVAITMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    CODIGOCL VARCHAR(20),
    ZONACOD VARCHAR(2),
    ZONANOM VARCHAR(60),
    DV CHAR(1),
    DIRECCION VARCHAR(60),
    CIUDAD VARCHAR(40),
    TELEFONO VARCHAR(40),
    CONTACTO VARCHAR(60),
    FAX VARCHAR(25),
    GRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    SUBGRUPO VARCHAR(3),
    NOMSUBG VARCHAR(30),
    MARCA VARCHAR(3),
    NOMMARCA VARCHAR(30),
    PESO NUMERIC(9,4),
    ANCHO NUMERIC(18,4),
    ALTO NUMERIC(18,4),
    LARGO NUMERIC(18,4),
    SUMA1 NUMERIC(18,2),
    SUMA2 NUMERIC(18,2),
    SUMA3 NUMERIC(18,2),
    IVA1 NUMERIC(18,2),
    IVA2 NUMERIC(18,2),
    IVA3 NUMERIC(18,2),
    SUMAEX NUMERIC(18,2),
    SUMAGR NUMERIC(18,2))
AS
DECLARE VARIABLE IMPTOS CHAR(1);
DECLARE VARIABLE TARIFA INTEGER;
declare variable ORDENCOD CHAR(2);
declare variable SUCUR VARCHAR(10);
BEGIN
  /*  */
  SELECT F.PREF_PRE, COTI_NUMERO, COTI_FECHA, COTI_VALIDEZ, F.TERC_NIT, COTI_NOMTERC, F.VEND_COD, VEND_NOMBRE, F.PTVT_ID, PTVT_NOM,
    COTI_IMPTOS, COTI_DTOPORC, COTI_DTOMONTO, COTI_ADICIONAL, COTI_IVAMONTO, COTI_EXTRA, COTI_TOTAL,
    TERC_CONTACTO, TERC_FAX, TERC_DV, COTI_OBS, COTI_SUCURSAL
    FROM COTIZACIONES F, VENDEDORES V, PUNTO_VENTA P, TERCEROS T
    WHERE F.VEND_COD = V.VEND_COD AND F.PTVT_ID = P.PTVT_ID AND F.TERC_NIT = T.TERC_NIT AND F.COTI_ID = :ID
    into :PREF, :NUMERO, :FECHA, :VALIDEZ, :NIT, :NOMTERCERO, :VENDEDOR, :NOMVENDEDOR, :PUNTOVTA, :NOMPUNTOVTA,
    :IMPTOS, :DTOPORC, :DTOMONTO, :ADICIONAL, :IVAMONTO, :EXTRA, :TOTALFAC,
    :CONTACTO, :FAX, :DV, :OBS, :SUCUR;
  SUBTOTAL = TOTALFAC - EXTRA - IVAMONTO - ADICIONAL + DTOMONTO;

  SELECT CLIE_COD, C.ZONA_COD, ZONA_NOM
    FROM CLIENTES C, ZONAS Z
    WHERE TERC_NIT = :NIT AND C.ZONA_COD = Z.ZONA_COD
    INTO :CODIGOCL, :ZONACOD, :ZONANOM;
  SELECT CLSU_DIR, CLSU_CIUDAD, CLSU_TEL FROM CLIENTE_SUCURSALES WHERE TERC_NIT = :NIT AND CLCU_COD = :SUCUR
    INTO :DIRECCION, :CIUDAD, :TELEFONO;
    
  SUMAEX = 0;
  SUMA1 = 0;
  SUMA2 = 0;
  SUMA3 = 0;
  IVA1 = 0;
  IVA2 = 0;
  IVA3 = 0;
  ITEM = 0;
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','DOCUMENTOS','ORDENAR ITEMS POR CODIGO DE ARTICULO') returning_values (:ORDENCOD);
  if (ORDENCOD = 'SI') then
    BEGIN
    FOR SELECT D.ARTI_COD, CTDE_CODBAR, SUBSTR(CTDE_DESC,1,60), CTDE_CANT, CTDE_UNIDAD, LIPR_COD, CTDE_PRUNIT, CTDE_DTOPORC, CTDE_DTOMONTO, CTDE_IVAPORC, CTDE_IVAMONTO, CTDE_CONSUMO, CTDE_TOTAL, CTDE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD
        FROM COTIZACIONES_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.COTI_ID = :ID
        ORDER BY CTDE_CODBAR
        INTO :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem,
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA
        DO
        BEGIN
        if (ARTICULO = CODBAR) then
            SELECT FIRST 1 COBA_COD FROM barras_articulo WHERE ARTI_COD = :articulo INTO :CODBAR;
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
        ITEM = ITEM + 1;
        PRNETO = PRUNIT - DTOITMONTO;
        if (ivaporc = 0) then
            SUMAEX = SUMAEX + TOTAL;
        if (TARIFA = 1) then
            BEGIN
            SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
            IVA1 = IVA1 + IVAITMONTO;
            END
        if (TARIFA = 2) then
            BEGIN
            SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
            IVA2 = IVA2 + IVAITMONTO;
            END
        if (TARIFA = 3) then
            BEGIN
            SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
            IVA3 = IVA3 + IVAITMONTO;
            END
        SUMAGR = SUMA1 + SUMA2 + SUMA3;
        if (IMPTOS = 'N') then
            TOTAL = TOTAL - IVAITMONTO;
        SUSPEND;
        END
    END
ELSE
    BEGIN
    FOR SELECT D.ARTI_COD, CTDE_CODBAR, SUBSTR(CTDE_DESC,1,60), CTDE_CANT, CTDE_UNIDAD, LIPR_COD, CTDE_PRUNIT, CTDE_DTOPORC, CTDE_DTOMONTO, CTDE_IVAPORC, CTDE_IVAMONTO, CTDE_CONSUMO, CTDE_TOTAL, CTDE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD
        FROM COTIZACIONES_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.COTI_ID = :ID
        ORDER BY CTDE_ITEM
        INTO :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem,
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA
        DO
        BEGIN
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
        ITEM = ITEM + 1;
        PRNETO = PRUNIT - DTOITMONTO;
        if (ivaporc = 0) then
            SUMAEX = SUMAEX + TOTAL;
        if (TARIFA = 1) then
            BEGIN
            SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
            IVA1 = IVA1 + IVAITMONTO;
            END
        if (TARIFA = 2) then
            BEGIN
            SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
            IVA2 = IVA2 + IVAITMONTO;
            END
        if (TARIFA = 3) then
            BEGIN
            SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
            IVA3 = IVA3 + IVAITMONTO;
            END
        SUMAGR = SUMA1 + SUMA2 + SUMA3;
        if (IMPTOS = 'N') then
            TOTAL = TOTAL - IVAITMONTO;
        SUSPEND;
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE IMPR_DEVOLUCION(
    ID INTEGER)
RETURNS (
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    VENDEDOR INTEGER,
    NOMVENDEDOR VARCHAR(60),
    PUNTOVTA INTEGER,
    NOMPUNTOVTA VARCHAR(30),
    CODBODEGA VARCHAR(2),
    NOMBODEGA VARCHAR(30),
    FACTURA VARCHAR(30),
    REMISION VARCHAR(10),
    COMIPORC NUMERIC(9,2),
    COMIMONTO NUMERIC(18,2),
    SUBTOTAL NUMERIC(18,2),
    DTOPORC NUMERIC(9,2),
    DTOMONTO NUMERIC(18,2),
    ADICIONAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    RTEFTEPORC NUMERIC(9,2),
    RTEFTEMONTO NUMERIC(18,2),
    RTEIVAPORC NUMERIC(9,2),
    RTEIVAMONTO NUMERIC(18,2),
    RTEICAPORC NUMERIC(9,2),
    RTEICAMONTO NUMERIC(18,2),
    EXTRA NUMERIC(18,2),
    TOTALFAC NUMERIC(18,2),
    TOTALPAGAR NUMERIC(18,2),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    LOTE VARCHAR(15),
    UNIDAD VARCHAR(8),
    REFITEM VARCHAR(60),
    BODITEM VARCHAR(2),
    PRUNIT NUMERIC(18,2),
    DTOITPORC NUMERIC(9,2),
    DTOITMONTO NUMERIC(18,2),
    PRNETO NUMERIC(18,2),
    IVAPORC NUMERIC(9,2),
    IVAITMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    CODIGOCL VARCHAR(20),
    ZONACOD VARCHAR(2),
    ZONANOM VARCHAR(60),
    DV CHAR(1),
    DIRECCION VARCHAR(60),
    CIUDAD VARCHAR(40),
    TELEFONO VARCHAR(40),
    CONTACTO VARCHAR(60),
    FAX VARCHAR(25),
    GRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    SUBGRUPO VARCHAR(3),
    NOMSUBG VARCHAR(30),
    MARCA VARCHAR(3),
    NOMMARCA VARCHAR(30),
    PESO NUMERIC(9,4),
    ANCHO NUMERIC(18,4),
    ALTO NUMERIC(18,4),
    LARGO NUMERIC(18,4),
    SUMA1 NUMERIC(18,2),
    SUMA2 NUMERIC(18,2),
    SUMA3 NUMERIC(18,2),
    IVA1 NUMERIC(18,2),
    IVA2 NUMERIC(18,2),
    IVA3 NUMERIC(18,2),
    TOTCONSUMO NUMERIC(18,2),
    SUMAEX NUMERIC(18,2),
    SUMAGR NUMERIC(18,2))
AS
DECLARE VARIABLE IMPTOS CHAR(1);
DECLARE VARIABLE TARIFA INTEGER;
declare variable ORDENCOD CHAR(2);
declare variable SUCUR VARCHAR(10);
declare variable PUNTOS NUMERIC(18,4);
BEGIN
  /*  */
  SELECT F.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, F.BODE_COD, BODE_NOM, F.TERC_NIT, DEVT_NOMTERC, F.VEND_COD, VEND_NOMBRE, F.PTVT_ID, PTVT_NOM,
    DEVT_FACTURA, DEVT_COMIPORC, DEVT_COMIMONTO, DEVT_IVAINC,
    DEVT_DTOPOR, DEVT_DTOMONTO, DEVT_ADICIONAL, DEVT_IVAMONTO, DEVT_RTFTEPORC, DEVT_RTFTEMONTO, DEVT_RTIVAPORC, DEVT_RTIVAMONTO, DEVT_RTICAPORC, DEVT_RTICAMONTO, DEVT_EXTRA, DEVT_TOTAL,
    TERC_CONTACTO, TERC_FAX, TERC_DV, DEVT_OBS, DEVT_SUCURSAL, DEVT_REMISION
    FROM DEVOLUCIONES_VENTAS F, BODEGA B, VENDEDORES V, PUNTO_VENTA P, TERCEROS T
    WHERE F.BODE_COD = B.BODE_COD AND F.VEND_COD = V.VEND_COD AND F.PTVT_ID = P.PTVT_ID AND F.TERC_NIT = T.TERC_NIT AND F.DEVT_ID = :ID
    into :PREF, :NUMERO, :FECHA, :CODBODEGA, :NOMBODEGA, :NIT, :NOMTERCERO, :VENDEDOR, :NOMVENDEDOR, :PUNTOVTA, :NOMPUNTOVTA,
    :FACTURA, :COMIPORC, :COMIMONTO, :IMPTOS,
    :DTOPORC, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTEFTEPORC, :RTEFTEMONTO, :RTEIVAPORC, :RTEIVAMONTO, :RTEICAPORC, :RTEICAMONTO, :EXTRA, :TOTALFAC,
    :CONTACTO, :FAX, :DV, :OBS, :SUCUR, :REMISION;
  SUBTOTAL = TOTALFAC - EXTRA - IVAMONTO - ADICIONAL + DTOMONTO;
  TOTALPAGAR = TOTALFAC - RTEFTEMONTO - RTEIVAMONTO - RTEICAMONTO;

  EXECUTE PROCEDURE acumula_puntos_cliente (33, :id, :nit, :fecha) returning_values (:PUNTOS);
  SELECT CLIE_COD, C.ZONA_COD, ZONA_NOM
    FROM CLIENTES C, ZONAS Z
    WHERE TERC_NIT = :NIT AND C.ZONA_COD = Z.ZONA_COD
    INTO :CODIGOCL, :ZONACOD, :ZONANOM;
  SELECT CLSU_DIR, CLSU_CIUDAD, CLSU_TEL FROM CLIENTE_SUCURSALES WHERE TERC_NIT = :NIT AND CLCU_COD = :SUCUR
    INTO :DIRECCION, :CIUDAD, :TELEFONO;
    
  SUMAEX = 0;
  SUMA1 = 0;
  SUMA2 = 0;
  SUMA3 = 0;
  IVA1 = 0;
  IVA2 = 0;
  IVA3 = 0;
  TOTCONSUMO = 0;
  ITEM = 0;
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','DOCUMENTOS','ORDENAR ITEMS POR CODIGO DE ARTICULO') returning_values (:ORDENCOD);
  if (ORDENCOD = 'SI') then
    BEGIN
    FOR SELECT D.ARTI_COD, DVDE_CODBAR, SUBSTR(DVDE_DESC,1,60), DVDE_CANT, DVDE_UNIDAD, BODE_COD, DVDE_LOTE, DVDE_PRUNIT, DVDE_DTOPORC, DVDE_DTOMONTO, DVDE_IVAPORC, DVDE_IVAMONTO, DVDE_CONSUMO, DVDE_TOTAL, DVDE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD
        FROM DEVOLUCIONES_VENTAS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.DEVT_ID = :ID
        ORDER BY DVDE_CODBAR
        INTO :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :REFITEM,
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA
        DO
        BEGIN
        if (ARTICULO = CODBAR) then
            SELECT FIRST 1 COBA_COD FROM barras_articulo WHERE ARTI_COD = :articulo INTO :CODBAR;
        ITEM = ITEM + 1;
        PRNETO = PRUNIT - DTOITMONTO - ((IVAITMONTO+CONSUMO) / CANT);
        TOTCONSUMO = TOTCONSUMO + CONSUMO;
        PRNETO = PRUNIT - DTOITMONTO;
        if (TARIFA = 0) then
            SUMAEX = SUMAEX + TOTAL;
        if (TARIFA = 1) then
            BEGIN
            SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
            IVA1 = IVA1 + IVAITMONTO;
            END
        if (TARIFA = 2) then
            BEGIN
            SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
            IVA2 = IVA2 + IVAITMONTO;
            END
        if (TARIFA = 3) then
            BEGIN
            SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
            IVA3 = IVA3 + IVAITMONTO;
            END
        SUMAGR = SUMA1 + SUMA2 + SUMA3;
        if (IMPTOS = 'N') then
            TOTAL = TOTAL - IVAITMONTO - CONSUMO;
        SUSPEND;
        END
    END
ELSE
    BEGIN
    FOR SELECT D.ARTI_COD, DVDE_CODBAR, SUBSTR(DVDE_DESC,1,60), DVDE_CANT, DVDE_UNIDAD, BODE_COD, DVDE_LOTE, DVDE_PRUNIT, DVDE_DTOPORC, DVDE_DTOMONTO, DVDE_IVAPORC, DVDE_IVAMONTO, DVDE_CONSUMO, DVDE_TOTAL, DVDE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD
        FROM DEVOLUCIONES_VENTAS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.DEVT_ID = :ID
        ORDER BY DVDE_ITEM
        INTO :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :REFITEM,
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA
        DO
        BEGIN
        if (ARTICULO = CODBAR) then
            SELECT FIRST 1 COBA_COD FROM barras_articulo WHERE ARTI_COD = :articulo INTO :CODBAR;
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
        ITEM = ITEM + 1;
        PRNETO = PRUNIT - DTOITMONTO - ((IVAITMONTO+CONSUMO) / CANT);
        TOTCONSUMO = TOTCONSUMO + CONSUMO;
        PRNETO = PRUNIT - DTOITMONTO;
        if (TARIFA = 0) then
            SUMAEX = SUMAEX + TOTAL;
        if (TARIFA = 1) then
            BEGIN
            SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
            IVA1 = IVA1 + IVAITMONTO;
            END
        if (TARIFA = 2) then
            BEGIN
            SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
            IVA2 = IVA2 + IVAITMONTO;
            END
        if (TARIFA = 3) then
            BEGIN
            SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
            IVA3 = IVA3 + IVAITMONTO;
            END
        SUMAGR = SUMA1 + SUMA2 + SUMA3;
        if (IMPTOS = 'N') then
            TOTAL = TOTAL - IVAITMONTO - CONSUMO;
        SUSPEND;
        END
    END
END
^

SET TERM ; ^


/* 05-26 codigos de barras con cantidad incluida */

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('FACTURACION', 'ARTICULOS', 'POSICIONES DE SEPARACION ENTRE EL CODIGO Y LA CANTIDAD INCLUIDOS EN EL CODIGO DE BARRAS', '3', '1,2,3,4,5', 'Indique el nmero de digitos que separan el codigo de la cantidad en el cdigo de barras que entrega la balanza');
commit work;

/* 05-28 */
grant EXECUTE on PROCEDURE CUENTA_INTERFAZ to PUBLIC;

/* 06-02 conciliacion de cartera y cxpagar */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE CONCILIA_CARTERA(
    FECINI DATE,
    FECFIN DATE,
    CTACART VARCHAR(20),
    SUBEMPRESA INTEGER,
    ANTERIOR CHAR(1))
RETURNS (
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    INICIAL NUMERIC(18,2),
    INICIALC NUMERIC(18,2),
    DEBITOS NUMERIC(18,2),
    DEBITOSC NUMERIC(18,2),
    CREDITOS NUMERIC(18,2),
    CREDITOSC NUMERIC(18,2),
    SALDO NUMERIC(18,2),
    SALDOC NUMERIC(18,2),
    DIFERENCIA NUMERIC(18,2))
AS
declare variable ANO CHAR(4);
declare variable MES INTEGER;
declare variable NUMROWS INTEGER;
declare variable ABONOS NUMERIC(18,2);
declare variable TIPODOC INTEGER;
declare variable IDDOC INTEGER;
declare variable RETES CHAR(2);
begin
ano = EXTRACT(YEAR FROM FECFIN);
mes = EXTRACT(MONTH FROM FECFIN);

for select TERC_NIT, TERC_NOM from TERCEROS WHERE TERC_CLIE = 'S' into :NIT, :NOMBRE
    DO
    BEGIN
    /* OMITE LOS CLIENTES DE CONTADO */
    SELECT COUNT(*) FROM AUTORIZACIONES WHERE AUTO_NITCONTADO = :NIT INTO :numrows;
    IF (numrows = 0) THEN
        BEGIN
        FECINI = FECINI - 1;
        INICIAL = 0;
        FOR SELECT MVCL_TIPOREF, MVCL_IDREF FROM MOVIMIENTO_CLIENTES
            WHERE TERC_NIT = :NIT AND MVCL_FECHA <= :FECINI AND
            MVCL_ABONO = 'N' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
            INTO :TIPODOC, :IDDOC
            DO
            BEGIN
            EXECUTE PROCEDURE saldo_doc_cartera(TIPODOC, IDDOC, FECINI) returning_values (SALDO);
            INICIAL = INICIAL + SALDO;
            END
        EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'DESCONTAR RETENCIONES POR CAUSACION') returning_values(:RETES);
        FECINI = FECINI + 1;
        if (RETES = 'SI') then
            BEGIN
            SELECT SUM(MVCL_MONTO-MVCL_RTEFTE-MVCL_RTEIVA-MVCL_RTEICA) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_DEBITO = 'S' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :DEBITOS;
            SELECT SUM(MVCL_MONTO-MVCL_RTEFTE-MVCL_RTEIVA-MVCL_RTEICA) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_DEBITO = 'N' AND MVCL_ABONO = 'N' and MVCL_TIPOREF <> 45 AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :CREDITOS;
            SELECT SUM(MVCL_MONTO) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_ABONO = 'S' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :ABONOS;
            END
        ELSE
            BEGIN
            SELECT SUM(MVCL_MONTO) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_DEBITO = 'S' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :DEBITOS;
            SELECT SUM(MVCL_MONTO) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_DEBITO = 'N' AND MVCL_ABONO = 'N' and MVCL_TIPOREF <> 45 AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :CREDITOS;
            SELECT SUM(MVCL_MONTO+MVCL_RTEFTE+MVCL_RTEIVA+MVCL_RTEICA) FROM movimiento_clientes
                WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA < :FECFIN
                AND MVCL_ABONO = 'S' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                INTO :ABONOS;
            END
        if (DEBITOS IS NULL) then
            DEBITOS = 0;
        if (CREDITOS IS NULL) then
            CREDITOS = 0;
        if (ABONOS IS NULL) then
            ABONOS = 0;
        CREDITOS = CREDITOS + ABONOS;
        SALDO = INICIAL + DEBITOS - CREDITOS;

        /* LO CONTABLE */
        EXECUTE PROCEDURE SALDO_TERCERO_MES(ctacart, NIT, ANO, MES, 'S') RETURNING_VALUES (INICIALC);
        EXECUTE PROCEDURE MOVIMIENTO_TERCERO_MES(ctacart, NIT, ANO, MES, 'S') RETURNING_VALUES(DEBITOSC);
        EXECUTE PROCEDURE MOVIMIENTO_TERCERO_MES(ctacart, NIT, ANO, MES, 'N') RETURNING_VALUES(CREDITOSC);
        SALDOC = INICIALC + DEBITOSC - CREDITOSC;
        diferencia = SALDO - SALDOC;
        if (DIFERENCIA <> 0) then
            BEGIN
            if (ANTERIOR <> 'S') then
                SUSPEND;
            ELSE
                BEGIN
                if (DIFERENCIA <> (INICIAL - INICIALC)) then
                    SUSPEND;
                END
            END
        END
    END
end
^

SET TERM ; ^


INSERT INTO PROCEDIMIENTOS_USUARIO (PRUS_COD, PRUS_NOMBRE, PRUS_SP, PRUS_PARAM1, PRUS_PARAM2, PRUS_PARAM3) VALUES (5, 'Conciliacin cartera-contable saldos por tercero', 'CONCILIA_CARTERA', 'Cuenta cartera', 'Agencia', 'Slo descuadre mes');
commit work;

SET TERM ^ ;

CREATE PROCEDURE CONCILIA_CXPAGAR(
    FECINI DATE,
    FECFIN DATE,
    CTACART VARCHAR(20),
    SUBEMPRESA INTEGER,
    ANTERIOR CHAR(1))
RETURNS (
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    INICIAL NUMERIC(18,2),
    INICIALC NUMERIC(18,2),
    DEBITOS NUMERIC(18,2),
    DEBITOSC NUMERIC(18,2),
    CREDITOS NUMERIC(18,2),
    CREDITOSC NUMERIC(18,2),
    SALDO NUMERIC(18,2),
    SALDOC NUMERIC(18,2),
    DIFERENCIA NUMERIC(18,2))
AS
declare variable ANO CHAR(4);
declare variable MES INTEGER;
declare variable ABONOS NUMERIC(18,2);
declare variable RETES CHAR(2);
begin
ano = EXTRACT(YEAR FROM FECFIN);
mes = EXTRACT(MONTH FROM FECFIN);

for select TERC_NIT, TERC_NOM from TERCEROS WHERE TERC_PROV = 'S' into :NIT, :NOMBRE
    DO
    BEGIN
    EXECUTE PROCEDURE saldo_proveedor (NIT, FECINI) returning_values (INICIAL);
    EXECUTE PROCEDURE LEE_CONFIGURACION('CXPAGAR', 'SALDOS', 'DESCONTAR RETENCIONES POR CAUSACION') returning_values(:RETES);
    if (RETES = 'SI') then
        BEGIN
        SELECT SUM(MVPR_MONTO-MVPR_RTFTE-MVPR_RTIVA-MVPR_RTICA)
            FROM movimiento_proveedor
            WHERE TERC_NIT = :NIT AND MVPR_FECHA >= :FECINI AND MVPR_FECHA < :FECFIN AND MVPR_DEBITO = 'S'
            INTO :DEBITOS;
        SELECT SUM(MVPR_MONTO-MVPR_RTFTE-MVPR_RTIVA-MVPR_RTICA)
            FROM movimiento_proveedor
            WHERE TERC_NIT = :NIT AND MVPR_FECHA >= :FECINI AND MVPR_FECHA < :FECFIN AND MVPR_DEBITO = 'N' AND MVPR_ABONO = 'N' and MVPR_TIPOREF <> 55
            INTO :CREDITOS;
        SELECT SUM(MVPR_MONTO) FROM movimiento_proveedor
            WHERE TERC_NIT = :NIT AND MVPR_FECHA >= :FECINI AND MVPR_FECHA < :FECFIN AND MVPR_ABONO = 'S'
            INTO :ABONOS;
        END
    ELSE
        BEGIN
        SELECT SUM(MVPR_MONTO)
            FROM movimiento_proveedor
            WHERE TERC_NIT = :NIT AND MVPR_FECHA >= :FECINI AND MVPR_FECHA < :FECFIN AND MVPR_DEBITO = 'S'
            INTO :DEBITOS;
        SELECT SUM(MVPR_MONTO)
            FROM movimiento_proveedor
            WHERE TERC_NIT = :NIT AND MVPR_FECHA >= :FECINI AND MVPR_FECHA < :FECFIN AND MVPR_DEBITO = 'N' AND MVPR_ABONO = 'N' AND MVPR_TIPOREF <> 55
            INTO :CREDITOS;
        SELECT SUM(MVPR_MONTO+MVPR_RTFTE+MVPR_RTIVA+MVPR_RTICA)
            FROM movimiento_proveedor
            WHERE TERC_NIT = :NIT AND MVPR_FECHA >= :FECINI AND MVPR_FECHA < :FECFIN AND MVPR_ABONO = 'S'
            INTO :ABONOS;
        END
    if (DEBITOS IS NULL) then
        DEBITOS = 0;
    if (CREDITOS IS NULL) then
        CREDITOS = 0;
    if (ABONOS IS NULL) then
        ABONOS = 0;
    CREDITOS = CREDITOS + ABONOS;
    SALDO = INICIAL + DEBITOS - CREDITOS;

    /* LO CONTABLE */
    EXECUTE PROCEDURE SALDO_TERCERO_MES(ctacart, NIT, ANO, MES, 'S') RETURNING_VALUES (INICIALC);
    EXECUTE PROCEDURE MOVIMIENTO_TERCERO_MES(ctacart, NIT, ANO, MES, 'S') RETURNING_VALUES(DEBITOSC);
    EXECUTE PROCEDURE MOVIMIENTO_TERCERO_MES(ctacart, NIT, ANO, MES, 'N') RETURNING_VALUES(CREDITOSC);
    SALDOC = INICIALC + DEBITOSC - CREDITOSC;
    diferencia = SALDO + SALDOC;
    if (DIFERENCIA <> 0) then
        BEGIN
        if (ANTERIOR <> 'S') then
            SUSPEND;
        ELSE
            BEGIN
            if (DIFERENCIA <> (INICIAL + INICIALC)) then
                SUSPEND;
            END
        END
    END
end
^

SET TERM ; ^

INSERT INTO PROCEDIMIENTOS_USUARIO (PRUS_COD, PRUS_NOMBRE, PRUS_SP, PRUS_PARAM1, PRUS_PARAM2, PRUS_PARAM3) VALUES (6, 'Conciliacin cxpagar-contable saldos por tercero', 'CONCILIA_CXPAGAR', 'Cuenta proveedores', 'Agencia', 'Slo descuadre mes');
commit work;

grant EXECUTE on PROCEDURE CONCILIA_CARTERA to PUBLIC;
grant EXECUTE on PROCEDURE CONCILIA_CXPAGAR to PUBLIC;


/* 06-03 OBSERVACIONES POR ITEM */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE IMPR_FACTURA(
    ID INTEGER)
RETURNS (
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    VENCE DATE,
    DIASVENCE INTEGER,
    CONTCRED CHAR(17),
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    VENDEDOR INTEGER,
    NOMVENDEDOR VARCHAR(60),
    PUNTOVTA INTEGER,
    NOMPUNTOVTA VARCHAR(30),
    CODBODEGA VARCHAR(2),
    NOMBODEGA VARCHAR(30),
    AUTORIZACION VARCHAR(20),
    DESPACHO VARCHAR(255),
    TRANSPORTADOR VARCHAR(60),
    COTIZACION VARCHAR(30),
    PEDIDO VARCHAR(30),
    REMISION VARCHAR(30),
    PACIENTE VARCHAR(20),
    NOMPACIENTE VARCHAR(60),
    COMIPORC NUMERIC(9,2),
    COMIMONTO NUMERIC(18,2),
    SUBTOTAL NUMERIC(18,2),
    DTOPORC NUMERIC(9,2),
    DTOMONTO NUMERIC(18,2),
    ADICIONAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    RTEFTEPORC NUMERIC(9,2),
    RTEFTEMONTO NUMERIC(18,2),
    RTEIVAPORC NUMERIC(9,2),
    RTEIVAMONTO NUMERIC(18,2),
    RTEICAPORC NUMERIC(9,2),
    RTEICAMONTO NUMERIC(18,2),
    EXTRA NUMERIC(18,2),
    DTOFPORC NUMERIC(9,2),
    DTOFMONTO NUMERIC(18,2),
    FECHADTO DATE,
    TOTALFAC NUMERIC(18,2),
    TOTALPAGAR NUMERIC(18,2),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    LOTE VARCHAR(15),
    VLOTE DATE,
    UNIDAD VARCHAR(8),
    FACTOR INTEGER,
    LISTAPR INTEGER,
    REFITEM VARCHAR(60),
    BODITEM VARCHAR(2),
    PRUNIT NUMERIC(18,2),
    DTOITPORC NUMERIC(9,2),
    DTOITMONTO NUMERIC(18,2),
    PRNETO NUMERIC(18,2),
    IVAPORC NUMERIC(9,2),
    IVAITMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    SUBTOTIT NUMERIC(18,2),
    SUBTOTITCON NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    CODIGOCL VARCHAR(20),
    ZONACOD VARCHAR(2),
    ZONANOM VARCHAR(60),
    DV CHAR(1),
    DIRECCION VARCHAR(60),
    CIUDAD VARCHAR(40),
    TELEFONO VARCHAR(40),
    CONTACTO VARCHAR(60),
    FAX VARCHAR(25),
    GRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    SUBGRUPO VARCHAR(3),
    NOMSUBG VARCHAR(30),
    MARCA VARCHAR(3),
    NOMMARCA VARCHAR(30),
    PESO NUMERIC(18,4),
    ANCHO NUMERIC(18,4),
    ALTO NUMERIC(18,4),
    LARGO NUMERIC(18,4),
    SUMA1 NUMERIC(18,2),
    SUMA2 NUMERIC(18,2),
    SUMA3 NUMERIC(18,2),
    IVA1 NUMERIC(18,2),
    IVA2 NUMERIC(18,2),
    IVA3 NUMERIC(18,2),
    SUMAEX NUMERIC(18,2),
    SUMAGR NUMERIC(18,2),
    TOTCONSUMO NUMERIC(18,2),
    VEHICULO VARCHAR(8),
    RECIBIDO NUMERIC(18,2),
    CAMBIO NUMERIC(18,2),
    HORA TIME,
    FORMAPAGO1 VARCHAR(30),
    MONTOPAGO1 NUMERIC(18,2),
    FORMAPAGO2 VARCHAR(30),
    MONTOPAGO2 NUMERIC(18,2),
    FORMAPAGO3 VARCHAR(30),
    MONTOPAGO3 NUMERIC(18,2),
    PUNTOS INTEGER,
    PUNTOSACUM INTEGER,
    PUNTOSVENC INTEGER,
    OBSITEM BLOB SUB_TYPE 1 SEGMENT SIZE 80)
AS
DECLARE VARIABLE IMPTOS CHAR(1);
DECLARE VARIABLE TARIFA INTEGER;
declare variable DEVUELTO NUMERIC(18,2);
/*DECLARE VARIABLE NROCOPIA INTEGER;*/
declare variable ORDENCOD CHAR(2);
declare variable IMPRDEV CHAR(2);
declare variable IMPR CHAR(1);
declare variable ITEMFP INTEGER;
declare variable FORMAP VARCHAR(30);
declare variable MONTOP NUMERIC(18,2);
declare variable SUCUR VARCHAR(10);
BEGIN
  SELECT F.PREF_PRE, FACT_NUMERO, FACT_FECHA, FACT_VENCE, F.BODE_COD, BODE_NOM, F.TERC_NIT, FACT_NOMCLIENTE, F.VEND_COD, VEND_NOMBRE, F.PTVT_ID, PTVT_NOM,
    AUTO_NUMERO, FACT_DESPACHO, FACT_TRANSP, FACT_COTIZACI, FACT_PEDIDO, FACT_REMISION, FACT_COMIPORC, FACT_COMIMONTO, FACT_IVAINC, 
    FACT_DTOPOR, FACT_DTOMONTO, FACT_ADICIONAL, FACT_IVAMONTO, FACT_RTFTEPOR, FACT_RTFTEMONTO, FACT_RTIVAPOR, FACT_RTIVAMONTO, FACT_RTICAPOR, FACT_RTICAMONTO, FACT_EXTRA, FACT_DTOFPOR, FACT_DTOFMONTO, FACT_DTOFFECHA, FACT_TOTAL,
    TERC_DIR, TERC_CIU, TERC_TEL, TERC_CONTACTO, TERC_FAX, TERC_DV,
    FACT_OBS, VEHI_COD, /*FACT_NROCOPIA,*/ FACT_RECIBIDO, FACT_SUCURSAL, FACT_DETCLI, FACT_DETCLINOM
    FROM FACTURAS F, BODEGA B, VENDEDORES V, PUNTO_VENTA P, TERCEROS T
    WHERE F.BODE_COD = B.BODE_COD AND F.VEND_COD = V.VEND_COD AND F.PTVT_ID = P.PTVT_ID AND F.TERC_NIT = T.TERC_NIT AND F.FACT_ID = :ID
    into :PREF, :NUMERO, :FECHA, :VENCE, :CODBODEGA, :NOMBODEGA, :NIT, :NOMTERCERO, :VENDEDOR, :NOMVENDEDOR, :PUNTOVTA, :NOMPUNTOVTA,
    :AUTORIZACION, :DESPACHO, :TRANSPORTADOR, :COTIZACION, :PEDIDO, :REMISION, :COMIPORC, :COMIMONTO, :IMPTOS,
    :DTOPORC, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTEFTEPORC, :RTEFTEMONTO, :RTEIVAPORC, :RTEIVAMONTO, :RTEICAPORC, :RTEICAMONTO, :EXTRA, :DTOFPORC, :DTOFMONTO, :FECHADTO, :TOTALFAC,
    :DIRECCION, :CIUDAD, :TELEFONO, :CONTACTO, :FAX, :DV, :OBS, :VEHICULO,/* :NROCOPIA,*/ :RECIBIDO, :SUCUR, :paciente, :nompaciente;

  /* ACUMULE LOS PUNTOS, SE HACE ACA POR SER POSTERIOR AL DETALLE */
  EXECUTE PROCEDURE acumula_puntos_cliente (31, :id, :nit, :fecha) returning_values (:PUNTOS);
  EXECUTE PROCEDURE consulta_puntos_cliente (:id, :nit, :fecha) returning_values (:puntos, :puntosacum, :puntosvenc);

  SELECT CLIE_COD, C.ZONA_COD, ZONA_NOM
    FROM CLIENTES C, ZONAS Z
    WHERE TERC_NIT = :NIT AND C.ZONA_COD = Z.ZONA_COD
    INTO :CODIGOCL, :ZONACOD, :ZONANOM;
  /*SELECT NOCO_NOMBRE FROM NOMBRES_COPIAS where NOCO_ID = :NROCOPIA INTO :NOMCOPIA;*/
  SELECT CLSU_DIR, CLSU_CIUDAD, CLSU_TEL FROM CLIENTE_SUCURSALES WHERE TERC_NIT = :NIT AND CLCU_COD = :SUCUR
    INTO :DIRECCION, :CIUDAD, :TELEFONO;
  /*if (NOMCOPIA IS NULL) then
    NOMCOPIA = 'COPIA No. ' || NROCOPIA;**/
  DIASVENCE = VENCE - FECHA;
  if (DIASVENCE > 0) then
    CONTCRED = 'CREDITO ' || CAST(DIASVENCE AS VARCHAR(3)) || ' DIAS';
  ELSE
    CONTCRED = 'CONTADO';
  SUBTOTAL = TOTALFAC - EXTRA - IVAMONTO - ADICIONAL + DTOMONTO;
  TOTALPAGAR = TOTALFAC - RTEFTEMONTO - RTEIVAMONTO - RTEICAMONTO;
  if (RECIBIDO <> 0) then
      CAMBIO = RECIBIDO - totalpagar;
  ELSE
    CAMBIO = 0;
  SUMAEX = 0;
  SUMA1 = 0;
  SUMA2 = 0;
  SUMA3 = 0;
  IVA1 = 0;
  IVA2 = 0;
  IVA3 = 0;
  TOTCONSUMO = 0;
  MONTOPAGO1 = 0;
  SELECT MAX(AUDI_HORA) FROM AUDITORIA WHERE TIDO_COD = 31 AND AUDI_IDDOC = :ID AND AUDI_OPER = 'I' INTO :HORA;
  /* AHORA LAS FORMAS DE PAGO, BUSQUE EL ABONO DE HOY A LA FACTURA */
  ITEMFP = 1;
  MONTOPAGO1 = 0;
  MONTOPAGO2 = 0;
  MONTOPAGO3 = 0;
  FOR SELECT FOPA_NOM, RCPA_MONTO FROM RECIBOS_CAJA_PAGO P, FORMAS_PAGO F, RECIBOS_CAJA R, RECIBOS_CAJA_DETALLE D
    WHERE R.RECA_ID = P.RECA_ID AND R.RECA_ID = D.RECA_ID AND P.FOPA_ID = F.FOPA_ID AND RECA_FECHA = :FECHA AND RCDE_TIPODOC = 31 AND RCDE_IDDOC = :ID
    INTO :formap, :MONTOP
    DO
    BEGIN
    if (ITEMFP = 1) then
        BEGIN
        FORMAPAGO1 = FORMAP;
        MONTOPAGO1 = MONTOP;
        END
    if (ITEMFP = 2) then
        BEGIN
        FORMAPAGO2 = FORMAP;
        MONTOPAGO2 = MONTOP;
        END
    if (ITEMFP = 3) then
        BEGIN
        FORMAPAGO3 = FORMAP;
        MONTOPAGO3 = MONTOP;
        END
    ITEMFP = ITEMFP + 1;
    END
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','DOCUMENTOS','ORDENAR ITEMS POR CODIGO DE ARTICULO') returning_values (:ORDENCOD);
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','POS', 'IMPRIMIR DEVOLUCIONES DE ARTICULOS NEGATIVOS') returning_values (:imprdev);
  if (ORDENCOD = 'SI') then
    BEGIN
    FOR SELECT FADE_ITEM, D.ARTI_COD, FADE_CODBAR, SUBSTR(FADE_DESC,1,60), FADE_CANT, FADE_UNIDAD, FADE_FACTOR, BODE_COD, FADE_LOTE, LIPR_COD, FADE_PRUNIT, FADE_DTOPORC, FADE_DTOMONTO, FADE_IVAPORC, FADE_IVAMONTO, FADE_CONSUMO, FADE_TOTAL, FADE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, FADE_DEVUELTO, FADE_OBS
        FROM FACTURAS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.FACT_ID = :ID
        ORDER BY D.ARTI_COD
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :FACTOR, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem,
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :devuelto, :obsitem
        DO
          BEGIN
          if (ARTICULO = CODBAR) then
            SELECT FIRST 1 COBA_COD FROM barras_articulo WHERE ARTI_COD = :articulo INTO :CODBAR;
          if (IMPRDEV <> 'SI') then
            BEGIN
            if ((CANT >= 0) AND (DEVUELTO = 0)) then
                IMPR = 'S';
            ELSE
                IMPR = 'N'; /* ES DEVOLUCION */
            END
          ELSE
            IMPR = 'S';
          if (IMPR = 'S') then
            BEGIN
            if (IMPTOS = 'S') then
                if (cant <> 0) then
                    PRNETO = PRUNIT - DTOITMONTO - ((IVAITMONTO+CONSUMO) / CANT);
                else
                    PRNETO = PRUNIT - DTOITMONTO;
            ELSE
                PRNETO = PRUNIT - DTOITMONTO;
            SUBTOTIT = TOTAL - IVAITMONTO - CONSUMO;
            SUBTOTITCON = TOTAL;
            TOTCONSUMO = TOTCONSUMO + CONSUMO;
            SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO INTO :vlote;
            if (TARIFA = 0) then
                SUMAEX = SUMAEX + TOTAL;
            if (TARIFA = 1) then
                BEGIN
                SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
                IVA1 = IVA1 + IVAITMONTO;
                END
            if (TARIFA = 2) then
                BEGIN
                SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
                IVA2 = IVA2 + IVAITMONTO;
                END
            if (TARIFA = 3) then
                BEGIN
                SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
                IVA3 = IVA3 + IVAITMONTO;
                END
            SUMAGR = SUMA1 + SUMA2 + SUMA3;
            if (IMPTOS = 'N') then
                TOTAL = TOTAL - IVAITMONTO - CONSUMO;
            if (ANCHO IS NULL) then
                ANCHO = 0;
            if (ALTO IS NULL) then
                ALTO = 0;
            if (LARGO IS NULL) then
                LARGO = 0;
            if (PESO IS NULL) then
                PESO = 0;
            PESO = PESO * CANT;
            SUSPEND;
            END
          END
    END
ELSE
    BEGIN
    FOR SELECT FADE_ITEM, D.ARTI_COD, FADE_CODBAR, SUBSTR(FADE_DESC,1,60), FADE_CANT, FADE_UNIDAD, FADE_FACTOR, BODE_COD, FADE_LOTE, LIPR_COD, FADE_PRUNIT, FADE_DTOPORC, FADE_DTOMONTO, FADE_IVAPORC, FADE_IVAMONTO, FADE_CONSUMO, FADE_TOTAL, FADE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, FADE_DEVUELTO, FADE_OBS
        FROM FACTURAS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.FACT_ID = :ID
        ORDER BY FADE_ITEM
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :FACTOR, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem, 
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :devuelto, :obsitem
        DO
          BEGIN
          if (IMPRDEV <> 'SI') then
            BEGIN
            if ((CANT >= 0) AND (DEVUELTO = 0)) then
                IMPR = 'S';
            ELSE
                IMPR = 'N'; /* ES DEVOLUCION */
            END
          ELSE
            IMPR = 'S';
          if (IMPR = 'S') then
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
            if (IMPTOS = 'S') then
              PRNETO = PRUNIT - DTOITMONTO - ((IVAITMONTO+CONSUMO) / CANT);
            ELSE
              PRNETO = PRUNIT - DTOITMONTO;
            SUBTOTIT = TOTAL - IVAITMONTO - CONSUMO;
            SUBTOTITCON = TOTAL;
            TOTCONSUMO = TOTCONSUMO + CONSUMO;
            SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO INTO :vlote;
            if (IVAPORC = 0) then
                SUMAEX = SUMAEX + TOTAL;
            if (TARIFA = 1) then
                BEGIN
                SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
                IVA1 = IVA1 + IVAITMONTO;
                END
            if (TARIFA = 2) then
                BEGIN
                SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
                IVA2 = IVA2 + IVAITMONTO;
                END
            if (TARIFA = 3) then
                BEGIN
                SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
                IVA3 = IVA3 + IVAITMONTO;
                END
            SUMAGR = SUMA1 + SUMA2 + SUMA3;
            if (IMPTOS = 'N') then
                TOTAL = TOTAL - IVAITMONTO - CONSUMO;
            if (ANCHO IS NULL) then
                ANCHO = 0;
            if (ALTO IS NULL) then
                ALTO = 0;
            if (LARGO IS NULL) then
                LARGO = 0;
            if (PESO IS NULL) then
                PESO = 0;
            PESO = PESO * CANT;
            SUSPEND;
            END
          END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE IMPR_COTIZACION(
    ID INTEGER)
RETURNS (
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    VALIDEZ INTEGER,
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    VENDEDOR INTEGER,
    NOMVENDEDOR VARCHAR(60),
    PUNTOVTA INTEGER,
    NOMPUNTOVTA VARCHAR(30),
    SUBTOTAL NUMERIC(18,2),
    DTOPORC NUMERIC(9,2),
    DTOMONTO NUMERIC(18,2),
    ADICIONAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    EXTRA NUMERIC(18,2),
    TOTALFAC NUMERIC(18,2),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    UNIDAD VARCHAR(8),
    LISTAPR INTEGER,
    REFITEM VARCHAR(60),
    PRUNIT NUMERIC(18,2),
    DTOITPORC NUMERIC(9,2),
    DTOITMONTO NUMERIC(18,2),
    PRNETO NUMERIC(18,2),
    IVAPORC NUMERIC(9,2),
    IVAITMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    CODIGOCL VARCHAR(20),
    ZONACOD VARCHAR(2),
    ZONANOM VARCHAR(60),
    DV CHAR(1),
    DIRECCION VARCHAR(60),
    CIUDAD VARCHAR(40),
    TELEFONO VARCHAR(40),
    CONTACTO VARCHAR(60),
    FAX VARCHAR(25),
    GRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    SUBGRUPO VARCHAR(3),
    NOMSUBG VARCHAR(30),
    MARCA VARCHAR(3),
    NOMMARCA VARCHAR(30),
    PESO NUMERIC(9,4),
    ANCHO NUMERIC(18,4),
    ALTO NUMERIC(18,4),
    LARGO NUMERIC(18,4),
    SUMA1 NUMERIC(18,2),
    SUMA2 NUMERIC(18,2),
    SUMA3 NUMERIC(18,2),
    IVA1 NUMERIC(18,2),
    IVA2 NUMERIC(18,2),
    IVA3 NUMERIC(18,2),
    SUMAEX NUMERIC(18,2),
    SUMAGR NUMERIC(18,2),
    OBSITEM BLOB SUB_TYPE 1 SEGMENT SIZE 80)
AS
DECLARE VARIABLE IMPTOS CHAR(1);
DECLARE VARIABLE TARIFA INTEGER;
declare variable ORDENCOD CHAR(2);
declare variable SUCUR VARCHAR(10);
BEGIN
  /*  */
  SELECT F.PREF_PRE, COTI_NUMERO, COTI_FECHA, COTI_VALIDEZ, F.TERC_NIT, COTI_NOMTERC, F.VEND_COD, VEND_NOMBRE, F.PTVT_ID, PTVT_NOM,
    COTI_IMPTOS, COTI_DTOPORC, COTI_DTOMONTO, COTI_ADICIONAL, COTI_IVAMONTO, COTI_EXTRA, COTI_TOTAL,
    TERC_CONTACTO, TERC_FAX, TERC_DV, COTI_OBS, COTI_SUCURSAL
    FROM COTIZACIONES F, VENDEDORES V, PUNTO_VENTA P, TERCEROS T
    WHERE F.VEND_COD = V.VEND_COD AND F.PTVT_ID = P.PTVT_ID AND F.TERC_NIT = T.TERC_NIT AND F.COTI_ID = :ID
    into :PREF, :NUMERO, :FECHA, :VALIDEZ, :NIT, :NOMTERCERO, :VENDEDOR, :NOMVENDEDOR, :PUNTOVTA, :NOMPUNTOVTA,
    :IMPTOS, :DTOPORC, :DTOMONTO, :ADICIONAL, :IVAMONTO, :EXTRA, :TOTALFAC,
    :CONTACTO, :FAX, :DV, :OBS, :SUCUR;
  SUBTOTAL = TOTALFAC - EXTRA - IVAMONTO - ADICIONAL + DTOMONTO;

  SELECT CLIE_COD, C.ZONA_COD, ZONA_NOM
    FROM CLIENTES C, ZONAS Z
    WHERE TERC_NIT = :NIT AND C.ZONA_COD = Z.ZONA_COD
    INTO :CODIGOCL, :ZONACOD, :ZONANOM;
  SELECT CLSU_DIR, CLSU_CIUDAD, CLSU_TEL FROM CLIENTE_SUCURSALES WHERE TERC_NIT = :NIT AND CLCU_COD = :SUCUR
    INTO :DIRECCION, :CIUDAD, :TELEFONO;
    
  SUMAEX = 0;
  SUMA1 = 0;
  SUMA2 = 0;
  SUMA3 = 0;
  IVA1 = 0;
  IVA2 = 0;
  IVA3 = 0;
  ITEM = 0;
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','DOCUMENTOS','ORDENAR ITEMS POR CODIGO DE ARTICULO') returning_values (:ORDENCOD);
  if (ORDENCOD = 'SI') then
    BEGIN
    FOR SELECT D.ARTI_COD, CTDE_CODBAR, SUBSTR(CTDE_DESC,1,60), CTDE_CANT, CTDE_UNIDAD, LIPR_COD, CTDE_PRUNIT, CTDE_DTOPORC, CTDE_DTOMONTO, CTDE_IVAPORC, CTDE_IVAMONTO, CTDE_CONSUMO, CTDE_TOTAL, CTDE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, CTDE_OBS
        FROM COTIZACIONES_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.COTI_ID = :ID
        ORDER BY CTDE_CODBAR
        INTO :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem,
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :obsitem
        DO
        BEGIN
        if (ARTICULO = CODBAR) then
            SELECT FIRST 1 COBA_COD FROM barras_articulo WHERE ARTI_COD = :articulo INTO :CODBAR;
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
        ITEM = ITEM + 1;
        PRNETO = PRUNIT - DTOITMONTO;
        if (ivaporc = 0) then
            SUMAEX = SUMAEX + TOTAL;
        if (TARIFA = 1) then
            BEGIN
            SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
            IVA1 = IVA1 + IVAITMONTO;
            END
        if (TARIFA = 2) then
            BEGIN
            SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
            IVA2 = IVA2 + IVAITMONTO;
            END
        if (TARIFA = 3) then
            BEGIN
            SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
            IVA3 = IVA3 + IVAITMONTO;
            END
        SUMAGR = SUMA1 + SUMA2 + SUMA3;
        if (IMPTOS = 'N') then
            TOTAL = TOTAL - IVAITMONTO;
        SUSPEND;
        END
    END
ELSE
    BEGIN
    FOR SELECT D.ARTI_COD, CTDE_CODBAR, SUBSTR(CTDE_DESC,1,60), CTDE_CANT, CTDE_UNIDAD, LIPR_COD, CTDE_PRUNIT, CTDE_DTOPORC, CTDE_DTOMONTO, CTDE_IVAPORC, CTDE_IVAMONTO, CTDE_CONSUMO, CTDE_TOTAL, CTDE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, CTDE_OBS
        FROM COTIZACIONES_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.COTI_ID = :ID
        ORDER BY CTDE_ITEM
        INTO :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem,
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :obsitem
        DO
        BEGIN
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
        ITEM = ITEM + 1;
        PRNETO = PRUNIT - DTOITMONTO;
        if (ivaporc = 0) then
            SUMAEX = SUMAEX + TOTAL;
        if (TARIFA = 1) then
            BEGIN
            SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
            IVA1 = IVA1 + IVAITMONTO;
            END
        if (TARIFA = 2) then
            BEGIN
            SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
            IVA2 = IVA2 + IVAITMONTO;
            END
        if (TARIFA = 3) then
            BEGIN
            SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
            IVA3 = IVA3 + IVAITMONTO;
            END
        SUMAGR = SUMA1 + SUMA2 + SUMA3;
        if (IMPTOS = 'N') then
            TOTAL = TOTAL - IVAITMONTO;
        SUSPEND;
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE IMPR_PEDIDO(
    ID INTEGER)
RETURNS (
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    VALIDEZ INTEGER,
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    VENDEDOR INTEGER,
    NOMVENDEDOR VARCHAR(60),
    PUNTOVTA INTEGER,
    NOMPUNTOVTA VARCHAR(30),
    COTIZACION VARCHAR(30),
    SUBTOTAL NUMERIC(18,2),
    DTOPORC NUMERIC(9,2),
    DTOMONTO NUMERIC(18,2),
    ADICIONAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    EXTRA NUMERIC(18,2),
    TOTALFAC NUMERIC(18,2),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    BODEGA VARCHAR(2),
    CANT NUMERIC(18,4),
    UNIDAD VARCHAR(8),
    LISTAPR INTEGER,
    REFITEM VARCHAR(60),
    PRUNIT NUMERIC(18,2),
    DTOITPORC NUMERIC(9,2),
    DTOITMONTO NUMERIC(18,2),
    PRNETO NUMERIC(18,2),
    IVAPORC NUMERIC(9,2),
    IVAITMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    CODIGOCL VARCHAR(20),
    ZONACOD VARCHAR(2),
    ZONANOM VARCHAR(60),
    DV CHAR(1),
    DIRECCION VARCHAR(60),
    CIUDAD VARCHAR(40),
    TELEFONO VARCHAR(40),
    CONTACTO VARCHAR(60),
    FAX VARCHAR(25),
    GRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    SUBGRUPO VARCHAR(3),
    NOMSUBG VARCHAR(30),
    MARCA VARCHAR(3),
    NOMMARCA VARCHAR(30),
    PESO NUMERIC(9,4),
    ANCHO NUMERIC(18,4),
    ALTO NUMERIC(18,4),
    LARGO NUMERIC(18,4),
    SUMA1 NUMERIC(18,2),
    SUMA2 NUMERIC(18,2),
    SUMA3 NUMERIC(18,2),
    IVA1 NUMERIC(18,2),
    IVA2 NUMERIC(18,2),
    IVA3 NUMERIC(18,2),
    SUMAEX NUMERIC(18,2),
    SUMAGR NUMERIC(18,2),
    OBSITEM BLOB SUB_TYPE 1 SEGMENT SIZE 80)
AS
DECLARE VARIABLE IMPTOS CHAR(1);
DECLARE VARIABLE TARIFA INTEGER;
declare variable ORDENCOD CHAR(2);
declare variable SUCUR VARCHAR(10);
BEGIN
  /*  */
  SELECT F.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, PEDI_VALIDEZ, F.TERC_NIT, PEDI_NOMTERC, F.VEND_COD, VEND_NOMBRE, F.PTVT_ID, PTVT_NOM, PEDI_COTIZACI,
    PEDI_IVAINC, PEDI_DTOPOR, PEDI_DTOMONTO, PEDI_ADICIONAL, PEDI_IVAMONTO, PEDI_EXTRA, PEDI_TOTAL,
    TERC_CONTACTO, TERC_FAX, TERC_DV, PEDI_OBS, PEDI_SUCURSAL
    FROM PEDIDOS F, VENDEDORES V, PUNTO_VENTA P, TERCEROS T
    WHERE F.VEND_COD = V.VEND_COD AND F.PTVT_ID = P.PTVT_ID AND F.TERC_NIT = T.TERC_NIT AND F.PEDI_ID = :ID
    into :PREF, :NUMERO, :FECHA, :VALIDEZ, :NIT, :NOMTERCERO, :VENDEDOR, :NOMVENDEDOR, :PUNTOVTA, :NOMPUNTOVTA, :COTIZACION,
    :IMPTOS, :DTOPORC, :DTOMONTO, :ADICIONAL, :IVAMONTO, :EXTRA, :TOTALFAC,
    :CONTACTO, :FAX, :DV, :OBS, :SUCUR;
  SUBTOTAL = TOTALFAC - EXTRA - IVAMONTO - ADICIONAL + DTOMONTO;

  SELECT CLIE_COD, C.ZONA_COD, ZONA_NOM
    FROM CLIENTES C, ZONAS Z
    WHERE TERC_NIT = :NIT AND C.ZONA_COD = Z.ZONA_COD
    INTO :CODIGOCL, :ZONACOD, :ZONANOM;
  SELECT CLSU_DIR, CLSU_CIUDAD, CLSU_TEL FROM CLIENTE_SUCURSALES WHERE TERC_NIT = :NIT AND CLCU_COD = :SUCUR
    INTO :DIRECCION, :CIUDAD, :TELEFONO;
    
  SUMAEX = 0;
  SUMA1 = 0;
  SUMA2 = 0;
  SUMA3 = 0;
  IVA1 = 0;
  IVA2 = 0;
  IVA3 = 0;
  ITEM = 0;
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','DOCUMENTOS','ORDENAR ITEMS POR CODIGO DE ARTICULO') returning_values (:ORDENCOD);
  if (ORDENCOD = 'SI') then
    BEGIN
    FOR SELECT D.ARTI_COD, PEDE_CODBAR, SUBSTR(PEDE_DESC,1,60), PEDE_CANT, PEDE_UNIDAD, LIPR_COD, PEDE_PRUNIT, PEDE_DTOPORC, PEDE_DTOMONTO, PEDE_IVAPORC, PEDE_IVAMONTO, PEDE_CONSUMO, PEDE_TOTAL, PEDE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, BODE_COD, PEDE_OBS
        FROM PEDIDOS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.PEDI_ID = :ID
        ORDER BY PEDE_CODBAR
        INTO :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :REFITEM,
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :BODEGA, :OBSITEM
        DO
        BEGIN
        if (ARTICULO = CODBAR) then
            SELECT FIRST 1 COBA_COD FROM barras_articulo WHERE ARTI_COD = :articulo INTO :CODBAR;
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
        ITEM = ITEM + 1;
        PRNETO = PRUNIT - DTOITMONTO;
        if (TARIFA = 0) then
            SUMAEX = SUMAEX + TOTAL;
        if (TARIFA = 1) then
            BEGIN
            SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
            IVA1 = IVA1 + IVAITMONTO;
            END
        if (TARIFA = 2) then
            BEGIN
            SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
            IVA2 = IVA2 + IVAITMONTO;
            END
        if (TARIFA = 3) then
            BEGIN
            SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
            IVA3 = IVA3 + IVAITMONTO;
            END
        SUMAGR = SUMA1 + SUMA2 + SUMA3;
        if (IMPTOS = 'N') then
            TOTAL = TOTAL - IVAITMONTO;
        SUSPEND;
        END
    END
ELSE
    BEGIN
    FOR SELECT PEDE_ITEM, D.ARTI_COD, PEDE_CODBAR, SUBSTR(PEDE_DESC,1,60), PEDE_CANT, PEDE_UNIDAD, LIPR_COD, PEDE_PRUNIT, PEDE_DTOPORC, PEDE_DTOMONTO, PEDE_IVAPORC, PEDE_IVAMONTO, PEDE_CONSUMO, PEDE_TOTAL, PEDE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, BODE_COD, PEDE_OBS
        FROM PEDIDOS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.PEDI_ID = :ID
        ORDER BY PEDE_ITEM
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :REFITEM,
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :BODEGA, :obsitem
        DO
        BEGIN
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
        ITEM = ITEM + 1;
        PRNETO = PRUNIT - DTOITMONTO;
        if (IVAPORC = 0) then
            SUMAEX = SUMAEX + TOTAL;
        if (TARIFA = 1) then
            BEGIN
            SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
            IVA1 = IVA1 + IVAITMONTO;
            END
        if (TARIFA = 2) then
            BEGIN
            SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
            IVA2 = IVA2 + IVAITMONTO;
            END
        if (TARIFA = 3) then
            BEGIN
            SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
            IVA3 = IVA3 + IVAITMONTO;
            END
        SUMAGR = SUMA1 + SUMA2 + SUMA3;
        if (IMPTOS = 'N') then
            TOTAL = TOTAL - IVAITMONTO;
        SUSPEND;
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE IMPR_REMISION(
    ID INTEGER)
RETURNS (
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    VENDEDOR INTEGER,
    NOMVENDEDOR VARCHAR(60),
    PUNTOVTA INTEGER,
    NOMPUNTOVTA VARCHAR(30),
    CODBODEGA VARCHAR(2),
    NOMBODEGA VARCHAR(30),
    COTIZACION VARCHAR(30),
    PEDIDO VARCHAR(30),
    FACTURA VARCHAR(30),
    SUBTOTAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    TOTALFAC NUMERIC(18,2),
    DESPACHO VARCHAR(255),
    TRANSPORTADOR VARCHAR(60),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    LOTE VARCHAR(15),
    VLOTE DATE,
    UNIDAD VARCHAR(8),
    DEVUELTO NUMERIC(18,4),
    LISTAPR INTEGER,
    REFITEM VARCHAR(60),
    BODITEM VARCHAR(2),
    PRUNIT NUMERIC(18,2),
    DTOITPORC NUMERIC(9,2),
    DTOITMONTO NUMERIC(18,2),
    SUBTOTALITEM NUMERIC(18,2),
    PRNETOSINIVA NUMERIC(18,2),
    PRNETO NUMERIC(18,2),
    IVAPORC NUMERIC(9,2),
    IVAITMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    CODIGOCL VARCHAR(20),
    ZONACOD VARCHAR(2),
    ZONANOM VARCHAR(60),
    DV CHAR(1),
    DIRECCION VARCHAR(60),
    CIUDAD VARCHAR(40),
    TELEFONO VARCHAR(40),
    CONTACTO VARCHAR(60),
    FAX VARCHAR(25),
    GRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    SUBGRUPO VARCHAR(3),
    NOMSUBG VARCHAR(30),
    MARCA VARCHAR(3),
    NOMMARCA VARCHAR(30),
    PESO NUMERIC(9,4),
    ANCHO NUMERIC(18,4),
    ALTO NUMERIC(18,4),
    LARGO NUMERIC(18,4),
    SUMA1 NUMERIC(18,2),
    SUMA2 NUMERIC(18,2),
    SUMA3 NUMERIC(18,2),
    IVA1 NUMERIC(18,2),
    IVA2 NUMERIC(18,2),
    IVA3 NUMERIC(18,2),
    SUMAEX NUMERIC(18,2),
    SUMAGR NUMERIC(18,2),
    OBSITEM BLOB SUB_TYPE 1 SEGMENT SIZE 80)
AS
DECLARE VARIABLE IMPTOS CHAR(1);
DECLARE VARIABLE TARIFA INTEGER;
declare variable ORDENCOD CHAR(2);
declare variable SUCUR VARCHAR(10);
BEGIN
  /*  */
  SELECT F.PREF_PRE, REVT_NUMERO, REVT_FECHA, F.BODE_COD, BODE_NOM, F.TERC_NIT, REVT_NOMTERC, F.VEND_COD, VEND_NOMBRE, F.PTVT_ID, PTVT_NOM,
    REVT_COTIZACI, REVT_PEDIDO, REVT_FACTURA, REVT_IVAINC,
    REVT_IVAMONTO, REVT_TOTAL, REVT_DESPACHO, REVT_TRANSP,
    TERC_CONTACTO, TERC_FAX, TERC_DV, REVT_OBS, REVT_SUCURSAL
    FROM REMISIONES_VENTA F, BODEGA B, VENDEDORES V, PUNTO_VENTA P, TERCEROS T
    WHERE F.BODE_COD = B.BODE_COD AND F.VEND_COD = V.VEND_COD AND F.PTVT_ID = P.PTVT_ID AND F.TERC_NIT = T.TERC_NIT AND F.REVT_ID = :ID
    into :PREF, :NUMERO, :FECHA, :CODBODEGA, :NOMBODEGA, :NIT, :NOMTERCERO, :VENDEDOR, :NOMVENDEDOR, :PUNTOVTA, :NOMPUNTOVTA,
    :COTIZACION, :PEDIDO, :FACTURA, :IMPTOS,
    :IVAMONTO, :TOTALFAC, :DESPACHO, :transportador, 
    :CONTACTO, :FAX, :DV, :OBS, :SUCUR;
  SUBTOTAL = TOTALFAC - IVAMONTO;

  SELECT CLIE_COD, C.ZONA_COD, ZONA_NOM
    FROM CLIENTES C, ZONAS Z
    WHERE TERC_NIT = :NIT AND C.ZONA_COD = Z.ZONA_COD
    INTO :CODIGOCL, :ZONACOD, :ZONANOM;
  SELECT CLSU_DIR, CLSU_CIUDAD, CLSU_TEL FROM CLIENTE_SUCURSALES WHERE TERC_NIT = :NIT AND CLCU_COD = :SUCUR
    INTO :DIRECCION, :CIUDAD, :TELEFONO;
    
  SUMAEX = 0;
  SUMA1 = 0;
  SUMA2 = 0;
  SUMA3 = 0;
  IVA1 = 0;
  IVA2 = 0;
  IVA3 = 0;
  ITEM = 0;
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','DOCUMENTOS','ORDENAR ITEMS POR CODIGO DE ARTICULO') returning_values (:ORDENCOD);
  if (ORDENCOD = 'SI') then
    BEGIN
    FOR SELECT D.ARTI_COD, RVDE_CODBAR, SUBSTR(RVDE_DESC,1,60), RVDE_CANT, RVDE_UNIDAD, BODE_COD, RVDE_LOTE, LIPR_COD, RVDE_PRUNIT, RVDE_DTOPORC, RVDE_DTOMONTO, RVDE_IVAPORC, RVDE_IVAMONTO, RVDE_CONSUMO, RVDE_TOTAL, RVDE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, RVDE_DEVUELTO, RVDE_OBS
        FROM REMISIONES_VENTA_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.REVT_ID = :ID
        ORDER BY RVDE_CODBAR
        INTO :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem,
            :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :DEVUELTO, :obsitem
        DO
        BEGIN
        if (ARTICULO = CODBAR) then
            SELECT FIRST 1 COBA_COD FROM barras_articulo WHERE ARTI_COD = :articulo INTO :CODBAR;
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
        SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO INTO :vlote;
        ITEM = ITEM + 1;
        PRNETO = PRUNIT - DTOITMONTO;
        if (IVAPORC = 0) then
            SUMAEX = SUMAEX + TOTAL;
        if (TARIFA = 1) then
            BEGIN
            SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
            IVA1 = IVA1 + IVAITMONTO;
            END
        if (TARIFA = 2) then
            BEGIN
            SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
            IVA2 = IVA2 + IVAITMONTO;
            END
        if (TARIFA = 3) then
            BEGIN
            SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
            IVA3 = IVA3 + IVAITMONTO;
            END
        SUMAGR = SUMA1 + SUMA2 + SUMA3;

        if (IMPTOS = 'N') then
            TOTAL = TOTAL - IVAITMONTO;
        ELSE
           BEGIN
           PRNETOSINIVA = PRUNIT / (1 + ivaporc/100);
           SUBTOTALITEM = PRNETOSINIVA * :CANT;
           END
        SUSPEND;
        END
    END
ELSE
    BEGIN
    FOR SELECT RVDE_ITEM, D.ARTI_COD, RVDE_CODBAR, SUBSTR(RVDE_DESC,1,60), RVDE_CANT, RVDE_UNIDAD, BODE_COD, RVDE_LOTE, LIPR_COD, RVDE_PRUNIT, RVDE_DTOPORC, RVDE_DTOMONTO, RVDE_IVAPORC, RVDE_IVAMONTO, RVDE_CONSUMO, RVDE_TOTAL, RVDE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, RVDE_DEVUELTO, RVDE_OBS
        FROM REMISIONES_VENTA_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.REVT_ID = :ID
        ORDER BY RVDE_ITEM
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem,
            :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :DEVUELTO, :obsitem
        DO
        BEGIN
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
        ITEM = ITEM + 1;
        PRNETO = PRUNIT - DTOITMONTO;
        if (IVAPORC = 0) then
            SUMAEX = SUMAEX + TOTAL;
        if (TARIFA = 1) then
            BEGIN
            SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
            IVA1 = IVA1 + IVAITMONTO;
            END
        if (TARIFA = 2) then
            BEGIN
            SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
            IVA2 = IVA2 + IVAITMONTO;
            END
        if (TARIFA = 3) then
            BEGIN
            SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
            IVA3 = IVA3 + IVAITMONTO;
            END
        SUMAGR = SUMA1 + SUMA2 + SUMA3;
        SUBTOTALITEM = TOTAL - IVAITMONTO;
        if (IMPTOS = 'N') then
            TOTAL = TOTAL - IVAITMONTO;
        ELSE
           BEGIN
             PRNETOSINIVA = PRUNIT / (1 + ivaporc/100);
             SUBTOTALITEM = PRNETOSINIVA * :CANT;
           END
        SUSPEND;
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE IMPR_DEVOLUCION(
    ID INTEGER)
RETURNS (
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    VENDEDOR INTEGER,
    NOMVENDEDOR VARCHAR(60),
    PUNTOVTA INTEGER,
    NOMPUNTOVTA VARCHAR(30),
    CODBODEGA VARCHAR(2),
    NOMBODEGA VARCHAR(30),
    FACTURA VARCHAR(30),
    REMISION VARCHAR(10),
    COMIPORC NUMERIC(9,2),
    COMIMONTO NUMERIC(18,2),
    SUBTOTAL NUMERIC(18,2),
    DTOPORC NUMERIC(9,2),
    DTOMONTO NUMERIC(18,2),
    ADICIONAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    RTEFTEPORC NUMERIC(9,2),
    RTEFTEMONTO NUMERIC(18,2),
    RTEIVAPORC NUMERIC(9,2),
    RTEIVAMONTO NUMERIC(18,2),
    RTEICAPORC NUMERIC(9,2),
    RTEICAMONTO NUMERIC(18,2),
    EXTRA NUMERIC(18,2),
    TOTALFAC NUMERIC(18,2),
    TOTALPAGAR NUMERIC(18,2),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    LOTE VARCHAR(15),
    UNIDAD VARCHAR(8),
    REFITEM VARCHAR(60),
    BODITEM VARCHAR(2),
    PRUNIT NUMERIC(18,2),
    DTOITPORC NUMERIC(9,2),
    DTOITMONTO NUMERIC(18,2),
    PRNETO NUMERIC(18,2),
    IVAPORC NUMERIC(9,2),
    IVAITMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    CODIGOCL VARCHAR(20),
    ZONACOD VARCHAR(2),
    ZONANOM VARCHAR(60),
    DV CHAR(1),
    DIRECCION VARCHAR(60),
    CIUDAD VARCHAR(40),
    TELEFONO VARCHAR(40),
    CONTACTO VARCHAR(60),
    FAX VARCHAR(25),
    GRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    SUBGRUPO VARCHAR(3),
    NOMSUBG VARCHAR(30),
    MARCA VARCHAR(3),
    NOMMARCA VARCHAR(30),
    PESO NUMERIC(9,4),
    ANCHO NUMERIC(18,4),
    ALTO NUMERIC(18,4),
    LARGO NUMERIC(18,4),
    SUMA1 NUMERIC(18,2),
    SUMA2 NUMERIC(18,2),
    SUMA3 NUMERIC(18,2),
    IVA1 NUMERIC(18,2),
    IVA2 NUMERIC(18,2),
    IVA3 NUMERIC(18,2),
    TOTCONSUMO NUMERIC(18,2),
    SUMAEX NUMERIC(18,2),
    SUMAGR NUMERIC(18,2),
    OBSITEM BLOB SUB_TYPE 1 SEGMENT SIZE 80)
AS
DECLARE VARIABLE IMPTOS CHAR(1);
DECLARE VARIABLE TARIFA INTEGER;
declare variable ORDENCOD CHAR(2);
declare variable SUCUR VARCHAR(10);
declare variable PUNTOS NUMERIC(18,4);
BEGIN
  /*  */
  SELECT F.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, F.BODE_COD, BODE_NOM, F.TERC_NIT, DEVT_NOMTERC, F.VEND_COD, VEND_NOMBRE, F.PTVT_ID, PTVT_NOM,
    DEVT_FACTURA, DEVT_COMIPORC, DEVT_COMIMONTO, DEVT_IVAINC,
    DEVT_DTOPOR, DEVT_DTOMONTO, DEVT_ADICIONAL, DEVT_IVAMONTO, DEVT_RTFTEPORC, DEVT_RTFTEMONTO, DEVT_RTIVAPORC, DEVT_RTIVAMONTO, DEVT_RTICAPORC, DEVT_RTICAMONTO, DEVT_EXTRA, DEVT_TOTAL,
    TERC_CONTACTO, TERC_FAX, TERC_DV, DEVT_OBS, DEVT_SUCURSAL, DEVT_REMISION
    FROM DEVOLUCIONES_VENTAS F, BODEGA B, VENDEDORES V, PUNTO_VENTA P, TERCEROS T
    WHERE F.BODE_COD = B.BODE_COD AND F.VEND_COD = V.VEND_COD AND F.PTVT_ID = P.PTVT_ID AND F.TERC_NIT = T.TERC_NIT AND F.DEVT_ID = :ID
    into :PREF, :NUMERO, :FECHA, :CODBODEGA, :NOMBODEGA, :NIT, :NOMTERCERO, :VENDEDOR, :NOMVENDEDOR, :PUNTOVTA, :NOMPUNTOVTA,
    :FACTURA, :COMIPORC, :COMIMONTO, :IMPTOS,
    :DTOPORC, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTEFTEPORC, :RTEFTEMONTO, :RTEIVAPORC, :RTEIVAMONTO, :RTEICAPORC, :RTEICAMONTO, :EXTRA, :TOTALFAC,
    :CONTACTO, :FAX, :DV, :OBS, :SUCUR, :REMISION;
  SUBTOTAL = TOTALFAC - EXTRA - IVAMONTO - ADICIONAL + DTOMONTO;
  TOTALPAGAR = TOTALFAC - RTEFTEMONTO - RTEIVAMONTO - RTEICAMONTO;

  EXECUTE PROCEDURE acumula_puntos_cliente (33, :id, :nit, :fecha) returning_values (:PUNTOS);
  SELECT CLIE_COD, C.ZONA_COD, ZONA_NOM
    FROM CLIENTES C, ZONAS Z
    WHERE TERC_NIT = :NIT AND C.ZONA_COD = Z.ZONA_COD
    INTO :CODIGOCL, :ZONACOD, :ZONANOM;
  SELECT CLSU_DIR, CLSU_CIUDAD, CLSU_TEL FROM CLIENTE_SUCURSALES WHERE TERC_NIT = :NIT AND CLCU_COD = :SUCUR
    INTO :DIRECCION, :CIUDAD, :TELEFONO;
    
  SUMAEX = 0;
  SUMA1 = 0;
  SUMA2 = 0;
  SUMA3 = 0;
  IVA1 = 0;
  IVA2 = 0;
  IVA3 = 0;
  TOTCONSUMO = 0;
  ITEM = 0;
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','DOCUMENTOS','ORDENAR ITEMS POR CODIGO DE ARTICULO') returning_values (:ORDENCOD);
  if (ORDENCOD = 'SI') then
    BEGIN
    FOR SELECT D.ARTI_COD, DVDE_CODBAR, SUBSTR(DVDE_DESC,1,60), DVDE_CANT, DVDE_UNIDAD, BODE_COD, DVDE_LOTE, DVDE_PRUNIT, DVDE_DTOPORC, DVDE_DTOMONTO, DVDE_IVAPORC, DVDE_IVAMONTO, DVDE_CONSUMO, DVDE_TOTAL, DVDE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, DVDE_OBS
        FROM DEVOLUCIONES_VENTAS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.DEVT_ID = :ID
        ORDER BY DVDE_CODBAR
        INTO :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :REFITEM,
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :obsitem
        DO
        BEGIN
        if (ARTICULO = CODBAR) then
            SELECT FIRST 1 COBA_COD FROM barras_articulo WHERE ARTI_COD = :articulo INTO :CODBAR;
        ITEM = ITEM + 1;
        PRNETO = PRUNIT - DTOITMONTO - ((IVAITMONTO+CONSUMO) / CANT);
        TOTCONSUMO = TOTCONSUMO + CONSUMO;
        PRNETO = PRUNIT - DTOITMONTO;
        if (TARIFA = 0) then
            SUMAEX = SUMAEX + TOTAL;
        if (TARIFA = 1) then
            BEGIN
            SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
            IVA1 = IVA1 + IVAITMONTO;
            END
        if (TARIFA = 2) then
            BEGIN
            SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
            IVA2 = IVA2 + IVAITMONTO;
            END
        if (TARIFA = 3) then
            BEGIN
            SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
            IVA3 = IVA3 + IVAITMONTO;
            END
        SUMAGR = SUMA1 + SUMA2 + SUMA3;
        if (IMPTOS = 'N') then
            TOTAL = TOTAL - IVAITMONTO - CONSUMO;
        SUSPEND;
        END
    END
ELSE
    BEGIN
    FOR SELECT D.ARTI_COD, DVDE_CODBAR, SUBSTR(DVDE_DESC,1,60), DVDE_CANT, DVDE_UNIDAD, BODE_COD, DVDE_LOTE, DVDE_PRUNIT, DVDE_DTOPORC, DVDE_DTOMONTO, DVDE_IVAPORC, DVDE_IVAMONTO, DVDE_CONSUMO, DVDE_TOTAL, DVDE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, DVDE_OBS
        FROM DEVOLUCIONES_VENTAS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.DEVT_ID = :ID
        ORDER BY DVDE_ITEM
        INTO :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :REFITEM,
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :obsitem
        DO
        BEGIN
        if (ARTICULO = CODBAR) then
            SELECT FIRST 1 COBA_COD FROM barras_articulo WHERE ARTI_COD = :articulo INTO :CODBAR;
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
        ITEM = ITEM + 1;
        PRNETO = PRUNIT - DTOITMONTO - ((IVAITMONTO+CONSUMO) / CANT);
        TOTCONSUMO = TOTCONSUMO + CONSUMO;
        PRNETO = PRUNIT - DTOITMONTO;
        if (TARIFA = 0) then
            SUMAEX = SUMAEX + TOTAL;
        if (TARIFA = 1) then
            BEGIN
            SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
            IVA1 = IVA1 + IVAITMONTO;
            END
        if (TARIFA = 2) then
            BEGIN
            SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
            IVA2 = IVA2 + IVAITMONTO;
            END
        if (TARIFA = 3) then
            BEGIN
            SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
            IVA3 = IVA3 + IVAITMONTO;
            END
        SUMAGR = SUMA1 + SUMA2 + SUMA3;
        if (IMPTOS = 'N') then
            TOTAL = TOTAL - IVAITMONTO - CONSUMO;
        SUSPEND;
        END
    END
END
^

SET TERM ; ^


/* 06-04 ACTUALICE LOS COSTOS DE LA REMISION RELACIONADA */
INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('COMPRAS', 'FACTURAS', 'ACTUALIZAR COSTOS DE LA REMISION RELACIONADA AL GRABAR LA FACTURA', 'NO', 'SI,NO', 'SI:Al grabar la factura se modifican los costos de la remisin previamente registrada asociada a la factura');
commit work;

SET TERM ^ ;

CREATE OR ALTER TRIGGER FACTCOMP_DETALLE_AI FOR FACTURAS_COMPRAS_DETALLE
ACTIVE AFTER INSERT POSITION 0
AS
declare variable fec date;
declare variable fecaux date;
declare variable aux varchar(90);
declare variable CONC VARCHAR(60);
declare variable factor numeric(18,4);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Nit varchar(20);
declare variable TIPO INTEGER;
declare variable INVFAC CHAR(2);
declare variable IVAINC CHAR(2);
declare variable COSTO NUMERIC(18,2);
declare variable CANTREL NUMERIC(18,4);
declare variable NUMPROV VARCHAR(10);
declare variable NUMPED VARCHAR(30);
declare variable NUMREM VARCHAR(30);
declare variable CONSO VARCHAR(2);
declare variable CONSOLIDA INTEGER;
declare variable NUMROWS INTEGER;
declare variable DTOPIE NUMERIC(18,2);
declare variable ADICIONAL NUMERIC(18,2);
declare variable TOTAL NUMERIC(18,2);
declare variable IVAMONTO NUMERIC(18,2);
declare variable EXTRA NUMERIC(18,2);
declare variable FACT NUMERIC(18,4);
declare variable MENORV CHAR(2);
declare variable ACTREM CHAR(2);
declare variable FECREM date;
declare variable IDREM INTEGER;
declare variable ITEREM INTEGER;
declare variable CANTREM NUMERIC(18,4);
declare variable LOTEREM VARCHAR(15);
declare variable PREFREM CHAR(4);
BEGIN
if ((NEW.faco_id <> 0) and (new.fcde_anulado = 'N')) then
    BEGIN
    select faco_fecha, pref_pre, faco_numero, terc_nit, faco_imptos, faco_numprov, faco_remision, faco_orden, FACO_CONSOLIDA,
        FACO_TOTAL, FACO_EXTRA, FACO_IVAMONTO, FACO_ADICIONAL, FACO_DTOMONTO
        from facturas_compra where faco_id = new.faco_id
        into :fec, :Pref, :Num, :Nit, :ivainc, :numprov, :numrem, :numped, :CONSOLIDA,
        :total, :extra, :ivamonto, :adicional, :dtopie;
    conc = 'FACTURA DE COMPRA No.' || PREF || NUM || '-' || NUMPROV;
    if (NUMREM <> '') then
        BEGIN
        AUX = SUBSTR(NUMREM, 1, 15);
        conc = conc || '-REM:' || AUX;
        END
    else
        if (NUMPED <> '') then
            BEGIN
            AUX = SUBSTR(NUMPED, 1, 15);
            conc = conc || '-ORDEN ' || NUMPED;
            END
    SELECT MAX(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :TIPO;
    if (Tipo is null) then
        Tipo = 0;
    execute procedure lee_configuracion('COMPRAS', 'FACTURAS', 'AFECTAR INVENTARIO CON LA FACTURA') returning_values (:INVFAC);
    execute procedure factor_unidad_cant(new.arti_cod, new.fcde_unidad) returning_values(factor);
    COSTO = ((new.fcde_prunit - NEW.fcde_dtomonto) / :factor);
    if (IVAINC = 'S') then
        COSTO = COSTO / (1 + NEW.fcde_ivaporc/100);
    EXECUTE PROCEDURE lee_configuracion('COMPRAS','FACTURAS','DESCUENTO Y VALOR ADICIONAL DEL DOCUMENTO COMO MENOR VALOR DEL COSTO') returning_values (:MENORV);
    if (MENORV = 'SI') then
        BEGIN
        FACT = (TOTAL - EXTRA - IVAMONTO);
        if ((FACT - ADICIONAL + DTOPIE) <> 0) then
            FACT = FACT / (FACT - ADICIONAL + DTOPIE);
        ELSE
            FACT = 1;
        COSTO = COSTO * FACT;
        END
    /* si se hizo con base en una remision no afecte inventario */
    if (INVFAC = 'SI') then
      if (Tipo <> 22) then
        begin
        INSERT INTO MOVIMIENTO_ARTICULO
          (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
          VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 21, NEW.faco_id,
          :CONC, :factor * new.fcde_cant, :COSTO, 'S', new.fcde_lote, :Pref, :Num, NEW.fcde_item, :Nit);

        if (COSTO > 0 ) then
         BEGIN
          /* ACTUALICE EL COSTO POR PROVEEDOR */
          SELECT PVAR_FECHA FROM PROVEEDOR_ARTICULO
            WHERE TERC_NIT = :Nit AND ARTI_COD = NEW.ARTI_COD
            INTO :FECAUX;
          if (FECAUX IS NULL) then
            INSERT INTO PROVEEDOR_ARTICULO (TERC_NIT, ARTI_COD, PVAR_COSTO, PVAR_FECHA, PVAR_COD,PVAR_DES)
                VALUES (:Nit, NEW.ARTI_COD, :COSTO, :fec, NEW.fcde_codprov,NEW.fcde_desc);
          else
            UPDATE PROVEEDOR_ARTICULO
                SET PVAR_COSTO = :COSTO, PVAR_FECHA = :fec, PVAR_COD = NEW.fcde_codprov
                WHERE ARTI_COD = NEW.ARTI_COD AND TERC_NIT = :Nit;
         END
        /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
        EXECUTE PROCEDURE CALCULA_PRECIOS(NEW.ARTI_COD, :FEC);
        END /* AFECTAR INV */
      else
        BEGIN
        EXECUTE PROCEDURE lee_configuracion('COMPRAS', 'FACTURAS', 'ACTUALIZAR COSTOS DE LA REMISION RELACIONADA AL GRABAR LA FACTURA') returning_values (:ACTREM);
        if (ACTREM = 'SI') then
            BEGIN
            /* SI LOS COSTOS DE LA REMISION ERAN CERO ACTUALICE EL REGISTRO EN MOVIMIENTO_ARTICULO */
            numrows = 0;
            select mvar_cons, MVAR_ITEM, MVAR_FECHA, MVAR_IDREF, MVAR_CANT, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO
                from movimiento_articulo M, consolidado_faltantes C
                where C.cofa_id = :CONSOLIDA AND mvar_tipodoc = 22 and mvar_idref = C.cofa_idori AND C.cofa_tipoori = 22 and m.arti_cod = new.arti_cod
                into :numrows, :iterem, :fecrem, :idrem, :cantrem, :loterem, :prefrem, :numrem;
        
            if (numrows <> 0) then
                BEGIN
                DELETE FROM MOVIMIENTO_ARTICULO WHERE MVAR_CONS = :numrows;
                INSERT INTO MOVIMIENTO_ARTICULO
                  (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
                  VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :fecrem, 22, :idrem,
                  :CONC, :cantrem, :costo, 'S', :loterem, :prefrem, :numrem, :iterem, :Nit);
        
                if (COSTO > 0 ) then
                  BEGIN
                  /* ACTUALICE EL COSTO POR PROVEEDOR */
                  SELECT PVAR_FECHA FROM PROVEEDOR_ARTICULO
                    WHERE TERC_NIT = :Nit AND ARTI_COD = NEW.ARTI_COD
                    INTO :FECAUX;
                  if (FECAUX IS NULL) then
                    INSERT INTO PROVEEDOR_ARTICULO (TERC_NIT, ARTI_COD, PVAR_COSTO, PVAR_FECHA, PVAR_COD,PVAR_DES)
                        VALUES (:Nit, NEW.ARTI_COD, :COSTO, :fec, NEW.fcde_codprov,NEW.fcde_desc);
                  else
                    UPDATE PROVEEDOR_ARTICULO
                        SET PVAR_COSTO = :COSTO, PVAR_FECHA = :fec, PVAR_COD = NEW.fcde_codprov
                        WHERE ARTI_COD = NEW.ARTI_COD AND TERC_NIT = :Nit;
                  END
                /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
                EXECUTE PROCEDURE CALCULA_PRECIOS(NEW.ARTI_COD, :FEC);
                END
            END
        END

    /* ACTUALICE EL PENDIENTE  */
    if (CONSOLIDA <> 0) then
        BEGIN
        UPDATE consolidado_faltantes SET COFA_OK = 'S' WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod;
        EXECUTE procedure LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','SUMAR CANTIDADES PENDIENTES AL CONSOLIDAR DOCUMENTOS') returning_values (CONSO);
        /* IGNORE LA CONSOLIDACION SI SE VALIDAN CODIGOS DE LA ORDEN */
        SELECT MIN(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
        if (NUMROWS = 23) then
            BEGIN
            EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'VERIFICAR CODIGOS DE LA ORDEN') returning_values (MENORV);
            if (MENORV = 'SI') then
                CONSO = 'NO';
            END
        SELECT COUNT(CEFA_ITEM) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
        if ((CONSO = 'SI') AND (NUMROWS > 1)) then
            UPDATE consolidado_faltantes SET COFA_IDDES = NEW.faco_id, COFA_OK = 'S' WHERE COFA_ID = :consolida;
        else
            BEGIN
            /* BUSQUE EL CONSOLIDADO EN EL MISMO ITEM Y SI ES DIFERENTE ACTUALICELO */
            select COFA_CANT * COFA_FACTOR FROM consolidado_faltantes WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod INTO :CANTREL;
            if (NEW.FCDE_CANT * NEW.FCDE_FACTOR < CANTREL) then
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.faco_id, COFA_CANT = NEW.FCDE_CANT, COFA_FACTOR = NEW.FCDE_FACTOR
                    WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod;
            END
        END
    END
END
^

SET TERM ; ^


/* 06-05 */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE EXISTENCIAS_COMPRAS(
    ARTICULO VARCHAR(15),
    FECHA DATE,
    UNIDAD VARCHAR(8))
RETURNS (
    BODEGA VARCHAR(2),
    EXISTENCIA NUMERIC(18,4),
    RESERVADO NUMERIC(18,4),
    ORDENADO NUMERIC(18,4),
    PROMEDIO NUMERIC(18,4),
    VENTAMES NUMERIC(18,4),
    FECHACMP DATE,
    DIAS INTEGER,
    SUGERIDO NUMERIC(18,4),
    STAND VARCHAR(15))
AS
declare variable FACTOR NUMERIC(15,4);
declare variable ORDENC NUMERIC(18,4);
declare variable PEDIDO NUMERIC(18,4);
declare variable ITEM INTEGER;
declare variable ID INTEGER;
declare variable UND VARCHAR(8);
declare variable CANT NUMERIC(18,4);
declare variable FACTOR2 NUMERIC(18,4);
declare variable fecini DATE;
declare variable FECHAAUX VARCHAR(10);
declare variable AGENCIA INTEGER;
declare variable DEVMES NUMERIC(18,2);
declare variable MFAC INTEGER;
declare variable MDEV INTEGER;
declare variable IVAF NUMERIC(18,2);
declare variable IVAD NUMERIC(18,2);
declare variable DIA_ART VARCHAR(2) CHARACTER SET NONE;
declare variable DIASC VARCHAR(255);
declare variable PEDAUTO CHAR(2);
declare variable SALIDAS NUMERIC(18,4);
BEGIN
  for select bode_cod, SUCU_ID from bodega into :bodega, :agencia
    do
    begin
    execute procedure saldo_inventario (:articulo, :bodega, :fecha) returning_values (:Existencia);
    EXECUTE PROCEDURE FACTOR_UNIDAD_CANT(:ARTICULO, :UNIDAD) returning_values (:FACTOR);
    if (FACTOR <> 0) then
        EXISTENCIA = EXISTENCIA / FACTOR;
    else
        EXISTENCIA = 0;
    SELECT MAX(EXIS_STAND) FROM EXISTENCIA WHERE ARTI_COD = :ARTICULO AND BODE_COD = :BODEGA INTO :STAND;
    EXECUTE PROCEDURE promedio_salidas_articulo (:ARTICULO, :FECHA, :BODEGA) returning_values (:PROMEDIO, :SALIDAS);
    EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'PROMEDIAR LAS SALIDAS DEL INVENTARIO CON EL NUMERO DE DIAS ASIGNADO A CADA ARTICULO') returning_values (:DIA_ART);
    if (DIA_ART = 'NO') then
        BEGIN
        EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'NUMERO DE DIAS PARA PROMEDIO DE SALIDAS POR ARTICULO') returning_values (DIASC);
        DIAS = CAST(DIASC AS INTEGER);
        END
    ELSE
        SELECT ARTI_DIAS FROM ARTICULO WHERE ARTI_COD = :ARTICULO INTO :DIAS;
    if (DIAS is null) then
        DIAS = 0;
    PROMEDIO = DIAS * PROMEDIO;
    if (FACTOR <> 0) then
        PROMEDIO = PROMEDIO / FACTOR;
    SUGERIDO = PROMEDIO - EXISTENCIA;
    SELECT SUM(ORID_ENTREGAR)
      FROM ORDENINVENTARIO_DETALLE OD, ordenes_inventario O
      WHERE O.ORIN_ID = OD.ORIN_ID AND ARTI_COD = :ARTICULO AND ORIN_FECHA <= :FECHA AND ORIN_FECLLEGA >= :FECHA AND ORID_ANULADO = 'N' AND OD.BODE_COD = :BODEGA
      INTO :ORDENADO;
    if (ORDENADO IS NULL) then
        ORDENADO = 0;
    ORDENC = 0;
    FOR SELECT O.ORDC_ID, OCDE_ITEM, OCDE_CANT * OCDE_FACTOR
        FROM ORDENES_COMPRA O, ORDENES_COMPRA_DETALLE OD
        WHERE O.ORDC_ID = OD.ORDC_ID AND OD.ARTI_COD = :ARTICULO AND (ORDC_FECHA+ORDC_VALIDEZ) >= :FECHA AND ORDC_FECHA <= :FECHA AND OCDE_ANULADO = 'N' AND OD.BODE_COD = :BODEGA
        INTO :ID, :ITEM, :CANT
        do
        BEGIN
        EXECUTE PROCEDURE FALTANTE(23, 21, ID, ITEM) returning_values (PEDIDO, UND, FACTOR2);
        if (PEDIDO * FACTOR2 = CANT) then /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */
            EXECUTE PROCEDURE FALTANTE(23, 22, ID, ITEM) returning_values (PEDIDO, UND, FACTOR2);
        if (PEDIDO IS NULL) then
            PEDIDO = 0;
        ORDENC = ORDENC + PEDIDO * FACTOR2;
        END
    ORDENADO = ORDENADO + ORDENC;
    if (FACTOR <> 0) then
        ORDENADO = ORDENADO / FACTOR;
    SELECT SUM(RSDE_LIBERAR)
      FROM RESERVAS_DETALLE RD, RESERVAS R
      WHERE R.RESE_ID = RD.RESE_ID AND ARTI_COD = :ARTICULO AND RESE_FECHA <= :FECHA AND RESE_VENCE >= :FECHA AND RD.BODE_COD = :BODEGA AND RSDE_ANULADO = 'N'
      INTO :RESERVADO;
    if (RESERVADO IS NULL) then
        RESERVADO = 0;
    PEDIDO = 0;
    FOR SELECT P.PEDI_ID, PEDE_ITEM, PEDE_CANT * PEDE_FACTOR
        FROM PEDIDOS P, PEDIDOS_DETALLE PD
        WHERE P.PEDI_ID = PD.PEDI_ID AND PD.ARTI_COD = :ARTICULO AND (PEDI_FECHA+PEDI_VALIDEZ) >= :FECHA AND PEDI_FECHA <= :FECHA AND PEDE_ANULADO = 'N' AND BODE_COD = :BODEGA
        INTO :ID, :ITEM, :CANT
        do
        BEGIN
        EXECUTE PROCEDURE FALTANTE(34, 31, ID, ITEM) returning_values (ORDENC, UND, FACTOR2);
        EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'FACTURAS', 'GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') returning_values (pedauto);
        if ((ORDENC * FACTOR2 = CANT) or (PEDAUTO = 'SI')) then /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */
            EXECUTE PROCEDURE FALTANTE(34, 32, ID, ITEM) returning_values (ORDENC, UND, FACTOR2);
        if (ORDENC IS NULL) then
            ORDENC = 0;
        PEDIDO = PEDIDO + ORDENC * FACTOR2;
        END
    RESERVADO = RESERVADO + PEDIDO;
    if (FACTOR <> 0) then
        RESERVADO = RESERVADO / FACTOR;
    /* VENTAS MES */
    FECHAAUX = CAST (FECHA AS VARCHAR(10));
    FECHAAUX = SUBSTR(FECHAAUX, 1, 7) || '/01';
    FECINI = CAST (FECHAAUX AS DATE);
    EXECUTE PROCEDURE ventas_articulo (:ARTICULO, :FECINI, :FECHA, :agencia) returning_values (:ventames, :mfac, :devmes, :mdev, :ivaf, :ivad);
    ventames = ventames - devmes;
    if (FACTOR <> 0) then
        ventames = ventames / FACTOR;
    /* FECHA COMPRA */
    SELECT MAX(FACO_FECHA) FROM FACTURAS_COMPRA F, FACTURAS_COMPRAS_DETALLE D
        WHERE F.FACO_ID = D.faco_id AND D.ARTI_COD = :articulo AND FACO_FECHA <= :FECHA AND D.bode_cod = :BODEGA
        INTO :fechacmp;
    SUSPEND;
    end
END
^

SET TERM ; ^


/* 06-06 consolidacion de formas de pago */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE CAMBIE_ID_CONSOLFP
RETURNS (
    ID INTEGER)
AS
begin
ID = GEN_ID(ID_CONSOLIDA, 1);
suspend;
end
^

SET TERM ; ^


grant EXECUTE on PROCEDURE CAMBIE_ID_CONSOLFP to PUBLIC;
grant select, delete, insert, update on consolide_formasp to public;

/* 06-07 */
GRANT INSERT ON PUNTOS_VENDEDOR TO TRIGGER RECIBOS_CAJA_DETALLE_AI;
GRANT INSERT, DELETE ON PUNTOS_VENDEDOR TO TRIGGER RECIBOS_CAJA_DETALLE_AU;
GRANT DELETE ON PUNTOS_VENDEDOR TO TRIGGER RECIBOS_CAJA_DETALLE_AD;

GRANT INSERT ON PUNTOS_VENDEDOR TO TRIGGER puntos_vend_redencion_ai;
GRANT INSERT, DELETE ON PUNTOS_VENDEDOR TO TRIGGER puntos_vend_redencion_au;
GRANT DELETE ON PUNTOS_VENDEDOR TO TRIGGER puntos_vend_redencion_ad;

grant select on puntos_vendedor TO PROCEDURE consulta_puntos_vendedor;
grant select on puntos_vendedor TO PROCEDURE chequeo_puntos_vendedor;

GRANT SELECT ON comisiones_puntos TO TRIGGER RECIBOS_CAJA_DETALLE_AI;
GRANT SELECT ON comisiones_puntos TO TRIGGER RECIBOS_CAJA_DETALLE_AU;

SET TERM ^ ;

CREATE OR ALTER TRIGGER TI_DEVOLUCION_CHEQUES FOR DEVOLUCION_CHEQUES
ACTIVE BEFORE INSERT POSITION 0
AS
DECLARE VARIABLE NUMROWS INTEGER;
declare variable POR_CTA CHAR(2);
BEGIN
    /*  PARENT 'PREFIJOS_BANCOS' MUST EXIST WHEN INSERTING A CHILD IN 'DEVOLUCION_CHEQUES'  */
    IF (NEW.CUBA_COD IS NOT NULL AND
        NEW.PRBA_PREF IS NOT NULL) THEN
    BEGIN
    EXECUTE PROCEDURE LEE_configuracion('BANCOS', 'DEVOLUCIONES', 'CONSECUTIVOS POR CUENTA') returning_values(:POR_CTA);
    if (por_cta = 'SI') then
        BEGIN
        SELECT COUNT(*)
        FROM   PREFIJOS_BANCOS
        WHERE  PREFIJOS_BANCOS.CUBA_COD = NEW.CUBA_COD
         AND   PREFIJOS_BANCOS.TIDO_COD = 77
         AND   PREFIJOS_BANCOS.PRBA_PREF = NEW.PRBA_PREF
        INTO   :NUMROWS;
        IF (NUMROWS = 0) THEN
           BEGIN
           EXCEPTION PREFIJOBANCO_NO_EXISTE;
           END
        END
    END
    /*  PARENT 'CLIENTES' MUST EXIST WHEN INSERTING A CHILD IN 'DEVOLUCION_CHEQUES'  */
    IF (NEW.TERC_NIT IS NOT NULL) THEN
    BEGIN
       SELECT COUNT(*)
       FROM   TERCEROS
       WHERE  TERCEROS.TERC_NIT = NEW.TERC_NIT
       INTO   :NUMROWS;
       IF (NUMROWS = 0) THEN
       BEGIN
          EXCEPTION TERCERO_NO_EXISTE;
       END
    END
END
^

SET TERM ; ^


/* 06-08 no permita repetir codigo de cuenta */
alter table CUENTAS_BANCO
add constraint UNQ1_CUENTAS_BANCO
unique (CUBA_CODCTA);

/* 06-09 SUCURSAL EN EL DETALLE DEL RECIBO Y NO EN EL ENCABEZADO */

ALTER TABLE RECIBOS_CAJA_DETALLE
ADD RCDE_SUCURSAL VARCHAR(10)
NOT NULL ;

SET TERM ^ ;

create trigger RECIBOS_CAJA_DETALLE_BU for RECIBOS_CAJA_DETALLE
active BEFORE UPDATE position 0
as
begin
if (NEW.rcde_sucursal IS NULL) then
    NEW.rcde_sucursal = '01';
end
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON RECIBOS_CAJA_DETALLE TO TRIGGER RECIBOS_CAJA_DETALLE_BU;

ALTER TRIGGER RECIBOS_CAJA_DETALLE_AU INACTIVE;
UPDATE RECIBOS_CAJA_DETALLE D SET RCDE_SUCURSAL = (SELECT RECA_SUCURSAL FROM RECIBOS_CAJA R WHERE RECA_ID = D.reca_id);
COMMIT WORK;
ALTER TRIGGER RECIBOS_CAJA_DETALLE_AU ACTIVE;

SET TERM ^ ;

CREATE OR ALTER TRIGGER RECIBOS_CAJA_DETALLE_AI FOR RECIBOS_CAJA_DETALLE
ACTIVE AFTER INSERT POSITION 0
AS
declare variable EXISTE CHAR(1);
declare variable FEC DATE;
declare variable NIT VARCHAR(20);
declare variable CONCEPTO VARCHAR(60);
declare variable PREFIJO VARCHAR(4);
declare variable NUMERO VARCHAR(6);
declare variable SALDO NUMERIC(18,2);
declare variable RETES CHAR(2);
declare variable OK CHAR(1);
declare variable RCANTI INTEGER;
declare variable COBR INTEGER;
declare variable ACUMULA CHAR(2);
declare variable DIASMAX INTEGER;
declare variable FACTOR NUMERIC(9,4);
declare variable FACTORD NUMERIC(9,4);
declare variable DIAS INTEGER;
declare variable FECDOC DATE;
BEGIN
if ((NEW.RECA_ID <> 0) and (new.rcde_anulado = 'N')) then
    BEGIN
    /* Abone el documento referenciado */
    select PREF_PRE, RECA_NUMERO, RECA_fecha, RECA_CONC, TERC_NIT, COBR_COD from RECIBOS_CAJA
        where RECA_id = new.RECA_id into :PREFIJO, :NUMERO, :FEC, :CONCEPTO, :NIT, :COBR;
    OK = 'N';
    if (new.RCDE_TIPODOC = 45) then
        BEGIN
        /* BUSQUE SI TIENE RECA_ID, SI NO LO ACTUALIZA */
        SELECT RECA_ID FROM ANTICIPOS_CLIENTE WHERE ANCL_ID = NEW.RCDE_IDDOC INTO :RCANTI;
        if (RCANTI = 0) then
            BEGIN
            OK = 'S';
            UPDATE ANTICIPOS_CLIENTE SET RECA_ID = NEW.RECA_ID WHERE ANCL_ID = NEW.RCDE_IDDOC;
            END
        END
    if (OK = 'N') then
        BEGIN
        /* valide que no se pase del saldo */
        execute procedure saldo_doc_cartera(new.rcde_tipodoc, new.rcde_iddoc, '9999/12/31') returning_values(saldo);
        execute procedure lee_configuracion('CARTERA', 'SALDOS', 'DESCONTAR RETENCIONES POR CAUSACION') returning_values (RETES);
        if (SALDO < 0) then
            BEGIN
            if (RETES = 'SI') then
                begin
                if (saldo > (NEW.rcde_abono + NEW.rcde_dtof)) then
                    EXCEPTION DOCUMENTO_ABONO_MAYOR;
                end
            ELSE
                begin
                if (saldo > (NEW.rcde_abono + NEW.rcde_rtfte + NEW.rcde_rtiva + NEW.rcde_rtica + NEW.rcde_dtof)) then
                    EXCEPTION DOCUMENTO_ABONO_MAYOR;
                end
            END
        else
            BEGIN
            if (RETES = 'SI') then
                begin
                if (saldo < (NEW.rcde_abono + NEW.rcde_dtof)) then
                    EXCEPTION DOCUMENTO_ABONO_MAYOR;
                end
            ELSE
                begin
                if (saldo < (NEW.rcde_abono + NEW.rcde_rtfte + NEW.rcde_rtiva + NEW.rcde_rtica + NEW.rcde_dtof)) then
                    EXCEPTION DOCUMENTO_ABONO_MAYOR;
                end
            END
        EXISTE = 'N';
        select 'S' from saldos_doc_cartera where sdca_tiporef = new.rcde_tipodoc and sdca_idref = new.rcde_iddoc and sdca_fecha = :FEC into :EXISTE;
        if (Existe = 'S') then
            begin
            /* actualice el saldo del dia */
            UPDATE saldos_doc_cartera
                SET SDCA_ABONO = SDCA_ABONO + NEW.rcde_abono + new.rcde_dtof,
                SDCA_ABRTFTE = SDCA_ABRTFTE + NEW.rcde_RTFTE,
                SDCA_ABRTIVA = SDCA_ABRTIVA + NEW.rcde_RTIVA,
                SDCA_ABRTICA = SDCA_ABRTICA + NEW.rcde_RTICA
                WHERE SDCA_TIPOREF = NEW.RCDE_TIPODOC AND SDCA_IDREF = NEW.rcde_IDDOC AND SDCA_FECHA = :FEC;
            END
        ELSE
            BEGIN
            /* Inserte un nuevo saldo diario */
            INSERT INTO SALDOS_DOC_CARTERA (SDCA_TIPOREF, SDCA_IDREF, SDCA_FECHA, TERC_NIT, SDCA_RTFTE, SDCA_RTIVA, SDCA_RTICA, SDCA_ABONO, SDCA_ABRTFTE, SDCA_ABRTIVA, SDCA_ABRTICA, SDCA_DEBITO, SDCA_MONTO)
                VALUES (NEW.RCDE_TIPODOC, NEW.RCDE_IDDOC, :FEC, :NIT, 0, 0, 0, (NEW.rcde_abono+NEW.rcde_dtof), NEW.rcde_rtfte, NEW.rcde_rtiva, NEW.rcde_rtica, 'N', 0);
            END
        END
    /* actualice el registro en mov_cliente (por si son varios items) */
    EXISTE = 'N';
    SELECT 'S' FROM MOVIMIENTO_CLIENTES WHERE MVCL_TIPOREF = 61 AND MVCL_IDREF = NEW.RECA_ID AND MVCL_SUCURSAL = NEW.rcde_sucursal INTO :EXISTE;
    if (EXISTE = 'S') then
        begin
        UPDATE movimiento_clientes
            SET MVCL_MONTO = MVCL_MONTO + NEW.rcde_abono + NEW.rcde_dtof,
                MVCL_RTEFTE = MVCL_RTEFTE + NEW.rcde_rtfte,
                MVCL_RTEIVA = MVCL_RTEIVA + NEW.rcde_rtiva,
                MVCL_RTEICA = MVCL_RTEICA + NEW.rcde_rtica
            WHERE MVCL_TIPOREF = 61 AND MVCL_IDREF = NEW.RECA_ID AND MVCL_SUCURSAL = NEW.rcde_sucursal;
        end
    ELSE
        INSERT INTO MOVIMIENTO_CLIENTES (MVCL_ID, TERC_NIT, MVCL_TIPOREF, MVCL_IDREF, MVCL_FECHA, MVCL_VENCE, MVCL_CONC, MVCL_MONTO, MVCL_RTEFTE, MVCL_RTEIVA, MVCL_RTEICA, MVCL_DEBITO, MVCL_ABONO, MVCL_PREFREF, MVCL_NUMREF, MVCL_SUCURSAL, COBR_COD)
            VALUES (GEN_ID(ID_MOVCLI, 1), :NIT, 61, NEW.RECA_ID, :FEC, :FEC, :CONCEPTO, (NEW.RCDE_ABONO+NEW.RCDE_DTOF), NEW.RCDE_RTFTE, NEW.RCDE_RTIVA, NEW.RCDE_RTICA, 'N', 'S', :PREFIJO, :NUMERO, NEW.rcde_sucursal, :COBR);

    /* acumule los puntos del vendedor */
    SELECT MVCL_FECHA FROM MOVIMIENTO_CLIENTES WHERE MVCL_TIPOREF = new.rcde_tipodoc AND MVCL_IDREF = new.rcde_iddoc
        INTO :FECDOC;
    if (FECDOC IS NOT NULL) then
        DIAS = FEC - FECDOC;
    else
        DIAS = 999;
    execute procedure lee_configuracion('FACTURACION', 'FACTURAS', 'ACUMULAR PUNTOS DE VENTAS POR VENDEDOR') returning_values (ACUMULA);
    execute procedure lee_configuracion('FACTURACION', 'FACTURAS', 'DIAS DE RECAUDO MAXIMO PARA ACUMULAR PUNTOS AL VENDEDOR') returning_values (DIASMAX);
    if ((acumula = 'SI') and (diasmax >= dias)) then
        begin
        SELECT COPU_FACTOR FROM comisiones_puntos WHERE COPU_COD = NEW.rcde_comip INTO :FACTOR;
        if ((NEW.rcde_tipodoc = 31) or (NEW.rcde_tipodoc = 41)) then
            begin
            /* recorra la factura acumulando los puntos */
            if (new.rcde_tipodoc = 31) then
                select (fact_total-fact_ivamonto)/fact_total from facturas where fact_id = new.rcde_iddoc into :factord;
            if (new.rcde_tipodoc = 41) then
                select ndcl_monto/(ndcl_monto+ndcl_ivamonto) from notas_debito_clientes where ndcl_id = new.rcde_iddoc into :factord;
            /* inserte el registro de puntos */
            insert into puntos_vendedor (vend_cod, ptvt_fecha, ptvt_tipodoc, ptvt_iddoc, ptvt_db, ptvt_cr)
                values (:cobr, :fec, new.rcde_tipodoc, new.rcde_iddoc, (new.rcde_abono*:factord*:factor), 0);
            end
        if ((new.rcde_tipodoc = 33) or (new.rcde_tipodoc = 42)) then
            begin
            if (new.rcde_tipodoc = 33) then
                select (devt_total-devt_ivamonto)/devt_total from devoluciones_ventas where devt_id = new.rcde_iddoc into :factord;
            if (new.rcde_tipodoc = 42) then
                select nccl_monto/(nccl_monto+nccl_ivamonto) from notas_credito_clientes where nccl_id = new.rcde_iddoc into :factord;
            /* inserte el registro de puntos */
            insert into puntos_vendedor (vend_cod, ptvt_fecha, ptvt_tipodoc, ptvt_iddoc, ptvt_db, ptvt_cr)
                values (:cobr, :fec, new.rcde_tipodoc, new.rcde_iddoc, 0, (new.rcde_abono*:factord*:factor));
            end
        end
    end
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER TRIGGER RECIBOS_CAJA_DETALLE_AU FOR RECIBOS_CAJA_DETALLE
ACTIVE AFTER UPDATE POSITION 0
AS
declare variable EXISTE CHAR(1);
declare variable FEC DATE;
declare variable NIT VARCHAR(20);
declare variable CONCEPTO VARCHAR(60);
declare variable PREFIJO VARCHAR(4);
declare variable NUMERO VARCHAR(6);
declare variable SALDO NUMERIC(18,2);
declare variable RETES char(2);
declare variable OK CHAR(1);
declare variable RCANTI INTEGER;
declare variable COBR INTEGER;
declare variable ACUMULA CHAR(2);
declare variable DIASMAX INTEGER;
declare variable FACTOR NUMERIC(9,4);
declare variable FACTORD NUMERIC(9,4);
declare variable DIAS INTEGER;
declare variable FECDOC DATE;
BEGIN
execute procedure lee_configuracion('FACTURACION', 'FACTURAS', 'ACUMULAR PUNTOS DE VENTAS POR VENDEDOR') returning_values (ACUMULA);
select PREF_PRE, RECA_NUMERO, reca_fecha, RECA_CONC, TERC_NIT, COBR_COD
    from recibos_caja
    where reca_id = new.reca_id
    into :PREFIJO, :NUMERO, :FEC, :CONCEPTO, :NIT, :COBR;
/* Borre el viejo */
if ((old.RECA_ID <> 0) AND (OLD.rcde_anulado = 'N')) then
    BEGIN
    OK = 'N';
    if (OLD.RCDE_TIPODOC = 45) then
        BEGIN
        SELECT RECA_ID FROM ANTICIPOS_CLIENTE WHERE ANCL_ID = OLD.RCDE_IDDOC INTO :RCANTI;
        if (RCANTI = OLD.RECA_ID) then
            begin
            OK = 'S';
            if (NEW.rcde_anulado = 'N') then
                delete from anticipos_cliente where ANCL_ID = OLD.RCDE_IDDOC;
            else
                UPDATE anticipos_cliente SET ANCL_ANULADO = 'S' where ANCL_ID = OLD.RCDE_IDDOC;
            end
        END
    if (OK = 'N') then
        BEGIN
        UPDATE saldos_doc_cartera
            SET SDCA_ABONO = SDCA_ABONO - old.rcde_abono - OLD.RCDE_DTOF,
            SDCA_ABRTFTE = SDCA_ABRTFTE - old.rcde_RTFTE,
            SDCA_ABRTIVA = SDCA_ABRTIVA - old.rcde_RTIVA,
            SDCA_ABRTICA = SDCA_ABRTICA - old.rcde_RTICA
            WHERE SDCA_TIPOREF = old.RCDE_TIPODOC AND SDCA_IDREF = old.rcde_IDDOC AND SDCA_FECHA = :FEC;
        END
    UPDATE movimiento_clientes
        SET MVCL_MONTO = MVCL_MONTO - OLD.rcde_abono - OLD.RCDE_DTOF,
        MVCL_RTEFTE = MVCL_RTEFTE - OLD.rcde_rtfte,
        MVCL_RTEIVA = MVCL_RTEIVA - OLD.rcde_rtiva,
        MVCL_RTEICA = MVCL_RTEICA - OLD.rcde_rtica
        WHERE MVCL_TIPOREF = 61 AND MVCL_IDREF = OLD.RECA_ID;

    /* DESHAGA LOS PUNTOS DEL VENDEDOR */
    if (acumula = 'SI') then
        delete from puntos_vendedor where vend_cod = :cobr and ptvt_tipodoc = old.rcde_tipodoc and ptvt_iddoc = old.rcde_iddoc and ptvt_fecha = :fec;
    END
if ((NEW.RECA_ID <> 0) and (NEW.rcde_anulado = 'N')) then
    BEGIN
    OK = 'N';
    if (new.RCDE_TIPODOC = 45) then
        BEGIN
        /* BUSQUE SI TIENE RECA_ID, SI NO LO ACTUALIZA */
        SELECT RECA_ID FROM ANTICIPOS_CLIENTE WHERE ANCL_ID = NEW.RCDE_IDDOC INTO :RCANTI;
        if (RCANTI = 0) then
            BEGIN
            OK = 'S';
            UPDATE ANTICIPOS_CLIENTE SET RECA_ID = NEW.RECA_ID WHERE ANCL_ID = NEW.RCDE_IDDOC;
            END
        END
    if (OK = 'N') then
        BEGIN
        /* valide que no se pase del saldo */
        execute procedure saldo_doc_cartera(new.rcde_tipodoc, new.rcde_iddoc, '9999/12/31') returning_values(saldo);
        execute procedure lee_configuracion('CARTERA', 'SALDOS', 'DESCONTAR RETENCIONES POR CAUSACION') returning_values (RETES);
        if (SALDO < 0) then
            BEGIN
            if (RETES = 'SI') then
                begin
                if (saldo > (NEW.rcde_abono + NEW.rcde_dtof)) then
                    EXCEPTION DOCUMENTO_ABONO_MAYOR;
                end
            ELSE
                begin
                if (saldo > (NEW.rcde_abono + NEW.rcde_rtfte + NEW.rcde_rtiva + NEW.rcde_rtica + NEW.rcde_dtof)) then
                    EXCEPTION DOCUMENTO_ABONO_MAYOR;
                end
            END
        else
            BEGIN
            if (RETES = 'SI') then
                begin
                if (saldo < (NEW.rcde_abono + NEW.rcde_dtof)) then
                    EXCEPTION DOCUMENTO_ABONO_MAYOR;
                end
            ELSE
                begin
                if (saldo < (NEW.rcde_abono + NEW.rcde_rtfte + NEW.rcde_rtiva + NEW.rcde_rtica + NEW.rcde_dtof)) then
                    EXCEPTION DOCUMENTO_ABONO_MAYOR;
                end
            END
        select 'S' from saldos_doc_cartera where sdca_tiporef = new.rcde_tipodoc and sdca_idref = new.rcde_iddoc and sdca_fecha = :FEC into :EXISTE;
        if (Existe = 'S') then
            /* actualice el saldo del dia */
            UPDATE saldos_doc_cartera
                SET SDCA_ABONO = SDCA_ABONO + NEW.rcde_abono + NEW.RCDE_DTOF,
                    SDCA_ABRTFTE = SDCA_ABRTFTE + NEW.rcde_RTFTE,
                    SDCA_ABRTIVA = SDCA_ABRTIVA + NEW.rcde_RTIVA,
                    SDCA_ABRTICA = SDCA_ABRTICA + NEW.rcde_RTICA
                WHERE SDCA_TIPOREF = NEW.RCDE_TIPODOC AND SDCA_IDREF = NEW.rcde_IDDOC AND SDCA_FECHA = :FEC;
        ELSE
            /* Inserte un nuevo saldo diario */
            INSERT INTO SALDOS_DOC_CARTERA (SDCA_TIPOREF, SDCA_IDREF, SDCA_FECHA, TERC_NIT, SDCA_RTFTE, SDCA_RTIVA, SDCA_RTICA, SDCA_ABONO, SDCA_ABRTFTE, SDCA_ABRTIVA, SDCA_ABRTICA, SDCA_DEBITO, SDCA_MONTO)
                VALUES (NEW.RCDE_TIPODOC, NEW.RCDE_IDDOC, :FEC, :NIT, 0, 0, 0, (NEW.rcde_abono+NEW.RCDE_DTOF), NEW.rcde_rtfte, NEW.rcde_rtiva, NEW.rcde_rtica, 'N', 0);
        END /* OK = N */
    /* Registre o actualice el registro en movimiento_cliente */
    EXISTE = 'N';
    SELECT 'S' FROM MOVIMIENTO_CLIENTES WHERE MVCL_TIPOREF = 61 AND MVCL_IDREF = NEW.RECA_ID and mvcl_sucursal = new.rcde_sucursal INTO :EXISTE;
    if (EXISTE = 'S') then
        begin
        /* Deshaga el viejo */
        if (old.RECA_ID <> 0) then
            UPDATE movimiento_clientes
                SET MVCL_MONTO = MVCL_MONTO - OLD.rcde_abono - OLD.rcde_dtof,
                    MVCL_RTEFTE = MVCL_RTEFTE - OLD.rcde_rtfte,
                    MVCL_RTEIVA = MVCL_RTEIVA - OLD.rcde_rtiva,
                    MVCL_RTEICA = MVCL_RTEICA - OLD.rcde_rtica
                WHERE MVCL_TIPOREF = 61 AND MVCL_IDREF = NEW.RECA_ID AND MVCL_SUCURSAL = NEW.rcde_sucursal;
        /* Actualice el nuevo */
        UPDATE movimiento_clientes
            SET MVCL_MONTO = MVCL_MONTO + NEW.rcde_abono + NEW.rcde_dtof,
                MVCL_RTEFTE = MVCL_RTEFTE + NEW.rcde_rtfte,
                MVCL_RTEIVA = MVCL_RTEIVA + NEW.rcde_rtiva,
                MVCL_RTEICA = MVCL_RTEICA + NEW.rcde_rtica
            WHERE MVCL_TIPOREF = 61 AND MVCL_IDREF = NEW.RECA_ID AND MVCL_SUCURSAL = NEW.rcde_sucursal;
        end
    ELSE
        INSERT INTO MOVIMIENTO_CLIENTES (MVCL_ID, TERC_NIT, MVCL_TIPOREF, MVCL_IDREF, MVCL_FECHA, MVCL_VENCE, MVCL_CONC, MVCL_MONTO, MVCL_RTEFTE, MVCL_RTEIVA, MVCL_RTEICA, MVCL_DEBITO, MVCL_ABONO, MVCL_PREFREF, MVCL_NUMREF, MVCL_SUCURSAL, COBR_COD)
            VALUES (GEN_ID(ID_MOVCLI, 1), :NIT, 61, NEW.RECA_ID, :FEC, :FEC, :CONCEPTO, (NEW.RCDE_ABONO+NEW.RCDE_DTOF), NEW.RCDE_RTFTE, NEW.RCDE_RTIVA, NEW.RCDE_RTICA, 'N', 'S', :PREFIJO, :NUMERO, NEW.rcde_sucursal, :COBR);

    /* acumule los puntos del vendedor */
    SELECT MVCL_FECHA FROM MOVIMIENTO_CLIENTES WHERE MVCL_TIPOREF = new.rcde_tipodoc AND MVCL_IDREF = new.rcde_iddoc
        INTO :FECDOC;
    if (FECDOC IS NOT NULL) then
        DIAS = FEC - FECDOC;
    else
        DIAS = 999;
    execute procedure lee_configuracion('FACTURACION', 'FACTURAS', 'DIAS DE RECAUDO MAXIMO PARA ACUMULAR PUNTOS AL VENDEDOR') returning_values (DIASMAX);
    if ((acumula = 'SI') and (diasmax >= dias)) then
        begin
        SELECT COPU_FACTOR FROM comisiones_puntos WHERE COPU_COD = NEW.rcde_comip INTO :FACTOR;
        if ((NEW.rcde_tipodoc = 31) or (NEW.rcde_tipodoc = 41)) then
            begin
            /* recorra la factura acumulando los puntos */
            if (new.rcde_tipodoc = 31) then
                select (fact_total-fact_ivamonto)/fact_total from facturas where fact_id = new.rcde_iddoc into :factord;
            if (new.rcde_tipodoc = 41) then
                select ndcl_monto/(ndcl_monto+ndcl_ivamonto) from notas_debito_clientes where ndcl_id = new.rcde_iddoc into :factord;
            /* inserte el registro de puntos */
            insert into puntos_vendedor (vend_cod, ptvt_fecha, ptvt_tipodoc, ptvt_iddoc, ptvt_db, ptvt_cr)
                values (:cobr, :fec, new.rcde_tipodoc, new.rcde_iddoc, (new.rcde_abono*:factord*:factor), 0);
            end
        if ((new.rcde_tipodoc = 33) or (new.rcde_tipodoc = 42)) then
            begin
            if (new.rcde_tipodoc = 33) then
                select (devt_total-devt_ivamonto)/devt_total from devoluciones_ventas where devt_id = new.rcde_iddoc into :factord;
            if (new.rcde_tipodoc = 42) then
                select nccl_monto/(nccl_monto+nccl_ivamonto) from notas_credito_clientes where nccl_id = new.rcde_iddoc into :factord;
            /* inserte el registro de puntos */
            insert into puntos_vendedor (vend_cod, ptvt_fecha, ptvt_tipodoc, ptvt_iddoc, ptvt_db, ptvt_cr)
                values (:cobr, :fec, new.rcde_tipodoc, new.rcde_iddoc, 0, (new.rcde_abono*:factord*:factor));
            end
        end
    END /* NUEVO */
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER TRIGGER RECIBOS_CAJA_DETALLE_AD FOR RECIBOS_CAJA_DETALLE
ACTIVE AFTER DELETE POSITION 0
AS
declare variable FEC DATE;
declare variable OK CHAR(1);
declare variable RCANTI INTEGER;
declare variable ACUMULA CHAR(2);
declare variable COBR INTEGER;
BEGIN
if (old.RECA_ID <> 0) then
    BEGIN
    execute procedure lee_configuracion('FACTURACION', 'FACTURAS', 'ACUMULAR PUNTOS DE VENTAS POR VENDEDOR') returning_values (ACUMULA);
    select reca_fecha, COBR_COD from recibos_caja where reca_id = OLD.reca_id into :FEC, :COBR;
    OK = 'N';
    if (OLD.RCDE_TIPODOC = 45) then
        BEGIN
        SELECT RECA_ID FROM ANTICIPOS_CLIENTE WHERE ANCL_ID = OLD.RCDE_IDDOC INTO :RCANTI;
        if (RCANTI = OLD.RECA_ID) then
            begin
            OK = 'S';
            delete from anticipos_cliente where ANCL_ID = OLD.RCDE_IDDOC;
            end
        END
    if (OLD.rcde_anulado = 'N') then
     begin
       if (OK = 'N') then
        BEGIN
        UPDATE saldos_doc_cartera
            SET SDCA_ABONO = SDCA_ABONO - old.rcde_abono - OLD.RCDE_DTOF,
            SDCA_ABRTFTE = SDCA_ABRTFTE - old.rcde_RTFTE,
            SDCA_ABRTIVA = SDCA_ABRTIVA - old.rcde_RTIVA,
            SDCA_ABRTICA = SDCA_ABRTICA - old.rcde_RTICA
            WHERE SDCA_TIPOREF = old.RCDE_TIPODOC AND SDCA_IDREF = old.rcde_IDDOC AND SDCA_FECHA = :FEC;
        END
       UPDATE movimiento_clientes
        SET MVCL_MONTO = MVCL_MONTO - OLD.rcde_abono - OLD.RCDE_DTOF,
        MVCL_RTEFTE = MVCL_RTEFTE - OLD.rcde_rtfte,
        MVCL_RTEIVA = MVCL_RTEIVA - OLD.rcde_rtiva,
        MVCL_RTEICA = MVCL_RTEICA - OLD.rcde_rtica
        WHERE MVCL_TIPOREF = 61 AND MVCL_IDREF = OLD.RECA_ID and MVCL_SUCURSAL = OLD.rcde_sucursal;
     end
    /* DESHAGA LOS PUNTOS DEL VENDEDOR */
    if (acumula = 'SI') then
        delete from puntos_vendedor where vend_cod = :cobr and ptvt_tipodoc = old.rcde_tipodoc and ptvt_iddoc = old.rcde_iddoc and ptvt_fecha = :fec;
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE CAMBIA_CLIENTE(
    ANTES VARCHAR(20),
    NUEVO VARCHAR(20))
RETURNS (
    TIPODOC INTEGER,
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6))
AS
declare variable CONC VARCHAR(90);
declare variable FECHA DATE;
declare variable VENCE DATE;
declare variable RTFTEMONTO NUMERIC(18,2);
declare variable RTIVAMONTO NUMERIC(18,2);
declare variable RTICAMONTO NUMERIC(18,2);
declare variable TOTAL NUMERIC(18,2);
declare variable TIPOAB integer;
declare variable IDAB integer;
declare variable MONTOAB integer;
declare variable EXISTE CHAR(1);
declare variable SUCURSAL VARCHAR(10);
begin
delete from saldos_doc_cartera where TERC_NIT = :ANTES;
delete from movimiento_clientes where TERC_NIT = :ANTES;
TIPODOC = 31;
FOR SELECT FACT_ID, PREF_PRE, FACT_NUMERO, FACT_FECHA, FACT_VENCE, FACT_RTFTEMONTO, FACT_RTIVAMONTO, FACT_RTICAMONTO, FACT_TOTAL, FACT_SUCURSAL
    FROM FACTURAS WHERE TERC_NIT = :antes AND FACT_ANULADO = 'N' AND FACT_ID <> 0 ORDER BY FACT_FECHA
    INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :RTFTEMONTO, :RTIVAMONTO, :RTICAMONTO, :TOTAL, :SUCURSAL
    DO
    BEGIN
    /* Registre el nuevo saldo del documento */
    INSERT INTO SALDOS_DOC_CARTERA (SDCA_TIPOREF, SDCA_IDREF, SDCA_FECHA, TERC_NIT, SDCA_RTFTE, SDCA_RTIVA, SDCA_RTICA, SDCA_ABONO, SDCA_ABRTFTE, SDCA_ABRTIVA, SDCA_ABRTICA, SDCA_DEBITO, SDCA_MONTO)
        VALUES (31, :ID, :fecha, :NUEVO, :rtftemonto, :rtivamonto, :rticamonto, 0, 0, 0, 0, 'S', :TOTAL);
    CONC = 'FACTURA DE VENTA No.' || :PREF || :NUMERO;
    INSERT INTO MOVIMIENTO_CLIENTES (MVCL_ID, TERC_NIT, MVCL_TIPOREF, MVCL_IDREF, MVCL_FECHA, MVCL_VENCE, MVCL_CONC, MVCL_MONTO, MVCL_RTEFTE, MVCL_RTEIVA, MVCL_RTEICA, MVCL_DEBITO, MVCL_ABONO, MVCL_PREFREF, MVCL_NUMREF, MVCL_SUCURSAL)
        VALUES (GEN_ID(ID_MOVCLI, 1), :NUEVO, 31, :ID, :FECHA, :VENCE, :CONC, :TOTAL, :RTFTEMONTO, :RTIVAMONTO, :RTICAMONTO, 'S', 'N', :pref, :numero, :sucursal);
    suspend;
    END
TIPODOC = 33;
FOR SELECT DEVT_ID, PREF_PRE, DEVT_NUMERO, DEVT_FECHA, DEVT_RTFTEMONTO, DEVT_RTIVAMONTO, DEVT_RTICAMONTO, DEVT_TOTAL, devt_factura, DEVT_SUCURSAL
    FROM DEVOLUCIONES_VENTAS WHERE TERC_NIT = :antes AND DEVT_ANULADO = 'N' AND DEVT_ID <> 0 ORDER BY DEVT_FECHA
    INTO :ID, :PREF, :NUMERO, :FECHA, :RTFTEMONTO, :RTIVAMONTO, :RTICAMONTO, :TOTAL, :CONC, :SUCURSAL
    DO
    BEGIN
    /* Registre el nuevo saldo del documento */
    INSERT INTO SALDOS_DOC_CARTERA (SDCA_TIPOREF, SDCA_IDREF, SDCA_FECHA, TERC_NIT, SDCA_RTFTE, SDCA_RTIVA, SDCA_RTICA, SDCA_ABONO, SDCA_ABRTFTE, SDCA_ABRTIVA, SDCA_ABRTICA, SDCA_DEBITO, SDCA_MONTO)
        VALUES (33, :ID, :fecha, :NUEVO, (:rtftemonto*-1), (:rtivamonto*-1), (:rticamonto*-1), 0, 0, 0, 0, 'S', (:TOTAL*-1));
    CONC = 'DEVOLUCION VENTA No.' || :PREF || :NUMERO || ' EN FACTURA ' || :CONC;
    INSERT INTO MOVIMIENTO_CLIENTES (MVCL_ID, TERC_NIT, MVCL_TIPOREF, MVCL_IDREF, MVCL_FECHA, MVCL_VENCE, MVCL_CONC, MVCL_MONTO, MVCL_RTEFTE, MVCL_RTEIVA, MVCL_RTEICA, MVCL_DEBITO, MVCL_ABONO, MVCL_PREFREF, MVCL_NUMREF, MVCL_SUCURSAL)
        VALUES (GEN_ID(ID_MOVCLI, 1), :NUEVO, 33, :ID, :FECHA, :FECHA, :CONC, :TOTAL, :RTFTEMONTO, :RTIVAMONTO, :RTICAMONTO, 'S', 'N', :pref, :numero, :SUCURSAL);
    suspend;
    END
TIPODOC = 41;
FOR SELECT NDCL_ID, PREF_PRE, NDCL_NUMERO, NDCL_FECHA, NDCL_VENCE, NDCL_RTFTEMONTO, NDCL_RTIVAMONTO, NDCL_RTICAMONTO, (NDCL_MONTO+NDCL_IVAMONTO), NDCL_CONC, NDCL_SUCURSAL
    FROM notas_debito_clientes WHERE TERC_NIT = :antes AND NDCL_ANULADO = 'N' AND NDCL_ID <> 0 ORDER BY NDCL_FECHA
    INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :RTFTEMONTO, :RTIVAMONTO, :RTICAMONTO, :TOTAL, :CONC, :SUCURSAL
    DO
    BEGIN
    /* Registre el nuevo saldo del documento */
    INSERT INTO SALDOS_DOC_CARTERA (SDCA_TIPOREF, SDCA_IDREF, SDCA_FECHA, TERC_NIT, SDCA_RTFTE, SDCA_RTIVA, SDCA_RTICA, SDCA_ABONO, SDCA_ABRTFTE, SDCA_ABRTIVA, SDCA_ABRTICA, SDCA_DEBITO, SDCA_MONTO)
        VALUES (41, :ID, :fecha, :NUEVO, :rtftemonto, :rtivamonto, :rticamonto, 0, 0, 0, 0, 'S', :TOTAL);
    INSERT INTO MOVIMIENTO_CLIENTES (MVCL_ID, TERC_NIT, MVCL_TIPOREF, MVCL_IDREF, MVCL_FECHA, MVCL_VENCE, MVCL_CONC, MVCL_MONTO, MVCL_RTEFTE, MVCL_RTEIVA, MVCL_RTEICA, MVCL_DEBITO, MVCL_ABONO, MVCL_PREFREF, MVCL_NUMREF, MVCL_SUCURSAL)
        VALUES (GEN_ID(ID_MOVCLI, 1), :NUEVO, 41, :ID, :FECHA, :VENCE, :CONC, :TOTAL, :RTFTEMONTO, :RTIVAMONTO, :RTICAMONTO, 'S', 'N', :pref, :numero, :SUCURSAL);
    suspend;
    END
TIPODOC = 42;
FOR SELECT NCCL_ID, PREF_PRE, NCCL_NUMERO, NCCL_FECHA, NCCL_RTFTEMONTO, NCCL_RTIVAMONTO, NCCL_RTICAMONTO, (NCCL_MONTO+NCCL_IVAMONTO), NCCL_CONC, NCCL_SUCURSAL
    FROM notas_credito_clientes WHERE TERC_NIT = :antes AND NCCL_ANULADO = 'N' AND NCCL_ID <> 0 ORDER BY NCCL_FECHA
    INTO :ID, :PREF, :NUMERO, :FECHA, :RTFTEMONTO, :RTIVAMONTO, :RTICAMONTO, :TOTAL, :CONC, :SUCURSAL
    DO
    BEGIN
    /* Registre el nuevo saldo del documento */
    INSERT INTO SALDOS_DOC_CARTERA (SDCA_TIPOREF, SDCA_IDREF, SDCA_FECHA, TERC_NIT, SDCA_RTFTE, SDCA_RTIVA, SDCA_RTICA, SDCA_ABONO, SDCA_ABRTFTE, SDCA_ABRTIVA, SDCA_ABRTICA, SDCA_DEBITO, SDCA_MONTO)
        VALUES (41, :ID, :fecha, :NUEVO, (:rtftemonto*-1), (:rtivamonto*-1), (:rticamonto*-1), 0, 0, 0, 0, 'S', (:TOTAL*-1));
    INSERT INTO MOVIMIENTO_CLIENTES (MVCL_ID, TERC_NIT, MVCL_TIPOREF, MVCL_IDREF, MVCL_FECHA, MVCL_VENCE, MVCL_CONC, MVCL_MONTO, MVCL_RTEFTE, MVCL_RTEIVA, MVCL_RTEICA, MVCL_DEBITO, MVCL_ABONO, MVCL_PREFREF, MVCL_NUMREF, MVCL_SUCURSAL)
        VALUES (GEN_ID(ID_MOVCLI, 1), :NUEVO, 41, :ID, :FECHA, :FECHA, :CONC, :TOTAL, :RTFTEMONTO, :RTIVAMONTO, :RTICAMONTO, 'S', 'N', :pref, :numero, :SUCURSAL);
    suspend;
    END
TIPODOC = 45;
FOR SELECT ANCL_ID, PREF_PRE, ANCL_NUMERO, ANCL_FECHA, ANCL_RTFTEMONTO, ANCL_RTIVAMONTO, ANCL_RTICAMONTO, (ANCL_BASE+ANCL_IVAMONTO), ANCL_CONC, ANCL_SUCURSAL
    FROM anticipos_cliente WHERE TERC_NIT = :antes AND ANCL_ANULADO = 'N' AND ANCL_ID <> 0 ORDER BY ANCL_FECHA
    INTO :ID, :PREF, :NUMERO, :FECHA, :RTFTEMONTO, :RTIVAMONTO, :RTICAMONTO, :TOTAL, :CONC, :SUCURSAL
    DO
    BEGIN
    /* Registre el nuevo saldo del documento */
    INSERT INTO SALDOS_DOC_CARTERA (SDCA_TIPOREF, SDCA_IDREF, SDCA_FECHA, TERC_NIT, SDCA_RTFTE, SDCA_RTIVA, SDCA_RTICA, SDCA_ABONO, SDCA_ABRTFTE, SDCA_ABRTIVA, SDCA_ABRTICA, SDCA_DEBITO, SDCA_MONTO)
        VALUES (45, :ID, :fecha, :NUEVO, (:rtftemonto*-1), (:rtivamonto*-1), (:rticamonto*-1), 0, 0, 0, 0, 'N', (:TOTAL*-1));
    /* Registre el movimiento del proveedor */
    INSERT INTO MOVIMIENTO_CLIENTES (MVCL_ID, TERC_NIT, MVCL_TIPOREF, MVCL_IDREF, MVCL_FECHA, MVCL_VENCE, MVCL_CONC, MVCL_MONTO, MVCL_RTEFTE, MVCL_RTEIVA, MVCL_RTEICA, MVCL_DEBITO, MVCL_ABONO, MVCL_PREFREF, MVCL_NUMREF, MVCL_SUCURSAL)
        VALUES (GEN_ID(ID_MOVCLI, 1), :NUEVO, 45, :ID, :FECHA, :FECHA, :CONC, :TOTAL, :RTFTEMONTO, :RTIVAMONTO, :RTICAMONTO, 'N', 'N', :pref, :numero, :SUCURSAL);
    END
TIPODOC = 77;
FOR SELECT DVCH_ID, PRBA_PREF, DVCH_NUMDOC, DVCH_FECHA, DVCH_MONTO, DVCH_CONC, DVCH_SUCURSAL
    FROM DEVOLUCION_CHEQUES WHERE TERC_NIT = :antes AND DVCH_ANULADO = 'N' AND DVCH_ID <> 0 ORDER BY DVCH_FECHA
    INTO :ID, :PREF, :NUMERO, :FECHA, :TOTAL, :CONC, :SUCURSAL
    DO
    BEGIN
    /* Registre el nuevo saldo del documento */
    INSERT INTO SALDOS_DOC_CARTERA (SDCA_TIPOREF, SDCA_IDREF, SDCA_FECHA, TERC_NIT, SDCA_RTFTE, SDCA_RTIVA, SDCA_RTICA, SDCA_ABONO, SDCA_ABRTFTE, SDCA_ABRTIVA, SDCA_ABRTICA, SDCA_DEBITO, SDCA_MONTO)
        VALUES (77, :ID, :fecha, :NUEVO, 0, 0, 0, 0, 0, 0, 0, 'N', :TOTAL);
    /* Registre el movimiento del proveedor */
    INSERT INTO  MOVIMIENTO_CLIENTES
        (MVCL_ID, TERC_NIT, MVCL_TIPOREF, MVCL_IDREF, MVCL_PREFREF, MVCL_NUMREF, MVCL_FECHA, MVCL_VENCE, MVCL_CONC, MVCL_MONTO, MVCL_RTEFTE, MVCL_RTEIVA, MVCL_RTEICA, MVCL_ABONO, MVCL_DEBITO, MVCL_SUCURSAL)
        VALUES (GEN_ID(ID_MOVCLI, 1), :NUEVO, 77, :ID, :PREF, :NUMERO, :FECHA, :FECHA, :CONC, :TOTAL, 0, 0, 0, 'N', 'S', :SUCURSAL);
    END
/* LOS ANTICIPOS */
TIPODOC = 43;
FOR SELECT A.APCL_ID, PREF_PRE, APCL_NUMERO, APCL_FECHA, APCL_CONCEPTO, ACDE_TIPODOC, ACDE_IDDOC, ACDE_APLICADO, ACDE_RTFTE, ACDE_RTIVA, ACDE_RTICA, APCL_SUCURSAL
    FROM APLICACION_CLIENTE A, APLICACION_CLIENTE_DETALLE D
    WHERE A.APCL_ID = D.APCL_ID AND TERC_NIT = :ANTES ORDER BY APCL_FECHA, A.APCL_ID, ACDE_ITEM
    INTO :ID, :PREF, :NUMERO, :FECHA, :CONC, :TIPOAB, :IDAB, :MONTOAB, :RTFTEMONTO, :RTIVAMONTO, :RTICAMONTO, :SUCURSAL
    DO
    BEGIN
    select 'S' from saldos_doc_cartera
        where sdca_tiporef = :TIPOAB and sdca_idref = :IDAB and sdca_fecha = :FECHA
        into :EXISTE;
    if (Existe = 'S') then
        begin
        /* actualice el saldo del dia */
        UPDATE saldos_doc_cartera
            SET SDCA_ABONO = SDCA_ABONO + :MONTOAB,
                SDCA_ABRTFTE = SDCA_ABRTFTE + :RTFTEMONTO,
                SDCA_ABRTIVA = SDCA_ABRTIVA + :RTIVAMONTO,
                SDCA_ABRTICA = SDCA_ABRTICA + :RTICAMONTO
            WHERE SDCA_TIPOREF = :TIPOAB AND SDCA_IDREF = :IDAB AND SDCA_FECHA = :FECHA;
        END
    ELSE
        BEGIN
        /* Inserte un nuevo saldo diario */
        INSERT INTO SALDOS_DOC_CARTERA (SDCA_TIPOREF, SDCA_IDREF, SDCA_FECHA, TERC_NIT, SDCA_RTFTE, SDCA_RTIVA, SDCA_RTICA, SDCA_ABONO, SDCA_ABRTFTE, SDCA_ABRTIVA, SDCA_ABRTICA, SDCA_DEBITO, SDCA_MONTO)
            VALUES (:TIPOAB, :IDAB, :FECHA, :NUEVO, 0, 0, 0, :MONTOAB, :rtftemonto, :rtivamonto, :rticamonto, 'N', 0);
        END
    /* actualice el registro en mov_cliente (por si son varios items) */
    EXISTE = 'N';
    SELECT 'S' FROM MOVIMIENTO_CLIENTES WHERE MVCL_TIPOREF = 43 AND MVCL_IDREF = :ID INTO :EXISTE;
    if (EXISTE = 'S') then
        begin
        UPDATE movimiento_clientes
            SET MVCL_MONTO = MVCL_MONTO + :MONTOAB,
                MVCL_RTEFTE = MVCL_RTEFTE + :rtftemonto,
                MVCL_RTEIVA = MVCL_RTEIVA + :rtivamonto,
                MVCL_RTEICA = MVCL_RTEICA + :rticamonto
            WHERE MVCL_TIPOREF = 43 AND MVCL_IDREF = :ID;
        end
    ELSE
        INSERT INTO MOVIMIENTO_CLIENTES (MVCL_ID, TERC_NIT, MVCL_TIPOREF, MVCL_IDREF, MVCL_FECHA, MVCL_VENCE, MVCL_CONC, MVCL_MONTO, MVCL_RTEFTE, MVCL_RTEIVA, MVCL_RTEICA, MVCL_DEBITO, MVCL_ABONO, MVCL_PREFREF, MVCL_NUMREF, MVCL_SUCURSAL)
            VALUES (GEN_ID(ID_MOVCLI, 1), :NUEVO, 43, :ID, :FECHA, :FECHA, :CONC, :MONTOAB, :rtftemonto, :rtivamonto, :rticamonto, 'N', 'S', :PREF, :NUMERO, :SUCURSAL);
    END
/* RECIBOS DE CAJA */
FOR SELECT R.RECA_ID, PREF_PRE, RECA_NUMERO, RECA_FECHA, RECA_CONC, RCDE_TIPODOC, RCDE_IDDOC, (RCDE_ABONO+RCDE_DTOF), RCDE_RTFTE, RCDE_RTIVA, RCDE_RTICA, RCDE_SUCURSAL
    FROM RECIBOS_CAJA R, RECIBOS_CAJA_DETALLE D
    WHERE R.RECA_ID = D.RECA_ID AND TERC_NIT = :ANTES ORDER BY RECA_FECHA, R.RECA_ID, RCDE_ITEM
    INTO :ID, :PREF, :NUMERO, :FECHA, :CONC, :TIPOAB, :IDAB, :MONTOAB, :RTFTEMONTO, :RTIVAMONTO, :RTICAMONTO, :SUCURSAL
    DO
    BEGIN
    select 'S' from saldos_doc_cartera where sdca_tiporef = :tipoab and sdca_idref = :idab and sdca_fecha = :FECHA into :EXISTE;
    if (Existe = 'S') then
        /* actualice el saldo del dia */
        UPDATE saldos_doc_cartera
            SET SDCA_ABONO = SDCA_ABONO + :MONTOAB,
                SDCA_ABRTFTE = SDCA_ABRTFTE + :rtftemonto,
                SDCA_ABRTIVA = SDCA_ABRTIVA + :rtivamonto,
                SDCA_ABRTICA = SDCA_ABRTICA + :rticamonto
            WHERE SDCA_TIPOREF = :TIPOAB AND SDCA_IDREF = :idab AND SDCA_FECHA = :FECHA;
    ELSE
        /* Inserte un nuevo saldo diario */
        INSERT INTO SALDOS_DOC_CARTERA (SDCA_TIPOREF, SDCA_IDREF, SDCA_FECHA, TERC_NIT, SDCA_RTFTE, SDCA_RTIVA, SDCA_RTICA, SDCA_ABONO, SDCA_ABRTFTE, SDCA_ABRTIVA, SDCA_ABRTICA, SDCA_DEBITO, SDCA_MONTO)
            VALUES (:tipoab, :idab, :FECHA, :NUEVO, 0, 0, 0, :MONTOAB, :rtftemonto, :rtivamonto, :rticamonto, 'N', 0);
    /* Registre o actualice el registro en movimiento_cliente */
    EXISTE = 'N';
    SELECT 'S' FROM MOVIMIENTO_CLIENTES WHERE MVCL_TIPOREF = 61 AND MVCL_IDREF = :ID and MVCL_SUCURSAL = :SUCURSAL INTO :EXISTE;
    if (EXISTE = 'S') then
        begin
        UPDATE movimiento_clientes
            SET MVCL_MONTO = MVCL_MONTO + :montoab,
                MVCL_RTEFTE = MVCL_RTEFTE + :rtftemonto,
                MVCL_RTEIVA = MVCL_RTEIVA + :rtivamonto,
                MVCL_RTEICA = MVCL_RTEICA + :rticamonto
            WHERE MVCL_TIPOREF = 61 AND MVCL_IDREF = :ID and MVCL_SUCURSAL = :SUCURSAL;
        end
    ELSE
        INSERT INTO MOVIMIENTO_CLIENTES (MVCL_ID, TERC_NIT, MVCL_TIPOREF, MVCL_IDREF, MVCL_FECHA, MVCL_VENCE, MVCL_CONC, MVCL_MONTO, MVCL_RTEFTE, MVCL_RTEIVA, MVCL_RTEICA, MVCL_DEBITO, MVCL_ABONO, MVCL_PREFREF, MVCL_NUMREF, MVCL_SUCURSAL)
            VALUES (GEN_ID(ID_MOVCLI, 1), :NUEVO, 61, :ID, :FECHA, :FECHA, :CONC, :MONTOAB, :rtftemonto, :rtivamonto, :rticamonto, 'N', 'S', :PREF, :NUMERO, :SUCURSAL);
    end
end
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE ARREGLA_MOV_CLIENTE_RC
RETURNS (
    ID INTEGER,
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    NIT VARCHAR(20),
    FECHA DATE)
AS
declare variable MONTO NUMERIC(18,2);
declare variable ABONO NUMERIC(18,2);
declare variable RTFTE NUMERIC(18,2);
declare variable RTIVA NUMERIC(18,2);
declare variable RTICA NUMERIC(18,2);
declare variable RTEFTE NUMERIC(18,2);
declare variable RTEIVA NUMERIC(18,2);
declare variable RTEICA NUMERIC(18,2);
declare variable CONCEPTO VARCHAR(60);
declare variable SUCURSAL VARCHAR(10);
declare variable COBR INTEGER;
declare variable EXISTE CHAR(1);
BEGIN
FOR SELECT MAX(D.RECA_ID), SUM(RCDE_ABONO+RCDE_DTOF), MAX(MVCL_MONTO), SUM(RCDE_RTFTE), MAX(MVCL_RTEFTE), SUM(RCDE_RTIVA), MAX(MVCL_RTEIVA), SUM(RCDE_RTICA), MAX(MVCL_RTEICA)
  FROM RECIBOS_CAJA_DETALLE D, MOVIMIENTO_CLIENTES M
  WHERE MVCL_TIPOREF = 61 AND MVCL_IDREF = RECA_ID GROUP BY D.RECA_ID
  INTO :ID, ABONO, MONTO, RTFTE, RTEFTE, RTIVA, RTEIVA, RTICA, RTEICA
  DO
  BEGIN
  IF ((ABONO <> MONTO) or (RTFTE <> RTEFTE) or (RTIVA <> RTEIVA) or (RTICA <> RTEICA)) THEN
    BEGIN
    DELETE FROM MOVIMIENTO_CLIENTES WHERE MVCL_TIPOREF = 61 AND MVCL_IDREF = :ID;
    FOR SELECT RCDE_ABONO, RCDE_DTOF, RCDE_RTFTE, RCDE_RTIVA, RCDE_RTICA, TERC_NIT, RECA_FECHA, RECA_CONC, PREF_PRE, RECA_NUMERO, RCDE_SUCURSAL, COBR_COD
        FROM RECIBOS_CAJA_DETALLE D, RECIBOS_CAJA R WHERE R.RECA_ID = D.RECA_ID AND R.RECA_ID = :ID
        INTO :ABONO, :monto, rtfte, :rteiva, :rtica, :nit,  :fecha, :concepto, :prefijo, :numero, :sucursal, :COBR
        DO
        BEGIN
        EXISTE = 'N';
        SELECT 'S' FROM MOVIMIENTO_CLIENTES WHERE MVCL_TIPOREF = 61 AND MVCL_IDREF = :ID AND MVCL_SUCURSAL = :SUCURSAL INTO :EXISTE;
        if (EXISTE = 'S') then
            begin
            UPDATE movimiento_clientes
                SET MVCL_MONTO = MVCL_MONTO + :abono + :monto,
                    MVCL_RTEFTE = MVCL_RTEFTE + :rtfte,
                    MVCL_RTEIVA = MVCL_RTEIVA + :rtiva,
                    MVCL_RTEICA = MVCL_RTEICA + :rtica
                WHERE MVCL_TIPOREF = 61 AND MVCL_IDREF = :ID AND MVCL_SUCURSAL = :SUCURSAL;
            end
        ELSE
            INSERT INTO MOVIMIENTO_CLIENTES (MVCL_ID, TERC_NIT, MVCL_TIPOREF, MVCL_IDREF, MVCL_FECHA, MVCL_VENCE, MVCL_CONC, MVCL_MONTO, MVCL_RTEFTE, MVCL_RTEIVA, MVCL_RTEICA, MVCL_DEBITO, MVCL_ABONO, MVCL_PREFREF, MVCL_NUMREF, MVCL_SUCURSAL, COBR_COD)
                VALUES (GEN_ID(ID_MOVCLI, 1), :NIT, 61, :ID, :FECHA, :FECHA, :CONCEPTO, (:ABONO+:monto), :RTFTE, :RTIVA, :RTICA, 'N', 'S', :PREFIJO, :NUMERO, :SUCURSAL, :COBR);
        END
    SUSPEND;
    END
  END
END
^

SET TERM ; ^

ALTER TABLE RECIBOS_CAJA DROP RECA_SUCURSAL;


/* PROVISIONALES */

ALTER TABLE RECIBO_PROVISIONAL_DETALLE
ADD RPDE_SUCURSAL VARCHAR(10)
NOT NULL ;

UPDATE recibo_provisional_detalle D SET RPDE_SUCURSAL = (SELECT RCPR_SUCURSAL FROM recibo_provisional R WHERE RCPR_ID = D.rcpr_id);
COMMIT WORK;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_CARTERA_CLIENTES(
    DESDE VARCHAR(20),
    HASTA VARCHAR(20),
    GRPINI VARCHAR(5),
    GRPFIN VARCHAR(5),
    FECHA DATE,
    ORDEN CHAR(1),
    AGRUPA CHAR(1),
    SUBEMPRESA INTEGER,
    GRUPCART INTEGER)
RETURNS (
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    DIR VARCHAR(60),
    TELEFONO VARCHAR(40),
    CIUDAD VARCHAR(40),
    CONTACTO VARCHAR(60),
    EMAIL VARCHAR(100),
    FAX VARCHAR(25),
    CEL VARCHAR(25),
    CODCLI VARCHAR(20),
    CODZONA VARCHAR(2),
    NOMZONA VARCHAR(60),
    CODCOBR INTEGER,
    NOMCOBR VARCHAR(60),
    SUCURSAL VARCHAR(10),
    NOMSUC VARCHAR(60),
    DV CHAR(1),
    CODCIUD CHAR(5),
    NOMCIUD VARCHAR(60),
    TIPO INTEGER,
    ID INTEGER,
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    CONCEPTO VARCHAR(60),
    SALDO NUMERIC(18,2),
    PROVISIONAL NUMERIC(18,2),
    RTFTE NUMERIC(18,2),
    RTIVA NUMERIC(18,2),
    RTICA NUMERIC(18,2),
    DTOF NUMERIC(18,2),
    TIPONOM VARCHAR(8),
    FECDOC DATE,
    VENCE DATE,
    DIAS INTEGER,
    CUPO NUMERIC(18,2),
    DISPONIBLE NUMERIC(18,2),
    NOTA VARCHAR(256),
    OBS BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    GRUPCOD INTEGER,
    GRUPNOM VARCHAR(30))
AS
DECLARE VARIABLE NITINI VARCHAR(20);
DECLARE VARIABLE NITFIN VARCHAR(20);
DECLARE VARIABLE NOMINI VARCHAR(20);
DECLARE VARIABLE NOMFIN VARCHAR(20);
DECLARE VARIABLE OK CHAR(1);
DECLARE VARIABLE FOV CHAR(11);
DECLARE VARIABLE DTOAPL NUMERIC(18,2);
DECLARE VARIABLE FECDTO DATE;
DECLARE VARIABLE FECNOTA VARCHAR(10);
DECLARE VARIABLE AUXNOTA VARCHAR(256);
DECLARE VARIABLE IDNOTA INTEGER;
declare variable descnt_prov char(2);
declare variable AUTORET VARCHAR(10);
declare variable FAUTORET DATE;
declare variable INCLANTI CHAR(2);
BEGIN
if (ORDEN = 'C') then
    BEGIN
    NITINI = DESDE;
    NITFIN = HASTA;
    NOMINI = '';
    NOMFIN = 'zz';
    END
ELSE
    BEGIN
    NOMINI = DESDE;
    NOMFIN = HASTA;
    NITINI = '';
    NITFIN = 'zz';
    END
  EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'DESCONTAR RECIBOS PROVISIONALES EN INFORMES DE CARTERA') RETURNING_VALUES (:descnt_prov);
  EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'INCLUIR ANTICIPOS DE CLIENTES EN REPORTES Y CONSULTAS DE CARTERA') returning_values (INCLANTI);
  EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'FECHA AUTORETENEDOR NO DESCONTAR RETENCIONES DEL SALDO PERO SI CONTABILIZARLAS') returning_values (AUTORET);
  if (AUTORET <> '') then
    FAUTORET = CAST(AUTORET AS DATE);
  else
    FAUTORET = '9999/12/31';
  /* Ubique el NIT */
  FOR select C.TERC_NIT, TERC_NOM, TERC_DV, CLSU_DIR, CLSU_TEL, CLSU_CIUDAD, S.COBR_COD, S.ZONA_COD, T.CIUD_COD, CLIE_CUPO, CLCU_COD, CLSU_NOMBRE, t.terc_obs, C.GRCA_COD, TERC_CONTACTO, TERC_EMAIL, TERC_FAX, TERC_CEL, CLIE_COD
    from terceros T, CLIENTES C, CLIENTE_SUCURSALES S
    where C.TERC_NIT = T.TERC_NIT AND TERC_CLIE = 'S' AND S.TERC_NIT = C.TERC_NIT AND C.TERC_NIT >= :NITINI AND C.TERC_NIT <= :NITFIN AND
        TERC_NOM >= :NOMINI AND TERC_NOM <= :NOMFIN AND ((:GRUPCART = 0) or (C.GRCA_COD = :GRUPCART))
    INTO :NIT, :NOMBRE, :DV, :DIR, :TELEFONO, :CIUDAD, :CODCOBR, :CODZONA, :CODCIUD, :CUPO, :SUCURSAL, :NOMSUC, :obs, :GRUPCOD, :CONTACTO, :EMAIL, :FAX, :CEL, :CODCLI
    DO  
    BEGIN
    if (CODCOBR IS NOT NULL) then
        SELECT COBR_NOM FROM COBRADORES  WHERE COBR_COD = :CODCOBR INTO :NOMCOBR;
    if (CODZONA IS NOT NULL) then
        SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :CODZONA INTO :NOMZONA;
    if (CODCIUD IS NOT NULL) then
        SELECT CIUD_NOM FROM CIUDADES  WHERE CIUD_COD = :CODCIUD INTO :NOMCIUD;
    SELECT GRCA_NOMBRE FROM GRUPO_CARTERA WHERE GRCA_COD = :GRUPCOD INTO :GRUPNOM;
    DISPONIBLE = CUPO;
    OK = 'N';
    if (AGRUPA = 'Z') then
        BEGIN
        if (GRPINI = '') then
            BEGIN
            if ((CODZONA IS NULL) or (CODZONA >= :GRPINI AND CODZONA <= :GRPFIN)) then
                OK = 'S';
            END
        ELSE
            if (CODZONA >= :GRPINI AND CODZONA <= :GRPFIN) then
                OK = 'S';
        END
    if (AGRUPA = 'I') then
        BEGIN
        if (GRPINI = '') then
            BEGIN
            if ((CODCIUD IS NULL) or (CODCIUD >= :GRPINI AND CODCIUD <= :GRPFIN)) then
                OK = 'S';
            END
        ELSE
            if (CODCIUD >= :GRPINI AND CODCIUD <= :GRPFIN) then
                OK = 'S';
        END
    if (AGRUPA = 'N') then
        OK = 'S';
        
    if (OK = 'S') then
        BEGIN
        /* BUSQUE EN SALDOS_DOC_CARTERA LOS QUE TENGAN SALDO > 0 */
        FOR SELECT MVCL_TIPOREF, MVCL_IDREF, MVCL_PREFREF, MVCL_NUMREF, MVCL_FECHA, MVCL_VENCE, MVCL_CONC
            FROM MOVIMIENTO_CLIENTES WHERE TERC_NIT = :NIT AND MVCL_SUCURSAL = :SUCURSAL AND MVCL_FECHA <= :FECHA AND
            MVCL_ABONO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            INTO :TIPO, :ID, :PREFIJO, :NUMERO, :FECDOC, :VENCE, :CONCEPTO
            DO
            BEGIN
            if ((inclanti = 'SI') or (TIPO <> 45)) then
                BEGIN
                EXECUTE PROCEDURE saldo_doc_cartera(TIPO, ID, FECHA) returning_values (SALDO);
                if (SALDO <> 0) then
                    BEGIN
                    PROVISIONAL = 0;
                    EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'ANALISIS DE CARTERA CON FECHA FACTURA O VENCIMIENTO') RETURNING_VALUES (FOV);
                    if (FOV = 'FECHA') then
                       DIAS = FECHA - FECDOC;
                    ELSE
                      DIAS = FECHA - VENCE;
                    DISPONIBLE = DISPONIBLE - SALDO;
                    SELECT TIDO_NOMCORTO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPO INTO :TIPONOM;
                    if (TIPO = 41) then
                        SELECT NDCL_DTOFMONTO, NDCL_FECHADTO FROM NOTAS_DEBITO_CLIENTES WHERE NDCL_ID = :ID INTO :DTOF, :FECDTO;
                    if (TIPO = 42) then
                        SELECT 0, :FECDOC FROM NOTAS_CREDITO_CLIENTES WHERE NCCL_ID = :ID INTO :DTOF, :FECDTO;
                    if (TIPO = 45) then
                        SELECT ANCL_DTOFMONTO, ANCL_DTOFECHA FROM ANTICIPOS_CLIENTE WHERE ANCL_ID = :ID INTO :DTOF, :FECDTO;
                    if (TIPO = 31) then
                        SELECT FACT_DTOFMONTO, FACT_DTOFFECHA FROM FACTURAS WHERE FACT_ID = :ID INTO :DTOF, :FECDTO;
                    if (TIPO = 33) then
                        SELECT 0, :FECDOC FROM devoluciones_ventas WHERE DEVT_ID = :ID INTO :DTOF, :FECDTO;
                    if (DTOF IS NULL) then
                        DTOF = 0;
                    if (DTOF <> 0) then
                        BEGIN
                        SELECT SUM(RCDE_DTOF) FROM RECIBOS_CAJA_DETALLE WHERE RCDE_IDDOC = :ID AND RCDE_TIPODOC = :TIPO INTO :DTOAPL;
                        if (DTOAPL IS NULL) then
                            DTOAPL = 0;
                        DTOF = DTOF - DTOAPL;
                        /* SI YA SE VENCIO DEJELO EN CERO */
                        if (FECDTO < FECHA) then
                            DTOF = 0;
                        END
                    SELECT SUM(SDCA_RTFTE - SDCA_ABRTFTE), SUM(SDCA_RTIVA - SDCA_ABRTIVA), SUM(SDCA_RTICA - SDCA_ABRTICA)
                        FROM SALDOS_DOC_CARTERA WHERE SDCA_TIPOREF = :TIPO AND SDCA_IDREF = :ID INTO :RTFTE, :RTIVA, :RTICA;
                    if (RTFTE IS NULL) then
                        RTFTE = 0;
                    if ((TIPO = 42) or (TIPO = 45) or (TIPO = 33)) THEN
                        BEGIN
                        if (RTFTE > 0) then
                            RTFTE = 0;
                        END
                    ELSE
                        BEGIN
                        if (RTFTE < 0) then
                            RTFTE = 0;
                        END
                    if (RTIVA IS NULL) then
                        RTIVA = 0;
                    if ((TIPO = 42) or (TIPO = 45) or (TIPO = 33)) THEN
                        BEGIN
                        if (RTIVA > 0) then
                            RTIVA = 0;
                        END
                    ELSE
                        BEGIN
                        if (RTIVA < 0) then
                            RTIVA = 0;
                        END
                    if (RTICA IS NULL) then
                        RTICA = 0;
                    if ((TIPO = 42) or (TIPO = 45) or (TIPO = 33)) THEN
                        BEGIN
                        if (RTICA > 0) then
                            RTICA = 0;
                        END
                    ELSE
                        BEGIN
                        if (RTICA < 0) then
                            RTICA = 0;
                        END
                    if (FAUTORET <= FECDOC) then
                        RTFTE = 0;
                    /* SI TIENE NOTA AGREGUELA */
                    SELECT MAX(NOCL_ID) FROM NOTAS_CLIENTES WHERE TERC_NIT = :NIT AND CLSU_COD = :SUCURSAL AND NOCL_TIPODOC = :TIPO AND NOCL_IDDOC = :ID INTO :IDNOTA;
                    if (IDNOTA IS NOT NULL) then
                        BEGIN
                        SELECT cast(NOCL_FECHA as char(10)), NOCL_TEXTO FROM NOTAS_CLIENTES
                            WHERE NOCL_ID = :IDNOTA INTO :FECNOTA, :AUXNOTA;
                        if (STRLEN(AUXNOTA) < 244) then
                            NOTA = FECNOTA || ':' || AUXNOTA;
                        ELSE
                            NOTA = AUXNOTA;
                        END
                    else
                        NOTA = '';
                    SUSPEND;
                    END /* SALDO <> 0 */
                END /* NO ANTICIPO */
            END /* FOR */
        /* AGREGUE LOS RECIBOS PROVISIONALES CON SIGNO NEGATIVO */
        FOR SELECT 65, MAX(P.RCPR_ID), MAX(PREF_PRE), MAX(RCPR_NUMERO), MAX(RCPR_FECHA), MAX(RCPR_CONC), SUM(RPDE_ABONO * -1), SUM(RPDE_RTFTE*-1), SUM(RPDE_RTIVA*-1), SUM(RPDE_RTICA*-1)
            FROM RECIBO_PROVISIONAL P, recibo_provisional_detalle D
            WHERE P.rcpr_id = D.rcpr_id AND P.TERC_NIT = :NIT AND RCPR_FECHA <= :FECHA AND RCPR_ANULADO = 'N' AND
            ((RCPR_FECCRUCE IS NULL) or (RCPR_FECCRUCE > :FECHA)) AND RPDE_SUCURSAL = :SUCURSAL AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY P.rcpr_id
            INTO :TIPO, :ID, :PREFIJO, :NUMERO, :FECDOC, :CONCEPTO, :PROVISIONAL, :rtfte,  :RTIVA, :RTICA
            DO
            BEGIN
            if (:descnt_prov = 'NO') then
              SALDO = 0;
            else
              SALDO = :PROVISIONAL;
            SELECT TIDO_NOMCORTO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPO INTO :TIPONOM;
            /* CALCULE EL VENCIMIENTO DEL ULTIMO DOCUMENTO POSFECHADO */
            SELECT MAX(RPPA_FECHA) FROM recibo_provisional_pago WHERE RCPR_ID = :ID INTO :VENCE;
            DIAS = VENCE - FECHA;
            SUSPEND;
            END
        END
    if (AGRUPA = 'C') then
        BEGIN
        FOR SELECT DISTINCT COBR_COD FROM MOVIMIENTO_CLIENTES
            WHERE TERC_NIT = :NIT AND MVCL_SUCURSAL = :SUCURSAL AND MVCL_FECHA <= :FECHA AND
            MVCL_ABONO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            INTO :codcobr
            DO
            BEGIN
            OK = 'N';
            if (GRPINI = '') then
                BEGIN
                if ((CODCOBR IS NULL) or (CODCOBR >= :GRPINI AND CODCOBR <= :GRPFIN)) then
                    OK = 'S';
                END
            ELSE
                if (CODCOBR >= :GRPINI AND CODCOBR <= :GRPFIN) then
                    OK = 'S';
            if (OK = 'S') then
                BEGIN
                SELECT COBR_NOM FROM COBRADORES  WHERE COBR_COD = :CODCOBR INTO :NOMCOBR;
                /* BUSQUE EN SALDOS_DOC_CARTERA LOS QUE TENGAN SALDO > 0 */
                FOR SELECT MVCL_TIPOREF, MVCL_IDREF, MVCL_PREFREF, MVCL_NUMREF, MVCL_FECHA, MVCL_VENCE, MVCL_CONC
                    FROM MOVIMIENTO_CLIENTES WHERE TERC_NIT = :NIT AND MVCL_SUCURSAL = :SUCURSAL AND MVCL_FECHA <= :FECHA AND
                    MVCL_ABONO = 'N' AND COBR_COD = :codcobr AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                    INTO :TIPO, :ID, :PREFIJO, :NUMERO, :FECDOC, :VENCE, :CONCEPTO
                    DO
                    BEGIN
                    if ((inclanti = 'SI') or (TIPO <> 45)) then
                        BEGIN
                        EXECUTE PROCEDURE saldo_doc_cartera(TIPO, ID, FECHA) returning_values (SALDO);
                        if (SALDO <> 0) then
                            BEGIN
                            PROVISIONAL = 0;
                            EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'ANALISIS DE CARTERA CON FECHA FACTURA O VENCIMIENTO') RETURNING_VALUES (FOV);
                            if (FOV = 'FECHA') then
                               DIAS = FECHA - FECDOC;
                            ELSE
                              DIAS = FECHA - VENCE;
                            DISPONIBLE = DISPONIBLE - SALDO;
                            SELECT TIDO_NOMCORTO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPO INTO :TIPONOM;
                            if (TIPO = 41) then
                                SELECT NDCL_DTOFMONTO, NDCL_FECHADTO FROM NOTAS_DEBITO_CLIENTES WHERE NDCL_ID = :ID INTO :DTOF, :FECDTO;
                            if (TIPO = 42) then
                                SELECT 0, :FECDOC FROM NOTAS_CREDITO_CLIENTES WHERE NCCL_ID = :ID INTO :DTOF, :FECDTO;
                            if (TIPO = 45) then
                                SELECT ANCL_DTOFMONTO, ANCL_DTOFECHA FROM ANTICIPOS_CLIENTE WHERE ANCL_ID = :ID INTO :DTOF, :FECDTO;
                            if (TIPO = 31) then
                                SELECT FACT_DTOFMONTO, FACT_DTOFFECHA FROM FACTURAS WHERE FACT_ID = :ID INTO :DTOF, :FECDTO;
                            if (TIPO = 33) then
                                SELECT 0, :FECDOC FROM devoluciones_ventas WHERE DEVT_ID = :ID INTO :DTOF, :FECDTO;
                            if (DTOF IS NULL) then
                                DTOF = 0;
                            if (DTOF <> 0) then
                                BEGIN
                                SELECT SUM(RCDE_DTOF) FROM RECIBOS_CAJA_DETALLE WHERE RCDE_IDDOC = :ID AND RCDE_TIPODOC = :TIPO INTO :DTOAPL;
                                if (DTOAPL IS NULL) then
                                    DTOAPL = 0;
                                DTOF = DTOF - DTOAPL;
                                /* SI YA SE VENCIO DEJELO EN CERO */
                                if (FECDTO < FECHA) then
                                    DTOF = 0;
                                END
                            SELECT SUM(SDCA_RTFTE - SDCA_ABRTFTE), SUM(SDCA_RTIVA - SDCA_ABRTIVA), SUM(SDCA_RTICA - SDCA_ABRTICA)
                                FROM SALDOS_DOC_CARTERA WHERE SDCA_TIPOREF = :TIPO AND SDCA_IDREF = :ID INTO :RTFTE, :RTIVA, :RTICA;
                            if (RTFTE IS NULL) then
                                RTFTE = 0;
                            if ((TIPO = 42) or (TIPO = 45) or (TIPO = 33)) THEN
                                BEGIN
                                if (RTFTE > 0) then
                                    RTFTE = 0;
                                END
                            ELSE
                                BEGIN
                                if (RTFTE < 0) then
                                    RTFTE = 0;
                                END
                            if (FAUTORET <= FECDOC) then
                                RTFTE = 0;
                            if (RTIVA IS NULL) then
                                RTIVA = 0;
                            if ((TIPO = 42) or (TIPO = 45) or (TIPO = 33)) THEN
                                BEGIN
                                if (RTIVA > 0) then
                                    RTIVA = 0;
                                END
                            ELSE
                                BEGIN
                                if (RTIVA < 0) then
                                    RTIVA = 0;
                                END
                            if (RTICA IS NULL) then
                                RTICA = 0;
                            if ((TIPO = 42) or (TIPO = 45) or (TIPO = 33)) THEN
                                BEGIN
                                if (RTICA > 0) then
                                    RTICA = 0;
                                END
                            ELSE
                                BEGIN
                                if (RTICA < 0) then
                                    RTICA = 0;
                                END
                            /* SI TIENE NOTA AGREGUELA */
                            SELECT MAX(NOCL_FECHA) FROM NOTAS_CLIENTES WHERE TERC_NIT = :NIT AND CLSU_COD = :SUCURSAL AND NOCL_TIPODOC = :TIPO AND NOCL_IDDOC = :ID INTO :FECDTO;
                            if (FECDTO IS NOT NULL) then
                                BEGIN
                                SELECT cast(NOCL_FECHA as char(10)), NOCL_TEXTO FROM NOTAS_CLIENTES
                                    WHERE NOCL_ID = :IDNOTA INTO :FECNOTA, :AUXNOTA;
                                if (STRLEN(AUXNOTA) < 244) then
                                    NOTA = FECNOTA || ':' || AUXNOTA;
                                ELSE
                                    NOTA = AUXNOTA;
                                END
                            else
                                NOTA = '';
                            SUSPEND;
                            END /* SALDO <> 0 */
                        END /* NO ANTICIPO */
                    END /* FOR */
                /* AGREGUE LOS RECIBOS PROVISIONALES CON SIGNO NEGATIVO */
                FOR SELECT 65, MAX(P.RCPR_ID), MAX(PREF_PRE), MAX(RCPR_NUMERO), MAX(RCPR_FECHA), MAX(RCPR_CONC), SUM(RPDE_ABONO * -1), SUM(RPDE_RTFTE*-1), SUM(RPDE_RTIVA*-1), SUM(RPDE_RTICA*-1)
                    FROM RECIBO_PROVISIONAL P, recibo_provisional_detalle D
                    WHERE P.rcpr_id = D.rcpr_id AND P.TERC_NIT = :NIT AND P.VEND_COD = :codcobr AND RCPR_FECHA <= :FECHA AND RCPR_ANULADO = 'N' AND
                    ((RCPR_FECCRUCE IS NULL) or (RCPR_FECCRUCE > :FECHA)) AND RPDE_SUCURSAL = :SUCURSAL AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                    GROUP BY P.rcpr_id
                    INTO :TIPO, :ID, :PREFIJO, :NUMERO, :FECDOC, :CONCEPTO, :PROVISIONAL, :rtfte,  :RTIVA, :RTICA
                    DO
                    BEGIN
                    if (:descnt_prov = 'NO') then
                      SALDO = 0;
                    else
                      SALDO = :PROVISIONAL;
                    SELECT TIDO_NOMCORTO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPO INTO :TIPONOM;
                    /* CALCULE EL VENCIMIENTO DEL ULTIMO DOCUMENTO POSFECHADO */
                    SELECT MAX(RPPA_FECHA) FROM recibo_provisional_pago WHERE RCPR_ID = :ID INTO :VENCE;
                    DIAS = VENCE - FECHA;
                    SUSPEND;
                    END
                END /* ok */
            END /* FOR COBR */
        END /* AGRUPA = C */
    END /* FOR NIT */
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_ANALISIS_CARTERA(
    DESDE VARCHAR(20),
    HASTA VARCHAR(20),
    GRPINI VARCHAR(5),
    GRPFIN VARCHAR(5),
    FECHA DATE,
    DETALLE CHAR(1),
    ORDEN CHAR(1),
    AGRUPA CHAR(1),
    DIASR INTEGER,
    SUBEMPRESA INTEGER,
    GRUPCART INTEGER,
    EXTENDIDA CHAR(1))
RETURNS (
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    TELEFONO VARCHAR(40),
    CIUDAD VARCHAR(40),
    CONTACTO VARCHAR(60),
    EMAIL VARCHAR(100),
    FAX VARCHAR(25),
    CEL VARCHAR(25),
    CODCLI VARCHAR(20),
    CODZONA VARCHAR(2),
    NOMZONA VARCHAR(60),
    CODCOBR INTEGER,
    NOMCOBR VARCHAR(60),
    DV CHAR(1),
    CODCIUD CHAR(5),
    NOMCIUD VARCHAR(60),
    SUCURSAL VARCHAR(10),
    NOMSUC VARCHAR(60),
    TIPO INTEGER,
    ID INTEGER,
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    DIAS INTEGER,
    SALDO NUMERIC(18,2),
    CORRIENTE NUMERIC(18,2),
    CERO NUMERIC(18,2),
    TREINTA NUMERIC(18,2),
    SESENTA NUMERIC(18,2),
    NOVENTA NUMERIC(18,2),
    CIENTOCHENTA NUMERIC(18,2),
    DOSSETENTA NUMERIC(18,2),
    TRESSESENTA NUMERIC(18,2),
    PROVISIONAL NUMERIC(18,2),
    TIPONOM VARCHAR(8),
    FECDOC DATE,
    VENCE DATE,
    CUPO NUMERIC(18,2),
    DISPONIBLE NUMERIC(18,2),
    OBS BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    GRUPCOD INTEGER,
    DIA_CAR INTEGER,
    GRUPNOM VARCHAR(30))
AS
DECLARE VARIABLE NITINI VARCHAR(20);
DECLARE VARIABLE NITFIN VARCHAR(20);
DECLARE VARIABLE NOMINI VARCHAR(20);
DECLARE VARIABLE NOMFIN VARCHAR(20);
DECLARE VARIABLE RTFTE NUMERIC(18,2);
DECLARE VARIABLE RTIVA NUMERIC(18,2);
DECLARE VARIABLE RTICA NUMERIC(18,2);
DECLARE VARIABLE VENCIMIENTO VARCHAR(12);
DECLARE VARIABLE OK CHAR(1);
declare variable AUTORET VARCHAR(10);
declare variable FAUTORET DATE;
declare variable INCLANTI CHAR(2);
declare variable descnt_prov char(2);
declare variable MAXDIAS INTEGER;
BEGIN
if (ORDEN = 'C') then
    BEGIN
    NITINI = DESDE;
    NITFIN = HASTA;
    NOMINI = '';
    NOMFIN = 'zz';
    END
ELSE
    BEGIN
    NOMINI = DESDE;
    NOMFIN = HASTA;
    NITINI = '';
    NITFIN = 'zz';
    END
  /* Ubique el NIT */
EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'FECHA AUTORETENEDOR NO DESCONTAR RETENCIONES DEL SALDO PERO SI CONTABILIZARLAS') returning_values (AUTORET);
if (AUTORET <> '') then
    FAUTORET = CAST(AUTORET AS DATE);
else
    FAUTORET = '9999/12/31';
EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'ANALISIS DE CARTERA CON FECHA FACTURA O VENCIMIENTO') returning_values (VENCIMIENTO);
EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'INCLUIR ANTICIPOS DE CLIENTES EN REPORTES Y CONSULTAS DE CARTERA') returning_values (INCLANTI);
EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'DESCONTAR RECIBOS PROVISIONALES EN INFORMES DE CARTERA') RETURNING_VALUES (:descnt_prov);

FOR select T.TERC_NIT, TERC_NOM, TERC_DV, CLSU_TEL, CLSU_CIUDAD, S.COBR_COD, S.ZONA_COD, T.CIUD_COD, CLIE_CUPO, CLIE_DIAS, CLCU_COD, CLSU_NOMBRE, t.terc_obs, C.GRCA_COD, TERC_CONTACTO, TERC_EMAIL, TERC_FAX, TERC_CEL, CLIE_COD
    from terceros T, CLIENTES C, CLIENTE_SUCURSALES S
    where C.TERC_NIT = T.TERC_NIT AND TERC_CLIE = 'S' AND S.TERC_NIT = C.TERC_NIT and T.TERC_NIT >= :NITINI AND T.TERC_NIT <= :NITFIN AND
        T.TERC_NOM >= :NOMINI AND T.TERC_NOM <= :NOMFIN AND ((:GRUPCART = 0) or (C.GRCA_COD = :GRUPCART))
    INTO :NIT, :NOMBRE, :DV, :TELEFONO, :CIUDAD, :CODCOBR, :CODZONA, :CODCIUD, :CUPO, :DIA_CAR,  :SUCURSAL, :NOMSUC, :obs, :GRUPCOD, :CONTACTO, :EMAIL, :FAX, :CEL, :CODCLI
    DO  
    BEGIN
    SELECT COBR_NOM FROM COBRADORES CB WHERE COBR_COD = :CODCOBR INTO :NOMCOBR;
    SELECT ZONA_NOM FROM ZONAS Z WHERE ZONA_COD = :CODZONA INTO :NOMZONA;
    SELECT CIUD_NOM FROM CIUDADES WHERE CIUD_COD = :CODCIUD INTO :NOMCIUD;
    SELECT GRCA_NOMBRE FROM GRUPO_CARTERA WHERE GRCA_COD = :GRUPCOD INTO :GRUPNOM;
    provisional = 0;
    MAXDIAS = 0;
    OK = 'N';
    if (AGRUPA = 'Z') then
        BEGIN
        if (GRPINI = '') then
            BEGIN
            if ((CODZONA IS NULL) or (CODZONA >= :GRPINI AND CODZONA <= :GRPFIN)) then
                OK = 'S';
            END
        ELSE
            if (CODZONA >= :GRPINI AND CODZONA <= :GRPFIN) then
                OK = 'S';
        END
    if (AGRUPA = 'I') then
        BEGIN
        if (GRPINI = '') then
            BEGIN
            if ((CODCIUD IS NULL) or (CODCIUD >= :GRPINI AND CODCIUD <= :GRPFIN)) then
                OK = 'S';
            END
        ELSE
            if (CODCIUD >= :GRPINI AND CODCIUD <= :GRPFIN) then
                OK = 'S';
        END
    if (AGRUPA = 'N') then
        OK = 'S';
    if (OK = 'S') then
        BEGIN
        DISPONIBLE = CUPO;
        CORRIENTE = 0;
        CERO = 0;
        TREINTA = 0;
        SESENTA = 0;
        NOVENTA = 0;
        CIENTOCHENTA = 0;
        DOSSETENTA = 0;
        TRESSESENTA = 0;
        /* BUSQUE EN SALDOS_DOC_CARTERA LOS QUE TENGAN SALDO > 0 */
        FOR SELECT MVCL_TIPOREF, MVCL_IDREF, MVCL_PREFREF, MVCL_NUMREF, MVCL_FECHA, MVCL_VENCE
            FROM MOVIMIENTO_CLIENTES
            WHERE TERC_NIT = :NIT AND MVCL_SUCURSAL = :SUCURSAL AND MVCL_FECHA <= :FECHA
                AND MVCL_ABONO = 'N' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
            INTO :TIPO, :ID, :PREFIJO, :NUMERO, :FECDOC, :VENCE
            DO
            BEGIN
            if ((inclanti = 'SI') or (TIPO <> 45)) then
                BEGIN
                EXECUTE PROCEDURE saldo_doc_cartera(TIPO, ID, FECHA) returning_values (SALDO);
                if (SALDO <> 0) then
                    BEGIN
                    DISPONIBLE = DISPONIBLE - SALDO;
                    SELECT TIDO_NOMCORTO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPO INTO :TIPONOM;

                    SELECT SUM(SDCA_RTFTE - SDCA_ABRTFTE), SUM(SDCA_RTIVA - SDCA_ABRTIVA), SUM(SDCA_RTICA - SDCA_ABRTICA)
                        FROM SALDOS_DOC_CARTERA WHERE SDCA_TIPOREF = :TIPO AND SDCA_IDREF = :ID
                        INTO :RTFTE, :RTIVA, :RTICA;
                    if (RTFTE IS NULL) then
                        RTFTE = 0;
                    if ((TIPO = 42) or (TIPO = 45) or (TIPO = 33)) THEN
                        BEGIN
                        if (RTFTE > 0) then
                            RTFTE = 0;
                        END
                    ELSE
                        BEGIN
                        if (RTFTE < 0) then
                            RTFTE = 0;
                        END
                    if (FAUTORET <= FECDOC) then
                        RTFTE = 0;
                    if (RTIVA IS NULL) then
                        RTIVA = 0;
                    if ((TIPO = 42) or (TIPO = 45) or (TIPO = 33)) THEN
                        BEGIN
                        if (RTIVA > 0) then
                            RTIVA = 0;
                        END
                    ELSE
                        BEGIN
                        if (RTIVA < 0) then
                            RTIVA = 0;
                        END
                    if (RTICA IS NULL) then
                        RTICA = 0;
                    if ((TIPO = 42) or (TIPO = 45) or (TIPO = 33)) THEN
                        BEGIN
                        if (RTICA > 0) then
                            RTICA = 0;
                        END
                    ELSE
                        BEGIN
                        if (RTICA < 0) then
                            RTICA = 0;
                        END
                    /* AHORA CLASIFIQUE LOS DIAS */
                    if (VENCIMIENTO = 'FECHA') then
                        DIAS = FECHA - FECDOC;
                    ELSE
                        DIAS = FECHA - VENCE;
                    if (MAXDIAS < DIAS) then
                        MAXDIAS = DIAS;
                    if (DETALLE = 'S') then
                        BEGIN
                        CORRIENTE = 0;
                        CERO = 0;
                        TREINTA = 0;
                        SESENTA = 0;
                        NOVENTA = 0;
                        CIENTOCHENTA = 0;
                        DOSSETENTA = 0;
                        tressesenta = 0;
                        END
                    if (DIAS < 0) then
                        CORRIENTE = CORRIENTE + SALDO;
                    ELSE
                        if (DIAS < DIASR) then
                            CERO = CERO + SALDO;
                        ELSE
                            if (DIAS < (DIASR * 2)) then
                                TREINTA = TREINTA + SALDO;
                            ELSE
                                if (DIAS < (DIASR * 3)) then
                                    SESENTA = SESENTA + SALDO;
                                ELSE
                                    BEGIN
                                    if (EXTENDIDA = 'N') then
                                        NOVENTA = NOVENTA + SALDO;
                                    else    
                                        BEGIN
                                        if (DIAS < (DIASR * 3) * 2) then
                                            NOVENTA = NOVENTA + SALDO;
                                        ELSE
                                            if (DIAS < (DIASR * 3) * 3) then
                                                CIENTOCHENTA = CIENTOCHENTA + SALDO;
                                            ELSE
                                                if (DIAS < (DIASR * 3) * 4) then
                                                    dossetenta = dossetenta + SALDO;
                                            ELSE
                                                tressesenta = tressesenta + SALDO;
                                        END
                                    END
                    if (DETALLE = 'S') then
                        SUSPEND;
                    END /* SALDO */
                END /* NO ANTICIPO */
            END /* FOR MOV_CLI */
        /* AGREGUE LOS RECIBOS PROVISIONALES CON SIGNO NEGATIVO */
        FOR SELECT 65, MAX(P.RCPR_ID), MAX(PREF_PRE), MAX(RCPR_NUMERO), MAX(RCPR_FECHA), SUM(RPDE_ABONO * -1), SUM(RPDE_RTFTE*-1), SUM(RPDE_RTIVA*-1), SUM(RPDE_RTICA*-1)
            FROM RECIBO_PROVISIONAL P, recibo_provisional_detalle D
            WHERE P.rcpr_id = D.rcpr_id AND P.TERC_NIT = :NIT AND D.RPDE_SUCURSAL = :SUCURSAL AND P.RCPR_FECHA <= :FECHA AND P.RCPR_ANULADO = 'N' AND
            ((RCPR_FECCRUCE IS NULL) or (RCPR_FECCRUCE > :FECHA)) AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
            GROUP BY P.rcpr_id
            INTO :TIPO, :ID, :PREFIJO, :NUMERO, :FECDOC, :PROVISIONAL, :rtfte,  :RTIVA, :RTICA
            DO
            BEGIN
            if (:descnt_prov = 'NO') then
              SALDO = 0;
            else
              SALDO = :PROVISIONAL;
            SELECT TIDO_NOMCORTO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPO INTO :TIPONOM;
            /* CALCULE EL VENCIMIENTO DEL ULTIMO DOCUMENTO POSFECHADO */
            SELECT MAX(RPPA_FECHA) FROM recibo_provisional_pago WHERE RCPR_ID = :ID INTO :VENCE;
            DIAS = VENCE - FECHA;
            if (DETALLE = 'S') then
                BEGIN
                CORRIENTE = 0;
                CERO = 0;
                TREINTA = 0;
                SESENTA = 0;
                NOVENTA = 0;
                CIENTOCHENTA = 0;
                DOSSETENTA = 0;
                tressesenta = 0;
                END
            if (DIAS < 0) then
                CORRIENTE = CORRIENTE + SALDO;
            ELSE
                if (DIAS < DIASR) then
                    CERO = CERO + SALDO;
                ELSE
                    if (DIAS < (DIASR * 2)) then
                        TREINTA = TREINTA + SALDO;
                    ELSE
                        if (DIAS < (DIASR * 3)) then
                            SESENTA = SESENTA + SALDO;
                        ELSE
                            BEGIN
                            if (EXTENDIDA = 'N') then
                                NOVENTA = NOVENTA + SALDO;
                            else
                                BEGIN
                                if (DIAS < (DIASR * 3) * 2) then
                                    CIENTOCHENTA = CIENTOCHENTA + SALDO;
                                ELSE
                                    if (DIAS < (DIASR * 3) * 3) then
                                        DOSSETENTA = DOSSETENTA + SALDO;
                                    ELSE
                                        TRESSESENTA = TRESSESENTA + SALDO;
                                END
                            END
            if (DETALLE = 'S') then
                SUSPEND;
            END
        if (DETALLE = 'N') then
            begin
            SALDO = CORRIENTE + CERO + TREINTA + SESENTA + NOVENTA;
            DIAS = MAXDIAS;
            SUSPEND;
            end
        END
    if (AGRUPA = 'C') then
        BEGIN
        FOR SELECT DISTINCT COBR_COD FROM MOVIMIENTO_CLIENTES
            WHERE TERC_NIT = :NIT AND MVCL_SUCURSAL = :SUCURSAL AND MVCL_FECHA <= :FECHA
                AND MVCL_ABONO = 'N' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
            INTO :codcobr
            DO
            BEGIN
            OK = 'N';
            if (GRPINI = '') then
                BEGIN
                if ((CODCOBR IS NULL) or (CODCOBR >= :GRPINI AND CODCOBR <= :GRPFIN)) then
                    OK = 'S';
                END
            ELSE
                if (CODCOBR >= :GRPINI AND CODCOBR <= :GRPFIN) then
                    OK = 'S';
            if (OK = 'S') then
                BEGIN
                DISPONIBLE = CUPO;
                CORRIENTE = 0;
                CERO = 0;
                TREINTA = 0;
                SESENTA = 0;
                NOVENTA = 0;
                CIENTOCHENTA = 0;
                DOSSETENTA = 0;
                tressesenta = 0;
                SELECT COBR_NOM FROM COBRADORES WHERE COBR_COD = :codcobr INTO :nomcobr;
                /* BUSQUE EN SALDOS_DOC_CARTERA LOS QUE TENGAN SALDO > 0 */
                FOR SELECT MVCL_TIPOREF, MVCL_IDREF, MVCL_PREFREF, MVCL_NUMREF, MVCL_FECHA, MVCL_VENCE
                    FROM MOVIMIENTO_CLIENTES
                    WHERE TERC_NIT = :NIT AND COBR_COD = :CODCOBR AND MVCL_SUCURSAL = :SUCURSAL AND MVCL_FECHA <= :FECHA
                        AND MVCL_ABONO = 'N' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                    INTO :TIPO, :ID, :PREFIJO, :NUMERO, :FECDOC, :VENCE
                    DO
                    BEGIN
                    if ((inclanti = 'SI') or (TIPO <> 45)) then
                        BEGIN
                        EXECUTE PROCEDURE saldo_doc_cartera(TIPO, ID, FECHA) returning_values (SALDO);
                        if (SALDO <> 0) then
                            BEGIN
                            DISPONIBLE = DISPONIBLE - SALDO;
                            SELECT TIDO_NOMCORTO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPO INTO :TIPONOM;
                            SELECT SUM(SDCA_RTFTE - SDCA_ABRTFTE), SUM(SDCA_RTIVA - SDCA_ABRTIVA), SUM(SDCA_RTICA - SDCA_ABRTICA)
                                FROM SALDOS_DOC_CARTERA WHERE SDCA_TIPOREF = :TIPO AND SDCA_IDREF = :ID
                                INTO :RTFTE, :RTIVA, :RTICA;
                            if (RTFTE IS NULL) then
                                RTFTE = 0;
                            if ((TIPO = 42) or (TIPO = 45) or (TIPO = 33)) THEN
                                BEGIN
                                if (RTFTE > 0) then
                                    RTFTE = 0;
                                END
                            ELSE
                                BEGIN
                                if (RTFTE < 0) then
                                    RTFTE = 0;
                                END
                            if (FAUTORET <= FECDOC) then
                                RTFTE = 0;
                            if (RTIVA IS NULL) then
                                RTIVA = 0;
                            if ((TIPO = 42) or (TIPO = 45) or (TIPO = 33)) THEN
                                BEGIN
                                if (RTIVA > 0) then
                                    RTIVA = 0;
                                END
                            ELSE
                                BEGIN
                                if (RTIVA < 0) then
                                    RTIVA = 0;
                                END
                            if (RTICA IS NULL) then
                                RTICA = 0;
                            if ((TIPO = 42) or (TIPO = 45) or (TIPO = 33)) THEN
                                BEGIN
                                if (RTICA > 0) then
                                    RTICA = 0;
                                END
                            ELSE
                                BEGIN
                                if (RTICA < 0) then
                                    RTICA = 0;
                                END
                            /* AHORA CLASIFIQUE LOS DIAS */
                            if (VENCIMIENTO = 'FECHA') then
                                DIAS = FECHA - FECDOC;
                            ELSE
                                DIAS = FECHA - VENCE;
                            if (MAXDIAS < DIAS) then
                                MAXDIAS = DIAS;
                            if (DETALLE = 'S') then
                                BEGIN
                                CORRIENTE = 0;
                                CERO = 0;
                                TREINTA = 0;
                                SESENTA = 0;
                                NOVENTA = 0;
                                CIENTOCHENTA = 0;
                                DOSSETENTA = 0;
                                tressesenta = 0;
                                END
                            if (DIAS < 0) then
                                CORRIENTE = CORRIENTE + SALDO;
                            ELSE
                                if (DIAS < DIASR) then
                                    CERO = CERO + SALDO;
                                ELSE
                                    if (DIAS < (DIASR * 2)) then
                                        TREINTA = TREINTA + SALDO;
                                    ELSE
                                        if (DIAS < (DIASR * 3)) then
                                            SESENTA = SESENTA + SALDO;
                                        ELSE
                                            BEGIN
                                            if (EXTENDIDA = 'N') then
                                                NOVENTA = NOVENTA + SALDO;
                                            else    
                                                BEGIN
                                                if (DIAS < (DIASR * 3) * 2) then
                                                    CIENTOCHENTA = CIENTOCHENTA + SALDO;
                                                ELSE
                                                    if (DIAS < (DIASR * 3) * 3) then
                                                        DOSSETENTA = DOSSETENTA + SALDO;
                                                    ELSE
                                                        TRESSESENTA = TRESSESENTA + SALDO;
                                                END
                                            END
                            if (DETALLE = 'S') then
                                SUSPEND;
                            END /* SALDO <>  0 */
                        END /* NO ANTICIPO */
                    END /* FOR MOV_CLI */
                /* AGREGUE LOS RECIBOS PROVISIONALES CON SIGNO NEGATIVO */
                FOR SELECT 65, MAX(P.RCPR_ID), MAX(PREF_PRE), MAX(RCPR_NUMERO), MAX(RCPR_FECHA), SUM(RPDE_ABONO * -1), SUM(RPDE_RTFTE*-1), SUM(RPDE_RTIVA*-1), SUM(RPDE_RTICA*-1)
                    FROM RECIBO_PROVISIONAL P, recibo_provisional_detalle D
                    WHERE P.rcpr_id = D.rcpr_id AND P.TERC_NIT = :NIT AND RPDE_SUCURSAL = :SUCURSAL AND P.VEND_COD = :CODCOBR AND P.RCPR_FECHA <= :FECHA AND P.RCPR_ANULADO = 'N' AND
                    ((RCPR_FECCRUCE IS NULL) or (RCPR_FECCRUCE > :FECHA)) AND ((SUCU_ID = :SUBEMPRESA) OR (:SUBEMPRESA = 0))
                    GROUP BY P.rcpr_id
                    INTO :TIPO, :ID, :PREFIJO, :NUMERO, :FECDOC, :PROVISIONAL, :rtfte,  :RTIVA, :RTICA
                    DO
                    BEGIN
                    if (:descnt_prov = 'NO') then
                      SALDO = 0;
                    else
                      SALDO = :PROVISIONAL;
                    SELECT TIDO_NOMCORTO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPO INTO :TIPONOM;
                    /* CALCULE EL VENCIMIENTO DEL ULTIMO DOCUMENTO POSFECHADO */
                    SELECT MAX(RPPA_FECHA) FROM recibo_provisional_pago WHERE RCPR_ID = :ID INTO :VENCE;
                    DIAS = VENCE - FECHA;
                    if (DETALLE = 'S') then
                        BEGIN
                        CORRIENTE = 0;
                        CERO = 0;
                        TREINTA = 0;
                        SESENTA = 0;
                        NOVENTA = 0;
                        CIENTOCHENTA = 0;
                        DOSSETENTA = 0;
                        tressesenta = 0;
                        END
                    if (DIAS < 0) then
                        CORRIENTE = CORRIENTE + SALDO;
                    ELSE
                        if (DIAS < DIASR) then
                            CERO = CERO + SALDO;
                        ELSE
                            if (DIAS < (DIASR * 2)) then
                                TREINTA = TREINTA + SALDO;
                            ELSE
                                if (DIAS < (DIASR * 3)) then
                                    SESENTA = SESENTA + SALDO;
                                ELSE
                                    BEGIN
                                    if (EXTENDIDA = 'N') then
                                        NOVENTA = NOVENTA + SALDO;
                                    else    
                                        BEGIN
                                        if (DIAS < (DIASR * 3) * 2) then
                                            CIENTOCHENTA = CIENTOCHENTA + SALDO;
                                        ELSE
                                            if (DIAS < (DIASR * 3) * 3) then
                                                DOSSETENTA = DOSSETENTA + SALDO;
                                            ELSE
                                                TRESSESENTA = TRESSESENTA + SALDO;
                                        END
                                    END
                    if (DETALLE = 'S') then
                        SUSPEND;
                    END
                if (DETALLE = 'N') then
                    begin
                    SALDO = CORRIENTE + CERO + TREINTA + SESENTA + NOVENTA;
                    DIAS = MAXDIAS;
                    SUSPEND;
                    end
                END
            END /* FOR COBRADOR */
        END
    END /* FOR NIT */
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_CARTERA_CONSOLIDADA(
    DESDE VARCHAR(20),
    HASTA VARCHAR(20),
    GRPINI VARCHAR(5),
    GRPFIN VARCHAR(5),
    FECHA DATE,
    ORDEN CHAR(1),
    AGRUPA CHAR(1),
    SUBEMPRESA INTEGER,
    GRUPCART INTEGER)
RETURNS (
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    TELEFONO VARCHAR(40),
    CIUDAD VARCHAR(40),
    EMAIL VARCHAR(100),
    FAX VARCHAR(25),
    CEL VARCHAR(25),
    CODCLI VARCHAR(20),
    CODZONA VARCHAR(2),
    NOMZONA VARCHAR(60),
    CODCOBR INTEGER,
    NOMCOBR VARCHAR(60),
    SUCURSAL VARCHAR(10),
    DV CHAR(1),
    CODCIUD CHAR(5),
    NOMCIUD VARCHAR(60),
    SALDO NUMERIC(18,2),
    RTFTE NUMERIC(18,2),
    RTIVA NUMERIC(18,2),
    RTICA NUMERIC(18,2),
    DTOF NUMERIC(18,2),
    CUPO NUMERIC(18,2),
    DISPONIBLE NUMERIC(18,2),
    PROVISIONAL NUMERIC(18,2),
    CONTACTO VARCHAR(60),
    ESTADO CHAR(1),
    GRUPCOD INTEGER,
    GRUPNOM VARCHAR(30))
AS
declare variable NITINI VARCHAR(20);
declare variable NITFIN VARCHAR(20);
declare variable NOMINI VARCHAR(20);
declare variable NOMFIN VARCHAR(20);
declare variable OK CHAR(1);
declare variable PSALDO NUMERIC(18,2);
declare variable PRTFTE NUMERIC(18,2);
declare variable PRTIVA NUMERIC(18,2);
declare variable PRTICA NUMERIC(18,2);
declare variable PDTOF NUMERIC(18,2);
declare variable TIPO INTEGER;
declare variable ID INTEGER;
declare variable DTOAPL NUMERIC(18,2);
declare variable FECDTO DATE;
declare variable descnt_prov char(2);
declare variable AUTORET VARCHAR(10);
declare variable FAUTORET DATE;
declare variable FECDOC DATE;
declare variable INCLANTI CHAR(2);
BEGIN
if (ORDEN = 'C') then
    BEGIN
    NITINI = DESDE;
    NITFIN = HASTA;
    NOMINI = '';
    NOMFIN = 'zz';
    END
ELSE
    BEGIN
    NOMINI = DESDE;
    NOMFIN = HASTA;
    NITINI = '';
    NITFIN = 'zz';
    END
  EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'DESCONTAR RECIBOS PROVISIONALES EN INFORMES DE CARTERA') RETURNING_VALUES (:descnt_prov);
  EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'INCLUIR ANTICIPOS DE CLIENTES EN REPORTES Y CONSULTAS DE CARTERA') returning_values (INCLANTI);
  EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'FECHA AUTORETENEDOR NO DESCONTAR RETENCIONES DEL SALDO PERO SI CONTABILIZARLAS') returning_values (AUTORET);
  if (AUTORET <> '') then
    FAUTORET = CAST(AUTORET AS DATE);
  else
    FAUTORET = '9999/12/31';
  /* Ubique el NIT */
  FOR select C.TERC_NIT, CLSU_NOMBRE, TERC_DV, CLSU_TEL, CLSU_CIUDAD, TERC_CONTACTO, S.COBR_COD, S.ZONA_COD, T.CIUD_COD, CLIE_CUPO, CLIE_ESTADO, CLCU_COD, C.GRCA_COD, TERC_EMAIL, TERC_FAX, TERC_CEL, CLIE_COD
    from terceros T, CLIENTES C, CLIENTE_SUCURSALES S
    where C.TERC_NIT = T.TERC_NIT AND TERC_CLIE = 'S' AND S.TERC_NIT = C.TERC_NIT AND C.TERC_NIT >= :NITINI AND C.TERC_NIT <= :NITFIN AND
        TERC_NOM >= :NOMINI AND TERC_NOM <= :NOMFIN AND ((:GRUPCART = 0) or (C.GRCA_COD = :GRUPCART))
    INTO :NIT, :NOMBRE, :DV, :TELEFONO, :CIUDAD, :CONTACTO, :CODCOBR, :CODZONA, :CODCIUD, :CUPO, :ESTADO, :SUCURSAL, :GRUPCOD, :EMAIL, :FAX, :CEL, :CODCLI
    DO  
    BEGIN
    SELECT GRCA_NOMBRE FROM GRUPO_CARTERA WHERE GRCA_COD = :GRUPCOD INTO :GRUPNOM;
    OK = 'N';
    if (AGRUPA = 'Z') then
        BEGIN
        if (GRPINI = '') then
            BEGIN
            if ((CODZONA IS NULL) or (CODZONA >= :GRPINI AND CODZONA <= :GRPFIN)) then
                OK = 'S';
            END
        ELSE
            if (CODZONA >= :GRPINI AND CODZONA <= :GRPFIN) then
                OK = 'S';
        END
    if (AGRUPA = 'I') then
        BEGIN
        if (GRPINI = '') then
            BEGIN
            if ((CODCIUD IS NULL) or (CODCIUD >= :GRPINI AND CODCIUD <= :GRPFIN)) then
                OK = 'S';
            END
        ELSE
            if (CODCIUD >= :GRPINI AND CODCIUD <= :GRPFIN) then
                OK = 'S';
        END
    if (AGRUPA = 'N') then
        OK = 'S';
        
    if (OK = 'S') then
        BEGIN
        if (CODCOBR IS NOT NULL) then
            SELECT COBR_NOM FROM COBRADORES  WHERE COBR_COD = :CODCOBR INTO :NOMCOBR;
        if (CODZONA IS NOT NULL) then
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :CODZONA INTO :NOMZONA;
        if (CODCIUD IS NOT NULL) then
            SELECT CIUD_NOM FROM CIUDADES  WHERE CIUD_COD = :CODCIUD INTO :NOMCIUD;
    
        SALDO = 0;
        RTFTE = 0;
        RTIVA = 0;
        RTICA = 0;
        DTOF = 0;
        /* BUSQUE EN SALDOS_DOC_CARTERA LOS QUE TENGAN SALDO > 0 */
        FOR SELECT MVCL_TIPOREF, MVCL_IDREF, MVCL_FECHA
          FROM MOVIMIENTO_CLIENTES WHERE TERC_NIT = :NIT AND MVCL_SUCURSAL = :SUCURSAL AND MVCL_FECHA <= :FECHA AND
          MVCL_ABONO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
          INTO :TIPO, :ID, :FECDOC
          DO
            BEGIN
            if ((inclanti = 'SI') or (TIPO <> 45)) then
                BEGIN
                EXECUTE PROCEDURE saldo_doc_cartera(TIPO, ID, FECHA) returning_values (PSALDO);
                if (PSALDO <> 0) then
                    BEGIN
                    if (TIPO = 41) then
                        SELECT NDCL_DTOFMONTO, NDCL_FECHADTO FROM NOTAS_DEBITO_CLIENTES WHERE NDCL_ID = :ID INTO :PDTOF, :FECDTO;
                    if (TIPO = 42) then
                        SELECT 0, NCCL_FECHA FROM NOTAS_CREDITO_CLIENTES WHERE NCCL_ID = :ID INTO :PDTOF, :FECDTO;
                    if (TIPO = 45) then
                        SELECT ANCL_DTOFMONTO, ANCL_DTOFECHA FROM ANTICIPOS_CLIENTE WHERE ANCL_ID = :ID INTO :PDTOF, :FECDTO;
                    if (TIPO = 31) then
                        SELECT FACT_DTOFMONTO, FACT_DTOFFECHA FROM FACTURAS WHERE FACT_ID = :ID INTO :PDTOF, :FECDTO;
                    if (TIPO = 33) then
                        SELECT 0, DEVT_FECHA FROM devoluciones_ventas WHERE DEVT_ID = :ID INTO :PDTOF, :FECDTO;
                    if (PDTOF IS NULL) then
                        PDTOF = 0;
                    if (PDTOF <> 0) then
                        BEGIN
                        SELECT SUM(RCDE_DTOF) FROM RECIBOS_CAJA_DETALLE WHERE RCDE_IDDOC = :ID AND RCDE_TIPODOC = :TIPO INTO :DTOAPL;
                        if (DTOAPL IS NULL) then
                            DTOAPL = 0;
                        PDTOF = PDTOF - DTOAPL;
                        /* SI YA SE VENCIO DEJELO EN CERO */
                        if (FECDTO < FECHA) then
                            PDTOF = 0;
                        END
                    SELECT SUM(SDCA_RTFTE - SDCA_ABRTFTE), SUM(SDCA_RTIVA - SDCA_ABRTIVA), SUM(SDCA_RTICA - SDCA_ABRTICA)
                        FROM SALDOS_DOC_CARTERA WHERE SDCA_TIPOREF = :TIPO AND SDCA_IDREF = :ID
                        INTO :PRTFTE, :PRTIVA, :PRTICA;
                    if (PRTFTE IS NULL) then
                        PRTFTE = 0;
                    if ((TIPO = 42) or (TIPO = 45) or (TIPO = 33)) THEN
                        BEGIN
                        if (PRTFTE > 0) then
                            PRTFTE = 0;
                        END
                    ELSE    
                        BEGIN
                        if (PRTFTE < 0) then
                            PRTFTE = 0;
                        END
                    if (PRTIVA IS NULL) then
                        PRTIVA = 0;
                    if ((TIPO = 42) or (TIPO = 45) or (TIPO = 33)) THEN
                        BEGIN
                        if (PRTIVA > 0) then
                            PRTIVA = 0;
                        END
                    ELSE
                        BEGIN
                        if (PRTIVA < 0) then
                            PRTIVA = 0;
                        END
                    if (PRTICA IS NULL) then
                        PRTICA = 0;
                    if ((TIPO = 42) or (TIPO = 45) or (TIPO = 33)) THEN
                        BEGIN
                        if (PRTICA > 0) then
                            PRTICA = 0;
                        END
                    ELSE
                        BEGIN
                        if (PRTICA < 0) then
                            PRTICA = 0;
                        END

                    if (FAUTORET <= FECDOC) then
                        PRTFTE = 0;

                    SALDO = SALDO + PSALDO;
                    RTFTE = RTFTE + PRTFTE;
                    RTIVA = RTIVA + PRTIVA;
                    RTICA = RTICA + PRTICA;
                    DTOF = DTOF + PDTOF;
                    END /* SALDO <> 0 */
                END /* NO ANTICIPO */
            END
        DISPONIBLE = CUPO - SALDO;
        /* LOS RECIBOS PROVISIONALES */
        SELECT SUM(RPDE_ABONO) FROM recibo_provisional P, recibo_provisional_detalle D
            WHERE P.rcpr_id = D.rcpr_id AND TERC_NIT = :NIT AND RPDE_SUCURSAL = :SUCURSAL AND
            RCPR_FECHA <= :FECHA AND RCPR_ANULADO = 'N' AND ((RCPR_FECCRUCE IS NULL) or (RCPR_FECCRUCE > :FECHA)) AND
            ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            INTO :provisional;
           if (:descnt_prov = 'SI') then
             if (NOT :provisional is NULL) then
              SALDO = :saldo - :PROVISIONAL;
        SUSPEND;
        END
    if (AGRUPA = 'C') then
        BEGIN
        if (CODZONA IS NOT NULL) then
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :CODZONA INTO :NOMZONA;
        if (CODCIUD IS NOT NULL) then
            SELECT CIUD_NOM FROM CIUDADES  WHERE CIUD_COD = :CODCIUD INTO :NOMCIUD;
        FOR SELECT DISTINCT COBR_COD FROM MOVIMIENTO_CLIENTES WHERE TERC_NIT = :NIT AND
            MVCL_SUCURSAL = :SUCURSAL AND MVCL_FECHA <= :FECHA AND
            MVCL_ABONO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            INTO :codcobr
            DO
            begin
            OK = 'N';
            if (GRPINI = '') then
                BEGIN
                if ((CODCOBR IS NULL) or (CODCOBR >= :GRPINI AND CODCOBR <= :GRPFIN)) then
                    OK = 'S';
                END
            ELSE
                if (CODCOBR >= :GRPINI AND CODCOBR <= :GRPFIN) then
                    OK = 'S';
            if (OK = 'S') then
                BEGIN
                SELECT COBR_NOM FROM COBRADORES  WHERE COBR_COD = :CODCOBR INTO :NOMCOBR;

                SALDO = 0;
                RTFTE = 0;
                RTIVA = 0;
                RTICA = 0;
                DTOF = 0;
                /* BUSQUE EN SALDOS_DOC_CARTERA LOS QUE TENGAN SALDO > 0 */
                FOR SELECT MVCL_TIPOREF, MVCL_IDREF, MVCL_FECHA
                  FROM MOVIMIENTO_CLIENTES WHERE TERC_NIT = :NIT AND MVCL_SUCURSAL = :SUCURSAL AND
                  MVCL_FECHA <= :FECHA AND COBR_COD = :codcobr AND MVCL_ABONO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                  INTO :TIPO, :ID, :FECDOC
                  DO
                    BEGIN
                    if ((inclanti = 'SI') or (TIPO <> 45)) then
                        BEGIN
                        EXECUTE PROCEDURE saldo_doc_cartera(TIPO, ID, FECHA) returning_values (PSALDO);
                        if (PSALDO <> 0) then
                            BEGIN
                            if (TIPO = 41) then
                                SELECT NDCL_DTOFMONTO, NDCL_FECHADTO FROM NOTAS_DEBITO_CLIENTES WHERE NDCL_ID = :ID INTO :PDTOF, :FECDTO;
                            if (TIPO = 42) then
                                SELECT 0, NCCL_FECHA FROM NOTAS_CREDITO_CLIENTES WHERE NCCL_ID = :ID INTO :PDTOF, :FECDTO;
                            if (TIPO = 45) then
                                SELECT ANCL_DTOFMONTO, ANCL_DTOFECHA FROM ANTICIPOS_CLIENTE WHERE ANCL_ID = :ID INTO :PDTOF, :FECDTO;
                            if (TIPO = 31) then
                                SELECT FACT_DTOFMONTO, FACT_DTOFFECHA FROM FACTURAS WHERE FACT_ID = :ID INTO :PDTOF, :FECDTO;
                            if (TIPO = 33) then
                                SELECT 0, DEVT_FECHA FROM devoluciones_ventas WHERE DEVT_ID = :ID INTO :PDTOF, :FECDTO;
                            if (PDTOF IS NULL) then
                                PDTOF = 0;
                            if (PDTOF <> 0) then
                                BEGIN
                                SELECT SUM(RCDE_DTOF) FROM RECIBOS_CAJA_DETALLE WHERE RCDE_IDDOC = :ID AND RCDE_TIPODOC = :TIPO INTO :DTOAPL;
                                if (DTOAPL IS NULL) then
                                    DTOAPL = 0;
                                PDTOF = PDTOF - DTOAPL;
                                /* SI YA SE VENCIO DEJELO EN CERO */
                                if (FECDTO < FECHA) then
                                    PDTOF = 0;
                                END
                            SELECT SUM(SDCA_RTFTE - SDCA_ABRTFTE), SUM(SDCA_RTIVA - SDCA_ABRTIVA), SUM(SDCA_RTICA - SDCA_ABRTICA)
                                FROM SALDOS_DOC_CARTERA WHERE SDCA_TIPOREF = :TIPO AND SDCA_IDREF = :ID
                                INTO :PRTFTE, :PRTIVA, :PRTICA;
                            if (PRTFTE IS NULL) then
                                PRTFTE = 0;
                            if ((TIPO = 42) or (TIPO = 45) or (TIPO = 33)) THEN
                                BEGIN
                                if (PRTFTE > 0) then
                                    PRTFTE = 0;
                                END
                            ELSE
                                BEGIN
                                if (PRTFTE < 0) then
                                    PRTFTE = 0;
                                END
                            if (PRTIVA IS NULL) then
                                PRTIVA = 0;
                            if ((TIPO = 42) or (TIPO = 45) or (TIPO = 33)) THEN
                                BEGIN
                                if (PRTIVA > 0) then
                                    PRTIVA = 0;
                                END
                            ELSE
                                BEGIN
                                if (PRTIVA < 0) then
                                    PRTIVA = 0;
                                END
                            if (PRTICA IS NULL) then
                                PRTICA = 0;
                            if ((TIPO = 42) or (TIPO = 45) or (TIPO = 33)) THEN
                                BEGIN
                                if (PRTICA > 0) then
                                    PRTICA = 0;
                                END
                            ELSE
                                BEGIN
                                if (PRTICA < 0) then
                                    PRTICA = 0;
                                END
                            if (FAUTORET <= FECDOC) then
                                PRTFTE = 0;
                            SALDO = SALDO + PSALDO;
                            RTFTE = RTFTE + PRTFTE;
                            RTIVA = RTIVA + PRTIVA;
                            RTICA = RTICA + PRTICA;
                            DTOF = DTOF + PDTOF;
                            END  /* SALDO <> 0 */
                        END /* NO ANTICIPO */
                    END
                DISPONIBLE = CUPO - SALDO;
                /* LOS RECIBOS PROVISIONALES */
                SELECT SUM(RPDE_ABONO) FROM RECIBO_PROVISIONAL P, recibo_provisional_detalle D
                    WHERE P.rcpr_id = D.rcpr_id AND TERC_NIT = :NIT AND RPDE_SUCURSAL = :SUCURSAL AND
                    VEND_COD = :CODCOBR AND RCPR_FECHA <= :FECHA AND RCPR_ANULADO = 'N' AND ((RCPR_FECCRUCE IS NULL) or (RCPR_FECCRUCE > :FECHA)) AND 
                    ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                    INTO :provisional;
                  if (:descnt_prov = 'SI') then
                   if (NOT :provisional IS NULL) then
                    SALDO = :saldo - :PROVISIONAL;
                if (AUTORET = 'SI') then
                    BEGIN
                    RTFTE = 0;
                    RTIVA = 0;
                    RTICA = 0;
                    END
                SUSPEND;
                END /* OK = S */
            END /* FOR COBRADOR */
        END /* AGRUPA = C */
    END /* FOR NIT */
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_CARTERA_NOTAS(
    DESDE VARCHAR(20),
    HASTA VARCHAR(20),
    GRPINI VARCHAR(5),
    GRPFIN VARCHAR(5),
    FECHA DATE,
    ORDEN CHAR(1),
    AGRUPA CHAR(1),
    SUBEMPRESA INTEGER,
    VENCEINI DATE,
    VENCEFIN DATE,
    GRUPCART INTEGER)
RETURNS (
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    TELEFONO VARCHAR(40),
    CIUDAD VARCHAR(40),
    CODZONA VARCHAR(2),
    NOMZONA VARCHAR(60),
    CODCOBR INTEGER,
    NOMCOBR VARCHAR(60),
    SUCURSAL VARCHAR(10),
    DV CHAR(1),
    CODCIUD CHAR(5),
    NOMCIUD VARCHAR(60),
    SALDO NUMERIC(18,2),
    NOTA1 VARCHAR(256),
    NOTA2 VARCHAR(256),
    CUPO NUMERIC(18,2),
    DISPONIBLE NUMERIC(18,2),
    PROVISIONAL NUMERIC(18,2),
    CONTACTO VARCHAR(60),
    ESTADO CHAR(1),
    GRUPCOD INTEGER,
    GRUPNOM VARCHAR(30))
AS
declare variable NITINI VARCHAR(20);
declare variable NITFIN VARCHAR(20);
declare variable NOMINI VARCHAR(20);
declare variable NOMFIN VARCHAR(20);
declare variable OK CHAR(1);
declare variable PSALDO NUMERIC(18,2);
declare variable TIPO INTEGER;
declare variable ID INTEGER;
declare variable NOTA VARCHAR(277);
declare variable TIPODOC VARCHAR(8);
declare variable NUMDOC VARCHAR(10);
declare variable FECNOTA VARCHAR(10);
declare variable I INTEGER;
declare variable INCLANTI CHAR(2);
BEGIN
if (ORDEN = 'C') then
    BEGIN
    NITINI = DESDE;
    NITFIN = HASTA;
    NOMINI = '';
    NOMFIN = 'zz';
    END
ELSE
    BEGIN
    NOMINI = DESDE;
    NOMFIN = HASTA;
    NITINI = '';
    NITFIN = 'zz';
    END
  EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'INCLUIR ANTICIPOS DE CLIENTES EN REPORTES Y CONSULTAS DE CARTERA') returning_values (INCLANTI);
  /* Ubique el NIT */
  FOR select T.TERC_NIT, CLSU_NOMBRE, TERC_DV, CLSU_TEL, CLSU_CIUDAD, TERC_CONTACTO, S.COBR_COD, S.ZONA_COD, CIUD_COD, CLIE_CUPO, CLIE_ESTADO, CLCU_COD, C.GRCA_COD
    from terceros T, CLIENTES C, CLIENTE_SUCURSALES S
    where C.TERC_NIT = T.TERC_NIT AND TERC_CLIE = 'S' AND S.TERC_NIT = C.TERC_NIT AND T.TERC_NIT >= :NITINI AND T.TERC_NIT <= :NITFIN AND
        TERC_NOM >= :NOMINI AND TERC_NOM <= :NOMFIN AND ((:GRUPCART = 0) or (C.GRCA_COD = :GRUPCART))
    INTO :NIT, :NOMBRE, :DV, :TELEFONO, :CIUDAD, :CONTACTO, :CODCOBR, :CODZONA, :CODCIUD, :CUPO, :ESTADO, :SUCURSAL, :GRUPCOD
    DO  
    BEGIN
    SELECT GRCA_NOMBRE FROM GRUPO_CARTERA WHERE GRCA_COD = :GRUPCOD INTO :GRUPNOM;
    OK = 'N';
    if (AGRUPA = 'Z') then
        BEGIN
        if (GRPINI = '') then
            BEGIN
            if ((CODZONA IS NULL) or (CODZONA >= :GRPINI AND CODZONA <= :GRPFIN)) then
                OK = 'S';
            END
        ELSE
            if (CODZONA >= :GRPINI AND CODZONA <= :GRPFIN) then
                OK = 'S';
        END
    if (AGRUPA = 'I') then
        BEGIN
        if (GRPINI = '') then
            BEGIN
            if ((CODCIUD IS NULL) or (CODCIUD >= :GRPINI AND CODCIUD <= :GRPFIN)) then
                OK = 'S';
            END
        ELSE
            if (CODCIUD >= :GRPINI AND CODCIUD <= :GRPFIN) then
                OK = 'S';
        END
    if (AGRUPA = 'N') then
        OK = 'S';
        
    if (OK = 'S') then
        BEGIN
        if (CODCOBR IS NOT NULL) then
            SELECT COBR_NOM FROM COBRADORES  WHERE COBR_COD = :CODCOBR INTO :NOMCOBR;
        if (CODZONA IS NOT NULL) then
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :CODZONA INTO :NOMZONA;
        if (CODCIUD IS NOT NULL) then
            SELECT CIUD_NOM FROM CIUDADES  WHERE CIUD_COD = :CODCIUD INTO :NOMCIUD;
    
        SALDO = 0;
        /* BUSQUE EN SALDOS_DOC_CARTERA LOS QUE TENGAN SALDO > 0 */
        FOR SELECT MVCL_TIPOREF, MVCL_IDREF
          FROM MOVIMIENTO_CLIENTES WHERE TERC_NIT = :NIT AND MVCL_SUCURSAL = :SUCURSAL AND MVCL_FECHA <= :FECHA AND
          MVCL_ABONO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) AND MVCL_VENCE >= :VENCEINI AND MVCL_VENCE <= :VENCEFIN
          INTO :TIPO, :ID
          DO
            if ((inclanti = 'SI') or (TIPO <> 45)) then
                BEGIN
                EXECUTE PROCEDURE saldo_doc_cartera(TIPO, ID, FECHA) returning_values (PSALDO);
                if (PSALDO <> 0) then
                    SALDO = SALDO + PSALDO;
                END
        DISPONIBLE = CUPO - SALDO;
        /* LOS RECIBOS PROVISIONALES */
        SELECT SUM(RPDE_ABONO) FROM RECIBO_PROVISIONAL P, recibo_provisional_detalle D
            WHERE P.rcpr_id = D.rcpr_id AND TERC_NIT = :NIT AND RPDE_SUCURSAL = :SUCURSAL AND
            RCPR_FECHA <= :FECHA AND RCPR_ANULADO = 'N' AND ((RCPR_FECCRUCE IS NULL) or (RCPR_FECCRUCE > :FECHA)) AND
            ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            INTO :provisional;
        /* LAS NOTAS DE CLIENTES */
        I = 0;
        NOTA1 = '';
        NOTA2 = '';
        FOR SELECT CAST(NOCL_FECHA AS VARCHAR(10)), tido_nomcorto, NOCL_NUMDOC, NOCL_TEXTO
            FROM NOTAS_CLIENTES N, TIPO_DOCUMENTO T WHERE N.NOCL_TIPODOC = T.TIDO_COD AND TERC_NIT = :NIT
            AND N.TINO_COD = 3 AND N.CLSU_COD = :SUCURSAL
            ORDER BY NOCL_ID DESC INTO :FECNOTA, :TIPODOC, :NUMDOC, :NOTA
            DO
            BEGIN
            if (I = 0) then
                NOTA1 = NOTA;
            if (I = 1) then
                NOTA2 = NOTA;
            I = I + 1;
            END
        SUSPEND;
        END
    if (AGRUPA = 'C') then
        BEGIN
        if (CODZONA IS NOT NULL) then
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :CODZONA INTO :NOMZONA;
        if (CODCIUD IS NOT NULL) then
            SELECT CIUD_NOM FROM CIUDADES  WHERE CIUD_COD = :CODCIUD INTO :NOMCIUD;
        FOR SELECT DISTINCT COBR_COD FROM MOVIMIENTO_CLIENTES WHERE TERC_NIT = :NIT AND
            MVCL_SUCURSAL = :SUCURSAL AND MVCL_FECHA <= :FECHA AND
            MVCL_ABONO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) AND MVCL_VENCE >= :VENCEINI AND MVCL_VENCE <= :VENCEFIN
            INTO :codcobr
            DO
            begin
            OK = 'N';
            if (GRPINI = '') then
                BEGIN
                if ((CODCOBR IS NULL) or (CODCOBR >= :GRPINI AND CODCOBR <= :GRPFIN)) then
                    OK = 'S';
                END
            ELSE
                if (CODCOBR >= :GRPINI AND CODCOBR <= :GRPFIN) then
                    OK = 'S';
            if (OK = 'S') then
                BEGIN
                SELECT COBR_NOM FROM COBRADORES  WHERE COBR_COD = :CODCOBR INTO :NOMCOBR;

                SALDO = 0;
                /* BUSQUE EN SALDOS_DOC_CARTERA LOS QUE TENGAN SALDO > 0 */
                FOR SELECT MVCL_TIPOREF, MVCL_IDREF
                  FROM MOVIMIENTO_CLIENTES WHERE TERC_NIT = :NIT AND MVCL_SUCURSAL = :SUCURSAL AND
                  MVCL_FECHA <= :FECHA AND COBR_COD = :codcobr AND MVCL_ABONO = 'N' AND
                  ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) AND MVCL_VENCE >= :VENCEINI AND MVCL_VENCE <= :VENCEFIN
                  INTO :TIPO, :ID
                  DO
                    if ((inclanti = 'SI') or (TIPO <> 45)) then
                        BEGIN
                        EXECUTE PROCEDURE saldo_doc_cartera(TIPO, ID, FECHA) returning_values (PSALDO);
                        if (PSALDO <> 0) then
                            BEGIN
                            SALDO = SALDO + PSALDO;
                            END
                        END
                DISPONIBLE = CUPO - SALDO;
                /* LOS RECIBOS PROVISIONALES */
                SELECT SUM(RPDE_ABONO) FROM RECIBO_PROVISIONAL P, recibo_provisional_detalle D
                    WHERE P.rcpr_id = D.rcpr_id AND TERC_NIT = :NIT AND RPDE_SUCURSAL = :SUCURSAL AND
                    VEND_COD = :CODCOBR AND RCPR_FECHA <= :FECHA AND RCPR_ANULADO = 'N' AND ((RCPR_FECCRUCE IS NULL) or (RCPR_FECCRUCE > :FECHA)) AND
                    ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                    INTO :provisional;
                /* LAS NOTAS DE CLIENTES */
                I = 0;
                NOTA1 = '';
                NOTA2 = '';
                FOR SELECT CAST(NOCL_FECHA AS VARCHAR(10)), tido_nomcorto, NOCL_NUMDOC, NOCL_TEXTO
                    FROM NOTAS_CLIENTES N, TIPO_DOCUMENTO T WHERE N.NOCL_TIPODOC = T.TIDO_COD AND TERC_NIT = :NIT
                    AND N.TINO_COD = 3 AND N.CLSU_COD = :SUCURSAL
                    ORDER BY NOCL_FECHA DESC INTO :FECNOTA, :TIPODOC, :NUMDOC, :NOTA
                    DO
                    BEGIN
                    if (I = 0) then
                        NOTA1 = NOTA;
                    if (I = 1) then
                        NOTA2 = NOTA;
                    I = I + 1;
                    END
                SUSPEND;
                END /* OK = S */
            END /* FOR COBRADOR */
        END /* AGRUPA = C */
    END /* FOR NIT */
END
^

SET TERM ; ^

ALTER TABLE RECIBO_PROVISIONAL DROP RCPR_SUCURSAL;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE IMPR_RECICAJA(
    ID INTEGER)
RETURNS (
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    NOMCAJA VARCHAR(60),
    CODCOBR INTEGER,
    NOMCOBR VARCHAR(60),
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    DIR VARCHAR(60),
    CIU VARCHAR(40),
    TEL VARCHAR(40),
    CONCEPTO VARCHAR(60),
    MONTO NUMERIC(18,2),
    RTFTE NUMERIC(18,2),
    RTIVA NUMERIC(18,2),
    RTICA NUMERIC(18,2),
    DSCTO NUMERIC(18,2),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEMDOC INTEGER,
    TIPODOC VARCHAR(8),
    PREFDOC VARCHAR(4),
    NUMDOC VARCHAR(6),
    SUCURSAL VARCHAR(10),
    ABONODOC NUMERIC(18,2),
    RTFTEDOC NUMERIC(18,2),
    RTIVADOC NUMERIC(18,2),
    RTICADOC NUMERIC(18,2),
    DSCTODOC NUMERIC(18,2),
    SALDODOC NUMERIC(18,2),
    ANTERDOC NUMERIC(18,2))
AS
declare variable NUMROWS INTEGER;
declare variable TIPO integer;
declare variable IDDOC INTEGER;
BEGIN
  SELECT PREF_PRE, RECA_NUMERO, RECA_FECHA, CAJA_NOMBRE, RECA_CONC, R.COBR_COD,
        R.TERC_NIT, RECA_NOMTERC, TERC_DIR, TERC_CIU, TERC_TEL,
        RECA_MONTO, RECA_RTFTEMONTO, RECA_RTIVAMONTO, RECA_RTICAMONTO, RECA_DTOF,
        RECA_OBS
  FROM RECIBOS_CAJA R, TERCEROS T, CAJAS C
  WHERE R.TERC_NIT = T.TERC_NIT AND R.CAJA_ID = C.CAJA_ID AND
        R.RECA_ID = :ID
  INTO :PREFIJO, :NUMERO, :FECHA, :NOMCAJA, :CONCEPTO, :CODCOBR,
        :NIT, :NOMBRE, :DIR, :CIU, :TEL,
        :MONTO, :RTFTE, :RTIVA, :RTICA, :DSCTO,
        :OBS;
  SELECT COBR_NOM FROM COBRADORES WHERE COBR_COD = :CODCOBR INTO :NOMCOBR;
  SELECT COUNT(RCDE_ITEM) FROM RECIBOS_CAJA_DETALLE
    WHERE RECA_ID = :ID INTO :NUMROWS;
  if (NUMROWS > 0) then
    FOR SELECT RCDE_ITEM, RCDE_TIPODOC, RCDE_IDDOC, TIDO_NOMCORTO, RCDE_PREFIJO, RCDE_NUMERO,
        RCDE_ABONO, RCDE_RTFTE, RCDE_RTIVA, RCDE_RTICA, RCDE_DTOF, RCDE_SUCURSAL
        FROM RECIBOS_CAJA_DETALLE D, TIPO_DOCUMENTO TD
        WHERE D.RECA_ID = :ID AND TD.TIDO_COD = D.RCDE_TIPODOC
        ORDER BY RCDE_ITEM
        INTO :ITEMDOC, :TIPO, :IDDOC, :TIPODOC, :PREFDOC, :NUMDOC, :ABONODOC, :RTFTEDOC, :RTIVADOC, :RTICADOC, :DSCTODOC, :sucursal
        DO
            BEGIN
            EXECUTE PROCEDURE SALDO_DOC_CARTERA(:TIPO, :IDDOC, :FECHA) returning_values (:SALDODOC);
            ANTERDOC = SALDODOC + RTFTEDOC + RTIVADOC + RTICADOC + ABONODOC + DSCTODOC;
            SUSPEND;
            END
  ELSE
    SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE IMPR_RECIPROV(
    ID INTEGER)
RETURNS (
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    NOMCAJA VARCHAR(60),
    CODCOBR INTEGER,
    NOMCOBR VARCHAR(60),
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    DIR VARCHAR(60),
    CIU VARCHAR(40),
    TEL VARCHAR(40),
    CONCEPTO VARCHAR(60),
    MONTO NUMERIC(18,2),
    RTFTE NUMERIC(18,2),
    RTIVA NUMERIC(18,2),
    RTICA NUMERIC(18,2),
    DSCTO NUMERIC(18,2),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEMDOC INTEGER,
    TIPODOC VARCHAR(8),
    PREFDOC VARCHAR(4),
    NUMDOC VARCHAR(6),
    SUCURSAL VARCHAR(10),
    ABONODOC NUMERIC(18,2),
    RTFTEDOC NUMERIC(18,2),
    RTIVADOC NUMERIC(18,2),
    RTICADOC NUMERIC(18,2),
    DSCTODOC NUMERIC(18,2),
    SALDODOC NUMERIC(18,2),
    ANTERDOC NUMERIC(18,2))
AS
declare variable NUMROWS INTEGER;
declare variable TIPO integer;
BEGIN
  SELECT PREF_PRE, RCPR_NUMERO, RCPR_FECHA, CAJA_NOMBRE, RCPR_CONC, R.VEND_COD,
        R.TERC_NIT, RCPR_NOMTERC, TERC_DIR, TERC_CIU, TERC_TEL,
        RCPR_MONTO, RCPR_RTFTE, RCPR_RTIVA, RCPR_RTICA, RCPR_DTOF,
        RCPR_OBS
  FROM RECIBO_PROVISIONAL R, TERCEROS T, CAJAS C
  WHERE R.TERC_NIT = T.TERC_NIT AND R.CAJA_ID = C.CAJA_ID AND
        R.RCPR_ID = :ID
  INTO :PREFIJO, :NUMERO, :FECHA, :NOMCAJA, :CONCEPTO, :CODCOBR,
        :NIT, :NOMBRE, :DIR, :CIU, :TEL,
        :MONTO, :RTFTE, :RTIVA, :RTICA, :DSCTO,
        :OBS;
  SELECT COBR_NOM FROM COBRADORES WHERE COBR_COD = :CODCOBR INTO :NOMCOBR;
  SELECT COUNT(RPDE_ITEM) FROM RECIBO_PROVISIONAL_DETALLE
    WHERE RCPR_ID = :ID INTO :NUMROWS;
  if (NUMROWS > 0) then
    FOR SELECT RPDE_ITEM, RPDE_TIPODOC, TIDO_NOMCORTO, RPDE_PREFDOC, RPDE_NUMDOC,
        RPDE_ABONO, RPDE_RTFTE, RPDE_RTIVA, RPDE_RTICA, RPDE_DTOF, RPDE_SUCURSAL
        FROM RECIBO_PROVISIONAL_DETALLE D, TIPO_DOCUMENTO TD
        WHERE D.RCPR_ID = :ID AND TD.TIDO_COD = D.RPDE_TIPODOC
        ORDER BY RPDE_ITEM
        INTO :ITEMDOC, :TIPO, :TIPODOC, :PREFDOC, :NUMDOC, :ABONODOC, :RTFTEDOC, :RTIVADOC, :RTICADOC, :DSCTODOC, :SUCURSAL
        DO
            BEGIN
            EXECUTE PROCEDURE SALDO_DOC_CARTERA(:TIPO, :ID, :FECHA) returning_values (:SALDODOC);
            ANTERDOC = SALDODOC + RTFTEDOC + RTIVADOC + RTICADOC + ABONODOC + DSCTODOC;
            SUSPEND;
            END
  ELSE
    SUSPEND;
END
^

SET TERM ; ^


/* 06-10 OBSERVACIONES EN CONSECUTIVOS Y CRONOLOGICO */

SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_CONSECUTIVOS_FAC(
    TIPO INTEGER,
    DETALLE CHAR(1),
    PREINI VARCHAR(4),
    PREFIN VARCHAR(4),
    NUMINI VARCHAR(6),
    NUMFIN VARCHAR(6),
    PTOINI INTEGER,
    PTOFIN INTEGER,
    ANULADOS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    NOMTIPO VARCHAR(30),
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    VENCE DATE,
    CODBOD VARCHAR(2),
    NOMBOD VARCHAR(30),
    AUTORIZA VARCHAR(20),
    PTVTID INTEGER,
    PTVTNOM VARCHAR(60),
    VENDCOD INTEGER,
    VENDNOM VARCHAR(60),
    COMIPORC NUMERIC(9,2),
    COMIMONTO NUMERIC(18,2),
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    PEDIDO VARCHAR(30),
    COTIZACI VARCHAR(30),
    REMISION VARCHAR(30),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    UNIDAD VARCHAR(8),
    BODITEM VARCHAR(2),
    LOTE VARCHAR(15),
    REFERENCIA VARCHAR(60),
    PRECIO NUMERIC(18,2),
    DTOPORCIT NUMERIC(9,2),
    DTOMONTOIT NUMERIC(18,2),
    IVAPORCIT NUMERIC(9,2),
    IVAMONTOIT NUMERIC(18,2),
    CONSUMOIT NUMERIC(18,2),
    SUBTOTALIT NUMERIC(18,2),
    DTOPOR NUMERIC(9,2),
    DTOMONTO NUMERIC(18,2),
    ADICIONAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    RTFTEPOR NUMERIC(9,2),
    RTFTEMONTO NUMERIC(18,2),
    RTIVAPOR NUMERIC(9,2),
    RTIVAMONTO NUMERIC(18,2),
    RTICAPOR NUMERIC(9,2),
    RTICAMONTO NUMERIC(18,2),
    EXTRA NUMERIC(18,2),
    DTOFPOR NUMERIC(9,2),
    DTOFMONTO NUMERIC(18,2),
    DTOFFECHA DATE,
    TOTAL NUMERIC(18,2),
    ANULADO CHAR(1),
    VEHICULO VARCHAR(8))
AS
declare variable descaux varchar(255);
BEGIN
VEHICULO = '';
  /* DETERMINE LA TABLA A EXAMINAR */
  if (BIN_AND(TIPO, 1) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
    /* FACTURA */
    FOR SELECT FACT_ID, F.PREF_PRE, FACT_NUMERO, FACT_FECHA, FACT_VENCE, F.BODE_COD, B.BODE_NOM, F.AUTO_NUMERO, F.PTVT_ID, PTVT_NOM, F.VEND_COD, VEND_NOMBRE, F.FACT_COMIPORC, F.FACT_COMIMONTO, F.TERC_NIT, FACT_NOMCLIENTE, FACT_PEDIDO, FACT_COTIZACI, FACT_REMISION, FACT_DTOPOR, FACT_DTOMONTO, FACT_ADICIONAL, FACT_IVAMONTO, FACT_RTFTEPOR, FACT_RTFTEMONTO, FACT_RTIVAPOR, FACT_RTIVAMONTO, FACT_RTICAPOR, FACT_RTICAMONTO, FACT_EXTRA, FACT_DTOFPOR, FACT_DTOFMONTO, FACT_DTOFFECHA, FACT_TOTAL, FACT_ANULADO, VEHI_COD, FACT_OBS
        FROM FACTURAS F, BODEGA B, PUNTO_VENTA P, VENDEDORES V, PREFIJOS PR WHERE F.PTVT_ID >= :PTOINI AND F.PTVT_ID <= :PTOFIN AND
         F.BODE_COD = B.BODE_COD AND F.PTVT_ID = P.PTVT_ID AND F.VEND_COD = V.VEND_COD AND F.PREF_PRE >= :PREINI AND F.PREF_PRE <= :PREFIN AND FACT_NUMERO >= :NUMINI AND FACT_NUMERO <= :NUMFIN
         AND PR.PREF_PRE = F.PREF_PRE AND PR.TIDO_COD = 31 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY F.PREF_PRE, FACT_NUMERO
        INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :CODBOD, :NOMBOD, :AUTORIZA, :PTVTID, :PTVTNOM, :VENDCOD, :VENDNOM, :COMIPORC, :COMIMONTO, :NIT, :NOMTERCERO, :PEDIDO, :COTIZACI, :REMISION, :DTOPOR, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTFTEPOR, :RTFTEMONTO, :RTIVAPOR, :RTIVAMONTO, :RTICAPOR, :RTICAMONTO, :EXTRA, :DTOFPOR, :DTOFMONTO, :DTOFFECHA, :TOTAL, :ANULADO, :VEHICULO, :OBS
        DO
        BEGIN
        if ((ANULADOS = 'S') or (ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
                BEGIN
                COMIPORC = 0;
                COMIMONTO = 0;
                DTOPOR = 0;
                DTOMONTO = 0;
                ADICIONAL = 0;
                IVAMONTO = 0;
                RTFTEPOR = 0;
                RTFTEMONTO = 0;
                RTIVAPOR = 0;
                RTIVAMONTO = 0;
                RTICAPOR = 0;
                RTICAMONTO = 0;
                EXTRA = 0;
                DTOFPOR = 0;
                DTOFMONTO = 0;
                TOTAL = 0;
                END
            if (DETALLE = 'S') then
                BEGIN
                if (anulado = 'S') then
                    BEGIN
                    ITEM = 0;
                    ARTICULO = '';
                    CODBAR = '';
                    ARTIDES = '';
                    CANT = 0;
                    UNIDAD = '';
                    BODITEM = '';
                    LOTE = '';
                    REFERENCIA = '';
                    PRECIO = 0;
                    DTOPORCIT = 0;
                    DTOMONTOIT = 0;
                    IVAPORCIT = 0;
                    IVAMONTOIT = 0;
                    CONSUMOIT = 0;
                    SUBTOTALIT = 0;
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    FOR SELECT FADE_ITEM, ARTI_COD, FADE_CODBAR, FADE_DESC, FADE_CANT, FADE_UNIDAD, BODE_COD, FADE_LOTE, FADE_REFERENCIA, FADE_PRUNIT, FADE_DTOPORC, FADE_DTOMONTO, FADE_IVAPORC, FADE_IVAMONTO, FADE_CONSUMO, FADE_TOTAL
                        FROM FACTURAS_DETALLE
                        WHERE FACT_ID = :ID
                        ORDER BY FADE_ITEM
                        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :REFERENCIA, :PRECIO, :DTOPORCIT, :DTOMONTOIT, :IVAPORCIT, :IVAMONTOIT, :CONSUMOIT, :SUBTOTALIT
                        DO
                        SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
            END
        END
    END
  if (BIN_AND(TIPO, 2) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
    /* REMISION */
    FOR SELECT REVT_ID, R.PREF_PRE, REVT_NUMERO, REVT_FECHA, REVT_FECHA, R.BODE_COD, B.BODE_NOM, '', R.PTVT_ID, PTVT_NOM, R.VEND_COD, VEND_NOMBRE, 0, 0, R.TERC_NIT, REVT_NOMTERC, '', '', '', 0, 0, 0, REVT_IVAMONTO, 0, 0, 0, 0, 0, 0, 0, 0, 0, REVT_FECHA, REVT_TOTAL, REVT_ANULADO, REVT_OBS
        FROM REMISIONES_VENTA R, BODEGA B, PUNTO_VENTA P, VENDEDORES V, PREFIJOS PR WHERE R.PTVT_ID >= :PTOINI AND R.PTVT_ID <= :PTOFIN AND
         R.BODE_COD = B.BODE_COD AND R.PTVT_ID = P.PTVT_ID AND R.VEND_COD = V.VEND_COD AND R.PREF_PRE >= :PREINI AND R.PREF_PRE <= :PREFIN AND REVT_NUMERO >= :NUMINI AND REVT_NUMERO <= :NUMFIN
         AND PR.PREF_PRE = R.PREF_PRE AND PR.TIDO_COD = 32 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY R.PREF_PRE, REVT_NUMERO
        INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :CODBOD, :NOMBOD, :AUTORIZA, :PTVTID, :PTVTNOM, :VENDCOD, :VENDNOM, :COMIPORC, :COMIMONTO, :NIT, :NOMTERCERO, :PEDIDO, :COTIZACI, :REMISION, :DTOPOR, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTFTEPOR, :RTFTEMONTO, :RTIVAPOR, :RTIVAMONTO, :RTICAPOR, :RTICAMONTO, :EXTRA, :DTOFPOR, :DTOFMONTO, :DTOFFECHA, :TOTAL, :ANULADO, :OBS
        DO
        BEGIN
        if ((ANULADOS = 'S') or (ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
                BEGIN
                COMIPORC = 0;
                COMIMONTO = 0;
                DTOPOR = 0;
                DTOMONTO = 0;
                ADICIONAL = 0;
                IVAMONTO = 0;
                RTFTEPOR = 0;
                RTFTEMONTO = 0;
                RTIVAPOR = 0;
                RTIVAMONTO = 0;
                RTICAPOR = 0;
                RTICAMONTO = 0;
                EXTRA = 0;
                DTOFPOR = 0;
                DTOFMONTO = 0;
                TOTAL = 0;
                END
            if (DETALLE = 'S') then
                BEGIN
                if (anulado = 'S') then
                    BEGIN
                    ITEM = 0;
                    ARTICULO = '';
                    CODBAR = '';
                    ARTIDES = '';
                    CANT = 0;
                    UNIDAD = '';
                    BODITEM = '';
                    LOTE = '';
                    REFERENCIA = '';
                    PRECIO = 0;
                    DTOPORCIT = 0;
                    DTOMONTOIT = 0;
                    IVAPORCIT = 0;
                    IVAMONTOIT = 0;
                    CONSUMOIT = 0;
                    SUBTOTALIT = 0;
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    FOR SELECT RVDE_ITEM, ARTI_COD, RVDE_CODBAR, RVDE_DESC, RVDE_CANT, RVDE_UNIDAD, BODE_COD, RVDE_LOTE, RVDE_REFERENCIA, RVDE_PRUNIT, RVDE_DTOPORC, RVDE_DTOMONTO, RVDE_IVAPORC, RVDE_IVAMONTO, RVDE_CONSUMO, RVDE_TOTAL
                        FROM REMISIONES_VENTA_DETALLE
                        WHERE REVT_ID = :ID
                        ORDER BY RVDE_ITEM
                        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :REFERENCIA, :PRECIO, :DTOPORCIT, :DTOMONTOIT, :IVAPORCIT, :IVAMONTOIT, :CONSUMOIT, :SUBTOTALIT
                        DO
                        SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
            END
        END
    END
  if (BIN_AND(TIPO, 4) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
    /* DEVOLUCIONES */
    FOR SELECT DEVT_ID, D.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, DEVT_FECHA, D.BODE_COD, B.BODE_NOM, '', D.PTVT_ID, PTVT_NOM, D.VEND_COD, VEND_NOMBRE, DEVT_COMIPORC, DEVT_COMIMONTO, D.TERC_NIT, DEVT_NOMTERC, '', '', '', DEVT_DTOPOR, DEVT_DTOMONTO, DEVT_ADICIONAL, DEVT_IVAMONTO, DEVT_RTFTEPORC, DEVT_RTFTEMONTO, DEVT_RTIVAPORC, DEVT_RTIVAMONTO, DEVT_RTICAPORC, DEVT_RTICAMONTO, DEVT_EXTRA, 0, 0, DEVT_FECHA, DEVT_TOTAL, DEVT_ANULADO, DEVT_OBS
        FROM DEVOLUCIONES_VENTAS D, BODEGA B, PUNTO_VENTA P, VENDEDORES V, PREFIJOS PR WHERE D.PTVT_ID >= :PTOINI AND D.PTVT_ID <= :PTOFIN AND
         D.BODE_COD = B.BODE_COD AND D.PTVT_ID = P.PTVT_ID AND D.VEND_COD = V.VEND_COD AND D.PREF_PRE >= :PREINI AND D.PREF_PRE <= :PREFIN AND DEVT_NUMERO >= :NUMINI AND DEVT_NUMERO <= :NUMFIN
         AND PR.PREF_PRE = D.PREF_PRE AND PR.TIDO_COD = 33 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY D.PREF_PRE, DEVT_NUMERO
        INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :CODBOD, :NOMBOD, :AUTORIZA, :PTVTID, :PTVTNOM, :VENDCOD, :VENDNOM, :COMIPORC, :COMIMONTO, :NIT, :NOMTERCERO, :PEDIDO, :COTIZACI, :REMISION, :DTOPOR, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTFTEPOR, :RTFTEMONTO, :RTIVAPOR, :RTIVAMONTO, :RTICAPOR, :RTICAMONTO, :EXTRA, :DTOFPOR, :DTOFMONTO, :DTOFFECHA, :TOTAL, :ANULADO, :OBS
        DO
        BEGIN
        if ((ANULADOS = 'S') or (ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
                BEGIN
                COMIPORC = 0;
                COMIMONTO = 0;
                DTOPOR = 0;
                DTOMONTO = 0;
                ADICIONAL = 0;
                IVAMONTO = 0;
                RTFTEPOR = 0;
                RTFTEMONTO = 0;
                RTIVAPOR = 0;
                RTIVAMONTO = 0;
                RTICAPOR = 0;
                RTICAMONTO = 0;
                EXTRA = 0;
                DTOFPOR = 0;
                DTOFMONTO = 0;
                TOTAL = 0;
                END
            if (DETALLE = 'S') then
                BEGIN
                if (anulado = 'S') then
                    BEGIN
                    ITEM = 0;
                    ARTICULO = '';
                    CODBAR = '';
                    ARTIDES = '';
                    CANT = 0;
                    UNIDAD = '';
                    BODITEM = '';
                    LOTE = '';
                    REFERENCIA = '';
                    PRECIO = 0;
                    DTOPORCIT = 0;
                    DTOMONTOIT = 0;
                    IVAPORCIT = 0;
                    IVAMONTOIT = 0;
                    CONSUMOIT = 0;
                    SUBTOTALIT = 0;
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    FOR SELECT DVDE_ITEM, ARTI_COD, DVDE_CODBAR, DVDE_DESC, DVDE_CANT, DVDE_UNIDAD, BODE_COD, DVDE_LOTE, DVDE_REFERENCIA, DVDE_PRUNIT, DVDE_DTOPORC, DVDE_DTOMONTO, DVDE_IVAPORC, DVDE_IVAMONTO, DVDE_CONSUMO, DVDE_TOTAL
                        FROM DEVOLUCIONES_VENTAS_DETALLE
                        WHERE DEVT_ID = :ID
                        ORDER BY DVDE_ITEM
                        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :REFERENCIA, :PRECIO, :DTOPORCIT, :DTOMONTOIT, :IVAPORCIT, :IVAMONTOIT, :CONSUMOIT, :SUBTOTALIT
                        DO
                        SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
            END
        END
    END
  if (BIN_AND(TIPO, 8) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
    /* PEDIDO */
    FOR SELECT PEDI_ID, P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, PEDI_FECHA, '', '', '', P.PTVT_ID, PTVT_NOM, P.VEND_COD, VEND_NOMBRE, 0, 0, P.TERC_NIT, PEDI_NOMTERC, '', '', '', PEDI_DTOPOR, PEDI_DTOMONTO, PEDI_ADICIONAL, PEDI_IVAMONTO, 0, 0, 0, 0, 0, 0, PEDI_EXTRA, 0, 0, PEDI_FECHA, PEDI_TOTAL, PEDI_ANULADO, PEDI_OBS
        FROM PEDIDOS P, PUNTO_VENTA PT, VENDEDORES V, PREFIJOS PR WHERE P.PTVT_ID >= :PTOINI AND P.PTVT_ID <= :PTOFIN AND
         P.PTVT_ID = PT.PTVT_ID AND P.VEND_COD = V.VEND_COD AND P.PREF_PRE >= :PREINI AND P.PREF_PRE <= :PREFIN AND PEDI_NUMERO >= :NUMINI AND PEDI_NUMERO <= :NUMFIN
         AND PR.PREF_PRE = P.PREF_PRE AND PR.TIDO_COD = 34 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY P.PREF_PRE, PEDI_NUMERO
        INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :CODBOD, :NOMBOD, :AUTORIZA, :PTVTID, :PTVTNOM, :VENDCOD, :VENDNOM, :COMIPORC, :COMIMONTO, :NIT, :NOMTERCERO, :PEDIDO, :COTIZACI, :REMISION, :DTOPOR, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTFTEPOR, :RTFTEMONTO, :RTIVAPOR, :RTIVAMONTO, :RTICAPOR, :RTICAMONTO, :EXTRA, :DTOFPOR, :DTOFMONTO, :DTOFFECHA, :TOTAL, :ANULADO, :OBS
        DO
        BEGIN
        if ((ANULADOS = 'S') or (ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
                BEGIN
                COMIPORC = 0;
                COMIMONTO = 0;
                DTOPOR = 0;
                DTOMONTO = 0;
                ADICIONAL = 0;
                IVAMONTO = 0;
                RTFTEPOR = 0;
                RTFTEMONTO = 0;
                RTIVAPOR = 0;
                RTIVAMONTO = 0;
                RTICAPOR = 0;
                RTICAMONTO = 0;
                EXTRA = 0;
                DTOFPOR = 0;
                DTOFMONTO = 0;
                TOTAL = 0;
                END
            if (DETALLE = 'S') then
                BEGIN
                if (anulado = 'S') then
                    BEGIN
                    ITEM = 0;
                    ARTICULO = '';
                    CODBAR = '';
                    ARTIDES = '';
                    CANT = 0;
                    UNIDAD = '';
                    BODITEM = '';
                    LOTE = '';
                    REFERENCIA = '';
                    PRECIO = 0;
                    DTOPORCIT = 0;
                    DTOMONTOIT = 0;
                    IVAPORCIT = 0;
                    IVAMONTOIT = 0;
                    CONSUMOIT = 0;
                    SUBTOTALIT = 0;
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    FOR SELECT PEDE_ITEM, ARTI_COD, PEDE_CODBAR, PEDE_DESC, PEDE_CANT, PEDE_UNIDAD, '', '', PEDE_REFERENCIA, PEDE_PRUNIT, PEDE_DTOPORC, PEDE_DTOMONTO, PEDE_IVAPORC, PEDE_IVAMONTO, PEDE_CONSUMO, PEDE_TOTAL
                        FROM PEDIDOS_DETALLE
                        WHERE PEDI_ID = :ID
                        ORDER BY PEDE_ITEM
                        INTO :ITEM, :ARTICULO, :CODBAR, :descaux, :CANT, :UNIDAD, :BODITEM, :LOTE, :REFERENCIA, :PRECIO, :DTOPORCIT, :DTOMONTOIT, :IVAPORCIT, :IVAMONTOIT, :CONSUMOIT, :SUBTOTALIT
                        DO
                         begin
                          if (STRLEN(descaux)> 60 ) then
                            ARTIDES = SUBSTR(descaux,1,60);
                          ELSE
                            ARTIDES = :descaux;
                         end
                        SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
            END
        END
    END
  if (BIN_AND(TIPO, 16) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
    FOR SELECT COTI_ID, C.PREF_PRE, COTI_NUMERO, COTI_FECHA, COTI_FECHA, '', '', '', C.PTVT_ID, PTVT_NOM, C.VEND_COD, VEND_NOMBRE, 0, 0, C.TERC_NIT, COTI_NOMTERC, '', '', '', COTI_DTOPORC, COTI_DTOMONTO, COTI_ADICIONAL, COTI_IVAMONTO, 0, 0, 0, 0, 0, 0, COTI_EXTRA, 0, 0, COTI_FECHA, COTI_TOTAL, COTI_ANULADO, COTI_OBS
        FROM COTIZACIONES C, PUNTO_VENTA P, VENDEDORES V, PREFIJOS PR WHERE C.PTVT_ID >= :PTOINI AND C.PTVT_ID <= :PTOFIN AND
         C.PTVT_ID = P.PTVT_ID AND C.VEND_COD = V.VEND_COD AND C.PREF_PRE >= :PREINI AND C.PREF_PRE <= :PREFIN AND COTI_NUMERO >= :NUMINI AND COTI_NUMERO <= :NUMFIN
         AND PR.PREF_PRE = C.PREF_PRE AND PR.TIDO_COD = 35 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY C.PREF_PRE, COTI_NUMERO
        INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :CODBOD, :NOMBOD, :AUTORIZA, :PTVTID, :PTVTNOM, :VENDCOD, :VENDNOM, :COMIPORC, :COMIMONTO, :NIT, :NOMTERCERO, :PEDIDO, :COTIZACI, :REMISION, :DTOPOR, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTFTEPOR, :RTFTEMONTO, :RTIVAPOR, :RTIVAMONTO, :RTICAPOR, :RTICAMONTO, :EXTRA, :DTOFPOR, :DTOFMONTO, :DTOFFECHA, :TOTAL, :ANULADO, :OBS
        DO
        BEGIN
        if ((ANULADOS = 'S') or (ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
                BEGIN
                COMIPORC = 0;
                COMIMONTO = 0;
                DTOPOR = 0;
                DTOMONTO = 0;
                ADICIONAL = 0;
                IVAMONTO = 0;
                RTFTEPOR = 0;
                RTFTEMONTO = 0;
                RTIVAPOR = 0;
                RTIVAMONTO = 0;
                RTICAPOR = 0;
                RTICAMONTO = 0;
                EXTRA = 0;
                DTOFPOR = 0;
                DTOFMONTO = 0;
                TOTAL = 0;
                END
            if (DETALLE = 'S') then
                BEGIN
                if (anulado = 'S') then
                    BEGIN
                    ITEM = 0;
                    ARTICULO = '';
                    CODBAR = '';
                    ARTIDES = '';
                    CANT = 0;
                    UNIDAD = '';
                    BODITEM = '';
                    LOTE = '';
                    REFERENCIA = '';
                    PRECIO = 0;
                    DTOPORCIT = 0;
                    DTOMONTOIT = 0;
                    IVAPORCIT = 0;
                    IVAMONTOIT = 0;
                    CONSUMOIT = 0;
                    SUBTOTALIT = 0;
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    FOR SELECT CTDE_ITEM, ARTI_COD, CTDE_CODBAR, CTDE_DESC, CTDE_CANT, CTDE_UNIDAD, '', '', CTDE_REFERENCIA, CTDE_PRUNIT, CTDE_DTOPORC, CTDE_DTOMONTO, CTDE_IVAPORC, CTDE_IVAMONTO, CTDE_CONSUMO, CTDE_TOTAL
                        FROM COTIZACIONES_DETALLE
                        WHERE COTI_ID = :ID
                        ORDER BY CTDE_ITEM
                        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :REFERENCIA, :PRECIO, :DTOPORCIT, :DTOMONTOIT, :IVAPORCIT, :IVAMONTOIT, :CONSUMOIT, :SUBTOTALIT
                        DO
                        SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
            END
        END
    END
END
^

SET TERM ; ^


SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_COMPROBANTES_FAC(
    TIPO INTEGER,
    DETALLE CHAR(1),
    FECINI DATE,
    FECFIN DATE,
    PREFINI VARCHAR(4),
    PREFFIN VARCHAR(4),
    PTOINI INTEGER,
    PTOFIN INTEGER,
    ANULADOS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    NOMTIPO VARCHAR(30),
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    VENCE DATE,
    CODBOD VARCHAR(2),
    NOMBOD VARCHAR(30),
    AUTORIZA VARCHAR(20),
    PTVTID INTEGER,
    PTVTNOM VARCHAR(60),
    VENDCOD INTEGER,
    VENDNOM VARCHAR(60),
    COMIPORC NUMERIC(9,2),
    COMIMONTO NUMERIC(18,2),
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    PEDIDO VARCHAR(30),
    COTIZACI VARCHAR(30),
    REMISION VARCHAR(30),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    UNIDAD VARCHAR(8),
    BODITEM VARCHAR(2),
    LOTE VARCHAR(15),
    REFERENCIA VARCHAR(60),
    PRECIO NUMERIC(18,2),
    DTOPORCIT NUMERIC(9,2),
    DTOMONTOIT NUMERIC(18,2),
    IVAPORCIT NUMERIC(9,2),
    IVAMONTOIT NUMERIC(18,2),
    CONSUMOIT NUMERIC(18,2),
    SUBTOTALIT NUMERIC(18,2),
    DTOPOR NUMERIC(9,2),
    DTOMONTO NUMERIC(18,2),
    ADICIONAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    RTFTEPOR NUMERIC(9,2),
    RTFTEMONTO NUMERIC(18,2),
    RTIVAPOR NUMERIC(9,2),
    RTIVAMONTO NUMERIC(18,2),
    RTICAPOR NUMERIC(9,2),
    RTICAMONTO NUMERIC(18,2),
    EXTRA NUMERIC(18,2),
    DTOFPOR NUMERIC(9,2),
    DTOFMONTO NUMERIC(18,2),
    DTOFFECHA DATE,
    TOTAL NUMERIC(18,2),
    ANULADO CHAR(1),
    VEHICULO VARCHAR(8))
AS
declare variable descaux varchar(255);
BEGIN
VEHICULO = '';
  /* DETERMINE LA TABLA A EXAMINAR */
  if (BIN_AND(TIPO, 1) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
    FOR SELECT FACT_ID, F.PREF_PRE, FACT_NUMERO, FACT_FECHA, FACT_VENCE, F.BODE_COD, B.BODE_NOM, F.AUTO_NUMERO, F.PTVT_ID, PTVT_NOM, F.VEND_COD, VEND_NOMBRE, F.FACT_COMIPORC, F.FACT_COMIMONTO, F.TERC_NIT, FACT_NOMCLIENTE, FACT_PEDIDO, FACT_COTIZACI, FACT_REMISION, FACT_DTOPOR, FACT_DTOMONTO, FACT_ADICIONAL, FACT_IVAMONTO, FACT_RTFTEPOR, FACT_RTFTEMONTO, FACT_RTIVAPOR, FACT_RTIVAMONTO, FACT_RTICAPOR, FACT_RTICAMONTO, FACT_EXTRA, FACT_DTOFPOR, FACT_DTOFMONTO, FACT_DTOFFECHA, FACT_TOTAL, FACT_ANULADO, VEHI_COD, FACT_OBS
        FROM FACTURAS F, BODEGA B, PUNTO_VENTA P, VENDEDORES V, PREFIJOS PR WHERE F.PTVT_ID >= :PTOINI AND F.PTVT_ID <= :PTOFIN AND
         F.BODE_COD = B.BODE_COD AND F.PTVT_ID = P.PTVT_ID AND F.VEND_COD = V.VEND_COD AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN
         AND PR.PREF_PRE = F.PREF_PRE AND PR.TIDO_COD = 31 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) AND
         F.PREF_PRE >= :prefini AND F.PREF_PRE <= :preffin
        ORDER BY FACT_FECHA, FACT_ID
        INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :CODBOD, :NOMBOD, :AUTORIZA, :PTVTID, :PTVTNOM, :VENDCOD, :VENDNOM, :COMIPORC, :COMIMONTO, :NIT, :NOMTERCERO, :PEDIDO, :COTIZACI, :REMISION, :DTOPOR, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTFTEPOR, :RTFTEMONTO, :RTIVAPOR, :RTIVAMONTO, :RTICAPOR, :RTICAMONTO, :EXTRA, :DTOFPOR, :DTOFMONTO, :DTOFFECHA, :TOTAL, :ANULADO, :VEHICULO, :OBS
        DO
        BEGIN
        if ((ANULADOS = 'S') or (ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
                BEGIN
                COMIPORC = 0;
                COMIMONTO = 0;
                DTOPOR = 0;
                DTOMONTO = 0;
                ADICIONAL = 0;
                IVAMONTO = 0;
                RTFTEPOR = 0;
                RTFTEMONTO = 0;
                RTIVAPOR = 0;
                RTIVAMONTO = 0;
                RTICAPOR = 0;
                RTICAMONTO = 0;
                EXTRA = 0;
                DTOFPOR = 0;
                DTOFMONTO = 0;
                TOTAL = 0;
                END
            if (DETALLE = 'S') then
                BEGIN
                if (anulado = 'S') then
                    BEGIN
                    ITEM = 0;
                    ARTICULO = '';
                    CODBAR = '';
                    ARTIDES = '';
                    CANT = 0;
                    UNIDAD = '';
                    BODITEM = '';
                    LOTE = '';
                    REFERENCIA = '';
                    PRECIO = 0;
                    DTOPORCIT = 0;
                    DTOMONTOIT = 0;
                    IVAPORCIT = 0;
                    IVAMONTOIT = 0;
                    CONSUMOIT = 0;
                    SUBTOTALIT = 0;
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    FOR SELECT FADE_ITEM, ARTI_COD, FADE_CODBAR, FADE_DESC, FADE_CANT, FADE_UNIDAD, BODE_COD, FADE_LOTE, FADE_REFERENCIA, FADE_PRUNIT, FADE_DTOPORC, FADE_DTOMONTO, FADE_IVAPORC, FADE_IVAMONTO, FADE_CONSUMO, FADE_TOTAL
                        FROM FACTURAS_DETALLE
                        WHERE FACT_ID = :ID
                        ORDER BY FADE_ITEM
                        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :REFERENCIA, :PRECIO, :DTOPORCIT, :DTOMONTOIT, :IVAPORCIT, :IVAMONTOIT, :CONSUMOIT, :SUBTOTALIT
                        DO
                        SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
            END
        END
    END
  if (BIN_AND(TIPO, 2) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
    FOR SELECT REVT_ID, R.PREF_PRE, REVT_NUMERO, REVT_FECHA, REVT_FECHA VENCE, R.BODE_COD, B.BODE_NOM, '', R.PTVT_ID, PTVT_NOM, R.VEND_COD, VEND_NOMBRE, 0, 0, R.TERC_NIT, REVT_NOMTERC, '', '', '', 0, 0, 0, REVT_IVAMONTO, 0, 0, 0, 0, 0, 0, 0, 0, 0, REVT_FECHA DTOF, REVT_TOTAL, REVT_ANULADO, REVT_OBS
        FROM REMISIONES_VENTA R, BODEGA B, PUNTO_VENTA P, VENDEDORES V, PREFIJOS PR WHERE R.PTVT_ID >= :PTOINI AND R.PTVT_ID <= :PTOFIN AND
         R.BODE_COD = B.BODE_COD AND R.PTVT_ID = P.PTVT_ID AND R.VEND_COD = V.VEND_COD AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN
         AND PR.PREF_PRE = R.PREF_PRE AND PR.TIDO_COD = 32 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) AND
         R.PREF_PRE >= :prefini AND R.PREF_PRE <= :preffin
        ORDER BY REVT_FECHA, REVT_ID
        INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :CODBOD, :NOMBOD, :AUTORIZA, :PTVTID, :PTVTNOM, :VENDCOD, :VENDNOM, :COMIPORC, :COMIMONTO, :NIT, :NOMTERCERO, :PEDIDO, :COTIZACI, :REMISION, :DTOPOR, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTFTEPOR, :RTFTEMONTO, :RTIVAPOR, :RTIVAMONTO, :RTICAPOR, :RTICAMONTO, :EXTRA, :DTOFPOR, :DTOFMONTO, :DTOFFECHA, :TOTAL, :ANULADO, :OBS
        DO
        BEGIN
        if ((ANULADOS = 'S') or (ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
                BEGIN
                COMIPORC = 0;
                COMIMONTO = 0;
                DTOPOR = 0;
                DTOMONTO = 0;
                ADICIONAL = 0;
                IVAMONTO = 0;
                RTFTEPOR = 0;
                RTFTEMONTO = 0;
                RTIVAPOR = 0;
                RTIVAMONTO = 0;
                RTICAPOR = 0;
                RTICAMONTO = 0;
                EXTRA = 0;
                DTOFPOR = 0;
                DTOFMONTO = 0;
                TOTAL = 0;
                END
            if (DETALLE = 'S') then
                BEGIN
                if (anulado = 'S') then
                    BEGIN
                    ITEM = 0;
                    ARTICULO = '';
                    CODBAR = '';
                    ARTIDES = '';
                    CANT = 0;
                    UNIDAD = '';
                    BODITEM = '';
                    LOTE = '';
                    REFERENCIA = '';
                    PRECIO = 0;
                    DTOPORCIT = 0;
                    DTOMONTOIT = 0;
                    IVAPORCIT = 0;
                    IVAMONTOIT = 0;
                    CONSUMOIT = 0;
                    SUBTOTALIT = 0;
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    FOR SELECT RVDE_ITEM, ARTI_COD, RVDE_CODBAR, RVDE_DESC, RVDE_CANT, RVDE_UNIDAD, BODE_COD, RVDE_LOTE, RVDE_REFERENCIA, RVDE_PRUNIT, RVDE_DTOPORC, RVDE_DTOMONTO, RVDE_IVAPORC, RVDE_IVAMONTO, RVDE_CONSUMO, RVDE_TOTAL
                        FROM REMISIONES_VENTA_DETALLE
                        WHERE REVT_ID = :ID
                        ORDER BY RVDE_ITEM
                        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :REFERENCIA, :PRECIO, :DTOPORCIT, :DTOMONTOIT, :IVAPORCIT, :IVAMONTOIT, :CONSUMOIT, :SUBTOTALIT
                        DO
                        SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
            END
        END
    END
  if (BIN_AND(TIPO, 4) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
    FOR SELECT DEVT_ID, D.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, DEVT_FECHA VENCE, D.BODE_COD, B.BODE_NOM, '', D.PTVT_ID, PTVT_NOM, D.VEND_COD, VEND_NOMBRE, DEVT_COMIPORC, DEVT_COMIMONTO, D.TERC_NIT, DEVT_NOMTERC, '', '', '', DEVT_DTOPOR, DEVT_DTOMONTO, DEVT_ADICIONAL, DEVT_IVAMONTO, DEVT_RTFTEPORC, DEVT_RTFTEMONTO, DEVT_RTIVAPORC, DEVT_RTIVAMONTO, DEVT_RTICAPORC, DEVT_RTICAMONTO, DEVT_EXTRA, 0, 0, DEVT_FECHA DTOF, DEVT_TOTAL, DEVT_ANULADO, DEVT_OBS
        FROM DEVOLUCIONES_VENTAS D, BODEGA B, PUNTO_VENTA P, VENDEDORES V, PREFIJOS PR WHERE D.PTVT_ID >= :PTOINI AND D.PTVT_ID <= :PTOFIN AND
         D.BODE_COD = B.BODE_COD AND D.PTVT_ID = P.PTVT_ID AND D.VEND_COD = V.VEND_COD AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN
         AND PR.PREF_PRE = D.PREF_PRE AND PR.TIDO_COD = 33 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) AND
         D.PREF_PRE >= :prefini AND D.PREF_PRE <= :preffin
        ORDER BY DEVT_FECHA, DEVT_ID
        INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :CODBOD, :NOMBOD, :AUTORIZA, :PTVTID, :PTVTNOM, :VENDCOD, :VENDNOM, :COMIPORC, :COMIMONTO, :NIT, :NOMTERCERO, :PEDIDO, :COTIZACI, :REMISION, :DTOPOR, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTFTEPOR, :RTFTEMONTO, :RTIVAPOR, :RTIVAMONTO, :RTICAPOR, :RTICAMONTO, :EXTRA, :DTOFPOR, :DTOFMONTO, :DTOFFECHA, :TOTAL, :ANULADO, :OBS
        DO
        BEGIN
        if ((ANULADOS = 'S') or (ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
                BEGIN
                COMIPORC = 0;
                COMIMONTO = 0;
                DTOPOR = 0;
                DTOMONTO = 0;
                ADICIONAL = 0;
                IVAMONTO = 0;
                RTFTEPOR = 0;
                RTFTEMONTO = 0;
                RTIVAPOR = 0;
                RTIVAMONTO = 0;
                RTICAPOR = 0;
                RTICAMONTO = 0;
                EXTRA = 0;
                DTOFPOR = 0;
                DTOFMONTO = 0;
                TOTAL = 0;
                END
            if (DETALLE = 'S') then
                BEGIN
                if (anulado = 'S') then
                    BEGIN
                    ITEM = 0;
                    ARTICULO = '';
                    CODBAR = '';
                    ARTIDES = '';
                    CANT = 0;
                    UNIDAD = '';
                    BODITEM = '';
                    LOTE = '';
                    REFERENCIA = '';
                    PRECIO = 0;
                    DTOPORCIT = 0;
                    DTOMONTOIT = 0;
                    IVAPORCIT = 0;
                    IVAMONTOIT = 0;
                    CONSUMOIT = 0;
                    SUBTOTALIT = 0;
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    FOR SELECT DVDE_ITEM, ARTI_COD, DVDE_CODBAR, DVDE_DESC, DVDE_CANT, DVDE_UNIDAD, BODE_COD, DVDE_LOTE, DVDE_REFERENCIA, DVDE_PRUNIT, DVDE_DTOPORC, DVDE_DTOMONTO, DVDE_IVAPORC, DVDE_IVAMONTO, DVDE_CONSUMO, DVDE_TOTAL
                        FROM DEVOLUCIONES_VENTAS_DETALLE
                        WHERE DEVT_ID = :ID
                        ORDER BY DVDE_ITEM
                        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :REFERENCIA, :PRECIO, :DTOPORCIT, :DTOMONTOIT, :IVAPORCIT, :IVAMONTOIT, :CONSUMOIT, :SUBTOTALIT
                        DO
                        SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
            END
        END
    END
  if (BIN_AND(TIPO, 8) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
    FOR SELECT PEDI_ID, P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, PEDI_FECHA VENCE, '', '', '', P.PTVT_ID, PTVT_NOM, P.VEND_COD, VEND_NOMBRE, 0, 0, P.TERC_NIT, PEDI_NOMTERC, '', '', '', PEDI_DTOPOR, PEDI_DTOMONTO, PEDI_ADICIONAL, PEDI_IVAMONTO, 0, 0, 0, 0, 0, 0, PEDI_EXTRA, 0, 0, PEDI_FECHA DTOF, PEDI_TOTAL, PEDI_ANULADO, PEDI_OBS
        FROM PEDIDOS P, PUNTO_VENTA PT, VENDEDORES V, PREFIJOS PR WHERE P.PTVT_ID >= :PTOINI AND P.PTVT_ID <= :PTOFIN AND
         P.PTVT_ID = PT.PTVT_ID AND P.VEND_COD = V.VEND_COD AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN
         AND PR.PREF_PRE = P.PREF_PRE AND PR.TIDO_COD = 34 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) AND
         P.PREF_PRE >= :prefini AND P.PREF_PRE <= :preffin
        ORDER BY PEDI_FECHA, PEDI_ID
        INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :CODBOD, :NOMBOD, :AUTORIZA, :PTVTID, :PTVTNOM, :VENDCOD, :VENDNOM, :COMIPORC, :COMIMONTO, :NIT, :NOMTERCERO, :PEDIDO, :COTIZACI, :REMISION, :DTOPOR, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTFTEPOR, :RTFTEMONTO, :RTIVAPOR, :RTIVAMONTO, :RTICAPOR, :RTICAMONTO, :EXTRA, :DTOFPOR, :DTOFMONTO, :DTOFFECHA, :TOTAL, :ANULADO, :OBS
        DO
        BEGIN
        if ((ANULADOS = 'S') or (ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
                BEGIN
                COMIPORC = 0;
                COMIMONTO = 0;
                DTOPOR = 0;
                DTOMONTO = 0;
                ADICIONAL = 0;
                IVAMONTO = 0;
                RTFTEPOR = 0;
                RTFTEMONTO = 0;
                RTIVAPOR = 0;
                RTIVAMONTO = 0;
                RTICAPOR = 0;
                RTICAMONTO = 0;
                EXTRA = 0;
                DTOFPOR = 0;
                DTOFMONTO = 0;
                TOTAL = 0;
                END
            if (DETALLE = 'S') then
                BEGIN
                if (anulado = 'S') then
                    BEGIN
                    ITEM = 0;
                    ARTICULO = '';
                    CODBAR = '';
                    ARTIDES = '';
                    CANT = 0;
                    UNIDAD = '';
                    BODITEM = '';
                    LOTE = '';
                    REFERENCIA = '';
                    PRECIO = 0;
                    DTOPORCIT = 0;
                    DTOMONTOIT = 0;
                    IVAPORCIT = 0;
                    IVAMONTOIT = 0;
                    CONSUMOIT = 0;
                    SUBTOTALIT = 0;
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    FOR SELECT PEDE_ITEM, ARTI_COD, PEDE_CODBAR, PEDE_DESC, PEDE_CANT, PEDE_UNIDAD, '', '', PEDE_REFERENCIA, PEDE_PRUNIT, PEDE_DTOPORC, PEDE_DTOMONTO, PEDE_IVAPORC, PEDE_IVAMONTO, PEDE_CONSUMO, PEDE_TOTAL
                        FROM PEDIDOS_DETALLE
                        WHERE PEDI_ID = :ID
                        ORDER BY PEDE_ITEM
                        INTO :ITEM, :ARTICULO, :CODBAR, :descaux, :CANT, :UNIDAD, :BODITEM, :LOTE, :REFERENCIA, :PRECIO, :DTOPORCIT, :DTOMONTOIT, :IVAPORCIT, :IVAMONTOIT, :CONSUMOIT, :SUBTOTALIT
                        DO
                         begin
                          if (STRLEN(descaux)> 60 ) then
                            ARTIDES = SUBSTR(descaux,1,60);
                          ELSE
                            ARTIDES = :descaux;
                         end
                        SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
            END
        END
    END
  if (BIN_AND(TIPO, 16) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
    FOR SELECT COTI_ID, C.PREF_PRE, COTI_NUMERO, COTI_FECHA, COTI_FECHA VENCE, '', '', '', C.PTVT_ID, PTVT_NOM, C.VEND_COD, VEND_NOMBRE, 0, 0, C.TERC_NIT, COTI_NOMTERC, '', '', '', COTI_DTOPORC, COTI_DTOMONTO, COTI_ADICIONAL, COTI_IVAMONTO, 0, 0, 0, 0, 0, 0, COTI_EXTRA, 0, 0, COTI_FECHA DTOF, COTI_TOTAL, COTI_ANULADO, COTI_OBS
        FROM COTIZACIONES C, PUNTO_VENTA P, VENDEDORES V, PREFIJOS PR WHERE C.PTVT_ID >= :PTOINI AND C.PTVT_ID <= :PTOFIN AND
         C.PTVT_ID = P.PTVT_ID AND C.VEND_COD = V.VEND_COD AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN
         AND PR.PREF_PRE = C.PREF_PRE AND PR.TIDO_COD = 35 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) AND
         C.PREF_PRE >= :prefini AND C.PREF_PRE <= :preffin
        ORDER BY COTI_FECHA, COTI_ID
        INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :CODBOD, :NOMBOD, :AUTORIZA, :PTVTID, :PTVTNOM, :VENDCOD, :VENDNOM, :COMIPORC, :COMIMONTO, :NIT, :NOMTERCERO, :PEDIDO, :COTIZACI, :REMISION, :DTOPOR, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTFTEPOR, :RTFTEMONTO, :RTIVAPOR, :RTIVAMONTO, :RTICAPOR, :RTICAMONTO, :EXTRA, :DTOFPOR, :DTOFMONTO, :DTOFFECHA, :TOTAL, :ANULADO, :OBS
        DO
        BEGIN
        if ((ANULADOS = 'S') or (ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
                BEGIN
                COMIPORC = 0;
                COMIMONTO = 0;
                DTOPOR = 0;
                DTOMONTO = 0;
                ADICIONAL = 0;
                IVAMONTO = 0;
                RTFTEPOR = 0;
                RTFTEMONTO = 0;
                RTIVAPOR = 0;
                RTIVAMONTO = 0;
                RTICAPOR = 0;
                RTICAMONTO = 0;
                EXTRA = 0;
                DTOFPOR = 0;
                DTOFMONTO = 0;
                TOTAL = 0;
                END
            if (DETALLE = 'S') then
                BEGIN
                if (anulado = 'S') then
                    BEGIN
                    ITEM = 0;
                    ARTICULO = '';
                    CODBAR = '';
                    ARTIDES = '';
                    CANT = 0;
                    UNIDAD = '';
                    BODITEM = '';
                    LOTE = '';
                    REFERENCIA = '';
                    PRECIO = 0;
                    DTOPORCIT = 0;
                    DTOMONTOIT = 0;
                    IVAPORCIT = 0;
                    IVAMONTOIT = 0;
                    CONSUMOIT = 0;
                    SUBTOTALIT = 0;
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    FOR SELECT CTDE_ITEM, ARTI_COD, CTDE_CODBAR, CTDE_DESC, CTDE_CANT, CTDE_UNIDAD, '', '', CTDE_REFERENCIA, CTDE_PRUNIT, CTDE_DTOPORC, CTDE_DTOMONTO, CTDE_IVAPORC, CTDE_IVAMONTO, CTDE_CONSUMO, CTDE_TOTAL
                        FROM COTIZACIONES_DETALLE
                        WHERE COTI_ID = :ID
                        ORDER BY CTDE_ITEM
                        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :REFERENCIA, :PRECIO, :DTOPORCIT, :DTOMONTOIT, :IVAPORCIT, :IVAMONTOIT, :CONSUMOIT, :SUBTOTALIT
                        DO
                        SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
            END
        END
    END
END
^

SET TERM ; ^

/* REPORTES DE VARIOS DOCUMENTOS A LA VEZ */

SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_ARTICULOS_CLIENTE(
    TIPO INTEGER,
    DETALLE CHAR(1),
    TERINI VARCHAR(20),
    TERFIN VARCHAR(20),
    FECINI DATE,
    FECFIN DATE,
    ARTINI VARCHAR(15),
    ARTFIN VARCHAR(15),
    ORDEN CHAR(1),
    CEROS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    TELEFONO VARCHAR(40),
    CIUDAD VARCHAR(40),
    CODZONA VARCHAR(2),
    NOMZONA VARCHAR(30),
    NOMTIPO VARCHAR(50),
    ARTICULO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    UNIDAD VARCHAR(8),
    CANTIDAD NUMERIC(18,4),
    BASE NUMERIC(18,2),
    IVA NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    DTO NUMERIC(9,2),
    TIPODOC INTEGER)
AS
declare variable CODINI VARCHAR(15);
declare variable CODFIN VARCHAR(15);
declare variable DESINI VARCHAR(15);
declare variable DESFIN VARCHAR(15);
BEGIN
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END

SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPO INTO :NOMTIPO;
if (DETALLE = 'N') then
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        TIPODOC = 31;
        FOR SELECT SUM(FADE_CANT * FADE_FACTOR), SUM((FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR), SUM(FADE_IVAMONTO*FACT_FACTOR), SUM(FADE_CONSUMO), SUM(FADE_TOTAL*FACT_FACTOR),
            max(D.ARTI_COD), MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(TERC_NIT)
            FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P, ARTICULO A
            WHERE F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND D.ARTI_COD = A.ARTI_COD AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            TERC_NIT >= :TERINI AND TERC_NIT <= :TERFIN AND FACT_ANULADO = 'N' AND
            FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY TERC_NIT, D.ARTI_COD
            INTO :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL, :ARTICULO, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT
            DO
            BEGIN
            select TERC_NOM, TERC_TEL, TERC_CIU, C.ZONA_COD from terceros T, CLIENTES C
                where C.TERC_NIT = T.TERC_NIT AND T.TERC_NIT = :NIT
                INTO :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA;
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :CODZONA INTO :NOMZONA;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        TIPODOC = 32;
        FOR SELECT SUM(RVDE_CANT * RVDE_FACTOR), SUM(RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO), SUM(RVDE_IVAMONTO), SUM(RVDE_CONSUMO), SUM(RVDE_TOTAL),
            max(D.ARTI_COD), MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(TERC_NIT)
            FROM REMISIONES_VENTA_DETALLE D, REMISIONES_VENTA R, PREFIJOS P, ARTICULO A
            WHERE R.REVT_ID = D.REVT_ID AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND D.ARTI_COD = A.ARTI_COD AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            TERC_NIT >= :TERINI AND TERC_NIT <= :TERFIN AND REVT_FECHA >= :FECINI AND
            REVT_FECHA <= :FECFIN AND REVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY TERC_NIT, D.ARTI_COD
            INTO :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL, :ARTICULO, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT
            DO
            BEGIN
            select TERC_NOM, TERC_TEL, TERC_CIU, C.ZONA_COD from terceros T, CLIENTES C
                where C.TERC_NIT = T.TERC_NIT AND T.TERC_NIT = :NIT
                INTO :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA;
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :CODZONA INTO :NOMZONA;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        TIPODOC = 33;
        FOR SELECT SUM(DVDE_CANT * DVDE_FACTOR), SUM((DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR), SUM(DVDE_IVAMONTO*DEVT_FACTOR), SUM(DVDE_CONSUMO), SUM(DVDE_TOTAL*DEVT_FACTOR),
            max(D.ARTI_COD), MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(TERC_NIT)
            FROM devoluciones_ventas_detalle D, DEVOLUCIONES_VENTAS V, PREFIJOS P, ARTICULO A
            WHERE V.DEVT_ID = D.DEVT_ID AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND D.ARTI_COD = A.ARTI_COD AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            TERC_NIT >= :TERINI AND TERC_NIT <= :TERFIN AND DEVT_FECHA >= :FECINI AND
            DEVT_FECHA <= :FECFIN AND DEVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY TERC_NIT, D.ARTI_COD
            INTO :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL, :ARTICULO, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT
            DO
            BEGIN
            select TERC_NOM, TERC_TEL, TERC_CIU, C.ZONA_COD from terceros T, CLIENTES C
                where C.TERC_NIT = T.TERC_NIT AND T.TERC_NIT = :NIT
                INTO :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA;
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :CODZONA INTO :NOMZONA;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            CANTIDAD = CANTIDAD * -1;
            BASE = BASE * -1;
            TOTAL = TOTAL * -1;
            IVA = IVA * -1;
            CONSUMO = CONSUMO * -1;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        TIPODOC = 34;
        FOR SELECT SUM(PEDE_CANT * PEDE_FACTOR), SUM((PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR), SUM(PEDE_IVAMONTO*PEDI_FACTOR), SUM(PEDE_CONSUMO), SUM(PEDE_TOTAL*PEDI_FACTOR),
            max(D.ARTI_COD), MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(TERC_NIT)
            FROM PEDIDOS_DETALLE D, PEDIDOS P, PREFIJOS R, ARTICULO A
            WHERE P.PEDI_ID = D.PEDI_ID AND R.PREF_PRE = P.PREF_PRE AND R.TIDO_COD = 34 AND D.ARTI_COD = A.ARTI_COD AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            TERC_NIT >= :TERINI AND TERC_NIT <= :TERFIN AND PEDI_FECHA >= :FECINI AND
            PEDI_FECHA <= :FECFIN AND PEDI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY TERC_NIT, D.ARTI_COD
            INTO :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL, :ARTICULO, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT
            DO
            BEGIN
            select TERC_NOM, TERC_TEL, TERC_CIU, C.ZONA_COD from terceros T, CLIENTES C
                where C.TERC_NIT = T.TERC_NIT AND T.TERC_NIT = :NIT
                INTO :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA;
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :CODZONA INTO :NOMZONA;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        TIPODOC = 35;
        FOR SELECT SUM(CTDE_CANT * CTDE_FACTOR), SUM((CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR), SUM(CTDE_IVAMONTO*COTI_FACTOR), SUM(CTDE_CONSUMO), SUM(CTDE_TOTAL*COTI_FACTOR),
            max(D.ARTI_COD), MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(TERC_NIT)
            FROM COTIZACIONES_DETALLE D, COTIZACIONES C, PREFIJOS P, ARTICULO A
            WHERE C.COTI_ID = D.COTI_ID AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND D.ARTI_COD = A.ARTI_COD AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            TERC_NIT >= :TERINI AND TERC_NIT <= :TERFIN AND COTI_FECHA >= :FECINI AND
            COTI_FECHA <= :FECFIN AND COTI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY TERC_NIT, D.ARTI_COD
            INTO :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL, :ARTICULO, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT
            DO
            BEGIN
            select TERC_NOM, TERC_TEL, TERC_CIU, C.ZONA_COD from terceros T, CLIENTES C
                where C.TERC_NIT = T.TERC_NIT AND T.TERC_NIT = :NIT
                INTO :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA;
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :CODZONA INTO :NOMZONA;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END
        END
    END
ELSE
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        TIPODOC = 31;
        FOR SELECT F.PREF_PRE, FACT_NUMERO, FACT_FECHA, FADE_CANT * FADE_FACTOR, FADE_PRUNIT/FADE_FACTOR*FACT_FACTOR, FADE_IVAMONTO*FACT_FACTOR, FADE_CONSUMO, FADE_DTOPORC, FADE_TOTAL*FACT_FACTOR,
            D.ARTI_COD, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, TERC_NIT
            FROM FACTURAS F, FACTURAS_DETALLE D, PREFIJOS P, ARTICULO A
            WHERE F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND D.ARTI_COD = A.ARTI_COD AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            TERC_NIT >= :TERINI AND TERC_NIT <= :TERFIN AND FACT_FECHA >= :FECINI AND
            FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY TERC_NIT, ARTI_COD, FACT_FECHA
            INTO :PREFIJO, :NUMERO, :FECHA, CANTIDAD, :BASE, :IVA, :CONSUMO, :dto, :TOTAL, :ARTICULO, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT
            DO
            BEGIN
            select TERC_NOM, TERC_TEL, TERC_CIU, C.ZONA_COD from terceros T, CLIENTES C
                where C.TERC_NIT = T.TERC_NIT AND T.TERC_NIT = :NIT
                INTO :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA;
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :CODZONA INTO :NOMZONA;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        TIPODOC = 32;
        FOR SELECT R.PREF_PRE, REVT_NUMERO, REVT_FECHA, RVDE_CANT * RVDE_FACTOR, RVDE_PRUNIT / RVDE_FACTOR, RVDE_IVAMONTO, RVDE_CONSUMO, RVDE_DTOPORC, RVDE_TOTAL,
            D.ARTI_COD, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, TERC_NIT
            FROM REMISIONES_VENTA R, REMISIONES_VENTA_DETALLE D, PREFIJOS P, ARTICULO A
            WHERE R.REVT_ID = D.REVT_ID AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND D.ARTI_COD = A.ARTI_COD AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            TERC_NIT >= :TERINI AND TERC_NIT <= :TERFIN AND REVT_FECHA >= :FECINI AND
            REVT_FECHA <= :FECFIN AND REVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY TERC_NIT, ARTI_COD, REVT_FECHA
            INTO :PREFIJO, :NUMERO, :FECHA, CANTIDAD, :BASE, :IVA, :CONSUMO, :dto, :TOTAL, :ARTICULO, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT
            DO
            BEGIN
            select TERC_NOM, TERC_TEL, TERC_CIU, C.ZONA_COD from terceros T, CLIENTES C
                where C.TERC_NIT = T.TERC_NIT AND T.TERC_NIT = :NIT
                INTO :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA;
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :CODZONA INTO :NOMZONA;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        TIPODOC = 33;
        FOR SELECT V.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, DVDE_CANT * DVDE_FACTOR, DVDE_PRUNIT/DVDE_FACTOR*DEVT_FACTOR, DVDE_IVAMONTO*DEVT_FACTOR, DVDE_CONSUMO, DVDE_DTOPORC, DVDE_TOTAL*DEVT_FACTOR,
            D.ARTI_COD, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, TERC_NIT
            FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D, PREFIJOS P, ARTICULO A
            WHERE V.DEVT_ID = D.DEVT_ID AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND D.ARTI_COD = A.ARTI_COD AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            TERC_NIT >= :TERINI AND TERC_NIT <= :TERFIN AND DEVT_FECHA >= :FECINI AND
            DEVT_FECHA <= :FECFIN AND DEVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY TERC_NIT, ARTI_COD, DEVT_FECHA
            INTO :PREFIJO, :NUMERO, :FECHA, CANTIDAD, :BASE, :IVA, :CONSUMO, :dto, :TOTAL, :ARTICULO, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT
            DO
            BEGIN
            select TERC_NOM, TERC_TEL, TERC_CIU, C.ZONA_COD from terceros T, CLIENTES C
                where C.TERC_NIT = T.TERC_NIT AND T.TERC_NIT = :NIT
                INTO :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA;
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :CODZONA INTO :NOMZONA;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            CANTIDAD = CANTIDAD * -1;
            BASE = BASE * -1;
            TOTAL = TOTAL * -1;
            IVA = IVA * -1;
            CONSUMO = CONSUMO * -1;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        TIPODOC = 34;
        FOR SELECT P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, PEDE_CANT * PEDE_FACTOR, PEDE_PRUNIT/PEDE_FACTOR*PEDI_FACTOR, PEDE_IVAMONTO*PEDI_FACTOR, PEDE_CONSUMO, PEDE_DTOPORC, PEDE_TOTAL*PEDI_FACTOR,
            D.ARTI_COD, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, TERC_NIT
            FROM PEDIDOS P, PEDIDOS_DETALLE D, PREFIJOS R, ARTICULO A
            WHERE P.PEDI_ID = D.PEDI_ID AND R.PREF_PRE = P.PREF_PRE AND R.TIDO_COD = 34 AND D.ARTI_COD = A.ARTI_COD AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            TERC_NIT >= :TERINI AND TERC_NIT <= :TERFIN AND PEDI_FECHA >= :FECINI AND
            PEDI_FECHA <= :FECFIN AND PEDI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY TERC_NIT, ARTI_COD, PEDI_FECHA
            INTO :PREFIJO, :NUMERO, :FECHA, CANTIDAD, :BASE, :IVA, :CONSUMO, :dto, :TOTAL, :ARTICULO, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT
            DO
            BEGIN
            select TERC_NOM, TERC_TEL, TERC_CIU, C.ZONA_COD from terceros T, CLIENTES C
                where C.TERC_NIT = T.TERC_NIT AND T.TERC_NIT = :NIT
                INTO :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA;
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :CODZONA INTO :NOMZONA;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        TIPODOC = 35;
        FOR SELECT C.PREF_PRE, COTI_NUMERO, COTI_FECHA, CTDE_CANT * CTDE_FACTOR, CTDE_PRUNIT/CTDE_FACTOR*COTI_FACTOR, CTDE_IVAMONTO*COTI_FACTOR, CTDE_CONSUMO, CTDE_DTOPORC, CTDE_TOTAL*COTI_FACTOR,
            D.ARTI_COD, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, TERC_NIT
            FROM COTIZACIONES C, COTIZACIONES_DETALLE D, PREFIJOS P, ARTICULO A
            WHERE C.COTI_ID = D.COTI_ID AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 34 AND D.ARTI_COD = A.ARTI_COD AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            TERC_NIT >= :TERINI AND TERC_NIT <= :TERFIN AND COTI_FECHA >= :FECINI AND
            COTI_FECHA <= :FECFIN AND COTI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY TERC_NIT, ARTI_COD, COTI_FECHA
            INTO :PREFIJO, :NUMERO, :FECHA, CANTIDAD, :BASE, :IVA, :CONSUMO, :dto, :TOTAL, :ARTICULO, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT
            DO
            BEGIN
            select TERC_NOM, TERC_TEL, TERC_CIU, C.ZONA_COD from terceros T, CLIENTES C
                where C.TERC_NIT = T.TERC_NIT AND T.TERC_NIT = :NIT
                INTO :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA;
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :CODZONA INTO :NOMZONA;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SUSPEND;
            END
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_ARTICULOS_VENDEDOR(
    TIPO INTEGER,
    DETALLE CHAR(1),
    DESDE VARCHAR(20),
    HASTA VARCHAR(20),
    FECINI DATE,
    FECFIN DATE,
    ARTINI VARCHAR(15),
    ARTFIN VARCHAR(15),
    GRPINI VARCHAR(3),
    GRPFIN VARCHAR(3),
    ORDEN CHAR(1),
    AGRUPA CHAR(1),
    CEROS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    CODVEND VARCHAR(20),
    NOMVEND VARCHAR(60),
    NOMTIPO VARCHAR(50),
    ARTICULO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    UNIDAD VARCHAR(8),
    CANTIDAD NUMERIC(18,4),
    BASE NUMERIC(18,2),
    IVA NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    DTO NUMERIC(9,2),
    NIT VARCHAR(20),
    NOMCLIENTE VARCHAR(60),
    CODZONA VARCHAR(2),
    NOMZONA VARCHAR(60))
AS
declare variable CODINI VARCHAR(15);
declare variable CODFIN VARCHAR(15);
declare variable DESINI VARCHAR(15);
declare variable DESFIN VARCHAR(15);
declare variable MARINI VARCHAR(3);
declare variable MARFIN VARCHAR(3);
BEGIN
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END
if (AGRUPA = 'G') then
    BEGIN
    MARINI = '';
    MARFIN = 'zz';
    END
ELSE
    if (AGRUPA = 'M') then
        BEGIN
        MARINI = GRPINI;
        MARFIN = GRPFIN;
        GRPINI = '';
        GRPFIN = 'zz';
        END
    ELSE
        BEGIN
        MARINI = '';
        MARFIN = 'zz';
        END
if (DETALLE = 'N') then
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(FADE_CANT * FADE_FACTOR), SUM((FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR), SUM(FADE_IVAMONTO*FACT_FACTOR), SUM(FADE_CONSUMO), SUM(FADE_TOTAL*FACT_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P, ARTICULO A
            WHERE F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            FACT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY VEND_COD, D.ARTI_COD
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(RVDE_CANT * RVDE_FACTOR), SUM(RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO), SUM(RVDE_IVAMONTO), SUM(RVDE_CONSUMO), SUM(RVDE_TOTAL),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM REMISIONES_VENTA_DETALLE D, REMISIONES_VENTA R, PREFIJOS P, ARTICULO A
            WHERE R.REVT_ID = D.REVT_ID AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            REVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY R.vend_cod, D.ARTI_COD
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(DVDE_CANT * DVDE_FACTOR), SUM((DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR), SUM(DVDE_IVAMONTO*DEVT_FACTOR), SUM(DVDE_CONSUMO), SUM(DVDE_TOTAL*DEVT_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM devoluciones_ventas_detalle D, DEVOLUCIONES_VENTAS V, PREFIJOS P, ARTICULO A
            WHERE V.DEVT_ID = D.DEVT_ID AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            DEVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY V.vend_cod, D.ARTI_COD
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            CANTIDAD = CANTIDAD * -1;
            BASE = BASE * -1;
            TOTAL = TOTAL * -1;
            IVA = IVA * -1;
            CONSUMO = CONSUMO * -1;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(PEDE_CANT * PEDE_FACTOR), SUM((PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR), SUM(PEDE_IVAMONTO*PEDI_FACTOR), SUM(PEDE_CONSUMO), SUM(PEDE_TOTAL*PEDI_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM PEDIDOS_DETALLE D, PEDIDOS P, PREFIJOS R, ARTICULO A
            WHERE P.PEDI_ID = D.PEDI_ID AND P.PREF_PRE = R.PREF_PRE AND R.TIDO_COD = 34 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            PEDI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY P.vend_cod, D.ARTI_COD
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(CTDE_CANT * CTDE_FACTOR), SUM((CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR), SUM(CTDE_IVAMONTO*COTI_FACTOR), SUM(CTDE_CONSUMO), SUM(CTDE_TOTAL*COTI_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM COTIZACIONES_DETALLE D, COTIZACIONES C, PREFIJOS P, ARTICULO A
            WHERE C.COTI_ID = D.COTI_ID AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            COTI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY C.vend_cod, D.ARTI_COD
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    END
ELSE
  if (DETALLE = 'S') then
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
        FOR SELECT F.PREF_PRE, FACT_NUMERO, FACT_FECHA, VEND_COD, D.ARTI_COD, FADE_CANT * FADE_FACTOR, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR, FADE_IVAMONTO*FACT_FACTOR, FADE_CONSUMO, FADE_DTOPORC, FADE_TOTAL*FACT_FACTOR,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD , F.TERC_NIT, F.fact_nomcliente
            FROM FACTURAS F, FACTURAS_DETALLE D, PREFIJOS P, ARTICULO A
            WHERE F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND D.ARTI_COD = A.arti_cod AND
                VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND FACT_FECHA >= :FECINI AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY VEND_COD, D.ARTI_COD, FACT_FECHA, F.FACT_ID, FADE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :CODVEND, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO, :DTO, :TOTAL,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT, :nomcliente
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
        FOR SELECT R.PREF_PRE, REVT_NUMERO, REVT_FECHA, VEND_COD, D.ARTI_COD, RVDE_CANT * RVDE_FACTOR, (RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO), RVDE_IVAMONTO, RVDE_CONSUMO, RVDE_DTOPORC, RVDE_TOTAL,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, R.terc_nit, R.revt_nomterc
            FROM REMISIONES_VENTA R, REMISIONES_VENTA_DETALLE D, PREFIJOS P, ARTICULO A
            WHERE R.REVT_ID = D.REVT_ID AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND D.ARTI_COD = A.arti_cod AND
                VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                REVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY VEND_COD, D.ARTI_COD, REVT_FECHA, R.REVT_ID, RVDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :CODVEND, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO, :DTO, :TOTAL,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT, :nomcliente
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
        FOR SELECT V.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, VEND_COD, D.ARTI_COD, DVDE_CANT * DVDE_FACTOR, (DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR, DVDE_IVAMONTO*DEVT_FACTOR, DVDE_CONSUMO, DVDE_DTOPORC, DVDE_TOTAL*DEVT_FACTOR,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, V.terc_nit, V.devt_nomterc
            FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D, PREFIJOS P, ARTICULO A
            WHERE V.DEVT_ID = D.DEVT_ID AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND D.ARTI_COD = A.arti_cod AND
                VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                DEVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY VEND_COD, D.ARTI_COD, DEVT_FECHA, V.DEVT_ID, DVDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :CODVEND, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO, :DTO, :TOTAL,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT, :nomcliente
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            CANTIDAD = CANTIDAD * -1;
            BASE = BASE * -1;
            TOTAL = TOTAL * -1;
            IVA = IVA * -1;
            CONSUMO = CONSUMO * -1;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
        FOR SELECT P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, VEND_COD, D.ARTI_COD, PEDE_CANT * PEDE_FACTOR, (PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR, PEDE_IVAMONTO*PEDI_FACTOR, PEDE_CONSUMO, PEDE_DTOPORC, PEDE_TOTAL*PEDI_FACTOR,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, P.terc_nit, P.pedi_nomterc
            FROM PEDIDOS P, PEDIDOS_DETALLE D, PREFIJOS R, ARTICULO A
            WHERE P.PEDI_ID = D.PEDI_ID AND P.PREF_PRE = R.PREF_PRE AND R.TIDO_COD = 34 AND D.ARTI_COD = A.arti_cod AND
                VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                PEDI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY VEND_COD, D.ARTI_COD, PEDI_FECHA, P.PEDI_ID, PEDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :CODVEND, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO, :DTO, :TOTAL,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT, :nomcliente
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
        FOR SELECT C.PREF_PRE, COTI_NUMERO, COTI_FECHA, VEND_COD, D.ARTI_COD, CTDE_CANT * CTDE_FACTOR, (CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR, CTDE_IVAMONTO*COTI_FACTOR, CTDE_CONSUMO, CTDE_DTOPORC, CTDE_TOTAL*COTI_FACTOR,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, C.terc_nit, C.coti_nomterc
            FROM COTIZACIONES C, COTIZACIONES_DETALLE D, PREFIJOS P, ARTICULO A
            WHERE C.COTI_ID = D.COTI_ID AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND D.ARTI_COD = A.arti_cod AND
                VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                COTI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY VEND_COD, D.ARTI_COD, COTI_FECHA, C.COTI_ID, CTDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :CODVEND, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO, :DTO, :TOTAL,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT, :nomcliente
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SUSPEND;
            END
        END
    END
  ELSE
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(FADE_CANT * FADE_FACTOR), SUM((FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR), SUM(FADE_IVAMONTO*FACT_FACTOR), SUM(FADE_CONSUMO), SUM(FADE_TOTAL*FACT_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(F.terc_nit), MAX(F.fact_nomcliente)
            FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P, ARTICULO A
            WHERE F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            FACT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY F.VEND_COD, F.TERC_NIT, D.ARTI_COD
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit INTO :codzona, :nomzona;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(RVDE_CANT * RVDE_FACTOR), SUM(RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO), SUM(RVDE_IVAMONTO), SUM(RVDE_CONSUMO), SUM(RVDE_TOTAL),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(R.terc_nit), MAX(R.revt_nomterc)
            FROM REMISIONES_VENTA_DETALLE D, REMISIONES_VENTA R, PREFIJOS P, ARTICULO A
            WHERE R.REVT_ID = D.REVT_ID AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            REVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY R.vend_cod, R.terc_nit, D.arti_cod
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit INTO :codzona, :nomzona;
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            CANTIDAD = CANTIDAD * -1;
            BASE = BASE * -1;
            TOTAL = TOTAL * -1;
            IVA = IVA * -1;
            CONSUMO = CONSUMO * -1;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(DVDE_CANT * DVDE_FACTOR), SUM((DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR), SUM(DVDE_IVAMONTO*DEVT_FACTOR), SUM(DVDE_CONSUMO), SUM(DVDE_TOTAL*DEVT_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(V.terc_nit), MAX(V.devt_nomterc)
            FROM devoluciones_ventas_detalle D, DEVOLUCIONES_VENTAS V, PREFIJOS P, ARTICULO A
            WHERE V.DEVT_ID = D.DEVT_ID AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            DEVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY V.vend_cod, V.terc_nit, D.arti_cod
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit INTO :codzona, :nomzona;
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(PEDE_CANT * PEDE_FACTOR), SUM((PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR), SUM(PEDE_IVAMONTO*PEDI_FACTOR), SUM(PEDE_CONSUMO), SUM(PEDE_TOTAL*PEDI_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(P.terc_nit), MAX(P.pedi_nomterc)
            FROM PEDIDOS_DETALLE D, PEDIDOS P, PREFIJOS R, ARTICULO A
            WHERE P.PEDI_ID = D.PEDI_ID AND P.PREF_PRE = R.PREF_PRE AND R.TIDO_COD = 34 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            PEDI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY P.vend_cod, P.terc_nit, D.arti_cod
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit INTO :codzona, :nomzona;
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(CTDE_CANT * CTDE_FACTOR), SUM((CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR), SUM(CTDE_IVAMONTO*COTI_FACTOR), SUM(CTDE_CONSUMO), SUM(CTDE_TOTAL*COTI_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(C.terc_nit), MAX(C.coti_nomterc)
            FROM COTIZACIONES_DETALLE D, COTIZACIONES C, PREFIJOS P, ARTICULO A
            WHERE C.COTI_ID = D.COTI_ID AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            COTI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY C.vend_cod, C.terc_nit, D.arti_cod
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit INTO :codzona, :nomzona;
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_VENTAS_ARTICULO(
    TIPO INTEGER,
    ARTINI VARCHAR(20),
    ARTFIN VARCHAR(20),
    DETALLE CHAR(1),
    FECINI DATE,
    FECFIN DATE,
    GRPINI VARCHAR(3),
    GRPFIN VARCHAR(3),
    PTOINI INTEGER,
    PTOFIN INTEGER,
    ORDEN CHAR(1),
    AGRUPA CHAR(1),
    CEROS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    ARTICULO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    UNIDAD VARCHAR(8),
    CANTIDAD NUMERIC(18,4),
    BASE NUMERIC(18,2),
    IVA NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    DTO NUMERIC(9,2),
    TRANSP VARCHAR(60),
    NOMTIPO VARCHAR(50))
AS
DECLARE VARIABLE CODINI VARCHAR(20);
DECLARE VARIABLE CODFIN VARCHAR(20);
DECLARE VARIABLE DESINI VARCHAR(20);
DECLARE VARIABLE DESFIN VARCHAR(20);
declare variable MARINI VARCHAR(3);
declare variable MARFIN VARCHAR(3);
declare variable NUMROWS INTEGER;
BEGIN
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '0';
    CODFIN = 'zz';
    END
if (AGRUPA = 'G') then
    BEGIN
    MARINI = '';
    MARFIN = 'zz';
    END
ELSE
    if (AGRUPA = 'M') then
        BEGIN
        MARINI = GRPINI;
        MARFIN = GRPFIN;
        GRPINI = '';
        GRPFIN = 'zz';
        END
    ELSE
        BEGIN
        MARINI = '';
        MARFIN = 'zz';
        END
/* BORRA LA TABLA AUXILIAR */
DELETE FROM reportes_aux WHERE REPA_ID = 1 AND REPA_USER = USER;

if (DETALLE = 'N') then
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 1 AND REPA_USER = USER;

        FOR SELECT MAX(D.ARTI_COD), SUM(FADE_CANT * FADE_FACTOR), SUM(FACT_FACTOR*(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)),
            SUM(FACT_FACTOR*FADE_IVAMONTO), SUM(FADE_CONSUMO), MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P, ARTICULO A WHERE F.PTVT_ID >= :PTOINI AND F.PTVT_ID <= :PTOFIN AND
            F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND D.ARTI_COD = A.arti_cod AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            FACT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY D.ARTI_COD
            INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (1, USER, :ARTICULO);
            SUSPEND;
            END
        if (CEROS = 'S') then
            BEGIN
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND
                    A.ARTI_DES <= :DESFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND
                    (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN)))
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,:DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 1 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END

    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 1 AND REPA_USER = USER;

        FOR SELECT MAX(D.ARTI_COD), SUM(RVDE_CANT * RVDE_FACTOR), SUM((RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO)), SUM(RVDE_IVAMONTO),
            SUM(RVDE_CONSUMO), MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM REMISIONES_VENTA_DETALLE D, REMISIONES_VENTA R, PREFIJOS P, ARTICULO A WHERE R.PTVT_ID >= :PTOINI AND R.PTVT_ID <= :PTOFIN AND
            R.REVT_ID = D.REVT_ID AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND D.ARTI_COD = A.arti_cod AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            REVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY D.ARTI_COD
            INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (1, USER, :ARTICULO);
            SUSPEND;
            END
        if (CEROS = 'S') then
            BEGIN
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND
                    A.ARTI_DES <= :DESFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND
                    (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN)))
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,:DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 1 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END

    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 1 AND REPA_USER = USER;

        FOR SELECT MAX(D.ARTI_COD), SUM(DVDE_CANT * DVDE_FACTOR), SUM(DEVT_FACTOR*(DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)),
            SUM(DEVT_FACTOR*DVDE_IVAMONTO), SUM(DVDE_CONSUMO), MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM devoluciones_ventas_detalle D, DEVOLUCIONES_VENTAS V, PREFIJOS P, ARTICULO A WHERE V.PTVT_ID >= :PTOINI AND V.PTVT_ID <= :PTOFIN AND
            V.DEVT_ID = D.DEVT_ID AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND D.ARTI_COD = A.arti_cod AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            DEVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) AND ((DEVT_REMID = 0) or (DEVT_REMID IS NULL))
            GROUP BY D.ARTI_COD
            INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            CANTIDAD = CANTIDAD * -1;
            BASE = BASE * -1;
            IVA = IVA * -1;
            CONSUMO = CONSUMO * -1;
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (1, USER, :ARTICULO);
            SUSPEND;
            END
        if (CEROS = 'S') then
            BEGIN
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND
                    A.ARTI_DES <= :DESFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND
                    (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN)))
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,:DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 1 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 1 AND REPA_USER = USER;

        FOR SELECT MAX(D.ARTI_COD), SUM(PEDE_CANT * PEDE_FACTOR), SUM(PEDI_FACTOR*(PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)),
            SUM(PEDI_FACTOR*PEDE_IVAMONTO), SUM(PEDE_CONSUMO),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM PEDIDOS_DETALLE D, PEDIDOS P, PREFIJOS R, ARTICULO A WHERE P.PTVT_ID >= :PTOINI AND P.PTVT_ID <= :PTOFIN AND
            P.PEDI_ID = D.PEDI_ID AND P.PREF_PRE = R.PREF_PRE AND R.TIDO_COD = 34 AND D.ARTI_COD = A.arti_cod AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            PEDI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY D.ARTI_COD
            INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (1, USER, :ARTICULO);
            SUSPEND;
            END
        if (CEROS = 'S') then
            BEGIN
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND
                    A.ARTI_DES <= :DESFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND
                    (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN)))
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,:DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 1 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 1 AND REPA_USER = USER;

        FOR SELECT MAX(D.ARTI_COD), SUM(CTDE_CANT * CTDE_FACTOR), SUM(COTI_FACTOR*(CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)),
            SUM(COTI_FACTOR*CTDE_IVAMONTO), SUM(CTDE_CONSUMO),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM COTIZACIONES_DETALLE D, COTIZACIONES C, PREFIJOS P, ARTICULO A WHERE C.PTVT_ID >= :PTOINI AND C.PTVT_ID <= :PTOFIN AND
            C.COTI_ID = D.COTI_ID AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND D.ARTI_COD = A.arti_cod AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            COTI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY D.ARTI_COD
            INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (1, USER, :ARTICULO);
            SUSPEND;
            END
        if (CEROS = 'S') then
            BEGIN
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND
                    A.ARTI_DES <= :DESFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND
                    (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN)))
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,:DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 1 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    END
ELSE
  if (DETALLE = 'S') then
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
        FOR SELECT F.PREF_PRE, FACT_NUMERO, FACT_FECHA, D.ARTI_COD, FADE_CANT * FADE_FACTOR, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR,
        FADE_IVAMONTO*FACT_FACTOR, FADE_CONSUMO, FADE_DTOPORC,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, FACT_TRANSP
            FROM FACTURAS F, FACTURAS_DETALLE D, PREFIJOS P, ARTICULO A WHERE F.PTVT_ID >= :PTOINI AND F.PTVT_ID <= :PTOFIN AND
                F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND D.ARTI_COD = A.arti_cod AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND FACT_FECHA >= :FECINI AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            /*ORDER BY D.ARTI_COD, FACT_FECHA, FACT_ID, FADE_ITEM*/
            INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO, :DTO,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :transp
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
        FOR SELECT R.PREF_PRE, REVT_NUMERO, REVT_FECHA, D.ARTI_COD, RVDE_CANT * RVDE_FACTOR, (RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO), RVDE_IVAMONTO, RVDE_CONSUMO, RVDE_DTOPORC,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, REVT_TRANSP
            FROM REMISIONES_VENTA R, REMISIONES_VENTA_DETALLE D, PREFIJOS P, ARTICULO A
            WHERE R.REVT_ID = D.REVT_ID AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND D.ARTI_COD = A.arti_cod AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                REVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO, :DTO,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :transp
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
        FOR SELECT V.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, D.ARTI_COD, DVDE_CANT * DVDE_FACTOR, (DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR,
            DVDE_IVAMONTO*DEVT_FACTOR, DVDE_CONSUMO, DVDE_DTOPORC,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD 
            FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D, PREFIJOS P, ARTICULO A WHERE V.PTVT_ID >= :PTOINI AND V.PTVT_ID <= :PTOFIN AND
                V.DEVT_ID = D.DEVT_ID AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND D.ARTI_COD = A.arti_cod AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                DEVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) AND ((DEVT_REMID = 0) or (DEVT_REMID IS NULL))
            /*ORDER BY D.ARTI_COD, DEVT_FECHA, DEVT_ID, DVDE_ITEM*/
            INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO, :DTO,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            CANTIDAD = CANTIDAD * -1;
            BASE = BASE * -1;
            IVA = IVA * -1;
            CONSUMO = CONSUMO * -1;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
        FOR SELECT P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, D.ARTI_COD, PEDE_CANT * PEDE_FACTOR, (PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR,
                PEDE_IVAMONTO*PEDI_FACTOR, PEDE_CONSUMO, PEDE_DTOPORC,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD 
            FROM PEDIDOS P, PEDIDOS_DETALLE D, PREFIJOS R, ARTICULO A WHERE P.PTVT_ID >= :PTOINI AND P.PTVT_ID <= :PTOFIN AND
                P.PEDI_ID = D.PEDI_ID AND P.PREF_PRE = R.PREF_PRE AND R.TIDO_COD = 34 AND D.ARTI_COD = A.arti_cod AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                PEDI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            /*ORDER BY D.ARTI_COD, PEDI_FECHA, PEDI_ID, PEDE_ITEM*/
            INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO, :DTO,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
        FOR SELECT C.PREF_PRE, COTI_NUMERO, COTI_FECHA, D.ARTI_COD, CTDE_CANT * CTDE_FACTOR, (CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR,
                CTDE_IVAMONTO*COTI_FACTOR, CTDE_CONSUMO, CTDE_DTOPORC,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD 
            FROM COTIZACIONES C, COTIZACIONES_DETALLE D, PREFIJOS P, ARTICULO A WHERE C.PTVT_ID >= :PTOINI AND C.PTVT_ID <= :PTOFIN AND
                C.COTI_ID = D.COTI_ID AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND D.ARTI_COD = A.arti_cod AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                COTI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            /*ORDER BY D.ARTI_COD, COTI_FECHA, COTI_ID, CTDE_ITEM*/
            INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO, :DTO,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SUSPEND;
            END
        END
    END
  ELSE
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), SUM(FADE_CANT * FADE_FACTOR), SUM((FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR),
            SUM(FACT_FACTOR*FADE_IVAMONTO), SUM(FADE_CONSUMO), MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(FACT_TRANSP)
            FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P, ARTICULO A WHERE F.PTVT_ID >= :PTOINI AND F.PTVT_ID <= :PTOFIN AND
            F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND D.ARTI_COD = A.arti_cod AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            FACT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY FACT_TRANSP, D.ARTI_COD
            INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :transp
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END
        END

    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), SUM(RVDE_CANT * RVDE_FACTOR), SUM((RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO)), SUM(RVDE_IVAMONTO),
            SUM(RVDE_CONSUMO), MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(REVT_TRANSP)
            FROM REMISIONES_VENTA_DETALLE D, REMISIONES_VENTA R, PREFIJOS P, ARTICULO A WHERE R.PTVT_ID >= :PTOINI AND R.PTVT_ID <= :PTOFIN AND
            R.REVT_ID = D.REVT_ID AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND D.ARTI_COD = A.arti_cod AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            REVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY REVT_TRANSP, D.ARTI_COD
            INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :transp
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_VENTAS_CLIENTE(
    TIPO INTEGER,
    NITDESDE VARCHAR(20),
    NITHASTA VARCHAR(20),
    FECINI DATE,
    FECFIN DATE,
    DETALLE CHAR(1),
    ORDEN CHAR(1),
    CEROS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    TELEFONO VARCHAR(40),
    CIUDAD VARCHAR(40),
    CODZONA VARCHAR(2),
    NOMZONA VARCHAR(30),
    NOMTIPO VARCHAR(50),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    ID INTEGER,
    FECDOC DATE,
    CANTIDAD INTEGER,
    SUBTOTAL NUMERIC(18,2),
    DTO NUMERIC(18,2),
    ADICIONAL NUMERIC(18,2),
    IVA NUMERIC(18,2),
    EXTRA NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    RTFTE NUMERIC(18,2),
    RTIVA NUMERIC(18,2),
    RTICA NUMERIC(18,2),
    NETO NUMERIC(18,2))
AS
DECLARE VARIABLE NITINI VARCHAR(15);
DECLARE VARIABLE NITFIN VARCHAR(15);
DECLARE VARIABLE NOMINI VARCHAR(15);
DECLARE VARIABLE NOMFIN VARCHAR(15);
BEGIN
if (ORDEN = 'C') then
    BEGIN
    NITINI = NITDESDE;
    NITFIN = NITHASTA;
    NOMINI = '';
    NOMFIN = 'zz';
    END
ELSE
    BEGIN
    NITINI = NITDESDE;
    NITFIN = NITHASTA;
    NOMINI = '';
    NOMFIN = 'zz';
    END

SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPO INTO :NOMTIPO;
if (DETALLE = 'N') then
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
        FOR SELECT MAX(T.TERC_NIT), MAX(TERC_NOM), MAX(TERC_TEL), MAX(TERC_CIU), MAX(ZONA_COD),
            COUNT(*), SUM(FACT_DTOMONTO), SUM(FACT_ADICIONAL), SUM(FACT_IVAMONTO), SUM(FACT_EXTRA), SUM(FACT_RTFTEMONTO), SUM(FACT_RTIVAMONTO), SUM(FACT_RTICAMONTO), SUM(FACT_TOTAL)
            FROM FACTURAS F, PREFIJOS P, terceros T, CLIENTES C
            where C.TERC_NIT = T.TERC_NIT AND T.TERC_CLIE = 'S' AND T.TERC_NIT >= :NITINI AND T.TERC_NIT <= :NITFIN AND TERC_NOM >= :NOMINI AND TERC_NOM <= :NOMFIN
             AND F.TERC_NIT = T.terc_nit AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N'
             AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY F.terc_nit
            INTO :NIT, :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA, :CANTIDAD, :DTO, :ADICIONAL, :IVA, :EXTRA, :RTFTE, :RTIVA, :RTICA, :TOTAL
            DO
            BEGIN
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :codzona INTO :NOMZONA;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (DTO IS NULL) then
                DTO = 0;
            if (ADICIONAL IS NULL) then
                ADICIONAL = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (EXTRA IS NULL) then
                EXTRA = 0;
            if (RTFTE IS NULL) then
                RTFTE = 0;
            if (RTIVA IS NULL) then
                RTIVA = 0;
            if (RTICA IS NULL) then
                RTICA = 0;
            SUBTOTAL = TOTAL - EXTRA - IVA - ADICIONAL + DTO;
            NETO = TOTAL - RTFTE - RTIVA - RTICA;
            if (CEROS = 'S') then
              SUSPEND;
            ELSE
              if (CANTIDAD > 0) then
                SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
        FOR SELECT MAX(T.TERC_NIT), MAX(TERC_NOM), MAX(TERC_TEL), MAX(TERC_CIU), MAX(ZONA_COD),
            COUNT(*), 0, 0, SUM(REVT_IVAMONTO), 0, 0, 0, 0, SUM(REVT_TOTAL)
            FROM REMISIONES_VENTA R, PREFIJOS P, terceros T, CLIENTES C
            where C.TERC_NIT = T.TERC_NIT AND T.TERC_CLIE = 'S' AND T.TERC_NIT >= :NITINI AND T.TERC_NIT <= :NITFIN AND TERC_NOM >= :NOMINI AND TERC_NOM <= :NOMFIN
             AND R.TERC_NIT = T.terc_nit AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND REVT_ANULADO = 'N'
             AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY R.terc_nit
            INTO :NIT, :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA, :CANTIDAD, :DTO, :ADICIONAL, :IVA, :EXTRA, :RTFTE, :RTIVA, :RTICA, :TOTAL
            DO
            BEGIN
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :codzona INTO :NOMZONA;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (DTO IS NULL) then
                DTO = 0;
            if (ADICIONAL IS NULL) then
                ADICIONAL = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (EXTRA IS NULL) then
                EXTRA = 0;
            if (RTFTE IS NULL) then
                RTFTE = 0;
            if (RTIVA IS NULL) then
                RTIVA = 0;
            if (RTICA IS NULL) then
                RTICA = 0;
            SUBTOTAL = TOTAL - EXTRA - IVA - ADICIONAL + DTO;
            NETO = TOTAL - RTFTE - RTIVA - RTICA;
            if (CEROS = 'S') then
              SUSPEND;
            ELSE
              if (CANTIDAD > 0) then
                SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
        FOR SELECT MAX(T.TERC_NIT), MAX(TERC_NOM), MAX(TERC_TEL), MAX(TERC_CIU), MAX(ZONA_COD),
            COUNT(*), SUM(DEVT_DTOMONTO), SUM(DEVT_ADICIONAL), SUM(DEVT_IVAMONTO), SUM(DEVT_EXTRA), SUM(DEVT_RTFTEMONTO), SUM(DEVT_RTIVAMONTO), SUM(DEVT_RTICAMONTO), SUM(DEVT_TOTAL)
            FROM DEVOLUCIONES_VENTAS V, PREFIJOS P, terceros T, CLIENTES C
            where C.TERC_NIT = T.TERC_NIT AND T.TERC_CLIE = 'S' AND T.TERC_NIT >= :NITINI AND T.TERC_NIT <= :NITFIN AND TERC_NOM >= :NOMINI AND TERC_NOM <= :NOMFIN
             AND V.TERC_NIT = T.terc_nit AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND DEVT_ANULADO = 'N'
             AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) AND ((DEVT_REMID = 0) or (DEVT_REMID IS NULL))
            GROUP BY V.terc_nit
            INTO :NIT, :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA, :CANTIDAD, :DTO, :ADICIONAL, :IVA, :EXTRA, :RTFTE, :RTIVA, :RTICA, :TOTAL
            DO
            BEGIN
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :codzona INTO :NOMZONA;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (DTO IS NULL) then
                DTO = 0;
            if (ADICIONAL IS NULL) then
                ADICIONAL = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (EXTRA IS NULL) then
                EXTRA = 0;
            if (RTFTE IS NULL) then
                RTFTE = 0;
            if (RTIVA IS NULL) then
                RTIVA = 0;
            if (RTICA IS NULL) then
                RTICA = 0;
            SUBTOTAL = TOTAL - EXTRA - IVA - ADICIONAL + DTO;
            NETO = TOTAL - RTFTE - RTIVA - RTICA;
            CANTIDAD = CANTIDAD * -1;
            SUBTOTAL = SUBTOTAL * -1;
            TOTAL = TOTAL * -1;
            IVA = IVA * -1;
            EXTRA = EXTRA * -1;
            DTO = DTO * -1;
            ADICIONAL = ADICIONAL * -1;
            RTFTE = RTFTE * -1;
            RTIVA = RTIVA * -1;
            RTICA = RTICA * -1;
            if (CEROS = 'S') then
              SUSPEND;
            ELSE
              if (CANTIDAD > 0) then
                SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
        FOR SELECT MAX(T.TERC_NIT), MAX(TERC_NOM), MAX(TERC_TEL), MAX(TERC_CIU), MAX(ZONA_COD),
            COUNT(*), SUM(PEDI_DTOMONTO), SUM(PEDI_ADICIONAL), SUM(PEDI_IVAMONTO), SUM(PEDI_EXTRA), 0, 0, 0, SUM(PEDI_TOTAL)
            FROM PEDIDOS P, PREFIJOS PR, terceros T, CLIENTES C
            where C.TERC_NIT = T.TERC_NIT AND T.TERC_CLIE = 'S' AND T.TERC_NIT >= :NITINI AND T.TERC_NIT <= :NITFIN AND TERC_NOM >= :NOMINI AND TERC_NOM <= :NOMFIN
             AND P.TERC_NIT = T.terc_nit AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND PEDI_ANULADO = 'N'
             AND PR.PREF_PRE = P.PREF_PRE AND P.TIDO_COD = 34 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY P.terc_nit
            INTO :NIT, :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA, :CANTIDAD, :DTO, :ADICIONAL, :IVA, :EXTRA, :RTFTE, :RTIVA, :RTICA, :TOTAL
            DO
            BEGIN
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :codzona INTO :NOMZONA;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (DTO IS NULL) then
                DTO = 0;
            if (ADICIONAL IS NULL) then
                ADICIONAL = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (EXTRA IS NULL) then
                EXTRA = 0;
            if (RTFTE IS NULL) then
                RTFTE = 0;
            if (RTIVA IS NULL) then
                RTIVA = 0;
            if (RTICA IS NULL) then
                RTICA = 0;
            SUBTOTAL = TOTAL - EXTRA - IVA - ADICIONAL + DTO;
            NETO = TOTAL - RTFTE - RTIVA - RTICA;
            if (CEROS = 'S') then
              SUSPEND;
            ELSE
              if (CANTIDAD > 0) then
                SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
        FOR SELECT MAX(T.TERC_NIT), MAX(TERC_NOM), MAX(TERC_TEL), MAX(TERC_CIU), MAX(ZONA_COD),
            COUNT(*), SUM(COTI_DTOMONTO), SUM(COTI_ADICIONAL), SUM(COTI_IVAMONTO), SUM(COTI_EXTRA), 0, 0, 0, SUM(COTI_TOTAL)
            FROM COTIZACIONES CT, PREFIJOS P, terceros T, CLIENTES C
            where C.TERC_NIT = T.TERC_NIT AND T.TERC_CLIE = 'S' AND T.TERC_NIT >= :NITINI AND T.TERC_NIT <= :NITFIN AND TERC_NOM >= :NOMINI AND TERC_NOM <= :NOMFIN
             AND CT.TERC_NIT = T.terc_nit AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND COTI_ANULADO = 'N'
             AND P.PREF_PRE = CT.PREF_PRE AND P.TIDO_COD = 35 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY C.terc_nit
            INTO :NIT, :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA, :CANTIDAD, :DTO, :ADICIONAL, :IVA, :EXTRA, :RTFTE, :RTIVA, :RTICA, :TOTAL
            DO
            BEGIN
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :codzona INTO :NOMZONA;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (DTO IS NULL) then
                DTO = 0;
            if (ADICIONAL IS NULL) then
                ADICIONAL = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (EXTRA IS NULL) then
                EXTRA = 0;
            if (RTFTE IS NULL) then
                RTFTE = 0;
            if (RTIVA IS NULL) then
                RTIVA = 0;
            if (RTICA IS NULL) then
                RTICA = 0;
            SUBTOTAL = TOTAL - EXTRA - IVA - ADICIONAL + DTO;
            NETO = TOTAL - RTFTE - RTIVA - RTICA;
            if (CEROS = 'S') then
              SUSPEND;
            ELSE
              if (CANTIDAD > 0) then
                SUSPEND;
            END
        END
    END
ELSE
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
        FOR SELECT FACT_ID, F.PREF_PRE, FACT_NUMERO, FACT_FECHA, FACT_DTOMONTO, FACT_ADICIONAL, FACT_IVAMONTO, FACT_EXTRA, FACT_TOTAL, FACT_RTFTEMONTO, FACT_RTIVAMONTO, FACT_RTICAMONTO, T.TERC_NIT, TERC_NOM, ZONA_COD, TERC_TEL, TERC_CIU
            FROM FACTURAS F, PREFIJOS P, terceros T, CLIENTES C
            where C.TERC_NIT = T.TERC_NIT AND T.TERC_CLIE = 'S' AND T.TERC_NIT >= :NITINI AND T.TERC_NIT <= :NITFIN AND TERC_NOM >= :NOMINI AND TERC_NOM <= :NOMFIN
             AND F.TERC_NIT = T.terc_nit AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N'
             AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY FACT_FECHA, FACT_ID
            INTO :ID, :PREFIJO, :NUMERO, :FECDOC, :DTO, :ADICIONAL, :IVA, :EXTRA, :TOTAL, :RTFTE, :RTIVA, :RTICA, :nit, :nombre, :codzona, :telefono, :ciudad
            DO
            BEGIN
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :codzona INTO :NOMZONA;
            SUBTOTAL = TOTAL - EXTRA - IVA - ADICIONAL + DTO;
            NETO = TOTAL - RTFTE - RTIVA - RTICA;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
        FOR SELECT REVT_ID, R.PREF_PRE, REVT_NUMERO, REVT_FECHA, 0, 0, REVT_IVAMONTO, 0, REVT_TOTAL, 0, 0, 0, T.TERC_NIT, TERC_NOM, ZONA_COD, TERC_TEL, TERC_CIU
            FROM REMISIONES_VENTA R, PREFIJOS P, terceros T, CLIENTES C
            where C.TERC_NIT = T.TERC_NIT AND T.TERC_CLIE = 'S' AND T.TERC_NIT >= :NITINI AND T.TERC_NIT <= :NITFIN AND TERC_NOM >= :NOMINI AND TERC_NOM <= :NOMFIN
             AND R.TERC_NIT = T.terc_nit AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND REVT_ANULADO = 'N'
             AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY REVT_FECHA, REVT_ID
            INTO :ID, :PREFIJO, :NUMERO, :FECDOC, :DTO, :ADICIONAL, :IVA, :EXTRA, :TOTAL, :RTFTE, :RTIVA, :RTICA, :nit, :nombre, :codzona, :telefono, :ciudad
            DO
            BEGIN
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :codzona INTO :NOMZONA;
            SUBTOTAL = TOTAL - EXTRA - IVA - ADICIONAL + DTO;
            NETO = TOTAL - RTFTE - RTIVA - RTICA;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
        FOR SELECT DEVT_ID, V.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, DEVT_DTOMONTO, DEVT_ADICIONAL, DEVT_IVAMONTO, DEVT_EXTRA, DEVT_TOTAL, DEVT_RTFTEMONTO, DEVT_RTIVAMONTO, DEVT_RTICAMONTO, T.TERC_NIT, TERC_NOM, ZONA_COD, TERC_TEL, TERC_CIU
            FROM DEVOLUCIONES_VENTAS V, PREFIJOS P, terceros T, CLIENTES C
            where C.TERC_NIT = T.TERC_NIT AND T.TERC_CLIE = 'S' AND T.TERC_NIT >= :NITINI AND T.TERC_NIT <= :NITFIN AND TERC_NOM >= :NOMINI AND TERC_NOM <= :NOMFIN
             AND V.TERC_NIT = T.terc_nit AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND DEVT_ANULADO = 'N'
             AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) AND ((DEVT_REMID = 0) or (DEVT_REMID IS NULL))
            ORDER BY DEVT_FECHA, DEVT_ID
            INTO :ID, :PREFIJO, :NUMERO, :FECDOC, :DTO, :ADICIONAL, :IVA, :EXTRA, :TOTAL, :RTFTE, :RTIVA, :RTICA, :nit, :nombre, :codzona, :telefono, :ciudad
            DO
            BEGIN
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :codzona INTO :NOMZONA;
            SUBTOTAL = TOTAL - EXTRA - IVA - ADICIONAL + DTO;
            NETO = TOTAL - RTFTE - RTIVA - RTICA;
            CANTIDAD = CANTIDAD * -1;
            SUBTOTAL = SUBTOTAL * -1;
            TOTAL = TOTAL * -1;
            IVA = IVA * -1;
            EXTRA = EXTRA * -1;
            DTO = DTO * -1;
            ADICIONAL = ADICIONAL * -1;
            RTFTE = RTFTE * -1;
            RTIVA = RTIVA * -1;
            RTICA = RTICA * -1;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
        FOR SELECT PEDI_ID, P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, PEDI_DTOMONTO, PEDI_ADICIONAL, PEDI_IVAMONTO, PEDI_EXTRA, PEDI_TOTAL, 0, 0, 0, T.TERC_NIT, TERC_NOM, ZONA_COD, TERC_TEL, TERC_CIU
            FROM PEDIDOS P, PREFIJOS PR, terceros T, CLIENTES C
            where C.TERC_NIT = T.TERC_NIT AND T.TERC_CLIE = 'S' AND T.TERC_NIT >= :NITINI AND T.TERC_NIT <= :NITFIN AND TERC_NOM >= :NOMINI AND TERC_NOM <= :NOMFIN
             AND P.TERC_NIT = T.terc_nit AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND PEDI_ANULADO = 'N'
             AND P.PREF_PRE = PR.PREF_PRE AND P.TIDO_COD = 34 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY PEDI_FECHA, PEDI_ID
            INTO :ID, :PREFIJO, :NUMERO, :FECDOC, :DTO, :ADICIONAL, :IVA, :EXTRA, :TOTAL, :RTFTE, :RTIVA, :RTICA, :nit, :nombre, :codzona, :telefono, :ciudad
            DO
            BEGIN
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :codzona INTO :NOMZONA;
            SUBTOTAL = TOTAL - EXTRA - IVA - ADICIONAL + DTO;
            NETO = TOTAL - RTFTE - RTIVA - RTICA;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
        FOR SELECT COTI_ID, CT.PREF_PRE, COTI_NUMERO, COTI_FECHA, COTI_DTOMONTO, COTI_ADICIONAL, COTI_IVAMONTO, COTI_EXTRA, COTI_TOTAL, 0, 0, 0, T.TERC_NIT, TERC_NOM, ZONA_COD, TERC_TEL, TERC_CIU
            FROM COTIZACIONES CT, PREFIJOS P, terceros T, CLIENTES C
            where C.TERC_NIT = T.TERC_NIT AND T.TERC_CLIE = 'S' AND T.TERC_NIT >= :NITINI AND T.TERC_NIT <= :NITFIN AND TERC_NOM >= :NOMINI AND TERC_NOM <= :NOMFIN
             AND CT.TERC_NIT = T.terc_nit AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND COTI_ANULADO = 'N'
             AND P.PREF_PRE = CT.PREF_PRE AND P.TIDO_COD = 35 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY COTI_FECHA, COTI_ID
            INTO :ID, :PREFIJO, :NUMERO, :FECDOC, :DTO, :ADICIONAL, :IVA, :EXTRA, :TOTAL, :RTFTE, :RTIVA, :RTICA, :nit, :nombre, :codzona, :telefono, :ciudad
            DO
            BEGIN
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :codzona INTO :NOMZONA;
            SUBTOTAL = TOTAL - EXTRA - IVA - ADICIONAL + DTO;
            NETO = TOTAL - RTFTE - RTIVA - RTICA;
            SUSPEND;
            END
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_VENTAS_VENDEDOR(
    TIPO INTEGER,
    DESDE VARCHAR(20),
    HASTA VARCHAR(20),
    FECINI DATE,
    FECFIN DATE,
    DETALLE CHAR(1),
    CEROS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    CODVEND INTEGER,
    NOMVEND VARCHAR(60),
    NOMTIPO VARCHAR(50),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    ID INTEGER,
    FECDOC DATE,
    CANTIDAD INTEGER,
    SUBTOTAL NUMERIC(18,2),
    DTO NUMERIC(18,2),
    ADICIONAL NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    IVA NUMERIC(18,2),
    EXTRA NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    RTFTE NUMERIC(18,2),
    RTIVA NUMERIC(18,2),
    RTICA NUMERIC(18,2),
    NETO NUMERIC(18,2))
AS
BEGIN
if (DETALLE = 'N') then
    BEGIN
    NIT = '';
    NOMBRE = '';
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
        FOR SELECT MAX(F.VEND_COD), MAX(VEND_NOMBRE), COUNT(*), SUM(FACT_DTOMONTO), SUM(FACT_ADICIONAL), SUM(FACT_IVAMONTO), SUM(FACT_EXTRA), SUM(FACT_RTFTEMONTO), SUM(FACT_RTIVAMONTO), SUM(FACT_RTICAMONTO), SUM(FACT_TOTAL)
            FROM FACTURAS F, PREFIJOS P, VENDEDORES V
            WHERE F.VEND_COD >= :DESDE AND F.VEND_COD <= :HASTA AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N'
             AND F.vend_cod = V.vend_cod AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY F.VEND_COD
            INTO :CODVEND, :NOMVEND, :CANTIDAD, :DTO, :ADICIONAL, :IVA, :EXTRA, :RTFTE, :RTIVA, :RTICA, :TOTAL
            DO
            BEGIN
            SELECT SUM(FADE_CONSUMO) FROM FACTURAS_DETALLE D, FACTURAS F WHERE F.FACT_ID = D.FACT_ID AND
                VEND_COD = :CODVEND AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N'
                INTO :CONSUMO;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (DTO IS NULL) then
                DTO = 0;
            if (ADICIONAL IS NULL) then
                ADICIONAL = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (EXTRA IS NULL) then
                EXTRA = 0;
            if (RTFTE IS NULL) then
                RTFTE = 0;
            if (RTIVA IS NULL) then
                RTIVA = 0;
            if (RTICA IS NULL) then
                RTICA = 0;
            SUBTOTAL = TOTAL - EXTRA - IVA - ADICIONAL + DTO - CONSUMO;
            NETO = TOTAL - RTFTE - RTIVA - RTICA;
            if (CEROS = 'S') then
              SUSPEND;
            ELSE
              if (CANTIDAD > 0) then
                SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
        FOR SELECT MAX(R.VEND_COD), MAX(VEND_NOMBRE), COUNT(*), 0, 0, SUM(REVT_IVAMONTO), 0, 0, 0, 0, SUM(REVT_TOTAL)
            FROM REMISIONES_VENTA R, PREFIJOS P, VENDEDORES V
            WHERE R.VEND_COD >= :DESDE AND R.VEND_COD <= :HASTA
             AND R.vend_cod = V.vend_cod AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND REVT_ANULADO = 'N'
             AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY R.VEND_COD
            INTO :CODVEND, :NOMVEND, :CANTIDAD, :DTO, :ADICIONAL, :IVA, :EXTRA, :RTFTE, :RTIVA, :RTICA, :TOTAL
            DO
            BEGIN
            SELECT SUM(RVDE_CONSUMO) FROM REMISIONES_VENTA R, REMISIONES_VENTA_DETALLE D WHERE R.REVT_ID = D.REVT_ID AND
                VEND_COD = :CODVEND AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND REVT_ANULADO = 'N'
                INTO :CONSUMO;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (DTO IS NULL) then
                DTO = 0;
            if (ADICIONAL IS NULL) then
                ADICIONAL = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (EXTRA IS NULL) then
                EXTRA = 0;
            if (RTFTE IS NULL) then
                RTFTE = 0;
            if (RTIVA IS NULL) then
                RTIVA = 0;
            if (RTICA IS NULL) then
                RTICA = 0;
            SUBTOTAL = TOTAL - EXTRA - IVA - ADICIONAL + DTO - CONSUMO;
            NETO = TOTAL - RTFTE - RTIVA - RTICA;
            if (CEROS = 'S') then
              SUSPEND;
            ELSE
              if (CANTIDAD > 0) then
                SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
        FOR SELECT MAX(D.VEND_COD), MAX(VEND_NOMBRE), COUNT(*), SUM(DEVT_DTOMONTO), SUM(DEVT_ADICIONAL), SUM(DEVT_IVAMONTO), SUM(DEVT_EXTRA), SUM(DEVT_RTFTEMONTO), SUM(DEVT_RTIVAMONTO), SUM(DEVT_RTICAMONTO), SUM(DEVT_TOTAL)
            FROM DEVOLUCIONES_VENTAS D, PREFIJOS P, VENDEDORES V
            WHERE D.VEND_COD >= :DESDE AND D.VEND_COD <= :HASTA
             AND D.vend_cod = V.vend_cod AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND DEVT_ANULADO = 'N'
             AND P.PREF_PRE = D.PREF_PRE AND P.TIDO_COD = 33 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) AND ((DEVT_REMID = 0) or (DEVT_REMID IS NULL))
            GROUP BY D.VEND_COD
            INTO :CODVEND, :NOMVEND, :CANTIDAD, :DTO, :ADICIONAL, :IVA, :EXTRA, :RTFTE, :RTIVA, :RTICA, :TOTAL
            DO
            BEGIN
            SELECT SUM(DVDE_CONSUMO) FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D WHERE V.DEVT_ID = D.DEVT_ID AND
                VEND_COD = :CODVEND AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND DEVT_ANULADO = 'N'
                INTO :CONSUMO;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (DTO IS NULL) then
                DTO = 0;
            if (ADICIONAL IS NULL) then
                ADICIONAL = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (EXTRA IS NULL) then
                EXTRA = 0;
            if (RTFTE IS NULL) then
                RTFTE = 0;
            if (RTIVA IS NULL) then
                RTIVA = 0;
            if (RTICA IS NULL) then
                RTICA = 0;
            SUBTOTAL = TOTAL - EXTRA - IVA - ADICIONAL + DTO - CONSUMO;
            NETO = TOTAL - RTFTE - RTIVA - RTICA;
            CANTIDAD = CANTIDAD * -1;
            SUBTOTAL = SUBTOTAL * -1;
            TOTAL = TOTAL * -1;
            IVA = IVA * -1;
            EXTRA = EXTRA * -1;
            DTO = DTO * -1;
            ADICIONAL = ADICIONAL * -1;
            RTFTE = RTFTE * -1;
            RTIVA = RTIVA * -1;
            RTICA = RTICA * -1;
            if (CEROS = 'S') then
              SUSPEND;
            ELSE
              if (CANTIDAD > 0) then
                SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
        FOR SELECT MAX(P.VEND_COD), MAX(VEND_NOMBRE), COUNT(*), SUM(PEDI_DTOMONTO), SUM(PEDI_ADICIONAL), SUM(PEDI_IVAMONTO), SUM(PEDI_EXTRA), 0, 0, 0, SUM(PEDI_TOTAL)
            FROM PEDIDOS P, PREFIJOS PR, VENDEDORES V
            WHERE V.VEND_COD >= :DESDE AND V.VEND_COD <= :HASTA
             AND P.vend_cod = V.vend_cod AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND PEDI_ANULADO = 'N'
             AND P.PREF_PRE = PR.PREF_PRE AND PR.TIDO_COD = 34 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY P.VEND_COD
            INTO :CODVEND, :NOMVEND, :CANTIDAD, :DTO, :ADICIONAL, :IVA, :EXTRA, :RTFTE, :RTIVA, :RTICA, :TOTAL
            DO
            BEGIN
            SELECT SUM(PEDE_CONSUMO) FROM PEDIDOS P, PEDIDOS_DETALLE D WHERE P.PEDI_ID = D.PEDI_ID AND
                VEND_COD = :CODVEND AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND PEDI_ANULADO = 'N'
                INTO :CONSUMO;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (DTO IS NULL) then
                DTO = 0;
            if (ADICIONAL IS NULL) then
                ADICIONAL = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (EXTRA IS NULL) then
                EXTRA = 0;
            if (RTFTE IS NULL) then
                RTFTE = 0;
            if (RTIVA IS NULL) then
                RTIVA = 0;
            if (RTICA IS NULL) then
                RTICA = 0;
            SUBTOTAL = TOTAL - EXTRA - IVA - ADICIONAL + DTO - CONSUMO;
            NETO = TOTAL - RTFTE - RTIVA - RTICA;
            if (CEROS = 'S') then
              SUSPEND;
            ELSE
              if (CANTIDAD > 0) then
                SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
        FOR SELECT MAX(C.VEND_COD), MAX(VEND_NOMBRE), COUNT(*), SUM(COTI_DTOMONTO), SUM(COTI_ADICIONAL), SUM(COTI_IVAMONTO), SUM(COTI_EXTRA), 0, 0, 0, SUM(COTI_TOTAL)
            FROM COTIZACIONES C, PREFIJOS P, VENDEDORES V
            WHERE V.VEND_COD >= :DESDE AND V.VEND_COD <= :HASTA
             AND C.vend_cod = V.vend_cod AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND COTI_ANULADO = 'N'
             AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY C.VEND_COD
            INTO :CODVEND, :NOMVEND, :CANTIDAD, :DTO, :ADICIONAL, :IVA, :EXTRA, :RTFTE, :RTIVA, :RTICA, :TOTAL
            DO
            BEGIN
            SELECT SUM(CTDE_CONSUMO) FROM COTIZACIONES C, COTIZACIONES_DETALLE D WHERE C.COTI_ID = D.COTI_ID AND
                VEND_COD = :CODVEND AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND COTI_ANULADO = 'N'
                INTO :CONSUMO;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (DTO IS NULL) then
                DTO = 0;
            if (ADICIONAL IS NULL) then
                ADICIONAL = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (EXTRA IS NULL) then
                EXTRA = 0;
            if (RTFTE IS NULL) then
                RTFTE = 0;
            if (RTIVA IS NULL) then
                RTIVA = 0;
            if (RTICA IS NULL) then
                RTICA = 0;
            SUBTOTAL = TOTAL - EXTRA - IVA - ADICIONAL + DTO - CONSUMO;
            NETO = TOTAL - RTFTE - RTIVA - RTICA;
            if (CEROS = 'S') then
              SUSPEND;
            ELSE
              if (CANTIDAD > 0) then
                SUSPEND;
            END
        END
    END
ELSE
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
        FOR SELECT F.VEND_COD, VEND_NOMBRE, F.FACT_ID, F.PREF_PRE, FACT_NUMERO, FACT_FECHA, FACT_DTOMONTO, FACT_ADICIONAL, FACT_IVAMONTO, FACT_EXTRA, FACT_TOTAL, FACT_RTFTEMONTO, FACT_RTIVAMONTO, FACT_RTICAMONTO, TERC_NIT, FACT_NOMCLIENTE
            FROM FACTURAS F, PREFIJOS P, VENDEDORES V WHERE F.vend_cod = V.vend_cod AND F.VEND_COD >= :DESDE AND F.VEND_COD <= :HASTA AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N'
             AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY FACT_FECHA, FACT_ID
            INTO :CODVEND, :NOMVEND, :ID, :PREFIJO, :NUMERO, :FECDOC, :DTO, :ADICIONAL, :IVA, :EXTRA, :TOTAL, :RTFTE, :RTIVA, :RTICA, :NIT, :NOMBRE
            DO
            BEGIN
            SELECT SUM(FADE_CONSUMO) FROM FACTURAS_DETALLE WHERE FACT_ID = :ID
                INTO :CONSUMO;
            SUBTOTAL = TOTAL - EXTRA - IVA - ADICIONAL + DTO - CONSUMO;
            NETO = TOTAL - RTFTE - RTIVA - RTICA;
            SUSPEND;
            END
         END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
        FOR SELECT R.VEND_COD, VEND_NOMBRE, REVT_ID, R.PREF_PRE, REVT_NUMERO, REVT_FECHA, 0, 0, REVT_IVAMONTO, 0, REVT_TOTAL, 0, 0, 0, TERC_NIT, REVT_NOMTERC
            FROM REMISIONES_VENTA R, PREFIJOS P, VENDEDORES V WHERE R.vend_cod = V.vend_cod AND R.VEND_COD >= :DESDE AND R.VEND_COD <= :HASTA AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND REVT_ANULADO = 'N'
             AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY REVT_FECHA, REVT_ID
            INTO :CODVEND, :NOMVEND, :ID, :PREFIJO, :NUMERO, :FECDOC, :DTO, :ADICIONAL, :IVA, :EXTRA, :TOTAL, :RTFTE, :RTIVA, :RTICA, :NIT, :NOMBRE
            DO
            BEGIN
            SELECT SUM(RVDE_CONSUMO) FROM REMISIONES_VENTA_DETALLE WHERE REVT_ID = :ID
                INTO :CONSUMO;
            SUBTOTAL = TOTAL - EXTRA - IVA - ADICIONAL + DTO - CONSUMO;
            NETO = TOTAL - RTFTE - RTIVA - RTICA;
            SUSPEND;
            END
         END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
        FOR SELECT V.VEND_COD, VEND_NOMBRE, DEVT_ID, D.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, DEVT_DTOMONTO, DEVT_ADICIONAL, DEVT_IVAMONTO, DEVT_EXTRA, DEVT_TOTAL, DEVT_RTFTEMONTO, DEVT_RTIVAMONTO, DEVT_RTICAMONTO, TERC_NIT, DEVT_NOMTERC
            FROM DEVOLUCIONES_VENTAS D, PREFIJOS P, VENDEDORES V WHERE D.vend_cod = V.vend_cod AND V.VEND_COD >= :DESDE AND V.VEND_COD <= :HASTA AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND DEVT_ANULADO = 'N'
             AND P.PREF_PRE = D.PREF_PRE AND P.TIDO_COD = 33 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) AND ((DEVT_REMID = 0) or (DEVT_REMID IS NULL))
            ORDER BY DEVT_FECHA, DEVT_ID
            INTO :CODVEND, :NOMVEND, :ID, :PREFIJO, :NUMERO, :FECDOC, :DTO, :ADICIONAL, :IVA, :EXTRA, :TOTAL, :RTFTE, :RTIVA, :RTICA, :NIT, :NOMBRE
            DO
            BEGIN
            SELECT SUM(DVDE_CONSUMO) FROM DEVOLUCIONES_VENTAS_DETALLE WHERE DEVT_ID = :ID
                INTO :CONSUMO;
            SUBTOTAL = TOTAL - EXTRA - IVA - ADICIONAL + DTO - CONSUMO;
            NETO = TOTAL - RTFTE - RTIVA - RTICA;
            TOTAL = TOTAL * -1;
            IVA = IVA * -1;
            EXTRA = EXTRA * -1;
            DTO = DTO * -1;
            ADICIONAL = ADICIONAL * -1;
            RTFTE = RTFTE * -1;
            RTIVA = RTIVA * -1;
            RTICA = RTICA * -1;
            SUSPEND;
            END
         END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
        FOR SELECT P.VEND_COD, VEND_NOMBRE, PEDI_ID, P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, PEDI_DTOMONTO, PEDI_ADICIONAL, PEDI_IVAMONTO, PEDI_EXTRA, PEDI_TOTAL, 0, 0, 0, TERC_NIT, PEDI_NOMTERC
            FROM PEDIDOS P, PREFIJOS PR, VENDEDORES V WHERE P.vend_cod = V.vend_cod AND P.VEND_COD >= :DESDE AND P.VEND_COD <= :HASTA AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND PEDI_ANULADO = 'N'
             AND P.PREF_PRE = PR.PREF_PRE AND PR.TIDO_COD = 34 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY PEDI_FECHA, PEDI_ID
            INTO :CODVEND, :NOMVEND, :ID, :PREFIJO, :NUMERO, :FECDOC, :DTO, :ADICIONAL, :IVA, :EXTRA, :TOTAL, :RTFTE, :RTIVA, :RTICA, :NIT, :NOMBRE
            DO
            BEGIN
            SELECT SUM(PEDE_CONSUMO) FROM PEDIDOS_DETALLE WHERE PEDI_ID = :ID
                INTO :CONSUMO;
            SUBTOTAL = TOTAL - EXTRA - IVA - ADICIONAL + DTO - CONSUMO;
            NETO = TOTAL - RTFTE - RTIVA - RTICA;
            SUSPEND;
            END
         END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
        FOR SELECT C.VEND_COD, VEND_NOMBRE, COTI_ID, C.PREF_PRE, COTI_NUMERO, COTI_FECHA, COTI_DTOMONTO, COTI_ADICIONAL, COTI_IVAMONTO, COTI_EXTRA, COTI_TOTAL, 0, 0, 0, TERC_NIT, COTI_NOMTERC
            FROM COTIZACIONES C, PREFIJOS P, VENDEDORES V WHERE C.vend_cod = V.vend_cod AND C.VEND_COD >= :DESDE AND C.VEND_COD <= :HASTA AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND COTI_ANULADO = 'N'
             AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY COTI_FECHA, COTI_ID
            INTO :CODVEND, :NOMVEND, :ID, :PREFIJO, :NUMERO, :FECDOC, :DTO, :ADICIONAL, :IVA, :EXTRA, :TOTAL, :RTFTE, :RTIVA, :RTICA, :NIT, :NOMBRE
            DO
            BEGIN
            SELECT SUM(CTDE_CONSUMO) FROM COTIZACIONES_DETALLE WHERE COTI_ID = :ID
                INTO :CONSUMO;
            SUBTOTAL = TOTAL - EXTRA - IVA - ADICIONAL + DTO - CONSUMO;
            NETO = TOTAL - RTFTE - RTIVA - RTICA;
            SUSPEND;
            END
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_UTILIDAD_CLIENTE(
    TIPO INTEGER,
    DETALLE CHAR(1),
    TERINI VARCHAR(20),
    TERFIN VARCHAR(20),
    FECINI DATE,
    FECFIN DATE,
    ARTINI VARCHAR(15),
    ARTFIN VARCHAR(15),
    ORDEN CHAR(1),
    CEROS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    TELEFONO VARCHAR(40),
    CIUDAD VARCHAR(40),
    CODZONA VARCHAR(2),
    NOMZONA VARCHAR(30),
    NOMTIPO VARCHAR(50),
    ARTICULO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    UNIDAD VARCHAR(8),
    CANTIDAD NUMERIC(18,4),
    BASE NUMERIC(18,2),
    IVA NUMERIC(18,2),
    COSTO NUMERIC(18,2),
    UTILIDAD NUMERIC(18,4),
    PORC NUMERIC(9,2),
    TOTAL NUMERIC(18,2),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    DTO NUMERIC(9,2))
AS
DECLARE VARIABLE COSTOUNIT NUMERIC(18,4);
DECLARE VARIABLE CODINI VARCHAR(15);
DECLARE VARIABLE CODFIN VARCHAR(15);
DECLARE VARIABLE DESINI VARCHAR(15);
DECLARE VARIABLE DESFIN VARCHAR(15);
declare variable UOM VARCHAR(20);
declare variable NUMROWS INTEGER;
BEGIN
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END
EXECUTE PROCEDURE lee_configuracion ('FACTURACION', 'ARTICULOS', 'SUGERIR PRECIOS CON PORCENTAJE DE MARGEN O UTILIDAD') returning_values (:UOM);
SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPO INTO :NOMTIPO;
if (DETALLE = 'N') then
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 3 AND REPA_USER = USER;

        FOR SELECT MAX(T.TERC_NIT), MAX(TERC_NOM), MAX(TERC_TEL), MAX(TERC_CIU), MAX(ZONA_COD), MAX(ARTI_COD), SUM(FADE_CANT * FADE_FACTOR), SUM(FACT_FACTOR*(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)),
            SUM(FACT_FACTOR*FADE_IVAMONTO), SUM(FACT_FACTOR*FADE_TOTAL)
            FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P, terceros T, CLIENTES C
            WHERE C.TERC_NIT = T.TERC_NIT AND TERC_CLIE = 'S' AND F.terc_nit = T.terc_nit AND T.TERC_NIT >= :TERINI AND T.TERC_NIT <= :TERFIN AND
            F.FACT_ID = D.FACT_ID AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N'
            AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY T.TERC_NIT, ARTI_COD
            INTO :NIT, :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL
            DO
            BEGIN
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :CODZONA INTO :NOMZONA;
            SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            COSTO = CANTIDAD * COSTOUNIT;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
            else
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (3, USER, :ARTICULO);
            SUSPEND;
            END /* FOR */
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 3 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 3 AND REPA_USER = USER;

        FOR SELECT MAX(T.TERC_NIT), MAX(TERC_NOM), MAX(TERC_TEL), MAX(TERC_CIU), MAX(ZONA_COD), MAX(ARTI_COD), SUM(RVDE_CANT * RVDE_FACTOR), SUM(RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO), SUM(RVDE_IVAMONTO), SUM(RVDE_TOTAL)
            FROM REMISIONES_VENTA_DETALLE D, REMISIONES_VENTA R, PREFIJOS P, terceros T, CLIENTES C
            WHERE C.TERC_NIT = T.TERC_NIT AND TERC_CLIE = 'S' AND R.terc_nit = T.terc_nit AND T.TERC_NIT >= :TERINI AND T.TERC_NIT <= :TERFIN AND
            R.REVT_ID = D.REVT_ID AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND REVT_ANULADO = 'N'
            AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY T.TERC_NIT, ARTI_COD
            INTO :NIT, :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL
            DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
                if (CANTIDAD IS NULL) then
                    CANTIDAD = 0;
                if (BASE IS NULL) then
                    BASE = 0;
                if (IVA IS NULL) then
                    IVA = 0;
                COSTO = CANTIDAD * COSTOUNIT;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (3, USER, :ARTICULO);
            SUSPEND;
            END /* FOR */
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 3 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 3 AND REPA_USER = USER;

        FOR SELECT MAX(T.TERC_NIT), MAX(TERC_NOM), MAX(TERC_TEL), MAX(TERC_CIU), MAX(ZONA_COD), MAX(ARTI_COD), SUM(DVDE_CANT * DVDE_FACTOR), SUM(DEVT_FACTOR*(DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)),
            SUM(DEVT_FACTOR*DVDE_IVAMONTO), SUM(DEVT_FACTOR*DVDE_TOTAL)
            FROM devoluciones_ventas_detalle D, DEVOLUCIONES_VENTAS V, PREFIJOS P, terceros T, CLIENTES C
            WHERE C.TERC_NIT = T.TERC_NIT AND TERC_CLIE = 'S' AND V.terc_nit = T.terc_nit AND T.TERC_NIT >= :TERINI AND T.TERC_NIT <= :TERFIN AND
            V.DEVT_ID = D.DEVT_ID AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND DEVT_ANULADO = 'N'
            AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY T.TERC_NIT, ARTI_COD
            INTO :NIT, :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL
            DO
            BEGIN
            SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            COSTO = CANTIDAD * COSTOUNIT;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
            else
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
            TOTAL = TOTAL * -1;
            IVA = IVA * -1;
            BASE = BASE * -1;
            CANTIDAD = CANTIDAD * -1;
            COSTO = COSTO * -1;
            UTILIDAD = UTILIDAD * -1;
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (3, USER, :ARTICULO);
            SUSPEND;
            END /* FOR */
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 3 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 3 AND REPA_USER = USER;

        FOR SELECT MAX(T.TERC_NIT), MAX(TERC_NOM), MAX(TERC_TEL), MAX(TERC_CIU), MAX(ZONA_COD), MAX(ARTI_COD), SUM(PEDE_CANT * PEDE_FACTOR), SUM(PEDI_FACTOR*(PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)),
            SUM(PEDI_FACTOR*PEDE_IVAMONTO), SUM(PEDI_FACTOR*PEDE_TOTAL)
            FROM PEDIDOS_DETALLE D, PEDIDOS P, PREFIJOS PR, terceros T, CLIENTES C
            WHERE C.TERC_NIT = T.TERC_NIT AND TERC_CLIE = 'S' AND P.terc_nit = T.terc_nit AND T.TERC_NIT >= :TERINI AND T.TERC_NIT <= :TERFIN AND
            P.PEDI_ID = D.PEDI_ID AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND PEDI_ANULADO = 'N'
            AND PR.PREF_PRE = P.PREF_PRE AND P.TIDO_COD = 34 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY T.TERC_NIT, ARTI_COD
            INTO :NIT, :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL
            DO
            BEGIN
            SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            COSTO = CANTIDAD * COSTOUNIT;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
            else
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (3, USER, :ARTICULO);
            SUSPEND;
            END /* FOR */
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 3 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 3 AND REPA_USER = USER;

        FOR SELECT MAX(T.TERC_NIT), MAX(TERC_NOM), MAX(TERC_TEL), MAX(TERC_CIU), MAX(ZONA_COD), MAX(ARTI_COD), SUM(CTDE_CANT * CTDE_FACTOR), SUM(COTI_FACTOR*(CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)),
            SUM(COTI_FACTOR*CTDE_IVAMONTO), SUM(COTI_FACTOR*CTDE_TOTAL)
            FROM COTIZACIONES_DETALLE D, COTIZACIONES CT, PREFIJOS P, terceros T, CLIENTES C
            WHERE C.TERC_NIT = T.TERC_NIT AND TERC_CLIE = 'S' AND C.terc_nit = T.terc_nit AND T.TERC_NIT >= :TERINI AND T.TERC_NIT <= :TERFIN AND
            CT.COTI_ID = D.COTI_ID AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND COTI_ANULADO = 'N'
            AND P.PREF_PRE = CT.PREF_PRE AND P.TIDO_COD = 35 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY T.TERC_NIT, ARTI_COD
            INTO :NIT, :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL
            DO
            BEGIN
            SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            COSTO = CANTIDAD * COSTOUNIT;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
            else
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (3, USER, :ARTICULO);
            SUSPEND;
            END /* FOR */
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 3 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    END
ELSE
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
            FOR SELECT F.PREF_PRE, FACT_NUMERO, FACT_FECHA, ARTI_COD, FADE_CANT * FADE_FACTOR, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR,
                FADE_IVAMONTO*FACT_FACTOR, FADE_DTOPORC, FADE_TOTAL*FACT_FACTOR, F.terc_nit, F.fact_nomcliente
                FROM FACTURAS F, FACTURAS_DETALLE D, PREFIJOS P
                WHERE F.FACT_ID = D.FACT_ID AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND F.TERC_NIT >= :TERINI AND F.TERC_NIT <= :TERFIN AND FACT_ANULADO = 'N'
                 AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY f.terc_nit, ARTI_COD, FACT_FECHA, F.FACT_ID, FADE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :NIT, :nombre
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                SUSPEND;
                END
            END
    if (BIN_AND(TIPO, 2) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
            FOR SELECT R.PREF_PRE, REVT_NUMERO, REVT_FECHA, ARTI_COD, RVDE_CANT * RVDE_FACTOR,
                (RVDE_TOTAL - RVDE_IVAMONTO), RVDE_IVAMONTO, RVDE_DTOPORC, RVDE_TOTAL, R.terc_nit, R.revt_nomterc
                FROM REMISIONES_VENTA R, REMISIONES_VENTA_DETALLE D, PREFIJOS P
                WHERE R.REVT_ID = D.REVT_ID AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND R.TERC_NIT >= :TERINI AND R.TERC_NIT <= :TERFIN AND REVT_ANULADO = 'N'
                 AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY r.terc_nit, ARTI_COD, REVT_FECHA, R.REVT_ID, RVDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :NIT, :nombre
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                SUSPEND;
                END
            END
    if (BIN_AND(TIPO, 4) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
            FOR SELECT V.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, ARTI_COD, DVDE_CANT * DVDE_FACTOR, (DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR,
                DVDE_IVAMONTO*DEVT_FACTOR, DVDE_DTOPORC, DVDE_TOTAL*DEVT_FACTOR, V.terc_nit, V.devt_nomterc
                FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D, PREFIJOS P
                WHERE V.DEVT_ID = D.DEVT_ID AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND V.TERC_NIT >= :TERINI AND V.TERC_NIT <= :TERFIN AND DEVT_ANULADO = 'N'
                 AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY v.terc_nit, ARTI_COD, DEVT_FECHA, D.DEVT_ID, DVDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :NIT, :nombre
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                TOTAL = TOTAL * -1;
                IVA = IVA * -1;
                BASE = BASE * -1;
                CANTIDAD = CANTIDAD * -1;
                COSTO = COSTO * -1;
                UTILIDAD = UTILIDAD * -1;
                SUSPEND;
                END
            END
    if (BIN_AND(TIPO, 8) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
            FOR SELECT P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, ARTI_COD, PEDE_CANT * PEDE_FACTOR, (PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR,
                PEDE_IVAMONTO*PEDI_FACTOR, PEDE_DTOPORC, PEDE_TOTAL*PEDI_FACTOR, P.terc_nit, P.pedi_nomterc
                FROM PEDIDOS P, PEDIDOS_DETALLE D, PREFIJOS PR
                WHERE P.PEDI_ID = D.PEDI_ID AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND P.TERC_NIT >= :TERINI AND P.TERC_NIT <= :TERFIN AND PEDI_ANULADO = 'N'
                 AND P.PREF_PRE = PR.PREF_PRE AND P.TIDO_COD = 34 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY p.terc_nit, ARTI_COD, PEDI_FECHA, P.PEDI_ID, PEDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :NIT, :nombre
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                SUSPEND;
                END
            END
    if (BIN_AND(TIPO, 16) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
            FOR SELECT C.PREF_PRE, COTI_NUMERO, COTI_FECHA, ARTI_COD, CTDE_CANT * CTDE_FACTOR, (CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR,
                CTDE_IVAMONTO*COTI_FACTOR, CTDE_DTOPORC, CTDE_TOTAL*COTI_FACTOR, C.terc_nit, C.coti_nomterc
                FROM COTIZACIONES C, COTIZACIONES_DETALLE D, PREFIJOS P
                WHERE C.COTI_ID = D.COTI_ID AND ARTI_COD = :ARTICULO AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND C.TERC_NIT >= :TERINI AND C.TERC_NIT <= :TERFIN AND COTI_ANULADO = 'N'
                 AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY c.terc_nit, COTI_FECHA, C.COTI_ID, CTDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :NIT, :nombre
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                SUSPEND;
                END
            END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_UTILIDAD_VENDEDOR(
    TIPO INTEGER,
    DETALLE CHAR(1),
    VENINI VARCHAR(20),
    VENFIN VARCHAR(20),
    FECINI DATE,
    FECFIN DATE,
    ARTINI VARCHAR(15),
    ARTFIN VARCHAR(15),
    ORDEN CHAR(1),
    CEROS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    CODVEND VARCHAR(20),
    NOMVEND VARCHAR(60),
    NOMTIPO VARCHAR(50),
    ARTICULO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    UNIDAD VARCHAR(8),
    CANTIDAD NUMERIC(18,4),
    BASE NUMERIC(18,2),
    IVA NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    COSTO NUMERIC(18,2),
    UTILIDAD NUMERIC(18,4),
    PORC NUMERIC(9,2),
    TOTAL NUMERIC(18,2),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    DTO NUMERIC(9,2))
AS
DECLARE VARIABLE COSTOUNIT NUMERIC(18,4);
DECLARE VARIABLE CODINI VARCHAR(15);
DECLARE VARIABLE CODFIN VARCHAR(15);
DECLARE VARIABLE DESINI VARCHAR(15);
DECLARE VARIABLE DESFIN VARCHAR(15);
declare variable UOM VARCHAR(20);
BEGIN
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION', 'ARTICULOS', 'SUGERIR PRECIOS CON PORCENTAJE DE MARGEN O UTILIDAD') returning_values (:UOM);
  SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPO INTO :NOMTIPO;
  FOR select VEND_COD, VEND_NOMBRE
    from VENDEDORES
    where VEND_COD >= :VENINI AND VEND_COD <= :VENFIN
    INTO :CODVEND, :NOMVEND
    DO  
    BEGIN
    if (DETALLE = 'N') then
        BEGIN
        if (BIN_AND(TIPO, 1) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
            /* BORRA LA TABLA AUXILIAR */
            DELETE FROM reportes_aux WHERE REPA_ID = 4 AND REPA_USER = USER;
            FOR SELECT MAX(ARTI_COD), SUM(FADE_CANT * FADE_FACTOR), SUM(FACT_FACTOR*(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)),
                SUM(FACT_FACTOR*FADE_IVAMONTO), SUM(FACT_FACTOR*FADE_TOTAL), SUM(FADE_CONSUMO)
                FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P
                WHERE F.FACT_ID = D.FACT_ID AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND FACT_ANULADO = 'N'
                 AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                GROUP BY ARTI_COD
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
                if (CANTIDAD IS NULL) then
                    CANTIDAD = 0;
                if (BASE IS NULL) then
                    BASE = 0;
                if (IVA IS NULL) then
                    IVA = 0;
                COSTO = CANTIDAD * COSTOUNIT;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    begin
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                    SUSPEND;
                    end
                ELSE
                    if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                        SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                /* agregue los articulos sin factura */
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 2) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
            FOR SELECT MAX(ARTI_COD), SUM(RVDE_CANT * RVDE_FACTOR), SUM(RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO), SUM(RVDE_IVAMONTO), SUM(RVDE_TOTAL), SUM(RVDE_CONSUMO)
                FROM REMISIONES_VENTA_DETALLE D, REMISIONES_VENTA R, PREFIJOS P
                WHERE R.REVT_ID = D.REVT_ID AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND REVT_ANULADO = 'N'
                 AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                GROUP BY ARTI_COD
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
                if (CANTIDAD IS NULL) then
                    CANTIDAD = 0;
                if (BASE IS NULL) then
                    BASE = 0;
                if (IVA IS NULL) then
                    IVA = 0;
                COSTO = CANTIDAD * COSTOUNIT;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    begin
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                    SUSPEND;
                    end
                ELSE
                    if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                        SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                /* agregue los articulos sin factura */
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 4) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
            FOR SELECT MAX(ARTI_COD), SUM(DVDE_CANT * DVDE_FACTOR), SUM(DEVT_FACTOR*(DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)),
                SUM(DEVT_FACTOR*DVDE_IVAMONTO), SUM(DEVT_FACTOR*DVDE_TOTAL), SUM(DVDE_CONSUMO)
                FROM devoluciones_ventas_detalle D, DEVOLUCIONES_VENTAS V, PREFIJOS P
                WHERE V.DEVT_ID = D.DEVT_ID AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND DEVT_ANULADO = 'N'
                 AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                GROUP BY ARTI_COD
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
                if (CANTIDAD IS NULL) then
                    CANTIDAD = 0;
                if (BASE IS NULL) then
                    BASE = 0;
                if (IVA IS NULL) then
                    IVA = 0;
                COSTO = CANTIDAD * COSTOUNIT;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                TOTAL = TOTAL * -1;
                IVA = IVA * -1;
                BASE = BASE * -1;
                CANTIDAD = CANTIDAD * -1;
                COSTO = COSTO * -1;
                UTILIDAD = UTILIDAD * -1;
                if (CEROS = 'S') then
                    begin
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                    SUSPEND;
                    end
                ELSE
                    if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                        SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                /* agregue los articulos sin factura */
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 8) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
            FOR SELECT MAX(ARTI_COD), SUM(PEDE_CANT * PEDE_FACTOR), SUM(PEDI_FACTOR*(PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)),
                SUM(PEDI_FACTOR*PEDE_IVAMONTO), SUM(PEDI_FACTOR*PEDE_TOTAL), SUM(PEDE_CONSUMO)
                FROM PEDIDOS_DETALLE D, PEDIDOS P, PREFIJOS PR
                WHERE P.PEDI_ID = D.PEDI_ID AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND PEDI_ANULADO = 'N'
                 AND PR.PREF_PRE = P.PREF_PRE AND P.TIDO_COD = 34 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                GROUP BY ARTI_COD
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
                if (CANTIDAD IS NULL) then
                    CANTIDAD = 0;
                if (BASE IS NULL) then
                    BASE = 0;
                if (IVA IS NULL) then
                    IVA = 0;
                COSTO = CANTIDAD * COSTOUNIT;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    begin
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                    SUSPEND;
                    end
                ELSE
                    if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                        SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                /* agregue los articulos sin factura */
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 16) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
            FOR SELECT MAX(ARTI_COD), SUM(CTDE_CANT * CTDE_FACTOR), SUM(COTI_FACTOR*(CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)),
                SUM(COTI_FACTOR*CTDE_IVAMONTO), SUM(COTI_FACTOR*CTDE_TOTAL), SUM(CTDE_CONSUMO)
                FROM COTIZACIONES_DETALLE D, COTIZACIONES C, PREFIJOS P
                WHERE C.COTI_ID = D.COTI_ID AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND COTI_ANULADO = 'N'
                 AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                GROUP BY ARTI_COD
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
                if (CANTIDAD IS NULL) then
                    CANTIDAD = 0;
                if (BASE IS NULL) then
                    BASE = 0;
                if (IVA IS NULL) then
                    IVA = 0;
                COSTO = CANTIDAD * COSTOUNIT;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    begin
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                    SUSPEND;
                    end
                ELSE
                    if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                        SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                /* agregue los articulos sin factura */
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    ELSE
        BEGIN
        if (BIN_AND(TIPO, 1) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
            FOR SELECT F.PREF_PRE, FACT_NUMERO, FACT_FECHA, ARTI_COD, FADE_CANT * FADE_FACTOR, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR,
                FADE_IVAMONTO*FACT_FACTOR, FADE_DTOPORC, FADE_TOTAL*FACT_FACTOR, FADE_CONSUMO
                FROM FACTURAS F, FACTURAS_DETALLE D, PREFIJOS P
                WHERE F.FACT_ID = D.FACT_ID AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND FACT_ANULADO = 'N'
                 AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY ARTI_COD, FACT_FECHA, F.FACT_ID, FADE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                /* agregue los articulos sin factura */
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 2) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
            FOR SELECT R.PREF_PRE, REVT_NUMERO, REVT_FECHA, ARTI_COD, RVDE_CANT * RVDE_FACTOR, (RVDE_TOTAL - RVDE_IVAMONTO), RVDE_IVAMONTO, RVDE_DTOPORC, RVDE_TOTAL, RVDE_CONSUMO
                FROM REMISIONES_VENTA R, REMISIONES_VENTA_DETALLE D, PREFIJOS P
                WHERE R.REVT_ID = D.REVT_ID AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND REVT_ANULADO = 'N'
                 AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY ARTI_COD, REVT_FECHA, R.REVT_ID, RVDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                /* agregue los articulos sin factura */
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 4) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
            FOR SELECT V.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, ARTI_COD, DVDE_CANT * DVDE_FACTOR, (DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR,
                DVDE_IVAMONTO*DEVT_FACTOR, DVDE_DTOPORC, DVDE_TOTAL*DEVT_FACTOR, DVDE_CONSUMO
                FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D, PREFIJOS P
                WHERE V.DEVT_ID = D.DEVT_ID AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND DEVT_ANULADO = 'N'
                 AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY ARTI_COD, DEVT_FECHA, D.DEVT_ID, DVDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                TOTAL = TOTAL * -1;
                IVA = IVA * -1;
                BASE = BASE * -1;
                CANTIDAD = CANTIDAD * -1;
                COSTO = COSTO * -1;
                UTILIDAD = UTILIDAD * -1;
                if (CEROS = 'S') then
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                /* agregue los articulos sin factura */
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 8) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
            FOR SELECT P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, ARTI_COD, PEDE_CANT * PEDE_FACTOR, (PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR,
                PEDE_IVAMONTO*PEDI_FACTOR, PEDE_DTOPORC, PEDE_TOTAL*PEDI_FACTOR, PEDE_CONSUMO
                FROM PEDIDOS P, PEDIDOS_DETALLE D, PREFIJOS PR
                WHERE P.PEDI_ID = D.PEDI_ID AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND PEDI_ANULADO = 'N'
                 AND P.PREF_PRE = PR.PREF_PRE AND P.TIDO_COD = 34 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY ARTI_COD, PEDI_FECHA, P.PEDI_ID, PEDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                /* agregue los articulos sin factura */
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 16) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
            FOR SELECT C.PREF_PRE, COTI_NUMERO, COTI_FECHA, ARTI_COD, CTDE_CANT * CTDE_FACTOR, (CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR,
                CTDE_IVAMONTO*COTI_FACTOR, CTDE_DTOPORC, CTDE_TOTAL*COTI_FACTOR, CTDE_CONSUMO
                FROM COTIZACIONES C, COTIZACIONES_DETALLE D, PREFIJOS P
                WHERE C.COTI_ID = D.COTI_ID AND ARTI_COD = :ARTICULO AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND COTI_ANULADO = 'N'
                 AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY COTI_FECHA, C.COTI_ID, CTDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                /* agregue los articulos sin factura */
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE IMPUESTOS_VENTAS(
    FECINI DATE,
    FECFIN DATE,
    PREFIJO VARCHAR(4),
    PTOINI INTEGER,
    PTOFIN INTEGER,
    ANULADOS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    TIPO INTEGER,
    NOMTIPO VARCHAR(30),
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    SUBTOTAL NUMERIC(18,2),
    DTOMONTO NUMERIC(18,2),
    ADICIONAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    EXENTOS NUMERIC(18,2),
    GRAVADOS1 NUMERIC(18,2),
    GRAVADOS2 NUMERIC(18,2),
    GRAVADOS3 NUMERIC(18,2),
    IVA1 NUMERIC(18,2),
    IVA2 NUMERIC(18,2),
    IVA3 NUMERIC(18,2),
    EXTRA NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    RTFTEMONTO NUMERIC(18,2),
    RTIVAMONTO NUMERIC(18,2),
    RTICAMONTO NUMERIC(18,2),
    NETO NUMERIC(18,2),
    ANULADO CHAR(1))
AS
declare variable ID INTEGER;
declare variable TER_exento CHAR(1);
declare variable NOTAS CHAR(2);
BEGIN
/* FACTURA */
TIPO = 31;
SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;

FOR SELECT FACT_ID, F.PREF_PRE, FACT_NUMERO, FACT_FECHA, TERC_NIT, FACT_NOMCLIENTE, FACT_ADICIONAL-FACT_DTOMONTO, FACT_IVAMONTO, FACT_RTFTEMONTO, FACT_RTIVAMONTO, FACT_RTICAMONTO, FACT_EXTRA, FACT_TOTAL, FACT_ANULADO
    FROM FACTURAS F, PREFIJOS PR WHERE PTVT_ID >= :PTOINI AND PTVT_ID <= :PTOFIN AND
    FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND ((:PREFIJO = '') or (:PREFIJO IS NULL) or (F.PREF_PRE = :PREFIJO))
    AND PR.PREF_PRE = F.PREF_PRE AND PR.TIDO_COD = 31 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY FACT_FECHA, F.PREF_PRE, FACT_NUMERO
    INTO :ID, :PREF, :NUMERO, :FECHA, :NIT, :NOMTERCERO, :DTOMONTO, :IVAMONTO, :RTFTEMONTO, :RTIVAMONTO, :RTICAMONTO, :EXTRA, :TOTAL, :ANULADO
    DO
    BEGIN
    SELECT TERC_EXENTO FROM TERCEROS WHERE TERC_NIT = :NIT INTO :TER_EXENTO;
    if ((ANULADOS = 'S') or (ANULADO = 'N')) then
        BEGIN
        if (ANULADO = 'S') then
            BEGIN
            EXENTOS = 0;
            GRAVADOS1 = 0;
            GRAVADOS2 = 0;
            GRAVADOS3 = 0;
            CONSUMO = 0;
            SUBTOTAL = 0;
            TOTAL = 0;
            EXTRA = 0;
            IVAMONTO = 0;
            DTOMONTO = 0;
            NETO = 0;
            RTFTEMONTO = 0;
            RTIVAMONTO = 0;
            RTICAMONTO = 0;
            END
        else
            BEGIN
            /* CALCULE LAS DIFERENTES TARIFAS */
            if (TER_EXENTO = 'S') then
                BEGIN
                SELECT SUM(FADE_TOTAL - FADE_IVAMONTO - FADE_CONSUMO) FROM FACTURAS_DETALLE D WHERE FACT_ID = :ID INTO :EXENTOS;
                GRAVADOS1 = 0;
                GRAVADOS2 = 0;
                GRAVADOS3 = 0;
                end
            else
                begin
                SELECT SUM(FADE_TOTAL - FADE_IVAMONTO - FADE_CONSUMO) FROM FACTURAS_DETALLE D WHERE FACT_ID = :ID AND FADE_IVAPORC = 0 INTO :EXENTOS;
                SELECT SUM(FADE_TOTAL - FADE_IVAMONTO - FADE_CONSUMO), SUM(FADE_IVAMONTO) FROM FACTURAS_DETALLE D, TARIFA_IVA T WHERE FACT_ID = :ID AND FADE_IVAPORC = TAIV_PORC AND TAIV_COD = 1 INTO :GRAVADOS1, :IVA1;
                SELECT SUM(FADE_TOTAL - FADE_IVAMONTO - FADE_CONSUMO), SUM(FADE_IVAMONTO) FROM FACTURAS_DETALLE D, TARIFA_IVA T WHERE FACT_ID = :ID AND FADE_IVAPORC = TAIV_PORC AND TAIV_COD = 2 INTO :GRAVADOS2, :IVA2;
                SELECT SUM(FADE_TOTAL - FADE_IVAMONTO - FADE_CONSUMO), SUM(FADE_IVAMONTO) FROM FACTURAS_DETALLE D, TARIFA_IVA T WHERE FACT_ID = :ID AND FADE_IVAPORC = TAIV_PORC AND TAIV_COD = 3 INTO :GRAVADOS3, :IVA3;
                end
            SELECT SUM(FADE_CONSUMO) FROM FACTURAS_DETALLE WHERE FACT_ID = :ID INTO :CONSUMO;
            SUBTOTAL = TOTAL - EXTRA - IVAMONTO - DTOMONTO;
            NETO = TOTAL - RTFTEMONTO - RTIVAMONTO - RTICAMONTO;
            END
        SUSPEND;
        END
    END
    
TIPO = 33;
SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
/* DEVOLUCIONES */
FOR SELECT DEVT_ID, D.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, TERC_NIT, DEVT_NOMTERC, DEVT_ADICIONAL-DEVT_DTOMONTO, DEVT_IVAMONTO, DEVT_RTFTEMONTO, DEVT_RTIVAMONTO, DEVT_RTICAMONTO, DEVT_EXTRA, DEVT_TOTAL, DEVT_ANULADO
    FROM DEVOLUCIONES_VENTAS D, PREFIJOS PR WHERE PTVT_ID >= :PTOINI AND PTVT_ID <= :PTOFIN AND
    DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND ((:PREFIJO = '') or (:PREFIJO IS NULL) or (D.PREF_PRE = :PREFIJO))
    AND PR.PREF_PRE = D.PREF_PRE AND PR.TIDO_COD = 33 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) AND ((DEVT_REMID = 0) or (DEVT_REMID IS NULL))
    ORDER BY DEVT_FECHA, D.PREF_PRE, DEVT_NUMERO
    INTO :ID, :PREF, :NUMERO, :FECHA, :NIT, :NOMTERCERO, :DTOMONTO, :IVAMONTO, :RTFTEMONTO, :RTIVAMONTO, :RTICAMONTO, :EXTRA, :TOTAL, :ANULADO
    DO
    BEGIN
    SELECT TERC_EXENTO FROM TERCEROS WHERE TERC_NIT = :NIT INTO :TER_EXENTO;
    if ((ANULADOS = 'S') or (ANULADO = 'N')) then
        BEGIN
        if (ANULADO = 'S') then
            BEGIN
            EXENTOS = 0;
            GRAVADOS1 = 0;
            GRAVADOS2 = 0;
            GRAVADOS3 = 0;
            CONSUMO = 0;
            SUBTOTAL = 0;
            TOTAL = 0;
            EXTRA = 0;
            IVAMONTO = 0;
            DTOMONTO = 0;
            NETO = 0;
            RTFTEMONTO = 0;
            RTIVAMONTO = 0;
            RTICAMONTO = 0;
            END
        else
            BEGIN
            DTOMONTO = DTOMONTO * -1;
            ADICIONAL = ADICIONAL * -1;
            IVAMONTO = IVAMONTO * -1;
            EXTRA = EXTRA * -1;
            TOTAL = TOTAL * -1;
            RTFTEMONTO = RTFTEMONTO * -1;
            RTIVAMONTO = RTIVAMONTO * -1;
            RTICAMONTO = RTICAMONTO * -1;
            /* CALCULE LAS DIFERENTES TARIFAS */
            if (TER_EXENTO = 'S') then
             BEGIN
              SELECT SUM(DVDE_TOTAL - DVDE_IVAMONTO - DVDE_CONSUMO) FROM DEVOLUCIONES_VENTAS_DETALLE D WHERE DEVT_ID = :ID INTO :EXENTOS;
              GRAVADOS1 = 0;
              GRAVADOS2 = 0;
              GRAVADOS3 = 0;
             end
            else
             begin
              SELECT SUM(DVDE_TOTAL - DVDE_IVAMONTO - DVDE_CONSUMO) FROM DEVOLUCIONES_VENTAS_DETALLE D WHERE DEVT_ID = :ID AND DVDE_IVAPORC = 0 INTO :EXENTOS;
              SELECT SUM(DVDE_TOTAL - DVDE_IVAMONTO - DVDE_CONSUMO), SUM(DVDE_IVAMONTO) FROM DEVOLUCIONES_VENTAS_DETALLE D, TARIFA_IVA T WHERE DEVT_ID = :ID AND DVDE_IVAPORC = TAIV_PORC AND TAIV_COD = 1 INTO :GRAVADOS1, :IVA1;
              SELECT SUM(DVDE_TOTAL - DVDE_IVAMONTO - DVDE_CONSUMO), SUM(DVDE_IVAMONTO) FROM DEVOLUCIONES_VENTAS_DETALLE D, TARIFA_IVA T WHERE DEVT_ID = :ID AND DVDE_IVAPORC = TAIV_PORC AND TAIV_COD = 2 INTO :GRAVADOS2, :IVA2;
              SELECT SUM(DVDE_TOTAL - DVDE_IVAMONTO - DVDE_CONSUMO), SUM(DVDE_IVAMONTO) FROM DEVOLUCIONES_VENTAS_DETALLE D, TARIFA_IVA T WHERE DEVT_ID = :ID AND DVDE_IVAPORC = TAIV_PORC AND TAIV_COD = 3 INTO :GRAVADOS3, :IVA3;
             end
            SELECT SUM(DVDE_CONSUMO) FROM DEVOLUCIONES_VENTAS_DETALLE WHERE DEVT_ID = :ID INTO :CONSUMO;
            SUBTOTAL = TOTAL - EXTRA - IVAMONTO - DTOMONTO;
            NETO = TOTAL - RTFTEMONTO - RTIVAMONTO - RTICAMONTO;
            EXENTOS = EXENTOS * -1;
            GRAVADOS1 = GRAVADOS1 * -1;
            GRAVADOS2 = GRAVADOS2 * -1;
            GRAVADOS3 = GRAVADOS3 * -1;
            CONSUMO = CONSUMO * -1;
            END
        SUSPEND;
        END
    END
execute procedure lee_configuracion ('FACTURACION', 'DOCUMENTOS', 'INCLUIR NOTAS DE CARTERA EN REPORTE DE IMPUESTOS EN VENTAS') returning_values (:NOTAS);
if (NOTAS = 'SI') then
    BEGIN
    TIPO = 41;
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 41 INTO :NOMTIPO;
    FOR SELECT NDCL_ID, N.PREF_PRE, NDCL_NUMERO, NDCL_FECHA, N.TERC_NIT, TERC_NOM, 0, NDCL_IVAMONTO, NDCL_RTFTEMONTO, NDCL_RTIVAMONTO, NDCL_RTICAMONTO, 0, NDCL_MONTO+NDCL_IVAMONTO, NDCL_ANULADO
        FROM NOTAS_DEBITO_CLIENTES N, TERCEROS T, PREFIJOS PR WHERE N.TERC_NIT = T.TERC_NIT AND
        NDCL_FECHA >= :FECINI AND NDCL_FECHA <= :FECFIN AND ((:PREFIJO = '') or (:PREFIJO IS NULL) or (N.PREF_PRE = :PREFIJO))
        AND PR.PREF_PRE = N.PREF_PRE AND PR.TIDO_COD = 41 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY NDCL_FECHA, N.PREF_PRE, NDCL_NUMERO
        INTO :ID, :PREF, :NUMERO, :FECHA, :NIT, :NOMTERCERO, :DTOMONTO, :IVAMONTO, :RTFTEMONTO, :RTIVAMONTO, :RTICAMONTO, :EXTRA, :TOTAL, :ANULADO
        DO
        BEGIN
        GRAVADOS2 = 0;
        GRAVADOS3 = 0;
        IVA2 = 0;
        IVA3 = 0;
        CONSUMO = 0;
        if (ANULADO = 'S') then
            BEGIN
            EXENTOS = 0;
            GRAVADOS1 = 0;
            SUBTOTAL = 0;
            TOTAL = 0;
            EXTRA = 0;
            IVAMONTO = 0;
            DTOMONTO = 0;
            NETO = 0;
            RTFTEMONTO = 0;
            RTIVAMONTO = 0;
            RTICAMONTO = 0;
            END
        ELSE
            BEGIN
            if (IVAMONTO <> 0) then
                BEGIN
                GRAVADOS1 = TOTAL-IVAMONTO;
                IVA1 = IVAMONTO;
                exentos = 0;
                END
            ELSE
                BEGIN
                GRAVADOS1 = 0;
                IVA1 = 0;
                exentos = TOTAL;
                END
            SUBTOTAL = TOTAL - EXTRA - IVAMONTO - DTOMONTO;
            NETO = TOTAL - RTFTEMONTO - RTIVAMONTO - RTICAMONTO;
            END
        SUSPEND;
        END

    TIPO = 42;
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 42 INTO :NOMTIPO;
    FOR SELECT NCCL_ID, N.PREF_PRE, NCCL_NUMERO, NCCL_FECHA, N.TERC_NIT, TERC_NOM, 0, NCCL_IVAMONTO, NCCL_RTFTEMONTO, NCCL_RTIVAMONTO, NCCL_RTICAMONTO, 0, NCCL_MONTO+NCCL_IVAMONTO, NCCL_ANULADO
        FROM NOTAS_CREDITO_CLIENTES N, TERCEROS T, PREFIJOS PR WHERE N.TERC_NIT = T.TERC_NIT AND
        NCCL_FECHA >= :FECINI AND NCCL_FECHA <= :FECFIN AND ((:PREFIJO = '') or (:PREFIJO IS NULL) or (N.PREF_PRE = :PREFIJO))
        AND PR.PREF_PRE = N.PREF_PRE AND PR.TIDO_COD = 42 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY NCCL_FECHA, N.PREF_PRE, NCCL_NUMERO
        INTO :ID, :PREF, :NUMERO, :FECHA, :NIT, :NOMTERCERO, :DTOMONTO, :IVAMONTO, :RTFTEMONTO, :RTIVAMONTO, :RTICAMONTO, :EXTRA, :TOTAL, :ANULADO
        DO
        BEGIN
        GRAVADOS2 = 0;
        GRAVADOS3 = 0;
        CONSUMO = 0;
        if (ANULADO = 'S') then
            BEGIN
            EXENTOS = 0;
            GRAVADOS1 = 0;
            SUBTOTAL = 0;
            TOTAL = 0;
            EXTRA = 0;
            IVAMONTO = 0;
            DTOMONTO = 0;
            NETO = 0;
            RTFTEMONTO = 0;
            RTIVAMONTO = 0;
            RTICAMONTO = 0;
            END
        ELSE
            BEGIN
            DTOMONTO = DTOMONTO * -1;
            ADICIONAL = ADICIONAL * -1;
            IVAMONTO = IVAMONTO * -1;
            EXTRA = EXTRA * -1;
            TOTAL = TOTAL * -1;
            RTFTEMONTO = RTFTEMONTO * -1;
            RTIVAMONTO = RTIVAMONTO * -1;
            RTICAMONTO = RTICAMONTO * -1;
            if (IVAMONTO <> 0) then
                BEGIN
                GRAVADOS1 = TOTAL-IVAMONTO;
                IVA1 = IVAMONTO;
                exentos = 0;
                END
            ELSE
                BEGIN
                GRAVADOS1 = 0;
                IVA1 = 0;
                exentos = TOTAL;
                END
            SUBTOTAL = TOTAL - EXTRA - IVAMONTO - DTOMONTO;
            NETO = TOTAL - RTFTEMONTO - RTIVAMONTO - RTICAMONTO;
            END
        SUSPEND;
        END
    END
END
^

SET TERM ; ^



/* 06-11 cruces cartera vs cxpagar */

CREATE TABLE EGRESOS_CRUCEC (
    EGRE_ID        T_ID NOT NULL,
    EGCC_ITEM      T_ID NOT NULL,
    EGCC_TIPODOC   T_ID,
    EGCC_PREFIJO   T_PROYECTO,
    EGCC_NUMERO    T_NUMDOC,
    EGCC_ABONO     T_MONTO,
    EGCC_RTFTE     T_MONTO,
    EGCC_RTIVA     T_MONTO,
    EGCC_RTICA     T_MONTO,
    EGCC_DTOF      T_MONTO,
    EGCC_SUCURSAL  VARCHAR(10),
    EGCC_ANULADO   T_BOOLEANO,
    EGCC_TRANSMIT  T_BOOLEANO,
    EGCC_IDDOC     T_ID
);

ALTER TABLE EGRESOS_CRUCEC ADD CONSTRAINT PK_EGRESOS_CRUCEC PRIMARY KEY (EGRE_ID, EGCC_ITEM);

SET TERM ^ ;

CREATE OR ALTER TRIGGER EGRESOS_CRUCEC_AI FOR EGRESOS_CRUCEC
ACTIVE AFTER INSERT POSITION 0
AS
declare variable EXISTE CHAR(1);
declare variable FEC DATE;
declare variable NIT VARCHAR(20);
declare variable CONCEPTO VARCHAR(60);
declare variable PREFIJO VARCHAR(4);
declare variable NUMERO VARCHAR(6);
declare variable SALDO NUMERIC(18,2);
declare variable RETES CHAR(2);
declare variable COBR INTEGER;
BEGIN
if ((NEW.egre_id <> 0) and (new.egcc_anulado = 'N')) then
    BEGIN
    /* Abone el documento referenciado */
    select PREF_PRE, EGRE_NUMERO, EGRE_fecha, EGRE_CONC, TERC_NIT from EGRESOS
        where EGRE_id = new.egre_id into :PREFIJO, :NUMERO, :FEC, :CONCEPTO, :NIT;
    SELECT COBR_COD FROM cliente_sucursales WHERE TERC_NIT = :NIT AND CLCU_COD = NEW.egcc_sucursal INTO :COBR;
    /* valide que no se pase del saldo */
    execute procedure saldo_doc_cartera(new.egcc_tipodoc, new.egcc_iddoc, '9999/12/31') returning_values(saldo);
    execute procedure lee_configuracion('CARTERA', 'SALDOS', 'DESCONTAR RETENCIONES POR CAUSACION') returning_values (RETES);
    if (SALDO < 0) then
        BEGIN
        if (RETES = 'SI') then
            begin
            if (saldo > (NEW.egcc_abono + NEW.egcc_dtof)) then
                EXCEPTION DOCUMENTO_ABONO_MAYOR;
            end
        ELSE
            begin
            if (saldo > (NEW.egcc_abono + NEW.egcc_rtfte + NEW.egcc_rtiva + NEW.egcc_rtica + NEW.egcc_dtof)) then
                EXCEPTION DOCUMENTO_ABONO_MAYOR;
            end
        END
    else
        BEGIN
        if (RETES = 'SI') then
            begin
            if (saldo < (NEW.egcc_abono + NEW.egcc_dtof)) then
                EXCEPTION DOCUMENTO_ABONO_MAYOR;
            end
        ELSE
            begin
            if (saldo < (NEW.egcc_abono + NEW.egcc_rtfte + NEW.egcc_rtiva + NEW.egcc_rtica + NEW.egcc_dtof)) then
                EXCEPTION DOCUMENTO_ABONO_MAYOR;
            end
        END
    EXISTE = 'N';
    select 'S' from saldos_doc_cartera where sdca_tiporef = new.egcc_tipodoc and sdca_idref = new.egcc_iddoc and sdca_fecha = :FEC into :EXISTE;
    if (Existe = 'S') then
        begin
        /* actualice el saldo del dia */
        UPDATE saldos_doc_cartera
            SET SDCA_ABONO = SDCA_ABONO + NEW.egcc_abono + new.egcc_dtof,
                SDCA_ABRTFTE = SDCA_ABRTFTE + NEW.egcc_rtfte,
                SDCA_ABRTIVA = SDCA_ABRTIVA + NEW.egcc_rtiva,
                SDCA_ABRTICA = SDCA_ABRTICA + NEW.egcc_rtica
                WHERE SDCA_TIPOREF = NEW.egcc_tipodoc AND SDCA_IDREF = NEW.egcc_iddoc AND SDCA_FECHA = :FEC;
        END
    ELSE
        BEGIN
        /* Inserte un nuevo saldo diario */
        INSERT INTO SALDOS_DOC_CARTERA (SDCA_TIPOREF, SDCA_IDREF, SDCA_FECHA, TERC_NIT, SDCA_RTFTE, SDCA_RTIVA, SDCA_RTICA, SDCA_ABONO, SDCA_ABRTFTE, SDCA_ABRTIVA, SDCA_ABRTICA, SDCA_DEBITO, SDCA_MONTO)
            VALUES (NEW.egcc_tipodoc, NEW.egcc_iddoc, :FEC, :NIT, 0, 0, 0, (NEW.egcc_abono+NEW.egcc_dtof), NEW.egcc_rtfte, NEW.egcc_rtiva, NEW.egcc_rtica, 'N', 0);
        END
    /* actualice el registro en mov_cliente (por si son varios items) */
    EXISTE = 'N';
    SELECT 'S' FROM MOVIMIENTO_CLIENTES WHERE MVCL_TIPOREF = 62 AND MVCL_IDREF = NEW.egre_id AND MVCL_SUCURSAL = NEW.egcc_sucursal INTO :EXISTE;
    if (EXISTE = 'S') then
        begin
        UPDATE movimiento_clientes
            SET MVCL_MONTO = MVCL_MONTO + NEW.egcc_abono + NEW.egcc_dtof,
                MVCL_RTEFTE = MVCL_RTEFTE + NEW.egcc_rtfte,
                MVCL_RTEIVA = MVCL_RTEIVA + NEW.egcc_rtiva,
                MVCL_RTEICA = MVCL_RTEICA + NEW.egcc_rtica
            WHERE MVCL_TIPOREF = 62 AND MVCL_IDREF = NEW.egre_id;
        end
    ELSE
        INSERT INTO MOVIMIENTO_CLIENTES (MVCL_ID, TERC_NIT, MVCL_TIPOREF, MVCL_IDREF, MVCL_FECHA, MVCL_VENCE, MVCL_CONC, MVCL_MONTO, MVCL_RTEFTE, MVCL_RTEIVA, MVCL_RTEICA, MVCL_DEBITO, MVCL_ABONO, MVCL_PREFREF, MVCL_NUMREF, MVCL_SUCURSAL, COBR_COD)
            VALUES (GEN_ID(ID_MOVCLI, 1), :NIT, 62, NEW.egre_id, :FEC, :FEC, :CONCEPTO, (NEW.egcc_abono+NEW.egcc_dtof), NEW.egcc_rtfte, NEW.egcc_rtiva, NEW.egcc_rtica, 'N', 'S', :PREFIJO, :NUMERO, NEW.egcc_sucursal, :COBR);
    end
END
^

SET TERM ; ^

SET TERM ^ ;

create trigger EGRESOS_CRUCEC_AU for EGRESOS_CRUCEC
active AFTER UPDATE position 0
AS
declare variable EXISTE CHAR(1);
declare variable FEC DATE;
declare variable NIT VARCHAR(20);
declare variable CONCEPTO VARCHAR(60);
declare variable PREFIJO VARCHAR(4);
declare variable NUMERO VARCHAR(6);
declare variable SALDO NUMERIC(18,2);
declare variable RETES char(2);
declare variable COBR INTEGER;
BEGIN
select PREF_PRE, EGRE_NUMERO, EGRE_fecha, EGRE_CONC, TERC_NIT
    from egresos where egre_id = new.egre_id
    into :PREFIJO, :NUMERO, :FEC, :CONCEPTO, :NIT;
/* Borre el viejo */
if ((old.egre_id <> 0) AND (OLD.egcc_anulado = 'N')) then
    BEGIN
    UPDATE saldos_doc_cartera
        SET SDCA_ABONO = SDCA_ABONO - old.egcc_abono - OLD.egcc_dtof,
        SDCA_ABRTFTE = SDCA_ABRTFTE - old.egcc_rtfte,
        SDCA_ABRTIVA = SDCA_ABRTIVA - old.egcc_rtiva,
        SDCA_ABRTICA = SDCA_ABRTICA - old.egcc_rtica
        WHERE SDCA_TIPOREF = old.egcc_tipodoc AND SDCA_IDREF = old.egcc_iddoc AND SDCA_FECHA = :FEC;
    UPDATE movimiento_clientes
        SET MVCL_MONTO = MVCL_MONTO - OLD.egcc_abono - OLD.egcc_dtof,
        MVCL_RTEFTE = MVCL_RTEFTE - OLD.egcc_rtfte,
        MVCL_RTEIVA = MVCL_RTEIVA - OLD.egcc_rtiva,
        MVCL_RTEICA = MVCL_RTEICA - OLD.egcc_rtica
        WHERE MVCL_TIPOREF = 62 AND MVCL_IDREF = OLD.egre_id AND MVCL_SUCURSAL = old.egcc_sucursal;
    END
if ((NEW.egre_id <> 0) and (NEW.egcc_anulado = 'N')) then
    BEGIN
    SELECT COBR_COD FROM cliente_sucursales WHERE TERC_NIT = :NIT AND CLCU_COD = NEW.egcc_sucursal INTO :COBR;
    /* valide que no se pase del saldo */
    execute procedure saldo_doc_cartera(new.egcc_tipodoc, new.egcc_iddoc, '9999/12/31') returning_values(saldo);
    execute procedure lee_configuracion('CARTERA', 'SALDOS', 'DESCONTAR RETENCIONES POR CAUSACION') returning_values (RETES);
    if (SALDO < 0) then
        BEGIN
        if (RETES = 'SI') then
            begin
            if (saldo > (NEW.egcc_abono + NEW.egcc_dtof)) then
                EXCEPTION DOCUMENTO_ABONO_MAYOR;
            end
        ELSE
            begin
            if (saldo > (NEW.egcc_abono + NEW.egcc_rtfte + NEW.egcc_rtiva + NEW.egcc_rtica + NEW.egcc_dtof)) then
                EXCEPTION DOCUMENTO_ABONO_MAYOR;
            end
        END
    else
        BEGIN
        if (RETES = 'SI') then
            begin
            if (saldo < (NEW.egcc_abono + NEW.egcc_dtof)) then
                EXCEPTION DOCUMENTO_ABONO_MAYOR;
            end
        ELSE
            begin
            if (saldo < (NEW.egcc_abono + NEW.egcc_rtfte + NEW.egcc_rtiva + NEW.egcc_rtica + NEW.egcc_dtof)) then
                EXCEPTION DOCUMENTO_ABONO_MAYOR;
            end
        END
    select 'S' from saldos_doc_cartera where sdca_tiporef = new.egcc_tipodoc and sdca_idref = new.egcc_iddoc and sdca_fecha = :FEC into :EXISTE;
    if (Existe = 'S') then
        /* actualice el saldo del dia */
        UPDATE saldos_doc_cartera
            SET SDCA_ABONO = SDCA_ABONO + NEW.egcc_abono + NEW.egcc_dtof,
            SDCA_ABRTFTE = SDCA_ABRTFTE + NEW.egcc_rtfte,
            SDCA_ABRTIVA = SDCA_ABRTIVA + NEW.egcc_rtiva,
            SDCA_ABRTICA = SDCA_ABRTICA + NEW.egcc_rtica
            WHERE SDCA_TIPOREF = NEW.egcc_tipodoc AND SDCA_IDREF = NEW.egcc_iddoc AND SDCA_FECHA = :FEC;
    ELSE
        /* Inserte un nuevo saldo diario */
        INSERT INTO SALDOS_DOC_CARTERA (SDCA_TIPOREF, SDCA_IDREF, SDCA_FECHA, TERC_NIT, SDCA_RTFTE, SDCA_RTIVA, SDCA_RTICA, SDCA_ABONO, SDCA_ABRTFTE, SDCA_ABRTIVA, SDCA_ABRTICA, SDCA_DEBITO, SDCA_MONTO)
            VALUES (NEW.egcc_tipodoc, NEW.egcc_iddoc, :FEC, :NIT, 0, 0, 0, (NEW.egcc_abono+NEW.egcc_dtof), NEW.egcc_rtfte, NEW.egcc_rtiva, NEW.egcc_rtica, 'N', 0);
    /* Registre o actualice el registro en movimiento_cliente */
    EXISTE = 'N';
    SELECT 'S' FROM MOVIMIENTO_CLIENTES WHERE MVCL_TIPOREF = 62 AND MVCL_IDREF = NEW.egre_id and mvcl_sucursal = new.egcc_sucursal INTO :EXISTE;
    if (EXISTE = 'S') then
        begin
        /* Deshaga el viejo */
        if (old.egre_id <> 0) then
            UPDATE movimiento_clientes
                SET MVCL_MONTO = MVCL_MONTO - OLD.egcc_abono - OLD.egcc_dtof,
                    MVCL_RTEFTE = MVCL_RTEFTE - OLD.egcc_rtfte,
                    MVCL_RTEIVA = MVCL_RTEIVA - OLD.egcc_rtiva,
                    MVCL_RTEICA = MVCL_RTEICA - OLD.egcc_rtica
                WHERE MVCL_TIPOREF = 62 AND MVCL_IDREF = NEW.egre_id AND MVCL_SUCURSAL = NEW.egcc_sucursal;
        /* Actualice el nuevo */
        UPDATE movimiento_clientes
            SET MVCL_MONTO = MVCL_MONTO + NEW.egcc_abono + NEW.egcc_dtof,
                MVCL_RTEFTE = MVCL_RTEFTE + NEW.egcc_rtfte,
                MVCL_RTEIVA = MVCL_RTEIVA + NEW.egcc_rtiva,
                MVCL_RTEICA = MVCL_RTEICA + NEW.egcc_rtica
            WHERE MVCL_TIPOREF = 62 AND MVCL_IDREF = NEW.egre_id AND MVCL_SUCURSAL = NEW.egcc_sucursal;
        end
    ELSE
        INSERT INTO MOVIMIENTO_CLIENTES (MVCL_ID, TERC_NIT, MVCL_TIPOREF, MVCL_IDREF, MVCL_FECHA, MVCL_VENCE, MVCL_CONC, MVCL_MONTO, MVCL_RTEFTE, MVCL_RTEIVA, MVCL_RTEICA, MVCL_DEBITO, MVCL_ABONO, MVCL_PREFREF, MVCL_NUMREF, MVCL_SUCURSAL, COBR_COD)
            VALUES (GEN_ID(ID_MOVCLI, 1), :NIT, 62, NEW.egre_id, :FEC, :FEC, :CONCEPTO, (NEW.egcc_abono+NEW.egcc_dtof), NEW.egcc_rtfte, NEW.egcc_rtiva, NEW.egcc_rtica, 'N', 'S', :PREFIJO, :NUMERO, NEW.egcc_sucursal, :COBR);
    END
END
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON EGRESOS_CRUCEC TO TRIGGER EGRESOS_CRUCEC_AU;
GRANT SELECT ON EGRESOS TO TRIGGER EGRESOS_CRUCEC_AU;
GRANT SELECT,INSERT,UPDATE ON SALDOS_DOC_CARTERA TO TRIGGER EGRESOS_CRUCEC_AU;
GRANT SELECT,INSERT,UPDATE ON MOVIMIENTO_CLIENTES TO TRIGGER EGRESOS_CRUCEC_AU;
GRANT SELECT ON CLIENTE_SUCURSALES TO TRIGGER EGRESOS_CRUCEC_AU;
GRANT EXECUTE ON PROCEDURE SALDO_DOC_CARTERA TO TRIGGER EGRESOS_CRUCEC_AU;
GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO TRIGGER EGRESOS_CRUCEC_AU;

SET TERM ^ ;

create trigger EGRESOS_CRUCEC_AD for EGRESOS_CRUCEC
active AFTER DELETE position 0
as
declare variable FEC DATE;
BEGIN
if (old.egre_id <> 0) then
    BEGIN
    select egre_fecha from egresos where egre_id = OLD.egre_id into :FEC;
    if (OLD.egcc_anulado = 'N') then
        begin
        UPDATE saldos_doc_cartera
            SET SDCA_ABONO = SDCA_ABONO - old.egcc_abono - OLD.egcc_dtof,
            SDCA_ABRTFTE = SDCA_ABRTFTE - old.egcc_rtfte,
            SDCA_ABRTIVA = SDCA_ABRTIVA - old.egcc_rtiva,
            SDCA_ABRTICA = SDCA_ABRTICA - old.egcc_rtica
            WHERE SDCA_TIPOREF = old.egcc_tipodoc AND SDCA_IDREF = old.egcc_iddoc AND SDCA_FECHA = :FEC;
        UPDATE movimiento_clientes
            SET MVCL_MONTO = MVCL_MONTO - OLD.egcc_abono - OLD.egcc_dtof,
            MVCL_RTEFTE = MVCL_RTEFTE - OLD.egcc_rtfte,
            MVCL_RTEIVA = MVCL_RTEIVA - OLD.egcc_rtiva,
            MVCL_RTEICA = MVCL_RTEICA - OLD.egcc_rtica
            WHERE MVCL_TIPOREF = 62 AND MVCL_IDREF = OLD.egre_id and MVCL_SUCURSAL = OLD.egcc_sucursal;
        end
    END
END
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON EGRESOS_CRUCEC TO TRIGGER EGRESOS_CRUCEC_AD;
GRANT SELECT ON EGRESOS TO TRIGGER EGRESOS_CRUCEC_AD;
GRANT SELECT,UPDATE ON SALDOS_DOC_CARTERA TO TRIGGER EGRESOS_CRUCEC_AD;
GRANT SELECT,UPDATE ON MOVIMIENTO_CLIENTES TO TRIGGER EGRESOS_CRUCEC_AD;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE CHEQUEO_SALDOS_DOC_CARTERA(
    CLIINI VARCHAR(20),
    CLIFIN VARCHAR(20))
RETURNS (
    ERROR VARCHAR(60),
    TIPO INTEGER,
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6))
AS
declare variable FECHA DATE;
declare variable NIT VARCHAR(20);
declare variable RTFTE NUMERIC(18, 2);
declare variable RTIVA NUMERIC(18, 2);
declare variable RTICA NUMERIC(18, 2);
declare variable MONTO NUMERIC(18, 2);
declare variable EXISTE CHAR(1);
declare variable IDR INTEGER;
declare variable RECAID INTEGER;
BEGIN
DELETE FROM SALDOS_DOC_CARTERA WHERE TERC_NIT >= :CLIINI AND TERC_NIT <= :CLIFIN;
DELETE FROM ANTICIPOS_CLIENTE WHERE RECA_ID = 0;

FOR SELECT FACT_ID, FACT_FECHA, TERC_NIT, FACT_RTFTEMONTO, FACT_rtivamonto, FACT_rticamonto, FACT_TOTAL
    FROM FACTURAS WHERE FACT_ID <> 0 and fact_anulado = 'N' AND TERC_NIT >= :CLIINI AND TERC_NIT <= :CLIFIN
    ORDER BY FACT_FECHA
    INTO :ID, :FECHA, :nit,  :RTFTE, :RTIVA, :RTICA, :MONTO
    DO
    INSERT INTO SALDOS_DOC_CARTERA (SDCA_TIPOREF, SDCA_IDREF, SDCA_FECHA, TERC_NIT, SDCA_RTFTE, SDCA_RTIVA, SDCA_RTICA, SDCA_ABONO, SDCA_ABRTFTE, SDCA_ABRTIVA, SDCA_ABRTICA, SDCA_DEBITO, SDCA_MONTO)
        VALUES (31, :ID, :fecha, :nit, :rtfte, :rtiva, :rtica, 0, 0, 0, 0, 'S', :MONTO);

FOR SELECT NDCL_ID, NDCL_FECHA, TERC_NIT, NDCL_RTFTEMONTO, NDCL_rtivamonto, NDCL_rticamonto, ndcl_monto+ndcl_ivamonto
    FROM NOTAS_DEBITO_CLIENTES WHERE NDCL_ID <> 0 and NDCL_anulado = 'N'  AND TERC_NIT >= :CLIINI AND TERC_NIT <= :CLIFIN
    ORDER BY NDCL_FECHA
    INTO :ID, :FECHA, :nit,  :RTFTE, :RTIVA, :RTICA, :MONTO
    DO
    INSERT INTO SALDOS_DOC_CARTERA (SDCA_TIPOREF, SDCA_IDREF, SDCA_FECHA, TERC_NIT, SDCA_RTFTE, SDCA_RTIVA, SDCA_RTICA, SDCA_ABONO, SDCA_ABRTFTE, SDCA_ABRTIVA, SDCA_ABRTICA, SDCA_DEBITO, SDCA_MONTO)
        VALUES (41, :ID, :fecha, :nit, :rtfte, :rtiva, :rtica, 0, 0, 0, 0, 'S', :MONTO);

FOR SELECT DVCH_ID, DVCH_FECHA, TERC_NIT, 0, 0, 0, DVCH_MONTO
    FROM devolucion_cheques WHERE DVCH_ID <> 0 and DVCH_anulado = 'N' AND DVCH_CARTERA = 'S'  AND TERC_NIT >= :CLIINI AND TERC_NIT <= :CLIFIN
    ORDER BY DVCH_FECHA
    INTO :ID, :FECHA, :nit,  :RTFTE, :RTIVA, :RTICA, :MONTO
    DO
    INSERT INTO SALDOS_DOC_CARTERA (SDCA_TIPOREF, SDCA_IDREF, SDCA_FECHA, TERC_NIT, SDCA_RTFTE, SDCA_RTIVA, SDCA_RTICA, SDCA_ABONO, SDCA_ABRTFTE, SDCA_ABRTIVA, SDCA_ABRTICA, SDCA_DEBITO, SDCA_MONTO)
        VALUES (77, :ID, :fecha, :nit, :rtfte, :rtiva, :rtica, 0, 0, 0, 0, 'S', :MONTO);

FOR SELECT DEVT_ID, DEVT_FECHA, TERC_NIT, DEVT_RTFTEMONTO, DEVT_rtivamonto, DEVT_rticamonto, devt_total
    FROM DEVOLUCIONES_VENTAS WHERE DEVT_ID <> 0 and DEVT_anulado = 'N' AND TERC_NIT >= :CLIINI AND TERC_NIT <= :CLIFIN
    ORDER BY DEVT_FECHA
    INTO :ID, :FECHA, :nit,  :RTFTE, :RTIVA, :RTICA, :MONTO
    DO
    INSERT INTO SALDOS_DOC_CARTERA (SDCA_TIPOREF, SDCA_IDREF, SDCA_FECHA, TERC_NIT, SDCA_RTFTE, SDCA_RTIVA, SDCA_RTICA, SDCA_ABONO, SDCA_ABRTFTE, SDCA_ABRTIVA, SDCA_ABRTICA, SDCA_DEBITO, SDCA_MONTO)
        VALUES (33, :ID, :fecha, :nit, :rtfte*-1, :rtiva*-1, :rtica*-1, 0, 0, 0, 0, 'N', :MONTO * -1);

FOR SELECT NCCL_ID, NCCL_FECHA, TERC_NIT, NCCL_RTFTEMONTO, NCCL_rtivamonto, NCCL_rticamonto, nccl_monto+nccl_ivamonto
    FROM NOTAS_CREDITO_CLIENTES WHERE NCCL_ID <> 0 and NCCL_anulado = 'N' AND TERC_NIT >= :CLIINI AND TERC_NIT <= :CLIFIN
    ORDER BY NCCL_FECHA
    INTO :ID, :FECHA, :nit,  :RTFTE, :RTIVA, :RTICA, :MONTO
    DO
    INSERT INTO SALDOS_DOC_CARTERA (SDCA_TIPOREF, SDCA_IDREF, SDCA_FECHA, TERC_NIT, SDCA_RTFTE, SDCA_RTIVA, SDCA_RTICA, SDCA_ABONO, SDCA_ABRTFTE, SDCA_ABRTIVA, SDCA_ABRTICA, SDCA_DEBITO, SDCA_MONTO)
        VALUES (42, :ID, :fecha, :nit, :rtfte*-1, :rtiva*-1, :rtica*-1, 0, 0, 0, 0, 'N', :MONTO * -1);

FOR SELECT ANCL_ID, ANCL_FECHA, TERC_NIT, ANCL_RTFTEMONTO, ANCL_rtivamonto, ANCL_rticamonto, ancl_base+ancl_ivamonto
    FROM ANTICIPOS_CLIENTE WHERE ANCL_ID <> 0 and ANCL_anulado = 'N' AND TERC_NIT >= :CLIINI AND TERC_NIT <= :CLIFIN
    ORDER BY ANCL_FECHA
    INTO :ID, :FECHA, :nit,  :RTFTE, :RTIVA, :RTICA, :MONTO
    DO
    INSERT INTO SALDOS_DOC_CARTERA (SDCA_TIPOREF, SDCA_IDREF, SDCA_FECHA, TERC_NIT, SDCA_RTFTE, SDCA_RTIVA, SDCA_RTICA, SDCA_ABONO, SDCA_ABRTFTE, SDCA_ABRTIVA, SDCA_ABRTICA, SDCA_DEBITO, SDCA_MONTO)
        VALUES (45, :ID, :fecha, :nit, :rtfte*-1, :rtiva*-1, :rtica*-1, 0, 0, 0, 0, 'N', :MONTO * -1);

FOR SELECT ACDE_TIPODOC, ACDE_IDDOC, APCL_FECHA, TERC_NIT, ACDE_APLICADO, ACDE_RTFTE, ACDE_RTIVA, ACDE_RTICA
    FROM APLICACION_CLIENTE_DETALLE D, APLICACION_CLIENTE A
    WHERE A.APCL_ID = D.apcl_id AND A.APCL_ID <> 0 AND APCL_ANULADO = 'N' AND TERC_NIT >= :CLIINI AND TERC_NIT <= :CLIFIN
    ORDER BY APCL_FECHA
    INTO :TIPO, :ID, :FECHA, :NIT, :MONTO, :RTFTE, :RTIVA, :RTICA
    DO
    BEGIN
    EXISTE = 'N';
    select 'S' from saldos_doc_cartera where sdca_tiporef = :TIPO and sdca_idref = :ID and sdca_fecha = :fecha into :EXISTE;
    if (Existe = 'S') then
        begin
        /* actualice el saldo del dia */
        UPDATE saldos_doc_cartera
            SET SDCA_ABONO = SDCA_ABONO + :MONTO,
                SDCA_ABRTFTE = SDCA_ABRTFTE + :RTFTE,
                SDCA_ABRTIVA = SDCA_ABRTIVA + :RTIVA,
                SDCA_ABRTICA = SDCA_ABRTICA + :RTICA
            WHERE SDCA_TIPOREF = :TIPO AND SDCA_IDREF = :ID AND SDCA_FECHA = :fecha;
        END
    ELSE
        BEGIN
        /* Inserte un nuevo saldo diario */
        INSERT INTO SALDOS_DOC_CARTERA (SDCA_TIPOREF, SDCA_IDREF, SDCA_FECHA, TERC_NIT, SDCA_RTFTE, SDCA_RTIVA, SDCA_RTICA, SDCA_ABONO, SDCA_ABRTFTE, SDCA_ABRTIVA, SDCA_ABRTICA, SDCA_DEBITO, SDCA_MONTO)
            VALUES (:TIPO, :ID, :fecha, :NIT, 0, 0, 0, :MONTO, :rtfte, :rtiva, :rtica, 'N', 0);
        END
    END

FOR SELECT R.RECA_ID, RCDE_TIPODOC, RCDE_IDDOC, RECA_FECHA, TERC_NIT, RCDE_ABONO+RCDE_DTOF, RCDE_RTFTE, RCDE_RTIVA, RCDE_RTICA
    FROM RECIBOS_CAJA_DETALLE D, RECIBOS_CAJA R
    WHERE R.RECA_ID = D.RECA_id AND R.RECA_ID <> 0 AND RECA_ANULADO = 'N' AND TERC_NIT >= :CLIINI AND TERC_NIT <= :CLIFIN
    ORDER BY RECA_FECHA
    INTO :IDR, :TIPO, :ID, :FECHA, :NIT, :MONTO, :RTFTE, :RTIVA, :RTICA
    DO
    BEGIN
    EXISTE = 'N';
    if (TIPO = 45) then
        BEGIN
        SELECT RECA_ID FROM ANTICIPOS_CLIENTE WHERE ANCL_ID = :ID INTO :RECAID;
        if (RECAID = IDR) then
            EXISTE = 'S';
        END
    if (EXISTE = 'N') then
        BEGIN
        select 'S' from saldos_doc_cartera where sdca_tiporef = :TIPO and sdca_idref = :ID and sdca_fecha = :fecha into :EXISTE;
        if (Existe = 'S') then
            begin
            /* actualice el saldo del dia */
            UPDATE saldos_doc_cartera
                SET SDCA_ABONO = SDCA_ABONO + :MONTO,
                    SDCA_ABRTFTE = SDCA_ABRTFTE + :RTFTE,
                    SDCA_ABRTIVA = SDCA_ABRTIVA + :RTIVA,
                    SDCA_ABRTICA = SDCA_ABRTICA + :RTICA
                WHERE SDCA_TIPOREF = :TIPO AND SDCA_IDREF = :ID AND SDCA_FECHA = :fecha;
            END
        ELSE
            BEGIN
            /* Inserte un nuevo saldo diario */
            INSERT INTO SALDOS_DOC_CARTERA (SDCA_TIPOREF, SDCA_IDREF, SDCA_FECHA, TERC_NIT, SDCA_RTFTE, SDCA_RTIVA, SDCA_RTICA, SDCA_ABONO, SDCA_ABRTFTE, SDCA_ABRTIVA, SDCA_ABRTICA, SDCA_DEBITO, SDCA_MONTO)
                VALUES (:TIPO, :ID, :fecha, :NIT, 0, 0, 0, :MONTO, :rtfte, :rtiva, :rtica, 'N', 0);
            END
        END
    END

FOR SELECT E.egre_id, EGCC_TIPODOC, EGCC_IDDOC, EGRE_FECHA, TERC_NIT, EGCC_ABONO+EGCC_DTOF, EGCC_RTFTE, EGCC_RTIVA, EGCC_RTICA
    FROM EGRESOS_CRUCEC C, EGRESOS E
    WHERE E.egre_id = C.egre_id AND EGRE_ANULADO = 'N' AND TERC_NIT >= :CLIINI AND TERC_NIT <= :CLIFIN
    ORDER BY EGRE_FECHA
    INTO :IDR, :TIPO, :ID, :FECHA, :NIT, :MONTO, :RTFTE, :RTIVA, :RTICA
    DO
    BEGIN
    select 'S' from saldos_doc_cartera where sdca_tiporef = :TIPO and sdca_idref = :ID and sdca_fecha = :fecha into :EXISTE;
    if (Existe = 'S') then
        begin
        /* actualice el saldo del dia */
        UPDATE saldos_doc_cartera
            SET SDCA_ABONO = SDCA_ABONO + :MONTO,
            SDCA_ABRTFTE = SDCA_ABRTFTE + :RTFTE,
            SDCA_ABRTIVA = SDCA_ABRTIVA + :RTIVA,
            SDCA_ABRTICA = SDCA_ABRTICA + :RTICA
            WHERE SDCA_TIPOREF = :TIPO AND SDCA_IDREF = :ID AND SDCA_FECHA = :fecha;
        END
    ELSE
        BEGIN
        /* Inserte un nuevo saldo diario */
        INSERT INTO SALDOS_DOC_CARTERA (SDCA_TIPOREF, SDCA_IDREF, SDCA_FECHA, TERC_NIT, SDCA_RTFTE, SDCA_RTIVA, SDCA_RTICA, SDCA_ABONO, SDCA_ABRTFTE, SDCA_ABRTIVA, SDCA_ABRTICA, SDCA_DEBITO, SDCA_MONTO)
            VALUES (:TIPO, :ID, :fecha, :NIT, 0, 0, 0, :MONTO, :rtfte, :rtiva, :rtica, 'N', 0);
        END
    END

for select ancl_id, ancl_base+ancl_ivamonto, PREF_PRE, ANCL_NUMERO from anticipos_cliente
    where ANCL_ANULADO = 'N' and reca_id not in (select reca_id from recibos_caja where reca_anulado = 'N')
    into :ID, :MONTO, :PREF, :NUMERO
    do
    begin
    FECHA = cast('now' as date);
    execute procedure saldo_doc_cartera(45, :id, :FECHA) returning_values (:RTFTE);
    if ((MONTO = RTFTE) or (RTFTE IS NULL)) then
        DELETE FROM ANTICIPOS_CLIENTE WHERE ANCL_ID = :ID;
    ELSE
        BEGIN
        TIPO = 45;
        ERROR = 'DOCUMENTO ANULADO CON ABONOS';
        SUSPEND;
        END
    end
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE COMISIONES_COBRO(
    DESDE INTEGER,
    HASTA INTEGER,
    FECINI DATE,
    FECFIN DATE,
    DETALLE CHAR(1))
RETURNS (
    CODVEND INTEGER,
    NOMVEND VARCHAR(60),
    NIT VARCHAR(20),
    CLIENTE VARCHAR(60),
    NOMTIPO VARCHAR(8),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECDOC DATE,
    PREFREC VARCHAR(4),
    NUMREC VARCHAR(6),
    FECREC DATE,
    DIAS INTEGER,
    ABONO NUMERIC(18,2),
    BASE NUMERIC(18,2),
    COMIMONTO NUMERIC(18,2),
    COMIPORC NUMERIC(9,2),
    ARTICULO VARCHAR(20),
    CODGRP VARCHAR(2),
    CANT NUMERIC(18,4))
AS
DECLARE VARIABLE TIPO INTEGER;
DECLARE VARIABLE ID INTEGER;
DECLARE VARIABLE IVAMONTO NUMERIC(18,2);
DECLARE VARIABLE TOTAL NUMERIC(18,2);
DECLARE VARIABLE SITOT CHAR(2);
DECLARE VARIABLE VENTA CHAR(2);
DECLARE VARIABLE COMIV NUMERIC(18,2);
DECLARE VARIABLE PORCV NUMERIC(18,2);
DECLARE VARIABLE CONSUMO NUMERIC(18,2);
declare variable ALFINAL CHAR(2);
declare variable SALDO NUMERIC(18,2);
declare variable COMISION VARCHAR(10);
declare variable porcaux NUMERIC(9,2);
declare variable BASEAUX DOUBLE PRECISION;
declare variable SUCURSAL VARCHAR(20);
BEGIN
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'VENDEDORES', 'COMISIONES EN VENTA INCLUYENDO IMPUESTOS') returning_values (:SITOT);
EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA','COMISIONES','COMISION POR COBRO PAGADERA SOLO EN EL COBRO TOTAL') returning_values (:ALFINAL);
execute procedure lee_configuracion('CARTERA','COMISIONES','COMISION POR COBRO COMO PORCENTAJE DE LA COMISION VENTA') returning_values (:venta);
EXECUTE PROCEDURE lee_configuracion('CARTERA', 'COMISIONES', 'LIQUIDAR COMISION COBRO CON COBRADOR DEL DOCUMENTO O DEL RECIBO') returning_values (:COMISION);
FOR SELECT RCDE_TIPODOC, RCDE_IDDOC, RCDE_PREFIJO, RCDE_NUMERO, R.TERC_NIT, TERC_NOM, RECA_FECHA, (RCDE_ABONO+RCDE_RTFTE+RCDE_RTIVA+RCDE_RTICA), PREF_PRE, RECA_NUMERO, COBR_COD
    FROM RECIBOS_CAJA R, RECIBOS_CAJA_DETALLE RD, TERCEROS T
    WHERE R.RECA_ID = RD.RECA_ID AND RECA_FECHA >= :FECINI AND RECA_FECHA <= :FECFIN AND R.TERC_NIT = T.TERC_NIT AND RECA_ANULADO = 'N'
    ORDER BY TERC_NIT, RECA_FECHA
    INTO :TIPO, :ID, :PREFIJO, :NUMERO, :NIT, :CLIENTE, :FECREC, :ABONO, :PREFREC, :NUMREC, :codvend
    DO
    BEGIN
    SELECT TIDO_NOMCORTO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPO INTO :NOMTIPO;
    if (COMISION = 'DOCUMENTO') then
        SELECT MVCL_FECHA, COBR_COD FROM MOVIMIENTO_CLIENTES WHERE MVCL_TIPOREF = :TIPO AND MVCL_IDREF = :ID
            INTO :FECDOC, :codvend;
    else
        SELECT MVCL_FECHA FROM MOVIMIENTO_CLIENTES WHERE MVCL_TIPOREF = :TIPO AND MVCL_IDREF = :ID
            INTO :FECDOC;
    if (FECDOC IS NOT NULL) then
        DIAS = FECREC - FECDOC;
    ELSE
        DIAS = 999;
    if ((codvend >= :DESDE) AND (codvend <= :hasta)) then
        BEGIN
        /* TRAIGA EL PORCENTAJE DE ACUERDO A LOS DIAS */
        COMIPORC = 0;
        SELECT CMCB_PORC FROM COMISION_COBRO WHERE CMCB_DIASINI <= :dias AND CMCB_DIASFIN >= :DIAS AND COBR_COD = :CODVEND INTO :COMIPORC;
        if (COMIPORC IS NULL) THEN
            COMIPORC = 0;
        if (VENTA = 'NO') then
            BEGIN
            if (TIPO = 31) then
                BEGIN
                if (DETALLE = 'N') then
                    SELECT MAX(FACT_TOTAL), MAX(FACT_IVAMONTO), SUM(FADE_CONSUMO) FROM FACTURAS F, FACTURAS_DETALLE D
                        WHERE F.FACT_ID = D.FACT_ID AND F.FACT_ID = :ID INTO :TOTAL, :IVAMONTO, :CONSUMO;
                ELSE
                    FOR SELECT D.ARTI_COD, FADE_CANT, FADE_TOTAL, FADE_IVAMONTO, FADE_CONSUMO, GRUP_COD
                        FROM FACTURAS F, FACTURAS_DETALLE D, ARTICULO A
                        WHERE F.FACT_ID = D.FACT_ID AND D.arti_cod = A.arti_cod AND F.FACT_ID = :ID
                        INTO :ARTICULO, :CANT, :TOTAL, :IVAMONTO, :CONSUMO, :CODGRP
                        DO
                        BEGIN
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = (TOTAL - IVAMONTO - CONSUMO);
                        BASE = BASEAUX;
                        COMIMONTO = BASE / 100 * COMIPORC;
                        SUSPEND;
                        END
                END
            if (TIPO = 33) then
                if (DETALLE = 'N') then
                    SELECT MAX(DEVT_TOTAL*-1), MAX(DEVT_IVAMONTO*-1), SUM(DVDE_CONSUMO) FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D
                        WHERE V.DEVT_ID = D.DEVT_ID AND V.DEVT_ID = :ID INTO :TOTAL, :IVAMONTO, :CONSUMO;
                ELSE
                    FOR SELECT D.ARTI_COD, DVDE_CANT, DVDE_TOTAL*-1, DVDE_IVAMONTO*-1, DVDE_CONSUMO*-1, GRUP_COD
                        FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D, ARTICULO A
                        WHERE V.DEVT_ID = D.DEVT_ID AND D.arti_cod = A.arti_cod AND V.DEVT_ID = :ID
                        INTO :ARTICULO, :CANT, :TOTAL, :IVAMONTO, :CONSUMO, :codgrp
                        DO
                        BEGIN
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = TOTAL - IVAMONTO - CONSUMO;
                        BASE = BASEAUX;
                        COMIMONTO = BASE / 100 * COMIPORC;
                        SUSPEND;
                        END
            if (TIPO = 41) then
                SELECT NDCL_MONTO, NDCL_IVAMONTO, 0 FROM NOTAS_DEBITO_CLIENTES WHERE NDCL_ID = :ID INTO :TOTAL, :IVAMONTO, :CONSUMO;
            if (TIPO = 42) then
                SELECT NCCL_MONTO*-1, NCCL_IVAMONTO*-1, 0 FROM NOTAS_CREDITO_CLIENTES WHERE NCCL_ID = :ID INTO :TOTAL, :IVAMONTO, :CONSUMO;
            if (TIPO = 77) then
                SELECT DVCH_MONTO, 0, 0 FROM DEVOLUCION_CHEQUES WHERE DVCH_ID = :ID INTO :TOTAL, :IVAMONTO, :CONSUMO;
            if (SITOT = 'SI') then
                BASEAUX = ABONO;
            ELSE
                if ((TOTAL - IVAMONTO - CONSUMO) <> 0) then
                    BASEAUX = (ABONO / TOTAL) * (TOTAL - IVAMONTO - CONSUMO);
                ELSE
                    BASEAUX = 0;
            BASE = BASEAUX;
            COMIMONTO = BASE / 100 * COMIPORC;
            END
        ELSE
            BEGIN
            if (TIPO = 31) then
                if (DETALLE = 'N') then
                    SELECT MAX(FACT_TOTAL), MAX(FACT_IVAMONTO), MAX(FACT_COMIPORC), SUM(FADE_CONSUMO)
                        FROM FACTURAS F, FACTURAS_DETALLE D WHERE F.FACT_ID = D.FACT_ID AND F.FACT_ID = :ID
                        INTO :TOTAL, :IVAMONTO, :PORCV, :CONSUMO;
                ELSE
                    FOR SELECT D.ARTI_COD, FADE_CANT, FADE_TOTAL, FADE_IVAMONTO, FADE_CONSUMO, FACT_COMIPORC, GRUP_COD
                        FROM FACTURAS F, FACTURAS_DETALLE D, ARTICULO A
                        WHERE F.FACT_ID = D.FACT_ID AND D.arti_cod = A.arti_cod AND F.FACT_ID = :ID
                        INTO :ARTICULO, :CANT, :TOTAL, :IVAMONTO, :CONSUMO, :porcv, :codgrp
                        DO
                        BEGIN
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = (TOTAL - IVAMONTO - CONSUMO);
                        COMIV = PORCV / 100 * BASEAUX;
                        COMIMONTO = COMIV / 100 * COMIPORC;
                        porcaux = comiporc;
                        comiporc = PORCV / 100 * COMIPORC;
                        BASE = BASEAUX;
                        SUSPEND;
                        END
            if (TIPO = 33) then
                if (DETALLE = 'N') then
                    SELECT MAX(DEVT_TOTAL), MAX(DEVT_IVAMONTO), MAX(DEVT_COMIPORC), SUM(DVDE_CONSUMO)
                        FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D WHERE V.DEVT_ID = D.DEVT_ID AND D.DEVT_ID = :ID
                        INTO :TOTAL, :IVAMONTO, :PORCV, :CONSUMO;
                ELSE
                    FOR SELECT D.ARTI_COD, DVDE_CANT, DVDE_TOTAL*-1, DVDE_IVAMONTO*-1, DVDE_CONSUMO*-1, DEVT_COMIPORC, GRUP_COD
                        FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D, ARTICULO A
                        WHERE V.DEVT_ID = D.DEVT_ID AND D.arti_cod = A.arti_cod AND V.DEVT_ID = :ID
                        INTO :ARTICULO, :CANT, :TOTAL, :IVAMONTO, :CONSUMO, :porcv, :codgrp
                        DO
                        BEGIN
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = (TOTAL - IVAMONTO - CONSUMO);
                        COMIV = PORCV / 100 * BASEAUX;
                        COMIMONTO = COMIV / 100 * COMIPORC;
                        porcaux = comiporc;
                        comiporc = PORCV / 100 * COMIPORC;
                        BASE = BASEAUX;
                        SUSPEND;
                        END
            if (TIPO = 41) then
                SELECT NDCL_MONTO, NDCL_IVAMONTO, NDCL_COMIPORC, 0 FROM NOTAS_DEBITO_CLIENTES
                    WHERE NDCL_ID = :ID INTO :TOTAL, :IVAMONTO, :PORCV, :CONSUMO;
            if (TIPO = 42) then
                SELECT NCCL_MONTO, NCCL_IVAMONTO, NCCL_COMIPORC, 0  FROM NOTAS_CREDITO_CLIENTES
                    WHERE NCCL_ID = :ID INTO :TOTAL, :IVAMONTO, :PORCV, :CONSUMO;
            if (TIPO = 77) then
                SELECT DVCH_MONTO, 0, 0, 0 FROM DEVOLUCION_CHEQUES WHERE DVCH_ID = :ID INTO :TOTAL, :IVAMONTO, :PORCV, :CONSUMO;
            if (SITOT = 'SI') then
                BASEAUX = ABONO;
            ELSE
                if ((total <> 0) AND (ABONO <> 0)) then
                    BASEAUX = (TOTAL - IVAMONTO - CONSUMO) / TOTAL * ABONO;
                ELSE
                    BASEAUX = 0;
            COMIV = PORCV / 100 * BASEAUX;
            COMIMONTO = COMIV / 100 * COMIPORC;
            porcaux = comiporc;
            comiporc = PORCV / 100 * COMIPORC;
            BASE = BASEAUX;
            END
        select COBR_NOM from COBRADORES where COBR_COD = :codvend INTO :nomvend;
        if (DETALLE = 'N') then
            if (ALFINAL = 'SI') then
                BEGIN
                /* VERIFIQUE EL SALDO DEL DOCUMENTO, SI ES CERO LIQUIDE COMISION SOBRE EL TOTAL */
                EXECUTE PROCEDURE saldo_doc_cartera(:tipo, :ID, :FECREC) returning_values (:SALDO);
                if (SALDO = 0) then
                    BEGIN
                    if (VENTA = 'NO') then
                        begin
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = TOTAL - IVAMONTO - CONSUMO;
                        COMIMONTO = BASEAUX * COMIPORC / 100;
                        end
                    ELSE
                        BEGIN
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = TOTAL - IVAMONTO - CONSUMO;
                        COMIV = PORCV * BASEAUX / 100;
                        COMIMONTO = COMIV / 100 * porcaux;
                        comiporc = PORCV / 100 * porcaux;
                        END
                    BASE = BASEAUX;
                    SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
        ELSE
            if ((TIPO <> 31) AND (TIPO <> 33)) then
                SUSPEND;
        END
    END
FOR SELECT EGCC_TIPODOC, EGCC_IDDOC, EGCC_PREFIJO, EGCC_NUMERO, E.TERC_NIT, TERC_NOM, EGRE_FECHA, (EGCC_ABONO+EGCC_RTFTE+EGCC_RTIVA+EGCC_RTICA), PREF_PRE, EGRE_NUMERO, EGCC_SUCURSAL
    FROM EGRESOS E, EGRESOS_CRUCEC C, TERCEROS T
    WHERE E.EGRE_ID = C.EGRE_ID AND EGRE_FECHA >= :FECINI AND EGRE_FECHA <= :FECFIN AND E.TERC_NIT = T.TERC_NIT AND EGRE_ANULADO = 'N'
    ORDER BY TERC_NIT, EGRE_FECHA
    INTO :TIPO, :ID, :PREFIJO, :NUMERO, :NIT, :CLIENTE, :FECREC, :ABONO, :PREFREC, :NUMREC, :SUCURSAL
    DO
    BEGIN
    SELECT COBR_COD FROM cliente_sucursales WHERE TERC_NIT = :NIT AND CLCU_COD = :sucursal INTO :codvend;
    SELECT TIDO_NOMCORTO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPO INTO :NOMTIPO;
    if (COMISION = 'DOCUMENTO') then
        SELECT MVCL_FECHA, COBR_COD FROM MOVIMIENTO_CLIENTES WHERE MVCL_TIPOREF = :TIPO AND MVCL_IDREF = :ID
            INTO :FECDOC, :codvend;
    else
        SELECT MVCL_FECHA FROM MOVIMIENTO_CLIENTES WHERE MVCL_TIPOREF = :TIPO AND MVCL_IDREF = :ID
            INTO :FECDOC;
    if (FECDOC IS NOT NULL) then
        DIAS = FECREC - FECDOC;
    ELSE
        DIAS = 999;
    if ((codvend >= :DESDE) AND (codvend <= :hasta)) then
        BEGIN
        /* TRAIGA EL PORCENTAJE DE ACUERDO A LOS DIAS */
        COMIPORC = 0;
        SELECT CMCB_PORC FROM COMISION_COBRO WHERE CMCB_DIASINI <= :dias AND CMCB_DIASFIN >= :DIAS AND COBR_COD = :CODVEND INTO :COMIPORC;
        if (COMIPORC IS NULL) THEN
            COMIPORC = 0;
        if (VENTA = 'NO') then
            BEGIN
            if (TIPO = 31) then
                BEGIN
                if (DETALLE = 'N') then
                    SELECT MAX(FACT_TOTAL), MAX(FACT_IVAMONTO), SUM(FADE_CONSUMO) FROM FACTURAS F, FACTURAS_DETALLE D
                        WHERE F.FACT_ID = D.FACT_ID AND F.FACT_ID = :ID INTO :TOTAL, :IVAMONTO, :CONSUMO;
                ELSE
                    FOR SELECT D.ARTI_COD, FADE_CANT, FADE_TOTAL, FADE_IVAMONTO, FADE_CONSUMO, GRUP_COD
                        FROM FACTURAS F, FACTURAS_DETALLE D, ARTICULO A
                        WHERE F.FACT_ID = D.FACT_ID AND D.arti_cod = A.arti_cod AND F.FACT_ID = :ID
                        INTO :ARTICULO, :CANT, :TOTAL, :IVAMONTO, :CONSUMO, :CODGRP
                        DO
                        BEGIN
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = (TOTAL - IVAMONTO - CONSUMO);
                        BASE = BASEAUX;
                        COMIMONTO = BASE / 100 * COMIPORC;
                        SUSPEND;
                        END
                END
            if (TIPO = 33) then
                if (DETALLE = 'N') then
                    SELECT MAX(DEVT_TOTAL*-1), MAX(DEVT_IVAMONTO*-1), SUM(DVDE_CONSUMO) FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D
                        WHERE V.DEVT_ID = D.DEVT_ID AND V.DEVT_ID = :ID INTO :TOTAL, :IVAMONTO, :CONSUMO;
                ELSE
                    FOR SELECT D.ARTI_COD, DVDE_CANT, DVDE_TOTAL*-1, DVDE_IVAMONTO*-1, DVDE_CONSUMO*-1, GRUP_COD
                        FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D, ARTICULO A
                        WHERE V.DEVT_ID = D.DEVT_ID AND D.arti_cod = A.arti_cod AND V.DEVT_ID = :ID
                        INTO :ARTICULO, :CANT, :TOTAL, :IVAMONTO, :CONSUMO, :codgrp
                        DO
                        BEGIN
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = TOTAL - IVAMONTO - CONSUMO;
                        BASE = BASEAUX;
                        COMIMONTO = BASE / 100 * COMIPORC;
                        SUSPEND;
                        END
            if (TIPO = 41) then
                SELECT NDCL_MONTO, NDCL_IVAMONTO, 0 FROM NOTAS_DEBITO_CLIENTES WHERE NDCL_ID = :ID INTO :TOTAL, :IVAMONTO, :CONSUMO;
            if (TIPO = 42) then
                SELECT NCCL_MONTO*-1, NCCL_IVAMONTO*-1, 0 FROM NOTAS_CREDITO_CLIENTES WHERE NCCL_ID = :ID INTO :TOTAL, :IVAMONTO, :CONSUMO;
            if (TIPO = 77) then
                SELECT DVCH_MONTO, 0, 0 FROM DEVOLUCION_CHEQUES WHERE DVCH_ID = :ID INTO :TOTAL, :IVAMONTO, :CONSUMO;
            if (SITOT = 'SI') then
                BASEAUX = ABONO;
            ELSE
                if ((TOTAL - IVAMONTO - CONSUMO) <> 0) then
                    BASEAUX = (ABONO / TOTAL) * (TOTAL - IVAMONTO - CONSUMO);
                ELSE
                    BASEAUX = 0;
            BASE = BASEAUX;
            COMIMONTO = BASE / 100 * COMIPORC;
            END
        ELSE
            BEGIN
            if (TIPO = 31) then
                if (DETALLE = 'N') then
                    SELECT MAX(FACT_TOTAL), MAX(FACT_IVAMONTO), MAX(FACT_COMIPORC), SUM(FADE_CONSUMO)
                        FROM FACTURAS F, FACTURAS_DETALLE D WHERE F.FACT_ID = D.FACT_ID AND F.FACT_ID = :ID
                        INTO :TOTAL, :IVAMONTO, :PORCV, :CONSUMO;
                ELSE
                    FOR SELECT D.ARTI_COD, FADE_CANT, FADE_TOTAL, FADE_IVAMONTO, FADE_CONSUMO, FACT_COMIPORC, GRUP_COD
                        FROM FACTURAS F, FACTURAS_DETALLE D, ARTICULO A
                        WHERE F.FACT_ID = D.FACT_ID AND D.arti_cod = A.arti_cod AND F.FACT_ID = :ID
                        INTO :ARTICULO, :CANT, :TOTAL, :IVAMONTO, :CONSUMO, :porcv, :codgrp
                        DO
                        BEGIN
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = (TOTAL - IVAMONTO - CONSUMO);
                        COMIV = PORCV / 100 * BASEAUX;
                        COMIMONTO = COMIV / 100 * COMIPORC;
                        porcaux = comiporc;
                        comiporc = PORCV / 100 * COMIPORC;
                        BASE = BASEAUX;
                        SUSPEND;
                        END
            if (TIPO = 33) then
                if (DETALLE = 'N') then
                    SELECT MAX(DEVT_TOTAL), MAX(DEVT_IVAMONTO), MAX(DEVT_COMIPORC), SUM(DVDE_CONSUMO)
                        FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D WHERE V.DEVT_ID = D.DEVT_ID AND D.DEVT_ID = :ID
                        INTO :TOTAL, :IVAMONTO, :PORCV, :CONSUMO;
                ELSE
                    FOR SELECT D.ARTI_COD, DVDE_CANT, DVDE_TOTAL*-1, DVDE_IVAMONTO*-1, DVDE_CONSUMO*-1, DEVT_COMIPORC, GRUP_COD
                        FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D, ARTICULO A
                        WHERE V.DEVT_ID = D.DEVT_ID AND D.arti_cod = A.arti_cod AND V.DEVT_ID = :ID
                        INTO :ARTICULO, :CANT, :TOTAL, :IVAMONTO, :CONSUMO, :porcv, :codgrp
                        DO
                        BEGIN
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = (TOTAL - IVAMONTO - CONSUMO);
                        COMIV = PORCV / 100 * BASEAUX;
                        COMIMONTO = COMIV / 100 * COMIPORC;
                        porcaux = comiporc;
                        comiporc = PORCV / 100 * COMIPORC;
                        BASE = BASEAUX;
                        SUSPEND;
                        END
            if (TIPO = 41) then
                SELECT NDCL_MONTO, NDCL_IVAMONTO, NDCL_COMIPORC, 0 FROM NOTAS_DEBITO_CLIENTES
                    WHERE NDCL_ID = :ID INTO :TOTAL, :IVAMONTO, :PORCV, :CONSUMO;
            if (TIPO = 42) then
                SELECT NCCL_MONTO, NCCL_IVAMONTO, NCCL_COMIPORC, 0  FROM NOTAS_CREDITO_CLIENTES
                    WHERE NCCL_ID = :ID INTO :TOTAL, :IVAMONTO, :PORCV, :CONSUMO;
            if (TIPO = 77) then
                SELECT DVCH_MONTO, 0, 0, 0 FROM DEVOLUCION_CHEQUES WHERE DVCH_ID = :ID INTO :TOTAL, :IVAMONTO, :PORCV, :CONSUMO;
            if (SITOT = 'SI') then
                BASEAUX = ABONO;
            ELSE
                if ((total <> 0) AND (ABONO <> 0)) then
                    BASEAUX = (TOTAL - IVAMONTO - CONSUMO) / TOTAL * ABONO;
                ELSE
                    BASEAUX = 0;
            COMIV = PORCV / 100 * BASEAUX;
            COMIMONTO = COMIV / 100 * COMIPORC;
            porcaux = comiporc;
            comiporc = PORCV / 100 * COMIPORC;
            BASE = BASEAUX;
            END
        select COBR_NOM from COBRADORES where COBR_COD = :codvend INTO :nomvend;
        if (DETALLE = 'N') then
            if (ALFINAL = 'SI') then
                BEGIN
                /* VERIFIQUE EL SALDO DEL DOCUMENTO, SI ES CERO LIQUIDE COMISION SOBRE EL TOTAL */
                EXECUTE PROCEDURE saldo_doc_cartera(:tipo, :ID, :FECREC) returning_values (:SALDO);
                if (SALDO = 0) then
                    BEGIN
                    if (VENTA = 'NO') then
                        begin
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = TOTAL - IVAMONTO - CONSUMO;
                        COMIMONTO = BASEAUX * COMIPORC / 100;
                        end
                    ELSE
                        BEGIN
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = TOTAL - IVAMONTO - CONSUMO;
                        COMIV = PORCV * BASEAUX / 100;
                        COMIMONTO = COMIV / 100 * porcaux;
                        comiporc = PORCV / 100 * porcaux;
                        END
                    BASE = BASEAUX;
                    SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
        ELSE
            if ((TIPO <> 31) AND (TIPO <> 33)) then
                SUSPEND;
        END
    END
FOR SELECT 'DEVOCHEQ', DVCH_MONTO*-1, DVCH_FECHA, PRBA_PREF, DVCH_NUMDOC, DVCH_FECHA, D.TERC_NIT, DVCH_NOMTERC, '', '', D.COBR_COD
    FROM DEVOLUCION_CHEQUES D, CLIENTES C
    WHERE DVCH_FECHA >= :FECINI AND DVCH_FECHA <= :FECFIN AND D.TERC_NIT = C.TERC_NIT AND D.COBR_COD = :CODVEND
    INTO :NOMTIPO, :BASE, :FECDOC, :PREFIJO, :NUMERO, :FECREC, :NIT, :CLIENTE, :PREFREC, :NUMREC, :codvend
    DO
    BEGIN
    COMIPORC = 0;
    COMIMONTO = 0;
    if ((codvend >= :DESDE) AND (codvend <= :hasta)) then
        BEGIN
        select COBR_NOM from COBRADORES where COBR_COD = :codvend INTO :nomvend;
        /* SELECT CMCB_PORC FROM COMISION_COBRO WHERE CMCB_DIASINI <= 1 AND CMCB_DIASFIN >= 1 AND COBR_COD = :CODVEND INTO :COMIPORC;
        if (COMIPORC IS NULL) THEN
            COMIPORC = 0;
        COMIMONTO = BASE * COMIPORC / 100; */
        SUSPEND;
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE ESTADISTICA_VENTAS_VENDEDOR_MES(
    AGENCIA INTEGER,
    VENDINI INTEGER,
    VENDFIN INTEGER,
    ANO CHAR(4),
    MES INTEGER)
RETURNS (
    CODVEND INTEGER,
    NOMVEND VARCHAR(60),
    CODAGENCIA INTEGER,
    NOMAGENCIA VARCHAR(60),
    FECHA DATE,
    VENTAS NUMERIC(18,2),
    MAXVENTA NUMERIC(18,2),
    RECAUDO NUMERIC(18,2),
    MAXRECAUDO NUMERIC(18,2))
AS
declare variable FECINI DATE;
declare variable FECFIN DATE;
declare variable ANOAUX INTEGER;
declare variable TIPO INTEGER;
declare variable ID INTEGER;
declare variable ABONO NUMERIC(18,2);
declare variable SUBTOTAL NUMERIC(18,2);
declare variable IVAMONTO NUMERIC(18,2);
declare variable TOTAL NUMERIC(18,2);
begin
EXECUTE PROCEDURE COMPONE_FECHA (ANO, MES, 1) RETURNING_VALUES (FECINI);
if (MES < 12) then
    MES = MES + 1;
ELSE
    BEGIN
    ANOAUX = CAST(ANO AS INTEGER);
    ANOAUX = ANOAUX + 1;
    ANO = CAST(ANOAUX AS CHAR(4));
    MES = 1;
    END
EXECUTE PROCEDURE COMPONE_FECHA (ANO, MES, 1) RETURNING_VALUES (FECFIN);
FOR SELECT VEND_COD, VEND_NOMBRE, SUCU_ID FROM VENDEDORES WHERE VEND_COD >= :VENDINI AND VEND_COD <= :VENDFIN AND
    ((SUCU_ID = :AGENCIA) or (:AGENCIA = 0))
    INTO :CODVEND, :NOMVEND, :CODAGENCIA
    DO
    BEGIN
    if (CODAGENCIA <> 0) then
        SELECT SUCU_NOMBRE FROM SUCURSALES WHERE SUCU_ID = :CODAGENCIA INTO :NOMAGENCIA;
    /* CALCULE LAS VENTAS */
    MAXVENTA = 0;
    MAXRECAUDO = 0;
    FOR SELECT SUM(FACT_TOTAL-FACT_IVAMONTO), MIN(FACT_FECHA) FROM FACTURAS F, PREFIJOS P
        WHERE VEND_COD = :CODVEND AND FACT_FECHA >= :FECINI AND FACT_FECHA < :FECFIN AND FACT_ANULADO = 'N'
        AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((SUCU_ID = :AGENCIA) or (:AGENCIA = 0))
        GROUP BY FACT_FECHA
        INTO :VENTAS, :FECHA
        DO
        BEGIN
        if (VENTAS > MAXVENTA) then
            MAXVENTA = VENTAS;
        SELECT SUM(DEVT_TOTAL-DEVT_IVAMONTO) FROM devoluciones_ventas F, PREFIJOS P
            WHERE VEND_COD = :CODVEND AND DEVT_FECHA = :FECHA AND DEVT_ANULADO = 'N'
            AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 33 AND ((SUCU_ID = :AGENCIA) or (:AGENCIA = 0))
            INTO :SUBTOTAL;
        if (SUBTOTAL IS NOT NULL) then
            VENTAS = VENTAS - SUBTOTAL;
        /* CALCULE EL RECAUDO DEL DIA EXCLUYENDO EL IVA */
        RECAUDO = 0;
        FOR SELECT RCDE_TIPODOC, RCDE_IDDOC, (RCDE_ABONO+RCDE_RTFTE+RCDE_RTIVA+RCDE_RTICA)
            FROM RECIBOS_CAJA R, RECIBOS_CAJA_DETALLE RD, MOVIMIENTO_CLIENTES M
            WHERE R.RECA_ID = RD.RECA_ID AND RECA_FECHA = :FECHA AND RECA_ANULADO = 'N' and
            MVCL_TIPOREF = RCDE_TIPODOC AND MVCL_IDREF = RCDE_IDDOC AND R.COBR_COD = :CODVEND
            INTO :TIPO, :ID, :ABONO
            DO
            BEGIN
            /* TRAIGA EL DOCUMENTO Y CALCULE LA BASE */
            if (TIPO = 31) then
                SELECT FACT_TOTAL,FACT_IVAMONTO FROM FACTURAS WHERE FACT_ID = :ID INTO :TOTAL, :IVAMONTO;
            if (TIPO = 33) then
                SELECT DEVT_TOTAL*-1,DEVT_IVAMONTO*-1 FROM DEVOLUCIONES_VENTAS WHERE DEVT_ID = :ID INTO :TOTAL, :IVAMONTO;
            if (TIPO = 41) then
                SELECT NDCL_MONTO,NDCL_IVAMONTO FROM NOTAS_DEBITO_CLIENTES WHERE NDCL_ID = :ID INTO :TOTAL, :IVAMONTO;
            if (TIPO = 42) then
                SELECT NCCL_MONTO*-1,NCCL_IVAMONTO*-1 FROM NOTAS_CREDITO_CLIENTES WHERE NCCL_ID = :ID INTO :TOTAL, :IVAMONTO;
            if (TIPO = 77) then
                SELECT DVCH_MONTO,0 FROM DEVOLUCION_CHEQUES WHERE DVCH_ID = :ID INTO :TOTAL, :IVAMONTO;
            if (TOTAL <> 0) then
                SUBTOTAL = (ABONO / TOTAL) * (TOTAL - IVAMONTO);
            RECAUDO = RECAUDO + SUBTOTAL;
            END
        FOR SELECT EGCC_TIPODOC, EGCC_IDDOC, (EGCC_ABONO+EGCC_RTFTE+EGCC_RTIVA+EGCC_RTICA)
            FROM EGRESOS E, EGRESOS_CRUCEC C, MOVIMIENTO_CLIENTES M
            WHERE E.EGRE_ID = C.EGRE_ID AND EGRE_FECHA = :FECHA AND EGRE_ANULADO = 'N' and
            MVCL_TIPOREF = EGCC_TIPODOC AND MVCL_IDREF = EGCC_IDDOC AND M.cobr_cod = :CODVEND
            INTO :TIPO, :ID, :ABONO
            DO
            BEGIN
            /* TRAIGA EL DOCUMENTO Y CALCULE LA BASE */
            if (TIPO = 31) then
                SELECT FACT_TOTAL,FACT_IVAMONTO FROM FACTURAS WHERE FACT_ID = :ID INTO :TOTAL, :IVAMONTO;
            if (TIPO = 33) then
                SELECT DEVT_TOTAL*-1,DEVT_IVAMONTO*-1 FROM DEVOLUCIONES_VENTAS WHERE DEVT_ID = :ID INTO :TOTAL, :IVAMONTO;
            if (TIPO = 41) then
                SELECT NDCL_MONTO,NDCL_IVAMONTO FROM NOTAS_DEBITO_CLIENTES WHERE NDCL_ID = :ID INTO :TOTAL, :IVAMONTO;
            if (TIPO = 42) then
                SELECT NCCL_MONTO*-1,NCCL_IVAMONTO*-1 FROM NOTAS_CREDITO_CLIENTES WHERE NCCL_ID = :ID INTO :TOTAL, :IVAMONTO;
            if (TIPO = 77) then
                SELECT DVCH_MONTO,0 FROM DEVOLUCION_CHEQUES WHERE DVCH_ID = :ID INTO :TOTAL, :IVAMONTO;
            if (TOTAL <> 0) then
                SUBTOTAL = (ABONO / TOTAL) * (TOTAL - IVAMONTO);
            RECAUDO = RECAUDO + SUBTOTAL;
            END
        if (RECAUDO > MAXRECAUDO) then
            MAXRECAUDO = RECAUDO;
        suspend;
        END
    END
end
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE ESTADISTICA_VENTAS_VENDEDOR_ANO(
    AGENCIA INTEGER,
    VENDINI INTEGER,
    VENDFIN INTEGER,
    ANO CHAR(4))
RETURNS (
    CODVEND INTEGER,
    NOMVEND VARCHAR(60),
    CODAGENCIA INTEGER,
    NOMAGENCIA VARCHAR(60),
    MES INTEGER,
    VENTA1 NUMERIC(18,2),
    VENTA2 NUMERIC(18,2),
    RECAUDO1 NUMERIC(18,2),
    RECAUDO2 NUMERIC(18,2))
AS
declare variable ANOAUX INTEGER;
declare variable ANO2 CHAR(4);
begin /*$$IBE$$ 
ANOAUX = CAST(ANO AS INTEGER);
ANOAUX = ANOAUX - 1;
ANO2 = CAST(ANOAUX AS CHAR(4));
MES = 1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
MES = 2;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
MES = 3;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
MES = 4;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
MES = 5;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
MES = 6;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
MES = 7;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
MES = 8;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
MES = 9;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
MES = 10;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
MES = 11;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
MES = 12;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
 $$IBE$$*/ SUSPEND;
end
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE ESTADISTICA_VENTAS_VENDEDOR_ANO(
    AGENCIA INTEGER,
    VENDINI INTEGER,
    VENDFIN INTEGER,
    ANO CHAR(4))
RETURNS (
    CODVEND INTEGER,
    NOMVEND VARCHAR(60),
    CODAGENCIA INTEGER,
    NOMAGENCIA VARCHAR(60),
    MES INTEGER,
    VENTA1 NUMERIC(18,2),
    VENTA2 NUMERIC(18,2),
    RECAUDO1 NUMERIC(18,2),
    RECAUDO2 NUMERIC(18,2))
AS
declare variable ANOAUX INTEGER;
declare variable ANO2 CHAR(4);
begin
ANOAUX = CAST(ANO AS INTEGER);
ANOAUX = ANOAUX - 1;
ANO2 = CAST(ANOAUX AS CHAR(4));
MES = 1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
MES = 2;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
MES = 3;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
MES = 4;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
MES = 5;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
MES = 6;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
MES = 7;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
MES = 8;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
MES = 9;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
MES = 10;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
MES = 11;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
MES = 12;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA1, :RECAUDO1;
SELECT MAX(CODVEND), MAX(NOMVEND), MAX(codagencia), MAX(nomagencia), SUM(VENTAS), SUM(RECAUDO)
    FROM ESTADISTICA_VENTAS_VENDEDOR_MES(:AGENCIA, :VENDINI, :vendfin,  :ANO2, :MES)
    GROUP BY CODVEND
    INTO :CODVEND, :NOMVEND, :CODAGENCIA, :NOMAGENCIA, :VENTA2, :RECAUDO2;
suspend;
end

^

SET TERM ; ^

CREATE TABLE RECIBOS_CAJA_CRUCEC (
    RECA_ID T_ID NOT NULL,
    RCCR_ITEM T_ID NOT NULL,
    RCCR_TIPODOC INTEGER,
    RCCR_IDDOC INTEGER,
    RCCR_PREFIJO VARCHAR(4),
    RCCR_NUMERO VARCHAR(6),
    RCCR_ABONO T_MONTO,
    RCCR_RTFTE T_MONTO,
    RCCR_RTIVA T_MONTO,
    RCCR_RTICA T_MONTO,
    RCCR_DTOF T_MONTO,
    RCCR_ANULADO T_BOOLEANO,
    RCCR_TRANSMIT T_BOOLEANO);
alter table RECIBOS_CAJA_CRUCEC
add constraint PK_RECIBOS_CAJA_CRUCEC
primary key (RECA_ID,RCCR_ITEM);

SET TERM ^ ;

create trigger RECIBOS_CAJA_CRUCEC_AI for RECIBOS_CAJA_CRUCEC
active AFTER INSERT position 0
AS
declare variable EXISTE CHAR(1);
declare variable FEC DATE;
declare variable NIT VARCHAR(20);
declare variable CONCEPTO VARCHAR(60);
declare variable PREFIJO VARCHAR(4);
declare variable NUMERO VARCHAR(6);
declare variable OK CHAR(1);
declare variable RETES CHAR(2);
declare variable SALDO NUMERIC(18,2);
BEGIN
  if ((NEW.RECA_ID <> 0) and (new.rccr_anulado = 'N')) then
    BEGIN
    OK = 'N';
    /* Abone el documento referenciado  */
    select PREF_PRE, RECA_NUMERO, RECA_FECHA, RECA_CONC, TERC_NIT
        from RECIBOS_CAJA where RECA_ID = new.reca_id into :PREFIJO, :NUMERO, :FEC, :CONCEPTO, :NIT;
    /* valide que no se pase del saldo */
    execute procedure saldo_doc_cxpagar(new.rccr_tipodoc, new.rccr_iddoc, '9999/12/31') returning_values(saldo);
    execute procedure lee_configuracion('CXPAGAR', 'SALDOS', 'DESCONTAR RETENCIONES POR CAUSACION') returning_values (RETES);
    if (SALDO < 0) then
        BEGIN
        if (RETES = 'SI') then
            begin
            if (saldo > NEW.rccr_abono) then
                EXCEPTION DOCUMENTO_ABONO_MAYOR;
            end
        ELSE
            begin
            if (saldo > (NEW.rccr_abono + NEW.rccr_rtfte + NEW.rccr_rtiva + NEW.rccr_rtica + new.rccr_dtof)) then
                EXCEPTION DOCUMENTO_ABONO_MAYOR;
            end
        END
    else
        BEGIN
        if (RETES = 'SI') then
            begin
            if (saldo < NEW.rccr_abono) then
                EXCEPTION DOCUMENTO_ABONO_MAYOR;
            end
        ELSE
            begin
            if (saldo < (NEW.rccr_abono + NEW.rccr_rtfte + NEW.rccr_rtiva + NEW.rccr_rtica + NEW.rccr_dtof)) then
                EXCEPTION DOCUMENTO_ABONO_MAYOR;
            end
        END
    if (OK = 'N') then
        BEGIN
        select 'S' from saldos_doc_cxpagar where sdcp_tiporef = new.rccr_tipodoc and
            sdcp_idref = new.rccr_iddoc and sdcp_fecha = :FEC into :EXISTE;
        if (Existe = 'S') then
            begin
            /* actualice el saldo del dia */
            UPDATE saldos_doc_cxpagar
                SET SDCP_ABONO = SDCP_ABONO + (NEW.rccr_abono + NEW.rccr_dtof),
                    SDCP_ABRTFTE = SDCP_ABRTFTE + NEW.rccr_rtfte,
                    SDCP_ABRTIVA = SDCP_ABRTIVA + NEW.rccr_rtiva,
                    SDCP_ABRTICA = SDCP_ABRTICA + NEW.rccr_rtica
                WHERE SDCP_TIPOREF = NEW.rccr_tipodoc AND SDCP_IDREF = NEW.rccr_iddoc AND SDCP_FECHA = :FEC;
            END
        ELSE
            BEGIN
            /* Inserte un nuevo saldo diario */
            INSERT INTO SALDOS_DOC_CXPAGAR (SDCP_TIPOREF, SDCP_IDREF, SDCP_FECHA, TERC_NIT, SDCP_RTEFTE, SDCP_RTIVA, SDCP_RTICA, SDCP_ABONO, SDCP_ABRTFTE, SDCP_ABRTIVA, SDCP_ABRTICA, SDCP_DEBITO, SDCP_MONTO)
                VALUES (NEW.rccr_tipodoc, NEW.rccr_iddoc, :FEC, :NIT, 0, 0, 0, (NEW.rccr_abono+NEW.rccr_dtof), NEW.rccr_rtfte, NEW.rccr_rtiva, NEW.rccr_rtica, 'N', 0);
            END
        END
    /* actualice el registro en mov_proveedor (por si son varios items) */
    EXISTE = 'N';
    SELECT 'S' FROM MOVIMIENTO_PROVEEDOR WHERE MVPR_TIPOREF = 61 AND MVPR_IDREF = NEW.reca_id INTO :EXISTE;
    if (EXISTE = 'S') then
        begin
        UPDATE movimiento_proveedor
            SET MVPR_MONTO = MVPR_MONTO + (NEW.rccr_abono + NEW.rccr_dtof),
                MVPR_RTFTE = MVPR_RTFTE + NEW.rccr_rtfte,
                MVPR_RTIVA = MVPR_RTIVA + NEW.rccr_rtiva,
                MVPR_RTICA = MVPR_RTICA + NEW.rccr_rtica
            WHERE MVPR_TIPOREF = 61 AND MVPR_IDREF = NEW.reca_id;
        end
    ELSE
        INSERT INTO MOVIMIENTO_PROVEEDOR (MVPR_ID, TERC_NIT, MVPR_TIPOREF, MVPR_IDREF, MVPR_FECHA, MVPR_VENCE, MVPR_CONC, MVPR_MONTO, MVPR_RTFTE, MVPR_RTIVA, MVPR_RTICA, MVPR_DEBITO, MVPR_ABONO, MVPR_PREFIJO, MVPR_NUMERO)
            VALUES (GEN_ID(ID_MOVPROV, 1), :NIT, 61, NEW.reca_id, :FEC, :FEC, :CONCEPTO, (NEW.rccr_abono+NEW.rccr_dtof), NEW.rccr_rtfte, NEW.rccr_rtiva, NEW.rccr_rtica, 'N', 'S', :PREFIJO, :NUMERO);
    END
END
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON RECIBOS_CAJA_CRUCEC TO TRIGGER RECIBOS_CAJA_CRUCEC_AI;
GRANT SELECT ON RECIBOS_CAJA TO TRIGGER RECIBOS_CAJA_CRUCEC_AI;
GRANT EXECUTE ON PROCEDURE SALDO_DOC_CXPAGAR TO TRIGGER RECIBOS_CAJA_CRUCEC_AI;
GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO TRIGGER RECIBOS_CAJA_CRUCEC_AI;
GRANT SELECT,INSERT,UPDATE ON SALDOS_DOC_CXPAGAR TO TRIGGER RECIBOS_CAJA_CRUCEC_AI;
GRANT SELECT,INSERT,UPDATE ON MOVIMIENTO_PROVEEDOR TO TRIGGER RECIBOS_CAJA_CRUCEC_AI;

SET TERM ^ ;

create trigger RECIBOS_CAJA_CRUCEC_AU for RECIBOS_CAJA_CRUCEC
active AFTER UPDATE position 0
as
declare variable EXISTE CHAR(1);
declare variable FEC DATE;
declare variable NIT VARCHAR(20);
declare variable CONCEPTO VARCHAR(60);
declare variable PREFIJO VARCHAR(4);
declare variable NUMERO VARCHAR(6);
declare variable RETES CHAR(2);
declare variable SALDO NUMERIC(18,2);
BEGIN
select PREF_PRE, RECA_NUMERO, RECA_FECHA, RECA_CONC, TERC_NIT from RECIBOS_CAJA
    where reca_id = new.reca_id into :PREFIJO, :NUMERO, :FEC, :CONCEPTO, :NIT;
if ((OLD.reca_id <> 0) and (old.rccr_anulado = 'N')) then
    BEGIN
    EXISTE = 'N';
    select 'S' from saldos_doc_cxpagar where sdcp_tiporef = old.rccr_tipodoc and
        sdcp_idref = old.rccr_iddoc and sdcp_fecha = :FEC into :EXISTE;
    if (Existe = 'S') then
        UPDATE saldos_doc_cxpagar
            SET SDCP_ABONO = SDCP_ABONO - (old.rccr_abono + OLD.rccr_dtof),
            SDCP_ABRTFTE = SDCP_ABRTFTE - old.rccr_rtfte,
            SDCP_ABRTIVA = SDCP_ABRTIVA - old.rccr_rtiva,
            SDCP_ABRTICA = SDCP_ABRTICA - old.rccr_rtica
            WHERE SDCP_TIPOREF = OLD.rccr_tipodoc AND SDCP_IDREF = OLD.rccr_iddoc AND SDCP_FECHA = :FEC;
    EXISTE = 'N';
    SELECT 'S' FROM MOVIMIENTO_PROVEEDOR WHERE MVPR_TIPOREF = 61 AND MVPR_IDREF = OLD.reca_id INTO :EXISTE;
    if (EXISTE = 'S') then
        UPDATE movimiento_proveedor
            SET MVPR_MONTO = MVPR_MONTO - (OLD.rccr_abono + OLD.rccr_dtof),
            MVPR_RTFTE = MVPR_RTFTE - OLD.rccr_rtfte,
            MVPR_RTIVA = MVPR_RTIVA - OLD.rccr_rtiva,
            MVPR_RTICA = MVPR_RTICA - OLD.rccr_rtica
            WHERE MVPR_TIPOREF = 61 AND MVPR_IDREF = OLD.reca_id;
    END
if ((NEW.reca_id <> 0) and (NEW.rccr_anulado = 'N')) then
    BEGIN
    /* valide que no se pase del saldo */
    execute procedure saldo_doc_cxpagar(new.rccr_tipodoc, new.rccr_iddoc, '9999/12/31') returning_values(saldo);
    execute procedure lee_configuracion('CXPAGAR', 'SALDOS', 'DESCONTAR RETENCIONES POR CAUSACION') returning_values (RETES);
    if (SALDO < 0) then
        BEGIN
        if (RETES = 'SI') then
            begin
            if (saldo > NEW.rccr_abono) then
                EXCEPTION DOCUMENTO_ABONO_MAYOR;
            end
        ELSE
            begin
            if (saldo > (NEW.rccr_abono + NEW.rccr_rtfte + NEW.rccr_rtiva + NEW.rccr_rtica + new.rccr_dtof)) then
                EXCEPTION DOCUMENTO_ABONO_MAYOR;
            end
        END
    else
        BEGIN
        if (RETES = 'SI') then
            begin
            if (saldo < NEW.rccr_abono) then
                EXCEPTION DOCUMENTO_ABONO_MAYOR;
            end
        ELSE
            begin
            if (saldo < (NEW.rccr_abono + NEW.rccr_rtfte + NEW.rccr_rtiva + NEW.rccr_rtica + NEW.rccr_dtof)) then
                EXCEPTION DOCUMENTO_ABONO_MAYOR;
            end
        END
    /* AHORA REGISTRE LO NUEVO */
    EXISTE = 'N';
    select 'S' from saldos_doc_cxpagar where sdcp_tiporef = new.rccr_tipodoc and
        sdcp_idref = new.rccr_iddoc and sdcp_fecha = :FEC into :EXISTE;
    if (Existe = 'S') then
        UPDATE saldos_doc_cxpagar
            SET SDCP_ABONO = SDCP_ABONO + (NEW.rccr_abono + NEW.rccr_dtof),
            SDCP_ABRTFTE = SDCP_ABRTFTE + NEW.rccr_rtfte,
            SDCP_ABRTIVA = SDCP_ABRTIVA + NEW.rccr_rtiva,
            SDCP_ABRTICA = SDCP_ABRTICA + NEW.rccr_rtica
            WHERE SDCP_TIPOREF = NEW.rccr_tipodoc AND SDCP_IDREF = NEW.rccr_iddoc AND SDCP_FECHA = :FEC;
    else
        INSERT INTO SALDOS_DOC_CXPAGAR (SDCP_TIPOREF, SDCP_IDREF, SDCP_FECHA, TERC_NIT, SDCP_RTEFTE, SDCP_RTIVA, SDCP_RTICA, SDCP_ABONO, SDCP_ABRTFTE, SDCP_ABRTIVA, SDCP_ABRTICA, SDCP_DEBITO, SDCP_MONTO)
            VALUES (NEW.rccr_tipodoc, NEW.rccr_iddoc, :FEC, :NIT, 0, 0, 0, (NEW.rccr_abono + NEW.rccr_dtof), NEW.rccr_rtfte, NEW.rccr_rtiva, NEW.rccr_rtica, 'N', 0);
    /* Registre o actualice el registro en movimiento_proveedor */
    EXISTE = 'N';
    SELECT 'S' FROM MOVIMIENTO_PROVEEDOR WHERE MVPR_TIPOREF = 61 AND MVPR_IDREF = NEW.reca_id INTO :EXISTE;
    if (EXISTE = 'S') then
        /* Actualice el nuevo */
        UPDATE movimiento_proveedor
            SET MVPR_MONTO = MVPR_MONTO + (NEW.rccr_abono + NEW.rccr_dtof),
                MVPR_RTFTE = MVPR_RTFTE + NEW.rccr_rtfte,
                MVPR_RTIVA = MVPR_RTIVA + NEW.rccr_rtiva,
                MVPR_RTICA = MVPR_RTICA + NEW.rccr_rtica
            WHERE MVPR_TIPOREF = 61 AND MVPR_IDREF = NEW.reca_id;
    ELSE
        INSERT INTO MOVIMIENTO_PROVEEDOR (MVPR_ID, TERC_NIT, MVPR_TIPOREF, MVPR_IDREF, MVPR_FECHA, MVPR_VENCE, MVPR_CONC, MVPR_MONTO, MVPR_RTFTE, MVPR_RTIVA, MVPR_RTICA, MVPR_DEBITO, MVPR_ABONO, MVPR_PREFIJO, MVPR_NUMERO)
            VALUES (GEN_ID(ID_MOVPROV, 1), :NIT, 61, NEW.reca_id, :FEC, :FEC, :CONCEPTO, (NEW.rccr_abono + NEW.rccr_dtof), NEW.rccr_rtfte, NEW.rccr_rtiva, NEW.rccr_rtica, 'N', 'S', :PREFIJO, :NUMERO);
    end
END
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON RECIBOS_CAJA_CRUCEC TO TRIGGER RECIBOS_CAJA_CRUCEC_AU;
GRANT SELECT ON RECIBOS_CAJA TO TRIGGER RECIBOS_CAJA_CRUCEC_AU;
GRANT SELECT,INSERT,UPDATE ON SALDOS_DOC_CXPAGAR TO TRIGGER RECIBOS_CAJA_CRUCEC_AU;
GRANT SELECT,INSERT,UPDATE ON MOVIMIENTO_PROVEEDOR TO TRIGGER RECIBOS_CAJA_CRUCEC_AU;
GRANT EXECUTE ON PROCEDURE SALDO_DOC_CXPAGAR TO TRIGGER RECIBOS_CAJA_CRUCEC_AU;
GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO TRIGGER RECIBOS_CAJA_CRUCEC_AU;

SET TERM ^ ;

create trigger RECIBOS_CAJA_CRUCEC_AD for RECIBOS_CAJA_CRUCEC
active AFTER DELETE position 0
as
declare variable FEC DATE;
BEGIN
if (OLD.reca_id <> 0) then
    BEGIN
    SELECT RECA_FECHA FROM RECIBOS_CAJA WHERE RECA_ID = OLD.reca_id INTO :FEC;
    if (old.rccr_anulado = 'N') then
      begin
      UPDATE saldos_doc_cxpagar
        SET SDCP_ABONO = SDCP_ABONO - (old.rccr_abono+old.rccr_dtof),
        SDCP_ABRTFTE = SDCP_ABRTFTE - old.rccr_rtfte,
        SDCP_ABRTIVA = SDCP_ABRTIVA - old.rccr_rtiva,
        SDCP_ABRTICA = SDCP_ABRTICA - old.rccr_rtica
        WHERE SDCP_TIPOREF = OLD.rccr_tipodoc AND SDCP_IDREF = OLD.rccr_iddoc AND SDCP_FECHA = :FEC;
      /* Deshaga el viejo */
      UPDATE movimiento_proveedor
        SET MVPR_MONTO = MVPR_MONTO - (OLD.rccr_abono+old.rccr_dtof),
        MVPR_RTFTE = MVPR_RTFTE - OLD.rccr_rtfte,
        MVPR_RTIVA = MVPR_RTIVA - OLD.rccr_rtiva,
        MVPR_RTICA = MVPR_RTICA - OLD.rccr_rtica
        WHERE MVPR_TIPOREF = 61 AND MVPR_IDREF = OLD.reca_id;
      end
    END
END
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON RECIBOS_CAJA_CRUCEC TO TRIGGER RECIBOS_CAJA_CRUCEC_AD;
GRANT SELECT ON RECIBOS_CAJA TO TRIGGER RECIBOS_CAJA_CRUCEC_AD;
GRANT SELECT,UPDATE ON SALDOS_DOC_CXPAGAR TO TRIGGER RECIBOS_CAJA_CRUCEC_AD;
GRANT SELECT,UPDATE ON MOVIMIENTO_PROVEEDOR TO TRIGGER RECIBOS_CAJA_CRUCEC_AD;

/* 06-12 error al modificar el pago se perdia el registro de mov_caja */
SET TERM ^ ;

CREATE OR ALTER TRIGGER RECIBOS_CAJA_PAGO_AU FOR RECIBOS_CAJA_PAGO
ACTIVE AFTER UPDATE POSITION 0
as
declare variable Fec date;
declare variable Caja integer;
declare variable Conc VARCHAR(60);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Existe char(1);
declare variable TIPOCON INTEGER;
declare variable CONS CHAR(1);
declare variable CTABCO INTEGER;
declare variable PREFBCO VARCHAR(4);
declare variable TARJ VARCHAR(3);
declare variable IDCONS INTEGER;
declare variable COMIP NUMERIC(9,2);
declare variable RTFTEP NUMERIC(9,2);
declare variable RTIVAP NUMERIC(9,2);
declare variable RTICAP NUMERIC(9,2);
declare variable COMI NUMERIC(18,2);
declare variable RTFTE NUMERIC(18,2);
declare variable RTIVA NUMERIC(18,2);
declare variable RTICA NUMERIC(18,2);
BEGIN
select reca_fecha, caja_id, reca_conc, pref_pre, reca_numero
    from recibos_caja where reca_id = new.reca_id
    into :Fec, :Caja, :Conc, :Pref, :Num;
if ((OLD.reca_id <> 0) AND (OLD.rcpa_anulado = 'N')) then
    begin
    /* anule la consignacin */
    existe = 'N';
    select 'S', cofa_tipodes, cofa_iddes from consolidado_faltantes
        where cofa_tipoori = 61 and cofa_idori = old.reca_id and cofa_itemori = old.rcpa_item
        into :existe, :tipocon, :idcons;
    if (existe = 'S') then
        begin
        if (:tipocon = 71) then
            BEGIN
            DELETE FROM CONSIGNA_DETALLE WHERE CONS_ID = :idcons;
            DELETE FROM CONSIGNA WHERE CONS_ID = :idcons;
            END
        if (:tipocon = 64) then
            BEGIN
            DELETE FROM consigna_tarjetas_det WHERE COTJ_ID = :idcons;
            DELETE FROM consigna_tarjetas WHERE COTJ_ID = :idcons;
            END
        end
    /* Actualice el total del movimiento caja */
    select 'S' from movimiento_caja where moca_tiporef = 61 and moca_idref = new.reca_id into :Existe;
    if (Existe = 'S') then
        update movimiento_caja
            set moca_debitos = moca_debitos - new.rcpa_monto
            where moca_tiporef = 61 and moca_idref = new.reca_id;
    /* BORRE EL DOCUMENTO EN CAJA */
    if (OLD.FOPA_ID <> 1) then
        DELETE FROM DOCUMENTOS_PAGO_CAJA WHERE DPCA_TIPOENT = 61 AND DPCA_IDENT = OLD.RECA_ID AND
            DPCA_BANCO = OLD.RCPA_BANCO AND DPCA_CUENTA = OLD.RCPA_CUENTA AND DPCA_NUMERO = OLD.RCPA_NUMERO;
    ELSE
        EXECUTE PROCEDURE SUME_SALDO_EFECTIVO (:CAJA, :FEC, OLD.RCPA_MONTO, 'S');
    end
if ((new.reca_id <> 0) AND (new.rcpa_anulado = 'N')) then
    begin
    existe = 'N';
    select 'S' from movimiento_caja where moca_tiporef = 61 and moca_idref = new.reca_id into :Existe;
    if (Existe = 'S') then
        update movimiento_caja
            set moca_debitos = moca_debitos + new.rcpa_monto
            where moca_tiporef = 61 and moca_idref = new.reca_id;
    else
        INSERT INTO MOVIMIENTO_CAJA
            (MOCA_ID, CAJA_ID, MOCA_TIPOREF, MOCA_PREFREF, MOCA_NUMREF, MOCA_FECHA, MOCA_CONC, MOCA_DEBITOS, MOCA_CREDITOS, MOCA_DB, MOCA_IDREF)
            VALUES(GEN_ID(id_movcaja,1), :Caja, 61, :Pref, :Num, :Fec, :Conc, NEW.rcpa_monto, 0, 'S', new.reca_id);
                
    /* GRABE EL DOCUMENTO DE PAGO EN CAJA */
    if (NEW.FOPA_ID <> 1) then
        INSERT INTO DOCUMENTOS_PAGO_CAJA (DPCA_ID, FOPA_ID, CAJA_ID, DPCA_BANCO, DPCA_CUENTA, DPCA_NUMERO, DPCA_FECHA, DPCA_MONTO, DPCA_TIPOENT, DPCA_IDENT, DPCA_TIPOSAL, DPCA_IDSAL)
            VALUES (GEN_ID(ID_DOCPAGOCAJA, 1), NEW.FOPA_ID, :CAJA, NEW.RCPA_BANCO, NEW.RCPA_CUENTA, NEW.RCPA_NUMERO, NEW.RCPA_FECHA, NEW.RCPA_MONTO, 61, NEW.RECA_ID, 0, 0);
    ELSE
        EXECUTE PROCEDURE SUME_SALDO_EFECTIVO (:CAJA, :FEC, NEW.RCPA_MONTO, 'N');

    /* SI ES DE CONSIGNACION LA FORMA GRABELA */
    SELECT FOPA_CONSIGNA, FOPA_CTABCO, FOPA_PREFBCO, FOPA_TARJETA FROM FORMAS_PAGO
        WHERE FOPA_ID = NEW.fopa_id INTO :CONS, :CTABCO, :PREFBCO, :TARJ;
    if (CONS = 'S') then
        begin
        if ((TARJ IS NULL) OR (TARJ = '')) then
            BEGIN
            if ((CTABCO <> 0) AND (PREFBCO <> '')) then
                BEGIN
                /* CONSIGNACION */
                IDCONS = GEN_ID(ID_CONSIGNA, 1);
                INSERT INTO CONSIGNA (CONS_ID, CUBA_COD, PRBA_PREF, CONS_NUMERO, CONS_FECHA, CONS_CONCEPTO, CONS_ANULADO, CONS_TRANSMIT, NUMOK)
                    VALUES (:idcons, :ctabco, :prefbco, SUBSTR(NEW.rcpa_numero, 1, 6), :fec, :conc, 'N', 'N', 'N');
                INSERT INTO CONSIGNA_DETALLE (CONS_ID, CODE_ITEM2, FOPA_ID, CODE_BANCO, CODE_CUENTA, CODE_NUMERO, CODE_FECHA, CODE_MONTO, CODE_ANULADO, CODE_TRANSMIT, CAJA_ID)
                    VALUES (:idcons, 1, new.fopa_id, NEW.rcpa_banco, NEW.rcpa_cuenta, NEW.rcpa_numero, NEW.rcpa_fecha, NEW.rcpa_monto, 'N', 'N', :caja);

                insert into consolidado_faltantes (cofa_id, cofa_item, cofa_tipoori, cofa_tipodes, cofa_iddes, cofa_idori, cofa_itemori, cofa_ok, cofa_lista, cofa_unidad)
                    values (gen_id(id_cons, 1), 1, 61, 71, :idcons, new.reca_id, new.rcpa_item, 'N', :ctabco, :prefbco);
                END
            END
        else
            BEGIN
            /* CONSIGNACION DE TARJETA */
            if ((ctabco <> 0) AND (PREFBCO <> '')) then
                BEGIN
            select TARJ_COMIPORC, TARJ_RTFTEPORC, TARJ_RTIVAPORC, TARJ_RTICAPORC FROM TARJETAS WHERE TARJ_COD = :tarj
                INTO :comip, :rtftep, :rtivap, :rticap;
                COMI = (NEW.rcpa_monto-NEW.rcpa_ivamonto) * :comip / 100;
                EXECUTE PROCEDURE REDONDEE (COMI,0) returning_values (COMI);
                RTFTE = (NEW.rcpa_monto-NEW.rcpa_ivamonto) * :rtftep / 100;
                EXECUTE PROCEDURE REDONDEE (RTFTE,0) returning_values (RTFTE);
                RTIVA = NEW.rcpa_ivamonto * :rtivap / 100;
                EXECUTE PROCEDURE REDONDEE (RTIVA,0) returning_values (RTIVA);
                RTICA = (NEW.rcpa_monto-NEW.rcpa_ivamonto) * :rticap / 1000;
                EXECUTE PROCEDURE REDONDEE (RTICA,0) returning_values (RTICA);
                IDCONS = GEN_ID(ID_CONSIGNATAR, 1);
                INSERT INTO CONSIGNA_TARJETAS (COTJ_ID, PREF_PRE, COTJ_NUMERO, COTJ_FECHA, COTJ_CONCEPTO, COTJ_CHEQUE, CUBA_COD,
                    COTJ_MONTO, COTJ_RTFTE, COTJ_COMISION, COTJ_RTIVA, COTJ_RTICA, COTJ_ANULADO, COTJ_TRANSMIT, NUMOK, CAJA_ID)
                    VALUES (:idcons, :prefbco, SUBSTR(NEW.rcpa_numero, 1, 6), :fec, :conc, 'N', :ctabco,
                    new.rcpa_monto-:COMI-:RTFTE-:RTIVA-:RTICA, :rtfte,  :COMI, :rtiva, :rtica, 'N', 'N', 'N', :caja);
                INSERT INTO CONSIGNA_TARJETAS_DET (COTJ_ID, CTJD_ITEM, TARJ_COD, CTJD_NROTJ, CTJD_COMPROB, CTJD_BASE, CTJD_IVA, CTJD_COMIPORC, CTJD_COMIIVA, CTJD_COMIMONTO,
                    CTJD_RTFTEPORC, CTJD_RTFTEMONTO, CTJD_RTIVAPOC, CTJD_RTIVAMONTO, CTJD_ANULADO, CTJD_TRANSMIT, FOPA_ID, CTJD_RTICAPORC, CTJD_RTCAMONTO)
                    VALUES (:idcons, 1, NEW.rcpa_banco, NEW.rcpa_cuenta, NEW.rcpa_numero, new.rcpa_monto, NEW.rcpa_ivamonto, :COMIP, 'N', :comi,
                    :rtftep, :rtfte, :rtivap, :rtiva, 'N', 'N', new.fopa_id, :rticap, :rtica);
                insert into consolidado_faltantes (cofa_id, cofa_item, cofa_tipoori, cofa_tipodes, cofa_iddes, cofa_idori, cofa_itemori, cofa_ok, cofa_lista, cofa_unidad)
                    values (gen_id(id_cons, 1), 1, 61, 64, :idcons, new.reca_id, new.rcpa_item, 'N', :ctabco, :prefbco);
                END
            END
        end /* consignacion */
    end
END
^

SET TERM ; ^



/* 06-13 compras de contado */

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('COMPRAS', 'FACTURAS', 'PREFIJO DEL EGRESO PARA COMPRAS DE CONTADO', '0000', '', 'Indique el prefijo del egrso de caja que se usar para cancelar las compras de contado');

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('COMPRAS', 'FACTURAS', 'NUMERO DE EGRESO IGUAL AL DE FACTURA PARA COMPRAS DE CONTADO', 'NO', 'SI,NO', 'SI: El nmero del egreso ser idntico al de la factura sin importar la numeracin actual de egresos (el prefijo de egresos no puede ser automtico). NO:El nmero de egreso se controla por el consecutivo');
commit work;

/* 06-14 activos fijos */
CREATE TABLE ACTIVOS_FIJOS (
    ACFJ_COD T_COD_ARTICULO NOT NULL,
    ACFJ_DESC T_CONCEPTO,
    ACFJ_FECING DATE,
    ACFJ_FECGAR DATE,
    ACFJ_MODELO T_CONCEPTO,
    ACFJ_MARCA T_CONCEPTO,
    ACFJ_MESDEP SMALLINT,
    ACFJ_DEP T_BOOLEANO,
    ACFJ_ACTIVO T_BOOLEANO);
alter table ACTIVOS_FIJOS
add constraint PK_ACTIVOS_FIJOS
primary key (ACFJ_COD);

ALTER TABLE ACTIVOS_FIJOS
ADD ACFJ_OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80;

/* dev.ventas sobre factura con remision parcial no debe afectar inv. si la dev es para justificar que solo se entrego lo remisionado */ 
SET TERM ^ ;

CREATE OR ALTER TRIGGER DEVOLUCIONES_VENTAS_DETALLE_AI FOR DEVOLUCIONES_VENTAS_DETALLE
ACTIVE AFTER INSERT POSITION 0
AS
declare variable fec date;
declare variable CONC VARCHAR(60);
declare variable factor numeric(18,4);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Nit varchar(20);
declare variable ID INTEGER;
declare variable ITEM INTEGER;
declare variable DEVUELTO NUMERIC(18,4);
declare variable CANT NUMERIC(18, 4);
declare variable CANTAUX NUMERIC(18, 4);
declare variable CNTFAC NUMERIC(18, 4);
declare variable FACT VARCHAR(10);
declare variable COSTO NUMERIC(18,2);
declare variable devnof CHAR(2);
declare variable numrows INTEGER;
declare variable OK CHAR(1);
declare variable PEDAUTO CHAR(2);
declare variable IDPED INTEGER;
declare variable IDREM INTEGER;
declare variable devrem CHAR(2);
BEGIN
execute procedure lee_configuracion ('FACTURACION', 'DEVOLUCIONES', 'HACER DEVOLUCIONES SOBRE REMISIONES') returning_values (:devrem);
if ((NEW.devt_id <> 0) and (new.dvde_anulado = 'N')) then
    BEGIN
    ID = 0;
    select devt_fecha, pref_pre, devt_numero, terc_nit, devt_factura, devt_remid, DEVT_FACTID 
        from devoluciones_ventas where devt_id = new.devt_id into :fec, :Pref, :Num, :Nit, :Fact, :idrem, :ID;
    execute procedure factor_unidad_cant(new.arti_cod, new.dvde_unidad) returning_values(factor);
    CONC = 'DEVOLUCION VENTA No.' || PREF || NUM || ' - FACTURA ' || FACT;
    /* si la factura afecto el inventario, afectelo */
    execute procedure lee_configuracion ('FACTURACION', 'DEVOLUCIONES', 'PERMITIR DEVOLVER ITEMS NO FACTURADOS') returning_values (:devnof);
    if (devnof = 'SI') then
        OK = 'S';
    else
        BEGIN
        if (id <> 0) then
            begin
            SELECT SUM(FADE_CANT * FADE_FACTOR) FROM FACTURAS_DETALLE WHERE FACT_ID = :ID AND ARTI_COD = NEW.arti_cod INTO :cntfac;
            /* verifique si afecto el inventario */
            select count(mvar_cons) from movimiento_articulo where mvar_tipodoc = 31 and mvar_idref = :id and arti_cod = new.arti_cod into :numrows;
            if (numrows > 0) then
                OK = 'S';
            else
                BEGIN
                /* busque remisiones que pudieron afectarlo */
                /* primero posteriores a la factura */
                select sum(cofa_cant * cofa_factor) from consolidado_faltantes where cofa_tipoori = 31 and cofa_idori = :id and cofa_tipodes = 32 and arti_cod = new.arti_cod and cofa_ok = 'S' into :cantaux;
                if ((cantaux <> 0) and (cantaux is not null)) then
                    BEGIN
                    if ((CNTFAC - (NEW.dvde_cant * NEW.dvde_factor)) <> CANTAUX) then
                        OK = 'S';
                    ELSE
                        OK = 'N';
                    END
                else
                    begin
                    /* si no, anteriores a la factura */
                    select sum(cofa_cant * cofa_factor) from consolidado_faltantes where cofa_tipoori = 32 and cofa_iddes = :id and cofa_tipodes = 31 and arti_cod = new.arti_cod and cofa_ok = 'S' into :cantaux;
                    if (cantaux <> 0) then
                        OK = 'S';
                    else
                        BEGIN
                        /* si hacen pedido automatico, puede que la remisin este hecha con el pedido */
                        EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','FACTURAS','GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') RETURNING_VALUES (PEDAUTO);
                        if (PEDAUTO = 'SI') then
                            BEGIN
                            SELECT PEDI_ID FROM PEDIDOS P, FACTURAS F WHERE P.PREF_PRE = F.pref_pre AND P.pedi_numero = F.fact_numero AND F.fact_id = :id INTO :IDped;
                            select sum(cofa_cant * cofa_factor) from consolidado_faltantes where cofa_tipoori = 34 and cofa_idori = :idped and cofa_tipodes = 32 and arti_cod = new.arti_cod and cofa_ok = 'S' into :cantaux;
                            if (cantaux <> 0) then
                                OK = 'S';
                            else
                                OK = 'N';
                            END
                        ELSE
                            OK = 'N';
                        END
                    end
                END
            end
        else
          if ((idrem <> 0) and (devrem = 'SI')) then
            begin
            /* verifique si afecto el inventario */
            select count(mvar_cons) from movimiento_articulo where mvar_tipodoc = 32 and mvar_idref = :idrem and arti_cod = new.arti_cod into :numrows;
            if (numrows > 0) then
                OK = 'S';
            else
                OK = 'N';
            end
        END
    if (OK = 'S') then
        begin
        /* calcule el costo al que salio o el promedio */
        execute procedure costo_promedio(new.arti_cod, :FEC) returning_values (:COSTO);
        INSERT INTO MOVIMIENTO_ARTICULO
            (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF,
            MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
            VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 33, NEW.devt_id,
            :CONC, :factor * new.dvde_cant, :COSTO, 'S', new.dvde_lote, :Pref, :Num, new.dvde_item, :Nit);
        end
    /* ACTUALICE LO DEVUELTO EN LA FACTURA */
    if (ID <> 0) then
        BEGIN
        CANTAUX = NEW.dvde_cant * NEW.dvde_factor;
        FOR SELECT FADE_ITEM, FADE_CANT, FADE_FACTOR, FADE_DEVUELTO
            FROM FACTURAS_DETALLE
            WHERE FACT_ID = :ID AND ARTI_COD = NEW.ARTI_COD
            INTO :ITEM, :CANT, :FACTOR, :DEVUELTO
            DO
                BEGIN
                if (CANTAUX > 0) then
                    if ((CANT * FACTOR - DEVUELTO) < CANTAUX) then
                      BEGIN
                      UPDATE FACTURAS_DETALLE
                        SET FADE_DEVUELTO = (:CANT * :FACTOR)
                        WHERE FACT_ID = :ID AND FADE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                      CANTAUX = CANTAUX - (CANT * FACTOR - DEVUELTO);
                      END
                    ELSE
                      BEGIN
                      UPDATE FACTURAS_DETALLE
                        SET FADE_DEVUELTO = FADE_DEVUELTO + :CANTAUX
                        WHERE FACT_ID = :ID AND FADE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                      CANTAUX = 0;
                      END
                END
        if (CANTAUX > 0) then
            EXCEPTION DEVOLUCION_MAYOR 'Esta devolviendo una cantidad mayor a la facturada del articulo ' || new.arti_cod;
        END
    if ((idrem <> 0) and (devrem = 'SI')) then
        BEGIN
        CANTAUX = NEW.dvde_cant * NEW.dvde_factor;
        FOR SELECT RVDE_ITEM, RVDE_CANT, RVDE_FACTOR, RVDE_DEVUELTO
            FROM remisiones_venta_detalle
            WHERE REVT_ID = :idrem AND ARTI_COD = NEW.ARTI_COD
            INTO :ITEM, :CANT, :FACTOR, :DEVUELTO
            DO
                BEGIN
                if (CANTAUX > 0) then
                    if ((CANT * FACTOR - DEVUELTO) < CANTAUX) then
                      BEGIN
                      UPDATE remisiones_venta_detalle
                        SET RVDE_DEVUELTO = (:CANT * :FACTOR)
                        WHERE REVT_ID = :IDREM AND RVDE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                      CANTAUX = CANTAUX - (CANT * FACTOR - DEVUELTO);
                      END
                    ELSE
                      BEGIN
                      UPDATE remisiones_venta_detalle
                        SET RVDE_DEVUELTO = RVDE_DEVUELTO + :CANTAUX
                        WHERE REVT_ID = :IDREM AND RVDE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                      CANTAUX = 0;
                      END
                END
        if (CANTAUX > 0) then
            EXCEPTION DEVOLUCION_MAYOR 'Esta devolviendo una cantidad mayor a la remisionada del articulo ' || new.arti_cod;
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER TRIGGER DEVOLUCIONES_VENTAS_DETALLE_AU FOR DEVOLUCIONES_VENTAS_DETALLE
ACTIVE AFTER UPDATE POSITION 0
AS
declare variable fec date;
declare variable CONC VARCHAR(60);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Nit varchar(20);
declare variable CANT NUMERIC(18, 4);
declare variable CANTAUX NUMERIC(18,4);
declare variable CNTFAC NUMERIC(18, 4);
declare variable COSTO NUMERIC(18,2);
declare variable factor numeric(18,4);
declare variable DEVUELTO NUMERIC(18,4);
declare variable ID integer;
declare variable ITEM INTEGER;
declare variable FACT varchar(10);
declare variable devnof CHAR(2);
declare variable numrows INTEGER;
declare variable OK CHAR(1);
declare variable PEDAUTO CHAR(2);
declare variable IDPED INTEGER;
declare variable IDREM INTEGER;
declare variable devrem CHAR(2);
BEGIN
execute procedure lee_configuracion ('FACTURACION', 'DEVOLUCIONES', 'HACER DEVOLUCIONES SOBRE REMISIONES') returning_values (:devrem);
/* Anule el anterior */
if ((OLD.DEVT_ID <> 0) AND (OLD.dvde_anulado = 'N')) then
    BEGIN
    DELETE FROM MOVIMIENTO_ARTICULO WHERE (mvar_tipodoc = 33) and (mvar_idref = new.devt_id) and (mvar_item = old.dvde_item);
    /* DESHAGA LO DEVUELTO EN LA FACTURA */
    ID = 0;
    SELECT DEVT_FACTID FROM DEVOLUCIONES_VENTAS
        WHERE DEVT_ID = OLD.DEVT_ID INTO :ID;
    if (ID <> 0) then
        BEGIN
        CANTAUX = OLD.dvde_cant * OLD.dvde_factor;
        FOR SELECT FADE_CANT, FADE_FACTOR, FADE_DEVUELTO, FADE_ITEM
            FROM FACTURAS_DETALLE
            WHERE FACT_ID = :ID AND ARTI_COD = OLD.ARTI_COD
            INTO :CANT, :FACTOR, :DEVUELTO, :ITEM
            DO
            BEGIN
            if (CANTAUX > (CANT * FACTOR - DEVUELTO)) then
                BEGIN
                UPDATE FACTURAS_DETALLE
                    SET FADE_DEVUELTO = 0
                    WHERE FACT_ID = :ID AND ARTI_COD = OLD.ARTI_COD AND FADE_ITEM = :ITEM;
                CANTAUX = CANTAUX - (CANT * FACTOR - DEVUELTO);
                END
            ELSE
                BEGIN
                UPDATE FACTURAS_DETALLE
                    SET FADE_DEVUELTO = FADE_DEVUELTO - :CANTAUX
                    WHERE FACT_ID = :ID AND ARTI_COD = OLD.ARTI_COD AND FADE_ITEM = :ITEM;
                CANTAUX = 0;
                END
            END
        END
    if (devrem = 'SI') then
        begin
        idrem = 0;
        SELECT DEVT_REMID FROM DEVOLUCIONES_VENTAS
            WHERE DEVT_ID = OLD.DEVT_ID INTO :idrem;
        if (idrem <> 0) then
            BEGIN
            CANTAUX = OLD.dvde_cant * OLD.dvde_factor;
            FOR SELECT RVDE_CANT, RVDE_FACTOR, RVDE_DEVUELTO, RVDE_ITEM
                FROM remisiones_venta_detalle
                WHERE REVT_ID = :idrem AND ARTI_COD = OLD.ARTI_COD
                INTO :CANT, :FACTOR, :DEVUELTO, :ITEM
                DO
                BEGIN
                if (CANTAUX > (CANT * FACTOR - DEVUELTO)) then
                    BEGIN
                    UPDATE remisiones_venta_detalle
                        SET RVDE_DEVUELTO = 0
                        WHERE REVT_ID = :idrem AND ARTI_COD = OLD.ARTI_COD AND RVDE_ITEM = :ITEM;
                    CANTAUX = CANTAUX - (CANT * FACTOR - DEVUELTO);
                    END
                ELSE
                    BEGIN
                    UPDATE remisiones_venta_detalle
                        SET RVDE_DEVUELTO = RVDE_DEVUELTO - :CANTAUX
                        WHERE REVT_ID = :idrem AND ARTI_COD = OLD.ARTI_COD AND RVDE_ITEM = :ITEM;
                    CANTAUX = 0;
                    END
                END
            END
        end
    END
/* Registre el nuevo */
if ((NEW.DEVT_ID <> 0) AND (NEW.dvde_anulado = 'N')) then
    begin
    ID = 0;
    select devt_fecha, pref_pre, devt_numero, terc_nit, devt_factura, devt_remid, DEVT_FACTID 
        from devoluciones_ventas where devt_id = new.devt_id into :fec, :Pref, :Num, :Nit, :Fact, :idrem, :ID;
    execute procedure factor_unidad_cant(new.arti_cod, new.dvde_unidad) returning_values(factor);
    CONC = 'DEVOLUCION VENTA No.' || PREF || NUM || '- FACTURA ' || FACT;
    execute procedure lee_configuracion ('FACTURACION', 'DEVOLUCIONES', 'PERMITIR DEVOLVER ITEMS NO FACTURADOS') returning_values (:devnof);
    if (devnof = 'SI') then
        OK = 'S';
    else
        if (id <> 0) then
            begin
            SELECT SUM(FADE_CANT * FADE_FACTOR) FROM FACTURAS_DETALLE WHERE FACT_ID = :ID AND ARTI_COD = NEW.arti_cod INTO :cntfac;
            /* verifique si afecto el inventario */
            select count(mvar_cons) from movimiento_articulo where mvar_tipodoc = 31 and mvar_idref = :id and arti_cod = new.arti_cod into :numrows;
            if (numrows > 0) then
                OK = 'S';
            else
                BEGIN
                /* busque remisiones que pudieron afectarlo */
                /* primero posteriores a la factura */
                select sum(cofa_cant * cofa_factor) from consolidado_faltantes where cofa_tipoori = 31 and cofa_idori = :id and cofa_tipodes = 32 and arti_cod = new.arti_cod and cofa_ok = 'S' into :cantaux;
                if ((cantaux <> 0) and (cantaux is not null)) then
                    BEGIN
                    if ((CNTFAC - (NEW.dvde_cant * NEW.dvde_factor)) <> CANTAUX) then
                        OK = 'S';
                    ELSE
                        OK = 'N';
                    END
                else
                    begin
                    /* si no, anteriores a la factura */
                    select sum(cofa_cant * cofa_factor) from consolidado_faltantes where cofa_tipoori = 32 and cofa_iddes = :id and cofa_tipodes = 31 and arti_cod = new.arti_cod and cofa_ok = 'S' into :cantaux;
                    if (cantaux <> 0) then
                        OK = 'S';
                    else
                        BEGIN
                        /* si hacen pedido automatico, puede que la remisin este hecha con el pedido */
                        EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','FACTURAS','GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') RETURNING_VALUES (PEDAUTO);
                        if (PEDAUTO = 'SI') then
                            BEGIN
                            SELECT PEDI_ID FROM PEDIDOS P, FACTURAS F WHERE P.PREF_PRE = F.pref_pre AND P.pedi_numero = F.fact_numero AND F.fact_id = :id INTO :IDped;
                            select sum(cofa_cant * cofa_factor) from consolidado_faltantes where cofa_tipoori = 34 and cofa_idori = :idped and cofa_tipodes = 32 and arti_cod = new.arti_cod and cofa_ok = 'S' into :cantaux;
                            if (cantaux <> 0) then
                                OK = 'S';
                            else
                                OK = 'N';
                            END
                        ELSE
                            OK = 'N';
                        END
                    end
                END
            end
        else
          if ((idrem <> 0) and (devrem = 'SI')) then
            begin
            /* verifique si afecto el inventario */
            select count(mvar_cons) from movimiento_articulo where mvar_tipodoc = 32 and mvar_idref = :idrem and arti_cod = new.arti_cod into :numrows;
            if (numrows > 0) then
                OK = 'S';
            else
                OK = 'N';
            end
    if (OK = 'S') then
        begin
        /* calcule el costo al que salio o el promedio */
        execute procedure costo_promedio(new.arti_cod, :FEC) returning_values (:COSTO);
        INSERT INTO MOVIMIENTO_ARTICULO
            (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF,
            MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
            VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 33, NEW.devt_id,
            :CONC, :factor * new.dvde_cant, :COSTO, 'S', new.dvde_lote, :Pref, :Num, NEW.dvde_item, :Nit);
        end
    /* ACTUALICE LO DEVUELTO EN LA FACTURA */
    if (ID <> 0) then
        BEGIN
        CANTAUX = NEW.dvde_cant * NEW.dvde_factor;
        FOR SELECT FADE_ITEM, FADE_CANT, FADE_FACTOR, FADE_DEVUELTO
            FROM FACTURAS_DETALLE
            WHERE FACT_ID = :ID AND ARTI_COD = NEW.ARTI_COD
            INTO :ITEM, :CANT, :FACTOR, :DEVUELTO
            DO
            BEGIN
            if (CANTAUX > 0) then
                if ((CANT * FACTOR - DEVUELTO) < CANTAUX) then
                    BEGIN
                    UPDATE FACTURAS_DETALLE
                        SET FADE_DEVUELTO = (:CANT * :FACTOR - :DEVUELTO)
                        WHERE FACT_ID = :ID AND FADE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                    CANTAUX = CANTAUX - (CANT * FACTOR - DEVUELTO);
                    END
                ELSE
                    BEGIN
                    UPDATE FACTURAS_DETALLE
                        SET FADE_DEVUELTO = FADE_DEVUELTO + :CANTAUX
                        WHERE FACT_ID = :ID AND FADE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                    CANTAUX = 0;
                    END
            END
        if (CANTAUX > 0) then
            EXCEPTION DEVOLUCION_MAYOR 'Esta devolviendo una cantidad mayor a la facturada del articulo ' || new.arti_cod;
        END
    if ((idrem <> 0) and (devrem = 'SI')) then
        BEGIN
        CANTAUX = NEW.dvde_cant * NEW.dvde_factor;
        FOR SELECT RVDE_ITEM, RVDE_CANT, RVDE_FACTOR, RVDE_DEVUELTO
            FROM remisiones_venta_detalle
            WHERE REVT_ID = :idrem AND ARTI_COD = NEW.ARTI_COD
            INTO :ITEM, :CANT, :FACTOR, :DEVUELTO
            DO
                BEGIN
                if (CANTAUX > 0) then
                    if ((CANT * FACTOR - DEVUELTO) < CANTAUX) then
                      BEGIN
                      UPDATE remisiones_venta_detalle
                        SET RVDE_DEVUELTO = (:CANT * :FACTOR - :DEVUELTO)
                        WHERE REVT_ID = :ID AND RVDE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                      CANTAUX = CANTAUX - (CANT * FACTOR - DEVUELTO);
                      END
                    ELSE
                      BEGIN
                      UPDATE remisiones_venta_detalle
                        SET RVDE_DEVUELTO = RVDE_DEVUELTO + :CANTAUX
                        WHERE REVT_ID = :ID AND RVDE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                      CANTAUX = 0;
                      END
                END
        if (CANTAUX > 0) then
            EXCEPTION DEVOLUCION_MAYOR 'Esta devolviendo una cantidad mayor a la remisionada del articulo ' || new.arti_cod;
        END
    END
END
^

SET TERM ; ^


/* 06-16 compras anuales por proveedor */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE COMPRAS_PROVEEDOR_ANO (
    NITDESDE VARCHAR(20),
    NITHASTA VARCHAR(20),
    FECHA DATE,
    ORDEN CHAR(1),
    MASIVA CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    NIT VARCHAR(20),
    MES INTEGER,
    TOTAL NUMERIC(18,2))
AS
DECLARE VARIABLE NITINI VARCHAR(15);
DECLARE VARIABLE NITFIN VARCHAR(15);
DECLARE VARIABLE NOMINI VARCHAR(15);
DECLARE VARIABLE NOMFIN VARCHAR(15);
declare variable FECINI DATE;
DECLARE VARIABLE DTO NUMERIC(18,2);
DECLARE VARIABLE ADICIONAL NUMERIC(18,2);
DECLARE VARIABLE IVA NUMERIC(18,2);
DECLARE VARIABLE EXTRA NUMERIC(18,2);
declare variable DEV NUMERIC(18, 2);
BEGIN
if (ORDEN = 'C') then
    BEGIN
    NITINI = NITDESDE;
    NITFIN = NITHASTA;
    NOMINI = '';
    NOMFIN = 'zz';
    END
ELSE
    BEGIN
    NITINI = NITDESDE;
    NITFIN = NITHASTA;
    NOMINI = '';
    NOMFIN = 'zz';
    END

FECINI = fecha - 365;
FOR SELECT MAX(T.TERC_NIT), MAX(EXTRACT(MONTH FROM FACO_FECHA)),
    SUM(FACO_IVAMONTO), SUM(FACO_TOTAL)
    FROM FACTURAS_COMPRA F, PREFIJOS P, terceros T
    where T.TERC_PROV = 'S' AND T.TERC_NIT >= :NITINI AND T.TERC_NIT <= :NITFIN AND TERC_NOM >= :NOMINI AND TERC_NOM <= :NOMFIN
    AND F.TERC_NIT = T.terc_nit AND FACO_FECHA >= :FECINI AND FACO_FECHA <= :FECHA AND FACO_ANULADO = 'N'
    AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 21 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    GROUP BY F.terc_nit, EXTRACT(MONTH FROM FACO_FECHA)
    INTO :NIT, :MES, :IVA, :TOTAL
    DO
    BEGIN
    if (TOTAL IS NULL) then
        TOTAL = 0;
    if (IVA IS NULL) then
        IVA = 0;
    if (MASIVA <> 'S') then
        TOTAL = TOTAL - IVA;
    SELECT SUM(DVCO_IVAMONTO), SUM(DVCO_TOTAL)
        FROM DEVOLUCIONES_COMPRAS V, PREFIJOS P
        where V.TERC_NIT = :nit AND DVCO_FECHA >= :FECINI AND DVCO_FECHA <= :FECHA AND DVCO_ANULADO = 'N'
        AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 24 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        AND EXTRACT(MONTH FROM DVCO_FECHA) = :MES
        INTO :IVA, :DEV;
    if (DEV IS NULL) then
        DEV = 0;
    if (IVA IS NULL) then
        IVA = 0;
    if (MASIVA <> 'S') then
        DEV = DEV - IVA;
    TOTAL = TOTAL - DEV;
    if (TOTAL <> 0) then
        SUSPEND;
    END
/* AGREGUE LOS TERCEROS SIN COMPRAS */
FOR SELECT MAX(T.TERC_NIT), MAX(EXTRACT(MONTH FROM DVCO_FECHA)),
    SUM(DVCO_DTOMONTO), SUM(DVCO_ADICIONAL), SUM(DVCO_IVAMONTO), SUM(DVCO_EXTRA), SUM(DVCO_TOTAL)
    FROM terceros T, DEVOLUCIONES_COMPRAS V, PREFIJOS P
    where T.TERC_CLIE = 'S' AND T.TERC_NIT >= :NITINI AND T.TERC_NIT <= :NITFIN AND TERC_NOM >= :NOMINI AND TERC_NOM <= :NOMFIN
        AND V.TERC_NIT = T.terc_nit AND DVCO_FECHA >= :FECINI AND DVCO_FECHA <= :FECHA AND DVCO_ANULADO = 'N'
        AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 24 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        AND NOT EXISTS (select FACO_ID FROM FACTURAS_COMPRA F, PREFIJOS PR WHERE TERC_NIT = T.terc_nit AND EXTRACT(MONTH FROM FACO_FECHA) = EXTRACT(MONTH FROM DVCO_FECHA) AND FACO_ANULADO = 'N'
        AND PR.PREF_PRE = F.PREF_PRE AND PR.TIDO_COD = 21 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)))
    GROUP BY V.terc_nit, EXTRACT(MONTH FROM DVCO_FECHA)
    INTO :NIT, :MES, :DTO, :ADICIONAL, :IVA, :EXTRA, :DEV
    DO
    BEGIN
    TOTAL = 0;
    if (DTO IS NULL) then
        DTO = 0;
    if (ADICIONAL IS NULL) then
        ADICIONAL = 0;
    if (IVA IS NULL) then
        IVA = 0;
    if (EXTRA IS NULL) then
        EXTRA = 0;
    if (MASIVA <> 'S') then
        DEV = DEV - EXTRA - IVA - ADICIONAL + DTO;
    TOTAL = TOTAL - DEV;
    if (TOTAL <> 0) then
        SUSPEND;
    END
END
^

CREATE OR ALTER PROCEDURE REP_COMPRAS_PROVEEDOR_ANO (
    NITDESDE VARCHAR(20),
    NITHASTA VARCHAR(20),
    FECHA DATE,
    ORDEN CHAR(1),
    MASIVA CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    CODGRP VARCHAR(2),
    NOMGRP VARCHAR(60),
    TOTAL1 NUMERIC(18,2),
    TOTAL2 NUMERIC(18,2),
    TOTAL3 NUMERIC(18,2),
    TOTAL4 NUMERIC(18,2),
    TOTAL5 NUMERIC(18,2),
    TOTAL6 NUMERIC(18,2),
    TOTAL7 NUMERIC(18,2),
    TOTAL8 NUMERIC(18,2),
    TOTAL9 NUMERIC(18,2),
    TOTAL10 NUMERIC(18,2),
    TOTAL11 NUMERIC(18,2),
    TOTAL12 NUMERIC(18,2))
AS
declare variable NITN VARCHAR(20);
declare variable TOTAL NUMERIC(18,2);
declare variable MES INTEGER;
BEGIN
NIT = '';
FOR SELECT NIT, MES, TOTAL
    FROM COMPRAS_PROVEEDOR_ANO (:nitdesde, :nithasta, :fecha, :orden, :masiva, :subempresa)
    ORDER BY NIT, MES
    INTO :NITN, :MES, :TOTAL
    DO
    BEGIN
    if (NIT = '') then
        BEGIN
        NIT = NITN;
        TOTAL1 = 0;
        TOTAL2 = 0;
        TOTAL3 = 0;
        TOTAL4 = 0;
        TOTAL5 = 0;
        TOTAL6 = 0;
        TOTAL7 = 0;
        TOTAL8 = 0;
        TOTAL9 = 0;
        TOTAL10 = 0;
        TOTAL11 = 0;
        TOTAL12 = 0;
        END
    if (NIT <> NITN) then
        BEGIN
        SELECT TERC_NOM, P.GRPR_COD, GRPR_NOM FROM TERCEROS T, PROVEEDORES P, grupos_proveedores G
         WHERE T.TERC_NIT = :nit AND T.terc_nit = P.terc_nit AND G.grpr_cod = P.grpr_cod
         INTO :NOMBRE, :CODGRP, :NOMGRP;
        SUSPEND;
        NIT = NITN;
        TOTAL1 = 0;
        TOTAL2 = 0;
        TOTAL3 = 0;
        TOTAL4 = 0;
        TOTAL5 = 0;
        TOTAL6 = 0;
        TOTAL7 = 0;
        TOTAL8 = 0;
        TOTAL9 = 0;
        TOTAL10 = 0;
        TOTAL11 = 0;
        TOTAL12 = 0;
        END
    IF (MES = 1) THEN TOTAL1 = TOTAL;
    IF (MES = 2) THEN TOTAL2 = TOTAL;
    IF (MES = 3) THEN TOTAL3 = TOTAL;
    IF (MES = 4) THEN TOTAL4 = TOTAL;
    IF (MES = 5) THEN TOTAL5 = TOTAL;
    IF (MES = 6) THEN TOTAL6 = TOTAL;
    IF (MES = 7) THEN TOTAL7 = TOTAL;
    IF (MES = 8) THEN TOTAL8 = TOTAL;
    IF (MES = 9) THEN TOTAL9 = TOTAL;
    IF (MES = 10) THEN TOTAL10 = TOTAL;
    IF (MES = 11) THEN TOTAL11 = TOTAL;
    IF (MES = 12) THEN TOTAL12 = TOTAL;
    END
NIT = NITN;
SELECT TERC_NOM FROM TERCEROS WHERE TERC_NIT = :nitn INTO :NOMBRE;
SUSPEND;
END
^


SET TERM ; ^

GRANT EXECUTE ON PROCEDURE REP_COMPRAS_PROVEEDOR_ANO TO PUBLIC;

/* no muestre el articulo con '.' */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE CONSULTA_ARTICULOS_VTAS(
    FECHA DATE,
    INACTIVOS CHAR(1),
    MODULO VARCHAR(20))
RETURNS (
    CODIGO VARCHAR(20),
    DES VARCHAR(60),
    GRUPO VARCHAR(30),
    MARCA VARCHAR(30),
    UNIDAD VARCHAR(8),
    ESTADO VARCHAR(30),
    IVA NUMERIC(9,2),
    EXISTEN NUMERIC(18,4),
    PRECIO NUMERIC(18,2),
    CLASE CHAR(1))
AS
DECLARE VARIABLE LISTA INTEGER;
DECLARE VARIABLE EXIST CHAR(2);
DECLARE VARIABLE SINEXIST CHAR(2);
declare variable DIG INTEGER;
BEGIN
EXISTEN = 0;
EXECUTE PROCEDURE lee_configuracion ('FACTURACION','ARTICULOS', 'VER EXISTENCIA EN CONSULTA ARTICULOS') returning_values (:EXIST);
EXECUTE PROCEDURE lee_configuracion ('FACTURACION','FACTURAS', 'CODIGO DE LA LISTA DE PRECIOS A MOSTRAR EN ARTICULOS') returning_values (:LISTA);
if (modulo = 'FACTURACION') then
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','ARTICULOS','VER ARTICULOS SIN EXISTENCIA EN CONSULTA DE ARTICULOS') returning_values (:sinexist);
else
  sinexist = 'SI';
EXECUTE PROCEDURE LEE_CONFIGURACION ('FACTURACION', 'ARTICULOS', 'REDONDEO AL MULTIPLO DE DIEZ EN PRECIOS') returning_values (DIG);
if (LISTA > 0) then
    BEGIN
    FOR select a.arti_cod, arti_des, grup_cod, arti_unidad, esar_cod, taiv_porc, marc_cod,arti_clase
        from articulo a, tarifa_iva t
        where a.taiv_cod = t.taiv_cod and a.arti_cod <> '.'
        INTO :CODIGO, :DES, :GRUPO, :UNIDAD, :ESTADO, :IVA, :MARCA, :CLASE
        do
          if ((INACTIVOS = 'S') or (ESTADO = 'A') or ((INACTIVOS = 'C') AND (ESTADO = 'N')) ) then
            begin
            PRECIO = 0;
            SELECT prar_fijo PRECIO FROM precios_articulo WHERE arti_cod = :CODIGO and lipr_cod = :LISTA INTO :PRECIO;
            EXECUTE PROCEDURE redondee(PRECIO, DIG) returning_values (PRECIO);
            if (EXIST = 'SI') then
                BEGIN
                EXECUTE PROCEDURE saldo_total_inventario (:CODIGO, :FECHA) returning_values (:EXISTEN);
                if ((SINEXIST = 'SI')  or (existen <> 0)) then
                    SUSPEND;
                END
            ELSE
                SUSPEND;
            end
    END
ELSE
    FOR select arti_cod, arti_des, grup_cod, arti_unidad, esar_cod, taiv_porc, arti_precio, marc_cod, arti_clase
        from articulo a, tarifa_iva t
        where a.taiv_cod = t.taiv_cod
        INTO :CODIGO, :DES, :GRUPO, :UNIDAD, :ESTADO, :IVA, :PRECIO, :MARCA, :CLASE
        do
          if ((INACTIVOS = 'S') or (ESTADO = 'A') or ((INACTIVOS = 'C') AND (ESTADO = 'N')) ) then
            begin
            if (EXIST = 'SI') then
                BEGIN
                EXECUTE PROCEDURE saldo_total_inventario (:CODIGO, :FECHA) returning_values (:EXISTEN);
                  if ((SINEXIST = 'SI') or (existen <> 0)) then
                    SUSPEND;
                END
            ELSE
                SUSPEND;
            end
END
^

SET TERM ; ^


/* rep. iva compras con tarifas separadas */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE IMPUESTOS_COMPRAS(
    FECINI DATE,
    FECFIN DATE,
    PREFIJO VARCHAR(4),
    ANULADOS CHAR(1))
RETURNS (
    TIPO INTEGER,
    NOMTIPO VARCHAR(30),
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    NIT VARCHAR(20),
    NUMPROV VARCHAR(10),
    NOMTERCERO VARCHAR(60),
    SUBTOTAL NUMERIC(18,2),
    DTOMONTO NUMERIC(18,2),
    ADICIONAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    EXENTOS NUMERIC(18,2),
    IVA1 NUMERIC(18,2),
    IVA2 NUMERIC(18,2),
    IVA3 NUMERIC(18,2),
    GRAVADOS1 NUMERIC(18,2),
    GRAVADOS2 NUMERIC(18,2),
    GRAVADOS3 NUMERIC(18,2),
    EXTRA NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    RTFTEMONTO NUMERIC(18,2),
    RTIVAMONTO NUMERIC(18,2),
    RTICAMONTO NUMERIC(18,2),
    NETO NUMERIC(18,2),
    ANULADO CHAR(1))
AS
declare variable ID INTEGER;
declare variable TER_exento CHAR(1);
declare variable NOTAS CHAR(2);
BEGIN
/* FACTURA */
TIPO = 21;
SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 21 INTO :NOMTIPO;

FOR SELECT FACO_ID, PREF_PRE, FACO_NUMERO, FACO_FECHA, TERC_NIT, FACO_ADICIONAL-FACO_DTOMONTO, FACO_IVAMONTO, FACO_RTFTEMONTO, FACO_RTIVAMONTO, FACO_RTICAMONTO, FACO_EXTRA, FACO_TOTAL, FACO_ANULADO, FACO_NUMPROV
    FROM FACTURAS_COMPRA
    WHERE FACO_FECHA >= :FECINI AND FACO_FECHA <= :FECFIN ORDER BY FACO_FECHA, PREF_PRE, FACO_NUMERO
    INTO :ID, :PREF, :NUMERO, :FECHA, :NIT, :DTOMONTO, :IVAMONTO, :RTFTEMONTO, :RTIVAMONTO, :RTICAMONTO, :EXTRA, :TOTAL, :ANULADO, :numprov
    DO
    BEGIN
    SELECT TERC_NOM, TERC_EXENTO FROM TERCEROS WHERE TERC_NIT = :NIT INTO :NOMTERCERO, :TER_EXENTO;
    if ((PREFIJO = '') or (PREFIJO IS NULL) or (PREF = PREFIJO)) then
        if ((ANULADOS = 'S') or (ANULADO = 'N')) then
            BEGIN
            if (ANULADO = 'S') then
              BEGIN
              EXENTOS = 0;
              GRAVADOS1 = 0;
              GRAVADOS2 = 0;
              GRAVADOS3 = 0;
              IVA1 = 0;
              IVA2 = 0;
              IVA3 = 0;
              SUBTOTAL = 0;
              TOTAL = 0;
              EXTRA = 0;
              IVAMONTO = 0;
              DTOMONTO = 0;
              NETO = 0;
              RTFTEMONTO = 0;
              RTIVAMONTO = 0;
              RTICAMONTO = 0;
              END
            ELSE
              BEGIN
              SELECT SUM(FCDE_TOTAL - FCDE_IVAMONTO - FCDE_CONSUMO) FROM FACTURAS_COMPRAS_DETALLE D WHERE FACO_ID = :ID AND FCDE_IVAPORC = 0 INTO :EXENTOS;
              SELECT SUM(FCDE_TOTAL - FCDE_IVAMONTO - FCDE_CONSUMO), SUM(FCDE_IVAMONTO) FROM FACTURAS_COMPRAS_DETALLE D, TARIFA_IVA T WHERE FACO_ID = :ID AND FCDE_IVAPORC = TAIV_PORC AND TAIV_COD = 1 INTO :GRAVADOS1, :IVA1;
              SELECT SUM(FCDE_TOTAL - FCDE_IVAMONTO - FCDE_CONSUMO), SUM(FCDE_IVAMONTO) FROM FACTURAS_COMPRAS_DETALLE D, TARIFA_IVA T WHERE FACO_ID = :ID AND FCDE_IVAPORC = TAIV_PORC AND TAIV_COD = 2 INTO :GRAVADOS2, :IVA2;
              SELECT SUM(FCDE_TOTAL - FCDE_IVAMONTO - FCDE_CONSUMO), SUM(FCDE_IVAMONTO) FROM FACTURAS_COMPRAS_DETALLE D, TARIFA_IVA T WHERE FACO_ID = :ID AND FCDE_IVAPORC = TAIV_PORC AND TAIV_COD = 3 INTO :GRAVADOS3, :IVA3;

              SELECT SUM(FCDE_CONSUMO) FROM FACTURAS_COMPRAS_DETALLE WHERE FACO_ID = :ID INTO :CONSUMO;
              SUBTOTAL = TOTAL - EXTRA - IVAMONTO - DTOMONTO;
              NETO = TOTAL - RTFTEMONTO - RTIVAMONTO - RTICAMONTO;
              END
            SUSPEND;
            END
    END
    
TIPO = 24;
SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 24 INTO :NOMTIPO;
/* DEVOLUCIONES */
FOR SELECT DVCO_ID, PREF_PRE, DVCO_NUMERO, DVCO_FECHA, TERC_NIT, DVCO_ADICIONAL-DVCO_DTOMONTO, DVCO_IVAMONTO, DVCO_RTFTEMONTO, DVCO_RTIVAMONTO, DVCO_RTICAMONTO, DVCO_EXTRA, DVCO_TOTAL, DVCO_ANULADO, ''
    FROM DEVOLUCIONES_COMPRAS
    WHERE DVCO_FECHA >= :FECINI AND DVCO_FECHA <= :FECFIN ORDER BY DVCO_FECHA, PREF_PRE, DVCO_NUMERO
    INTO :ID, :PREF, :NUMERO, :FECHA, :NIT, :DTOMONTO, :IVAMONTO, :RTFTEMONTO, :RTIVAMONTO, :RTICAMONTO, :EXTRA, :TOTAL, :ANULADO, :numprov
    DO
    BEGIN
    if ((PREFIJO = '') or (PREFIJO IS NULL) or (PREF = PREFIJO)) then
        if ((ANULADOS = 'S') or (ANULADO = 'N')) then
            BEGIN
            SELECT TERC_NOM, TERC_EXENTO FROM TERCEROS WHERE TERC_NIT = :NIT INTO :NOMTERCERO, :TER_EXENTO;
            If (ANULADO = 'S') then
             BEGIN
              EXENTOS = 0;
              GRAVADOS1 = 0;
              GRAVADOS2 = 0;
              GRAVADOS3 = 0;
              IVA1 = 0;
              IVA2 = 0;
              IVA3 = 0;
              SUBTOTAL = 0;
              TOTAL = 0;
              EXTRA = 0;
              IVAMONTO = 0;
              DTOMONTO = 0;
              NETO = 0;
              RTFTEMONTO = 0;
              RTIVAMONTO = 0;
              RTICAMONTO = 0;
             END
            ELSE
             BEGIN
              DTOMONTO = DTOMONTO * -1;
              ADICIONAL = ADICIONAL * -1;
              IVAMONTO = IVAMONTO * -1;
              EXTRA = EXTRA * -1;
              TOTAL = TOTAL * -1;
              RTFTEMONTO = RTFTEMONTO * -1;
              RTIVAMONTO = RTIVAMONTO * -1;
              RTICAMONTO = RTICAMONTO * -1;
              /* CALCULE LAS DIFERENTES TARIFAS */
               SELECT SUM(DVCD_TOTAL - DVCD_IVAMONTO - DVCD_CONSUMO) FROM DEVOLUCIONES_COMPRAS_DET D WHERE DVCO_ID = :ID AND DVCD_IVAPORC = 0 INTO :EXENTOS;
               SELECT SUM(DVCD_TOTAL - DVCD_IVAMONTO - DVCD_CONSUMO), SUM(DVCD_IVAMONTO) FROM DEVOLUCIONES_COMPRAS_DET D, TARIFA_IVA T WHERE DVCO_ID = :ID AND DVCD_IVAPORC = TAIV_PORC AND TAIV_COD = 1 INTO :GRAVADOS1, :IVA1;
               SELECT SUM(DVCD_TOTAL - DVCD_IVAMONTO - DVCD_CONSUMO), SUM(DVCD_IVAMONTO) FROM DEVOLUCIONES_COMPRAS_DET D, TARIFA_IVA T WHERE DVCO_ID = :ID AND DVCD_IVAPORC = TAIV_PORC AND TAIV_COD = 2 INTO :GRAVADOS2, :IVA2;
               SELECT SUM(DVCD_TOTAL - DVCD_IVAMONTO - DVCD_CONSUMO), SUM(DVCD_IVAMONTO) FROM DEVOLUCIONES_COMPRAS_DET D, TARIFA_IVA T WHERE DVCO_ID = :ID AND DVCD_IVAPORC = TAIV_PORC AND TAIV_COD = 3 INTO :GRAVADOS3, :IVA3;

              SELECT SUM(DVCD_CONSUMO) FROM DEVOLUCIONES_COMPRAS_DET WHERE DVCO_ID = :ID INTO :CONSUMO;
              if (EXENTOS is NULL) then
                EXENTOS = 0;
              ELSE
                EXENTOS = EXENTOS * -1;
              if (GRAVADOS1 is NULL) then
                GRAVADOS1 = 0;
              ELSE
                GRAVADOS1 = GRAVADOS1 * -1;
              if (GRAVADOS2 is NULL) then
                GRAVADOS2 = 0;
              ELSE
                GRAVADOS2 = GRAVADOS2 * -1;
              if (GRAVADOS3 is NULL) then
                GRAVADOS3 = 0;
              ELSE
                GRAVADOS3 = GRAVADOS3 * -1;
              SUBTOTAL = TOTAL - EXTRA - IVAMONTO - DTOMONTO;
              NETO = TOTAL - RTFTEMONTO - RTIVAMONTO - RTICAMONTO;
             END
            SUSPEND;
            END
    END

execute procedure lee_configuracion ('COMPRAS', 'DOCUMENTOS', 'INCLUIR NOTAS DE CXPAGAR EN REPORTE DE IMPUESTOS EN COMPRAS') returning_values (:NOTAS);
if (NOTAS = 'SI') then
    BEGIN
     TIPO = 52;
     SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 52 INTO :NOMTIPO;
     FOR SELECT NCPR_ID, PREF_PRE, NCPR_NUMERO, NCPR_FECHA, TERC_NIT, 0, NCPR_IVAMONTO, NCPR_RTFTEMONTO, NCPR_RTIVAMONTO, NCPR_RTICAMONTO, 0, NCPR_MONTO + NCPR_IVAMONTO, NCPR_ANULADO, ''
       FROM NOTAS_CREDITO_PROVEEDOR
       WHERE NCPR_FECHA >= :FECINI AND NCPR_FECHA <= :FECFIN ORDER BY NCPR_FECHA, PREF_PRE, NCPR_NUMERO
       INTO :ID, :PREF, :NUMERO, :FECHA, :NIT, :DTOMONTO, :IVAMONTO, :RTFTEMONTO, :RTIVAMONTO, :RTICAMONTO, :EXTRA, :TOTAL, :ANULADO, :numprov
       DO
       BEGIN
       SELECT TERC_NOM, TERC_EXENTO FROM TERCEROS WHERE TERC_NIT = :NIT INTO :NOMTERCERO, :TER_EXENTO;
        if ((PREFIJO = '') or (PREFIJO IS NULL) or (PREF = PREFIJO)) then
         BEGIN
          If (ANULADO = 'S') then
           BEGIN
            EXENTOS = 0;
            GRAVADOS1 = 0;
            GRAVADOS2 = 0;
            GRAVADOS3 = 0;
            IVA1 = 0;
            IVA2 = 0;
            IVA3 = 0;
            SUBTOTAL = 0;
            TOTAL = 0;
            EXTRA = 0;
            IVAMONTO = 0;
            DTOMONTO = 0;
            NETO = 0;
            RTFTEMONTO = 0;
            RTIVAMONTO = 0;
            RTICAMONTO = 0;
           END
          ELSE
           BEGIN
            GRAVADOS2 = 0;
            GRAVADOS3 = 0;
            CONSUMO = 0;
            if (IVAMONTO <> 0) then
                BEGIN
                GRAVADOS1 = TOTAL-IVAMONTO;
                IVA1 = IVAMONTO;
                exentos = 0;
                END
            ELSE
                BEGIN
                GRAVADOS1 = 0;
                exentos = TOTAL;
                END
            SUBTOTAL = TOTAL - EXTRA - IVAMONTO - DTOMONTO;
            NETO = TOTAL - RTFTEMONTO - RTIVAMONTO - RTICAMONTO;
           END
         suspend;
         END
       END

     TIPO = 51;
     SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 51 INTO :NOMTIPO;
     FOR SELECT NDPR_ID, PREF_PRE, NDPR_NUMERO, NDPR_FECHA, TERC_NIT, 0, NDPR_IVAMONTO, NDPR_RTFTEMONTO, NDPR_RTIVAMONTO, NDPR_RTICAMONTO, 0, NDPR_MONTO + NDPR_IVAMONTO, NDPR_ANULADO, NDPR_NUMPROV 
       FROM NOTAS_DEBITO_PROVEEDOR
       WHERE NDPR_FECHA >= :FECINI AND NDPR_FECHA <= :FECFIN ORDER BY NDPR_FECHA, PREF_PRE, NDPR_NUMERO
       INTO :ID, :PREF, :NUMERO, :FECHA, :NIT, :DTOMONTO, :IVAMONTO, :RTFTEMONTO, :RTIVAMONTO, :RTICAMONTO, :EXTRA, :TOTAL, :ANULADO, :numprov
       DO
       BEGIN
       SELECT TERC_NOM, TERC_EXENTO FROM TERCEROS WHERE TERC_NIT = :NIT INTO :NOMTERCERO, :TER_EXENTO;
        if ((PREFIJO = '') or (PREFIJO IS NULL) or (PREF = PREFIJO)) then
         BEGIN

          GRAVADOS2 = 0;
          GRAVADOS3 = 0;
          CONSUMO = 0;
          If (ANULADO = 'S') then
           BEGIN
            EXENTOS = 0;
            GRAVADOS1 = 0;
            GRAVADOS2 = 0;
            GRAVADOS3 = 0;
            IVA1 = 0;
            IVA2 = 0;
            IVA3 = 0;
            SUBTOTAL = 0;
            TOTAL = 0;
            EXTRA = 0;
            IVAMONTO = 0;
            DTOMONTO = 0;
            NETO = 0;
            RTFTEMONTO = 0;
            RTIVAMONTO = 0;
            RTICAMONTO = 0;
           END
          ELSE
           BEGIN
            DTOMONTO = DTOMONTO * -1;
            ADICIONAL = ADICIONAL * -1;
            IVAMONTO = IVAMONTO * -1;
            EXTRA = EXTRA * -1;
            TOTAL = TOTAL * -1;
            RTFTEMONTO = RTFTEMONTO * -1;
            RTIVAMONTO = RTIVAMONTO * -1;
            RTICAMONTO = RTICAMONTO * -1;
            if (IVAMONTO <> 0) then
                BEGIN
                GRAVADOS1 = TOTAL-IVAMONTO;
                IVA1 = IVAMONTO;
                exentos = 0;
                END
            ELSE
                BEGIN
                GRAVADOS1 = 0;
                exentos = TOTAL;
                END
            SUBTOTAL = TOTAL - EXTRA - IVAMONTO - DTOMONTO;
            NETO = TOTAL - RTFTEMONTO - RTIVAMONTO - RTICAMONTO;
           END
         suspend;
         END
       END
    END
END
^

SET TERM ; ^



/* 06-16 egresos caja no repone el doc. al anula rpor error en tipo_docsal */
SET TERM ^ ;

CREATE OR ALTER TRIGGER EGRESOS_CAJA_AI FOR EGRESOS_CAJA
ACTIVE AFTER INSERT POSITION 0
AS
declare variable Fec DATE;
declare variable Conc VARCHAR(60);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Existe integer;
declare variable VALFP char(2);
BEGIN
if ((NEW.egre_id <> 0) and (new.egca_anulado = 'N')) then
  BEGIN
  EXECUTE PROCEDURE LEE_CONFIGURACION('BANCOS','CONSIGNACIONES','VALIDAR FORMAS DE PAGO EN CAJA') RETURNING_VALUES (VALFP);
  select pref_pre, egre_numero, egre_fecha, egre_conc
    from egresos where egre_id = new.egre_id
    into :pref, :num, :fec, :conc;
  /* Actualice el movimiento en caja */
  select count(moca_id) from movimiento_caja where moca_tiporef = 62 and moca_idref = new.egre_id and caja_id = new.caja_id into :Existe;
  if (Existe > 0) then
    update movimiento_caja
        set moca_creditos = moca_creditos + new.egca_monto
        where moca_tiporef = 62 and moca_idref = new.egre_id and caja_id = new.caja_id;
  else
    INSERT INTO MOVIMIENTO_CAJA
        (MOCA_ID, CAJA_ID, MOCA_TIPOREF, MOCA_PREFREF, MOCA_NUMREF, MOCA_FECHA, MOCA_CONC, MOCA_DEBITOS, MOCA_CREDITOS, MOCA_DB, MOCA_IDREF)
        VALUES(GEN_ID(ID_MOVCAJA,1), NEW.caja_id, 62, :Pref, :Num, :Fec, :Conc, 0, NEW.egca_monto, 'N', new.egre_id);
        
  /* ACTUALICE LA SALIDA DEL DOCUMENTO */
  if (NEW.FOPA_ID <> 1) then
      BEGIN
      SELECT count(dpca_id) FROM DOCUMENTOS_PAGO_CAJA WHERE FOPA_ID = NEW.FOPA_ID AND DPCA_BANCO = NEW.EGCA_BANCO AND
        DPCA_CUENTA = NEW.EGCA_CUENTA AND DPCA_NUMERO = NEW.EGCA_NUMERO AND DPCA_TIPOSAL = 0 AND DPCA_IDSAL = 0 INTO :EXISTE;
      if (EXISTE > 0) then
          UPDATE DOCUMENTOS_PAGO_CAJA
            SET DPCA_TIPOSAL = 62, DPCA_IDSAL = NEW.EGRE_ID
            WHERE FOPA_ID = NEW.FOPA_ID AND DPCA_BANCO = NEW.EGCA_BANCO AND DPCA_CUENTA = NEW.EGCA_CUENTA AND
            DPCA_NUMERO = NEW.EGCA_NUMERO AND DPCA_TIPOSAL = 0 AND DPCA_IDSAL = 0;
      ELSE
        IF (VALFP = 'SI') THEN
          EXCEPTION documento_pago_salido;
      END
  ELSE
      EXECUTE PROCEDURE RESTE_SALDO_EFECTIVO(NEW.CAJA_ID, :FEC, NEW.EGCA_MONTO, 'N');
  END
END
^

SET TERM ; ^


/* busqueda de artculos del proveedor con sugerido para ordenes */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE ORDEN_PROVEEDOR(
    NIT VARCHAR(20),
    FECHA DATE)
RETURNS (
    ARTICULO VARCHAR(20),
    DESCRIPCION VARCHAR(60),
    UNIDAD VARCHAR(8),
    BODEGA VARCHAR(2),
    EXISTENCIA NUMERIC(18,4),
    RESERVADO NUMERIC(18,4),
    ORDENADO NUMERIC(18,4),
    PROMEDIO NUMERIC(18,4),
    VENTAMES NUMERIC(18,4),
    FECHACMP DATE,
    DIAS INTEGER,
    SUGERIDO NUMERIC(18,4),
    STAND VARCHAR(15))
AS
declare variable FACTOR NUMERIC(15,4);
declare variable ORDENC NUMERIC(18,4);
declare variable PEDIDO NUMERIC(18,4);
declare variable ITEM INTEGER;
declare variable ID INTEGER;
declare variable UND VARCHAR(8);
declare variable CANT NUMERIC(18,4);
declare variable FACTOR2 NUMERIC(18,4);
declare variable fecini DATE;
declare variable FECHAAUX VARCHAR(10);
declare variable AGENCIA INTEGER;
declare variable DEVMES NUMERIC(18,2);
declare variable MFAC INTEGER;
declare variable MDEV INTEGER;
declare variable IVAF NUMERIC(18,2);
declare variable IVAD NUMERIC(18,2);
declare variable DIA_ART VARCHAR(2) CHARACTER SET NONE;
declare variable DIASC VARCHAR(255);
declare variable PEDAUTO CHAR(2);
declare variable SALIDAS NUMERIC(18,4);
BEGIN
FOR SELECT A.ARTI_COD, A.ARTI_DES, A.ARTI_UNIDAD FROM ARTICULO A, proveedor_articulo P
  WHERE A.arti_cod = P.arti_cod AND P.terc_nit = :NIT INTO :articulo, :descripcion, :unidad
  DO
  for select bode_cod, SUCU_ID from bodega into :bodega, :agencia
    do
    begin
    execute procedure saldo_inventario (:articulo, :bodega, :fecha) returning_values (:Existencia);
    EXECUTE PROCEDURE FACTOR_UNIDAD_CANT(:ARTICULO, :UNIDAD) returning_values (:FACTOR);
    if (FACTOR <> 0) then
        EXISTENCIA = EXISTENCIA / FACTOR;
    else
        EXISTENCIA = 0;
    SELECT MAX(EXIS_STAND) FROM EXISTENCIA WHERE ARTI_COD = :ARTICULO AND BODE_COD = :BODEGA INTO :STAND;
    EXECUTE PROCEDURE promedio_salidas_articulo (:ARTICULO, :FECHA, :BODEGA) returning_values (:PROMEDIO, :SALIDAS);
    EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'PROMEDIAR LAS SALIDAS DEL INVENTARIO CON EL NUMERO DE DIAS ASIGNADO A CADA ARTICULO') returning_values (:DIA_ART);
    if (DIA_ART = 'NO') then
        BEGIN
        EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'NUMERO DE DIAS PARA PROMEDIO DE SALIDAS POR ARTICULO') returning_values (DIASC);
        DIAS = CAST(DIASC AS INTEGER);
        END
    ELSE
        SELECT ARTI_DIAS FROM ARTICULO WHERE ARTI_COD = :ARTICULO INTO :DIAS;
    if (DIAS is null) then
        DIAS = 0;
    PROMEDIO = DIAS * PROMEDIO;
    if (FACTOR <> 0) then
        PROMEDIO = PROMEDIO / FACTOR;
    SUGERIDO = PROMEDIO - EXISTENCIA;
    SELECT SUM(ORID_ENTREGAR)
      FROM ORDENINVENTARIO_DETALLE OD, ordenes_inventario O
      WHERE O.ORIN_ID = OD.ORIN_ID AND ARTI_COD = :ARTICULO AND ORIN_FECHA <= :FECHA AND ORIN_FECLLEGA >= :FECHA AND ORID_ANULADO = 'N' AND OD.BODE_COD = :BODEGA
      INTO :ORDENADO;
    if (ORDENADO IS NULL) then
        ORDENADO = 0;
    ORDENC = 0;
    FOR SELECT O.ORDC_ID, OCDE_ITEM, OCDE_CANT * OCDE_FACTOR
        FROM ORDENES_COMPRA O, ORDENES_COMPRA_DETALLE OD
        WHERE O.ORDC_ID = OD.ORDC_ID AND OD.ARTI_COD = :ARTICULO AND (ORDC_FECHA+ORDC_VALIDEZ) >= :FECHA AND ORDC_FECHA <= :FECHA AND OCDE_ANULADO = 'N' AND OD.BODE_COD = :BODEGA
        INTO :ID, :ITEM, :CANT
        do
        BEGIN
        EXECUTE PROCEDURE FALTANTE(23, 21, ID, ITEM) returning_values (PEDIDO, UND, FACTOR2);
        if (PEDIDO * FACTOR2 = CANT) then /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */
            EXECUTE PROCEDURE FALTANTE(23, 22, ID, ITEM) returning_values (PEDIDO, UND, FACTOR2);
        if (PEDIDO IS NULL) then
            PEDIDO = 0;
        ORDENC = ORDENC + PEDIDO * FACTOR2;
        END
    ORDENADO = ORDENADO + ORDENC;
    if (FACTOR <> 0) then
        ORDENADO = ORDENADO / FACTOR;
    SELECT SUM(RSDE_LIBERAR)
      FROM RESERVAS_DETALLE RD, RESERVAS R
      WHERE R.RESE_ID = RD.RESE_ID AND ARTI_COD = :ARTICULO AND RESE_FECHA <= :FECHA AND RESE_VENCE >= :FECHA AND RD.BODE_COD = :BODEGA AND RSDE_ANULADO = 'N'
      INTO :RESERVADO;
    if (RESERVADO IS NULL) then
        RESERVADO = 0;
    PEDIDO = 0;
    FOR SELECT P.PEDI_ID, PEDE_ITEM, PEDE_CANT * PEDE_FACTOR
        FROM PEDIDOS P, PEDIDOS_DETALLE PD
        WHERE P.PEDI_ID = PD.PEDI_ID AND PD.ARTI_COD = :ARTICULO AND (PEDI_FECHA+PEDI_VALIDEZ) >= :FECHA AND PEDI_FECHA <= :FECHA AND PEDE_ANULADO = 'N' AND BODE_COD = :BODEGA
        INTO :ID, :ITEM, :CANT
        do
        BEGIN
        EXECUTE PROCEDURE FALTANTE(34, 31, ID, ITEM) returning_values (ORDENC, UND, FACTOR2);
        EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'FACTURAS', 'GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') returning_values (pedauto);
        if ((ORDENC * FACTOR2 = CANT) or (PEDAUTO = 'SI')) then /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */
            EXECUTE PROCEDURE FALTANTE(34, 32, ID, ITEM) returning_values (ORDENC, UND, FACTOR2);
        if (ORDENC IS NULL) then
            ORDENC = 0;
        PEDIDO = PEDIDO + ORDENC * FACTOR2;
        END
    RESERVADO = RESERVADO + PEDIDO;
    if (FACTOR <> 0) then
        RESERVADO = RESERVADO / FACTOR;
    /* VENTAS MES */
    FECHAAUX = CAST (FECHA AS VARCHAR(10));
    FECHAAUX = SUBSTR(FECHAAUX, 1, 7) || '/01';
    FECINI = CAST (FECHAAUX AS DATE);
    EXECUTE PROCEDURE ventas_articulo (:ARTICULO, :FECINI, :FECHA, :agencia) returning_values (:ventames, :mfac, :devmes, :mdev, :ivaf, :ivad);
    ventames = ventames - devmes;
    if (FACTOR <> 0) then
        ventames = ventames / FACTOR;
    /* FECHA COMPRA */
    SELECT MAX(FACO_FECHA) FROM FACTURAS_COMPRA F, FACTURAS_COMPRAS_DETALLE D
        WHERE F.FACO_ID = D.faco_id AND D.ARTI_COD = :articulo AND FACO_FECHA <= :FECHA AND D.bode_cod = :BODEGA
        INTO :fechacmp;
    SUSPEND;
    end
END
^

SET TERM ; ^



/* rotulos con cantidad y rango */ 
SET TERM ^ ;

CREATE OR ALTER PROCEDURE IMPR_ARTICULO(
    CODINI VARCHAR(20),
    CODFIN VARCHAR(20),
    CANT integer)
RETURNS (
    ARTICULO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    PRECIO NUMERIC(18,2),
    CODGRP VARCHAR(2),
    NOMGRP VARCHAR(30),
    COSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    PESO NUMERIC(18,4),
    PUM NUMERIC(18,2),
    LISTA INTEGER,
    NOMLISTA VARCHAR(30),
    FECHA DATE)
AS
declare variable I INTEGER;
begin
EXECUTE PROCEDURE lee_configuracion('FACTURACION', 'FACTURAS', 'CODIGO DE LA LISTA DE PRECIOS A MOSTRAR EN ARTICULOS') returning_values (LISTA);
for select a.arti_cod, arti_des, a.grup_cod, a.subg_cod, a.marc_cod, arti_peso, p.lipr_cod, p.prar_fijo, grup_nom, lipr_nom
    from articulo a, precios_articulo p, grupo g, lista_precios l
    where a.arti_cod = p.arti_cod and a.grup_cod = g.grup_cod and l.lipr_cod = p.lipr_cod AND a.arti_cod >= :codini AND a.arti_cod <= :codfin AND P.lipr_cod = :LISTA
    into :articulo, :descripcion, :codgrp, :cosubg, :codmarc, :peso, :lista, :precio, :nomgrp, :nomlista
    do
    begin
    if (cosubg <> '') then
        select subg_nom from subgrupo where grup_cod = :codgrp and subg_cod = :cosubg into :nomsubg;
    if (codmarc <> '') then
        select marc_nom from marcas where marc_cod = :codmarc into :nommarc;
    if ((PESO <> 0) AND (PESO IS NOT NULL)) then
        PUM = PRECIO / PESO;
    ELSE
        PUM = 0;
    SELECT MAX(AUDI_FECHA) FROM AUDITORIA WHERE TIDO_COD = 126 AND AUDI_COD = :articulo AND AUDI_OPER <> 'D' INTO :fecha;
    if (cant = 0) then
        execute procedure saldo_total_inventario(:articulo, cast('now' as DATE)) returning_values (CANT);
    I = 1;
    WHILE (I < CANT) DO
        BEGIN
        SUSPEND;
        I = I + 1;
        END
    end
end
^

SET TERM ; ^


/* CONCILIACION VENTAS CON IMPUESTOS INCLUIDOS NO RESTABA EL IVA */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE CONCILIA_VENTAS(
    FECINI DATE,
    FECFIN DATE,
    CTAEXE VARCHAR(20),
    CTAGRA VARCHAR(20),
    CTAOTRO VARCHAR(20))
RETURNS (
    IDF INTEGER,
    IDC INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    TARIFA0 NUMERIC(18,2),
    TARIFA0C NUMERIC(18,2),
    TARIFA1 NUMERIC(18,2),
    TARIFA1C NUMERIC(18,2),
    TARIFA2 NUMERIC(18,2),
    TARIFA2C NUMERIC(18,2))
AS
declare variable iva1 numeric(18,2);
declare variable iva2 numeric(18,2);
declare variable IVAINC CHAR(1);
begin
for select fact_id, pref_pre, fact_numero, enco_consec, FACT_IVAINC from facturas f, comprobante_encabezado c
    where fact_fecha >= :fecini and fact_fecha <= :fecfin and fact_id = enco_idref and enco_tiporef = 31
    into :idf, :pref, :numero, :idc, :IVAINC
    do
    begin
    tarifa0 = 0;
    tarifa1 = 0;
    tarifa2 = 0;
    tarifa0c = 0;
    tarifa1c = 0;
    tarifa2c = 0;
    select SUM(CAST(FADE_CANT AS DOUBLE PRECISION) * (FADE_PRUNIT-FADE_DTOMONTO))
        FROM FACTURAS_DETALLE WHERE FACT_ID = :idf and fade_ivaporc = 0 into :tarifa0;
    select SUM(CAST(FADE_CANT AS DOUBLE PRECISION) * (FADE_PRUNIT-FADE_DTOMONTO)), sum(FADE_IVAMONTO)
        FROM FACTURAS_DETALLE WHERE FACT_ID = :idf and fade_ivaporc = 16 into :tarifa1, :IVA1;
    select SUM(CAST(FADE_CANT AS DOUBLE PRECISION) * (FADE_PRUNIT-FADE_DTOMONTO)), sum(FADE_IVAMONTO)
        FROM FACTURAS_DETALLE WHERE FACT_ID = :idf and fade_ivaporc <> 16 and fade_ivaporc <> 0 into :tarifa2, :IVA2;
    if (IVAINC = 'S') then
        BEGIN
        if (IVA1 IS NULL) then
            IVA1 = 0;
        if (IVA2 IS NULL) then
            IVA2 = 0;
        TARIFA1 = TARIFA1 - IVA1;
        TARIFA2 = TARIFA2 - IVA2;
        END
    select code_debito - code_credito from comprobante_detalle where enco_consec = :idc and cuen_cod = :ctaexe into tarifa0c;
    select code_debito - code_credito from comprobante_detalle where enco_consec = :idc and cuen_cod = :ctagra into tarifa1c;
    select code_debito - code_credito from comprobante_detalle where enco_consec = :idc and cuen_cod = :ctaotro into tarifa2c;
    suspend;
    end
end
^

SET TERM ; ^


SET TERM ^ ;

CREATE OR ALTER PROCEDURE CONCILIA_DEVVENTAS(
    FECINI DATE,
    FECFIN DATE,
    CTAEXE VARCHAR(20),
    CTAGRA VARCHAR(20),
    CTAOTRO VARCHAR(20))
RETURNS (
    IDF INTEGER,
    IDC INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    TARIFA0 NUMERIC(18,2),
    TARIFA0C NUMERIC(18,2),
    TARIFA1 NUMERIC(18,2),
    TARIFA1C NUMERIC(18,2),
    TARIFA2 NUMERIC(18,2),
    TARIFA2C NUMERIC(18,2))
AS
declare variable iva1 numeric(18,2);
declare variable iva2 numeric(18,2);
declare variable IVAINC CHAR(1);
begin
for select devt_id, pref_pre, devt_numero, enco_consec, devt_ivainc from devoluciones_ventas f, comprobante_encabezado c
    where devt_fecha >= :fecini and devt_fecha <= :fecfin and devt_id = enco_idref and enco_tiporef = 33
    into :idf, :pref, :numero, :idc, :ivainc
    do
    begin
    tarifa0 = 0;
    tarifa1 = 0;
    tarifa2 = 0;
    tarifa0c = 0;
    tarifa1c = 0;
    tarifa2c = 0;
    select SUM(CAST(DVDE_CANT AS DOUBLE PRECISION) * (DVDE_PRUNIT-DVDE_DTOMONTO))
        FROM DEVOLUCIONES_VENTAS_DETALLE WHERE DEVT_ID = :idf and dvde_ivaporc = 0 into :tarifa0;
    select SUM(CAST(DVDE_CANT AS DOUBLE PRECISION) * (DVDE_PRUNIT-DVDE_DTOMONTO)), sum(DVDE_IVAMONTO)
        FROM DEVOLUCIONES_VENTAS_DETALLE WHERE DEVT_ID = :idf and dvde_ivaporc = 16 into :tarifa1, :iva1;
    select SUM(CAST(DVDE_CANT AS DOUBLE PRECISION) * (DVDE_PRUNIT-DVDE_DTOMONTO)), SUM(DVDE_IVAMONTO)
        FROM DEVOLUCIONES_VENTAS_DETALLE WHERE DEVT_ID = :idf and dvde_ivaporc <> 16 and dvde_ivaporc <> 0 into :tarifa2, :iva2;
    if (IVAINC = 'S') then
        BEGIN
        if (IVA1 IS NULL) then
            IVA1 = 0;
        if (IVA2 IS NULL) then
            IVA2 = 0;
        TARIFA1 = TARIFA1 - IVA1;
        TARIFA2 = TARIFA2 - IVA2;
        END
    select sum(code_debito - code_credito) from comprobante_detalle where enco_consec = :idc and cuen_cod = :ctaexe into tarifa0c;
    select sum(code_debito - code_credito) from comprobante_detalle where enco_consec = :idc and cuen_cod = :ctagra into tarifa1c;
    select sum(code_debito - code_credito) from comprobante_detalle where enco_consec = :idc and cuen_cod = :ctaotro into tarifa2c;
    suspend;
    end
end
^

SET TERM ; ^


/* 20080618 dev faltante en ventas con factura-remision */
SET TERM ^ ;

CREATE OR ALTER TRIGGER DEVOLUCIONES_VENTAS_DETALLE_AI FOR DEVOLUCIONES_VENTAS_DETALLE
ACTIVE AFTER INSERT POSITION 0
AS
declare variable fec date;
declare variable CONC VARCHAR(60);
declare variable factor numeric(18,4);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Nit varchar(20);
declare variable ID INTEGER;
declare variable ITEM INTEGER;
declare variable DEVUELTO NUMERIC(18,4);
declare variable CANT NUMERIC(18, 4);
declare variable CANTAUX NUMERIC(18, 4);
declare variable CNTFAC NUMERIC(18, 4);
declare variable FACT VARCHAR(10);
declare variable COSTO NUMERIC(18,2);
declare variable devnof CHAR(2);
declare variable numrows INTEGER;
declare variable OK CHAR(1);
declare variable PEDAUTO CHAR(2);
declare variable IDPED INTEGER;
declare variable IDREM INTEGER;
declare variable devrem CHAR(2);
BEGIN
execute procedure lee_configuracion ('FACTURACION', 'DEVOLUCIONES', 'HACER DEVOLUCIONES SOBRE REMISIONES') returning_values (:devrem);
if ((NEW.devt_id <> 0) and (new.dvde_anulado = 'N')) then
    BEGIN
    ID = 0;
    select devt_fecha, pref_pre, devt_numero, terc_nit, devt_factura, devt_remid, DEVT_FACTID 
        from devoluciones_ventas where devt_id = new.devt_id into :fec, :Pref, :Num, :Nit, :Fact, :idrem, :ID;
    execute procedure factor_unidad_cant(new.arti_cod, new.dvde_unidad) returning_values(factor);
    CONC = 'DEVOLUCION VENTA No.' || PREF || NUM || ' - FACTURA ' || FACT;
    /* si la factura afecto el inventario, afectelo */
    execute procedure lee_configuracion ('FACTURACION', 'DEVOLUCIONES', 'PERMITIR DEVOLVER ITEMS NO FACTURADOS') returning_values (:devnof);
    if (devnof = 'SI') then
        OK = 'S';
    else
        BEGIN
        if (id <> 0) then
            begin
            SELECT SUM(FADE_CANT * FADE_FACTOR) FROM FACTURAS_DETALLE WHERE FACT_ID = :ID AND ARTI_COD = NEW.arti_cod INTO :cntfac;
            /* verifique si afecto el inventario */
            select count(mvar_cons) from movimiento_articulo where mvar_tipodoc = 31 and mvar_idref = :id and arti_cod = new.arti_cod into :numrows;
            if (numrows > 0) then
                OK = 'S';
            else
                BEGIN
                /* busque remisiones que pudieron afectarlo */
                /* primero posteriores a la factura */
                select sum(cofa_cant * cofa_factor) from consolidado_faltantes where cofa_tipoori = 31 and cofa_idori = :id and cofa_tipodes = 32 and arti_cod = new.arti_cod and cofa_ok = 'S' into :cantaux;
                if ((cantaux <> 0) and (cantaux is not null)) then
                    BEGIN
                    if ((CNTFAC - (NEW.dvde_cant * NEW.dvde_factor)) <> CANTAUX) then
                        OK = 'S';
                    ELSE
                        OK = 'N';
                    END
                else
                    begin
                    /* si no, anteriores a la factura */
                    select sum(cofa_cant * cofa_factor) from consolidado_faltantes C, FACTURAS f where f.fact_consolida = c.cofa_id and cofa_tipoori = 32 and f.fact_id = :id and cofa_tipodes = 31 and arti_cod = new.arti_cod and cofa_ok = 'S' into :cantaux;
                    if ((cantaux <> 0) and (cantaux is not null)) then
                        OK = 'S';
                    else
                        BEGIN
                        /* si hacen pedido automatico, puede que la remisin este hecha con el pedido */
                        EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','FACTURAS','GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') RETURNING_VALUES (PEDAUTO);
                        if (PEDAUTO = 'SI') then
                            BEGIN
                            SELECT PEDI_ID FROM PEDIDOS P, FACTURAS F WHERE P.PREF_PRE = F.pref_pre AND P.pedi_numero = F.fact_numero AND F.fact_id = :id INTO :IDped;
                            select sum(cofa_cant * cofa_factor) from consolidado_faltantes where cofa_tipoori = 34 and cofa_idori = :idped and cofa_tipodes = 32 and arti_cod = new.arti_cod and cofa_ok = 'S' into :cantaux;
                            if ((cantaux <> 0) and (cantaux is not null)) then
                                if ((CNTFAC - (NEW.dvde_cant * NEW.dvde_factor)) <> CANTAUX) then
                                    OK = 'S';
                                else
                                    OK = 'N';
                            else
                                OK = 'N';
                            END
                        ELSE
                            OK = 'N';
                        END
                    end
                END
            end
        else
          if ((idrem <> 0) and (devrem = 'SI')) then
            begin
            /* verifique si afecto el inventario */
            select count(mvar_cons) from movimiento_articulo where mvar_tipodoc = 32 and mvar_idref = :idrem and arti_cod = new.arti_cod into :numrows;
            if (numrows > 0) then
                OK = 'S';
            else
                OK = 'N';
            end
        END
    if (OK = 'S') then
        begin
        /* calcule el costo al que salio o el promedio */
        execute procedure costo_promedio(new.arti_cod, :FEC) returning_values (:COSTO);
        INSERT INTO MOVIMIENTO_ARTICULO
            (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF,
            MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
            VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 33, NEW.devt_id,
            :CONC, :factor * new.dvde_cant, :COSTO, 'S', new.dvde_lote, :Pref, :Num, new.dvde_item, :Nit);
        end
    /* ACTUALICE LO DEVUELTO EN LA FACTURA */
    if (ID <> 0) then
        BEGIN
        CANTAUX = NEW.dvde_cant * NEW.dvde_factor;
        FOR SELECT FADE_ITEM, FADE_CANT, FADE_FACTOR, FADE_DEVUELTO
            FROM FACTURAS_DETALLE
            WHERE FACT_ID = :ID AND ARTI_COD = NEW.ARTI_COD
            INTO :ITEM, :CANT, :FACTOR, :DEVUELTO
            DO
                BEGIN
                if (CANTAUX > 0) then
                    if ((CANT * FACTOR - DEVUELTO) < CANTAUX) then
                      BEGIN
                      UPDATE FACTURAS_DETALLE
                        SET FADE_DEVUELTO = (:CANT * :FACTOR)
                        WHERE FACT_ID = :ID AND FADE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                      CANTAUX = CANTAUX - (CANT * FACTOR - DEVUELTO);
                      END
                    ELSE
                      BEGIN
                      UPDATE FACTURAS_DETALLE
                        SET FADE_DEVUELTO = FADE_DEVUELTO + :CANTAUX
                        WHERE FACT_ID = :ID AND FADE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                      CANTAUX = 0;
                      END
                END
        if (CANTAUX > 0) then
            EXCEPTION DEVOLUCION_MAYOR 'Esta devolviendo una cantidad mayor a la facturada del articulo ' || new.arti_cod;
        END
    if ((idrem <> 0) and (devrem = 'SI')) then
        BEGIN
        CANTAUX = NEW.dvde_cant * NEW.dvde_factor;
        FOR SELECT RVDE_ITEM, RVDE_CANT, RVDE_FACTOR, RVDE_DEVUELTO
            FROM remisiones_venta_detalle
            WHERE REVT_ID = :idrem AND ARTI_COD = NEW.ARTI_COD
            INTO :ITEM, :CANT, :FACTOR, :DEVUELTO
            DO
                BEGIN
                if (CANTAUX > 0) then
                    if ((CANT * FACTOR - DEVUELTO) < CANTAUX) then
                      BEGIN
                      UPDATE remisiones_venta_detalle
                        SET RVDE_DEVUELTO = (:CANT * :FACTOR)
                        WHERE REVT_ID = :IDREM AND RVDE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                      CANTAUX = CANTAUX - (CANT * FACTOR - DEVUELTO);
                      END
                    ELSE
                      BEGIN
                      UPDATE remisiones_venta_detalle
                        SET RVDE_DEVUELTO = RVDE_DEVUELTO + :CANTAUX
                        WHERE REVT_ID = :IDREM AND RVDE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                      CANTAUX = 0;
                      END
                END
        if (CANTAUX > 0) then
            EXCEPTION DEVOLUCION_MAYOR 'Esta devolviendo una cantidad mayor a la remisionada del articulo ' || new.arti_cod;
        END
    END
END
^

SET TERM ; ^


SET TERM ^ ;

CREATE OR ALTER TRIGGER DEVOLUCIONES_VENTAS_DETALLE_AU FOR DEVOLUCIONES_VENTAS_DETALLE
ACTIVE AFTER UPDATE POSITION 0
AS
declare variable fec date;
declare variable CONC VARCHAR(60);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Nit varchar(20);
declare variable CANT NUMERIC(18, 4);
declare variable CANTAUX NUMERIC(18,4);
declare variable CNTFAC NUMERIC(18, 4);
declare variable COSTO NUMERIC(18,2);
declare variable factor numeric(18,4);
declare variable DEVUELTO NUMERIC(18,4);
declare variable ID integer;
declare variable ITEM INTEGER;
declare variable FACT varchar(10);
declare variable devnof CHAR(2);
declare variable numrows INTEGER;
declare variable OK CHAR(1);
declare variable PEDAUTO CHAR(2);
declare variable IDPED INTEGER;
declare variable IDREM INTEGER;
declare variable devrem CHAR(2);
BEGIN
execute procedure lee_configuracion ('FACTURACION', 'DEVOLUCIONES', 'HACER DEVOLUCIONES SOBRE REMISIONES') returning_values (:devrem);
/* Anule el anterior */
if ((OLD.DEVT_ID <> 0) AND (OLD.dvde_anulado = 'N')) then
    BEGIN
    DELETE FROM MOVIMIENTO_ARTICULO WHERE (mvar_tipodoc = 33) and (mvar_idref = new.devt_id) and (mvar_item = old.dvde_item);
    /* DESHAGA LO DEVUELTO EN LA FACTURA */
    ID = 0;
    SELECT DEVT_FACTID FROM DEVOLUCIONES_VENTAS
        WHERE DEVT_ID = OLD.DEVT_ID INTO :ID;
    if (ID <> 0) then
        BEGIN
        CANTAUX = OLD.dvde_cant * OLD.dvde_factor;
        FOR SELECT FADE_CANT, FADE_FACTOR, FADE_DEVUELTO, FADE_ITEM
            FROM FACTURAS_DETALLE
            WHERE FACT_ID = :ID AND ARTI_COD = OLD.ARTI_COD
            INTO :CANT, :FACTOR, :DEVUELTO, :ITEM
            DO
            BEGIN
            if (CANTAUX > (CANT * FACTOR - DEVUELTO)) then
                BEGIN
                UPDATE FACTURAS_DETALLE
                    SET FADE_DEVUELTO = 0
                    WHERE FACT_ID = :ID AND ARTI_COD = OLD.ARTI_COD AND FADE_ITEM = :ITEM;
                CANTAUX = CANTAUX - (CANT * FACTOR - DEVUELTO);
                END
            ELSE
                BEGIN
                UPDATE FACTURAS_DETALLE
                    SET FADE_DEVUELTO = FADE_DEVUELTO - :CANTAUX
                    WHERE FACT_ID = :ID AND ARTI_COD = OLD.ARTI_COD AND FADE_ITEM = :ITEM;
                CANTAUX = 0;
                END
            END
        END
    if (devrem = 'SI') then
        begin
        idrem = 0;
        SELECT DEVT_REMID FROM DEVOLUCIONES_VENTAS
            WHERE DEVT_ID = OLD.DEVT_ID INTO :idrem;
        if (idrem <> 0) then
            BEGIN
            CANTAUX = OLD.dvde_cant * OLD.dvde_factor;
            FOR SELECT RVDE_CANT, RVDE_FACTOR, RVDE_DEVUELTO, RVDE_ITEM
                FROM remisiones_venta_detalle
                WHERE REVT_ID = :idrem AND ARTI_COD = OLD.ARTI_COD
                INTO :CANT, :FACTOR, :DEVUELTO, :ITEM
                DO
                BEGIN
                if (CANTAUX > (CANT * FACTOR - DEVUELTO)) then
                    BEGIN
                    UPDATE remisiones_venta_detalle
                        SET RVDE_DEVUELTO = 0
                        WHERE REVT_ID = :idrem AND ARTI_COD = OLD.ARTI_COD AND RVDE_ITEM = :ITEM;
                    CANTAUX = CANTAUX - (CANT * FACTOR - DEVUELTO);
                    END
                ELSE
                    BEGIN
                    UPDATE remisiones_venta_detalle
                        SET RVDE_DEVUELTO = RVDE_DEVUELTO - :CANTAUX
                        WHERE REVT_ID = :idrem AND ARTI_COD = OLD.ARTI_COD AND RVDE_ITEM = :ITEM;
                    CANTAUX = 0;
                    END
                END
            END
        end
    END
/* Registre el nuevo */
if ((NEW.DEVT_ID <> 0) AND (NEW.dvde_anulado = 'N')) then
    begin
    ID = 0;
    select devt_fecha, pref_pre, devt_numero, terc_nit, devt_factura, devt_remid, DEVT_FACTID 
        from devoluciones_ventas where devt_id = new.devt_id into :fec, :Pref, :Num, :Nit, :Fact, :idrem, :ID;
    execute procedure factor_unidad_cant(new.arti_cod, new.dvde_unidad) returning_values(factor);
    CONC = 'DEVOLUCION VENTA No.' || PREF || NUM || '- FACTURA ' || FACT;
    execute procedure lee_configuracion ('FACTURACION', 'DEVOLUCIONES', 'PERMITIR DEVOLVER ITEMS NO FACTURADOS') returning_values (:devnof);
    if (devnof = 'SI') then
        OK = 'S';
    else
        if (id <> 0) then
            begin
            SELECT SUM(FADE_CANT * FADE_FACTOR) FROM FACTURAS_DETALLE WHERE FACT_ID = :ID AND ARTI_COD = NEW.arti_cod INTO :cntfac;
            /* verifique si afecto el inventario */
            select count(mvar_cons) from movimiento_articulo where mvar_tipodoc = 31 and mvar_idref = :id and arti_cod = new.arti_cod into :numrows;
            if (numrows > 0) then
                OK = 'S';
            else
                BEGIN
                /* busque remisiones que pudieron afectarlo */
                /* primero posteriores a la factura */
                select sum(cofa_cant * cofa_factor) from consolidado_faltantes where cofa_tipoori = 31 and cofa_idori = :id and cofa_tipodes = 32 and arti_cod = new.arti_cod and cofa_ok = 'S' into :cantaux;
                if ((cantaux <> 0) and (cantaux is not null)) then
                    BEGIN
                    if ((CNTFAC - (NEW.dvde_cant * NEW.dvde_factor)) <> CANTAUX) then
                        OK = 'S';
                    ELSE
                        OK = 'N';
                    END
                else
                    begin
                    /* si no, anteriores a la factura */
                    select sum(cofa_cant * cofa_factor) from consolidado_faltantes C, FACTURAS f where f.fact_consolida = c.cofa_id and cofa_tipoori = 32 and f.fact_id = :id and cofa_tipodes = 31 and arti_cod = new.arti_cod and cofa_ok = 'S' into :cantaux;
                    if ((cantaux <> 0) and (cantaux is not null)) then
                        OK = 'S';
                    else
                        BEGIN
                        /* si hacen pedido automatico, puede que la remisin este hecha con el pedido */
                        EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','FACTURAS','GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') RETURNING_VALUES (PEDAUTO);
                        if (PEDAUTO = 'SI') then
                            BEGIN
                            SELECT PEDI_ID FROM PEDIDOS P, FACTURAS F WHERE P.PREF_PRE = F.pref_pre AND P.pedi_numero = F.fact_numero AND F.fact_id = :id INTO :IDped;
                            select sum(cofa_cant * cofa_factor) from consolidado_faltantes where cofa_tipoori = 34 and cofa_idori = :idped and cofa_tipodes = 32 and arti_cod = new.arti_cod and cofa_ok = 'S' into :cantaux;
                            if ((cantaux <> 0) and (cantaux is not null)) then
                                if ((CNTFAC - (NEW.dvde_cant * NEW.dvde_factor)) <> CANTAUX) then
                                    OK = 'S';
                                else
                                    OK = 'N';
                            else
                                OK = 'N';
                            END
                        ELSE
                            OK = 'N';
                        END
                    end
                END
            end
        else
          if ((idrem <> 0) and (devrem = 'SI')) then
            begin
            /* verifique si afecto el inventario */
            select count(mvar_cons) from movimiento_articulo where mvar_tipodoc = 32 and mvar_idref = :idrem and arti_cod = new.arti_cod into :numrows;
            if (numrows > 0) then
                OK = 'S';
            else
                OK = 'N';
            end
    if (OK = 'S') then
        begin
        /* calcule el costo al que salio o el promedio */
        execute procedure costo_promedio(new.arti_cod, :FEC) returning_values (:COSTO);
        INSERT INTO MOVIMIENTO_ARTICULO
            (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF,
            MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
            VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 33, NEW.devt_id,
            :CONC, :factor * new.dvde_cant, :COSTO, 'S', new.dvde_lote, :Pref, :Num, new.dvde_item, :Nit);
        end
    /* ACTUALICE LO DEVUELTO EN LA FACTURA */
    if (ID <> 0) then
        BEGIN
        CANTAUX = NEW.dvde_cant * NEW.dvde_factor;
        FOR SELECT FADE_ITEM, FADE_CANT, FADE_FACTOR, FADE_DEVUELTO
            FROM FACTURAS_DETALLE
            WHERE FACT_ID = :ID AND ARTI_COD = NEW.ARTI_COD
            INTO :ITEM, :CANT, :FACTOR, :DEVUELTO
            DO
            BEGIN
            if (CANTAUX > 0) then
                if ((CANT * FACTOR - DEVUELTO) < CANTAUX) then
                    BEGIN
                    UPDATE FACTURAS_DETALLE
                        SET FADE_DEVUELTO = (:CANT * :FACTOR - :DEVUELTO)
                        WHERE FACT_ID = :ID AND FADE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                    CANTAUX = CANTAUX - (CANT * FACTOR - DEVUELTO);
                    END
                ELSE
                    BEGIN
                    UPDATE FACTURAS_DETALLE
                        SET FADE_DEVUELTO = FADE_DEVUELTO + :CANTAUX
                        WHERE FACT_ID = :ID AND FADE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                    CANTAUX = 0;
                    END
            END
        if (CANTAUX > 0) then
            EXCEPTION DEVOLUCION_MAYOR 'Esta devolviendo una cantidad mayor a la facturada del articulo ' || new.arti_cod;
        END
    if ((idrem <> 0) and (devrem = 'SI')) then
        BEGIN
        CANTAUX = NEW.dvde_cant * NEW.dvde_factor;
        FOR SELECT RVDE_ITEM, RVDE_CANT, RVDE_FACTOR, RVDE_DEVUELTO
            FROM remisiones_venta_detalle
            WHERE REVT_ID = :idrem AND ARTI_COD = NEW.ARTI_COD
            INTO :ITEM, :CANT, :FACTOR, :DEVUELTO
            DO
                BEGIN
                if (CANTAUX > 0) then
                    if ((CANT * FACTOR - DEVUELTO) < CANTAUX) then
                      BEGIN
                      UPDATE remisiones_venta_detalle
                        SET RVDE_DEVUELTO = (:CANT * :FACTOR - :DEVUELTO)
                        WHERE REVT_ID = :ID AND RVDE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                      CANTAUX = CANTAUX - (CANT * FACTOR - DEVUELTO);
                      END
                    ELSE
                      BEGIN
                      UPDATE remisiones_venta_detalle
                        SET RVDE_DEVUELTO = RVDE_DEVUELTO + :CANTAUX
                        WHERE REVT_ID = :ID AND RVDE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                      CANTAUX = 0;
                      END
                END
        if (CANTAUX > 0) then
            EXCEPTION DEVOLUCION_MAYOR 'Esta devolviendo una cantidad mayor a la remisionada del articulo ' || new.arti_cod;
        END
    END
END
^

SET TERM ; ^


/* observaciones del cliente en pantalla al facturar */
INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('FACTURACION', 'FACTURAS', 'MOSTRAR OBSERVACIONES DEL CLIENTE AL LLAMARLO EN LA FACTURA', 'NO', 'SI,NO', 'SI:Al digitar el cliente se MUESTRAN las observacions de la factura las observaciones del cliente');
commit work;

/* error en revision de precios */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE REVISA_PRECIOS(
    LISTA INTEGER,
    FECHA DATE)
RETURNS (
    ARTICULO VARCHAR(20),
    DESCR VARCHAR(60),
    FIJO NUMERIC(18,2),
    UNIDAD VARCHAR(8),
    PORC NUMERIC(9,4),
    SUGERIDO NUMERIC(18,2),
    DIFER NUMERIC(18,2))
AS
declare variable marg numeric(9,4);
declare variable UOM VARCHAR(10);
declare variable BASE VARCHAR(10);
declare variable CAMBIO VARCHAR(10);
declare variable COSTO numeric(18,2);
declare variable COSTOP numeric(18,2);
declare variable COSTOU numeric(18,2);
declare variable DIFMAX numeric(18,2);
declare variable DIG INTEGER;
declare variable TARIVA NUMERIC(9,4);
declare variable IVAINC CHAR(1);
declare variable LISTAREF INTEGER;
begin
execute procedure lee_configuracion ('FACTURACION', 'ARTICULOS', 'SUGERIR PRECIOS CON PORCENTAJE DE MARGEN O UTILIDAD') returning_values (:UOM);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'ARTICULOS', 'REDONDEO AL MULTIPLO DE DIEZ EN PRECIOS') RETURNING_VALUES (:DIG);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','CAMBIO DE PRECIOS AUTOMATICO AL CAMBIAR COSTO O PRECIO') returning_values (CAMBIO);
EXECUTE PROCEDURE lee_configuracion('FACTURACION','ARTICULOS','COSTO BASE PARA CALCULO DE PRECIOS DE VENTA AUTOMATICOS') returning_values (:BASE);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','CODIGO DE LA LISTA DE PRECIOS BASE PARA CAMBIO DE PRECIOS AUTOMATICO') returning_values (LISTAREF);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','DIFERENCIA EN PESOS MAXIMA A PERMITIR PARA CAMBIAR PRECIOS') returning_values (DIFMAX);
for select A.arti_cod, A.arti_des, A.arti_unidad, prar_fijo, prar_margen, prar_util, TAIV_PORC
    from precios_articulo p, articulo a, tarifa_iva T
    where a.arti_cod = p.arti_cod and lipr_cod = :lista and a.taiv_cod = t.taiv_cod order by A.arti_cod
    into :articulo, descr, :unidad, :fijo, :marg, :porc, :tariva
    do
    begin
    if (UOM <> 'UTILIDAD') then
        PORC = MARG;
    if (CAMBIO = 'COSTO') then
        BEGIN
        EXECUTE PROCEDURE COSTO_PROMEDIO (:ARTICULO, :FECHA) RETURNING_VALUES(:COSTOP);
        EXECUTE PROCEDURE ULTIMO_COSTO (:ARTICULO, :FECHA, :UNIDAD) RETURNING_VALUES(:COSTOU);
        if (base = 'ULTIMO') then
            COSTO = COSTOU;
        ELSE
            BEGIN
            COSTO = COSTOP;
            if (base = 'MAYOR') then
                if (COSTOP < COSTOU) then
                    COSTO = COSTOU;
            END
        SELECT LIPR_MODIF FROM LISTA_PRECIOS WHERE LIPR_COD = :lista INTO :IVAINC;
        if (IVAINC = 'S') then
            COSTO = COSTO * (1 + TARIVA/100);
        if (UOM = 'UTILIDAD') then
            SUGERIDO = COSTO * (1 + :PORC/100);
        ELSE
            SUGERIDO = COSTO / (1 - :PORC/100);
        END
    ELSE
        if (LISTA <> LISTAREF) then
            BEGIN
            SELECT PRAR_FIJO FROM PRECIOS_ARTICULO WHERE ARTI_COD = :articulo AND LIPR_COD = :LISTAREF INTO :SUGERIDO;
            if (IVAINC = 'S') then
                SUGERIDO = SUGERIDO / (1 + TARIVA/100);
            if (UOM = 'UTILIDAD') then
                SUGERIDO = SUGERIDO * (1 + :PORC/100);
            ELSE
                SUGERIDO = SUGERIDO / (1 - :PORC/100);
            END
    EXECUTE PROCEDURE REDONDEE (SUGERIDO, DIG) returning_values (SUGERIDO);
    DIFER = SUGERIDO - FIJO;
    if ((DIFER > DIFMAX) and (sugerido <> 0)) then
        suspend;
    end
end
^

SET TERM ; ^


/* actualizar costos de la remision al facturar en compras */
SET TERM ^ ;

CREATE OR ALTER TRIGGER FACTCOMP_DETALLE_AI FOR FACTURAS_COMPRAS_DETALLE
ACTIVE AFTER INSERT POSITION 0
AS
declare variable fec date;
declare variable fecaux date;
declare variable aux varchar(90);
declare variable CONC VARCHAR(60);
declare variable factor numeric(18,4);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Nit varchar(20);
declare variable TIPO INTEGER;
declare variable INVFAC CHAR(2);
declare variable IVAINC CHAR(2);
declare variable COSTO NUMERIC(18,2);
declare variable CANTREL NUMERIC(18,4);
declare variable NUMPROV VARCHAR(10);
declare variable NUMPED VARCHAR(30);
declare variable NUMREM VARCHAR(30);
declare variable CONSO VARCHAR(2);
declare variable CONSOLIDA INTEGER;
declare variable NUMROWS INTEGER;
declare variable DTOPIE NUMERIC(18,2);
declare variable ADICIONAL NUMERIC(18,2);
declare variable TOTAL NUMERIC(18,2);
declare variable IVAMONTO NUMERIC(18,2);
declare variable EXTRA NUMERIC(18,2);
declare variable FACT NUMERIC(18,4);
declare variable MENORV CHAR(2);
declare variable ACTREM CHAR(2);
declare variable FECREM date;
declare variable IDREM INTEGER;
declare variable ITEREM INTEGER;
declare variable CANTREM NUMERIC(18,4);
declare variable LOTEREM VARCHAR(15);
declare variable PREFREM CHAR(4);
BEGIN
if ((NEW.faco_id <> 0) and (new.fcde_anulado = 'N')) then
    BEGIN
    select faco_fecha, pref_pre, faco_numero, terc_nit, faco_imptos, faco_numprov, faco_remision, faco_orden, FACO_CONSOLIDA,
        FACO_TOTAL, FACO_EXTRA, FACO_IVAMONTO, FACO_ADICIONAL, FACO_DTOMONTO
        from facturas_compra where faco_id = new.faco_id
        into :fec, :Pref, :Num, :Nit, :ivainc, :numprov, :numrem, :numped, :CONSOLIDA,
        :total, :extra, :ivamonto, :adicional, :dtopie;
    conc = 'FACTURA DE COMPRA No.' || PREF || NUM || '-' || NUMPROV;
    if (NUMREM <> '') then
        BEGIN
        AUX = SUBSTR(NUMREM, 1, 15);
        conc = conc || '-REM:' || AUX;
        END
    else
        if (NUMPED <> '') then
            BEGIN
            AUX = SUBSTR(NUMPED, 1, 15);
            conc = conc || '-ORDEN ' || NUMPED;
            END
    SELECT MAX(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :TIPO;
    if (Tipo is null) then
        Tipo = 0;
    execute procedure lee_configuracion('COMPRAS', 'FACTURAS', 'AFECTAR INVENTARIO CON LA FACTURA') returning_values (:INVFAC);
    execute procedure factor_unidad_cant(new.arti_cod, new.fcde_unidad) returning_values(factor);
    COSTO = ((new.fcde_prunit - NEW.fcde_dtomonto) / :factor);
    if (IVAINC = 'S') then
        COSTO = COSTO / (1 + NEW.fcde_ivaporc/100);
    EXECUTE PROCEDURE lee_configuracion('COMPRAS','FACTURAS','DESCUENTO Y VALOR ADICIONAL DEL DOCUMENTO COMO MENOR VALOR DEL COSTO') returning_values (:MENORV);
    if (MENORV = 'SI') then
        BEGIN
        FACT = (TOTAL - EXTRA - IVAMONTO);
        if ((FACT - ADICIONAL + DTOPIE) <> 0) then
            FACT = FACT / (FACT - ADICIONAL + DTOPIE);
        ELSE
            FACT = 1;
        COSTO = COSTO * FACT;
        END
    /* si se hizo con base en una remision no afecte inventario */
    if (INVFAC = 'SI') then
      if (Tipo <> 22) then
        begin
        INSERT INTO MOVIMIENTO_ARTICULO
          (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
          VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 21, NEW.faco_id,
          :CONC, :factor * new.fcde_cant, :COSTO, 'S', new.fcde_lote, :Pref, :Num, NEW.fcde_item, :Nit);

        if (COSTO > 0 ) then
         BEGIN
          /* ACTUALICE EL COSTO POR PROVEEDOR */
          SELECT PVAR_FECHA FROM PROVEEDOR_ARTICULO
            WHERE TERC_NIT = :Nit AND ARTI_COD = NEW.ARTI_COD
            INTO :FECAUX;
          if (FECAUX IS NULL) then
            INSERT INTO PROVEEDOR_ARTICULO (TERC_NIT, ARTI_COD, PVAR_COSTO, PVAR_FECHA, PVAR_COD,PVAR_DES)
                VALUES (:Nit, NEW.ARTI_COD, :COSTO, :fec, NEW.fcde_codprov,NEW.fcde_desc);
          else
            UPDATE PROVEEDOR_ARTICULO
                SET PVAR_COSTO = :COSTO, PVAR_FECHA = :fec, PVAR_COD = NEW.fcde_codprov
                WHERE ARTI_COD = NEW.ARTI_COD AND TERC_NIT = :Nit;
         END
        /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
        EXECUTE PROCEDURE CALCULA_PRECIOS(NEW.ARTI_COD, :FEC);
        END /* AFECTAR INV */
    EXECUTE PROCEDURE lee_configuracion('COMPRAS', 'FACTURAS', 'ACTUALIZAR COSTOS DE LA REMISION RELACIONADA AL GRABAR LA FACTURA') returning_values (:ACTREM);
    if ((ACTREM = 'SI') and (Tipo = 22)) then
        BEGIN
        numrows = 0;
        select mvar_cons, MVAR_ITEM, MVAR_FECHA, MVAR_IDREF, MVAR_CANT, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO
            from movimiento_articulo M, consolidado_faltantes C
            where C.cofa_id = :CONSOLIDA AND mvar_tipodoc = 22 and mvar_idref = C.cofa_idori AND C.cofa_tipoori = 22 and m.arti_cod = new.arti_cod
            into :numrows, :iterem, :fecrem, :idrem, :cantrem, :loterem, :prefrem, :numrem;
        
        if (numrows <> 0) then
            BEGIN
            DELETE FROM MOVIMIENTO_ARTICULO WHERE MVAR_CONS = :numrows;
            INSERT INTO MOVIMIENTO_ARTICULO
                (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
                VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :fecrem, 22, :idrem,
                :CONC, :cantrem, :costo, 'S', :loterem, :prefrem, :numrem, :iterem, :Nit);
        
            if (COSTO > 0 ) then
                BEGIN
                /* ACTUALICE EL COSTO POR PROVEEDOR */
                SELECT PVAR_FECHA FROM PROVEEDOR_ARTICULO
                    WHERE TERC_NIT = :Nit AND ARTI_COD = NEW.ARTI_COD
                    INTO :FECAUX;
                if (FECAUX IS NULL) then
                    INSERT INTO PROVEEDOR_ARTICULO (TERC_NIT, ARTI_COD, PVAR_COSTO, PVAR_FECHA, PVAR_COD,PVAR_DES)
                        VALUES (:Nit, NEW.ARTI_COD, :COSTO, :fec, NEW.fcde_codprov,NEW.fcde_desc);
                else
                    UPDATE PROVEEDOR_ARTICULO
                        SET PVAR_COSTO = :COSTO, PVAR_FECHA = :fec, PVAR_COD = NEW.fcde_codprov
                        WHERE ARTI_COD = NEW.ARTI_COD AND TERC_NIT = :Nit;
                END
            /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
            EXECUTE PROCEDURE CALCULA_PRECIOS(NEW.ARTI_COD, :FEC);
            END
        END

    /* ACTUALICE EL PENDIENTE  */
    if (CONSOLIDA <> 0) then
        BEGIN
        UPDATE consolidado_faltantes SET COFA_OK = 'S' WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod;
        EXECUTE procedure LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','SUMAR CANTIDADES PENDIENTES AL CONSOLIDAR DOCUMENTOS') returning_values (CONSO);
        /* IGNORE LA CONSOLIDACION SI SE VALIDAN CODIGOS DE LA ORDEN */
        SELECT MIN(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
        if (NUMROWS = 23) then
            BEGIN
            EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'VERIFICAR CODIGOS DE LA ORDEN') returning_values (MENORV);
            if (MENORV = 'SI') then
                CONSO = 'NO';
            END
        SELECT COUNT(CEFA_ITEM) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
        if ((CONSO = 'SI') AND (NUMROWS > 1)) then
            UPDATE consolidado_faltantes SET COFA_IDDES = NEW.faco_id, COFA_OK = 'S' WHERE COFA_ID = :consolida;
        else
            BEGIN
            /* BUSQUE EL CONSOLIDADO EN EL MISMO ITEM Y SI ES DIFERENTE ACTUALICELO */
            select COFA_CANT * COFA_FACTOR FROM consolidado_faltantes WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod INTO :CANTREL;
            if (NEW.FCDE_CANT * NEW.FCDE_FACTOR < CANTREL) then
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.faco_id, COFA_CANT = NEW.FCDE_CANT, COFA_FACTOR = NEW.FCDE_FACTOR
                    WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod;
            END
        END
    END
END
^

SET TERM ; ^


SET TERM ^ ;

CREATE OR ALTER TRIGGER FACTCOMP_DETALLE_AU FOR FACTURAS_COMPRAS_DETALLE
ACTIVE AFTER UPDATE POSITION 0
as
declare variable fec date;
declare variable fecaux date;
declare variable AUX varchar(90);
declare variable CONC VARCHAR(60);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Nit varchar(20);
declare variable factor numeric(18,4);
declare variable TIPO INTEGER;
declare variable INVFAC CHAR(2);
declare variable IVAINC CHAR(2);
declare variable COSTO NUMERIC(18,2);
declare variable CANTREL NUMERIC(18,4);
declare variable NUMPROV VARCHAR(10);
declare variable NUMPED VARCHAR(30);
declare variable NUMREM VARCHAR(30);
declare variable CONSO VARCHAR(2);
declare variable CONSOLIDA INTEGER;
declare variable NUMROWS INTEGER;
declare variable DTOPIE NUMERIC(18,2);
declare variable ADICIONAL NUMERIC(18,2);
declare variable TOTAL NUMERIC(18,2);
declare variable IVAMONTO NUMERIC(18,2);
declare variable EXTRA NUMERIC(18,2);
declare variable FACT NUMERIC(18,4);
declare variable MENORV CHAR(2);
declare variable ACTREM CHAR(2);
declare variable FECREM date;
declare variable IDREM INTEGER;
declare variable ITEREM INTEGER;
declare variable CANTREM NUMERIC(18,4);
declare variable LOTEREM VARCHAR(15);
declare variable PREFREM CHAR(4);
BEGIN
if (old.fcde_devuelto = new.fcde_devuelto) then
    begin
    /* deshaga lo viejo */
    if ((old.fcde_anulado = 'N') and (OLD.faco_id <> 0)) then
        begin
        select faco_fecha, faco_consolida from facturas_compra where faco_id = old.faco_id into :fec, :consolida;
        DELETE FROM MOVIMIENTO_ARTICULO WHERE (mvar_tipodoc = 21) and (mvar_idref = old.faco_id) and (mvar_item = old.fcde_item);
        /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
        EXECUTE PROCEDURE CALCULA_PRECIOS(old.ARTI_COD, :FEC);
        /* LOS PENDIENTES */
        if (CONSOLIDA <> 0) then
            BEGIN
            UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida AND COFA_ITEM = old.FCDE_ITEM AND ARTI_COD = old.arti_cod;
            SELECT COUNT(CEFA_ITEM) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
            EXECUTE procedure LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','SUMAR CANTIDADES PENDIENTES AL CONSOLIDAR DOCUMENTOS') returning_values (CONSO);
            /* IGNORE LA CONSOLIDACION SI SE VALIDAN CODIGOS DE LA ORDEN */
            SELECT MIN(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
            if (NUMROWS = 23) then
                BEGIN
                EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'VERIFICAR CODIGOS DE LA ORDEN') returning_values (MENORV);
                if (MENORV = 'SI') then
                    CONSO = 'NO';
                END
            if (CONSO = 'SI') then
                UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida;
            END
        end
    /* Registre el nuevo */
    if ((new.fcde_anulado = 'N') and (new.faco_id <> 0)) then
        BEGIN
        select faco_fecha, pref_pre, faco_numero, terc_nit, faco_imptos, faco_numprov, faco_remision, faco_orden, faco_consolida, faco_dtomonto, faco_adicional, faco_total, faco_ivamonto, faco_extra
            from facturas_compra where faco_id = new.faco_id
            into :fec, :Pref, :Num, :Nit, :ivainc, :numprov, :numrem, :numped, :consolida, :dtopie, :adicional, :total, :ivamonto, :extra;
        conc = 'FACTURA DE COMPRA No.' || PREF || NUM || '-' || NUMPROV;
        if (NUMREM <> '') then
            BEGIN
            AUX = SUBSTR(NUMREM, 1, 15);
            conc = conc || '-REM:' || AUX;
            END
        else
            if (NUMPED <> '') then
                BEGIN
                AUX = SUBSTR(NUMPED, 1, 15);
                conc = conc || '-ORDEN ' || AUX;
                END
        SELECT MAX(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :TIPO;
        if (Tipo is null) then
            Tipo = 0;
        execute procedure lee_configuracion('COMPRAS', 'FACTURAS', 'AFECTAR INVENTARIO CON LA FACTURA') returning_values (:INVFAC);
        /* si se hizo con base en una remision no afecte inventario */
        if ((Tipo <> 22) and (INVFAC = 'SI')) then
            begin
            execute procedure factor_unidad_cant(new.arti_cod, new.fcde_unidad) returning_values(factor);
            COSTO = ((new.fcde_prunit - NEW.fcde_dtomonto) / :factor);
            if (IVAINC = 'S') then
                COSTO = COSTO / (1 + NEW.fcde_ivaporc/100);
            EXECUTE PROCEDURE lee_configuracion('COMPRAS','FACTURAS','DESCUENTO Y VALOR ADICIONAL DEL DOCUMENTO COMO MENOR VALOR DEL COSTO') returning_values (:MENORV);
            if (MENORV = 'SI') then
                BEGIN
                FACT = (TOTAL - EXTRA - IVAMONTO);
                if ((FACT - ADICIONAL + DTOPIE) <> 0) then
                    FACT = FACT / (FACT - ADICIONAL + DTOPIE);
                ELSE
                    FACT = 1;
                COSTO = COSTO * FACT;
                END
            INSERT INTO MOVIMIENTO_ARTICULO
                (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
                VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 21, NEW.faco_id,
                :CONC, :factor * new.fcde_cant, :COSTO, 'S', new.fcde_lote, :Pref, :Num, NEW.fcde_item, :Nit);
            if (COSTO > 0 ) then
             BEGIN
              /* ACTUALICE EL COSTO POR PROVEEDOR */
              SELECT PVAR_FECHA FROM PROVEEDOR_ARTICULO
                WHERE TERC_NIT = :Nit AND ARTI_COD = NEW.ARTI_COD INTO :FECAUX;
              if (FECAUX IS NULL) then
                INSERT INTO PROVEEDOR_ARTICULO (TERC_NIT, ARTI_COD, PVAR_COSTO, PVAR_FECHA, PVAR_COD,PVAR_DES)
                    VALUES (:Nit, NEW.ARTI_COD, :COSTO, :fec, NEW.fcde_codprov,NEW.fcde_desc);
              else
                UPDATE PROVEEDOR_ARTICULO
                    SET PVAR_COSTO = :COSTO, PVAR_FECHA = :fec, PVAR_COD = NEW.fcde_codprov
                    WHERE ARTI_COD = NEW.ARTI_COD AND TERC_NIT = :Nit;
             END
            /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
            EXECUTE PROCEDURE CALCULA_PRECIOS(NEW.ARTI_COD, :FEC);
            end
        EXECUTE PROCEDURE lee_configuracion('COMPRAS', 'FACTURAS', 'ACTUALIZAR COSTOS DE LA REMISION RELACIONADA AL GRABAR LA FACTURA') returning_values (:ACTREM);
        if ((ACTREM = 'SI') and (Tipo = 22)) then
            BEGIN
            numrows = 0;
            select mvar_cons, MVAR_ITEM, MVAR_FECHA, MVAR_IDREF, MVAR_CANT, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO
                from movimiento_articulo M, consolidado_faltantes C
                where C.cofa_id = :CONSOLIDA AND mvar_tipodoc = 22 and mvar_idref = C.cofa_idori AND C.cofa_tipoori = 22 and m.arti_cod = new.arti_cod
                into :numrows, :iterem, :fecrem, :idrem, :cantrem, :loterem, :prefrem, :numrem;
            
            if (numrows <> 0) then
                BEGIN
                DELETE FROM MOVIMIENTO_ARTICULO WHERE MVAR_CONS = :numrows;
                INSERT INTO MOVIMIENTO_ARTICULO
                    (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
                    VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :fecrem, 22, :idrem,
                    :CONC, :cantrem, :costo, 'S', :loterem, :prefrem, :numrem, :iterem, :Nit);
        
                if (COSTO > 0 ) then
                    BEGIN
                    /* ACTUALICE EL COSTO POR PROVEEDOR */
                    SELECT PVAR_FECHA FROM PROVEEDOR_ARTICULO
                        WHERE TERC_NIT = :Nit AND ARTI_COD = NEW.ARTI_COD
                        INTO :FECAUX;
                    if (FECAUX IS NULL) then
                        INSERT INTO PROVEEDOR_ARTICULO (TERC_NIT, ARTI_COD, PVAR_COSTO, PVAR_FECHA, PVAR_COD,PVAR_DES)
                            VALUES (:Nit, NEW.ARTI_COD, :COSTO, :fec, NEW.fcde_codprov,NEW.fcde_desc);
                    else
                        UPDATE PROVEEDOR_ARTICULO
                            SET PVAR_COSTO = :COSTO, PVAR_FECHA = :fec, PVAR_COD = NEW.fcde_codprov
                            WHERE ARTI_COD = NEW.ARTI_COD AND TERC_NIT = :Nit;
                    END
                /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
                EXECUTE PROCEDURE CALCULA_PRECIOS(NEW.ARTI_COD, :FEC);
                END
            END

        if (CONSOLIDA <> 0) then
            begin
            UPDATE consolidado_faltantes SET COFA_OK = 'S' WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod;
            EXECUTE procedure LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','SUMAR CANTIDADES PENDIENTES AL CONSOLIDAR DOCUMENTOS') returning_values (CONSO);
            /* IGNORE LA CONSOLIDACION SI SE VALIDAN CODIGOS DE LA ORDEN */
            SELECT MIN(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
            if (NUMROWS = 23) then
                BEGIN
                EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'VERIFICAR CODIGOS DE LA ORDEN') returning_values (MENORV);
                if (MENORV = 'SI') then
                    CONSO = 'NO';
                END
            SELECT COUNT(CEFA_ITEM) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
            if ((CONSO = 'SI') AND (NUMROWS > 1)) then
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.faco_id, COFA_OK = 'S' WHERE COFA_ID = :consolida;
            else
                BEGIN
                /* BUSQUE EL CONSOLIDADO EN EL MISMO ITEM Y SI ES DIFERENTE ACTUALICELO */
                select COFA_CANT * COFA_FACTOR FROM consolidado_faltantes WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod INTO :CANTREL;
                if (NEW.FCDE_CANT * NEW.FCDE_FACTOR < CANTREL) then
                    UPDATE consolidado_faltantes SET COFA_IDDES = NEW.faco_id, COFA_CANT = NEW.FCDE_CANT, COFA_FACTOR = NEW.FCDE_FACTOR
                        WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod;
                END
            end
        END
    end
END
^

SET TERM ; ^


/* incluir cruces en abonos de documentos */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE ABONOS_DOCUMENTO_CARTERA(
    TIPO INTEGER,
    ID INTEGER)
RETURNS (
    TIPOAB INTEGER,
    IDAB INTEGER,
    TIPODOC VARCHAR(8),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    ABONO NUMERIC(18,2),
    RETES NUMERIC(18,2))
AS
begin
TIPOAB = 61;
TIPODOC = 'RECICAJA';
FOR SELECT D.RECA_ID, PREF_PRE, RECA_NUMERO, RECA_FECHA, RCDE_ABONO + RCDE_DTOF, RCDE_RTFTE+RCDE_RTIVA+RCDE_RTICA
    FROM RECIBOS_CAJA_DETALLE D, RECIBOS_CAJA R WHERE R.reca_id = D.RECA_ID AND RCDE_TIPODOC = :TIPO AND RCDE_IDDOC = :id AND RECA_ANULADO = 'N'
    INTO :idab, :PREFIJO, :NUMERO, :FECHA, :abono, :retes
    DO
    suspend;
TIPOAB = 43;
TIPODOC = 'APLICACL';
FOR SELECT D.APCL_ID, PREF_PRE, APCL_NUMERO, APCL_FECHA, ACDE_APLICADO, ACDE_RTFTE+ACDE_RTIVA+ACDE_RTICA
    FROM APLICACION_CLIENTE_DETALLE D, APLICACION_CLIENTE A WHERE A.apcl_id = D.APCL_ID AND ACDE_TIPODOC = :TIPO AND ACDE_IDDOC = :id AND APCL_ANULADO = 'N'
    INTO :idab, :PREFIJO, :NUMERO, :FECHA, :abono, :retes
    DO
    suspend;
TIPOAB = 62;
TIPODOC = 'EGRESO';
FOR SELECT E.egre_id, PREF_PRE, EGRE_NUMERO, EGRE_FECHA, D.egcc_abono+D.egcc_dtof, D.egcc_rtfte+D.egcc_rtiva+D.egcc_rtica
    FROM EGRESOS_CRUCEC D, EGRESOS E WHERE E.egre_id = D.egre_id AND EGCC_TIPODOC = :TIPO AND EGCC_IDDOC = :id AND EGRE_ANULADO = 'N'
    INTO :idab, :PREFIJO, :NUMERO, :FECHA, :abono, :retes
    DO
    suspend;
end
^

SET TERM ; ^


SET TERM ^ ;

CREATE OR ALTER PROCEDURE ABONOS_DOCUMENTO_CXPAGAR(
    TIPO INTEGER,
    ID INTEGER)
RETURNS (
    TIPOAB INTEGER,
    IDAB INTEGER,
    TIPODOC VARCHAR(8),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    ABONO NUMERIC(18,2),
    RETES NUMERIC(18,2))
AS
begin
TIPOAB = 62;
TIPODOC = 'EGRESO';
FOR SELECT D.EGRE_ID, PREF_PRE, EGRE_NUMERO, EGRE_FECHA, EGDE_ABONO + EGDE_DTOF, EGDE_RTFTE+EGDE_RTIVA+EGDE_RTICA
    FROM EGRESOS_DETALLE D, EGRESOS E WHERE E.EGRE_ID = D.EGRE_ID AND EGDE_TIPODOC = :TIPO AND EGDE_IDDOC = :id AND EGRE_ANULADO = 'N'
    INTO :idab, :PREFIJO, :NUMERO, :FECHA, :abono, :retes
    DO
    suspend;
TIPOAB = 53;
TIPODOC = 'APLICAPR';
FOR SELECT D.APPR_ID, PREF_PRE, APPR_NUMERO, APPR_FECHA, APPD_APLICADO, APPD_RTFTE+APPD_RTIVA+APPD_RTICA
    FROM APLICACION_PROVEEDOR_DETALLE D, APLICACION_PROVEDOR A WHERE A.appr_id = D.APPR_ID AND APPD_TIPODOC = :TIPO AND APPD_IDDOC = :id AND APPR_ANULADO = 'N'
    INTO :idab, :PREFIJO, :NUMERO, :FECHA, :abono, :retes
    DO
    suspend;
TIPOAB = 61;
TIPODOC = 'RECIBO';
FOR SELECT R.reca_id, PREF_PRE, RECA_NUMERO, RECA_FECHA, D.rccr_abono + D.rccr_dtof, D.rccr_rtfte+D.rccr_rtiva+D.rccr_rtica
    FROM recibos_caja_crucec D, recibos_caja R WHERE R.reca_id = D.reca_id AND D.rccr_tipodoc = :TIPO AND D.rccr_iddoc = :id AND RECA_ANULADO = 'N'
    INTO :idab, :PREFIJO, :NUMERO, :FECHA, :abono, :retes
    DO
    suspend;
end
^

SET TERM ; ^


/* chequeo caja inicial y final */
 SET TERM ^ ;

CREATE OR ALTER PROCEDURE CHEQUEO_SALDOS_CAJAS (
    CAJAINI INTEGER,
    CAJAFIN INTEGER)
AS
declare variable ID INTEGER;
declare variable Fec date;
declare variable Caja integer;
declare variable Conc VARCHAR(60);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable FORMA INTEGER;
declare variable BANCO VARCHAR(2);
declare variable CUENTA VARCHAR(20);
declare variable NUMERO VARCHAR(20);
declare variable FECHA DATE;
declare variable MONTO NUMERIC(18,2);
declare variable Existe INTEGER;
declare variable Dest INTEGER;
declare variable idref INTEGER;
begin
/* BORRE LOS MOVIMIENTOS CAJA, LOS DOCUMENTOS PAGO CAJA Y SALDO EFECTIVO */
DELETE FROM ANTICIPOS_CLIENTE WHERE RECA_ID = 0;
DELETE FROM ANTICIPOS_PROVEEDOR WHERE EGRE_ID = 0;
UPDATE DOCUMENTOS_PAGO_CAJA SET dpca_idsal = 0 WHERE CAJA_ID >= :cajaini AND CAJA_ID <= :cajafin;
DELETE FROM MOVIMIENTO_CAJA WHERE CAJA_ID >= :cajaini AND CAJA_ID <= :cajafin;
DELETE FROM DOCUMENTOS_PAGO_CAJA WHERE CAJA_ID >= :cajaini AND CAJA_ID <= :cajafin;
DELETE FROM SALDO_EFECTIVO WHERE CAJA_ID >= :cajaini AND CAJA_ID <= :cajafin;
DELETE FROM saldo_caja WHERE CAJA_ID >= :cajaini AND CAJA_ID <= :cajafin;

/* INCORPORE LOS RECIBOS DE CAJA */
FOR SELECT R.RECA_ID, reca_fecha, caja_id, reca_conc, pref_pre, reca_numero, FOPA_ID, RCPA_BANCO, RCPA_CUENTA, RCPA_NUMERO, RCPA_FECHA, RCPA_MONTO
    FROM recibos_caja R, RECIBOS_CAJA_PAGO P where R.reca_id = P.reca_id and reca_anulado = 'N' AND CAJA_ID >= :cajaini AND CAJA_ID <= :cajafin
    ORDER BY CAJA_ID, R.RECA_FECHA, R.RECA_ID, RCPA_ITEM
    INTO :ID, :Fec, :Caja, :Conc, :Pref, :Num, :forma,  :banco, :cuenta, :numero, :fecha, :monto
    DO
    BEGIN
    select COUNT(*) from movimiento_caja where moca_tiporef = 61 and moca_idref = :id into :Existe;
    if (Existe > 0) then
        update movimiento_caja
        set moca_debitos = moca_debitos + :monto
        where moca_tiporef = 61 and moca_idref = :id;
    else
        INSERT INTO MOVIMIENTO_CAJA
            (MOCA_ID, CAJA_ID, MOCA_TIPOREF, MOCA_PREFREF, MOCA_NUMREF, MOCA_FECHA, MOCA_CONC, MOCA_DEBITOS, MOCA_CREDITOS, MOCA_DB, MOCA_IDREF)
            VALUES(GEN_ID(id_movcaja,1), :Caja, 61, :Pref, :Num, :Fec, :Conc, :monto, 0, 'S', :id);
        /* GRABE EL DOCUMENTO DE PAGO EN CAJA */
        if (FORMA <> 1) then
            INSERT INTO DOCUMENTOS_PAGO_CAJA (DPCA_ID, FOPA_ID, CAJA_ID, DPCA_BANCO, DPCA_CUENTA, DPCA_NUMERO, DPCA_FECHA, DPCA_MONTO, DPCA_TIPOENT, DPCA_IDENT, DPCA_TIPOSAL, DPCA_IDSAL)
                VALUES (GEN_ID(ID_DOCPAGOCAJA, 1), :FORMA, :CAJA, :BANCO, :CUENTA, :NUMERO, :FECHA, :MONTO, 61, :ID, 0, 0);
        ELSE
            EXECUTE PROCEDURE SUME_SALDO_EFECTIVO (:CAJA, :FEC, :MONTO, 'N');
    END

/* LOS EGRESOS POR TRASLADO A CAJA */
for SELECT EGRE_ID, CAJA_ID, PREF_PRE, EGRE_NUMERO, EGRE_FECHA, EGRE_CONC, EGRE_MONTO FROM EGRESOS
    WHERE EGRE_TIPO = '2' AND CAJA_ID <> 0 AND egre_id <> 0 AND egre_anulado = 'N' AND CAJA_ID >= :cajaini AND CAJA_ID <= :cajafin
    ORDER BY CAJA_ID, EGRE_FECHA
    INTO :ID, :CAJA, :PREF, :NUM, :FEC, :CONC, :MONTO
    DO
    BEGIN
    SELECT MOCA_IDREF FROM movimiento_caja WHERE MOCA_TIPOREF = 62 AND MOCA_IDREF = :ID INTO :idref;
    if (idref IS NULL) then
     BEGIN
     INSERT INTO MOVIMIENTO_CAJA
        (MOCA_ID, CAJA_ID, MOCA_TIPOREF, MOCA_PREFREF, MOCA_NUMREF, MOCA_FECHA, MOCA_CONC, MOCA_DEBITOS, MOCA_CREDITOS, MOCA_DB, MOCA_IDREF)
        VALUES(GEN_ID(id_movcaja,1), :CAJA, 62, :PREF, :NUM, :FEC, :CONC, :MONTO, 0, 'S', :ID);
      /* GRABE EL DOCUMENTO DE PAGO EN CAJA */
      EXECUTE PROCEDURE SUME_SALDO_EFECTIVO (:caja, :fec, :monto, 'N');
     END
    END
/* LOS CAMBIOS */
FOR SELECT C.CADO_ID, cado_fecha, cado_conc, pref_pre, cado_numero, caja_id, FOPA_ID, CDSA_BANCO, CDSA_CUENTA, CDSA_NUMERO, CDSA_FECHA, CDSA_MONTO
    FROM CAMBIO_DOCUMENTOS C, CAMBIODOC_SALIDAS D where C.CADO_ID = D.CADO_ID and cado_anulado = 'N' AND CAJA_ID >= :cajaini AND CAJA_ID <= :cajafin
    ORDER BY CAJA_ID, C.CADO_FECHA, C.CADO_ID, CDSA_ITEM
    INTO :ID, :Fec, :Conc, :Pref, :Num, :Caja, :forma, :banco, :cuenta, :numero, :fecha, :monto
    DO
    BEGIN
    select COUNT(*) from movimiento_caja where moca_tiporef = 63 and moca_idref = :id and caja_id = :CAJA into :Existe;
    if (Existe > 0) then
        begin
        update movimiento_caja
            set moca_debitos = moca_debitos + :monto
            where moca_tiporef = 63 and moca_idref = :id and caja_id = :CAJA;
        end
    else
        INSERT INTO MOVIMIENTO_CAJA
            (MOCA_ID, CAJA_ID, MOCA_TIPOREF, MOCA_PREFREF, MOCA_NUMREF, MOCA_FECHA, MOCA_CONC, MOCA_DEBITOS, MOCA_CREDITOS, MOCA_DB, MOCA_IDREF)
            VALUES(GEN_ID(ID_MOVCAJA,1), :CAJA, 63, :Pref, :Num, :Fec, :Conc, :monto, 0, 'S', :id);
        
    if (FORMA <> 1) then
        INSERT INTO DOCUMENTOS_PAGO_CAJA (DPCA_ID, FOPA_ID, CAJA_ID, DPCA_BANCO, DPCA_CUENTA, DPCA_NUMERO, DPCA_FECHA, DPCA_MONTO, DPCA_TIPOENT, DPCA_IDENT, DPCA_TIPOSAL, DPCA_IDSAL)
            VALUES (GEN_ID(ID_DOCPAGOCAJA, 1), :FORMA, :CAJA, :BANCO, :CUENTA, :NUMERO, :FECHA, :MONTO, 63, :ID, 0, 0);
    ELSE
        EXECUTE PROCEDURE SUME_SALDO_EFECTIVO(:CAJA, :FEC, :MONTO, 'N');
    END
/* DEVOLUCIONES DE CHEQUES ojo fopa_id = 2 */
FOR SELECT DVCH_ID, dvch_fecha, caja_id, dvch_conc, prba_pref, dvch_numdoc, 2, DVCH_BANCO, DVCH_CUENTA, DVCH_NROCH, DVCH_FECCH, DVCH_MONTO
    FROM DEVOLUCION_CHEQUES where dvch_anulado = 'N' AND dvch_cartera <> 'S' AND CAJA_ID >= :cajaini AND CAJA_ID <= :cajafin
    ORDER BY CAJA_ID, DVCH_FECHA, DVCH_ID
    INTO :ID, :Fec, :Caja, :Conc, :Pref, :Num, :forma,  :banco, :cuenta, :numero, :fecha, :monto
    DO
    BEGIN
    select COUNT(*) from movimiento_caja where moca_tiporef = 77 and moca_idref = :id into :Existe;
    if (Existe > 0) then
        update movimiento_caja
        set moca_debitos = moca_debitos + :monto
        where moca_tiporef = 77 and moca_idref = :id;
    else
        INSERT INTO MOVIMIENTO_CAJA
            (MOCA_ID, CAJA_ID, MOCA_TIPOREF, MOCA_PREFREF, MOCA_NUMREF, MOCA_FECHA, MOCA_CONC, MOCA_DEBITOS, MOCA_CREDITOS, MOCA_DB, MOCA_IDREF)
            VALUES(GEN_ID(id_movcaja,1), :Caja, 77, :Pref, :Num, :Fec, :Conc, :monto, 0, 'S', :id);
        /* GRABE EL DOCUMENTO DE PAGO EN CAJA */
        INSERT INTO DOCUMENTOS_PAGO_CAJA (DPCA_ID, FOPA_ID, CAJA_ID, DPCA_BANCO, DPCA_CUENTA, DPCA_NUMERO, DPCA_FECHA, DPCA_MONTO, DPCA_TIPOENT, DPCA_IDENT, DPCA_TIPOSAL, DPCA_IDSAL)
            VALUES (GEN_ID(ID_DOCPAGOCAJA, 1), 2, :CAJA, :BANCO, :CUENTA, :NUMERO, :FECHA, :MONTO, 77, :ID, 0, 0);
    END

/* TRASLADOS ENTRE CAJAS */
FOR SELECT T.TRCJ_ID, trcj_fecha, caja_id, trcj_destino, trcj_conc, pref_pre, trcj_numero, fopa_id, TRCD_BANCO, TRCD_CUENTA, TRCD_NUMERO, TRCD_FECHA, TRCD_MONTO
    FROM TRASLADOS_CAJA T, TRASLADOS_CAJA_DET D where T.TRCJ_ID = D.TRCJ_ID AND trcj_anulado = 'N' AND CAJA_ID >= :cajaini AND CAJA_ID <= :cajafin
    ORDER BY CAJA_ID, TRCJ_FECHA, T.TRCJ_ID, TRCD_ITEM
    INTO :ID, :Fec, :Caja, :Dest, :Conc, :Pref, :Num, :forma,  :banco, :cuenta, :numero, :fecha, :monto
    DO
    BEGIN
    select COUNT(*) from movimiento_caja where moca_tiporef = 66 and moca_idref = :id and caja_id = :CAJA into :Existe;
    if (Existe > 0) then
        begin
        update movimiento_caja
            set moca_creditos = moca_creditos + :monto
            where moca_tiporef = 66 and moca_idref = :id and caja_id = :CAJA;
        end
    else
        INSERT INTO MOVIMIENTO_CAJA
            (MOCA_ID, CAJA_ID, MOCA_TIPOREF, MOCA_PREFREF, MOCA_NUMREF, MOCA_FECHA, MOCA_CONC, MOCA_DEBITOS, MOCA_CREDITOS, MOCA_DB, MOCA_IDREF)
            VALUES(GEN_ID(ID_MOVCAJA,1), :CAJA, 66, :Pref, :Num, :Fec, :Conc, 0, :monto, 'N', :id);
    /* Actualice la salida del documento en la caja origen */
    if (FORMA <> 1) then
        UPDATE DOCUMENTOS_PAGO_CAJA
            SET DPCA_TIPOSAL = 66, DPCA_IDSAL = :ID
            WHERE FOPA_ID = :FORMA AND DPCA_BANCO = :BANCO AND DPCA_CUENTA = :CUENTA AND
            DPCA_NUMERO = :NUMERO AND DPCA_TIPOSAL = 0 AND DPCA_IDSAL = 0;
    else
        EXECUTE PROCEDURE RESTE_SALDO_EFECTIVO (:CAJA, :Fec, :MONTO, 'N');
    /* AHORA EL INGRESO A LA CAJA DESTINO */
    select COUNT(*) from movimiento_caja where moca_tiporef = 66 and moca_idref = :id and caja_id = :Dest into :Existe;
    if (Existe > 0) then
        begin
        update movimiento_caja
            set moca_debitos = moca_debitos + :monto
            where moca_tiporef = 66 and moca_idref = :id and caja_id = :Dest;
        end
    else
        INSERT INTO MOVIMIENTO_CAJA
            (MOCA_ID, CAJA_ID, MOCA_TIPOREF, MOCA_PREFREF, MOCA_NUMREF, MOCA_FECHA, MOCA_CONC, MOCA_DEBITOS, MOCA_CREDITOS, MOCA_DB, MOCA_IDREF)
            VALUES(GEN_ID(ID_MOVCAJA,1), :Dest, 66, :Pref, :Num, :Fec, :Conc, :monto, 0, 'S', :id);
    /* Ingrese el doc. de pago */
    if (FORMA <> 1) then
        INSERT INTO DOCUMENTOS_PAGO_CAJA (DPCA_ID, FOPA_ID, CAJA_ID, DPCA_BANCO, DPCA_CUENTA, DPCA_NUMERO, DPCA_FECHA, DPCA_MONTO, DPCA_TIPOENT, DPCA_IDENT, DPCA_TIPOSAL, DPCA_IDSAL)
            VALUES (GEN_ID(ID_DOCPAGOCAJA, 1), :FORMA, :Dest, :BANCO, :CUENTA, :NUMERO, :FECHA, :MONTO, 66, :ID, 0, 0);
    else
        EXECUTE PROCEDURE SUME_SALDO_EFECTIVO (:Dest, :Fec, :MONTO, 'N');
    END

/* INCORPORE LOS EGRESOS DE CAJA */
FOR SELECT E.EGRE_ID, egre_fecha, egre_conc, pref_pre, egre_numero, C.caja_id, FOPA_ID, EGCA_BANCO, EGCA_CUENTA, EGCA_NUMERO, EGCA_FECHA, EGCA_MONTO
    FROM EGRESOS E, EGRESOS_CAJA C where E.egre_id = C.egre_id and egre_anulado = 'N' AND C.CAJA_ID >= :cajaini AND C.CAJA_ID <= :cajafin
    ORDER BY CAJA_ID, E.EGRE_FECHA, E.EGRE_ID, EGCA_ITEM
    INTO :ID, :Fec, :Conc, :Pref, :Num, :Caja, :forma, :banco, :cuenta, :numero, :fecha, :monto
    DO
    BEGIN
    select COUNT(*) from movimiento_caja where moca_tiporef = 62 and moca_idref = :id and caja_id = :caja into :Existe;
    if (Existe > 0) then
        update movimiento_caja
        set moca_creditos = moca_creditos + :monto
        where moca_tiporef = 62 and moca_idref = :id and caja_id = :caja;
    else
        INSERT INTO MOVIMIENTO_CAJA
            (MOCA_ID, CAJA_ID, MOCA_TIPOREF, MOCA_PREFREF, MOCA_NUMREF, MOCA_FECHA, MOCA_CONC, MOCA_DEBITOS, MOCA_CREDITOS, MOCA_DB, MOCA_IDREF)
            VALUES(GEN_ID(ID_MOVCAJA,1), :caja, 62, :Pref, :Num, :Fec, :Conc, 0, :monto, 'N', :id);
    /* ACTUALICE LA SALIDA DEL DOCUMENTO */
    if (FORMA <> 1) then
        UPDATE DOCUMENTOS_PAGO_CAJA
            SET DPCA_TIPOSAL = 62, DPCA_IDSAL = :ID
            WHERE FOPA_ID = :FORMA AND DPCA_BANCO = :BANCO AND DPCA_CUENTA = :CUENTA AND
            DPCA_NUMERO = :NUMERO AND DPCA_TIPOSAL = 0 AND DPCA_IDSAL = 0;
    ELSE
        EXECUTE PROCEDURE RESTE_SALDO_EFECTIVO(:CAJA, :FEC, :MONTO, 'N');
    END

/* INCORPORE LAS CONSIGNACIONES */
FOR SELECT C.CONS_ID, cons_fecha, cons_concepto, prba_pref, cons_numero, caja_id, FOPA_ID, CODE_BANCO, CODE_CUENTA, CODE_NUMERO, CODE_FECHA, CODE_MONTO
    FROM CONSIGNA C, CONSIGNA_DETALLE D where C.CONS_ID = D.CONS_ID and cons_anulado = 'N' AND CAJA_ID >= :cajaini AND CAJA_ID <= :cajafin
    ORDER BY CAJA_ID, C.CONS_FECHA, C.CONS_ID, CODE_ITEM2
    INTO :ID, :Fec, :Conc, :Pref, :Num, :Caja, :forma, :banco, :cuenta, :numero, :fecha, :monto
    DO
    BEGIN
    select COUNT(*) from movimiento_caja where moca_tiporef = 71 and moca_idref = :id and caja_id = :caja into :Existe;
    if (Existe > 0) then
        update movimiento_caja
            set moca_creditos = moca_creditos + :monto
            where moca_tiporef = 71 and moca_idref = :id and caja_id = :caja;
    else
        INSERT INTO MOVIMIENTO_CAJA
            (MOCA_ID, CAJA_ID, MOCA_TIPOREF, MOCA_PREFREF, MOCA_NUMREF, MOCA_FECHA, MOCA_CONC, MOCA_DEBITOS, MOCA_CREDITOS, MOCA_DB, MOCA_IDREF)
            VALUES(GEN_ID(ID_MOVCAJA,1), :CAJA, 71, :Pref, :Num, :Fec, :Conc, 0, :monto, 'N', :id);
    /* ACTUALICE LA SALIDA DEL DOCUMENTO DE PAGO */
    if (FORMA <> 1) then
        UPDATE DOCUMENTOS_PAGO_CAJA
            SET DPCA_TIPOSAL = 71, DPCA_IDSAL = :id
            WHERE FOPA_ID = :FORMA AND DPCA_BANCO = :BANCO AND DPCA_CUENTA = :CUENTA AND
            DPCA_NUMERO = :NUMERO AND DPCA_TIPOSAL = 0 AND DPCA_IDSAL = 0;
    ELSE
        EXECUTE PROCEDURE RESTE_SALDO_EFECTIVO(:CAJA, :FEC, :MONTO, 'N');
    END

/* CONSIGNACIONES DE TARJETAS */
FOR SELECT C.COTJ_ID, cotj_fecha, cotj_concepto, pref_pre, cotj_numero, caja_id, FOPA_ID, TARJ_COD, CTJD_NROTJ, CTJD_COMPROB, COTJ_FECHA, CTJD_BASE
    FROM CONSIGNA_TARJETAS C, CONSIGNA_TARJETAS_DET D where C.cotj_id = D.cotj_id and cotj_anulado = 'N' AND CAJA_ID >= :cajaini AND CAJA_ID <= :cajafin
    ORDER BY CAJA_ID, C.COTJ_FECHA, C.cotj_id, CTJD_ITEM
    INTO :ID, :Fec, :Conc, :Pref, :Num, :Caja, :forma, :banco, :cuenta, :numero, :fecha, :monto
    DO
    BEGIN
    select COUNT(*) from movimiento_caja where moca_tiporef = 64 and moca_idref = :id into :Existe;
    if (Existe > 0) then
        update movimiento_caja
            set moca_creditos = moca_creditos + :monto
            where moca_tiporef = 64 and moca_idref = :id;
    else
        INSERT INTO MOVIMIENTO_CAJA
            (MOCA_ID, CAJA_ID, MOCA_TIPOREF, MOCA_PREFREF, MOCA_NUMREF, MOCA_FECHA, MOCA_CONC, MOCA_DEBITOS, MOCA_CREDITOS, MOCA_DB, MOCA_IDREF)
            VALUES(GEN_ID(ID_MOVCAJA,1), :Caja, 64, :Pref, :Num, :Fec, :Conc, 0, :monto, 'N', :id);

  /* ACTUALICE LA SALIDA DEL DOCUMENTO DE PAGO */
  UPDATE DOCUMENTOS_PAGO_CAJA
    SET DPCA_TIPOSAL = 64, DPCA_IDSAL = :id
    WHERE FOPA_ID = :FORMA AND DPCA_BANCO = :BANCO AND DPCA_CUENTA = :CUENTA AND
    DPCA_NUMERO = :NUMERO AND DPCA_TIPOSAL = 0 AND DPCA_IDSAL = 0;
  end

/* INCORPORE LOS CAMBIOS DE DOCUMENTOS */
FOR SELECT C.CADO_ID, cado_fecha, cado_conc, pref_pre, cado_numero, caja_id, FOPA_ID, CDEN_BANCO, CDEN_CUENTA, CDEN_NUMERO, CDEN_FECHA, CDEN_MONTO
    FROM CAMBIO_DOCUMENTOS C, CAMBIODOC_ENTRADAS D where C.CADO_ID = D.CADO_ID and cado_anulado = 'N' AND CAJA_ID >= :cajaini AND CAJA_ID <= :cajafin
    ORDER BY CAJA_ID, C.CADO_FECHA, C.CADO_ID, CDEN_ITEM
    INTO :ID, :Fec, :Conc, :Pref, :Num, :Caja, :forma, :banco, :cuenta, :numero, :fecha, :monto
    DO
    BEGIN
    select COUNT(*) from movimiento_caja where moca_tiporef = 63 and moca_idref = :id and caja_id = :CAJA into :Existe;
    if (Existe > 0) then
        begin
        update movimiento_caja
            set moca_creditos = moca_creditos + :monto
            where moca_tiporef = 63 and moca_idref = :id and caja_id = :CAJA;
        end
    else
        INSERT INTO MOVIMIENTO_CAJA
            (MOCA_ID, CAJA_ID, MOCA_TIPOREF, MOCA_PREFREF, MOCA_NUMREF, MOCA_FECHA, MOCA_CONC, MOCA_DEBITOS, MOCA_CREDITOS, MOCA_DB, MOCA_IDREF)
            VALUES(GEN_ID(ID_MOVCAJA,1), :CAJA, 63, :Pref, :Num, :Fec, :Conc, 0, :monto, 'N', :id);
        
    /* ACTUALICE LA SALIDA DEL DOCUMENTO */
    if (FORMA <> 1) then
        UPDATE DOCUMENTOS_PAGO_CAJA
            SET DPCA_TIPOSAL = 63, DPCA_IDSAL = :id
            WHERE FOPA_ID = :FORMA AND DPCA_BANCO = :BANCO AND DPCA_CUENTA = :CUENTA AND
            DPCA_NUMERO = :NUMERO AND DPCA_TIPOSAL = 0 AND DPCA_IDSAL = 0;
    ELSE
        EXECUTE PROCEDURE RESTE_SALDO_EFECTIVO(:CAJA, :FEC, :MONTO, 'N');
    END
end
^

SET TERM ; ^



/* anular cruces al anular recibos y egresos */
SET TERM ^ ;

CREATE OR ALTER TRIGGER EGRESOS_AU FOR EGRESOS
ACTIVE AFTER UPDATE POSITION 0
as
declare variable consec INTEGER;
begin
/* BORRE LA CONTABILIZACION */
if (NEW.EGRE_ANULADO = 'S') then
    BEGIN
    select enco_consec from comprobante_encabezado where enco_tiporef = 62 and enco_idref = old.egre_id into :consec;
    if (NOT consec is null) then
      delete from comprobante_detalle where enco_consec = :consec;
    delete from comprobante_encabezado where enco_tiporef = 62 and enco_idref = old.egre_id;    
    INSERT INTO AUDITORIA(audi_usuario, TIDO_COD, AUDI_IDDOC, AUDI_OPER, AUDI_COD)
        VALUES (USER, 62, NEW.egre_id, 'A', NEW.pref_pre || NEW.egre_numero);
    END
/* BORRE EL ANTERIOR Y GRABE EL NUEVO */
if ((OLD.egre_id <> 0) AND (OLD.egre_anulado = 'N')) then
    BEGIN
    if ((OLD.EGRE_TIPO = '2') AND OLD.CAJA_ID <> 0) then
        BEGIN
        DELETE FROM MOVIMIENTO_CAJA WHERE MOCA_TIPOREF = 62 AND MOCA_IDREF = OLD.EGRE_ID;
        /* GRABE EL DOCUMENTO DE PAGO EN CAJA */
        EXECUTE PROCEDURE SUME_SALDO_EFECTIVO (OLD.caja_id, OLD.egre_fecha, OLD.egre_monto, 'S');
        END
    end
if ((NEW.EGRE_ID <> 0)  AND (NEW.egre_anulado = 'N')) then
    BEGIN
    if ((NEW.EGRE_TIPO = '2') AND NEW.CAJA_ID <> 0) then
        BEGIN
        INSERT INTO MOVIMIENTO_CAJA
            (MOCA_ID, CAJA_ID, MOCA_TIPOREF, MOCA_PREFREF, MOCA_NUMREF, MOCA_FECHA, MOCA_CONC, MOCA_DEBITOS, MOCA_CREDITOS, MOCA_DB, MOCA_IDREF)
            VALUES(GEN_ID(id_movcaja,1), NEW.CAJA_ID, 62, NEW.PREF_PRE, NEW.EGRE_NUMERO, NEW.EGRE_FECHA, NEW.EGRE_CONC, NEW.EGRE_MONTO, 0, 'S', new.EGRE_ID);
        /* GRABE EL DOCUMENTO DE PAGO EN CAJA */
        EXECUTE PROCEDURE SUME_SALDO_EFECTIVO (NEW.caja_id, NEW.egre_fecha, NEW.egre_monto, 'N');
        END
    INSERT INTO AUDITORIA(AUDI_USUARIO, TIDO_COD, AUDI_IDDOC, AUDI_OPER, AUDI_COD)
        VALUES (USER, 62, NEW.egre_id, 'U', NEW.pref_pre || NEW.egre_numero);
    END
/* si hubo un cambio critico afecte los detalles */
if ((OLD.pref_pre <> NEW.pref_pre) or
    (OLD.egre_numero <> NEW.egre_numero) or
    (OLD.egre_fecha <> NEW.egre_fecha)) then
    BEGIN
    UPDATE EGRESOS_CAJA SET EGCA_TRANSMIT = 'N' WHERE EGRE_ID = NEW.EGRE_ID;
    UPDATE EGRESOS_BANCO SET EGBC_TRANSMIT = 'N' WHERE EGRE_ID = NEW.EGRE_ID;
    UPDATE EGRESOS_DETALLE SET EGDE_TRANSMIT = 'N' WHERE EGRE_ID = NEW.EGRE_ID;
    UPDATE egresos_crucec SET EGCC_TRANSMIT = 'N' WHERE EGRE_ID = NEW.EGRE_ID;
    END
/* ANULE LOS DETALLES */
if (OLD.egre_anulado <> NEW.egre_anulado) then
    BEGIN
    UPDATE egresos_caja SET EGCA_ANULADO = NEW.EGRE_anulado WHERE EGRE_ID = NEW.EGRE_ID;
    UPDATE egresos_banco SET EGBC_ANULADO = NEW.EGRE_anulado WHERE EGRE_ID = NEW.EGRE_ID;
    UPDATE egresos_detalle SET EGDE_ANULADO = NEW.EGRE_anulado WHERE EGRE_ID = NEW.EGRE_ID;
    UPDATE egresos_crucec SET EGCC_ANULADO = NEW.EGRE_anulado WHERE EGRE_ID = NEW.EGRE_ID;
    END
/* TRASMITA LOS DETALLES */
if (OLD.EGRE_transmit <> NEW.EGRE_transmit) then
    BEGIN
    UPDATE EGRESOS_CAJA SET EGCA_TRANSMIT = NEW.EGRE_TRANSMIT WHERE EGRE_ID = NEW.EGRE_ID;
    UPDATE EGRESOS_BANCO SET EGBC_TRANSMIT = NEW.EGRE_TRANSMIT WHERE EGRE_ID = NEW.EGRE_ID;
    UPDATE EGRESOS_DETALLE SET EGDE_TRANSMIT = NEW.EGRE_TRANSMIT WHERE EGRE_ID = NEW.EGRE_ID;
    UPDATE egresos_crucec SET EGCC_TRANSMIT = NEW.EGRE_TRANSMIT WHERE EGRE_ID = NEW.EGRE_ID;
    END
end
^

SET TERM ; ^


SET TERM ^ ;

CREATE OR ALTER TRIGGER RECIBOS_CAJA_AU FOR RECIBOS_CAJA
ACTIVE AFTER UPDATE POSITION 0
AS
declare variable consec INTEGER;
BEGIN
/* Borre la contabilizacion */
if (new.reca_anulado = 'S') then
    begin
    select enco_consec from comprobante_encabezado where enco_tiporef = 61 and enco_idref = old.reca_id into :consec;
    if (NOT consec is null) then
      delete from comprobante_detalle where enco_consec = :consec;
    delete from comprobante_encabezado where enco_tiporef = 61 and enco_idref = old.reca_id;
    INSERT INTO AUDITORIA(AUDI_USUARIO, TIDO_COD, AUDI_IDDOC, AUDI_OPER, AUDI_COD)
        VALUES (USER, 61, NEW.reca_id, 'A', NEW.pref_pre || NEW.reca_numero);
    end

/* si existia un recibo provisional borrelo */
if ((old.reca_id <> 0) and (old.reca_anulado = 'N')) then
    if ((old.reca_provid is not null) and (old.reca_provid <> 0)) then
        update recibo_provisional set rcpr_idcruce = 0, rcpr_feccruce = null where rcpr_id = old.reca_provid;
if ((new.reca_id <> 0) and (new.reca_anulado = 'N')) then
    BEGIN
    if ((new.reca_provid is not null) and (new.reca_provid <> 0)) then
        update recibo_provisional set rcpr_idcruce = new.reca_id, rcpr_feccruce = new.reca_fecha where rcpr_id = new.reca_provid;
    INSERT INTO AUDITORIA(AUDI_USUARIO, TIDO_COD, AUDI_IDDOC, AUDI_OPER, AUDI_COD)
        VALUES (USER, 61, NEW.reca_id, 'U', NEW.pref_pre || NEW.reca_numero);
    END
/* si cambio fecha o numero actualice detalles */
if ((OLD.pref_pre <> NEW.pref_pre) or
    (OLD.reca_numero <> NEW.reca_numero) or
    (OLD.reca_fecha <> NEW.reca_fecha)) then
    BEGIN
    UPDATE recibos_caja_pago SET RCPA_TRANSMIT = 'N' WHERE RECA_ID = NEW.RECA_ID;
    UPDATE recibos_caja_detalle SET RCDE_TRANSMIT = 'N' WHERE RECA_ID = NEW.RECA_ID;
    UPDATE recibos_caja_crucec SET RCCR_TRANSMIT = 'N' WHERE RECA_ID = NEW.RECA_ID;
    END
/* ACTUALICE EL ANULADO EN LOS DETALLES */
if (OLD.RECA_anulado <> NEW.RECA_anulado) then
    BEGIN
    UPDATE recibos_caja_pago SET RCPA_ANULADO = NEW.RECA_anulado WHERE RECA_ID = NEW.RECA_ID;
    UPDATE recibos_caja_detalle SET RCDE_ANULADO = NEW.RECA_anulado WHERE RECA_ID = NEW.RECA_ID;
    UPDATE recibos_caja_crucec SET RCCR_ANULADO = NEW.RECA_anulado WHERE RECA_ID = NEW.RECA_ID;
    END
if (OLD.reca_transmit <> NEW.reca_transmit) then
    BEGIN
    UPDATE recibos_caja_pago SET RCPA_TRANSMIT = NEW.reca_transmit WHERE RECA_ID = NEW.RECA_ID;
    UPDATE recibos_caja_detalle SET RCDE_TRANSMIT = NEW.reca_transmit WHERE RECA_ID = NEW.RECA_ID;
    UPDATE recibos_caja_crucec SET RCCR_TRANSMIT = NEW.reca_transmit WHERE RECA_ID = NEW.RECA_ID;
    END
END
^

SET TERM ; ^

alter table RECIBOS_CAJA_CRUCEC add constraint FK_RECIBOS_CAJA_CRUCEC_1
foreign key (RECA_ID) references RECIBOS_CAJA(RECA_ID) on delete CASCADE on update CASCADE;

alter table EGRESOS_CRUCEC add constraint FK_EGRESOS_CRUCEC_1
foreign key (EGRE_ID) references EGRESOS(EGRE_ID) on delete CASCADE on update CASCADE;


/* revisa precios con marcas */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE REVISA_PRECIOS(
    LISTA INTEGER,
    FECHA DATE)
RETURNS (
    ARTICULO VARCHAR(20),
    DESCR VARCHAR(60),
    FIJO NUMERIC(18,2),
    UNIDAD VARCHAR(8),
    PORC NUMERIC(9,4),
    SUGERIDO NUMERIC(18,2),
    DIFER NUMERIC(18,2),
    NUEVO NUMERIC(18,2),
    OK CHAR(1))
AS
declare variable marg numeric(9,4);
declare variable UOM VARCHAR(10);
declare variable BASE VARCHAR(10);
declare variable CAMBIO VARCHAR(10);
declare variable COSTO numeric(18,2);
declare variable COSTOP numeric(18,2);
declare variable COSTOU numeric(18,2);
declare variable DIFMAX numeric(18,2);
declare variable DIG INTEGER;
declare variable TARIVA NUMERIC(9,4);
declare variable IVAINC CHAR(1);
declare variable LISTAREF INTEGER;
begin
execute procedure lee_configuracion ('FACTURACION', 'ARTICULOS', 'SUGERIR PRECIOS CON PORCENTAJE DE MARGEN O UTILIDAD') returning_values (:UOM);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'ARTICULOS', 'REDONDEO AL MULTIPLO DE DIEZ EN PRECIOS') RETURNING_VALUES (:DIG);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','CAMBIO DE PRECIOS AUTOMATICO AL CAMBIAR COSTO O PRECIO') returning_values (CAMBIO);
EXECUTE PROCEDURE lee_configuracion('FACTURACION','ARTICULOS','COSTO BASE PARA CALCULO DE PRECIOS DE VENTA AUTOMATICOS') returning_values (:BASE);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','CODIGO DE LA LISTA DE PRECIOS BASE PARA CAMBIO DE PRECIOS AUTOMATICO') returning_values (LISTAREF);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','DIFERENCIA EN PESOS MAXIMA A PERMITIR PARA CAMBIAR PRECIOS') returning_values (DIFMAX);
for select A.arti_cod, A.arti_des, A.arti_unidad, prar_fijo, prar_margen, prar_util, TAIV_PORC
    from precios_articulo p, articulo a, tarifa_iva T
    where a.arti_cod = p.arti_cod and lipr_cod = :lista and a.taiv_cod = t.taiv_cod order by A.arti_cod
    into :articulo, descr, :unidad, :fijo, :marg, :porc, :tariva
    do
    begin
    if (UOM <> 'UTILIDAD') then
        PORC = MARG;
    if (CAMBIO = 'COSTO') then
        BEGIN
        EXECUTE PROCEDURE COSTO_PROMEDIO (:ARTICULO, :FECHA) RETURNING_VALUES(:COSTOP);
        EXECUTE PROCEDURE ULTIMO_COSTO (:ARTICULO, :FECHA, :UNIDAD) RETURNING_VALUES(:COSTOU);
        if (base = 'ULTIMO') then
            COSTO = COSTOU;
        ELSE
            BEGIN
            COSTO = COSTOP;
            if (base = 'MAYOR') then
                if (COSTOP < COSTOU) then
                    COSTO = COSTOU;
            END
        SELECT LIPR_MODIF FROM LISTA_PRECIOS WHERE LIPR_COD = :lista INTO :IVAINC;
        if (IVAINC = 'S') then
            COSTO = COSTO * (1 + TARIVA/100);
        if (UOM = 'UTILIDAD') then
            SUGERIDO = COSTO * (1 + :PORC/100);
        ELSE
            SUGERIDO = COSTO / (1 - :PORC/100);
        END
    ELSE
        if (LISTA <> LISTAREF) then
            BEGIN
            SELECT PRAR_FIJO FROM PRECIOS_ARTICULO WHERE ARTI_COD = :articulo AND LIPR_COD = :LISTAREF INTO :SUGERIDO;
            if (IVAINC = 'S') then
                SUGERIDO = SUGERIDO / (1 + TARIVA/100);
            if (UOM = 'UTILIDAD') then
                SUGERIDO = SUGERIDO * (1 + :PORC/100);
            ELSE
                SUGERIDO = SUGERIDO / (1 - :PORC/100);
            END
    EXECUTE PROCEDURE REDONDEE (SUGERIDO, DIG) returning_values (SUGERIDO);
    DIFER = SUGERIDO - FIJO;
    NUEVO = SUGERIDO;
    OK = 'S';
    if ((DIFER > DIFMAX) and (sugerido <> 0)) then
        suspend;
    end
end
^

SET TERM ; ^

GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO PROCEDURE REVISA_PRECIOS;
GRANT SELECT ON PRECIOS_ARTICULO TO PROCEDURE REVISA_PRECIOS;
GRANT SELECT ON ARTICULO TO PROCEDURE REVISA_PRECIOS;
GRANT SELECT ON TARIFA_IVA TO PROCEDURE REVISA_PRECIOS;
GRANT EXECUTE ON PROCEDURE COSTO_PROMEDIO TO PROCEDURE REVISA_PRECIOS;
GRANT EXECUTE ON PROCEDURE ULTIMO_COSTO TO PROCEDURE REVISA_PRECIOS;
GRANT SELECT ON LISTA_PRECIOS TO PROCEDURE REVISA_PRECIOS;
GRANT EXECUTE ON PROCEDURE REDONDEE TO PROCEDURE REVISA_PRECIOS;


/* promedio de salidas sin incluir dias sin existencias */ 

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('INVENTARIO', 'EXISTENCIAS', 'INCLUIR DIAS SIN EXISTENCIA EN PROMEDIO DE VENTAS DIARIO', 'SI', 'SI,NO', 'SI:Promedia las ventas dividiendo entre el nmero das indicado para el artculo. NO: Promedia dividiendo entre el nmero de das con existencia');
commit work;


SET TERM ^ ;

CREATE OR ALTER PROCEDURE PROMEDIO_SALIDAS_ARTICULO(
    ARTICULO VARCHAR(15),
    FECHA DATE,
    BODEGA VARCHAR(2))
RETURNS (
    PROMEDIO NUMERIC(18,4),
    SALIDAS NUMERIC(18,4))
AS
declare variable FECINI DATE;
declare variable DIASC VARCHAR(255);
declare variable DIAS INTEGER;
declare variable DIA_ART VARCHAR(2) CHARACTER SET NONE;
declare variable INCSALI VARCHAR(2);
declare variable SININV VARCHAR(2);
declare variable saldo numeric(18,2);
BEGIN
  EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'INCLUIR SALIDAS POR CONCEPTOS DIFERENTES A VENTA EN CALCULO DE PROMEDIO DE SALIDAS POR ARTICULO') returning_values (INCSALI);
  /*DE ACUERDO A PARAMETRO TOME LOS DIAS PARA EL PROMDIO*/
  EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'PROMEDIAR LAS SALIDAS DEL INVENTARIO CON EL NUMERO DE DIAS ASIGNADO A CADA ARTICULO') returning_values (:DIA_ART);
  /* SUME LAS CANTIDADES SALIDAS DEL INVENTARIO */
  EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'NUMERO DE DIAS PARA PROMEDIO DE SALIDAS POR ARTICULO') returning_values (DIASC);
  EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'INCLUIR DIAS SIN EXISTENCIA EN PROMEDIO DE VENTAS DIARIO') returning_values (:SININV);
  if (DIA_ART = 'SI') then
    BEGIN
      SELECT ARTI_DIANALIS FROM ARTICULO WHERE ARTI_COD = :ARTICULO
       INTO :DIAS;
    END
  ELSE
     DIAS = CAST(DIASC AS INTEGER);

  FECINI = FECHA - DIAS;
  if (INCSALI = 'SI') then
      SELECT SUM(MVAR_CANT) FROM MOVIMIENTO_ARTICULO
        WHERE ARTI_COD = :ARTICULO AND BODE_COD = :BODEGA AND MVAR_FECHA >= :FECINI AND MVAR_FECHA <= :FECHA AND MVAR_ENTRADA = 'N' AND MVAR_TIPODOC <> 13 INTO :SALIDAS;
  else
      SELECT SUM(MVAR_CANT) FROM MOVIMIENTO_ARTICULO
        WHERE ARTI_COD = :ARTICULO AND BODE_COD = :BODEGA AND MVAR_FECHA >= :FECINI AND MVAR_FECHA <= :FECHA AND ((MVAR_TIPODOC = 31) or (MVAR_TIPODOC = 32)) INTO :SALIDAS;
  if (SALIDAS IS NULL) then
    SALIDAS = 0;
  if (SININV = 'SI') then
      PROMEDIO = SALIDAS / DIAS;
  else
    begin
    dias = 0;
    while (fecini < fecha) do
        begin
        execute procedure saldo_inventario (:articulo, :bodega, :fecini) returning_values (:saldo);
        if (SALDO <> 0) then
            DIAS = DIAS + 1;
        fecini = fecini + 1;
        end
    if (DIAS = 0) then
        PROMEDIO = 0;
    ELSE
        PROMEDIO = SALIDAS / DIAS;
    end
  SUSPEND;
END
^

SET TERM ; ^

GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO PROCEDURE PROMEDIO_SALIDAS_ARTICULO;
GRANT SELECT ON ARTICULO TO PROCEDURE PROMEDIO_SALIDAS_ARTICULO;
GRANT SELECT ON MOVIMIENTO_ARTICULO TO PROCEDURE PROMEDIO_SALIDAS_ARTICULO;
GRANT EXECUTE ON PROCEDURE SALDO_INVENTARIO TO PROCEDURE PROMEDIO_SALIDAS_ARTICULO;

SET TERM ^ ;

ALTER PROCEDURE DISPONIBILIDAD_ARTICULO(
    ARTICULO VARCHAR(15),
    FECHA DATE,
    BODEGA VARCHAR(2))
RETURNS (
    DISPONIBILIDAD INTEGER,
    EXIST NUMERIC(18,4),
    PROMEDIO NUMERIC(18,4),
    SALIDAS NUMERIC(18,4))
AS
BEGIN
  EXECUTE PROCEDURE SALDO_INVENTARIO (ARTICULO, BODEGA, FECHA) returning_values (:EXIST);
  EXECUTE PROCEDURE PROMEDIO_SALIDAS_ARTICULO(:ARTICULO, :FECHA, :BODEGA) returning_values (:PROMEDIO, :SALIDAS);
  if (PROMEDIO > 0) then
    DISPONIBILIDAD = EXIST / PROMEDIO;
  ELSE
    DISPONIBILIDAD = 0;
  SUSPEND;
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE EXISTENCIAS_COMPRAS(
    ARTICULO VARCHAR(15),
    FECHA DATE,
    UNIDAD VARCHAR(8))
RETURNS (
    BODEGA VARCHAR(2),
    EXISTENCIA NUMERIC(18,4),
    RESERVADO NUMERIC(18,4),
    ORDENADO NUMERIC(18,4),
    PROMEDIO NUMERIC(18,4),
    VENTAMES NUMERIC(18,4),
    FECHACMP DATE,
    DIAS INTEGER,
    SUGERIDO NUMERIC(18,4),
    STAND VARCHAR(15))
AS
declare variable FACTOR NUMERIC(15,4);
declare variable ORDENC NUMERIC(18,4);
declare variable PEDIDO NUMERIC(18,4);
declare variable ITEM INTEGER;
declare variable ID INTEGER;
declare variable UND VARCHAR(8);
declare variable CANT NUMERIC(18,4);
declare variable FACTOR2 NUMERIC(18,4);
declare variable fecini DATE;
declare variable FECHAAUX VARCHAR(10);
declare variable AGENCIA INTEGER;
declare variable DEVMES NUMERIC(18,2);
declare variable MFAC INTEGER;
declare variable MDEV INTEGER;
declare variable IVAF NUMERIC(18,2);
declare variable IVAD NUMERIC(18,2);
declare variable DIA_ART VARCHAR(2) CHARACTER SET NONE;
declare variable DIASC VARCHAR(255);
declare variable PEDAUTO CHAR(2);
declare variable SALIDAS NUMERIC(18,4);
BEGIN
  for select bode_cod, SUCU_ID from bodega into :bodega, :agencia
    do
    begin
    execute procedure saldo_inventario (:articulo, :bodega, :fecha) returning_values (:Existencia);
    EXECUTE PROCEDURE FACTOR_UNIDAD_CANT(:ARTICULO, :UNIDAD) returning_values (:FACTOR);
    if (FACTOR <> 0) then
        EXISTENCIA = EXISTENCIA / FACTOR;
    else
        EXISTENCIA = 0;
    SELECT MAX(EXIS_STAND) FROM EXISTENCIA WHERE ARTI_COD = :ARTICULO AND BODE_COD = :BODEGA INTO :STAND;
    EXECUTE PROCEDURE promedio_salidas_articulo (:ARTICULO, :FECHA, :BODEGA) returning_values (:PROMEDIO, :SALIDAS);
    EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'PROMEDIAR LAS SALIDAS DEL INVENTARIO CON EL NUMERO DE DIAS ASIGNADO A CADA ARTICULO') returning_values (:DIA_ART);
    if (DIA_ART = 'NO') then
        BEGIN
        EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'NUMERO DE DIAS PARA PROMEDIO DE SALIDAS POR ARTICULO') returning_values (DIASC);
        DIAS = CAST(DIASC AS INTEGER);
        END
    ELSE
        SELECT ARTI_DIAS FROM ARTICULO WHERE ARTI_COD = :ARTICULO INTO :DIAS;
    if (DIAS is null) then
        DIAS = 0;
    PROMEDIO = DIAS * PROMEDIO;
    if (FACTOR <> 0) then
        PROMEDIO = PROMEDIO / FACTOR;
    SUGERIDO = PROMEDIO - EXISTENCIA;
    SELECT SUM(ORID_ENTREGAR)
      FROM ORDENINVENTARIO_DETALLE OD, ordenes_inventario O
      WHERE O.ORIN_ID = OD.ORIN_ID AND ARTI_COD = :ARTICULO AND ORIN_FECHA <= :FECHA AND ORIN_FECLLEGA >= :FECHA AND ORID_ANULADO = 'N' AND OD.BODE_COD = :BODEGA
      INTO :ORDENADO;
    if (ORDENADO IS NULL) then
        ORDENADO = 0;
    ORDENC = 0;
    FOR SELECT O.ORDC_ID, OCDE_ITEM, OCDE_CANT * OCDE_FACTOR
        FROM ORDENES_COMPRA O, ORDENES_COMPRA_DETALLE OD
        WHERE O.ORDC_ID = OD.ORDC_ID AND OD.ARTI_COD = :ARTICULO AND (ORDC_FECHA+ORDC_VALIDEZ) >= :FECHA AND ORDC_FECHA <= :FECHA AND OCDE_ANULADO = 'N' AND OD.BODE_COD = :BODEGA
        INTO :ID, :ITEM, :CANT
        do
        BEGIN
        EXECUTE PROCEDURE FALTANTE(23, 21, ID, ITEM) returning_values (PEDIDO, UND, FACTOR2);
        if (PEDIDO * FACTOR2 = CANT) then /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */
            EXECUTE PROCEDURE FALTANTE(23, 22, ID, ITEM) returning_values (PEDIDO, UND, FACTOR2);
        if (PEDIDO IS NULL) then
            PEDIDO = 0;
        ORDENC = ORDENC + PEDIDO * FACTOR2;
        END
    ORDENADO = ORDENADO + ORDENC;
    if (FACTOR <> 0) then
        ORDENADO = ORDENADO / FACTOR;
    SELECT SUM(RSDE_LIBERAR)
      FROM RESERVAS_DETALLE RD, RESERVAS R
      WHERE R.RESE_ID = RD.RESE_ID AND ARTI_COD = :ARTICULO AND RESE_FECHA <= :FECHA AND RESE_VENCE >= :FECHA AND RD.BODE_COD = :BODEGA AND RSDE_ANULADO = 'N'
      INTO :RESERVADO;
    if (RESERVADO IS NULL) then
        RESERVADO = 0;
    PEDIDO = 0;
    FOR SELECT P.PEDI_ID, PEDE_ITEM, PEDE_CANT * PEDE_FACTOR
        FROM PEDIDOS P, PEDIDOS_DETALLE PD
        WHERE P.PEDI_ID = PD.PEDI_ID AND PD.ARTI_COD = :ARTICULO AND (PEDI_FECHA+PEDI_VALIDEZ) >= :FECHA AND PEDI_FECHA <= :FECHA AND PEDE_ANULADO = 'N' AND BODE_COD = :BODEGA
        INTO :ID, :ITEM, :CANT
        do
        BEGIN
        EXECUTE PROCEDURE FALTANTE(34, 31, ID, ITEM) returning_values (ORDENC, UND, FACTOR2);
        EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'FACTURAS', 'GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') returning_values (pedauto);
        if ((ORDENC * FACTOR2 = CANT) or (PEDAUTO = 'SI')) then /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */
            EXECUTE PROCEDURE FALTANTE(34, 32, ID, ITEM) returning_values (ORDENC, UND, FACTOR2);
        if (ORDENC IS NULL) then
            ORDENC = 0;
        PEDIDO = PEDIDO + ORDENC * FACTOR2;
        END
    RESERVADO = RESERVADO + PEDIDO;
    if (FACTOR <> 0) then
        RESERVADO = RESERVADO / FACTOR;
    /* VENTAS MES */
    FECHAAUX = CAST (FECHA AS VARCHAR(10));
    FECHAAUX = SUBSTR(FECHAAUX, 1, 7) || '/01';
    FECINI = CAST (FECHAAUX AS DATE);
    EXECUTE PROCEDURE ventas_articulo (:ARTICULO, :FECINI, :FECHA, :agencia) returning_values (:ventames, :mfac, :devmes, :mdev, :ivaf, :ivad);
    ventames = ventames - devmes;
    if (FACTOR <> 0) then
        ventames = ventames / FACTOR;
    /* FECHA COMPRA */
    SELECT MAX(FACO_FECHA) FROM FACTURAS_COMPRA F, FACTURAS_COMPRAS_DETALLE D
        WHERE F.FACO_ID = D.faco_id AND D.ARTI_COD = :articulo AND FACO_FECHA <= :FECHA AND D.bode_cod = :BODEGA
        INTO :fechacmp;
    SUSPEND;
    end
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE MINIMO_ARTICULO(
    ARTICULO VARCHAR(15),
    FECHA DATE,
    BODEGA CHAR(2))
RETURNS (
    MINIMO NUMERIC(18,4))
AS
declare variable DIAS CHAR(2);
declare variable PROMEDIO NUMERIC(18,4);
declare variable SALIDAS NUMERIC(18,4);
BEGIN
  /* CUANDO CONFIGURACION MINIMO EN DIAS */
  EXECUTE PROCEDURE LEE_CONFIGURACION ('INVENTARIO', 'EXISTENCIAS', 'MINIMO INVENTARIO EN DIAS') returning_values (DIAS);
  if (DIAS = 'SI') then
    BEGIN
    EXECUTE PROCEDURE PROMEDIO_SALIDAS_ARTICULO(:ARTICULO, :FECHA, :BODEGA) returning_values (:PROMEDIO, :SALIDAS);
    SELECT ARTI_DIAS * :PROMEDIO FROM ARTICULO WHERE ARTI_COD = :ARTICULO INTO :MINIMO;
    end
  ELSE
    BEGIN
    SELECT ARTI_MIN FROM ARTICULO WHERE ARTI_COD = :ARTICULO INTO :MINIMO;
    END
  if (MINIMO IS NULL) then
    MINIMO = 0;
  SUSPEND;
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE ORDEN_PROVEEDOR(
    NIT VARCHAR(20),
    FECHA DATE)
RETURNS (
    ARTICULO VARCHAR(20),
    DESCRIPCION VARCHAR(60),
    UNIDAD VARCHAR(8),
    BODEGA VARCHAR(2),
    EXISTENCIA NUMERIC(18,4),
    RESERVADO NUMERIC(18,4),
    ORDENADO NUMERIC(18,4),
    PROMEDIO NUMERIC(18,4),
    VENTAMES NUMERIC(18,4),
    FECHACMP DATE,
    DIAS INTEGER,
    SUGERIDO NUMERIC(18,4),
    STAND VARCHAR(15))
AS
declare variable FACTOR NUMERIC(15,4);
declare variable ORDENC NUMERIC(18,4);
declare variable PEDIDO NUMERIC(18,4);
declare variable ITEM INTEGER;
declare variable ID INTEGER;
declare variable UND VARCHAR(8);
declare variable CANT NUMERIC(18,4);
declare variable FACTOR2 NUMERIC(18,4);
declare variable fecini DATE;
declare variable FECHAAUX VARCHAR(10);
declare variable AGENCIA INTEGER;
declare variable DEVMES NUMERIC(18,2);
declare variable MFAC INTEGER;
declare variable MDEV INTEGER;
declare variable IVAF NUMERIC(18,2);
declare variable IVAD NUMERIC(18,2);
declare variable DIA_ART VARCHAR(2) CHARACTER SET NONE;
declare variable DIASC VARCHAR(255);
declare variable PEDAUTO CHAR(2);
declare variable SALIDAS NUMERIC(18,4);
BEGIN
FOR SELECT A.ARTI_COD, A.ARTI_DES, A.ARTI_UNIDAD FROM ARTICULO A, proveedor_articulo P
  WHERE A.arti_cod = P.arti_cod AND P.terc_nit = :NIT INTO :articulo, :descripcion, :unidad
  DO
  for select bode_cod, SUCU_ID from bodega into :bodega, :agencia
    do
    begin
    execute procedure saldo_inventario (:articulo, :bodega, :fecha) returning_values (:Existencia);
    EXECUTE PROCEDURE FACTOR_UNIDAD_CANT(:ARTICULO, :UNIDAD) returning_values (:FACTOR);
    if (FACTOR <> 0) then
        EXISTENCIA = EXISTENCIA / FACTOR;
    else
        EXISTENCIA = 0;
    SELECT MAX(EXIS_STAND) FROM EXISTENCIA WHERE ARTI_COD = :ARTICULO AND BODE_COD = :BODEGA INTO :STAND;
    EXECUTE PROCEDURE promedio_salidas_articulo (:ARTICULO, :FECHA, :BODEGA) returning_values (:PROMEDIO, :SALIDAS);
    EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'PROMEDIAR LAS SALIDAS DEL INVENTARIO CON EL NUMERO DE DIAS ASIGNADO A CADA ARTICULO') returning_values (:DIA_ART);
    if (DIA_ART = 'NO') then
        BEGIN
        EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'NUMERO DE DIAS PARA PROMEDIO DE SALIDAS POR ARTICULO') returning_values (DIASC);
        DIAS = CAST(DIASC AS INTEGER);
        END
    ELSE
        SELECT ARTI_DIAS FROM ARTICULO WHERE ARTI_COD = :ARTICULO INTO :DIAS;
    if (DIAS is null) then
        DIAS = 0;
    PROMEDIO = DIAS * PROMEDIO;
    if (FACTOR <> 0) then
        PROMEDIO = PROMEDIO / FACTOR;
    SUGERIDO = PROMEDIO - EXISTENCIA;
    SELECT SUM(ORID_ENTREGAR)
      FROM ORDENINVENTARIO_DETALLE OD, ordenes_inventario O
      WHERE O.ORIN_ID = OD.ORIN_ID AND ARTI_COD = :ARTICULO AND ORIN_FECHA <= :FECHA AND ORIN_FECLLEGA >= :FECHA AND ORID_ANULADO = 'N' AND OD.BODE_COD = :BODEGA
      INTO :ORDENADO;
    if (ORDENADO IS NULL) then
        ORDENADO = 0;
    ORDENC = 0;
    FOR SELECT O.ORDC_ID, OCDE_ITEM, OCDE_CANT * OCDE_FACTOR
        FROM ORDENES_COMPRA O, ORDENES_COMPRA_DETALLE OD
        WHERE O.ORDC_ID = OD.ORDC_ID AND OD.ARTI_COD = :ARTICULO AND (ORDC_FECHA+ORDC_VALIDEZ) >= :FECHA AND ORDC_FECHA <= :FECHA AND OCDE_ANULADO = 'N' AND OD.BODE_COD = :BODEGA
        INTO :ID, :ITEM, :CANT
        do
        BEGIN
        EXECUTE PROCEDURE FALTANTE(23, 21, ID, ITEM) returning_values (PEDIDO, UND, FACTOR2);
        if (PEDIDO * FACTOR2 = CANT) then /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */
            EXECUTE PROCEDURE FALTANTE(23, 22, ID, ITEM) returning_values (PEDIDO, UND, FACTOR2);
        if (PEDIDO IS NULL) then
            PEDIDO = 0;
        ORDENC = ORDENC + PEDIDO * FACTOR2;
        END
    ORDENADO = ORDENADO + ORDENC;
    if (FACTOR <> 0) then
        ORDENADO = ORDENADO / FACTOR;
    SELECT SUM(RSDE_LIBERAR)
      FROM RESERVAS_DETALLE RD, RESERVAS R
      WHERE R.RESE_ID = RD.RESE_ID AND ARTI_COD = :ARTICULO AND RESE_FECHA <= :FECHA AND RESE_VENCE >= :FECHA AND RD.BODE_COD = :BODEGA AND RSDE_ANULADO = 'N'
      INTO :RESERVADO;
    if (RESERVADO IS NULL) then
        RESERVADO = 0;
    PEDIDO = 0;
    FOR SELECT P.PEDI_ID, PEDE_ITEM, PEDE_CANT * PEDE_FACTOR
        FROM PEDIDOS P, PEDIDOS_DETALLE PD
        WHERE P.PEDI_ID = PD.PEDI_ID AND PD.ARTI_COD = :ARTICULO AND (PEDI_FECHA+PEDI_VALIDEZ) >= :FECHA AND PEDI_FECHA <= :FECHA AND PEDE_ANULADO = 'N' AND BODE_COD = :BODEGA
        INTO :ID, :ITEM, :CANT
        do
        BEGIN
        EXECUTE PROCEDURE FALTANTE(34, 31, ID, ITEM) returning_values (ORDENC, UND, FACTOR2);
        EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'FACTURAS', 'GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') returning_values (pedauto);
        if ((ORDENC * FACTOR2 = CANT) or (PEDAUTO = 'SI')) then /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */
            EXECUTE PROCEDURE FALTANTE(34, 32, ID, ITEM) returning_values (ORDENC, UND, FACTOR2);
        if (ORDENC IS NULL) then
            ORDENC = 0;
        PEDIDO = PEDIDO + ORDENC * FACTOR2;
        END
    RESERVADO = RESERVADO + PEDIDO;
    if (FACTOR <> 0) then
        RESERVADO = RESERVADO / FACTOR;
    /* VENTAS MES */
    FECHAAUX = CAST (FECHA AS VARCHAR(10));
    FECHAAUX = SUBSTR(FECHAAUX, 1, 7) || '/01';
    FECINI = CAST (FECHAAUX AS DATE);
    EXECUTE PROCEDURE ventas_articulo (:ARTICULO, :FECINI, :FECHA, :agencia) returning_values (:ventames, :mfac, :devmes, :mdev, :ivaf, :ivad);
    ventames = ventames - devmes;
    if (FACTOR <> 0) then
        ventames = ventames / FACTOR;
    /* FECHA COMPRA */
    SELECT MAX(FACO_FECHA) FROM FACTURAS_COMPRA F, FACTURAS_COMPRAS_DETALLE D
        WHERE F.FACO_ID = D.faco_id AND D.ARTI_COD = :articulo AND FACO_FECHA <= :FECHA AND D.bode_cod = :BODEGA
        INTO :fechacmp;
    SUSPEND;
    end
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE REP_DISPONIBILIDAD(
    FECHA DATE,
    ARTINI VARCHAR(20),
    ARTFIN VARCHAR(20),
    GRPINI VARCHAR(2),
    GRPFIN VARCHAR(2),
    ORDEN CHAR(1),
    CEROS CHAR(1),
    DETALLE CHAR(1),
    SUCURSAL INTEGER)
RETURNS (
    CODIGO VARCHAR(15),
    NOMBRE VARCHAR(60),
    UNIDAD VARCHAR(8),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    CODBOD VARCHAR(2),
    NOMBOD VARCHAR(30),
    EXIST NUMERIC(18,4),
    PROMEDIO NUMERIC(18,4),
    SALIDAS NUMERIC(18,4),
    DISPONIBILIDAD INTEGER,
    DIAS INTEGER,
    PROMEDIADO INTEGER,
    COSTO NUMERIC(18,2),
    COSTOPRO NUMERIC(18,2),
    SUGERIDO NUMERIC(18,4),
    FECCOMPRA DATE)
AS
DECLARE VARIABLE CODINI VARCHAR(20);
DECLARE VARIABLE CODFIN VARCHAR(20);
DECLARE VARIABLE DESINI VARCHAR(20);
declare variable FECINI DATE;
declare variable DIASC VARCHAR(255);
DECLARE VARIABLE DESFIN VARCHAR(20);
declare variable DIA_ART VARCHAR(2) CHARACTER SET NONE;
BEGIN
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END
if (DETALLE = 'S') then
  BEGIN
  FOR SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, ARTI_DIAS, A.GRUP_COD, GRUP_NOM, A.SUBG_COD, A.MARC_COD, BODE_COD, BODE_NOM, ARTI_DIANALIS
      FROM ARTICULO A, GRUPO G, BODEGA B
      WHERE ARTI_COD >= :CODINI AND ARTI_COD <= :CODFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :GRPFIN AND ARTI_DES >= :DESINI AND ARTI_DES <= :DESFIN AND
      G.GRUP_COD = A.GRUP_COD AND A.ESAR_COD <> 'I' AND ((SUCU_ID = :SUCURSAL) or (:SUCURSAL = 0))
      INTO :CODIGO, :NOMBRE, :UNIDAD, :DIAS, :CODGRUPO, :NOMGRUPO, :CODSUBG, :CODMARC, :CODBOD, :NOMBOD, :PROMEDIADO
      DO
        BEGIN
        NOMMARC = '';
        NOMSUBG = '';
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO :NOMMARC;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
        EXECUTE PROCEDURE ultimo_costo(:CODIGO, :FECHA, :UNIDAD) returning_values (:COSTO);
        EXECUTE PROCEDURE costo_promedio(:CODIGO, :FECHA) RETURNING_VALUES :costopro;
        EXECUTE PROCEDURE DISPONIBILIDAD_ARTICULO(CODIGO, FECHA, :CODBOD) returning_values (:DISPONIBILIDAD, :EXIST, :PROMEDIO, :SALIDAS);
        /*ESTABLECER CUAL ES EL VALOR DE DIAS PARA PROMEDIO*/
        EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'PROMEDIAR LAS SALIDAS DEL INVENTARIO CON EL NUMERO DE DIAS ASIGNADO A CADA ARTICULO') returning_values (:DIA_ART);
        if (DIA_ART = 'NO') then
          BEGIN
            EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'NUMERO DE DIAS PARA PROMEDIO DE SALIDAS POR ARTICULO') returning_values (DIASC);
            PROMEDIADO = CAST(DIASC AS INTEGER);
          END
        FECINI = :FECHA - :PROMEDIADO;
        if ((DISPONIBILIDAD < DIAS) and (PROMEDIO > 0))then
            SUGERIDO = (DIAS * PROMEDIO) - EXIST;
        ELSE
            SUGERIDO = 0;
        SELECT MAX(FACO_FECHA) FROM FACTURAS_COMPRA F, FACTURAS_COMPRAS_DETALLE D
            WHERE F.FACO_ID = D.faco_id AND D.ARTI_COD = :CODIGO AND FACO_FECHA <= :FECHA AND D.bode_cod = :codbod
            INTO :FECCOMPRA;
        if ((PROMEDIO > 0) or (EXIST <> 0) or (CEROS = 'S')) then
            SUSPEND;
        END
  END
ELSE
  BEGIN
  FOR SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, ARTI_DIAS, A.GRUP_COD, GRUP_NOM, A.SUBG_COD, A.MARC_COD, ARTI_DIANALIS
      FROM ARTICULO A, GRUPO G
      WHERE ARTI_COD >= :CODINI AND ARTI_COD <= :CODFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :GRPFIN AND ARTI_DES >= :DESINI AND ARTI_DES <= :DESFIN AND G.GRUP_COD = A.GRUP_COD AND A.ESAR_COD <> 'I'
      INTO :CODIGO, :NOMBRE, :UNIDAD, :DIAS, :CODGRUPO, :NOMGRUPO, :CODSUBG, :CODMARC, :PROMEDIADO
      DO
        BEGIN
        NOMMARC = '';
        NOMSUBG = '';
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO :NOMMARC;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
        EXECUTE PROCEDURE costo_promedio(:CODIGO, :FECHA) RETURNING_VALUES :costopro;
        EXECUTE PROCEDURE ultimo_costo(:CODIGO, :FECHA, :UNIDAD) returning_values (:COSTO);
        EXECUTE PROCEDURE DISPONIBILIDAD_TOTAL_ARTICULO(CODIGO, FECHA) returning_values (:DISPONIBILIDAD, :EXIST, :PROMEDIO, :SALIDAS);
        /*ESTABLECER CUAL ES EL VALOR DE DIAS PARA PROMEDIO*/
        EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'PROMEDIAR LAS SALIDAS DEL INVENTARIO CON EL NUMERO DE DIAS ASIGNADO A CADA ARTICULO') returning_values (:DIA_ART);
        if (DIA_ART = 'NO') then
          BEGIN
            EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'NUMERO DE DIAS PARA PROMEDIO DE SALIDAS POR ARTICULO') returning_values (DIASC);
            PROMEDIADO = CAST(DIASC AS INTEGER);
          END
        FECINI = :FECHA - :PROMEDIADO;
        if ((DISPONIBILIDAD < DIAS) and (PROMEDIO > 0))then
            SUGERIDO = (DIAS * PROMEDIO) - EXIST;
        ELSE
            SUGERIDO = 0;
        SELECT MAX(FACO_FECHA) FROM FACTURAS_COMPRA F, FACTURAS_COMPRAS_DETALLE D
            WHERE F.FACO_ID = D.faco_id AND D.ARTI_COD = :CODIGO AND FACO_FECHA <= :FECHA
            INTO :FECCOMPRA;
        if ((PROMEDIO > 0) or (EXIST <> 0) or (CEROS = 'S')) then
            SUSPEND;
        END
  END
END

^

SET TERM ; ^


/* 20080626 */
ALTER TABLE LOTES ADD BODE_COD VARCHAR(2) NOT NULL ;
ALTER TABLE EXISTENCIA_LOTE ADD BODE_COD VARCHAR(2) NOT NULL ;
ALTER TABLE EXISTENCIA_LOTE DROP CONSTRAINT FK_EXISTLOTE_LOTES;
ALTER TABLE EXISTENCIA_LOTE DROP CONSTRAINT PK_EXISTENCIA_LOTE;
ALTER TABLE LOTES DROP CONSTRAINT PK_LOTES;

alter table LOTES add constraint PK_LOTES primary key (ARTI_COD,BODE_COD,LOTE_NRO);
alter table EXISTENCIA_LOTE add constraint PK_EXISTENCIA_LOTE primary key (ARTI_COD,BODE_COD,LOTE_NRO,EXLO_FECHA);
alter table EXISTENCIA_LOTE add constraint FK_EXISTENCIA_LOTE_1 foreign key (ARTI_COD,BODE_COD,LOTE_NRO) references LOTES(ARTI_COD,BODE_COD,LOTE_NRO);

SET TERM ^ ;

CREATE OR ALTER PROCEDURE CHEQUEO_INVENTARIO(
    ARTINI VARCHAR(20),
    ARTFIN VARCHAR(20))
AS
DECLARE VARIABLE FECHA DATE;
DECLARE VARIABLE CANT NUMERIC(15,4);
DECLARE VARIABLE COSTO NUMERIC(18,2);
DECLARE VARIABLE ENTRADA CHAR(1);
DECLARE VARIABLE BODEGA CHAR(2);
DECLARE VARIABLE ID INTEGER;
DECLARE VARIABLE TIPO INTEGER;
declare variable TIPOEX CHAR(1);
DECLARE VARIABLE LOTE VARCHAR(20);
DECLARE VARIABLE EXISTE CHAR(1);
declare variable ARTICULO VARCHAR(20);
declare variable IDL INTEGER;
BEGIN
for select arti_cod from articulo where arti_cod >= :artini and arti_cod <= :artfin into :ARTICULO
  DO
  BEGIN
  DELETE FROM existencia_lote where arti_cod = :articulo;
  DELETE FROM lotes where arti_cod = :articulo;
  delete from costos where arti_cod = :ARTICULO;
  delete from existencia WHERE ARTI_COD = :ARTICULO;
  for select mvar_cons, mvar_fecha, mvar_cant, mvar_costo, mvar_entrada, bode_cod, mvar_tipodoc, mvar_lote
    from movimiento_articulo WHERE ARTI_COD = :ARTICULO
    order by mvar_fecha, mvar_cons
    into :id, :fecha, :cant, :costo, :entrada, :bodega, :tipo, :lote
  do
    begin
    SELECT ARTI_EXIST
        FROM   ARTICULO
        WHERE  ARTICULO.ARTI_COD = :ARTICULO
        INTO :TIPOEX;
    if ((TIPO <> 13)) then
        EXECUTE PROCEDURE actualice_costo(:ARTICULO, :fecha, :costo, :cant, :entrada, 'N', :id, :tipo);
    /* actualice existencias */
    if (:entrada = 'S') then
        begin
        execute procedure sume_existencia(:articulo, :bodega, :fecha, :cant, 'N');
        if (TIPOEX = 'L') then
            begin
            EXISTE = 'N';
            SELECT 'S' FROM LOTES WHERE ARTI_COD = :ARTICULO AND BODE_COD = :BODEGA AND LOTE_NRO = :lote INTO :EXISTE;
            if (EXISTE = 'S') then
                UPDATE LOTES
                    set lote_saldo = lote_saldo + :cant
                    where (arti_cod = :ARTICULO) and (BODE_COD = :BODEGA) AND (lote_nro = :lote);
            ELSE
                INSERT INTO LOTES (ARTI_COD, BODE_COD, LOTE_NRO, LOTE_FECHA, LOTE_CANT, LOTE_COSTO, LOTE_SALDO)
                    VALUES (:ARTICULO, :bodega, :lote, :fecha, :cant, :costo, :cant);
            end
        end
    else
        begin
        execute procedure reste_existencia(:articulo, :bodega, :fecha, :cant, 'N');
        if (TIPOEX = 'L') then
            begin
            EXISTE = 'N';
            SELECT 'S' FROM LOTES WHERE ARTI_COD = :ARTICULO AND BODE_COD = :BODEGA AND LOTE_NRO = :lote INTO :EXISTE;
            if (EXISTE = 'S') then
                UPDATE LOTES
                    set lote_saldo = lote_saldo - :cant
                    where (arti_cod = :ARTICULO) AND (BODE_COD = :BODEGA) and (lote_nro = :lote);
            ELSE
                BEGIN
                /* ARREGLE EL LOTE YA QUE NO EXISTE */
                SELECT MIN(LOTE_ID) FROM LOTES WHERE ARTI_COD = :articulo AND BODE_COD = :BODEGA AND LOTE_CANT >= :cant INTO :IDL;
                SELECT LOTE_NRO FROM LOTES WHERE LOTE_ID = :IDL INTO :LOTE;
                UPDATE MOVIMIENTO_ARTICULO SET MVAR_LOTE = :LOTE WHERE MVAR_CONS = :ID;
                UPDATE LOTES
                    set lote_saldo = lote_saldo - :cant
                    where (arti_cod = :ARTICULO) and (BODE_COD = :BODEGA) AND (lote_nro = :lote);
                END
            EXISTE = 'N';
            SELECT 'S' FROM EXISTENCIA_LOTE
                WHERE LOTE_NRO = :LOTE AND EXLO_FECHA = :FECHA AND ARTI_COD = :ARTICULO AND BODE_COD = :bodega
                INTO :EXISTE;
            if (EXISTE = 'S') then
                UPDATE EXISTENCIA_LOTE
                       SET EXLO_SAL = EXLO_SAL + :cant
                    WHERE LOTE_NRO = :LOTE AND EXLO_FECHA = :FECHA AND ARTI_COD = :ARTICULO AND BODE_COD = :bodega;
            else
                INSERT INTO EXISTENCIA_LOTE (ARTI_COD, BODE_COD, LOTE_NRO, EXLO_FECHA, EXLO_SAL)
                    VALUES (:ARTICULO, :BODEGA, :LOTE, :FECHA, :CANT);
            end
        end
    END
  END
END
^

SET TERM ; ^

GRANT SELECT ON ARTICULO TO PROCEDURE CHEQUEO_INVENTARIO;
GRANT SELECT,INSERT,DELETE,UPDATE ON EXISTENCIA_LOTE TO PROCEDURE CHEQUEO_INVENTARIO;
GRANT SELECT,INSERT,DELETE,UPDATE ON LOTES TO PROCEDURE CHEQUEO_INVENTARIO;
GRANT SELECT,DELETE ON COSTOS TO PROCEDURE CHEQUEO_INVENTARIO;
GRANT SELECT,DELETE ON EXISTENCIA TO PROCEDURE CHEQUEO_INVENTARIO;
GRANT SELECT,UPDATE ON MOVIMIENTO_ARTICULO TO PROCEDURE CHEQUEO_INVENTARIO;
GRANT EXECUTE ON PROCEDURE ACTUALICE_COSTO TO PROCEDURE CHEQUEO_INVENTARIO;
GRANT EXECUTE ON PROCEDURE SUME_EXISTENCIA TO PROCEDURE CHEQUEO_INVENTARIO;
GRANT EXECUTE ON PROCEDURE RESTE_EXISTENCIA TO PROCEDURE CHEQUEO_INVENTARIO;

SET TERM ^ ;

CREATE OR ALTER TRIGGER LOTES_AI FOR LOTES
ACTIVE AFTER INSERT POSITION 0
AS
BEGIN
  /* INSERTE UNA EXISTENCIA DEL LOTE EN LA FECHA */
  INSERT INTO EXISTENCIA_LOTE (ARTI_COD, BODE_COD, LOTE_NRO, EXLO_FECHA, EXLO_SAL, EXLO_SALDO)
    VALUES (NEW.ARTI_COD, NEW.bode_cod, NEW.lote_nro, NEW.lote_fecha, 0, NEW.lote_cant);
END
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON LOTES TO TRIGGER LOTES_AI;
GRANT INSERT ON EXISTENCIA_LOTE TO TRIGGER LOTES_AI;

SET TERM ^ ;

CREATE OR ALTER TRIGGER LOTES_BD FOR LOTES
ACTIVE BEFORE DELETE POSITION 0
AS
declare variable SUMA NUMERIC(15,4);
BEGIN
  /* CUANDO LO INTENTEN BORRAR MIRE QUE NO TENGA SALIDAS */
  SUMA = 0;
  SELECT SUM(EXLO_SAL) FROM EXISTENCIA_LOTE WHERE ARTI_COD = OLD.ARTI_COD AND BODE_COD = OLD.bode_cod AND LOTE_NRO = OLD.LOTE_NRO INTO :SUMA;
  if ((SUMA IS NULL) or (SUMA = 0)) then
    DELETE FROM EXISTENCIA_LOTE
        WHERE ARTI_COD = OLD.ARTI_COD AND BODE_COD = OLD.bode_cod AND LOTE_NRO = OLD.LOTE_NRO;
  ELSE
    EXCEPTION lote_con_movimientos 'El Articulo ' || old.arti_cod || ' con lote ' || old.lote_nro || ' tiene salidas registradas en la bodega ' || old.bode_cod;
END
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON LOTES TO TRIGGER LOTES_BD;
GRANT SELECT,DELETE ON EXISTENCIA_LOTE TO TRIGGER LOTES_BD;

SET TERM ^ ;

CREATE OR ALTER TRIGGER MOVIMIENTO_ARTICULO_AI FOR MOVIMIENTO_ARTICULO
ACTIVE AFTER INSERT POSITION 0
AS
declare variable EXISTE CHAR(1);
declare variable LOTE CHAR(1);
BEGIN
  /* INSERTE EL NUEVO LOTE */
  SELECT ARTI_EXIST FROM ARTICULO WHERE ARTICULO.ARTI_COD = NEW.ARTI_COD INTO :LOTE;
  /* ACTUALICE COSTOS cuando no es transferencia */
  if (new.mvar_tipodoc <> 13) then
      BEGIN
      EXECUTE PROCEDURE actualice_costo(new.arti_cod, new.mvar_fecha, new.mvar_costo, new.mvar_cant, new.mvar_entrada, 'N', new.mvar_cons, new.mvar_tipodoc);
      EXECUTE PROCEDURE chequeo_costos(NEW.arti_cod, NEW.mvar_fecha);
      END
  /* actualice existencias */
  if (new.mvar_entrada = 'S') then
    BEGIN
    execute procedure sume_existencia(new.arti_cod, new.bode_cod, new.mvar_fecha, new.mvar_cant, 'N');
    if (LOTE = 'L') then
        BEGIN
        if (NEW.MVAR_LOTE IS NULL) then
            EXCEPTION LOTE_OBLIGATORIO 'Debe especificar un nmero de lote para el articulo ' || new.arti_cod;
        ELSE
         BEGIN
         EXISTE = 'N';
         SELECT 'S' FROM LOTES WHERE ARTI_COD = NEW.ARTI_COD AND BODE_COD = NEW.bode_cod AND LOTE_NRO = new.mvar_lote INTO :EXISTE;
         if (EXISTE = 'S') then
            UPDATE LOTES
             set lote_saldo = lote_saldo + new.mvar_cant
              where (arti_cod = NEW.ARTI_COD) and (BODE_COD = NEW.bode_cod) and (lote_nro = new.mvar_lote);
         ELSE
            INSERT INTO LOTES (ARTI_COD, BODE_COD, LOTE_NRO, LOTE_FECHA, LOTE_CANT, LOTE_COSTO, LOTE_SALDO)
                VALUES (NEW.ARTI_COD, NEW.bode_cod, NEW.mvar_lote, NEW.mvar_fecha, NEW.mvar_cant, NEW.mvar_costo, NEW.mvar_cant);
         END
        END
    END
  else
    BEGIN
    execute procedure reste_existencia(new.arti_cod, new.bode_cod, new.mvar_fecha, new.mvar_cant, 'N');
    /* ACTUALICE LA EXISTENCIA DEL LOTE */
    if (LOTE = 'L') then
    if (NEW.mvar_lote IS NULL) then
        EXCEPTION LOTE_NEGATIVO 'Debe indicar un nmero de lote para el artculo ' || new.arti_cod;
    ELSE
        BEGIN
        /* Actualice el saldo historico del lote */
        EXISTE = 'N';
        SELECT 'S' FROM EXISTENCIA_LOTE WHERE LOTE_NRO = NEW.MVAR_LOTE AND EXLO_FECHA = NEW.MVAR_FECHA AND ARTI_COD = NEW.arti_cod AND BODE_COD = NEW.bode_cod INTO :EXISTE;
        if (EXISTE = 'S') then
            BEGIN
            UPDATE EXISTENCIA_LOTE
                SET EXLO_SAL = EXLO_SAL + NEW.mvar_cant
                WHERE LOTE_NRO = NEW.MVAR_LOTE AND EXLO_FECHA = NEW.MVAR_FECHA AND ARTI_COD = NEW.ARTI_COD AND BODE_COD = NEW.bode_cod;
            END
        ELSE
            BEGIN
            INSERT INTO EXISTENCIA_LOTE (ARTI_COD, BODE_COD, LOTE_NRO, EXLO_FECHA, EXLO_SAL)
                VALUES (NEW.ARTI_COD, NEW.bode_cod, NEW.MVAR_LOTE, NEW.MVAR_FECHA, NEW.MVAR_CANT);
            END
        UPDATE LOTES
            set lote_saldo = lote_saldo - new.mvar_cant
            where (arti_cod = NEW.ARTI_COD) and (BODE_COD = NEW.bode_cod) and (lote_nro = new.mvar_lote);
        END
    END
END
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON MOVIMIENTO_ARTICULO TO TRIGGER MOVIMIENTO_ARTICULO_AI;
GRANT SELECT ON ARTICULO TO TRIGGER MOVIMIENTO_ARTICULO_AI;
GRANT EXECUTE ON PROCEDURE ACTUALICE_COSTO TO TRIGGER MOVIMIENTO_ARTICULO_AI;
GRANT EXECUTE ON PROCEDURE CHEQUEO_COSTOS TO TRIGGER MOVIMIENTO_ARTICULO_AI;
GRANT EXECUTE ON PROCEDURE SUME_EXISTENCIA TO TRIGGER MOVIMIENTO_ARTICULO_AI;
GRANT SELECT,INSERT,UPDATE ON LOTES TO TRIGGER MOVIMIENTO_ARTICULO_AI;
GRANT EXECUTE ON PROCEDURE RESTE_EXISTENCIA TO TRIGGER MOVIMIENTO_ARTICULO_AI;
GRANT SELECT,INSERT,UPDATE ON EXISTENCIA_LOTE TO TRIGGER MOVIMIENTO_ARTICULO_AI;

SET TERM ^ ;

CREATE OR ALTER TRIGGER TI_EXISTENCIA_LOTE FOR EXISTENCIA_LOTE
ACTIVE BEFORE INSERT POSITION 0
AS
DECLARE VARIABLE NUMROWS INTEGER;
BEGIN
    /*  PARENT 'LOTES' MUST EXIST WHEN INSERTING A CHILD IN 'EXISTENCIA_LOTE'  */
    IF (NEW.ARTI_COD IS NOT NULL AND
        NEW.bode_cod IS NOT NULL AND
        NEW.LOTE_NRO IS NOT NULL) THEN
    BEGIN
       SELECT COUNT(*)
       FROM   LOTES
       WHERE  LOTES.ARTI_COD = NEW.ARTI_COD
        AND   LOTES.bode_cod = NEW.bode_cod
        AND   LOTES.LOTE_NRO = NEW.LOTE_NRO
       INTO   :NUMROWS;
       IF (NUMROWS = 0) THEN
       BEGIN
          EXCEPTION LOTE_NO_EXISTE 'No se encontr el numero de lote ' || new.lote_nro || ' para el artculo ' || new.arti_cod || ' en la bodega ' || new.bode_cod;
       END
    END
END
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON EXISTENCIA_LOTE TO TRIGGER TI_EXISTENCIA_LOTE;
GRANT SELECT ON LOTES TO TRIGGER TI_EXISTENCIA_LOTE;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE EXISTENCIAS_DESDE_HASTA(
    FECHA DATE,
    ARTINI VARCHAR(20),
    ARTFIN VARCHAR(20),
    GRPINI VARCHAR(3),
    GRPFIN VARCHAR(3),
    BODINI VARCHAR(2),
    BODFIN VARCHAR(2),
    ORDEN CHAR(1),
    AGRUPA CHAR(1),
    DETALLE CHAR(1),
    RESERVA CHAR(1),
    SUCURSAL INTEGER)
RETURNS (
    CANT NUMERIC(18,4),
    COSTO NUMERIC(18,2),
    COSTO_LOTE NUMERIC(18,2),
    CODIGO VARCHAR(15),
    NOMBRE VARCHAR(60),
    UNIDAD VARCHAR(8),
    STAND VARCHAR(15),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    CODBOD VARCHAR(2),
    LOTE VARCHAR(15),
    NOMBOD VARCHAR(30),
    COSTOTOT NUMERIC(18,2),
    ULTCOSTO NUMERIC(18,2),
    FECHACOSTO DATE,
    CONSUMO NUMERIC(18,2),
    RESERVADO NUMERIC(18,4),
    ORDENADO NUMERIC(18,4),
    IVA NUMERIC(9,2),
    CODBAR VARCHAR(20))
AS
declare variable exist char(1);
declare variable codini varchar(20);
declare variable codfin varchar(20);
declare variable desini varchar(20);
declare variable desfin varchar(20);
declare variable ordenc numeric(18,4);
declare variable pedido numeric(18,4);
declare variable ok char(1);
declare variable id integer;
declare variable item integer;
declare variable und varchar(8);
declare variable factor numeric(18,4);
declare variable cant2 numeric(18,4);
declare variable PEDAUTO CHAR(2);
BEGIN
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'FACTURAS', 'GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') returning_values (pedauto);
if (DETALLE = 'B') then
  BEGIN
  FOR SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, ARTI_EXIST, TAIV_PORC, A.GRUP_COD, A.SUBG_COD, A.MARC_COD, BODE_COD, BODE_NOM, ARTI_CONSUMO
      FROM ARTICULO A, BODEGA B, TARIFA_IVA T
      WHERE ARTI_COD >= :CODINI AND ARTI_COD <= :CODFIN AND ARTI_DES >= :DESINI AND ARTI_DES <= :DESFIN AND ESAR_COD <> 'I' AND BODE_COD >= :BODINI AND
      BODE_COD <= :BODFIN AND ((SUCU_ID = :SUCURSAL) or (:SUCURSAL = 0)) AND A.TAIV_COD = T.TAIV_COD
      INTO :CODIGO, :NOMBRE, :UNIDAD, :EXIST, :IVA, :CODGRUPO, :CODSUBG, :CODMARC, :CODBOD, :NOMBOD, :CONSUMO
      DO
        BEGIN
        OK = 'N';
        if (AGRUPA = 'G') then
            BEGIN
            if ((CODGRUPO >= GRPINI) AND (CODGRUPO <= GRPFIN)) then
                OK = 'S';
            end
        ELSE
            if (AGRUPA = 'M') then
                BEGIN
                if ((CODMARC >= GRPINI) AND (CODMARC <= GRPFIN)) then
                    OK = 'S';
                END
        if (OK = 'S') then
            BEGIN
            NOMGRUPO = '';
            NOMMARC = '';
            NOMSUBG = '';
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SELECT MAX(COBA_COD) FROM BARRAS_ARTICULO WHERE ARTI_COD = :codigo AND COBA_UNIDAD = :unidad INTO :codbar;
            if (CODBAR IS NULL) then
                CODBAR = CODIGO;
            if (EXIST <> 'N') then
                BEGIN
                SELECT MAX(EXIS_STAND) FROM EXISTENCIA WHERE ARTI_COD = :CODIGO AND BODE_COD = :CODBOD INTO :STAND;
                EXECUTE PROCEDURE SALDO_INICIAL_INVENTARIO(CODIGO, FECHA, :CODBOD) returning_values (CANT);
                EXECUTE PROCEDURE COSTO_PROMEDIO_UNIDAD(CODIGO, FECHA, UNIDAD) returning_values (COSTO);
                EXECUTE PROCEDURE ULTIMO_COSTO(CODIGO, FECHA, UNIDAD) returning_values (ULTCOSTO);
                SELECT MAX(MVAR_FECHA) FROM MOVIMIENTO_ARTICULO WHERE ARTI_COD = :CODIGO AND MVAR_ENTRADA = 'S' AND MVAR_FECHA <= :FECHA INTO :FECHACOSTO;
                COSTOTOT = :CANT * :COSTO;
                CONSUMO = CONSUMO * CANT;
                if (RESERVA = 'S') then
                    BEGIN
                    SELECT SUM(ORID_ENTREGAR)
                        FROM ORDENINVENTARIO_DETALLE OD, ordenes_inventario O
                        WHERE O.ORIN_ID = OD.ORIN_ID AND ARTI_COD = :CODIGO AND ORIN_FECHA <= :FECHA AND ORIN_FECLLEGA >= :FECHA AND ORID_ANULADO = 'N' AND OD.BODE_COD = :CODBOD
                        INTO :ORDENADO;
                    if (ORDENADO IS NULL) then
                        ORDENADO = 0;
                    ORDENC = 0;
                    FOR SELECT O.ORDC_ID, OCDE_ITEM, OCDE_CANT * OCDE_FACTOR
                        FROM ORDENES_COMPRA O, ORDENES_COMPRA_DETALLE OD
                        WHERE O.ORDC_ID = OD.ORDC_ID AND OD.ARTI_COD = :CODIGO AND (ORDC_FECHA+ORDC_VALIDEZ) >= :FECHA AND ORDC_FECHA <= :FECHA AND OCDE_ANULADO = 'N' AND OD.BODE_COD = :CODBOD
                        INTO :ID, :ITEM, :CANT2
                        do
                        BEGIN
                        EXECUTE PROCEDURE FALTANTE(23, 21, ID, ITEM) returning_values (PEDIDO, UND, FACTOR);
                        if (PEDIDO * FACTOR = CANT2) then /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */
                            EXECUTE PROCEDURE FALTANTE(23, 22, ID, ITEM) returning_values (PEDIDO, UND, FACTOR);
                        if (PEDIDO IS NULL) then
                            PEDIDO = 0;
                        ORDENC = ORDENC + PEDIDO * FACTOR;
                        END
                    ORDENADO = ORDENADO + ORDENC;
                    SELECT SUM(RSDE_LIBERAR)
                        FROM RESERVAS_DETALLE RD, RESERVAS R
                        WHERE R.RESE_ID = RD.RESE_ID AND ARTI_COD = :CODIGO AND RESE_FECHA <= :FECHA AND RESE_VENCE >= :FECHA AND RD.BODE_COD = :CODBOD AND RSDE_ANULADO = 'N'
                        INTO :RESERVADO;
                    if (RESERVADO IS NULL) then
                        RESERVADO = 0;
                    PEDIDO = 0;
                    FOR SELECT P.PEDI_ID, PEDE_ITEM, PEDE_CANT * PEDE_FACTOR
                        FROM PEDIDOS P, PEDIDOS_DETALLE PD
                        WHERE P.PEDI_ID = PD.PEDI_ID AND PD.ARTI_COD = :CODIGO AND (PEDI_FECHA+PEDI_VALIDEZ) >= :FECHA AND PEDI_FECHA <= :FECHA AND PEDE_ANULADO = 'N' AND BODE_COD = :CODBOD
                        INTO :ID, :ITEM, :CANT2
                        do
                        BEGIN
                        EXECUTE PROCEDURE FALTANTE(34, 31, ID, ITEM) returning_values (ORDENC, UND, FACTOR);
                        if ((ORDENC * FACTOR = CANT2) or (PEDAUTO = 'SI')) then /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */
                            EXECUTE PROCEDURE FALTANTE(34, 32, ID, ITEM) returning_values (ORDENC, UND, FACTOR);
                        if (ORDENC IS NULL) then
                            ORDENC = 0;
                        PEDIDO = PEDIDO + ORDENC * FACTOR;
                        END
                    RESERVADO = RESERVADO + PEDIDO;
                    END
                ELSE
                    BEGIN
                    RESERVADO = 0;
                    ORDENADO = 0;
                    END
                SUSPEND;
                END
            END
        END
  END

if (DETALLE = 'L') then
  BEGIN
  FOR SELECT A.ARTI_COD, ARTI_DES, ARTI_UNIDAD, ARTI_EXIST, TAIV_PORC, A.GRUP_COD, A.SUBG_COD, A.MARC_COD, L.lote_nro, L.lote_nro||' - '||L.lote_vence, ARTI_CONSUMO,l.bode_cod, L.lote_saldo,l.lote_costo
      FROM ARTICULO A, LOTES l, TARIFA_IVA T
      WHERE A.ARTI_COD >= '0' AND A.ARTI_COD <= 'zz' AND ARTI_DES >= '' AND ARTI_DES <= 'zz' AND ESAR_COD <> 'I' AND A.TAIV_COD = T.TAIV_COD and a.arti_cod = l.arti_cod
      INTO :CODIGO, :NOMBRE, :UNIDAD, :EXIST, :IVA, :CODGRUPO, :CODSUBG, :CODMARC, :LOTE, :NOMBOD, :CONSUMO, :codbod, :cant, :costo_lote
      DO
        BEGIN
        OK = 'N';
        if (AGRUPA = 'G') then
            BEGIN
            if ((CODGRUPO >= GRPINI) AND (CODGRUPO <= GRPFIN)) then
                OK = 'S';
            end
        ELSE
            if (AGRUPA = 'M') then
                BEGIN
                if ((CODMARC >= GRPINI) AND (CODMARC <= GRPFIN)) then
                    OK = 'S';
                END
        if (OK = 'S') then
            BEGIN
            NOMGRUPO = '';
            NOMMARC = '';
            NOMSUBG = '';
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SELECT MAX(COBA_COD) FROM BARRAS_ARTICULO WHERE ARTI_COD = :codigo AND COBA_UNIDAD = :unidad INTO :codbar;
            if (CODBAR IS NULL) then
                CODBAR = CODIGO;

            if (EXIST <> 'N') then
                BEGIN
                EXECUTE PROCEDURE COSTO_PROMEDIO_UNIDAD(CODIGO, FECHA, UNIDAD) returning_values (COSTO);
                EXECUTE PROCEDURE ULTIMO_COSTO(CODIGO, FECHA, UNIDAD) returning_values (ULTCOSTO);
                SELECT MAX(MVAR_FECHA) FROM MOVIMIENTO_ARTICULO WHERE ARTI_COD = :CODIGO AND MVAR_ENTRADA = 'S' AND MVAR_FECHA <= :FECHA INTO :FECHACOSTO;
                COSTOTOT = :CANT * :COSTO;
                CONSUMO = CONSUMO * CANT;
                if (RESERVA = 'S') then
                    BEGIN
                    SELECT SUM(ORID_ENTREGAR)
                        FROM ORDENINVENTARIO_DETALLE OD, ordenes_inventario O
                        WHERE O.ORIN_ID = OD.ORIN_ID AND ARTI_COD = :CODIGO AND ORIN_FECHA <= :FECHA AND ORIN_FECLLEGA >= :FECHA AND ORID_ANULADO = 'N'
                        INTO :ORDENADO;
                    if (ORDENADO IS NULL) then
                        ORDENADO = 0;
                    ORDENC = 0;
                    FOR SELECT O.ORDC_ID, OCDE_ITEM, OCDE_CANT * OCDE_FACTOR
                        FROM ORDENES_COMPRA O, ORDENES_COMPRA_DETALLE OD
                        WHERE O.ORDC_ID = OD.ORDC_ID AND OD.ARTI_COD = :CODIGO AND (ORDC_FECHA+ORDC_VALIDEZ) >= :FECHA AND ORDC_FECHA <= :FECHA AND OCDE_ANULADO = 'N'
                        INTO :ID, :ITEM, :CANT2
                        do
                        BEGIN
                        EXECUTE PROCEDURE FALTANTE(23, 21, ID, ITEM) returning_values (PEDIDO, UND, FACTOR);
                        if (PEDIDO * FACTOR = CANT2) then /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */
                            EXECUTE PROCEDURE FALTANTE(23, 22, ID, ITEM) returning_values (PEDIDO, UND, FACTOR);
                        if (PEDIDO IS NULL) then
                            PEDIDO = 0;
                        ORDENC = ORDENC + PEDIDO * FACTOR;
                        END
                    ORDENADO = ORDENADO + ORDENC;
                    SELECT SUM(RSDE_LIBERAR)
                        FROM RESERVAS_DETALLE RD, RESERVAS R
                        WHERE R.RESE_ID = RD.RESE_ID AND ARTI_COD = :CODIGO AND RESE_FECHA <= :FECHA AND RESE_VENCE >= :FECHA AND RSDE_ANULADO = 'N'
                        INTO :RESERVADO;
                    if (RESERVADO IS NULL) then
                        RESERVADO = 0;
                    PEDIDO = 0;
                    FOR SELECT P.PEDI_ID, PEDE_ITEM, PEDE_CANT * PEDE_FACTOR
                        FROM PEDIDOS P, PEDIDOS_DETALLE PD
                        WHERE P.PEDI_ID = PD.PEDI_ID AND PD.ARTI_COD = :CODIGO AND (PEDI_FECHA+PEDI_VALIDEZ) >= :FECHA AND PEDI_FECHA <= :FECHA AND PEDE_ANULADO = 'N'
                        INTO :ID, :ITEM, :CANT2
                        do
                        BEGIN
                        EXECUTE PROCEDURE FALTANTE(34, 31, ID, ITEM) returning_values (ORDENC, UND, FACTOR);
                        if ((ORDENC * FACTOR = CANT2) or (PEDAUTO = 'SI')) then /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */
                            EXECUTE PROCEDURE FALTANTE(34, 32, ID, ITEM) returning_values (ORDENC, UND, FACTOR);
                        if (ORDENC IS NULL) then
                            ORDENC = 0;
                        PEDIDO = PEDIDO + ORDENC * FACTOR;
                        END
                    RESERVADO = RESERVADO + PEDIDO;
                    END
                ELSE
                    BEGIN
                    RESERVADO = 0;
                    ORDENADO = 0;
                    END
                SUSPEND;
                END
            END
        END
  end
if (DETALLE = 'N') then
  BEGIN
  FOR SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, ARTI_EXIST, TAIV_PORC, A.GRUP_COD, A.SUBG_COD, A.MARC_COD, ARTI_CONSUMO
      FROM ARTICULO A, TARIFA_IVA T
      WHERE ARTI_COD >= :CODINI AND ARTI_COD <= :CODFIN AND ARTI_DES >= :DESINI AND ARTI_DES <= :DESFIN AND ESAR_COD <> 'I' AND A.TAIV_COD = T.TAIV_COD
      INTO :CODIGO, :NOMBRE, :UNIDAD, :EXIST, :IVA, :CODGRUPO, :CODSUBG, :CODMARC, :CONSUMO
      DO
        BEGIN
        OK = 'N';
        if (AGRUPA = 'G') then
            BEGIN
            if ((GRPINI = '0') AND (GRPFIN = 'zz')) then
                OK = 'S';
            else
                if ((CODGRUPO >= GRPINI) AND (CODGRUPO <= GRPFIN)) then
                    OK = 'S';
            end
        ELSE
            if (AGRUPA = 'M') then
                BEGIN
                if ((GRPINI = '0') AND (GRPFIN = 'zzz')) then
                    OK = 'S';
                else
                    if ((CODMARC >= GRPINI) AND (CODMARC <= GRPFIN)) then
                        OK = 'S';
                END
        if (OK = 'S') then
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SELECT MAX(COBA_COD) FROM BARRAS_ARTICULO WHERE ARTI_COD = :codigo AND COBA_UNIDAD = :unidad INTO :codbar;
            if (CODBAR IS NULL) then
                CODBAR = CODIGO;

            if (EXIST <> 'N') then
                BEGIN
                EXECUTE PROCEDURE SALDO_INICIAL_TOTAL_INV(CODIGO, FECHA) returning_values (CANT);
                EXECUTE PROCEDURE COSTO_PROMEDIO_UNIDAD(CODIGO, FECHA, UNIDAD) returning_values (COSTO);
                EXECUTE PROCEDURE ULTIMO_COSTO(CODIGO, FECHA, UNIDAD) returning_values (ULTCOSTO);
                SELECT MAX(MVAR_FECHA) FROM MOVIMIENTO_ARTICULO WHERE ARTI_COD = :CODIGO AND MVAR_ENTRADA = 'S' AND MVAR_FECHA <= :FECHA INTO :FECHACOSTO;
                COSTOTOT = :CANT * :COSTO;
                CONSUMO = CONSUMO * CANT;
                if (RESERVA = 'S') then
                    BEGIN
                    SELECT SUM(ORID_ENTREGAR)
                        FROM ORDENINVENTARIO_DETALLE OD, ordenes_inventario O
                        WHERE O.ORIN_ID = OD.ORIN_ID AND ARTI_COD = :CODIGO AND ORIN_FECHA <= :FECHA AND ORIN_FECLLEGA >= :FECHA AND ORID_ANULADO = 'N'
                        INTO :ORDENADO;
                        if (ORDENADO IS NULL) then
                            ORDENADO = 0;
                    ORDENC = 0;
                    FOR SELECT O.ORDC_ID, OCDE_ITEM, OCDE_CANT * OCDE_FACTOR
                        FROM ORDENES_COMPRA O, ORDENES_COMPRA_DETALLE OD
                        WHERE O.ORDC_ID = OD.ORDC_ID AND OD.ARTI_COD = :CODIGO AND (ORDC_FECHA+ORDC_VALIDEZ) >= :FECHA AND ORDC_FECHA <= :FECHA AND OCDE_ANULADO = 'N'
                        INTO :ID, :ITEM, :CANT2
                        do
                        BEGIN
                        EXECUTE PROCEDURE FALTANTE(23, 21, ID, ITEM) returning_values (PEDIDO, UND, FACTOR);
                        if (PEDIDO * FACTOR = CANT2) then /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */
                            EXECUTE PROCEDURE FALTANTE(23, 22, ID, ITEM) returning_values (PEDIDO, UND, FACTOR);
                        if (PEDIDO IS NULL) then
                            PEDIDO = 0;
                        ORDENC = ORDENC + PEDIDO * FACTOR;
                        END
                    ORDENADO = ORDENADO + ORDENC;
                    SELECT SUM(RSDE_LIBERAR)
                        FROM RESERVAS_DETALLE RD, RESERVAS R
                        WHERE R.RESE_ID = RD.RESE_ID AND ARTI_COD = :CODIGO AND RESE_FECHA <= :FECHA AND RESE_VENCE >= :FECHA AND RSDE_ANULADO = 'N'
                        INTO :RESERVADO;
                    if (RESERVADO IS NULL) then
                        RESERVADO = 0;
                    PEDIDO = 0;
                    FOR SELECT P.PEDI_ID, PEDE_ITEM, PEDE_CANT * PEDE_FACTOR
                        FROM PEDIDOS P, PEDIDOS_DETALLE PD, PUNTO_VENTA PT
                        WHERE P.PEDI_ID = PD.PEDI_ID AND PD.ARTI_COD = :CODIGO AND PT.ptvt_id = P.PTVT_ID AND (PEDI_FECHA+PEDI_VALIDEZ) >= :FECHA AND PEDI_FECHA <= :FECHA AND PEDE_ANULADO = 'N'
                        INTO :ID, :ITEM, :CANT2
                        do
                        BEGIN
                        EXECUTE PROCEDURE FALTANTE(34, 31, ID, ITEM) returning_values (ORDENC, UND, FACTOR);
                        if ((ORDENC * FACTOR = CANT2) or (PEDAUTO = 'SI')) then /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */
                            EXECUTE PROCEDURE FALTANTE(34, 32, ID, ITEM) returning_values (ORDENC, UND, FACTOR);
                        if (ORDENC IS NULL) then
                            ORDENC = 0;
                        PEDIDO = PEDIDO + ORDENC * FACTOR;
                        END
                    if (PEDIDO IS NULL) then
                        PEDIDO = 0;
                    RESERVADO = RESERVADO + PEDIDO;
                    END
                ELSE
                    BEGIN
                    RESERVADO = 0;
                    ORDENADO = 0;
                    END
                SUSPEND;
                END
            END
        END
  END
END
^

SET TERM ; ^

GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT SELECT ON ARTICULO TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT SELECT ON BODEGA TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT SELECT ON TARIFA_IVA TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT SELECT ON GRUPO TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT SELECT ON MARCAS TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT SELECT ON SUBGRUPO TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT SELECT ON BARRAS_ARTICULO TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT SELECT ON EXISTENCIA TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT EXECUTE ON PROCEDURE SALDO_INICIAL_INVENTARIO TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT EXECUTE ON PROCEDURE COSTO_PROMEDIO_UNIDAD TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT EXECUTE ON PROCEDURE ULTIMO_COSTO TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT SELECT ON MOVIMIENTO_ARTICULO TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT SELECT ON ORDENINVENTARIO_DETALLE TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT SELECT ON ORDENES_INVENTARIO TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT SELECT ON ORDENES_COMPRA TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT SELECT ON ORDENES_COMPRA_DETALLE TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT EXECUTE ON PROCEDURE FALTANTE TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT SELECT ON RESERVAS_DETALLE TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT SELECT ON RESERVAS TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT SELECT ON PEDIDOS TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT SELECT ON PEDIDOS_DETALLE TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT SELECT ON LOTES TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT EXECUTE ON PROCEDURE SALDO_INICIAL_TOTAL_INV TO PROCEDURE EXISTENCIAS_DESDE_HASTA;
GRANT SELECT ON PUNTO_VENTA TO PROCEDURE EXISTENCIAS_DESDE_HASTA;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE IMPR_FACTURA(
    ID INTEGER)
RETURNS (
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    VENCE DATE,
    DIASVENCE INTEGER,
    CONTCRED CHAR(17),
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    VENDEDOR INTEGER,
    NOMVENDEDOR VARCHAR(60),
    PUNTOVTA INTEGER,
    NOMPUNTOVTA VARCHAR(30),
    CODBODEGA VARCHAR(2),
    NOMBODEGA VARCHAR(30),
    AUTORIZACION VARCHAR(20),
    DESPACHO VARCHAR(255),
    TRANSPORTADOR VARCHAR(60),
    COTIZACION VARCHAR(30),
    PEDIDO VARCHAR(30),
    REMISION VARCHAR(30),
    PACIENTE VARCHAR(20),
    NOMPACIENTE VARCHAR(60),
    COMIPORC NUMERIC(9,2),
    COMIMONTO NUMERIC(18,2),
    SUBTOTAL NUMERIC(18,2),
    DTOPORC NUMERIC(9,2),
    DTOMONTO NUMERIC(18,2),
    ADICIONAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    RTEFTEPORC NUMERIC(9,2),
    RTEFTEMONTO NUMERIC(18,2),
    RTEIVAPORC NUMERIC(9,2),
    RTEIVAMONTO NUMERIC(18,2),
    RTEICAPORC NUMERIC(9,2),
    RTEICAMONTO NUMERIC(18,2),
    EXTRA NUMERIC(18,2),
    DTOFPORC NUMERIC(9,2),
    DTOFMONTO NUMERIC(18,2),
    FECHADTO DATE,
    TOTALFAC NUMERIC(18,2),
    TOTALPAGAR NUMERIC(18,2),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    LOTE VARCHAR(15),
    VLOTE DATE,
    UNIDAD VARCHAR(8),
    FACTOR INTEGER,
    LISTAPR INTEGER,
    REFITEM VARCHAR(60),
    BODITEM VARCHAR(2),
    PRUNIT NUMERIC(18,2),
    DTOITPORC NUMERIC(9,2),
    DTOITMONTO NUMERIC(18,2),
    PRNETO NUMERIC(18,2),
    IVAPORC NUMERIC(9,2),
    IVAITMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    SUBTOTIT NUMERIC(18,2),
    SUBTOTITCON NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    CODIGOCL VARCHAR(20),
    ZONACOD VARCHAR(2),
    ZONANOM VARCHAR(60),
    DV CHAR(1),
    DIRECCION VARCHAR(60),
    CIUDAD VARCHAR(40),
    TELEFONO VARCHAR(40),
    CONTACTO VARCHAR(60),
    FAX VARCHAR(25),
    GRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    SUBGRUPO VARCHAR(3),
    NOMSUBG VARCHAR(30),
    MARCA VARCHAR(3),
    NOMMARCA VARCHAR(30),
    PESO NUMERIC(18,4),
    ANCHO NUMERIC(18,4),
    ALTO NUMERIC(18,4),
    LARGO NUMERIC(18,4),
    SUMA1 NUMERIC(18,2),
    SUMA2 NUMERIC(18,2),
    SUMA3 NUMERIC(18,2),
    IVA1 NUMERIC(18,2),
    IVA2 NUMERIC(18,2),
    IVA3 NUMERIC(18,2),
    SUMAEX NUMERIC(18,2),
    SUMAGR NUMERIC(18,2),
    TOTCONSUMO NUMERIC(18,2),
    VEHICULO VARCHAR(8),
    RECIBIDO NUMERIC(18,2),
    CAMBIO NUMERIC(18,2),
    HORA TIME,
    FORMAPAGO1 VARCHAR(30),
    MONTOPAGO1 NUMERIC(18,2),
    FORMAPAGO2 VARCHAR(30),
    MONTOPAGO2 NUMERIC(18,2),
    FORMAPAGO3 VARCHAR(30),
    MONTOPAGO3 NUMERIC(18,2),
    PUNTOS INTEGER,
    PUNTOSACUM INTEGER,
    PUNTOSVENC INTEGER,
    OBSITEM BLOB SUB_TYPE 1 SEGMENT SIZE 80)
AS
DECLARE VARIABLE IMPTOS CHAR(1);
DECLARE VARIABLE TARIFA INTEGER;
declare variable DEVUELTO NUMERIC(18,2);
/*DECLARE VARIABLE NROCOPIA INTEGER;*/
declare variable ORDENCOD CHAR(2);
declare variable IMPRDEV CHAR(2);
declare variable IMPR CHAR(1);
declare variable ITEMFP INTEGER;
declare variable FORMAP VARCHAR(30);
declare variable MONTOP NUMERIC(18,2);
declare variable SUCUR VARCHAR(10);
BEGIN
  SELECT F.PREF_PRE, FACT_NUMERO, FACT_FECHA, FACT_VENCE, F.BODE_COD, BODE_NOM, F.TERC_NIT, FACT_NOMCLIENTE, F.VEND_COD, VEND_NOMBRE, F.PTVT_ID, PTVT_NOM,
    AUTO_NUMERO, FACT_DESPACHO, FACT_TRANSP, FACT_COTIZACI, FACT_PEDIDO, FACT_REMISION, FACT_COMIPORC, FACT_COMIMONTO, FACT_IVAINC, 
    FACT_DTOPOR, FACT_DTOMONTO, FACT_ADICIONAL, FACT_IVAMONTO, FACT_RTFTEPOR, FACT_RTFTEMONTO, FACT_RTIVAPOR, FACT_RTIVAMONTO, FACT_RTICAPOR, FACT_RTICAMONTO, FACT_EXTRA, FACT_DTOFPOR, FACT_DTOFMONTO, FACT_DTOFFECHA, FACT_TOTAL,
    TERC_DIR, TERC_CIU, TERC_TEL, TERC_CONTACTO, TERC_FAX, TERC_DV,
    FACT_OBS, VEHI_COD, /*FACT_NROCOPIA,*/ FACT_RECIBIDO, FACT_SUCURSAL, FACT_DETCLI, FACT_DETCLINOM
    FROM FACTURAS F, BODEGA B, VENDEDORES V, PUNTO_VENTA P, TERCEROS T
    WHERE F.BODE_COD = B.BODE_COD AND F.VEND_COD = V.VEND_COD AND F.PTVT_ID = P.PTVT_ID AND F.TERC_NIT = T.TERC_NIT AND F.FACT_ID = :ID
    into :PREF, :NUMERO, :FECHA, :VENCE, :CODBODEGA, :NOMBODEGA, :NIT, :NOMTERCERO, :VENDEDOR, :NOMVENDEDOR, :PUNTOVTA, :NOMPUNTOVTA,
    :AUTORIZACION, :DESPACHO, :TRANSPORTADOR, :COTIZACION, :PEDIDO, :REMISION, :COMIPORC, :COMIMONTO, :IMPTOS,
    :DTOPORC, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTEFTEPORC, :RTEFTEMONTO, :RTEIVAPORC, :RTEIVAMONTO, :RTEICAPORC, :RTEICAMONTO, :EXTRA, :DTOFPORC, :DTOFMONTO, :FECHADTO, :TOTALFAC,
    :DIRECCION, :CIUDAD, :TELEFONO, :CONTACTO, :FAX, :DV, :OBS, :VEHICULO,/* :NROCOPIA,*/ :RECIBIDO, :SUCUR, :paciente, :nompaciente;

  /* ACUMULE LOS PUNTOS, SE HACE ACA POR SER POSTERIOR AL DETALLE */
  EXECUTE PROCEDURE acumula_puntos_cliente (31, :id, :nit, :fecha) returning_values (:PUNTOS);
  EXECUTE PROCEDURE consulta_puntos_cliente (:id, :nit, :fecha) returning_values (:puntos, :puntosacum, :puntosvenc);

  SELECT CLIE_COD, C.ZONA_COD, ZONA_NOM
    FROM CLIENTES C, ZONAS Z
    WHERE TERC_NIT = :NIT AND C.ZONA_COD = Z.ZONA_COD
    INTO :CODIGOCL, :ZONACOD, :ZONANOM;
  /*SELECT NOCO_NOMBRE FROM NOMBRES_COPIAS where NOCO_ID = :NROCOPIA INTO :NOMCOPIA;*/
  SELECT CLSU_DIR, CLSU_CIUDAD, CLSU_TEL FROM CLIENTE_SUCURSALES WHERE TERC_NIT = :NIT AND CLCU_COD = :SUCUR
    INTO :DIRECCION, :CIUDAD, :TELEFONO;
  /*if (NOMCOPIA IS NULL) then
    NOMCOPIA = 'COPIA No. ' || NROCOPIA;**/
  DIASVENCE = VENCE - FECHA;
  if (DIASVENCE > 0) then
    CONTCRED = 'CREDITO ' || CAST(DIASVENCE AS VARCHAR(3)) || ' DIAS';
  ELSE
    CONTCRED = 'CONTADO';
  SUBTOTAL = TOTALFAC - EXTRA - IVAMONTO - ADICIONAL + DTOMONTO;
  TOTALPAGAR = TOTALFAC - RTEFTEMONTO - RTEIVAMONTO - RTEICAMONTO;
  if (RECIBIDO <> 0) then
      CAMBIO = RECIBIDO - totalpagar;
  ELSE
    CAMBIO = 0;
  SUMAEX = 0;
  SUMA1 = 0;
  SUMA2 = 0;
  SUMA3 = 0;
  IVA1 = 0;
  IVA2 = 0;
  IVA3 = 0;
  TOTCONSUMO = 0;
  MONTOPAGO1 = 0;
  SELECT MAX(AUDI_HORA) FROM AUDITORIA WHERE TIDO_COD = 31 AND AUDI_IDDOC = :ID AND AUDI_OPER = 'I' INTO :HORA;
  /* AHORA LAS FORMAS DE PAGO, BUSQUE EL ABONO DE HOY A LA FACTURA */
  ITEMFP = 1;
  MONTOPAGO1 = 0;
  MONTOPAGO2 = 0;
  MONTOPAGO3 = 0;
  FOR SELECT FOPA_NOM, RCPA_MONTO FROM RECIBOS_CAJA_PAGO P, FORMAS_PAGO F, RECIBOS_CAJA R, RECIBOS_CAJA_DETALLE D
    WHERE R.RECA_ID = P.RECA_ID AND R.RECA_ID = D.RECA_ID AND P.FOPA_ID = F.FOPA_ID AND RECA_FECHA = :FECHA AND RCDE_TIPODOC = 31 AND RCDE_IDDOC = :ID
    INTO :formap, :MONTOP
    DO
    BEGIN
    if (ITEMFP = 1) then
        BEGIN
        FORMAPAGO1 = FORMAP;
        MONTOPAGO1 = MONTOP;
        END
    if (ITEMFP = 2) then
        BEGIN
        FORMAPAGO2 = FORMAP;
        MONTOPAGO2 = MONTOP;
        END
    if (ITEMFP = 3) then
        BEGIN
        FORMAPAGO3 = FORMAP;
        MONTOPAGO3 = MONTOP;
        END
    ITEMFP = ITEMFP + 1;
    END
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','DOCUMENTOS','ORDENAR ITEMS POR CODIGO DE ARTICULO') returning_values (:ORDENCOD);
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','POS', 'IMPRIMIR DEVOLUCIONES DE ARTICULOS NEGATIVOS') returning_values (:imprdev);
  if (ORDENCOD = 'SI') then
    BEGIN
    FOR SELECT FADE_ITEM, D.ARTI_COD, FADE_CODBAR, SUBSTR(FADE_DESC,1,60), FADE_CANT, FADE_UNIDAD, FADE_FACTOR, BODE_COD, FADE_LOTE, LIPR_COD, FADE_PRUNIT, FADE_DTOPORC, FADE_DTOMONTO, FADE_IVAPORC, FADE_IVAMONTO, FADE_CONSUMO, FADE_TOTAL, FADE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, FADE_DEVUELTO, FADE_OBS
        FROM FACTURAS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.FACT_ID = :ID
        ORDER BY D.ARTI_COD
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :FACTOR, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem,
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :devuelto, :obsitem
        DO
          BEGIN
          if (ARTICULO = CODBAR) then
            SELECT FIRST 1 COBA_COD FROM barras_articulo WHERE ARTI_COD = :articulo INTO :CODBAR;
          if (IMPRDEV <> 'SI') then
            BEGIN
            if ((CANT >= 0) AND (DEVUELTO = 0)) then
                IMPR = 'S';
            ELSE
                IMPR = 'N'; /* ES DEVOLUCION */
            END
          ELSE
            IMPR = 'S';
          if (IMPR = 'S') then
            BEGIN
            if (IMPTOS = 'S') then
                if (cant <> 0) then
                    PRNETO = PRUNIT - DTOITMONTO - ((IVAITMONTO+CONSUMO) / CANT);
                else
                    PRNETO = PRUNIT - DTOITMONTO;
            ELSE
                PRNETO = PRUNIT - DTOITMONTO;
            SUBTOTIT = TOTAL - IVAITMONTO - CONSUMO;
            SUBTOTITCON = TOTAL;
            TOTCONSUMO = TOTCONSUMO + CONSUMO;
            SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO AND BODE_COD = :boditem INTO :vlote;
            if (TARIFA = 0) then
                SUMAEX = SUMAEX + TOTAL;
            if (TARIFA = 1) then
                BEGIN
                SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
                IVA1 = IVA1 + IVAITMONTO;
                END
            if (TARIFA = 2) then
                BEGIN
                SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
                IVA2 = IVA2 + IVAITMONTO;
                END
            if (TARIFA = 3) then
                BEGIN
                SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
                IVA3 = IVA3 + IVAITMONTO;
                END
            SUMAGR = SUMA1 + SUMA2 + SUMA3;
            if (IMPTOS = 'N') then
                TOTAL = TOTAL - IVAITMONTO - CONSUMO;
            if (ANCHO IS NULL) then
                ANCHO = 0;
            if (ALTO IS NULL) then
                ALTO = 0;
            if (LARGO IS NULL) then
                LARGO = 0;
            if (PESO IS NULL) then
                PESO = 0;
            PESO = PESO * CANT;
            SUSPEND;
            END
          END
    END
ELSE
    BEGIN
    FOR SELECT FADE_ITEM, D.ARTI_COD, FADE_CODBAR, SUBSTR(FADE_DESC,1,60), FADE_CANT, FADE_UNIDAD, FADE_FACTOR, BODE_COD, FADE_LOTE, LIPR_COD, FADE_PRUNIT, FADE_DTOPORC, FADE_DTOMONTO, FADE_IVAPORC, FADE_IVAMONTO, FADE_CONSUMO, FADE_TOTAL, FADE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, FADE_DEVUELTO, FADE_OBS
        FROM FACTURAS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.FACT_ID = :ID
        ORDER BY FADE_ITEM
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :FACTOR, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem, 
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :devuelto, :obsitem
        DO
          BEGIN
          if (IMPRDEV <> 'SI') then
            BEGIN
            if ((CANT >= 0) AND (DEVUELTO = 0)) then
                IMPR = 'S';
            ELSE
                IMPR = 'N'; /* ES DEVOLUCION */
            END
          ELSE
            IMPR = 'S';
          if (IMPR = 'S') then
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
            if (IMPTOS = 'S') then
              PRNETO = PRUNIT - DTOITMONTO - ((IVAITMONTO+CONSUMO) / CANT);
            ELSE
              PRNETO = PRUNIT - DTOITMONTO;
            SUBTOTIT = TOTAL - IVAITMONTO - CONSUMO;
            SUBTOTITCON = TOTAL;
            TOTCONSUMO = TOTCONSUMO + CONSUMO;
            SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO AND BODE_COD = :boditem INTO :vlote;
            if (IVAPORC = 0) then
                SUMAEX = SUMAEX + TOTAL;
            if (TARIFA = 1) then
                BEGIN
                SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
                IVA1 = IVA1 + IVAITMONTO;
                END
            if (TARIFA = 2) then
                BEGIN
                SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
                IVA2 = IVA2 + IVAITMONTO;
                END
            if (TARIFA = 3) then
                BEGIN
                SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
                IVA3 = IVA3 + IVAITMONTO;
                END
            SUMAGR = SUMA1 + SUMA2 + SUMA3;
            if (IMPTOS = 'N') then
                TOTAL = TOTAL - IVAITMONTO - CONSUMO;
            if (ANCHO IS NULL) then
                ANCHO = 0;
            if (ALTO IS NULL) then
                ALTO = 0;
            if (LARGO IS NULL) then
                LARGO = 0;
            if (PESO IS NULL) then
                PESO = 0;
            PESO = PESO * CANT;
            SUSPEND;
            END
          END
    END
END
^

SET TERM ; ^

GRANT SELECT ON FACTURAS TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON BODEGA TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON VENDEDORES TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON PUNTO_VENTA TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON TERCEROS TO PROCEDURE IMPR_FACTURA;
GRANT EXECUTE ON PROCEDURE ACUMULA_PUNTOS_CLIENTE TO PROCEDURE IMPR_FACTURA;
GRANT EXECUTE ON PROCEDURE CONSULTA_PUNTOS_CLIENTE TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON CLIENTES TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON ZONAS TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON CLIENTE_SUCURSALES TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON AUDITORIA TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON RECIBOS_CAJA_PAGO TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON FORMAS_PAGO TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON RECIBOS_CAJA TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON RECIBOS_CAJA_DETALLE TO PROCEDURE IMPR_FACTURA;
GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON FACTURAS_DETALLE TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON ARTICULO TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON BARRAS_ARTICULO TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON LOTES TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON GRUPO TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON MARCAS TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON SUBGRUPO TO PROCEDURE IMPR_FACTURA;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE IMPR_REMISION(
    ID INTEGER)
RETURNS (
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    VENDEDOR INTEGER,
    NOMVENDEDOR VARCHAR(60),
    PUNTOVTA INTEGER,
    NOMPUNTOVTA VARCHAR(30),
    CODBODEGA VARCHAR(2),
    NOMBODEGA VARCHAR(30),
    COTIZACION VARCHAR(30),
    PEDIDO VARCHAR(30),
    FACTURA VARCHAR(30),
    SUBTOTAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    TOTALFAC NUMERIC(18,2),
    DESPACHO VARCHAR(255),
    TRANSPORTADOR VARCHAR(60),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    LOTE VARCHAR(15),
    VLOTE DATE,
    UNIDAD VARCHAR(8),
    DEVUELTO NUMERIC(18,4),
    LISTAPR INTEGER,
    REFITEM VARCHAR(60),
    BODITEM VARCHAR(2),
    PRUNIT NUMERIC(18,2),
    DTOITPORC NUMERIC(9,2),
    DTOITMONTO NUMERIC(18,2),
    SUBTOTALITEM NUMERIC(18,2),
    PRNETOSINIVA NUMERIC(18,2),
    PRNETO NUMERIC(18,2),
    IVAPORC NUMERIC(9,2),
    IVAITMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    CODIGOCL VARCHAR(20),
    ZONACOD VARCHAR(2),
    ZONANOM VARCHAR(60),
    DV CHAR(1),
    DIRECCION VARCHAR(60),
    CIUDAD VARCHAR(40),
    TELEFONO VARCHAR(40),
    CONTACTO VARCHAR(60),
    FAX VARCHAR(25),
    GRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    SUBGRUPO VARCHAR(3),
    NOMSUBG VARCHAR(30),
    MARCA VARCHAR(3),
    NOMMARCA VARCHAR(30),
    PESO NUMERIC(9,4),
    ANCHO NUMERIC(18,4),
    ALTO NUMERIC(18,4),
    LARGO NUMERIC(18,4),
    SUMA1 NUMERIC(18,2),
    SUMA2 NUMERIC(18,2),
    SUMA3 NUMERIC(18,2),
    IVA1 NUMERIC(18,2),
    IVA2 NUMERIC(18,2),
    IVA3 NUMERIC(18,2),
    SUMAEX NUMERIC(18,2),
    SUMAGR NUMERIC(18,2),
    OBSITEM BLOB SUB_TYPE 1 SEGMENT SIZE 80)
AS
DECLARE VARIABLE IMPTOS CHAR(1);
DECLARE VARIABLE TARIFA INTEGER;
declare variable ORDENCOD CHAR(2);
declare variable SUCUR VARCHAR(10);
BEGIN
  /*  */
  SELECT F.PREF_PRE, REVT_NUMERO, REVT_FECHA, F.BODE_COD, BODE_NOM, F.TERC_NIT, REVT_NOMTERC, F.VEND_COD, VEND_NOMBRE, F.PTVT_ID, PTVT_NOM,
    REVT_COTIZACI, REVT_PEDIDO, REVT_FACTURA, REVT_IVAINC,
    REVT_IVAMONTO, REVT_TOTAL, REVT_DESPACHO, REVT_TRANSP,
    TERC_CONTACTO, TERC_FAX, TERC_DV, REVT_OBS, REVT_SUCURSAL
    FROM REMISIONES_VENTA F, BODEGA B, VENDEDORES V, PUNTO_VENTA P, TERCEROS T
    WHERE F.BODE_COD = B.BODE_COD AND F.VEND_COD = V.VEND_COD AND F.PTVT_ID = P.PTVT_ID AND F.TERC_NIT = T.TERC_NIT AND F.REVT_ID = :ID
    into :PREF, :NUMERO, :FECHA, :CODBODEGA, :NOMBODEGA, :NIT, :NOMTERCERO, :VENDEDOR, :NOMVENDEDOR, :PUNTOVTA, :NOMPUNTOVTA,
    :COTIZACION, :PEDIDO, :FACTURA, :IMPTOS,
    :IVAMONTO, :TOTALFAC, :DESPACHO, :transportador, 
    :CONTACTO, :FAX, :DV, :OBS, :SUCUR;
  SUBTOTAL = TOTALFAC - IVAMONTO;

  SELECT CLIE_COD, C.ZONA_COD, ZONA_NOM
    FROM CLIENTES C, ZONAS Z
    WHERE TERC_NIT = :NIT AND C.ZONA_COD = Z.ZONA_COD
    INTO :CODIGOCL, :ZONACOD, :ZONANOM;
  SELECT CLSU_DIR, CLSU_CIUDAD, CLSU_TEL FROM CLIENTE_SUCURSALES WHERE TERC_NIT = :NIT AND CLCU_COD = :SUCUR
    INTO :DIRECCION, :CIUDAD, :TELEFONO;
    
  SUMAEX = 0;
  SUMA1 = 0;
  SUMA2 = 0;
  SUMA3 = 0;
  IVA1 = 0;
  IVA2 = 0;
  IVA3 = 0;
  ITEM = 0;
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','DOCUMENTOS','ORDENAR ITEMS POR CODIGO DE ARTICULO') returning_values (:ORDENCOD);
  if (ORDENCOD = 'SI') then
    BEGIN
    FOR SELECT D.ARTI_COD, RVDE_CODBAR, SUBSTR(RVDE_DESC,1,60), RVDE_CANT, RVDE_UNIDAD, BODE_COD, RVDE_LOTE, LIPR_COD, RVDE_PRUNIT, RVDE_DTOPORC, RVDE_DTOMONTO, RVDE_IVAPORC, RVDE_IVAMONTO, RVDE_CONSUMO, RVDE_TOTAL, RVDE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, RVDE_DEVUELTO, RVDE_OBS
        FROM REMISIONES_VENTA_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.REVT_ID = :ID
        ORDER BY RVDE_CODBAR
        INTO :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem,
            :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :DEVUELTO, :obsitem
        DO
        BEGIN
        if (ARTICULO = CODBAR) then
            SELECT FIRST 1 COBA_COD FROM barras_articulo WHERE ARTI_COD = :articulo INTO :CODBAR;
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
        SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO AND BODE_COD = :boditem INTO :vlote;
        ITEM = ITEM + 1;
        PRNETO = PRUNIT - DTOITMONTO;
        if (IVAPORC = 0) then
            SUMAEX = SUMAEX + TOTAL;
        if (TARIFA = 1) then
            BEGIN
            SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
            IVA1 = IVA1 + IVAITMONTO;
            END
        if (TARIFA = 2) then
            BEGIN
            SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
            IVA2 = IVA2 + IVAITMONTO;
            END
        if (TARIFA = 3) then
            BEGIN
            SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
            IVA3 = IVA3 + IVAITMONTO;
            END
        SUMAGR = SUMA1 + SUMA2 + SUMA3;

        if (IMPTOS = 'N') then
            TOTAL = TOTAL - IVAITMONTO;
        ELSE
           BEGIN
           PRNETOSINIVA = PRUNIT / (1 + ivaporc/100);
           SUBTOTALITEM = PRNETOSINIVA * :CANT;
           END
        SUSPEND;
        END
    END
ELSE
    BEGIN
    FOR SELECT RVDE_ITEM, D.ARTI_COD, RVDE_CODBAR, SUBSTR(RVDE_DESC,1,60), RVDE_CANT, RVDE_UNIDAD, BODE_COD, RVDE_LOTE, LIPR_COD, RVDE_PRUNIT, RVDE_DTOPORC, RVDE_DTOMONTO, RVDE_IVAPORC, RVDE_IVAMONTO, RVDE_CONSUMO, RVDE_TOTAL, RVDE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, RVDE_DEVUELTO, RVDE_OBS
        FROM REMISIONES_VENTA_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.REVT_ID = :ID
        ORDER BY RVDE_ITEM
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem,
            :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :DEVUELTO, :obsitem
        DO
        BEGIN
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
        SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO AND BODE_COD = :boditem INTO :vlote;
        ITEM = ITEM + 1;
        PRNETO = PRUNIT - DTOITMONTO;
        if (IVAPORC = 0) then
            SUMAEX = SUMAEX + TOTAL;
        if (TARIFA = 1) then
            BEGIN
            SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
            IVA1 = IVA1 + IVAITMONTO;
            END
        if (TARIFA = 2) then
            BEGIN
            SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
            IVA2 = IVA2 + IVAITMONTO;
            END
        if (TARIFA = 3) then
            BEGIN
            SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
            IVA3 = IVA3 + IVAITMONTO;
            END
        SUMAGR = SUMA1 + SUMA2 + SUMA3;
        SUBTOTALITEM = TOTAL - IVAITMONTO;
        if (IMPTOS = 'N') then
            TOTAL = TOTAL - IVAITMONTO;
        ELSE
           BEGIN
             PRNETOSINIVA = PRUNIT / (1 + ivaporc/100);
             SUBTOTALITEM = PRNETOSINIVA * :CANT;
           END
        SUSPEND;
        END
    END
END
^

SET TERM ; ^

GRANT SELECT ON REMISIONES_VENTA TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON BODEGA TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON VENDEDORES TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON PUNTO_VENTA TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON TERCEROS TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON CLIENTES TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON ZONAS TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON CLIENTE_SUCURSALES TO PROCEDURE IMPR_REMISION;
GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON REMISIONES_VENTA_DETALLE TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON ARTICULO TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON BARRAS_ARTICULO TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON GRUPO TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON MARCAS TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON SUBGRUPO TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON LOTES TO PROCEDURE IMPR_REMISION;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE LISTA_LOTES(
    ARTICULO VARCHAR(15),
    BODEGA VARCHAR(2),
    CANT NUMERIC(18,4))
RETURNS (
    LOTE VARCHAR(15),
    SALDO NUMERIC(18,4),
    VENCE DATE)
AS
BEGIN
  /* Muestra los lotes del artculo con existencia */
  for select lote_nro, lote_saldo, lote_vence from lotes
    where arti_cod = :articulo and BODE_COD = :bodega AND lote_saldo >= :cant and lote_saldo <> 0
    into :lote, :saldo, :vence
    do
      SUSPEND;
END
^

SET TERM ; ^

GRANT SELECT ON LOTES TO PROCEDURE LISTA_LOTES;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE MAYOR_SALDO_LOTE(
    ARTICULO VARCHAR(15),
    BODEGA VARCHAR(2))
RETURNS (
    LOTE VARCHAR(15),
    SALDO NUMERIC(18,4))
AS
BEGIN
  SELECT MAX(LOTE_SALDO) FROM LOTES
    WHERE ARTI_COD = :ARTICULO AND BODE_COD = :bodega INTO :SALDO;
  SELECT LOTE_NRO FROM LOTES
    WHERE (ARTI_COD = :ARTICULO) AND BODE_COD = :bodega AND LOTE_SALDO = :SALDO INTO :LOTE;
  SUSPEND;
END
^

SET TERM ; ^

GRANT SELECT ON LOTES TO PROCEDURE MAYOR_SALDO_LOTE;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_MOVIMIENTO_X_ARTICULO(
    DETALLE CHAR(1),
    FECINI DATE,
    FECFIN DATE,
    ARTINI VARCHAR(20),
    ARTFIN VARCHAR(20),
    GRPINI VARCHAR(2),
    GRPFIN VARCHAR(2),
    ORDEN CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    CODIGO VARCHAR(15),
    NOMBRE VARCHAR(60),
    UNIDAD VARCHAR(8),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    CODBOD VARCHAR(2),
    NOMBOD VARCHAR(30),
    SALDOINI NUMERIC(18,4),
    ENTRADAS NUMERIC(18,4),
    SALIDAS NUMERIC(18,4),
    SALDOFIN NUMERIC(18,4),
    TIPODOC VARCHAR(8),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    CONCEPTO VARCHAR(60),
    LOTE VARCHAR(15),
    LO_VENCE DATE,
    NIT VARCHAR(20),
    NOMTERC VARCHAR(60),
    CONS INTEGER)
AS
declare variable ENTRADA CHAR(1);
declare variable IDMOV INTEGER;
declare variable CODINI VARCHAR(20);
declare variable CODant VARCHAR(15) CHARACTER SET NONE;
declare variable CODFIN VARCHAR(20);
declare variable DESINI VARCHAR(20);
declare variable DESFIN VARCHAR(20);
DECLARE VARIABLE FEC DATE;
BEGIN
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END

if (DETALLE = 'L') then
  BEGIN
   codant = 0;
   for SELECT A.ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD, LOTE_NRO,LOTE_VENCE, BODE_COD
     FROM ARTICULO A, LOTES L
     WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :GRPFIN AND
       ARTI_DES >= :DESINI AND ARTI_DES <= :DESFIN AND A.ESAR_COD <> 'I' AND a.arti_cod = l.arti_cod
     INTO :CODIGO, :NOMBRE, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :LOTE, :LO_VENCE, :codbod
     DO
     BEGIN
      SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
      SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
      SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;

      SELECT  MAX(EXIS_FECHA) FROM EXISTENCIA
        WHERE (ARTI_COD = :CODIGO) AND (BODE_COD = :codbod) AND (EXIS_FECHA < :FECINI) INTO :FEC;
      IF (FEC IS NULL) THEN
        SALDOINI = 0;
      ELSE
        begin
        /* Con la fecha mxima calcule el nuevo saldo */
        if (FECINI = FEC) then
          SELECT SUM(EXIS_SALDO) FROM EXISTENCIA
            WHERE (ARTI_COD = :CODIGO) AND (BODE_COD = :codbod) AND (EXIS_FECHA = :FEC) INTO :SALDOINI;
        ELSE
          SELECT SUM(EXIS_ENTR - EXIS_SAL) FROM EXISTENCIA
            WHERE (ARTI_COD = :CODIGO) AND (BODE_COD = :codbod) AND (EXIS_FECHA <= :FEC) INTO :SALDOINI;
        end
      if (SALDOINI IS NULL) then
        SALDOINI = 0;
      if (codigo <> codant) then
          SALDOFIN = SALDOINI;
/*      for SELECT * FROM MOVLOTES_DESDE_HASTA(:codigo, :LOTE,:fecini, :fecfin,:SUBEMPRESA)
        ORDER BY FECHA,CONS
        INTO :TIPODOC, :PREFIJO, :NUMERO, :FECHA, :CONCEPTO, :ENTRADA, :ENTRADAS, :SALIDAS, :IDMOV, :NIT, :CONS
        DO
        BEGIN
          if (nit is not null) then
            SELECT TERC_NOM FROM TERCEROS WHERE TERC_NIT = :NIT INTO :NOMTERC;
          else
            NOMTERC = '';
          if (ENTRADA = 'S') then
           BEGIN
            salidas = 0;
            SALDOFIN = SALDOFIN + ENTRADAS;
           END
          ELSE
           BEGIN
            ENTRADAS = 0;
            SALDOFIN = SALDOFIN - SALIDAS;
           END
          SUSPEND;
        END */
      codant = :codigo;
    END
  END
ELSE
 BEGIN
  FOR
    SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD, BODE_COD, BODE_NOM
      FROM ARTICULO A, BODEGA B
      WHERE ARTI_COD >= :CODINI AND ARTI_COD <= :CODFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :GRPFIN AND
       ARTI_DES >= :DESINI AND ARTI_DES <= :DESFIN AND A.ESAR_COD <> 'I' AND ((SUCU_ID = :SUBEMPRESA) OR (:SUBEMPRESA = 0))
      INTO :CODIGO, :NOMBRE, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :CODBOD, :NOMBOD
      DO
        BEGIN
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
        EXECUTE PROCEDURE SALDO_INICIAL_INVENTARIO(CODIGO, FECINI, :CODBOD) returning_values (:SALDOINI);
        if (DETALLE = 'N') then
            BEGIN
            /* SUME LAS ENTRADAS */
            SELECT SUM(MVAR_CANT) FROM MOVIMIENTO_ARTICULO
              WHERE (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA <= :FECFIN) AND
              (ARTI_COD = :CODIGO) AND (BODE_COD = :CODBOD) AND (MVAR_ENTRADA = 'S') INTO :ENTRADAS;
            if (ENTRADAS IS NULL) then
              ENTRADAS = 0;
            /* CALCULE LAS SALIDAS A COSTO PROMEDIO */
            SALIDAS = 0;
            SELECT SUM(MVAR_CANT)
                FROM MOVIMIENTO_ARTICULO
                WHERE (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA <= :FECFIN) AND
                (ARTI_COD = :CODIGO) AND (BODE_COD = :CODBOD) AND (MVAR_ENTRADA = 'N')
                INTO :SALIDAS;
            if (SALIDAS IS NULL) then
              SALIDAS = 0;
            SALDOFIN = SALDOINI + ENTRADAS - SALIDAS;
            SUSPEND;
            END
        if (DETALLE = 'B') then
            BEGIN
            SALDOFIN = SALDOINI;
            FOR SELECT TIDO_NOMCORTO, MVAR_ENTRADA, MVAR_PREF, MVAR_NUMERO, MVAR_CANT, MVAR_CONC, MVAR_FECHA, M.TERC_NIT, MVAR_CONS
                FROM MOVIMIENTO_ARTICULO M, TIPO_DOCUMENTO TD
                WHERE TD.TIDO_COD = MVAR_TIPODOC AND (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA <= :FECFIN) AND (ARTI_COD = :CODIGO) AND (BODE_COD = :CODBOD)
                ORDER BY MVAR_FECHA, MVAR_CONS
                INTO :TIPODOC, :ENTRADA, :PREFIJO, :NUMERO, :ENTRADAS, :CONCEPTO, :FECHA, :NIT, :CONS
                DO
                    BEGIN
                    if (nit is not null) then
                        SELECT TERC_NOM FROM TERCEROS WHERE TERC_NIT = :NIT INTO :NOMTERC;
                    else
                        NOMTERC = '';
                    if (ENTRADA = 'S') then
                        BEGIN
                        SALIDAS = 0;
                        SALDOFIN = SALDOFIN + ENTRADAS;
                        end
                    ELSE
                        BEGIN
                        SALIDAS = ENTRADAS;
                        ENTRADAS = 0;
                        SALDOFIN = SALDOFIN - SALIDAS;
                        END
                    SUSPEND;
                    END
            END
        END
  END
END
^

SET TERM ; ^

GRANT SELECT ON ARTICULO TO PROCEDURE REP_MOVIMIENTO_X_ARTICULO;
GRANT SELECT ON LOTES TO PROCEDURE REP_MOVIMIENTO_X_ARTICULO;
GRANT SELECT ON GRUPO TO PROCEDURE REP_MOVIMIENTO_X_ARTICULO;
GRANT SELECT ON MARCAS TO PROCEDURE REP_MOVIMIENTO_X_ARTICULO;
GRANT SELECT ON SUBGRUPO TO PROCEDURE REP_MOVIMIENTO_X_ARTICULO;
GRANT SELECT ON EXISTENCIA TO PROCEDURE REP_MOVIMIENTO_X_ARTICULO;
GRANT SELECT ON BODEGA TO PROCEDURE REP_MOVIMIENTO_X_ARTICULO;
GRANT EXECUTE ON PROCEDURE SALDO_INICIAL_INVENTARIO TO PROCEDURE REP_MOVIMIENTO_X_ARTICULO;
GRANT SELECT ON MOVIMIENTO_ARTICULO TO PROCEDURE REP_MOVIMIENTO_X_ARTICULO;
GRANT SELECT ON TIPO_DOCUMENTO TO PROCEDURE REP_MOVIMIENTO_X_ARTICULO;
GRANT SELECT ON TERCEROS TO PROCEDURE REP_MOVIMIENTO_X_ARTICULO;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE MOVLOTES_DESDE_HASTA(
    ARTICULO VARCHAR(15),
    BODEGA VARCHAR(2),
    LOTE VARCHAR(15),
    DESDE DATE,
    HASTA DATE,
    AGENCIA INTEGER)
RETURNS (
    TIPODOC VARCHAR(8),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    CONCEPTO VARCHAR(60),
    ENT CHAR(1),
    CANTENT NUMERIC(18,4),
    CANTSAL NUMERIC(18,4),
    IDMOV INTEGER,
    NIT VARCHAR(20),
    CONS INTEGER)
AS
declare variable Cant numeric(18,4);
begin
  /* Retorna el mov. x LOTE detallado desde hasta */
  for select tido_nomcorto, mvar_pref, mvar_numero, mvar_fecha, mvar_conc, mvar_entrada, mvar_cant, MVAR_IDREF,TERC_NIT, MVAR_CONS
    from tipo_documento t, movimiento_articulo m, prefijos p
    where t.tido_cod = m.mvar_tipodoc and arti_cod = :articulo and BODE_COD = :BODEGA and MVAR_LOTE = :LOTE and mvar_fecha >= :desde and mvar_fecha <= :hasta and
    p.tido_cod = t.tido_cod and p.pref_pre = m.mvar_pref and ((:agencia = 0) or (p.sucu_id = :agencia))
    ORDER BY MVAR_FECHA into :tipodoc, :prefijo, :numero, :fecha, :concepto, :Ent, :Cant, :IDMOV, :nit, :cons 
    do
        begin
          if (:Ent = 'S') then
            begin
            CANTENT = Cant;
            CANTSAL = 0;
            end
          else
            begin
            CANTENT = 0;
            CANTSAL = Cant;
            end
          SUSPEND;
        end
end
^

SET TERM ; ^

GRANT SELECT ON TIPO_DOCUMENTO TO PROCEDURE MOVLOTES_DESDE_HASTA;
GRANT SELECT ON MOVIMIENTO_ARTICULO TO PROCEDURE MOVLOTES_DESDE_HASTA;
GRANT SELECT ON PREFIJOS TO PROCEDURE MOVLOTES_DESDE_HASTA;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_MOVIMIENTO_X_ARTICULO(
    DETALLE CHAR(1),
    FECINI DATE,
    FECFIN DATE,
    ARTINI VARCHAR(20),
    ARTFIN VARCHAR(20),
    GRPINI VARCHAR(2),
    GRPFIN VARCHAR(2),
    ORDEN CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    CODIGO VARCHAR(15),
    NOMBRE VARCHAR(60),
    UNIDAD VARCHAR(8),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    CODBOD VARCHAR(2),
    NOMBOD VARCHAR(30),
    SALDOINI NUMERIC(18,4),
    ENTRADAS NUMERIC(18,4),
    SALIDAS NUMERIC(18,4),
    SALDOFIN NUMERIC(18,4),
    TIPODOC VARCHAR(8),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    CONCEPTO VARCHAR(60),
    LOTE VARCHAR(15),
    LO_VENCE DATE,
    NIT VARCHAR(20),
    NOMTERC VARCHAR(60),
    CONS INTEGER)
AS
declare variable ENTRADA CHAR(1);
declare variable CODINI VARCHAR(20);
declare variable CODant VARCHAR(15) CHARACTER SET NONE;
declare variable CODFIN VARCHAR(20);
declare variable DESINI VARCHAR(20);
declare variable DESFIN VARCHAR(20);
DECLARE VARIABLE FEC DATE;
BEGIN
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END

if (DETALLE = 'L') then
  BEGIN
   codant = 0;
   for SELECT A.ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD, LOTE_NRO,LOTE_VENCE, BODE_COD
     FROM ARTICULO A, LOTES L
     WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :GRPFIN AND
       ARTI_DES >= :DESINI AND ARTI_DES <= :DESFIN AND A.ESAR_COD <> 'I' AND a.arti_cod = l.arti_cod
     INTO :CODIGO, :NOMBRE, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :LOTE, :LO_VENCE, :codbod
     DO
     BEGIN
      SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
      SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
      SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
      SELECT BODE_NOM FROM BODEGA WHERE BODE_COD = :codbod INTO nombod;

      SELECT  MAX(EXIS_FECHA) FROM EXISTENCIA
        WHERE (ARTI_COD = :CODIGO) AND (BODE_COD = :codbod) AND (EXIS_FECHA < :FECINI) INTO :FEC;
      IF (FEC IS NULL) THEN
        SALDOINI = 0;
      ELSE
        begin
        /* Con la fecha mxima calcule el nuevo saldo */
        if (FECINI = FEC) then
          SELECT SUM(EXIS_SALDO) FROM EXISTENCIA
            WHERE (ARTI_COD = :CODIGO) AND (BODE_COD = :codbod) AND (EXIS_FECHA = :FEC) INTO :SALDOINI;
        ELSE
          SELECT SUM(EXIS_ENTR - EXIS_SAL) FROM EXISTENCIA
            WHERE (ARTI_COD = :CODIGO) AND (BODE_COD = :codbod) AND (EXIS_FECHA <= :FEC) INTO :SALDOINI;
        end
      if (SALDOINI IS NULL) then
        SALDOINI = 0;
      if (codigo <> codant) then
          SALDOFIN = SALDOINI;
      for SELECT TIPODOC, PREFIJO, NUMERO, FECHA, CONCEPTO, ENT, CANTENT, CANTSAL, NIT, CONS
        FROM MOVLOTES_DESDE_HASTA(:codigo, :codbod, :LOTE,:fecini, :fecfin,:SUBEMPRESA)
        ORDER BY FECHA,CONS
        INTO :TIPODOC, :PREFIJO, :NUMERO, :FECHA, :CONCEPTO, :ENTRADA, :ENTRADAS, :SALIDAS, :NIT, :CONS
        DO
        BEGIN
          if (nit is not null) then
            SELECT TERC_NOM FROM TERCEROS WHERE TERC_NIT = :NIT INTO :NOMTERC;
          else
            NOMTERC = '';
          if (ENTRADA = 'S') then
           BEGIN
            salidas = 0;
            SALDOFIN = SALDOFIN + ENTRADAS;
           END
          ELSE
           BEGIN
            ENTRADAS = 0;
            SALDOFIN = SALDOFIN - SALIDAS;
           END
          SUSPEND;
        END
      codant = :codigo;
    END
  END
ELSE
 BEGIN
  FOR
    SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD, BODE_COD, BODE_NOM
      FROM ARTICULO A, BODEGA B
      WHERE ARTI_COD >= :CODINI AND ARTI_COD <= :CODFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :GRPFIN AND
       ARTI_DES >= :DESINI AND ARTI_DES <= :DESFIN AND A.ESAR_COD <> 'I' AND ((SUCU_ID = :SUBEMPRESA) OR (:SUBEMPRESA = 0))
      INTO :CODIGO, :NOMBRE, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :CODBOD, :NOMBOD
      DO
        BEGIN
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
        EXECUTE PROCEDURE SALDO_INICIAL_INVENTARIO(CODIGO, FECINI, :CODBOD) returning_values (:SALDOINI);
        if (DETALLE = 'N') then
            BEGIN
            /* SUME LAS ENTRADAS */
            SELECT SUM(MVAR_CANT) FROM MOVIMIENTO_ARTICULO
              WHERE (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA <= :FECFIN) AND
              (ARTI_COD = :CODIGO) AND (BODE_COD = :CODBOD) AND (MVAR_ENTRADA = 'S') INTO :ENTRADAS;
            if (ENTRADAS IS NULL) then
              ENTRADAS = 0;
            /* CALCULE LAS SALIDAS A COSTO PROMEDIO */
            SALIDAS = 0;
            SELECT SUM(MVAR_CANT)
                FROM MOVIMIENTO_ARTICULO
                WHERE (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA <= :FECFIN) AND
                (ARTI_COD = :CODIGO) AND (BODE_COD = :CODBOD) AND (MVAR_ENTRADA = 'N')
                INTO :SALIDAS;
            if (SALIDAS IS NULL) then
              SALIDAS = 0;
            SALDOFIN = SALDOINI + ENTRADAS - SALIDAS;
            SUSPEND;
            END
        if (DETALLE = 'B') then
            BEGIN
            SALDOFIN = SALDOINI;
            FOR SELECT TIDO_NOMCORTO, MVAR_ENTRADA, MVAR_PREF, MVAR_NUMERO, MVAR_CANT, MVAR_CONC, MVAR_FECHA, M.TERC_NIT, MVAR_CONS
                FROM MOVIMIENTO_ARTICULO M, TIPO_DOCUMENTO TD
                WHERE TD.TIDO_COD = MVAR_TIPODOC AND (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA <= :FECFIN) AND (ARTI_COD = :CODIGO) AND (BODE_COD = :CODBOD)
                ORDER BY MVAR_FECHA, MVAR_CONS
                INTO :TIPODOC, :ENTRADA, :PREFIJO, :NUMERO, :ENTRADAS, :CONCEPTO, :FECHA, :NIT, :CONS
                DO
                    BEGIN
                    if (nit is not null) then
                        SELECT TERC_NOM FROM TERCEROS WHERE TERC_NIT = :NIT INTO :NOMTERC;
                    else
                        NOMTERC = '';
                    if (ENTRADA = 'S') then
                        BEGIN
                        SALIDAS = 0;
                        SALDOFIN = SALDOFIN + ENTRADAS;
                        end
                    ELSE
                        BEGIN
                        SALIDAS = ENTRADAS;
                        ENTRADAS = 0;
                        SALDOFIN = SALDOFIN - SALIDAS;
                        END
                    SUSPEND;
                    END
            END
        END
  END
END
^

SET TERM ; ^

GRANT SELECT ON ARTICULO TO PROCEDURE REP_MOVIMIENTO_X_ARTICULO;
GRANT SELECT ON LOTES TO PROCEDURE REP_MOVIMIENTO_X_ARTICULO;
GRANT SELECT ON GRUPO TO PROCEDURE REP_MOVIMIENTO_X_ARTICULO;
GRANT SELECT ON MARCAS TO PROCEDURE REP_MOVIMIENTO_X_ARTICULO;
GRANT SELECT ON SUBGRUPO TO PROCEDURE REP_MOVIMIENTO_X_ARTICULO;
GRANT SELECT ON BODEGA TO PROCEDURE REP_MOVIMIENTO_X_ARTICULO;
GRANT SELECT ON EXISTENCIA TO PROCEDURE REP_MOVIMIENTO_X_ARTICULO;
GRANT EXECUTE ON PROCEDURE MOVLOTES_DESDE_HASTA TO PROCEDURE REP_MOVIMIENTO_X_ARTICULO;
GRANT SELECT ON TERCEROS TO PROCEDURE REP_MOVIMIENTO_X_ARTICULO;
GRANT EXECUTE ON PROCEDURE SALDO_INICIAL_INVENTARIO TO PROCEDURE REP_MOVIMIENTO_X_ARTICULO;
GRANT SELECT ON MOVIMIENTO_ARTICULO TO PROCEDURE REP_MOVIMIENTO_X_ARTICULO;
GRANT SELECT ON TIPO_DOCUMENTO TO PROCEDURE REP_MOVIMIENTO_X_ARTICULO;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE SALDO_LOTE(
    ARTICULO VARCHAR(15),
    BODEGA VARCHAR(2),
    LOTE VARCHAR(15))
RETURNS (
    SALDO NUMERIC(18,4))
AS
BEGIN
  /* Busca la fecha del ltimo movimiento del artculo en la bodega antes de la fecha */
  SELECT LOTE_SALDO FROM LOTES
    WHERE (ARTI_COD = :ARTICULO) AND (BODE_COD = :BODEGA) AND (LOTE_NRO = :LOTE) INTO :SALDO;
  if (saldo is null) then
    saldo = 0;
  SUSPEND;
END
^

SET TERM ; ^

GRANT SELECT ON LOTES TO PROCEDURE SALDO_LOTE;

SET TERM ^ ;

CREATE OR ALTER TRIGGER MOVIMIENTO_ARTICULO_BI FOR MOVIMIENTO_ARTICULO
ACTIVE BEFORE INSERT POSITION 0
AS
declare variable LOTE CHAR(1);
BEGIN
  /* INSERTE EL NUEVO LOTE */
  SELECT ARTI_EXIST
    FROM   ARTICULO
    WHERE  ARTICULO.ARTI_COD = NEW.ARTI_COD
    INTO :LOTE;
  if (LOTE = 'L') then
    BEGIN
      if ((NEW.mvar_lote IS NULL) or (NEW.mvar_lote = '')) then
        if (new.mvar_entrada = 'S') then
            new.mvar_lote = cast(new.mvar_cons as varchar(15));
        else
            begin
            /* NO HAY LOTE, ENTONCES CALCULELO SEGUN CONFIGURACION
            execute procedure seleccione_lote(new.arti_cod, NEW.mvar_cant) returning_values(NEW.MVAR_LOTE); */
            if (new.mvar_lote is null) then
                EXCEPTION LOTE_NEGATIVO 'No hay un lote del artculo ' || new.arti_cod || ' con existencia suficiente.';
            end
    END
END
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON MOVIMIENTO_ARTICULO TO TRIGGER MOVIMIENTO_ARTICULO_BI;
GRANT SELECT ON ARTICULO TO TRIGGER MOVIMIENTO_ARTICULO_BI;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE SELECCIONE_LOTE(
    ARTICULO VARCHAR(15),
    BODEGA VARCHAR(2),
    CANT NUMERIC(18,4))
RETURNS (
    LOTE VARCHAR(15))
AS
declare variable PEPS VARCHAR(4);
declare variable IDLOTE INTEGER;
BEGIN
  EXECUTE PROCEDURE lee_configuracion('INVENTARIO', 'EXISTENCIAS', 'DINAMICA DE LOS LOTES DE MERCANCIA') returning_values (:PEPS);
  if (PEPS = 'PEPS') then
    BEGIN
    SELECT min(LOTE_ID) FROM LOTES WHERE (ARTI_COD = :ARTICULO) AND (BODE_COD = :BODEGA) AND (LOTE_SALDO >= :CANT) INTO :IDLOTE;
    if (IDLOTE > 0) then
        SELECT LOTE_NRO FROM LOTES WHERE LOTE_ID = :IDLOTE INTO :LOTE;
    ELSE
        LOTE = NULL;
    END
  ELSE
    BEGIN
    SELECT MAX(LOTE_ID) FROM LOTES WHERE (ARTI_COD = :ARTICULO) AND (BODE_COD = :BODEGA) AND (LOTE_SALDO >= :CANT) INTO :IDLOTE;
    if (IDLOTE > 0) then
        SELECT LOTE_NRO FROM LOTES WHERE LOTE_ID = :IDLOTE INTO :LOTE;
    ELSE
        LOTE = NULL;
    END
  SUSPEND;
END
^

SET TERM ; ^

GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO PROCEDURE SELECCIONE_LOTE;
GRANT SELECT ON LOTES TO PROCEDURE SELECCIONE_LOTE;

SET TERM ^ ;

CREATE OR ALTER TRIGGER MOVIMIENTO_ARTICULO_BI FOR MOVIMIENTO_ARTICULO
ACTIVE BEFORE INSERT POSITION 0
AS
declare variable LOTE CHAR(1);
BEGIN
  /* INSERTE EL NUEVO LOTE */
  SELECT ARTI_EXIST
    FROM   ARTICULO
    WHERE  ARTICULO.ARTI_COD = NEW.ARTI_COD
    INTO :LOTE;
  if (LOTE = 'L') then
    BEGIN
      if ((NEW.mvar_lote IS NULL) or (NEW.mvar_lote = '')) then
        if (new.mvar_entrada = 'S') then
            new.mvar_lote = cast(new.mvar_cons as varchar(15));
        else
            begin
            /* NO HAY LOTE, ENTONCES CALCULELO SEGUN CONFIGURACION */
            execute procedure seleccione_lote(new.arti_cod, NEW.bode_cod, NEW.mvar_cant) returning_values(NEW.MVAR_LOTE);
            if (new.mvar_lote is null) then
                EXCEPTION LOTE_NEGATIVO 'No hay un lote del artculo ' || new.arti_cod || ' con existencia suficiente.';
            end
    END
END
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON MOVIMIENTO_ARTICULO TO TRIGGER MOVIMIENTO_ARTICULO_BI;
GRANT SELECT ON ARTICULO TO TRIGGER MOVIMIENTO_ARTICULO_BI;
GRANT EXECUTE ON PROCEDURE SELECCIONE_LOTE TO TRIGGER MOVIMIENTO_ARTICULO_BI;

SET TERM ^ ;

CREATE OR ALTER TRIGGER MOVIMIENTO_ARTICULO_AD FOR MOVIMIENTO_ARTICULO
ACTIVE AFTER DELETE POSITION 0
AS
declare variable LOTE CHAR(1);
BEGIN
  /* INSERTE EL NUEVO LOTE */
  SELECT ARTI_EXIST
    FROM   ARTICULO
    WHERE  ARTICULO.ARTI_COD = OLD.ARTI_COD
    INTO :LOTE;
  /* BORRE LOS VIEJOS */
  if (old.mvar_tipodoc <> 13) then
      BEGIN
      EXECUTE PROCEDURE actualice_costo(old.arti_cod, old.mvar_fecha, old.mvar_costo, old.mvar_cant, old.mvar_entrada, 'S', OLD.mvar_cons, OLD.mvar_tipodoc);
      EXECUTE PROCEDURE chequeo_costos(old.arti_cod, old.mvar_fecha);
      END
  /* actualice existencias */
  if (old.mvar_entrada = 'S') then
    BEGIN
    execute procedure sume_existencia(old.arti_cod, old.bode_cod, old.mvar_fecha, old.mvar_cant, 'S');
    if (LOTE = 'L') then
        UPDATE LOTES
            set lote_saldo = lote_saldo - old.mvar_cant
            where (arti_cod = old.ARTI_COD) and (bode_cod = old.bode_cod) and (lote_nro = old.mvar_lote);
    END
  else
    BEGIN
    execute procedure reste_existencia(old.arti_cod, old.bode_cod, old.mvar_fecha, old.mvar_cant, 'S');
    if (LOTE = 'L') then
        UPDATE LOTES
            set lote_saldo = lote_saldo + old.mvar_cant
            where (arti_cod = old.ARTI_COD) and (bode_cod = old.bode_cod) and (lote_nro = old.mvar_lote);
    END
END
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON MOVIMIENTO_ARTICULO TO TRIGGER MOVIMIENTO_ARTICULO_AD;
GRANT SELECT ON ARTICULO TO TRIGGER MOVIMIENTO_ARTICULO_AD;
GRANT EXECUTE ON PROCEDURE ACTUALICE_COSTO TO TRIGGER MOVIMIENTO_ARTICULO_AD;
GRANT EXECUTE ON PROCEDURE CHEQUEO_COSTOS TO TRIGGER MOVIMIENTO_ARTICULO_AD;
GRANT EXECUTE ON PROCEDURE SUME_EXISTENCIA TO TRIGGER MOVIMIENTO_ARTICULO_AD;
GRANT SELECT,UPDATE ON LOTES TO TRIGGER MOVIMIENTO_ARTICULO_AD;
GRANT EXECUTE ON PROCEDURE RESTE_EXISTENCIA TO TRIGGER MOVIMIENTO_ARTICULO_AD;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE VENTAS_VENDEDOR(
    CODVEND INTEGER,
    FECINI DATE,
    FECFIN DATE,
    SUBEMPRESA INTEGER)
RETURNS (
    FACTURAS INTEGER,
    MFACTURAS NUMERIC(18,2),
    DEVOLUCIONES INTEGER,
    MDEVOLUCIONES NUMERIC(18,2),
    IVAFACT NUMERIC(18,2),
    IVADEV NUMERIC(18,2),
    CONSUMOF NUMERIC(18,2),
    CONSUMOD NUMERIC(18,2))
AS
BEGIN
  SELECT COUNT(*), SUM(FACT_TOTAL-FACT_IVAMONTO), SUM(FACT_IVAMONTO)
    FROM FACTURAS F, PREFIJOS P
      WHERE VEND_COD = :CODVEND AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N'
       AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
      INTO :FACTURAS, :MFACTURAS, :IVAFACT;
  SELECT COUNT(*), SUM(DEVT_TOTAL-DEVT_IVAMONTO), SUM(DEVT_IVAMONTO)
    FROM devoluciones_ventas F, PREFIJOS P
      WHERE VEND_COD = :CODVEND AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN  AND DEVT_ANULADO = 'N'
       AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 33 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) and ((devt_remid is null) or (DEVT_REMID = 0))
      INTO :DEVOLUCIONES, :MDEVOLUCIONES, :IVADEV;
  if (MFACTURAS IS NULL) then
    MFACTURAS = 0;
  if (MDEVOLUCIONES IS NULL) then
    MDEVOLUCIONES = 0;
  if (IVAFACT IS NULL) then
    IVAFACT = 0;
  if (IVADEV IS NULL) then
    IVADEV = 0;
  select sum(fade_consumo) from facturas_detalle d, facturas f, PREFIJOS P
    where d.fact_id = f.fact_id and VEND_COD = :CODVEND AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N'
     AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    into :consumof;
    if (consumof is null) then
        consumof = 0;
    mfacturas = mfacturas - consumof;
  select sum(dvde_consumo) from devoluciones_ventas_detalle d, devoluciones_ventas f, PREFIJOS P
    where d.devt_id = f.devt_id and VEND_COD = :CODVEND AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND DEVT_ANULADO = 'N'
     AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 33 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) and ((devt_remid is null) or (DEVT_REMID = 0))
    into :consumod;
    if (consumod is null) then
        consumod = 0;
    mdevoluciones = mdevoluciones - consumod;
  SUSPEND;
END
^

SET TERM ; ^

GRANT SELECT ON FACTURAS TO PROCEDURE VENTAS_VENDEDOR;
GRANT SELECT ON PREFIJOS TO PROCEDURE VENTAS_VENDEDOR;
GRANT SELECT ON DEVOLUCIONES_VENTAS TO PROCEDURE VENTAS_VENDEDOR;
GRANT SELECT ON FACTURAS_DETALLE TO PROCEDURE VENTAS_VENDEDOR;
GRANT SELECT ON DEVOLUCIONES_VENTAS_DETALLE TO PROCEDURE VENTAS_VENDEDOR;
SET TERM ^ ;

ALTER PROCEDURE VENTAS_VENDEDOR_MES(
    FECINI DATE,
    FECFIN DATE,
    SUBEMPRESA INTEGER)
RETURNS (
    CODIGO INTEGER,
    NOMBRE VARCHAR(60),
    FACTURAS INTEGER,
    MFACTURAS NUMERIC(18,2),
    DEVOLUCIONES INTEGER,
    MDEVOLUCIONES NUMERIC(18,2),
    IVAFACT NUMERIC(18,2),
    IVADEV NUMERIC(18,2),
    CONSUMOF NUMERIC(18,2),
    CONSUMOD NUMERIC(18,2))
AS
BEGIN /*$$IBE$$ 
  for select VEND_COD, VEND_NOMBRE from VENDEDORES into :CODIGO, :NOMBRE
  DO
    BEGIN
    EXECUTE PROCEDURE VENTAS_VENDEDOR (CODIGO, FECINI, FECFIN, SUBEMPRESA) returning_values (FACTURAS, MFACTURAS, DEVOLUCIONES, MDEVOLUCIONES, IVAFACT, IVADEV, CONSUMOF, CONSUMOD);
    SUSPEND;
    END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE VENTAS_VENDEDOR_MES(
    FECINI DATE,
    FECFIN DATE,
    SUBEMPRESA INTEGER)
RETURNS (
    CODIGO INTEGER,
    NOMBRE VARCHAR(60),
    FACTURAS INTEGER,
    MFACTURAS NUMERIC(18,2),
    DEVOLUCIONES INTEGER,
    MDEVOLUCIONES NUMERIC(18,2),
    IVAFACT NUMERIC(18,2),
    IVADEV NUMERIC(18,2),
    CONSUMOF NUMERIC(18,2),
    CONSUMOD NUMERIC(18,2))
AS
BEGIN
  for select VEND_COD, VEND_NOMBRE from VENDEDORES into :CODIGO, :NOMBRE
  DO
    BEGIN
    EXECUTE PROCEDURE VENTAS_VENDEDOR (CODIGO, FECINI, FECFIN, SUBEMPRESA) returning_values (FACTURAS, MFACTURAS, DEVOLUCIONES, MDEVOLUCIONES, IVAFACT, IVADEV, CONSUMOF, CONSUMOD);
    SUSPEND;
    END
END

^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE VENTAS_CLIENTE(
    NIT VARCHAR(20),
    FECINI DATE,
    FECFIN DATE,
    SUBEMPRESA INTEGER)
RETURNS (
    FACTURAS INTEGER,
    MFACTURAS NUMERIC(18,2),
    DEVOLUCIONES INTEGER,
    MDEVOLUCIONES NUMERIC(18,2),
    IVAFACT NUMERIC(18,2),
    IVADEV NUMERIC(18,2),
    CONSUMOF NUMERIC(18,2),
    CONSUMOD NUMERIC(18,2))
AS
BEGIN
  SELECT COUNT(*), SUM(FACT_TOTAL-FACT_IVAMONTO), SUM(FACT_IVAMONTO)
    FROM FACTURAS F, PREFIJOS P
    WHERE TERC_NIT = :NIT AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N'
     AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    INTO :FACTURAS, :MFACTURAS, :IVAFACT;
  SELECT COUNT(*), SUM(DEVT_TOTAL-DEVT_IVAMONTO), SUM(DEVT_IVAMONTO)
    FROM devoluciones_ventas F, PREFIJOS P
    WHERE TERC_NIT = :NIT AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND DEVT_ANULADO = 'N'
     AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 33 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) and ((devt_remid is null) or (DEVT_REMID = 0))
    INTO :DEVOLUCIONES, :MDEVOLUCIONES, :IVADEV;
  if (MFACTURAS IS NULL) then
    MFACTURAS = 0;
  if (MDEVOLUCIONES IS NULL) then
    MDEVOLUCIONES = 0;
  if (IVAFACT IS NULL) then
    IVAFACT = 0;
  if (IVADEV IS NULL) then
    IVADEV = 0;
  select sum(fade_consumo) from facturas_detalle d, facturas f, PREFIJOS P
    where d.fact_id = f.fact_id and TERC_NIT = :NIT AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N'
     AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    into :consumof;
    if (consumof is null) then
        consumof = 0;
    mfacturas = mfacturas - consumof;
  select sum(dvde_consumo) from devoluciones_ventas_detalle d, devoluciones_ventas f, PREFIJOS P
    where d.devt_id = f.devt_id and TERC_NIT = :NIT AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND DEVT_ANULADO = 'N'
     AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 33 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) and  ((devt_remid is null) or (DEVT_REMID = 0))
    into :consumod;
    if (consumod is null) then
        consumod = 0;
    mdevoluciones = mdevoluciones - consumod;
  SUSPEND;
END
^

SET TERM ; ^

GRANT SELECT ON FACTURAS TO PROCEDURE VENTAS_CLIENTE;
GRANT SELECT ON PREFIJOS TO PROCEDURE VENTAS_CLIENTE;
GRANT SELECT ON DEVOLUCIONES_VENTAS TO PROCEDURE VENTAS_CLIENTE;
GRANT SELECT ON FACTURAS_DETALLE TO PROCEDURE VENTAS_CLIENTE;
GRANT SELECT ON DEVOLUCIONES_VENTAS_DETALLE TO PROCEDURE VENTAS_CLIENTE;
SET TERM ^ ;

ALTER PROCEDURE VENTAS_CLIENTE_MES(
    FECINI DATE,
    FECFIN DATE,
    SUBEMPRESA INTEGER)
RETURNS (
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    FACTURAS INTEGER,
    MFACTURAS NUMERIC(18,2),
    DEVOLUCIONES INTEGER,
    MDEVOLUCIONES NUMERIC(18,2),
    IVAFACT NUMERIC(18,2),
    IVADEV NUMERIC(18,2),
    CONSUMOF NUMERIC(18,2),
    CONSUMOD NUMERIC(18,2))
AS
BEGIN /*$$IBE$$ 
  for select TERC_NIT, TERC_NOM from TERCEROS WHERE TERC_CLIE = 'S' into :NIT, :NOMBRE
  DO
    BEGIN
    EXECUTE PROCEDURE VENTAS_CLIENTE (NIT, FECINI, FECFIN, SUBEMPRESA) returning_values (FACTURAS, MFACTURAS, DEVOLUCIONES, MDEVOLUCIONES, IVAFACT, IVADEV, CONSUMOF, CONSUMOD);
    SUSPEND;
    END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE VENTAS_CLIENTE_MES(
    FECINI DATE,
    FECFIN DATE,
    SUBEMPRESA INTEGER)
RETURNS (
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    FACTURAS INTEGER,
    MFACTURAS NUMERIC(18,2),
    DEVOLUCIONES INTEGER,
    MDEVOLUCIONES NUMERIC(18,2),
    IVAFACT NUMERIC(18,2),
    IVADEV NUMERIC(18,2),
    CONSUMOF NUMERIC(18,2),
    CONSUMOD NUMERIC(18,2))
AS
BEGIN
  for select TERC_NIT, TERC_NOM from TERCEROS WHERE TERC_CLIE = 'S' into :NIT, :NOMBRE
  DO
    BEGIN
    EXECUTE PROCEDURE VENTAS_CLIENTE (NIT, FECINI, FECFIN, SUBEMPRESA) returning_values (FACTURAS, MFACTURAS, DEVOLUCIONES, MDEVOLUCIONES, IVAFACT, IVADEV, CONSUMOF, CONSUMOD);
    SUSPEND;
    END
END

^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE VENTAS_ARTICULO_MES(
    FECINI DATE,
    FECFIN DATE,
    SUBEMPRESA INTEGER)
RETURNS (
    ARTICULO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    UNIDAD VARCHAR(8),
    CANTVTAS NUMERIC(18,4),
    BASEVTAS NUMERIC(18,2),
    IVAVTAS NUMERIC(18,2),
    CANTDEV NUMERIC(18,4),
    BASEDEV NUMERIC(18,2),
    IVADEV NUMERIC(18,2))
AS
BEGIN
FOR SELECT MAX(ARTI_COD), SUM(FADE_CANT * FADE_FACTOR), SUM((cast(FADE_TOTAL as double precision)-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR),
    SUM(FADE_IVAMONTO*FACT_FACTOR)
    FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P
    WHERE F.FACT_ID = D.FACT_ID AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N'
       AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    GROUP BY ARTI_COD
    INTO :ARTICULO, :CANTVTAS, :BASEVTAS, :IVAVTAS
    DO
    BEGIN
    SELECT ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD, GRUP_NOM 
        FROM ARTICULO A, GRUPO G WHERE A.ARTI_COD = :articulo AND A.GRUP_COD = G.grup_cod
        INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NOMGRUPO;
    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
    SELECT SUM(DVDE_CANT * DVDE_FACTOR), SUM((cast(DVDE_TOTAL as double precision)-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR),
        SUM(DVDE_IVAMONTO*DEVT_FACTOR)
        FROM DEVOLUCIONES_VENTAS F, devoluciones_ventas_DETALLE D, PREFIJOS P
        WHERE F.DEVT_ID = D.DEVT_ID AND ARTI_COD = :ARTICULO AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND DEVT_ANULADO = 'N' AND ((devt_remid is null) or (DEVT_REMID = 0))
        AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 33 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        INTO :CANTDEV, :BASEDEV, :IVADEV;
    if (cantvtas IS NULL) then
        cantvtas = 0;
    if (cantdev IS NULL) then
        cantdev = 0;
    if (ivavtas IS NULL) then
        ivavtas = 0;
    if (IVADEV IS NULL) then
        IVADEV = 0;
    if (basevtas IS NULL) then
        basevtas = 0;
    if (basedev IS NULL) then
        basedev = 0;
    if ((CANTVTAS <> 0) or (CANTDEV <> 0)) then
        SUSPEND;
    END
END
^

SET TERM ; ^

GRANT SELECT ON FACTURAS_DETALLE TO PROCEDURE VENTAS_ARTICULO_MES;
GRANT SELECT ON FACTURAS TO PROCEDURE VENTAS_ARTICULO_MES;
GRANT SELECT ON PREFIJOS TO PROCEDURE VENTAS_ARTICULO_MES;
GRANT SELECT ON ARTICULO TO PROCEDURE VENTAS_ARTICULO_MES;
GRANT SELECT ON GRUPO TO PROCEDURE VENTAS_ARTICULO_MES;
GRANT SELECT ON MARCAS TO PROCEDURE VENTAS_ARTICULO_MES;
GRANT SELECT ON SUBGRUPO TO PROCEDURE VENTAS_ARTICULO_MES;
GRANT SELECT ON DEVOLUCIONES_VENTAS TO PROCEDURE VENTAS_ARTICULO_MES;
GRANT SELECT ON DEVOLUCIONES_VENTAS_DETALLE TO PROCEDURE VENTAS_ARTICULO_MES;
SET TERM ^ ;

CREATE OR ALTER PROCEDURE DETALLE_VENTAS_VENDEDOR(
    VEND INTEGER,
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    TIPO VARCHAR(8),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    ID INTEGER,
    FECDOC DATE,
    SUBTOTAL NUMERIC(18,2),
    IVA NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    TOTAL NUMERIC(18,2))
AS
BEGIN
  TIPO = 'FACTVENT';
  FOR SELECT FACT_ID, PREF_PRE, FACT_NUMERO, FACT_FECHA
    FROM FACTURAS
    WHERE VEND_COD = :VEND AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN  AND FACT_ANULADO = 'N'
    INTO :ID, :PREFIJO, :NUMERO, :FECDOC DO
    BEGIN
    EXECUTE PROCEDURE TOTAL_DOC_VENTAS(31, ID) returning_values (SUBTOTAL, IVA, CONSUMO);
    TOTAL = SUBTOTAL + IVA + CONSUMO;
    SUSPEND;
    END
    
  TIPO = 'DEVOLCLI';
  FOR SELECT DEVT_ID, PREF_PRE, DEVT_NUMERO, DEVT_FECHA
    FROM DEVOLUCIONES_VENTAS
    WHERE VEND_COD = :VEND AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND DEVT_ANULADO = 'N' AND ((DEVT_REMID IS NULL) or (DEVT_REMID = 0))
    INTO :ID, :PREFIJO, :NUMERO, :FECDOC DO
    BEGIN
    EXECUTE PROCEDURE TOTAL_DOC_VENTAS(33, ID) returning_values (SUBTOTAL, IVA, CONSUMO);
    TOTAL = SUBTOTAL + IVA + CONSUMO;
    SUBTOTAL = SUBTOTAL * -1;
    IVA = IVA * -1;
    CONSUMO = CONSUMO * -1;
    TOTAL = TOTAL * -1;
    SUSPEND;
    END
END
^

SET TERM ; ^

GRANT SELECT ON FACTURAS TO PROCEDURE DETALLE_VENTAS_VENDEDOR;
GRANT EXECUTE ON PROCEDURE TOTAL_DOC_VENTAS TO PROCEDURE DETALLE_VENTAS_VENDEDOR;
GRANT SELECT ON DEVOLUCIONES_VENTAS TO PROCEDURE DETALLE_VENTAS_VENDEDOR;
SET TERM ^ ;

CREATE OR ALTER PROCEDURE DETALLE_VENTAS_CLIENTE(
    NIT VARCHAR(20),
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    TIPO VARCHAR(8),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    ID INTEGER,
    FECDOC DATE,
    SUBTOTAL NUMERIC(18,2),
    IVA NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    TOTAL NUMERIC(18,2))
AS
BEGIN
  TIPO = 'FACTVENT';
  FOR SELECT FACT_ID, PREF_PRE, FACT_NUMERO, FACT_FECHA
    FROM FACTURAS
    WHERE TERC_NIT = :NIT AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N'
    INTO :ID, :PREFIJO, :NUMERO, :FECDOC DO
    BEGIN
    EXECUTE PROCEDURE TOTAL_DOC_VENTAS(31, ID) returning_values (SUBTOTAL, IVA, CONSUMO);
    TOTAL = SUBTOTAL + IVA + CONSUMO;
    SUSPEND;
    END
    
  TIPO = 'DEVOLCLI';
  FOR SELECT DEVT_ID, PREF_PRE, DEVT_NUMERO, DEVT_FECHA
    FROM DEVOLUCIONES_VENTAS
    WHERE TERC_NIT = :NIT AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND DEVT_ANULADO = 'N' AND ((DEVT_REMID IS NULL) or (DEVT_REMID = 0))
    INTO :ID, :PREFIJO, :NUMERO, :FECDOC DO
    BEGIN
    EXECUTE PROCEDURE TOTAL_DOC_VENTAS(33, ID) returning_values (SUBTOTAL, IVA, CONSUMO);
    TOTAL = SUBTOTAL + IVA + CONSUMO;
    SUBTOTAL = SUBTOTAL * -1;
    IVA = IVA * -1;
    CONSUMO = CONSUMO * -1;
    TOTAL = TOTAL * -1;
    SUSPEND;
    END
END
^

SET TERM ; ^

GRANT SELECT ON FACTURAS TO PROCEDURE DETALLE_VENTAS_CLIENTE;
GRANT EXECUTE ON PROCEDURE TOTAL_DOC_VENTAS TO PROCEDURE DETALLE_VENTAS_CLIENTE;
GRANT SELECT ON DEVOLUCIONES_VENTAS TO PROCEDURE DETALLE_VENTAS_CLIENTE;
GRANT ALL ON egresos_crucec TO PUBLIC;
GRANT ALL ON recibos_caja_crucec TO PUBLIC;

/* 20080704 */
SET TERM ^ ;

CREATE OR ALTER TRIGGER FACTCOMP_DETALLE_AI FOR FACTURAS_COMPRAS_DETALLE
ACTIVE AFTER INSERT POSITION 0
AS
declare variable fec date;
declare variable fecaux date;
declare variable aux varchar(90);
declare variable CONC VARCHAR(60);
declare variable factor numeric(18,4);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Nit varchar(20);
declare variable TIPO INTEGER;
declare variable INVFAC CHAR(2);
declare variable IVAINC CHAR(2);
declare variable COSTO NUMERIC(18,2);
declare variable CANTREL NUMERIC(18,4);
declare variable NUMPROV VARCHAR(10);
declare variable NUMPED VARCHAR(30);
declare variable NUMREM VARCHAR(30);
declare variable CONSO VARCHAR(2);
declare variable CONSOLIDA INTEGER;
declare variable NUMROWS INTEGER;
declare variable DTOPIE NUMERIC(18,2);
declare variable ADICIONAL NUMERIC(18,2);
declare variable TOTAL NUMERIC(18,2);
declare variable IVAMONTO NUMERIC(18,2);
declare variable EXTRA NUMERIC(18,2);
declare variable FACT NUMERIC(18,4);
declare variable MENORV CHAR(2);
declare variable COSTOREM NUMERIC(18,2);
declare variable FECREM date;
declare variable IDREM INTEGER;
declare variable ITEREM INTEGER;
declare variable CANTREM NUMERIC(18,4);
declare variable LOTEREM VARCHAR(15);
declare variable PREFREM CHAR(4);
BEGIN
if ((NEW.faco_id <> 0) and (new.fcde_anulado = 'N')) then
    BEGIN
    select faco_fecha, pref_pre, faco_numero, terc_nit, faco_imptos, faco_numprov, faco_remision, faco_orden, FACO_CONSOLIDA,
        FACO_TOTAL, FACO_EXTRA, FACO_IVAMONTO, FACO_ADICIONAL, FACO_DTOMONTO
        from facturas_compra where faco_id = new.faco_id
        into :fec, :Pref, :Num, :Nit, :ivainc, :numprov, :numrem, :numped, :CONSOLIDA,
        :total, :extra, :ivamonto, :adicional, :dtopie;
    conc = 'FACTURA DE COMPRA No.' || PREF || NUM || '-' || NUMPROV;
    if (NUMREM <> '') then
        BEGIN
        AUX = SUBSTR(NUMREM, 1, 15);
        conc = conc || '-REM:' || AUX;
        END
    else
        if (NUMPED <> '') then
            BEGIN
            AUX = SUBSTR(NUMPED, 1, 15);
            conc = conc || '-ORDEN ' || NUMPED;
            END
    if (consolida <> 0) then
        SELECT MAX(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :TIPO;
    else
        TIPO = 0;
    if (Tipo is null) then
        Tipo = 0;
    execute procedure lee_configuracion('COMPRAS', 'FACTURAS', 'AFECTAR INVENTARIO CON LA FACTURA') returning_values (:INVFAC);
    execute procedure factor_unidad_cant(new.arti_cod, new.fcde_unidad) returning_values(factor);
    COSTO = ((new.fcde_prunit - NEW.fcde_dtomonto) / :factor);
    if (IVAINC = 'S') then
        COSTO = COSTO / (1 + NEW.fcde_ivaporc/100);
    EXECUTE PROCEDURE lee_configuracion('COMPRAS','FACTURAS','DESCUENTO Y VALOR ADICIONAL DEL DOCUMENTO COMO MENOR VALOR DEL COSTO') returning_values (:MENORV);
    if (MENORV = 'SI') then
        BEGIN
        FACT = (TOTAL - EXTRA - IVAMONTO);
        if ((FACT - ADICIONAL + DTOPIE) <> 0) then
            FACT = FACT / (FACT - ADICIONAL + DTOPIE);
        ELSE
            FACT = 1;
        COSTO = COSTO * FACT;
        END
    /* si se hizo con base en una remision no afecte inventario */
    if (INVFAC = 'SI') then
      if (Tipo <> 22) then
        begin
        INSERT INTO MOVIMIENTO_ARTICULO
          (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
          VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 21, NEW.faco_id,
          :CONC, :factor * new.fcde_cant, :COSTO, 'S', new.fcde_lote, :Pref, :Num, NEW.fcde_item, :Nit);

        if (COSTO > 0 ) then
         BEGIN
          /* ACTUALICE EL COSTO POR PROVEEDOR */
          SELECT PVAR_FECHA FROM PROVEEDOR_ARTICULO
            WHERE TERC_NIT = :Nit AND ARTI_COD = NEW.ARTI_COD
            INTO :FECAUX;
          if (FECAUX IS NULL) then
            INSERT INTO PROVEEDOR_ARTICULO (TERC_NIT, ARTI_COD, PVAR_COSTO, PVAR_FECHA, PVAR_COD,PVAR_DES)
                VALUES (:Nit, NEW.ARTI_COD, :COSTO, :fec, NEW.fcde_codprov,NEW.fcde_desc);
          else
            UPDATE PROVEEDOR_ARTICULO
                SET PVAR_COSTO = :COSTO, PVAR_FECHA = :fec, PVAR_COD = NEW.fcde_codprov
                WHERE ARTI_COD = NEW.ARTI_COD AND TERC_NIT = :Nit;
         END
        /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
        EXECUTE PROCEDURE CALCULA_PRECIOS(NEW.ARTI_COD, :FEC);
        END /* AFECTAR INV */
      else
        BEGIN
        /* SI LOS COSTOS DE LA REMISION ERAN CERO ACTUALICE EL REGISTRO EN MOVIMIENTO_ARTICULO */
        numrows = 0;
        select mvar_cons, MVAR_ITEM, MVAR_FECHA, MVAR_IDREF, MVAR_COSTO, MVAR_CANT, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO
            from movimiento_articulo M, consolidado_faltantes C
            where C.cofa_id = :CONSOLIDA AND mvar_tipodoc = 22 and mvar_idref = C.cofa_idori AND C.cofa_tipoori = 22 and m.arti_cod = new.arti_cod
            into :numrows, :iterem, :fecrem, :idrem, :costorem, :cantrem, :loterem, :prefrem, :numrem;

        if ((numrows <> 0) AND (costorem = 0)) then
            BEGIN
            DELETE FROM MOVIMIENTO_ARTICULO WHERE MVAR_CONS = :numrows;
            INSERT INTO MOVIMIENTO_ARTICULO
              (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
              VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :fecrem, 22, :idrem,
              :CONC, :cantrem, :costo, 'S', :loterem, :prefrem, :numrem, :iterem, :Nit);

            if (COSTO > 0 ) then
              BEGIN
              /* ACTUALICE EL COSTO POR PROVEEDOR */
              SELECT PVAR_FECHA FROM PROVEEDOR_ARTICULO
                WHERE TERC_NIT = :Nit AND ARTI_COD = NEW.ARTI_COD
                INTO :FECAUX;
              if (FECAUX IS NULL) then
                INSERT INTO PROVEEDOR_ARTICULO (TERC_NIT, ARTI_COD, PVAR_COSTO, PVAR_FECHA, PVAR_COD,PVAR_DES)
                    VALUES (:Nit, NEW.ARTI_COD, :COSTO, :fec, NEW.fcde_codprov,NEW.fcde_desc);
              else
                UPDATE PROVEEDOR_ARTICULO
                    SET PVAR_COSTO = :COSTO, PVAR_FECHA = :fec, PVAR_COD = NEW.fcde_codprov
                    WHERE ARTI_COD = NEW.ARTI_COD AND TERC_NIT = :Nit;
              END
            /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
            EXECUTE PROCEDURE CALCULA_PRECIOS(NEW.ARTI_COD, :FEC);
            END
        END

    /* ACTUALICE EL PENDIENTE  */
    if (CONSOLIDA <> 0) then
        BEGIN
        UPDATE consolidado_faltantes SET COFA_OK = 'S' WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod;
        EXECUTE procedure LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','SUMAR CANTIDADES PENDIENTES AL CONSOLIDAR DOCUMENTOS') returning_values (CONSO);
        /* IGNORE LA CONSOLIDACION SI SE VALIDAN CODIGOS DE LA ORDEN */
        SELECT MIN(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
        if (NUMROWS = 23) then
            BEGIN
            EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'VERIFICAR CODIGOS DE LA ORDEN') returning_values (MENORV);
            if (MENORV = 'SI') then
                CONSO = 'NO';
            END
        SELECT COUNT(CEFA_ITEM) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
        if ((CONSO = 'SI') AND (NUMROWS > 1)) then
            UPDATE consolidado_faltantes SET COFA_IDDES = NEW.faco_id, COFA_OK = 'S' WHERE COFA_ID = :consolida;
        else
            BEGIN
            /* BUSQUE EL CONSOLIDADO EN EL MISMO ITEM Y SI ES DIFERENTE ACTUALICELO */
            select COFA_CANT * COFA_FACTOR FROM consolidado_faltantes WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod INTO :CANTREL;
            if (NEW.FCDE_CANT * NEW.FCDE_FACTOR < CANTREL) then
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.faco_id, COFA_CANT = NEW.FCDE_CANT, COFA_FACTOR = NEW.FCDE_FACTOR
                    WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod;
            END
        END
    END
END
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON FACTURAS_COMPRAS_DETALLE TO TRIGGER FACTCOMP_DETALLE_AI;
GRANT SELECT ON FACTURAS_COMPRA TO TRIGGER FACTCOMP_DETALLE_AI;
GRANT SELECT ON CONSOLIDE_FALTANTES TO TRIGGER FACTCOMP_DETALLE_AI;
GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO TRIGGER FACTCOMP_DETALLE_AI;
GRANT EXECUTE ON PROCEDURE FACTOR_UNIDAD_CANT TO TRIGGER FACTCOMP_DETALLE_AI;
GRANT SELECT,INSERT,DELETE ON MOVIMIENTO_ARTICULO TO TRIGGER FACTCOMP_DETALLE_AI;
GRANT SELECT,INSERT,UPDATE ON PROVEEDOR_ARTICULO TO TRIGGER FACTCOMP_DETALLE_AI;
GRANT EXECUTE ON PROCEDURE CALCULA_PRECIOS TO TRIGGER FACTCOMP_DETALLE_AI;
GRANT SELECT,UPDATE ON CONSOLIDADO_FALTANTES TO TRIGGER FACTCOMP_DETALLE_AI;


/* 20080705 */
SET TERM ^ ;

CREATE OR ALTER TRIGGER LOTES_BI FOR LOTES
ACTIVE BEFORE INSERT POSITION 0
AS
declare variable EXISTE integer;
declare variable VENCE DATE;
BEGIN
  /* coloque el ID */
  new.lote_id = gen_ID(ID_LOTE, 1);
  select count(*), max(lote_vence) from entradas_detalle where ARTI_COD = NEW.ARTI_COD AND ENDE_LOTE = NEW.LOTE_NRO INTO :EXISTE, :VENCE;
  if (EXISTE > 0) then
     NEW.LOTE_VENCE = :VENCE;
  else
     begin
     SELECT count(*), max(lote_vence) from ensambles WHERE ARTI_COD = NEW.ARTI_COD AND ENSA_LOTE = NEW.LOTE_NRO INTO :EXISTE, :VENCE;
     if (EXISTE > 0) then
       NEW.LOTE_VENCE = :VENCE;
     else
      begin
      SELECT count(*), max(lote_vence) from facturas_compras_detalle WHERE ARTI_COD = NEW.ARTI_COD AND FCDE_LOTE = NEW.LOTE_NRO INTO :EXISTE, :VENCE;
      if (EXISTE > 0) then
        NEW.LOTE_VENCE = :VENCE;
      else
       begin
       SELECT count(*), max(lote_vence) from remision_proveedor_det WHERE ARTI_COD = NEW.ARTI_COD AND RPVD_LOTE = NEW.LOTE_NRO INTO :EXISTE, :VENCE;
       if (EXISTE > 0) then
         NEW.LOTE_VENCE = :VENCE;
       else
        begin
        SELECT count(*), max(lote_vence) from devoluciones_ventas_detalle WHERE ARTI_COD = NEW.ARTI_COD AND DVDE_LOTE = NEW.LOTE_NRO INTO :EXISTE, :VENCE;
        if (EXISTE > 0) then
          NEW.LOTE_VENCE = :VENCE;
        end
       end
      end
     END
END
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON LOTES TO TRIGGER LOTES_BI;
GRANT SELECT ON ENTRADAS_DETALLE TO TRIGGER LOTES_BI;
GRANT SELECT ON ENSAMBLES TO TRIGGER LOTES_BI;
GRANT SELECT ON FACTURAS_COMPRAS_DETALLE TO TRIGGER LOTES_BI;
GRANT SELECT ON REMISION_PROVEEDOR_DET TO TRIGGER LOTES_BI;
GRANT SELECT ON DEVOLUCIONES_VENTAS_DETALLE TO TRIGGER LOTES_BI;


/* 20080706 */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_ARTICULOS_VENDEDOR(
    TIPO INTEGER,
    DETALLE CHAR(1),
    DESDE VARCHAR(20),
    HASTA VARCHAR(20),
    FECINI DATE,
    FECFIN DATE,
    ARTINI VARCHAR(15),
    ARTFIN VARCHAR(15),
    GRPINI VARCHAR(3),
    GRPFIN VARCHAR(3),
    ORDEN CHAR(1),
    AGRUPA CHAR(1),
    ZONA CHAR(1),
    CEROS CHAR(1),
    SUBEMPRESA INTEGER,
    ZONAINI CHAR(2),
    ZONAFIN CHAR(2))
RETURNS (
    CODVEND VARCHAR(20),
    NOMVEND VARCHAR(60),
    NOMTIPO VARCHAR(50),
    ARTICULO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    UNIDAD VARCHAR(8),
    CANTIDAD NUMERIC(18,4),
    BASE NUMERIC(18,2),
    IVA NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    DTO NUMERIC(9,2),
    NIT VARCHAR(20),
    NOMCLIENTE VARCHAR(60),
    CODZONA VARCHAR(2),
    NOMZONA VARCHAR(60))
AS
declare variable codini varchar(15);
declare variable codfin varchar(15);
declare variable desini varchar(15);
declare variable desfin varchar(15);
declare variable marini varchar(3);
declare variable marfin varchar(3);
BEGIN
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END
if (AGRUPA = 'G') then
    BEGIN
    MARINI = '';
    MARFIN = 'zz';
    END
ELSE
    if (AGRUPA = 'M') then
        BEGIN
        MARINI = GRPINI;
        MARFIN = GRPFIN;
        GRPINI = '';
        GRPFIN = 'zz';
        END
    ELSE
        BEGIN
        MARINI = '';
        MARFIN = 'zz';
        END
if (DETALLE = 'N') then
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(FADE_CANT * FADE_FACTOR), SUM((FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR), SUM(FADE_IVAMONTO*FACT_FACTOR), SUM(FADE_CONSUMO), SUM(FADE_TOTAL*FACT_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P, ARTICULO A
            WHERE F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            FACT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY VEND_COD, D.ARTI_COD
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(RVDE_CANT * RVDE_FACTOR), SUM(RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO), SUM(RVDE_IVAMONTO), SUM(RVDE_CONSUMO), SUM(RVDE_TOTAL),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM REMISIONES_VENTA_DETALLE D, REMISIONES_VENTA R, PREFIJOS P, ARTICULO A
            WHERE R.REVT_ID = D.REVT_ID AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            REVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY R.vend_cod, D.ARTI_COD
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(DVDE_CANT * DVDE_FACTOR), SUM((DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR), SUM(DVDE_IVAMONTO*DEVT_FACTOR), SUM(DVDE_CONSUMO), SUM(DVDE_TOTAL*DEVT_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM devoluciones_ventas_detalle D, DEVOLUCIONES_VENTAS V, PREFIJOS P, ARTICULO A
            WHERE V.DEVT_ID = D.DEVT_ID AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            DEVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY V.vend_cod, D.ARTI_COD
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(PEDE_CANT * PEDE_FACTOR), SUM((PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR), SUM(PEDE_IVAMONTO*PEDI_FACTOR), SUM(PEDE_CONSUMO), SUM(PEDE_TOTAL*PEDI_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM PEDIDOS_DETALLE D, PEDIDOS P, PREFIJOS R, ARTICULO A
            WHERE P.PEDI_ID = D.PEDI_ID AND P.PREF_PRE = R.PREF_PRE AND R.TIDO_COD = 34 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            PEDI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY P.vend_cod, D.ARTI_COD
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(CTDE_CANT * CTDE_FACTOR), SUM((CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR), SUM(CTDE_IVAMONTO*COTI_FACTOR), SUM(CTDE_CONSUMO), SUM(CTDE_TOTAL*COTI_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM COTIZACIONES_DETALLE D, COTIZACIONES C, PREFIJOS P, ARTICULO A
            WHERE C.COTI_ID = D.COTI_ID AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            COTI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY C.vend_cod, D.ARTI_COD
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    END
ELSE
  if (DETALLE = 'S') then
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
        FOR SELECT F.PREF_PRE, FACT_NUMERO, FACT_FECHA, VEND_COD, D.ARTI_COD, FADE_CANT * FADE_FACTOR, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR, FADE_IVAMONTO*FACT_FACTOR, FADE_CONSUMO, FADE_DTOPORC, FADE_TOTAL*FACT_FACTOR,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD , F.TERC_NIT, F.fact_nomcliente
            FROM FACTURAS F, FACTURAS_DETALLE D, PREFIJOS P, ARTICULO A
            WHERE F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND D.ARTI_COD = A.arti_cod AND
                VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND FACT_FECHA >= :FECINI AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY VEND_COD, D.ARTI_COD, FACT_FECHA, F.FACT_ID, FADE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :CODVEND, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO, :DTO, :TOTAL,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT, :nomcliente
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
        FOR SELECT R.PREF_PRE, REVT_NUMERO, REVT_FECHA, VEND_COD, D.ARTI_COD, RVDE_CANT * RVDE_FACTOR, (RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO), RVDE_IVAMONTO, RVDE_CONSUMO, RVDE_DTOPORC, RVDE_TOTAL,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, R.terc_nit, R.revt_nomterc
            FROM REMISIONES_VENTA R, REMISIONES_VENTA_DETALLE D, PREFIJOS P, ARTICULO A
            WHERE R.REVT_ID = D.REVT_ID AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND D.ARTI_COD = A.arti_cod AND
                VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                REVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY VEND_COD, D.ARTI_COD, REVT_FECHA, R.REVT_ID, RVDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :CODVEND, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO, :DTO, :TOTAL,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT, :nomcliente
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
        FOR SELECT V.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, VEND_COD, D.ARTI_COD, DVDE_CANT * DVDE_FACTOR, (DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR, DVDE_IVAMONTO*DEVT_FACTOR, DVDE_CONSUMO, DVDE_DTOPORC, DVDE_TOTAL*DEVT_FACTOR,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, V.terc_nit, V.devt_nomterc
            FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D, PREFIJOS P, ARTICULO A
            WHERE V.DEVT_ID = D.DEVT_ID AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND D.ARTI_COD = A.arti_cod AND
                VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                DEVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY VEND_COD, D.ARTI_COD, DEVT_FECHA, V.DEVT_ID, DVDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :CODVEND, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO, :DTO, :TOTAL,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT, :nomcliente
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
        FOR SELECT P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, VEND_COD, D.ARTI_COD, PEDE_CANT * PEDE_FACTOR, (PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR, PEDE_IVAMONTO*PEDI_FACTOR, PEDE_CONSUMO, PEDE_DTOPORC, PEDE_TOTAL*PEDI_FACTOR,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, P.terc_nit, P.pedi_nomterc
            FROM PEDIDOS P, PEDIDOS_DETALLE D, PREFIJOS R, ARTICULO A
            WHERE P.PEDI_ID = D.PEDI_ID AND P.PREF_PRE = R.PREF_PRE AND R.TIDO_COD = 34 AND D.ARTI_COD = A.arti_cod AND
                VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                PEDI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY VEND_COD, D.ARTI_COD, PEDI_FECHA, P.PEDI_ID, PEDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :CODVEND, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO, :DTO, :TOTAL,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT, :nomcliente
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
        FOR SELECT C.PREF_PRE, COTI_NUMERO, COTI_FECHA, VEND_COD, D.ARTI_COD, CTDE_CANT * CTDE_FACTOR, (CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR, CTDE_IVAMONTO*COTI_FACTOR, CTDE_CONSUMO, CTDE_DTOPORC, CTDE_TOTAL*COTI_FACTOR,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, C.terc_nit, C.coti_nomterc
            FROM COTIZACIONES C, COTIZACIONES_DETALLE D, PREFIJOS P, ARTICULO A
            WHERE C.COTI_ID = D.COTI_ID AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND D.ARTI_COD = A.arti_cod AND
                VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                COTI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY VEND_COD, D.ARTI_COD, COTI_FECHA, C.COTI_ID, CTDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :CODVEND, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO, :DTO, :TOTAL,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :NIT, :nomcliente
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SUSPEND;
            END
        END
    END
  ELSE
if (DETALLE = 'C') then
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(FADE_CANT * FADE_FACTOR), SUM((FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR), SUM(FADE_IVAMONTO*FACT_FACTOR), SUM(FADE_CONSUMO), SUM(FADE_TOTAL*FACT_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(F.terc_nit), MAX(F.fact_nomcliente)
            FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P, ARTICULO A
            WHERE F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            FACT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY F.VEND_COD, F.TERC_NIT, D.ARTI_COD
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit INTO :codzona, :nomzona;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(RVDE_CANT * RVDE_FACTOR), SUM(RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO), SUM(RVDE_IVAMONTO), SUM(RVDE_CONSUMO), SUM(RVDE_TOTAL),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(R.terc_nit), MAX(R.revt_nomterc)
            FROM REMISIONES_VENTA_DETALLE D, REMISIONES_VENTA R, PREFIJOS P, ARTICULO A
            WHERE R.REVT_ID = D.REVT_ID AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            REVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY R.vend_cod, R.terc_nit, D.arti_cod
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit INTO :codzona, :nomzona;
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(DVDE_CANT * DVDE_FACTOR), SUM((DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR), SUM(DVDE_IVAMONTO*DEVT_FACTOR), SUM(DVDE_CONSUMO), SUM(DVDE_TOTAL*DEVT_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(V.terc_nit), MAX(V.devt_nomterc)
            FROM devoluciones_ventas_detalle D, DEVOLUCIONES_VENTAS V, PREFIJOS P, ARTICULO A
            WHERE V.DEVT_ID = D.DEVT_ID AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            DEVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY V.vend_cod, V.terc_nit, D.arti_cod
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit INTO :codzona, :nomzona;
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(PEDE_CANT * PEDE_FACTOR), SUM((PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR), SUM(PEDE_IVAMONTO*PEDI_FACTOR), SUM(PEDE_CONSUMO), SUM(PEDE_TOTAL*PEDI_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(P.terc_nit), MAX(P.pedi_nomterc)
            FROM PEDIDOS_DETALLE D, PEDIDOS P, PREFIJOS R, ARTICULO A
            WHERE P.PEDI_ID = D.PEDI_ID AND P.PREF_PRE = R.PREF_PRE AND R.TIDO_COD = 34 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            PEDI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY P.vend_cod, P.terc_nit, D.arti_cod
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit INTO :codzona, :nomzona;
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(VEND_COD), SUM(CTDE_CANT * CTDE_FACTOR), SUM((CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR), SUM(CTDE_IVAMONTO*COTI_FACTOR), SUM(CTDE_CONSUMO), SUM(CTDE_TOTAL*COTI_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(C.terc_nit), MAX(C.coti_nomterc)
            FROM COTIZACIONES_DETALLE D, COTIZACIONES C, PREFIJOS P, ARTICULO A
            WHERE C.COTI_ID = D.COTI_ID AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND D.ARTI_COD = A.arti_cod AND
            VEND_COD >= :DESDE AND VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            COTI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY C.vend_cod, C.terc_nit, D.arti_cod
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit INTO :codzona, :nomzona;
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    END
if (zona = 'S') then
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(F.VEND_COD), SUM(FADE_CANT * FADE_FACTOR), SUM((FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR), SUM(FADE_IVAMONTO*FACT_FACTOR), SUM(FADE_CONSUMO), SUM(FADE_TOTAL*FACT_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(F.terc_nit), MAX(F.fact_nomcliente)
            FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P, ARTICULO A, clientes C, ZONAS Z
            WHERE F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND D.ARTI_COD = A.arti_cod AND
            F.VEND_COD >= :DESDE AND F.VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            FACT_ANULADO = 'N' AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) AND F.terc_nit = C.terc_nit AND
            Z.zona_cod = C.zona_cod AND C.zona_cod >= :zonaini AND C.zona_cod <= :zonafin
            GROUP BY F.VEND_COD, C.zona_cod ,D.ARTI_COD , C.terc_nit
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit /*AND Z.zona_cod >= :zonaini AND Z.zona_cod >= :zonafin*/ INTO :codzona, :nomzona;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(R.VEND_COD), SUM(RVDE_CANT * RVDE_FACTOR), SUM(RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO), SUM(RVDE_IVAMONTO), SUM(RVDE_CONSUMO), SUM(RVDE_TOTAL),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(R.terc_nit), MAX(R.revt_nomterc)
            FROM REMISIONES_VENTA_DETALLE D, REMISIONES_VENTA R, PREFIJOS P, ARTICULO A, clientes C, ZONAS Z
            WHERE R.REVT_ID = D.REVT_ID AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND D.ARTI_COD = A.arti_cod AND
            R.VEND_COD >= :DESDE AND R.VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            REVT_ANULADO = 'N' AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))AND R.terc_nit = C.terc_nit AND
            Z.zona_cod = C.zona_cod AND C.zona_cod >= :zonaini AND C.zona_cod <= :zonafin
            GROUP BY R.vend_cod, c.zona_cod, D.arti_cod , R.terc_nit
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit INTO :codzona, :nomzona;
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(V.VEND_COD), SUM(DVDE_CANT * DVDE_FACTOR), SUM((DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR), SUM(DVDE_IVAMONTO*DEVT_FACTOR), SUM(DVDE_CONSUMO), SUM(DVDE_TOTAL*DEVT_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(V.terc_nit), MAX(V.devt_nomterc)
            FROM devoluciones_ventas_detalle D, DEVOLUCIONES_VENTAS V, PREFIJOS P, ARTICULO A, clientes C, ZONAS Z
            WHERE V.DEVT_ID = D.DEVT_ID AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND D.ARTI_COD = A.arti_cod AND
            V.VEND_COD >= :DESDE AND V.VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            DEVT_ANULADO = 'N' AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))AND V.terc_nit = C.terc_nit AND
            Z.zona_cod = C.zona_cod AND C.zona_cod >= :zonaini AND C.zona_cod <= :zonafin
            GROUP BY V.vend_cod, c.zona_cod, D.arti_cod , V.terc_nit
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit INTO :codzona, :nomzona;
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(P.VEND_COD), SUM(PEDE_CANT * PEDE_FACTOR), SUM((PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR), SUM(PEDE_IVAMONTO*PEDI_FACTOR), SUM(PEDE_CONSUMO), SUM(PEDE_TOTAL*PEDI_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(P.terc_nit), MAX(P.pedi_nomterc)
            FROM PEDIDOS_DETALLE D, PEDIDOS P, PREFIJOS R, ARTICULO A, clientes C, ZONAS Z
            WHERE P.PEDI_ID = D.PEDI_ID AND P.PREF_PRE = R.PREF_PRE AND R.TIDO_COD = 34 AND D.ARTI_COD = A.arti_cod AND
            P.VEND_COD >= :DESDE AND P.VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            PEDI_ANULADO = 'N' AND ((R.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))AND P.terc_nit = C.terc_nit AND
            Z.zona_cod = C.zona_cod AND C.zona_cod >= :zonaini AND C.zona_cod <= :zonafin
            GROUP BY P.vend_cod, c.zona_cod, D.arti_cod , P.terc_nit
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit INTO :codzona, :nomzona;
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
        FOR SELECT MAX(D.ARTI_COD), MAX(C.VEND_COD), SUM(CTDE_CANT * CTDE_FACTOR), SUM((CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR), SUM(CTDE_IVAMONTO*COTI_FACTOR), SUM(CTDE_CONSUMO), SUM(CTDE_TOTAL*COTI_FACTOR),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), MAX(C.terc_nit), MAX(C.coti_nomterc)
            FROM COTIZACIONES_DETALLE D, COTIZACIONES C, PREFIJOS P, ARTICULO A, clientes T, ZONAS Z
            WHERE C.COTI_ID = D.COTI_ID AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND D.ARTI_COD = A.arti_cod AND
            C.VEND_COD >= :DESDE AND C.VEND_COD <= :HASTA AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            COTI_ANULADO = 'N' AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))AND C.terc_nit = T.terc_nit AND
            Z.zona_cod = T.zona_cod AND T.zona_cod >= :zonaini AND T.zona_cod <= :zonafin
            GROUP BY C.vend_cod, t.zona_cod, D.arti_cod , C.terc_nit
            INTO :ARTICULO, :CODVEND, :CANTIDAD, :BASE, :IVA, :CONSUMO, :TOTAL,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :nit, :nomcliente
            DO
            BEGIN
            SELECT C.ZONA_COD, ZONA_NOM FROM CLIENTES C, ZONAS Z WHERE C.zona_cod = Z.zona_cod AND C.terc_nit = :nit INTO :codzona, :nomzona;
            select VEND_NOMBRE from VENDEDORES where VEND_COD = :CODVEND INTO :NOMVEND;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            if (CEROS = 'S') then
                SUSPEND;
            ELSE
                if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                    SUSPEND;
            END /* FOR */
        END
    END
END
^

SET TERM ; ^

GRANT SELECT ON TIPO_DOCUMENTO TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON FACTURAS_DETALLE TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON FACTURAS TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON PREFIJOS TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON ARTICULO TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON VENDEDORES TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON GRUPO TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON MARCAS TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON SUBGRUPO TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON REMISIONES_VENTA_DETALLE TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON REMISIONES_VENTA TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON DEVOLUCIONES_VENTAS_DETALLE TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON DEVOLUCIONES_VENTAS TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON PEDIDOS_DETALLE TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON PEDIDOS TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON COTIZACIONES_DETALLE TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON COTIZACIONES TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON CLIENTES TO PROCEDURE REP_ARTICULOS_VENDEDOR;
GRANT SELECT ON ZONAS TO PROCEDURE REP_ARTICULOS_VENDEDOR;


/* 20080707 */

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('CAJA', 'RECIBOS', 'MAXIMO DESCUENTO PERMITIDO EN RECIBOS DE CAJA', '100', '', 'Indique el mximo valor absoluto permitido para digitar como descuento en el recibo y ajustar el valor recibido del cliente sin hacer notas de cartera');
commit work;

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('CAJA', 'EGRESOS', 'MAXIMO DESCUENTO PERMITIDO EN EGRESOS', '100', '', 'Indique el mximo valor absoluto permitido para digitar como descuento en el egreso y ajustar el valor pagado al acreedor sin hacer otros documentos');
commit work;


/* 20080708 */
SET TERM ^ ;

ALTER PROCEDURE COSTO_PROMEDIO(
    ARTICULO VARCHAR(15),
    FECHA DATE)
RETURNS (
    COSTOP NUMERIC(18,2))
AS
declare variable saldop numeric(18,2);
declare variable saldoc numeric(15,4);
declare variable entp numeric(18,2);
declare variable entc numeric(15,4);
DECLARE VARIABLE FEC DATE;
declare variable ITEM INTEGER;
BEGIN
  /* Busca la fecha del ltimo movimiento del artculo antes de la fecha */
  SELECT  MAX(COST_FECHA) FROM COSTOS
  WHERE (ARTI_COD = :ARTICULO) AND (COST_FECHA <= :FECHA) INTO :FEC;
  IF (FEC IS NULL) THEN
    COSTOP = 0;
  ELSE
    begin
    SELECT  MAX(COST_ITEM) FROM COSTOS
        WHERE (ARTI_COD = :ARTICULO) AND (COST_FECHA = :FEC) INTO :ITEM;

    /* Con la fecha mxima calcule el costo promedio */
    SELECT COST_SALDOP, COST_ENTP,COST_SALDOC, COST_ENTC, COST_ULTIMO FROM COSTOS
        WHERE (ARTI_COD = :ARTICULO) AND (COST_FECHA = :FEC) AND (COST_ITEM = :ITEM)
        INTO :SALDOP, ENTP, :SALDOC, ENTC, :COSTOP;
    if ((SALDOC < 0) AND (SALDOC+ENTC > 0)) then
        COSTOP = ENTP/ENTC;
    else
        /* Cuando hay existencia calcule el promedio, de otra manera retorne el ultimo */
        if (SALDOC+ENTC > 0) then
            COSTOP = (SALDOP+ENTP) / (SALDOC+ENTC);
    end
  SUSPEND;
END

^

SET TERM ; ^

GRANT SELECT ON COSTOS TO PROCEDURE COSTO_PROMEDIO;

SET TERM ^ ;

ALTER PROCEDURE ACTUALICE_COSTO(
    ARTICULO VARCHAR(15),
    FECHA DATE,
    COSTO NUMERIC(18,2),
    CANTIDAD NUMERIC(18,2),
    ENTRADA CHAR(1),
    ANULAR CHAR(1),
    IDMOV INTEGER,
    TIPO INTEGER)
AS
DECLARE VARIABLE saldo NUMERIC(18,2);
DECLARE VARIABLE COSTOP NUMERIC(18,2);
DECLARE VARIABLE exart CHAR(1);
DECLARE VARIABLE UCOSTO NUMERIC(18,2);
declare variable FECAUX DATE;
declare variable SALDOC NUMERIC(15,4);
declare variable ITEM INTEGER;
declare variable UNIDAD VARCHAR(8);
BEGIN
/* Verfique si el artculo tiene control de existencias */ /*$$IBE$$ 
SELECT arti_exist, ARTI_UNIDAD FROM articulo WHERE arti_COD = :articulo
    INTO :exart, :UNIDAD;
IF (exart <> 'N') THEN
    BEGIN
    if (ANULAR = 'S') then
        BEGIN
        select cost_saldoc, cost_saldop from costos
            WHERE (arti_cod = :articulo) AND (cost_fecha = :fecha) AND (cost_idmov = :IDMOV) AND (COST_TIPO = :TIPO)
            into :SALDOC, :SALDO;  $$IBE$$*/ /* para dejar inicializadas las 2 variables */ /*$$IBE$$ 
        DELETE FROM COSTOS WHERE (arti_cod = :articulo) AND (cost_fecha = :fecha) AND (cost_idmov = :IDMOV) AND (COST_TIPO = :TIPO);
         $$IBE$$*/ /* para inicializar el ultimo costo */ /*$$IBE$$ 
        SELECT MAX(COST_FECHA) FROM costos
            WHERE (arti_cod = :articulo) AND (cost_fecha <= :fecha) INTO :FECAUX;
        if (FECAUX IS NULL) then
            UCOSTO = 0;
        ELSE
            BEGIN
            SELECT MAX(COST_ITEM) FROM costos
                WHERE (arti_cod = :articulo) AND (cost_fecha = :fecaux) INTO :ITEM;
            SELECT COST_ULTIMO FROM costos
                WHERE (arti_cod = :articulo) AND (cost_fecha = :fecaux) AND (cost_item = :ITEM) INTO :UCOSTO;
            END
        END
    ELSE
        BEGIN
        select max(cost_fecha) from costos WHERE (arti_cod = :articulo) AND (cost_fecha <= :fecha) into :fecaux;
        select max(cost_item) from costos WHERE (arti_cod = :articulo) AND (cost_fecha = :fecaux) into :item;
        select (cost_saldoc + cost_entc - cost_salc) from costos WHERE (arti_cod = :articulo) AND (cost_fecha = :fecaux) AND (cost_item = :item) into :saldoc;
        if (saldoc is null) THEN
            SALDOC = 0;
        EXECUTE PROCEDURE costo_promedio(:articulo, :fecha) RETURNING_VALUES :costop;
        if (ENTRADA = 'S') then
            if (TIPO = 33) then
                BEGIN
                EXECUTE PROCEDURE ULTIMO_COSTO(ARTICULO, FECHA, UNIDAD) returning_values (UCOSTO);
                INSERT INTO COSTOS (arti_cod, cost_fecha,
                    cost_entc, cost_entp, cost_salc, cost_salp,
                    cost_saldoc, cost_saldop, cost_ultimo, cost_idmov, cost_tipo)
                    VALUES (:articulo, :fecha, :cantidad, :cantidad*:costop, 0, 0, :saldoc, :saldoc*:costop, :ucosto, :IDMOV, :TIPO);
                SALDO = (SALDOC * COSTOP) + (CANTIDAD * COSTOP);
                SALDOC = SALDOC + CANTIDAD;
                END
            ELSE
                BEGIN
                UCOSTO = :COSTO;
                INSERT INTO COSTOS (arti_cod, cost_fecha,
                    cost_entc, cost_entp, cost_salc, cost_salp,
                    cost_saldoc, cost_saldop, cost_ultimo, cost_idmov, cost_tipo)
                    VALUES (:articulo, :fecha, :cantidad, :cantidad*:costo, 0, 0, :saldoc, :saldoc*:costop, :costo, :IDMOV, :TIPO);
                SALDO = (SALDOC * COSTOP) + (CANTIDAD * COSTO);
                SALDOC = SALDOC + CANTIDAD;
                END
        ELSE
            BEGIN
            EXECUTE PROCEDURE ULTIMO_COSTO(ARTICULO, FECHA, UNIDAD) returning_values (UCOSTO);
            INSERT INTO COSTOS (arti_cod, cost_fecha,
                cost_entc, cost_entp, cost_salc, cost_salp,
                cost_saldoc, cost_saldop, cost_ultimo, cost_idmov, cost_tipo)
                VALUES (:articulo, :fecha, 0, 0, :cantidad, :cantidad*:costop, :saldoc, :saldoc*:costop, :UCOSTO, :IDMOV, :TIPO);
            SALDOC = SALDOC - CANTIDAD;
            SALDO = SALDOC * COSTOP;  $$IBE$$*/ /* YA ESTA RESTADA LA CANTIDAD */ /*$$IBE$$ 
            END
        END
    END
 $$IBE$$*/ EXIT;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE CALCULA_PRECIOS(
    ARTICULO VARCHAR(20),
    FECHA DATE)
AS
declare variable LISTA INTEGER;
declare variable MARGEN NUMERIC(9, 4);
declare variable UTIL NUMERIC(9, 4);
declare variable UNIDAD VARCHAR(8);
declare variable UOR VARCHAR(20);
declare variable COSTOP NUMERIC(18, 2);
declare variable COSTOU NUMERIC(18, 2);
declare variable COSTO NUMERIC(18, 2);
declare variable DIG INTEGER;
declare variable IVAINC CHAR(1);
declare variable TARIVA NUMERIC(9,2);
declare variable AUTOM CHAR(1);
declare variable BASE varchar(10);
declare variable CAMBIO CHAR(7);
BEGIN /*$$IBE$$ 
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','CAMBIO DE PRECIOS AUTOMATICO AL CAMBIAR COSTO O PRECIO') returning_values (CAMBIO);
if (CAMBIO = 'COSTO') then
  BEGIN
  FOR SELECT P.LIPR_COD, PRAR_MARGEN, PRAR_UTIL, LIPR_MODIF, PRAR_AUTO
    FROM PRECIOS_ARTICULO P, LISTA_PRECIOS L
    WHERE P.LIPR_COD = L.LIPR_COD AND ARTI_COD = :articulo
    INTO :LISTA, :MARGEN, :UTIL, :IVAINC, :AUTOM
    DO
      if (AUTOM = 'S') then
        BEGIN
        if (UTIL IS NULL) then
            UTIL = 0;
        if (MARGEN IS NULL) then
            MARGEN = 0;
        SELECT ARTI_UNIDAD, TAIV_PORC FROM ARTICULO A, TARIFA_IVA T WHERE A.TAIV_COD = T.TAIV_COD AND ARTI_COD = :ARTICULO INTO :UNIDAD, :TARIVA;
        EXECUTE PROCEDURE lee_configuracion('FACTURACION','ARTICULOS','COSTO BASE PARA CALCULO DE PRECIOS DE VENTA AUTOMATICOS') returning_values (:BASE);
            EXECUTE PROCEDURE COSTO_PROMEDIO (:ARTICULO, :FECHA) RETURNING_VALUES(:COSTOP);
            EXECUTE PROCEDURE ULTIMO_COSTO (:ARTICULO, :FECHA, :UNIDAD) RETURNING_VALUES(:COSTOU);
        if (base = 'ULTIMO') then
            COSTO = COSTOU;
        ELSE
            BEGIN
            COSTO = COSTOP;
            if (base = 'MAYOR') then
                if (COSTOP < COSTOU) then
                    COSTO = COSTOU;
            END
        if (IVAINC = 'S') then
            COSTO = COSTO * (1 + TARIVA/100);
        EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'ARTICULOS', 'SUGERIR PRECIOS CON PORCENTAJE DE MARGEN O UTILIDAD') RETURNING_VALUES (:UOR);
        EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'ARTICULOS', 'REDONDEO AL MULTIPLO DE DIEZ EN PRECIOS') RETURNING_VALUES (:DIG);
        if (UOR = 'UTILIDAD') then
            BEGIN
            COSTO = COSTO * (1 + :UTIL/100);
            EXECUTE PROCEDURE REDONDEE (COSTO, DIG) returning_values (COSTO);
            UPDATE PRECIOS_ARTICULO
                SET PRAR_FIJO = :COSTO
                WHERE ARTI_COD = :ARTICULO AND LIPR_COD = :LISTA;
            END
        ELSE
            BEGIN
            COSTO = COSTO / (1 - :MARGEN/100);
            EXECUTE PROCEDURE REDONDEE (COSTO, DIG) returning_values (COSTO);
            UPDATE PRECIOS_ARTICULO
                SET PRAR_FIJO = :COSTO
                WHERE ARTI_COD = :ARTICULO AND LIPR_COD = :LISTA;
            END
        END
  END
 $$IBE$$*/ EXIT;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE COSTO_EN_VENTAS(
    TIPO INTEGER,
    ID INTEGER)
AS
declare variable FECHA DATE;
declare variable ARTICULO VARCHAR(20);
declare variable CANTIDAD NUMERIC(18,4);
declare variable COSTO NUMERIC(18,2);
declare variable CTACOSTO VARCHAR(20);
declare variable CTAINVEN VARCHAR(20);
BEGIN /*$$IBE$$ 
DELETE FROM COSTO_VENTAS;
if (TIPO = 31) then
    BEGIN
     $$IBE$$*/ /* FACTURA DE VENTA */ /*$$IBE$$ 
    FOR SELECT D.ARTI_COD, FADE_CANT * FADE_FACTOR, COAR_CTACOS, COAR_CTAINV, FACT_FECHA
        FROM ARTICULO A, FACTURAS F, FACTURAS_DETALLE D, CONTABIL_ARTICULO C
        WHERE F.FACT_ID = D.FACT_ID AND A.ARTI_COD = D.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND F.FACT_ID = :ID AND FACT_ANULADO = 'N'
        INTO :ARTICULO, :CANTIDAD, :CTACOSTO, :CTAINVEN, :FECHA
        DO
        BEGIN
        EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
        INSERT INTO COSTO_VENTAS VALUES (:ARTICULO, :CANTIDAD, :COSTO, :CTACOSTO, :CTAINVEN);
        END
    END
if (TIPO = 32) then
    BEGIN
     $$IBE$$*/ /* REMISION */ /*$$IBE$$ 
    FOR SELECT D.ARTI_COD, RVDE_CANT * RVDE_FACTOR, COAR_CTACOS, COAR_CTAINV, REVT_FECHA
        FROM ARTICULO A, REMISIONES_VENTA R, REMISIONES_VENTA_DETALLE D, CONTABIL_ARTICULO C
        WHERE R.REVT_ID = D.REVT_ID AND A.ARTI_COD = D.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND R.REVT_ID = :ID AND REVT_ANULADO = 'N'
        INTO :ARTICULO, :CANTIDAD, :CTACOSTO, :CTAINVEN, :FECHA
        DO
        BEGIN
        EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
        INSERT INTO COSTO_VENTAS VALUES (:ARTICULO, :CANTIDAD, :COSTO, :CTACOSTO, :CTAINVEN);
        END
    END
if (TIPO = 33) then
    BEGIN
     $$IBE$$*/ /* DEVOLUCION */ /*$$IBE$$ 
    FOR SELECT D.ARTI_COD, DVDE_CANT * DVDE_FACTOR, COAR_CTACOS, COAR_CTAINV, DEVT_FECHA
        FROM ARTICULO A, DEVOLUCIONES_VENTAS DV, DEVOLUCIONES_VENTAS_DETALLE D, CONTABIL_ARTICULO C
        WHERE DV.DEVT_ID = D.DEVT_ID AND A.ARTI_COD = D.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND DV.DEVT_ID = :ID AND DEVT_ANULADO = 'N'
        INTO :ARTICULO, :CANTIDAD, :CTACOSTO, :CTAINVEN, :FECHA
        DO
        BEGIN
        EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
        INSERT INTO COSTO_VENTAS VALUES (:ARTICULO, :CANTIDAD, :COSTO, :CTACOSTO, :CTAINVEN);
        END
    END
 $$IBE$$*/ EXIT;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE COSTO_EN_VENTAS_CONTADO(
    FECFAC DATE,
    PREF VARCHAR(4),
    PTVTA INTEGER)
AS
declare variable ARTICULO VARCHAR(20);
declare variable CANTIDAD NUMERIC(18,4);
declare variable COSTO NUMERIC(18,2);
declare variable CTACOSTO VARCHAR(20);
declare variable CTAINVEN VARCHAR(20);
BEGIN /*$$IBE$$ 
    DELETE FROM COSTO_VENTAS;
     $$IBE$$*/ /* FACTURA DE VENTA */ /*$$IBE$$ 
    FOR SELECT MAX(D.ARTI_COD), SUM(FADE_CANT * FADE_FACTOR), MAX(COAR_CTACOS), MAX(COAR_CTAINV)
        FROM ARTICULO A, FACTURAS F, FACTURAS_DETALLE D, CONTABIL_ARTICULO C
        WHERE F.FACT_ID = D.FACT_ID AND A.ARTI_COD = D.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND FACT_ANULADO = 'N' AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA
        GROUP BY D.ARTI_COD
        INTO :ARTICULO, :CANTIDAD, :CTACOSTO, :CTAINVEN
        DO
        BEGIN
        EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECFAC) returning_values (:COSTO);
        INSERT INTO COSTO_VENTAS VALUES (:ARTICULO, :CANTIDAD, :COSTO * :CANTIDAD, :CTACOSTO, :CTAINVEN);
        END
 $$IBE$$*/ EXIT;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE COSTO_PROMEDIO_UNIDAD(
    ARTICULO VARCHAR(15),
    FECHA DATE,
    UNIDAD VARCHAR(8))
RETURNS (
    COSTO NUMERIC(18,2))
AS
declare variable FACTOR NUMERIC(15,4);
BEGIN /*$$IBE$$ 
  EXECUTE PROCEDURE COSTO_PROMEDIO(ARTICULO, FECHA) returning_values (COSTO);
  EXECUTE PROCEDURE FACTOR_UNIDAD_CANT(ARTICULO, UNIDAD) returning_values (FACTOR);
  COSTO = COSTO * FACTOR;
  SUSPEND;
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE IMPR_AJUSTE(
    ID INTEGER)
RETURNS (
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    CONCEPTO VARCHAR(60),
    CODBODEGA VARCHAR(2),
    NOMBODEGA VARCHAR(30),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    EXANT NUMERIC(18,4),
    EXNUE NUMERIC(18,4),
    UNIDAD VARCHAR(8),
    BODITEM VARCHAR(2),
    LOTE VARCHAR(15),
    COSTO NUMERIC(18,2),
    TOTAL NUMERIC(18,2))
AS
DECLARE VARIABLE ITEMS INTEGER;
DECLARE VARIABLE MAX_AJUSTE INTEGER;
BEGIN
  /*  */ /*$$IBE$$ 
  SELECT PREF_PRE, AJUS_NUMERO, AJUS_FECHA, AJUS_CONC, A.BODE_COD, BODE_NOM, AJUS_OBS
    FROM AJUSTES A, BODEGA B WHERE A.BODE_COD = B.BODE_COD AND A.AJUS_ID = :ID into
    :PREF, :NUMERO, :FECHA, :CONCEPTO, :CODBODEGA, :NOMBODEGA, :OBS;
  FOR SELECT AJUS_ITEM, A.ARTI_COD, AJUS_CODBAR, AJDE_DESC, AJUS_EXANT, AJUS_UNIDAD, BODE_COD, AJUS_EXNUE, AJUS_LOTE
    FROM AJUSTES_DETALLE D, ARTICULO A
    WHERE D.ARTI_COD = A.ARTI_COD AND D.AJUS_ID = :ID
    ORDER BY AJUS_ITEM
    INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :EXANT, :UNIDAD, :BODITEM, :EXNUE, :LOTE
    DO
      BEGIN
      EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
      TOTAL = (EXNUE - EXANT) * COSTO;
      SUSPEND;
      END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE ORDENES_ARTICULO(
    FECHA DATE,
    DETALLE CHAR(1))
RETURNS (
    CODIGO VARCHAR(15),
    NOMBRE VARCHAR(60),
    ORDEN NUMERIC(18,4),
    EXIST NUMERIC(18,2),
    SUMA NUMERIC(18,2),
    COSTO NUMERIC(18,2),
    UNIDAD VARCHAR(8),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    COSTOTOT NUMERIC(18,2),
    CLIENTE VARCHAR(60),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHADOC DATE)
AS
declare variable ORDENC NUMERIC(18,4);
declare variable ID INTEGER;
declare variable ITEM INTEGER;
declare variable UND VARCHAR(8);
declare variable FACTOR NUMERIC(18,4);
declare variable FACT NUMERIC(18,4);
declare variable CANT NUMERIC(18,4);
BEGIN /*$$IBE$$ 
  FOR
    SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD
      FROM ARTICULO A
      INTO :CODIGO, :NOMBRE, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
      DO
        BEGIN
        EXECUTE PROCEDURE SALDO_TOTAL_INVENTARIO(CODIGO, FECHA) returning_values (EXIST);
        EXECUTE PROCEDURE COSTO_PROMEDIO(CODIGO, FECHA) returning_values (COSTO);
        if (DETALLE = 'N') then
            BEGIN
            NOMMARC = '';
            NOMSUBG = '';
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SELECT SUM(ORID_ENTREGAR) FROM ordenes_inventario O, ordeninventario_detalle OD
                WHERE O.ORIN_ID = OD.ORIN_ID AND OD.ARTI_COD = :CODIGO AND ORIN_FECHA <= :FECHA AND ORIN_FECLLEGA >= :FECHA AND ORIN_ANULADO = 'N'
                INTO :ORDEN;
            if (ORDEN IS NULL) then
                ORDEN = 0;
            FOR SELECT O.ORDC_ID, OCDE_ITEM, OCDE_CANT * OCDE_FACTOR
                FROM ORDENES_COMPRA O, ORDENES_COMPRA_DETALLE OD
                WHERE O.ORDC_ID = OD.ORDC_ID AND OD.ARTI_COD = :CODIGO AND (ORDC_FECHA+ORDC_VALIDEZ) >= :FECHA AND ORDC_FECHA <= :FECHA AND ORDC_ANULADO = 'N'
                INTO :ID, :item, :CANT
                DO
                BEGIN
                EXECUTE PROCEDURE FALTANTE(23, 21, ID, ITEM) returning_values (ORDENC, UND, FACT);
                if (ORDENC * FACT = CANT) then
                    EXECUTE PROCEDURE FALTANTE(23, 22, ID, ITEM) returning_values (ORDENC, UND, FACT);
                if (ORDENC IS NULL) then
                    ORDENC = 0;
                if (ORDENC <> 0) then
                    BEGIN
                    ORDEN = ORDEN + ORDENC;
                    END
                END
            SUMA = ORDEN + EXIST;
            COSTOTOT = ORDEN * :COSTO;
            if (ORDEN <> 0) then
                SUSPEND;
            END
        ELSE
            BEGIN
            FOR SELECT ORIN_FECHA, PREF_PRE, ORIN_NUMERO, ORIN_NOMTERC, ORID_CANT, ORID_UNIDAD, ORID_ENTREGAR
                FROM ordenes_inventario O, ordeninventario_detalle OD
                WHERE O.ORIN_ID = OD.ORIN_ID AND OD.ARTI_COD = :CODIGO AND ORIN_FECHA <= :FECHA AND ORIN_FECLLEGA > :FECHA AND ORIN_ANULADO = 'N'
                INTO :FECHADOC, :PREFIJO, :NUMERO, :CLIENTE, :EXIST, :UNIDAD, :ORDEN
                DO
                BEGIN
                COSTOTOT = ORDEN * :COSTO;
                SUSPEND;
                END
            FOR SELECT O.ORDC_ID, OCDE_ITEM, ORDC_FECHA, PREF_PRE, ORDC_NUMERO, TERC_NOM, OCDE_CANT, OCDE_UNIDAD, OCDE_ORDENADO, OCDE_FACTOR
                FROM ordenes_compra O, ordenes_compra_detalle OD, TERCEROS T
                WHERE O.ORDC_ID = OD.ORDC_ID AND OD.ARTI_COD = :CODIGO AND O.TERC_NIT = T.TERC_NIT AND ORDC_FECHA <= :FECHA AND (ORDC_FECHA+ordc_validez) > :FECHA AND ORDC_ANULADO = 'N'
                INTO :ID, :ITEM, :FECHADOC, :PREFIJO, :NUMERO, :CLIENTE, :CANT, :UNIDAD, :ORDEN, :FACTOR
                DO
                BEGIN
                EXECUTE PROCEDURE FALTANTE(23, 21, ID, ITEM) returning_values (ORDEN, UND, FACT);
                if (ORDEN * FACT = CANT * FACTOR) then
                    EXECUTE PROCEDURE FALTANTE(23, 22, ID, ITEM) returning_values (ORDEN, UND, FACTOR);
                if (ORDEN IS NULL) then
                    ORDEN = 0;
                COSTOTOT = ORDEN * :COSTO;
                if (ORDEN <> 0) then
                    SUSPEND;
                END
            END
        END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE REP_COMPROBANTES_ARTICULO(
    TIPODOC INTEGER,
    DETALLE CHAR(1),
    FECINI DATE,
    FECFIN DATE,
    ARTINI VARCHAR(20),
    ARTFIN VARCHAR(20),
    GRPINI VARCHAR(2),
    GRPFIN VARCHAR(2),
    ORDEN CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    CODIGO VARCHAR(15),
    NOMBRE VARCHAR(60),
    UNIDAD VARCHAR(8),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    CODBOD VARCHAR(2),
    NOMTIPO VARCHAR(30),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    CONCEPTO VARCHAR(60),
    NIT VARCHAR(20),
    NOMTERC VARCHAR(60),
    CONS INTEGER,
    CANT NUMERIC(18,4),
    COSTO NUMERIC(18,2),
    COSTOTOT NUMERIC(18,2))
AS
declare variable ENT CHAR(1);
declare variable ENTRADAS NUMERIC(18,4);
declare variable COSTOENT NUMERIC(18,2);
declare variable SALIDAS NUMERIC(18,4);
declare variable COSTOSAL NUMERIC(18,2);
declare variable CODINI VARCHAR(20);
declare variable CODFIN VARCHAR(20);
declare variable DESINI VARCHAR(20);
declare variable DESFIN VARCHAR(20);
BEGIN /*$$IBE$$ 
  SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPODOC INTO :NOMTIPO;
  if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
  ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END
  FOR
    SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD
      FROM ARTICULO A
      WHERE ARTI_COD >= :CODINI AND ARTI_COD <= :CODFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :GRPFIN AND ARTI_DES >= :DESINI AND ARTI_DES <= :DESFIN
      INTO :CODIGO, :NOMBRE, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
      DO
        BEGIN
        NOMMARC = '';
        NOMSUBG = '';
        SELECT GRUP_NOM FROM GRUPO WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
        if (DETALLE = 'N') then
            BEGIN
            CANT = 0;
            COSTOTOT = 0;
             $$IBE$$*/ /* SUME LAS ENTRADAS */ /*$$IBE$$ 
            SELECT SUM(MVAR_CANT), SUM(MVAR_CANT * MVAR_COSTO) FROM MOVIMIENTO_ARTICULO M, PREFIJOS P
              WHERE P.PREF_PRE = M.MVAR_PREF AND P.TIDO_COD = M.mvar_tipodoc AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA)) AND
              (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA < :FECFIN) AND
              (ARTI_COD = :CODIGO) AND (MVAR_ENTRADA = 'S') AND (MVAR_TIPODOC = :TIPODOC)
              INTO :ENTRADAS, :COSTOENT;
            if (ENTRADAS IS NULL) then
              ENTRADAS = 0;
            if (COSTOENT IS NULL) then
              COSTOENT = 0;
             $$IBE$$*/ /* CALCULE LAS SALIDAS A COSTO PROMEDIO */ /*$$IBE$$ 
            SALIDAS = 0;
            COSTOSAL = 0;
            FOR SELECT MVAR_CANT, MVAR_FECHA
                FROM MOVIMIENTO_ARTICULO M, PREFIJOS P
                WHERE P.PREF_PRE = M.MVAR_PREF AND P.TIDO_COD = M.mvar_tipodoc AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA)) AND
                (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA <= :FECFIN) AND
                (ARTI_COD = :CODIGO) AND (MVAR_ENTRADA = 'N') AND (MVAR_TIPODOC = :TIPODOC)
                INTO :CANT, :FECHA
                DO
                    BEGIN
                    EXECUTE PROCEDURE COSTO_PROMEDIO(:CODIGO, :FECHA) returning_values (:COSTO);
                    SALIDAS = SALIDAS + CANT;
                    COSTOSAL = COSTOSAL + (COSTO * CANT);
                    END
            if (SALIDAS IS NULL) then
              SALIDAS = 0;
            if (COSTOSAL IS NULL) then
              COSTOSAL = 0;
            if (ENTRADAS > 0) then
                CANT = ENTRADAS;
            if (SALIDAS > 0) then
                CANT = SALIDAS;
            if (COSTOENT > 0) then
                COSTOTOT = COSTOENT;
            if (COSTOSAL > 0) then
                COSTOTOT = COSTOSAL;
            if (CANT > 0) then
                COSTO = COSTOTOT / CANT;
            ELSE
                COSTO = 0;
            if (CANT <> 0) then
                SUSPEND;
            END
        ELSE
            BEGIN
            FOR SELECT MVAR_ENTRADA, MVAR_PREF, MVAR_NUMERO, MVAR_CANT, MVAR_COSTO, MVAR_CONC, MVAR_FECHA, M.TERC_NIT, TERC_NOM, MVAR_CONS, BODE_COD
                FROM MOVIMIENTO_ARTICULO M, TIPO_DOCUMENTO TD, PREFIJOS P
                LEFT OUTER JOIN TERCEROS T ON (M.TERC_NIT = T.TERC_NIT)
                WHERE TD.TIDO_COD = MVAR_TIPODOC AND P.PREF_PRE = M.MVAR_PREF AND P.TIDO_COD = M.mvar_tipodoc AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA)) AND
                (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA < :FECFIN) AND (ARTI_COD = :CODIGO) AND (MVAR_TIPODOC = :TIPODOC)
                ORDER BY MVAR_FECHA, MVAR_CONS
                INTO :ENT, :PREFIJO, :NUMERO, :CANT, :COSTO, :CONCEPTO, :FECHA, :NIT, :NOMTERC, :CONS, :CODBOD
                DO
                    BEGIN
                    if (ENT = 'S') then
                        BEGIN
                        COSTOTOT = (CANT * COSTO);
                        end
                    ELSE
                        BEGIN
                        EXECUTE PROCEDURE COSTO_PROMEDIO(:CODIGO, :FECHA) returning_values (:COSTO);
                        COSTOTOT = (CANT * COSTO);
                        END
                    SUSPEND;
                    END
            END
        END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE REP_COMPROBANTES_INV(
    TIPO INTEGER,
    DETALLE CHAR(1),
    FECINI DATE,
    FECFIN DATE,
    PREFIJO VARCHAR(4),
    ANULADOS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    NOMTIPO VARCHAR(30),
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    VENCE DATE,
    CONCEPTO VARCHAR(60),
    REFER VARCHAR(60),
    CODBODORI VARCHAR(2),
    NOMBODORI VARCHAR(30),
    CODBODDES VARCHAR(2),
    NOMBODDES VARCHAR(30),
    NOMTERCERO VARCHAR(60),
    PRODCODBAR VARCHAR(15),
    PRODDES VARCHAR(60),
    PRODCANT NUMERIC(18,4),
    PRODUNIDAD VARCHAR(8),
    PRODLOTE VARCHAR(15),
    OBS BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    EXANT NUMERIC(18,4),
    UNIDAD VARCHAR(8),
    BODITEM VARCHAR(2),
    COSTO NUMERIC(18,2),
    DTOPORC NUMERIC(9,2),
    DTOMONTO NUMERIC(18,2),
    IVAPORC NUMERIC(9,2),
    IVAMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    SUBTOTAL NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    LOTE VARCHAR(15),
    ANULADO CHAR(1),
    OBSITEM BLOB SUB_TYPE 0 SEGMENT SIZE 80)
AS
BEGIN
  /* DETERMINE LA TABLA A EXAMINAR */ /*$$IBE$$ 
  if (BIN_AND(TIPO, 1) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 11 INTO :NOMTIPO;
    FOR SELECT ENTR_ID, E.PREF_PRE, ENTR_NUMERO, ENTR_FECHA, ENTR_CONC, ENTR_REFER, E.BODE_COD, BODE_NOM, ENTR_NOMTERC, ENTR_OBS, ENTR_ANULADO
    FROM ENTRADAS E, BODEGA B, PREFIJOS P
    WHERE E.BODE_COD = B.BODE_COD AND ENTR_FECHA >= :FECINI AND ENTR_FECHA <= :FECFIN
     AND P.PREF_PRE = E.PREF_PRE AND P.TIDO_COD = 11 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY ENTR_FECHA, ENTR_ID
    INTO :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :NOMTERCERO, :OBS, :ANULADO
    DO
        BEGIN
        if (((:PREFIJO = '') or (:PREF = :PREFIJO)) AND ((:ANULADOS = 'S') or (:ANULADO = 'N'))) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT ENDE_ITEM, A.ARTI_COD, ENDE_CODBAR, ENDE_DESC, ENDE_CANT, ENDE_UNIDAD, BODE_COD, ENDE_COSTO, ENDE_DTOPORC, ENDE_DTOMONTO, ENDE_IVAPORC, ENDE_IVAMONTO, ENDE_CONSUMO, ENDE_TOTAL, ENDE_LOTE, ENDE_OBS
                    FROM ENTRADAS_DETALLE D, ARTICULO A WHERE D.ARTI_COD = A.ARTI_COD AND D.ENTR_ID = :ID INTO
                    :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :COSTO, :DTOPORC, :DTOMONTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :LOTE, :OBSITEM
                    DO
                    BEGIN
                    SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                    SUSPEND;
                    END
              ELSE
                BEGIN
                SELECT SUM(ENDE_IVAMONTO), SUM(ENDE_CONSUMO), SUM(ENDE_TOTAL)
                    FROM ENTRADAS_DETALLE D WHERE D.ENTR_ID = :ID INTO
                    :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 2) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 12 INTO :NOMTIPO;
    FOR SELECT SALI_ID, S.PREF_PRE, SALI_NUMERO, SALI_FECHA, SALI_CONC, SALI_REFER, S.BODE_COD, BODE_NOM, SALI_NOMTERC, SALI_OBS, SALI_ANULADO
    FROM SALIDAS S, BODEGA B, PREFIJOS P
    WHERE S.BODE_COD = B.BODE_COD AND SALI_FECHA >= :FECINI AND SALI_FECHA <= :FECFIN 
     AND P.PREF_PRE = S.PREF_PRE AND P.TIDO_COD = 12 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY SALI_FECHA, SALI_ID
    into :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :NOMTERCERO, :OBS, :ANULADO
    DO
        BEGIN
        if (((:PREFIJO = '') or (:PREF = :PREFIJO)) AND ((:ANULADOS = 'S') or (:ANULADO = 'N'))) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              EXANT = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT SADE_ITEM, A.ARTI_COD, SADE_CODBAR, SADE_DESC, SADE_CANT, SADE_UNIDAD, BODE_COD, SADE_COSTO, SADE_IVAPORC, SADE_IVAMONTO, SADE_CONSUMO, SADE_TOTAL, SADE_LOTE, SADE_OBS
                    FROM SALIDAS_DETALLE D, ARTICULO A WHERE D.ARTI_COD = A.ARTI_COD AND D.SALI_ID = :ID INTO
                    :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :COSTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :LOTE, :OBSITEM
                    DO
                BEGIN
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
              ELSE
                BEGIN
                SELECT SUM(SADE_IVAMONTO), SUM(SADE_CONSUMO), SUM(SADE_TOTAL)
                    FROM SALIDAS_DETALLE D WHERE D.SALI_ID = :ID INTO
                    :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 4) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 13 INTO :NOMTIPO;
    FOR SELECT TRAN_ID, T.PREF_PRE, TRAN_NUMERO, TRAN_FECHA, TRAN_CONC, TRAN_REFER, T.BODE_COD, BO.BODE_NOM, TRAN_BODDES, BD.BODE_NOM, TRAN_OBS, TRAN_ANULADO
    FROM TRASFERENCIAS T, BODEGA BO, BODEGA BD, PREFIJOS P
    WHERE T.BODE_COD = BO.BODE_COD AND T.TRAN_BODDES = BD.BODE_COD AND TRAN_FECHA >= :FECINI AND TRAN_FECHA <= :FECFIN 
     AND P.PREF_PRE = T.PREF_PRE AND P.TIDO_COD = 13 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY TRAN_FECHA, TRAN_ID
    into :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :CODBODDES, :NOMBODDES, :OBS, :ANULADO
    DO
        BEGIN
        if (((:PREFIJO = '') or (:PREF = :PREFIJO)) AND ((:ANULADOS = 'S') or (:ANULADO = 'N'))) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              EXANT = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT TRAS_ITEM, A.ARTI_COD, TRAS_CODBAR, TRAS_DESC, TRAS_CANT, TRAS_UNIDAD, TRAS_COSTO, TRAS_IVAPORC, TRAS_IVAMONTO, TRAS_CONSUMO, TRAS_TOTAL, TRAS_LOTE, TRAS_OBS
                    FROM TRASFERENCIAS_DETALLE D, ARTICULO A WHERE D.ARTI_COD = A.ARTI_COD AND D.TRAN_ID = :ID INTO
                    :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :COSTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :LOTE, :OBSITEM
                    DO
                    BEGIN
                    SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                    SUSPEND;
                    END
              ELSE
                BEGIN
                SELECT SUM(TRAS_IVAMONTO), SUM(TRAS_CONSUMO), SUM(TRAS_TOTAL) FROM trasferencias_detalle D
                    WHERE D.TRAN_ID = :ID INTO :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 8) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 14 INTO :NOMTIPO;
    FOR SELECT AJUS_ID, A.PREF_PRE, AJUS_NUMERO, AJUS_FECHA, AJUS_CONC, A.BODE_COD, BODE_NOM, AJUS_OBS, AJUS_ANULADO
    FROM AJUSTES A, BODEGA B, PREFIJOS P
    WHERE A.BODE_COD = B.BODE_COD AND AJUS_FECHA >= :FECINI AND AJUS_FECHA <= :FECFIN 
     AND P.PREF_PRE = A.PREF_PRE AND P.TIDO_COD = 14 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY AJUS_FECHA, AJUS_ID
    into :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :CODBODORI, :NOMBODORI, :OBS, :ANULADO
    DO
        BEGIN
        if (((:PREFIJO = '') or (:PREF = :PREFIJO)) AND ((:ANULADOS = 'S') or (:ANULADO = 'N'))) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              EXANT = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT AJUS_ITEM, A.ARTI_COD, AJUS_CODBAR, AJDE_DESC, AJUS_EXANT, AJUS_UNIDAD, BODE_COD, AJUS_EXNUE, AJUS_LOTE, AJDE_OBS
                    FROM AJUSTES_DETALLE D, ARTICULO A WHERE D.ARTI_COD = A.ARTI_COD AND D.AJUS_ID = :ID INTO
                    :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :EXANT, :UNIDAD, :BODITEM, :CANT, :LOTE, :OBSITEM
                    DO
                      BEGIN
                      EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
                      TOTAL = (CANT - EXANT) * COSTO;
                      SUBTOTAL = TOTAL;
                      SUSPEND;
                      END
              ELSE
                BEGIN
                TOTAL = 0;
                FOR SELECT ARTI_COD, AJUS_EXNUE, AJUS_EXANT FROM AJUSTES_DETALLE D WHERE D.AJUS_ID = :ID INTO
                    :ARTICULO, :CANT, :EXANT
                    DO
                      BEGIN
                      EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
                      TOTAL = TOTAL + ((CANT - EXANT) * COSTO);
                      SUBTOTAL = TOTAL;
                      END
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 16) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 15 INTO :NOMTIPO;
    FOR SELECT ENSA_ID, E.PREF_PRE, ENSA_NUMERO, ENSA_FECHA, ENSA_CONC, ENSA_REFER, E.BODE_COD, BODE_NOM, ENSA_CODBAR, ENSA_DESC, ENSA_CANT, ENSA_UNIDAD, ENSA_LOTE, ENSA_OBS, ENSA_ANULADO
    FROM ENSAMBLES E, BODEGA B, PREFIJOS P
    WHERE E.BODE_COD = B.BODE_COD AND E.ENSA_FECHA >= :FECINI AND E.ENSA_FECHA <= :FECFIN
     AND P.PREF_PRE = E.PREF_PRE AND P.TIDO_COD = 15 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY ENSA_FECHA, ENSA_ID
    into :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :PRODCODBAR, :PRODDES, :PRODCANT, :PRODUNIDAD, :PRODLOTE, :OBS, :ANULADO
    DO
        BEGIN
        if (((:PREFIJO = '') or (:PREF = :PREFIJO)) AND ((:ANULADOS = 'S') or (:ANULADO = 'N'))) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              EXANT = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT ESDE_ITEM, A.ARTI_COD, ESDE_CODBAR, ESDE_DESC, ESDE_CANT, ESDE_UNIDAD, BODE_COD, ESDE_COSTO, ESDE_IVAPORC, ESDE_IVAMONTO, ESDE_CONSUMO, ESDE_TOTAL, ESDE_LOTE, ESDE_OBS
                    FROM ensambles_detalle D, ARTICULO A WHERE D.ARTI_COD = A.ARTI_COD AND D.ENSA_ID = :ID INTO
                    :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :COSTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :LOTE, :OBSITEM
                    DO
                    BEGIN
                    SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                    SUSPEND;
                    END
              ELSE
                BEGIN
                SELECT SUM(ESDE_IVAMONTO), SUM(ESDE_CONSUMO), SUM(ESDE_TOTAL) FROM ENSAMBLES_detalle D WHERE D.ENSA_ID = :ID INTO
                    :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 32) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 16 INTO :NOMTIPO;
    FOR SELECT DESE_ID, E.PREF_PRE, DESE_NUMERO, DESE_FECHA, DESE_CONC, DESE_REFER, E.BODE_COD, BODE_NOM, DESE_CODBAR, DESE_DESC, DESE_CANT, DESE_UNIDAD, DESE_LOTE, DESE_OBS, DESE_ANULADO
    FROM DESENSAMBLES E, BODEGA B, PREFIJOS P
    WHERE E.BODE_COD = B.BODE_COD AND DESE_FECHA >= :FECINI AND DESE_FECHA <= :FECFIN 
     AND P.PREF_PRE = E.PREF_PRE AND P.TIDO_COD = 16 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY DESE_FECHA, DESE_ID
    into :ID, PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :PRODCODBAR, :PRODDES, :PRODCANT, :PRODUNIDAD, :PRODLOTE, :OBS, :ANULADO
    DO
        BEGIN
        if (((:PREFIJO = '') or (:PREF = :PREFIJO)) AND ((:ANULADOS = 'S') or (:ANULADO = 'N'))) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              EXANT = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT DESE_ITEM, A.ARTI_COD, DEDE_CODBAR, DEDE_DESC, DEDE_CANT, DEDE_UNIDAD, BODE_COD, DEDE_COSTO, DEDE_IVAPORC, DEDE_IVAMONTO, DEDE_CONSUMO, DEDE_TOTAL, DEDE_LOTE, DEDE_OBS
                    FROM desensambles_detalle D, ARTICULO A WHERE D.ARTI_COD = A.ARTI_COD AND D.DESE_ID = :ID INTO
                    :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :COSTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :LOTE, :OBSITEM
                    DO
                    BEGIN
                    SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                    SUSPEND;
                    END
              ELSE
                BEGIN
                SELECT SUM(DEDE_IVAMONTO), SUM(DEDE_CONSUMO), SUM(DEDE_TOTAL) FROM DESENSAMBLES_detalle D WHERE D.DESE_ID = :ID INTO
                    :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 64) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 17 INTO :NOMTIPO;
    FOR SELECT RESE_ID, R.PREF_PRE, RESE_NUMERO, RESE_FECHA, RESE_CONC, RESE_REFER, R.BODE_COD, BODE_NOM, RESE_NOMTERC, RESE_OBS, RESE_ANULADO
    FROM RESERVAS R, BODEGA B, PREFIJOS P
    WHERE R.BODE_COD = B.BODE_COD AND R.RESE_FECHA >= :FECINI AND R.RESE_FECHA <= :FECFIN 
     AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 17 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY RESE_FECHA, RESE_ID
    into :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :NOMTERCERO, :OBS, :ANULADO
    DO
        BEGIN
        if (((:PREFIJO = '') or (:PREF = :PREFIJO)) AND ((:ANULADOS = 'S') or (:ANULADO = 'N'))) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              EXANT = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT RSDE_ITEM, A.ARTI_COD, RSDE_CODBAR, RSDE_DESC, RDSE_CANT, RSDE_UNIDAD, BODE_COD, RSDE_OBS
                    FROM RESERVAS_DETALLE D, ARTICULO A WHERE D.ARTI_COD = A.ARTI_COD AND D.RESE_ID = :ID INTO
                    :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :OBSITEM
                    DO
                    SUSPEND;
              ELSE
                BEGIN
                SELECT SUM(RDSE_CANT) FROM RESERVAS_detalle D WHERE D.RESE_ID = :ID INTO
                    :CANT;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 128) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 18 INTO :NOMTIPO;
    FOR SELECT ORIN_ID, O.PREF_PRE, ORIN_NUMERO, ORIN_FECHA, ORIN_FECLLEGA, ORIN_CONC, ORIN_REFER, ORIN_NOMTERC, ORIN_OBS, ORIN_ANULADO
        FROM ORDENES_INVENTARIO O, PREFIJOS P
        WHERE ORIN_FECHA >= :FECINI AND ORIN_FECHA <= :FECFIN 
        AND P.PREF_PRE = O.PREF_PRE AND P.TIDO_COD = 18 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY ORIN_FECHA, ORIN_ID
        into :ID, PREF, :NUMERO, :FECHA, :VENCE, :CONCEPTO, :REFER, :NOMTERCERO, :OBS, :ANULADO
        DO
        BEGIN
        if (((:PREFIJO = '') or (:PREF = :PREFIJO)) AND ((:ANULADOS = 'S') or (:ANULADO = 'N'))) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              EXANT = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT ORID_ITEM, A.ARTI_COD, ORID_CODBAR, ORID_DESC, ORID_CANT, ORID_UNIDAD, ORIN_COSTO, ORID_DTOPORC, ORID_DTOMONTO, ORID_IVAPORC, ORID_IVAMONTO, ORID_CONSUMO, ORID_TOTAL, ORID_OBS, ORID_LOTE
                    FROM ORDENINVENTARIO_DETALLE D, ARTICULO A WHERE D.ARTI_COD = A.ARTI_COD AND D.ORIN_ID = :ID INTO
                    :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :COSTO, :DTOPORC, :DTOMONTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :OBSITEM, :LOTE
                    DO
                    BEGIN
                    SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                    SUSPEND;
                    END
              ELSE
                BEGIN
                SELECT SUM(ORID_IVAMONTO), SUM(ORID_CONSUMO), SUM(ORID_TOTAL) FROM ordeninventario_detalle D WHERE D.ORIN_ID = :ID INTO
                    :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE REP_CONSECUTIVOS_INV(
    TIPO INTEGER,
    DETALLE CHAR(1),
    PREINI VARCHAR(4),
    PREFIN VARCHAR(4),
    NUMINI VARCHAR(6),
    NUMFIN VARCHAR(6),
    ANULADOS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    NOMTIPO VARCHAR(30),
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    VENCE DATE,
    CONCEPTO VARCHAR(60),
    REFER VARCHAR(60),
    CODBODORI VARCHAR(2),
    NOMBODORI VARCHAR(30),
    CODBODDES VARCHAR(2),
    NOMBODDES VARCHAR(30),
    NOMTERCERO VARCHAR(60),
    PRODCODBAR VARCHAR(15),
    PRODDES VARCHAR(60),
    PRODCANT NUMERIC(18,4),
    PRODUNIDAD VARCHAR(8),
    PRODLOTE VARCHAR(15),
    OBS BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    EXANT NUMERIC(18,4),
    UNIDAD VARCHAR(8),
    BODITEM VARCHAR(2),
    COSTO NUMERIC(18,2),
    DTOPORC NUMERIC(9,2),
    DTOMONTO NUMERIC(18,2),
    IVAPORC NUMERIC(9,2),
    IVAMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    SUBTOTAL NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    LOTE VARCHAR(15),
    ANULADO CHAR(1),
    OBSITEM BLOB SUB_TYPE 0 SEGMENT SIZE 80)
AS
BEGIN
  /* DETERMINE LA TABLA A EXAMINAR */ /*$$IBE$$ 
  if (BIN_AND(TIPO, 1) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 11 INTO :NOMTIPO;
    FOR SELECT ENTR_ID, E.PREF_PRE, ENTR_NUMERO, ENTR_FECHA, ENTR_CONC, ENTR_REFER, E.BODE_COD, BODE_NOM, ENTR_NOMTERC, ENTR_OBS, ENTR_ANULADO
    FROM ENTRADAS E, BODEGA B, PREFIJOS PR
    WHERE E.BODE_COD = B.BODE_COD AND E.PREF_PRE >= :PREINI AND E.PREF_PRE <= :PREFIN AND ENTR_NUMERO >= :NUMINI AND ENTR_NUMERO <= :NUMFIN
     AND PR.PREF_PRE = E.PREF_PRE AND PR.TIDO_COD = 11 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY E.PREF_PRE, ENTR_NUMERO
    INTO :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :NOMTERCERO, :OBS, :ANULADO
    DO
        BEGIN
        if ((:ANULADOS = 'S') or (:ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT ENDE_ITEM, A.ARTI_COD, ENDE_CODBAR, ENDE_DESC, ENDE_CANT, ENDE_UNIDAD, BODE_COD, ENDE_COSTO, ENDE_DTOPORC, ENDE_DTOMONTO, ENDE_IVAPORC, ENDE_IVAMONTO, ENDE_CONSUMO, ENDE_TOTAL, ENDE_LOTE, ENDE_OBS
                    FROM ENTRADAS_DETALLE D, ARTICULO A
                    WHERE D.ARTI_COD = A.ARTI_COD AND D.ENTR_ID = :ID
                    ORDER BY ENDE_ITEM
                    INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :COSTO, :DTOPORC, :DTOMONTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :LOTE, :OBSITEM
                    DO
                    BEGIN
                    SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                    SUSPEND;
                    END
              ELSE
                BEGIN
                SELECT SUM(ENDE_IVAMONTO), SUM(ENDE_CONSUMO), SUM(ENDE_TOTAL) FROM ENTRADAS_DETALLE D WHERE D.ENTR_ID = :ID INTO
                    :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 2) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 12 INTO :NOMTIPO;
    FOR SELECT SALI_ID, S.PREF_PRE, SALI_NUMERO, SALI_FECHA, SALI_CONC, SALI_REFER, S.BODE_COD, BODE_NOM, SALI_NOMTERC, SALI_OBS, SALI_ANULADO
    FROM SALIDAS S, BODEGA B, PREFIJOS PR
    WHERE S.BODE_COD = B.BODE_COD AND S.PREF_PRE >= :PREINI AND S.PREF_PRE <= :PREFIN AND SALI_NUMERO >= :NUMINI AND SALI_NUMERO <= :NUMFIN
     AND PR.PREF_PRE = S.PREF_PRE AND PR.TIDO_COD = 12 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY S.PREF_PRE, SALI_NUMERO
    into :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :NOMTERCERO, :OBS, :ANULADO
    DO
        BEGIN
        if ((:ANULADOS = 'S') or (:ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT SADE_ITEM, A.ARTI_COD, SADE_CODBAR, SADE_DESC, SADE_CANT, SADE_UNIDAD, BODE_COD, SADE_COSTO, SADE_IVAPORC, SADE_IVAMONTO, SADE_CONSUMO, SADE_TOTAL, SADE_LOTE, SADE_OBS
                FROM SALIDAS_DETALLE D, ARTICULO A
                WHERE D.ARTI_COD = A.ARTI_COD AND D.SALI_ID = :ID
                ORDER BY SADE_ITEM
                INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :COSTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :LOTE, :OBSITEM
                    DO
                BEGIN
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
              ELSE
                BEGIN
                SELECT SUM(SADE_IVAMONTO), SUM(SADE_CONSUMO), SUM(SADE_TOTAL) FROM SALIDAS_DETALLE D WHERE D.SALI_ID = :ID INTO
                    :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 4) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 13 INTO :NOMTIPO;
    FOR SELECT TRAN_ID, T.PREF_PRE, TRAN_NUMERO, TRAN_FECHA, TRAN_CONC, TRAN_REFER, T.BODE_COD, BO.BODE_NOM, TRAN_BODDES, BD.BODE_NOM, TRAN_OBS, TRAN_ANULADO
    FROM TRASFERENCIAS T, BODEGA BO, BODEGA BD, PREFIJOS PR
    WHERE T.BODE_COD = BO.BODE_COD AND T.TRAN_BODDES = BD.BODE_COD AND T.PREF_PRE >= :PREINI AND T.PREF_PRE <= :PREFIN AND TRAN_NUMERO >= :NUMINI AND TRAN_NUMERO <= :NUMFIN
     AND PR.PREF_PRE = T.PREF_PRE AND PR.TIDO_COD = 13 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY T.PREF_PRE, TRAN_NUMERO
    into :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :CODBODDES, :NOMBODDES, :OBS, :ANULADO
    DO
        BEGIN
        if ((:ANULADOS = 'S') or (:ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT TRAS_ITEM, A.ARTI_COD, TRAS_CODBAR, TRAS_DESC, TRAS_CANT, TRAS_UNIDAD, TRAS_COSTO, TRAS_IVAPORC, TRAS_IVAMONTO, TRAS_CONSUMO, TRAS_TOTAL, TRAS_LOTE, TRAS_OBS
                FROM TRASFERENCIAS_DETALLE D, ARTICULO A
                WHERE D.ARTI_COD = A.ARTI_COD AND D.TRAN_ID = :ID
                ORDER BY TRAS_ITEM
                INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :COSTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :LOTE, :OBSITEM
                    DO
                    BEGIN
                    SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                    SUSPEND;
                    END
              ELSE
                BEGIN
                SELECT SUM(TRAS_IVAMONTO), SUM(TRAS_CONSUMO), SUM(TRAS_TOTAL) FROM trasferencias_detalle D WHERE D.TRAN_ID = :ID INTO
                    :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 8) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 14 INTO :NOMTIPO;
    FOR SELECT AJUS_ID, A.PREF_PRE, AJUS_NUMERO, AJUS_FECHA, AJUS_CONC, A.BODE_COD, BODE_NOM, AJUS_OBS, AJUS_ANULADO
    FROM AJUSTES A, BODEGA B, PREFIJOS PR
    WHERE A.BODE_COD = B.BODE_COD AND A.PREF_PRE >= :PREINI AND A.PREF_PRE <= :PREFIN AND AJUS_NUMERO >= :NUMINI AND AJUS_NUMERO <= :NUMFIN
     AND PR.PREF_PRE = A.PREF_PRE AND PR.TIDO_COD = 14 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY A.PREF_PRE, AJUS_NUMERO
    into :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :CODBODORI, :NOMBODORI, :OBS, :ANULADO
    DO
        BEGIN
        if ((:ANULADOS = 'S') or (:ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              EXANT = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT AJUS_ITEM, A.ARTI_COD, AJUS_CODBAR, AJDE_DESC, AJUS_EXANT, AJUS_UNIDAD, BODE_COD, AJUS_EXNUE, AJUS_LOTE, AJDE_OBS
                FROM AJUSTES_DETALLE D, ARTICULO A
                WHERE D.ARTI_COD = A.ARTI_COD AND D.AJUS_ID = :ID
                ORDER BY AJUS_ITEM
                INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :EXANT, :UNIDAD, :BODITEM, :CANT, :LOTE, :OBSITEM
                    DO
                      BEGIN
                      TOTAL = (CANT - EXANT) * COSTO;
                      SUBTOTAL = TOTAL;
                      SUSPEND;
                      END
              ELSE
                BEGIN
                TOTAL = 0;
                FOR SELECT ARTI_COD, AJUS_EXNUE, AJUS_EXANT FROM AJUSTES_DETALLE D WHERE D.AJUS_ID = :ID INTO
                    :ARTICULO, :CANT, :EXANT
                    DO
                      BEGIN
                      EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
                      TOTAL = TOTAL + ((CANT - EXANT) * COSTO);
                      SUBTOTAL = TOTAL;
                      END
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 16) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 15 INTO :NOMTIPO;
    FOR SELECT ENSA_ID, E.PREF_PRE, ENSA_NUMERO, ENSA_FECHA, ENSA_CONC, ENSA_REFER, E.BODE_COD, BODE_NOM, ENSA_CODBAR, ENSA_DESC, ENSA_CANT, ENSA_UNIDAD, ENSA_LOTE, ENSA_OBS, ENSA_ANULADO
    FROM ENSAMBLES E, BODEGA B, PREFIJOS PR
    WHERE E.BODE_COD = B.BODE_COD AND E.PREF_PRE >= :PREINI AND E.PREF_PRE <= :PREFIN AND ENSA_NUMERO >= :NUMINI AND ENSA_NUMERO <= :NUMFIN
     AND PR.PREF_PRE = E.PREF_PRE AND PR.TIDO_COD = 15 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY E.PREF_PRE, ENSA_NUMERO
    into :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :PRODCODBAR, :PRODDES, :PRODCANT, :PRODUNIDAD, :PRODLOTE, :OBS, :ANULADO
    DO
        BEGIN
        if ((:ANULADOS = 'S') or (:ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT ESDE_ITEM, A.ARTI_COD, ESDE_CODBAR, ESDE_DESC, ESDE_CANT, ESDE_UNIDAD, BODE_COD, ESDE_COSTO, ESDE_IVAPORC, ESDE_IVAMONTO, ESDE_CONSUMO, ESDE_TOTAL, ESDE_LOTE, ESDE_OBS
                FROM ensambles_detalle D, ARTICULO A
                WHERE D.ARTI_COD = A.ARTI_COD AND D.ENSA_ID = :ID
                ORDER BY ESDE_ITEM
                INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :COSTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :LOTE, :OBSITEM
                    DO
                    BEGIN
                    SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                    SUSPEND;
                    END
              ELSE
                BEGIN
                SELECT SUM(ESDE_IVAMONTO), SUM(ESDE_CONSUMO), SUM(ESDE_TOTAL) FROM ENSAMBLES_detalle D WHERE D.ENSA_ID = :ID INTO
                    :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 32) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 16 INTO :NOMTIPO;
    FOR SELECT DESE_ID, E.PREF_PRE, DESE_NUMERO, DESE_FECHA, DESE_CONC, DESE_REFER, E.BODE_COD, BODE_NOM, DESE_CODBAR, DESE_DESC, DESE_CANT, DESE_UNIDAD, DESE_LOTE, DESE_OBS, DESE_ANULADO
    FROM DESENSAMBLES E, BODEGA B, PREFIJOS PR
    WHERE E.BODE_COD = B.BODE_COD AND E.PREF_PRE >= :PREINI AND E.PREF_PRE <= :PREFIN AND DESE_NUMERO >= :NUMINI AND DESE_NUMERO <= :NUMFIN
     AND PR.PREF_PRE = E.PREF_PRE AND PR.TIDO_COD = 16 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY E.PREF_PRE, DESE_NUMERO
    into :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :PRODCODBAR, :PRODDES, :PRODCANT, :PRODUNIDAD, :PRODLOTE, :OBS, :ANULADO
    DO
        BEGIN
        if ((:ANULADOS = 'S') or (:ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT DESE_ITEM, A.ARTI_COD, DEDE_CODBAR, DEDE_DESC, DEDE_CANT, DEDE_UNIDAD, BODE_COD, DEDE_COSTO, DEDE_IVAPORC, DEDE_IVAMONTO, DEDE_CONSUMO, DEDE_TOTAL, DEDE_LOTE, DEDE_OBS
                FROM DESensambles_detalle D, ARTICULO A
                WHERE D.ARTI_COD = A.ARTI_COD AND D.DESE_ID = :ID
                ORDER BY DESE_ITEM
                INTO
                    :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :COSTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :LOTE, :OBSITEM
                    DO
                    BEGIN
                    SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                    SUSPEND;
                    END
              ELSE
                BEGIN
                SELECT SUM(DEDE_IVAMONTO), SUM(DEDE_CONSUMO), SUM(DEDE_TOTAL) FROM DESENSAMBLES_detalle D WHERE D.DESE_ID = :ID INTO
                    :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 64) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 17 INTO :NOMTIPO;
    FOR SELECT RESE_ID, R.PREF_PRE, RESE_NUMERO, RESE_FECHA, RESE_CONC, RESE_REFER, R.BODE_COD, BODE_NOM, RESE_NOMTERC, RESE_OBS, RESE_ANULADO
    FROM RESERVAS R, BODEGA B, PREFIJOS PR
    WHERE R.BODE_COD = B.BODE_COD AND R.PREF_PRE >= :PREINI AND R.PREF_PRE <= :PREFIN AND RESE_NUMERO >= :NUMINI AND RESE_NUMERO <= :NUMFIN
     AND PR.PREF_PRE = R.PREF_PRE AND PR.TIDO_COD = 17 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY R.PREF_PRE, RESE_NUMERO
    into :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :NOMTERCERO, :OBS, :ANULADO
    DO
        BEGIN
        if ((:ANULADOS = 'S') or (:ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              EXANT = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT RSDE_ITEM, A.ARTI_COD, RSDE_CODBAR, RSDE_DESC, RDSE_CANT, RSDE_UNIDAD, BODE_COD, RSDE_OBS
                FROM RESERVAS_DETALLE D, ARTICULO A
                WHERE D.ARTI_COD = A.ARTI_COD AND D.RESE_ID = :ID
                ORDER BY RSDE_ITEM
                INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :OBSITEM
                    DO
                    SUSPEND;
              ELSE
                BEGIN
                SELECT SUM(RDSE_CANT) FROM RESERVAS_detalle D WHERE D.RESE_ID = :ID INTO
                    :CANT;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 128) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 18 INTO :NOMTIPO;
    FOR SELECT ORIN_ID, O.PREF_PRE, ORIN_NUMERO, ORIN_FECHA, ORIN_FECLLEGA, ORIN_CONC, ORIN_REFER, ORIN_NOMTERC, ORIN_OBS, ORIN_ANULADO
    FROM ORDENES_INVENTARIO O, PREFIJOS PR
    WHERE O.PREF_PRE >= :PREINI AND O.PREF_PRE <= :PREFIN AND ORIN_NUMERO >= :NUMINI AND ORIN_NUMERO <= :NUMFIN
     AND PR.PREF_PRE = O.PREF_PRE AND PR.TIDO_COD = 18 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY O.PREF_PRE, ORIN_NUMERO
    into :ID, :PREF, :NUMERO, :FECHA, :VENCE, :CONCEPTO, :REFER, :NOMTERCERO, :OBS, :ANULADO
    DO
        BEGIN
        if ((:ANULADOS = 'S') or (:ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              EXANT = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT ORID_ITEM, A.ARTI_COD, ORID_CODBAR, ORID_DESC, ORID_CANT, ORID_UNIDAD, ORIN_COSTO, ORID_DTOPORC, ORID_DTOMONTO, ORID_IVAPORC, ORID_IVAMONTO, ORID_CONSUMO, ORID_TOTAL, ORID_OBS, ORID_LOTE
                FROM ORDENINVENTARIO_DETALLE D, ARTICULO A
                WHERE D.ARTI_COD = A.ARTI_COD AND D.ORIN_ID = :ID
                ORDER BY ORID_ITEM
                INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :COSTO, :DTOPORC, :DTOMONTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :OBSITEM, :LOTE
                    DO
                    BEGIN
                    SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                    SUSPEND;
                    END
              ELSE
                BEGIN
                SELECT SUM(ORID_IVAMONTO), SUM(ORID_CONSUMO), SUM(ORID_TOTAL) FROM ordeninventario_detalle D WHERE D.ORIN_ID = :ID INTO
                    :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE REP_DISPONIBILIDAD(
    FECHA DATE,
    ARTINI VARCHAR(20),
    ARTFIN VARCHAR(20),
    GRPINI VARCHAR(2),
    GRPFIN VARCHAR(2),
    ORDEN CHAR(1),
    CEROS CHAR(1),
    DETALLE CHAR(1),
    SUCURSAL INTEGER)
RETURNS (
    CODIGO VARCHAR(15),
    NOMBRE VARCHAR(60),
    UNIDAD VARCHAR(8),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    CODBOD VARCHAR(2),
    NOMBOD VARCHAR(30),
    EXIST NUMERIC(18,4),
    PROMEDIO NUMERIC(18,4),
    SALIDAS NUMERIC(18,4),
    DISPONIBILIDAD INTEGER,
    DIAS INTEGER,
    PROMEDIADO INTEGER,
    COSTO NUMERIC(18,2),
    COSTOPRO NUMERIC(18,2),
    SUGERIDO NUMERIC(18,4),
    FECCOMPRA DATE)
AS
DECLARE VARIABLE CODINI VARCHAR(20);
DECLARE VARIABLE CODFIN VARCHAR(20);
DECLARE VARIABLE DESINI VARCHAR(20);
declare variable FECINI DATE;
declare variable DIASC VARCHAR(255);
DECLARE VARIABLE DESFIN VARCHAR(20);
declare variable DIA_ART VARCHAR(2) CHARACTER SET NONE;
BEGIN /*$$IBE$$ 
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END
if (DETALLE = 'S') then
  BEGIN
  FOR SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, ARTI_DIAS, A.GRUP_COD, GRUP_NOM, A.SUBG_COD, A.MARC_COD, BODE_COD, BODE_NOM, ARTI_DIANALIS
      FROM ARTICULO A, GRUPO G, BODEGA B
      WHERE ARTI_COD >= :CODINI AND ARTI_COD <= :CODFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :GRPFIN AND ARTI_DES >= :DESINI AND ARTI_DES <= :DESFIN AND
      G.GRUP_COD = A.GRUP_COD AND A.ESAR_COD <> 'I' AND ((SUCU_ID = :SUCURSAL) or (:SUCURSAL = 0))
      INTO :CODIGO, :NOMBRE, :UNIDAD, :DIAS, :CODGRUPO, :NOMGRUPO, :CODSUBG, :CODMARC, :CODBOD, :NOMBOD, :PROMEDIADO
      DO
        BEGIN
        NOMMARC = '';
        NOMSUBG = '';
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO :NOMMARC;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
        EXECUTE PROCEDURE ultimo_costo(:CODIGO, :FECHA, :UNIDAD) returning_values (:COSTO);
        EXECUTE PROCEDURE costo_promedio(:CODIGO, :FECHA) RETURNING_VALUES :costopro;
        EXECUTE PROCEDURE DISPONIBILIDAD_ARTICULO(CODIGO, FECHA, :CODBOD) returning_values (:DISPONIBILIDAD, :EXIST, :PROMEDIO, :SALIDAS);
         $$IBE$$*/ /*ESTABLECER CUAL ES EL VALOR DE DIAS PARA PROMEDIO*/ /*$$IBE$$ 
        EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'PROMEDIAR LAS SALIDAS DEL INVENTARIO CON EL NUMERO DE DIAS ASIGNADO A CADA ARTICULO') returning_values (:DIA_ART);
        if (DIA_ART = 'NO') then
          BEGIN
            EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'NUMERO DE DIAS PARA PROMEDIO DE SALIDAS POR ARTICULO') returning_values (DIASC);
            PROMEDIADO = CAST(DIASC AS INTEGER);
          END
        FECINI = :FECHA - :PROMEDIADO;
        if ((DISPONIBILIDAD < DIAS) and (PROMEDIO > 0))then
            SUGERIDO = (DIAS * PROMEDIO) - EXIST;
        ELSE
            SUGERIDO = 0;
        SELECT MAX(FACO_FECHA) FROM FACTURAS_COMPRA F, FACTURAS_COMPRAS_DETALLE D
            WHERE F.FACO_ID = D.faco_id AND D.ARTI_COD = :CODIGO AND FACO_FECHA <= :FECHA AND D.bode_cod = :codbod
            INTO :FECCOMPRA;
        if ((PROMEDIO > 0) or (EXIST <> 0) or (CEROS = 'S')) then
            SUSPEND;
        END
  END
ELSE
  BEGIN
  FOR SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, ARTI_DIAS, A.GRUP_COD, GRUP_NOM, A.SUBG_COD, A.MARC_COD, ARTI_DIANALIS
      FROM ARTICULO A, GRUPO G
      WHERE ARTI_COD >= :CODINI AND ARTI_COD <= :CODFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :GRPFIN AND ARTI_DES >= :DESINI AND ARTI_DES <= :DESFIN AND G.GRUP_COD = A.GRUP_COD AND A.ESAR_COD <> 'I'
      INTO :CODIGO, :NOMBRE, :UNIDAD, :DIAS, :CODGRUPO, :NOMGRUPO, :CODSUBG, :CODMARC, :PROMEDIADO
      DO
        BEGIN
        NOMMARC = '';
        NOMSUBG = '';
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO :NOMMARC;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
        EXECUTE PROCEDURE costo_promedio(:CODIGO, :FECHA) RETURNING_VALUES :costopro;
        EXECUTE PROCEDURE ultimo_costo(:CODIGO, :FECHA, :UNIDAD) returning_values (:COSTO);
        EXECUTE PROCEDURE DISPONIBILIDAD_TOTAL_ARTICULO(CODIGO, FECHA) returning_values (:DISPONIBILIDAD, :EXIST, :PROMEDIO, :SALIDAS);
         $$IBE$$*/ /*ESTABLECER CUAL ES EL VALOR DE DIAS PARA PROMEDIO*/ /*$$IBE$$ 
        EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'PROMEDIAR LAS SALIDAS DEL INVENTARIO CON EL NUMERO DE DIAS ASIGNADO A CADA ARTICULO') returning_values (:DIA_ART);
        if (DIA_ART = 'NO') then
          BEGIN
            EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'NUMERO DE DIAS PARA PROMEDIO DE SALIDAS POR ARTICULO') returning_values (DIASC);
            PROMEDIADO = CAST(DIASC AS INTEGER);
          END
        FECINI = :FECHA - :PROMEDIADO;
        if ((DISPONIBILIDAD < DIAS) and (PROMEDIO > 0))then
            SUGERIDO = (DIAS * PROMEDIO) - EXIST;
        ELSE
            SUGERIDO = 0;
        SELECT MAX(FACO_FECHA) FROM FACTURAS_COMPRA F, FACTURAS_COMPRAS_DETALLE D
            WHERE F.FACO_ID = D.faco_id AND D.ARTI_COD = :CODIGO AND FACO_FECHA <= :FECHA
            INTO :FECCOMPRA;
        if ((PROMEDIO > 0) or (EXIST <> 0) or (CEROS = 'S')) then
            SUSPEND;
        END
  END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE REP_KARDEX_ARTICULO(
    DETALLE CHAR(1),
    FECINI DATE,
    FECFIN DATE,
    ARTINI VARCHAR(20),
    ARTFIN VARCHAR(20),
    GRPINI VARCHAR(2),
    GRPFIN VARCHAR(2),
    ORDEN CHAR(1),
    BODEGA VARCHAR(2))
RETURNS (
    CODIGO VARCHAR(15),
    NOMBRE VARCHAR(60),
    UNIDAD VARCHAR(8),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    CODBOD VARCHAR(2),
    SALDOINI NUMERIC(18,4),
    COSTOINI NUMERIC(18,2),
    ENTRADAS NUMERIC(18,4),
    COSTOENT NUMERIC(18,2),
    SALIDAS NUMERIC(18,4),
    COSTOSAL NUMERIC(18,2),
    SALDOFIN NUMERIC(18,4),
    COSTOFIN NUMERIC(18,2),
    TIPODOC VARCHAR(8),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    CONCEPTO VARCHAR(60),
    NIT VARCHAR(20),
    CONS INTEGER,
    CANFINAL NUMERIC(18,4),
    COSFINAL NUMERIC(18,2))
AS
DECLARE VARIABLE ENTRADA CHAR(1);
DECLARE VARIABLE CANT NUMERIC(18,4);
DECLARE VARIABLE EXIST NUMERIC(18,4);
DECLARE VARIABLE COSTO NUMERIC(18,2);
DECLARE VARIABLE CODINI VARCHAR(20);
DECLARE VARIABLE CODFIN VARCHAR(20);
DECLARE VARIABLE DESINI VARCHAR(20);
DECLARE VARIABLE DESFIN VARCHAR(20);
declare variable TIPO INTEGER;
declare variable ID INTEGER;
BEGIN /*$$IBE$$ 
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END
  FOR
    SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD
      FROM ARTICULO A
      WHERE ARTI_COD >= :CODINI AND ARTI_COD <= :CODFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :GRPFIN AND ARTI_DES >= :DESINI AND ARTI_DES <= :DESFIN AND A.ESAR_COD <> 'I'
      INTO :CODIGO, :NOMBRE, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
      DO
        BEGIN
        NOMMARC = '';
        NOMSUBG = '';
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
        if (BODEGA = '') then
            BEGIN
            EXECUTE PROCEDURE SALDO_INICIAL_TOTAL_INV(CODIGO, FECINI) returning_values (:SALDOINI);
            EXECUTE PROCEDURE VALOR_INICIAL_INVENTARIO(CODIGO, FECINI) returning_values (COSTOINI);
            END
        ELSE
            BEGIN
            EXECUTE PROCEDURE SALDO_INICIAL_INVENTARIO(CODIGO, FECINI, :BODEGA) returning_values (SALDOINI);
            EXECUTE PROCEDURE COSTO_PROMEDIO(CODIGO, FECINI) returning_values (COSTOINI);
            COSTOINI = COSTOINI * saldoini;
            END
        if (DETALLE = 'N') then
            BEGIN
             $$IBE$$*/ /* SUME LAS ENTRADAS */ /*$$IBE$$ 
            if (BODEGA = '') then
                SELECT SUM(MVAR_CANT), SUM(MVAR_CANT * MVAR_COSTO) FROM MOVIMIENTO_ARTICULO
                  WHERE (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA <= :FECFIN) AND (MVAR_TIPODOC <> 13) AND
                  (ARTI_COD = :CODIGO) AND (MVAR_ENTRADA = 'S') INTO :ENTRADAS, :COSTOENT;
            ELSE
                SELECT SUM(MVAR_CANT), SUM(MVAR_CANT * MVAR_COSTO) FROM MOVIMIENTO_ARTICULO
                  WHERE (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA <= :FECFIN) AND (MVAR_TIPODOC <> 13) AND
                  (ARTI_COD = :CODIGO) AND (MVAR_ENTRADA = 'S') AND BODE_COD = :BODEGA
                  INTO :ENTRADAS, :COSTOENT;
                
            if (ENTRADAS IS NULL) then
              ENTRADAS = 0;
            if (COSTOENT IS NULL) then
              COSTOENT = 0;
             $$IBE$$*/ /* CALCULE LAS SALIDAS A COSTO PROMEDIO */ /*$$IBE$$ 
            SALIDAS = 0;
            COSTOSAL = 0;
            if (BODEGA = '') then
                FOR SELECT MVAR_CANT, MVAR_FECHA, MVAR_TIPODOC, MVAR_CONS
                    FROM MOVIMIENTO_ARTICULO
                    WHERE (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA <= :FECFIN) AND (MVAR_TIPODOC <> 13) AND
                    (ARTI_COD = :CODIGO) AND (MVAR_ENTRADA = 'N')
                    INTO :CANT, :FECHA, :TIPO, :ID
                    DO
                    BEGIN
                    SELECT COST_SALDOP, COST_SALDOC FROM COSTOS WHERE COST_TIPO = :TIPO AND COST_IDMOV = :ID INTO :COSTO, :EXIST;
                    if (EXIST <> 0) then
                        COSTO = COSTO / EXIST;
                    ELSE
                        COSTO = 0;
                    COSTOSAL = COSTOSAL + (COSTO*CANT);
                    SALIDAS = SALIDAS + CANT;
                    END
            ELSE
                FOR SELECT MVAR_CANT, MVAR_FECHA, MVAR_TIPODOC, MVAR_CONS
                    FROM MOVIMIENTO_ARTICULO
                    WHERE (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA <= :FECFIN) AND (MVAR_TIPODOC <> 13) AND
                    (ARTI_COD = :CODIGO) AND (MVAR_ENTRADA = 'N') AND BODE_COD = :BODEGA
                    INTO :CANT, :FECHA, :TIPO, :ID
                    DO
                    BEGIN
                    SELECT COST_SALDOP, COST_SALDOC FROM COSTOS WHERE COST_TIPO = :TIPO AND COST_IDMOV = :ID INTO :COSTO, :EXIST;
                    if (EXIST <> 0) then
                        COSTO = COSTO / EXIST;
                    ELSE
                        COSTO = 0;
                    COSTOSAL = COSTOSAL + (COSTO*CANT);
                    SALIDAS = SALIDAS + CANT;
                    END
            if (SALIDAS IS NULL) then
              SALIDAS = 0;
            if (COSTOSAL IS NULL) then
              COSTOSAL = 0;
            SALDOFIN = SALDOINI + ENTRADAS - SALIDAS;
            COSTOFIN = COSTOINI + COSTOENT - COSTOSAL;
            if (BODEGA = '') then
                BEGIN
                EXECUTE PROCEDURE SALDO_INICIAL_TOTAL_INV(CODIGO, fecfin+1) returning_values (canfinal);
                EXECUTE PROCEDURE VALOR_INICIAL_INVENTARIO(CODIGO, FECFIN+1) returning_values (cosfinal);
                END
            ELSE
                BEGIN
                EXECUTE PROCEDURE SALDO_INICIAL_INVENTARIO(CODIGO, FECFIN+1, :BODEGA) returning_values (CANFINAL);
                EXECUTE PROCEDURE COSTO_PROMEDIO(CODIGO, FECFIN+1) returning_values (COSFINAL);
                COSFINAL = COSFINAL * CANFINAL;
                END
            SUSPEND;
            END
        ELSE
            BEGIN
            SALDOFIN = SALDOINI;
            COSTOFIN = COSTOINI;
            COSTOENT = 0;
            COSTOSAL = 0;
            FOR SELECT TIDO_NOMCORTO, MVAR_ENTRADA, MVAR_PREF, MVAR_NUMERO, MVAR_CANT, MVAR_COSTO, MVAR_CONC, MVAR_FECHA, M.TERC_NIT, MVAR_CONS, BODE_COD
                FROM MOVIMIENTO_ARTICULO M, TIPO_DOCUMENTO TD
                WHERE TD.TIDO_COD = MVAR_TIPODOC AND (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA <= :FECFIN) AND (MVAR_TIPODOC <> 13) AND (ARTI_COD = :CODIGO)
                ORDER BY MVAR_FECHA, MVAR_CONS
                INTO :TIPODOC, :ENTRADA, :PREFIJO, :NUMERO, :ENTRADAS, :COSTOENT, :CONCEPTO, :FECHA, :NIT, :CONS, :CODBOD
                DO
                    BEGIN
                    if (ENTRADA = 'S') then
                        BEGIN
                        SALIDAS = 0;
                        SALDOFIN = SALDOFIN + ENTRADAS;
                        COSTOFIN = COSTOFIN + (ENTRADAS * COSTOENT);
                        if (SALDOFIN > 0) then
                            COSTOSAL = COSTOFIN / SALDOFIN;
                        end
                    ELSE
                        BEGIN
                        SALIDAS = ENTRADAS;
                        ENTRADAS = 0;
                        if (SALDOFIN > 0) then
                            COSTOENT = COSTOFIN / SALDOFIN;
                        else
                            EXECUTE PROCEDURE COSTO_PROMEDIO(:CODIGO, :FECHA) returning_values (:COSTOENT);
                        SALDOFIN = SALDOFIN - SALIDAS;
                        COSTOFIN = COSTOFIN - (SALIDAS * COSTOENT);
                        if (SALDOFIN > 0) then
                            COSTOSAL = COSTOFIN / SALDOFIN;
                        END
                    SUSPEND;
                    END
            END
        END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE REP_PRODUCTOS(
    ORDEN CHAR(1),
    DESDE VARCHAR(15),
    HASTA VARCHAR(15),
    FECHA DATE)
RETURNS (
    CODIGO VARCHAR(15),
    DESCR VARCHAR(60),
    GRUPCOD VARCHAR(2),
    GRUPNOM VARCHAR(30),
    SUBGCOD VARCHAR(3),
    SUBGNOM VARCHAR(30),
    MARCCOD VARCHAR(3),
    MARCNOM VARCHAR(30),
    ESTADO CHAR(1),
    UNIDAD VARCHAR(8),
    CODCOMP VARCHAR(15),
    DESCOMP VARCHAR(60),
    CANT NUMERIC(18,4),
    UNDCOMP VARCHAR(8),
    CODBARCOMP VARCHAR(15),
    COSTO NUMERIC(18,2),
    TOTAL NUMERIC(18,2))
AS
BEGIN /*$$IBE$$ 
  FOR SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, GRUP_NOM, A.SUBG_COD, A.MARC_COD, A.esar_cod
  FROM ARTICULO A, GRUPO G, estado_articulo E
  WHERE A.GRUP_COD = G.GRUP_COD AND A.ESAR_COD = E.ESAR_COD AND ARTI_COD IN (SELECT DISTINCT ARTI_COD FROM ARTICULOS_PRODUCTO)
  INTO :CODIGO, :DESCR, :unidad, :GRUPCOD, :GRUPNOM, :SUBGCOD, :MARCCOD, :ESTADO
  DO
    if ((ORDEN = 'C' AND CODIGO >= :DESDE AND CODIGO <= :HASTA) OR
        (ORDEN = 'D' AND DESCR >= :DESDE AND DESCR <= :HASTA)) then
        BEGIN
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCCOD INTO MARCNOM;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGCOD AND GRUP_COD = :GRUPCOD INTO :SUBGNOM;
        FOR SELECT ARPR_COMP, ARTI_DES, ARPR_CODBAR, ARPR_CANT, ARPR_UNIDAD
        FROM ARTICULOS_PRODUCTO P, ARTICULO A
        WHERE P.ARTI_COD = :CODIGO AND P.ARPR_COMP = A.ARTI_COD
          INTO :CODCOMP, :DESCOMP, :CODBARCOMP, :CANT, :UNDCOMP
          DO
            begin
            EXECUTE PROCEDURE COSTO_PROMEDIO (:CODCOMP, :FECHA) returning_values (:COSTO);
            EXECUTE PROCEDURE CANTIDAD_POR_FACTOR (:CODCOMP, :CANT, :UNDCOMP) returning_values (:CANT);
            TOTAL = COSTO * CANT;
            SUSPEND;
            END
        END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE REP_UTILIDAD_CLIENTE(
    TIPO INTEGER,
    DETALLE CHAR(1),
    TERINI VARCHAR(20),
    TERFIN VARCHAR(20),
    FECINI DATE,
    FECFIN DATE,
    ARTINI VARCHAR(15),
    ARTFIN VARCHAR(15),
    ORDEN CHAR(1),
    CEROS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    TELEFONO VARCHAR(40),
    CIUDAD VARCHAR(40),
    CODZONA VARCHAR(2),
    NOMZONA VARCHAR(30),
    NOMTIPO VARCHAR(50),
    ARTICULO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    UNIDAD VARCHAR(8),
    CANTIDAD NUMERIC(18,4),
    BASE NUMERIC(18,2),
    IVA NUMERIC(18,2),
    COSTO NUMERIC(18,2),
    UTILIDAD NUMERIC(18,4),
    PORC NUMERIC(9,2),
    TOTAL NUMERIC(18,2),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    DTO NUMERIC(9,2))
AS
DECLARE VARIABLE COSTOUNIT NUMERIC(18,4);
DECLARE VARIABLE CODINI VARCHAR(15);
DECLARE VARIABLE CODFIN VARCHAR(15);
DECLARE VARIABLE DESINI VARCHAR(15);
DECLARE VARIABLE DESFIN VARCHAR(15);
declare variable UOM VARCHAR(20);
declare variable NUMROWS INTEGER;
BEGIN /*$$IBE$$ 
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END
EXECUTE PROCEDURE lee_configuracion ('FACTURACION', 'ARTICULOS', 'SUGERIR PRECIOS CON PORCENTAJE DE MARGEN O UTILIDAD') returning_values (:UOM);
SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPO INTO :NOMTIPO;
if (DETALLE = 'N') then
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
         $$IBE$$*/ /* BORRA LA TABLA AUXILIAR */ /*$$IBE$$ 
        DELETE FROM reportes_aux WHERE REPA_ID = 3 AND REPA_USER = USER;

        FOR SELECT MAX(T.TERC_NIT), MAX(TERC_NOM), MAX(TERC_TEL), MAX(TERC_CIU), MAX(ZONA_COD), MAX(ARTI_COD), SUM(FADE_CANT * FADE_FACTOR), SUM(FACT_FACTOR*(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)),
            SUM(FACT_FACTOR*FADE_IVAMONTO), SUM(FACT_FACTOR*FADE_TOTAL)
            FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P, terceros T, CLIENTES C
            WHERE C.TERC_NIT = T.TERC_NIT AND TERC_CLIE = 'S' AND F.terc_nit = T.terc_nit AND T.TERC_NIT >= :TERINI AND T.TERC_NIT <= :TERFIN AND
            F.FACT_ID = D.FACT_ID AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N'
            AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY T.TERC_NIT, ARTI_COD
            INTO :NIT, :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL
            DO
            BEGIN
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :CODZONA INTO :NOMZONA;
            SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            COSTO = CANTIDAD * COSTOUNIT;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
            else
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (3, USER, :ARTICULO);
            SUSPEND;
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
             $$IBE$$*/ /* agregue los articulos sin factura */ /*$$IBE$$ 
            FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 3 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
         $$IBE$$*/ /* BORRA LA TABLA AUXILIAR */ /*$$IBE$$ 
        DELETE FROM reportes_aux WHERE REPA_ID = 3 AND REPA_USER = USER;

        FOR SELECT MAX(T.TERC_NIT), MAX(TERC_NOM), MAX(TERC_TEL), MAX(TERC_CIU), MAX(ZONA_COD), MAX(ARTI_COD), SUM(RVDE_CANT * RVDE_FACTOR), SUM(RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO), SUM(RVDE_IVAMONTO), SUM(RVDE_TOTAL)
            FROM REMISIONES_VENTA_DETALLE D, REMISIONES_VENTA R, PREFIJOS P, terceros T, CLIENTES C
            WHERE C.TERC_NIT = T.TERC_NIT AND TERC_CLIE = 'S' AND R.terc_nit = T.terc_nit AND T.TERC_NIT >= :TERINI AND T.TERC_NIT <= :TERFIN AND
            R.REVT_ID = D.REVT_ID AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND REVT_ANULADO = 'N'
            AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY T.TERC_NIT, ARTI_COD
            INTO :NIT, :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL
            DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
                if (CANTIDAD IS NULL) then
                    CANTIDAD = 0;
                if (BASE IS NULL) then
                    BASE = 0;
                if (IVA IS NULL) then
                    IVA = 0;
                COSTO = CANTIDAD * COSTOUNIT;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (3, USER, :ARTICULO);
            SUSPEND;
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
             $$IBE$$*/ /* agregue los articulos sin factura */ /*$$IBE$$ 
            FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 3 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
         $$IBE$$*/ /* BORRA LA TABLA AUXILIAR */ /*$$IBE$$ 
        DELETE FROM reportes_aux WHERE REPA_ID = 3 AND REPA_USER = USER;

        FOR SELECT MAX(T.TERC_NIT), MAX(TERC_NOM), MAX(TERC_TEL), MAX(TERC_CIU), MAX(ZONA_COD), MAX(ARTI_COD), SUM(DVDE_CANT * DVDE_FACTOR), SUM(DEVT_FACTOR*(DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)),
            SUM(DEVT_FACTOR*DVDE_IVAMONTO), SUM(DEVT_FACTOR*DVDE_TOTAL)
            FROM devoluciones_ventas_detalle D, DEVOLUCIONES_VENTAS V, PREFIJOS P, terceros T, CLIENTES C
            WHERE C.TERC_NIT = T.TERC_NIT AND TERC_CLIE = 'S' AND V.terc_nit = T.terc_nit AND T.TERC_NIT >= :TERINI AND T.TERC_NIT <= :TERFIN AND
            V.DEVT_ID = D.DEVT_ID AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND DEVT_ANULADO = 'N'
            AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY T.TERC_NIT, ARTI_COD
            INTO :NIT, :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL
            DO
            BEGIN
            SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            COSTO = CANTIDAD * COSTOUNIT;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
            else
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
            TOTAL = TOTAL * -1;
            IVA = IVA * -1;
            BASE = BASE * -1;
            CANTIDAD = CANTIDAD * -1;
            COSTO = COSTO * -1;
            UTILIDAD = UTILIDAD * -1;
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (3, USER, :ARTICULO);
            SUSPEND;
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
             $$IBE$$*/ /* agregue los articulos sin factura */ /*$$IBE$$ 
            FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 3 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
         $$IBE$$*/ /* BORRA LA TABLA AUXILIAR */ /*$$IBE$$ 
        DELETE FROM reportes_aux WHERE REPA_ID = 3 AND REPA_USER = USER;

        FOR SELECT MAX(T.TERC_NIT), MAX(TERC_NOM), MAX(TERC_TEL), MAX(TERC_CIU), MAX(ZONA_COD), MAX(ARTI_COD), SUM(PEDE_CANT * PEDE_FACTOR), SUM(PEDI_FACTOR*(PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)),
            SUM(PEDI_FACTOR*PEDE_IVAMONTO), SUM(PEDI_FACTOR*PEDE_TOTAL)
            FROM PEDIDOS_DETALLE D, PEDIDOS P, PREFIJOS PR, terceros T, CLIENTES C
            WHERE C.TERC_NIT = T.TERC_NIT AND TERC_CLIE = 'S' AND P.terc_nit = T.terc_nit AND T.TERC_NIT >= :TERINI AND T.TERC_NIT <= :TERFIN AND
            P.PEDI_ID = D.PEDI_ID AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND PEDI_ANULADO = 'N'
            AND PR.PREF_PRE = P.PREF_PRE AND P.TIDO_COD = 34 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY T.TERC_NIT, ARTI_COD
            INTO :NIT, :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL
            DO
            BEGIN
            SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            COSTO = CANTIDAD * COSTOUNIT;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
            else
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (3, USER, :ARTICULO);
            SUSPEND;
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
             $$IBE$$*/ /* agregue los articulos sin factura */ /*$$IBE$$ 
            FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 3 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
         $$IBE$$*/ /* BORRA LA TABLA AUXILIAR */ /*$$IBE$$ 
        DELETE FROM reportes_aux WHERE REPA_ID = 3 AND REPA_USER = USER;

        FOR SELECT MAX(T.TERC_NIT), MAX(TERC_NOM), MAX(TERC_TEL), MAX(TERC_CIU), MAX(ZONA_COD), MAX(ARTI_COD), SUM(CTDE_CANT * CTDE_FACTOR), SUM(COTI_FACTOR*(CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)),
            SUM(COTI_FACTOR*CTDE_IVAMONTO), SUM(COTI_FACTOR*CTDE_TOTAL)
            FROM COTIZACIONES_DETALLE D, COTIZACIONES CT, PREFIJOS P, terceros T, CLIENTES C
            WHERE C.TERC_NIT = T.TERC_NIT AND TERC_CLIE = 'S' AND C.terc_nit = T.terc_nit AND T.TERC_NIT >= :TERINI AND T.TERC_NIT <= :TERFIN AND
            CT.COTI_ID = D.COTI_ID AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND COTI_ANULADO = 'N'
            AND P.PREF_PRE = CT.PREF_PRE AND P.TIDO_COD = 35 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY T.TERC_NIT, ARTI_COD
            INTO :NIT, :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL
            DO
            BEGIN
            SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            COSTO = CANTIDAD * COSTOUNIT;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
            else
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (3, USER, :ARTICULO);
            SUSPEND;
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
             $$IBE$$*/ /* agregue los articulos sin factura */ /*$$IBE$$ 
            FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 3 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    END
ELSE
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
            FOR SELECT F.PREF_PRE, FACT_NUMERO, FACT_FECHA, ARTI_COD, FADE_CANT * FADE_FACTOR, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR,
                FADE_IVAMONTO*FACT_FACTOR, FADE_DTOPORC, FADE_TOTAL*FACT_FACTOR, F.terc_nit, F.fact_nomcliente
                FROM FACTURAS F, FACTURAS_DETALLE D, PREFIJOS P
                WHERE F.FACT_ID = D.FACT_ID AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND F.TERC_NIT >= :TERINI AND F.TERC_NIT <= :TERFIN AND FACT_ANULADO = 'N'
                 AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY f.terc_nit, ARTI_COD, FACT_FECHA, F.FACT_ID, FADE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :NIT, :nombre
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                SUSPEND;
                END
            END
    if (BIN_AND(TIPO, 2) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
            FOR SELECT R.PREF_PRE, REVT_NUMERO, REVT_FECHA, ARTI_COD, RVDE_CANT * RVDE_FACTOR,
                (RVDE_TOTAL - RVDE_IVAMONTO), RVDE_IVAMONTO, RVDE_DTOPORC, RVDE_TOTAL, R.terc_nit, R.revt_nomterc
                FROM REMISIONES_VENTA R, REMISIONES_VENTA_DETALLE D, PREFIJOS P
                WHERE R.REVT_ID = D.REVT_ID AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND R.TERC_NIT >= :TERINI AND R.TERC_NIT <= :TERFIN AND REVT_ANULADO = 'N'
                 AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY r.terc_nit, ARTI_COD, REVT_FECHA, R.REVT_ID, RVDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :NIT, :nombre
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                SUSPEND;
                END
            END
    if (BIN_AND(TIPO, 4) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
            FOR SELECT V.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, ARTI_COD, DVDE_CANT * DVDE_FACTOR, (DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR,
                DVDE_IVAMONTO*DEVT_FACTOR, DVDE_DTOPORC, DVDE_TOTAL*DEVT_FACTOR, V.terc_nit, V.devt_nomterc
                FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D, PREFIJOS P
                WHERE V.DEVT_ID = D.DEVT_ID AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND V.TERC_NIT >= :TERINI AND V.TERC_NIT <= :TERFIN AND DEVT_ANULADO = 'N'
                 AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY v.terc_nit, ARTI_COD, DEVT_FECHA, D.DEVT_ID, DVDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :NIT, :nombre
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                TOTAL = TOTAL * -1;
                IVA = IVA * -1;
                BASE = BASE * -1;
                CANTIDAD = CANTIDAD * -1;
                COSTO = COSTO * -1;
                UTILIDAD = UTILIDAD * -1;
                SUSPEND;
                END
            END
    if (BIN_AND(TIPO, 8) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
            FOR SELECT P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, ARTI_COD, PEDE_CANT * PEDE_FACTOR, (PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR,
                PEDE_IVAMONTO*PEDI_FACTOR, PEDE_DTOPORC, PEDE_TOTAL*PEDI_FACTOR, P.terc_nit, P.pedi_nomterc
                FROM PEDIDOS P, PEDIDOS_DETALLE D, PREFIJOS PR
                WHERE P.PEDI_ID = D.PEDI_ID AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND P.TERC_NIT >= :TERINI AND P.TERC_NIT <= :TERFIN AND PEDI_ANULADO = 'N'
                 AND P.PREF_PRE = PR.PREF_PRE AND P.TIDO_COD = 34 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY p.terc_nit, ARTI_COD, PEDI_FECHA, P.PEDI_ID, PEDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :NIT, :nombre
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                SUSPEND;
                END
            END
    if (BIN_AND(TIPO, 16) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
            FOR SELECT C.PREF_PRE, COTI_NUMERO, COTI_FECHA, ARTI_COD, CTDE_CANT * CTDE_FACTOR, (CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR,
                CTDE_IVAMONTO*COTI_FACTOR, CTDE_DTOPORC, CTDE_TOTAL*COTI_FACTOR, C.terc_nit, C.coti_nomterc
                FROM COTIZACIONES C, COTIZACIONES_DETALLE D, PREFIJOS P
                WHERE C.COTI_ID = D.COTI_ID AND ARTI_COD = :ARTICULO AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND C.TERC_NIT >= :TERINI AND C.TERC_NIT <= :TERFIN AND COTI_ANULADO = 'N'
                 AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY c.terc_nit, COTI_FECHA, C.COTI_ID, CTDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :NIT, :nombre
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                SUSPEND;
                END
            END
    END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE REP_UTILIDAD_VENDEDOR(
    TIPO INTEGER,
    DETALLE CHAR(1),
    VENINI VARCHAR(20),
    VENFIN VARCHAR(20),
    FECINI DATE,
    FECFIN DATE,
    ARTINI VARCHAR(15),
    ARTFIN VARCHAR(15),
    ORDEN CHAR(1),
    CEROS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    CODVEND VARCHAR(20),
    NOMVEND VARCHAR(60),
    NOMTIPO VARCHAR(50),
    ARTICULO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    UNIDAD VARCHAR(8),
    CANTIDAD NUMERIC(18,4),
    BASE NUMERIC(18,2),
    IVA NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    COSTO NUMERIC(18,2),
    UTILIDAD NUMERIC(18,4),
    PORC NUMERIC(9,2),
    TOTAL NUMERIC(18,2),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    DTO NUMERIC(9,2))
AS
DECLARE VARIABLE COSTOUNIT NUMERIC(18,4);
DECLARE VARIABLE CODINI VARCHAR(15);
DECLARE VARIABLE CODFIN VARCHAR(15);
DECLARE VARIABLE DESINI VARCHAR(15);
DECLARE VARIABLE DESFIN VARCHAR(15);
declare variable UOM VARCHAR(20);
BEGIN /*$$IBE$$ 
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION', 'ARTICULOS', 'SUGERIR PRECIOS CON PORCENTAJE DE MARGEN O UTILIDAD') returning_values (:UOM);
  SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPO INTO :NOMTIPO;
  FOR select VEND_COD, VEND_NOMBRE
    from VENDEDORES
    where VEND_COD >= :VENINI AND VEND_COD <= :VENFIN
    INTO :CODVEND, :NOMVEND
    DO  
    BEGIN
    if (DETALLE = 'N') then
        BEGIN
        if (BIN_AND(TIPO, 1) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
             $$IBE$$*/ /* BORRA LA TABLA AUXILIAR */ /*$$IBE$$ 
            DELETE FROM reportes_aux WHERE REPA_ID = 4 AND REPA_USER = USER;
            FOR SELECT MAX(ARTI_COD), SUM(FADE_CANT * FADE_FACTOR), SUM(FACT_FACTOR*(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)),
                SUM(FACT_FACTOR*FADE_IVAMONTO), SUM(FACT_FACTOR*FADE_TOTAL), SUM(FADE_CONSUMO)
                FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P
                WHERE F.FACT_ID = D.FACT_ID AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND FACT_ANULADO = 'N'
                 AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                GROUP BY ARTI_COD
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
                if (CANTIDAD IS NULL) then
                    CANTIDAD = 0;
                if (BASE IS NULL) then
                    BASE = 0;
                if (IVA IS NULL) then
                    IVA = 0;
                COSTO = CANTIDAD * COSTOUNIT;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    begin
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                    SUSPEND;
                    end
                ELSE
                    if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                        SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                 $$IBE$$*/ /* agregue los articulos sin factura */ /*$$IBE$$ 
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 2) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
            FOR SELECT MAX(ARTI_COD), SUM(RVDE_CANT * RVDE_FACTOR), SUM(RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO), SUM(RVDE_IVAMONTO), SUM(RVDE_TOTAL), SUM(RVDE_CONSUMO)
                FROM REMISIONES_VENTA_DETALLE D, REMISIONES_VENTA R, PREFIJOS P
                WHERE R.REVT_ID = D.REVT_ID AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND REVT_ANULADO = 'N'
                 AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                GROUP BY ARTI_COD
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
                if (CANTIDAD IS NULL) then
                    CANTIDAD = 0;
                if (BASE IS NULL) then
                    BASE = 0;
                if (IVA IS NULL) then
                    IVA = 0;
                COSTO = CANTIDAD * COSTOUNIT;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    begin
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                    SUSPEND;
                    end
                ELSE
                    if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                        SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                 $$IBE$$*/ /* agregue los articulos sin factura */ /*$$IBE$$ 
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 4) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
            FOR SELECT MAX(ARTI_COD), SUM(DVDE_CANT * DVDE_FACTOR), SUM(DEVT_FACTOR*(DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)),
                SUM(DEVT_FACTOR*DVDE_IVAMONTO), SUM(DEVT_FACTOR*DVDE_TOTAL), SUM(DVDE_CONSUMO)
                FROM devoluciones_ventas_detalle D, DEVOLUCIONES_VENTAS V, PREFIJOS P
                WHERE V.DEVT_ID = D.DEVT_ID AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND DEVT_ANULADO = 'N'
                 AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                GROUP BY ARTI_COD
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
                if (CANTIDAD IS NULL) then
                    CANTIDAD = 0;
                if (BASE IS NULL) then
                    BASE = 0;
                if (IVA IS NULL) then
                    IVA = 0;
                COSTO = CANTIDAD * COSTOUNIT;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                TOTAL = TOTAL * -1;
                IVA = IVA * -1;
                BASE = BASE * -1;
                CANTIDAD = CANTIDAD * -1;
                COSTO = COSTO * -1;
                UTILIDAD = UTILIDAD * -1;
                if (CEROS = 'S') then
                    begin
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                    SUSPEND;
                    end
                ELSE
                    if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                        SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                 $$IBE$$*/ /* agregue los articulos sin factura */ /*$$IBE$$ 
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 8) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
            FOR SELECT MAX(ARTI_COD), SUM(PEDE_CANT * PEDE_FACTOR), SUM(PEDI_FACTOR*(PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)),
                SUM(PEDI_FACTOR*PEDE_IVAMONTO), SUM(PEDI_FACTOR*PEDE_TOTAL), SUM(PEDE_CONSUMO)
                FROM PEDIDOS_DETALLE D, PEDIDOS P, PREFIJOS PR
                WHERE P.PEDI_ID = D.PEDI_ID AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND PEDI_ANULADO = 'N'
                 AND PR.PREF_PRE = P.PREF_PRE AND P.TIDO_COD = 34 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                GROUP BY ARTI_COD
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
                if (CANTIDAD IS NULL) then
                    CANTIDAD = 0;
                if (BASE IS NULL) then
                    BASE = 0;
                if (IVA IS NULL) then
                    IVA = 0;
                COSTO = CANTIDAD * COSTOUNIT;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    begin
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                    SUSPEND;
                    end
                ELSE
                    if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                        SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                 $$IBE$$*/ /* agregue los articulos sin factura */ /*$$IBE$$ 
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 16) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
            FOR SELECT MAX(ARTI_COD), SUM(CTDE_CANT * CTDE_FACTOR), SUM(COTI_FACTOR*(CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)),
                SUM(COTI_FACTOR*CTDE_IVAMONTO), SUM(COTI_FACTOR*CTDE_TOTAL), SUM(CTDE_CONSUMO)
                FROM COTIZACIONES_DETALLE D, COTIZACIONES C, PREFIJOS P
                WHERE C.COTI_ID = D.COTI_ID AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND COTI_ANULADO = 'N'
                 AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                GROUP BY ARTI_COD
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
                if (CANTIDAD IS NULL) then
                    CANTIDAD = 0;
                if (BASE IS NULL) then
                    BASE = 0;
                if (IVA IS NULL) then
                    IVA = 0;
                COSTO = CANTIDAD * COSTOUNIT;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    begin
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                    SUSPEND;
                    end
                ELSE
                    if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                        SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                 $$IBE$$*/ /* agregue los articulos sin factura */ /*$$IBE$$ 
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    ELSE
        BEGIN
        if (BIN_AND(TIPO, 1) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
            FOR SELECT F.PREF_PRE, FACT_NUMERO, FACT_FECHA, ARTI_COD, FADE_CANT * FADE_FACTOR, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR,
                FADE_IVAMONTO*FACT_FACTOR, FADE_DTOPORC, FADE_TOTAL*FACT_FACTOR, FADE_CONSUMO
                FROM FACTURAS F, FACTURAS_DETALLE D, PREFIJOS P
                WHERE F.FACT_ID = D.FACT_ID AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND FACT_ANULADO = 'N'
                 AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY ARTI_COD, FACT_FECHA, F.FACT_ID, FADE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                 $$IBE$$*/ /* agregue los articulos sin factura */ /*$$IBE$$ 
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 2) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
            FOR SELECT R.PREF_PRE, REVT_NUMERO, REVT_FECHA, ARTI_COD, RVDE_CANT * RVDE_FACTOR, (RVDE_TOTAL - RVDE_IVAMONTO), RVDE_IVAMONTO, RVDE_DTOPORC, RVDE_TOTAL, RVDE_CONSUMO
                FROM REMISIONES_VENTA R, REMISIONES_VENTA_DETALLE D, PREFIJOS P
                WHERE R.REVT_ID = D.REVT_ID AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND REVT_ANULADO = 'N'
                 AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY ARTI_COD, REVT_FECHA, R.REVT_ID, RVDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                 $$IBE$$*/ /* agregue los articulos sin factura */ /*$$IBE$$ 
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 4) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
            FOR SELECT V.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, ARTI_COD, DVDE_CANT * DVDE_FACTOR, (DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR,
                DVDE_IVAMONTO*DEVT_FACTOR, DVDE_DTOPORC, DVDE_TOTAL*DEVT_FACTOR, DVDE_CONSUMO
                FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D, PREFIJOS P
                WHERE V.DEVT_ID = D.DEVT_ID AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND DEVT_ANULADO = 'N'
                 AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY ARTI_COD, DEVT_FECHA, D.DEVT_ID, DVDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                TOTAL = TOTAL * -1;
                IVA = IVA * -1;
                BASE = BASE * -1;
                CANTIDAD = CANTIDAD * -1;
                COSTO = COSTO * -1;
                UTILIDAD = UTILIDAD * -1;
                if (CEROS = 'S') then
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                 $$IBE$$*/ /* agregue los articulos sin factura */ /*$$IBE$$ 
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 8) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
            FOR SELECT P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, ARTI_COD, PEDE_CANT * PEDE_FACTOR, (PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR,
                PEDE_IVAMONTO*PEDI_FACTOR, PEDE_DTOPORC, PEDE_TOTAL*PEDI_FACTOR, PEDE_CONSUMO
                FROM PEDIDOS P, PEDIDOS_DETALLE D, PREFIJOS PR
                WHERE P.PEDI_ID = D.PEDI_ID AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND PEDI_ANULADO = 'N'
                 AND P.PREF_PRE = PR.PREF_PRE AND P.TIDO_COD = 34 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY ARTI_COD, PEDI_FECHA, P.PEDI_ID, PEDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                 $$IBE$$*/ /* agregue los articulos sin factura */ /*$$IBE$$ 
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 16) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
            FOR SELECT C.PREF_PRE, COTI_NUMERO, COTI_FECHA, ARTI_COD, CTDE_CANT * CTDE_FACTOR, (CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR,
                CTDE_IVAMONTO*COTI_FACTOR, CTDE_DTOPORC, CTDE_TOTAL*COTI_FACTOR, CTDE_CONSUMO
                FROM COTIZACIONES C, COTIZACIONES_DETALLE D, PREFIJOS P
                WHERE C.COTI_ID = D.COTI_ID AND ARTI_COD = :ARTICULO AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND COTI_ANULADO = 'N'
                 AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY COTI_FECHA, C.COTI_ID, CTDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                 $$IBE$$*/ /* agregue los articulos sin factura */ /*$$IBE$$ 
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE REP_UTILIDAD_VENTAS(
    TIPO INTEGER,
    DETALLE CHAR(1),
    FECINI DATE,
    FECFIN DATE,
    ARTINI VARCHAR(15),
    ARTFIN VARCHAR(15),
    GRPINI VARCHAR(3),
    GRPFIN VARCHAR(3),
    ORDEN CHAR(1),
    AGRUPA CHAR(1),
    CEROS CHAR(1),
    EQUILIBRIO CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    ARTICULO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    UNIDAD VARCHAR(8),
    CANTIDAD NUMERIC(18,4),
    BASE NUMERIC(18,4),
    COSTO NUMERIC(18,4),
    UTILIDAD NUMERIC(18,4),
    PORC NUMERIC(9,2),
    IVA NUMERIC(18,4),
    CONSUMO NUMERIC(18,4),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    TIPODOC INTEGER)
AS
DECLARE VARIABLE COSTOUNIT NUMERIC(18,4);
declare variable CODINI VARCHAR(15);
declare variable CODFIN VARCHAR(15);
declare variable DESINI VARCHAR(15);
declare variable DESFIN VARCHAR(15);
declare variable MARINI VARCHAR(3);
declare variable MARFIN VARCHAR(3);
declare variable UOM VARCHAR(20);
declare variable NUMROWS INTEGER;
declare variable TOTAL NUMERIC(18,2);
declare variable CUENTA VARCHAR(20);
declare variable SECC INTEGER;
declare variable DB CHAR(1);
declare variable FECCNT VARCHAR(8);
declare variable FIJOS NUMERIC(18,2);
declare variable VARIA NUMERIC(18,2);
declare variable SALDO NUMERIC(18,2);
BEGIN /*$$IBE$$ 
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END
if (AGRUPA = 'G') then
    BEGIN
    MARINI = '';
    MARFIN = 'zz';
    END
ELSE
    if (AGRUPA = 'M') then
        BEGIN
        MARINI = GRPINI;
        MARFIN = GRPFIN;
        GRPINI = '';
        GRPFIN = 'zz';
        END
    ELSE
        BEGIN
        MARINI = '';
        MARFIN = 'zz';
        GRPINI = '';
        GRPFIN = 'zz';
        END
EXECUTE PROCEDURE lee_configuracion ('FACTURACION', 'ARTICULOS', 'SUGERIR PRECIOS CON PORCENTAJE DE MARGEN O UTILIDAD') returning_values (:UOM);
if (DETALLE = 'N') then
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        TIPODOC = 31;
         $$IBE$$*/ /* BORRA LA TABLA AUXILIAR */ /*$$IBE$$ 
        DELETE FROM reportes_aux WHERE REPA_ID = 2 AND REPA_USER = USER;
        if (EQUILIBRIO = 'S') then
            BEGIN
            SELECT SUM((FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR)
                FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P
                WHERE F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND 
                FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND
                FACT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                INTO :TOTAL;

            execute PROCEDURE fecha_a_conta (:FECFIN) returning_values (:FECCNT);
            FIJOS = 0;
            FOR SELECT PTEQ_CUENTA, PTEQ_DB FROM PUNTO_EQUILIBRIO WHERE PTEQ_SECC = 1 INTO :CUENTA, :DB
                DO
                BEGIN
                 $$IBE$$*/ /* CALCULE EL SALDO DE LA CUENTA */ /*$$IBE$$ 
                EXECUTE PROCEDURE saldo_cuenta (CUENTA, :FECCNT) returning_values (:SALDO);
                if (DB = 'S') then
                    FIJOS = FIJOS + SALDO;
                ELSE
                    FIJOS = FIJOS - SALDO;
                END
            VARIA = 0;
            FOR SELECT PTEQ_CUENTA, PTEQ_DB FROM PUNTO_EQUILIBRIO WHERE PTEQ_SECC = 2 INTO :CUENTA, :DB
                DO
                BEGIN
                 $$IBE$$*/ /* CALCULE EL SALDO DE LA CUENTA */ /*$$IBE$$ 
                EXECUTE PROCEDURE saldo_cuenta (CUENTA, :FECCNT) returning_values (:SALDO);
                if (DB = 'S') then
                    VARIA = VARIA + SALDO;
                ELSE
                    VARIA = VARIA - SALDO;
                END
            END

        FOR SELECT MAX(D.ARTI_COD), SUM(FADE_CANT * FADE_FACTOR), SUM((FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR), SUM(FADE_IVAMONTO*FACT_FACTOR), SUM(FADE_CONSUMO),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), SUM(COST_SALP)
            FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P, ARTICULO A, movimiento_articulo m, costos c
            WHERE F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND D.ARTI_COD = A.arti_cod AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            F.fact_id = M.mvar_idref AND M.mvar_tipodoc = 31 AND M.mvar_item = D.fade_item AND M.mvar_cons = C.cost_idmov AND
            FACT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY D.ARTI_COD
            INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :COSTO
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
 $$IBE$$*/ /*            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);*/ /*$$IBE$$ 
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
 $$IBE$$*/ /*            COSTO = cantidad * COSTOUNIT;*/ /*$$IBE$$ 
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (2, USER, :ARTICULO);
            SUSPEND;
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
             $$IBE$$*/ /* agregue los articulos sin factura */ /*$$IBE$$ 
            FOR SELECT ARTI_COD, 0, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND
                    A.ARTI_DES <= :DESFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND
                    (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN)))
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,:DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 2 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        TIPODOC = 32;
         $$IBE$$*/ /* BORRA LA TABLA AUXILIAR */ /*$$IBE$$ 
        DELETE FROM reportes_aux WHERE REPA_ID = 2 AND REPA_USER = USER;

        FOR SELECT MAX(D.ARTI_COD), SUM(RVDE_CANT * RVDE_FACTOR), SUM(RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO), SUM(RVDE_IVAMONTO), SUM(RVDE_CONSUMO),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), SUM(COST_SALP)
            FROM REMISIONES_VENTA_DETALLE D, REMISIONES_VENTA R, PREFIJOS P, ARTICULO A, movimiento_articulo m, costos c
            WHERE R.REVT_ID = D.REVT_ID AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND D.ARTI_COD = A.arti_cod AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            R.revt_id = M.mvar_idref AND M.mvar_tipodoc = 32 AND M.mvar_item = D.rvde_item AND M.mvar_cons = C.cost_idmov AND
            REVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY D.ARTI_COD
            INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :COSTO
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
 $$IBE$$*/ /*            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT); */
/*            COSTO = cantidad * COSTOUNIT;*/ /*$$IBE$$ 
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (2, USER, :ARTICULO);
            SUSPEND;
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
             $$IBE$$*/ /* agregue los articulos sin factura */ /*$$IBE$$ 
            FOR SELECT ARTI_COD, 0, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND
                    A.ARTI_DES <= :DESFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND
                    (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN)))
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,:DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 2 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        TIPODOC = 33;
         $$IBE$$*/ /* BORRA LA TABLA AUXILIAR */ /*$$IBE$$ 
        DELETE FROM reportes_aux WHERE REPA_ID = 2 AND REPA_USER = USER;

        FOR SELECT MAX(D.ARTI_COD), SUM(DVDE_CANT * DVDE_FACTOR), SUM((DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR), SUM(DVDE_IVAMONTO*DEVT_FACTOR), SUM(DVDE_CONSUMO),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), SUM(COST_ENTP)
            FROM devoluciones_ventas_detalle D, DEVOLUCIONES_VENTAS V, PREFIJOS P, ARTICULO A, MOVIMIENTO_ARTICULO M, COSTOS C
            WHERE V.DEVT_ID = D.DEVT_ID AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND D.ARTI_COD = A.arti_cod AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            V.devt_id = M.mvar_idref AND M.mvar_tipodoc = 33 AND M.mvar_item = D.dvde_item AND M.mvar_cons = C.cost_idmov AND
            DEVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY D.ARTI_COD
            INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :COSTO
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            else
                CANTIDAD = CANTIDAD * -1;
            if (BASE IS NULL) then
                BASE = 0;
            else
                BASE = BASE * -1;
            if (IVA IS NULL) then
                IVA = 0;
            else
                IVA = IVA * -1;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            else
                CONSUMO = CONSUMO * -1;
 $$IBE$$*/ /*            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);*/
/*            COSTO = cantidad * COSTOUNIT;*/ /*$$IBE$$ 
            COSTO = costo * -1;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (2, USER, :ARTICULO);
            SUSPEND;
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
             $$IBE$$*/ /* agregue los articulos sin factura */ /*$$IBE$$ 
            FOR SELECT ARTI_COD, 0, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND
                    A.ARTI_DES <= :DESFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND
                    (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN)))
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,:DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 2 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        TIPODOC = 34;
         $$IBE$$*/ /* BORRA LA TABLA AUXILIAR */ /*$$IBE$$ 
        DELETE FROM reportes_aux WHERE REPA_ID = 2 AND REPA_USER = USER;

        FOR SELECT MAX(D.ARTI_COD), SUM(PEDE_CANT * PEDE_FACTOR), SUM((PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR), SUM(PEDE_IVAMONTO*PEDI_FACTOR), SUM(PEDE_CONSUMO),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM PEDIDOS_DETALLE D, PEDIDOS P, PREFIJOS R, ARTICULO A
            WHERE P.PEDI_ID = D.PEDI_ID AND P.PREF_PRE = R.PREF_PRE AND R.TIDO_COD = 34 AND D.ARTI_COD = A.arti_cod AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            PEDI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY D.ARTI_COD
            INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
            COSTO = cantidad * COSTOUNIT;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (2, USER, :ARTICULO);
            SUSPEND;
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
             $$IBE$$*/ /* agregue los articulos sin factura */ /*$$IBE$$ 
            FOR SELECT ARTI_COD, 0, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND
                    A.ARTI_DES <= :DESFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND
                    (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN)))
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,:DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 2 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        TIPODOC = 35;
         $$IBE$$*/ /* BORRA LA TABLA AUXILIAR */ /*$$IBE$$ 
        DELETE FROM reportes_aux WHERE REPA_ID = 2 AND REPA_USER = USER;

        FOR SELECT MAX(D.ARTI_COD), SUM(CTDE_CANT * CTDE_FACTOR), SUM((CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR), SUM(CTDE_IVAMONTO), SUM(CTDE_CONSUMO),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM COTIZACIONES_DETALLE D, COTIZACIONES C, PREFIJOS P, ARTICULO A
            WHERE C.COTI_ID = D.COTI_ID AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND D.ARTI_COD = A.arti_cod AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            COTI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY D.ARTI_COD
            INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
            COSTO = cantidad * COSTOUNIT;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (2, USER, :ARTICULO);
            SUSPEND;
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
             $$IBE$$*/ /* agregue los articulos sin factura */ /*$$IBE$$ 
            FOR SELECT ARTI_COD, 0, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND
                    A.ARTI_DES <= :DESFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND
                    (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN)))
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,:DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 2 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    END
ELSE
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        TIPODOC = 31;
        FOR SELECT F.PREF_PRE, FACT_NUMERO, FACT_FECHA, D.ARTI_COD, FADE_CANT * FADE_FACTOR, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR, FADE_IVAMONTO*FACT_FACTOR, FADE_CONSUMO,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, COST_SALP
            FROM FACTURAS F, FACTURAS_DETALLE D, PREFIJOS P, ARTICULO A, MOVIMIENTO_ARTICULO M, COSTOS C
            WHERE F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND D.ARTI_COD = A.arti_cod AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND FACT_FECHA >= :FECINI AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                F.fact_id = M.mvar_idref AND M.mvar_tipodoc = 31 AND M.mvar_item = D.fade_item AND M.mvar_cons = C.cost_idmov AND
                FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY D.ARTI_COD, FACT_FECHA, F.FACT_ID, FADE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :COSTO
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
 $$IBE$$*/ /*            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);*/
/*            COSTO = COSTOUNIT * CANTIDAD;*/ /*$$IBE$$ 
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        TIPODOC = 32;
        FOR SELECT R.PREF_PRE, REVT_NUMERO, REVT_FECHA, D.ARTI_COD, RVDE_CANT * RVDE_FACTOR, RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO, RVDE_IVAMONTO, RVDE_CONSUMO,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, COST_SALP
            FROM REMISIONES_VENTA R, REMISIONES_VENTA_DETALLE D, PREFIJOS P, ARTICULO A, MOVIMIENTO_ARTICULO M, COSTOS C
            WHERE R.REVT_ID = D.REVT_ID AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND D.ARTI_COD = A.arti_cod AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND
                R.revt_id = M.mvar_idref AND M.mvar_tipodoc = 32 AND M.mvar_item = D.rvde_item AND M.mvar_cons = C.cost_idmov AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                REVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY D.ARTI_COD, REVT_FECHA, R.REVT_ID, RVDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :COSTO
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
            COSTO = COSTOUNIT * CANTIDAD;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        TIPODOC = 33;
        FOR SELECT V.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, D.ARTI_COD, DVDE_CANT * DVDE_FACTOR, (DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR, DVDE_IVAMONTO*DEVT_FACTOR, DVDE_CONSUMO,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, COST_ENTP
            FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D, PREFIJOS P, ARTICULO A, MOVIMIENTO_ARTICULO M, COSTOS C
            WHERE V.DEVT_ID = D.DEVT_ID AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND D.ARTI_COD = A.arti_cod AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                V.devt_id = M.mvar_idref AND M.mvar_tipodoc = 33 AND M.mvar_item = D.dvde_item AND M.mvar_cons = C.cost_idmov AND
                DEVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY D.ARTI_COD, DEVT_FECHA, V.DEVT_ID, DVDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :COSTO
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
            BASE = BASE * -1;
            CANTIDAD = CANTIDAD * -1;
            IVA = IVA * -1;
            CONSUMO = CONSUMO * -1;
            COSTO = COSTOUNIT * CANTIDAD;
            COSTO = COSTO * -1;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        TIPODOC = 34;
        FOR SELECT P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, D.ARTI_COD, PEDE_CANT * PEDE_FACTOR, (PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR, PEDE_IVAMONTO*PEDI_FACTOR, PEDE_CONSUMO,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD 
            FROM PEDIDOS P, PEDIDOS_DETALLE D, PREFIJOS R, ARTICULO A
            WHERE P.PEDI_ID = D.PEDI_ID AND P.PREF_PRE = R.PREF_PRE AND R.TIDO_COD = 34 AND D.ARTI_COD = A.arti_cod AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                PEDI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY D.ARTI_COD, PEDI_FECHA, P.PEDI_ID, PEDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
            COSTO = COSTOUNIT * CANTIDAD;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        TIPODOC = 35;
        FOR SELECT C.PREF_PRE, COTI_NUMERO, COTI_FECHA, D.ARTI_COD, CTDE_CANT * CTDE_FACTOR, (CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR, CTDE_IVAMONTO*COTI_FACTOR, CTDE_CONSUMO,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD 
            FROM COTIZACIONES C, COTIZACIONES_DETALLE D, PREFIJOS P, ARTICULO A
            WHERE C.COTI_ID = D.COTI_ID AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND D.ARTI_COD = A.arti_cod AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                COTI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY D.ARTI_COD, COTI_FECHA, C.COTI_ID, CTDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
            COSTO = COSTOUNIT * CANTIDAD;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            SUSPEND;
            END
        END
    END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE RESERVAS_ARTICULO(
    FECHA DATE,
    DETALLE CHAR(1))
RETURNS (
    CODIGO VARCHAR(15),
    NOMBRE VARCHAR(60),
    RESERVA NUMERIC(18,4),
    EXIST NUMERIC(18,2),
    FALTANTE NUMERIC(18,2),
    COSTO NUMERIC(18,2),
    UNIDAD VARCHAR(8),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    COSTOTOT NUMERIC(18,2),
    CLIENTE VARCHAR(60),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHADOC DATE)
AS
declare variable PEDIDO NUMERIC(18,4);
declare variable ID INTEGER;
declare variable ITEM INTEGER;
declare variable UND VARCHAR(8);
declare variable FACTOR NUMERIC(18,4);
declare variable FACT NUMERIC(18,4);
declare variable CANT NUMERIC(18,4);
declare variable PEDAUTO CHAR(2);
BEGIN /*$$IBE$$ 
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'FACTURAS', 'GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') returning_values (pedauto);
  FOR
    SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD
      FROM ARTICULO A
      INTO :CODIGO, :NOMBRE, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
      DO
        BEGIN
        NOMMARC = '';
        NOMSUBG = '';
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
        EXECUTE PROCEDURE SALDO_TOTAL_INVENTARIO(CODIGO, FECHA) returning_values (EXIST);
        if (DETALLE = 'N') then
            BEGIN
            EXECUTE PROCEDURE COSTO_PROMEDIO(CODIGO, FECHA) returning_values (COSTO);
            SELECT SUM(RSDE_LIBERAR) FROM RESERVAS R, RESERVAS_DETALLE RD
                WHERE R.RESE_ID = RD.RESE_ID AND RD.ARTI_COD = :CODIGO AND RESE_FECHA <= :FECHA AND RESE_VENCE > :FECHA AND RESE_ANULADO = 'N'
                INTO :RESERVA;
            if (RESERVA IS NULL) then
                RESERVA = 0;
            FOR SELECT P.PEDI_ID, PEDE_ITEM, PEDE_CANT * PEDE_FACTOR
                FROM PEDIDOS P, PEDIDOS_DETALLE D
                WHERE P.PEDI_ID = D.PEDI_ID AND D.ARTI_COD = :CODIGO AND (PEDI_FECHA+PEDI_VALIDEZ) >= :FECHA AND PEDI_FECHA <= :FECHA AND PEDI_ANULADO = 'N'
                INTO :ID, :item, :CANT
                DO
                BEGIN
                EXECUTE PROCEDURE FALTANTE(34, 31, ID, ITEM) returning_values (PEDIDO, UND, FACT);
                if (PEDIDO * FACT = CANT) then
                    EXECUTE PROCEDURE FALTANTE(34, 32, ID, ITEM) returning_values (PEDIDO, UND, FACT);
                if (PEDIDO IS NULL) then
                    PEDIDO = 0;
                RESERVA = RESERVA + PEDIDO;
                END
            if (RESERVA > EXIST) then
                FALTANTE = RESERVA - EXIST;
            ELSE
                FALTANTE = 0;
            COSTOTOT = RESERVA * COSTO;
            if (RESERVA > 0) then
                SUSPEND;
            END
        ELSE
            BEGIN
            FOR SELECT RESE_FECHA, PREF_PRE, RESE_NUMERO, RESE_NOMTERC, RDSE_CANT, RSDE_UNIDAD, RSDE_LIBERAR
                FROM RESERVAS R, RESERVAS_DETALLE RD
                WHERE R.RESE_ID = RD.RESE_ID AND RD.ARTI_COD = :CODIGO AND RESE_FECHA <= :FECHA AND RESE_VENCE > :FECHA AND RESE_ANULADO = 'N'
                INTO :FECHADOC, :PREFIJO, :NUMERO, :CLIENTE, :RESERVA, :UNIDAD, :FALTANTE
                DO
                BEGIN
                if (RESERVA > EXIST) then
                    FALTANTE = RESERVA - EXIST;
                ELSE
                    FALTANTE = 0;
                COSTOTOT = RESERVA * COSTO;
                SUSPEND;
                END
            FOR SELECT P.PEDI_ID, PEDE_ITEM, PEDI_FECHA, PREF_PRE, PEDI_NUMERO, PEDI_NOMTERC, PEDE_CANT, PEDE_UNIDAD, PEDE_RESERVA, PEDE_FACTOR
                FROM PEDIDOS P, PEDIDOS_DETALLE PD
                WHERE P.PEDI_ID = PD.PEDI_ID AND PD.ARTI_COD = :CODIGO AND PEDI_FECHA <= :FECHA AND (PEDI_FECHA+PEDI_VALIDEZ) >= :FECHA AND PEDI_ANULADO = 'N'
                INTO :ID, :ITEM, :FECHADOC, :PREFIJO, :NUMERO, :CLIENTE, :CANT, :UNIDAD, :FALTANTE, :FACTOR
                DO
                BEGIN
                EXECUTE PROCEDURE FALTANTE(34, 31, ID, ITEM) returning_values (RESERVA, UND, FACT);
                if ((RESERVA * FACT = CANT * FACTOR) or (PEDAUTO = 'SI')) then
                    EXECUTE PROCEDURE FALTANTE(34, 31, ID, ITEM) returning_values (RESERVA, UND, FACTOR);
                if (RESERVA IS NULL) then
                    RESERVA = 0;
                if (RESERVA > 0) then
                    BEGIN
                    if (RESERVA > EXIST) then
                        FALTANTE = RESERVA - EXIST;
                    ELSE
                        FALTANTE = 0;
                    COSTOTOT = RESERVA * COSTO;
                    SUSPEND;
                    END
                END
            END
        END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE REVISA_PRECIOS(
    LISTA INTEGER,
    FECHA DATE)
RETURNS (
    ARTICULO VARCHAR(20),
    DESCR VARCHAR(60),
    FIJO NUMERIC(18,2),
    UNIDAD VARCHAR(8),
    PORC NUMERIC(9,4),
    SUGERIDO NUMERIC(18,2),
    DIFER NUMERIC(18,2),
    NUEVO NUMERIC(18,2),
    OK CHAR(1))
AS
declare variable marg numeric(9,4);
declare variable UOM VARCHAR(10);
declare variable BASE VARCHAR(10);
declare variable CAMBIO VARCHAR(10);
declare variable COSTO numeric(18,2);
declare variable COSTOP numeric(18,2);
declare variable COSTOU numeric(18,2);
declare variable DIFMAX numeric(18,2);
declare variable DIG INTEGER;
declare variable TARIVA NUMERIC(9,4);
declare variable IVAINC CHAR(1);
declare variable LISTAREF INTEGER;
begin /*$$IBE$$ 
execute procedure lee_configuracion ('FACTURACION', 'ARTICULOS', 'SUGERIR PRECIOS CON PORCENTAJE DE MARGEN O UTILIDAD') returning_values (:UOM);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'ARTICULOS', 'REDONDEO AL MULTIPLO DE DIEZ EN PRECIOS') RETURNING_VALUES (:DIG);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','CAMBIO DE PRECIOS AUTOMATICO AL CAMBIAR COSTO O PRECIO') returning_values (CAMBIO);
EXECUTE PROCEDURE lee_configuracion('FACTURACION','ARTICULOS','COSTO BASE PARA CALCULO DE PRECIOS DE VENTA AUTOMATICOS') returning_values (:BASE);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','CODIGO DE LA LISTA DE PRECIOS BASE PARA CAMBIO DE PRECIOS AUTOMATICO') returning_values (LISTAREF);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','DIFERENCIA EN PESOS MAXIMA A PERMITIR PARA CAMBIAR PRECIOS') returning_values (DIFMAX);
for select A.arti_cod, A.arti_des, A.arti_unidad, prar_fijo, prar_margen, prar_util, TAIV_PORC
    from precios_articulo p, articulo a, tarifa_iva T
    where a.arti_cod = p.arti_cod and lipr_cod = :lista and a.taiv_cod = t.taiv_cod order by A.arti_cod
    into :articulo, descr, :unidad, :fijo, :marg, :porc, :tariva
    do
    begin
    if (UOM <> 'UTILIDAD') then
        PORC = MARG;
    if (CAMBIO = 'COSTO') then
        BEGIN
        EXECUTE PROCEDURE COSTO_PROMEDIO (:ARTICULO, :FECHA) RETURNING_VALUES(:COSTOP);
        EXECUTE PROCEDURE ULTIMO_COSTO (:ARTICULO, :FECHA, :UNIDAD) RETURNING_VALUES(:COSTOU);
        if (base = 'ULTIMO') then
            COSTO = COSTOU;
        ELSE
            BEGIN
            COSTO = COSTOP;
            if (base = 'MAYOR') then
                if (COSTOP < COSTOU) then
                    COSTO = COSTOU;
            END
        SELECT LIPR_MODIF FROM LISTA_PRECIOS WHERE LIPR_COD = :lista INTO :IVAINC;
        if (IVAINC = 'S') then
            COSTO = COSTO * (1 + TARIVA/100);
        if (UOM = 'UTILIDAD') then
            SUGERIDO = COSTO * (1 + :PORC/100);
        ELSE
            SUGERIDO = COSTO / (1 - :PORC/100);
        END
    ELSE
        if (LISTA <> LISTAREF) then
            BEGIN
            SELECT PRAR_FIJO FROM PRECIOS_ARTICULO WHERE ARTI_COD = :articulo AND LIPR_COD = :LISTAREF INTO :SUGERIDO;
            if (IVAINC = 'S') then
                SUGERIDO = SUGERIDO / (1 + TARIVA/100);
            if (UOM = 'UTILIDAD') then
                SUGERIDO = SUGERIDO * (1 + :PORC/100);
            ELSE
                SUGERIDO = SUGERIDO / (1 - :PORC/100);
            END
    EXECUTE PROCEDURE REDONDEE (SUGERIDO, DIG) returning_values (SUGERIDO);
    DIFER = SUGERIDO - FIJO;
    NUEVO = SUGERIDO;
    OK = 'S';
    if ((DIFER > DIFMAX) and (sugerido <> 0)) then
        suspend;
    end
 $$IBE$$*/ SUSPEND;
end
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE UTILIDAD_VENTAS(
    TIPO INTEGER,
    DETALLE CHAR(1),
    FECINI DATE,
    FECFIN DATE,
    PREFIJO VARCHAR(4),
    SUBEMPRESA INTEGER)
RETURNS (
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    PTVTID INTEGER,
    VENDCOD INTEGER,
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    ARTICULO VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    UNIDAD VARCHAR(8),
    PRECIO NUMERIC(18,2),
    COSTO NUMERIC(18,2),
    UTILIDAD NUMERIC(18,2),
    PORC NUMERIC(9,2))
AS
declare variable IMPTOS CHAR(1);
declare variable ID INTEGER;
declare variable IVA NUMERIC(18,2);
declare variable COSTOT NUMERIC(18,2);
declare variable PRECIOT NUMERIC(18,2);
declare variable UOM VARCHAR(20);
BEGIN /*$$IBE$$ 
EXECUTE PROCEDURE lee_configuracion ('FACTURACION', 'ARTICULOS', 'SUGERIR PRECIOS CON PORCENTAJE DE MARGEN O UTILIDAD') returning_values (:UOM);
 $$IBE$$*/ /* DETERMINE LA TABLA A EXAMINAR */ /*$$IBE$$ 
if (TIPO = 31) then
    BEGIN
     $$IBE$$*/ /* FACTURA */ /*$$IBE$$ 
    FOR SELECT FACT_ID, F.PREF_PRE, FACT_NUMERO, FACT_FECHA, PTVT_ID, VEND_COD, TERC_NIT, FACT_NOMCLIENTE, FACT_IVAINC
        FROM FACTURAS F, PREFIJOS P
        WHERE FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N'
         AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = :TIPO AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY FACT_FECHA, F.PREF_PRE, FACT_NUMERO
        INTO :ID, :PREF, :NUMERO, :FECHA, :PTVTID, :VENDCOD, :NIT, :NOMTERCERO, :IMPTOS
        DO
        if ((PREFIJO = '') or (PREFIJO = PREF)) then
          BEGIN
          COSTOT = 0;
          PRECIOT = 0;
          FOR SELECT ARTI_COD, SUBSTR(FADE_DESC,1,60), FADE_CANT * FADE_FACTOR, FADE_UNIDAD, (FADE_PRUNIT - FADE_DTOMONTO) / FADE_FACTOR, FADE_IVAMONTO
            FROM FACTURAS_DETALLE
            WHERE FACT_ID = :ID
            INTO :ARTICULO, :ARTIDES, :CANT, :UNIDAD, :PRECIO, :IVA
            DO
                BEGIN
                EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
                COSTO = COSTO * CANT;
                PRECIO = PRECIO * CANT;
                if (IMPTOS = 'S') then
                    PRECIO = PRECIO - IVA;
                UTILIDAD = PRECIO - COSTO;
                if (DETALLE = 'S') then
                    BEGIN
                    if (UOM = 'UTILIDAD') then
                        EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                    else
                        EXECUTE PROCEDURE PORCENTAJE (utilidad,  PRECIO, 'S') returning_values (PORC);
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    COSTOT = COSTOT + COSTO;
                    PRECIOT = PRECIOT + PRECIO;
                    END
                END
          if (DETALLE <> 'S') then
            BEGIN
            COSTO = COSTOT;
            PRECIO = PRECIOT;
            UTILIDAD = PRECIO - COSTO;
            if (UOM = 'UTILIDAD') then
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
            else
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  PRECIO, 'S') returning_values (PORC);
            SUSPEND;
            END
          END
    END
  if (TIPO = 32) then
    BEGIN
     $$IBE$$*/ /* REMISION */ /*$$IBE$$ 
    FOR SELECT REVT_ID, R.PREF_PRE, REVT_NUMERO, REVT_FECHA, PTVT_ID, VEND_COD, TERC_NIT, REVT_NOMTERC, REVT_IVAINC
        FROM REMISIONES_VENTA R, PREFIJOS P
        WHERE REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND REVT_ANULADO = 'N'
         AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = :TIPO AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY REVT_FECHA, R.PREF_PRE, REVT_NUMERO
        INTO :ID, :PREF, :NUMERO, :FECHA, :PTVTID, :VENDCOD, :NIT, :NOMTERCERO, :IMPTOS
        DO
        if ((PREFIJO = '') or (PREFIJO = PREF)) then
          BEGIN
          COSTOT = 0;
          PRECIOT = 0;
          FOR SELECT ARTI_COD, SUBSTR(RVDE_DESC,1,60), RVDE_CANT * RVDE_FACTOR, RVDE_UNIDAD, (RVDE_PRUNIT - RVDE_DTOMONTO) / RVDE_FACTOR, RVDE_IVAMONTO
            FROM REMISIONES_VENTA_DETALLE
            WHERE REVT_ID = :ID
            INTO :ARTICULO, :ARTIDES, :CANT, :UNIDAD, :PRECIO, :IVA
            DO
                BEGIN
                EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
                COSTO = COSTO * CANT;
                PRECIO = PRECIO * CANT;
                if (IMPTOS = 'S') then
                    PRECIO = PRECIO - IVA;
                UTILIDAD = PRECIO - COSTO;
                if (DETALLE = 'S') then
                    BEGIN
                    if (UOM = 'UTILIDAD') then
                        EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                    else
                        EXECUTE PROCEDURE PORCENTAJE (utilidad,  PRECIO, 'S') returning_values (PORC);
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    COSTOT = COSTOT + COSTO;
                    PRECIOT = PRECIOT + PRECIO;
                    END
                END
          if (DETALLE <> 'S') then
            BEGIN
            COSTO = COSTOT;
            PRECIO = PRECIOT;
            UTILIDAD = PRECIO - COSTO;
            if (UOM = 'UTILIDAD') then
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
            else
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  PRECIO, 'S') returning_values (PORC);
            SUSPEND;
            END
          END
    END
  if (TIPO = 33) then
    BEGIN
     $$IBE$$*/ /* DEVOLUCION */ /*$$IBE$$ 
    FOR SELECT DEVT_ID, D.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, PTVT_ID, VEND_COD, TERC_NIT, DEVT_NOMTERC, DEVT_IVAINC
        FROM DEVOLUCIONES_VENTAS D, PREFIJOS P
        WHERE DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND DEVT_ANULADO = 'N'
         AND P.PREF_PRE = D.PREF_PRE AND P.TIDO_COD = :TIPO AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY DEVT_FECHA, D.PREF_PRE, DEVT_NUMERO
        INTO :ID, :PREF, :NUMERO, :FECHA, :PTVTID, :VENDCOD, :NIT, :NOMTERCERO, :IMPTOS
        DO
        if ((PREFIJO = '') or (PREFIJO = PREF)) then
          BEGIN
          COSTOT = 0;
          PRECIOT = 0;
          FOR SELECT ARTI_COD, SUBSTR(DVDE_DESC,1,60), DVDE_CANT * DVDE_FACTOR, DVDE_UNIDAD, (DVDE_PRUNIT - DVDE_DTOMONTO) / DVDE_FACTOR, DVDE_IVAMONTO
            FROM DEVOLUCIONES_VENTAS_DETALLE
            WHERE DEVT_ID = :ID
            INTO :ARTICULO, :ARTIDES, :CANT, :UNIDAD, :PRECIO, :IVA
            DO
                BEGIN
                EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
                COSTO = COSTO * CANT;
                PRECIO = PRECIO * CANT;
                if (IMPTOS = 'S') then
                    PRECIO = PRECIO - IVA;
                UTILIDAD = PRECIO - COSTO;
                if (DETALLE = 'S') then
                    BEGIN
                    if (UOM = 'UTILIDAD') then
                        EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                    else
                        EXECUTE PROCEDURE PORCENTAJE (utilidad,  PRECIO, 'S') returning_values (PORC);
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    COSTOT = COSTOT + COSTO;
                    PRECIOT = PRECIOT + PRECIO;
                    END
                END
        if (DETALLE <> 'S') then
            BEGIN
            COSTO = COSTOT;
            PRECIO = PRECIOT;
            UTILIDAD = PRECIO - COSTO;
            if (UOM = 'UTILIDAD') then
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
            else
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  PRECIO, 'S') returning_values (PORC);
            SUSPEND;
            END
        END
    END
  if (TIPO = 34) then
    BEGIN
     $$IBE$$*/ /* PEDIDO */ /*$$IBE$$ 
    FOR SELECT PEDI_ID, P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, PTVT_ID, VEND_COD, TERC_NIT, PEDI_NOMTERC, PEDI_IVAINC
        FROM PEDIDOS P, PREFIJOS R
        WHERE PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND PEDI_ANULADO = 'N'
         AND P.PREF_PRE = R.PREF_PRE AND R.TIDO_COD = :TIPO AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY PEDI_FECHA, P.PREF_PRE, PEDI_NUMERO
        INTO :ID, :PREF, :NUMERO, :FECHA, :PTVTID, :VENDCOD, :NIT, :NOMTERCERO, :IMPTOS
        DO
        if ((PREFIJO = '') or (PREFIJO = PREF)) then
          BEGIN
          COSTOT = 0;
          PRECIOT = 0;
          FOR SELECT ARTI_COD, SUBSTR(PEDE_DESC,1,60), PEDE_CANT * PEDE_FACTOR, PEDE_UNIDAD, (PEDE_PRUNIT - PEDE_DTOMONTO) / PEDE_FACTOR, PEDE_IVAMONTO
            FROM PEDIDOS_DETALLE
            WHERE PEDI_ID = :ID
            INTO :ARTICULO, :ARTIDES, :CANT, :UNIDAD, :PRECIO, :IVA
            DO
                BEGIN
                EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
                COSTO = COSTO * CANT;
                PRECIO = PRECIO * CANT;
                if (IMPTOS = 'S') then
                    PRECIO = PRECIO - IVA;
                UTILIDAD = PRECIO - COSTO;
                if (DETALLE = 'S') then
                    BEGIN
                    if (UOM = 'UTILIDAD') then
                        EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                    else
                        EXECUTE PROCEDURE PORCENTAJE (utilidad,  PRECIO, 'S') returning_values (PORC);
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    COSTOT = COSTOT + COSTO;
                    PRECIOT = PRECIOT + PRECIO;
                    END
                END
        if (DETALLE <> 'S') then
            BEGIN
            COSTO = COSTOT;
            PRECIO = PRECIOT;
            UTILIDAD = PRECIO - COSTO;
            if (UOM = 'UTILIDAD') then
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
            else
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  PRECIO, 'S') returning_values (PORC);
            SUSPEND;
            END
        END
    END
  if (TIPO = 35) then
    BEGIN
     $$IBE$$*/ /* COTIZACION */ /*$$IBE$$ 
    FOR SELECT COTI_ID, C.PREF_PRE, COTI_NUMERO, COTI_FECHA, PTVT_ID, VEND_COD, TERC_NIT, COTI_NOMTERC, COTI_IMPTOS
        FROM COTIZACIONES C, PREFIJOS P
        WHERE COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND COTI_ANULADO = 'N'
         AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = :TIPO AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY COTI_FECHA, C.PREF_PRE, COTI_NUMERO
        INTO :ID, :PREF, :NUMERO, :FECHA, :PTVTID, :VENDCOD, :NIT, :NOMTERCERO, :IMPTOS
        DO
        if ((PREFIJO = '') or (PREFIJO = PREF)) then
          BEGIN
          COSTOT = 0;
          PRECIOT = 0;
          FOR SELECT ARTI_COD, SUBSTR(CTDE_DESC,1,60), CTDE_CANT * CTDE_FACTOR, CTDE_UNIDAD, (CTDE_PRUNIT - CTDE_DTOMONTO) / CTDE_FACTOR, CTDE_IVAMONTO
            FROM COTIZACIONES_DETALLE
            WHERE COTI_ID = :ID
            INTO :ARTICULO, :ARTIDES, :CANT, :UNIDAD, :PRECIO, :IVA
            DO
                BEGIN
                EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
                COSTO = COSTO * CANT;
                PRECIO = PRECIO * CANT;
                if (IMPTOS = 'S') then
                    PRECIO = PRECIO - IVA;
                UTILIDAD = PRECIO - COSTO;
                if (DETALLE = 'S') then
                    BEGIN
                    if (UOM = 'UTILIDAD') then
                        EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                    else
                        EXECUTE PROCEDURE PORCENTAJE (utilidad,  PRECIO, 'S') returning_values (PORC);
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    COSTOT = COSTOT + COSTO;
                    PRECIOT = PRECIOT + PRECIO;
                    END
                END
        if (DETALLE <> 'S') then
            BEGIN
            COSTO = COSTOT;
            PRECIO = PRECIOT;
            UTILIDAD = PRECIO - COSTO;
            if (UOM = 'UTILIDAD') then
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
            else
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  PRECIO, 'S') returning_values (PORC);
            SUSPEND;
            END
        END
    END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE CHEQUEO_COSTOS(
    ARTICULO VARCHAR(20),
    FECHA DATE)
AS
declare variable NUMROWS INTEGER;
DECLARE VARIABLE ID INTEGER;
DECLARE VARIABLE FECMV DATE;
DECLARE VARIABLE CANT NUMERIC(15,4);
DECLARE VARIABLE COSTO NUMERIC(18,2);
DECLARE VARIABLE ENTRADA CHAR(1);
DECLARE VARIABLE TIPO INTEGER;
begin /*$$IBE$$ 
SELECT COUNT(*) FROM COSTOS WHERE ARTI_COD = :ARTICULO AND COST_FECHA > :FECHA INTO :NUMROWS;
if (NUMROWS > 0) then
    BEGIN
    delete from costos where arti_cod = :ARTICULO AND COST_FECHA > :FECHA;
    for select mvar_cons, mvar_fecha, mvar_cant, mvar_costo, mvar_entrada, mvar_tipodoc
        from movimiento_articulo WHERE ARTI_COD = :ARTICULO AND MVAR_FECHA > :FECHA
        order by mvar_fecha, mvar_cons  $$IBE$$*/ /* SE HACE ESTRICTAMENTE EN ORDEN DE FECHA Y REGISTRO, SI LO EDITAN CAMBIA EL ORDEN */ /*$$IBE$$ 
        into :id, :fecmv, :cant, :costo, :entrada, :tipo
        do
        if ((TIPO <> 13)) then
            EXECUTE PROCEDURE actualice_costo(:ARTICULO, :fecmv, :costo, :cant, :entrada, 'N', :id, :tipo);
    END
 $$IBE$$*/ EXIT;
end
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE CHEQUEO_INVENTARIO(
    ARTINI VARCHAR(20),
    ARTFIN VARCHAR(20))
AS
DECLARE VARIABLE FECHA DATE;
DECLARE VARIABLE CANT NUMERIC(15,4);
DECLARE VARIABLE COSTO NUMERIC(18,2);
DECLARE VARIABLE ENTRADA CHAR(1);
DECLARE VARIABLE BODEGA CHAR(2);
DECLARE VARIABLE ID INTEGER;
DECLARE VARIABLE TIPO INTEGER;
declare variable TIPOEX CHAR(1);
DECLARE VARIABLE LOTE VARCHAR(20);
DECLARE VARIABLE EXISTE CHAR(1);
declare variable ARTICULO VARCHAR(20);
declare variable IDL INTEGER;
BEGIN /*$$IBE$$ 
for select arti_cod from articulo where arti_cod >= :artini and arti_cod <= :artfin into :ARTICULO
  DO
  BEGIN
  DELETE FROM existencia_lote where arti_cod = :articulo;
  DELETE FROM lotes where arti_cod = :articulo;
  delete from costos where arti_cod = :ARTICULO;
  delete from existencia WHERE ARTI_COD = :ARTICULO;
  for select mvar_cons, mvar_fecha, mvar_cant, mvar_costo, mvar_entrada, bode_cod, mvar_tipodoc, mvar_lote
    from movimiento_articulo WHERE ARTI_COD = :ARTICULO
    order by mvar_fecha, mvar_cons
    into :id, :fecha, :cant, :costo, :entrada, :bodega, :tipo, :lote
  do
    begin
    SELECT ARTI_EXIST
        FROM   ARTICULO
        WHERE  ARTICULO.ARTI_COD = :ARTICULO
        INTO :TIPOEX;
    if ((TIPO <> 13)) then
        EXECUTE PROCEDURE actualice_costo(:ARTICULO, :fecha, :costo, :cant, :entrada, 'N', :id, :tipo);
     $$IBE$$*/ /* actualice existencias */ /*$$IBE$$ 
    if (:entrada = 'S') then
        begin
        execute procedure sume_existencia(:articulo, :bodega, :fecha, :cant, 'N');
        if (TIPOEX = 'L') then
            begin
            EXISTE = 'N';
            SELECT 'S' FROM LOTES WHERE ARTI_COD = :ARTICULO AND BODE_COD = :BODEGA AND LOTE_NRO = :lote INTO :EXISTE;
            if (EXISTE = 'S') then
                UPDATE LOTES
                    set lote_saldo = lote_saldo + :cant
                    where (arti_cod = :ARTICULO) and (BODE_COD = :BODEGA) AND (lote_nro = :lote);
            ELSE
                INSERT INTO LOTES (ARTI_COD, BODE_COD, LOTE_NRO, LOTE_FECHA, LOTE_CANT, LOTE_COSTO, LOTE_SALDO)
                    VALUES (:ARTICULO, :bodega, :lote, :fecha, :cant, :costo, :cant);
            end
        end
    else
        begin
        execute procedure reste_existencia(:articulo, :bodega, :fecha, :cant, 'N');
        if (TIPOEX = 'L') then
            begin
            EXISTE = 'N';
            SELECT 'S' FROM LOTES WHERE ARTI_COD = :ARTICULO AND BODE_COD = :BODEGA AND LOTE_NRO = :lote INTO :EXISTE;
            if (EXISTE = 'S') then
                UPDATE LOTES
                    set lote_saldo = lote_saldo - :cant
                    where (arti_cod = :ARTICULO) AND (BODE_COD = :BODEGA) and (lote_nro = :lote);
            ELSE
                BEGIN
                 $$IBE$$*/ /* ARREGLE EL LOTE YA QUE NO EXISTE */ /*$$IBE$$ 
                SELECT MIN(LOTE_ID) FROM LOTES WHERE ARTI_COD = :articulo AND BODE_COD = :BODEGA AND LOTE_CANT >= :cant INTO :IDL;
                SELECT LOTE_NRO FROM LOTES WHERE LOTE_ID = :IDL INTO :LOTE;
                UPDATE MOVIMIENTO_ARTICULO SET MVAR_LOTE = :LOTE WHERE MVAR_CONS = :ID;
                UPDATE LOTES
                    set lote_saldo = lote_saldo - :cant
                    where (arti_cod = :ARTICULO) and (BODE_COD = :BODEGA) AND (lote_nro = :lote);
                END
            EXISTE = 'N';
            SELECT 'S' FROM EXISTENCIA_LOTE
                WHERE LOTE_NRO = :LOTE AND EXLO_FECHA = :FECHA AND ARTI_COD = :ARTICULO AND BODE_COD = :bodega
                INTO :EXISTE;
            if (EXISTE = 'S') then
                UPDATE EXISTENCIA_LOTE
                       SET EXLO_SAL = EXLO_SAL + :cant
                    WHERE LOTE_NRO = :LOTE AND EXLO_FECHA = :FECHA AND ARTI_COD = :ARTICULO AND BODE_COD = :bodega;
            else
                INSERT INTO EXISTENCIA_LOTE (ARTI_COD, BODE_COD, LOTE_NRO, EXLO_FECHA, EXLO_SAL)
                    VALUES (:ARTICULO, :BODEGA, :LOTE, :FECHA, :CANT);
            end
        end
    END
  END
 $$IBE$$*/ EXIT;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE CAMBIO_PRECIOS(
    FECHA DATE)
AS
declare variable ART VARCHAR(20);
BEGIN /*$$IBE$$ 
FOR SELECT ARTI_COD FROM ARTICULO INTO :ART DO
    EXECUTE PROCEDURE CALCULA_PRECIOS(:ART, :FECHA);
  SUSPEND;
 $$IBE$$*/ EXIT;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE CONTABILICE_COSTO_VENTAS(
    ID INTEGER,
    IDINTER INTEGER)
RETURNS (
    IDC INTEGER)
AS
declare variable PREF VARCHAR(4);
declare variable NUM VARCHAR(6);
declare variable NUMERO VARCHAR(10);
declare variable INVEN CHAR(1);
declare variable CTAINVEN VARCHAR(20);
declare variable COSTOS CHAR(1);
declare variable CTACOSTOS VARCHAR(20);
declare variable EXISTE CHAR(1);
declare variable CUENTA VARCHAR(20);
declare variable MONTO NUMERIC(18,2);
declare variable TIPOCUEN CHAR(1);
declare variable NIT VARCHAR(20);
declare variable PROY VARCHAR(4);
declare variable CENTRO VARCHAR(4);
declare variable ART VARCHAR(15);
declare variable ANULADO CHAR(1);
declare variable NROI INTEGER;
declare variable NUMROWS INTEGER;
declare variable CONC CHAR(120);
declare variable VENCEAUX DATE;
declare variable VENCE CHAR(8);
begin
/* TRAIGA EL ID DEL ENCABEZADO DEL COMPROBANTE CONTABLE */ /*$$IBE$$ 
SELECT ENCO_CONSEC FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 31 AND ENCO_IDREF = :ID INTO :IDC;
SELECT MAX(CODE_ITEM) FROM COMPROBANTE_DETALLE WHERE ENCO_CONSEC = :idc INTO :NROI;
NROI = NROI + 1;
 $$IBE$$*/ /* EJECUTE LA PARTE DE CONTABIL_FACTURA QUE CORRESPONDE A LOS COSTOS */ /*$$IBE$$ 
EXISTE = 'N';
SELECT 'S', INVE_COSTO, INVE_INVEN, INVE_CTAINVEN, INVE_CTACOSTOS
    FROM INTERFAZ_VENTAS
    WHERE INVE_ID = :IDINTER
    INTO :EXISTE, :COSTOS, :INVEN, :CTAINVEN, :CTACOSTOS;
if (EXISTE = 'S') then
  BEGIN
  SELECT FACT_ANULADO, PREF_PRE, FACT_NUMERO, FACT_VENCE, TERC_NIT FROM FACTURAS F
        WHERE FACT_ID = :ID INTO :ANULADO, :PREF, :NUMERO, :VENCEAUX, :NIT;
  NUMERO = PREF || NUM;
  CONC = 'COSTO EN VENTAS FACTURA ' || :NUMERO;
  EXECUTE PROCEDURE FECHA_A_CONTA(:VENCEAUX) returning_values (:VENCE);
  if (ANULADO = 'N') then
    BEGIN
    SELECT BODE_CENTRO, BODE_PROY FROM BODEGA B, FACTURAS F, PUNTO_VENTA P
        WHERE B.BODE_COD = P.BODE_COD AND P.PTVT_ID = F.PTVT_ID AND F.FACT_ID = :ID INTO :CENTRO, :PROY;
     $$IBE$$*/ /* SE ASUME QUE NO HAN CAMBIADO LAS CUENTAS DE COSTOS, POR ESO SE HACE UPDATE A LOS MOVIMIENTOS DE ESAS CUENTAS */ /*$$IBE$$ 
    EXECUTE PROCEDURE COSTO_EN_VENTAS(31, :ID);
    if (COSTOS = 'A') then
        BEGIN
        FOR SELECT MAX(CTACOS), SUM(CANT * COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTACOS
            INTO :CTACOSTOS, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                CUENTA = NULL;
                SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                    WHERE CUEN_COD = :CTACOSTOS INTO :CUENTA, :TIPOCUEN;
                IF (CUENTA IS NULL) THEN
                    begin
                    EXCEPTION CUENTA_NO_EXISTE 'La cuenta ' || :ctacostos || ' no existe.';
                    end
                if (TIPOCUEN = 'I') then
                    BEGIN
                     $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                    FOR SELECT ARTI_COD, CANT * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTACOS = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        SELECT COUNT(*) FROM COMPROBANTE_DETALLE WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC AND ARTI_COD = :ART INTO :NUMROWS;
                        if (NUMROWS = 0) then
                            BEGIN
                            INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            END
                        ELSE
                            UPDATE COMPROBANTE_DETALLE
                                SET CODE_DEBITO = :MONTO
                            WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC AND ARTI_COD = :ART;
                        END
                    END
                ELSE
                    BEGIN
                    SELECT COUNT(*) FROM COMPROBANTE_DETALLE WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC INTO :NUMROWS;
                    if (NUMROWS = 0) then
                        BEGIN
                        if (TIPOCUEN = 'C') then
                            INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                        ELSE
                            INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        NROI = NROI + 1;
                        END
                    ELSE
                        UPDATE COMPROBANTE_DETALLE
                            SET CODE_DEBITO = :MONTO
                        WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC;
                    END
                END  $$IBE$$*/ /* MONTO <> 0 */ /*$$IBE$$ 
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        END  $$IBE$$*/ /* COSTOS */ /*$$IBE$$ 
    if (COSTOS = 'K') then
        BEGIN
        SELECT SUM(CANT * COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTACOSTOS INTO :CUENTA, :TIPOCUEN;
            IF (CUENTA IS NULL) THEN
                begin
                EXCEPTION CUENTA_NO_EXISTE 'La cuenta ' || :ctacostos || ' no existe.';
                end
            if (TIPOCUEN = 'I') then
                BEGIN
                 $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                FOR SELECT ARTI_COD, CANT * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    SELECT COUNT(*) FROM COMPROBANTE_DETALLE WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC AND ARTI_COD = :ART INTO :NUMROWS;
                    if (NUMROWS = 0) then
                        BEGIN
                            INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    ELSE
                        UPDATE COMPROBANTE_DETALLE
                            SET CODE_DEBITO = :MONTO
                        WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC AND ARTI_COD = :ART;
                    END
                END
            ELSE
                BEGIN
                SELECT COUNT(*) FROM COMPROBANTE_DETALLE WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC INTO :NUMROWS;
                if (NUMROWS = 0) then
                    BEGIN
                    if (TIPOCUEN = 'C') then
                        INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    ELSE
                        INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                ELSE
                    UPDATE COMPROBANTE_DETALLE
                        SET CODE_DEBITO = :MONTO
                    WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC;
                END
            END  $$IBE$$*/ /* MONTO <> 0 */ /*$$IBE$$ 
        END  $$IBE$$*/ /* COSTOS = K */ /*$$IBE$$ 
    if (INVEN = 'A') then
        BEGIN
        FOR SELECT MAX(CTAINV), SUM(CANT * COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTAINV
            INTO :CTAINVEN, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                CUENTA = NULL;
                SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                    WHERE CUEN_COD = :CTAINVEN INTO :CUENTA, :TIPOCUEN;
                IF (CUENTA IS NULL) THEN
                    begin
                    EXCEPTION CUENTA_NO_EXISTE 'La cuenta ' || :ctainven || ' no existe.';
                    end
                if (TIPOCUEN = 'I') then
                    BEGIN
                     $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                    FOR SELECT ARTI_COD, CANT * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTAINV = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        SELECT COUNT(*) FROM COMPROBANTE_DETALLE WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC AND ARTI_COD = :ART INTO :NUMROWS;
                        if (NUMROWS = 0) then
                            BEGIN
                            INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            END
                        ELSE
                            UPDATE COMPROBANTE_DETALLE
                                SET CODE_CREDITO = :MONTO
                            WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC AND ARTI_COD = :ART;
                        END
                    END
                ELSE
                    BEGIN
                    SELECT COUNT(*) FROM COMPROBANTE_DETALLE WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC INTO :NUMROWS;
                    if (NUMROWS = 0) then
                        BEGIN
                        if (TIPOCUEN = 'C') then
                            INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                        ELSE
                            INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        NROI = NROI + 1;
                        END
                    ELSE
                        UPDATE COMPROBANTE_DETALLE
                            SET CODE_CREDITO = :MONTO
                        WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC;
                    END
                END  $$IBE$$*/ /* MONTO <> 0 */ /*$$IBE$$ 
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        END  $$IBE$$*/ /* INVEN = A */ /*$$IBE$$ 
    if (INVEN = 'K') then
        BEGIN
        SELECT SUM(CANT * COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTAINVEN INTO :CUENTA, :TIPOCUEN;
            IF (CUENTA IS NULL) THEN
                begin
                EXCEPTION CUENTA_NO_EXISTE 'La cuenta ' || :ctainven || ' no existe.';
                end
            if (TIPOCUEN = 'I') then
                BEGIN
                 $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                FOR SELECT ARTI_COD, CANT * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    SELECT COUNT(*) FROM COMPROBANTE_DETALLE WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC AND ARTI_COD = :ART INTO :NUMROWS;
                    if (NUMROWS = 0) then
                        BEGIN
                        INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    ELSE
                        UPDATE COMPROBANTE_DETALLE
                            SET CODE_CREDITO = :MONTO
                        WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC AND ARTI_COD = :ART;
                    END
                END
            ELSE
                BEGIN
                SELECT COUNT(*) FROM COMPROBANTE_DETALLE WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC INTO :NUMROWS;
                if (NUMROWS = 0) then
                    BEGIN
                    if (TIPOCUEN = 'C') then
                        INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    ELSE
                        INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                ELSE
                    UPDATE COMPROBANTE_DETALLE
                        SET CODE_CREDITO = :MONTO
                    WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC;
                END
            END  $$IBE$$*/ /* MONTO <> 0 */ /*$$IBE$$ 
        END  $$IBE$$*/ /* INVEN = K */ /*$$IBE$$ 
    END
  END
 $$IBE$$*/ SUSPEND;
end
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE CONTABIL_DEVOLCLI(
    IDDOC INTEGER,
    IDINTER INTEGER)
RETURNS (
    ERROR INTEGER,
    VER CHAR(1),
    IDC INTEGER)
AS
declare variable PREF VARCHAR(4);
declare variable NUM VARCHAR(6);
declare variable NUMERO VARCHAR(10);
declare variable FECAUX DATE;
declare variable FECHA CHAR(8);
declare variable CONC CHAR(120);
declare variable NUMFAC VARCHAR(10);
declare variable VRDTO NUMERIC(18, 2);
declare variable VRADIC NUMERIC(18, 2);
declare variable VRSUBT NUMERIC(18, 2);
declare variable VRIVA NUMERIC(18, 2);
declare variable PRTFTE NUMERIC(9, 2);
declare variable VRRTFTE NUMERIC(18, 2);
declare variable VRRTIVA NUMERIC(18, 2);
declare variable PRTICA NUMERIC(9, 2);
declare variable VRRTICA NUMERIC(18, 2);
declare variable VRTOTAL NUMERIC(18, 2);
declare variable VREXTRA NUMERIC(18, 2);
declare variable TIPOCOMP VARCHAR(3);
declare variable PREFCONT VARCHAR(4);
declare variable VENTAS CHAR(1);
declare variable CTAVENTAS VARCHAR(20);
declare variable IVA CHAR(1);
declare variable CTAIVA VARCHAR(20);
declare variable CONSUMO CHAR(1);
declare variable CTACONSUMO VARCHAR(20);
declare variable CARTERA CHAR(1);
declare variable CTACARTERA VARCHAR(20);
declare variable RTFTE CHAR(1);
declare variable CTARTFTE VARCHAR(20);
declare variable RTIVA CHAR(1);
declare variable CTARTIVA VARCHAR(20);
declare variable RTICA CHAR(1);
declare variable CTARTICA VARCHAR(20);
declare variable INVEN CHAR(1);
declare variable CTAINVEN VARCHAR(20);
declare variable COSTOS CHAR(1);
declare variable CTACOSTOS VARCHAR(20);
declare variable CTADTO VARCHAR(20);
declare variable CTAADIC VARCHAR(20);
declare variable CTAEXTRA VARCHAR(20);
declare variable EXISTE CHAR(1);
declare variable CUENTA VARCHAR(20);
declare variable MONTO NUMERIC(18,2);
declare variable TIPOCUEN CHAR(1);
declare variable NIT VARCHAR(20);
declare variable PROY VARCHAR(4);
declare variable CENTRO VARCHAR(4);
declare variable PORC NUMERIC(5,2);
declare variable DEBITO NUMERIC(18,2);
declare variable CREDITO NUMERIC(18,2);
declare variable NROI INTEGER;
declare variable ART VARCHAR(15);
declare variable IMPINC CHAR(1);
declare variable IMPTOS NUMERIC(18, 2);
declare variable SUMA NUMERIC(18,2);
declare variable PORCIVA NUMERIC(9,2);
declare variable TCTACLIEN VARCHAR(20);
declare variable TCTAVENTA VARCHAR(20);
declare variable TCTARTFTE VARCHAR(20);
declare variable TCTARTIVA VARCHAR(20);
declare variable TCTARTICA VARCHAR(20);
declare variable CTADIC VARCHAR(20);
declare variable BASEADIC VARCHAR(20);
declare variable PORCADIC NUMERIC(5,2);
declare variable VALORADIC NUMERIC(18,2);
declare variable DBADIC CHAR(1);
declare variable PTOVTA INTEGER;
declare variable ANULADO CHAR(1);
declare variable CENT CHAR(1);
DECLARE VARIABLE MERCANCIA NUMERIC(18,2);
declare variable FACTOR DOUBLE PRECISION;
declare variable DIG INTEGER;
DECLARE VARIABLE FOMENTO VARCHAR(2);
DECLARE VARIABLE VRCONSUMO NUMERIC(18,2);
declare variable AUTORET VARCHAR(10);
declare variable FAUTORET DATE;
declare variable IDREM INTEGER;
declare variable DTOXIT CHAR(2);
declare variable ERRORC INTEGER;
BEGIN /*$$IBE$$ 
EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'USAR IMPOCONSUMO COMO PORCENTAJE DE FOMENTO') returning_values (FOMENTO);
EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'FECHA AUTORETENEDOR NO DESCONTAR RETENCIONES DEL SALDO PERO SI CONTABILIZARLAS') returning_values (AUTORET);
if (AUTORET <> '') then
    FAUTORET = CAST(AUTORET AS DATE);
else
    FAUTORET = '9999/12/31';
   $$IBE$$*/ /* BUSQUE LA INTERFACE */ /*$$IBE$$ 
  EXISTE = 'N';
  SELECT 'S', TICO_COD, PRCO_PRE, INVE_VENTAS, INVE_IVA, INVE_CONSUMO, INVE_CARTERA, INVE_RTFTE, INVE_RTIVA, INVE_RTICA, INVE_COSTO, INVE_INVEN, INVE_CTAVENTAS, INVE_CTAIVA, INVE_CTACONSUMO, INVE_CTADTO, INVE_CTAADIC, INVE_CTAEXTRA, INVE_CTACARTERA, INVE_CTARTFTE, INVE_CTARTIVA, INVE_CTARTICA, INVE_CTAINVEN, INVE_CTACOSTOS, INVE_CONFIRMAR, INVE_CENTRO
    FROM INTERFAZ_VENTAS
    WHERE INVE_ID = :IDINTER
    INTO :EXISTE, :TIPOCOMP, :PREFCONT, :VENTAS, :IVA, :CONSUMO, :CARTERA, :RTFTE, :RTIVA, :RTICA, :COSTOS, :INVEN, :CTAVENTAS, :CTAIVA, :CTACONSUMO, :CTADTO, :CTAADIC, :CTAEXTRA, :CTACARTERA, :CTARTFTE, :CTARTIVA, :CTARTICA, :CTAINVEN, :CTACOSTOS, :VER, :CENT;
  if (EXISTE = 'S') then
   BEGIN
     $$IBE$$*/ /* BORRE CUALQUEIR CONTABILIZACION PREVIA */ /*$$IBE$$ 
    DELETE FROM CONTABILIZACION WHERE CNTB_TIPOREF = 33 AND CNTB_IDREF = :IDDOC;
     $$IBE$$*/ /* TRAIGA EL ENCABEZADO DE LA DEVOLUCION */ /*$$IBE$$ 
   SELECT PREF_PRE, DEVT_NUMERO, DEVT_FECHA, F.TERC_NIT, DEVT_IVAINC, PTVT_ID, DEVT_FACTURA, DEVT_DTOMONTO, DEVT_ADICIONAL, DEVT_IVAMONTO, DEVT_EXTRA, DEVT_TOTAL, DEVT_RTFTEPORC, DEVT_RTFTEMONTO, DEVT_RTIVAPORC, DEVT_RTIVAMONTO, DEVT_RTICAPORC, DEVT_RTICAMONTO, TERC_CTARTFTE, TERC_CTARTIVA, TERC_CTARTICA, TERC_CTAVENTA, TERC_CTACLIENTE, DEVT_ANULADO, DEVT_REMID
        FROM DEVOLUCIONES_VENTAS F, TERCEROS T
        WHERE DEVT_ID = :IDDOC AND F.TERC_NIT = T.TERC_NIT
        INTO :PREF, :NUM, :FECAUX, :NIT, :IMPINC, :PTOVTA, :NUMFAC, :VRDTO, :VRADIC, :VRIVA, :VREXTRA, :VRTOTAL, :PRTFTE, :VRRTFTE, :PORC, :VRRTIVA, :PRTICA, :VRRTICA, :TCTARTFTE, TCTARTIVA, TCTARTICA, TCTAVENTA, TCTACLIEN, ANULADO, :IDREM;
   if (idrem is null) Then
    IDREM = 0;
   if ((ANULADO = 'N') AND (IDREM = 0)) then
    BEGIN
    NUMERO = PREF || NUM;
    SELECT SUM(DVDE_CONSUMO) FROM devoluciones_ventas_detalle WHERE DEVT_ID = :iddoc INTO :MERCANCIA;
    VRSUBT = VRTOTAL - VREXTRA - VRIVA - MERCANCIA;  $$IBE$$*/ /* BASE DE RETEFTE Y RETEICA */ /*$$IBE$$ 
    EXECUTE PROCEDURE lee_configuracion ('FACTURACION', 'DEVOLUCIONES', 'DESCUENTO PIE DEVOLUCION IGUAL A SUMA DE DESCUENTOS POR ITEM') returning_values (:DTOXIT);
    if (DTOXIT = 'SI') then
        VRDTO = 0;
    MERCANCIA = VRSUBT - VRADIC + VRDTO;
    IF (CENT = 'B') THEN
        SELECT B.BODE_CENTRO, B.BODE_PROY FROM BODEGA B, DEVOLUCIONES_VENTAS F
            WHERE B.BODE_COD = F.BODE_COD AND F.DEVT_ID = :IDDOC INTO :CENTRO, :PROY;
    IF (CENT = 'V') THEN
        SELECT V.CENT_COD, V.PROY_COD FROM VENDEDORES V, DEVOLUCIONES_VENTAS F
            WHERE V.VEND_COD = F.VEND_COD AND F.DEVT_ID = :IDDOC INTO :CENTRO, :PROY;
    IF (CENT = 'P') THEN
        SELECT P.PREF_CENTRO,P.PREF_PROY  FROM PREFIJOS P, DEVOLUCIONES_VENTAS F
            WHERE P.PREF_PRE = F.PREF_PRE AND F.DEVT_ID = :IDDOC AND P.TIDO_COD = 33 INTO :CENTRO, :PROY;
    EXECUTE PROCEDURE FECHA_A_CONTA(:FECAUX) returning_values (:FECHA);
     $$IBE$$*/ /* REGISTRE EL ENCABEZADO CONTABLE */ /*$$IBE$$ 
    IDC = GEN_ID(ID_CONTABILIZA, 1);
    CONC = 'DEVOLUCION VENTAS No. ' || NUMERO || ' EN FACTURA ' || NUMFAC;
    CONC = SUBSTR(CONC, 1, 60);
    INSERT INTO CONTABILIZACION (CNTB_ID, CNTB_TIPOCOMP, CNTB_PREFCNT, CNTB_NUMERO, CNTB_FECHA, CNTB_CONCEPTO, CNTB_REF, CNTB_TIPOREF, CNTB_IDREF, CNTB_PREFREF, CNTB_NUMREF, CNTB_PROCESADO)
        VALUES (:IDC, :TIPOCOMP, :PREFCONT, :NUM, :FECHA, :CONC, '', 33, :IDDOC, :PREF, :NUM, 'N');
    NROI = 0;
    SUMA = 0;
    ERROR = 0;
     $$IBE$$*/ /* SI NO HAY CUENTA DE DESCUENTO NI ADICIONAL CALCULE UN FACTOR PARA LAS VENTAS Y EL IVA */ /*$$IBE$$ 
    if (MERCANCIA <> 0) then
        FACTOR = CAST(VRSUBT AS DOUBLE PRECISION) / CAST(MERCANCIA AS DOUBLE PRECISION);
    ELSE
        FACTOR = 1;
     $$IBE$$*/ /* TRAIGA EL NUMERO DE DIGITOS PARA EL REDONDEO */ /*$$IBE$$ 
    SELECT CAST(CONF_VALOR AS INTEGER) FROM CONFIGURACION WHERE CONF_MODULO = 'FACTURACION' AND
        CONF_CATEGORIA = 'GENERAL' AND CONF_PROPIEDAD = 'REDONDEO AL MULTIPLO DE DIEZ EN TOTALES' INTO :DIG;
     $$IBE$$*/ /* CUENTAS DE VENTAS */ /*$$IBE$$ 
    if (VENTAS = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTADEV), SUM(cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), SUM(DVDE_IVAMONTO), SUM(DVDE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTADEV
            INTO :CTAVENTAS, :MONTO, :IMPTOS, :VRCONSUMO
            DO
            BEGIN
            if (IMPINC = 'S') then
                if (FOMENTO = 'SI') then
                    MONTO = MONTO - IMPTOS;
                ELSE
                    MONTO = MONTO - IMPTOS - VRCONSUMO;
            ELSE
            if (FOMENTO = 'SI') then
            MONTO = MONTO + VRCONSUMO;
            if ((CTADTO IS NULL) OR (CTADTO = '')) then
                MONTO = MONTO * FACTOR;
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAVENTAS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                     $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                    FOR SELECT F.ARTI_COD, (cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), (DVDE_IVAMONTO+DVDE_CONSUMO)
                        FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F
                        WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAINV = :CUENTA
                        INTO :ART, :MONTO, :IMPTOS
                    DO
                        BEGIN
                        if (IMPINC = 'S') then
                            MONTO = MONTO - IMPTOS;
                        if ((CTADTO IS NULL) OR (CTADTO = '')) then
                            MONTO = MONTO * FACTOR;
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA + MONTO;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    SUMA = SUMA + MONTO;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + MONTO;
                    END
                END  $$IBE$$*/ /* MONTO <> 0 */ /*$$IBE$$ 
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        END  $$IBE$$*/ /* VENTAS X ARTICULO */ /*$$IBE$$ 
     IF ((VENTAS = 'C') OR (VENTAS = 'K')) THEN
        BEGIN
        IF (VENTAS = 'C') THEN
            CTAVENTAS = TCTAVENTA;
        SELECT SUM(cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), SUM(DVDE_IVAMONTO), SUM(DVDE_CONSUMO)
            FROM DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC 
            INTO :MONTO, :IMPTOS, :VRCONSUMO;
        if (IMPINC = 'S') then
            if (FOMENTO = 'SI') then
               MONTO = MONTO - IMPTOS;
            ELSE
               MONTO = MONTO - IMPTOS - VRCONSUMO;
        ELSE
         if (FOMENTO = 'SI') then
          MONTO = MONTO + VRCONSUMO;
        if ((CTADTO IS NULL) OR (CTADTO = '')) then
            MONTO = MONTO * FACTOR;
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAVENTAS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                 $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                FOR SELECT F.ARTI_COD, (cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), (DVDE_IVAMONTO+DVDE_CONSUMO)
                    FROM ARTICULO A, DEVOLUCIONES_VENTAS_DETALLE F
                    WHERE F.DEVT_ID = :IDDOC
                    INTO :ART, :MONTO, :IMPTOS
                    DO
                    BEGIN
                    if (IMPINC = 'S') then
                        MONTO = MONTO - IMPTOS;
                    if ((CTADTO IS NULL) OR (CTADTO = '')) then
                        MONTO = MONTO * FACTOR;
                    execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + MONTO;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                SUMA = SUMA + MONTO;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA + MONTO;
                END
            END  $$IBE$$*/ /* MONTO <> 0 */ /*$$IBE$$ 
        END  $$IBE$$*/ /* VENTAS DE CLIENTE O CONSTANTE */
    /* EL IVA EN VENTAS */ /*$$IBE$$ 
    if (IVA = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTAIVAV), SUM(DVDE_IVAMONTO), SUM(DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO), SUM(DVDE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTAIVAV
            INTO :CTAIVA, :IMPTOS, :MONTO, :VALORADIC
        DO
            BEGIN
            if (FOMENTO = 'SI') then
                MONTO = MONTO + VALORADIC;
            MONTO = MONTO * -1;
            MONTO = MONTO * FACTOR;
            IMPTOS = IMPTOS * FACTOR;
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
            if (IMPTOS <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                     $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                    FOR SELECT F.ARTI_COD, DVDE_IVAMONTO, (cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), TAIV_PORC, DVDE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F, TARIFA_IVA T
                        WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND A.TAIV_COD = T.TAIV_COD AND COAR_CTAIVAV = :CUENTA
                        INTO :ART, :IMPTOS, :MONTO, :PORCIVA, :VALORADIC
                    DO
                        BEGIN
                        if (IMPINC = 'S') then
                            MONTO = MONTO - IMPTOS - VALORADIC;
                        MONTO = MONTO * -1;
                        MONTO = MONTO * FACTOR;
                        IMPTOS = IMPTOS * FACTOR;
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                        if (IMPTOS <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            SUMA = SUMA + IMPTOS;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                END    $$IBE$$*/ /* IMPTOS <> 0 */ /*$$IBE$$ 
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        END  $$IBE$$*/ /* IVA X ARTICULO */ /*$$IBE$$ 
    if (IVA = 'K') then  $$IBE$$*/ /* IVA EN CTA CONSTANTE */ /*$$IBE$$ 
        BEGIN
        SELECT SUM(DVDE_IVAMONTO), SUM(DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO), SUM(DVDE_CONSUMO)
            FROM DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC 
            INTO :IMPTOS, :MONTO, :VALORADIC;
        if (FOMENTO = 'SI') then
            MONTO = MONTO + VALORADIC;
        MONTO = MONTO * -1;
        MONTO = MONTO * FACTOR;
        IMPTOS = IMPTOS * FACTOR;
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
        if (IMPTOS <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                 $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                FOR SELECT F.ARTI_COD, (cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), DVDE_IVAMONTO, TAIV_PORC, DVDE_CONSUMO
                    FROM ARTICULO A, DEVOLUCIONES_VENTAS_DETALLE F, TARIFA_IVA T
                    WHERE F.DEVT_ID = :IDDOC AND A.TAIV_COD = T.TAIV_COD
                    INTO :ART, :MONTO, :IMPTOS, :PORCIVA, :VALORADIC
                    DO
                    BEGIN
                    if (IMPINC = 'S') then
                        MONTO = MONTO - IMPTOS - VALORADIC;
                    MONTO = MONTO * -1;
                    MONTO = MONTO * FACTOR;
                    IMPTOS = IMPTOS * FACTOR;
                    execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                    execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                    if (IMPTOS <> 0) then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', :IMPTOS, 0, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA + IMPTOS;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                SUMA = SUMA + IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA + IMPTOS;
                END
            END  $$IBE$$*/ /* IMPTOS <> 0 */ /*$$IBE$$ 
        END  $$IBE$$*/ /* IVA EN CTA CONSTANTE */
    /* EL IMPOCONSUMO */ /*$$IBE$$ 
    if ((CONSUMO = 'A') AND (FOMENTO <> 'SI')) then
        BEGIN
        FOR SELECT MAX(COAR_CTACONS), SUM(DVDE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTACONS
            INTO :CTACONSUMO, :IMPTOS
        DO
            BEGIN
            if (IMPTOS <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                     $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                    FOR SELECT F.ARTI_COD, DVDE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F
                        WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTACONS = :CUENTA
                        INTO :ART, :IMPTOS
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA + IMPTOS;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                END  $$IBE$$*/ /* IMPTOS <> 0 */ /*$$IBE$$ 
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        END  $$IBE$$*/ /* CONSUMO X ARTICULO */ /*$$IBE$$ 
    if ((CONSUMO = 'K') AND (FOMENTO <> 'SI')) then
        BEGIN
        SELECT SUM(DVDE_CONSUMO)
            FROM DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC 
            INTO :IMPTOS;
        if (IMPTOS <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                 $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                FOR SELECT F.ARTI_COD, DVDE_CONSUMO
                    FROM ARTICULO A, DEVOLUCIONES_VENTAS_DETALLE F
                    WHERE F.DEVT_ID = :IDDOC 
                    INTO :ART, :IMPTOS
                    DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA + IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA + IMPTOS;
                END
            END  $$IBE$$*/ /* IMPTOS <> 0 */ /*$$IBE$$ 
        END  $$IBE$$*/ /* CONSUMO EN CTA CONSTANTE */
    /* DESCUENTO */ /*$$IBE$$ 
    if ((CTADTO IS NOT NULL) AND
        (CTADTO <> '') AND
        (VRDTO <> 0)) THEN
        BEGIN
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTADTO, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRDTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA - VRDTO;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRDTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA - VRDTO;
            END
        END  $$IBE$$*/ /* DESCUENTO */
    /* VALOR ADIC */ /*$$IBE$$ 
    if ((CTAADIC IS NOT NULL) AND
        (CTAADIC <> '') AND
        (VRADIC <> 0)) THEN
        BEGIN
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRADIC, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA + VRADIC;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRADIC, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA + VRADIC;
            END
        END  $$IBE$$*/ /* VR. ADIC */
    /* VALOR EXTRA */ /*$$IBE$$ 
    if ((CTAEXTRA IS NOT NULL) AND
        (CTAEXTRA <> '') AND
        (VREXTRA <> 0)) THEN
        BEGIN
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAEXTRA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VREXTRA, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA + VREXTRA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VREXTRA, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA + VREXTRA;
            END
        END  $$IBE$$*/ /* VR. EXTRA */
    /* RETENCION FUENTE */ /*$$IBE$$ 
    if ((RTFTE = 'C') or (RTFTE = 'K')) then
      if (VRRTFTE <> 0) then
        BEGIN
        if (RTFTE = 'C') then
            CTARTFTE = TCTARTFTE;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:VRSUBT*-1), :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTFTE;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:VRSUBT*-1), :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTFTE;
            END
         $$IBE$$*/ /* AUTORETENCION */ /*$$IBE$$ 
        if (FAUTORET <= fecaux) then
            BEGIN
            EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'CUENTA DE AUTORETENCION EN LA FUENTE') returning_values (CTARTFTE);
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                SUMA = SUMA + VRRTFTE;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA + VRRTFTE;
                END
            END
        END  $$IBE$$*/ /* RTFTE */ /*$$IBE$$ 
    if (RTFTE = 'A') then
      BEGIN
      FOR SELECT MAX(COAR_CTARTFTEV), MAX(COAR_RTFTE), MIN(COAR_RTBASE), SUM(DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO), SUM((DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*COAR_RTFTE)
        FROM CONTABIL_ARTICULO C, devoluciones_ventas_detalle F
        WHERE F.devt_id = :IDDOC AND F.ARTI_COD = C.ARTI_COD
        GROUP BY COAR_CTARTFTEV
        INTO :CTARTFTE, :PRTFTE, :baseadic, :MONTO, :VRRTFTE
        DO
        BEGIN
        MONTO = MONTO * FACTOR;
        if (MONTO >= BASEADIC) then
            BEGIN
            VRRTFTE = VRRTFTE * FACTOR / 100;
            execute procedure redondee(VRRTFTE, DIG) returning_values (VRRTFTE);
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (VRRTFTE <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:MONTO*-1), :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    SUMA = SUMA - VRRTFTE;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:MONTO*-1), :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - VRRTFTE;
                    END
                 $$IBE$$*/ /* AUTORETENCION */ /*$$IBE$$ 
                if (FAUTORET <= fecaux) then
                    BEGIN
                    EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'CUENTA DE AUTORETENCION EN LA FUENTE') returning_values (CTARTFTE);
                    EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                    if (ERRORC <> 0) then
                        ERROR = ERROR + 1;
                    if (TIPOCUEN = 'C') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :MONTO, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                        NROI = NROI + 1;
                        SUMA = SUMA + VRRTFTE;
                        END
                    if (TIPOCUEN = 'N') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :MONTO, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA + VRRTFTE;
                        END
                    END
                END
            END
        END  $$IBE$$*/ /* RTFTE */ /*$$IBE$$ 
      END
     $$IBE$$*/ /* RETENCION IVA */ /*$$IBE$$ 
    if ((RTIVA = 'C') or (RTIVA = 'K')) then
      if (VRRTIVA <> 0) then
        BEGIN
        if (RTIVA = 'C') then
            CTARTIVA = TCTARTIVA;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTIVA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTIVA, (:VRIVA*-1), :PORC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTIVA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTIVA, (:VRIVA*-1), :PORC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTIVA;
            END
        END  $$IBE$$*/ /* RTIVA */
    /* RETENCION DE ICA */ /*$$IBE$$ 
    if ((RTICA = 'C') or (RTICA = 'K')) then
      if (VRRTICA <> 0) then
        BEGIN
        if (RTICA = 'C') then
            CTARTICA = TCTARTICA;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTICA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTICA, (:VRSUBT*-1), :PRTICA, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTICA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTICA, (:VRSUBT*-1), :PRTICA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTICA;
            END
        END  $$IBE$$*/ /* RTICA */
    /* CIERRE EL COMPROBANTE CONTRA LA CUENTA DEL TERCERO O LA CONSTANTE */ /*$$IBE$$ 
    if ((SUMA <> 0) and ((CARTERA = 'C') or (CARTERA = 'K') or (CARTERA = 'J'))) then
        BEGIN
        if (SUMA < 0) then
            BEGIN
            DEBITO = SUMA * -1;
            CREDITO = 0;
            END
        ELSE
            BEGIN
            DEBITO = 0;
            CREDITO = SUMA;
            END
        if (CARTERA = 'C') then
            CTACARTERA = TCTACLIEN;
        if (CARTERA = 'J') then
            BEGIN
             $$IBE$$*/ /* BUSQUE LA CUENTA DE LA CAJA */ /*$$IBE$$ 
            SELECT CAJA_CUENTA FROM CAJAS C, PUNTO_VENTA P
                WHERE P.CAJA_ID = C.CAJA_ID AND PTVT_ID = :PTOVTA
                INTO :CTACARTERA;
            END
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTACARTERA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
        if (TIPOCUEN = 'N') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
        NROI = NROI + 1;
        END  $$IBE$$*/ /* SUMA EN CARTERA */
    /* CALCULE COSTOS EN VENTAS */ /*$$IBE$$ 
    EXECUTE PROCEDURE COSTO_EN_VENTAS(33, :IDDOC);
    if (COSTOS = 'A') then
        BEGIN
        FOR SELECT MAX(CTACOS), SUM(cast(CANT as double precision) * COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTACOS
            INTO :CTACOSTOS, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTACOSTOS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                     $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                    FOR SELECT ARTI_COD, cast(CANT as double precision) * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTACOS = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                END  $$IBE$$*/ /* MONTO <> 0 */ /*$$IBE$$ 
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        END  $$IBE$$*/ /* COSTOS */ /*$$IBE$$ 
    if (COSTOS = 'K') then
        BEGIN
        SELECT SUM(cast(CANT as double precision) * COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTACOSTOS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                 $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                FOR SELECT ARTI_COD, cast(CANT as double precision) * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            END  $$IBE$$*/ /* MONTO <> 0 */ /*$$IBE$$ 
        END  $$IBE$$*/ /* COSTOS = K */ /*$$IBE$$ 
    if (INVEN = 'A') then
        BEGIN
        FOR SELECT MAX(CTAINV), SUM(cast(CANT as double precision) * COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTAINV
            INTO :CTAINVEN, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                     $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                    FOR SELECT ARTI_COD, cast(CANT as double precision) * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTAINV = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                END  $$IBE$$*/ /* MONTO <> 0 */ /*$$IBE$$ 
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        END  $$IBE$$*/ /* INVEN = A */ /*$$IBE$$ 
    if (INVEN = 'K') then
        BEGIN
        SELECT SUM(cast(CANT as double precision) * COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                 $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                FOR SELECT ARTI_COD, cast(CANT as double precision) * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            END  $$IBE$$*/ /* MONTO <> 0 */ /*$$IBE$$ 
        END  $$IBE$$*/ /* INVEN = K */
    /* recorra las cuentas adicionales */ /*$$IBE$$ 
    FOR SELECT INVC_CUENTA, INVC_BASE, INVC_PORC, INVC_VALOR, INVC_DB
        FROM INTERFAZ_VENTAS_CTAS WHERE INVE_ID = :IDINTER
        INTO :CTADIC, :BASEADIC, :PORCADIC, :VALORADIC, :DBADIC
        DO
        BEGIN
        if (valoradic <> 0) then
            monto = valoradic;
        else
            BEGIN
            if (:BASEADIC = 'SUBTOTAL') then
                VALORADIC = vrsubt;
            if (:BASEADIC = 'DESCUENTO') then
                VALORADIC = VRDTO;
            if (:BASEADIC = 'IVA') then
                VALORADIC = VRIVA;
            if (:BASEADIC = 'ADICIONAL') then
                VALORADIC = VRADIC;
            if (:BASEADIC = 'EXTRA') then
                VALORADIC = VREXTRA;
            if (:BASEADIC = 'TOTAL') then
                VALORADIC = VRTOTAL;
            MONTO = VALORADIC * PORCADIC;
            END
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                if (DBADIC = 'S') then
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                ELSE
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                if (DBADIC = 'S') then
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                ELSE
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            NROI = NROI + 1;
            END
        END
    if (error > 0) then
        ver = 'S';
    SUSPEND;
    END
   END  $$IBE$$*/ /* EXISTE LA INTERFAZ */ /*$$IBE$$ 
  ELSE
    BEGIN
    EXECUTE PROCEDURE ERROR (33, :IDDOC, :PREF, 1);
    ERROR = ERROR + 1;
    VER = 'S';
    SUSPEND;
    END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE CONTABIL_FACTURA(
    IDDOC INTEGER,
    IDINTER INTEGER)
RETURNS (
    ERROR INTEGER,
    VER CHAR(1),
    IDC INTEGER)
AS
declare variable pref varchar(4);
declare variable num varchar(6);
declare variable numero varchar(10);
declare variable fecaux date;
declare variable fecha char(8);
declare variable conc varchar(60);
declare variable venceaux date;
declare variable vence char(8);
declare variable vrdto numeric(18,2);
declare variable vradic numeric(18,2);
declare variable vrsubt numeric(18,2);
declare variable vriva numeric(18,2);
declare variable prtfte numeric(9,2);
declare variable vrrtfte numeric(18,2);
declare variable vrrtiva numeric(18,2);
declare variable prtica numeric(9,2);
declare variable vrrtica numeric(18,2);
declare variable vrtotal numeric(18,2);
declare variable vrextra numeric(18,2);
declare variable tipocomp varchar(3);
declare variable prefcont varchar(4);
declare variable ventas char(1);
declare variable ctaventas varchar(20);
declare variable iva char(1);
declare variable ctaiva varchar(20);
declare variable consumo char(1);
declare variable ctaconsumo varchar(20);
declare variable cartera char(1);
declare variable ctacartera varchar(20);
declare variable rtfte char(1);
declare variable ctartfte varchar(20);
declare variable rtiva char(1);
declare variable ctartiva varchar(20);
declare variable rtica char(1);
declare variable ctartica varchar(20);
declare variable inven char(1);
declare variable ctainven varchar(20);
declare variable costos char(1);
declare variable ctacostos varchar(20);
declare variable ctadto varchar(20);
declare variable ctaadic varchar(20);
declare variable ctaextra varchar(20);
declare variable existe char(1);
declare variable cuenta varchar(20);
declare variable monto numeric(18,2);
declare variable tipocuen char(1);
declare variable nit varchar(20);
declare variable nombre varchar(60);
declare variable proy varchar(4);
declare variable centro varchar(4);
declare variable porc numeric(5,2);
declare variable debito numeric(18,2);
declare variable credito numeric(18,2);
declare variable nroi integer;
declare variable art varchar(15);
declare variable imptos numeric(18,2);
declare variable suma numeric(18,2);
declare variable porciva numeric(9,2);
declare variable tctaclien varchar(20);
declare variable tctaventa varchar(20);
declare variable tctartfte varchar(20);
declare variable tctartiva varchar(20);
declare variable tctartica varchar(20);
declare variable ctadic varchar(20);
declare variable baseadic varchar(20);
declare variable porcadic numeric(5,2);
declare variable valoradic numeric(18,2);
declare variable dbadic char(1);
declare variable ptovta integer;
declare variable anulado char(1);
declare variable dig integer;
declare variable mercancia numeric(18,2);
declare variable fomento varchar(2);
declare variable DTOXIT varchar(2);
declare variable vrconsumo numeric(18,2);
declare variable factor double precision;
declare variable cent char(1);
declare variable AUTORET VARCHAR(10);
declare variable FAUTORET DATE;
declare variable ERRORC INTEGER;
BEGIN /*$$IBE$$ 
EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'USAR IMPOCONSUMO COMO PORCENTAJE DE FOMENTO') returning_values (FOMENTO);
EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'FECHA AUTORETENEDOR NO DESCONTAR RETENCIONES DEL SALDO PERO SI CONTABILIZARLAS') returning_values (AUTORET);
if (AUTORET <> '') then
    FAUTORET = CAST(AUTORET AS DATE);
else
    FAUTORET = '9999/12/31';
 $$IBE$$*/ /* BUSQUE LA INTERFACE */ /*$$IBE$$ 
EXISTE = 'N';
SELECT 'S', TICO_COD, PRCO_PRE, INVE_VENTAS, INVE_IVA, INVE_CONSUMO, INVE_CARTERA, INVE_RTFTE, INVE_RTIVA, INVE_RTICA, INVE_COSTO, INVE_INVEN, INVE_CTAVENTAS, INVE_CTAIVA, INVE_CTACONSUMO, INVE_CTADTO, INVE_CTAADIC, INVE_CTAEXTRA, INVE_CTACARTERA, INVE_CTARTFTE, INVE_CTARTIVA, INVE_CTARTICA, INVE_CTAINVEN, INVE_CTACOSTOS, INVE_CONFIRMAR, INVE_CENTRO
    FROM INTERFAZ_VENTAS
    WHERE INVE_ID = :IDINTER
    INTO :EXISTE, :TIPOCOMP, :PREFCONT, :VENTAS, :IVA, :CONSUMO, :CARTERA, :RTFTE, :RTIVA, :RTICA, :COSTOS, :INVEN, :CTAVENTAS, :CTAIVA, :CTACONSUMO, :CTADTO, :CTAADIC, :CTAEXTRA, :CTACARTERA, :CTARTFTE, :CTARTIVA, :CTARTICA, :CTAINVEN, :CTACOSTOS, :VER, :CENT;
if (EXISTE = 'S') then
  BEGIN
     $$IBE$$*/ /* BORRE CUALQUEIR CONTABILIZACION PREVIA */ /*$$IBE$$ 
    DELETE FROM CONTABILIZACION WHERE CNTB_TIPOREF = 31 AND CNTB_IDREF = :IDDOC;

   $$IBE$$*/ /* TRAIGA EL ENCABEZADO DE LA FACTURA */ /*$$IBE$$ 
  SELECT PREF_PRE, FACT_NUMERO, FACT_FECHA, F.TERC_NIT, PTVT_ID, FACT_VENCE, FACT_DTOMONTO, FACT_ADICIONAL, FACT_IVAMONTO, FACT_EXTRA, FACT_TOTAL, FACT_RTFTEPOR, FACT_RTFTEMONTO, FACT_RTIVAPOR, FACT_RTIVAMONTO, FACT_RTICAPOR, FACT_RTICAMONTO, FACT_NOMCLIENTE, TERC_CTARTFTE, TERC_CTARTIVA, TERC_CTARTICA, TERC_CTAVENTA, TERC_CTACLIENTE, FACT_ANULADO
        FROM FACTURAS F, TERCEROS T
        WHERE FACT_ID = :IDDOC AND F.TERC_NIT = T.TERC_NIT
        INTO :PREF, :NUM, :FECAUX, :NIT, :PTOVTA, :VENCEAUX, :VRDTO, :VRADIC, :VRIVA, :VREXTRA, :VRTOTAL, :PRTFTE, :VRRTFTE, :PORC, :VRRTIVA, :PRTICA, :VRRTICA, :NOMBRE, TCTARTFTE, TCTARTIVA, TCTARTICA, TCTAVENTA, TCTACLIEN, ANULADO;
  if (ANULADO = 'N') then
    BEGIN
     $$IBE$$*/ /* BUSQUE EL CENTRO DEL PUNTO, LA BODEGA, O EL PREFIJO  */ /*$$IBE$$ 
    IF (CENT = 'B') THEN
        SELECT B.BODE_CENTRO, B.BODE_PROY FROM BODEGA B, FACTURAS F
            WHERE B.BODE_COD = F.BODE_COD AND F.FACT_ID = :IDDOC INTO :CENTRO, :PROY;
    IF (CENT = 'V') THEN
        SELECT V.CENT_COD, V.PROY_COD FROM VENDEDORES V, FACTURAS F
            WHERE V.VEND_COD = F.VEND_COD AND F.FACT_ID = :IDDOC INTO :CENTRO, :PROY;
    IF (CENT = 'P') THEN
        SELECT P.PREF_CENTRO,P.PREF_PROY  FROM PREFIJOS P, FACTURAS F
            WHERE P.PREF_PRE = F.PREF_PRE AND F.FACT_ID = :IDDOC AND P.TIDO_COD = 31 INTO :CENTRO, :PROY;
    NUMERO = PREF || NUM;
    SELECT SUM (FADE_CONSUMO) FROM FACTURAS_DETALLE WHERE FACT_ID = :IDDOC INTO MERCANCIA;
    VRSUBT = VRTOTAL - VREXTRA - VRIVA - MERCANCIA;  $$IBE$$*/ /* BASE DE RETEFTE Y RETEICA */ /*$$IBE$$ 

    EXECUTE PROCEDURE lee_configuracion ('FACTURACION', 'FACTURAS', 'DESCUENTO PIE FACTURA IGUAL A SUMA DE DESCUENTOS POR ITEM') returning_values (:DTOXIT);
    if (DTOXIT = 'SI') then
        VRDTO = 0;
    MERCANCIA = VRSUBT - VRADIC + VRDTO;
    EXECUTE PROCEDURE FECHA_A_CONTA(:FECAUX) returning_values (:FECHA);
    EXECUTE PROCEDURE FECHA_A_CONTA(:VENCEAUX) returning_values (:VENCE);
     $$IBE$$*/ /* REGISTRE EL ENCABEZADO CONTABLE */ /*$$IBE$$ 
    IDC = GEN_ID(ID_CONTABILIZA, 1);
    if (STRLEN(NOMBRE)> 43 ) then
      CONC = 'FV No.' || NUMERO || '-' || SUBSTR(NOMBRE,1,43);
    ELSE
      CONC = 'FV No.' || NUMERO || '-' || NOMBRE;
    INSERT INTO CONTABILIZACION (CNTB_ID, CNTB_TIPOCOMP, CNTB_PREFCNT, CNTB_NUMERO, CNTB_FECHA, CNTB_CONCEPTO, CNTB_REF, CNTB_TIPOREF, CNTB_IDREF, CNTB_PREFREF, CNTB_NUMREF, CNTB_PROCESADO)
        VALUES (:IDC, :TIPOCOMP, :PREFCONT, :NUM, :FECHA, :CONC, '', 31, :IDDOC, :PREF, :NUM, 'N');
    NROI = 0;
    SUMA = 0;
    ERROR = 0;
     $$IBE$$*/ /* SI NO HAY CUENTA DE DESCUENTO NI ADICIONAL CALCULE UN FACTOR PARA LAS VENTAS Y EL IVA */ /*$$IBE$$ 
    if (MERCANCIA <> 0) then
        FACTOR = CAST(VRSUBT AS DOUBLE PRECISION) / CAST(MERCANCIA AS DOUBLE PRECISION);
    ELSE
        FACTOR = 1;
     $$IBE$$*/ /* TRAIGA EL NUMERO DE DIGITOS PARA EL REDONDEO */ /*$$IBE$$ 
    SELECT CAST(CONF_VALOR AS INTEGER) FROM CONFIGURACION WHERE CONF_MODULO = 'FACTURACION' AND
        CONF_CATEGORIA = 'GENERAL' AND CONF_PROPIEDAD = 'REDONDEO AL MULTIPLO DE DIEZ EN TOTALES' INTO :DIG;
     $$IBE$$*/ /* CUENTAS DE VENTAS */ /*$$IBE$$ 
    if (VENTAS = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTAVNT), SUM(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), SUM(FADE_IVAMONTO), SUM(FADE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTAVNT
            INTO :CTAVENTAS, :MONTO, :IMPTOS, :VRCONSUMO
            DO
            BEGIN
            if (FOMENTO = 'SI') then
                MONTO = MONTO + VRCONSUMO;
            if ((CTADTO IS NULL) OR (CTADTO = '')) then
                MONTO = MONTO * FACTOR;
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAVENTAS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                     $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                    FOR SELECT F.ARTI_COD, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), FADE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
                        WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAINV = :CUENTA
                        INTO :ART, :MONTO, :IMPTOS
                    DO
                        BEGIN
                        if (FOMENTO = 'SI') then
                            MONTO = MONTO + IMPTOS;
                        if ((CTADTO IS NULL) OR (CTADTO = '')) then
                            MONTO = MONTO * FACTOR;
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        if (MONTO <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            SUMA = SUMA - MONTO;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    SUMA = SUMA - MONTO;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - MONTO;
                    END
                END  $$IBE$$*/ /* MONTO <> 0 */ /*$$IBE$$ 
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        END  $$IBE$$*/ /* VENTAS X ARTICULO */ /*$$IBE$$ 
     IF ((VENTAS = 'C') OR (VENTAS = 'K')) THEN
        BEGIN
        IF (VENTAS = 'C') THEN
            CTAVENTAS = TCTAVENTA;
        SELECT SUM(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), SUM(FADE_IVAMONTO), SUM (FADE_CONSUMO)
            FROM FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC 
            INTO :MONTO, :IMPTOS, :VRCONSUMO;
        if (FOMENTO = 'SI') then
            MONTO = MONTO + VRCONSUMO;
        if ((CTADTO IS NULL) OR (CTADTO = '')) then
            MONTO = MONTO * FACTOR;
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAVENTAS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                 $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                FOR SELECT F.ARTI_COD, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), FADE_CONSUMO
                    FROM ARTICULO A, FACTURAS_DETALLE F
                    WHERE F.FACT_ID = :IDDOC 
                    INTO :ART, :MONTO, :IMPTOS
                    DO
                    BEGIN
                    if (FOMENTO = 'SI') then
                        MONTO = MONTO + VRCONSUMO;
                    if ((CTADTO IS NULL) OR (CTADTO = '')) then
                        MONTO = MONTO * FACTOR;
                    execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                    if (MONTO <> 0) then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA - MONTO;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - MONTO;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - MONTO;
                END
            END  $$IBE$$*/ /* MONTO <> 0 */ /*$$IBE$$ 
        END  $$IBE$$*/ /* VENTAS DE CLIENTE O CONSTANTE */
    /* EL IVA EN VENTAS */ /*$$IBE$$ 
    if (IVA = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTAIVAV), SUM(FADE_IVAMONTO), SUM(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), sum(FADE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTAIVAV
            INTO :CTAIVA, :IMPTOS, :MONTO, :VALORADIC
        DO
            BEGIN
            if (FOMENTO = 'SI') then
                MONTO = MONTO + VALORADIC;
            MONTO = MONTO * -1;
            MONTO = MONTO * FACTOR;
            IMPTOS = IMPTOS * FACTOR;
            execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (IMPTOS <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                     $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                    FOR SELECT F.ARTI_COD, FADE_IVAMONTO, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), TAIV_PORC, FADE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F, TARIFA_IVA T
                        WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAIVAV = :CUENTA AND A.TAIV_COD = T.TAIV_COD
                        INTO :ART, :IMPTOS, :MONTO, :PORCIVA, :VALORADIC
                    DO
                        BEGIN
                        if (FOMENTO = 'SI') then
                            MONTO = MONTO + VALORADIC;
                        MONTO = MONTO * -1;
                        MONTO = MONTO * FACTOR;
                        IMPTOS = IMPTOS * FACTOR;
                        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        if (IMPTOS <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            SUMA = SUMA + DEBITO - CREDITO;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                END    $$IBE$$*/ /* IMPTOS <> 0 */ /*$$IBE$$ 
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        END  $$IBE$$*/ /* IVA X ARTICULO */ /*$$IBE$$ 
    if (IVA = 'K') then  $$IBE$$*/ /* IVA EN CTA CONSTANTE */ /*$$IBE$$ 
        BEGIN
        SELECT SUM(FADE_IVAMONTO), SUM(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), SUM(FADE_CONSUMO)
            FROM FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC and FADE_IVAMONTO <> 0
            INTO :IMPTOS, :MONTO, :valoradic;
        if (FOMENTO = 'SI') then
            MONTO = MONTO + VALORADIC;
        MONTO = MONTO * -1;
        MONTO = MONTO * FACTOR;
        IMPTOS = IMPTOS * FACTOR;
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
        if (IMPTOS <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                 $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                FOR SELECT F.ARTI_COD, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), FADE_IVAMONTO, TAIV_PORC, FADE_CONSUMO
                    FROM ARTICULO A, FACTURAS_DETALLE F, TARIFA_IVA T
                    WHERE F.FACT_ID = :IDDOC AND A.TAIV_COD = T.TAIV_COD
                    INTO :ART, :MONTO, :IMPTOS, :PORCIVA, :VALORADIC
                    DO
                    BEGIN
                    if (FOMENTO = 'SI') then
                        MONTO = MONTO + VALORADIC;
                    MONTO = MONTO * -1;
                    MONTO = MONTO * FACTOR;
                    IMPTOS = IMPTOS * FACTOR;
                    execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                    execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                    if (IMPTOS <> 0) then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', 0, :IMPTOS, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA - IMPTOS;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            END  $$IBE$$*/ /* IMPTOS <> 0 */ /*$$IBE$$ 
        END  $$IBE$$*/ /* IVA EN CTA CONSTANTE */
    /* EL IMPOCONSUMO */ /*$$IBE$$ 
    if ((CONSUMO = 'A') AND (FOMENTO <> 'SI')) then
        BEGIN
        FOR SELECT MAX(COAR_CTACONS), SUM(FADE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTACONS
            INTO :CTACONSUMO, :IMPTOS
        DO
            BEGIN
            execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
            if (IMPTOS <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                     $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                    FOR SELECT F.ARTI_COD, FADE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
                        WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTACONS = :CUENTA
                        INTO :ART, :IMPTOS
                    DO
                        BEGIN
                        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                        if (IMPTOS <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            SUMA = SUMA - IMPTOS;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                END  $$IBE$$*/ /* IMPTOS <> 0 */ /*$$IBE$$ 
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        END  $$IBE$$*/ /* CONSUMO X ARTICULO */ /*$$IBE$$ 
    if ((CONSUMO = 'K') AND (FOMENTO <> 'SI')) then  $$IBE$$*/ /* CONSUMO EN CTA CONSTANTE */ /*$$IBE$$ 
        BEGIN
        SELECT SUM(FADE_CONSUMO)
            FROM FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC 
            INTO :IMPTOS;
        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
        if (IMPTOS <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                 $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                FOR SELECT F.ARTI_COD, FADE_CONSUMO
                    FROM ARTICULO A, FACTURAS_DETALLE F
                    WHERE F.FACT_ID = :IDDOC 
                    INTO :ART, :IMPTOS
                    DO
                    BEGIN
                    execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                    if (IMPTOS <> 0) then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA - IMPTOS;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            END  $$IBE$$*/ /* IMPTOS <> 0 */ /*$$IBE$$ 
        END  $$IBE$$*/ /* CONSUMO EN CTA CONSTANTE */
    /* DESCUENTO */ /*$$IBE$$ 
    if ((CTADTO IS NOT NULL) AND (CTADTO <> '')) then
        BEGIN
        execute procedure redondee(VRDTO, DIG) returning_values (VRDTO);
        if (VRDTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTADTO, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRDTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA + VRDTO;
                END
            if (TIPOCUEN = 'N') then
                    BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRDTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA + VRDTO;
                END
            END
        END  $$IBE$$*/ /* DESCUENTO */
    /* VALOR ADIC */ /*$$IBE$$ 
    if ((CTAADIC IS NOT NULL) AND (CTAADIC <> '')) then
        BEGIN
        execute procedure redondee(VRADIC, DIG) returning_values (VRADIC);
        if (VRADIC <> 0) THEN
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRADIC, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VRADIC;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRADIC, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VRADIC;
                END
            END
        END  $$IBE$$*/ /* VR. ADIC */
    /* VALOR EXTRA */ /*$$IBE$$ 
    if ((CTAEXTRA IS NOT NULL) AND (CTAEXTRA <> '')) THEN
        BEGIN
        execute procedure redondee(VREXTRA, DIG) returning_values (VREXTRA);
        if (VREXTRA <> 0) THEN
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAEXTRA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VREXTRA, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VREXTRA;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VREXTRA, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VREXTRA;
                END
            END
        END  $$IBE$$*/ /* VR. EXTRA */
    /* DESCUENTE EL IMPOCONSUMO */ /*$$IBE$$ 
    SELECT SUM(FADE_CONSUMO)
        FROM FACTURAS_DETALLE F WHERE F.FACT_ID = :IDDOC INTO :IMPTOS;
    vrsubt = vrsubt - IMPTOS;
     $$IBE$$*/ /* RETENCION FUENTE */ /*$$IBE$$ 
    if ((RTFTE = 'C') or (RTFTE = 'K')) then
      BEGIN
      execute procedure redondee(VRRTFTE, DIG) returning_values (VRRTFTE);
      if (VRRTFTE <> 0) then
        BEGIN
        if (RTFTE = 'C') then
            CTARTFTE = TCTARTFTE;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTFTE;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTFTE;
            END
         $$IBE$$*/ /* AUTORETENCION */ /*$$IBE$$ 
        if (FAUTORET <= fecaux) then
            BEGIN
            EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'CUENTA DE AUTORETENCION EN LA FUENTE') returning_values (CTARTFTE);
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTARTFTE INTO :CUENTA, :TIPOCUEN;
            if (CUENTA IS NULL) then
                begin
                EXECUTE PROCEDURE ERROR (31, :IDDOC, :CTARTFTE, 2);
                CUENTA = CTARTFTE;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                begin
                EXECUTE PROCEDURE ERROR (31, :IDDOC, :CUENTA, 3);
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:VRSUBT*-1), :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VRRTFTE;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:VRSUBT*-1), :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - VRRTFTE;
                END
            END
        END  $$IBE$$*/ /* RTFTE */ /*$$IBE$$ 
      END
    if (RTFTE = 'A') then
      BEGIN
      FOR SELECT MAX(COAR_CTARTFTEV), MAX(COAR_RTFTE), MIN(COAR_RTBASE), SUM(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), SUM((FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*COAR_RTFTE)
        FROM CONTABIL_ARTICULO C, FACTURAS_DETALLE F
        WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = C.ARTI_COD
        GROUP BY COAR_CTARTFTEV
        INTO :CTARTFTE, :PRTFTE, :baseadic, :MONTO, :VRRTFTE
        DO
        BEGIN
        MONTO = MONTO * FACTOR;
        if (MONTO >= BASEADIC) then
            BEGIN
            VRRTFTE = VRRTFTE * FACTOR / 100;
            execute procedure redondee(VRRTFTE, DIG) returning_values (VRRTFTE);
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (VRRTFTE <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :MONTO, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    SUMA = SUMA + VRRTFTE;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :MONTO, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + VRRTFTE;
                    END
                 $$IBE$$*/ /* AUTORETENCION */ /*$$IBE$$ 
                if (FAUTORET <= fecaux) then
                    BEGIN
                    EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'CUENTA DE AUTORETENCION EN LA FUENTE') returning_values (CTARTFTE);
                    EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                    if (ERRORC <> 0) then
                        ERROR = ERROR + 1;
                    if (TIPOCUEN = 'C') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:MONTO*-1), :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                        NROI = NROI + 1;
                        SUMA = SUMA - VRRTFTE;
                        END
                    if (TIPOCUEN = 'N') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:MONTO*-1), :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA - VRRTFTE;
                        END
                    END
                END
            END
        END  $$IBE$$*/ /* RTFTE */ /*$$IBE$$ 
      END
     $$IBE$$*/ /* RETENCION IVA */ /*$$IBE$$ 
    if ((RTIVA = 'C') or (RTIVA = 'K')) then
      BEGIN
      execute procedure redondee(VRRTIVA, DIG) returning_values (VRRTIVA);
      if (VRRTIVA <> 0) then
        BEGIN
        if (RTIVA = 'C') then
            CTARTIVA = TCTARTIVA;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTARTIVA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTIVA, 0, :VRIVA, :PORC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTIVA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTIVA, 0, :VRIVA, :PORC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTIVA;
            END
        END  $$IBE$$*/ /* RTIVA */ /*$$IBE$$ 
      END
     $$IBE$$*/ /* RETENCION DE ICA */ /*$$IBE$$ 
    if ((RTICA = 'C') or (RTICA = 'K')) then
      BEGIN
      execute procedure redondee(VRRTICA, DIG) returning_values (VRRTICA);
      if (VRRTICA <> 0) then
        BEGIN
        if (RTICA = 'C') then
            CTARTICA = TCTARTICA;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTARTICA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTICA, 0, :VRSUBT, :PRTICA, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTICA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTICA, 0, :VRSUBT, :PRTICA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTICA;
            END
        END  $$IBE$$*/ /* RTICA */ /*$$IBE$$ 
      END
     $$IBE$$*/ /* CIERRE EL COMPROBANTE CONTRA LA CUENTA DEL TERCERO O LA CONSTANTE */ /*$$IBE$$ 
    if ((SUMA <> 0) and ((CARTERA = 'C') or (CARTERA = 'K') or (CARTERA = 'J'))) then
        BEGIN
        if (SUMA < 0) then
            BEGIN
            DEBITO = SUMA * -1;
            CREDITO = 0;
            END
        ELSE
            BEGIN
            DEBITO = 0;
            CREDITO = SUMA;
            END
        if (CARTERA = 'C') then
            CTACARTERA = TCTACLIEN;
        if (CARTERA = 'J') then
            BEGIN
             $$IBE$$*/ /* BUSQUE LA CUENTA DE LA CAJA */ /*$$IBE$$ 
            SELECT CAJA_CUENTA FROM CAJAS C, PUNTO_VENTA P
                WHERE P.CAJA_ID = C.CAJA_ID AND PTVT_ID = :PTOVTA
                INTO :CTACARTERA;
            END
        EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTACARTERA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
        if (TIPOCUEN = 'N') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
        NROI = NROI + 1;
        END  $$IBE$$*/ /* SUMA EN CARTERA */
    /* CALCULE COSTOS EN VENTAS */ /*$$IBE$$ 
    EXECUTE PROCEDURE COSTO_EN_VENTAS(31, :IDDOC);
    if (COSTOS = 'A') then
        BEGIN
        FOR SELECT MAX(CTACOS), SUM(CAST(CANT AS DOUBLE PRECISION) * COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTACOS
            INTO :CTACOSTOS, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTACOSTOS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                     $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                    FOR SELECT ARTI_COD, CANT * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTACOS = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                END  $$IBE$$*/ /* MONTO <> 0 */ /*$$IBE$$ 
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        END  $$IBE$$*/ /* COSTOS */ /*$$IBE$$ 
    if (COSTOS = 'K') then
        BEGIN
        SELECT SUM(CAST(CANT AS DOUBLE PRECISION) * COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTACOSTOS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                 $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                FOR SELECT ARTI_COD, CANT * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            END  $$IBE$$*/ /* MONTO <> 0 */ /*$$IBE$$ 
        END  $$IBE$$*/ /* COSTOS = K */ /*$$IBE$$ 
    if (INVEN = 'A') then
        BEGIN
        FOR SELECT MAX(CTAINV), SUM(CAST(CANT AS DOUBLE PRECISION) * COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTAINV
            INTO :CTAINVEN, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                     $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                    FOR SELECT ARTI_COD, CANT * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTAINV = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                END  $$IBE$$*/ /* MONTO <> 0 */ /*$$IBE$$ 
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        END  $$IBE$$*/ /* INVEN = A */ /*$$IBE$$ 
    if (INVEN = 'K') then
        BEGIN
        SELECT SUM(CAST(CANT AS DOUBLE PRECISION) * COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                 $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                FOR SELECT ARTI_COD, CANT * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            END  $$IBE$$*/ /* MONTO <> 0 */ /*$$IBE$$ 
        END  $$IBE$$*/ /* INVEN = K */
    /* recorra las cuentas adicionales */ /*$$IBE$$ 
    FOR SELECT INVC_CUENTA, INVC_BASE, INVC_PORC, INVC_VALOR, INVC_DB
        FROM INTERFAZ_VENTAS_CTAS
        WHERE INVE_ID = :IDINTER
        INTO :CTADIC, :BASEADIC, :PORCADIC, :VALORADIC, :DBADIC
        DO
        BEGIN
        if (VALORADIC <> 0) then
            MONTO = VALORADIC;
        ELSE
            BEGIN
            if (:BASEADIC = 'SUBTOTAL') then
                VALORADIC = vrsubt;
            if (:BASEADIC = 'DESCUENTO') then
                VALORADIC = VRDTO;
            if (:BASEADIC = 'IVA') then
                VALORADIC = VRIVA;
            if (:BASEADIC = 'ADICIONAL') then
                VALORADIC = VRADIC;
            if (:BASEADIC = 'EXTRA') then
                VALORADIC = VREXTRA;
            if (:BASEADIC = 'TOTAL') then
                VALORADIC = VRTOTAL;
            MONTO = VALORADIC * PORCADIC / 100;
            END
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                if (DBADIC = 'S') then
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                ELSE
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                if (DBADIC = 'S') then
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                ELSE
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            NROI = NROI + 1;
            END
        END
    if (ERROR > 0) then
        VER = 'S';
    SUSPEND;
    END  $$IBE$$*/ /* NO ANULADO */ /*$$IBE$$ 
  END  $$IBE$$*/ /* EXISTE LA INTERFAZ */ /*$$IBE$$ 
ELSE
    BEGIN
    EXECUTE PROCEDURE ERROR (31, :IDDOC, :PREF, 1);
    ERROR = ERROR + 1;
    VER = 'S';
    SUSPEND;
    END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE EXPORTA_FACTURAS(
    INI DATE,
    FIN DATE)
RETURNS (
    IDDOC INTEGER,
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA VARCHAR(8),
    VENCE VARCHAR(8),
    NIT VARCHAR(15),
    VENDEDOR INTEGER,
    BODEGA VARCHAR(2),
    OBSERVACION VARCHAR(255),
    ITEM INTEGER,
    CUENTA VARCHAR(20),
    PROY VARCHAR(4),
    CENTRO VARCHAR(4),
    ARTICULO VARCHAR(15),
    DESCR VARCHAR(60),
    LOTE VARCHAR(15),
    CANT NUMERIC(18,4),
    MONTO NUMERIC(18,2),
    DB CHAR(1))
AS
declare variable TOTAL NUMERIC(18,2);
declare variable CARTERA CHAR(1);
declare variable FECAUX DATE;
declare variable VENCEAUX DATE;
declare variable SUMA NUMERIC(18,2);
BEGIN
/* FACTURAS DEL RANGO QUE NO SE HAN TRANSMITIDO */ /*$$IBE$$ 
FOR SELECT FACT_ID, F.PREF_PRE, FACT_NUMERO, FACT_FECHA, FACT_VENCE, FACT_TOTAL, TERC_NIT, PREF_PROY, PREF_CENTRO, VEND_COD, BODE_COD, FACT_OBS
    FROM FACTURAS F, PREFIJOS P
    WHERE F.PREF_PRE = P.PREF_PRE AND P.TIDO_COD = 31 AND FACT_FECHA >= :INI AND FACT_FECHA <= :FIN AND FACT_TRANSMIT = 'N'
    INTO :IDDOC, :PREFIJO, :NUMERO, :FECAUX, :VENCEAUX, :TOTAL, :NIT, :PROY, :CENTRO, :VENDEDOR, :BODEGA, :OBSERVACION
    DO
    BEGIN
    EXECUTE PROCEDURE FECHA_A_CONTA(:FECAUX) returning_values (:FECHA);
    EXECUTE PROCEDURE FECHA_A_CONTA(:VENCEAUX) returning_values (:VENCE);
    SUMA = 0;
     $$IBE$$*/ /* VENTAS */ /*$$IBE$$ 
    FOR SELECT F.ARTI_COD, FADE_DESC, COAR_CTAVNT, FADE_LOTE, FADE_CANT, FADE_CANT * (FADE_PRUNIT - FADE_DTOMONTO), 'C'
        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
        WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
        INTO :ARTICULO, :DESCR, :CUENTA, :LOTE, :CANT, :MONTO, :DB
        DO
            BEGIN
            SUMA = SUMA + MONTO;
            SUSPEND;
            END
     $$IBE$$*/ /* IVA */ /*$$IBE$$ 
    FOR SELECT F.FADE_ITEM, F.ARTI_COD, FADE_DESC, COAR_CTAIVAV, FADE_LOTE, FADE_CANT, FADE_IVAMONTO, 'C'
        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
        WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
        INTO :ITEM, :ARTICULO, :DESCR, :CUENTA, :LOTE, :CANT, :MONTO, :DB
        DO 
            BEGIN
            SUMA = SUMA + MONTO;
            SUSPEND;
            END
     $$IBE$$*/ /* TOTAL */ /*$$IBE$$ 
    SELECT MAX(INVE_CARTERA), MAX(INVE_CTACARTERA)
    FROM INTERFAZ_VENTAS I
    WHERE TIDO_COD = 31 AND PREF_PRE = :PREFIJO
    INTO :CARTERA, :CUENTA;
    if (CARTERA = 'C') then
        SELECT TERC_CTACLIENTE FROM TERCEROS WHERE TERC_NIT = :NIT INTO :CUENTA;
    ARTICULO = '';
    DESCR = '';
    LOTE = '000';
    CANT = 0;
    MONTO = SUMA;
    DB = 'D';
    SUSPEND;
     $$IBE$$*/ /* INVENTARIO */ /*$$IBE$$ 
    EXECUTE PROCEDURE COSTO_EN_VENTAS(31, :IDDOC);
    FOR SELECT C.ARTI_COD, ARTI_DES, CTAINV, '000', CANT, CANT * COSTO, 'C'
        FROM COSTO_VENTAS C, ARTICULO A
        WHERE C.ARTI_COD = A.ARTI_COD
        INTO :ARTICULO, :DESCR, :CUENTA, :LOTE, :CANT, :MONTO, :DB
        DO SUSPEND;
     $$IBE$$*/ /* COSTO */ /*$$IBE$$ 
    FOR SELECT C.ARTI_COD, ARTI_DES, CTACOS, '000', CANT, CANT * COSTO, 'D'
        FROM COSTO_VENTAS C, ARTICULO A
        WHERE C.ARTI_COD = A.ARTI_COD
        INTO :ARTICULO, :DESCR, :CUENTA, :LOTE, :CANT, :MONTO, :DB
        DO SUSPEND;
    END
  SUSPEND;
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE CONTABIL_FACTURAS_CONTADO(
    FECFAC DATE,
    NIT VARCHAR(20),
    PREF VARCHAR(4),
    PTVTA INTEGER,
    IDINTER INTEGER)
RETURNS (
    ERROR INTEGER,
    VER CHAR(1),
    IDC INTEGER)
AS
declare variable num varchar(8);
declare variable numero varchar(10);
declare variable fecha char(8);
declare variable conc char(120);
declare variable vence char(8);
declare variable vrdto numeric(18,2);
declare variable vradic numeric(18,2);
declare variable vrsubt numeric(18,2);
declare variable vriva numeric(18,2);
declare variable prtfte numeric(9,2);
declare variable vrrtfte numeric(18,2);
declare variable vrrtiva numeric(18,2);
declare variable prtica numeric(9,2);
declare variable vrrtica numeric(18,2);
declare variable vrtotal numeric(18,2);
declare variable vrextra numeric(18,2);
declare variable tipocomp varchar(3);
declare variable prefcont varchar(4);
declare variable ventas char(1);
declare variable ctaventas varchar(20);
declare variable iva char(1);
declare variable ctaiva varchar(20);
declare variable consumo char(1);
declare variable ctaconsumo varchar(20);
declare variable cartera char(1);
declare variable ctacartera varchar(20);
declare variable rtfte char(1);
declare variable ctartfte varchar(20);
declare variable rtiva char(1);
declare variable ctartiva varchar(20);
declare variable rtica char(1);
declare variable ctartica varchar(20);
declare variable inven char(1);
declare variable ctainven varchar(20);
declare variable costos char(1);
declare variable ctacostos varchar(20);
declare variable ctadto varchar(20);
declare variable ctaadic varchar(20);
declare variable ctaextra varchar(20);
declare variable existe char(1);
declare variable cuenta varchar(20);
declare variable monto numeric(18,2);
declare variable tipocuen char(1);
declare variable nombre varchar(60);
declare variable proy varchar(4);
declare variable centro varchar(4);
declare variable porc numeric(5,2);
declare variable debito numeric(18,2);
declare variable credito numeric(18,2);
declare variable nroi integer;
declare variable art varchar(15);
declare variable impinc char(1);
declare variable imptos numeric(18,2);
declare variable suma numeric(18,2);
declare variable porciva numeric(9,2);
declare variable tctaclien varchar(20);
declare variable tctaventa varchar(20);
declare variable tctartfte varchar(20);
declare variable tctartiva varchar(20);
declare variable tctartica varchar(20);
declare variable ctadic varchar(20);
declare variable baseadic varchar(20);
declare variable porcadic numeric(5,2);
declare variable valoradic numeric(18,2);
declare variable dbadic char(1);
declare variable ptovta integer;
declare variable dig integer;
declare variable mercancia numeric(18,2);
declare variable factor double precision;
declare variable cent char(1);
BEGIN
/* BUSQUE LA INTERFACE */ /*$$IBE$$ 
EXISTE = 'N';
SELECT 'S', TICO_COD, PRCO_PRE, INVE_VENTAS, INVE_IVA, INVE_CONSUMO, INVE_CARTERA, INVE_RTFTE, INVE_RTIVA, INVE_RTICA, INVE_COSTO, INVE_INVEN, INVE_CTAVENTAS, INVE_CTAIVA, INVE_CTACONSUMO, INVE_CTADTO, INVE_CTAADIC, INVE_CTAEXTRA, INVE_CTACARTERA, INVE_CTARTFTE, INVE_CTARTIVA, INVE_CTARTICA, INVE_CTAINVEN, INVE_CTACOSTOS, INVE_CONFIRMAR, INVE_CENTRO
    FROM INTERFAZ_VENTAS
    WHERE INVE_ID = :IDINTER
    INTO :EXISTE, :TIPOCOMP, :PREFCONT, :VENTAS, :IVA, :CONSUMO, :CARTERA, :RTFTE, :RTIVA, :RTICA, :COSTOS, :INVEN, :CTAVENTAS, :CTAIVA, :CTACONSUMO, :CTADTO, :CTAADIC, :CTAEXTRA, :CTACARTERA, :CTARTFTE, :CTARTIVA, :CTARTICA, :CTAINVEN, :CTACOSTOS, :VER, :CENT;
if (EXISTE = 'S') then
  BEGIN
   $$IBE$$*/ /* BORRE CUALQUEIR CONTABILIZACION PREVIA */
/*  DELETE FROM CONTABILIZACION WHERE CNTB_TIPOREF = 31 AND CNTB_IDREF = 0;
  /* BUSQUE EL CENTRO DEL PUNTO, LA BODEGA, O EL PREFIJO  */ /*$$IBE$$ 
  IF (CENT = 'B') THEN
    SELECT B.BODE_CENTRO, B.BODE_PROY FROM BODEGA B, PUNTO_VENTA P
        WHERE B.BODE_COD = P.BODE_COD AND P.ptvt_id = :ptvta INTO :CENTRO, :PROY;
  IF (CENT = 'V') THEN
    SELECT MAX(V.CENT_COD), MAX(V.PROY_COD) FROM VENDEDORES V
        WHERE V.PTVT_ID = :PTVTA INTO :CENTRO, :PROY;
  IF (CENT = 'P') THEN
    SELECT P.PREF_PROY, P.PREF_CENTRO FROM PREFIJOS P
        WHERE P.PREF_PRE = :PREF AND P.TIDO_COD = 31 INTO :CENTRO, :PROY;
   $$IBE$$*/ /* TRAIGA LOS DATOS DEL CLIENTE */ /*$$IBE$$ 
  SELECT TERC_NOM, TERC_CTARTFTE, TERC_CTARTIVA, TERC_CTARTICA, TERC_CTAVENTA, TERC_CTACLIENTE
        FROM TERCEROS T WHERE TERC_NIT = :NIT
        INTO :NOMBRE, TCTARTFTE, TCTARTIVA, TCTARTICA, TCTAVENTA, TCTACLIEN;
  SELECT SUM(FACT_DTOMONTO), SUM(FACT_ADICIONAL), SUM(FACT_IVAMONTO), SUM(FACT_EXTRA), SUM(FACT_TOTAL), SUM(FACT_RTFTEMONTO), SUM(FACT_RTIVAMONTO), SUM(FACT_RTICAMONTO), MAX(FACT_IVAINC)
        FROM FACTURAS F WHERE FACT_FECHA = :FECFAC AND FACT_ANULADO = 'N' AND PTVT_ID = :ptvta AND PREF_PRE = :PREF
        INTO :VRDTO, :VRADIC, :VRIVA, :VREXTRA, :VRTOTAL, :VRRTFTE, :VRRTIVA, :VRRTICA, :impinc;
  VRSUBT = VRTOTAL - VREXTRA - VRIVA;  $$IBE$$*/ /* BASE DE RETEFTE Y RETEICA */ /*$$IBE$$ 
  MERCANCIA = VRSUBT - VRADIC + VRDTO;
  EXECUTE PROCEDURE FECHA_A_CONTA(:FECFAC) returning_values (:FECHA);
  VENCE = FECHA;
   $$IBE$$*/ /* REGISTRE EL ENCABEZADO CONTABLE */ /*$$IBE$$ 
  IDC = GEN_ID(ID_CONTABILIZA, 1);
  CONC = 'RESUMEN VENTAS ' || FECHA;
  NUM = SUBSTR(FECHA, 3, 8);
  INSERT INTO CONTABILIZACION (CNTB_ID, CNTB_TIPOCOMP, CNTB_PREFCNT, CNTB_NUMERO, CNTB_FECHA, CNTB_CONCEPTO, CNTB_REF, CNTB_TIPOREF, CNTB_IDREF, CNTB_PREFREF, CNTB_NUMREF, CNTB_PROCESADO)
        VALUES (:IDC, :TIPOCOMP, :PREFCONT, :NUM, :FECHA, :CONC, '', 0, 0, :PREF, :NUM, 'N');
  NROI = 0;
  SUMA = 0;
  ERROR = 0;
   $$IBE$$*/ /* SI NO HAY CUENTA DE DESCUENTO NI ADICIONAL CALCULE UN FACTOR PARA LAS VENTAS Y EL IVA */ /*$$IBE$$ 
  if (MERCANCIA <> 0) then
    FACTOR = CAST(VRSUBT AS DOUBLE PRECISION) / CAST(MERCANCIA AS DOUBLE PRECISION);
  ELSE
    FACTOR = 1;
   $$IBE$$*/ /* TRAIGA EL NUMERO DE DIGITOS PARA EL REDONDEO */ /*$$IBE$$ 
  SELECT CAST(CONF_VALOR AS INTEGER) FROM CONFIGURACION WHERE CONF_MODULO = 'FACTURACION' AND
        CONF_CATEGORIA = 'GENERAL' AND CONF_PROPIEDAD = 'REDONDEO AL MULTIPLO DE DIEZ EN TOTALES' INTO :DIG;
   $$IBE$$*/ /* CUENTAS DE VENTAS */ /*$$IBE$$ 
  if (VENTAS = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTAVNT), SUM(CAST(FADE_CANT AS DOUBLE PRECISION) * (FADE_PRUNIT-FADE_DTOMONTO)), SUM(FADE_IVAMONTO+FADE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE FD, FACTURAS F
            WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND FD.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FACT_ANULADO = 'N'
            GROUP BY COAR_CTAVNT
            INTO :CTAVENTAS, :MONTO, :IMPTOS
            DO
            BEGIN
            if (IMPINC = 'S') then
                MONTO = MONTO - IMPTOS;
            if ((CTADTO IS NULL) OR (CTADTO = '')) then
                MONTO = MONTO * FACTOR;
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (MONTO <> 0) then
                BEGIN
                CUENTA = NULL;
                SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                    WHERE CUEN_COD = :CTAVENTAS INTO :CUENTA, :TIPOCUEN;
                if (CUENTA IS NULL) then
                    begin
                    EXECUTE PROCEDURE ERROR (31, 0, :CTAVENTAS, 2);
                    CUENTA = CTAVENTAS;
                    TIPOCUEN = 'N';
                    ERROR = ERROR + 1;
                    end
                if (TIPOCUEN = 'I') then
                    BEGIN
                     $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                    FOR SELECT FD.ARTI_COD, (CAST(FADE_CANT AS DOUBLE PRECISION) * (FADE_PRUNIT-FADE_DTOMONTO)), (FADE_IVAMONTO+FADE_CONSUMO)
                        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE FD, FACTURAS F
                        WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FD.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAINV = :CUENTA AND FACT_ANULADO = 'N'
                        INTO :ART, :MONTO, :IMPTOS
                    DO
                        BEGIN
                        if (IMPINC = 'S') then
                            MONTO = MONTO - IMPTOS;
                        if ((CTADTO IS NULL) OR (CTADTO = '')) then
                            MONTO = MONTO * FACTOR;
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        if (MONTO <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            SUMA = SUMA - MONTO;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    SUMA = SUMA - MONTO;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - MONTO;
                    END
                END  $$IBE$$*/ /* MONTO <> 0 */ /*$$IBE$$ 
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        END  $$IBE$$*/ /* VENTAS X ARTICULO */ /*$$IBE$$ 
     IF ((VENTAS = 'C') OR (VENTAS = 'K')) THEN
        BEGIN
        IF (VENTAS = 'C') THEN
            CTAVENTAS = TCTAVENTA;
        SELECT SUM(CAST(FADE_CANT AS DOUBLE PRECISION) * (FADE_PRUNIT-FADE_DTOMONTO)), SUM(FADE_IVAMONTO+FADE_CONSUMO)
            FROM FACTURAS_DETALLE FD, FACTURAS F
            WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FACT_ANULADO = 'N'
            INTO :MONTO, :IMPTOS;
        if (IMPINC = 'S') then
            MONTO = MONTO - IMPTOS;
        if ((CTADTO IS NULL) OR (CTADTO = '')) then
            MONTO = MONTO * FACTOR;
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        if (MONTO <> 0) then
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTAVENTAS INTO :CUENTA, :TIPOCUEN;
            if (CUENTA IS NULL) then
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CTAVENTAS, 2);
                CUENTA = CTAVENTAS;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                BEGIN
                 $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                FOR SELECT FD.ARTI_COD, (CAST(FADE_CANT AS DOUBLE PRECISION) * (FADE_PRUNIT-FADE_DTOMONTO)), (FADE_IVAMONTO+FADE_CONSUMO)
                    FROM  $$IBE$$*/ /*ARTICULO A,*/ /*$$IBE$$  FACTURAS_DETALLE FD, FACTURAS F
                    WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FACT_ANULADO = 'N'
                    INTO :ART, :MONTO, :IMPTOS
                    DO
                    BEGIN
                    if (IMPINC = 'S') then
                        MONTO = MONTO - IMPTOS;
                    if ((CTADTO IS NULL) OR (CTADTO = '')) then
                        MONTO = MONTO * FACTOR;
                    execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                    if (MONTO <> 0) then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA - MONTO;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - MONTO;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - MONTO;
                END
            END  $$IBE$$*/ /* MONTO <> 0 */ /*$$IBE$$ 
        END  $$IBE$$*/ /* VENTAS DE CLIENTE O CONSTANTE */
    /* EL IVA EN VENTAS */ /*$$IBE$$ 
    if (IVA = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTAIVAV), SUM(FADE_IVAMONTO), SUM(CAST(FADE_CANT AS DOUBLE PRECISION) * (FADE_PRUNIT-FADE_DTOMONTO)), sum(FADE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE FD, FACTURAS F
            WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FD.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND FACT_ANULADO = 'N'
            GROUP BY COAR_CTAIVAV
            INTO :CTAIVA, :IMPTOS, :MONTO, :VALORADIC
        DO
            BEGIN
            if (IMPINC = 'S') then
                MONTO = MONTO - IMPTOS - VALORADIC;
            MONTO = MONTO * -1;
            MONTO = MONTO * FACTOR;
            IMPTOS = IMPTOS * FACTOR;
            execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (IMPTOS <> 0) then
                BEGIN
                CUENTA = NULL;
                SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                    WHERE CUEN_COD = :CTAIVA INTO :CUENTA, :TIPOCUEN;
                if (CUENTA IS NULL) then
                    begin
                    EXECUTE PROCEDURE ERROR (31, 0, :CTAIVA, 2);
                    CUENTA = CTAIVA;
                    TIPOCUEN = 'N';
                    ERROR = ERROR + 1;
                    end
                if (TIPOCUEN = 'I') then
                    BEGIN
                     $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                    FOR SELECT FD.ARTI_COD, FADE_IVAMONTO, (CAST(FADE_CANT AS DOUBLE PRECISION) * (FADE_PRUNIT-FADE_DTOMONTO)), TAIV_PORC, FADE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE FD, FACTURAS F, TARIFA_IVA T
                        WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FD.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAIVAV = :CUENTA AND A.TAIV_COD = T.TAIV_COD AND FACT_ANULADO = 'N'
                        INTO :ART, :IMPTOS, :MONTO, :PORCIVA, :VALORADIC
                    DO
                        BEGIN
                        if (IMPINC = 'S') then
                            MONTO = MONTO - IMPTOS - VALORADIC;
                        MONTO = MONTO * -1;
                        MONTO = MONTO * FACTOR;
                        IMPTOS = IMPTOS * FACTOR;
                        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        if (IMPTOS <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            SUMA = SUMA + DEBITO - CREDITO;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                END    $$IBE$$*/ /* IMPTOS <> 0 */ /*$$IBE$$ 
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        END  $$IBE$$*/ /* IVA X ARTICULO */ /*$$IBE$$ 
    if (IVA = 'K') then  $$IBE$$*/ /* IVA EN CTA CONSTANTE */ /*$$IBE$$ 
        BEGIN
        SELECT SUM(FADE_IVAMONTO), SUM(CAST(FADE_CANT AS DOUBLE PRECISION) * (FADE_PRUNIT-FADE_DTOMONTO)), SUM(FADE_CONSUMO)
            FROM FACTURAS_DETALLE FD, FACTURAS F
            WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FACT_ANULADO = 'N'
            INTO :IMPTOS, :MONTO, :valoradic;
        if (IMPINC = 'S') then
            MONTO = MONTO - IMPTOS - VALORADIC;
        MONTO = MONTO * -1;
        MONTO = MONTO * FACTOR;
        IMPTOS = IMPTOS * FACTOR;
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
        if (IMPTOS <> 0) then
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTAIVA INTO :CUENTA, :TIPOCUEN;
            if (CUENTA IS NULL) then
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CTAIVA, 2);
                CUENTA = CTAIVA;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                BEGIN
                 $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                FOR SELECT FD.ARTI_COD, (CAST(FADE_CANT AS DOUBLE PRECISION) * (FADE_PRUNIT-FADE_DTOMONTO)), FADE_IVAMONTO, TAIV_PORC, FADE_CONSUMO
                    FROM ARTICULO A, FACTURAS_DETALLE FD, FACTURAS F, TARIFA_IVA T
                    WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FD.arti_cod = A.arti_cod AND T.TAIV_COD=A.TAIV_COD AND FACT_ANULADO = 'N'
                    INTO :ART, :MONTO, :IMPTOS, :PORCIVA, :VALORADIC
                    DO
                    BEGIN
                    if (IMPINC = 'S') then
                        MONTO = MONTO - IMPTOS - VALORADIC;
                    MONTO = MONTO * -1;
                    MONTO = MONTO * FACTOR;
                    IMPTOS = IMPTOS * FACTOR;
                    execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                    execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                    if (IMPTOS <> 0) then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', 0, :IMPTOS, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA - IMPTOS;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            END  $$IBE$$*/ /* IMPTOS <> 0 */ /*$$IBE$$ 
        END  $$IBE$$*/ /* IVA EN CTA CONSTANTE */
    /* EL IMPOCONSUMO */ /*$$IBE$$ 
    if (CONSUMO = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTACONS), SUM(FADE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE FD, FACTURAS F
            WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FD.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND FACT_ANULADO = 'N'
            GROUP BY COAR_CTACONS
            INTO :CTACONSUMO, :IMPTOS
        DO
            BEGIN
            execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
            if (IMPTOS <> 0) then
                BEGIN
                CUENTA = NULL;
                SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                    WHERE CUEN_COD = :CTACONSUMO INTO :CUENTA, :TIPOCUEN;
                if (CUENTA IS NULL) then
                    begin
                    EXECUTE PROCEDURE ERROR (31, 0, :CTACONSUMO, 2);
                    CUENTA = CTACONSUMO;
                    TIPOCUEN = 'N';
                    ERROR = ERROR + 1;
                    end
                if (TIPOCUEN = 'I') then
                    BEGIN
                     $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                    FOR SELECT FD.ARTI_COD, FADE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE FD, FACTURAS F
                        WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FD.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTACONS = :CUENTA AND FACT_ANULADO = 'N'
                        INTO :ART, :IMPTOS
                    DO
                        BEGIN
                        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                        if (IMPTOS <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            SUMA = SUMA - IMPTOS;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - CREDITO;
                    END
                END  $$IBE$$*/ /* IMPTOS <> 0 */ /*$$IBE$$ 
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        END  $$IBE$$*/ /* CONSUMO X ARTICULO */ /*$$IBE$$ 
    if (CONSUMO = 'K') then  $$IBE$$*/ /* CONSUMO EN CTA CONSTANTE */ /*$$IBE$$ 
        BEGIN
        SELECT SUM(FADE_CONSUMO)
            FROM FACTURAS_DETALLE FD, FACTURAS F
            WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FACT_ANULADO = 'N'
            INTO :IMPTOS;
        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
        if (IMPTOS <> 0) then
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTACONSUMO INTO :CUENTA, :TIPOCUEN;
            if (CUENTA IS NULL) then
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CTACONSUMO, 2);
                CUENTA = CTACONSUMO;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                BEGIN
                 $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                FOR SELECT FD.ARTI_COD, FADE_CONSUMO
                    FROM  $$IBE$$*/ /*ARTICULO A,*/ /*$$IBE$$  FACTURAS_DETALLE FD, FACTURAS F
                    WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FACT_ANULADO = 'N'
                    INTO :ART, :IMPTOS
                    DO
                    BEGIN
                    execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                    if (IMPTOS <> 0) then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA - IMPTOS;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            END  $$IBE$$*/ /* IMPTOS <> 0 */ /*$$IBE$$ 
        END  $$IBE$$*/ /* CONSUMO EN CTA CONSTANTE */
    /* DESCUENTO */ /*$$IBE$$ 
    if ((CTADTO IS NOT NULL) AND (CTADTO <> '')) then
        BEGIN
        execute procedure redondee(VRDTO, DIG) returning_values (VRDTO);
        if (VRDTO <> 0) then
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTADTO INTO :CUENTA, :TIPOCUEN;
            if (CUENTA IS NULL) then
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CTADTO, 2);
                CUENTA = CTADTO;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CUENTA, 3);
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRDTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA + VRDTO;
                END
            if (TIPOCUEN = 'N') then
                    BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRDTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA + VRDTO;
                END
            END
        END  $$IBE$$*/ /* DESCUENTO */
    /* VALOR ADIC */ /*$$IBE$$ 
    if ((CTAADIC IS NOT NULL) AND (CTAADIC <> '')) then
        BEGIN
        execute procedure redondee(VRADIC, DIG) returning_values (VRADIC);
        if (VRADIC <> 0) THEN
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTAADIC INTO :CUENTA, :TIPOCUEN;
            if (CUENTA IS NULL) then
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CTAADIC, 2);
                CUENTA = CTAADIC;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CUENTA, 3);
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRADIC, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VRADIC;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRADIC, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VRADIC;
                END
            END
        END  $$IBE$$*/ /* VR. ADIC */
    /* VALOR EXTRA */ /*$$IBE$$ 
    if ((CTAEXTRA IS NOT NULL) AND (CTAEXTRA <> '')) THEN
        BEGIN
        execute procedure redondee(VREXTRA, DIG) returning_values (VREXTRA);
        if (VREXTRA <> 0) THEN
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTAEXTRA INTO :CUENTA, :TIPOCUEN;
            if (CUENTA IS NULL) then
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CTAEXTRA, 2);
                CUENTA = CTAEXTRA;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CUENTA, 3);
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VREXTRA, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VREXTRA;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VREXTRA, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VREXTRA;
                END
            END
        END  $$IBE$$*/ /* VR. EXTRA */
    /* RETENCION FUENTE */ /*$$IBE$$ 
    if ((RTFTE = 'C') or (RTFTE = 'K')) then
      BEGIN
      execute procedure redondee(VRRTFTE, DIG) returning_values (VRRTFTE);
      if (VRRTFTE <> 0) then
        BEGIN
        if (RTFTE = 'C') then
            CTARTFTE = TCTARTFTE;
        CUENTA = NULL;
        SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
            WHERE CUEN_COD = :CTARTFTE INTO :CUENTA, :TIPOCUEN;
        if (CUENTA IS NULL) then
            begin
            EXECUTE PROCEDURE ERROR (31, 0, :CTARTFTE, 2);
            CUENTA = CTARTFTE;
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            end
        if (TIPOCUEN = 'I') then
            begin
            EXECUTE PROCEDURE ERROR (31, 0, :CUENTA, 3);
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            end
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTFTE;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTFTE;
            END
        END  $$IBE$$*/ /* RTFTE */ /*$$IBE$$ 
      END
     $$IBE$$*/ /* RETENCION IVA */ /*$$IBE$$ 
    if ((RTIVA = 'C') or (RTIVA = 'K')) then
      BEGIN
      execute procedure redondee(VRRTIVA, DIG) returning_values (VRRTIVA);
      if (VRRTIVA <> 0) then
        BEGIN
        if (RTIVA = 'C') then
            CTARTIVA = TCTARTIVA;
        CUENTA = NULL;
        SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
            WHERE CUEN_COD = :CTARTIVA INTO :CUENTA, :TIPOCUEN;
        if (CUENTA IS NULL) then
            begin
            EXECUTE PROCEDURE ERROR (31, 0, :CTARTIVA, 2);
            CUENTA = CTARTIVA;
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            end
        if (TIPOCUEN = 'I') then
            begin
            EXECUTE PROCEDURE ERROR (31, 0, :CUENTA, 3);
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            end
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTIVA, 0, :VRIVA, :PORC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTIVA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTIVA, 0, :VRIVA, :PORC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTIVA;
            END
        END  $$IBE$$*/ /* RTIVA */ /*$$IBE$$ 
      END
     $$IBE$$*/ /* RETENCION DE ICA */ /*$$IBE$$ 
    if ((RTICA = 'C') or (RTICA = 'K')) then
      BEGIN
      execute procedure redondee(VRRTICA, DIG) returning_values (VRRTICA);
      if (VRRTICA <> 0) then
        BEGIN
        if (RTICA = 'C') then
            CTARTICA = TCTARTICA;
        CUENTA = NULL;
        SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
            WHERE CUEN_COD = :CTARTICA INTO :CUENTA, :TIPOCUEN;
        if (CUENTA IS NULL) then
            begin
            EXECUTE PROCEDURE ERROR (31, 0, :CTARTICA, 2);
            CUENTA = CTARTICA;
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            end
        if (TIPOCUEN = 'I') then
            begin
            EXECUTE PROCEDURE ERROR (31, 0, :CUENTA, 3);
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            end
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTICA, 0, :VRSUBT, :PRTICA, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTICA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTICA, 0, :VRSUBT, :PRTICA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTICA;
            END
        END  $$IBE$$*/ /* RTICA */ /*$$IBE$$ 
      END
     $$IBE$$*/ /* CIERRE EL COMPROBANTE CONTRA LA CUENTA DEL TERCERO O LA CONSTANTE */ /*$$IBE$$ 
    if ((SUMA <> 0) and ((CARTERA = 'C') or (CARTERA = 'K') or (CARTERA = 'J'))) then
        BEGIN
        if (SUMA < 0) then
            BEGIN
            DEBITO = SUMA * -1;
            CREDITO = 0;
            END
        ELSE
            BEGIN
            DEBITO = 0;
            CREDITO = SUMA;
            END
        if (CARTERA = 'C') then
            CTACARTERA = TCTACLIEN;
        if (CARTERA = 'J') then
            BEGIN
             $$IBE$$*/ /* BUSQUE LA CUENTA DE LA CAJA */ /*$$IBE$$ 
            SELECT CAJA_CUENTA FROM CAJAS C, PUNTO_VENTA P
                WHERE P.CAJA_ID = C.CAJA_ID AND PTVT_ID = :PTOVTA
                INTO :CTACARTERA;
            END
        CUENTA = NULL;
        SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
            WHERE CUEN_COD = :CTACARTERA INTO :CUENTA, :TIPOCUEN;
        if (CUENTA IS NULL) then
            begin
            EXECUTE PROCEDURE ERROR (31, 0, :CTACARTERA, 2);
            CUENTA = CTACARTERA;
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            end
        if (TIPOCUEN = 'I') then
            begin
            EXECUTE PROCEDURE ERROR (31, 0, :CUENTA, 3);
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            end
        if (TIPOCUEN = 'C') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
        if (TIPOCUEN = 'N') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
        NROI = NROI + 1;
        END  $$IBE$$*/ /* SUMA EN CARTERA */
    /* CALCULE LOS COSTOS */ /*$$IBE$$ 
    EXECUTE PROCEDURE costo_en_ventas_contado(:fecfac,  :pref, :ptvta);
    if (COSTOS = 'A') then
        BEGIN
        FOR SELECT MAX(CTACOS), SUM(COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTACOS
            INTO :CTACOSTOS, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                CUENTA = NULL;
                SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                    WHERE CUEN_COD = :CTACOSTOS INTO :CUENTA, :TIPOCUEN;
                IF (CUENTA IS NULL) THEN
                    begin
                    EXECUTE PROCEDURE ERROR (31, 0, :CTACOSTOS, 2);
                    CUENTA = CTARTFTE;
                    TIPOCUEN = 'N';
                    ERROR = ERROR + 1;
                    end
                if (TIPOCUEN = 'I') then
                    BEGIN
                     $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                    FOR SELECT ARTI_COD, CANT * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTACOS = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                END  $$IBE$$*/ /* MONTO <> 0 */ /*$$IBE$$ 
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        END  $$IBE$$*/ /* COSTOS */ /*$$IBE$$ 
    if (COSTOS = 'K') then
        BEGIN
        SELECT SUM(COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTACOSTOS INTO :CUENTA, :TIPOCUEN;
            IF (CUENTA IS NULL) THEN
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CTACOSTOS, 2);
                CUENTA = CTARTFTE;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                BEGIN
                 $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                FOR SELECT ARTI_COD, CANT * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            END  $$IBE$$*/ /* MONTO <> 0 */ /*$$IBE$$ 
        END  $$IBE$$*/ /* COSTOS = K */ /*$$IBE$$ 
    if (INVEN = 'A') then
        BEGIN
        FOR SELECT MAX(CTAINV), SUM(COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTAINV
            INTO :CTAINVEN, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                CUENTA = NULL;
                SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                    WHERE CUEN_COD = :CTAINVEN INTO :CUENTA, :TIPOCUEN;
                IF (CUENTA IS NULL) THEN
                    begin
                    EXECUTE PROCEDURE ERROR (31, 0, :CTAINVEN, 2);
                    CUENTA = CTAINVEN;
                    TIPOCUEN = 'N';
                    ERROR = ERROR + 1;
                    end
                if (TIPOCUEN = 'I') then
                    BEGIN
                     $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                    FOR SELECT ARTI_COD, CANT * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTAINV = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                END  $$IBE$$*/ /* MONTO <> 0 */ /*$$IBE$$ 
            END  $$IBE$$*/ /* FOR */ /*$$IBE$$ 
        END  $$IBE$$*/ /* INVEN = A */ /*$$IBE$$ 
    if (INVEN = 'K') then
        BEGIN
        SELECT SUM(COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTAINVEN INTO :CUENTA, :TIPOCUEN;
            IF (CUENTA IS NULL) THEN
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CTAINVEN, 2);
                CUENTA = CTAINVEN;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                BEGIN
                 $$IBE$$*/ /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */ /*$$IBE$$ 
                FOR SELECT ARTI_COD, CANT * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            END  $$IBE$$*/ /* MONTO <> 0 */ /*$$IBE$$ 
        END  $$IBE$$*/ /* INVEN = K */
    /* recorra las cuentas adicionales */ /*$$IBE$$ 
    FOR SELECT INVC_CUENTA, INVC_BASE, INVC_PORC, INVC_VALOR, INVC_DB
        FROM INTERFAZ_VENTAS_CTAS
        WHERE INVE_ID = :IDINTER
        INTO :CTADIC, :BASEADIC, :PORCADIC, :VALORADIC, :DBADIC
        DO
        BEGIN
        if (VALORADIC <> 0) then
            MONTO = VALORADIC;
        ELSE
            BEGIN
            if (:BASEADIC = 'SUBTOTAL') then
                VALORADIC = vrsubt;
            if (:BASEADIC = 'DESCUENTO') then
                VALORADIC = VRDTO;
            if (:BASEADIC = 'IVA') then
                VALORADIC = VRIVA;
            if (:BASEADIC = 'ADICIONAL') then
                VALORADIC = VRADIC;
            if (:BASEADIC = 'EXTRA') then
                VALORADIC = VREXTRA;
            if (:BASEADIC = 'TOTAL') then
                VALORADIC = VRTOTAL;
            MONTO = VALORADIC * PORCADIC / 100;
            END
        if (MONTO <> 0) then
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTADIC INTO :CUENTA, :TIPOCUEN;
            if (CUENTA IS NULL) then
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CTADIC, 2);
                CUENTA = CTADIC;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CUENTA, 3);
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'C') then
                BEGIN
                if (DBADIC = 'S') then
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                ELSE
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                if (DBADIC = 'S') then
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                ELSE
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            NROI = NROI + 1;
            END
        END
    if (ERROR > 0) then
        VER = 'S';
    SUSPEND;
    END  $$IBE$$*/ /* EXISTE LA INTERFAZ */ /*$$IBE$$ 
ELSE
    BEGIN
    EXECUTE PROCEDURE ERROR (31, 0, :PREF, 1);
    ERROR = ERROR + 1;
    VER = 'S';
    SUSPEND;
    END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE EXISTENCIAS_DESDE_HASTA(
    FECHA DATE,
    ARTINI VARCHAR(20),
    ARTFIN VARCHAR(20),
    GRPINI VARCHAR(3),
    GRPFIN VARCHAR(3),
    BODINI VARCHAR(2),
    BODFIN VARCHAR(2),
    ORDEN CHAR(1),
    AGRUPA CHAR(1),
    DETALLE CHAR(1),
    RESERVA CHAR(1),
    SUCURSAL INTEGER)
RETURNS (
    CANT NUMERIC(18,4),
    COSTO NUMERIC(18,2),
    COSTO_LOTE NUMERIC(18,2),
    CODIGO VARCHAR(15),
    NOMBRE VARCHAR(60),
    UNIDAD VARCHAR(8),
    STAND VARCHAR(15),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    CODBOD VARCHAR(2),
    LOTE VARCHAR(15),
    NOMBOD VARCHAR(30),
    COSTOTOT NUMERIC(18,2),
    ULTCOSTO NUMERIC(18,2),
    FECHACOSTO DATE,
    CONSUMO NUMERIC(18,2),
    RESERVADO NUMERIC(18,4),
    ORDENADO NUMERIC(18,4),
    IVA NUMERIC(9,2),
    CODBAR VARCHAR(20))
AS
declare variable exist char(1);
declare variable codini varchar(20);
declare variable codfin varchar(20);
declare variable desini varchar(20);
declare variable desfin varchar(20);
declare variable ordenc numeric(18,4);
declare variable pedido numeric(18,4);
declare variable ok char(1);
declare variable id integer;
declare variable item integer;
declare variable und varchar(8);
declare variable factor numeric(18,4);
declare variable cant2 numeric(18,4);
declare variable PEDAUTO CHAR(2);
BEGIN /*$$IBE$$ 
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'FACTURAS', 'GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') returning_values (pedauto);
if (DETALLE = 'B') then
  BEGIN
  FOR SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, ARTI_EXIST, TAIV_PORC, A.GRUP_COD, A.SUBG_COD, A.MARC_COD, BODE_COD, BODE_NOM, ARTI_CONSUMO
      FROM ARTICULO A, BODEGA B, TARIFA_IVA T
      WHERE ARTI_COD >= :CODINI AND ARTI_COD <= :CODFIN AND ARTI_DES >= :DESINI AND ARTI_DES <= :DESFIN AND ESAR_COD <> 'I' AND BODE_COD >= :BODINI AND
      BODE_COD <= :BODFIN AND ((SUCU_ID = :SUCURSAL) or (:SUCURSAL = 0)) AND A.TAIV_COD = T.TAIV_COD
      INTO :CODIGO, :NOMBRE, :UNIDAD, :EXIST, :IVA, :CODGRUPO, :CODSUBG, :CODMARC, :CODBOD, :NOMBOD, :CONSUMO
      DO
        BEGIN
        OK = 'N';
        if (AGRUPA = 'G') then
            BEGIN
            if ((CODGRUPO >= GRPINI) AND (CODGRUPO <= GRPFIN)) then
                OK = 'S';
            end
        ELSE
            if (AGRUPA = 'M') then
                BEGIN
                if ((CODMARC >= GRPINI) AND (CODMARC <= GRPFIN)) then
                    OK = 'S';
                END
        if (OK = 'S') then
            BEGIN
            NOMGRUPO = '';
            NOMMARC = '';
            NOMSUBG = '';
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SELECT MAX(COBA_COD) FROM BARRAS_ARTICULO WHERE ARTI_COD = :codigo AND COBA_UNIDAD = :unidad INTO :codbar;
            if (CODBAR IS NULL) then
                CODBAR = CODIGO;
            if (EXIST <> 'N') then
                BEGIN
                SELECT MAX(EXIS_STAND) FROM EXISTENCIA WHERE ARTI_COD = :CODIGO AND BODE_COD = :CODBOD INTO :STAND;
                EXECUTE PROCEDURE SALDO_INICIAL_INVENTARIO(CODIGO, FECHA, :CODBOD) returning_values (CANT);
                EXECUTE PROCEDURE COSTO_PROMEDIO_UNIDAD(CODIGO, FECHA, UNIDAD) returning_values (COSTO);
                EXECUTE PROCEDURE ULTIMO_COSTO(CODIGO, FECHA, UNIDAD) returning_values (ULTCOSTO);
                SELECT MAX(MVAR_FECHA) FROM MOVIMIENTO_ARTICULO WHERE ARTI_COD = :CODIGO AND MVAR_ENTRADA = 'S' AND MVAR_FECHA <= :FECHA INTO :FECHACOSTO;
                COSTOTOT = :CANT * :COSTO;
                CONSUMO = CONSUMO * CANT;
                if (RESERVA = 'S') then
                    BEGIN
                    SELECT SUM(ORID_ENTREGAR)
                        FROM ORDENINVENTARIO_DETALLE OD, ordenes_inventario O
                        WHERE O.ORIN_ID = OD.ORIN_ID AND ARTI_COD = :CODIGO AND ORIN_FECHA <= :FECHA AND ORIN_FECLLEGA >= :FECHA AND ORID_ANULADO = 'N' AND OD.BODE_COD = :CODBOD
                        INTO :ORDENADO;
                    if (ORDENADO IS NULL) then
                        ORDENADO = 0;
                    ORDENC = 0;
                    FOR SELECT O.ORDC_ID, OCDE_ITEM, OCDE_CANT * OCDE_FACTOR
                        FROM ORDENES_COMPRA O, ORDENES_COMPRA_DETALLE OD
                        WHERE O.ORDC_ID = OD.ORDC_ID AND OD.ARTI_COD = :CODIGO AND (ORDC_FECHA+ORDC_VALIDEZ) >= :FECHA AND ORDC_FECHA <= :FECHA AND OCDE_ANULADO = 'N' AND OD.BODE_COD = :CODBOD
                        INTO :ID, :ITEM, :CANT2
                        do
                        BEGIN
                        EXECUTE PROCEDURE FALTANTE(23, 21, ID, ITEM) returning_values (PEDIDO, UND, FACTOR);
                        if (PEDIDO * FACTOR = CANT2) then  $$IBE$$*/ /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */ /*$$IBE$$ 
                            EXECUTE PROCEDURE FALTANTE(23, 22, ID, ITEM) returning_values (PEDIDO, UND, FACTOR);
                        if (PEDIDO IS NULL) then
                            PEDIDO = 0;
                        ORDENC = ORDENC + PEDIDO * FACTOR;
                        END
                    ORDENADO = ORDENADO + ORDENC;
                    SELECT SUM(RSDE_LIBERAR)
                        FROM RESERVAS_DETALLE RD, RESERVAS R
                        WHERE R.RESE_ID = RD.RESE_ID AND ARTI_COD = :CODIGO AND RESE_FECHA <= :FECHA AND RESE_VENCE >= :FECHA AND RD.BODE_COD = :CODBOD AND RSDE_ANULADO = 'N'
                        INTO :RESERVADO;
                    if (RESERVADO IS NULL) then
                        RESERVADO = 0;
                    PEDIDO = 0;
                    FOR SELECT P.PEDI_ID, PEDE_ITEM, PEDE_CANT * PEDE_FACTOR
                        FROM PEDIDOS P, PEDIDOS_DETALLE PD
                        WHERE P.PEDI_ID = PD.PEDI_ID AND PD.ARTI_COD = :CODIGO AND (PEDI_FECHA+PEDI_VALIDEZ) >= :FECHA AND PEDI_FECHA <= :FECHA AND PEDE_ANULADO = 'N' AND BODE_COD = :CODBOD
                        INTO :ID, :ITEM, :CANT2
                        do
                        BEGIN
                        EXECUTE PROCEDURE FALTANTE(34, 31, ID, ITEM) returning_values (ORDENC, UND, FACTOR);
                        if ((ORDENC * FACTOR = CANT2) or (PEDAUTO = 'SI')) then  $$IBE$$*/ /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */ /*$$IBE$$ 
                            EXECUTE PROCEDURE FALTANTE(34, 32, ID, ITEM) returning_values (ORDENC, UND, FACTOR);
                        if (ORDENC IS NULL) then
                            ORDENC = 0;
                        PEDIDO = PEDIDO + ORDENC * FACTOR;
                        END
                    RESERVADO = RESERVADO + PEDIDO;
                    END
                ELSE
                    BEGIN
                    RESERVADO = 0;
                    ORDENADO = 0;
                    END
                SUSPEND;
                END
            END
        END
  END

if (DETALLE = 'L') then
  BEGIN
  FOR SELECT A.ARTI_COD, ARTI_DES, ARTI_UNIDAD, ARTI_EXIST, TAIV_PORC, A.GRUP_COD, A.SUBG_COD, A.MARC_COD, L.lote_nro, L.lote_nro||' - '||L.lote_vence, ARTI_CONSUMO,l.bode_cod, L.lote_saldo,l.lote_costo
      FROM ARTICULO A, LOTES l, TARIFA_IVA T
      WHERE A.ARTI_COD >= '0' AND A.ARTI_COD <= 'zz' AND ARTI_DES >= '' AND ARTI_DES <= 'zz' AND ESAR_COD <> 'I' AND A.TAIV_COD = T.TAIV_COD and a.arti_cod = l.arti_cod
      INTO :CODIGO, :NOMBRE, :UNIDAD, :EXIST, :IVA, :CODGRUPO, :CODSUBG, :CODMARC, :LOTE, :NOMBOD, :CONSUMO, :codbod, :cant, :costo_lote
      DO
        BEGIN
        OK = 'N';
        if (AGRUPA = 'G') then
            BEGIN
            if ((CODGRUPO >= GRPINI) AND (CODGRUPO <= GRPFIN)) then
                OK = 'S';
            end
        ELSE
            if (AGRUPA = 'M') then
                BEGIN
                if ((CODMARC >= GRPINI) AND (CODMARC <= GRPFIN)) then
                    OK = 'S';
                END
        if (OK = 'S') then
            BEGIN
            NOMGRUPO = '';
            NOMMARC = '';
            NOMSUBG = '';
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SELECT MAX(COBA_COD) FROM BARRAS_ARTICULO WHERE ARTI_COD = :codigo AND COBA_UNIDAD = :unidad INTO :codbar;
            if (CODBAR IS NULL) then
                CODBAR = CODIGO;

            if (EXIST <> 'N') then
                BEGIN
                EXECUTE PROCEDURE COSTO_PROMEDIO_UNIDAD(CODIGO, FECHA, UNIDAD) returning_values (COSTO);
                EXECUTE PROCEDURE ULTIMO_COSTO(CODIGO, FECHA, UNIDAD) returning_values (ULTCOSTO);
                SELECT MAX(MVAR_FECHA) FROM MOVIMIENTO_ARTICULO WHERE ARTI_COD = :CODIGO AND MVAR_ENTRADA = 'S' AND MVAR_FECHA <= :FECHA INTO :FECHACOSTO;
                COSTOTOT = :CANT * :COSTO;
                CONSUMO = CONSUMO * CANT;
                if (RESERVA = 'S') then
                    BEGIN
                    SELECT SUM(ORID_ENTREGAR)
                        FROM ORDENINVENTARIO_DETALLE OD, ordenes_inventario O
                        WHERE O.ORIN_ID = OD.ORIN_ID AND ARTI_COD = :CODIGO AND ORIN_FECHA <= :FECHA AND ORIN_FECLLEGA >= :FECHA AND ORID_ANULADO = 'N'
                        INTO :ORDENADO;
                    if (ORDENADO IS NULL) then
                        ORDENADO = 0;
                    ORDENC = 0;
                    FOR SELECT O.ORDC_ID, OCDE_ITEM, OCDE_CANT * OCDE_FACTOR
                        FROM ORDENES_COMPRA O, ORDENES_COMPRA_DETALLE OD
                        WHERE O.ORDC_ID = OD.ORDC_ID AND OD.ARTI_COD = :CODIGO AND (ORDC_FECHA+ORDC_VALIDEZ) >= :FECHA AND ORDC_FECHA <= :FECHA AND OCDE_ANULADO = 'N'
                        INTO :ID, :ITEM, :CANT2
                        do
                        BEGIN
                        EXECUTE PROCEDURE FALTANTE(23, 21, ID, ITEM) returning_values (PEDIDO, UND, FACTOR);
                        if (PEDIDO * FACTOR = CANT2) then  $$IBE$$*/ /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */ /*$$IBE$$ 
                            EXECUTE PROCEDURE FALTANTE(23, 22, ID, ITEM) returning_values (PEDIDO, UND, FACTOR);
                        if (PEDIDO IS NULL) then
                            PEDIDO = 0;
                        ORDENC = ORDENC + PEDIDO * FACTOR;
                        END
                    ORDENADO = ORDENADO + ORDENC;
                    SELECT SUM(RSDE_LIBERAR)
                        FROM RESERVAS_DETALLE RD, RESERVAS R
                        WHERE R.RESE_ID = RD.RESE_ID AND ARTI_COD = :CODIGO AND RESE_FECHA <= :FECHA AND RESE_VENCE >= :FECHA AND RSDE_ANULADO = 'N'
                        INTO :RESERVADO;
                    if (RESERVADO IS NULL) then
                        RESERVADO = 0;
                    PEDIDO = 0;
                    FOR SELECT P.PEDI_ID, PEDE_ITEM, PEDE_CANT * PEDE_FACTOR
                        FROM PEDIDOS P, PEDIDOS_DETALLE PD
                        WHERE P.PEDI_ID = PD.PEDI_ID AND PD.ARTI_COD = :CODIGO AND (PEDI_FECHA+PEDI_VALIDEZ) >= :FECHA AND PEDI_FECHA <= :FECHA AND PEDE_ANULADO = 'N'
                        INTO :ID, :ITEM, :CANT2
                        do
                        BEGIN
                        EXECUTE PROCEDURE FALTANTE(34, 31, ID, ITEM) returning_values (ORDENC, UND, FACTOR);
                        if ((ORDENC * FACTOR = CANT2) or (PEDAUTO = 'SI')) then  $$IBE$$*/ /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */ /*$$IBE$$ 
                            EXECUTE PROCEDURE FALTANTE(34, 32, ID, ITEM) returning_values (ORDENC, UND, FACTOR);
                        if (ORDENC IS NULL) then
                            ORDENC = 0;
                        PEDIDO = PEDIDO + ORDENC * FACTOR;
                        END
                    RESERVADO = RESERVADO + PEDIDO;
                    END
                ELSE
                    BEGIN
                    RESERVADO = 0;
                    ORDENADO = 0;
                    END
                SUSPEND;
                END
            END
        END
  end
if (DETALLE = 'N') then
  BEGIN
  FOR SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, ARTI_EXIST, TAIV_PORC, A.GRUP_COD, A.SUBG_COD, A.MARC_COD, ARTI_CONSUMO
      FROM ARTICULO A, TARIFA_IVA T
      WHERE ARTI_COD >= :CODINI AND ARTI_COD <= :CODFIN AND ARTI_DES >= :DESINI AND ARTI_DES <= :DESFIN AND ESAR_COD <> 'I' AND A.TAIV_COD = T.TAIV_COD
      INTO :CODIGO, :NOMBRE, :UNIDAD, :EXIST, :IVA, :CODGRUPO, :CODSUBG, :CODMARC, :CONSUMO
      DO
        BEGIN
        OK = 'N';
        if (AGRUPA = 'G') then
            BEGIN
            if ((GRPINI = '0') AND (GRPFIN = 'zz')) then
                OK = 'S';
            else
                if ((CODGRUPO >= GRPINI) AND (CODGRUPO <= GRPFIN)) then
                    OK = 'S';
            end
        ELSE
            if (AGRUPA = 'M') then
                BEGIN
                if ((GRPINI = '0') AND (GRPFIN = 'zzz')) then
                    OK = 'S';
                else
                    if ((CODMARC >= GRPINI) AND (CODMARC <= GRPFIN)) then
                        OK = 'S';
                END
        if (OK = 'S') then
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SELECT MAX(COBA_COD) FROM BARRAS_ARTICULO WHERE ARTI_COD = :codigo AND COBA_UNIDAD = :unidad INTO :codbar;
            if (CODBAR IS NULL) then
                CODBAR = CODIGO;

            if (EXIST <> 'N') then
                BEGIN
                EXECUTE PROCEDURE SALDO_INICIAL_TOTAL_INV(CODIGO, FECHA) returning_values (CANT);
                EXECUTE PROCEDURE COSTO_PROMEDIO_UNIDAD(CODIGO, FECHA, UNIDAD) returning_values (COSTO);
                EXECUTE PROCEDURE ULTIMO_COSTO(CODIGO, FECHA, UNIDAD) returning_values (ULTCOSTO);
                SELECT MAX(MVAR_FECHA) FROM MOVIMIENTO_ARTICULO WHERE ARTI_COD = :CODIGO AND MVAR_ENTRADA = 'S' AND MVAR_FECHA <= :FECHA INTO :FECHACOSTO;
                COSTOTOT = :CANT * :COSTO;
                CONSUMO = CONSUMO * CANT;
                if (RESERVA = 'S') then
                    BEGIN
                    SELECT SUM(ORID_ENTREGAR)
                        FROM ORDENINVENTARIO_DETALLE OD, ordenes_inventario O
                        WHERE O.ORIN_ID = OD.ORIN_ID AND ARTI_COD = :CODIGO AND ORIN_FECHA <= :FECHA AND ORIN_FECLLEGA >= :FECHA AND ORID_ANULADO = 'N'
                        INTO :ORDENADO;
                        if (ORDENADO IS NULL) then
                            ORDENADO = 0;
                    ORDENC = 0;
                    FOR SELECT O.ORDC_ID, OCDE_ITEM, OCDE_CANT * OCDE_FACTOR
                        FROM ORDENES_COMPRA O, ORDENES_COMPRA_DETALLE OD
                        WHERE O.ORDC_ID = OD.ORDC_ID AND OD.ARTI_COD = :CODIGO AND (ORDC_FECHA+ORDC_VALIDEZ) >= :FECHA AND ORDC_FECHA <= :FECHA AND OCDE_ANULADO = 'N'
                        INTO :ID, :ITEM, :CANT2
                        do
                        BEGIN
                        EXECUTE PROCEDURE FALTANTE(23, 21, ID, ITEM) returning_values (PEDIDO, UND, FACTOR);
                        if (PEDIDO * FACTOR = CANT2) then  $$IBE$$*/ /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */ /*$$IBE$$ 
                            EXECUTE PROCEDURE FALTANTE(23, 22, ID, ITEM) returning_values (PEDIDO, UND, FACTOR);
                        if (PEDIDO IS NULL) then
                            PEDIDO = 0;
                        ORDENC = ORDENC + PEDIDO * FACTOR;
                        END
                    ORDENADO = ORDENADO + ORDENC;
                    SELECT SUM(RSDE_LIBERAR)
                        FROM RESERVAS_DETALLE RD, RESERVAS R
                        WHERE R.RESE_ID = RD.RESE_ID AND ARTI_COD = :CODIGO AND RESE_FECHA <= :FECHA AND RESE_VENCE >= :FECHA AND RSDE_ANULADO = 'N'
                        INTO :RESERVADO;
                    if (RESERVADO IS NULL) then
                        RESERVADO = 0;
                    PEDIDO = 0;
                    FOR SELECT P.PEDI_ID, PEDE_ITEM, PEDE_CANT * PEDE_FACTOR
                        FROM PEDIDOS P, PEDIDOS_DETALLE PD, PUNTO_VENTA PT
                        WHERE P.PEDI_ID = PD.PEDI_ID AND PD.ARTI_COD = :CODIGO AND PT.ptvt_id = P.PTVT_ID AND (PEDI_FECHA+PEDI_VALIDEZ) >= :FECHA AND PEDI_FECHA <= :FECHA AND PEDE_ANULADO = 'N'
                        INTO :ID, :ITEM, :CANT2
                        do
                        BEGIN
                        EXECUTE PROCEDURE FALTANTE(34, 31, ID, ITEM) returning_values (ORDENC, UND, FACTOR);
                        if ((ORDENC * FACTOR = CANT2) or (PEDAUTO = 'SI')) then  $$IBE$$*/ /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */ /*$$IBE$$ 
                            EXECUTE PROCEDURE FALTANTE(34, 32, ID, ITEM) returning_values (ORDENC, UND, FACTOR);
                        if (ORDENC IS NULL) then
                            ORDENC = 0;
                        PEDIDO = PEDIDO + ORDENC * FACTOR;
                        END
                    if (PEDIDO IS NULL) then
                        PEDIDO = 0;
                    RESERVADO = RESERVADO + PEDIDO;
                    END
                ELSE
                    BEGIN
                    RESERVADO = 0;
                    ORDENADO = 0;
                    END
                SUSPEND;
                END
            END
        END
  END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE INVENTARIO_FAMILIA(
    FECHA DATE,
    FAMILIA VARCHAR(20))
RETURNS (
    ARTICULO VARCHAR(20),
    INTERNO VARCHAR(20),
    DESCRIPCION VARCHAR(60),
    CANTIDAD NUMERIC(18,2),
    UNIDAD VARCHAR(8),
    TOTAL NUMERIC(18,2))
AS
declare variable COSTO NUMERIC(18,4);
begin /*$$IBE$$ 
FOR SELECT A.ARTI_COD, ARTI_DES, ARTI_UNIDAD, p.pvar_cod FROM ARTICULO A, PROVEEDOR_ARTICULO P
    WHERE ESAR_COD <> 'I' AND A.arti_cod = P.arti_cod AND P.terc_nit = :FAMILIA
    INTO :ARTICULO, :descripcion, :UNIDAD, :INTERNO
    DO
    BEGIN
    EXECUTE PROCEDURE SALDO_INICIAL_TOTAL_INV(ARTICULO, FECHA) returning_values (cantidad);
    EXECUTE PROCEDURE COSTO_PROMEDIO_UNIDAD(ARTICULO, FECHA, UNIDAD) returning_values (COSTO);
    TOTAL = COSTO * CANTIDAD;
    suspend;
    END
 $$IBE$$*/ SUSPEND;
end
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE RECONTABILICE_COSTOS_VENTAS(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    IDC INTEGER)
AS
declare variable IDI INTEGER;
begin /*$$IBE$$ 
FOR SELECT FACT_ID, PREF_PRE, FACT_NUMERO FROM FACTURAS WHERE fact_anulado = 'N' and FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN ORDER BY FACT_FECHA, FACT_ID INTO :ID, :PREF, :NUMERO
do  
    BEGIN
    SELECT MAX(INVE_ID) FROM INTERFAZ_VENTAS WHERE PREF_PRE = :PREF AND TIDO_COD = 31 INTO :IDI;
    EXECUTE PROCEDURE CONTABILICE_COSTO_VENTAS(:ID, :IDI) returning_values (:IDC);
    suspend;
    END
 $$IBE$$*/ SUSPEND;
end
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE DEVOLUCIONES_SIN_CONTABILIDAD(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDI INTEGER,
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable FECICNT VARCHAR(10);
declare variable FECFCNT VARCHAR(10);
declare variable ERROR INTEGER;
declare variable idref INTEGER;
BEGIN /*$$IBE$$ 
EXECUTE PROCEDURE fecha_a_conta(FECINI) returning_values (FECICNT);
EXECUTE PROCEDURE fecha_a_conta(FECFIN) returning_values (FECFCNT);
FOR SELECT DEVT_ID, PREF_PRE, DEVT_NUMERO FROM devoluciones_ventas WHERE DEVT_ANULADO = 'N' AND
    DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN
    INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  idref = null;
  SELECT ENCO_IDREF FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 33 AND ENCO_FECHA >= :FECICNT AND ENCO_FECHA <= :FECFCNT and ENCO_IDREF = :id into :idref;
  if (idref IS NULL) then
  begin
   ESTADO = 'PROCESANDO';
   SUSPEND;
   SELECT MAX(INVE_ID) FROM INTERFAZ_VENTAS WHERE PREF_PRE = :PREF AND TIDO_COD = 33 INTO :IDI;
   EXECUTE PROCEDURE contabil_devolcli (:ID, :IDI) RETURNING_VALUES (:ERROR, :VER, :IDC);
   if (ERROR = 0) then
    BEGIN
    EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC);
    ESTADO = 'OK';
    END
   ELSE
    ESTADO = 'ERROR';
   suspend;
  End
  END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE FACTURAS_SIN_CONTABILIDAD(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDI INTEGER,
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable FECICNT VARCHAR(10);
declare variable FECFCNT VARCHAR(10);
declare variable ERROR INTEGER;
declare variable idref INTEGER;
BEGIN /*$$IBE$$ 
EXECUTE PROCEDURE fecha_a_conta(FECINI) returning_values (FECICNT);
EXECUTE PROCEDURE fecha_a_conta(FECFIN) returning_values (FECFCNT);
FOR SELECT FACT_ID, PREF_PRE, FACT_NUMERO FROM FACTURAS WHERE FACT_ANULADO = 'N' AND
    FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  idref = null;
  SELECT ENCO_IDREF FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 31 AND ENCO_FECHA >= :FECICNT AND ENCO_FECHA <= :FECFCNT and ENCO_IDREF = :ID into :idref;
  if (idref IS NULL) then
  begin
   ESTADO = 'PROCESANDO';
   ERROR = NULL;
   SUSPEND;
   SELECT MAX(INVE_ID) FROM INTERFAZ_VENTAS WHERE PREF_PRE = :PREF AND TIDO_COD = 31 INTO :IDI;
   EXECUTE PROCEDURE CONTABIL_FACTURA (:ID, :IDI) RETURNING_VALUES (:ERROR, VER, :IDC);
   if ((ERROR = 0) or (error IS NULL)) then
    BEGIN
    EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC);
    ESTADO = 'OK';
    END
   ELSE
    ESTADO = 'ERROR';
   suspend;
  end
  END
 $$IBE$$*/ SUSPEND;
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE ACTUALICE_COSTO(
    ARTICULO VARCHAR(15),
    FECHA DATE,
    COSTO NUMERIC(18,2),
    CANTIDAD NUMERIC(18,2),
    ENTRADA CHAR(1),
    ANULAR CHAR(1),
    IDMOV INTEGER,
    TIPO INTEGER)
AS
DECLARE VARIABLE saldo NUMERIC(18,2);
DECLARE VARIABLE COSTOP NUMERIC(18,2);
DECLARE VARIABLE exart CHAR(1);
DECLARE VARIABLE UCOSTO NUMERIC(18,2);
declare variable FECAUX DATE;
declare variable SALDOC NUMERIC(15,4);
declare variable ITEM INTEGER;
declare variable UNIDAD VARCHAR(8);
BEGIN
/* Verfique si el artculo tiene control de existencias */
SELECT arti_exist, ARTI_UNIDAD FROM articulo WHERE arti_COD = :articulo
    INTO :exart, :UNIDAD;
IF (exart <> 'N') THEN
    BEGIN
    if (ANULAR = 'S') then
        BEGIN
        select cost_saldoc, cost_saldop from costos
            WHERE (arti_cod = :articulo) AND (cost_fecha = :fecha) AND (cost_idmov = :IDMOV) AND (COST_TIPO = :TIPO)
            into :SALDOC, :SALDO; /* para dejar inicializadas las 2 variables */
        DELETE FROM COSTOS WHERE (arti_cod = :articulo) AND (cost_fecha = :fecha) AND (cost_idmov = :IDMOV) AND (COST_TIPO = :TIPO);
        /* para inicializar el ultimo costo */
        SELECT MAX(COST_FECHA) FROM costos
            WHERE (arti_cod = :articulo) AND (cost_fecha <= :fecha) INTO :FECAUX;
        if (FECAUX IS NULL) then
            UCOSTO = 0;
        ELSE
            BEGIN
            SELECT MAX(COST_ITEM) FROM costos
                WHERE (arti_cod = :articulo) AND (cost_fecha = :fecaux) INTO :ITEM;
            SELECT COST_ULTIMO FROM costos
                WHERE (arti_cod = :articulo) AND (cost_fecha = :fecaux) AND (cost_item = :ITEM) INTO :UCOSTO;
            END
        END
    ELSE
        BEGIN
        select max(cost_fecha) from costos WHERE (arti_cod = :articulo) AND (cost_fecha <= :fecha) into :fecaux;
        select max(cost_item) from costos WHERE (arti_cod = :articulo) AND (cost_fecha = :fecaux) into :item;
        select (cost_saldoc + cost_entc - cost_salc) from costos WHERE (arti_cod = :articulo) AND (cost_fecha = :fecaux) AND (cost_item = :item) into :saldoc;
        if (saldoc is null) THEN
            SALDOC = 0;
        EXECUTE PROCEDURE costo_promedio(:articulo, :fecha) RETURNING_VALUES :costop;
        if (ENTRADA = 'S') then
            if (TIPO = 33) then
                BEGIN
                EXECUTE PROCEDURE ULTIMO_COSTO(ARTICULO, FECHA, UNIDAD) returning_values (UCOSTO);
                INSERT INTO COSTOS (arti_cod, cost_fecha,
                    cost_entc, cost_entp, cost_salc, cost_salp,
                    cost_saldoc, cost_saldop, cost_ultimo, cost_idmov, cost_tipo)
                    VALUES (:articulo, :fecha, :cantidad, :cantidad*:costop, 0, 0, :saldoc, :saldoc*:costop, :ucosto, :IDMOV, :TIPO);
                SALDO = (SALDOC * COSTOP) + (CANTIDAD * COSTOP);
                SALDOC = SALDOC + CANTIDAD;
                END
            ELSE
                BEGIN
                UCOSTO = :COSTO;
                INSERT INTO COSTOS (arti_cod, cost_fecha,
                    cost_entc, cost_entp, cost_salc, cost_salp,
                    cost_saldoc, cost_saldop, cost_ultimo, cost_idmov, cost_tipo)
                    VALUES (:articulo, :fecha, :cantidad, :cantidad*:costo, 0, 0, :saldoc, :saldoc*:costop, :costo, :IDMOV, :TIPO);
                SALDO = (SALDOC * COSTOP) + (CANTIDAD * COSTO);
                SALDOC = SALDOC + CANTIDAD;
                END
        ELSE
            BEGIN
            EXECUTE PROCEDURE ULTIMO_COSTO(ARTICULO, FECHA, UNIDAD) returning_values (UCOSTO);
            INSERT INTO COSTOS (arti_cod, cost_fecha,
                cost_entc, cost_entp, cost_salc, cost_salp,
                cost_saldoc, cost_saldop, cost_ultimo, cost_idmov, cost_tipo)
                VALUES (:articulo, :fecha, 0, 0, :cantidad, :cantidad*:costop, :saldoc, :saldoc*:costop, :UCOSTO, :IDMOV, :TIPO);
            SALDOC = SALDOC - CANTIDAD;
            SALDO = SALDOC * COSTOP; /* YA ESTA RESTADA LA CANTIDAD */
            END
        END
    END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE CALCULA_PRECIOS(
    ARTICULO VARCHAR(20),
    FECHA DATE)
AS
declare variable LISTA INTEGER;
declare variable MARGEN NUMERIC(9, 4);
declare variable UTIL NUMERIC(9, 4);
declare variable UNIDAD VARCHAR(8);
declare variable UOR VARCHAR(20);
declare variable COSTOP NUMERIC(18, 2);
declare variable COSTOU NUMERIC(18, 2);
declare variable COSTO NUMERIC(18, 2);
declare variable DIG INTEGER;
declare variable IVAINC CHAR(1);
declare variable TARIVA NUMERIC(9,2);
declare variable AUTOM CHAR(1);
declare variable BASE varchar(10);
declare variable CAMBIO CHAR(7);
BEGIN
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','CAMBIO DE PRECIOS AUTOMATICO AL CAMBIAR COSTO O PRECIO') returning_values (CAMBIO);
if (CAMBIO = 'COSTO') then
  BEGIN
  FOR SELECT P.LIPR_COD, PRAR_MARGEN, PRAR_UTIL, LIPR_MODIF, PRAR_AUTO
    FROM PRECIOS_ARTICULO P, LISTA_PRECIOS L
    WHERE P.LIPR_COD = L.LIPR_COD AND ARTI_COD = :articulo
    INTO :LISTA, :MARGEN, :UTIL, :IVAINC, :AUTOM
    DO
      if (AUTOM = 'S') then
        BEGIN
        if (UTIL IS NULL) then
            UTIL = 0;
        if (MARGEN IS NULL) then
            MARGEN = 0;
        SELECT ARTI_UNIDAD, TAIV_PORC FROM ARTICULO A, TARIFA_IVA T WHERE A.TAIV_COD = T.TAIV_COD AND ARTI_COD = :ARTICULO INTO :UNIDAD, :TARIVA;
        EXECUTE PROCEDURE lee_configuracion('FACTURACION','ARTICULOS','COSTO BASE PARA CALCULO DE PRECIOS DE VENTA AUTOMATICOS') returning_values (:BASE);
            EXECUTE PROCEDURE COSTO_PROMEDIO (:ARTICULO, :FECHA) RETURNING_VALUES(:COSTOP);
            EXECUTE PROCEDURE ULTIMO_COSTO (:ARTICULO, :FECHA, :UNIDAD) RETURNING_VALUES(:COSTOU);
        if (base = 'ULTIMO') then
            COSTO = COSTOU;
        ELSE
            BEGIN
            COSTO = COSTOP;
            if (base = 'MAYOR') then
                if (COSTOP < COSTOU) then
                    COSTO = COSTOU;
            END
        if (IVAINC = 'S') then
            COSTO = COSTO * (1 + TARIVA/100);
        EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'ARTICULOS', 'SUGERIR PRECIOS CON PORCENTAJE DE MARGEN O UTILIDAD') RETURNING_VALUES (:UOR);
        EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'ARTICULOS', 'REDONDEO AL MULTIPLO DE DIEZ EN PRECIOS') RETURNING_VALUES (:DIG);
        if (UOR = 'UTILIDAD') then
            BEGIN
            COSTO = COSTO * (1 + :UTIL/100);
            EXECUTE PROCEDURE REDONDEE (COSTO, DIG) returning_values (COSTO);
            UPDATE PRECIOS_ARTICULO
                SET PRAR_FIJO = :COSTO
                WHERE ARTI_COD = :ARTICULO AND LIPR_COD = :LISTA;
            END
        ELSE
            BEGIN
            COSTO = COSTO / (1 - :MARGEN/100);
            EXECUTE PROCEDURE REDONDEE (COSTO, DIG) returning_values (COSTO);
            UPDATE PRECIOS_ARTICULO
                SET PRAR_FIJO = :COSTO
                WHERE ARTI_COD = :ARTICULO AND LIPR_COD = :LISTA;
            END
        END
  END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE COSTO_EN_VENTAS(
    TIPO INTEGER,
    ID INTEGER)
AS
declare variable FECHA DATE;
declare variable ARTICULO VARCHAR(20);
declare variable CANTIDAD NUMERIC(18,4);
declare variable COSTO NUMERIC(18,2);
declare variable CTACOSTO VARCHAR(20);
declare variable CTAINVEN VARCHAR(20);
BEGIN
DELETE FROM COSTO_VENTAS;
if (TIPO = 31) then
    BEGIN
    /* FACTURA DE VENTA */
    FOR SELECT D.ARTI_COD, FADE_CANT * FADE_FACTOR, COAR_CTACOS, COAR_CTAINV, FACT_FECHA
        FROM ARTICULO A, FACTURAS F, FACTURAS_DETALLE D, CONTABIL_ARTICULO C
        WHERE F.FACT_ID = D.FACT_ID AND A.ARTI_COD = D.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND F.FACT_ID = :ID AND FACT_ANULADO = 'N'
        INTO :ARTICULO, :CANTIDAD, :CTACOSTO, :CTAINVEN, :FECHA
        DO
        BEGIN
        EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
        INSERT INTO COSTO_VENTAS VALUES (:ARTICULO, :CANTIDAD, :COSTO, :CTACOSTO, :CTAINVEN);
        END
    END
if (TIPO = 32) then
    BEGIN
    /* REMISION */
    FOR SELECT D.ARTI_COD, RVDE_CANT * RVDE_FACTOR, COAR_CTACOS, COAR_CTAINV, REVT_FECHA
        FROM ARTICULO A, REMISIONES_VENTA R, REMISIONES_VENTA_DETALLE D, CONTABIL_ARTICULO C
        WHERE R.REVT_ID = D.REVT_ID AND A.ARTI_COD = D.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND R.REVT_ID = :ID AND REVT_ANULADO = 'N'
        INTO :ARTICULO, :CANTIDAD, :CTACOSTO, :CTAINVEN, :FECHA
        DO
        BEGIN
        EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
        INSERT INTO COSTO_VENTAS VALUES (:ARTICULO, :CANTIDAD, :COSTO, :CTACOSTO, :CTAINVEN);
        END
    END
if (TIPO = 33) then
    BEGIN
    /* DEVOLUCION */
    FOR SELECT D.ARTI_COD, DVDE_CANT * DVDE_FACTOR, COAR_CTACOS, COAR_CTAINV, DEVT_FECHA
        FROM ARTICULO A, DEVOLUCIONES_VENTAS DV, DEVOLUCIONES_VENTAS_DETALLE D, CONTABIL_ARTICULO C
        WHERE DV.DEVT_ID = D.DEVT_ID AND A.ARTI_COD = D.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND DV.DEVT_ID = :ID AND DEVT_ANULADO = 'N'
        INTO :ARTICULO, :CANTIDAD, :CTACOSTO, :CTAINVEN, :FECHA
        DO
        BEGIN
        EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
        INSERT INTO COSTO_VENTAS VALUES (:ARTICULO, :CANTIDAD, :COSTO, :CTACOSTO, :CTAINVEN);
        END
    END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE COSTO_EN_VENTAS_CONTADO(
    FECFAC DATE,
    PREF VARCHAR(4),
    PTVTA INTEGER)
AS
declare variable ARTICULO VARCHAR(20);
declare variable CANTIDAD NUMERIC(18,4);
declare variable COSTO NUMERIC(18,2);
declare variable CTACOSTO VARCHAR(20);
declare variable CTAINVEN VARCHAR(20);
BEGIN
    DELETE FROM COSTO_VENTAS;
    /* FACTURA DE VENTA */
    FOR SELECT MAX(D.ARTI_COD), SUM(FADE_CANT * FADE_FACTOR), MAX(COAR_CTACOS), MAX(COAR_CTAINV)
        FROM ARTICULO A, FACTURAS F, FACTURAS_DETALLE D, CONTABIL_ARTICULO C
        WHERE F.FACT_ID = D.FACT_ID AND A.ARTI_COD = D.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND FACT_ANULADO = 'N' AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA
        GROUP BY D.ARTI_COD
        INTO :ARTICULO, :CANTIDAD, :CTACOSTO, :CTAINVEN
        DO
        BEGIN
        EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECFAC) returning_values (:COSTO);
        INSERT INTO COSTO_VENTAS VALUES (:ARTICULO, :CANTIDAD, :COSTO * :CANTIDAD, :CTACOSTO, :CTAINVEN);
        END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE COSTO_PROMEDIO_UNIDAD(
    ARTICULO VARCHAR(15),
    FECHA DATE,
    UNIDAD VARCHAR(8))
RETURNS (
    COSTO NUMERIC(18,2))
AS
declare variable FACTOR NUMERIC(15,4);
BEGIN
  EXECUTE PROCEDURE COSTO_PROMEDIO(ARTICULO, FECHA) returning_values (COSTO);
  EXECUTE PROCEDURE FACTOR_UNIDAD_CANT(ARTICULO, UNIDAD) returning_values (FACTOR);
  COSTO = COSTO * FACTOR;
  SUSPEND;
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE IMPR_AJUSTE(
    ID INTEGER)
RETURNS (
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    CONCEPTO VARCHAR(60),
    CODBODEGA VARCHAR(2),
    NOMBODEGA VARCHAR(30),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    EXANT NUMERIC(18,4),
    EXNUE NUMERIC(18,4),
    UNIDAD VARCHAR(8),
    BODITEM VARCHAR(2),
    LOTE VARCHAR(15),
    COSTO NUMERIC(18,2),
    TOTAL NUMERIC(18,2))
AS
DECLARE VARIABLE ITEMS INTEGER;
DECLARE VARIABLE MAX_AJUSTE INTEGER;
BEGIN
  /*  */
  SELECT PREF_PRE, AJUS_NUMERO, AJUS_FECHA, AJUS_CONC, A.BODE_COD, BODE_NOM, AJUS_OBS
    FROM AJUSTES A, BODEGA B WHERE A.BODE_COD = B.BODE_COD AND A.AJUS_ID = :ID into
    :PREF, :NUMERO, :FECHA, :CONCEPTO, :CODBODEGA, :NOMBODEGA, :OBS;
  FOR SELECT AJUS_ITEM, A.ARTI_COD, AJUS_CODBAR, AJDE_DESC, AJUS_EXANT, AJUS_UNIDAD, BODE_COD, AJUS_EXNUE, AJUS_LOTE
    FROM AJUSTES_DETALLE D, ARTICULO A
    WHERE D.ARTI_COD = A.ARTI_COD AND D.AJUS_ID = :ID
    ORDER BY AJUS_ITEM
    INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :EXANT, :UNIDAD, :BODITEM, :EXNUE, :LOTE
    DO
      BEGIN
      EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
      TOTAL = (EXNUE - EXANT) * COSTO;
      SUSPEND;
      END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE ORDENES_ARTICULO(
    FECHA DATE,
    DETALLE CHAR(1))
RETURNS (
    CODIGO VARCHAR(15),
    NOMBRE VARCHAR(60),
    ORDEN NUMERIC(18,4),
    EXIST NUMERIC(18,2),
    SUMA NUMERIC(18,2),
    COSTO NUMERIC(18,2),
    UNIDAD VARCHAR(8),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    COSTOTOT NUMERIC(18,2),
    CLIENTE VARCHAR(60),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHADOC DATE)
AS
declare variable ORDENC NUMERIC(18,4);
declare variable ID INTEGER;
declare variable ITEM INTEGER;
declare variable UND VARCHAR(8);
declare variable FACTOR NUMERIC(18,4);
declare variable FACT NUMERIC(18,4);
declare variable CANT NUMERIC(18,4);
BEGIN
  FOR
    SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD
      FROM ARTICULO A
      INTO :CODIGO, :NOMBRE, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
      DO
        BEGIN
        EXECUTE PROCEDURE SALDO_TOTAL_INVENTARIO(CODIGO, FECHA) returning_values (EXIST);
        EXECUTE PROCEDURE COSTO_PROMEDIO(CODIGO, FECHA) returning_values (COSTO);
        if (DETALLE = 'N') then
            BEGIN
            NOMMARC = '';
            NOMSUBG = '';
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SELECT SUM(ORID_ENTREGAR) FROM ordenes_inventario O, ordeninventario_detalle OD
                WHERE O.ORIN_ID = OD.ORIN_ID AND OD.ARTI_COD = :CODIGO AND ORIN_FECHA <= :FECHA AND ORIN_FECLLEGA >= :FECHA AND ORIN_ANULADO = 'N'
                INTO :ORDEN;
            if (ORDEN IS NULL) then
                ORDEN = 0;
            FOR SELECT O.ORDC_ID, OCDE_ITEM, OCDE_CANT * OCDE_FACTOR
                FROM ORDENES_COMPRA O, ORDENES_COMPRA_DETALLE OD
                WHERE O.ORDC_ID = OD.ORDC_ID AND OD.ARTI_COD = :CODIGO AND (ORDC_FECHA+ORDC_VALIDEZ) >= :FECHA AND ORDC_FECHA <= :FECHA AND ORDC_ANULADO = 'N'
                INTO :ID, :item, :CANT
                DO
                BEGIN
                EXECUTE PROCEDURE FALTANTE(23, 21, ID, ITEM) returning_values (ORDENC, UND, FACT);
                if (ORDENC * FACT = CANT) then
                    EXECUTE PROCEDURE FALTANTE(23, 22, ID, ITEM) returning_values (ORDENC, UND, FACT);
                if (ORDENC IS NULL) then
                    ORDENC = 0;
                if (ORDENC <> 0) then
                    BEGIN
                    ORDEN = ORDEN + ORDENC;
                    END
                END
            SUMA = ORDEN + EXIST;
            COSTOTOT = ORDEN * :COSTO;
            if (ORDEN <> 0) then
                SUSPEND;
            END
        ELSE
            BEGIN
            FOR SELECT ORIN_FECHA, PREF_PRE, ORIN_NUMERO, ORIN_NOMTERC, ORID_CANT, ORID_UNIDAD, ORID_ENTREGAR
                FROM ordenes_inventario O, ordeninventario_detalle OD
                WHERE O.ORIN_ID = OD.ORIN_ID AND OD.ARTI_COD = :CODIGO AND ORIN_FECHA <= :FECHA AND ORIN_FECLLEGA > :FECHA AND ORIN_ANULADO = 'N'
                INTO :FECHADOC, :PREFIJO, :NUMERO, :CLIENTE, :EXIST, :UNIDAD, :ORDEN
                DO
                BEGIN
                COSTOTOT = ORDEN * :COSTO;
                SUSPEND;
                END
            FOR SELECT O.ORDC_ID, OCDE_ITEM, ORDC_FECHA, PREF_PRE, ORDC_NUMERO, TERC_NOM, OCDE_CANT, OCDE_UNIDAD, OCDE_ORDENADO, OCDE_FACTOR
                FROM ordenes_compra O, ordenes_compra_detalle OD, TERCEROS T
                WHERE O.ORDC_ID = OD.ORDC_ID AND OD.ARTI_COD = :CODIGO AND O.TERC_NIT = T.TERC_NIT AND ORDC_FECHA <= :FECHA AND (ORDC_FECHA+ordc_validez) > :FECHA AND ORDC_ANULADO = 'N'
                INTO :ID, :ITEM, :FECHADOC, :PREFIJO, :NUMERO, :CLIENTE, :CANT, :UNIDAD, :ORDEN, :FACTOR
                DO
                BEGIN
                EXECUTE PROCEDURE FALTANTE(23, 21, ID, ITEM) returning_values (ORDEN, UND, FACT);
                if (ORDEN * FACT = CANT * FACTOR) then
                    EXECUTE PROCEDURE FALTANTE(23, 22, ID, ITEM) returning_values (ORDEN, UND, FACTOR);
                if (ORDEN IS NULL) then
                    ORDEN = 0;
                COSTOTOT = ORDEN * :COSTO;
                if (ORDEN <> 0) then
                    SUSPEND;
                END
            END
        END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE REP_COMPROBANTES_ARTICULO(
    TIPODOC INTEGER,
    DETALLE CHAR(1),
    FECINI DATE,
    FECFIN DATE,
    ARTINI VARCHAR(20),
    ARTFIN VARCHAR(20),
    GRPINI VARCHAR(2),
    GRPFIN VARCHAR(2),
    ORDEN CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    CODIGO VARCHAR(15),
    NOMBRE VARCHAR(60),
    UNIDAD VARCHAR(8),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    CODBOD VARCHAR(2),
    NOMTIPO VARCHAR(30),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    CONCEPTO VARCHAR(60),
    NIT VARCHAR(20),
    NOMTERC VARCHAR(60),
    CONS INTEGER,
    CANT NUMERIC(18,4),
    COSTO NUMERIC(18,2),
    COSTOTOT NUMERIC(18,2))
AS
declare variable ENT CHAR(1);
declare variable ENTRADAS NUMERIC(18,4);
declare variable COSTOENT NUMERIC(18,2);
declare variable SALIDAS NUMERIC(18,4);
declare variable COSTOSAL NUMERIC(18,2);
declare variable CODINI VARCHAR(20);
declare variable CODFIN VARCHAR(20);
declare variable DESINI VARCHAR(20);
declare variable DESFIN VARCHAR(20);
BEGIN
  SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPODOC INTO :NOMTIPO;
  if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
  ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END
  FOR
    SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD
      FROM ARTICULO A
      WHERE ARTI_COD >= :CODINI AND ARTI_COD <= :CODFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :GRPFIN AND ARTI_DES >= :DESINI AND ARTI_DES <= :DESFIN
      INTO :CODIGO, :NOMBRE, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
      DO
        BEGIN
        NOMMARC = '';
        NOMSUBG = '';
        SELECT GRUP_NOM FROM GRUPO WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
        if (DETALLE = 'N') then
            BEGIN
            CANT = 0;
            COSTOTOT = 0;
            /* SUME LAS ENTRADAS */
            SELECT SUM(MVAR_CANT), SUM(MVAR_CANT * MVAR_COSTO) FROM MOVIMIENTO_ARTICULO M, PREFIJOS P
              WHERE P.PREF_PRE = M.MVAR_PREF AND P.TIDO_COD = M.mvar_tipodoc AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA)) AND
              (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA < :FECFIN) AND
              (ARTI_COD = :CODIGO) AND (MVAR_ENTRADA = 'S') AND (MVAR_TIPODOC = :TIPODOC)
              INTO :ENTRADAS, :COSTOENT;
            if (ENTRADAS IS NULL) then
              ENTRADAS = 0;
            if (COSTOENT IS NULL) then
              COSTOENT = 0;
            /* CALCULE LAS SALIDAS A COSTO PROMEDIO */
            SALIDAS = 0;
            COSTOSAL = 0;
            FOR SELECT MVAR_CANT, MVAR_FECHA
                FROM MOVIMIENTO_ARTICULO M, PREFIJOS P
                WHERE P.PREF_PRE = M.MVAR_PREF AND P.TIDO_COD = M.mvar_tipodoc AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA)) AND
                (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA <= :FECFIN) AND
                (ARTI_COD = :CODIGO) AND (MVAR_ENTRADA = 'N') AND (MVAR_TIPODOC = :TIPODOC)
                INTO :CANT, :FECHA
                DO
                    BEGIN
                    EXECUTE PROCEDURE COSTO_PROMEDIO(:CODIGO, :FECHA) returning_values (:COSTO);
                    SALIDAS = SALIDAS + CANT;
                    COSTOSAL = COSTOSAL + (COSTO * CANT);
                    END
            if (SALIDAS IS NULL) then
              SALIDAS = 0;
            if (COSTOSAL IS NULL) then
              COSTOSAL = 0;
            if (ENTRADAS > 0) then
                CANT = ENTRADAS;
            if (SALIDAS > 0) then
                CANT = SALIDAS;
            if (COSTOENT > 0) then
                COSTOTOT = COSTOENT;
            if (COSTOSAL > 0) then
                COSTOTOT = COSTOSAL;
            if (CANT > 0) then
                COSTO = COSTOTOT / CANT;
            ELSE
                COSTO = 0;
            if (CANT <> 0) then
                SUSPEND;
            END
        ELSE
            BEGIN
            FOR SELECT MVAR_ENTRADA, MVAR_PREF, MVAR_NUMERO, MVAR_CANT, MVAR_COSTO, MVAR_CONC, MVAR_FECHA, M.TERC_NIT, TERC_NOM, MVAR_CONS, BODE_COD
                FROM MOVIMIENTO_ARTICULO M, TIPO_DOCUMENTO TD, PREFIJOS P
                LEFT OUTER JOIN TERCEROS T ON (M.TERC_NIT = T.TERC_NIT)
                WHERE TD.TIDO_COD = MVAR_TIPODOC AND P.PREF_PRE = M.MVAR_PREF AND P.TIDO_COD = M.mvar_tipodoc AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA)) AND
                (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA < :FECFIN) AND (ARTI_COD = :CODIGO) AND (MVAR_TIPODOC = :TIPODOC)
                ORDER BY MVAR_FECHA, MVAR_CONS
                INTO :ENT, :PREFIJO, :NUMERO, :CANT, :COSTO, :CONCEPTO, :FECHA, :NIT, :NOMTERC, :CONS, :CODBOD
                DO
                    BEGIN
                    if (ENT = 'S') then
                        BEGIN
                        COSTOTOT = (CANT * COSTO);
                        end
                    ELSE
                        BEGIN
                        EXECUTE PROCEDURE COSTO_PROMEDIO(:CODIGO, :FECHA) returning_values (:COSTO);
                        COSTOTOT = (CANT * COSTO);
                        END
                    SUSPEND;
                    END
            END
        END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE REP_COMPROBANTES_INV(
    TIPO INTEGER,
    DETALLE CHAR(1),
    FECINI DATE,
    FECFIN DATE,
    PREFIJO VARCHAR(4),
    ANULADOS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    NOMTIPO VARCHAR(30),
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    VENCE DATE,
    CONCEPTO VARCHAR(60),
    REFER VARCHAR(60),
    CODBODORI VARCHAR(2),
    NOMBODORI VARCHAR(30),
    CODBODDES VARCHAR(2),
    NOMBODDES VARCHAR(30),
    NOMTERCERO VARCHAR(60),
    PRODCODBAR VARCHAR(15),
    PRODDES VARCHAR(60),
    PRODCANT NUMERIC(18,4),
    PRODUNIDAD VARCHAR(8),
    PRODLOTE VARCHAR(15),
    OBS BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    EXANT NUMERIC(18,4),
    UNIDAD VARCHAR(8),
    BODITEM VARCHAR(2),
    COSTO NUMERIC(18,2),
    DTOPORC NUMERIC(9,2),
    DTOMONTO NUMERIC(18,2),
    IVAPORC NUMERIC(9,2),
    IVAMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    SUBTOTAL NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    LOTE VARCHAR(15),
    ANULADO CHAR(1),
    OBSITEM BLOB SUB_TYPE 0 SEGMENT SIZE 80)
AS
BEGIN
  /* DETERMINE LA TABLA A EXAMINAR */
  if (BIN_AND(TIPO, 1) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 11 INTO :NOMTIPO;
    FOR SELECT ENTR_ID, E.PREF_PRE, ENTR_NUMERO, ENTR_FECHA, ENTR_CONC, ENTR_REFER, E.BODE_COD, BODE_NOM, ENTR_NOMTERC, ENTR_OBS, ENTR_ANULADO
    FROM ENTRADAS E, BODEGA B, PREFIJOS P
    WHERE E.BODE_COD = B.BODE_COD AND ENTR_FECHA >= :FECINI AND ENTR_FECHA <= :FECFIN
     AND P.PREF_PRE = E.PREF_PRE AND P.TIDO_COD = 11 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY ENTR_FECHA, ENTR_ID
    INTO :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :NOMTERCERO, :OBS, :ANULADO
    DO
        BEGIN
        if (((:PREFIJO = '') or (:PREF = :PREFIJO)) AND ((:ANULADOS = 'S') or (:ANULADO = 'N'))) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT ENDE_ITEM, A.ARTI_COD, ENDE_CODBAR, ENDE_DESC, ENDE_CANT, ENDE_UNIDAD, BODE_COD, ENDE_COSTO, ENDE_DTOPORC, ENDE_DTOMONTO, ENDE_IVAPORC, ENDE_IVAMONTO, ENDE_CONSUMO, ENDE_TOTAL, ENDE_LOTE, ENDE_OBS
                    FROM ENTRADAS_DETALLE D, ARTICULO A WHERE D.ARTI_COD = A.ARTI_COD AND D.ENTR_ID = :ID INTO
                    :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :COSTO, :DTOPORC, :DTOMONTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :LOTE, :OBSITEM
                    DO
                    BEGIN
                    SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                    SUSPEND;
                    END
              ELSE
                BEGIN
                SELECT SUM(ENDE_IVAMONTO), SUM(ENDE_CONSUMO), SUM(ENDE_TOTAL)
                    FROM ENTRADAS_DETALLE D WHERE D.ENTR_ID = :ID INTO
                    :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 2) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 12 INTO :NOMTIPO;
    FOR SELECT SALI_ID, S.PREF_PRE, SALI_NUMERO, SALI_FECHA, SALI_CONC, SALI_REFER, S.BODE_COD, BODE_NOM, SALI_NOMTERC, SALI_OBS, SALI_ANULADO
    FROM SALIDAS S, BODEGA B, PREFIJOS P
    WHERE S.BODE_COD = B.BODE_COD AND SALI_FECHA >= :FECINI AND SALI_FECHA <= :FECFIN 
     AND P.PREF_PRE = S.PREF_PRE AND P.TIDO_COD = 12 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY SALI_FECHA, SALI_ID
    into :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :NOMTERCERO, :OBS, :ANULADO
    DO
        BEGIN
        if (((:PREFIJO = '') or (:PREF = :PREFIJO)) AND ((:ANULADOS = 'S') or (:ANULADO = 'N'))) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              EXANT = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT SADE_ITEM, A.ARTI_COD, SADE_CODBAR, SADE_DESC, SADE_CANT, SADE_UNIDAD, BODE_COD, SADE_COSTO, SADE_IVAPORC, SADE_IVAMONTO, SADE_CONSUMO, SADE_TOTAL, SADE_LOTE, SADE_OBS
                    FROM SALIDAS_DETALLE D, ARTICULO A WHERE D.ARTI_COD = A.ARTI_COD AND D.SALI_ID = :ID INTO
                    :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :COSTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :LOTE, :OBSITEM
                    DO
                BEGIN
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
              ELSE
                BEGIN
                SELECT SUM(SADE_IVAMONTO), SUM(SADE_CONSUMO), SUM(SADE_TOTAL)
                    FROM SALIDAS_DETALLE D WHERE D.SALI_ID = :ID INTO
                    :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 4) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 13 INTO :NOMTIPO;
    FOR SELECT TRAN_ID, T.PREF_PRE, TRAN_NUMERO, TRAN_FECHA, TRAN_CONC, TRAN_REFER, T.BODE_COD, BO.BODE_NOM, TRAN_BODDES, BD.BODE_NOM, TRAN_OBS, TRAN_ANULADO
    FROM TRASFERENCIAS T, BODEGA BO, BODEGA BD, PREFIJOS P
    WHERE T.BODE_COD = BO.BODE_COD AND T.TRAN_BODDES = BD.BODE_COD AND TRAN_FECHA >= :FECINI AND TRAN_FECHA <= :FECFIN 
     AND P.PREF_PRE = T.PREF_PRE AND P.TIDO_COD = 13 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY TRAN_FECHA, TRAN_ID
    into :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :CODBODDES, :NOMBODDES, :OBS, :ANULADO
    DO
        BEGIN
        if (((:PREFIJO = '') or (:PREF = :PREFIJO)) AND ((:ANULADOS = 'S') or (:ANULADO = 'N'))) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              EXANT = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT TRAS_ITEM, A.ARTI_COD, TRAS_CODBAR, TRAS_DESC, TRAS_CANT, TRAS_UNIDAD, TRAS_COSTO, TRAS_IVAPORC, TRAS_IVAMONTO, TRAS_CONSUMO, TRAS_TOTAL, TRAS_LOTE, TRAS_OBS
                    FROM TRASFERENCIAS_DETALLE D, ARTICULO A WHERE D.ARTI_COD = A.ARTI_COD AND D.TRAN_ID = :ID INTO
                    :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :COSTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :LOTE, :OBSITEM
                    DO
                    BEGIN
                    SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                    SUSPEND;
                    END
              ELSE
                BEGIN
                SELECT SUM(TRAS_IVAMONTO), SUM(TRAS_CONSUMO), SUM(TRAS_TOTAL) FROM trasferencias_detalle D
                    WHERE D.TRAN_ID = :ID INTO :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 8) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 14 INTO :NOMTIPO;
    FOR SELECT AJUS_ID, A.PREF_PRE, AJUS_NUMERO, AJUS_FECHA, AJUS_CONC, A.BODE_COD, BODE_NOM, AJUS_OBS, AJUS_ANULADO
    FROM AJUSTES A, BODEGA B, PREFIJOS P
    WHERE A.BODE_COD = B.BODE_COD AND AJUS_FECHA >= :FECINI AND AJUS_FECHA <= :FECFIN 
     AND P.PREF_PRE = A.PREF_PRE AND P.TIDO_COD = 14 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY AJUS_FECHA, AJUS_ID
    into :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :CODBODORI, :NOMBODORI, :OBS, :ANULADO
    DO
        BEGIN
        if (((:PREFIJO = '') or (:PREF = :PREFIJO)) AND ((:ANULADOS = 'S') or (:ANULADO = 'N'))) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              EXANT = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT AJUS_ITEM, A.ARTI_COD, AJUS_CODBAR, AJDE_DESC, AJUS_EXANT, AJUS_UNIDAD, BODE_COD, AJUS_EXNUE, AJUS_LOTE, AJDE_OBS
                    FROM AJUSTES_DETALLE D, ARTICULO A WHERE D.ARTI_COD = A.ARTI_COD AND D.AJUS_ID = :ID INTO
                    :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :EXANT, :UNIDAD, :BODITEM, :CANT, :LOTE, :OBSITEM
                    DO
                      BEGIN
                      EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
                      TOTAL = (CANT - EXANT) * COSTO;
                      SUBTOTAL = TOTAL;
                      SUSPEND;
                      END
              ELSE
                BEGIN
                TOTAL = 0;
                FOR SELECT ARTI_COD, AJUS_EXNUE, AJUS_EXANT FROM AJUSTES_DETALLE D WHERE D.AJUS_ID = :ID INTO
                    :ARTICULO, :CANT, :EXANT
                    DO
                      BEGIN
                      EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
                      TOTAL = TOTAL + ((CANT - EXANT) * COSTO);
                      SUBTOTAL = TOTAL;
                      END
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 16) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 15 INTO :NOMTIPO;
    FOR SELECT ENSA_ID, E.PREF_PRE, ENSA_NUMERO, ENSA_FECHA, ENSA_CONC, ENSA_REFER, E.BODE_COD, BODE_NOM, ENSA_CODBAR, ENSA_DESC, ENSA_CANT, ENSA_UNIDAD, ENSA_LOTE, ENSA_OBS, ENSA_ANULADO
    FROM ENSAMBLES E, BODEGA B, PREFIJOS P
    WHERE E.BODE_COD = B.BODE_COD AND E.ENSA_FECHA >= :FECINI AND E.ENSA_FECHA <= :FECFIN
     AND P.PREF_PRE = E.PREF_PRE AND P.TIDO_COD = 15 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY ENSA_FECHA, ENSA_ID
    into :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :PRODCODBAR, :PRODDES, :PRODCANT, :PRODUNIDAD, :PRODLOTE, :OBS, :ANULADO
    DO
        BEGIN
        if (((:PREFIJO = '') or (:PREF = :PREFIJO)) AND ((:ANULADOS = 'S') or (:ANULADO = 'N'))) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              EXANT = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT ESDE_ITEM, A.ARTI_COD, ESDE_CODBAR, ESDE_DESC, ESDE_CANT, ESDE_UNIDAD, BODE_COD, ESDE_COSTO, ESDE_IVAPORC, ESDE_IVAMONTO, ESDE_CONSUMO, ESDE_TOTAL, ESDE_LOTE, ESDE_OBS
                    FROM ensambles_detalle D, ARTICULO A WHERE D.ARTI_COD = A.ARTI_COD AND D.ENSA_ID = :ID INTO
                    :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :COSTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :LOTE, :OBSITEM
                    DO
                    BEGIN
                    SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                    SUSPEND;
                    END
              ELSE
                BEGIN
                SELECT SUM(ESDE_IVAMONTO), SUM(ESDE_CONSUMO), SUM(ESDE_TOTAL) FROM ENSAMBLES_detalle D WHERE D.ENSA_ID = :ID INTO
                    :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 32) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 16 INTO :NOMTIPO;
    FOR SELECT DESE_ID, E.PREF_PRE, DESE_NUMERO, DESE_FECHA, DESE_CONC, DESE_REFER, E.BODE_COD, BODE_NOM, DESE_CODBAR, DESE_DESC, DESE_CANT, DESE_UNIDAD, DESE_LOTE, DESE_OBS, DESE_ANULADO
    FROM DESENSAMBLES E, BODEGA B, PREFIJOS P
    WHERE E.BODE_COD = B.BODE_COD AND DESE_FECHA >= :FECINI AND DESE_FECHA <= :FECFIN 
     AND P.PREF_PRE = E.PREF_PRE AND P.TIDO_COD = 16 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY DESE_FECHA, DESE_ID
    into :ID, PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :PRODCODBAR, :PRODDES, :PRODCANT, :PRODUNIDAD, :PRODLOTE, :OBS, :ANULADO
    DO
        BEGIN
        if (((:PREFIJO = '') or (:PREF = :PREFIJO)) AND ((:ANULADOS = 'S') or (:ANULADO = 'N'))) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              EXANT = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT DESE_ITEM, A.ARTI_COD, DEDE_CODBAR, DEDE_DESC, DEDE_CANT, DEDE_UNIDAD, BODE_COD, DEDE_COSTO, DEDE_IVAPORC, DEDE_IVAMONTO, DEDE_CONSUMO, DEDE_TOTAL, DEDE_LOTE, DEDE_OBS
                    FROM desensambles_detalle D, ARTICULO A WHERE D.ARTI_COD = A.ARTI_COD AND D.DESE_ID = :ID INTO
                    :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :COSTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :LOTE, :OBSITEM
                    DO
                    BEGIN
                    SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                    SUSPEND;
                    END
              ELSE
                BEGIN
                SELECT SUM(DEDE_IVAMONTO), SUM(DEDE_CONSUMO), SUM(DEDE_TOTAL) FROM DESENSAMBLES_detalle D WHERE D.DESE_ID = :ID INTO
                    :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 64) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 17 INTO :NOMTIPO;
    FOR SELECT RESE_ID, R.PREF_PRE, RESE_NUMERO, RESE_FECHA, RESE_CONC, RESE_REFER, R.BODE_COD, BODE_NOM, RESE_NOMTERC, RESE_OBS, RESE_ANULADO
    FROM RESERVAS R, BODEGA B, PREFIJOS P
    WHERE R.BODE_COD = B.BODE_COD AND R.RESE_FECHA >= :FECINI AND R.RESE_FECHA <= :FECFIN 
     AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 17 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY RESE_FECHA, RESE_ID
    into :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :NOMTERCERO, :OBS, :ANULADO
    DO
        BEGIN
        if (((:PREFIJO = '') or (:PREF = :PREFIJO)) AND ((:ANULADOS = 'S') or (:ANULADO = 'N'))) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              EXANT = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT RSDE_ITEM, A.ARTI_COD, RSDE_CODBAR, RSDE_DESC, RDSE_CANT, RSDE_UNIDAD, BODE_COD, RSDE_OBS
                    FROM RESERVAS_DETALLE D, ARTICULO A WHERE D.ARTI_COD = A.ARTI_COD AND D.RESE_ID = :ID INTO
                    :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :OBSITEM
                    DO
                    SUSPEND;
              ELSE
                BEGIN
                SELECT SUM(RDSE_CANT) FROM RESERVAS_detalle D WHERE D.RESE_ID = :ID INTO
                    :CANT;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 128) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 18 INTO :NOMTIPO;
    FOR SELECT ORIN_ID, O.PREF_PRE, ORIN_NUMERO, ORIN_FECHA, ORIN_FECLLEGA, ORIN_CONC, ORIN_REFER, ORIN_NOMTERC, ORIN_OBS, ORIN_ANULADO
        FROM ORDENES_INVENTARIO O, PREFIJOS P
        WHERE ORIN_FECHA >= :FECINI AND ORIN_FECHA <= :FECFIN 
        AND P.PREF_PRE = O.PREF_PRE AND P.TIDO_COD = 18 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY ORIN_FECHA, ORIN_ID
        into :ID, PREF, :NUMERO, :FECHA, :VENCE, :CONCEPTO, :REFER, :NOMTERCERO, :OBS, :ANULADO
        DO
        BEGIN
        if (((:PREFIJO = '') or (:PREF = :PREFIJO)) AND ((:ANULADOS = 'S') or (:ANULADO = 'N'))) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              EXANT = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT ORID_ITEM, A.ARTI_COD, ORID_CODBAR, ORID_DESC, ORID_CANT, ORID_UNIDAD, ORIN_COSTO, ORID_DTOPORC, ORID_DTOMONTO, ORID_IVAPORC, ORID_IVAMONTO, ORID_CONSUMO, ORID_TOTAL, ORID_OBS, ORID_LOTE
                    FROM ORDENINVENTARIO_DETALLE D, ARTICULO A WHERE D.ARTI_COD = A.ARTI_COD AND D.ORIN_ID = :ID INTO
                    :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :COSTO, :DTOPORC, :DTOMONTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :OBSITEM, :LOTE
                    DO
                    BEGIN
                    SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                    SUSPEND;
                    END
              ELSE
                BEGIN
                SELECT SUM(ORID_IVAMONTO), SUM(ORID_CONSUMO), SUM(ORID_TOTAL) FROM ordeninventario_detalle D WHERE D.ORIN_ID = :ID INTO
                    :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE REP_CONSECUTIVOS_INV(
    TIPO INTEGER,
    DETALLE CHAR(1),
    PREINI VARCHAR(4),
    PREFIN VARCHAR(4),
    NUMINI VARCHAR(6),
    NUMFIN VARCHAR(6),
    ANULADOS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    NOMTIPO VARCHAR(30),
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    VENCE DATE,
    CONCEPTO VARCHAR(60),
    REFER VARCHAR(60),
    CODBODORI VARCHAR(2),
    NOMBODORI VARCHAR(30),
    CODBODDES VARCHAR(2),
    NOMBODDES VARCHAR(30),
    NOMTERCERO VARCHAR(60),
    PRODCODBAR VARCHAR(15),
    PRODDES VARCHAR(60),
    PRODCANT NUMERIC(18,4),
    PRODUNIDAD VARCHAR(8),
    PRODLOTE VARCHAR(15),
    OBS BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    EXANT NUMERIC(18,4),
    UNIDAD VARCHAR(8),
    BODITEM VARCHAR(2),
    COSTO NUMERIC(18,2),
    DTOPORC NUMERIC(9,2),
    DTOMONTO NUMERIC(18,2),
    IVAPORC NUMERIC(9,2),
    IVAMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    SUBTOTAL NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    LOTE VARCHAR(15),
    ANULADO CHAR(1),
    OBSITEM BLOB SUB_TYPE 0 SEGMENT SIZE 80)
AS
BEGIN
  /* DETERMINE LA TABLA A EXAMINAR */
  if (BIN_AND(TIPO, 1) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 11 INTO :NOMTIPO;
    FOR SELECT ENTR_ID, E.PREF_PRE, ENTR_NUMERO, ENTR_FECHA, ENTR_CONC, ENTR_REFER, E.BODE_COD, BODE_NOM, ENTR_NOMTERC, ENTR_OBS, ENTR_ANULADO
    FROM ENTRADAS E, BODEGA B, PREFIJOS PR
    WHERE E.BODE_COD = B.BODE_COD AND E.PREF_PRE >= :PREINI AND E.PREF_PRE <= :PREFIN AND ENTR_NUMERO >= :NUMINI AND ENTR_NUMERO <= :NUMFIN
     AND PR.PREF_PRE = E.PREF_PRE AND PR.TIDO_COD = 11 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY E.PREF_PRE, ENTR_NUMERO
    INTO :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :NOMTERCERO, :OBS, :ANULADO
    DO
        BEGIN
        if ((:ANULADOS = 'S') or (:ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT ENDE_ITEM, A.ARTI_COD, ENDE_CODBAR, ENDE_DESC, ENDE_CANT, ENDE_UNIDAD, BODE_COD, ENDE_COSTO, ENDE_DTOPORC, ENDE_DTOMONTO, ENDE_IVAPORC, ENDE_IVAMONTO, ENDE_CONSUMO, ENDE_TOTAL, ENDE_LOTE, ENDE_OBS
                    FROM ENTRADAS_DETALLE D, ARTICULO A
                    WHERE D.ARTI_COD = A.ARTI_COD AND D.ENTR_ID = :ID
                    ORDER BY ENDE_ITEM
                    INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :COSTO, :DTOPORC, :DTOMONTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :LOTE, :OBSITEM
                    DO
                    BEGIN
                    SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                    SUSPEND;
                    END
              ELSE
                BEGIN
                SELECT SUM(ENDE_IVAMONTO), SUM(ENDE_CONSUMO), SUM(ENDE_TOTAL) FROM ENTRADAS_DETALLE D WHERE D.ENTR_ID = :ID INTO
                    :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 2) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 12 INTO :NOMTIPO;
    FOR SELECT SALI_ID, S.PREF_PRE, SALI_NUMERO, SALI_FECHA, SALI_CONC, SALI_REFER, S.BODE_COD, BODE_NOM, SALI_NOMTERC, SALI_OBS, SALI_ANULADO
    FROM SALIDAS S, BODEGA B, PREFIJOS PR
    WHERE S.BODE_COD = B.BODE_COD AND S.PREF_PRE >= :PREINI AND S.PREF_PRE <= :PREFIN AND SALI_NUMERO >= :NUMINI AND SALI_NUMERO <= :NUMFIN
     AND PR.PREF_PRE = S.PREF_PRE AND PR.TIDO_COD = 12 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY S.PREF_PRE, SALI_NUMERO
    into :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :NOMTERCERO, :OBS, :ANULADO
    DO
        BEGIN
        if ((:ANULADOS = 'S') or (:ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT SADE_ITEM, A.ARTI_COD, SADE_CODBAR, SADE_DESC, SADE_CANT, SADE_UNIDAD, BODE_COD, SADE_COSTO, SADE_IVAPORC, SADE_IVAMONTO, SADE_CONSUMO, SADE_TOTAL, SADE_LOTE, SADE_OBS
                FROM SALIDAS_DETALLE D, ARTICULO A
                WHERE D.ARTI_COD = A.ARTI_COD AND D.SALI_ID = :ID
                ORDER BY SADE_ITEM
                INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :COSTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :LOTE, :OBSITEM
                    DO
                BEGIN
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
              ELSE
                BEGIN
                SELECT SUM(SADE_IVAMONTO), SUM(SADE_CONSUMO), SUM(SADE_TOTAL) FROM SALIDAS_DETALLE D WHERE D.SALI_ID = :ID INTO
                    :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 4) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 13 INTO :NOMTIPO;
    FOR SELECT TRAN_ID, T.PREF_PRE, TRAN_NUMERO, TRAN_FECHA, TRAN_CONC, TRAN_REFER, T.BODE_COD, BO.BODE_NOM, TRAN_BODDES, BD.BODE_NOM, TRAN_OBS, TRAN_ANULADO
    FROM TRASFERENCIAS T, BODEGA BO, BODEGA BD, PREFIJOS PR
    WHERE T.BODE_COD = BO.BODE_COD AND T.TRAN_BODDES = BD.BODE_COD AND T.PREF_PRE >= :PREINI AND T.PREF_PRE <= :PREFIN AND TRAN_NUMERO >= :NUMINI AND TRAN_NUMERO <= :NUMFIN
     AND PR.PREF_PRE = T.PREF_PRE AND PR.TIDO_COD = 13 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY T.PREF_PRE, TRAN_NUMERO
    into :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :CODBODDES, :NOMBODDES, :OBS, :ANULADO
    DO
        BEGIN
        if ((:ANULADOS = 'S') or (:ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT TRAS_ITEM, A.ARTI_COD, TRAS_CODBAR, TRAS_DESC, TRAS_CANT, TRAS_UNIDAD, TRAS_COSTO, TRAS_IVAPORC, TRAS_IVAMONTO, TRAS_CONSUMO, TRAS_TOTAL, TRAS_LOTE, TRAS_OBS
                FROM TRASFERENCIAS_DETALLE D, ARTICULO A
                WHERE D.ARTI_COD = A.ARTI_COD AND D.TRAN_ID = :ID
                ORDER BY TRAS_ITEM
                INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :COSTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :LOTE, :OBSITEM
                    DO
                    BEGIN
                    SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                    SUSPEND;
                    END
              ELSE
                BEGIN
                SELECT SUM(TRAS_IVAMONTO), SUM(TRAS_CONSUMO), SUM(TRAS_TOTAL) FROM trasferencias_detalle D WHERE D.TRAN_ID = :ID INTO
                    :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 8) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 14 INTO :NOMTIPO;
    FOR SELECT AJUS_ID, A.PREF_PRE, AJUS_NUMERO, AJUS_FECHA, AJUS_CONC, A.BODE_COD, BODE_NOM, AJUS_OBS, AJUS_ANULADO
    FROM AJUSTES A, BODEGA B, PREFIJOS PR
    WHERE A.BODE_COD = B.BODE_COD AND A.PREF_PRE >= :PREINI AND A.PREF_PRE <= :PREFIN AND AJUS_NUMERO >= :NUMINI AND AJUS_NUMERO <= :NUMFIN
     AND PR.PREF_PRE = A.PREF_PRE AND PR.TIDO_COD = 14 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY A.PREF_PRE, AJUS_NUMERO
    into :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :CODBODORI, :NOMBODORI, :OBS, :ANULADO
    DO
        BEGIN
        if ((:ANULADOS = 'S') or (:ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              EXANT = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT AJUS_ITEM, A.ARTI_COD, AJUS_CODBAR, AJDE_DESC, AJUS_EXANT, AJUS_UNIDAD, BODE_COD, AJUS_EXNUE, AJUS_LOTE, AJDE_OBS
                FROM AJUSTES_DETALLE D, ARTICULO A
                WHERE D.ARTI_COD = A.ARTI_COD AND D.AJUS_ID = :ID
                ORDER BY AJUS_ITEM
                INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :EXANT, :UNIDAD, :BODITEM, :CANT, :LOTE, :OBSITEM
                    DO
                      BEGIN
                      TOTAL = (CANT - EXANT) * COSTO;
                      SUBTOTAL = TOTAL;
                      SUSPEND;
                      END
              ELSE
                BEGIN
                TOTAL = 0;
                FOR SELECT ARTI_COD, AJUS_EXNUE, AJUS_EXANT FROM AJUSTES_DETALLE D WHERE D.AJUS_ID = :ID INTO
                    :ARTICULO, :CANT, :EXANT
                    DO
                      BEGIN
                      EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
                      TOTAL = TOTAL + ((CANT - EXANT) * COSTO);
                      SUBTOTAL = TOTAL;
                      END
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 16) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 15 INTO :NOMTIPO;
    FOR SELECT ENSA_ID, E.PREF_PRE, ENSA_NUMERO, ENSA_FECHA, ENSA_CONC, ENSA_REFER, E.BODE_COD, BODE_NOM, ENSA_CODBAR, ENSA_DESC, ENSA_CANT, ENSA_UNIDAD, ENSA_LOTE, ENSA_OBS, ENSA_ANULADO
    FROM ENSAMBLES E, BODEGA B, PREFIJOS PR
    WHERE E.BODE_COD = B.BODE_COD AND E.PREF_PRE >= :PREINI AND E.PREF_PRE <= :PREFIN AND ENSA_NUMERO >= :NUMINI AND ENSA_NUMERO <= :NUMFIN
     AND PR.PREF_PRE = E.PREF_PRE AND PR.TIDO_COD = 15 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY E.PREF_PRE, ENSA_NUMERO
    into :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :PRODCODBAR, :PRODDES, :PRODCANT, :PRODUNIDAD, :PRODLOTE, :OBS, :ANULADO
    DO
        BEGIN
        if ((:ANULADOS = 'S') or (:ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT ESDE_ITEM, A.ARTI_COD, ESDE_CODBAR, ESDE_DESC, ESDE_CANT, ESDE_UNIDAD, BODE_COD, ESDE_COSTO, ESDE_IVAPORC, ESDE_IVAMONTO, ESDE_CONSUMO, ESDE_TOTAL, ESDE_LOTE, ESDE_OBS
                FROM ensambles_detalle D, ARTICULO A
                WHERE D.ARTI_COD = A.ARTI_COD AND D.ENSA_ID = :ID
                ORDER BY ESDE_ITEM
                INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :COSTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :LOTE, :OBSITEM
                    DO
                    BEGIN
                    SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                    SUSPEND;
                    END
              ELSE
                BEGIN
                SELECT SUM(ESDE_IVAMONTO), SUM(ESDE_CONSUMO), SUM(ESDE_TOTAL) FROM ENSAMBLES_detalle D WHERE D.ENSA_ID = :ID INTO
                    :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 32) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 16 INTO :NOMTIPO;
    FOR SELECT DESE_ID, E.PREF_PRE, DESE_NUMERO, DESE_FECHA, DESE_CONC, DESE_REFER, E.BODE_COD, BODE_NOM, DESE_CODBAR, DESE_DESC, DESE_CANT, DESE_UNIDAD, DESE_LOTE, DESE_OBS, DESE_ANULADO
    FROM DESENSAMBLES E, BODEGA B, PREFIJOS PR
    WHERE E.BODE_COD = B.BODE_COD AND E.PREF_PRE >= :PREINI AND E.PREF_PRE <= :PREFIN AND DESE_NUMERO >= :NUMINI AND DESE_NUMERO <= :NUMFIN
     AND PR.PREF_PRE = E.PREF_PRE AND PR.TIDO_COD = 16 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY E.PREF_PRE, DESE_NUMERO
    into :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :PRODCODBAR, :PRODDES, :PRODCANT, :PRODUNIDAD, :PRODLOTE, :OBS, :ANULADO
    DO
        BEGIN
        if ((:ANULADOS = 'S') or (:ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT DESE_ITEM, A.ARTI_COD, DEDE_CODBAR, DEDE_DESC, DEDE_CANT, DEDE_UNIDAD, BODE_COD, DEDE_COSTO, DEDE_IVAPORC, DEDE_IVAMONTO, DEDE_CONSUMO, DEDE_TOTAL, DEDE_LOTE, DEDE_OBS
                FROM DESensambles_detalle D, ARTICULO A
                WHERE D.ARTI_COD = A.ARTI_COD AND D.DESE_ID = :ID
                ORDER BY DESE_ITEM
                INTO
                    :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :COSTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :LOTE, :OBSITEM
                    DO
                    BEGIN
                    SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                    SUSPEND;
                    END
              ELSE
                BEGIN
                SELECT SUM(DEDE_IVAMONTO), SUM(DEDE_CONSUMO), SUM(DEDE_TOTAL) FROM DESENSAMBLES_detalle D WHERE D.DESE_ID = :ID INTO
                    :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 64) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 17 INTO :NOMTIPO;
    FOR SELECT RESE_ID, R.PREF_PRE, RESE_NUMERO, RESE_FECHA, RESE_CONC, RESE_REFER, R.BODE_COD, BODE_NOM, RESE_NOMTERC, RESE_OBS, RESE_ANULADO
    FROM RESERVAS R, BODEGA B, PREFIJOS PR
    WHERE R.BODE_COD = B.BODE_COD AND R.PREF_PRE >= :PREINI AND R.PREF_PRE <= :PREFIN AND RESE_NUMERO >= :NUMINI AND RESE_NUMERO <= :NUMFIN
     AND PR.PREF_PRE = R.PREF_PRE AND PR.TIDO_COD = 17 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY R.PREF_PRE, RESE_NUMERO
    into :ID, :PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, :CODBODORI, :NOMBODORI, :NOMTERCERO, :OBS, :ANULADO
    DO
        BEGIN
        if ((:ANULADOS = 'S') or (:ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              EXANT = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT RSDE_ITEM, A.ARTI_COD, RSDE_CODBAR, RSDE_DESC, RDSE_CANT, RSDE_UNIDAD, BODE_COD, RSDE_OBS
                FROM RESERVAS_DETALLE D, ARTICULO A
                WHERE D.ARTI_COD = A.ARTI_COD AND D.RESE_ID = :ID
                ORDER BY RSDE_ITEM
                INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :OBSITEM
                    DO
                    SUSPEND;
              ELSE
                BEGIN
                SELECT SUM(RDSE_CANT) FROM RESERVAS_detalle D WHERE D.RESE_ID = :ID INTO
                    :CANT;
                SUSPEND;
                END
             END
            END
        END
    END
  if (BIN_AND(TIPO, 128) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 18 INTO :NOMTIPO;
    FOR SELECT ORIN_ID, O.PREF_PRE, ORIN_NUMERO, ORIN_FECHA, ORIN_FECLLEGA, ORIN_CONC, ORIN_REFER, ORIN_NOMTERC, ORIN_OBS, ORIN_ANULADO
    FROM ORDENES_INVENTARIO O, PREFIJOS PR
    WHERE O.PREF_PRE >= :PREINI AND O.PREF_PRE <= :PREFIN AND ORIN_NUMERO >= :NUMINI AND ORIN_NUMERO <= :NUMFIN
     AND PR.PREF_PRE = O.PREF_PRE AND PR.TIDO_COD = 18 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
    ORDER BY O.PREF_PRE, ORIN_NUMERO
    into :ID, :PREF, :NUMERO, :FECHA, :VENCE, :CONCEPTO, :REFER, :NOMTERCERO, :OBS, :ANULADO
    DO
        BEGIN
        if ((:ANULADOS = 'S') or (:ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
             BEGIN
              ITEM = 0;
              ARTICULO = '';
              CODBAR = '';
              ARTIDES = '';
              CANT = 0;
              UNIDAD = '';
              BODITEM = '';
              lote = '';
              costo = 0;
              DTOPORC = 0;
              DTOMONTO = 0;
              IVAPORC = 0;
              IVAMONTO = 0;
              CONSUMO = 0;
              EXANT = 0;
              TOTAL = 0;
              OBSITEM = null;
              SUBTOTAL = 0;
              SUSPEND;
             END
            ELSE
             BEGIN
              if (DETALLE = 'S') then
                FOR SELECT ORID_ITEM, A.ARTI_COD, ORID_CODBAR, ORID_DESC, ORID_CANT, ORID_UNIDAD, ORIN_COSTO, ORID_DTOPORC, ORID_DTOMONTO, ORID_IVAPORC, ORID_IVAMONTO, ORID_CONSUMO, ORID_TOTAL, ORID_OBS, ORID_LOTE
                FROM ORDENINVENTARIO_DETALLE D, ARTICULO A
                WHERE D.ARTI_COD = A.ARTI_COD AND D.ORIN_ID = :ID
                ORDER BY ORID_ITEM
                INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :COSTO, :DTOPORC, :DTOMONTO, :IVAPORC, :IVAMONTO, :CONSUMO, :TOTAL, :OBSITEM, :LOTE
                    DO
                    BEGIN
                    SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                    SUSPEND;
                    END
              ELSE
                BEGIN
                SELECT SUM(ORID_IVAMONTO), SUM(ORID_CONSUMO), SUM(ORID_TOTAL) FROM ordeninventario_detalle D WHERE D.ORIN_ID = :ID INTO
                    :IVAMONTO, :CONSUMO, :TOTAL;
                SUBTOTAL = TOTAL - IVAMONTO - CONSUMO;
                SUSPEND;
                END
             END
            END
        END
    END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE REP_DISPONIBILIDAD(
    FECHA DATE,
    ARTINI VARCHAR(20),
    ARTFIN VARCHAR(20),
    GRPINI VARCHAR(2),
    GRPFIN VARCHAR(2),
    ORDEN CHAR(1),
    CEROS CHAR(1),
    DETALLE CHAR(1),
    SUCURSAL INTEGER)
RETURNS (
    CODIGO VARCHAR(15),
    NOMBRE VARCHAR(60),
    UNIDAD VARCHAR(8),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    CODBOD VARCHAR(2),
    NOMBOD VARCHAR(30),
    EXIST NUMERIC(18,4),
    PROMEDIO NUMERIC(18,4),
    SALIDAS NUMERIC(18,4),
    DISPONIBILIDAD INTEGER,
    DIAS INTEGER,
    PROMEDIADO INTEGER,
    COSTO NUMERIC(18,2),
    COSTOPRO NUMERIC(18,2),
    SUGERIDO NUMERIC(18,4),
    FECCOMPRA DATE)
AS
DECLARE VARIABLE CODINI VARCHAR(20);
DECLARE VARIABLE CODFIN VARCHAR(20);
DECLARE VARIABLE DESINI VARCHAR(20);
declare variable FECINI DATE;
declare variable DIASC VARCHAR(255);
DECLARE VARIABLE DESFIN VARCHAR(20);
declare variable DIA_ART VARCHAR(2) CHARACTER SET NONE;
BEGIN
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END
if (DETALLE = 'S') then
  BEGIN
  FOR SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, ARTI_DIAS, A.GRUP_COD, GRUP_NOM, A.SUBG_COD, A.MARC_COD, BODE_COD, BODE_NOM, ARTI_DIANALIS
      FROM ARTICULO A, GRUPO G, BODEGA B
      WHERE ARTI_COD >= :CODINI AND ARTI_COD <= :CODFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :GRPFIN AND ARTI_DES >= :DESINI AND ARTI_DES <= :DESFIN AND
      G.GRUP_COD = A.GRUP_COD AND A.ESAR_COD <> 'I' AND ((SUCU_ID = :SUCURSAL) or (:SUCURSAL = 0))
      INTO :CODIGO, :NOMBRE, :UNIDAD, :DIAS, :CODGRUPO, :NOMGRUPO, :CODSUBG, :CODMARC, :CODBOD, :NOMBOD, :PROMEDIADO
      DO
        BEGIN
        NOMMARC = '';
        NOMSUBG = '';
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO :NOMMARC;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
        EXECUTE PROCEDURE ultimo_costo(:CODIGO, :FECHA, :UNIDAD) returning_values (:COSTO);
        EXECUTE PROCEDURE costo_promedio(:CODIGO, :FECHA) RETURNING_VALUES :costopro;
        EXECUTE PROCEDURE DISPONIBILIDAD_ARTICULO(CODIGO, FECHA, :CODBOD) returning_values (:DISPONIBILIDAD, :EXIST, :PROMEDIO, :SALIDAS);
        /*ESTABLECER CUAL ES EL VALOR DE DIAS PARA PROMEDIO*/
        EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'PROMEDIAR LAS SALIDAS DEL INVENTARIO CON EL NUMERO DE DIAS ASIGNADO A CADA ARTICULO') returning_values (:DIA_ART);
        if (DIA_ART = 'NO') then
          BEGIN
            EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'NUMERO DE DIAS PARA PROMEDIO DE SALIDAS POR ARTICULO') returning_values (DIASC);
            PROMEDIADO = CAST(DIASC AS INTEGER);
          END
        FECINI = :FECHA - :PROMEDIADO;
        if ((DISPONIBILIDAD < DIAS) and (PROMEDIO > 0))then
            SUGERIDO = (DIAS * PROMEDIO) - EXIST;
        ELSE
            SUGERIDO = 0;
        SELECT MAX(FACO_FECHA) FROM FACTURAS_COMPRA F, FACTURAS_COMPRAS_DETALLE D
            WHERE F.FACO_ID = D.faco_id AND D.ARTI_COD = :CODIGO AND FACO_FECHA <= :FECHA AND D.bode_cod = :codbod
            INTO :FECCOMPRA;
        if ((PROMEDIO > 0) or (EXIST <> 0) or (CEROS = 'S')) then
            SUSPEND;
        END
  END
ELSE
  BEGIN
  FOR SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, ARTI_DIAS, A.GRUP_COD, GRUP_NOM, A.SUBG_COD, A.MARC_COD, ARTI_DIANALIS
      FROM ARTICULO A, GRUPO G
      WHERE ARTI_COD >= :CODINI AND ARTI_COD <= :CODFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :GRPFIN AND ARTI_DES >= :DESINI AND ARTI_DES <= :DESFIN AND G.GRUP_COD = A.GRUP_COD AND A.ESAR_COD <> 'I'
      INTO :CODIGO, :NOMBRE, :UNIDAD, :DIAS, :CODGRUPO, :NOMGRUPO, :CODSUBG, :CODMARC, :PROMEDIADO
      DO
        BEGIN
        NOMMARC = '';
        NOMSUBG = '';
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO :NOMMARC;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
        EXECUTE PROCEDURE costo_promedio(:CODIGO, :FECHA) RETURNING_VALUES :costopro;
        EXECUTE PROCEDURE ultimo_costo(:CODIGO, :FECHA, :UNIDAD) returning_values (:COSTO);
        EXECUTE PROCEDURE DISPONIBILIDAD_TOTAL_ARTICULO(CODIGO, FECHA) returning_values (:DISPONIBILIDAD, :EXIST, :PROMEDIO, :SALIDAS);
        /*ESTABLECER CUAL ES EL VALOR DE DIAS PARA PROMEDIO*/
        EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'PROMEDIAR LAS SALIDAS DEL INVENTARIO CON EL NUMERO DE DIAS ASIGNADO A CADA ARTICULO') returning_values (:DIA_ART);
        if (DIA_ART = 'NO') then
          BEGIN
            EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'NUMERO DE DIAS PARA PROMEDIO DE SALIDAS POR ARTICULO') returning_values (DIASC);
            PROMEDIADO = CAST(DIASC AS INTEGER);
          END
        FECINI = :FECHA - :PROMEDIADO;
        if ((DISPONIBILIDAD < DIAS) and (PROMEDIO > 0))then
            SUGERIDO = (DIAS * PROMEDIO) - EXIST;
        ELSE
            SUGERIDO = 0;
        SELECT MAX(FACO_FECHA) FROM FACTURAS_COMPRA F, FACTURAS_COMPRAS_DETALLE D
            WHERE F.FACO_ID = D.faco_id AND D.ARTI_COD = :CODIGO AND FACO_FECHA <= :FECHA
            INTO :FECCOMPRA;
        if ((PROMEDIO > 0) or (EXIST <> 0) or (CEROS = 'S')) then
            SUSPEND;
        END
  END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE REP_KARDEX_ARTICULO(
    DETALLE CHAR(1),
    FECINI DATE,
    FECFIN DATE,
    ARTINI VARCHAR(20),
    ARTFIN VARCHAR(20),
    GRPINI VARCHAR(2),
    GRPFIN VARCHAR(2),
    ORDEN CHAR(1),
    BODEGA VARCHAR(2))
RETURNS (
    CODIGO VARCHAR(15),
    NOMBRE VARCHAR(60),
    UNIDAD VARCHAR(8),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    CODBOD VARCHAR(2),
    SALDOINI NUMERIC(18,4),
    COSTOINI NUMERIC(18,2),
    ENTRADAS NUMERIC(18,4),
    COSTOENT NUMERIC(18,2),
    SALIDAS NUMERIC(18,4),
    COSTOSAL NUMERIC(18,2),
    SALDOFIN NUMERIC(18,4),
    COSTOFIN NUMERIC(18,2),
    TIPODOC VARCHAR(8),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    CONCEPTO VARCHAR(60),
    NIT VARCHAR(20),
    CONS INTEGER,
    CANFINAL NUMERIC(18,4),
    COSFINAL NUMERIC(18,2))
AS
DECLARE VARIABLE ENTRADA CHAR(1);
DECLARE VARIABLE CANT NUMERIC(18,4);
DECLARE VARIABLE EXIST NUMERIC(18,4);
DECLARE VARIABLE COSTO NUMERIC(18,2);
DECLARE VARIABLE CODINI VARCHAR(20);
DECLARE VARIABLE CODFIN VARCHAR(20);
DECLARE VARIABLE DESINI VARCHAR(20);
DECLARE VARIABLE DESFIN VARCHAR(20);
declare variable TIPO INTEGER;
declare variable ID INTEGER;
BEGIN
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END
  FOR
    SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD
      FROM ARTICULO A
      WHERE ARTI_COD >= :CODINI AND ARTI_COD <= :CODFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :GRPFIN AND ARTI_DES >= :DESINI AND ARTI_DES <= :DESFIN AND A.ESAR_COD <> 'I'
      INTO :CODIGO, :NOMBRE, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
      DO
        BEGIN
        NOMMARC = '';
        NOMSUBG = '';
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
        if (BODEGA = '') then
            BEGIN
            EXECUTE PROCEDURE SALDO_INICIAL_TOTAL_INV(CODIGO, FECINI) returning_values (:SALDOINI);
            EXECUTE PROCEDURE VALOR_INICIAL_INVENTARIO(CODIGO, FECINI) returning_values (COSTOINI);
            END
        ELSE
            BEGIN
            EXECUTE PROCEDURE SALDO_INICIAL_INVENTARIO(CODIGO, FECINI, :BODEGA) returning_values (SALDOINI);
            EXECUTE PROCEDURE COSTO_PROMEDIO(CODIGO, FECINI) returning_values (COSTOINI);
            COSTOINI = COSTOINI * saldoini;
            END
        if (DETALLE = 'N') then
            BEGIN
            /* SUME LAS ENTRADAS */
            if (BODEGA = '') then
                SELECT SUM(MVAR_CANT), SUM(MVAR_CANT * MVAR_COSTO) FROM MOVIMIENTO_ARTICULO
                  WHERE (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA <= :FECFIN) AND (MVAR_TIPODOC <> 13) AND
                  (ARTI_COD = :CODIGO) AND (MVAR_ENTRADA = 'S') INTO :ENTRADAS, :COSTOENT;
            ELSE
                SELECT SUM(MVAR_CANT), SUM(MVAR_CANT * MVAR_COSTO) FROM MOVIMIENTO_ARTICULO
                  WHERE (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA <= :FECFIN) AND (MVAR_TIPODOC <> 13) AND
                  (ARTI_COD = :CODIGO) AND (MVAR_ENTRADA = 'S') AND BODE_COD = :BODEGA
                  INTO :ENTRADAS, :COSTOENT;
                
            if (ENTRADAS IS NULL) then
              ENTRADAS = 0;
            if (COSTOENT IS NULL) then
              COSTOENT = 0;
            /* CALCULE LAS SALIDAS A COSTO PROMEDIO */
            SALIDAS = 0;
            COSTOSAL = 0;
            if (BODEGA = '') then
                FOR SELECT MVAR_CANT, MVAR_FECHA, MVAR_TIPODOC, MVAR_CONS
                    FROM MOVIMIENTO_ARTICULO
                    WHERE (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA <= :FECFIN) AND (MVAR_TIPODOC <> 13) AND
                    (ARTI_COD = :CODIGO) AND (MVAR_ENTRADA = 'N')
                    INTO :CANT, :FECHA, :TIPO, :ID
                    DO
                    BEGIN
                    SELECT COST_SALDOP, COST_SALDOC FROM COSTOS WHERE COST_TIPO = :TIPO AND COST_IDMOV = :ID INTO :COSTO, :EXIST;
                    if (EXIST <> 0) then
                        COSTO = COSTO / EXIST;
                    ELSE
                        COSTO = 0;
                    COSTOSAL = COSTOSAL + (COSTO*CANT);
                    SALIDAS = SALIDAS + CANT;
                    END
            ELSE
                FOR SELECT MVAR_CANT, MVAR_FECHA, MVAR_TIPODOC, MVAR_CONS
                    FROM MOVIMIENTO_ARTICULO
                    WHERE (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA <= :FECFIN) AND (MVAR_TIPODOC <> 13) AND
                    (ARTI_COD = :CODIGO) AND (MVAR_ENTRADA = 'N') AND BODE_COD = :BODEGA
                    INTO :CANT, :FECHA, :TIPO, :ID
                    DO
                    BEGIN
                    SELECT COST_SALDOP, COST_SALDOC FROM COSTOS WHERE COST_TIPO = :TIPO AND COST_IDMOV = :ID INTO :COSTO, :EXIST;
                    if (EXIST <> 0) then
                        COSTO = COSTO / EXIST;
                    ELSE
                        COSTO = 0;
                    COSTOSAL = COSTOSAL + (COSTO*CANT);
                    SALIDAS = SALIDAS + CANT;
                    END
            if (SALIDAS IS NULL) then
              SALIDAS = 0;
            if (COSTOSAL IS NULL) then
              COSTOSAL = 0;
            SALDOFIN = SALDOINI + ENTRADAS - SALIDAS;
            COSTOFIN = COSTOINI + COSTOENT - COSTOSAL;
            if (BODEGA = '') then
                BEGIN
                EXECUTE PROCEDURE SALDO_INICIAL_TOTAL_INV(CODIGO, fecfin+1) returning_values (canfinal);
                EXECUTE PROCEDURE VALOR_INICIAL_INVENTARIO(CODIGO, FECFIN+1) returning_values (cosfinal);
                END
            ELSE
                BEGIN
                EXECUTE PROCEDURE SALDO_INICIAL_INVENTARIO(CODIGO, FECFIN+1, :BODEGA) returning_values (CANFINAL);
                EXECUTE PROCEDURE COSTO_PROMEDIO(CODIGO, FECFIN+1) returning_values (COSFINAL);
                COSFINAL = COSFINAL * CANFINAL;
                END
            SUSPEND;
            END
        ELSE
            BEGIN
            SALDOFIN = SALDOINI;
            COSTOFIN = COSTOINI;
            COSTOENT = 0;
            COSTOSAL = 0;
            FOR SELECT TIDO_NOMCORTO, MVAR_ENTRADA, MVAR_PREF, MVAR_NUMERO, MVAR_CANT, MVAR_COSTO, MVAR_CONC, MVAR_FECHA, M.TERC_NIT, MVAR_CONS, BODE_COD
                FROM MOVIMIENTO_ARTICULO M, TIPO_DOCUMENTO TD
                WHERE TD.TIDO_COD = MVAR_TIPODOC AND (MVAR_FECHA >= :FECINI) AND (MVAR_FECHA <= :FECFIN) AND (MVAR_TIPODOC <> 13) AND (ARTI_COD = :CODIGO)
                ORDER BY MVAR_FECHA, MVAR_CONS
                INTO :TIPODOC, :ENTRADA, :PREFIJO, :NUMERO, :ENTRADAS, :COSTOENT, :CONCEPTO, :FECHA, :NIT, :CONS, :CODBOD
                DO
                    BEGIN
                    if (ENTRADA = 'S') then
                        BEGIN
                        SALIDAS = 0;
                        SALDOFIN = SALDOFIN + ENTRADAS;
                        COSTOFIN = COSTOFIN + (ENTRADAS * COSTOENT);
                        if (SALDOFIN > 0) then
                            COSTOSAL = COSTOFIN / SALDOFIN;
                        end
                    ELSE
                        BEGIN
                        SALIDAS = ENTRADAS;
                        ENTRADAS = 0;
                        if (SALDOFIN > 0) then
                            COSTOENT = COSTOFIN / SALDOFIN;
                        else
                            EXECUTE PROCEDURE COSTO_PROMEDIO(:CODIGO, :FECHA) returning_values (:COSTOENT);
                        SALDOFIN = SALDOFIN - SALIDAS;
                        COSTOFIN = COSTOFIN - (SALIDAS * COSTOENT);
                        if (SALDOFIN > 0) then
                            COSTOSAL = COSTOFIN / SALDOFIN;
                        END
                    SUSPEND;
                    END
            END
        END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE REP_PRODUCTOS(
    ORDEN CHAR(1),
    DESDE VARCHAR(15),
    HASTA VARCHAR(15),
    FECHA DATE)
RETURNS (
    CODIGO VARCHAR(15),
    DESCR VARCHAR(60),
    GRUPCOD VARCHAR(2),
    GRUPNOM VARCHAR(30),
    SUBGCOD VARCHAR(3),
    SUBGNOM VARCHAR(30),
    MARCCOD VARCHAR(3),
    MARCNOM VARCHAR(30),
    ESTADO CHAR(1),
    UNIDAD VARCHAR(8),
    CODCOMP VARCHAR(15),
    DESCOMP VARCHAR(60),
    CANT NUMERIC(18,4),
    UNDCOMP VARCHAR(8),
    CODBARCOMP VARCHAR(15),
    COSTO NUMERIC(18,2),
    TOTAL NUMERIC(18,2))
AS
BEGIN
  FOR SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, GRUP_NOM, A.SUBG_COD, A.MARC_COD, A.esar_cod
  FROM ARTICULO A, GRUPO G, estado_articulo E
  WHERE A.GRUP_COD = G.GRUP_COD AND A.ESAR_COD = E.ESAR_COD AND ARTI_COD IN (SELECT DISTINCT ARTI_COD FROM ARTICULOS_PRODUCTO)
  INTO :CODIGO, :DESCR, :unidad, :GRUPCOD, :GRUPNOM, :SUBGCOD, :MARCCOD, :ESTADO
  DO
    if ((ORDEN = 'C' AND CODIGO >= :DESDE AND CODIGO <= :HASTA) OR
        (ORDEN = 'D' AND DESCR >= :DESDE AND DESCR <= :HASTA)) then
        BEGIN
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCCOD INTO MARCNOM;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGCOD AND GRUP_COD = :GRUPCOD INTO :SUBGNOM;
        FOR SELECT ARPR_COMP, ARTI_DES, ARPR_CODBAR, ARPR_CANT, ARPR_UNIDAD
        FROM ARTICULOS_PRODUCTO P, ARTICULO A
        WHERE P.ARTI_COD = :CODIGO AND P.ARPR_COMP = A.ARTI_COD
          INTO :CODCOMP, :DESCOMP, :CODBARCOMP, :CANT, :UNDCOMP
          DO
            begin
            EXECUTE PROCEDURE COSTO_PROMEDIO (:CODCOMP, :FECHA) returning_values (:COSTO);
            EXECUTE PROCEDURE CANTIDAD_POR_FACTOR (:CODCOMP, :CANT, :UNDCOMP) returning_values (:CANT);
            TOTAL = COSTO * CANT;
            SUSPEND;
            END
        END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE REP_UTILIDAD_CLIENTE(
    TIPO INTEGER,
    DETALLE CHAR(1),
    TERINI VARCHAR(20),
    TERFIN VARCHAR(20),
    FECINI DATE,
    FECFIN DATE,
    ARTINI VARCHAR(15),
    ARTFIN VARCHAR(15),
    ORDEN CHAR(1),
    CEROS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    TELEFONO VARCHAR(40),
    CIUDAD VARCHAR(40),
    CODZONA VARCHAR(2),
    NOMZONA VARCHAR(30),
    NOMTIPO VARCHAR(50),
    ARTICULO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    UNIDAD VARCHAR(8),
    CANTIDAD NUMERIC(18,4),
    BASE NUMERIC(18,2),
    IVA NUMERIC(18,2),
    COSTO NUMERIC(18,2),
    UTILIDAD NUMERIC(18,4),
    PORC NUMERIC(9,2),
    TOTAL NUMERIC(18,2),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    DTO NUMERIC(9,2))
AS
DECLARE VARIABLE COSTOUNIT NUMERIC(18,4);
DECLARE VARIABLE CODINI VARCHAR(15);
DECLARE VARIABLE CODFIN VARCHAR(15);
DECLARE VARIABLE DESINI VARCHAR(15);
DECLARE VARIABLE DESFIN VARCHAR(15);
declare variable UOM VARCHAR(20);
declare variable NUMROWS INTEGER;
BEGIN
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END
EXECUTE PROCEDURE lee_configuracion ('FACTURACION', 'ARTICULOS', 'SUGERIR PRECIOS CON PORCENTAJE DE MARGEN O UTILIDAD') returning_values (:UOM);
SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPO INTO :NOMTIPO;
if (DETALLE = 'N') then
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 3 AND REPA_USER = USER;

        FOR SELECT MAX(T.TERC_NIT), MAX(TERC_NOM), MAX(TERC_TEL), MAX(TERC_CIU), MAX(ZONA_COD), MAX(ARTI_COD), SUM(FADE_CANT * FADE_FACTOR), SUM(FACT_FACTOR*(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)),
            SUM(FACT_FACTOR*FADE_IVAMONTO), SUM(FACT_FACTOR*FADE_TOTAL)
            FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P, terceros T, CLIENTES C
            WHERE C.TERC_NIT = T.TERC_NIT AND TERC_CLIE = 'S' AND F.terc_nit = T.terc_nit AND T.TERC_NIT >= :TERINI AND T.TERC_NIT <= :TERFIN AND
            F.FACT_ID = D.FACT_ID AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N'
            AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY T.TERC_NIT, ARTI_COD
            INTO :NIT, :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL
            DO
            BEGIN
            SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :CODZONA INTO :NOMZONA;
            SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            COSTO = CANTIDAD * COSTOUNIT;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
            else
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (3, USER, :ARTICULO);
            SUSPEND;
            END /* FOR */
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 3 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 3 AND REPA_USER = USER;

        FOR SELECT MAX(T.TERC_NIT), MAX(TERC_NOM), MAX(TERC_TEL), MAX(TERC_CIU), MAX(ZONA_COD), MAX(ARTI_COD), SUM(RVDE_CANT * RVDE_FACTOR), SUM(RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO), SUM(RVDE_IVAMONTO), SUM(RVDE_TOTAL)
            FROM REMISIONES_VENTA_DETALLE D, REMISIONES_VENTA R, PREFIJOS P, terceros T, CLIENTES C
            WHERE C.TERC_NIT = T.TERC_NIT AND TERC_CLIE = 'S' AND R.terc_nit = T.terc_nit AND T.TERC_NIT >= :TERINI AND T.TERC_NIT <= :TERFIN AND
            R.REVT_ID = D.REVT_ID AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND REVT_ANULADO = 'N'
            AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY T.TERC_NIT, ARTI_COD
            INTO :NIT, :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL
            DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
                if (CANTIDAD IS NULL) then
                    CANTIDAD = 0;
                if (BASE IS NULL) then
                    BASE = 0;
                if (IVA IS NULL) then
                    IVA = 0;
                COSTO = CANTIDAD * COSTOUNIT;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (3, USER, :ARTICULO);
            SUSPEND;
            END /* FOR */
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 3 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 3 AND REPA_USER = USER;

        FOR SELECT MAX(T.TERC_NIT), MAX(TERC_NOM), MAX(TERC_TEL), MAX(TERC_CIU), MAX(ZONA_COD), MAX(ARTI_COD), SUM(DVDE_CANT * DVDE_FACTOR), SUM(DEVT_FACTOR*(DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)),
            SUM(DEVT_FACTOR*DVDE_IVAMONTO), SUM(DEVT_FACTOR*DVDE_TOTAL)
            FROM devoluciones_ventas_detalle D, DEVOLUCIONES_VENTAS V, PREFIJOS P, terceros T, CLIENTES C
            WHERE C.TERC_NIT = T.TERC_NIT AND TERC_CLIE = 'S' AND V.terc_nit = T.terc_nit AND T.TERC_NIT >= :TERINI AND T.TERC_NIT <= :TERFIN AND
            V.DEVT_ID = D.DEVT_ID AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND DEVT_ANULADO = 'N'
            AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY T.TERC_NIT, ARTI_COD
            INTO :NIT, :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL
            DO
            BEGIN
            SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            COSTO = CANTIDAD * COSTOUNIT;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
            else
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
            TOTAL = TOTAL * -1;
            IVA = IVA * -1;
            BASE = BASE * -1;
            CANTIDAD = CANTIDAD * -1;
            COSTO = COSTO * -1;
            UTILIDAD = UTILIDAD * -1;
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (3, USER, :ARTICULO);
            SUSPEND;
            END /* FOR */
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 3 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 3 AND REPA_USER = USER;

        FOR SELECT MAX(T.TERC_NIT), MAX(TERC_NOM), MAX(TERC_TEL), MAX(TERC_CIU), MAX(ZONA_COD), MAX(ARTI_COD), SUM(PEDE_CANT * PEDE_FACTOR), SUM(PEDI_FACTOR*(PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)),
            SUM(PEDI_FACTOR*PEDE_IVAMONTO), SUM(PEDI_FACTOR*PEDE_TOTAL)
            FROM PEDIDOS_DETALLE D, PEDIDOS P, PREFIJOS PR, terceros T, CLIENTES C
            WHERE C.TERC_NIT = T.TERC_NIT AND TERC_CLIE = 'S' AND P.terc_nit = T.terc_nit AND T.TERC_NIT >= :TERINI AND T.TERC_NIT <= :TERFIN AND
            P.PEDI_ID = D.PEDI_ID AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND PEDI_ANULADO = 'N'
            AND PR.PREF_PRE = P.PREF_PRE AND P.TIDO_COD = 34 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY T.TERC_NIT, ARTI_COD
            INTO :NIT, :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL
            DO
            BEGIN
            SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            COSTO = CANTIDAD * COSTOUNIT;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
            else
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (3, USER, :ARTICULO);
            SUSPEND;
            END /* FOR */
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 3 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 3 AND REPA_USER = USER;

        FOR SELECT MAX(T.TERC_NIT), MAX(TERC_NOM), MAX(TERC_TEL), MAX(TERC_CIU), MAX(ZONA_COD), MAX(ARTI_COD), SUM(CTDE_CANT * CTDE_FACTOR), SUM(COTI_FACTOR*(CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)),
            SUM(COTI_FACTOR*CTDE_IVAMONTO), SUM(COTI_FACTOR*CTDE_TOTAL)
            FROM COTIZACIONES_DETALLE D, COTIZACIONES CT, PREFIJOS P, terceros T, CLIENTES C
            WHERE C.TERC_NIT = T.TERC_NIT AND TERC_CLIE = 'S' AND C.terc_nit = T.terc_nit AND T.TERC_NIT >= :TERINI AND T.TERC_NIT <= :TERFIN AND
            CT.COTI_ID = D.COTI_ID AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND COTI_ANULADO = 'N'
            AND P.PREF_PRE = CT.PREF_PRE AND P.TIDO_COD = 35 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY T.TERC_NIT, ARTI_COD
            INTO :NIT, :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL
            DO
            BEGIN
            SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            COSTO = CANTIDAD * COSTOUNIT;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
            else
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (3, USER, :ARTICULO);
            SUSPEND;
            END /* FOR */
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 3 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    END
ELSE
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
            FOR SELECT F.PREF_PRE, FACT_NUMERO, FACT_FECHA, ARTI_COD, FADE_CANT * FADE_FACTOR, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR,
                FADE_IVAMONTO*FACT_FACTOR, FADE_DTOPORC, FADE_TOTAL*FACT_FACTOR, F.terc_nit, F.fact_nomcliente
                FROM FACTURAS F, FACTURAS_DETALLE D, PREFIJOS P
                WHERE F.FACT_ID = D.FACT_ID AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND F.TERC_NIT >= :TERINI AND F.TERC_NIT <= :TERFIN AND FACT_ANULADO = 'N'
                 AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY f.terc_nit, ARTI_COD, FACT_FECHA, F.FACT_ID, FADE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :NIT, :nombre
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                SUSPEND;
                END
            END
    if (BIN_AND(TIPO, 2) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
            FOR SELECT R.PREF_PRE, REVT_NUMERO, REVT_FECHA, ARTI_COD, RVDE_CANT * RVDE_FACTOR,
                (RVDE_TOTAL - RVDE_IVAMONTO), RVDE_IVAMONTO, RVDE_DTOPORC, RVDE_TOTAL, R.terc_nit, R.revt_nomterc
                FROM REMISIONES_VENTA R, REMISIONES_VENTA_DETALLE D, PREFIJOS P
                WHERE R.REVT_ID = D.REVT_ID AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND R.TERC_NIT >= :TERINI AND R.TERC_NIT <= :TERFIN AND REVT_ANULADO = 'N'
                 AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY r.terc_nit, ARTI_COD, REVT_FECHA, R.REVT_ID, RVDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :NIT, :nombre
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                SUSPEND;
                END
            END
    if (BIN_AND(TIPO, 4) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
            FOR SELECT V.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, ARTI_COD, DVDE_CANT * DVDE_FACTOR, (DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR,
                DVDE_IVAMONTO*DEVT_FACTOR, DVDE_DTOPORC, DVDE_TOTAL*DEVT_FACTOR, V.terc_nit, V.devt_nomterc
                FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D, PREFIJOS P
                WHERE V.DEVT_ID = D.DEVT_ID AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND V.TERC_NIT >= :TERINI AND V.TERC_NIT <= :TERFIN AND DEVT_ANULADO = 'N'
                 AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY v.terc_nit, ARTI_COD, DEVT_FECHA, D.DEVT_ID, DVDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :NIT, :nombre
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                TOTAL = TOTAL * -1;
                IVA = IVA * -1;
                BASE = BASE * -1;
                CANTIDAD = CANTIDAD * -1;
                COSTO = COSTO * -1;
                UTILIDAD = UTILIDAD * -1;
                SUSPEND;
                END
            END
    if (BIN_AND(TIPO, 8) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
            FOR SELECT P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, ARTI_COD, PEDE_CANT * PEDE_FACTOR, (PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR,
                PEDE_IVAMONTO*PEDI_FACTOR, PEDE_DTOPORC, PEDE_TOTAL*PEDI_FACTOR, P.terc_nit, P.pedi_nomterc
                FROM PEDIDOS P, PEDIDOS_DETALLE D, PREFIJOS PR
                WHERE P.PEDI_ID = D.PEDI_ID AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND P.TERC_NIT >= :TERINI AND P.TERC_NIT <= :TERFIN AND PEDI_ANULADO = 'N'
                 AND P.PREF_PRE = PR.PREF_PRE AND P.TIDO_COD = 34 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY p.terc_nit, ARTI_COD, PEDI_FECHA, P.PEDI_ID, PEDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :NIT, :nombre
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                SUSPEND;
                END
            END
    if (BIN_AND(TIPO, 16) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
            FOR SELECT C.PREF_PRE, COTI_NUMERO, COTI_FECHA, ARTI_COD, CTDE_CANT * CTDE_FACTOR, (CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR,
                CTDE_IVAMONTO*COTI_FACTOR, CTDE_DTOPORC, CTDE_TOTAL*COTI_FACTOR, C.terc_nit, C.coti_nomterc
                FROM COTIZACIONES C, COTIZACIONES_DETALLE D, PREFIJOS P
                WHERE C.COTI_ID = D.COTI_ID AND ARTI_COD = :ARTICULO AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND C.TERC_NIT >= :TERINI AND C.TERC_NIT <= :TERFIN AND COTI_ANULADO = 'N'
                 AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY c.terc_nit, COTI_FECHA, C.COTI_ID, CTDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :NIT, :nombre
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                SUSPEND;
                END
            END
    END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE REP_UTILIDAD_VENDEDOR(
    TIPO INTEGER,
    DETALLE CHAR(1),
    VENINI VARCHAR(20),
    VENFIN VARCHAR(20),
    FECINI DATE,
    FECFIN DATE,
    ARTINI VARCHAR(15),
    ARTFIN VARCHAR(15),
    ORDEN CHAR(1),
    CEROS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    CODVEND VARCHAR(20),
    NOMVEND VARCHAR(60),
    NOMTIPO VARCHAR(50),
    ARTICULO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    UNIDAD VARCHAR(8),
    CANTIDAD NUMERIC(18,4),
    BASE NUMERIC(18,2),
    IVA NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    COSTO NUMERIC(18,2),
    UTILIDAD NUMERIC(18,4),
    PORC NUMERIC(9,2),
    TOTAL NUMERIC(18,2),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    DTO NUMERIC(9,2))
AS
DECLARE VARIABLE COSTOUNIT NUMERIC(18,4);
DECLARE VARIABLE CODINI VARCHAR(15);
DECLARE VARIABLE CODFIN VARCHAR(15);
DECLARE VARIABLE DESINI VARCHAR(15);
DECLARE VARIABLE DESFIN VARCHAR(15);
declare variable UOM VARCHAR(20);
BEGIN
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION', 'ARTICULOS', 'SUGERIR PRECIOS CON PORCENTAJE DE MARGEN O UTILIDAD') returning_values (:UOM);
  SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPO INTO :NOMTIPO;
  FOR select VEND_COD, VEND_NOMBRE
    from VENDEDORES
    where VEND_COD >= :VENINI AND VEND_COD <= :VENFIN
    INTO :CODVEND, :NOMVEND
    DO  
    BEGIN
    if (DETALLE = 'N') then
        BEGIN
        if (BIN_AND(TIPO, 1) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
            /* BORRA LA TABLA AUXILIAR */
            DELETE FROM reportes_aux WHERE REPA_ID = 4 AND REPA_USER = USER;
            FOR SELECT MAX(ARTI_COD), SUM(FADE_CANT * FADE_FACTOR), SUM(FACT_FACTOR*(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)),
                SUM(FACT_FACTOR*FADE_IVAMONTO), SUM(FACT_FACTOR*FADE_TOTAL), SUM(FADE_CONSUMO)
                FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P
                WHERE F.FACT_ID = D.FACT_ID AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND FACT_ANULADO = 'N'
                 AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                GROUP BY ARTI_COD
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
                if (CANTIDAD IS NULL) then
                    CANTIDAD = 0;
                if (BASE IS NULL) then
                    BASE = 0;
                if (IVA IS NULL) then
                    IVA = 0;
                COSTO = CANTIDAD * COSTOUNIT;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    begin
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                    SUSPEND;
                    end
                ELSE
                    if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                        SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                /* agregue los articulos sin factura */
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 2) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
            FOR SELECT MAX(ARTI_COD), SUM(RVDE_CANT * RVDE_FACTOR), SUM(RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO), SUM(RVDE_IVAMONTO), SUM(RVDE_TOTAL), SUM(RVDE_CONSUMO)
                FROM REMISIONES_VENTA_DETALLE D, REMISIONES_VENTA R, PREFIJOS P
                WHERE R.REVT_ID = D.REVT_ID AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND REVT_ANULADO = 'N'
                 AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                GROUP BY ARTI_COD
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
                if (CANTIDAD IS NULL) then
                    CANTIDAD = 0;
                if (BASE IS NULL) then
                    BASE = 0;
                if (IVA IS NULL) then
                    IVA = 0;
                COSTO = CANTIDAD * COSTOUNIT;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    begin
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                    SUSPEND;
                    end
                ELSE
                    if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                        SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                /* agregue los articulos sin factura */
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 4) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
            FOR SELECT MAX(ARTI_COD), SUM(DVDE_CANT * DVDE_FACTOR), SUM(DEVT_FACTOR*(DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)),
                SUM(DEVT_FACTOR*DVDE_IVAMONTO), SUM(DEVT_FACTOR*DVDE_TOTAL), SUM(DVDE_CONSUMO)
                FROM devoluciones_ventas_detalle D, DEVOLUCIONES_VENTAS V, PREFIJOS P
                WHERE V.DEVT_ID = D.DEVT_ID AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND DEVT_ANULADO = 'N'
                 AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                GROUP BY ARTI_COD
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
                if (CANTIDAD IS NULL) then
                    CANTIDAD = 0;
                if (BASE IS NULL) then
                    BASE = 0;
                if (IVA IS NULL) then
                    IVA = 0;
                COSTO = CANTIDAD * COSTOUNIT;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                TOTAL = TOTAL * -1;
                IVA = IVA * -1;
                BASE = BASE * -1;
                CANTIDAD = CANTIDAD * -1;
                COSTO = COSTO * -1;
                UTILIDAD = UTILIDAD * -1;
                if (CEROS = 'S') then
                    begin
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                    SUSPEND;
                    end
                ELSE
                    if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                        SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                /* agregue los articulos sin factura */
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 8) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
            FOR SELECT MAX(ARTI_COD), SUM(PEDE_CANT * PEDE_FACTOR), SUM(PEDI_FACTOR*(PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)),
                SUM(PEDI_FACTOR*PEDE_IVAMONTO), SUM(PEDI_FACTOR*PEDE_TOTAL), SUM(PEDE_CONSUMO)
                FROM PEDIDOS_DETALLE D, PEDIDOS P, PREFIJOS PR
                WHERE P.PEDI_ID = D.PEDI_ID AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND PEDI_ANULADO = 'N'
                 AND PR.PREF_PRE = P.PREF_PRE AND P.TIDO_COD = 34 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                GROUP BY ARTI_COD
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
                if (CANTIDAD IS NULL) then
                    CANTIDAD = 0;
                if (BASE IS NULL) then
                    BASE = 0;
                if (IVA IS NULL) then
                    IVA = 0;
                COSTO = CANTIDAD * COSTOUNIT;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    begin
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                    SUSPEND;
                    end
                ELSE
                    if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                        SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                /* agregue los articulos sin factura */
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 16) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
            FOR SELECT MAX(ARTI_COD), SUM(CTDE_CANT * CTDE_FACTOR), SUM(COTI_FACTOR*(CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)),
                SUM(COTI_FACTOR*CTDE_IVAMONTO), SUM(COTI_FACTOR*CTDE_TOTAL), SUM(CTDE_CONSUMO)
                FROM COTIZACIONES_DETALLE D, COTIZACIONES C, PREFIJOS P
                WHERE C.COTI_ID = D.COTI_ID AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND COTI_ANULADO = 'N'
                 AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                GROUP BY ARTI_COD
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
                if (CANTIDAD IS NULL) then
                    CANTIDAD = 0;
                if (BASE IS NULL) then
                    BASE = 0;
                if (IVA IS NULL) then
                    IVA = 0;
                COSTO = CANTIDAD * COSTOUNIT;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    begin
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                    SUSPEND;
                    end
                ELSE
                    if ((BASE <> 0) AND (CANTIDAD <> 0)) then
                        SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                /* agregue los articulos sin factura */
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    ELSE
        BEGIN
        if (BIN_AND(TIPO, 1) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
            FOR SELECT F.PREF_PRE, FACT_NUMERO, FACT_FECHA, ARTI_COD, FADE_CANT * FADE_FACTOR, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR,
                FADE_IVAMONTO*FACT_FACTOR, FADE_DTOPORC, FADE_TOTAL*FACT_FACTOR, FADE_CONSUMO
                FROM FACTURAS F, FACTURAS_DETALLE D, PREFIJOS P
                WHERE F.FACT_ID = D.FACT_ID AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND FACT_ANULADO = 'N'
                 AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY ARTI_COD, FACT_FECHA, F.FACT_ID, FADE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                /* agregue los articulos sin factura */
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 2) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
            FOR SELECT R.PREF_PRE, REVT_NUMERO, REVT_FECHA, ARTI_COD, RVDE_CANT * RVDE_FACTOR, (RVDE_TOTAL - RVDE_IVAMONTO), RVDE_IVAMONTO, RVDE_DTOPORC, RVDE_TOTAL, RVDE_CONSUMO
                FROM REMISIONES_VENTA R, REMISIONES_VENTA_DETALLE D, PREFIJOS P
                WHERE R.REVT_ID = D.REVT_ID AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND REVT_ANULADO = 'N'
                 AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY ARTI_COD, REVT_FECHA, R.REVT_ID, RVDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                /* agregue los articulos sin factura */
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 4) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
            FOR SELECT V.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, ARTI_COD, DVDE_CANT * DVDE_FACTOR, (DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR,
                DVDE_IVAMONTO*DEVT_FACTOR, DVDE_DTOPORC, DVDE_TOTAL*DEVT_FACTOR, DVDE_CONSUMO
                FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D, PREFIJOS P
                WHERE V.DEVT_ID = D.DEVT_ID AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND DEVT_ANULADO = 'N'
                 AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY ARTI_COD, DEVT_FECHA, D.DEVT_ID, DVDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                TOTAL = TOTAL * -1;
                IVA = IVA * -1;
                BASE = BASE * -1;
                CANTIDAD = CANTIDAD * -1;
                COSTO = COSTO * -1;
                UTILIDAD = UTILIDAD * -1;
                if (CEROS = 'S') then
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                /* agregue los articulos sin factura */
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 8) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
            FOR SELECT P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, ARTI_COD, PEDE_CANT * PEDE_FACTOR, (PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR,
                PEDE_IVAMONTO*PEDI_FACTOR, PEDE_DTOPORC, PEDE_TOTAL*PEDI_FACTOR, PEDE_CONSUMO
                FROM PEDIDOS P, PEDIDOS_DETALLE D, PREFIJOS PR
                WHERE P.PEDI_ID = D.PEDI_ID AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND PEDI_ANULADO = 'N'
                 AND P.PREF_PRE = PR.PREF_PRE AND P.TIDO_COD = 34 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY ARTI_COD, PEDI_FECHA, P.PEDI_ID, PEDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                /* agregue los articulos sin factura */
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        if (BIN_AND(TIPO, 16) <> 0) then
            BEGIN
            SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
            FOR SELECT C.PREF_PRE, COTI_NUMERO, COTI_FECHA, ARTI_COD, CTDE_CANT * CTDE_FACTOR, (CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR,
                CTDE_IVAMONTO*COTI_FACTOR, CTDE_DTOPORC, CTDE_TOTAL*COTI_FACTOR, CTDE_CONSUMO
                FROM COTIZACIONES C, COTIZACIONES_DETALLE D, PREFIJOS P
                WHERE C.COTI_ID = D.COTI_ID AND ARTI_COD = :ARTICULO AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND VEND_COD = :CODVEND AND COTI_ANULADO = 'N'
                 AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY COTI_FECHA, C.COTI_ID, CTDE_ITEM
                INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :DTO, :TOTAL, :CONSUMO
                DO
                BEGIN
                SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO WHERE ARTI_COD = :ARTICULO
                    INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
                COSTO = COSTOUNIT * CANTIDAD;
                UTILIDAD = BASE - COSTO;
                if (UOM = 'UTILIDAD') then
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                else
                    EXECUTE PROCEDURE PORCENTAJE (utilidad,  BASE, 'S') returning_values (PORC);
                if (CEROS = 'S') then
                    INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (4, USER, :ARTICULO);
                SUSPEND;
                END
            if (CEROS = 'S') then
                BEGIN
                COSTO = 0;
                UTILIDAD = 0;
                PORC = 0;
                /* agregue los articulos sin factura */
                FOR SELECT ARTI_COD, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                    FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN and
                    not exists (select REPA_ARTICULO FROM REPORTES_AUX WHERE REPA_ID = 4 AND REPA_USER = USER AND REPA_ARTICULO = a.arti_cod)
                    INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                    DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    END
END

^

SET TERM ; ^

CREATE TABLE PUNTO_EQUILIBRIO (
    PTEQ_ITEM    T_ID NOT NULL,
    PTEQ_CUENTA  T_CTA_CONTABLE,
    PTEQ_SECC    SMALLINT,
    PTEQ_DB      T_BOOLEANO
);

SET TERM ^ ;

ALTER PROCEDURE REP_UTILIDAD_VENTAS(
    TIPO INTEGER,
    DETALLE CHAR(1),
    FECINI DATE,
    FECFIN DATE,
    ARTINI VARCHAR(15),
    ARTFIN VARCHAR(15),
    GRPINI VARCHAR(3),
    GRPFIN VARCHAR(3),
    ORDEN CHAR(1),
    AGRUPA CHAR(1),
    CEROS CHAR(1),
    EQUILIBRIO CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    ARTICULO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    UNIDAD VARCHAR(8),
    CANTIDAD NUMERIC(18,4),
    BASE NUMERIC(18,4),
    COSTO NUMERIC(18,4),
    UTILIDAD NUMERIC(18,4),
    PORC NUMERIC(9,2),
    IVA NUMERIC(18,4),
    CONSUMO NUMERIC(18,4),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    TIPODOC INTEGER)
AS
DECLARE VARIABLE COSTOUNIT NUMERIC(18,4);
declare variable CODINI VARCHAR(15);
declare variable CODFIN VARCHAR(15);
declare variable DESINI VARCHAR(15);
declare variable DESFIN VARCHAR(15);
declare variable MARINI VARCHAR(3);
declare variable MARFIN VARCHAR(3);
declare variable UOM VARCHAR(20);
declare variable NUMROWS INTEGER;
declare variable TOTAL NUMERIC(18,2);
declare variable CUENTA VARCHAR(20);
declare variable SECC INTEGER;
declare variable DB CHAR(1);
declare variable FECCNT VARCHAR(8);
declare variable FIJOS NUMERIC(18,2);
declare variable VARIA NUMERIC(18,2);
declare variable SALDO NUMERIC(18,2);
BEGIN
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END
if (AGRUPA = 'G') then
    BEGIN
    MARINI = '';
    MARFIN = 'zz';
    END
ELSE
    if (AGRUPA = 'M') then
        BEGIN
        MARINI = GRPINI;
        MARFIN = GRPFIN;
        GRPINI = '';
        GRPFIN = 'zz';
        END
    ELSE
        BEGIN
        MARINI = '';
        MARFIN = 'zz';
        GRPINI = '';
        GRPFIN = 'zz';
        END
EXECUTE PROCEDURE lee_configuracion ('FACTURACION', 'ARTICULOS', 'SUGERIR PRECIOS CON PORCENTAJE DE MARGEN O UTILIDAD') returning_values (:UOM);
if (DETALLE = 'N') then
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        TIPODOC = 31;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 2 AND REPA_USER = USER;
        if (EQUILIBRIO = 'S') then
            BEGIN
            SELECT SUM((FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR)
                FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P
                WHERE F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND 
                FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND
                FACT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                INTO :TOTAL;

            execute PROCEDURE fecha_a_conta (:FECFIN) returning_values (:FECCNT);
            FIJOS = 0;
            FOR SELECT PTEQ_CUENTA, PTEQ_DB FROM PUNTO_EQUILIBRIO WHERE PTEQ_SECC = 1 INTO :CUENTA, :DB
                DO
                BEGIN
                /* CALCULE EL SALDO DE LA CUENTA */
                EXECUTE PROCEDURE saldo_cuenta (CUENTA, :FECCNT) returning_values (:SALDO);
                if (DB = 'S') then
                    FIJOS = FIJOS + SALDO;
                ELSE
                    FIJOS = FIJOS - SALDO;
                END
            VARIA = 0;
            FOR SELECT PTEQ_CUENTA, PTEQ_DB FROM PUNTO_EQUILIBRIO WHERE PTEQ_SECC = 2 INTO :CUENTA, :DB
                DO
                BEGIN
                /* CALCULE EL SALDO DE LA CUENTA */
                EXECUTE PROCEDURE saldo_cuenta (CUENTA, :FECCNT) returning_values (:SALDO);
                if (DB = 'S') then
                    VARIA = VARIA + SALDO;
                ELSE
                    VARIA = VARIA - SALDO;
                END
            END

        FOR SELECT MAX(D.ARTI_COD), SUM(FADE_CANT * FADE_FACTOR), SUM((FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR), SUM(FADE_IVAMONTO*FACT_FACTOR), SUM(FADE_CONSUMO),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), SUM(COST_SALP)
            FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P, ARTICULO A, movimiento_articulo m, costos c
            WHERE F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND D.ARTI_COD = A.arti_cod AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            F.fact_id = M.mvar_idref AND M.mvar_tipodoc = 31 AND M.mvar_item = D.fade_item AND M.mvar_cons = C.cost_idmov AND
            FACT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY D.ARTI_COD
            INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :COSTO
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
/*            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);*/
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
/*            COSTO = cantidad * COSTOUNIT;*/
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (2, USER, :ARTICULO);
            SUSPEND;
            END /* FOR */
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND
                    A.ARTI_DES <= :DESFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND
                    (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN)))
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,:DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 2 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        TIPODOC = 32;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 2 AND REPA_USER = USER;

        FOR SELECT MAX(D.ARTI_COD), SUM(RVDE_CANT * RVDE_FACTOR), SUM(RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO), SUM(RVDE_IVAMONTO), SUM(RVDE_CONSUMO),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), SUM(COST_SALP)
            FROM REMISIONES_VENTA_DETALLE D, REMISIONES_VENTA R, PREFIJOS P, ARTICULO A, movimiento_articulo m, costos c
            WHERE R.REVT_ID = D.REVT_ID AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND D.ARTI_COD = A.arti_cod AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            R.revt_id = M.mvar_idref AND M.mvar_tipodoc = 32 AND M.mvar_item = D.rvde_item AND M.mvar_cons = C.cost_idmov AND
            REVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY D.ARTI_COD
            INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :COSTO
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
/*            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT); */
/*            COSTO = cantidad * COSTOUNIT;*/
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (2, USER, :ARTICULO);
            SUSPEND;
            END /* FOR */
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND
                    A.ARTI_DES <= :DESFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND
                    (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN)))
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,:DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 2 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        TIPODOC = 33;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 2 AND REPA_USER = USER;

        FOR SELECT MAX(D.ARTI_COD), SUM(DVDE_CANT * DVDE_FACTOR), SUM((DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR), SUM(DVDE_IVAMONTO*DEVT_FACTOR), SUM(DVDE_CONSUMO),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD), SUM(COST_ENTP)
            FROM devoluciones_ventas_detalle D, DEVOLUCIONES_VENTAS V, PREFIJOS P, ARTICULO A, MOVIMIENTO_ARTICULO M, COSTOS C
            WHERE V.DEVT_ID = D.DEVT_ID AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND D.ARTI_COD = A.arti_cod AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            V.devt_id = M.mvar_idref AND M.mvar_tipodoc = 33 AND M.mvar_item = D.dvde_item AND M.mvar_cons = C.cost_idmov AND
            DEVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY D.ARTI_COD
            INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :COSTO
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            else
                CANTIDAD = CANTIDAD * -1;
            if (BASE IS NULL) then
                BASE = 0;
            else
                BASE = BASE * -1;
            if (IVA IS NULL) then
                IVA = 0;
            else
                IVA = IVA * -1;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            else
                CONSUMO = CONSUMO * -1;
/*            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);*/
/*            COSTO = cantidad * COSTOUNIT;*/
            COSTO = costo * -1;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (2, USER, :ARTICULO);
            SUSPEND;
            END /* FOR */
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND
                    A.ARTI_DES <= :DESFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND
                    (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN)))
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,:DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 2 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        TIPODOC = 34;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 2 AND REPA_USER = USER;

        FOR SELECT MAX(D.ARTI_COD), SUM(PEDE_CANT * PEDE_FACTOR), SUM((PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR), SUM(PEDE_IVAMONTO*PEDI_FACTOR), SUM(PEDE_CONSUMO),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM PEDIDOS_DETALLE D, PEDIDOS P, PREFIJOS R, ARTICULO A
            WHERE P.PEDI_ID = D.PEDI_ID AND P.PREF_PRE = R.PREF_PRE AND R.TIDO_COD = 34 AND D.ARTI_COD = A.arti_cod AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            PEDI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY D.ARTI_COD
            INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
            COSTO = cantidad * COSTOUNIT;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (2, USER, :ARTICULO);
            SUSPEND;
            END /* FOR */
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND
                    A.ARTI_DES <= :DESFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND
                    (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN)))
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,:DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 2 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        TIPODOC = 35;
        /* BORRA LA TABLA AUXILIAR */
        DELETE FROM reportes_aux WHERE REPA_ID = 2 AND REPA_USER = USER;

        FOR SELECT MAX(D.ARTI_COD), SUM(CTDE_CANT * CTDE_FACTOR), SUM((CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR), SUM(CTDE_IVAMONTO), SUM(CTDE_CONSUMO),
            MAX(ARTI_DES), MAX(ARTI_UNIDAD), MAX(GRUP_COD), MAX(SUBG_COD), MAX(MARC_COD)
            FROM COTIZACIONES_DETALLE D, COTIZACIONES C, PREFIJOS P, ARTICULO A
            WHERE C.COTI_ID = D.COTI_ID AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND D.ARTI_COD = A.arti_cod AND
            A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
            A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND
            (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
            COTI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            GROUP BY D.ARTI_COD
            INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
            :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            if (CANTIDAD IS NULL) then
                CANTIDAD = 0;
            if (BASE IS NULL) then
                BASE = 0;
            if (IVA IS NULL) then
                IVA = 0;
            if (CONSUMO IS NULL) then
                CONSUMO = 0;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECFIN) RETURNING_VALUES (:COSTOUNIT);
            COSTO = cantidad * COSTOUNIT;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            if (CEROS = 'S') then
                INSERT INTO REPORTES_AUX (REPA_ID, REPA_USER, REPA_ARTICULO) VALUES (2, USER, :ARTICULO);
            SUSPEND;
            END /* FOR */
        if (CEROS = 'S') then
            BEGIN
            COSTO = 0;
            UTILIDAD = 0;
            PORC = 0;
            /* agregue los articulos sin factura */
            FOR SELECT ARTI_COD, 0, 0, 0, 0, ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                FROM ARTICULO A WHERE A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND
                    A.ARTI_DES <= :DESFIN AND A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND
                    (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN)))
                INTO :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,:DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
                DO
                BEGIN
                SELECT COUNT(REPA_ARTICULO) FROM REPORTES_AUX WHERE REPA_ID = 2 AND REPA_USER = USER AND REPA_ARTICULO = :articulo INTO :numrows;
                if (numrows = 0) then
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    SUSPEND;
                    END
                END
            END
        END
    END
ELSE
    BEGIN
    if (BIN_AND(TIPO, 1) <> 0) then
        BEGIN
        TIPODOC = 31;
        FOR SELECT F.PREF_PRE, FACT_NUMERO, FACT_FECHA, D.ARTI_COD, FADE_CANT * FADE_FACTOR, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*FACT_FACTOR, FADE_IVAMONTO*FACT_FACTOR, FADE_CONSUMO,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, COST_SALP
            FROM FACTURAS F, FACTURAS_DETALLE D, PREFIJOS P, ARTICULO A, MOVIMIENTO_ARTICULO M, COSTOS C
            WHERE F.FACT_ID = D.FACT_ID AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND D.ARTI_COD = A.arti_cod AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND FACT_FECHA >= :FECINI AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                F.fact_id = M.mvar_idref AND M.mvar_tipodoc = 31 AND M.mvar_item = D.fade_item AND M.mvar_cons = C.cost_idmov AND
                FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY D.ARTI_COD, FACT_FECHA, F.FACT_ID, FADE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :COSTO
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
/*            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);*/
/*            COSTO = COSTOUNIT * CANTIDAD;*/
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 2) <> 0) then
        BEGIN
        TIPODOC = 32;
        FOR SELECT R.PREF_PRE, REVT_NUMERO, REVT_FECHA, D.ARTI_COD, RVDE_CANT * RVDE_FACTOR, RVDE_TOTAL-RVDE_IVAMONTO-RVDE_CONSUMO, RVDE_IVAMONTO, RVDE_CONSUMO,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, COST_SALP
            FROM REMISIONES_VENTA R, REMISIONES_VENTA_DETALLE D, PREFIJOS P, ARTICULO A, MOVIMIENTO_ARTICULO M, COSTOS C
            WHERE R.REVT_ID = D.REVT_ID AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND D.ARTI_COD = A.arti_cod AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND
                R.revt_id = M.mvar_idref AND M.mvar_tipodoc = 32 AND M.mvar_item = D.rvde_item AND M.mvar_cons = C.cost_idmov AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                REVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY D.ARTI_COD, REVT_FECHA, R.REVT_ID, RVDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :COSTO
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
            COSTO = COSTOUNIT * CANTIDAD;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 4) <> 0) then
        BEGIN
        TIPODOC = 33;
        FOR SELECT V.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, D.ARTI_COD, DVDE_CANT * DVDE_FACTOR, (DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*DEVT_FACTOR, DVDE_IVAMONTO*DEVT_FACTOR, DVDE_CONSUMO,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD, COST_ENTP
            FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D, PREFIJOS P, ARTICULO A, MOVIMIENTO_ARTICULO M, COSTOS C
            WHERE V.DEVT_ID = D.DEVT_ID AND P.PREF_PRE = V.PREF_PRE AND P.TIDO_COD = 33 AND D.ARTI_COD = A.arti_cod AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                V.devt_id = M.mvar_idref AND M.mvar_tipodoc = 33 AND M.mvar_item = D.dvde_item AND M.mvar_cons = C.cost_idmov AND
                DEVT_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY D.ARTI_COD, DEVT_FECHA, V.DEVT_ID, DVDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :COSTO
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
            BASE = BASE * -1;
            CANTIDAD = CANTIDAD * -1;
            IVA = IVA * -1;
            CONSUMO = CONSUMO * -1;
            COSTO = COSTOUNIT * CANTIDAD;
            COSTO = COSTO * -1;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 8) <> 0) then
        BEGIN
        TIPODOC = 34;
        FOR SELECT P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, D.ARTI_COD, PEDE_CANT * PEDE_FACTOR, (PEDE_TOTAL-PEDE_IVAMONTO-PEDE_CONSUMO)*PEDI_FACTOR, PEDE_IVAMONTO*PEDI_FACTOR, PEDE_CONSUMO,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD 
            FROM PEDIDOS P, PEDIDOS_DETALLE D, PREFIJOS R, ARTICULO A
            WHERE P.PEDI_ID = D.PEDI_ID AND P.PREF_PRE = R.PREF_PRE AND R.TIDO_COD = 34 AND D.ARTI_COD = A.arti_cod AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                PEDI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY D.ARTI_COD, PEDI_FECHA, P.PEDI_ID, PEDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
            COSTO = COSTOUNIT * CANTIDAD;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            SUSPEND;
            END
        END
    if (BIN_AND(TIPO, 16) <> 0) then
        BEGIN
        TIPODOC = 35;
        FOR SELECT C.PREF_PRE, COTI_NUMERO, COTI_FECHA, D.ARTI_COD, CTDE_CANT * CTDE_FACTOR, (CTDE_TOTAL-CTDE_IVAMONTO-CTDE_CONSUMO)*COTI_FACTOR, CTDE_IVAMONTO*COTI_FACTOR, CTDE_CONSUMO,
            ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD 
            FROM COTIZACIONES C, COTIZACIONES_DETALLE D, PREFIJOS P, ARTICULO A
            WHERE C.COTI_ID = D.COTI_ID AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND D.ARTI_COD = A.arti_cod AND
                A.ARTI_COD >= :CODINI AND A.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                A.GRUP_COD >= :GRPINI AND A.GRUP_COD <= :grpfin AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND
                (((:MARINI = '') AND (:MARFIN = 'zz')) or ((A.MARC_COD >= :MARINI) AND (A.MARC_COD <= :MARFIN))) AND
                COTI_ANULADO = 'N' AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            ORDER BY D.ARTI_COD, COTI_FECHA, C.COTI_ID, CTDE_ITEM
            INTO :PREFIJO, :NUMERO, :FECHA, :ARTICULO, :CANTIDAD, :BASE, :IVA, :CONSUMO,
                :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
            DO
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            EXECUTE PROCEDURE costo_promedio (:ARTICULO, :FECHA) RETURNING_VALUES (:COSTOUNIT);
            COSTO = COSTOUNIT * CANTIDAD;
            UTILIDAD = BASE - COSTO;
            if (UOM = 'UTILIDAD') then
                if (COSTO > 0) then
                    PORC = UTILIDAD * 100 / COSTO;
                ELSE
                    PORC = 100;
            else
                if (BASE > 0) then
                    PORC = UTILIDAD * 100 / BASE;
                ELSE
                    PORC = 0;
            SUSPEND;
            END
        END
    END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE RESERVAS_ARTICULO(
    FECHA DATE,
    DETALLE CHAR(1))
RETURNS (
    CODIGO VARCHAR(15),
    NOMBRE VARCHAR(60),
    RESERVA NUMERIC(18,4),
    EXIST NUMERIC(18,2),
    FALTANTE NUMERIC(18,2),
    COSTO NUMERIC(18,2),
    UNIDAD VARCHAR(8),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    COSTOTOT NUMERIC(18,2),
    CLIENTE VARCHAR(60),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHADOC DATE)
AS
declare variable PEDIDO NUMERIC(18,4);
declare variable ID INTEGER;
declare variable ITEM INTEGER;
declare variable UND VARCHAR(8);
declare variable FACTOR NUMERIC(18,4);
declare variable FACT NUMERIC(18,4);
declare variable CANT NUMERIC(18,4);
declare variable PEDAUTO CHAR(2);
BEGIN
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'FACTURAS', 'GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') returning_values (pedauto);
  FOR
    SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD
      FROM ARTICULO A
      INTO :CODIGO, :NOMBRE, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
      DO
        BEGIN
        NOMMARC = '';
        NOMSUBG = '';
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
        EXECUTE PROCEDURE SALDO_TOTAL_INVENTARIO(CODIGO, FECHA) returning_values (EXIST);
        if (DETALLE = 'N') then
            BEGIN
            EXECUTE PROCEDURE COSTO_PROMEDIO(CODIGO, FECHA) returning_values (COSTO);
            SELECT SUM(RSDE_LIBERAR) FROM RESERVAS R, RESERVAS_DETALLE RD
                WHERE R.RESE_ID = RD.RESE_ID AND RD.ARTI_COD = :CODIGO AND RESE_FECHA <= :FECHA AND RESE_VENCE > :FECHA AND RESE_ANULADO = 'N'
                INTO :RESERVA;
            if (RESERVA IS NULL) then
                RESERVA = 0;
            FOR SELECT P.PEDI_ID, PEDE_ITEM, PEDE_CANT * PEDE_FACTOR
                FROM PEDIDOS P, PEDIDOS_DETALLE D
                WHERE P.PEDI_ID = D.PEDI_ID AND D.ARTI_COD = :CODIGO AND (PEDI_FECHA+PEDI_VALIDEZ) >= :FECHA AND PEDI_FECHA <= :FECHA AND PEDI_ANULADO = 'N'
                INTO :ID, :item, :CANT
                DO
                BEGIN
                EXECUTE PROCEDURE FALTANTE(34, 31, ID, ITEM) returning_values (PEDIDO, UND, FACT);
                if (PEDIDO * FACT = CANT) then
                    EXECUTE PROCEDURE FALTANTE(34, 32, ID, ITEM) returning_values (PEDIDO, UND, FACT);
                if (PEDIDO IS NULL) then
                    PEDIDO = 0;
                RESERVA = RESERVA + PEDIDO;
                END
            if (RESERVA > EXIST) then
                FALTANTE = RESERVA - EXIST;
            ELSE
                FALTANTE = 0;
            COSTOTOT = RESERVA * COSTO;
            if (RESERVA > 0) then
                SUSPEND;
            END
        ELSE
            BEGIN
            FOR SELECT RESE_FECHA, PREF_PRE, RESE_NUMERO, RESE_NOMTERC, RDSE_CANT, RSDE_UNIDAD, RSDE_LIBERAR
                FROM RESERVAS R, RESERVAS_DETALLE RD
                WHERE R.RESE_ID = RD.RESE_ID AND RD.ARTI_COD = :CODIGO AND RESE_FECHA <= :FECHA AND RESE_VENCE > :FECHA AND RESE_ANULADO = 'N'
                INTO :FECHADOC, :PREFIJO, :NUMERO, :CLIENTE, :RESERVA, :UNIDAD, :FALTANTE
                DO
                BEGIN
                if (RESERVA > EXIST) then
                    FALTANTE = RESERVA - EXIST;
                ELSE
                    FALTANTE = 0;
                COSTOTOT = RESERVA * COSTO;
                SUSPEND;
                END
            FOR SELECT P.PEDI_ID, PEDE_ITEM, PEDI_FECHA, PREF_PRE, PEDI_NUMERO, PEDI_NOMTERC, PEDE_CANT, PEDE_UNIDAD, PEDE_RESERVA, PEDE_FACTOR
                FROM PEDIDOS P, PEDIDOS_DETALLE PD
                WHERE P.PEDI_ID = PD.PEDI_ID AND PD.ARTI_COD = :CODIGO AND PEDI_FECHA <= :FECHA AND (PEDI_FECHA+PEDI_VALIDEZ) >= :FECHA AND PEDI_ANULADO = 'N'
                INTO :ID, :ITEM, :FECHADOC, :PREFIJO, :NUMERO, :CLIENTE, :CANT, :UNIDAD, :FALTANTE, :FACTOR
                DO
                BEGIN
                EXECUTE PROCEDURE FALTANTE(34, 31, ID, ITEM) returning_values (RESERVA, UND, FACT);
                if ((RESERVA * FACT = CANT * FACTOR) or (PEDAUTO = 'SI')) then
                    EXECUTE PROCEDURE FALTANTE(34, 31, ID, ITEM) returning_values (RESERVA, UND, FACTOR);
                if (RESERVA IS NULL) then
                    RESERVA = 0;
                if (RESERVA > 0) then
                    BEGIN
                    if (RESERVA > EXIST) then
                        FALTANTE = RESERVA - EXIST;
                    ELSE
                        FALTANTE = 0;
                    COSTOTOT = RESERVA * COSTO;
                    SUSPEND;
                    END
                END
            END
        END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE REVISA_PRECIOS(
    LISTA INTEGER,
    FECHA DATE)
RETURNS (
    ARTICULO VARCHAR(20),
    DESCR VARCHAR(60),
    FIJO NUMERIC(18,2),
    UNIDAD VARCHAR(8),
    PORC NUMERIC(9,4),
    SUGERIDO NUMERIC(18,2),
    DIFER NUMERIC(18,2),
    NUEVO NUMERIC(18,2),
    OK CHAR(1))
AS
declare variable marg numeric(9,4);
declare variable UOM VARCHAR(10);
declare variable BASE VARCHAR(10);
declare variable CAMBIO VARCHAR(10);
declare variable COSTO numeric(18,2);
declare variable COSTOP numeric(18,2);
declare variable COSTOU numeric(18,2);
declare variable DIFMAX numeric(18,2);
declare variable DIG INTEGER;
declare variable TARIVA NUMERIC(9,4);
declare variable IVAINC CHAR(1);
declare variable LISTAREF INTEGER;
begin
execute procedure lee_configuracion ('FACTURACION', 'ARTICULOS', 'SUGERIR PRECIOS CON PORCENTAJE DE MARGEN O UTILIDAD') returning_values (:UOM);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'ARTICULOS', 'REDONDEO AL MULTIPLO DE DIEZ EN PRECIOS') RETURNING_VALUES (:DIG);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','CAMBIO DE PRECIOS AUTOMATICO AL CAMBIAR COSTO O PRECIO') returning_values (CAMBIO);
EXECUTE PROCEDURE lee_configuracion('FACTURACION','ARTICULOS','COSTO BASE PARA CALCULO DE PRECIOS DE VENTA AUTOMATICOS') returning_values (:BASE);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','CODIGO DE LA LISTA DE PRECIOS BASE PARA CAMBIO DE PRECIOS AUTOMATICO') returning_values (LISTAREF);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','DIFERENCIA EN PESOS MAXIMA A PERMITIR PARA CAMBIAR PRECIOS') returning_values (DIFMAX);
for select A.arti_cod, A.arti_des, A.arti_unidad, prar_fijo, prar_margen, prar_util, TAIV_PORC
    from precios_articulo p, articulo a, tarifa_iva T
    where a.arti_cod = p.arti_cod and lipr_cod = :lista and a.taiv_cod = t.taiv_cod order by A.arti_cod
    into :articulo, descr, :unidad, :fijo, :marg, :porc, :tariva
    do
    begin
    if (UOM <> 'UTILIDAD') then
        PORC = MARG;
    if (CAMBIO = 'COSTO') then
        BEGIN
        EXECUTE PROCEDURE COSTO_PROMEDIO (:ARTICULO, :FECHA) RETURNING_VALUES(:COSTOP);
        EXECUTE PROCEDURE ULTIMO_COSTO (:ARTICULO, :FECHA, :UNIDAD) RETURNING_VALUES(:COSTOU);
        if (base = 'ULTIMO') then
            COSTO = COSTOU;
        ELSE
            BEGIN
            COSTO = COSTOP;
            if (base = 'MAYOR') then
                if (COSTOP < COSTOU) then
                    COSTO = COSTOU;
            END
        SELECT LIPR_MODIF FROM LISTA_PRECIOS WHERE LIPR_COD = :lista INTO :IVAINC;
        if (IVAINC = 'S') then
            COSTO = COSTO * (1 + TARIVA/100);
        if (UOM = 'UTILIDAD') then
            SUGERIDO = COSTO * (1 + :PORC/100);
        ELSE
            SUGERIDO = COSTO / (1 - :PORC/100);
        END
    ELSE
        if (LISTA <> LISTAREF) then
            BEGIN
            SELECT PRAR_FIJO FROM PRECIOS_ARTICULO WHERE ARTI_COD = :articulo AND LIPR_COD = :LISTAREF INTO :SUGERIDO;
            if (IVAINC = 'S') then
                SUGERIDO = SUGERIDO / (1 + TARIVA/100);
            if (UOM = 'UTILIDAD') then
                SUGERIDO = SUGERIDO * (1 + :PORC/100);
            ELSE
                SUGERIDO = SUGERIDO / (1 - :PORC/100);
            END
    EXECUTE PROCEDURE REDONDEE (SUGERIDO, DIG) returning_values (SUGERIDO);
    DIFER = SUGERIDO - FIJO;
    NUEVO = SUGERIDO;
    OK = 'S';
    if ((DIFER > DIFMAX) and (sugerido <> 0)) then
        suspend;
    end
end

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE UTILIDAD_VENTAS(
    TIPO INTEGER,
    DETALLE CHAR(1),
    FECINI DATE,
    FECFIN DATE,
    PREFIJO VARCHAR(4),
    SUBEMPRESA INTEGER)
RETURNS (
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    PTVTID INTEGER,
    VENDCOD INTEGER,
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    ARTICULO VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    UNIDAD VARCHAR(8),
    PRECIO NUMERIC(18,2),
    COSTO NUMERIC(18,2),
    UTILIDAD NUMERIC(18,2),
    PORC NUMERIC(9,2))
AS
declare variable IMPTOS CHAR(1);
declare variable ID INTEGER;
declare variable IVA NUMERIC(18,2);
declare variable COSTOT NUMERIC(18,2);
declare variable PRECIOT NUMERIC(18,2);
declare variable UOM VARCHAR(20);
BEGIN
EXECUTE PROCEDURE lee_configuracion ('FACTURACION', 'ARTICULOS', 'SUGERIR PRECIOS CON PORCENTAJE DE MARGEN O UTILIDAD') returning_values (:UOM);
/* DETERMINE LA TABLA A EXAMINAR */
if (TIPO = 31) then
    BEGIN
    /* FACTURA */
    FOR SELECT FACT_ID, F.PREF_PRE, FACT_NUMERO, FACT_FECHA, PTVT_ID, VEND_COD, TERC_NIT, FACT_NOMCLIENTE, FACT_IVAINC
        FROM FACTURAS F, PREFIJOS P
        WHERE FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N'
         AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = :TIPO AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY FACT_FECHA, F.PREF_PRE, FACT_NUMERO
        INTO :ID, :PREF, :NUMERO, :FECHA, :PTVTID, :VENDCOD, :NIT, :NOMTERCERO, :IMPTOS
        DO
        if ((PREFIJO = '') or (PREFIJO = PREF)) then
          BEGIN
          COSTOT = 0;
          PRECIOT = 0;
          FOR SELECT ARTI_COD, SUBSTR(FADE_DESC,1,60), FADE_CANT * FADE_FACTOR, FADE_UNIDAD, (FADE_PRUNIT - FADE_DTOMONTO) / FADE_FACTOR, FADE_IVAMONTO
            FROM FACTURAS_DETALLE
            WHERE FACT_ID = :ID
            INTO :ARTICULO, :ARTIDES, :CANT, :UNIDAD, :PRECIO, :IVA
            DO
                BEGIN
                EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
                COSTO = COSTO * CANT;
                PRECIO = PRECIO * CANT;
                if (IMPTOS = 'S') then
                    PRECIO = PRECIO - IVA;
                UTILIDAD = PRECIO - COSTO;
                if (DETALLE = 'S') then
                    BEGIN
                    if (UOM = 'UTILIDAD') then
                        EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                    else
                        EXECUTE PROCEDURE PORCENTAJE (utilidad,  PRECIO, 'S') returning_values (PORC);
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    COSTOT = COSTOT + COSTO;
                    PRECIOT = PRECIOT + PRECIO;
                    END
                END
          if (DETALLE <> 'S') then
            BEGIN
            COSTO = COSTOT;
            PRECIO = PRECIOT;
            UTILIDAD = PRECIO - COSTO;
            if (UOM = 'UTILIDAD') then
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
            else
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  PRECIO, 'S') returning_values (PORC);
            SUSPEND;
            END
          END
    END
  if (TIPO = 32) then
    BEGIN
    /* REMISION */
    FOR SELECT REVT_ID, R.PREF_PRE, REVT_NUMERO, REVT_FECHA, PTVT_ID, VEND_COD, TERC_NIT, REVT_NOMTERC, REVT_IVAINC
        FROM REMISIONES_VENTA R, PREFIJOS P
        WHERE REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND REVT_ANULADO = 'N'
         AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = :TIPO AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY REVT_FECHA, R.PREF_PRE, REVT_NUMERO
        INTO :ID, :PREF, :NUMERO, :FECHA, :PTVTID, :VENDCOD, :NIT, :NOMTERCERO, :IMPTOS
        DO
        if ((PREFIJO = '') or (PREFIJO = PREF)) then
          BEGIN
          COSTOT = 0;
          PRECIOT = 0;
          FOR SELECT ARTI_COD, SUBSTR(RVDE_DESC,1,60), RVDE_CANT * RVDE_FACTOR, RVDE_UNIDAD, (RVDE_PRUNIT - RVDE_DTOMONTO) / RVDE_FACTOR, RVDE_IVAMONTO
            FROM REMISIONES_VENTA_DETALLE
            WHERE REVT_ID = :ID
            INTO :ARTICULO, :ARTIDES, :CANT, :UNIDAD, :PRECIO, :IVA
            DO
                BEGIN
                EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
                COSTO = COSTO * CANT;
                PRECIO = PRECIO * CANT;
                if (IMPTOS = 'S') then
                    PRECIO = PRECIO - IVA;
                UTILIDAD = PRECIO - COSTO;
                if (DETALLE = 'S') then
                    BEGIN
                    if (UOM = 'UTILIDAD') then
                        EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                    else
                        EXECUTE PROCEDURE PORCENTAJE (utilidad,  PRECIO, 'S') returning_values (PORC);
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    COSTOT = COSTOT + COSTO;
                    PRECIOT = PRECIOT + PRECIO;
                    END
                END
          if (DETALLE <> 'S') then
            BEGIN
            COSTO = COSTOT;
            PRECIO = PRECIOT;
            UTILIDAD = PRECIO - COSTO;
            if (UOM = 'UTILIDAD') then
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
            else
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  PRECIO, 'S') returning_values (PORC);
            SUSPEND;
            END
          END
    END
  if (TIPO = 33) then
    BEGIN
    /* DEVOLUCION */
    FOR SELECT DEVT_ID, D.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, PTVT_ID, VEND_COD, TERC_NIT, DEVT_NOMTERC, DEVT_IVAINC
        FROM DEVOLUCIONES_VENTAS D, PREFIJOS P
        WHERE DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN AND DEVT_ANULADO = 'N'
         AND P.PREF_PRE = D.PREF_PRE AND P.TIDO_COD = :TIPO AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY DEVT_FECHA, D.PREF_PRE, DEVT_NUMERO
        INTO :ID, :PREF, :NUMERO, :FECHA, :PTVTID, :VENDCOD, :NIT, :NOMTERCERO, :IMPTOS
        DO
        if ((PREFIJO = '') or (PREFIJO = PREF)) then
          BEGIN
          COSTOT = 0;
          PRECIOT = 0;
          FOR SELECT ARTI_COD, SUBSTR(DVDE_DESC,1,60), DVDE_CANT * DVDE_FACTOR, DVDE_UNIDAD, (DVDE_PRUNIT - DVDE_DTOMONTO) / DVDE_FACTOR, DVDE_IVAMONTO
            FROM DEVOLUCIONES_VENTAS_DETALLE
            WHERE DEVT_ID = :ID
            INTO :ARTICULO, :ARTIDES, :CANT, :UNIDAD, :PRECIO, :IVA
            DO
                BEGIN
                EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
                COSTO = COSTO * CANT;
                PRECIO = PRECIO * CANT;
                if (IMPTOS = 'S') then
                    PRECIO = PRECIO - IVA;
                UTILIDAD = PRECIO - COSTO;
                if (DETALLE = 'S') then
                    BEGIN
                    if (UOM = 'UTILIDAD') then
                        EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                    else
                        EXECUTE PROCEDURE PORCENTAJE (utilidad,  PRECIO, 'S') returning_values (PORC);
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    COSTOT = COSTOT + COSTO;
                    PRECIOT = PRECIOT + PRECIO;
                    END
                END
        if (DETALLE <> 'S') then
            BEGIN
            COSTO = COSTOT;
            PRECIO = PRECIOT;
            UTILIDAD = PRECIO - COSTO;
            if (UOM = 'UTILIDAD') then
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
            else
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  PRECIO, 'S') returning_values (PORC);
            SUSPEND;
            END
        END
    END
  if (TIPO = 34) then
    BEGIN
    /* PEDIDO */
    FOR SELECT PEDI_ID, P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, PTVT_ID, VEND_COD, TERC_NIT, PEDI_NOMTERC, PEDI_IVAINC
        FROM PEDIDOS P, PREFIJOS R
        WHERE PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND PEDI_ANULADO = 'N'
         AND P.PREF_PRE = R.PREF_PRE AND R.TIDO_COD = :TIPO AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY PEDI_FECHA, P.PREF_PRE, PEDI_NUMERO
        INTO :ID, :PREF, :NUMERO, :FECHA, :PTVTID, :VENDCOD, :NIT, :NOMTERCERO, :IMPTOS
        DO
        if ((PREFIJO = '') or (PREFIJO = PREF)) then
          BEGIN
          COSTOT = 0;
          PRECIOT = 0;
          FOR SELECT ARTI_COD, SUBSTR(PEDE_DESC,1,60), PEDE_CANT * PEDE_FACTOR, PEDE_UNIDAD, (PEDE_PRUNIT - PEDE_DTOMONTO) / PEDE_FACTOR, PEDE_IVAMONTO
            FROM PEDIDOS_DETALLE
            WHERE PEDI_ID = :ID
            INTO :ARTICULO, :ARTIDES, :CANT, :UNIDAD, :PRECIO, :IVA
            DO
                BEGIN
                EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
                COSTO = COSTO * CANT;
                PRECIO = PRECIO * CANT;
                if (IMPTOS = 'S') then
                    PRECIO = PRECIO - IVA;
                UTILIDAD = PRECIO - COSTO;
                if (DETALLE = 'S') then
                    BEGIN
                    if (UOM = 'UTILIDAD') then
                        EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                    else
                        EXECUTE PROCEDURE PORCENTAJE (utilidad,  PRECIO, 'S') returning_values (PORC);
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    COSTOT = COSTOT + COSTO;
                    PRECIOT = PRECIOT + PRECIO;
                    END
                END
        if (DETALLE <> 'S') then
            BEGIN
            COSTO = COSTOT;
            PRECIO = PRECIOT;
            UTILIDAD = PRECIO - COSTO;
            if (UOM = 'UTILIDAD') then
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
            else
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  PRECIO, 'S') returning_values (PORC);
            SUSPEND;
            END
        END
    END
  if (TIPO = 35) then
    BEGIN
    /* COTIZACION */
    FOR SELECT COTI_ID, C.PREF_PRE, COTI_NUMERO, COTI_FECHA, PTVT_ID, VEND_COD, TERC_NIT, COTI_NOMTERC, COTI_IMPTOS
        FROM COTIZACIONES C, PREFIJOS P
        WHERE COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND COTI_ANULADO = 'N'
         AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = :TIPO AND ((SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY COTI_FECHA, C.PREF_PRE, COTI_NUMERO
        INTO :ID, :PREF, :NUMERO, :FECHA, :PTVTID, :VENDCOD, :NIT, :NOMTERCERO, :IMPTOS
        DO
        if ((PREFIJO = '') or (PREFIJO = PREF)) then
          BEGIN
          COSTOT = 0;
          PRECIOT = 0;
          FOR SELECT ARTI_COD, SUBSTR(CTDE_DESC,1,60), CTDE_CANT * CTDE_FACTOR, CTDE_UNIDAD, (CTDE_PRUNIT - CTDE_DTOMONTO) / CTDE_FACTOR, CTDE_IVAMONTO
            FROM COTIZACIONES_DETALLE
            WHERE COTI_ID = :ID
            INTO :ARTICULO, :ARTIDES, :CANT, :UNIDAD, :PRECIO, :IVA
            DO
                BEGIN
                EXECUTE PROCEDURE COSTO_PROMEDIO(:ARTICULO, :FECHA) returning_values (:COSTO);
                COSTO = COSTO * CANT;
                PRECIO = PRECIO * CANT;
                if (IMPTOS = 'S') then
                    PRECIO = PRECIO - IVA;
                UTILIDAD = PRECIO - COSTO;
                if (DETALLE = 'S') then
                    BEGIN
                    if (UOM = 'UTILIDAD') then
                        EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
                    else
                        EXECUTE PROCEDURE PORCENTAJE (utilidad,  PRECIO, 'S') returning_values (PORC);
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    COSTOT = COSTOT + COSTO;
                    PRECIOT = PRECIOT + PRECIO;
                    END
                END
        if (DETALLE <> 'S') then
            BEGIN
            COSTO = COSTOT;
            PRECIO = PRECIOT;
            UTILIDAD = PRECIO - COSTO;
            if (UOM = 'UTILIDAD') then
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  COSTO, 'N') returning_values (PORC);
            else
                EXECUTE PROCEDURE PORCENTAJE (utilidad,  PRECIO, 'S') returning_values (PORC);
            SUSPEND;
            END
        END
    END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE CHEQUEO_COSTOS(
    ARTICULO VARCHAR(20),
    FECHA DATE)
AS
declare variable NUMROWS INTEGER;
DECLARE VARIABLE ID INTEGER;
DECLARE VARIABLE FECMV DATE;
DECLARE VARIABLE CANT NUMERIC(15,4);
DECLARE VARIABLE COSTO NUMERIC(18,2);
DECLARE VARIABLE ENTRADA CHAR(1);
DECLARE VARIABLE TIPO INTEGER;
begin
SELECT COUNT(*) FROM COSTOS WHERE ARTI_COD = :ARTICULO AND COST_FECHA > :FECHA INTO :NUMROWS;
if (NUMROWS > 0) then
    BEGIN
    delete from costos where arti_cod = :ARTICULO AND COST_FECHA > :FECHA;
    for select mvar_cons, mvar_fecha, mvar_cant, mvar_costo, mvar_entrada, mvar_tipodoc
        from movimiento_articulo WHERE ARTI_COD = :ARTICULO AND MVAR_FECHA > :FECHA
        order by mvar_fecha, mvar_cons /* SE HACE ESTRICTAMENTE EN ORDEN DE FECHA Y REGISTRO, SI LO EDITAN CAMBIA EL ORDEN */
        into :id, :fecmv, :cant, :costo, :entrada, :tipo
        do
        if ((TIPO <> 13)) then
            EXECUTE PROCEDURE actualice_costo(:ARTICULO, :fecmv, :costo, :cant, :entrada, 'N', :id, :tipo);
    END
end

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE CHEQUEO_INVENTARIO(
    ARTINI VARCHAR(20),
    ARTFIN VARCHAR(20))
AS
DECLARE VARIABLE FECHA DATE;
DECLARE VARIABLE CANT NUMERIC(15,4);
DECLARE VARIABLE COSTO NUMERIC(18,2);
DECLARE VARIABLE ENTRADA CHAR(1);
DECLARE VARIABLE BODEGA CHAR(2);
DECLARE VARIABLE ID INTEGER;
DECLARE VARIABLE TIPO INTEGER;
declare variable TIPOEX CHAR(1);
DECLARE VARIABLE LOTE VARCHAR(20);
DECLARE VARIABLE EXISTE CHAR(1);
declare variable ARTICULO VARCHAR(20);
declare variable IDL INTEGER;
BEGIN
for select arti_cod from articulo where arti_cod >= :artini and arti_cod <= :artfin into :ARTICULO
  DO
  BEGIN
  DELETE FROM existencia_lote where arti_cod = :articulo;
  DELETE FROM lotes where arti_cod = :articulo;
  delete from costos where arti_cod = :ARTICULO;
  delete from existencia WHERE ARTI_COD = :ARTICULO;
  for select mvar_cons, mvar_fecha, mvar_cant, mvar_costo, mvar_entrada, bode_cod, mvar_tipodoc, mvar_lote
    from movimiento_articulo WHERE ARTI_COD = :ARTICULO
    order by mvar_fecha, mvar_cons
    into :id, :fecha, :cant, :costo, :entrada, :bodega, :tipo, :lote
  do
    begin
    SELECT ARTI_EXIST
        FROM   ARTICULO
        WHERE  ARTICULO.ARTI_COD = :ARTICULO
        INTO :TIPOEX;
    if ((TIPO <> 13)) then
        EXECUTE PROCEDURE actualice_costo(:ARTICULO, :fecha, :costo, :cant, :entrada, 'N', :id, :tipo);
    /* actualice existencias */
    if (:entrada = 'S') then
        begin
        execute procedure sume_existencia(:articulo, :bodega, :fecha, :cant, 'N');
        if (TIPOEX = 'L') then
            begin
            EXISTE = 'N';
            SELECT 'S' FROM LOTES WHERE ARTI_COD = :ARTICULO AND BODE_COD = :BODEGA AND LOTE_NRO = :lote INTO :EXISTE;
            if (EXISTE = 'S') then
                UPDATE LOTES
                    set lote_saldo = lote_saldo + :cant
                    where (arti_cod = :ARTICULO) and (BODE_COD = :BODEGA) AND (lote_nro = :lote);
            ELSE
                INSERT INTO LOTES (ARTI_COD, BODE_COD, LOTE_NRO, LOTE_FECHA, LOTE_CANT, LOTE_COSTO, LOTE_SALDO)
                    VALUES (:ARTICULO, :bodega, :lote, :fecha, :cant, :costo, :cant);
            end
        end
    else
        begin
        execute procedure reste_existencia(:articulo, :bodega, :fecha, :cant, 'N');
        if (TIPOEX = 'L') then
            begin
            EXISTE = 'N';
            SELECT 'S' FROM LOTES WHERE ARTI_COD = :ARTICULO AND BODE_COD = :BODEGA AND LOTE_NRO = :lote INTO :EXISTE;
            if (EXISTE = 'S') then
                UPDATE LOTES
                    set lote_saldo = lote_saldo - :cant
                    where (arti_cod = :ARTICULO) AND (BODE_COD = :BODEGA) and (lote_nro = :lote);
            ELSE
                BEGIN
                /* ARREGLE EL LOTE YA QUE NO EXISTE */
                SELECT MIN(LOTE_ID) FROM LOTES WHERE ARTI_COD = :articulo AND BODE_COD = :BODEGA AND LOTE_CANT >= :cant INTO :IDL;
                SELECT LOTE_NRO FROM LOTES WHERE LOTE_ID = :IDL INTO :LOTE;
                UPDATE MOVIMIENTO_ARTICULO SET MVAR_LOTE = :LOTE WHERE MVAR_CONS = :ID;
                UPDATE LOTES
                    set lote_saldo = lote_saldo - :cant
                    where (arti_cod = :ARTICULO) and (BODE_COD = :BODEGA) AND (lote_nro = :lote);
                END
            EXISTE = 'N';
            SELECT 'S' FROM EXISTENCIA_LOTE
                WHERE LOTE_NRO = :LOTE AND EXLO_FECHA = :FECHA AND ARTI_COD = :ARTICULO AND BODE_COD = :bodega
                INTO :EXISTE;
            if (EXISTE = 'S') then
                UPDATE EXISTENCIA_LOTE
                       SET EXLO_SAL = EXLO_SAL + :cant
                    WHERE LOTE_NRO = :LOTE AND EXLO_FECHA = :FECHA AND ARTI_COD = :ARTICULO AND BODE_COD = :bodega;
            else
                INSERT INTO EXISTENCIA_LOTE (ARTI_COD, BODE_COD, LOTE_NRO, EXLO_FECHA, EXLO_SAL)
                    VALUES (:ARTICULO, :BODEGA, :LOTE, :FECHA, :CANT);
            end
        end
    END
  END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE CAMBIO_PRECIOS(
    FECHA DATE)
AS
declare variable ART VARCHAR(20);
BEGIN
FOR SELECT ARTI_COD FROM ARTICULO INTO :ART DO
    EXECUTE PROCEDURE CALCULA_PRECIOS(:ART, :FECHA);
  SUSPEND;
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE CONTABILICE_COSTO_VENTAS(
    ID INTEGER,
    IDINTER INTEGER)
RETURNS (
    IDC INTEGER)
AS
declare variable PREF VARCHAR(4);
declare variable NUM VARCHAR(6);
declare variable NUMERO VARCHAR(10);
declare variable INVEN CHAR(1);
declare variable CTAINVEN VARCHAR(20);
declare variable COSTOS CHAR(1);
declare variable CTACOSTOS VARCHAR(20);
declare variable EXISTE CHAR(1);
declare variable CUENTA VARCHAR(20);
declare variable MONTO NUMERIC(18,2);
declare variable TIPOCUEN CHAR(1);
declare variable NIT VARCHAR(20);
declare variable PROY VARCHAR(4);
declare variable CENTRO VARCHAR(4);
declare variable ART VARCHAR(15);
declare variable ANULADO CHAR(1);
declare variable NROI INTEGER;
declare variable NUMROWS INTEGER;
declare variable CONC CHAR(120);
declare variable VENCEAUX DATE;
declare variable VENCE CHAR(8);
begin
/* TRAIGA EL ID DEL ENCABEZADO DEL COMPROBANTE CONTABLE */
SELECT ENCO_CONSEC FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 31 AND ENCO_IDREF = :ID INTO :IDC;
SELECT MAX(CODE_ITEM) FROM COMPROBANTE_DETALLE WHERE ENCO_CONSEC = :idc INTO :NROI;
NROI = NROI + 1;
/* EJECUTE LA PARTE DE CONTABIL_FACTURA QUE CORRESPONDE A LOS COSTOS */
EXISTE = 'N';
SELECT 'S', INVE_COSTO, INVE_INVEN, INVE_CTAINVEN, INVE_CTACOSTOS
    FROM INTERFAZ_VENTAS
    WHERE INVE_ID = :IDINTER
    INTO :EXISTE, :COSTOS, :INVEN, :CTAINVEN, :CTACOSTOS;
if (EXISTE = 'S') then
  BEGIN
  SELECT FACT_ANULADO, PREF_PRE, FACT_NUMERO, FACT_VENCE, TERC_NIT FROM FACTURAS F
        WHERE FACT_ID = :ID INTO :ANULADO, :PREF, :NUMERO, :VENCEAUX, :NIT;
  NUMERO = PREF || NUM;
  CONC = 'COSTO EN VENTAS FACTURA ' || :NUMERO;
  EXECUTE PROCEDURE FECHA_A_CONTA(:VENCEAUX) returning_values (:VENCE);
  if (ANULADO = 'N') then
    BEGIN
    SELECT BODE_CENTRO, BODE_PROY FROM BODEGA B, FACTURAS F, PUNTO_VENTA P
        WHERE B.BODE_COD = P.BODE_COD AND P.PTVT_ID = F.PTVT_ID AND F.FACT_ID = :ID INTO :CENTRO, :PROY;
    /* SE ASUME QUE NO HAN CAMBIADO LAS CUENTAS DE COSTOS, POR ESO SE HACE UPDATE A LOS MOVIMIENTOS DE ESAS CUENTAS */
    EXECUTE PROCEDURE COSTO_EN_VENTAS(31, :ID);
    if (COSTOS = 'A') then
        BEGIN
        FOR SELECT MAX(CTACOS), SUM(CANT * COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTACOS
            INTO :CTACOSTOS, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                CUENTA = NULL;
                SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                    WHERE CUEN_COD = :CTACOSTOS INTO :CUENTA, :TIPOCUEN;
                IF (CUENTA IS NULL) THEN
                    begin
                    EXCEPTION CUENTA_NO_EXISTE 'La cuenta ' || :ctacostos || ' no existe.';
                    end
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT ARTI_COD, CANT * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTACOS = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        SELECT COUNT(*) FROM COMPROBANTE_DETALLE WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC AND ARTI_COD = :ART INTO :NUMROWS;
                        if (NUMROWS = 0) then
                            BEGIN
                            INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            END
                        ELSE
                            UPDATE COMPROBANTE_DETALLE
                                SET CODE_DEBITO = :MONTO
                            WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC AND ARTI_COD = :ART;
                        END
                    END
                ELSE
                    BEGIN
                    SELECT COUNT(*) FROM COMPROBANTE_DETALLE WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC INTO :NUMROWS;
                    if (NUMROWS = 0) then
                        BEGIN
                        if (TIPOCUEN = 'C') then
                            INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                        ELSE
                            INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        NROI = NROI + 1;
                        END
                    ELSE
                        UPDATE COMPROBANTE_DETALLE
                            SET CODE_DEBITO = :MONTO
                        WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC;
                    END
                END /* MONTO <> 0 */
            END /* FOR */
        END /* COSTOS */
    if (COSTOS = 'K') then
        BEGIN
        SELECT SUM(CANT * COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTACOSTOS INTO :CUENTA, :TIPOCUEN;
            IF (CUENTA IS NULL) THEN
                begin
                EXCEPTION CUENTA_NO_EXISTE 'La cuenta ' || :ctacostos || ' no existe.';
                end
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT ARTI_COD, CANT * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    SELECT COUNT(*) FROM COMPROBANTE_DETALLE WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC AND ARTI_COD = :ART INTO :NUMROWS;
                    if (NUMROWS = 0) then
                        BEGIN
                            INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    ELSE
                        UPDATE COMPROBANTE_DETALLE
                            SET CODE_DEBITO = :MONTO
                        WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC AND ARTI_COD = :ART;
                    END
                END
            ELSE
                BEGIN
                SELECT COUNT(*) FROM COMPROBANTE_DETALLE WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC INTO :NUMROWS;
                if (NUMROWS = 0) then
                    BEGIN
                    if (TIPOCUEN = 'C') then
                        INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    ELSE
                        INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                ELSE
                    UPDATE COMPROBANTE_DETALLE
                        SET CODE_DEBITO = :MONTO
                    WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC;
                END
            END /* MONTO <> 0 */
        END /* COSTOS = K */
    if (INVEN = 'A') then
        BEGIN
        FOR SELECT MAX(CTAINV), SUM(CANT * COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTAINV
            INTO :CTAINVEN, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                CUENTA = NULL;
                SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                    WHERE CUEN_COD = :CTAINVEN INTO :CUENTA, :TIPOCUEN;
                IF (CUENTA IS NULL) THEN
                    begin
                    EXCEPTION CUENTA_NO_EXISTE 'La cuenta ' || :ctainven || ' no existe.';
                    end
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT ARTI_COD, CANT * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTAINV = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        SELECT COUNT(*) FROM COMPROBANTE_DETALLE WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC AND ARTI_COD = :ART INTO :NUMROWS;
                        if (NUMROWS = 0) then
                            BEGIN
                            INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            END
                        ELSE
                            UPDATE COMPROBANTE_DETALLE
                                SET CODE_CREDITO = :MONTO
                            WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC AND ARTI_COD = :ART;
                        END
                    END
                ELSE
                    BEGIN
                    SELECT COUNT(*) FROM COMPROBANTE_DETALLE WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC INTO :NUMROWS;
                    if (NUMROWS = 0) then
                        BEGIN
                        if (TIPOCUEN = 'C') then
                            INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                        ELSE
                            INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        NROI = NROI + 1;
                        END
                    ELSE
                        UPDATE COMPROBANTE_DETALLE
                            SET CODE_CREDITO = :MONTO
                        WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC;
                    END
                END /* MONTO <> 0 */
            END /* FOR */
        END /* INVEN = A */
    if (INVEN = 'K') then
        BEGIN
        SELECT SUM(CANT * COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTAINVEN INTO :CUENTA, :TIPOCUEN;
            IF (CUENTA IS NULL) THEN
                begin
                EXCEPTION CUENTA_NO_EXISTE 'La cuenta ' || :ctainven || ' no existe.';
                end
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT ARTI_COD, CANT * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    SELECT COUNT(*) FROM COMPROBANTE_DETALLE WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC AND ARTI_COD = :ART INTO :NUMROWS;
                    if (NUMROWS = 0) then
                        BEGIN
                        INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    ELSE
                        UPDATE COMPROBANTE_DETALLE
                            SET CODE_CREDITO = :MONTO
                        WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC AND ARTI_COD = :ART;
                    END
                END
            ELSE
                BEGIN
                SELECT COUNT(*) FROM COMPROBANTE_DETALLE WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC INTO :NUMROWS;
                if (NUMROWS = 0) then
                    BEGIN
                    if (TIPOCUEN = 'C') then
                        INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    ELSE
                        INSERT INTO comprobante_detalle (ENCO_CONSEC, CODE_ITEM, CUEN_COD, CODE_CONCEPTO, CODE_REFER, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, TERC_NIT, PROY_COD, CENT_COD, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, ARTI_COD, CODE_TIPOAPL, CODE_TIPONUE)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                ELSE
                    UPDATE COMPROBANTE_DETALLE
                        SET CODE_CREDITO = :MONTO
                    WHERE CUEN_COD = :CUENTA AND ENCO_CONSEC = :IDC;
                END
            END /* MONTO <> 0 */
        END /* INVEN = K */
    END
  END
end

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE CONTABIL_DEVOLCLI(
    IDDOC INTEGER,
    IDINTER INTEGER)
RETURNS (
    ERROR INTEGER,
    VER CHAR(1),
    IDC INTEGER)
AS
declare variable PREF VARCHAR(4);
declare variable NUM VARCHAR(6);
declare variable NUMERO VARCHAR(10);
declare variable FECAUX DATE;
declare variable FECHA CHAR(8);
declare variable CONC CHAR(120);
declare variable NUMFAC VARCHAR(10);
declare variable VRDTO NUMERIC(18, 2);
declare variable VRADIC NUMERIC(18, 2);
declare variable VRSUBT NUMERIC(18, 2);
declare variable VRIVA NUMERIC(18, 2);
declare variable PRTFTE NUMERIC(9, 2);
declare variable VRRTFTE NUMERIC(18, 2);
declare variable VRRTIVA NUMERIC(18, 2);
declare variable PRTICA NUMERIC(9, 2);
declare variable VRRTICA NUMERIC(18, 2);
declare variable VRTOTAL NUMERIC(18, 2);
declare variable VREXTRA NUMERIC(18, 2);
declare variable TIPOCOMP VARCHAR(3);
declare variable PREFCONT VARCHAR(4);
declare variable VENTAS CHAR(1);
declare variable CTAVENTAS VARCHAR(20);
declare variable IVA CHAR(1);
declare variable CTAIVA VARCHAR(20);
declare variable CONSUMO CHAR(1);
declare variable CTACONSUMO VARCHAR(20);
declare variable CARTERA CHAR(1);
declare variable CTACARTERA VARCHAR(20);
declare variable RTFTE CHAR(1);
declare variable CTARTFTE VARCHAR(20);
declare variable RTIVA CHAR(1);
declare variable CTARTIVA VARCHAR(20);
declare variable RTICA CHAR(1);
declare variable CTARTICA VARCHAR(20);
declare variable INVEN CHAR(1);
declare variable CTAINVEN VARCHAR(20);
declare variable COSTOS CHAR(1);
declare variable CTACOSTOS VARCHAR(20);
declare variable CTADTO VARCHAR(20);
declare variable CTAADIC VARCHAR(20);
declare variable CTAEXTRA VARCHAR(20);
declare variable EXISTE CHAR(1);
declare variable CUENTA VARCHAR(20);
declare variable MONTO NUMERIC(18,2);
declare variable TIPOCUEN CHAR(1);
declare variable NIT VARCHAR(20);
declare variable PROY VARCHAR(4);
declare variable CENTRO VARCHAR(4);
declare variable PORC NUMERIC(5,2);
declare variable DEBITO NUMERIC(18,2);
declare variable CREDITO NUMERIC(18,2);
declare variable NROI INTEGER;
declare variable ART VARCHAR(15);
declare variable IMPINC CHAR(1);
declare variable IMPTOS NUMERIC(18, 2);
declare variable SUMA NUMERIC(18,2);
declare variable PORCIVA NUMERIC(9,2);
declare variable TCTACLIEN VARCHAR(20);
declare variable TCTAVENTA VARCHAR(20);
declare variable TCTARTFTE VARCHAR(20);
declare variable TCTARTIVA VARCHAR(20);
declare variable TCTARTICA VARCHAR(20);
declare variable CTADIC VARCHAR(20);
declare variable BASEADIC VARCHAR(20);
declare variable PORCADIC NUMERIC(5,2);
declare variable VALORADIC NUMERIC(18,2);
declare variable DBADIC CHAR(1);
declare variable PTOVTA INTEGER;
declare variable ANULADO CHAR(1);
declare variable CENT CHAR(1);
DECLARE VARIABLE MERCANCIA NUMERIC(18,2);
declare variable FACTOR DOUBLE PRECISION;
declare variable DIG INTEGER;
DECLARE VARIABLE FOMENTO VARCHAR(2);
DECLARE VARIABLE VRCONSUMO NUMERIC(18,2);
declare variable AUTORET VARCHAR(10);
declare variable FAUTORET DATE;
declare variable IDREM INTEGER;
declare variable DTOXIT CHAR(2);
declare variable ERRORC INTEGER;
BEGIN
EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'USAR IMPOCONSUMO COMO PORCENTAJE DE FOMENTO') returning_values (FOMENTO);
EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'FECHA AUTORETENEDOR NO DESCONTAR RETENCIONES DEL SALDO PERO SI CONTABILIZARLAS') returning_values (AUTORET);
if (AUTORET <> '') then
    FAUTORET = CAST(AUTORET AS DATE);
else
    FAUTORET = '9999/12/31';
  /* BUSQUE LA INTERFACE */
  EXISTE = 'N';
  SELECT 'S', TICO_COD, PRCO_PRE, INVE_VENTAS, INVE_IVA, INVE_CONSUMO, INVE_CARTERA, INVE_RTFTE, INVE_RTIVA, INVE_RTICA, INVE_COSTO, INVE_INVEN, INVE_CTAVENTAS, INVE_CTAIVA, INVE_CTACONSUMO, INVE_CTADTO, INVE_CTAADIC, INVE_CTAEXTRA, INVE_CTACARTERA, INVE_CTARTFTE, INVE_CTARTIVA, INVE_CTARTICA, INVE_CTAINVEN, INVE_CTACOSTOS, INVE_CONFIRMAR, INVE_CENTRO
    FROM INTERFAZ_VENTAS
    WHERE INVE_ID = :IDINTER
    INTO :EXISTE, :TIPOCOMP, :PREFCONT, :VENTAS, :IVA, :CONSUMO, :CARTERA, :RTFTE, :RTIVA, :RTICA, :COSTOS, :INVEN, :CTAVENTAS, :CTAIVA, :CTACONSUMO, :CTADTO, :CTAADIC, :CTAEXTRA, :CTACARTERA, :CTARTFTE, :CTARTIVA, :CTARTICA, :CTAINVEN, :CTACOSTOS, :VER, :CENT;
  if (EXISTE = 'S') then
   BEGIN
    /* BORRE CUALQUEIR CONTABILIZACION PREVIA */
    DELETE FROM CONTABILIZACION WHERE CNTB_TIPOREF = 33 AND CNTB_IDREF = :IDDOC;
    /* TRAIGA EL ENCABEZADO DE LA DEVOLUCION */
   SELECT PREF_PRE, DEVT_NUMERO, DEVT_FECHA, F.TERC_NIT, DEVT_IVAINC, PTVT_ID, DEVT_FACTURA, DEVT_DTOMONTO, DEVT_ADICIONAL, DEVT_IVAMONTO, DEVT_EXTRA, DEVT_TOTAL, DEVT_RTFTEPORC, DEVT_RTFTEMONTO, DEVT_RTIVAPORC, DEVT_RTIVAMONTO, DEVT_RTICAPORC, DEVT_RTICAMONTO, TERC_CTARTFTE, TERC_CTARTIVA, TERC_CTARTICA, TERC_CTAVENTA, TERC_CTACLIENTE, DEVT_ANULADO, DEVT_REMID
        FROM DEVOLUCIONES_VENTAS F, TERCEROS T
        WHERE DEVT_ID = :IDDOC AND F.TERC_NIT = T.TERC_NIT
        INTO :PREF, :NUM, :FECAUX, :NIT, :IMPINC, :PTOVTA, :NUMFAC, :VRDTO, :VRADIC, :VRIVA, :VREXTRA, :VRTOTAL, :PRTFTE, :VRRTFTE, :PORC, :VRRTIVA, :PRTICA, :VRRTICA, :TCTARTFTE, TCTARTIVA, TCTARTICA, TCTAVENTA, TCTACLIEN, ANULADO, :IDREM;
   if (idrem is null) Then
    IDREM = 0;
   if ((ANULADO = 'N') AND (IDREM = 0)) then
    BEGIN
    NUMERO = PREF || NUM;
    SELECT SUM(DVDE_CONSUMO) FROM devoluciones_ventas_detalle WHERE DEVT_ID = :iddoc INTO :MERCANCIA;
    VRSUBT = VRTOTAL - VREXTRA - VRIVA - MERCANCIA; /* BASE DE RETEFTE Y RETEICA */
    EXECUTE PROCEDURE lee_configuracion ('FACTURACION', 'DEVOLUCIONES', 'DESCUENTO PIE DEVOLUCION IGUAL A SUMA DE DESCUENTOS POR ITEM') returning_values (:DTOXIT);
    if (DTOXIT = 'SI') then
        VRDTO = 0;
    MERCANCIA = VRSUBT - VRADIC + VRDTO;
    IF (CENT = 'B') THEN
        SELECT B.BODE_CENTRO, B.BODE_PROY FROM BODEGA B, DEVOLUCIONES_VENTAS F
            WHERE B.BODE_COD = F.BODE_COD AND F.DEVT_ID = :IDDOC INTO :CENTRO, :PROY;
    IF (CENT = 'V') THEN
        SELECT V.CENT_COD, V.PROY_COD FROM VENDEDORES V, DEVOLUCIONES_VENTAS F
            WHERE V.VEND_COD = F.VEND_COD AND F.DEVT_ID = :IDDOC INTO :CENTRO, :PROY;
    IF (CENT = 'P') THEN
        SELECT P.PREF_CENTRO,P.PREF_PROY  FROM PREFIJOS P, DEVOLUCIONES_VENTAS F
            WHERE P.PREF_PRE = F.PREF_PRE AND F.DEVT_ID = :IDDOC AND P.TIDO_COD = 33 INTO :CENTRO, :PROY;
    EXECUTE PROCEDURE FECHA_A_CONTA(:FECAUX) returning_values (:FECHA);
    /* REGISTRE EL ENCABEZADO CONTABLE */
    IDC = GEN_ID(ID_CONTABILIZA, 1);
    CONC = 'DEVOLUCION VENTAS No. ' || NUMERO || ' EN FACTURA ' || NUMFAC;
    CONC = SUBSTR(CONC, 1, 60);
    INSERT INTO CONTABILIZACION (CNTB_ID, CNTB_TIPOCOMP, CNTB_PREFCNT, CNTB_NUMERO, CNTB_FECHA, CNTB_CONCEPTO, CNTB_REF, CNTB_TIPOREF, CNTB_IDREF, CNTB_PREFREF, CNTB_NUMREF, CNTB_PROCESADO)
        VALUES (:IDC, :TIPOCOMP, :PREFCONT, :NUM, :FECHA, :CONC, '', 33, :IDDOC, :PREF, :NUM, 'N');
    NROI = 0;
    SUMA = 0;
    ERROR = 0;
    /* SI NO HAY CUENTA DE DESCUENTO NI ADICIONAL CALCULE UN FACTOR PARA LAS VENTAS Y EL IVA */
    if (MERCANCIA <> 0) then
        FACTOR = CAST(VRSUBT AS DOUBLE PRECISION) / CAST(MERCANCIA AS DOUBLE PRECISION);
    ELSE
        FACTOR = 1;
    /* TRAIGA EL NUMERO DE DIGITOS PARA EL REDONDEO */
    SELECT CAST(CONF_VALOR AS INTEGER) FROM CONFIGURACION WHERE CONF_MODULO = 'FACTURACION' AND
        CONF_CATEGORIA = 'GENERAL' AND CONF_PROPIEDAD = 'REDONDEO AL MULTIPLO DE DIEZ EN TOTALES' INTO :DIG;
    /* CUENTAS DE VENTAS */
    if (VENTAS = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTADEV), SUM(cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), SUM(DVDE_IVAMONTO), SUM(DVDE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTADEV
            INTO :CTAVENTAS, :MONTO, :IMPTOS, :VRCONSUMO
            DO
            BEGIN
            if (IMPINC = 'S') then
                if (FOMENTO = 'SI') then
                    MONTO = MONTO - IMPTOS;
                ELSE
                    MONTO = MONTO - IMPTOS - VRCONSUMO;
            ELSE
            if (FOMENTO = 'SI') then
            MONTO = MONTO + VRCONSUMO;
            if ((CTADTO IS NULL) OR (CTADTO = '')) then
                MONTO = MONTO * FACTOR;
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAVENTAS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, (cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), (DVDE_IVAMONTO+DVDE_CONSUMO)
                        FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F
                        WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAINV = :CUENTA
                        INTO :ART, :MONTO, :IMPTOS
                    DO
                        BEGIN
                        if (IMPINC = 'S') then
                            MONTO = MONTO - IMPTOS;
                        if ((CTADTO IS NULL) OR (CTADTO = '')) then
                            MONTO = MONTO * FACTOR;
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA + MONTO;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    SUMA = SUMA + MONTO;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + MONTO;
                    END
                END /* MONTO <> 0 */
            END /* FOR */
        END /* VENTAS X ARTICULO */
     IF ((VENTAS = 'C') OR (VENTAS = 'K')) THEN
        BEGIN
        IF (VENTAS = 'C') THEN
            CTAVENTAS = TCTAVENTA;
        SELECT SUM(cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), SUM(DVDE_IVAMONTO), SUM(DVDE_CONSUMO)
            FROM DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC 
            INTO :MONTO, :IMPTOS, :VRCONSUMO;
        if (IMPINC = 'S') then
            if (FOMENTO = 'SI') then
               MONTO = MONTO - IMPTOS;
            ELSE
               MONTO = MONTO - IMPTOS - VRCONSUMO;
        ELSE
         if (FOMENTO = 'SI') then
          MONTO = MONTO + VRCONSUMO;
        if ((CTADTO IS NULL) OR (CTADTO = '')) then
            MONTO = MONTO * FACTOR;
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAVENTAS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, (cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), (DVDE_IVAMONTO+DVDE_CONSUMO)
                    FROM ARTICULO A, DEVOLUCIONES_VENTAS_DETALLE F
                    WHERE F.DEVT_ID = :IDDOC
                    INTO :ART, :MONTO, :IMPTOS
                    DO
                    BEGIN
                    if (IMPINC = 'S') then
                        MONTO = MONTO - IMPTOS;
                    if ((CTADTO IS NULL) OR (CTADTO = '')) then
                        MONTO = MONTO * FACTOR;
                    execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + MONTO;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                SUMA = SUMA + MONTO;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA + MONTO;
                END
            END /* MONTO <> 0 */
        END /* VENTAS DE CLIENTE O CONSTANTE */
    /* EL IVA EN VENTAS */
    if (IVA = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTAIVAV), SUM(DVDE_IVAMONTO), SUM(DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO), SUM(DVDE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTAIVAV
            INTO :CTAIVA, :IMPTOS, :MONTO, :VALORADIC
        DO
            BEGIN
            if (FOMENTO = 'SI') then
                MONTO = MONTO + VALORADIC;
            MONTO = MONTO * -1;
            MONTO = MONTO * FACTOR;
            IMPTOS = IMPTOS * FACTOR;
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
            if (IMPTOS <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, DVDE_IVAMONTO, (cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), TAIV_PORC, DVDE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F, TARIFA_IVA T
                        WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND A.TAIV_COD = T.TAIV_COD AND COAR_CTAIVAV = :CUENTA
                        INTO :ART, :IMPTOS, :MONTO, :PORCIVA, :VALORADIC
                    DO
                        BEGIN
                        if (IMPINC = 'S') then
                            MONTO = MONTO - IMPTOS - VALORADIC;
                        MONTO = MONTO * -1;
                        MONTO = MONTO * FACTOR;
                        IMPTOS = IMPTOS * FACTOR;
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                        if (IMPTOS <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            SUMA = SUMA + IMPTOS;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                END   /* IMPTOS <> 0 */
            END /* FOR */
        END /* IVA X ARTICULO */
    if (IVA = 'K') then /* IVA EN CTA CONSTANTE */
        BEGIN
        SELECT SUM(DVDE_IVAMONTO), SUM(DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO), SUM(DVDE_CONSUMO)
            FROM DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC 
            INTO :IMPTOS, :MONTO, :VALORADIC;
        if (FOMENTO = 'SI') then
            MONTO = MONTO + VALORADIC;
        MONTO = MONTO * -1;
        MONTO = MONTO * FACTOR;
        IMPTOS = IMPTOS * FACTOR;
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
        if (IMPTOS <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, (cast(DVDE_CANT as double precision) * (DVDE_PRUNIT-DVDE_DTOMONTO)), DVDE_IVAMONTO, TAIV_PORC, DVDE_CONSUMO
                    FROM ARTICULO A, DEVOLUCIONES_VENTAS_DETALLE F, TARIFA_IVA T
                    WHERE F.DEVT_ID = :IDDOC AND A.TAIV_COD = T.TAIV_COD
                    INTO :ART, :MONTO, :IMPTOS, :PORCIVA, :VALORADIC
                    DO
                    BEGIN
                    if (IMPINC = 'S') then
                        MONTO = MONTO - IMPTOS - VALORADIC;
                    MONTO = MONTO * -1;
                    MONTO = MONTO * FACTOR;
                    IMPTOS = IMPTOS * FACTOR;
                    execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                    execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                    if (IMPTOS <> 0) then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', :IMPTOS, 0, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA + IMPTOS;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                SUMA = SUMA + IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA + IMPTOS;
                END
            END /* IMPTOS <> 0 */
        END /* IVA EN CTA CONSTANTE */
    /* EL IMPOCONSUMO */
    if ((CONSUMO = 'A') AND (FOMENTO <> 'SI')) then
        BEGIN
        FOR SELECT MAX(COAR_CTACONS), SUM(DVDE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTACONS
            INTO :CTACONSUMO, :IMPTOS
        DO
            BEGIN
            if (IMPTOS <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, DVDE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, DEVOLUCIONES_VENTAS_DETALLE F
                        WHERE F.DEVT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTACONS = :CUENTA
                        INTO :ART, :IMPTOS
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA + IMPTOS;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                END /* IMPTOS <> 0 */
            END /* FOR */
        END /* CONSUMO X ARTICULO */
    if ((CONSUMO = 'K') AND (FOMENTO <> 'SI')) then
        BEGIN
        SELECT SUM(DVDE_CONSUMO)
            FROM DEVOLUCIONES_VENTAS_DETALLE F
            WHERE F.DEVT_ID = :IDDOC 
            INTO :IMPTOS;
        if (IMPTOS <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, DVDE_CONSUMO
                    FROM ARTICULO A, DEVOLUCIONES_VENTAS_DETALLE F
                    WHERE F.DEVT_ID = :IDDOC 
                    INTO :ART, :IMPTOS
                    DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + IMPTOS;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA + IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', :IMPTOS, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA + IMPTOS;
                END
            END /* IMPTOS <> 0 */
        END /* CONSUMO EN CTA CONSTANTE */
    /* DESCUENTO */
    if ((CTADTO IS NOT NULL) AND
        (CTADTO <> '') AND
        (VRDTO <> 0)) THEN
        BEGIN
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTADTO, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRDTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA - VRDTO;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRDTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA - VRDTO;
            END
        END /* DESCUENTO */
    /* VALOR ADIC */
    if ((CTAADIC IS NOT NULL) AND
        (CTAADIC <> '') AND
        (VRADIC <> 0)) THEN
        BEGIN
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRADIC, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA + VRADIC;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRADIC, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA + VRADIC;
            END
        END /* VR. ADIC */
    /* VALOR EXTRA */
    if ((CTAEXTRA IS NOT NULL) AND
        (CTAEXTRA <> '') AND
        (VREXTRA <> 0)) THEN
        BEGIN
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAEXTRA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VREXTRA, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA + VREXTRA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VREXTRA, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA + VREXTRA;
            END
        END /* VR. EXTRA */
    /* RETENCION FUENTE */
    if ((RTFTE = 'C') or (RTFTE = 'K')) then
      if (VRRTFTE <> 0) then
        BEGIN
        if (RTFTE = 'C') then
            CTARTFTE = TCTARTFTE;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:VRSUBT*-1), :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTFTE;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:VRSUBT*-1), :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTFTE;
            END
        /* AUTORETENCION */
        if (FAUTORET <= fecaux) then
            BEGIN
            EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'CUENTA DE AUTORETENCION EN LA FUENTE') returning_values (CTARTFTE);
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                SUMA = SUMA + VRRTFTE;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA + VRRTFTE;
                END
            END
        END /* RTFTE */
    if (RTFTE = 'A') then
      BEGIN
      FOR SELECT MAX(COAR_CTARTFTEV), MAX(COAR_RTFTE), MIN(COAR_RTBASE), SUM(DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO), SUM((DVDE_TOTAL-DVDE_IVAMONTO-DVDE_CONSUMO)*COAR_RTFTE)
        FROM CONTABIL_ARTICULO C, devoluciones_ventas_detalle F
        WHERE F.devt_id = :IDDOC AND F.ARTI_COD = C.ARTI_COD
        GROUP BY COAR_CTARTFTEV
        INTO :CTARTFTE, :PRTFTE, :baseadic, :MONTO, :VRRTFTE
        DO
        BEGIN
        MONTO = MONTO * FACTOR;
        if (MONTO >= BASEADIC) then
            BEGIN
            VRRTFTE = VRRTFTE * FACTOR / 100;
            execute procedure redondee(VRRTFTE, DIG) returning_values (VRRTFTE);
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (VRRTFTE <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:MONTO*-1), :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    SUMA = SUMA - VRRTFTE;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:MONTO*-1), :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - VRRTFTE;
                    END
                /* AUTORETENCION */
                if (FAUTORET <= fecaux) then
                    BEGIN
                    EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'CUENTA DE AUTORETENCION EN LA FUENTE') returning_values (CTARTFTE);
                    EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                    if (ERRORC <> 0) then
                        ERROR = ERROR + 1;
                    if (TIPOCUEN = 'C') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :MONTO, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                        NROI = NROI + 1;
                        SUMA = SUMA + VRRTFTE;
                        END
                    if (TIPOCUEN = 'N') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :MONTO, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA + VRRTFTE;
                        END
                    END
                END
            END
        END /* RTFTE */
      END
    /* RETENCION IVA */
    if ((RTIVA = 'C') or (RTIVA = 'K')) then
      if (VRRTIVA <> 0) then
        BEGIN
        if (RTIVA = 'C') then
            CTARTIVA = TCTARTIVA;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTIVA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTIVA, (:VRIVA*-1), :PORC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTIVA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTIVA, (:VRIVA*-1), :PORC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTIVA;
            END
        END /* RTIVA */
    /* RETENCION DE ICA */
    if ((RTICA = 'C') or (RTICA = 'K')) then
      if (VRRTICA <> 0) then
        BEGIN
        if (RTICA = 'C') then
            CTARTICA = TCTARTICA;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTARTICA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTICA, (:VRSUBT*-1), :PRTICA, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTICA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTICA, (:VRSUBT*-1), :PRTICA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA - VRRTICA;
            END
        END /* RTICA */
    /* CIERRE EL COMPROBANTE CONTRA LA CUENTA DEL TERCERO O LA CONSTANTE */
    if ((SUMA <> 0) and ((CARTERA = 'C') or (CARTERA = 'K') or (CARTERA = 'J'))) then
        BEGIN
        if (SUMA < 0) then
            BEGIN
            DEBITO = SUMA * -1;
            CREDITO = 0;
            END
        ELSE
            BEGIN
            DEBITO = 0;
            CREDITO = SUMA;
            END
        if (CARTERA = 'C') then
            CTACARTERA = TCTACLIEN;
        if (CARTERA = 'J') then
            BEGIN
            /* BUSQUE LA CUENTA DE LA CAJA */
            SELECT CAJA_CUENTA FROM CAJAS C, PUNTO_VENTA P
                WHERE P.CAJA_ID = C.CAJA_ID AND PTVT_ID = :PTOVTA
                INTO :CTACARTERA;
            END
        EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTACARTERA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
        if (TIPOCUEN = 'N') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
        NROI = NROI + 1;
        END /* SUMA EN CARTERA */
    /* CALCULE COSTOS EN VENTAS */
    EXECUTE PROCEDURE COSTO_EN_VENTAS(33, :IDDOC);
    if (COSTOS = 'A') then
        BEGIN
        FOR SELECT MAX(CTACOS), SUM(cast(CANT as double precision) * COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTACOS
            INTO :CTACOSTOS, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTACOSTOS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT ARTI_COD, cast(CANT as double precision) * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTACOS = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                END /* MONTO <> 0 */
            END /* FOR */
        END /* COSTOS */
    if (COSTOS = 'K') then
        BEGIN
        SELECT SUM(cast(CANT as double precision) * COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTACOSTOS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT ARTI_COD, cast(CANT as double precision) * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            END /* MONTO <> 0 */
        END /* COSTOS = K */
    if (INVEN = 'A') then
        BEGIN
        FOR SELECT MAX(CTAINV), SUM(cast(CANT as double precision) * COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTAINV
            INTO :CTAINVEN, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT ARTI_COD, cast(CANT as double precision) * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTAINV = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                    NROI = NROI + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                END /* MONTO <> 0 */
            END /* FOR */
        END /* INVEN = A */
    if (INVEN = 'K') then
        BEGIN
        SELECT SUM(cast(CANT as double precision) * COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT ARTI_COD, cast(CANT as double precision) * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            END /* MONTO <> 0 */
        END /* INVEN = K */
    /* recorra las cuentas adicionales */
    FOR SELECT INVC_CUENTA, INVC_BASE, INVC_PORC, INVC_VALOR, INVC_DB
        FROM INTERFAZ_VENTAS_CTAS WHERE INVE_ID = :IDINTER
        INTO :CTADIC, :BASEADIC, :PORCADIC, :VALORADIC, :DBADIC
        DO
        BEGIN
        if (valoradic <> 0) then
            monto = valoradic;
        else
            BEGIN
            if (:BASEADIC = 'SUBTOTAL') then
                VALORADIC = vrsubt;
            if (:BASEADIC = 'DESCUENTO') then
                VALORADIC = VRDTO;
            if (:BASEADIC = 'IVA') then
                VALORADIC = VRIVA;
            if (:BASEADIC = 'ADICIONAL') then
                VALORADIC = VRADIC;
            if (:BASEADIC = 'EXTRA') then
                VALORADIC = VREXTRA;
            if (:BASEADIC = 'TOTAL') then
                VALORADIC = VRTOTAL;
            MONTO = VALORADIC * PORCADIC;
            END
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(33, :IDDOC, :CTADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                if (DBADIC = 'S') then
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                ELSE
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :FECHA, NULL, 0, 33);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                if (DBADIC = 'S') then
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                ELSE
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            NROI = NROI + 1;
            END
        END
    if (error > 0) then
        ver = 'S';
    SUSPEND;
    END
   END /* EXISTE LA INTERFAZ */
  ELSE
    BEGIN
    EXECUTE PROCEDURE ERROR (33, :IDDOC, :PREF, 1);
    ERROR = ERROR + 1;
    VER = 'S';
    SUSPEND;
    END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE CONTABIL_FACTURA(
    IDDOC INTEGER,
    IDINTER INTEGER)
RETURNS (
    ERROR INTEGER,
    VER CHAR(1),
    IDC INTEGER)
AS
declare variable pref varchar(4);
declare variable num varchar(6);
declare variable numero varchar(10);
declare variable fecaux date;
declare variable fecha char(8);
declare variable conc varchar(60);
declare variable venceaux date;
declare variable vence char(8);
declare variable vrdto numeric(18,2);
declare variable vradic numeric(18,2);
declare variable vrsubt numeric(18,2);
declare variable vriva numeric(18,2);
declare variable prtfte numeric(9,2);
declare variable vrrtfte numeric(18,2);
declare variable vrrtiva numeric(18,2);
declare variable prtica numeric(9,2);
declare variable vrrtica numeric(18,2);
declare variable vrtotal numeric(18,2);
declare variable vrextra numeric(18,2);
declare variable tipocomp varchar(3);
declare variable prefcont varchar(4);
declare variable ventas char(1);
declare variable ctaventas varchar(20);
declare variable iva char(1);
declare variable ctaiva varchar(20);
declare variable consumo char(1);
declare variable ctaconsumo varchar(20);
declare variable cartera char(1);
declare variable ctacartera varchar(20);
declare variable rtfte char(1);
declare variable ctartfte varchar(20);
declare variable rtiva char(1);
declare variable ctartiva varchar(20);
declare variable rtica char(1);
declare variable ctartica varchar(20);
declare variable inven char(1);
declare variable ctainven varchar(20);
declare variable costos char(1);
declare variable ctacostos varchar(20);
declare variable ctadto varchar(20);
declare variable ctaadic varchar(20);
declare variable ctaextra varchar(20);
declare variable existe char(1);
declare variable cuenta varchar(20);
declare variable monto numeric(18,2);
declare variable tipocuen char(1);
declare variable nit varchar(20);
declare variable nombre varchar(60);
declare variable proy varchar(4);
declare variable centro varchar(4);
declare variable porc numeric(5,2);
declare variable debito numeric(18,2);
declare variable credito numeric(18,2);
declare variable nroi integer;
declare variable art varchar(15);
declare variable imptos numeric(18,2);
declare variable suma numeric(18,2);
declare variable porciva numeric(9,2);
declare variable tctaclien varchar(20);
declare variable tctaventa varchar(20);
declare variable tctartfte varchar(20);
declare variable tctartiva varchar(20);
declare variable tctartica varchar(20);
declare variable ctadic varchar(20);
declare variable baseadic varchar(20);
declare variable porcadic numeric(5,2);
declare variable valoradic numeric(18,2);
declare variable dbadic char(1);
declare variable ptovta integer;
declare variable anulado char(1);
declare variable dig integer;
declare variable mercancia numeric(18,2);
declare variable fomento varchar(2);
declare variable DTOXIT varchar(2);
declare variable vrconsumo numeric(18,2);
declare variable factor double precision;
declare variable cent char(1);
declare variable AUTORET VARCHAR(10);
declare variable FAUTORET DATE;
declare variable ERRORC INTEGER;
BEGIN
EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'USAR IMPOCONSUMO COMO PORCENTAJE DE FOMENTO') returning_values (FOMENTO);
EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'FECHA AUTORETENEDOR NO DESCONTAR RETENCIONES DEL SALDO PERO SI CONTABILIZARLAS') returning_values (AUTORET);
if (AUTORET <> '') then
    FAUTORET = CAST(AUTORET AS DATE);
else
    FAUTORET = '9999/12/31';
/* BUSQUE LA INTERFACE */
EXISTE = 'N';
SELECT 'S', TICO_COD, PRCO_PRE, INVE_VENTAS, INVE_IVA, INVE_CONSUMO, INVE_CARTERA, INVE_RTFTE, INVE_RTIVA, INVE_RTICA, INVE_COSTO, INVE_INVEN, INVE_CTAVENTAS, INVE_CTAIVA, INVE_CTACONSUMO, INVE_CTADTO, INVE_CTAADIC, INVE_CTAEXTRA, INVE_CTACARTERA, INVE_CTARTFTE, INVE_CTARTIVA, INVE_CTARTICA, INVE_CTAINVEN, INVE_CTACOSTOS, INVE_CONFIRMAR, INVE_CENTRO
    FROM INTERFAZ_VENTAS
    WHERE INVE_ID = :IDINTER
    INTO :EXISTE, :TIPOCOMP, :PREFCONT, :VENTAS, :IVA, :CONSUMO, :CARTERA, :RTFTE, :RTIVA, :RTICA, :COSTOS, :INVEN, :CTAVENTAS, :CTAIVA, :CTACONSUMO, :CTADTO, :CTAADIC, :CTAEXTRA, :CTACARTERA, :CTARTFTE, :CTARTIVA, :CTARTICA, :CTAINVEN, :CTACOSTOS, :VER, :CENT;
if (EXISTE = 'S') then
  BEGIN
    /* BORRE CUALQUEIR CONTABILIZACION PREVIA */
    DELETE FROM CONTABILIZACION WHERE CNTB_TIPOREF = 31 AND CNTB_IDREF = :IDDOC;

  /* TRAIGA EL ENCABEZADO DE LA FACTURA */
  SELECT PREF_PRE, FACT_NUMERO, FACT_FECHA, F.TERC_NIT, PTVT_ID, FACT_VENCE, FACT_DTOMONTO, FACT_ADICIONAL, FACT_IVAMONTO, FACT_EXTRA, FACT_TOTAL, FACT_RTFTEPOR, FACT_RTFTEMONTO, FACT_RTIVAPOR, FACT_RTIVAMONTO, FACT_RTICAPOR, FACT_RTICAMONTO, FACT_NOMCLIENTE, TERC_CTARTFTE, TERC_CTARTIVA, TERC_CTARTICA, TERC_CTAVENTA, TERC_CTACLIENTE, FACT_ANULADO
        FROM FACTURAS F, TERCEROS T
        WHERE FACT_ID = :IDDOC AND F.TERC_NIT = T.TERC_NIT
        INTO :PREF, :NUM, :FECAUX, :NIT, :PTOVTA, :VENCEAUX, :VRDTO, :VRADIC, :VRIVA, :VREXTRA, :VRTOTAL, :PRTFTE, :VRRTFTE, :PORC, :VRRTIVA, :PRTICA, :VRRTICA, :NOMBRE, TCTARTFTE, TCTARTIVA, TCTARTICA, TCTAVENTA, TCTACLIEN, ANULADO;
  if (ANULADO = 'N') then
    BEGIN
    /* BUSQUE EL CENTRO DEL PUNTO, LA BODEGA, O EL PREFIJO  */
    IF (CENT = 'B') THEN
        SELECT B.BODE_CENTRO, B.BODE_PROY FROM BODEGA B, FACTURAS F
            WHERE B.BODE_COD = F.BODE_COD AND F.FACT_ID = :IDDOC INTO :CENTRO, :PROY;
    IF (CENT = 'V') THEN
        SELECT V.CENT_COD, V.PROY_COD FROM VENDEDORES V, FACTURAS F
            WHERE V.VEND_COD = F.VEND_COD AND F.FACT_ID = :IDDOC INTO :CENTRO, :PROY;
    IF (CENT = 'P') THEN
        SELECT P.PREF_CENTRO,P.PREF_PROY  FROM PREFIJOS P, FACTURAS F
            WHERE P.PREF_PRE = F.PREF_PRE AND F.FACT_ID = :IDDOC AND P.TIDO_COD = 31 INTO :CENTRO, :PROY;
    NUMERO = PREF || NUM;
    SELECT SUM (FADE_CONSUMO) FROM FACTURAS_DETALLE WHERE FACT_ID = :IDDOC INTO MERCANCIA;
    VRSUBT = VRTOTAL - VREXTRA - VRIVA - MERCANCIA; /* BASE DE RETEFTE Y RETEICA */

    EXECUTE PROCEDURE lee_configuracion ('FACTURACION', 'FACTURAS', 'DESCUENTO PIE FACTURA IGUAL A SUMA DE DESCUENTOS POR ITEM') returning_values (:DTOXIT);
    if (DTOXIT = 'SI') then
        VRDTO = 0;
    MERCANCIA = VRSUBT - VRADIC + VRDTO;
    EXECUTE PROCEDURE FECHA_A_CONTA(:FECAUX) returning_values (:FECHA);
    EXECUTE PROCEDURE FECHA_A_CONTA(:VENCEAUX) returning_values (:VENCE);
    /* REGISTRE EL ENCABEZADO CONTABLE */
    IDC = GEN_ID(ID_CONTABILIZA, 1);
    if (STRLEN(NOMBRE)> 43 ) then
      CONC = 'FV No.' || NUMERO || '-' || SUBSTR(NOMBRE,1,43);
    ELSE
      CONC = 'FV No.' || NUMERO || '-' || NOMBRE;
    INSERT INTO CONTABILIZACION (CNTB_ID, CNTB_TIPOCOMP, CNTB_PREFCNT, CNTB_NUMERO, CNTB_FECHA, CNTB_CONCEPTO, CNTB_REF, CNTB_TIPOREF, CNTB_IDREF, CNTB_PREFREF, CNTB_NUMREF, CNTB_PROCESADO)
        VALUES (:IDC, :TIPOCOMP, :PREFCONT, :NUM, :FECHA, :CONC, '', 31, :IDDOC, :PREF, :NUM, 'N');
    NROI = 0;
    SUMA = 0;
    ERROR = 0;
    /* SI NO HAY CUENTA DE DESCUENTO NI ADICIONAL CALCULE UN FACTOR PARA LAS VENTAS Y EL IVA */
    if (MERCANCIA <> 0) then
        FACTOR = CAST(VRSUBT AS DOUBLE PRECISION) / CAST(MERCANCIA AS DOUBLE PRECISION);
    ELSE
        FACTOR = 1;
    /* TRAIGA EL NUMERO DE DIGITOS PARA EL REDONDEO */
    SELECT CAST(CONF_VALOR AS INTEGER) FROM CONFIGURACION WHERE CONF_MODULO = 'FACTURACION' AND
        CONF_CATEGORIA = 'GENERAL' AND CONF_PROPIEDAD = 'REDONDEO AL MULTIPLO DE DIEZ EN TOTALES' INTO :DIG;
    /* CUENTAS DE VENTAS */
    if (VENTAS = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTAVNT), SUM(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), SUM(FADE_IVAMONTO), SUM(FADE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTAVNT
            INTO :CTAVENTAS, :MONTO, :IMPTOS, :VRCONSUMO
            DO
            BEGIN
            if (FOMENTO = 'SI') then
                MONTO = MONTO + VRCONSUMO;
            if ((CTADTO IS NULL) OR (CTADTO = '')) then
                MONTO = MONTO * FACTOR;
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAVENTAS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), FADE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
                        WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAINV = :CUENTA
                        INTO :ART, :MONTO, :IMPTOS
                    DO
                        BEGIN
                        if (FOMENTO = 'SI') then
                            MONTO = MONTO + IMPTOS;
                        if ((CTADTO IS NULL) OR (CTADTO = '')) then
                            MONTO = MONTO * FACTOR;
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        if (MONTO <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            SUMA = SUMA - MONTO;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    SUMA = SUMA - MONTO;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - MONTO;
                    END
                END /* MONTO <> 0 */
            END /* FOR */
        END /* VENTAS X ARTICULO */
     IF ((VENTAS = 'C') OR (VENTAS = 'K')) THEN
        BEGIN
        IF (VENTAS = 'C') THEN
            CTAVENTAS = TCTAVENTA;
        SELECT SUM(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), SUM(FADE_IVAMONTO), SUM (FADE_CONSUMO)
            FROM FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC 
            INTO :MONTO, :IMPTOS, :VRCONSUMO;
        if (FOMENTO = 'SI') then
            MONTO = MONTO + VRCONSUMO;
        if ((CTADTO IS NULL) OR (CTADTO = '')) then
            MONTO = MONTO * FACTOR;
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAVENTAS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), FADE_CONSUMO
                    FROM ARTICULO A, FACTURAS_DETALLE F
                    WHERE F.FACT_ID = :IDDOC 
                    INTO :ART, :MONTO, :IMPTOS
                    DO
                    BEGIN
                    if (FOMENTO = 'SI') then
                        MONTO = MONTO + VRCONSUMO;
                    if ((CTADTO IS NULL) OR (CTADTO = '')) then
                        MONTO = MONTO * FACTOR;
                    execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                    if (MONTO <> 0) then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA - MONTO;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - MONTO;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - MONTO;
                END
            END /* MONTO <> 0 */
        END /* VENTAS DE CLIENTE O CONSTANTE */
    /* EL IVA EN VENTAS */
    if (IVA = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTAIVAV), SUM(FADE_IVAMONTO), SUM(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), sum(FADE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTAIVAV
            INTO :CTAIVA, :IMPTOS, :MONTO, :VALORADIC
        DO
            BEGIN
            if (FOMENTO = 'SI') then
                MONTO = MONTO + VALORADIC;
            MONTO = MONTO * -1;
            MONTO = MONTO * FACTOR;
            IMPTOS = IMPTOS * FACTOR;
            execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (IMPTOS <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, FADE_IVAMONTO, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), TAIV_PORC, FADE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F, TARIFA_IVA T
                        WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAIVAV = :CUENTA AND A.TAIV_COD = T.TAIV_COD
                        INTO :ART, :IMPTOS, :MONTO, :PORCIVA, :VALORADIC
                    DO
                        BEGIN
                        if (FOMENTO = 'SI') then
                            MONTO = MONTO + VALORADIC;
                        MONTO = MONTO * -1;
                        MONTO = MONTO * FACTOR;
                        IMPTOS = IMPTOS * FACTOR;
                        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        if (IMPTOS <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            SUMA = SUMA + DEBITO - CREDITO;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                END   /* IMPTOS <> 0 */
            END /* FOR */
        END /* IVA X ARTICULO */
    if (IVA = 'K') then /* IVA EN CTA CONSTANTE */
        BEGIN
        SELECT SUM(FADE_IVAMONTO), SUM(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), SUM(FADE_CONSUMO)
            FROM FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC and FADE_IVAMONTO <> 0
            INTO :IMPTOS, :MONTO, :valoradic;
        if (FOMENTO = 'SI') then
            MONTO = MONTO + VALORADIC;
        MONTO = MONTO * -1;
        MONTO = MONTO * FACTOR;
        IMPTOS = IMPTOS * FACTOR;
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
        if (IMPTOS <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAIVA, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, (FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), FADE_IVAMONTO, TAIV_PORC, FADE_CONSUMO
                    FROM ARTICULO A, FACTURAS_DETALLE F, TARIFA_IVA T
                    WHERE F.FACT_ID = :IDDOC AND A.TAIV_COD = T.TAIV_COD
                    INTO :ART, :MONTO, :IMPTOS, :PORCIVA, :VALORADIC
                    DO
                    BEGIN
                    if (FOMENTO = 'SI') then
                        MONTO = MONTO + VALORADIC;
                    MONTO = MONTO * -1;
                    MONTO = MONTO * FACTOR;
                    IMPTOS = IMPTOS * FACTOR;
                    execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                    execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                    if (IMPTOS <> 0) then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', 0, :IMPTOS, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA - IMPTOS;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            END /* IMPTOS <> 0 */
        END /* IVA EN CTA CONSTANTE */
    /* EL IMPOCONSUMO */
    if ((CONSUMO = 'A') AND (FOMENTO <> 'SI')) then
        BEGIN
        FOR SELECT MAX(COAR_CTACONS), SUM(FADE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
            GROUP BY COAR_CTACONS
            INTO :CTACONSUMO, :IMPTOS
        DO
            BEGIN
            execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
            if (IMPTOS <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT F.ARTI_COD, FADE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
                        WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTACONS = :CUENTA
                        INTO :ART, :IMPTOS
                    DO
                        BEGIN
                        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                        if (IMPTOS <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            SUMA = SUMA - IMPTOS;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                END /* IMPTOS <> 0 */
            END /* FOR */
        END /* CONSUMO X ARTICULO */
    if ((CONSUMO = 'K') AND (FOMENTO <> 'SI')) then /* CONSUMO EN CTA CONSTANTE */
        BEGIN
        SELECT SUM(FADE_CONSUMO)
            FROM FACTURAS_DETALLE F
            WHERE F.FACT_ID = :IDDOC 
            INTO :IMPTOS;
        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
        if (IMPTOS <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTACONSUMO, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT F.ARTI_COD, FADE_CONSUMO
                    FROM ARTICULO A, FACTURAS_DETALLE F
                    WHERE F.FACT_ID = :IDDOC 
                    INTO :ART, :IMPTOS
                    DO
                    BEGIN
                    execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                    if (IMPTOS <> 0) then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA - IMPTOS;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            END /* IMPTOS <> 0 */
        END /* CONSUMO EN CTA CONSTANTE */
    /* DESCUENTO */
    if ((CTADTO IS NOT NULL) AND (CTADTO <> '')) then
        BEGIN
        execute procedure redondee(VRDTO, DIG) returning_values (VRDTO);
        if (VRDTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTADTO, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRDTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA + VRDTO;
                END
            if (TIPOCUEN = 'N') then
                    BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRDTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA + VRDTO;
                END
            END
        END /* DESCUENTO */
    /* VALOR ADIC */
    if ((CTAADIC IS NOT NULL) AND (CTAADIC <> '')) then
        BEGIN
        execute procedure redondee(VRADIC, DIG) returning_values (VRADIC);
        if (VRADIC <> 0) THEN
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRADIC, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VRADIC;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRADIC, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VRADIC;
                END
            END
        END /* VR. ADIC */
    /* VALOR EXTRA */
    if ((CTAEXTRA IS NOT NULL) AND (CTAEXTRA <> '')) THEN
        BEGIN
        execute procedure redondee(VREXTRA, DIG) returning_values (VREXTRA);
        if (VREXTRA <> 0) THEN
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAEXTRA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VREXTRA, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VREXTRA;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VREXTRA, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VREXTRA;
                END
            END
        END /* VR. EXTRA */
    /* DESCUENTE EL IMPOCONSUMO */
    SELECT SUM(FADE_CONSUMO)
        FROM FACTURAS_DETALLE F WHERE F.FACT_ID = :IDDOC INTO :IMPTOS;
    vrsubt = vrsubt - IMPTOS;
    /* RETENCION FUENTE */
    if ((RTFTE = 'C') or (RTFTE = 'K')) then
      BEGIN
      execute procedure redondee(VRRTFTE, DIG) returning_values (VRRTFTE);
      if (VRRTFTE <> 0) then
        BEGIN
        if (RTFTE = 'C') then
            CTARTFTE = TCTARTFTE;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTFTE;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTFTE;
            END
        /* AUTORETENCION */
        if (FAUTORET <= fecaux) then
            BEGIN
            EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'CUENTA DE AUTORETENCION EN LA FUENTE') returning_values (CTARTFTE);
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTARTFTE INTO :CUENTA, :TIPOCUEN;
            if (CUENTA IS NULL) then
                begin
                EXECUTE PROCEDURE ERROR (31, :IDDOC, :CTARTFTE, 2);
                CUENTA = CTARTFTE;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                begin
                EXECUTE PROCEDURE ERROR (31, :IDDOC, :CUENTA, 3);
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:VRSUBT*-1), :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VRRTFTE;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:VRSUBT*-1), :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - VRRTFTE;
                END
            END
        END /* RTFTE */
      END
    if (RTFTE = 'A') then
      BEGIN
      FOR SELECT MAX(COAR_CTARTFTEV), MAX(COAR_RTFTE), MIN(COAR_RTBASE), SUM(FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO), SUM((FADE_TOTAL-FADE_IVAMONTO-FADE_CONSUMO)*COAR_RTFTE)
        FROM CONTABIL_ARTICULO C, FACTURAS_DETALLE F
        WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = C.ARTI_COD
        GROUP BY COAR_CTARTFTEV
        INTO :CTARTFTE, :PRTFTE, :baseadic, :MONTO, :VRRTFTE
        DO
        BEGIN
        MONTO = MONTO * FACTOR;
        if (MONTO >= BASEADIC) then
            BEGIN
            VRRTFTE = VRRTFTE * FACTOR / 100;
            execute procedure redondee(VRRTFTE, DIG) returning_values (VRRTFTE);
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (VRRTFTE <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :MONTO, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    SUMA = SUMA + VRRTFTE;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :MONTO, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA + VRRTFTE;
                    END
                /* AUTORETENCION */
                if (FAUTORET <= fecaux) then
                    BEGIN
                    EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'CUENTA DE AUTORETENCION EN LA FUENTE') returning_values (CTARTFTE);
                    EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTARTFTE, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
                    if (ERRORC <> 0) then
                        ERROR = ERROR + 1;
                    if (TIPOCUEN = 'C') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:MONTO*-1), :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                        NROI = NROI + 1;
                        SUMA = SUMA - VRRTFTE;
                        END
                    if (TIPOCUEN = 'N') then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRRTFTE, (:MONTO*-1), :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA - VRRTFTE;
                        END
                    END
                END
            END
        END /* RTFTE */
      END
    /* RETENCION IVA */
    if ((RTIVA = 'C') or (RTIVA = 'K')) then
      BEGIN
      execute procedure redondee(VRRTIVA, DIG) returning_values (VRRTIVA);
      if (VRRTIVA <> 0) then
        BEGIN
        if (RTIVA = 'C') then
            CTARTIVA = TCTARTIVA;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTARTIVA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTIVA, 0, :VRIVA, :PORC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTIVA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTIVA, 0, :VRIVA, :PORC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTIVA;
            END
        END /* RTIVA */
      END
    /* RETENCION DE ICA */
    if ((RTICA = 'C') or (RTICA = 'K')) then
      BEGIN
      execute procedure redondee(VRRTICA, DIG) returning_values (VRRTICA);
      if (VRRTICA <> 0) then
        BEGIN
        if (RTICA = 'C') then
            CTARTICA = TCTARTICA;
        EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTARTICA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTICA, 0, :VRSUBT, :PRTICA, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTICA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTICA, 0, :VRSUBT, :PRTICA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTICA;
            END
        END /* RTICA */
      END
    /* CIERRE EL COMPROBANTE CONTRA LA CUENTA DEL TERCERO O LA CONSTANTE */
    if ((SUMA <> 0) and ((CARTERA = 'C') or (CARTERA = 'K') or (CARTERA = 'J'))) then
        BEGIN
        if (SUMA < 0) then
            BEGIN
            DEBITO = SUMA * -1;
            CREDITO = 0;
            END
        ELSE
            BEGIN
            DEBITO = 0;
            CREDITO = SUMA;
            END
        if (CARTERA = 'C') then
            CTACARTERA = TCTACLIEN;
        if (CARTERA = 'J') then
            BEGIN
            /* BUSQUE LA CUENTA DE LA CAJA */
            SELECT CAJA_CUENTA FROM CAJAS C, PUNTO_VENTA P
                WHERE P.CAJA_ID = C.CAJA_ID AND PTVT_ID = :PTOVTA
                INTO :CTACARTERA;
            END
        EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTACARTERA, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
        if (ERRORC <> 0) then
            ERROR = ERROR + 1;
        if (TIPOCUEN = 'C') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
        if (TIPOCUEN = 'N') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
        NROI = NROI + 1;
        END /* SUMA EN CARTERA */
    /* CALCULE COSTOS EN VENTAS */
    EXECUTE PROCEDURE COSTO_EN_VENTAS(31, :IDDOC);
    if (COSTOS = 'A') then
        BEGIN
        FOR SELECT MAX(CTACOS), SUM(CAST(CANT AS DOUBLE PRECISION) * COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTACOS
            INTO :CTACOSTOS, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTACOSTOS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT ARTI_COD, CANT * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTACOS = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                END /* MONTO <> 0 */
            END /* FOR */
        END /* COSTOS */
    if (COSTOS = 'K') then
        BEGIN
        SELECT SUM(CAST(CANT AS DOUBLE PRECISION) * COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTACOSTOS, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT ARTI_COD, CANT * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            END /* MONTO <> 0 */
        END /* COSTOS = K */
    if (INVEN = 'A') then
        BEGIN
        FOR SELECT MAX(CTAINV), SUM(CAST(CANT AS DOUBLE PRECISION) * COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTAINV
            INTO :CTAINVEN, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
                if (ERRORC <> 0) then
                    ERROR = ERROR + 1;
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT ARTI_COD, CANT * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTAINV = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                END /* MONTO <> 0 */
            END /* FOR */
        END /* INVEN = A */
    if (INVEN = 'K') then
        BEGIN
        SELECT SUM(CAST(CANT AS DOUBLE PRECISION) * COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTAINVEN, 'S') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT ARTI_COD, CANT * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            END /* MONTO <> 0 */
        END /* INVEN = K */
    /* recorra las cuentas adicionales */
    FOR SELECT INVC_CUENTA, INVC_BASE, INVC_PORC, INVC_VALOR, INVC_DB
        FROM INTERFAZ_VENTAS_CTAS
        WHERE INVE_ID = :IDINTER
        INTO :CTADIC, :BASEADIC, :PORCADIC, :VALORADIC, :DBADIC
        DO
        BEGIN
        if (VALORADIC <> 0) then
            MONTO = VALORADIC;
        ELSE
            BEGIN
            if (:BASEADIC = 'SUBTOTAL') then
                VALORADIC = vrsubt;
            if (:BASEADIC = 'DESCUENTO') then
                VALORADIC = VRDTO;
            if (:BASEADIC = 'IVA') then
                VALORADIC = VRIVA;
            if (:BASEADIC = 'ADICIONAL') then
                VALORADIC = VRADIC;
            if (:BASEADIC = 'EXTRA') then
                VALORADIC = VREXTRA;
            if (:BASEADIC = 'TOTAL') then
                VALORADIC = VRTOTAL;
            MONTO = VALORADIC * PORCADIC / 100;
            END
        if (MONTO <> 0) then
            BEGIN
            EXECUTE PROCEDURE CUENTA_INTERFAZ(31, :IDDOC, :CTADIC, 'N') returning_values (CUENTA, TIPOCUEN, ERRORC);
            if (ERRORC <> 0) then
                ERROR = ERROR + 1;
            if (TIPOCUEN = 'C') then
                BEGIN
                if (DBADIC = 'S') then
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                ELSE
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                if (DBADIC = 'S') then
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                ELSE
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            NROI = NROI + 1;
            END
        END
    if (ERROR > 0) then
        VER = 'S';
    SUSPEND;
    END /* NO ANULADO */
  END /* EXISTE LA INTERFAZ */
ELSE
    BEGIN
    EXECUTE PROCEDURE ERROR (31, :IDDOC, :PREF, 1);
    ERROR = ERROR + 1;
    VER = 'S';
    SUSPEND;
    END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE EXPORTA_FACTURAS(
    INI DATE,
    FIN DATE)
RETURNS (
    IDDOC INTEGER,
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA VARCHAR(8),
    VENCE VARCHAR(8),
    NIT VARCHAR(15),
    VENDEDOR INTEGER,
    BODEGA VARCHAR(2),
    OBSERVACION VARCHAR(255),
    ITEM INTEGER,
    CUENTA VARCHAR(20),
    PROY VARCHAR(4),
    CENTRO VARCHAR(4),
    ARTICULO VARCHAR(15),
    DESCR VARCHAR(60),
    LOTE VARCHAR(15),
    CANT NUMERIC(18,4),
    MONTO NUMERIC(18,2),
    DB CHAR(1))
AS
declare variable TOTAL NUMERIC(18,2);
declare variable CARTERA CHAR(1);
declare variable FECAUX DATE;
declare variable VENCEAUX DATE;
declare variable SUMA NUMERIC(18,2);
BEGIN
/* FACTURAS DEL RANGO QUE NO SE HAN TRANSMITIDO */
FOR SELECT FACT_ID, F.PREF_PRE, FACT_NUMERO, FACT_FECHA, FACT_VENCE, FACT_TOTAL, TERC_NIT, PREF_PROY, PREF_CENTRO, VEND_COD, BODE_COD, FACT_OBS
    FROM FACTURAS F, PREFIJOS P
    WHERE F.PREF_PRE = P.PREF_PRE AND P.TIDO_COD = 31 AND FACT_FECHA >= :INI AND FACT_FECHA <= :FIN AND FACT_TRANSMIT = 'N'
    INTO :IDDOC, :PREFIJO, :NUMERO, :FECAUX, :VENCEAUX, :TOTAL, :NIT, :PROY, :CENTRO, :VENDEDOR, :BODEGA, :OBSERVACION
    DO
    BEGIN
    EXECUTE PROCEDURE FECHA_A_CONTA(:FECAUX) returning_values (:FECHA);
    EXECUTE PROCEDURE FECHA_A_CONTA(:VENCEAUX) returning_values (:VENCE);
    SUMA = 0;
    /* VENTAS */
    FOR SELECT F.ARTI_COD, FADE_DESC, COAR_CTAVNT, FADE_LOTE, FADE_CANT, FADE_CANT * (FADE_PRUNIT - FADE_DTOMONTO), 'C'
        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
        WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
        INTO :ARTICULO, :DESCR, :CUENTA, :LOTE, :CANT, :MONTO, :DB
        DO
            BEGIN
            SUMA = SUMA + MONTO;
            SUSPEND;
            END
    /* IVA */
    FOR SELECT F.FADE_ITEM, F.ARTI_COD, FADE_DESC, COAR_CTAIVAV, FADE_LOTE, FADE_CANT, FADE_IVAMONTO, 'C'
        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE F
        WHERE F.FACT_ID = :IDDOC AND F.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD
        INTO :ITEM, :ARTICULO, :DESCR, :CUENTA, :LOTE, :CANT, :MONTO, :DB
        DO 
            BEGIN
            SUMA = SUMA + MONTO;
            SUSPEND;
            END
    /* TOTAL */
    SELECT MAX(INVE_CARTERA), MAX(INVE_CTACARTERA)
    FROM INTERFAZ_VENTAS I
    WHERE TIDO_COD = 31 AND PREF_PRE = :PREFIJO
    INTO :CARTERA, :CUENTA;
    if (CARTERA = 'C') then
        SELECT TERC_CTACLIENTE FROM TERCEROS WHERE TERC_NIT = :NIT INTO :CUENTA;
    ARTICULO = '';
    DESCR = '';
    LOTE = '000';
    CANT = 0;
    MONTO = SUMA;
    DB = 'D';
    SUSPEND;
    /* INVENTARIO */
    EXECUTE PROCEDURE COSTO_EN_VENTAS(31, :IDDOC);
    FOR SELECT C.ARTI_COD, ARTI_DES, CTAINV, '000', CANT, CANT * COSTO, 'C'
        FROM COSTO_VENTAS C, ARTICULO A
        WHERE C.ARTI_COD = A.ARTI_COD
        INTO :ARTICULO, :DESCR, :CUENTA, :LOTE, :CANT, :MONTO, :DB
        DO SUSPEND;
    /* COSTO */
    FOR SELECT C.ARTI_COD, ARTI_DES, CTACOS, '000', CANT, CANT * COSTO, 'D'
        FROM COSTO_VENTAS C, ARTICULO A
        WHERE C.ARTI_COD = A.ARTI_COD
        INTO :ARTICULO, :DESCR, :CUENTA, :LOTE, :CANT, :MONTO, :DB
        DO SUSPEND;
    END
  SUSPEND;
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE CONTABIL_FACTURAS_CONTADO(
    FECFAC DATE,
    NIT VARCHAR(20),
    PREF VARCHAR(4),
    PTVTA INTEGER,
    IDINTER INTEGER)
RETURNS (
    ERROR INTEGER,
    VER CHAR(1),
    IDC INTEGER)
AS
declare variable num varchar(8);
declare variable numero varchar(10);
declare variable fecha char(8);
declare variable conc char(120);
declare variable vence char(8);
declare variable vrdto numeric(18,2);
declare variable vradic numeric(18,2);
declare variable vrsubt numeric(18,2);
declare variable vriva numeric(18,2);
declare variable prtfte numeric(9,2);
declare variable vrrtfte numeric(18,2);
declare variable vrrtiva numeric(18,2);
declare variable prtica numeric(9,2);
declare variable vrrtica numeric(18,2);
declare variable vrtotal numeric(18,2);
declare variable vrextra numeric(18,2);
declare variable tipocomp varchar(3);
declare variable prefcont varchar(4);
declare variable ventas char(1);
declare variable ctaventas varchar(20);
declare variable iva char(1);
declare variable ctaiva varchar(20);
declare variable consumo char(1);
declare variable ctaconsumo varchar(20);
declare variable cartera char(1);
declare variable ctacartera varchar(20);
declare variable rtfte char(1);
declare variable ctartfte varchar(20);
declare variable rtiva char(1);
declare variable ctartiva varchar(20);
declare variable rtica char(1);
declare variable ctartica varchar(20);
declare variable inven char(1);
declare variable ctainven varchar(20);
declare variable costos char(1);
declare variable ctacostos varchar(20);
declare variable ctadto varchar(20);
declare variable ctaadic varchar(20);
declare variable ctaextra varchar(20);
declare variable existe char(1);
declare variable cuenta varchar(20);
declare variable monto numeric(18,2);
declare variable tipocuen char(1);
declare variable nombre varchar(60);
declare variable proy varchar(4);
declare variable centro varchar(4);
declare variable porc numeric(5,2);
declare variable debito numeric(18,2);
declare variable credito numeric(18,2);
declare variable nroi integer;
declare variable art varchar(15);
declare variable impinc char(1);
declare variable imptos numeric(18,2);
declare variable suma numeric(18,2);
declare variable porciva numeric(9,2);
declare variable tctaclien varchar(20);
declare variable tctaventa varchar(20);
declare variable tctartfte varchar(20);
declare variable tctartiva varchar(20);
declare variable tctartica varchar(20);
declare variable ctadic varchar(20);
declare variable baseadic varchar(20);
declare variable porcadic numeric(5,2);
declare variable valoradic numeric(18,2);
declare variable dbadic char(1);
declare variable ptovta integer;
declare variable dig integer;
declare variable mercancia numeric(18,2);
declare variable factor double precision;
declare variable cent char(1);
BEGIN
/* BUSQUE LA INTERFACE */
EXISTE = 'N';
SELECT 'S', TICO_COD, PRCO_PRE, INVE_VENTAS, INVE_IVA, INVE_CONSUMO, INVE_CARTERA, INVE_RTFTE, INVE_RTIVA, INVE_RTICA, INVE_COSTO, INVE_INVEN, INVE_CTAVENTAS, INVE_CTAIVA, INVE_CTACONSUMO, INVE_CTADTO, INVE_CTAADIC, INVE_CTAEXTRA, INVE_CTACARTERA, INVE_CTARTFTE, INVE_CTARTIVA, INVE_CTARTICA, INVE_CTAINVEN, INVE_CTACOSTOS, INVE_CONFIRMAR, INVE_CENTRO
    FROM INTERFAZ_VENTAS
    WHERE INVE_ID = :IDINTER
    INTO :EXISTE, :TIPOCOMP, :PREFCONT, :VENTAS, :IVA, :CONSUMO, :CARTERA, :RTFTE, :RTIVA, :RTICA, :COSTOS, :INVEN, :CTAVENTAS, :CTAIVA, :CTACONSUMO, :CTADTO, :CTAADIC, :CTAEXTRA, :CTACARTERA, :CTARTFTE, :CTARTIVA, :CTARTICA, :CTAINVEN, :CTACOSTOS, :VER, :CENT;
if (EXISTE = 'S') then
  BEGIN
  /* BORRE CUALQUEIR CONTABILIZACION PREVIA */
/*  DELETE FROM CONTABILIZACION WHERE CNTB_TIPOREF = 31 AND CNTB_IDREF = 0;
  /* BUSQUE EL CENTRO DEL PUNTO, LA BODEGA, O EL PREFIJO  */
  IF (CENT = 'B') THEN
    SELECT B.BODE_CENTRO, B.BODE_PROY FROM BODEGA B, PUNTO_VENTA P
        WHERE B.BODE_COD = P.BODE_COD AND P.ptvt_id = :ptvta INTO :CENTRO, :PROY;
  IF (CENT = 'V') THEN
    SELECT MAX(V.CENT_COD), MAX(V.PROY_COD) FROM VENDEDORES V
        WHERE V.PTVT_ID = :PTVTA INTO :CENTRO, :PROY;
  IF (CENT = 'P') THEN
    SELECT P.PREF_PROY, P.PREF_CENTRO FROM PREFIJOS P
        WHERE P.PREF_PRE = :PREF AND P.TIDO_COD = 31 INTO :CENTRO, :PROY;
  /* TRAIGA LOS DATOS DEL CLIENTE */
  SELECT TERC_NOM, TERC_CTARTFTE, TERC_CTARTIVA, TERC_CTARTICA, TERC_CTAVENTA, TERC_CTACLIENTE
        FROM TERCEROS T WHERE TERC_NIT = :NIT
        INTO :NOMBRE, TCTARTFTE, TCTARTIVA, TCTARTICA, TCTAVENTA, TCTACLIEN;
  SELECT SUM(FACT_DTOMONTO), SUM(FACT_ADICIONAL), SUM(FACT_IVAMONTO), SUM(FACT_EXTRA), SUM(FACT_TOTAL), SUM(FACT_RTFTEMONTO), SUM(FACT_RTIVAMONTO), SUM(FACT_RTICAMONTO), MAX(FACT_IVAINC)
        FROM FACTURAS F WHERE FACT_FECHA = :FECFAC AND FACT_ANULADO = 'N' AND PTVT_ID = :ptvta AND PREF_PRE = :PREF
        INTO :VRDTO, :VRADIC, :VRIVA, :VREXTRA, :VRTOTAL, :VRRTFTE, :VRRTIVA, :VRRTICA, :impinc;
  VRSUBT = VRTOTAL - VREXTRA - VRIVA; /* BASE DE RETEFTE Y RETEICA */
  MERCANCIA = VRSUBT - VRADIC + VRDTO;
  EXECUTE PROCEDURE FECHA_A_CONTA(:FECFAC) returning_values (:FECHA);
  VENCE = FECHA;
  /* REGISTRE EL ENCABEZADO CONTABLE */
  IDC = GEN_ID(ID_CONTABILIZA, 1);
  CONC = 'RESUMEN VENTAS ' || FECHA;
  NUM = SUBSTR(FECHA, 3, 8);
  INSERT INTO CONTABILIZACION (CNTB_ID, CNTB_TIPOCOMP, CNTB_PREFCNT, CNTB_NUMERO, CNTB_FECHA, CNTB_CONCEPTO, CNTB_REF, CNTB_TIPOREF, CNTB_IDREF, CNTB_PREFREF, CNTB_NUMREF, CNTB_PROCESADO)
        VALUES (:IDC, :TIPOCOMP, :PREFCONT, :NUM, :FECHA, :CONC, '', 0, 0, :PREF, :NUM, 'N');
  NROI = 0;
  SUMA = 0;
  ERROR = 0;
  /* SI NO HAY CUENTA DE DESCUENTO NI ADICIONAL CALCULE UN FACTOR PARA LAS VENTAS Y EL IVA */
  if (MERCANCIA <> 0) then
    FACTOR = CAST(VRSUBT AS DOUBLE PRECISION) / CAST(MERCANCIA AS DOUBLE PRECISION);
  ELSE
    FACTOR = 1;
  /* TRAIGA EL NUMERO DE DIGITOS PARA EL REDONDEO */
  SELECT CAST(CONF_VALOR AS INTEGER) FROM CONFIGURACION WHERE CONF_MODULO = 'FACTURACION' AND
        CONF_CATEGORIA = 'GENERAL' AND CONF_PROPIEDAD = 'REDONDEO AL MULTIPLO DE DIEZ EN TOTALES' INTO :DIG;
  /* CUENTAS DE VENTAS */
  if (VENTAS = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTAVNT), SUM(CAST(FADE_CANT AS DOUBLE PRECISION) * (FADE_PRUNIT-FADE_DTOMONTO)), SUM(FADE_IVAMONTO+FADE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE FD, FACTURAS F
            WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND FD.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FACT_ANULADO = 'N'
            GROUP BY COAR_CTAVNT
            INTO :CTAVENTAS, :MONTO, :IMPTOS
            DO
            BEGIN
            if (IMPINC = 'S') then
                MONTO = MONTO - IMPTOS;
            if ((CTADTO IS NULL) OR (CTADTO = '')) then
                MONTO = MONTO * FACTOR;
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (MONTO <> 0) then
                BEGIN
                CUENTA = NULL;
                SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                    WHERE CUEN_COD = :CTAVENTAS INTO :CUENTA, :TIPOCUEN;
                if (CUENTA IS NULL) then
                    begin
                    EXECUTE PROCEDURE ERROR (31, 0, :CTAVENTAS, 2);
                    CUENTA = CTAVENTAS;
                    TIPOCUEN = 'N';
                    ERROR = ERROR + 1;
                    end
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT FD.ARTI_COD, (CAST(FADE_CANT AS DOUBLE PRECISION) * (FADE_PRUNIT-FADE_DTOMONTO)), (FADE_IVAMONTO+FADE_CONSUMO)
                        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE FD, FACTURAS F
                        WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FD.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAINV = :CUENTA AND FACT_ANULADO = 'N'
                        INTO :ART, :MONTO, :IMPTOS
                    DO
                        BEGIN
                        if (IMPINC = 'S') then
                            MONTO = MONTO - IMPTOS;
                        if ((CTADTO IS NULL) OR (CTADTO = '')) then
                            MONTO = MONTO * FACTOR;
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        if (MONTO <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            SUMA = SUMA - MONTO;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    SUMA = SUMA - MONTO;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - MONTO;
                    END
                END /* MONTO <> 0 */
            END /* FOR */
        END /* VENTAS X ARTICULO */
     IF ((VENTAS = 'C') OR (VENTAS = 'K')) THEN
        BEGIN
        IF (VENTAS = 'C') THEN
            CTAVENTAS = TCTAVENTA;
        SELECT SUM(CAST(FADE_CANT AS DOUBLE PRECISION) * (FADE_PRUNIT-FADE_DTOMONTO)), SUM(FADE_IVAMONTO+FADE_CONSUMO)
            FROM FACTURAS_DETALLE FD, FACTURAS F
            WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FACT_ANULADO = 'N'
            INTO :MONTO, :IMPTOS;
        if (IMPINC = 'S') then
            MONTO = MONTO - IMPTOS;
        if ((CTADTO IS NULL) OR (CTADTO = '')) then
            MONTO = MONTO * FACTOR;
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        if (MONTO <> 0) then
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTAVENTAS INTO :CUENTA, :TIPOCUEN;
            if (CUENTA IS NULL) then
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CTAVENTAS, 2);
                CUENTA = CTAVENTAS;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT FD.ARTI_COD, (CAST(FADE_CANT AS DOUBLE PRECISION) * (FADE_PRUNIT-FADE_DTOMONTO)), (FADE_IVAMONTO+FADE_CONSUMO)
                    FROM /*ARTICULO A,*/ FACTURAS_DETALLE FD, FACTURAS F
                    WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FACT_ANULADO = 'N'
                    INTO :ART, :MONTO, :IMPTOS
                    DO
                    BEGIN
                    if (IMPINC = 'S') then
                        MONTO = MONTO - IMPTOS;
                    if ((CTADTO IS NULL) OR (CTADTO = '')) then
                        MONTO = MONTO * FACTOR;
                    execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                    if (MONTO <> 0) then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA - MONTO;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - MONTO;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - MONTO;
                END
            END /* MONTO <> 0 */
        END /* VENTAS DE CLIENTE O CONSTANTE */
    /* EL IVA EN VENTAS */
    if (IVA = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTAIVAV), SUM(FADE_IVAMONTO), SUM(CAST(FADE_CANT AS DOUBLE PRECISION) * (FADE_PRUNIT-FADE_DTOMONTO)), sum(FADE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE FD, FACTURAS F
            WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FD.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND FACT_ANULADO = 'N'
            GROUP BY COAR_CTAIVAV
            INTO :CTAIVA, :IMPTOS, :MONTO, :VALORADIC
        DO
            BEGIN
            if (IMPINC = 'S') then
                MONTO = MONTO - IMPTOS - VALORADIC;
            MONTO = MONTO * -1;
            MONTO = MONTO * FACTOR;
            IMPTOS = IMPTOS * FACTOR;
            execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
            execute procedure redondee(MONTO, DIG) returning_values (MONTO);
            if (IMPTOS <> 0) then
                BEGIN
                CUENTA = NULL;
                SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                    WHERE CUEN_COD = :CTAIVA INTO :CUENTA, :TIPOCUEN;
                if (CUENTA IS NULL) then
                    begin
                    EXECUTE PROCEDURE ERROR (31, 0, :CTAIVA, 2);
                    CUENTA = CTAIVA;
                    TIPOCUEN = 'N';
                    ERROR = ERROR + 1;
                    end
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT FD.ARTI_COD, FADE_IVAMONTO, (CAST(FADE_CANT AS DOUBLE PRECISION) * (FADE_PRUNIT-FADE_DTOMONTO)), TAIV_PORC, FADE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE FD, FACTURAS F, TARIFA_IVA T
                        WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FD.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTAIVAV = :CUENTA AND A.TAIV_COD = T.TAIV_COD AND FACT_ANULADO = 'N'
                        INTO :ART, :IMPTOS, :MONTO, :PORCIVA, :VALORADIC
                    DO
                        BEGIN
                        if (IMPINC = 'S') then
                            MONTO = MONTO - IMPTOS - VALORADIC;
                        MONTO = MONTO * -1;
                        MONTO = MONTO * FACTOR;
                        IMPTOS = IMPTOS * FACTOR;
                        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                        if (IMPTOS <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            SUMA = SUMA + DEBITO - CREDITO;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                END   /* IMPTOS <> 0 */
            END /* FOR */
        END /* IVA X ARTICULO */
    if (IVA = 'K') then /* IVA EN CTA CONSTANTE */
        BEGIN
        SELECT SUM(FADE_IVAMONTO), SUM(CAST(FADE_CANT AS DOUBLE PRECISION) * (FADE_PRUNIT-FADE_DTOMONTO)), SUM(FADE_CONSUMO)
            FROM FACTURAS_DETALLE FD, FACTURAS F
            WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FACT_ANULADO = 'N'
            INTO :IMPTOS, :MONTO, :valoradic;
        if (IMPINC = 'S') then
            MONTO = MONTO - IMPTOS - VALORADIC;
        MONTO = MONTO * -1;
        MONTO = MONTO * FACTOR;
        IMPTOS = IMPTOS * FACTOR;
        execute procedure redondee(MONTO, DIG) returning_values (MONTO);
        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
        if (IMPTOS <> 0) then
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTAIVA INTO :CUENTA, :TIPOCUEN;
            if (CUENTA IS NULL) then
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CTAIVA, 2);
                CUENTA = CTAIVA;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT FD.ARTI_COD, (CAST(FADE_CANT AS DOUBLE PRECISION) * (FADE_PRUNIT-FADE_DTOMONTO)), FADE_IVAMONTO, TAIV_PORC, FADE_CONSUMO
                    FROM ARTICULO A, FACTURAS_DETALLE FD, FACTURAS F, TARIFA_IVA T
                    WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FD.arti_cod = A.arti_cod AND T.TAIV_COD=A.TAIV_COD AND FACT_ANULADO = 'N'
                    INTO :ART, :MONTO, :IMPTOS, :PORCIVA, :VALORADIC
                    DO
                    BEGIN
                    if (IMPINC = 'S') then
                        MONTO = MONTO - IMPTOS - VALORADIC;
                    MONTO = MONTO * -1;
                    MONTO = MONTO * FACTOR;
                    IMPTOS = IMPTOS * FACTOR;
                    execute procedure redondee(MONTO, DIG) returning_values (MONTO);
                    execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                    if (IMPTOS <> 0) then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', 0, :IMPTOS, :MONTO, :PORCIVA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA - IMPTOS;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAIVA, :CONC, '', 0, :IMPTOS, :MONTO, ABS(:IMPTOS*100/:MONTO), :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            END /* IMPTOS <> 0 */
        END /* IVA EN CTA CONSTANTE */
    /* EL IMPOCONSUMO */
    if (CONSUMO = 'A') then
        BEGIN
        FOR SELECT MAX(COAR_CTACONS), SUM(FADE_CONSUMO)
            FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE FD, FACTURAS F
            WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FD.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND FACT_ANULADO = 'N'
            GROUP BY COAR_CTACONS
            INTO :CTACONSUMO, :IMPTOS
        DO
            BEGIN
            execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
            if (IMPTOS <> 0) then
                BEGIN
                CUENTA = NULL;
                SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                    WHERE CUEN_COD = :CTACONSUMO INTO :CUENTA, :TIPOCUEN;
                if (CUENTA IS NULL) then
                    begin
                    EXECUTE PROCEDURE ERROR (31, 0, :CTACONSUMO, 2);
                    CUENTA = CTACONSUMO;
                    TIPOCUEN = 'N';
                    ERROR = ERROR + 1;
                    end
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT FD.ARTI_COD, FADE_CONSUMO
                        FROM ARTICULO A, CONTABIL_ARTICULO C, FACTURAS_DETALLE FD, FACTURAS F
                        WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FD.ARTI_COD = A.ARTI_COD AND A.ARTI_COD = C.ARTI_COD AND COAR_CTACONS = :CUENTA AND FACT_ANULADO = 'N'
                        INTO :ART, :IMPTOS
                    DO
                        BEGIN
                        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                        if (IMPTOS <> 0) then
                            BEGIN
                            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                            NROI = NROI + 1;
                            SUMA = SUMA - IMPTOS;
                            END
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    SUMA = SUMA - IMPTOS;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    SUMA = SUMA - CREDITO;
                    END
                END /* IMPTOS <> 0 */
            END /* FOR */
        END /* CONSUMO X ARTICULO */
    if (CONSUMO = 'K') then /* CONSUMO EN CTA CONSTANTE */
        BEGIN
        SELECT SUM(FADE_CONSUMO)
            FROM FACTURAS_DETALLE FD, FACTURAS F
            WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FACT_ANULADO = 'N'
            INTO :IMPTOS;
        execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
        if (IMPTOS <> 0) then
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTACONSUMO INTO :CUENTA, :TIPOCUEN;
            if (CUENTA IS NULL) then
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CTACONSUMO, 2);
                CUENTA = CTACONSUMO;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT FD.ARTI_COD, FADE_CONSUMO
                    FROM /*ARTICULO A,*/ FACTURAS_DETALLE FD, FACTURAS F
                    WHERE F.FACT_ID = FD.FACT_ID AND FACT_FECHA = :FECFAC AND F.PREF_PRE = :PREF AND F.PTVT_ID = :PTVTA AND FACT_ANULADO = 'N'
                    INTO :ART, :IMPTOS
                    DO
                    BEGIN
                    execute procedure redondee(IMPTOS, DIG) returning_values (IMPTOS);
                    if (IMPTOS <> 0) then
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        SUMA = SUMA - IMPTOS;
                        END
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACONSUMO, :CONC, '', 0, :IMPTOS, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                SUMA = SUMA - IMPTOS;
                END
            END /* IMPTOS <> 0 */
        END /* CONSUMO EN CTA CONSTANTE */
    /* DESCUENTO */
    if ((CTADTO IS NOT NULL) AND (CTADTO <> '')) then
        BEGIN
        execute procedure redondee(VRDTO, DIG) returning_values (VRDTO);
        if (VRDTO <> 0) then
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTADTO INTO :CUENTA, :TIPOCUEN;
            if (CUENTA IS NULL) then
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CTADTO, 2);
                CUENTA = CTADTO;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CUENTA, 3);
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRDTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA + VRDTO;
                END
            if (TIPOCUEN = 'N') then
                    BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRDTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA + VRDTO;
                END
            END
        END /* DESCUENTO */
    /* VALOR ADIC */
    if ((CTAADIC IS NOT NULL) AND (CTAADIC <> '')) then
        BEGIN
        execute procedure redondee(VRADIC, DIG) returning_values (VRADIC);
        if (VRADIC <> 0) THEN
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTAADIC INTO :CUENTA, :TIPOCUEN;
            if (CUENTA IS NULL) then
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CTAADIC, 2);
                CUENTA = CTAADIC;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CUENTA, 3);
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRADIC, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VRADIC;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VRADIC, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VRADIC;
                END
            END
        END /* VR. ADIC */
    /* VALOR EXTRA */
    if ((CTAEXTRA IS NOT NULL) AND (CTAEXTRA <> '')) THEN
        BEGIN
        execute procedure redondee(VREXTRA, DIG) returning_values (VREXTRA);
        if (VREXTRA <> 0) THEN
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTAEXTRA INTO :CUENTA, :TIPOCUEN;
            if (CUENTA IS NULL) then
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CTAEXTRA, 2);
                CUENTA = CTAEXTRA;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CUENTA, 3);
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VREXTRA, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VREXTRA;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :VREXTRA, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 31);
                NROI = NROI + 1;
                SUMA = SUMA - VREXTRA;
                END
            END
        END /* VR. EXTRA */
    /* RETENCION FUENTE */
    if ((RTFTE = 'C') or (RTFTE = 'K')) then
      BEGIN
      execute procedure redondee(VRRTFTE, DIG) returning_values (VRRTFTE);
      if (VRRTFTE <> 0) then
        BEGIN
        if (RTFTE = 'C') then
            CTARTFTE = TCTARTFTE;
        CUENTA = NULL;
        SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
            WHERE CUEN_COD = :CTARTFTE INTO :CUENTA, :TIPOCUEN;
        if (CUENTA IS NULL) then
            begin
            EXECUTE PROCEDURE ERROR (31, 0, :CTARTFTE, 2);
            CUENTA = CTARTFTE;
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            end
        if (TIPOCUEN = 'I') then
            begin
            EXECUTE PROCEDURE ERROR (31, 0, :CUENTA, 3);
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            end
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTFTE;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTFTE, 0, :VRSUBT, :PRTFTE, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTFTE;
            END
        END /* RTFTE */
      END
    /* RETENCION IVA */
    if ((RTIVA = 'C') or (RTIVA = 'K')) then
      BEGIN
      execute procedure redondee(VRRTIVA, DIG) returning_values (VRRTIVA);
      if (VRRTIVA <> 0) then
        BEGIN
        if (RTIVA = 'C') then
            CTARTIVA = TCTARTIVA;
        CUENTA = NULL;
        SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
            WHERE CUEN_COD = :CTARTIVA INTO :CUENTA, :TIPOCUEN;
        if (CUENTA IS NULL) then
            begin
            EXECUTE PROCEDURE ERROR (31, 0, :CTARTIVA, 2);
            CUENTA = CTARTIVA;
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            end
        if (TIPOCUEN = 'I') then
            begin
            EXECUTE PROCEDURE ERROR (31, 0, :CUENTA, 3);
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            end
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTIVA, 0, :VRIVA, :PORC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTIVA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTIVA, 0, :VRIVA, :PORC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTIVA;
            END
        END /* RTIVA */
      END
    /* RETENCION DE ICA */
    if ((RTICA = 'C') or (RTICA = 'K')) then
      BEGIN
      execute procedure redondee(VRRTICA, DIG) returning_values (VRRTICA);
      if (VRRTICA <> 0) then
        BEGIN
        if (RTICA = 'C') then
            CTARTICA = TCTARTICA;
        CUENTA = NULL;
        SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
            WHERE CUEN_COD = :CTARTICA INTO :CUENTA, :TIPOCUEN;
        if (CUENTA IS NULL) then
            begin
            EXECUTE PROCEDURE ERROR (31, 0, :CTARTICA, 2);
            CUENTA = CTARTICA;
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            end
        if (TIPOCUEN = 'I') then
            begin
            EXECUTE PROCEDURE ERROR (31, 0, :CUENTA, 3);
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            end
        if (TIPOCUEN = 'C') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTICA, 0, :VRSUBT, :PRTICA, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTICA;
            END
        if (TIPOCUEN = 'N') then
            BEGIN
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :VRRTICA, 0, :VRSUBT, :PRTICA, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
            NROI = NROI + 1;
            SUMA = SUMA + VRRTICA;
            END
        END /* RTICA */
      END
    /* CIERRE EL COMPROBANTE CONTRA LA CUENTA DEL TERCERO O LA CONSTANTE */
    if ((SUMA <> 0) and ((CARTERA = 'C') or (CARTERA = 'K') or (CARTERA = 'J'))) then
        BEGIN
        if (SUMA < 0) then
            BEGIN
            DEBITO = SUMA * -1;
            CREDITO = 0;
            END
        ELSE
            BEGIN
            DEBITO = 0;
            CREDITO = SUMA;
            END
        if (CARTERA = 'C') then
            CTACARTERA = TCTACLIEN;
        if (CARTERA = 'J') then
            BEGIN
            /* BUSQUE LA CUENTA DE LA CAJA */
            SELECT CAJA_CUENTA FROM CAJAS C, PUNTO_VENTA P
                WHERE P.CAJA_ID = C.CAJA_ID AND PTVT_ID = :PTOVTA
                INTO :CTACARTERA;
            END
        CUENTA = NULL;
        SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
            WHERE CUEN_COD = :CTACARTERA INTO :CUENTA, :TIPOCUEN;
        if (CUENTA IS NULL) then
            begin
            EXECUTE PROCEDURE ERROR (31, 0, :CTACARTERA, 2);
            CUENTA = CTACARTERA;
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            end
        if (TIPOCUEN = 'I') then
            begin
            EXECUTE PROCEDURE ERROR (31, 0, :CUENTA, 3);
            TIPOCUEN = 'N';
            ERROR = ERROR + 1;
            end
        if (TIPOCUEN = 'C') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
        if (TIPOCUEN = 'N') then
            INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :DEBITO, :CREDITO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
        NROI = NROI + 1;
        END /* SUMA EN CARTERA */
    /* CALCULE LOS COSTOS */
    EXECUTE PROCEDURE costo_en_ventas_contado(:fecfac,  :pref, :ptvta);
    if (COSTOS = 'A') then
        BEGIN
        FOR SELECT MAX(CTACOS), SUM(COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTACOS
            INTO :CTACOSTOS, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                CUENTA = NULL;
                SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                    WHERE CUEN_COD = :CTACOSTOS INTO :CUENTA, :TIPOCUEN;
                IF (CUENTA IS NULL) THEN
                    begin
                    EXECUTE PROCEDURE ERROR (31, 0, :CTACOSTOS, 2);
                    CUENTA = CTARTFTE;
                    TIPOCUEN = 'N';
                    ERROR = ERROR + 1;
                    end
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT ARTI_COD, CANT * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTACOS = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                END /* MONTO <> 0 */
            END /* FOR */
        END /* COSTOS */
    if (COSTOS = 'K') then
        BEGIN
        SELECT SUM(COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTACOSTOS INTO :CUENTA, :TIPOCUEN;
            IF (CUENTA IS NULL) THEN
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CTACOSTOS, 2);
                CUENTA = CTARTFTE;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT ARTI_COD, CANT * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTACOSTOS, :CONC, '', :MONTO, 0, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            END /* MONTO <> 0 */
        END /* COSTOS = K */
    if (INVEN = 'A') then
        BEGIN
        FOR SELECT MAX(CTAINV), SUM(COSTO)
            FROM COSTO_VENTAS
            GROUP BY CTAINV
            INTO :CTAINVEN, :MONTO
        DO
            BEGIN
            if (MONTO <> 0) then
                BEGIN
                CUENTA = NULL;
                SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                    WHERE CUEN_COD = :CTAINVEN INTO :CUENTA, :TIPOCUEN;
                IF (CUENTA IS NULL) THEN
                    begin
                    EXECUTE PROCEDURE ERROR (31, 0, :CTAINVEN, 2);
                    CUENTA = CTAINVEN;
                    TIPOCUEN = 'N';
                    ERROR = ERROR + 1;
                    end
                if (TIPOCUEN = 'I') then
                    BEGIN
                    /* ES UNA CUENTA DE INVENTARIO, REGISTRE UNO A UNO LOS ARTICULOS */
                    FOR SELECT ARTI_COD, CANT * COSTO
                        FROM COSTO_VENTAS
                        WHERE CTAINV = :CUENTA
                        INTO :ART, :MONTO
                    DO
                        BEGIN
                        INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                            VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                        NROI = NROI + 1;
                        END
                    END
                if (TIPOCUEN = 'C') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                    NROI = NROI + 1;
                    END
                if (TIPOCUEN = 'N') then
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CUENTA, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                    NROI = NROI + 1;
                    END
                END /* MONTO <> 0 */
            END /* FOR */
        END /* INVEN = A */
    if (INVEN = 'K') then
        BEGIN
        SELECT SUM(COSTO)
            FROM COSTO_VENTAS
            INTO :MONTO;
        if (MONTO <> 0) then
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTAINVEN INTO :CUENTA, :TIPOCUEN;
            IF (CUENTA IS NULL) THEN
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CTAINVEN, 2);
                CUENTA = CTAINVEN;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                BEGIN
                /* ES UNA CUENTA DE INVENTARIO, RESGISTRE UNO A UNO LOS ARTICULOS */
                FOR SELECT ARTI_COD, CANT * COSTO
                    FROM COSTO_VENTAS
                    INTO :ART, :MONTO
                DO
                    BEGIN
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, :ART, 0, 0);
                    NROI = NROI + 1;
                    END
                END
            if (TIPOCUEN = 'C') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                    VALUES (:IDC, :NROI, :CTAINVEN, :CONC, '', 0, :MONTO, 0, 0, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            END /* MONTO <> 0 */
        END /* INVEN = K */
    /* recorra las cuentas adicionales */
    FOR SELECT INVC_CUENTA, INVC_BASE, INVC_PORC, INVC_VALOR, INVC_DB
        FROM INTERFAZ_VENTAS_CTAS
        WHERE INVE_ID = :IDINTER
        INTO :CTADIC, :BASEADIC, :PORCADIC, :VALORADIC, :DBADIC
        DO
        BEGIN
        if (VALORADIC <> 0) then
            MONTO = VALORADIC;
        ELSE
            BEGIN
            if (:BASEADIC = 'SUBTOTAL') then
                VALORADIC = vrsubt;
            if (:BASEADIC = 'DESCUENTO') then
                VALORADIC = VRDTO;
            if (:BASEADIC = 'IVA') then
                VALORADIC = VRIVA;
            if (:BASEADIC = 'ADICIONAL') then
                VALORADIC = VRADIC;
            if (:BASEADIC = 'EXTRA') then
                VALORADIC = VREXTRA;
            if (:BASEADIC = 'TOTAL') then
                VALORADIC = VRTOTAL;
            MONTO = VALORADIC * PORCADIC / 100;
            END
        if (MONTO <> 0) then
            BEGIN
            CUENTA = NULL;
            SELECT CUEN_COD, CUEN_TIPO FROM CUENTAS
                WHERE CUEN_COD = :CTADIC INTO :CUENTA, :TIPOCUEN;
            if (CUENTA IS NULL) then
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CTADIC, 2);
                CUENTA = CTADIC;
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'I') then
                begin
                EXECUTE PROCEDURE ERROR (31, 0, :CUENTA, 3);
                TIPOCUEN = 'N';
                ERROR = ERROR + 1;
                end
            if (TIPOCUEN = 'C') then
                BEGIN
                if (DBADIC = 'S') then
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                ELSE
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, :NUMERO, NULL, :VENCE, NULL, 0, 31);
                NROI = NROI + 1;
                END
            if (TIPOCUEN = 'N') then
                BEGIN
                if (DBADIC = 'S') then
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', :MONTO, 0, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                ELSE
                    INSERT INTO CONTABILIZACION_DET (CNTB_ID, CNDE_ITEM, CNDE_CUENTA, CNDE_CONC, CNDE_REF, CNDE_DEBITOS, CNDE_CREDITOS, CNDE_BASE, CNDE_PORC, CNDE_TERC, CNDE_PROY, CNDE_CENTRO, CNDE_DOCNUMERO, CNDE_DOCAPLICAR, CNDE_DOCVENCE, CNDE_ARTICULO, CNDE_DOCTIPOA, CNDE_DOCTIPON)
                        VALUES (:IDC, :NROI, :CTADIC, :CONC, '', 0, :MONTO, :VALORADIC, :PORCADIC, :NIT, :PROY, :CENTRO, NULL, NULL, NULL, NULL, 0, 0);
                NROI = NROI + 1;
                END
            NROI = NROI + 1;
            END
        END
    if (ERROR > 0) then
        VER = 'S';
    SUSPEND;
    END /* EXISTE LA INTERFAZ */
ELSE
    BEGIN
    EXECUTE PROCEDURE ERROR (31, 0, :PREF, 1);
    ERROR = ERROR + 1;
    VER = 'S';
    SUSPEND;
    END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE EXISTENCIAS_DESDE_HASTA(
    FECHA DATE,
    ARTINI VARCHAR(20),
    ARTFIN VARCHAR(20),
    GRPINI VARCHAR(3),
    GRPFIN VARCHAR(3),
    BODINI VARCHAR(2),
    BODFIN VARCHAR(2),
    ORDEN CHAR(1),
    AGRUPA CHAR(1),
    DETALLE CHAR(1),
    RESERVA CHAR(1),
    SUCURSAL INTEGER)
RETURNS (
    CANT NUMERIC(18,4),
    COSTO NUMERIC(18,2),
    COSTO_LOTE NUMERIC(18,2),
    CODIGO VARCHAR(15),
    NOMBRE VARCHAR(60),
    UNIDAD VARCHAR(8),
    STAND VARCHAR(15),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    CODBOD VARCHAR(2),
    LOTE VARCHAR(15),
    NOMBOD VARCHAR(30),
    COSTOTOT NUMERIC(18,2),
    ULTCOSTO NUMERIC(18,2),
    FECHACOSTO DATE,
    CONSUMO NUMERIC(18,2),
    RESERVADO NUMERIC(18,4),
    ORDENADO NUMERIC(18,4),
    IVA NUMERIC(9,2),
    CODBAR VARCHAR(20))
AS
declare variable exist char(1);
declare variable codini varchar(20);
declare variable codfin varchar(20);
declare variable desini varchar(20);
declare variable desfin varchar(20);
declare variable ordenc numeric(18,4);
declare variable pedido numeric(18,4);
declare variable ok char(1);
declare variable id integer;
declare variable item integer;
declare variable und varchar(8);
declare variable factor numeric(18,4);
declare variable cant2 numeric(18,4);
declare variable PEDAUTO CHAR(2);
BEGIN
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'FACTURAS', 'GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') returning_values (pedauto);
if (DETALLE = 'B') then
  BEGIN
  FOR SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, ARTI_EXIST, TAIV_PORC, A.GRUP_COD, A.SUBG_COD, A.MARC_COD, BODE_COD, BODE_NOM, ARTI_CONSUMO
      FROM ARTICULO A, BODEGA B, TARIFA_IVA T
      WHERE ARTI_COD >= :CODINI AND ARTI_COD <= :CODFIN AND ARTI_DES >= :DESINI AND ARTI_DES <= :DESFIN AND ESAR_COD <> 'I' AND BODE_COD >= :BODINI AND
      BODE_COD <= :BODFIN AND ((SUCU_ID = :SUCURSAL) or (:SUCURSAL = 0)) AND A.TAIV_COD = T.TAIV_COD
      INTO :CODIGO, :NOMBRE, :UNIDAD, :EXIST, :IVA, :CODGRUPO, :CODSUBG, :CODMARC, :CODBOD, :NOMBOD, :CONSUMO
      DO
        BEGIN
        OK = 'N';
        if (AGRUPA = 'G') then
            BEGIN
            if ((CODGRUPO >= GRPINI) AND (CODGRUPO <= GRPFIN)) then
                OK = 'S';
            end
        ELSE
            if (AGRUPA = 'M') then
                BEGIN
                if ((CODMARC >= GRPINI) AND (CODMARC <= GRPFIN)) then
                    OK = 'S';
                END
        if (OK = 'S') then
            BEGIN
            NOMGRUPO = '';
            NOMMARC = '';
            NOMSUBG = '';
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SELECT MAX(COBA_COD) FROM BARRAS_ARTICULO WHERE ARTI_COD = :codigo AND COBA_UNIDAD = :unidad INTO :codbar;
            if (CODBAR IS NULL) then
                CODBAR = CODIGO;
            if (EXIST <> 'N') then
                BEGIN
                SELECT MAX(EXIS_STAND) FROM EXISTENCIA WHERE ARTI_COD = :CODIGO AND BODE_COD = :CODBOD INTO :STAND;
                EXECUTE PROCEDURE SALDO_INICIAL_INVENTARIO(CODIGO, FECHA, :CODBOD) returning_values (CANT);
                EXECUTE PROCEDURE COSTO_PROMEDIO_UNIDAD(CODIGO, FECHA, UNIDAD) returning_values (COSTO);
                EXECUTE PROCEDURE ULTIMO_COSTO(CODIGO, FECHA, UNIDAD) returning_values (ULTCOSTO);
                SELECT MAX(MVAR_FECHA) FROM MOVIMIENTO_ARTICULO WHERE ARTI_COD = :CODIGO AND MVAR_ENTRADA = 'S' AND MVAR_FECHA <= :FECHA INTO :FECHACOSTO;
                COSTOTOT = :CANT * :COSTO;
                CONSUMO = CONSUMO * CANT;
                if (RESERVA = 'S') then
                    BEGIN
                    SELECT SUM(ORID_ENTREGAR)
                        FROM ORDENINVENTARIO_DETALLE OD, ordenes_inventario O
                        WHERE O.ORIN_ID = OD.ORIN_ID AND ARTI_COD = :CODIGO AND ORIN_FECHA <= :FECHA AND ORIN_FECLLEGA >= :FECHA AND ORID_ANULADO = 'N' AND OD.BODE_COD = :CODBOD
                        INTO :ORDENADO;
                    if (ORDENADO IS NULL) then
                        ORDENADO = 0;
                    ORDENC = 0;
                    FOR SELECT O.ORDC_ID, OCDE_ITEM, OCDE_CANT * OCDE_FACTOR
                        FROM ORDENES_COMPRA O, ORDENES_COMPRA_DETALLE OD
                        WHERE O.ORDC_ID = OD.ORDC_ID AND OD.ARTI_COD = :CODIGO AND (ORDC_FECHA+ORDC_VALIDEZ) >= :FECHA AND ORDC_FECHA <= :FECHA AND OCDE_ANULADO = 'N' AND OD.BODE_COD = :CODBOD
                        INTO :ID, :ITEM, :CANT2
                        do
                        BEGIN
                        EXECUTE PROCEDURE FALTANTE(23, 21, ID, ITEM) returning_values (PEDIDO, UND, FACTOR);
                        if (PEDIDO * FACTOR = CANT2) then /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */
                            EXECUTE PROCEDURE FALTANTE(23, 22, ID, ITEM) returning_values (PEDIDO, UND, FACTOR);
                        if (PEDIDO IS NULL) then
                            PEDIDO = 0;
                        ORDENC = ORDENC + PEDIDO * FACTOR;
                        END
                    ORDENADO = ORDENADO + ORDENC;
                    SELECT SUM(RSDE_LIBERAR)
                        FROM RESERVAS_DETALLE RD, RESERVAS R
                        WHERE R.RESE_ID = RD.RESE_ID AND ARTI_COD = :CODIGO AND RESE_FECHA <= :FECHA AND RESE_VENCE >= :FECHA AND RD.BODE_COD = :CODBOD AND RSDE_ANULADO = 'N'
                        INTO :RESERVADO;
                    if (RESERVADO IS NULL) then
                        RESERVADO = 0;
                    PEDIDO = 0;
                    FOR SELECT P.PEDI_ID, PEDE_ITEM, PEDE_CANT * PEDE_FACTOR
                        FROM PEDIDOS P, PEDIDOS_DETALLE PD
                        WHERE P.PEDI_ID = PD.PEDI_ID AND PD.ARTI_COD = :CODIGO AND (PEDI_FECHA+PEDI_VALIDEZ) >= :FECHA AND PEDI_FECHA <= :FECHA AND PEDE_ANULADO = 'N' AND BODE_COD = :CODBOD
                        INTO :ID, :ITEM, :CANT2
                        do
                        BEGIN
                        EXECUTE PROCEDURE FALTANTE(34, 31, ID, ITEM) returning_values (ORDENC, UND, FACTOR);
                        if ((ORDENC * FACTOR = CANT2) or (PEDAUTO = 'SI')) then /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */
                            EXECUTE PROCEDURE FALTANTE(34, 32, ID, ITEM) returning_values (ORDENC, UND, FACTOR);
                        if (ORDENC IS NULL) then
                            ORDENC = 0;
                        PEDIDO = PEDIDO + ORDENC * FACTOR;
                        END
                    RESERVADO = RESERVADO + PEDIDO;
                    END
                ELSE
                    BEGIN
                    RESERVADO = 0;
                    ORDENADO = 0;
                    END
                SUSPEND;
                END
            END
        END
  END

if (DETALLE = 'L') then
  BEGIN
  FOR SELECT A.ARTI_COD, ARTI_DES, ARTI_UNIDAD, ARTI_EXIST, TAIV_PORC, A.GRUP_COD, A.SUBG_COD, A.MARC_COD, L.lote_nro, L.lote_nro||' - '||L.lote_vence, ARTI_CONSUMO,l.bode_cod, L.lote_saldo,l.lote_costo
      FROM ARTICULO A, LOTES l, TARIFA_IVA T
      WHERE A.ARTI_COD >= '0' AND A.ARTI_COD <= 'zz' AND ARTI_DES >= '' AND ARTI_DES <= 'zz' AND ESAR_COD <> 'I' AND A.TAIV_COD = T.TAIV_COD and a.arti_cod = l.arti_cod
      INTO :CODIGO, :NOMBRE, :UNIDAD, :EXIST, :IVA, :CODGRUPO, :CODSUBG, :CODMARC, :LOTE, :NOMBOD, :CONSUMO, :codbod, :cant, :costo_lote
      DO
        BEGIN
        OK = 'N';
        if (AGRUPA = 'G') then
            BEGIN
            if ((CODGRUPO >= GRPINI) AND (CODGRUPO <= GRPFIN)) then
                OK = 'S';
            end
        ELSE
            if (AGRUPA = 'M') then
                BEGIN
                if ((CODMARC >= GRPINI) AND (CODMARC <= GRPFIN)) then
                    OK = 'S';
                END
        if (OK = 'S') then
            BEGIN
            NOMGRUPO = '';
            NOMMARC = '';
            NOMSUBG = '';
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SELECT MAX(COBA_COD) FROM BARRAS_ARTICULO WHERE ARTI_COD = :codigo AND COBA_UNIDAD = :unidad INTO :codbar;
            if (CODBAR IS NULL) then
                CODBAR = CODIGO;

            if (EXIST <> 'N') then
                BEGIN
                EXECUTE PROCEDURE COSTO_PROMEDIO_UNIDAD(CODIGO, FECHA, UNIDAD) returning_values (COSTO);
                EXECUTE PROCEDURE ULTIMO_COSTO(CODIGO, FECHA, UNIDAD) returning_values (ULTCOSTO);
                SELECT MAX(MVAR_FECHA) FROM MOVIMIENTO_ARTICULO WHERE ARTI_COD = :CODIGO AND MVAR_ENTRADA = 'S' AND MVAR_FECHA <= :FECHA INTO :FECHACOSTO;
                COSTOTOT = :CANT * :COSTO;
                CONSUMO = CONSUMO * CANT;
                if (RESERVA = 'S') then
                    BEGIN
                    SELECT SUM(ORID_ENTREGAR)
                        FROM ORDENINVENTARIO_DETALLE OD, ordenes_inventario O
                        WHERE O.ORIN_ID = OD.ORIN_ID AND ARTI_COD = :CODIGO AND ORIN_FECHA <= :FECHA AND ORIN_FECLLEGA >= :FECHA AND ORID_ANULADO = 'N'
                        INTO :ORDENADO;
                    if (ORDENADO IS NULL) then
                        ORDENADO = 0;
                    ORDENC = 0;
                    FOR SELECT O.ORDC_ID, OCDE_ITEM, OCDE_CANT * OCDE_FACTOR
                        FROM ORDENES_COMPRA O, ORDENES_COMPRA_DETALLE OD
                        WHERE O.ORDC_ID = OD.ORDC_ID AND OD.ARTI_COD = :CODIGO AND (ORDC_FECHA+ORDC_VALIDEZ) >= :FECHA AND ORDC_FECHA <= :FECHA AND OCDE_ANULADO = 'N'
                        INTO :ID, :ITEM, :CANT2
                        do
                        BEGIN
                        EXECUTE PROCEDURE FALTANTE(23, 21, ID, ITEM) returning_values (PEDIDO, UND, FACTOR);
                        if (PEDIDO * FACTOR = CANT2) then /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */
                            EXECUTE PROCEDURE FALTANTE(23, 22, ID, ITEM) returning_values (PEDIDO, UND, FACTOR);
                        if (PEDIDO IS NULL) then
                            PEDIDO = 0;
                        ORDENC = ORDENC + PEDIDO * FACTOR;
                        END
                    ORDENADO = ORDENADO + ORDENC;
                    SELECT SUM(RSDE_LIBERAR)
                        FROM RESERVAS_DETALLE RD, RESERVAS R
                        WHERE R.RESE_ID = RD.RESE_ID AND ARTI_COD = :CODIGO AND RESE_FECHA <= :FECHA AND RESE_VENCE >= :FECHA AND RSDE_ANULADO = 'N'
                        INTO :RESERVADO;
                    if (RESERVADO IS NULL) then
                        RESERVADO = 0;
                    PEDIDO = 0;
                    FOR SELECT P.PEDI_ID, PEDE_ITEM, PEDE_CANT * PEDE_FACTOR
                        FROM PEDIDOS P, PEDIDOS_DETALLE PD
                        WHERE P.PEDI_ID = PD.PEDI_ID AND PD.ARTI_COD = :CODIGO AND (PEDI_FECHA+PEDI_VALIDEZ) >= :FECHA AND PEDI_FECHA <= :FECHA AND PEDE_ANULADO = 'N'
                        INTO :ID, :ITEM, :CANT2
                        do
                        BEGIN
                        EXECUTE PROCEDURE FALTANTE(34, 31, ID, ITEM) returning_values (ORDENC, UND, FACTOR);
                        if ((ORDENC * FACTOR = CANT2) or (PEDAUTO = 'SI')) then /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */
                            EXECUTE PROCEDURE FALTANTE(34, 32, ID, ITEM) returning_values (ORDENC, UND, FACTOR);
                        if (ORDENC IS NULL) then
                            ORDENC = 0;
                        PEDIDO = PEDIDO + ORDENC * FACTOR;
                        END
                    RESERVADO = RESERVADO + PEDIDO;
                    END
                ELSE
                    BEGIN
                    RESERVADO = 0;
                    ORDENADO = 0;
                    END
                SUSPEND;
                END
            END
        END
  end
if (DETALLE = 'N') then
  BEGIN
  FOR SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, ARTI_EXIST, TAIV_PORC, A.GRUP_COD, A.SUBG_COD, A.MARC_COD, ARTI_CONSUMO
      FROM ARTICULO A, TARIFA_IVA T
      WHERE ARTI_COD >= :CODINI AND ARTI_COD <= :CODFIN AND ARTI_DES >= :DESINI AND ARTI_DES <= :DESFIN AND ESAR_COD <> 'I' AND A.TAIV_COD = T.TAIV_COD
      INTO :CODIGO, :NOMBRE, :UNIDAD, :EXIST, :IVA, :CODGRUPO, :CODSUBG, :CODMARC, :CONSUMO
      DO
        BEGIN
        OK = 'N';
        if (AGRUPA = 'G') then
            BEGIN
            if ((GRPINI = '0') AND (GRPFIN = 'zz')) then
                OK = 'S';
            else
                if ((CODGRUPO >= GRPINI) AND (CODGRUPO <= GRPFIN)) then
                    OK = 'S';
            end
        ELSE
            if (AGRUPA = 'M') then
                BEGIN
                if ((GRPINI = '0') AND (GRPFIN = 'zzz')) then
                    OK = 'S';
                else
                    if ((CODMARC >= GRPINI) AND (CODMARC <= GRPFIN)) then
                        OK = 'S';
                END
        if (OK = 'S') then
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
            SELECT MAX(COBA_COD) FROM BARRAS_ARTICULO WHERE ARTI_COD = :codigo AND COBA_UNIDAD = :unidad INTO :codbar;
            if (CODBAR IS NULL) then
                CODBAR = CODIGO;

            if (EXIST <> 'N') then
                BEGIN
                EXECUTE PROCEDURE SALDO_INICIAL_TOTAL_INV(CODIGO, FECHA) returning_values (CANT);
                EXECUTE PROCEDURE COSTO_PROMEDIO_UNIDAD(CODIGO, FECHA, UNIDAD) returning_values (COSTO);
                EXECUTE PROCEDURE ULTIMO_COSTO(CODIGO, FECHA, UNIDAD) returning_values (ULTCOSTO);
                SELECT MAX(MVAR_FECHA) FROM MOVIMIENTO_ARTICULO WHERE ARTI_COD = :CODIGO AND MVAR_ENTRADA = 'S' AND MVAR_FECHA <= :FECHA INTO :FECHACOSTO;
                COSTOTOT = :CANT * :COSTO;
                CONSUMO = CONSUMO * CANT;
                if (RESERVA = 'S') then
                    BEGIN
                    SELECT SUM(ORID_ENTREGAR)
                        FROM ORDENINVENTARIO_DETALLE OD, ordenes_inventario O
                        WHERE O.ORIN_ID = OD.ORIN_ID AND ARTI_COD = :CODIGO AND ORIN_FECHA <= :FECHA AND ORIN_FECLLEGA >= :FECHA AND ORID_ANULADO = 'N'
                        INTO :ORDENADO;
                        if (ORDENADO IS NULL) then
                            ORDENADO = 0;
                    ORDENC = 0;
                    FOR SELECT O.ORDC_ID, OCDE_ITEM, OCDE_CANT * OCDE_FACTOR
                        FROM ORDENES_COMPRA O, ORDENES_COMPRA_DETALLE OD
                        WHERE O.ORDC_ID = OD.ORDC_ID AND OD.ARTI_COD = :CODIGO AND (ORDC_FECHA+ORDC_VALIDEZ) >= :FECHA AND ORDC_FECHA <= :FECHA AND OCDE_ANULADO = 'N'
                        INTO :ID, :ITEM, :CANT2
                        do
                        BEGIN
                        EXECUTE PROCEDURE FALTANTE(23, 21, ID, ITEM) returning_values (PEDIDO, UND, FACTOR);
                        if (PEDIDO * FACTOR = CANT2) then /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */
                            EXECUTE PROCEDURE FALTANTE(23, 22, ID, ITEM) returning_values (PEDIDO, UND, FACTOR);
                        if (PEDIDO IS NULL) then
                            PEDIDO = 0;
                        ORDENC = ORDENC + PEDIDO * FACTOR;
                        END
                    ORDENADO = ORDENADO + ORDENC;
                    SELECT SUM(RSDE_LIBERAR)
                        FROM RESERVAS_DETALLE RD, RESERVAS R
                        WHERE R.RESE_ID = RD.RESE_ID AND ARTI_COD = :CODIGO AND RESE_FECHA <= :FECHA AND RESE_VENCE >= :FECHA AND RSDE_ANULADO = 'N'
                        INTO :RESERVADO;
                    if (RESERVADO IS NULL) then
                        RESERVADO = 0;
                    PEDIDO = 0;
                    FOR SELECT P.PEDI_ID, PEDE_ITEM, PEDE_CANT * PEDE_FACTOR
                        FROM PEDIDOS P, PEDIDOS_DETALLE PD, PUNTO_VENTA PT
                        WHERE P.PEDI_ID = PD.PEDI_ID AND PD.ARTI_COD = :CODIGO AND PT.ptvt_id = P.PTVT_ID AND (PEDI_FECHA+PEDI_VALIDEZ) >= :FECHA AND PEDI_FECHA <= :FECHA AND PEDE_ANULADO = 'N'
                        INTO :ID, :ITEM, :CANT2
                        do
                        BEGIN
                        EXECUTE PROCEDURE FALTANTE(34, 31, ID, ITEM) returning_values (ORDENC, UND, FACTOR);
                        if ((ORDENC * FACTOR = CANT2) or (PEDAUTO = 'SI')) then /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */
                            EXECUTE PROCEDURE FALTANTE(34, 32, ID, ITEM) returning_values (ORDENC, UND, FACTOR);
                        if (ORDENC IS NULL) then
                            ORDENC = 0;
                        PEDIDO = PEDIDO + ORDENC * FACTOR;
                        END
                    if (PEDIDO IS NULL) then
                        PEDIDO = 0;
                    RESERVADO = RESERVADO + PEDIDO;
                    END
                ELSE
                    BEGIN
                    RESERVADO = 0;
                    ORDENADO = 0;
                    END
                SUSPEND;
                END
            END
        END
  END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE INVENTARIO_FAMILIA(
    FECHA DATE,
    FAMILIA VARCHAR(20))
RETURNS (
    ARTICULO VARCHAR(20),
    INTERNO VARCHAR(20),
    DESCRIPCION VARCHAR(60),
    CANTIDAD NUMERIC(18,2),
    UNIDAD VARCHAR(8),
    TOTAL NUMERIC(18,2))
AS
declare variable COSTO NUMERIC(18,4);
begin
FOR SELECT A.ARTI_COD, ARTI_DES, ARTI_UNIDAD, p.pvar_cod FROM ARTICULO A, PROVEEDOR_ARTICULO P
    WHERE ESAR_COD <> 'I' AND A.arti_cod = P.arti_cod AND P.terc_nit = :FAMILIA
    INTO :ARTICULO, :descripcion, :UNIDAD, :INTERNO
    DO
    BEGIN
    EXECUTE PROCEDURE SALDO_INICIAL_TOTAL_INV(ARTICULO, FECHA) returning_values (cantidad);
    EXECUTE PROCEDURE COSTO_PROMEDIO_UNIDAD(ARTICULO, FECHA, UNIDAD) returning_values (COSTO);
    TOTAL = COSTO * CANTIDAD;
    suspend;
    END
end

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE RECONTABILICE_COSTOS_VENTAS(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    IDC INTEGER)
AS
declare variable IDI INTEGER;
begin
FOR SELECT FACT_ID, PREF_PRE, FACT_NUMERO FROM FACTURAS WHERE fact_anulado = 'N' and FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN ORDER BY FACT_FECHA, FACT_ID INTO :ID, :PREF, :NUMERO
do  
    BEGIN
    SELECT MAX(INVE_ID) FROM INTERFAZ_VENTAS WHERE PREF_PRE = :PREF AND TIDO_COD = 31 INTO :IDI;
    EXECUTE PROCEDURE CONTABILICE_COSTO_VENTAS(:ID, :IDI) returning_values (:IDC);
    suspend;
    END
end

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE DEVOLUCIONES_SIN_CONTABILIDAD(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDI INTEGER,
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable FECICNT VARCHAR(10);
declare variable FECFCNT VARCHAR(10);
declare variable ERROR INTEGER;
declare variable idref INTEGER;
BEGIN
EXECUTE PROCEDURE fecha_a_conta(FECINI) returning_values (FECICNT);
EXECUTE PROCEDURE fecha_a_conta(FECFIN) returning_values (FECFCNT);
FOR SELECT DEVT_ID, PREF_PRE, DEVT_NUMERO FROM devoluciones_ventas WHERE DEVT_ANULADO = 'N' AND
    DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN
    INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  idref = null;
  SELECT ENCO_IDREF FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 33 AND ENCO_FECHA >= :FECICNT AND ENCO_FECHA <= :FECFCNT and ENCO_IDREF = :id into :idref;
  if (idref IS NULL) then
  begin
   ESTADO = 'PROCESANDO';
   SUSPEND;
   SELECT MAX(INVE_ID) FROM INTERFAZ_VENTAS WHERE PREF_PRE = :PREF AND TIDO_COD = 33 INTO :IDI;
   EXECUTE PROCEDURE contabil_devolcli (:ID, :IDI) RETURNING_VALUES (:ERROR, :VER, :IDC);
   if (ERROR = 0) then
    BEGIN
    EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC);
    ESTADO = 'OK';
    END
   ELSE
    ESTADO = 'ERROR';
   suspend;
  End
  END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER PROCEDURE FACTURAS_SIN_CONTABILIDAD(
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    ESTADO VARCHAR(20),
    IDI INTEGER,
    IDC INTEGER)
AS
DECLARE VARIABLE VER CHAR(2);
declare variable FECICNT VARCHAR(10);
declare variable FECFCNT VARCHAR(10);
declare variable ERROR INTEGER;
declare variable idref INTEGER;
BEGIN
EXECUTE PROCEDURE fecha_a_conta(FECINI) returning_values (FECICNT);
EXECUTE PROCEDURE fecha_a_conta(FECFIN) returning_values (FECFCNT);
FOR SELECT FACT_ID, PREF_PRE, FACT_NUMERO FROM FACTURAS WHERE FACT_ANULADO = 'N' AND
    FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN INTO :ID, :PREF, :NUMERO
DO
  BEGIN
  idref = null;
  SELECT ENCO_IDREF FROM COMPROBANTE_ENCABEZADO WHERE ENCO_TIPOREF = 31 AND ENCO_FECHA >= :FECICNT AND ENCO_FECHA <= :FECFCNT and ENCO_IDREF = :ID into :idref;
  if (idref IS NULL) then
  begin
   ESTADO = 'PROCESANDO';
   ERROR = NULL;
   SUSPEND;
   SELECT MAX(INVE_ID) FROM INTERFAZ_VENTAS WHERE PREF_PRE = :PREF AND TIDO_COD = 31 INTO :IDI;
   EXECUTE PROCEDURE CONTABIL_FACTURA (:ID, :IDI) RETURNING_VALUES (:ERROR, VER, :IDC);
   if ((ERROR = 0) or (error IS NULL)) then
    BEGIN
    EXECUTE PROCEDURE CONTABILIZA_PENDIENTE (:IDC);
    ESTADO = 'OK';
    END
   ELSE
    ESTADO = 'ERROR';
   suspend;
  end
  END
END

^

SET TERM ; ^

SET TERM ^ ;

ALTER TRIGGER AJUSTES_DETALLE_AI
AS
declare variable fec date;
declare variable CONC VARCHAR(60);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable CANTAJ numeric(18,4);
declare variable COSTO NUMERIC(18,2);
declare variable factor numeric(18,4);
BEGIN
  if ((NEW.AJUS_ID <> 0) and (new.ajde_anulado = 'N')) then
    BEGIN
    execute procedure factor_unidad_cant(new.arti_cod, new.ajus_unidad) returning_values(factor);
    CANTAJ = NEW.ajus_exant - (NEW.ajus_exnue / :factor);
    /* CUANDO CAMBIA LA EXISTENCIA REGISTRE EL MOV. */
    select AJUS_fecha, AJUS_conc, AJUS_NUMERO, PREF_PRE from AJUSTES where AJUS_id = new.AJUS_id into :fec, :conc, :Num, :Pref;
    if (CANTAJ > 0) then
      BEGIN
      /* ES UNA SALIDA */
      INSERT INTO MOVIMIENTO_ARTICULO
        (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM)
        VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 14, NEW.AJUS_id,
        :CONC, :cantaj, 0, 'N', NEW.ajus_lote, :Pref, :Num, NEW.ajus_item);
      END
    ELSE
      BEGIN
      /* ES UNA ENTRADA */
      EXECUTE PROCEDURE costo_promedio(NEW.arti_cod, :FEC) returning_values (:COSTO);
      INSERT INTO MOVIMIENTO_ARTICULO
        (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM)
        VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 14, NEW.AJUS_id,
        :CONC, abs(:cantaj), :COSTO, 'S', NEW.ajus_lote, :Pref, :Num, NEW.ajus_item);
      END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER TRIGGER AJUSTES_DETALLE_AU
as
declare variable fec date;
declare variable CONC VARCHAR(60);
declare variable cantaj numeric(18,4);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable COSTO NUMERIC(18,2);
declare variable factor numeric(18,4);
BEGIN
if ((old.ajus_id <> 0) and (old.ajde_anulado = 'N')) then
    DELETE FROM MOVIMIENTO_ARTICULO WHERE (mvar_tipodoc = 14) and (mvar_idref = new.ajus_id) and (mvar_item = new.ajus_item);
if ((NEW.AJUS_id <> 0) and (NEW.ajde_anulado = 'N')) then
    begin
    execute procedure factor_unidad_cant(new.arti_cod, new.ajus_unidad) returning_values(factor);
    CANTAJ = NEW.ajus_exant - (NEW.ajus_exnue / :factor);
    /* CUANDO CAMBIA LA EXISTENCIA REGISTRE EL MOV. */
    select AJUS_fecha, AJUS_conc, AJUS_NUMERO, PREF_PRE from AJUSTES where AJUS_id = new.AJUS_id into :fec, :conc, :Num, :Pref;
    if (CANTAJ > 0) then
        BEGIN
        /* ES UNA SALIDA */
        INSERT INTO MOVIMIENTO_ARTICULO
            (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM)
            VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 14, NEW.AJUS_id,
            :CONC, :cantaj, 0, 'N', NEW.ajus_lote, :Pref, :Num, new.ajus_item);
        END
    ELSE
        BEGIN
        /* ES UNA ENTRADA */
        EXECUTE PROCEDURE costo_promedio(NEW.arti_cod, :FEC) returning_values (:COSTO);
        INSERT INTO MOVIMIENTO_ARTICULO
            (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM)
            VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 14, NEW.AJUS_id,
            :CONC, abs(:cantaj), :costo, 'S', NEW.ajus_lote, :Pref, :Num, new.ajus_item);
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER TRIGGER AJUSTES_DETALLE_BI
as
declare variable FECHA DATE;
begin
/* COLOQUE EL COSTO PROMEDIO */
SELECT AJUS_FECHA FROM AJUSTES WHERE AJUS_ID = NEW.ajus_id INTO :FECHA;
EXECUTE PROCEDURE costo_promedio(NEW.arti_cod, :FECHA) returning_values (NEW.ajde_costo);
end
^

SET TERM ; ^

SET TERM ^ ;

ALTER TRIGGER DESENSAMBLES_DETALLE_AI
AS
declare variable fec date;
declare variable CONC VARCHAR(60);
declare variable factor numeric(18,4);
declare variable COSTO numeric(18,2);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable CANT NUMERIC(18,2);
declare variable CANTOT CHAR(2);
BEGIN
  if ((NEW.DESE_id <> 0) and (new.dede_anulado = 'N')) then
    begin
    select dese_fecha, dese_conc, pref_pre, dese_numero, dese_cant * dese_factor from desensambles where dese_id = new.dese_id into :fec, :conc, :Pref, :Num, :CANT;
    execute procedure factor_unidad_cant(new.arti_cod, new.dede_unidad) returning_values(factor);
    execute procedure costo_promedio(new.arti_cod, :FEC) returning_values (:COSTO);
    EXECUTE PROCEDURE LEE_CONFIGURACION('INVENTARIO', 'ENSAMBLES', 'FORMACIONES CON CANTIDADES TOTALES') returning_values (:CANTOT);
    if (CANTOT <> 'SI') then
        CANT = CANT * factor * new.dede_cant;
    ELSE
        CANT = factor * new.dede_cant;
    INSERT INTO MOVIMIENTO_ARTICULO
      (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM)
      VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 16, NEW.dese_id,
      :CONC, :CANT, :COSTO, 'S', new.dede_lote, :Pref, :Num, new.dese_item);
    END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER TRIGGER DESENSAMBLES_DETALLE_AU
AS
declare variable fec date;
declare variable CONC VARCHAR(60);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable factor numeric(18,4);
declare variable COSTO numeric(18,2);
declare variable CANT NUMERIC(18,2);
declare variable CANTOT CHAR(2);
BEGIN
/* Anule el anterior */
if ((OLD.DESE_ID <> 0) AND (OLD.dede_anulado = 'N')) then
    delete from movimiento_articulo where (mvar_tipodoc = 16) and (mvar_idref = old.DESE_id) and (mvar_item = old.dese_item);
if ((NEW.dese_id <> 0) AND (new.dede_anulado = 'N')) then
    BEGIN
    EXECUTE PROCEDURE LEE_CONFIGURACION('INVENTARIO', 'ENSAMBLES', 'FORMACIONES CON CANTIDADES TOTALES') returning_values (:CANTOT);
    select dese_fecha, dese_conc, pref_pre, dese_numero, dese_cant * dese_factor from desensambles where dese_id = new.dese_id into :fec, :conc, :Pref, :Num, :CANT;
    execute procedure factor_unidad_cant(new.arti_cod, new.dede_unidad) returning_values(factor);
    execute procedure costo_promedio(new.arti_cod, :FEC) returning_values (:COSTO);
    if (CANTOT <> 'SI') then
        CANT = CANT * factor * new.dede_cant;
    ELSE
        CANT = factor * new.dede_cant;
    INSERT INTO MOVIMIENTO_ARTICULO
        (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM)
        VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 16, NEW.dese_id,
        :CONC, :CANT, :COSTO, 'S', new.dede_lote, :Pref, :Num, new.dese_item);
    END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER TRIGGER DEVOLUCIONES_VENTAS_DETALLE_AI
AS
declare variable fec date;
declare variable CONC VARCHAR(60);
declare variable factor numeric(18,4);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Nit varchar(20);
declare variable ID INTEGER;
declare variable ITEM INTEGER;
declare variable DEVUELTO NUMERIC(18,4);
declare variable CANT NUMERIC(18, 4);
declare variable CANTAUX NUMERIC(18, 4);
declare variable CNTFAC NUMERIC(18, 4);
declare variable FACT VARCHAR(10);
declare variable COSTO NUMERIC(18,2);
declare variable devnof CHAR(2);
declare variable numrows INTEGER;
declare variable OK CHAR(1);
declare variable PEDAUTO CHAR(2);
declare variable IDPED INTEGER;
declare variable IDREM INTEGER;
declare variable devrem CHAR(2);
BEGIN
execute procedure lee_configuracion ('FACTURACION', 'DEVOLUCIONES', 'HACER DEVOLUCIONES SOBRE REMISIONES') returning_values (:devrem);
if ((NEW.devt_id <> 0) and (new.dvde_anulado = 'N')) then
    BEGIN
    ID = 0;
    select devt_fecha, pref_pre, devt_numero, terc_nit, devt_factura, devt_remid, DEVT_FACTID 
        from devoluciones_ventas where devt_id = new.devt_id into :fec, :Pref, :Num, :Nit, :Fact, :idrem, :ID;
    execute procedure factor_unidad_cant(new.arti_cod, new.dvde_unidad) returning_values(factor);
    CONC = 'DEVOLUCION VENTA No.' || PREF || NUM || ' - FACTURA ' || FACT;
    /* si la factura afecto el inventario, afectelo */
    execute procedure lee_configuracion ('FACTURACION', 'DEVOLUCIONES', 'PERMITIR DEVOLVER ITEMS NO FACTURADOS') returning_values (:devnof);
    if (devnof = 'SI') then
        OK = 'S';
    else
        BEGIN
        if (id <> 0) then
            begin
            SELECT SUM(FADE_CANT * FADE_FACTOR) FROM FACTURAS_DETALLE WHERE FACT_ID = :ID AND ARTI_COD = NEW.arti_cod INTO :cntfac;
            /* verifique si afecto el inventario */
            select count(mvar_cons) from movimiento_articulo where mvar_tipodoc = 31 and mvar_idref = :id and arti_cod = new.arti_cod into :numrows;
            if (numrows > 0) then
                OK = 'S';
            else
                BEGIN
                /* busque remisiones que pudieron afectarlo */
                /* primero posteriores a la factura */
                select sum(cofa_cant * cofa_factor) from consolidado_faltantes where cofa_tipoori = 31 and cofa_idori = :id and cofa_tipodes = 32 and arti_cod = new.arti_cod and cofa_ok = 'S' into :cantaux;
                if ((cantaux <> 0) and (cantaux is not null)) then
                    BEGIN
                    if ((CNTFAC - (NEW.dvde_cant * NEW.dvde_factor)) <> CANTAUX) then
                        OK = 'S';
                    ELSE
                        OK = 'N';
                    END
                else
                    begin
                    /* si no, anteriores a la factura */
                    select sum(cofa_cant * cofa_factor) from consolidado_faltantes C, FACTURAS f where f.fact_consolida = c.cofa_id and cofa_tipoori = 32 and f.fact_id = :id and cofa_tipodes = 31 and arti_cod = new.arti_cod and cofa_ok = 'S' into :cantaux;
                    if ((cantaux <> 0) and (cantaux is not null)) then
                        OK = 'S';
                    else
                        BEGIN
                        /* si hacen pedido automatico, puede que la remisin este hecha con el pedido */
                        EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','FACTURAS','GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') RETURNING_VALUES (PEDAUTO);
                        if (PEDAUTO = 'SI') then
                            BEGIN
                            SELECT PEDI_ID FROM PEDIDOS P, FACTURAS F WHERE P.PREF_PRE = F.pref_pre AND P.pedi_numero = F.fact_numero AND F.fact_id = :id INTO :IDped;
                            select sum(cofa_cant * cofa_factor) from consolidado_faltantes where cofa_tipoori = 34 and cofa_idori = :idped and cofa_tipodes = 32 and arti_cod = new.arti_cod and cofa_ok = 'S' into :cantaux;
                            if ((cantaux <> 0) and (cantaux is not null)) then
                                if ((CNTFAC - (NEW.dvde_cant * NEW.dvde_factor)) <> CANTAUX) then
                                    OK = 'S';
                                else
                                    OK = 'N';
                            else
                                OK = 'N';
                            END
                        ELSE
                            OK = 'N';
                        END
                    end
                END
            end
        else
          if ((idrem <> 0) and (devrem = 'SI')) then
            begin
            /* verifique si afecto el inventario */
            select count(mvar_cons) from movimiento_articulo where mvar_tipodoc = 32 and mvar_idref = :idrem and arti_cod = new.arti_cod into :numrows;
            if (numrows > 0) then
                OK = 'S';
            else
                OK = 'N';
            end
        END
    if (OK = 'S') then
        begin
        /* calcule el costo al que salio o el promedio */
        execute procedure costo_promedio(new.arti_cod, :FEC) returning_values (:COSTO);
        INSERT INTO MOVIMIENTO_ARTICULO
            (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF,
            MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
            VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 33, NEW.devt_id,
            :CONC, :factor * new.dvde_cant, :COSTO, 'S', new.dvde_lote, :Pref, :Num, new.dvde_item, :Nit);
        end
    /* ACTUALICE LO DEVUELTO EN LA FACTURA */
    if (ID <> 0) then
        BEGIN
        CANTAUX = NEW.dvde_cant * NEW.dvde_factor;
        FOR SELECT FADE_ITEM, FADE_CANT, FADE_FACTOR, FADE_DEVUELTO
            FROM FACTURAS_DETALLE
            WHERE FACT_ID = :ID AND ARTI_COD = NEW.ARTI_COD
            INTO :ITEM, :CANT, :FACTOR, :DEVUELTO
            DO
                BEGIN
                if (CANTAUX > 0) then
                    if ((CANT * FACTOR - DEVUELTO) < CANTAUX) then
                      BEGIN
                      UPDATE FACTURAS_DETALLE
                        SET FADE_DEVUELTO = (:CANT * :FACTOR)
                        WHERE FACT_ID = :ID AND FADE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                      CANTAUX = CANTAUX - (CANT * FACTOR - DEVUELTO);
                      END
                    ELSE
                      BEGIN
                      UPDATE FACTURAS_DETALLE
                        SET FADE_DEVUELTO = FADE_DEVUELTO + :CANTAUX
                        WHERE FACT_ID = :ID AND FADE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                      CANTAUX = 0;
                      END
                END
        if (CANTAUX > 0) then
            EXCEPTION DEVOLUCION_MAYOR 'Esta devolviendo una cantidad mayor a la facturada del articulo ' || new.arti_cod;
        END
    if ((idrem <> 0) and (devrem = 'SI')) then
        BEGIN
        CANTAUX = NEW.dvde_cant * NEW.dvde_factor;
        FOR SELECT RVDE_ITEM, RVDE_CANT, RVDE_FACTOR, RVDE_DEVUELTO
            FROM remisiones_venta_detalle
            WHERE REVT_ID = :idrem AND ARTI_COD = NEW.ARTI_COD
            INTO :ITEM, :CANT, :FACTOR, :DEVUELTO
            DO
                BEGIN
                if (CANTAUX > 0) then
                    if ((CANT * FACTOR - DEVUELTO) < CANTAUX) then
                      BEGIN
                      UPDATE remisiones_venta_detalle
                        SET RVDE_DEVUELTO = (:CANT * :FACTOR)
                        WHERE REVT_ID = :IDREM AND RVDE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                      CANTAUX = CANTAUX - (CANT * FACTOR - DEVUELTO);
                      END
                    ELSE
                      BEGIN
                      UPDATE remisiones_venta_detalle
                        SET RVDE_DEVUELTO = RVDE_DEVUELTO + :CANTAUX
                        WHERE REVT_ID = :IDREM AND RVDE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                      CANTAUX = 0;
                      END
                END
        if (CANTAUX > 0) then
            EXCEPTION DEVOLUCION_MAYOR 'Esta devolviendo una cantidad mayor a la remisionada del articulo ' || new.arti_cod;
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER TRIGGER DEVOLUCIONES_VENTAS_DETALLE_AU
AS
declare variable fec date;
declare variable CONC VARCHAR(60);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Nit varchar(20);
declare variable CANT NUMERIC(18, 4);
declare variable CANTAUX NUMERIC(18,4);
declare variable CNTFAC NUMERIC(18, 4);
declare variable COSTO NUMERIC(18,2);
declare variable factor numeric(18,4);
declare variable DEVUELTO NUMERIC(18,4);
declare variable ID integer;
declare variable ITEM INTEGER;
declare variable FACT varchar(10);
declare variable devnof CHAR(2);
declare variable numrows INTEGER;
declare variable OK CHAR(1);
declare variable PEDAUTO CHAR(2);
declare variable IDPED INTEGER;
declare variable IDREM INTEGER;
declare variable devrem CHAR(2);
BEGIN
execute procedure lee_configuracion ('FACTURACION', 'DEVOLUCIONES', 'HACER DEVOLUCIONES SOBRE REMISIONES') returning_values (:devrem);
/* Anule el anterior */
if ((OLD.DEVT_ID <> 0) AND (OLD.dvde_anulado = 'N')) then
    BEGIN
    DELETE FROM MOVIMIENTO_ARTICULO WHERE (mvar_tipodoc = 33) and (mvar_idref = new.devt_id) and (mvar_item = old.dvde_item);
    /* DESHAGA LO DEVUELTO EN LA FACTURA */
    ID = 0;
    SELECT DEVT_FACTID FROM DEVOLUCIONES_VENTAS
        WHERE DEVT_ID = OLD.DEVT_ID INTO :ID;
    if (ID <> 0) then
        BEGIN
        CANTAUX = OLD.dvde_cant * OLD.dvde_factor;
        FOR SELECT FADE_CANT, FADE_FACTOR, FADE_DEVUELTO, FADE_ITEM
            FROM FACTURAS_DETALLE
            WHERE FACT_ID = :ID AND ARTI_COD = OLD.ARTI_COD
            INTO :CANT, :FACTOR, :DEVUELTO, :ITEM
            DO
            BEGIN
            if (CANTAUX > (CANT * FACTOR - DEVUELTO)) then
                BEGIN
                UPDATE FACTURAS_DETALLE
                    SET FADE_DEVUELTO = 0
                    WHERE FACT_ID = :ID AND ARTI_COD = OLD.ARTI_COD AND FADE_ITEM = :ITEM;
                CANTAUX = CANTAUX - (CANT * FACTOR - DEVUELTO);
                END
            ELSE
                BEGIN
                UPDATE FACTURAS_DETALLE
                    SET FADE_DEVUELTO = FADE_DEVUELTO - :CANTAUX
                    WHERE FACT_ID = :ID AND ARTI_COD = OLD.ARTI_COD AND FADE_ITEM = :ITEM;
                CANTAUX = 0;
                END
            END
        END
    if (devrem = 'SI') then
        begin
        idrem = 0;
        SELECT DEVT_REMID FROM DEVOLUCIONES_VENTAS
            WHERE DEVT_ID = OLD.DEVT_ID INTO :idrem;
        if (idrem <> 0) then
            BEGIN
            CANTAUX = OLD.dvde_cant * OLD.dvde_factor;
            FOR SELECT RVDE_CANT, RVDE_FACTOR, RVDE_DEVUELTO, RVDE_ITEM
                FROM remisiones_venta_detalle
                WHERE REVT_ID = :idrem AND ARTI_COD = OLD.ARTI_COD
                INTO :CANT, :FACTOR, :DEVUELTO, :ITEM
                DO
                BEGIN
                if (CANTAUX > (CANT * FACTOR - DEVUELTO)) then
                    BEGIN
                    UPDATE remisiones_venta_detalle
                        SET RVDE_DEVUELTO = 0
                        WHERE REVT_ID = :idrem AND ARTI_COD = OLD.ARTI_COD AND RVDE_ITEM = :ITEM;
                    CANTAUX = CANTAUX - (CANT * FACTOR - DEVUELTO);
                    END
                ELSE
                    BEGIN
                    UPDATE remisiones_venta_detalle
                        SET RVDE_DEVUELTO = RVDE_DEVUELTO - :CANTAUX
                        WHERE REVT_ID = :idrem AND ARTI_COD = OLD.ARTI_COD AND RVDE_ITEM = :ITEM;
                    CANTAUX = 0;
                    END
                END
            END
        end
    END
/* Registre el nuevo */
if ((NEW.DEVT_ID <> 0) AND (NEW.dvde_anulado = 'N')) then
    begin
    ID = 0;
    select devt_fecha, pref_pre, devt_numero, terc_nit, devt_factura, devt_remid, DEVT_FACTID 
        from devoluciones_ventas where devt_id = new.devt_id into :fec, :Pref, :Num, :Nit, :Fact, :idrem, :ID;
    execute procedure factor_unidad_cant(new.arti_cod, new.dvde_unidad) returning_values(factor);
    CONC = 'DEVOLUCION VENTA No.' || PREF || NUM || '- FACTURA ' || FACT;
    execute procedure lee_configuracion ('FACTURACION', 'DEVOLUCIONES', 'PERMITIR DEVOLVER ITEMS NO FACTURADOS') returning_values (:devnof);
    if (devnof = 'SI') then
        OK = 'S';
    else
        if (id <> 0) then
            begin
            SELECT SUM(FADE_CANT * FADE_FACTOR) FROM FACTURAS_DETALLE WHERE FACT_ID = :ID AND ARTI_COD = NEW.arti_cod INTO :cntfac;
            /* verifique si afecto el inventario */
            select count(mvar_cons) from movimiento_articulo where mvar_tipodoc = 31 and mvar_idref = :id and arti_cod = new.arti_cod into :numrows;
            if (numrows > 0) then
                OK = 'S';
            else
                BEGIN
                /* busque remisiones que pudieron afectarlo */
                /* primero posteriores a la factura */
                select sum(cofa_cant * cofa_factor) from consolidado_faltantes where cofa_tipoori = 31 and cofa_idori = :id and cofa_tipodes = 32 and arti_cod = new.arti_cod and cofa_ok = 'S' into :cantaux;
                if ((cantaux <> 0) and (cantaux is not null)) then
                    BEGIN
                    if ((CNTFAC - (NEW.dvde_cant * NEW.dvde_factor)) <> CANTAUX) then
                        OK = 'S';
                    ELSE
                        OK = 'N';
                    END
                else
                    begin
                    /* si no, anteriores a la factura */
                    select sum(cofa_cant * cofa_factor) from consolidado_faltantes C, FACTURAS f where f.fact_consolida = c.cofa_id and cofa_tipoori = 32 and f.fact_id = :id and cofa_tipodes = 31 and arti_cod = new.arti_cod and cofa_ok = 'S' into :cantaux;
                    if ((cantaux <> 0) and (cantaux is not null)) then
                        OK = 'S';
                    else
                        BEGIN
                        /* si hacen pedido automatico, puede que la remisin este hecha con el pedido */
                        EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','FACTURAS','GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') RETURNING_VALUES (PEDAUTO);
                        if (PEDAUTO = 'SI') then
                            BEGIN
                            SELECT PEDI_ID FROM PEDIDOS P, FACTURAS F WHERE P.PREF_PRE = F.pref_pre AND P.pedi_numero = F.fact_numero AND F.fact_id = :id INTO :IDped;
                            select sum(cofa_cant * cofa_factor) from consolidado_faltantes where cofa_tipoori = 34 and cofa_idori = :idped and cofa_tipodes = 32 and arti_cod = new.arti_cod and cofa_ok = 'S' into :cantaux;
                            if ((cantaux <> 0) and (cantaux is not null)) then
                                if ((CNTFAC - (NEW.dvde_cant * NEW.dvde_factor)) <> CANTAUX) then
                                    OK = 'S';
                                else
                                    OK = 'N';
                            else
                                OK = 'N';
                            END
                        ELSE
                            OK = 'N';
                        END
                    end
                END
            end
        else
          if ((idrem <> 0) and (devrem = 'SI')) then
            begin
            /* verifique si afecto el inventario */
            select count(mvar_cons) from movimiento_articulo where mvar_tipodoc = 32 and mvar_idref = :idrem and arti_cod = new.arti_cod into :numrows;
            if (numrows > 0) then
                OK = 'S';
            else
                OK = 'N';
            end
    if (OK = 'S') then
        begin
        /* calcule el costo al que salio o el promedio */
        execute procedure costo_promedio(new.arti_cod, :FEC) returning_values (:COSTO);
        INSERT INTO MOVIMIENTO_ARTICULO
            (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF,
            MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
            VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 33, NEW.devt_id,
            :CONC, :factor * new.dvde_cant, :COSTO, 'S', new.dvde_lote, :Pref, :Num, new.dvde_item, :Nit);
        end
    /* ACTUALICE LO DEVUELTO EN LA FACTURA */
    if (ID <> 0) then
        BEGIN
        CANTAUX = NEW.dvde_cant * NEW.dvde_factor;
        FOR SELECT FADE_ITEM, FADE_CANT, FADE_FACTOR, FADE_DEVUELTO
            FROM FACTURAS_DETALLE
            WHERE FACT_ID = :ID AND ARTI_COD = NEW.ARTI_COD
            INTO :ITEM, :CANT, :FACTOR, :DEVUELTO
            DO
            BEGIN
            if (CANTAUX > 0) then
                if ((CANT * FACTOR - DEVUELTO) < CANTAUX) then
                    BEGIN
                    UPDATE FACTURAS_DETALLE
                        SET FADE_DEVUELTO = (:CANT * :FACTOR - :DEVUELTO)
                        WHERE FACT_ID = :ID AND FADE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                    CANTAUX = CANTAUX - (CANT * FACTOR - DEVUELTO);
                    END
                ELSE
                    BEGIN
                    UPDATE FACTURAS_DETALLE
                        SET FADE_DEVUELTO = FADE_DEVUELTO + :CANTAUX
                        WHERE FACT_ID = :ID AND FADE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                    CANTAUX = 0;
                    END
            END
        if (CANTAUX > 0) then
            EXCEPTION DEVOLUCION_MAYOR 'Esta devolviendo una cantidad mayor a la facturada del articulo ' || new.arti_cod;
        END
    if ((idrem <> 0) and (devrem = 'SI')) then
        BEGIN
        CANTAUX = NEW.dvde_cant * NEW.dvde_factor;
        FOR SELECT RVDE_ITEM, RVDE_CANT, RVDE_FACTOR, RVDE_DEVUELTO
            FROM remisiones_venta_detalle
            WHERE REVT_ID = :idrem AND ARTI_COD = NEW.ARTI_COD
            INTO :ITEM, :CANT, :FACTOR, :DEVUELTO
            DO
                BEGIN
                if (CANTAUX > 0) then
                    if ((CANT * FACTOR - DEVUELTO) < CANTAUX) then
                      BEGIN
                      UPDATE remisiones_venta_detalle
                        SET RVDE_DEVUELTO = (:CANT * :FACTOR - :DEVUELTO)
                        WHERE REVT_ID = :ID AND RVDE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                      CANTAUX = CANTAUX - (CANT * FACTOR - DEVUELTO);
                      END
                    ELSE
                      BEGIN
                      UPDATE remisiones_venta_detalle
                        SET RVDE_DEVUELTO = RVDE_DEVUELTO + :CANTAUX
                        WHERE REVT_ID = :ID AND RVDE_ITEM = :ITEM AND ARTI_COD = NEW.ARTI_COD;
                      CANTAUX = 0;
                      END
                END
        if (CANTAUX > 0) then
            EXCEPTION DEVOLUCION_MAYOR 'Esta devolviendo una cantidad mayor a la remisionada del articulo ' || new.arti_cod;
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER TRIGGER NOTAS_CREDITO_PROVEEDOR_AI
AS
declare variable COSTO NUMERIC(18,2);
declare variable EXISTENCIA NUMERIC(18,4);
declare variable CODBOD VARCHAR(3);
BEGIN
if ((NEW.NCPR_ID <> 0) and (new.ncpr_anulado = 'N')) then
    BEGIN
    /* Registre el nuevo saldo del documento */
    INSERT INTO SALDOS_DOC_CXPAGAR (SDCP_TIPOREF, SDCP_IDREF, SDCP_FECHA, TERC_NIT, SDCP_RTEFTE, SDCP_RTIVA, SDCP_RTICA, SDCP_ABONO, SDCP_ABRTFTE, SDCP_ABRTIVA, SDCP_ABRTICA, SDCP_DEBITO, SDCP_MONTO)
        VALUES (52, NEW.NCPR_ID, NEW.ncpr_fecha, NEW.terc_nit, (NEW.ncpr_rtftemonto * -1), (NEW.ncpr_rtivamonto * -1), (NEW.ncpr_rticamonto * -1), 0, 0, 0, 0, 'N', (NEW.ncpr_monto+NEW.ncpr_ivamonto)*-1);
    /* Registre el movimiento del proveedor */
    INSERT INTO MOVIMIENTO_PROVEEDOR (MVPR_ID, TERC_NIT, MVPR_TIPOREF, MVPR_IDREF, MVPR_FECHA, MVPR_VENCE, MVPR_CONC, MVPR_MONTO, MVPR_RTFTE, MVPR_RTIVA, MVPR_RTICA, MVPR_DEBITO, MVPR_ABONO, MVPR_PREFIJO, MVPR_NUMERO)
      VALUES (GEN_ID(ID_MOVPROV, 1), NEW.TERC_NIT, 52, NEW.NCPR_ID, NEW.NCPR_FECHA, NEW.NCPR_FECHA, NEW.NCPR_CONC, NEW.NCPR_MONTO+NEW.NCPR_IVAMONTO, NEW.NCPR_RTFTEMONTO, NEW.NCPR_RTIVAMONTO, NEW.NCPR_RTICAMONTO, 'N', 'N', NEW.pref_pre, NEW.ncpr_numero);
    /* afecte el articulo */
    if (new.arti_cod <> '') then
        begin
        /* CALCULE EL NUEVO COSTO */
        execute procedure costo_promedio (new.arti_cod, new.ncpr_fecha) returning_values (:COSTO);
        execute procedure saldo_total_inventario (new.arti_cod, new.ncpr_fecha) returning_values (:EXISTENCIA);
        COSTO = (COSTO * EXISTENCIA - (NEW.ncpr_monto - NEW.ncpr_ivamonto)) / EXISTENCIA;
        FOR SELECT DISTINCT BODE_COD FROM EXISTENCIA WHERE ARTI_COD = NEW.ARTI_COD INTO :CODBOD do
            BEGIN
            execute procedure saldo_inventario (new.arti_cod, :CODBOD, new.ncpr_fecha) returning_values (:EXISTENCIA);
            /* SAQUE TODO LO QUE TENGA */
            INSERT INTO MOVIMIENTO_ARTICULO
              (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
              VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), :CODBOD, new.ncpr_fecha, 52, NEW.ncpr_id,
              new.ncpr_conc, :EXISTENCIA, 0, 'N', '', new.pref_pre, new.ncpr_numero, 1, new.terc_nit);
            /* META TODO CON EL NUEVO COSTO */
            INSERT INTO MOVIMIENTO_ARTICULO
              (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
              VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), :CODBOD, new.ncpr_fecha, 52, NEW.ncpr_id,
              new.ncpr_conc, :EXISTENCIA, :COSTO, 'S', '', new.pref_pre, new.ncpr_numero, 1, new.terc_nit);
            END
        /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
        EXECUTE PROCEDURE CALCULA_PRECIOS(NEW.ARTI_COD, new.ncpr_fecha);
        end
    INSERT INTO AUDITORIA(AUDI_USUARIO, TIDO_COD, AUDI_IDDOC, AUDI_OPER, AUDI_COD)
        VALUES (USER, 52, NEW.ncpr_id, 'I', NEW.pref_pre || NEW.ncpr_numero);
    END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER TRIGGER NOTAS_CREDITO_PROVEEDOR_AU
AS
declare variable ABONOS char(1);
declare variable consec INTEGER;
declare variable COSTO NUMERIC(18,2);
declare variable EXISTENCIA NUMERIC(18,4);
declare variable CODBOD VARCHAR(3);
BEGIN
if (new.ncpr_anulado = 'S') then
    begin
    select enco_consec from comprobante_encabezado where enco_tiporef = 52 and enco_idref = old.ncpr_id into :consec;
    if (NOT consec is null) then
      delete from comprobante_detalle where enco_consec = :consec;
    delete from comprobante_encabezado where enco_tiporef = 52 and enco_idref = old.ncpr_id;
    INSERT INTO AUDITORIA (AUDI_USUARIO, TIDO_COD, AUDI_IDDOC, AUDI_OPER, AUDI_COD)
        VALUES (USER, 52, new.ncpr_id, 'A', NEW.pref_pre || NEW.ncpr_numero);
    end

/* BORRE EL REGISTRO PREVIO */
if ((old.ncpr_id <> 0) and (old.ncpr_anulado = 'N')) then
    begin
    /* Verifique si habia abonos a la nota */
    ABONOS = 'N';
    select 'S' FROM SALDOS_DOC_CXPAGAR WHERE SDCP_TIPOREF = 52 AND SDCP_IDREF = OLD.NCPR_ID AND SDCP_ABONO <> 0 INTO :ABONOS;
    if (ABONOS = 'N') then
        BEGIN
        /* BORRE EL REGISTRO PREVIO */
        delete from saldos_doc_cxpagar where sdcp_tiporef = 52 and sdcp_idref = old.ncpr_id;
        delete from movimiento_PROVEEDOR where (mvpr_tiporef = 52) and (mvpr_idref = old.ncpr_id);
        delete from movimiento_articulo where  (mvar_tipodoc = 52) and (mvar_idref = old.ncpr_id);
        END
    else
        exception DOCUMENTO_CON_ABONOS;
    end
if ((new.ncpr_id <> 0) and (new.ncpr_anulado = 'N')) then
    begin
    /* Registre el nuevo saldo del documento */
    INSERT INTO SALDOS_DOC_CXPAGAR (SDCP_TIPOREF, SDCP_IDREF, SDCP_FECHA, TERC_NIT, SDCP_RTEFTE, SDCP_RTIVA, SDCP_RTICA, SDCP_ABONO, SDCP_ABRTFTE, SDCP_ABRTIVA, SDCP_ABRTICA, SDCP_DEBITO, SDCP_MONTO)
        VALUES (52, NEW.NCPR_ID, NEW.ncpr_fecha, NEW.terc_nit, (NEW.ncpr_rtftemonto * -1), (NEW.ncpr_rtivamonto * -1), (NEW.ncpr_rticamonto * -1), 0, 0, 0, 0, 'N', (NEW.ncpr_monto+NEW.ncpr_ivamonto)*-1);
    /* Registre el movimiento del proveedor */
    INSERT INTO MOVIMIENTO_PROVEEDOR (MVPR_ID, TERC_NIT, MVPR_TIPOREF, MVPR_IDREF, MVPR_FECHA, MVPR_VENCE, MVPR_CONC, MVPR_MONTO, MVPR_RTFTE, MVPR_RTIVA, MVPR_RTICA, MVPR_DEBITO, MVPR_ABONO, MVPR_PREFIJO, MVPR_NUMERO)
        VALUES (GEN_ID(ID_MOVPROV, 1), NEW.TERC_NIT, 52, NEW.NCPR_ID, NEW.NCPR_FECHA, NEW.NCPR_FECHA, NEW.NCPR_CONC, NEW.NCPR_MONTO+NEW.ncpr_ivamonto, NEW.NCPR_RTFTEMONTO, NEW.NCPR_RTIVAMONTO, NEW.NCPR_RTICAMONTO, 'N', 'N', NEW.pref_pre, NEW.ncpr_numero);
    /* afecte el articulo */
    if (new.arti_cod <> '') then
        begin
        /* CALCULE EL NUEVO COSTO */
        execute procedure costo_promedio (new.arti_cod, new.ncpr_fecha) returning_values (:COSTO);
        execute procedure saldo_total_inventario (new.arti_cod, new.ncpr_fecha) returning_values (:EXISTENCIA);
        COSTO = (COSTO * EXISTENCIA - (NEW.ncpr_monto - NEW.ncpr_ivamonto)) / EXISTENCIA;
        FOR SELECT DISTINCT BODE_COD FROM EXISTENCIA WHERE ARTI_COD = NEW.ARTI_COD INTO :CODBOD do
            BEGIN
            execute procedure saldo_inventario (new.arti_cod, :CODBOD, new.ncpr_fecha) returning_values (:EXISTENCIA);
            /* SAQUE TODO LO QUE TENGA */
            INSERT INTO MOVIMIENTO_ARTICULO
                (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
                VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), :CODBOD, new.ncpr_fecha, 52, NEW.ncpr_id,
                new.ncpr_conc, :EXISTENCIA, 0, 'N', '', new.pref_pre, new.ncpr_numero, 1, new.terc_nit);
            /* META TODO CON EL NUEVO COSTO */
            INSERT INTO MOVIMIENTO_ARTICULO
                (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
                VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), :CODBOD, new.ncpr_fecha, 52, NEW.ncpr_id,
                new.ncpr_conc, :EXISTENCIA, :COSTO, 'S', '', new.pref_pre, new.ncpr_numero, 1, new.terc_nit);
            END
        /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
        EXECUTE PROCEDURE CALCULA_PRECIOS(NEW.ARTI_COD, new.ncpr_fecha);
        end
    INSERT INTO AUDITORIA(AUDI_USUARIO, TIDO_COD, AUDI_IDDOC, AUDI_OPER, AUDI_COD)
        VALUES (USER, 52, NEW.ncpr_id, 'U', NEW.pref_pre || NEW.ncpr_numero);
    end
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER TRIGGER PRECIOS_ARTICULO_BI
AS
declare variable UNIDAD VARCHAR(8);
declare variable UOR VARCHAR(20);
declare variable COSTOP NUMERIC(18, 2);
declare variable COSTOU NUMERIC(18, 2);
declare variable COSTO NUMERIC(18, 2);
declare variable DIG INTEGER;
declare variable IVAINC CHAR(1);
declare variable IVAINC1 CHAR(1);
declare variable TARIVA NUMERIC(9,2);
declare variable BASE varchar(10);
declare variable CAMBIO CHAR(7);
declare variable LISTA INTEGER;
declare variable PRECIO NUMERIC(18, 4);
BEGIN
if (NEW.prar_util IS NULL) then
    NEW.prar_util = 0;
if (NEW.prar_margen IS NULL) then
    NEW.prar_margen = 0;
if (NEW.prar_cantmin IS NULL) then
    NEW.prar_cantmin = 0.01;
if (NEW.prar_auto = 'S') then
    BEGIN
    SELECT LIPR_MODIF FROM LISTA_PRECIOS L
        WHERE LIPR_COD = NEW.LIPR_COD INTO :IVAINC;
    
    SELECT ARTI_UNIDAD, TAIV_PORC FROM ARTICULO A, TARIFA_IVA T
        WHERE ARTI_COD = NEW.ARTI_COD AND A.taiv_cod = T.taiv_cod INTO :UNIDAD, :TARIVA;
    EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'ARTICULOS', 'SUGERIR PRECIOS CON PORCENTAJE DE MARGEN O UTILIDAD') RETURNING_VALUES (:UOR);
    EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'ARTICULOS', 'REDONDEO AL MULTIPLO DE DIEZ EN PRECIOS') RETURNING_VALUES (:DIG);
    EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','CAMBIO DE PRECIOS AUTOMATICO AL CAMBIAR COSTO O PRECIO') returning_values (CAMBIO);
    if (CAMBIO <> 'PRECIO') then
        BEGIN
        EXECUTE PROCEDURE lee_configuracion('FACTURACION','ARTICULOS','COSTO BASE PARA CALCULO DE PRECIOS DE VENTA AUTOMATICOS') returning_values (:BASE);
        EXECUTE PROCEDURE COSTO_PROMEDIO (NEW.ARTI_COD, 'NOW') RETURNING_VALUES(:COSTOP);
        EXECUTE PROCEDURE ULTIMO_COSTO (NEW.ARTI_COD, 'NOW', :UNIDAD) RETURNING_VALUES(:COSTOU);
        if (base = 'ULTIMO') then
            BEGIN
            COSTO = COSTOU;
            END
        ELSE
            BEGIN
            COSTO = COSTOP;
            if (base = 'MAYOR') then
                if (COSTOP < COSTOU) then
                    COSTO = COSTOU;
            END
        if (IVAINC = 'S') then
            COSTO = COSTO * (1 + TARIVA/100);
        if (UOR = 'UTILIDAD') then
            NEW.PRAR_FIJO = (:COSTO * (1 + NEW.prar_util/100));
        ELSE
            NEW.PRAR_FIJO = (:COSTO / (1 - NEW.prar_margen/100));
        END
    ELSE
        BEGIN
        /* PRECIO */
        EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','CODIGO DE LA LISTA DE PRECIOS BASE PARA CAMBIO DE PRECIOS AUTOMATICO') returning_values (LISTA);
        if (NEW.lipr_cod <> :LISTA) then
            BEGIN
            SELECT PRAR_FIJO FROM PRECIOS_ARTICULO WHERE LIPR_COD = :LISTA AND ARTI_COD = NEW.arti_cod INTO :PRECIO;
            SELECT LIPR_MODIF FROM LISTA_PRECIOS L
                WHERE LIPR_COD = :lista INTO :IVAINC1;
            if (ivainc = 'S') then
                if (IVAINC1 = 'S') then
                    NEW.prar_fijo = precio;
                else
                    NEW.prar_fijo = precio * (1 + TARIVA/100);
            ELSE
                if (IVAINC1 = 'S') then
                    NEW.prar_fijo = precio / (1 + TARIVA/100);
                else
                    NEW.prar_fijo = precio;
            if (UOR = 'UTILIDAD') then
                NEW.prar_fijo = NEW.prar_fijo * (1 + NEW.prar_util/100);
            ELSE
                NEW.prar_fijo = NEW.prar_fijo / (1 - NEW.prar_margen/100);
            EXECUTE PROCEDURE REDONDEE (NEW.prar_fijo, DIG) returning_values (NEW.prar_fijo);
            END
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER TRIGGER PRECIOS_ARTICULO_BU
as
declare variable UNIDAD VARCHAR(8);
declare variable UOR VARCHAR(20);
declare variable DIG INTEGER;
declare variable IVAINC CHAR(1);
declare variable TARIVA NUMERIC(9,4);
declare variable CAMBIO CHAR(7);
declare variable BASE VARCHAR(10);
declare variable REP CHAR(2);
declare variable COSTOP NUMERIC(18, 2);
declare variable COSTOU NUMERIC(18, 2);
declare variable COSTO NUMERIC(18, 2);
declare variable LISTA INTEGER;
declare variable PRECIO NUMERIC(18, 4);
declare variable IVAINC1 CHAR(1);
begin
if (NEW.prar_auto = 'S') then
    BEGIN
    EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','CAMBIO DE PRECIOS AUTOMATICO AL CAMBIAR COSTO O PRECIO') returning_values (CAMBIO);
    EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'ARTICULOS', 'SUGERIR PRECIOS CON PORCENTAJE DE MARGEN O UTILIDAD') RETURNING_VALUES (:UOR);
    EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'ARTICULOS', 'REDONDEO AL MULTIPLO DE DIEZ EN PRECIOS') RETURNING_VALUES (:DIG);
    EXECUTE PROCEDURE LEE_CONFIGURACION('INVENTARIO', 'ARTICULOS', 'REPLICAR CAMBIOS EN ARTICULOS') RETURNING_VALUES (:REP);
    SELECT LIPR_MODIF FROM LISTA_PRECIOS L
        WHERE LIPR_COD = NEW.LIPR_COD INTO :IVAINC;
    
    if (CAMBIO <> 'PRECIO') then
      begin
      if (REP <> 'SI') then
        BEGIN
        SELECT ARTI_UNIDAD, TAIV_PORC FROM ARTICULO A, TARIFA_IVA T WHERE A.TAIV_COD = T.TAIV_COD AND ARTI_COD = NEW.arti_cod INTO :UNIDAD, :TARIVA;
        EXECUTE PROCEDURE lee_configuracion('FACTURACION','ARTICULOS','COSTO BASE PARA CALCULO DE PRECIOS DE VENTA AUTOMATICOS') returning_values (:BASE);
        EXECUTE PROCEDURE COSTO_PROMEDIO (NEW.arti_cod, 'NOW') RETURNING_VALUES(:COSTOP);
        EXECUTE PROCEDURE ULTIMO_COSTO (NEW.arti_cod, 'NOW', :UNIDAD) RETURNING_VALUES(:COSTOU);
        if (base = 'ULTIMO') then
            COSTO = COSTOU;
        ELSE
            BEGIN
            COSTO = COSTOP;
            if (base = 'MAYOR') then
                if (COSTOP < COSTOU) then
                    COSTO = COSTOU;
            END
        if (IVAINC = 'S') then
            COSTO = COSTO * (1 + TARIVA/100);
            
        if (UOR = 'UTILIDAD') then
            BEGIN
            COSTO = COSTO * (1 + NEW.prar_util/100);
            EXECUTE PROCEDURE REDONDEE (COSTO, DIG) returning_values (COSTO);
            new.prar_fijo = :COSTO;
            END
        ELSE
            BEGIN
            COSTO = COSTO / (1 - NEW.prar_margen/100);
            EXECUTE PROCEDURE REDONDEE (COSTO, DIG) returning_values (COSTO);
            NEW.PRAR_FIJO = :COSTO;
            END
        END
      end
    else
        begin
        /* PRECIO */
        EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','CODIGO DE LA LISTA DE PRECIOS BASE PARA CAMBIO DE PRECIOS AUTOMATICO') returning_values (LISTA);
        if (NEW.lipr_cod <> :LISTA) then
            BEGIN
            SELECT PRAR_FIJO FROM PRECIOS_ARTICULO WHERE LIPR_COD = :LISTA AND ARTI_COD = NEW.arti_cod INTO :PRECIO;
            SELECT LIPR_MODIF FROM LISTA_PRECIOS L
                WHERE LIPR_COD = :lista INTO :IVAINC1;
            if (ivainc = 'S') then
                if (IVAINC1 = 'S') then
                    NEW.prar_fijo = precio;
                else
                    NEW.prar_fijo = precio * (1 + TARIVA/100);
            ELSE
                if (IVAINC1 = 'S') then
                    NEW.prar_fijo = precio / (1 + TARIVA/100);
                else
                    NEW.prar_fijo = precio;
            if (UOR = 'UTILIDAD') then
                NEW.prar_fijo = NEW.prar_fijo * (1 + NEW.prar_util/100);
            ELSE
                NEW.prar_fijo = NEW.prar_fijo / (1 - NEW.prar_margen/100);
            EXECUTE PROCEDURE REDONDEE (NEW.prar_fijo, DIG) returning_values (NEW.prar_fijo);
            END
        end
    END
end
^

SET TERM ; ^

SET TERM ^ ;

ALTER TRIGGER MOVIMIENTO_ARTICULO_AD
AS
declare variable LOTE CHAR(1);
BEGIN
  /* INSERTE EL NUEVO LOTE */
  SELECT ARTI_EXIST
    FROM   ARTICULO
    WHERE  ARTICULO.ARTI_COD = OLD.ARTI_COD
    INTO :LOTE;
  /* BORRE LOS VIEJOS */
  if (old.mvar_tipodoc <> 13) then
      BEGIN
      EXECUTE PROCEDURE actualice_costo(old.arti_cod, old.mvar_fecha, old.mvar_costo, old.mvar_cant, old.mvar_entrada, 'S', OLD.mvar_cons, OLD.mvar_tipodoc);
      EXECUTE PROCEDURE chequeo_costos(old.arti_cod, old.mvar_fecha);
      END
  /* actualice existencias */
  if (old.mvar_entrada = 'S') then
    BEGIN
    execute procedure sume_existencia(old.arti_cod, old.bode_cod, old.mvar_fecha, old.mvar_cant, 'S');
    if (LOTE = 'L') then
        UPDATE LOTES
            set lote_saldo = lote_saldo - old.mvar_cant
            where (arti_cod = old.ARTI_COD) and (bode_cod = old.bode_cod) and (lote_nro = old.mvar_lote);
    END
  else
    BEGIN
    execute procedure reste_existencia(old.arti_cod, old.bode_cod, old.mvar_fecha, old.mvar_cant, 'S');
    if (LOTE = 'L') then
        UPDATE LOTES
            set lote_saldo = lote_saldo + old.mvar_cant
            where (arti_cod = old.ARTI_COD) and (bode_cod = old.bode_cod) and (lote_nro = old.mvar_lote);
    END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER TRIGGER MOVIMIENTO_ARTICULO_AI
AS
declare variable EXISTE CHAR(1);
declare variable LOTE CHAR(1);
BEGIN
  /* INSERTE EL NUEVO LOTE */
  SELECT ARTI_EXIST FROM ARTICULO WHERE ARTICULO.ARTI_COD = NEW.ARTI_COD INTO :LOTE;
  /* ACTUALICE COSTOS cuando no es transferencia */
  if (new.mvar_tipodoc <> 13) then
      BEGIN
      EXECUTE PROCEDURE actualice_costo(new.arti_cod, new.mvar_fecha, new.mvar_costo, new.mvar_cant, new.mvar_entrada, 'N', new.mvar_cons, new.mvar_tipodoc);
      EXECUTE PROCEDURE chequeo_costos(NEW.arti_cod, NEW.mvar_fecha);
      END
  /* actualice existencias */
  if (new.mvar_entrada = 'S') then
    BEGIN
    execute procedure sume_existencia(new.arti_cod, new.bode_cod, new.mvar_fecha, new.mvar_cant, 'N');
    if (LOTE = 'L') then
        BEGIN
        if (NEW.MVAR_LOTE IS NULL) then
            EXCEPTION LOTE_OBLIGATORIO 'Debe especificar un nmero de lote para el articulo ' || new.arti_cod;
        ELSE
         BEGIN
         EXISTE = 'N';
         SELECT 'S' FROM LOTES WHERE ARTI_COD = NEW.ARTI_COD AND BODE_COD = NEW.bode_cod AND LOTE_NRO = new.mvar_lote INTO :EXISTE;
         if (EXISTE = 'S') then
            UPDATE LOTES
             set lote_saldo = lote_saldo + new.mvar_cant
              where (arti_cod = NEW.ARTI_COD) and (BODE_COD = NEW.bode_cod) and (lote_nro = new.mvar_lote);
         ELSE
            INSERT INTO LOTES (ARTI_COD, BODE_COD, LOTE_NRO, LOTE_FECHA, LOTE_CANT, LOTE_COSTO, LOTE_SALDO)
                VALUES (NEW.ARTI_COD, NEW.bode_cod, NEW.mvar_lote, NEW.mvar_fecha, NEW.mvar_cant, NEW.mvar_costo, NEW.mvar_cant);
         END
        END
    END
  else
    BEGIN
    execute procedure reste_existencia(new.arti_cod, new.bode_cod, new.mvar_fecha, new.mvar_cant, 'N');
    /* ACTUALICE LA EXISTENCIA DEL LOTE */
    if (LOTE = 'L') then
    if (NEW.mvar_lote IS NULL) then
        EXCEPTION LOTE_NEGATIVO 'Debe indicar un nmero de lote para el artculo ' || new.arti_cod;
    ELSE
        BEGIN
        /* Actualice el saldo historico del lote */
        EXISTE = 'N';
        SELECT 'S' FROM EXISTENCIA_LOTE WHERE LOTE_NRO = NEW.MVAR_LOTE AND EXLO_FECHA = NEW.MVAR_FECHA AND ARTI_COD = NEW.arti_cod AND BODE_COD = NEW.bode_cod INTO :EXISTE;
        if (EXISTE = 'S') then
            BEGIN
            UPDATE EXISTENCIA_LOTE
                SET EXLO_SAL = EXLO_SAL + NEW.mvar_cant
                WHERE LOTE_NRO = NEW.MVAR_LOTE AND EXLO_FECHA = NEW.MVAR_FECHA AND ARTI_COD = NEW.ARTI_COD AND BODE_COD = NEW.bode_cod;
            END
        ELSE
            BEGIN
            INSERT INTO EXISTENCIA_LOTE (ARTI_COD, BODE_COD, LOTE_NRO, EXLO_FECHA, EXLO_SAL)
                VALUES (NEW.ARTI_COD, NEW.bode_cod, NEW.MVAR_LOTE, NEW.MVAR_FECHA, NEW.MVAR_CANT);
            END
        UPDATE LOTES
            set lote_saldo = lote_saldo - new.mvar_cant
            where (arti_cod = NEW.ARTI_COD) and (BODE_COD = NEW.bode_cod) and (lote_nro = new.mvar_lote);
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER TRIGGER ENTRADAS_DETALLE_AI
AS
declare variable fec date;
declare variable CONC VARCHAR(60);
declare variable factor numeric(18,4);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Nit varchar(20);
declare variable IVAINC CHAR(2);
declare variable COSTO NUMERIC(18,2);
BEGIN
  if ((NEW.entr_id <> 0) and (new.ende_anulado = 'N')) then
    BEGIN
    select entr_fecha, entr_conc, pref_pre, entr_numero, terc_nit, entr_imptos
        from entradas where entr_id = new.entr_id
        into :fec, :conc, :Pref, :Num, :Nit, :ivainc;
    execute procedure factor_unidad_cant(new.arti_cod, new.ende_unidad) returning_values(factor);
    COSTO = ((new.ende_costo - NEW.ende_dtomonto) / :factor);
    if (IVAINC = 'S') then
        COSTO = COSTO / (1 + NEW.ende_ivaporc/100);
    INSERT INTO MOVIMIENTO_ARTICULO
      (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
      VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 11, NEW.entr_id,
      :CONC, :factor * new.ende_cant, :costo, 'S', new.ende_lote, :Pref, :Num, new.ende_item, :Nit);
    /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
    EXECUTE PROCEDURE CALCULA_PRECIOS(NEW.ARTI_COD, :FEC);
    END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER TRIGGER ENTRADAS_DETALLE_AU
as
declare variable fec date;
declare variable CONC VARCHAR(60);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Nit varchar(20);
declare variable factor numeric(18,4);
declare variable IVAINC CHAR(2);
declare variable COSTO NUMERIC(18,2);
BEGIN
if ((OLD.entr_id <> 0) AND (OLD.ende_anulado = 'N')) then
    DELETE FROM MOVIMIENTO_ARTICULO WHERE (mvar_tipodoc = 11) and (mvar_idref = new.entr_id) and (mvar_item = old.ende_item);
if ((NEW.entr_id <> 0) AND (NEW.ende_anulado = 'N')) then
    begin
    select entr_fecha, entr_conc, pref_pre, entr_numero, terc_nit, entr_imptos
        from entradas where entr_id = new.entr_id
        into :fec, :conc, :Pref, :Num, :Nit, :ivainc;
    execute procedure factor_unidad_cant(new.arti_cod, new.ende_unidad) returning_values(factor);
    COSTO = ((new.ende_costo - NEW.ende_dtomonto) / :factor);
    if (IVAINC = 'S') then
        COSTO = COSTO / (1 + NEW.ende_ivaporc/100);
    INSERT INTO MOVIMIENTO_ARTICULO
        (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
        VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 11, NEW.entr_id,
        :CONC, :factor * new.ende_cant, :COSTO, 'S', new.ende_lote, :Pref, :Num, new.ende_item, :Nit);
    /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
    EXECUTE PROCEDURE CALCULA_PRECIOS(NEW.ARTI_COD, :FEC);
    END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER TRIGGER FACTCOMP_DETALLE_AD
AS
declare variable fec date;
declare variable CONSO VARCHAR(2);
declare variable CONSOLIDA INTEGER;
declare variable NUMROWS INTEGER;
declare variable VERIF CHAR(2);
BEGIN
if ((old.fcde_anulado = 'N') and (OLD.faco_id <> 0)) then
    begin
    select faco_fecha, faco_consolida from facturas_compra where faco_id = old.faco_id into :fec, :consolida;
    DELETE FROM MOVIMIENTO_ARTICULO WHERE (mvar_tipodoc = 21) and (mvar_idref = old.faco_id) and (mvar_item = old.fcde_item);
    /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
    EXECUTE PROCEDURE CALCULA_PRECIOS(old.ARTI_COD, :FEC);
    /* LOS PENDIENTES */
    if (CONSOLIDA <> 0) then
        BEGIN
        UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida AND COFA_ITEM = old.FCDE_ITEM AND ARTI_COD = old.arti_cod;
        SELECT COUNT(CEFA_ITEM) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
        EXECUTE procedure LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','SUMAR CANTIDADES PENDIENTES AL CONSOLIDAR DOCUMENTOS') returning_values (CONSO);
        /* IGNORE LA CONSOLIDACION SI SE VALIDAN CODIGOS DE LA ORDEN */
        SELECT MIN(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
        if (NUMROWS = 23) then
            BEGIN
            EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'VERIFICAR CODIGOS DE LA ORDEN') returning_values (VERIF);
            if (VERIF = 'SI') then
                CONSO = 'NO';
            END
        SELECT COUNT(CEFA_ITEM) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
        if ((CONSO = 'SI') AND (NUMROWS > 1)) then
            UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida;
        END
    enD
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER TRIGGER FACTCOMP_DETALLE_AI
AS
declare variable fec date;
declare variable fecaux date;
declare variable aux varchar(90);
declare variable CONC VARCHAR(60);
declare variable factor numeric(18,4);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Nit varchar(20);
declare variable TIPO INTEGER;
declare variable INVFAC CHAR(2);
declare variable IVAINC CHAR(2);
declare variable COSTO NUMERIC(18,2);
declare variable CANTREL NUMERIC(18,4);
declare variable NUMPROV VARCHAR(10);
declare variable NUMPED VARCHAR(30);
declare variable NUMREM VARCHAR(30);
declare variable CONSO VARCHAR(2);
declare variable CONSOLIDA INTEGER;
declare variable NUMROWS INTEGER;
declare variable DTOPIE NUMERIC(18,2);
declare variable ADICIONAL NUMERIC(18,2);
declare variable TOTAL NUMERIC(18,2);
declare variable IVAMONTO NUMERIC(18,2);
declare variable EXTRA NUMERIC(18,2);
declare variable FACT NUMERIC(18,4);
declare variable MENORV CHAR(2);
declare variable ACTREM CHAR(2);
declare variable FECREM date;
declare variable IDREM INTEGER;
declare variable ITEREM INTEGER;
declare variable CANTREM NUMERIC(18,4);
declare variable LOTEREM VARCHAR(15);
declare variable PREFREM CHAR(4);
BEGIN
if ((NEW.faco_id <> 0) and (new.fcde_anulado = 'N')) then
    BEGIN
    select faco_fecha, pref_pre, faco_numero, terc_nit, faco_imptos, faco_numprov, faco_remision, faco_orden, FACO_CONSOLIDA,
        FACO_TOTAL, FACO_EXTRA, FACO_IVAMONTO, FACO_ADICIONAL, FACO_DTOMONTO
        from facturas_compra where faco_id = new.faco_id
        into :fec, :Pref, :Num, :Nit, :ivainc, :numprov, :numrem, :numped, :CONSOLIDA,
        :total, :extra, :ivamonto, :adicional, :dtopie;
    conc = 'FACTURA DE COMPRA No.' || PREF || NUM || '-' || NUMPROV;
    if (NUMREM <> '') then
        BEGIN
        AUX = SUBSTR(NUMREM, 1, 15);
        conc = conc || '-REM:' || AUX;
        END
    else
        if (NUMPED <> '') then
            BEGIN
            AUX = SUBSTR(NUMPED, 1, 15);
            conc = conc || '-ORDEN ' || NUMPED;
            END
    SELECT MAX(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :TIPO;
    if (Tipo is null) then
        Tipo = 0;
    execute procedure lee_configuracion('COMPRAS', 'FACTURAS', 'AFECTAR INVENTARIO CON LA FACTURA') returning_values (:INVFAC);
    execute procedure factor_unidad_cant(new.arti_cod, new.fcde_unidad) returning_values(factor);
    COSTO = ((new.fcde_prunit - NEW.fcde_dtomonto) / :factor);
    if (IVAINC = 'S') then
        COSTO = COSTO / (1 + NEW.fcde_ivaporc/100);
    EXECUTE PROCEDURE lee_configuracion('COMPRAS','FACTURAS','DESCUENTO Y VALOR ADICIONAL DEL DOCUMENTO COMO MENOR VALOR DEL COSTO') returning_values (:MENORV);
    if (MENORV = 'SI') then
        BEGIN
        FACT = (TOTAL - EXTRA - IVAMONTO);
        if ((FACT - ADICIONAL + DTOPIE) <> 0) then
            FACT = FACT / (FACT - ADICIONAL + DTOPIE);
        ELSE
            FACT = 1;
        COSTO = COSTO * FACT;
        END
    /* si se hizo con base en una remision no afecte inventario */
    if (INVFAC = 'SI') then
      if (Tipo <> 22) then
        begin
        INSERT INTO MOVIMIENTO_ARTICULO
          (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
          VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 21, NEW.faco_id,
          :CONC, :factor * new.fcde_cant, :COSTO, 'S', new.fcde_lote, :Pref, :Num, NEW.fcde_item, :Nit);

        if (COSTO > 0 ) then
         BEGIN
          /* ACTUALICE EL COSTO POR PROVEEDOR */
          SELECT PVAR_FECHA FROM PROVEEDOR_ARTICULO
            WHERE TERC_NIT = :Nit AND ARTI_COD = NEW.ARTI_COD
            INTO :FECAUX;
          if (FECAUX IS NULL) then
            INSERT INTO PROVEEDOR_ARTICULO (TERC_NIT, ARTI_COD, PVAR_COSTO, PVAR_FECHA, PVAR_COD,PVAR_DES)
                VALUES (:Nit, NEW.ARTI_COD, :COSTO, :fec, NEW.fcde_codprov,NEW.fcde_desc);
          else
            UPDATE PROVEEDOR_ARTICULO
                SET PVAR_COSTO = :COSTO, PVAR_FECHA = :fec, PVAR_COD = NEW.fcde_codprov
                WHERE ARTI_COD = NEW.ARTI_COD AND TERC_NIT = :Nit;
         END
        /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
        EXECUTE PROCEDURE CALCULA_PRECIOS(NEW.ARTI_COD, :FEC);
        END /* AFECTAR INV */
    EXECUTE PROCEDURE lee_configuracion('COMPRAS', 'FACTURAS', 'ACTUALIZAR COSTOS DE LA REMISION RELACIONADA AL GRABAR LA FACTURA') returning_values (:ACTREM);
    if ((ACTREM = 'SI') and (Tipo = 22)) then
        BEGIN
        numrows = 0;
        select mvar_cons, MVAR_ITEM, MVAR_FECHA, MVAR_IDREF, MVAR_CANT, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO
            from movimiento_articulo M, consolidado_faltantes C
            where C.cofa_id = :CONSOLIDA AND mvar_tipodoc = 22 and mvar_idref = C.cofa_idori AND C.cofa_tipoori = 22 and m.arti_cod = new.arti_cod
            into :numrows, :iterem, :fecrem, :idrem, :cantrem, :loterem, :prefrem, :numrem;
        
        if (numrows <> 0) then
            BEGIN
            DELETE FROM MOVIMIENTO_ARTICULO WHERE MVAR_CONS = :numrows;
            INSERT INTO MOVIMIENTO_ARTICULO
                (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
                VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :fecrem, 22, :idrem,
                :CONC, :cantrem, :costo, 'S', :loterem, :prefrem, :numrem, :iterem, :Nit);
        
            if (COSTO > 0 ) then
                BEGIN
                /* ACTUALICE EL COSTO POR PROVEEDOR */
                SELECT PVAR_FECHA FROM PROVEEDOR_ARTICULO
                    WHERE TERC_NIT = :Nit AND ARTI_COD = NEW.ARTI_COD
                    INTO :FECAUX;
                if (FECAUX IS NULL) then
                    INSERT INTO PROVEEDOR_ARTICULO (TERC_NIT, ARTI_COD, PVAR_COSTO, PVAR_FECHA, PVAR_COD,PVAR_DES)
                        VALUES (:Nit, NEW.ARTI_COD, :COSTO, :fec, NEW.fcde_codprov,NEW.fcde_desc);
                else
                    UPDATE PROVEEDOR_ARTICULO
                        SET PVAR_COSTO = :COSTO, PVAR_FECHA = :fec, PVAR_COD = NEW.fcde_codprov
                        WHERE ARTI_COD = NEW.ARTI_COD AND TERC_NIT = :Nit;
                END
            /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
            EXECUTE PROCEDURE CALCULA_PRECIOS(NEW.ARTI_COD, :FEC);
            END
        END

    /* ACTUALICE EL PENDIENTE  */
    if (CONSOLIDA <> 0) then
        BEGIN
        UPDATE consolidado_faltantes SET COFA_OK = 'S' WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod;
        EXECUTE procedure LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','SUMAR CANTIDADES PENDIENTES AL CONSOLIDAR DOCUMENTOS') returning_values (CONSO);
        /* IGNORE LA CONSOLIDACION SI SE VALIDAN CODIGOS DE LA ORDEN */
        SELECT MIN(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
        if (NUMROWS = 23) then
            BEGIN
            EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'VERIFICAR CODIGOS DE LA ORDEN') returning_values (MENORV);
            if (MENORV = 'SI') then
                CONSO = 'NO';
            END
        SELECT COUNT(CEFA_ITEM) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
        if ((CONSO = 'SI') AND (NUMROWS > 1)) then
            UPDATE consolidado_faltantes SET COFA_IDDES = NEW.faco_id, COFA_OK = 'S' WHERE COFA_ID = :consolida;
        else
            BEGIN
            /* BUSQUE EL CONSOLIDADO EN EL MISMO ITEM Y SI ES DIFERENTE ACTUALICELO */
            select COFA_CANT * COFA_FACTOR FROM consolidado_faltantes WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod INTO :CANTREL;
            if (NEW.FCDE_CANT * NEW.FCDE_FACTOR < CANTREL) then
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.faco_id, COFA_CANT = NEW.FCDE_CANT, COFA_FACTOR = NEW.FCDE_FACTOR
                    WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod;
            END
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER TRIGGER FACTCOMP_DETALLE_AU
as
declare variable fec date;
declare variable fecaux date;
declare variable AUX varchar(90);
declare variable CONC VARCHAR(60);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Nit varchar(20);
declare variable factor numeric(18,4);
declare variable TIPO INTEGER;
declare variable INVFAC CHAR(2);
declare variable IVAINC CHAR(2);
declare variable COSTO NUMERIC(18,2);
declare variable CANTREL NUMERIC(18,4);
declare variable NUMPROV VARCHAR(10);
declare variable NUMPED VARCHAR(30);
declare variable NUMREM VARCHAR(30);
declare variable CONSO VARCHAR(2);
declare variable CONSOLIDA INTEGER;
declare variable NUMROWS INTEGER;
declare variable DTOPIE NUMERIC(18,2);
declare variable ADICIONAL NUMERIC(18,2);
declare variable TOTAL NUMERIC(18,2);
declare variable IVAMONTO NUMERIC(18,2);
declare variable EXTRA NUMERIC(18,2);
declare variable FACT NUMERIC(18,4);
declare variable MENORV CHAR(2);
declare variable ACTREM CHAR(2);
declare variable FECREM date;
declare variable IDREM INTEGER;
declare variable ITEREM INTEGER;
declare variable CANTREM NUMERIC(18,4);
declare variable LOTEREM VARCHAR(15);
declare variable PREFREM CHAR(4);
BEGIN
if (old.fcde_devuelto = new.fcde_devuelto) then
    begin
    /* deshaga lo viejo */
    if ((old.fcde_anulado = 'N') and (OLD.faco_id <> 0)) then
        begin
        select faco_fecha, faco_consolida from facturas_compra where faco_id = old.faco_id into :fec, :consolida;
        DELETE FROM MOVIMIENTO_ARTICULO WHERE (mvar_tipodoc = 21) and (mvar_idref = old.faco_id) and (mvar_item = old.fcde_item);
        /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
        EXECUTE PROCEDURE CALCULA_PRECIOS(old.ARTI_COD, :FEC);
        /* LOS PENDIENTES */
        if (CONSOLIDA <> 0) then
            BEGIN
            UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida AND COFA_ITEM = old.FCDE_ITEM AND ARTI_COD = old.arti_cod;
            SELECT COUNT(CEFA_ITEM) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
            EXECUTE procedure LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','SUMAR CANTIDADES PENDIENTES AL CONSOLIDAR DOCUMENTOS') returning_values (CONSO);
            /* IGNORE LA CONSOLIDACION SI SE VALIDAN CODIGOS DE LA ORDEN */
            SELECT MIN(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
            if (NUMROWS = 23) then
                BEGIN
                EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'VERIFICAR CODIGOS DE LA ORDEN') returning_values (MENORV);
                if (MENORV = 'SI') then
                    CONSO = 'NO';
                END
            if (CONSO = 'SI') then
                UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida;
            END
        end
    /* Registre el nuevo */
    if ((new.fcde_anulado = 'N') and (new.faco_id <> 0)) then
        BEGIN
        select faco_fecha, pref_pre, faco_numero, terc_nit, faco_imptos, faco_numprov, faco_remision, faco_orden, faco_consolida, faco_dtomonto, faco_adicional, faco_total, faco_ivamonto, faco_extra
            from facturas_compra where faco_id = new.faco_id
            into :fec, :Pref, :Num, :Nit, :ivainc, :numprov, :numrem, :numped, :consolida, :dtopie, :adicional, :total, :ivamonto, :extra;
        conc = 'FACTURA DE COMPRA No.' || PREF || NUM || '-' || NUMPROV;
        if (NUMREM <> '') then
            BEGIN
            AUX = SUBSTR(NUMREM, 1, 15);
            conc = conc || '-REM:' || AUX;
            END
        else
            if (NUMPED <> '') then
                BEGIN
                AUX = SUBSTR(NUMPED, 1, 15);
                conc = conc || '-ORDEN ' || AUX;
                END
        SELECT MAX(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :TIPO;
        if (Tipo is null) then
            Tipo = 0;
        execute procedure lee_configuracion('COMPRAS', 'FACTURAS', 'AFECTAR INVENTARIO CON LA FACTURA') returning_values (:INVFAC);
        /* si se hizo con base en una remision no afecte inventario */
        if ((Tipo <> 22) and (INVFAC = 'SI')) then
            begin
            execute procedure factor_unidad_cant(new.arti_cod, new.fcde_unidad) returning_values(factor);
            COSTO = ((new.fcde_prunit - NEW.fcde_dtomonto) / :factor);
            if (IVAINC = 'S') then
                COSTO = COSTO / (1 + NEW.fcde_ivaporc/100);
            EXECUTE PROCEDURE lee_configuracion('COMPRAS','FACTURAS','DESCUENTO Y VALOR ADICIONAL DEL DOCUMENTO COMO MENOR VALOR DEL COSTO') returning_values (:MENORV);
            if (MENORV = 'SI') then
                BEGIN
                FACT = (TOTAL - EXTRA - IVAMONTO);
                if ((FACT - ADICIONAL + DTOPIE) <> 0) then
                    FACT = FACT / (FACT - ADICIONAL + DTOPIE);
                ELSE
                    FACT = 1;
                COSTO = COSTO * FACT;
                END
            INSERT INTO MOVIMIENTO_ARTICULO
                (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
                VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 21, NEW.faco_id,
                :CONC, :factor * new.fcde_cant, :COSTO, 'S', new.fcde_lote, :Pref, :Num, NEW.fcde_item, :Nit);
            if (COSTO > 0 ) then
             BEGIN
              /* ACTUALICE EL COSTO POR PROVEEDOR */
              SELECT PVAR_FECHA FROM PROVEEDOR_ARTICULO
                WHERE TERC_NIT = :Nit AND ARTI_COD = NEW.ARTI_COD INTO :FECAUX;
              if (FECAUX IS NULL) then
                INSERT INTO PROVEEDOR_ARTICULO (TERC_NIT, ARTI_COD, PVAR_COSTO, PVAR_FECHA, PVAR_COD,PVAR_DES)
                    VALUES (:Nit, NEW.ARTI_COD, :COSTO, :fec, NEW.fcde_codprov,NEW.fcde_desc);
              else
                UPDATE PROVEEDOR_ARTICULO
                    SET PVAR_COSTO = :COSTO, PVAR_FECHA = :fec, PVAR_COD = NEW.fcde_codprov
                    WHERE ARTI_COD = NEW.ARTI_COD AND TERC_NIT = :Nit;
             END
            /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
            EXECUTE PROCEDURE CALCULA_PRECIOS(NEW.ARTI_COD, :FEC);
            end
        EXECUTE PROCEDURE lee_configuracion('COMPRAS', 'FACTURAS', 'ACTUALIZAR COSTOS DE LA REMISION RELACIONADA AL GRABAR LA FACTURA') returning_values (:ACTREM);
        if ((ACTREM = 'SI') and (Tipo = 22)) then
            BEGIN
            numrows = 0;
            select mvar_cons, MVAR_ITEM, MVAR_FECHA, MVAR_IDREF, MVAR_CANT, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO
                from movimiento_articulo M, consolidado_faltantes C
                where C.cofa_id = :CONSOLIDA AND mvar_tipodoc = 22 and mvar_idref = C.cofa_idori AND C.cofa_tipoori = 22 and m.arti_cod = new.arti_cod
                into :numrows, :iterem, :fecrem, :idrem, :cantrem, :loterem, :prefrem, :numrem;
            
            if (numrows <> 0) then
                BEGIN
                DELETE FROM MOVIMIENTO_ARTICULO WHERE MVAR_CONS = :numrows;
                INSERT INTO MOVIMIENTO_ARTICULO
                    (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
                    VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :fecrem, 22, :idrem,
                    :CONC, :cantrem, :costo, 'S', :loterem, :prefrem, :numrem, :iterem, :Nit);
        
                if (COSTO > 0 ) then
                    BEGIN
                    /* ACTUALICE EL COSTO POR PROVEEDOR */
                    SELECT PVAR_FECHA FROM PROVEEDOR_ARTICULO
                        WHERE TERC_NIT = :Nit AND ARTI_COD = NEW.ARTI_COD
                        INTO :FECAUX;
                    if (FECAUX IS NULL) then
                        INSERT INTO PROVEEDOR_ARTICULO (TERC_NIT, ARTI_COD, PVAR_COSTO, PVAR_FECHA, PVAR_COD,PVAR_DES)
                            VALUES (:Nit, NEW.ARTI_COD, :COSTO, :fec, NEW.fcde_codprov,NEW.fcde_desc);
                    else
                        UPDATE PROVEEDOR_ARTICULO
                            SET PVAR_COSTO = :COSTO, PVAR_FECHA = :fec, PVAR_COD = NEW.fcde_codprov
                            WHERE ARTI_COD = NEW.ARTI_COD AND TERC_NIT = :Nit;
                    END
                /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
                EXECUTE PROCEDURE CALCULA_PRECIOS(NEW.ARTI_COD, :FEC);
                END
            END

        if (CONSOLIDA <> 0) then
            begin
            UPDATE consolidado_faltantes SET COFA_OK = 'S' WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod;
            EXECUTE procedure LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','SUMAR CANTIDADES PENDIENTES AL CONSOLIDAR DOCUMENTOS') returning_values (CONSO);
            /* IGNORE LA CONSOLIDACION SI SE VALIDAN CODIGOS DE LA ORDEN */
            SELECT MIN(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
            if (NUMROWS = 23) then
                BEGIN
                EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'FACTURAS', 'VERIFICAR CODIGOS DE LA ORDEN') returning_values (MENORV);
                if (MENORV = 'SI') then
                    CONSO = 'NO';
                END
            SELECT COUNT(CEFA_ITEM) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
            if ((CONSO = 'SI') AND (NUMROWS > 1)) then
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.faco_id, COFA_OK = 'S' WHERE COFA_ID = :consolida;
            else
                BEGIN
                /* BUSQUE EL CONSOLIDADO EN EL MISMO ITEM Y SI ES DIFERENTE ACTUALICELO */
                select COFA_CANT * COFA_FACTOR FROM consolidado_faltantes WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod INTO :CANTREL;
                if (NEW.FCDE_CANT * NEW.FCDE_FACTOR < CANTREL) then
                    UPDATE consolidado_faltantes SET COFA_IDDES = NEW.faco_id, COFA_CANT = NEW.FCDE_CANT, COFA_FACTOR = NEW.FCDE_FACTOR
                        WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.FCDE_ITEM AND ARTI_COD = NEW.arti_cod;
                END
            end
        END
    end
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER TRIGGER REMISION_PROVEEDOR_DET_AI
AS
declare variable fec date;
declare variable CONC VARCHAR(60);
declare variable factor numeric(18,4);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable EXISTE CHAR(1);
declare variable NIT VARCHAR(20);
declare variable NUMPROV VARCHAR(20);
declare variable Tipo Integer;
declare variable idfact integer;
declare variable numrows integer;
declare variable IVAINC CHAR(2);
declare variable COSTO NUMERIC(18,2);
declare variable CANTREL NUMERIC(18,4);
declare variable NUMPED VARCHAR(30);
declare variable CONSO CHAR(2);
declare variable CONSOLIDA INTEGER;
declare variable DTOPIE NUMERIC(18,2);
declare variable ADICIONAL NUMERIC(18,2);
declare variable TOTAL NUMERIC(18,2);
declare variable IVAMONTO NUMERIC(18,2);
declare variable EXTRA NUMERIC(18,2);
declare variable FACT NUMERIC(18,4);
declare variable MENORV CHAR(2);
BEGIN
  if ((NEW.repr_id <> 0) and (new.rpvd_anulado = 'N')) then
    BEGIN
    select max(rprd_tiporel), max(rprd_idrel) from remision_proveedor_docrela
        where repr_id = new.repr_id into :Tipo, :idfact;
    if (Tipo is null) then
        Tipo = 0;
    /* si se hizo con base en una factura que afecto el inventario no afecte inventario */
    numrows = 0;
    if (Tipo = 21) Then
        select count(*) from movimiento_articulo where mvar_tipodoc = 21 and mvar_idref = :idfact into :numrows;
    if (numrows is null) then
        numrows = 0;
    if (numrows = 0) then
        begin
        select repr_fecha, pref_pre, repr_numero, REPR_IMPTOS, terc_nit, REPR_NUMPROV, REPR_ORDEN, REPR_CONSOLIDA, repr_dtomonto, repr_adicional, repr_total, repr_ivamonto, repr_extra
            from remision_proveedor where repr_id = new.repr_id
            into :fec, :Pref, :Num, :IVAINC, :NIT, :NUMPROV, :numped, :CONSOLIDA, :dtopie, :adicional, :total, :ivamonto, :extra;
        execute procedure factor_unidad_cant(new.arti_cod, new.rpvd_unidad) returning_values(factor);
        CONC = 'REMISION PROVEEDOR No.' || PREF || NUM || '-' || NUMPROV;
        if (numped <> '') then
            conc = conc || '-ORDEN ' || NUMPED;
        COSTO = ((new.rpvd_prunit - NEW.rpvd_dtomonto) / :factor);
        if (IVAINC = 'S') then
            COSTO = COSTO / (1 + NEW.rpvd_ivaporc/100);
        EXECUTE PROCEDURE lee_configuracion('COMPRAS','FACTURAS','DESCUENTO Y VALOR ADICIONAL DEL DOCUMENTO COMO MENOR VALOR DEL COSTO') returning_values (:MENORV);
        if (MENORV = 'SI') then
            BEGIN
            FACT = (TOTAL - EXTRA - IVAMONTO);
            if ((FACT - ADICIONAL + DTOPIE) <> 0) then
                FACT = FACT / (FACT - ADICIONAL + DTOPIE);
            ELSE
                FACT = 1;
            COSTO = COSTO * FACT;
            END
        INSERT INTO MOVIMIENTO_ARTICULO
          (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
          VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 22, NEW.repr_id,
          :CONC, :factor * new.rpvd_cant, :COSTO, 'S', new.rpvd_lote, :Pref, :Num, new.rpvd_item, :Nit);

        /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
        EXECUTE PROCEDURE CALCULA_PRECIOS(NEW.ARTI_COD, :FEC);

        if (COSTO > 0 ) then
         BEGIN
          /* GRABE PROV X ARTICULO */
          EXISTE = 'N';
          SELECT 'S' FROM PROVEEDOR_ARTICULO WHERE TERC_NIT = :NIT AND ARTI_COD = NEW.ARTI_COD INTO :EXISTE;
          if (EXISTE = 'S') then
            UPDATE PROVEEDOR_ARTICULO 
                SET PVAR_FECHA = :FEC, PVAR_COSTO = :COSTO, PVAR_COD = NEW.rpvd_codprov
                WHERE TERC_NIT = :NIT AND ARTI_COD = NEW.ARTI_COD;
          ELSE
            INSERT INTO PROVEEDOR_ARTICULO (TERC_NIT, ARTI_COD, PVAR_COSTO, PVAR_FECHA, PVAR_COD,PVAR_DES)
                VALUES (:NIT, NEW.ARTI_COD, :COSTO, :FEC, NEW.rpvd_codprov,NEW.rpvd_desc);
         END
        end

    /* ACTUALICE EL PENDIENTE  */
    if (CONSOLIDA <> 0) then
        BEGIN
        EXECUTE PROCEDURE LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','SUMAR CANTIDADES PENDIENTES AL CONSOLIDAR DOCUMENTOS') returning_values (CONSO);
        SELECT MIN(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
        if (NUMROWS = 23) then
            BEGIN
            EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'REMISIONES', 'VERIFICAR CODIGOS DE LA ORDEN') returning_values (MENORV);
            if (MENORV = 'SI') then
                CONSO = 'NO';
            END
        SELECT COUNT(CEFA_ITEM) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
        if ((CONSO = 'SI') AND (NUMROWS > 1)) then
            UPDATE consolidado_faltantes SET COFA_OK = 'S' WHERE COFA_ID = :consolida;
        ELSE
            BEGIN
            /* BUSQUE EL CONSOLIDADO EN EL MISMO ITEM Y SI ES DIFERENTE ACTUALICELO */
            select COFA_CANT * COFA_FACTOR FROM consolidado_faltantes WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.RPVD_ITEM AND ARTI_COD = NEW.arti_cod INTO :CANTREL;
            if (NEW.RPVD_CANT * NEW.RPVD_FACTOR < CANTREL) then
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.repr_id, COFA_CANT = NEW.RPVD_CANT, COFA_FACTOR = NEW.RPVD_FACTOR
                    WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.RPVD_ITEM AND ARTI_COD = NEW.arti_cod;
            ELSE
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.repr_id, COFA_OK = 'S' WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.RPVD_ITEM AND ARTI_COD = NEW.arti_cod;
            END
        END
    END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER TRIGGER REMISION_PROVEEDOR_DET_AU
AS
declare variable fec date;
declare variable CONC VARCHAR(60);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable factor numeric(18,4);
declare variable EXISTE CHAR(1);
declare variable NIT VARCHAR(20);
declare variable NUMPROV VARCHAR(20);
declare variable Tipo integer;
declare variable idfact integer;
declare variable numrows integer;
declare variable IVAINC CHAR(2);
declare variable COSTO NUMERIC(18,2);
declare variable CANTREL NUMERIC(18,4);
declare variable NUMPED VARCHAR(30);
declare variable CONSO CHAR(2);
declare variable CONSOLIDA INTEGER;
declare variable DTOPIE NUMERIC(18,2);
declare variable ADICIONAL NUMERIC(18,2);
declare variable TOTAL NUMERIC(18,2);
declare variable IVAMONTO NUMERIC(18,2);
declare variable EXTRA NUMERIC(18,2);
declare variable FACT NUMERIC(18,4);
declare variable MENORV CHAR(2);
BEGIN
if ((OLD.repr_id <> 0) AND (OLD.rpvd_anulado = 'N')) then
    begin
    DELETE FROM MOVIMIENTO_ARTICULO WHERE (mvar_tipodoc = 22) and (mvar_idref = new.repr_id) and (mvar_item = old.rpvd_item);
    select REPR_CONSOLIDA from remision_proveedor where repr_id = old.repr_id into :CONSOLIDA;
    if (CONSOLIDA <> 0) then
        begin
        EXECUTE PROCEDURE LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','SUMAR CANTIDADES PENDIENTES AL CONSOLIDAR DOCUMENTOS') returning_values (CONSO);
        SELECT COUNT(CEFA_ITEM) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
        if ((NUMROWS = 1) OR (CONSO = 'NO')) then
            UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida AND COFA_ITEM = old.RPVD_ITEM AND ARTI_COD = old.arti_cod;
        else
            UPDATE consolidado_faltantes SET COFA_OK = 'N' WHERE COFA_ID = :consolida;
        END
    end
/* Registre el nuevo */
if ((new.repr_id <> 0) AND (new.rpvd_anulado = 'N')) then
    begin
    select repr_fecha, pref_pre, repr_numero, repr_imptos, terc_nit, REPR_NUMPROV, REPR_ORDEN, REPR_CONSOLIDA, repr_dtomonto, repr_adicional, repr_total, repr_ivamonto, repr_extra
        from remision_proveedor where repr_id = new.repr_id
        into :fec, :Pref, :Num, :IVAINC, :NIT, :NUMPROV, :numped, :CONSOLIDA, :dtopie, :adicional, :total, :ivamonto, :extra;
    CONC = 'REMISION PROVEEDOR No.' || PREF || NUM || '-' || NUMPROV;
    if (numped <> '') then
        conc = conc || '-ORDEN ' || NUMPED;
    SELECT MAX(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :TIPO;
    if (Tipo is null) then
        Tipo = 0;
    select FACO_ID from FACTURAS_COMPRA WHERE FACO_CONSOLIDA = :consolida INTO :IDFACT;
    if (Idfact is null) then
        Idfact = 0;
    /* si se hizo con base en una factura que afecto el inventario no afecte inventario */
    numrows = 0;
    if (Tipo = 21) Then
        select count(*) from movimiento_articulo where mvar_tipodoc = 21 and mvar_idref = :idfact into :numrows;
    if (numrows is null) then
        numrows = 0;
    if (numrows = 0) then
        begin
        execute procedure factor_unidad_cant(new.arti_cod, new.rpvd_unidad) returning_values(factor);
        COSTO = ((new.rpvd_prunit - NEW.rpvd_dtomonto) / :factor);
        if (IVAINC = 'S') then
            COSTO = COSTO / (1 + NEW.rpvd_ivaporc/100);
        EXECUTE PROCEDURE lee_configuracion('COMPRAS','FACTURAS','DESCUENTO Y VALOR ADICIONAL DEL DOCUMENTO COMO MENOR VALOR DEL COSTO') returning_values (:MENORV);
        if (MENORV = 'SI') then
            BEGIN
            FACT = (TOTAL - EXTRA - IVAMONTO);
            if ((FACT - ADICIONAL + DTOPIE) <> 0) then
                FACT = FACT / (FACT - ADICIONAL + DTOPIE);
            ELSE
                FACT = 1;
            COSTO = COSTO * FACT;
            END
        INSERT INTO MOVIMIENTO_ARTICULO
            (ARTI_COD, MVAR_CONS, BODE_COD, MVAR_FECHA, MVAR_TIPODOC, MVAR_IDREF, MVAR_CONC, MVAR_CANT, MVAR_COSTO, MVAR_ENTRADA, MVAR_LOTE, MVAR_PREF, MVAR_NUMERO, MVAR_ITEM, TERC_NIT)
            VALUES(NEW.ARTI_COD, GEN_ID(ID_MOVARTI,1), NEW.BODE_COD, :FEC, 22, NEW.repr_id,
            :CONC, :factor * new.rpvd_cant, :COSTO, 'S', new.rpvd_lote, :Pref, :Num, new.rpvd_item, :Nit);
            
        /* RECORRA LAS LISTAS DE PRECIOS Y CAMBIE EL PRECIO */
        EXECUTE PROCEDURE CALCULA_PRECIOS(NEW.ARTI_COD, :FEC);
          
        if (COSTO > 0 ) then
         BEGIN
          /* GRABE PROV X ARTICULO */
          EXISTE = 'N';
          SELECT 'S' FROM PROVEEDOR_ARTICULO WHERE TERC_NIT = :NIT AND ARTI_COD = NEW.ARTI_COD INTO :EXISTE;
          if (EXISTE = 'S') then
            UPDATE PROVEEDOR_ARTICULO
                SET PVAR_FECHA = :FEC, PVAR_COSTO = :COSTO, PVAR_COD = NEW.rpvd_codprov
                WHERE TERC_NIT = :NIT AND ARTI_COD = NEW.ARTI_COD;
          ELSE
            INSERT INTO PROVEEDOR_ARTICULO (TERC_NIT, ARTI_COD, PVAR_COSTO, PVAR_FECHA, PVAR_COD,PVAR_DES)
                VALUES (:NIT, NEW.ARTI_COD, :COSTO, :FEC, NEW.rpvd_codprov,NEW.rpvd_desc);
         END
        end
    if (CONSOLIDA <> 0) then
        BEGIN
        EXECUTE PROCEDURE LEE_CONFIGURACION ('COMPRAS','DOCUMENTOS','SUMAR CANTIDADES PENDIENTES AL CONSOLIDAR DOCUMENTOS') returning_values (CONSO);
        /* IGNORE LA CONSOLIDACION SI SE VALIDAN CODIGOS DE LA ORDEN */
        SELECT MIN(CEFA_TIPOORI) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
        if (NUMROWS = 23) then
            BEGIN
            EXECUTE PROCEDURE LEE_CONFIGURACION('COMPRAS', 'REMISIONES', 'VERIFICAR CODIGOS DE LA ORDEN') returning_values (MENORV);
            if (MENORV = 'SI') then
                CONSO = 'NO';
            END
        SELECT COUNT(CEFA_ITEM) FROM consolide_faltantes WHERE CEFA_ID = :CONSOLIDA INTO :NUMROWS;
        if ((CONSO = 'SI') AND (NUMROWS > 1)) then
            UPDATE consolidado_faltantes SET COFA_IDDES = NEW.repr_id, COFA_OK = 'S' WHERE COFA_ID = :consolida;
        ELSE
            BEGIN
            /* BUSQUE EL CONSOLIDADO EN EL MISMO ITEM Y SI ES DIFERENTE ACTUALICELO */
            select COFA_CANT * COFA_FACTOR FROM consolidado_faltantes WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.RPVD_ITEM AND ARTI_COD = NEW.arti_cod INTO :CANTREL;
            if (NEW.RPVD_CANT * NEW.RPVD_FACTOR < CANTREL) then
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.repr_id, COFA_CANT = NEW.RPVD_CANT, COFA_FACTOR = NEW.RPVD_FACTOR
                    WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.RPVD_ITEM AND ARTI_COD = NEW.arti_cod;
            else
                UPDATE consolidado_faltantes SET COFA_IDDES = NEW.repr_id, COFA_OK = 'S' WHERE COFA_ID = :consolida AND COFA_ITEM = NEW.RPVD_ITEM AND ARTI_COD = NEW.arti_cod;
            END
        END
    END
END
^

SET TERM ; ^

/* quedaba la salida del documento como 66 y no como 62 al anular no reponia las formas de pago */

SET TERM ^ ;

CREATE OR ALTER TRIGGER EGRESOS_CAJA_AI FOR EGRESOS_CAJA
ACTIVE AFTER INSERT POSITION 0
AS
declare variable Fec DATE;
declare variable Conc VARCHAR(60);
declare variable Pref varchar(4);
declare variable Num varchar(6);
declare variable Existe integer;
declare variable VALFP char(2);
BEGIN
if ((NEW.egre_id <> 0) and (new.egca_anulado = 'N')) then
  BEGIN
  EXECUTE PROCEDURE LEE_CONFIGURACION('BANCOS','CONSIGNACIONES','VALIDAR FORMAS DE PAGO EN CAJA') RETURNING_VALUES (VALFP);
  select pref_pre, egre_numero, egre_fecha, egre_conc
    from egresos where egre_id = new.egre_id
    into :pref, :num, :fec, :conc;
  /* Actualice el movimiento en caja */
  select count(moca_id) from movimiento_caja where moca_tiporef = 62 and moca_idref = new.egre_id and caja_id = new.caja_id into :Existe;
  if (Existe > 0) then
    update movimiento_caja
        set moca_creditos = moca_creditos + new.egca_monto
        where moca_tiporef = 62 and moca_idref = new.egre_id and caja_id = new.caja_id;
  else
    INSERT INTO MOVIMIENTO_CAJA
        (MOCA_ID, CAJA_ID, MOCA_TIPOREF, MOCA_PREFREF, MOCA_NUMREF, MOCA_FECHA, MOCA_CONC, MOCA_DEBITOS, MOCA_CREDITOS, MOCA_DB, MOCA_IDREF)
        VALUES(GEN_ID(ID_MOVCAJA,1), NEW.caja_id, 62, :Pref, :Num, :Fec, :Conc, 0, NEW.egca_monto, 'N', new.egre_id);
        
  /* ACTUALICE LA SALIDA DEL DOCUMENTO */
  if (NEW.FOPA_ID <> 1) then
      BEGIN
      SELECT count(dpca_id) FROM DOCUMENTOS_PAGO_CAJA WHERE FOPA_ID = NEW.FOPA_ID AND DPCA_BANCO = NEW.EGCA_BANCO AND
        DPCA_CUENTA = NEW.EGCA_CUENTA AND DPCA_NUMERO = NEW.EGCA_NUMERO AND DPCA_TIPOSAL = 0 AND DPCA_IDSAL = 0 INTO :EXISTE;
      if (EXISTE > 0) then
          UPDATE DOCUMENTOS_PAGO_CAJA
            SET DPCA_TIPOSAL = 62, DPCA_IDSAL = NEW.EGRE_ID
            WHERE FOPA_ID = NEW.FOPA_ID AND DPCA_BANCO = NEW.EGCA_BANCO AND DPCA_CUENTA = NEW.EGCA_CUENTA AND
            DPCA_NUMERO = NEW.EGCA_NUMERO AND DPCA_TIPOSAL = 0 AND DPCA_IDSAL = 0;
      ELSE
        IF (VALFP = 'SI') THEN
          EXCEPTION documento_pago_salido;
      END
  ELSE
      EXECUTE PROCEDURE RESTE_SALDO_EFECTIVO(NEW.CAJA_ID, :FEC, NEW.EGCA_MONTO, 'N');
  END
END
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON EGRESOS_CAJA TO TRIGGER EGRESOS_CAJA_AI;
GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO TRIGGER EGRESOS_CAJA_AI;
GRANT SELECT ON EGRESOS TO TRIGGER EGRESOS_CAJA_AI;
GRANT SELECT,INSERT,UPDATE ON MOVIMIENTO_CAJA TO TRIGGER EGRESOS_CAJA_AI;
GRANT SELECT,UPDATE ON DOCUMENTOS_PAGO_CAJA TO TRIGGER EGRESOS_CAJA_AI;
GRANT EXECUTE ON PROCEDURE RESTE_SALDO_EFECTIVO TO TRIGGER EGRESOS_CAJA_AI;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE PUNTOS_VENDEDOR_FECHAS(
    VENDI INTEGER,
    VENDF INTEGER,
    FECINI DATE,
    FECFIN DATE)
RETURNS (
    CODVEN INTEGER,
    NOMVEN VARCHAR(60),
    FECDOC DATE,
    CLIENTE VARCHAR(60),
    NUMDOC VARCHAR(10),
    MONDOC NUMERIC(18,2),
    FECREC DATE,
    NUMREC VARCHAR(10),
    MONREC NUMERIC(18,2),
    COMI CHAR(2),
    DB NUMERIC(18,2),
    CR NUMERIC(18,2))
AS
declare variable TIPO INTEGER;
declare variable ID INTEGER;
begin
FOR SELECT VEND_COD, PTVT_FECHA, PTVT_TIPODOC, PTVT_IDDOC, PTVT_DB, PTVT_CR FROM puntos_vendedor
    WHERE PTVT_FECHA >= :FECINI AND PTVT_FECHA <= :FECFIN AND VEND_COD >= :VENDI AND VEND_COD <= :VENDF
    ORDER BY VEND_COD, PTVT_FECHA, PTVT_TIPODOC, PTVT_IDDOC
    INTO :CODVEN, :FECDOC, :tipo, :id, :db, :cr
    DO
    BEGIN
    SELECT VEND_NOMBRE FROM VENDEDORES WHERE VEND_COD = :codven INTO :nomven;
    if (TIPO = 31) then
        SELECT PREF_PRE || FACT_NUMERO, FACT_TOTAL, fact_nomcliente FROM FACTURAS WHERE FACT_ID = :ID INTO :numdoc, :mondoc, :CLIENTE;
    if (TIPO = 33) then
        SELECT PREF_PRE || DEVT_NUMERO, DEVT_TOTAL, DEVT_NOMTERC FROM devoluciones_ventas WHERE DEVT_ID = :ID INTO :numdoc, :mondoc, :CLIENTE;
    if (TIPO = 41) then
        SELECT PREF_PRE || NDCL_NUMERO, NDCL_MONTO, NDCL_CONC FROM notas_debito_clientes WHERE NDCL_ID = :ID INTO :numdoc, :mondoc, :CLIENTE;
    if (TIPO = 42) then
        SELECT PREF_PRE || NCCL_NUMERO, NCCL_MONTO, NCCL_CONC FROM notas_credito_clientes WHERE NCCL_ID = :ID INTO :numdoc, :mondoc, :CLIENTE;

    SELECT MAX(PREF_PRE || RECA_NUMERO), MAX(RECA_FECHA), SUM(RCDE_ABONO), MAX(RCDE_COMIP) FROM RECIBOS_CAJA R, RECIBOS_CAJA_DETALLE D
        WHERE R.reca_id = D.reca_id AND RECA_FECHA = :FECDOC AND D.rcde_tipodoc = :TIPO AND D.rcde_iddoc = :id
        INTO :numrec, :fecrec, :monrec, :comi;
    suspend;
    END
end
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER PROCEDURE CUADRE_CAJA_DETALLE(
    FECHA DATE)
RETURNS (
    CXCTIPO VARCHAR(10),
    CXCNUMERO VARCHAR(10),
    CXCMONTO NUMERIC(18,2))
AS
declare variable id integer;
declare variable TIPO integer;
declare variable ABONO NUMERIC(18,2);
begin
/* DETALLE DE LA CARTERA DEL DIA */
for SELECT MVCL_IDREF, mvcl_tiporef, TIDO_NOMCORTO, MVCL_PREFREF || MVCL_NUMREF, MVCL_MONTO FROM MOVIMIENTO_CLIENTES M, TIPO_DOCUMENTO T
    WHERE MVCL_FECHA = :FECHA AND MVCL_ABONO = 'N' AND M.mvcl_tiporef = T.tido_cod
    into :id, :TIPO, :cxctipo, :cxcnumero, cxcmonto
    do
    BEGIN
    if (cxcmonto IS NULL) then
        cxcmonto = 0;
    SELECT sum(SDCA_ABONO) FROM SALDOS_DOC_CARTERA WHERE sdca_idref = :id AND sdca_tiporef = :TIPO AND SDCA_FECHA = :FECHA AND SDCA_ABONO <> 0
        INTO :ABONO;
    if (ABONO IS NULL) then
        ABONO = 0;
    if (CXCMONTO <> ABONO) then
        BEGIN
        if ((cxctipo = 'DEVOLCLI') or (cxctipo = 'NOTACRCL')) then
            begin
            cxcmonto = cxcmonto + abono;
            CXCMONTO = CXCMONTO * -1;
            end
        else
            cxcmonto = cxcmonto - abono;
        SUSPEND;
        END
    END
end
^

SET TERM ; ^

SET TERM ^ ;

CREATE OR ALTER TRIGGER FACTURAS_BI FOR FACTURAS
ACTIVE BEFORE INSERT POSITION 0
AS
declare variable NUMERO VARCHAR(6);
declare variable AUTOM CHAR(1);
declare variable EXISTE CHAR(1);
DECLARE VARIABLE VALCUPO CHAR(10);
declare variable DISPONIBLE NUMERIC(18,2);
declare variable OK CHAR(1);
declare variable SITOT CHAR(2);
declare variable CODCOBR INTEGER;
declare variable CODVEND INTEGER;
declare variable contado char(1);
declare variable BLOQAUTO CHAR(2);
declare variable FECCONTA VARCHAR(8);
declare variable FECBLO VARCHAR(8);
BEGIN
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'POS', 'CAMBIAR FECHA DE BLOQUEO AUTOMATICAMENTE AL CAMBIAR FECHA DE LA FACTURA') RETURNING_VALUES (:bloqauto);
if (bloqauto = 'SI') then
    BEGIN
    EXECUTE PROCEDURE LEE_CONFIGURACION ('CONTABILIDAD', 'GENERAL', 'FECHA DE BLOQUEO') RETURNING_VALUES (:FECBLO);
    EXECUTE PROCEDURE fecha_a_conta (NEW.fact_fecha) returning_values (:FECCONTA);
    if (FECBLO > FECCONTA) then
        EXCEPTION CONTABILIDAD_BLOQUEADA;
    if (FECBLO < FECCONTA) then
        UPDATE CONFIGURACION
            SET CONF_VALOR = :FECCONTA
            WHERE (CONF_MODULO = 'CONTABILIDAD') AND (CONF_CATEGORIA = 'GENERAL') AND (CONF_PROPIEDAD = 'FECHA DE BLOQUEO');
    END
OK = 'S';
EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'ACCION A TOMAR SI EL CUPO DE CREDITO ES INSUFICIENTE') RETURNING_VALUES (:VALCUPO);
select auto_contado from autorizaciones where pref_pre = new.pref_pre and tido_cod = 31 into :contado;
if (contado='N') then
BEGIN
  IF (VALCUPO = 'PROHIBIR') THEN
  BEGIN
  OK = 'N';
  /* VERIFIQUE EL CUPO DE CREDITO */
  execute procedure cupo_disponible(new.TERC_NIT, NEW.fact_fecha, NEW.fact_sucursal) returning_values (:DISPONIBLE);
  if (DISPONIBLE >= NEW.FACT_TOTAL) then
    OK = 'S';
  END
END
IF (OK = 'S') THEN
  begin
  /* calcule la comision */
  EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'VENDEDORES', 'COMISIONES EN VENTA INCLUYENDO IMPUESTOS') returning_values (:SITOT);
  if ((NEW.fact_comiporc IS NULL) or (NEW.fact_comiporc = 0)) THEN
    BEGIN
    if (SITOT = 'SI') then
      SELECT MAX(COMI_PORC) FROM comisiones WHERE VEND_COD = NEW.vend_cod AND
        COMI_INICIAL <= NEW.fact_total AND COMI_FINAL >= NEW.fact_total
        INTO NEW.fact_comiporc;
    else
      SELECT MAX(COMI_PORC) FROM comisiones WHERE VEND_COD = NEW.vend_cod AND
        COMI_INICIAL <= (NEW.fact_total -NEW.fact_ivamonto) AND COMI_FINAL >= (NEW.fact_total -NEW.fact_ivamonto)
        INTO NEW.fact_comiporc;
    if (NEW.fact_comiporc IS NULL) then
        NEW.fact_comiporc = 0;
    END
  if (SITOT = 'SI') then
      NEW.fact_comimonto = NEW.fact_total * NEW.fact_comiporc / 100;
  ELSE
      NEW.fact_comimonto = (NEW.fact_total -NEW.fact_ivamonto) * NEW.fact_comiporc / 100;

  if (NEW.numok = 'N') then
    BEGIN
    /* Actualice el contador del prefijo */
    SELECT PREF_ACTUAL, PREF_AUTO FROM PREFIJOS WHERE TIDO_COD = 31 AND PREF_PRE = NEW.PREF_PRE INTO :NUMERO, :AUTOM;
    /* ACTUALICE EL NUMERO EN ENCABEZADO  */
    if (AUTOM = 'S') then
        BEGIN
        NEW.FACT_NUMERO = NUMERO;
        NUMERO = CAST((CAST(NUMERO AS INTEGER) + 1) AS CHAR(6));
        UPDATE PREFIJOS
            SET PREF_ACTUAL = :NUMERO
            WHERE TIDO_COD = 31 AND PREF_PRE = NEW.PREF_PRE;
        END
    ELSE
        BEGIN
        if (CAST(NUMERO AS INTEGER) = CAST(NEW.FACT_NUMERO AS INTEGER)) then
            UPDATE PREFIJOS
                SET PREF_ACTUAL = CAST((CAST(PREF_ACTUAL AS INTEGER) + 1) AS CHAR(6))
                WHERE TIDO_COD = 31 AND PREF_PRE = NEW.PREF_PRE;
        END
    EXECUTE PROCEDURE COMPLETA_CEROS (NEW.FACT_numero) returning_values (NEW.FACT_numero);
    NEW.numok = 'S';
    END
  /* Verifique que el numero no existe previamente */
  EXISTE = 'N';
  SELECT 'S' FROM FACTURAS WHERE PREF_PRE = NEW.PREF_PRE AND FACT_NUMERO = NEW.FACT_NUMERO INTO :EXISTE;
  if (EXISTE = 'S') then
    EXCEPTION DOCUMENTO_REGISTRADO;
  end
else
  begin
  EXCEPTION CUPO_INSUFICIENTE;
  end

select COBR_COD, VEND_COD FROM CLIENTE_SUCURSALES WHERE TERC_NIT = NEW.terc_nit AND CLCU_COD = NEW.fact_sucursal INTO :CODCOBR, CODVEND;
if (NEW.vend_cod IS NULL) then
    NEW.vend_cod = :CODVEND;
if (NEW.cobr_cod IS NULL) then
    BEGIN
    EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'COMISIONES', 'UNIFICAR CODIGOS DE VENDEDORES Y COBRADORES') returning_values (:SITOT);
    if ((SITOT = 'SI') AND (NEW.vend_cod IS NOT NULL)) then
        NEW.cobr_cod = NEW.vend_cod;
    else
        NEW.cobr_cod = :CODCOBR;
    END
if ((new.FACT_TOTAL-new.FACT_IVAMONTO+new.FACT_DTOMONTO-new.FACT_ADICIONAL) = 0) then
    NEW.FACT_FACTOR = 1;
else
    NEW.FACT_FACTOR = (new.FACT_TOTAL-new.FACT_IVAMONTO)/(new.FACT_TOTAL-new.FACT_IVAMONTO+new.FACT_DTOMONTO-new.FACT_ADICIONAL);

select auto_numero from autorizaciones where auto_inicial <= new.fact_numero and auto_final >= new.fact_numero and auto_fecha <= new.fact_fecha and auto_vence >= new.fact_fecha and pref_pre = new.pref_pre into new.auto_numero;
END
^

SET TERM ; ^

GRANT SELECT,UPDATE,REFERENCES ON FACTURAS TO TRIGGER FACTURAS_BI;
GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO TRIGGER FACTURAS_BI;
GRANT EXECUTE ON PROCEDURE FECHA_A_CONTA TO TRIGGER FACTURAS_BI;
GRANT SELECT,UPDATE ON CONFIGURACION TO TRIGGER FACTURAS_BI;
GRANT SELECT ON AUTORIZACIONES TO TRIGGER FACTURAS_BI;
GRANT EXECUTE ON PROCEDURE CUPO_DISPONIBLE TO TRIGGER FACTURAS_BI;
GRANT SELECT ON COMISIONES TO TRIGGER FACTURAS_BI;
GRANT SELECT,UPDATE ON PREFIJOS TO TRIGGER FACTURAS_BI;
GRANT EXECUTE ON PROCEDURE COMPLETA_CEROS TO TRIGGER FACTURAS_BI;
GRANT SELECT ON CLIENTE_SUCURSALES TO TRIGGER FACTURAS_BI;

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('FACTURACION', 'POS', 'CAMBIAR FECHA DE BLOQUEO AUTOMATICAMENTE AL CAMBIAR FECHA DE LA FACTURA', 'NO', 'SI,NO', 'SI: El sistema modificar automticamente la fecha de bloqueo contable cada vez que se grabe una factura con fecha posterior al bloqueo impidiendo nuevos registros de fechas anteriores');
commit work;

SET TERM ^ ;

CREATE OR ALTER TRIGGER COMPROBANTE_DETALLE_AU FOR COMPROBANTE_DETALLE
ACTIVE AFTER UPDATE POSITION 0
AS
DECLARE VARIABLE FECHA CHAR(8);
DECLARE VARIABLE DIF_DB NUMERIC(15,2);
DECLARE VARIABLE DIF_CR NUMERIC(15,2);
BEGIN
/* DESHAGA LO VIEJO */
SELECT ENCO_FECHA FROM COMPROBANTE_ENCABEZADO WHERE ENCO_CONSEC = NEW.ENCO_CONSEC INTO :FECHA;
DIF_DB = - OLD.CODE_DEBITO;
DIF_CR = - OLD.CODE_CREDITO;
EXECUTE PROCEDURE ACTUALICE_SALDO_CENTRO_TERCERO(OLD.CUEN_COD, OLD.PROY_COD, OLD.CENT_COD, OLD.TERC_NIT, FECHA, DIF_DB, DIF_CR);
EXECUTE PROCEDURE ACTUALICE_SALDO_CENTRO(OLD.CUEN_COD, OLD.PROY_COD, OLD.CENT_COD, FECHA, DIF_DB, DIF_CR);
EXECUTE PROCEDURE ACTUALICE_SALDO_TERCERO(OLD.CUEN_COD, OLD.TERC_NIT, FECHA, DIF_DB, DIF_CR);
EXECUTE PROCEDURE ACTUALICE_SALDO_CUENTA(OLD.CUEN_COD, FECHA, DIF_DB, DIF_CR);
if (OLD.ARTI_COD IS NOT NULL) then
    EXECUTE PROCEDURE ACTUALICE_SALDO_ARTICULO(OLD.CUEN_COD, OLD.ARTI_COD, FECHA, DIF_DB, DIF_CR);
/* GRABE LOS NUEVOS */
SELECT ENCO_FECHA FROM COMPROBANTE_ENCABEZADO WHERE ENCO_CONSEC = NEW.ENCO_CONSEC INTO :FECHA;
EXECUTE PROCEDURE ACTUALICE_SALDO_CENTRO_TERCERO(NEW.CUEN_COD, NEW.PROY_COD, NEW.CENT_COD, NEW.TERC_NIT, FECHA, NEW.CODE_DEBITO, NEW.CODE_CREDITO);
EXECUTE PROCEDURE ACTUALICE_SALDO_CENTRO(NEW.CUEN_COD, NEW.PROY_COD, NEW.CENT_COD, FECHA, NEW.CODE_DEBITO, NEW.CODE_CREDITO);
EXECUTE PROCEDURE ACTUALICE_SALDO_TERCERO(NEW.CUEN_COD, NEW.TERC_NIT, FECHA, NEW.CODE_DEBITO, NEW.CODE_CREDITO);
EXECUTE PROCEDURE ACTUALICE_SALDO_CUENTA(NEW.CUEN_COD, FECHA, NEW.CODE_DEBITO, NEW.CODE_CREDITO);
if (NEW.ARTI_COD IS NOT NULL) then
    EXECUTE PROCEDURE ACTUALICE_SALDO_ARTICULO(NEW.CUEN_COD, NEW.ARTI_COD, FECHA, NEW.code_debito, NEW.code_credito);
END
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON COMPROBANTE_DETALLE TO TRIGGER COMPROBANTE_DETALLE_AU;
GRANT SELECT ON COMPROBANTE_ENCABEZADO TO TRIGGER COMPROBANTE_DETALLE_AU;
GRANT EXECUTE ON PROCEDURE ACTUALICE_SALDO_CENTRO_TERCERO TO TRIGGER COMPROBANTE_DETALLE_AU;
GRANT EXECUTE ON PROCEDURE ACTUALICE_SALDO_CENTRO TO TRIGGER COMPROBANTE_DETALLE_AU;
GRANT EXECUTE ON PROCEDURE ACTUALICE_SALDO_TERCERO TO TRIGGER COMPROBANTE_DETALLE_AU;
GRANT EXECUTE ON PROCEDURE ACTUALICE_SALDO_CUENTA TO TRIGGER COMPROBANTE_DETALLE_AU;
GRANT EXECUTE ON PROCEDURE ACTUALICE_SALDO_ARTICULO TO TRIGGER COMPROBANTE_DETALLE_AU;


/* 20080709b compras, recalcular precio unitario */

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('COMPRAS', 'DOCUMENTOS', 'RECALCULAR COSTOS UNITARIOS AL CAMBIAR IMPUESTOS INCLUIDOS', 'NO', 'SI,NO', 'SI: Al cambiar la condicin de impuestos incluidos en el encabezado se recalculan todos los precios unitarios y los impuestos. NO: Se conserva el mismo precio unitario originalmente digitado y se recalculan los impuestos');
commit work;


/* 20080714 */

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('COMPRAS', 'DOCUMENTOS', 'SUGERIR ULTIMO COSTO POR PROVEEDOR O GENERAL PARA EL ARTICULO', 'PROVEEDOR', 'PROVEEDOR,GENERAL', 'PROVEEDOR:Suguiere el ltimo costo para el proveedor especfico del documento, GENERAL: Suguiere el ultimo costo del artculo');
commit work;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE COSTO_PROVEEDOR(
    NIT VARCHAR(20),
    ARTI VARCHAR(15),
    FECHA DATE)
RETURNS (
    COSTO NUMERIC(18,2))
AS
declare variable UNIDAD VARCHAR(8);
declare variable porprov char(10);
BEGIN
execute procedure lee_configuracion('COMPRAS', 'DOCUMENTOS', 'SUGERIR ULTIMO COSTO POR PROVEEDOR O GENERAL PARA EL ARTICULO') returning_values (:porprov);
/* busque el costo del proveedor, cuendo no hay trae el ultimo */
SELECT PVAR_COSTO FROM PROVEEDOR_ARTICULO
    WHERE TERC_NIT = :Nit AND ARTI_COD = :ARTI
    INTO :COSTO;
if ((COSTO IS NULL) or (PORPROV = 'GENERAL')) then
    BEGIN
    SELECT ARTI_UNIDAD FROM ARTICULO WHERE ARTI_COD = :ARTI INTO :UNIDAD;
    EXECUTE PROCEDURE ultimo_costo(:ARTI, :FECHA, :UNIDAD) returning_values (:COSTO);
    END
SUSPEND;
END
^

SET TERM ; ^

GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO PROCEDURE COSTO_PROVEEDOR;
GRANT SELECT ON PROVEEDOR_ARTICULO TO PROCEDURE COSTO_PROVEEDOR;
GRANT SELECT ON ARTICULO TO PROCEDURE COSTO_PROVEEDOR;
GRANT EXECUTE ON PROCEDURE ULTIMO_COSTO TO PROCEDURE COSTO_PROVEEDOR;

/* 20080715 */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE EXISTE_TERCERO(
    NIT VARCHAR(20))
RETURNS (
    OK CHAR(1))
AS
BEGIN
  OK = 'N';
  SELECT 'S' FROM TERCEROS WHERE TERC_NIT = :NIT AND TERC_ESTADO = 'S' INTO :OK;
  SUSPEND;
END
^

SET TERM ; ^

GRANT SELECT ON TERCEROS TO PROCEDURE EXISTE_TERCERO;

SET TERM ^ ;

ALTER TRIGGER COMPROBANTE_DETALLE_BI
AS
DECLARE VARIABLE OK CHAR(1);
DECLARE VARIABLE TERCERO CHAR(1);
DECLARE VARIABLE RETENCION CHAR(1);
DECLARE VARIABLE CENTRO CHAR(1);
declare variable TIPO CHAR(1);
declare variable TICO VARCHAR(3);
declare variable NUMCOMP VARCHAR(10);
BEGIN
SELECT TICO_COD, PRCO_PREF || ENCO_NUMERO FROM COMPROBANTE_ENCABEZADO WHERE ENCO_CONSEC = NEW.enco_consec INTO :TICO, :numcomp;
/* VERIFIQUE QUE LA CUENTA EXISTA Y QUE SEA AFECTABLE */
EXECUTE PROCEDURE VALIDE_CUENTA (NEW.CUEN_COD) RETURNING_VALUES (:OK);
IF (OK = 'S') THEN
  BEGIN
  IF (NEW.CODE_DEBITO IS NULL) THEN
    NEW.CODE_DEBITO = 0;
  IF (NEW.CODE_CREDITO IS NULL) THEN
    NEW.CODE_CREDITO = 0;
  if (NEW.code_base IS NULL) then
    NEW.CODE_BASE = 0;
  if (NEW.code_porc IS NULL) then
    NEW.CODE_PORC = 0;
  if ((NEW.code_base <> 0) AND (NEW.CODE_PORC = 0) AND ((NEW.code_debito <> 0) or (NEW.code_credito <> 0))) then
    NEW.code_porc = (NEW.code_debito - NEW.code_credito) * 100 / NEW.code_base;
  IF ((NEW.TERC_NIT IS NULL) or (new.terc_nit = '')) THEN
    EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'NIT COMPAIA') RETURNING_VALUES (NEW.TERC_NIT);
  IF ((NEW.PROY_COD IS NULL) or (new.proy_cod = '')) THEN
    EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'PROYECTO UNICO') RETURNING_VALUES (NEW.PROY_COD);
  IF ((NEW.CENT_COD IS NULL) or (new.cent_cod = '')) THEN
    EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'CENTRO DE COSTOS UNICO') RETURNING_VALUES (NEW.CENT_COD);
  SELECT CUEN_TERCERO, CUEN_RETENCION, CUEN_CENTRO, CUEN_TIPO FROM CUENTAS WHERE CUEN_COD = NEW.CUEN_COD INTO :TERCERO, :RETENCION, :CENTRO, :TIPO;
  /* VERIFIQUE QUE LA CUENTA PERMITA RETENCION Y VERIFIQUE EL TERCERO */
  IF (TERCERO = 'S' OR RETENCION = 'S') THEN
    EXECUTE PROCEDURE EXISTE_TERCERO (NEW.TERC_NIT) RETURNING_VALUES (:OK);
  ELSE
    EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'NIT COMPAIA') RETURNING_VALUES (NEW.TERC_NIT);
  IF (OK = 'S') THEN
    BEGIN
    /* SI LA CUENTA ES DE RETENCION ASEGURECE QUE TENGA BASE Y PORCENTAJE */
    IF (RETENCION = 'S') THEN
      BEGIN
      IF ((NEW.CODE_BASE = 0) OR (NEW.CODE_PORC = 0)) THEN
        EXCEPTION FALTA_BASE :tico || '-' || :numcomp || ' FALTA INDICAR LA BASE PARA LA CUENTA ' || NEW.cuen_cod;
      END
    ELSE
       BEGIN
      IF (CENTRO = 'S') THEN
        EXECUTE PROCEDURE EXISTE_CENTRO (NEW.PROY_COD, NEW.CENT_COD) RETURNING_VALUES (:OK);
        ELSE
        BEGIN
        EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'PROYECTO UNICO') RETURNING_VALUES (NEW.PROY_COD);
        EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'CENTRO DE COSTOS UNICO') RETURNING_VALUES (NEW.CENT_COD);
          END
        END
    END
  if (:TIPO = 'I') then
    BEGIN
    if (NEW.ARTI_COD IS NULL) then
        EXCEPTION FALTA_ARTICULO :tico || '-' || :numcomp || ' FALTA INDICAR EL ARTICULO PARA LA CUENTA ' || NEW.cuen_cod;
    END
  END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER TRIGGER PLANTILLA_DETALLE_BI
AS
DECLARE VARIABLE OK CHAR(1);
DECLARE VARIABLE TERCERO CHAR(1);
DECLARE VARIABLE RETENCION CHAR(1);
DECLARE VARIABLE CENTRO CHAR(1);
declare variable TIPO CHAR(1);
BEGIN
/* VERIFIQUE QUE LA CUENTA EXISTA Y QUE SEA AFECTABLE */
EXECUTE PROCEDURE VALIDE_CUENTA (NEW.CUEN_COD) RETURNING_VALUES (:OK);
IF (OK = 'S') THEN
  BEGIN
  IF (NEW.PLDE_DEBITOS IS NULL) THEN
        NEW.PLDE_DEBITOS = 0;
        IF (NEW.PLDE_CREDITOS IS NULL) THEN
          NEW.PLDE_CREDITOS = 0;
    if (NEW.plde_base IS NULL) then
    NEW.PLDE_BASE = 0;
    if (NEW.plde_porc IS NULL) then
    NEW.PLDE_PORC = 0;
  IF (NEW.TERC_NIT IS NULL) THEN
    EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'NIT COMPAIA') RETURNING_VALUES (NEW.TERC_NIT);
  IF (NEW.PROY_COD IS NULL) THEN
    EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'PROYECTO UNICO') RETURNING_VALUES (NEW.PROY_COD);
  IF (NEW.CENT_COD IS NULL) THEN
    EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'CENTRO DE COSTOS UNICO') RETURNING_VALUES (NEW.CENT_COD);
  SELECT CUEN_TERCERO, CUEN_RETENCION, CUEN_CENTRO, CUEN_TIPO FROM CUENTAS WHERE CUEN_COD = NEW.CUEN_COD INTO :TERCERO, :RETENCION, :CENTRO, :TIPO;
  /* VERIFIQUE QUE LA CUENTA PERMITA RETENCION Y VERIFIQUE EL TERCERO */
  IF (TERCERO = 'S' OR RETENCION = 'S') THEN
    EXECUTE PROCEDURE EXISTE_TERCERO (NEW.TERC_NIT) RETURNING_VALUES (:OK);
  ELSE
    EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'NIT COMPAIA') RETURNING_VALUES (NEW.TERC_NIT);
  IF (OK = 'S') THEN
    BEGIN
    /* SI LA CUENTA ES DE RETENCION ASEGURECE QUE TENGA BASE Y PORCENTAJE */
    IF (RETENCION = 'S') THEN
      BEGIN
      IF ((NEW.PLDE_BASE = 0) OR (NEW.PLDE_PORC = 0)) THEN
        EXCEPTION FALTA_BASE 'FALTA INDICAR LA BASE PARA LA CUENTA ' || NEW.cuen_cod;
      END
    ELSE
       BEGIN
      IF (CENTRO = 'S') THEN
        EXECUTE PROCEDURE EXISTE_CENTRO (NEW.PROY_COD, NEW.CENT_COD) RETURNING_VALUES (:OK);
        ELSE
        BEGIN
        EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'PROYECTO UNICO') RETURNING_VALUES (NEW.PROY_COD);
        EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'CENTRO DE COSTOS UNICO') RETURNING_VALUES (NEW.CENT_COD);
          END
      END
  END
  if (:TIPO = 'I') then
    BEGIN
    if (NEW.ARTI_COD IS NULL) then
        EXCEPTION FALTA_ARTICULO 'FALTA INDICAR EL ARTICULO PARA LA CUENTA ' || NEW.cuen_cod;
    END
END
END
^

SET TERM ; ^

SET TERM ^ ;

ALTER TRIGGER SALDOS_INICIALES_BI
AS
DECLARE VARIABLE OK CHAR(1);
DECLARE VARIABLE TERCERO CHAR(1);
DECLARE VARIABLE RETENCION CHAR(1);
DECLARE VARIABLE CENTRO CHAR(1);
BEGIN
/* VERIFIQUE QUE LA CUENTA EXISTA Y QUE SEA AFECTABLE */
EXECUTE PROCEDURE VALIDE_CUENTA (NEW.CUEN_COD) RETURNING_VALUES (:OK);
IF (OK <> '0') THEN
  BEGIN
  IF (NEW.sain_debito IS NULL) THEN
    NEW.sain_debito = 0;
  IF (NEW.sain_credito IS NULL) THEN
    NEW.sain_credito = 0;
  IF (NEW.TERC_NIT IS NULL) THEN
    EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'NIT COMPAIA') RETURNING_VALUES (NEW.TERC_NIT);
  IF (NEW.PROY_COD IS NULL) THEN
    EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'PROYECTO UNICO') RETURNING_VALUES (NEW.PROY_COD);
  IF (NEW.CENT_COD IS NULL) THEN
    EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'CENTRO DE COSTOS UNICO') RETURNING_VALUES (NEW.CENT_COD);
  SELECT CUEN_TERCERO, CUEN_RETENCION, CUEN_CENTRO FROM CUENTAS WHERE CUEN_COD = NEW.CUEN_COD INTO :TERCERO, :RETENCION, :CENTRO;
  /* VERIFIQUE EL TERCERO */
  IF (TERCERO = 'S' OR RETENCION = 'S') THEN
    EXECUTE PROCEDURE EXISTE_TERCERO (NEW.TERC_NIT) RETURNING_VALUES (:OK);
  ELSE
    EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'NIT COMPAIA') RETURNING_VALUES (NEW.TERC_NIT);
  IF (CENTRO = 'S') THEN
    EXECUTE PROCEDURE EXISTE_CENTRO (NEW.PROY_COD, NEW.CENT_COD) RETURNING_VALUES (:OK);
  ELSE
    BEGIN
    EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'PROYECTO UNICO') RETURNING_VALUES (NEW.PROY_COD);
    EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'CENTRO DE COSTOS UNICO') RETURNING_VALUES (NEW.CENT_COD);
    END
  IF (OK = 'S') THEN
    BEGIN
    IF (NEW.SAIN_DEBITO IS NULL) THEN
      NEW.SAIN_DEBITO = 0;
    IF (NEW.SAIN_CREDITO IS NULL) THEN
      NEW.SAIN_CREDITO = 0;
    END
  END
END
^

SET TERM ; ^



/* CANTIDAD COMPRADA EN LA ULTIMA FECHA */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE EXISTENCIAS_COMPRAS(
    ARTICULO VARCHAR(15),
    FECHA DATE,
    UNIDAD VARCHAR(8))
RETURNS (
    BODEGA VARCHAR(2),
    EXISTENCIA NUMERIC(18,4),
    RESERVADO NUMERIC(18,4),
    ORDENADO NUMERIC(18,4),
    PROMEDIO NUMERIC(18,4),
    VENTAMES NUMERIC(18,4),
    FECHACMP DATE,
    CANTCMP NUMERIC(18,4),
    DIAS INTEGER,
    SUGERIDO NUMERIC(18,4),
    STAND VARCHAR(15))
AS
declare variable FACTOR NUMERIC(15,4);
declare variable ORDENC NUMERIC(18,4);
declare variable PEDIDO NUMERIC(18,4);
declare variable ITEM INTEGER;
declare variable ID INTEGER;
declare variable UND VARCHAR(8);
declare variable CANT NUMERIC(18,4);
declare variable FACTOR2 NUMERIC(18,4);
declare variable fecini DATE;
declare variable FECHAAUX VARCHAR(10);
declare variable AGENCIA INTEGER;
declare variable DEVMES NUMERIC(18,2);
declare variable MFAC INTEGER;
declare variable MDEV INTEGER;
declare variable IVAF NUMERIC(18,2);
declare variable IVAD NUMERIC(18,2);
declare variable DIA_ART VARCHAR(2) CHARACTER SET NONE;
declare variable DIASC VARCHAR(255);
declare variable PEDAUTO CHAR(2);
declare variable SALIDAS NUMERIC(18,4);
BEGIN
  for select bode_cod, SUCU_ID from bodega into :bodega, :agencia
    do
    begin
    execute procedure saldo_inventario (:articulo, :bodega, :fecha) returning_values (:Existencia);
    EXECUTE PROCEDURE FACTOR_UNIDAD_CANT(:ARTICULO, :UNIDAD) returning_values (:FACTOR);
    if (FACTOR <> 0) then
        EXISTENCIA = EXISTENCIA / FACTOR;
    else
        EXISTENCIA = 0;
    SELECT MAX(EXIS_STAND) FROM EXISTENCIA WHERE ARTI_COD = :ARTICULO AND BODE_COD = :BODEGA INTO :STAND;
    EXECUTE PROCEDURE promedio_salidas_articulo (:ARTICULO, :FECHA, :BODEGA) returning_values (:PROMEDIO, :SALIDAS);
    EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'PROMEDIAR LAS SALIDAS DEL INVENTARIO CON EL NUMERO DE DIAS ASIGNADO A CADA ARTICULO') returning_values (:DIA_ART);
    if (DIA_ART = 'NO') then
        BEGIN
        EXECUTE PROCEDURE lee_configuracion ('INVENTARIO', 'EXISTENCIAS', 'NUMERO DE DIAS PARA PROMEDIO DE SALIDAS POR ARTICULO') returning_values (DIASC);
        DIAS = CAST(DIASC AS INTEGER);
        END
    ELSE
        SELECT ARTI_DIAS FROM ARTICULO WHERE ARTI_COD = :ARTICULO INTO :DIAS;
    if (DIAS is null) then
        DIAS = 0;
    PROMEDIO = DIAS * PROMEDIO;
    if (FACTOR <> 0) then
        PROMEDIO = PROMEDIO / FACTOR;
    SUGERIDO = PROMEDIO - EXISTENCIA;
    SELECT SUM(ORID_ENTREGAR)
      FROM ORDENINVENTARIO_DETALLE OD, ordenes_inventario O
      WHERE O.ORIN_ID = OD.ORIN_ID AND ARTI_COD = :ARTICULO AND ORIN_FECHA <= :FECHA AND ORIN_FECLLEGA >= :FECHA AND ORID_ANULADO = 'N' AND OD.BODE_COD = :BODEGA
      INTO :ORDENADO;
    if (ORDENADO IS NULL) then
        ORDENADO = 0;
    ORDENC = 0;
    FOR SELECT O.ORDC_ID, OCDE_ITEM, OCDE_CANT * OCDE_FACTOR
        FROM ORDENES_COMPRA O, ORDENES_COMPRA_DETALLE OD
        WHERE O.ORDC_ID = OD.ORDC_ID AND OD.ARTI_COD = :ARTICULO AND (ORDC_FECHA+ORDC_VALIDEZ) >= :FECHA AND ORDC_FECHA <= :FECHA AND OCDE_ANULADO = 'N' AND OD.BODE_COD = :BODEGA
        INTO :ID, :ITEM, :CANT
        do
        BEGIN
        EXECUTE PROCEDURE FALTANTE(23, 21, ID, ITEM) returning_values (PEDIDO, UND, FACTOR2);
        if (PEDIDO * FACTOR2 = CANT) then /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */
            EXECUTE PROCEDURE FALTANTE(23, 22, ID, ITEM) returning_values (PEDIDO, UND, FACTOR2);
        if (PEDIDO IS NULL) then
            PEDIDO = 0;
        ORDENC = ORDENC + PEDIDO * FACTOR2;
        END
    ORDENADO = ORDENADO + ORDENC;
    if (FACTOR <> 0) then
        ORDENADO = ORDENADO / FACTOR;
    SELECT SUM(RSDE_LIBERAR)
      FROM RESERVAS_DETALLE RD, RESERVAS R
      WHERE R.RESE_ID = RD.RESE_ID AND ARTI_COD = :ARTICULO AND RESE_FECHA <= :FECHA AND RESE_VENCE >= :FECHA AND RD.BODE_COD = :BODEGA AND RSDE_ANULADO = 'N'
      INTO :RESERVADO;
    if (RESERVADO IS NULL) then
        RESERVADO = 0;
    PEDIDO = 0;
    FOR SELECT P.PEDI_ID, PEDE_ITEM, PEDE_CANT * PEDE_FACTOR
        FROM PEDIDOS P, PEDIDOS_DETALLE PD
        WHERE P.PEDI_ID = PD.PEDI_ID AND PD.ARTI_COD = :ARTICULO AND (PEDI_FECHA+PEDI_VALIDEZ) >= :FECHA AND PEDI_FECHA <= :FECHA AND PEDE_ANULADO = 'N' AND BODE_COD = :BODEGA
        INTO :ID, :ITEM, :CANT
        do
        BEGIN
        EXECUTE PROCEDURE FALTANTE(34, 31, ID, ITEM) returning_values (ORDENC, UND, FACTOR2);
        EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'FACTURAS', 'GENERAR PEDIDO AUTOMATICAMENTE CON LA FACTURA') returning_values (pedauto);
        if ((ORDENC * FACTOR2 = CANT) or (PEDAUTO = 'SI')) then /* SI NO SE HA FACTURADO MIRE A VER SI SE REMISIONO */
            EXECUTE PROCEDURE FALTANTE(34, 32, ID, ITEM) returning_values (ORDENC, UND, FACTOR2);
        if (ORDENC IS NULL) then
            ORDENC = 0;
        PEDIDO = PEDIDO + ORDENC * FACTOR2;
        END
    RESERVADO = RESERVADO + PEDIDO;
    if (FACTOR <> 0) then
        RESERVADO = RESERVADO / FACTOR;
    /* VENTAS MES */
    FECHAAUX = CAST (FECHA AS VARCHAR(10));
    FECHAAUX = SUBSTR(FECHAAUX, 1, 7) || '/01';
    FECINI = CAST (FECHAAUX AS DATE);
    EXECUTE PROCEDURE ventas_articulo (:ARTICULO, :FECINI, :FECHA, :agencia) returning_values (:ventames, :mfac, :devmes, :mdev, :ivaf, :ivad);
    ventames = ventames - devmes;
    if (FACTOR <> 0) then
        ventames = ventames / FACTOR;
    /* FECHA COMPRA */
    SELECT FIRST 1 FACO_FECHA, FCDE_CANT * FCDE_FACTOR FROM FACTURAS_COMPRA F, FACTURAS_COMPRAS_DETALLE D
        WHERE F.FACO_ID = D.faco_id AND D.ARTI_COD = :articulo AND FACO_FECHA <= :FECHA AND D.bode_cod = :BODEGA
        ORDER BY FACO_FECHA DESC, F.FACO_ID DESC
        INTO :fechacmp, :cantcmp;
    SUSPEND;
    end
END
^

SET TERM ; ^

GRANT SELECT ON BODEGA TO PROCEDURE EXISTENCIAS_COMPRAS;
GRANT EXECUTE ON PROCEDURE SALDO_INVENTARIO TO PROCEDURE EXISTENCIAS_COMPRAS;
GRANT EXECUTE ON PROCEDURE FACTOR_UNIDAD_CANT TO PROCEDURE EXISTENCIAS_COMPRAS;
GRANT SELECT ON EXISTENCIA TO PROCEDURE EXISTENCIAS_COMPRAS;
GRANT EXECUTE ON PROCEDURE PROMEDIO_SALIDAS_ARTICULO TO PROCEDURE EXISTENCIAS_COMPRAS;
GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO PROCEDURE EXISTENCIAS_COMPRAS;
GRANT SELECT ON ARTICULO TO PROCEDURE EXISTENCIAS_COMPRAS;
GRANT SELECT ON ORDENINVENTARIO_DETALLE TO PROCEDURE EXISTENCIAS_COMPRAS;
GRANT SELECT ON ORDENES_INVENTARIO TO PROCEDURE EXISTENCIAS_COMPRAS;
GRANT SELECT ON ORDENES_COMPRA TO PROCEDURE EXISTENCIAS_COMPRAS;
GRANT SELECT ON ORDENES_COMPRA_DETALLE TO PROCEDURE EXISTENCIAS_COMPRAS;
GRANT EXECUTE ON PROCEDURE FALTANTE TO PROCEDURE EXISTENCIAS_COMPRAS;
GRANT SELECT ON RESERVAS_DETALLE TO PROCEDURE EXISTENCIAS_COMPRAS;
GRANT SELECT ON RESERVAS TO PROCEDURE EXISTENCIAS_COMPRAS;
GRANT SELECT ON PEDIDOS TO PROCEDURE EXISTENCIAS_COMPRAS;
GRANT SELECT ON PEDIDOS_DETALLE TO PROCEDURE EXISTENCIAS_COMPRAS;
GRANT EXECUTE ON PROCEDURE VENTAS_ARTICULO TO PROCEDURE EXISTENCIAS_COMPRAS;
GRANT SELECT ON FACTURAS_COMPRA TO PROCEDURE EXISTENCIAS_COMPRAS;
GRANT SELECT ON FACTURAS_COMPRAS_DETALLE TO PROCEDURE EXISTENCIAS_COMPRAS;



SET TERM ^ ;

CREATE OR ALTER PROCEDURE CHEQUEO_MOVIMIENTO_CXPAGAR(
    PRVINI VARCHAR(20),
    PRVFIN VARCHAR(20))
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6))
AS
declare variable FECHA DATE;
declare variable VENCE DATE;
declare variable NIT VARCHAR(20);
declare variable RTFTE NUMERIC(18, 2);
declare variable RTIVA NUMERIC(18, 2);
declare variable RTICA NUMERIC(18, 2);
declare variable MONTO NUMERIC(18, 2);
declare variable EXISTE CHAR(1);
declare variable IDR INTEGER;
declare variable NUMPROV VARCHAR(10);
declare variable CONC VARCHAR(60);
BEGIN
DELETE FROM anticipos_proveedor WHERE EGRE_ID = 0;
DELETE FROM MOVIMIENTO_PROVEEDOR WHERE TERC_NIT >= :PRVINI AND TERC_NIT <= :PRVFIN;

FOR SELECT FACO_ID, PREF_PRE, FACO_NUMERO, FACO_FECHA, FACO_VENCE, TERC_NIT, FACO_RTFTEMONTO, FACO_rtivamonto, FACO_rticamonto, FACO_TOTAL, FACO_NUMPROV
    FROM FACTURAS_COMPRA WHERE FACO_ID <> 0 and faco_anulado = 'N' AND TERC_NIT >= :PRVINI AND TERC_NIT <= :PRVFIN
    ORDER BY FACO_FECHA
    INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :nit,  :RTFTE, :RTIVA, :RTICA, :MONTO, :NUMPROV
    DO
    BEGIN
    CONC = 'FACTURA DE COMPRA No.' || :PREF || :NUMERO || ' - ' || :NUMPROV;
    INSERT INTO movimiento_proveedor(MVPR_ID, TERC_NIT, MVPR_TIPOREF, MVPR_IDREF, MVPR_FECHA, MVPR_VENCE, MVPR_CONC, MVPR_MONTO, MVPR_RTFTE, MVPR_RTIVA, MVPR_RTICA, MVPR_DEBITO, MVPR_ABONO, MVPR_PREFIJO, MVPR_NUMERO)
      VALUES (GEN_ID(ID_MOVPROV, 1), :NIT, 21, :ID, :FECHA, :VENCE, :CONC, :MONTO, :RTFTE, :RTIVA, :RTICA, 'S', 'N', :pref, :numero);
    END

FOR SELECT NDPR_ID, PREF_PRE, NDPR_NUMERO, NDPR_FECHA, NDPR_VENCE, NDPR_CONC, TERC_NIT, NDPR_RTFTEMONTO, NDPR_rtivamonto, NDPR_rticamonto, ndpr_monto+ndpr_ivamonto
    FROM notas_debito_proveedor WHERE NDPR_ID <> 0 and NDPR_anulado = 'N' AND TERC_NIT >= :PRVINI AND TERC_NIT <= :PRVFIN
    ORDER BY NDPR_FECHA
    INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :CONC, :nit,  :RTFTE, :RTIVA, :RTICA, :MONTO
    DO
    INSERT INTO MOVIMIENTO_PROVEEDOR (MVPR_ID, TERC_NIT, MVPR_TIPOREF, MVPR_IDREF, MVPR_FECHA, MVPR_VENCE, MVPR_CONC, MVPR_MONTO, MVPR_RTFTE, MVPR_RTIVA, MVPR_RTICA, MVPR_DEBITO, MVPR_ABONO, MVPR_PREFIJO, MVPR_NUMERO)
      VALUES (GEN_ID(ID_MOVPROV, 1), :NIT, 51, :ID, :FECHA, :VENCE, :CONC, :monto, :RTFTE, :RTIVA, :RTICA, 'S', 'N', :pref, :numero);

FOR SELECT DVCO_ID, PREF_PRE, DVCO_NUMERO, DVCO_FECHA, TERC_NIT, DVCO_RTFTEMONTO, DVCO_rtivamonto, DVCO_rticamonto, dvco_total
    FROM devoluciones_compras WHERE DVCO_ID <> 0 and DVCO_anulado = 'N' AND TERC_NIT >= :PRVINI AND TERC_NIT <= :PRVFIN
    ORDER BY DVCO_FECHA
    INTO :ID, :PREF, :NUMERO, :FECHA, :nit,  :RTFTE, :RTIVA, :RTICA, :MONTO
    DO
    BEGIN
    CONC = 'DEVOLUCION COMPRA No.' || PREF || NUMERO;
    INSERT INTO movimiento_proveedor (MVPR_ID, TERC_NIT, MVPR_TIPOREF, MVPR_IDREF, MVPR_FECHA, MVPR_VENCE, MVPR_CONC, MVPR_MONTO, MVPR_RTFTE, MVPR_RTIVA, MVPR_RTICA, MVPR_DEBITO, MVPR_ABONO, MVPR_PREFIJO, MVPR_NUMERO)
      VALUES (GEN_ID(ID_MOVPROV, 1), :NIT, 24, :ID, :FECHA, :FECHA, :CONC, :monto, :RTFTE, :RTIVA, :RTICA, 'N', 'N', :pref, :numero);
    END

FOR SELECT NCPR_ID, PREF_PRE, NCPR_NUMERO, NCPR_FECHA, NCPR_CONC, TERC_NIT, NCPR_RTFTEMONTO, NCPR_rtivamonto, NCPR_rticamonto, ncpr_monto+ncpr_ivamonto
    FROM notas_credito_proveedor WHERE NCPR_ID <> 0 and NCPR_anulado = 'N' AND TERC_NIT >= :PRVINI AND TERC_NIT <= :PRVFIN
    ORDER BY NCPR_FECHA
    INTO :ID, :PREF, :NUMERO, :FECHA, :CONC, :nit,  :RTFTE, :RTIVA, :RTICA, :MONTO
    DO
    INSERT INTO MOVIMIENTO_PROVEEDOR (MVPR_ID, TERC_NIT, MVPR_TIPOREF, MVPR_IDREF, MVPR_FECHA, MVPR_VENCE, MVPR_CONC, MVPR_MONTO, MVPR_RTFTE, MVPR_RTIVA, MVPR_RTICA, MVPR_DEBITO, MVPR_ABONO, MVPR_PREFIJO, MVPR_NUMERO)
      VALUES (GEN_ID(ID_MOVPROV, 1), :NIT, 52, :ID, :FECHA, :FECHA, :CONC, :MONTO, :RTFTE, :RTIVA, :RTICA, 'N', 'N', :pref, :numero);

FOR SELECT ANPR_ID, PREF_PRE, ANPR_NUMERO, ANPR_FECHA, ANPR_CONC, TERC_NIT, ANPR_RTFTEMONTO, ANPR_rtivamonto, ANPR_rticamonto, anpr_base+anpr_ivamonto
    FROM anticipos_proveedor WHERE ANPR_ID <> 0 and ANPR_anulado = 'N' AND TERC_NIT >= :PRVINI AND TERC_NIT <= :PRVFIN
    ORDER BY ANPR_FECHA
    INTO :ID, :PREF, :NUMERO, :FECHA, :CONC, :nit,  :RTFTE, :RTIVA, :RTICA, :MONTO
    DO
    INSERT INTO MOVIMIENTO_PROVEEDOR (MVPR_ID, TERC_NIT, MVPR_TIPOREF, MVPR_IDREF, MVPR_FECHA, MVPR_VENCE, MVPR_CONC, MVPR_MONTO, MVPR_RTFTE, MVPR_RTIVA, MVPR_RTICA, MVPR_DEBITO, MVPR_ABONO, MVPR_PREFIJO, MVPR_NUMERO)
      VALUES (GEN_ID(ID_MOVPROV, 1), :NIT, 55, :ID, :FECHA, :FECHA, :CONC, :monto, :RTFTE, :RTIVA, :RTICA, 'N', 'N', :pref, :numero);

FOR SELECT A.APPR_ID, PREF_PRE, APPR_NUMERO, APPR_FECHA, APPR_CONC, TERC_NIT, APPD_APLICADO, APPD_RTFTE, APPD_RTIVA, APPD_RTICA
    FROM APLICACION_PROVEEDOR_DETALLE D, aplicacion_provedor A
    WHERE A.APPR_ID = D.appr_id AND A.APPR_ID <> 0 AND APPR_ANULADO = 'N' AND TERC_NIT >= :PRVINI AND TERC_NIT <= :PRVFIN
    ORDER BY APPR_FECHA
    INTO :ID, :PREF, :NUMERO, :FECHA, :CONC, :NIT, :MONTO, :RTFTE, :RTIVA, :RTICA
    DO
    BEGIN
    EXISTE = 'N';
    SELECT 'S' FROM MOVIMIENTO_PROVEEDOR WHERE MVPR_TIPOREF = 53 AND MVPR_IDREF = :ID INTO :EXISTE;
    if (EXISTE = 'S') then
        begin
        UPDATE movimiento_proveedor
            SET MVPR_MONTO = MVPR_MONTO + :MONTO,
                MVPR_RTFTE = MVPR_RTFTE + :rtfte,
                MVPR_RTIVA = MVPR_RTIVA + :rtiva,
                MVPR_RTICA = MVPR_RTICA + :rtica
            WHERE MVPR_TIPOREF = 53 AND MVPR_IDREF = :ID;
        end
    ELSE
        INSERT INTO MOVIMIENTO_PROVEEDOR (MVPR_ID, TERC_NIT, MVPR_TIPOREF, MVPR_IDREF, MVPR_FECHA, MVPR_VENCE, MVPR_CONC, MVPR_MONTO, MVPR_RTFTE, MVPR_RTIVA, MVPR_RTICA, MVPR_DEBITO, MVPR_ABONO, MVPR_PREFIJO, MVPR_NUMERO)
            VALUES (GEN_ID(ID_MOVPROV, 1), :NIT, 53, :ID, :FECHA, :FECHA, :CONC, :MONTO, :RTFTE, :RTIVA, :RTICA, 'N', 'S', :PREF, :NUMERO);
    END

FOR SELECT E.EGRE_ID, PREF_PRE, EGRE_NUMERO, EGRE_FECHA, EGRE_CONC, TERC_NIT, EGDE_ABONO+EGDE_DTOF, EGDE_RTFTE, EGDE_RTIVA, EGDE_RTICA
    FROM EGRESOS_DETALLE D, EGRESOS E
    WHERE E.EGRE_ID = D.EGRE_ID AND E.EGRE_ID <> 0 AND EGRE_ANULADO = 'N' AND TERC_NIT >= :PRVINI AND TERC_NIT <= :PRVFIN
    ORDER BY EGRE_FECHA
    INTO :IDR, :PREF, :NUMERO, :FECHA, :CONC, :NIT, :MONTO, :RTFTE, :RTIVA, :RTICA
    DO
    BEGIN
    EXISTE = 'N';
    SELECT 'S' FROM MOVIMIENTO_PROVEEDOR WHERE MVPR_TIPOREF = 62 AND MVPR_IDREF = :ID INTO :EXISTE;
    if (EXISTE = 'S') then
        begin
        UPDATE movimiento_proveedor
            SET MVPR_MONTO = MVPR_MONTO + :MONTO,
                MVPR_RTFTE = MVPR_RTFTE + :rtfte,
                MVPR_RTIVA = MVPR_RTIVA + :rtiva,
                MVPR_RTICA = MVPR_RTICA + :rtica
            WHERE MVPR_TIPOREF = 62 AND MVPR_IDREF = :IDR;
        end
    ELSE
        INSERT INTO MOVIMIENTO_PROVEEDOR (MVPR_ID, TERC_NIT, MVPR_TIPOREF, MVPR_IDREF, MVPR_FECHA, MVPR_VENCE, MVPR_CONC, MVPR_MONTO, MVPR_RTFTE, MVPR_RTIVA, MVPR_RTICA, MVPR_DEBITO, MVPR_ABONO, MVPR_PREFIJO, MVPR_NUMERO)
            VALUES (GEN_ID(ID_MOVPROV, 1), :NIT, 62, :IDR, :FECHA, :FECHA, :CONC, :MONTO, :RTFTE, :RTIVA, :RTICA, 'N', 'S', :PREF, :NUMERO);
    END
END
^

SET TERM ; ^

GRANT SELECT,DELETE ON ANTICIPOS_PROVEEDOR TO PROCEDURE CHEQUEO_MOVIMIENTO_CXPAGAR;
GRANT SELECT,DELETE ON SALDOS_DOC_CXPAGAR TO PROCEDURE CHEQUEO_MOVIMIENTO_CXPAGAR;
GRANT SELECT,INSERT,DELETE,UPDATE ON MOVIMIENTO_PROVEEDOR TO PROCEDURE CHEQUEO_MOVIMIENTO_CXPAGAR;
GRANT SELECT ON FACTURAS_COMPRA TO PROCEDURE CHEQUEO_MOVIMIENTO_CXPAGAR;
GRANT SELECT ON NOTAS_DEBITO_PROVEEDOR TO PROCEDURE CHEQUEO_MOVIMIENTO_CXPAGAR;
GRANT SELECT ON DEVOLUCIONES_COMPRAS TO PROCEDURE CHEQUEO_MOVIMIENTO_CXPAGAR;
GRANT SELECT ON NOTAS_CREDITO_PROVEEDOR TO PROCEDURE CHEQUEO_MOVIMIENTO_CXPAGAR;
GRANT SELECT ON APLICACION_PROVEEDOR_DETALLE TO PROCEDURE CHEQUEO_MOVIMIENTO_CXPAGAR;
GRANT SELECT ON APLICACION_PROVEDOR TO PROCEDURE CHEQUEO_MOVIMIENTO_CXPAGAR;
GRANT SELECT ON EGRESOS_DETALLE TO PROCEDURE CHEQUEO_MOVIMIENTO_CXPAGAR;
GRANT SELECT ON EGRESOS TO PROCEDURE CHEQUEO_MOVIMIENTO_CXPAGAR;


/* 20080716 */
/* NO RESTE LAS RETENCIONES SI EL PARAMETRO DE DESCONTAR ESTA EN NO */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE CARTERA_CLIENTE(
    NIT VARCHAR(20),
    FECHA DATE,
    SUCURSAL VARCHAR(10))
RETURNS (
    TIPO INTEGER,
    ID INTEGER,
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    CONCEPTO VARCHAR(60),
    SALDO NUMERIC(18,2),
    RTFTE NUMERIC(18,2),
    RTIVA NUMERIC(18,2),
    RTICA NUMERIC(18,2),
    DTOF NUMERIC(18,2),
    TIPONOM VARCHAR(8),
    VENCE DATE,
    FECDOC DATE,
    DIAS INTEGER,
    RECPROV_ID INTEGER,
    RECIPROV CHAR(1),
    NOTA VARCHAR(256))
AS
declare variable FEC DATE;
declare variable DESC_RTES CHAR(2);
declare variable DTOAPL NUMERIC(18,2);
declare variable IDNOTA INTEGER;
declare variable AUTORET VARCHAR(10);
declare variable FAUTORET DATE;
BEGIN
  /* BUSQUE EN SALDOS_DOC_CARTERA LOS QUE TENGAN SALDO > 0 */
  FOR SELECT MVCL_TIPOREF, MVCL_IDREF, MVCL_FECHA, MVCL_VENCE, MVCL_PREFREF, MVCL_NUMREF, MVCL_CONC
  FROM MOVIMIENTO_CLIENTES
  WHERE TERC_NIT = :NIT AND mvcl_sucursal = :sucursal and MVCL_FECHA <= :FECHA AND MVCL_ABONO = 'N'
  INTO :TIPO, :ID, :FECDOC, :VENCE, :PREFIJO, :NUMERO, :CONCEPTO
    DO
    BEGIN
    DIAS = (FECHA -VENCE );
    EXECUTE PROCEDURE saldo_doc_cartera(TIPO, ID, FECHA) returning_values (SALDO);
    if (SALDO <> 0) then
        BEGIN
        SELECT TIDO_NOMCORTO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPO INTO :TIPONOM;
        if (TIPO = 41) then
            SELECT NDCL_DTOFMONTO, NDCL_FECHADTO FROM NOTAS_DEBITO_CLIENTES WHERE NDCL_ID = :ID INTO :DTOF, :FEC;
        if (TIPO = 42) then
            SELECT 0, NCCL_FECHA FROM NOTAS_CREDITO_CLIENTES WHERE NCCL_ID = :ID INTO :DTOF, :FEC;
        if (TIPO = 45) then
            SELECT ANCL_DTOFMONTO, ANCL_DTOFECHA FROM ANTICIPOS_CLIENTE WHERE ANCL_ID = :ID INTO :DTOF, :FEC;
        if (TIPO = 31) then
            SELECT FACT_DTOFMONTO, FACT_DTOFFECHA FROM FACTURAS WHERE FACT_ID = :ID INTO :DTOF, :FEC;
        if (TIPO = 33) then
                SELECT 0, :FECHA FROM devoluciones_ventas WHERE DEVT_ID = :ID INTO :DTOF, :FEC;
                            /* POR WILLIAM IDENTIFICAR SI EL DOCUMENTO TIENE RECIBO PROVISIONAL*/
        recprov_id = 0;
        SELECT max(RCPR_ID) FROM recibo_provisional_detalle WHERE RPDE_IDDOC = :ID AND RPDE_TIPODOC = :TIPO and RPDE_ANULADO = 'N' INTO :recprov_id;
        if /*(recprov_id = 0) or */(recprov_id is null) then
           BEGIN
           reciprov = 'N';
           end 
        ELSE
          begin 
           reciprov = 'S';
          END
         /*FIN WILLIAM*/
        if (FECHA > FEC) then
            DTOF = 0;
        if (DTOF IS NULL) then
            DTOF = 0;
        if (DTOF <> 0) then
            BEGIN
            SELECT SUM(RCDE_DTOF) FROM RECIBOS_CAJA_DETALLE WHERE RCDE_IDDOC = :ID AND RCDE_TIPODOC = :TIPO INTO :DTOAPL;
            if (DTOAPL IS NULL) then
                DTOAPL = 0;
            DTOF = DTOF - DTOAPL;
            END
        SELECT SUM(SDCA_RTFTE - SDCA_ABRTFTE), SUM(SDCA_RTIVA - SDCA_ABRTIVA), SUM(SDCA_RTICA - SDCA_ABRTICA)
            FROM SALDOS_DOC_CARTERA WHERE SDCA_TIPOREF = :TIPO AND SDCA_IDREF = :ID
            INTO :RTFTE, :RTIVA, :RTICA;
        if (RTFTE IS NULL) then
            RTFTE = 0;
        if ((TIPO = 42) or (TIPO = 45) or (TIPO = 33)) THEN
            BEGIN
            if (RTFTE > 0) then
                RTFTE = 0;
            END
        ELSE
            BEGIN
            if (RTFTE < 0) then
                RTFTE = 0;
            END

        if (RTIVA IS NULL) then
            RTIVA = 0;
        if ((TIPO = 42) or (TIPO = 45) or (TIPO = 33)) THEN
            BEGIN
            if (RTIVA > 0) then
                RTIVA = 0;
            END
        ELSE
            BEGIN
            if (RTIVA < 0) then
                RTIVA = 0;
            END

        if (RTICA IS NULL) then
            RTICA = 0;
        if ((TIPO = 42) or (TIPO = 45) or (TIPO = 33)) THEN
            BEGIN
            if (RTICA > 0) then
                RTICA = 0;
            END
        ELSE
            BEGIN
            if (RTICA < 0) then
                RTICA = 0;
            END

        EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'FECHA AUTORETENEDOR NO DESCONTAR RETENCIONES DEL SALDO PERO SI CONTABILIZARLAS') returning_values (AUTORET);
        if (AUTORET <> '') then
            FAUTORET = CAST(AUTORET AS DATE);
        else
            FAUTORET = '9999/12/31';
        if (FAUTORET <= FECDOC) then
            BEGIN
            RTFTE = 0;
            RTIVA = 0;
            RTICA = 0;
            END
        /* RESTE LAS RETENCIONES YA QUE SE SUGERIRAN
        EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'DESCONTAR RETENCIONES POR CAUSACION') returning_values (DESC_RTES);
        if (DESC_RTES = 'NO') then
            SALDO = SALDO - RTFTE - RTIVA - RTICA;
        /* SI TIENE NOTA AGREGUELA */
        SELECT MAX(NOCL_ID) FROM NOTAS_CLIENTES WHERE TERC_NIT = :NIT AND CLSU_COD = :SUCURSAL AND NOCL_TIPODOC = :TIPO AND NOCL_IDDOC = :ID INTO :IDNOTA;
        if (IDNOTA IS NOT NULL) then
            SELECT NOCL_TEXTO FROM NOTAS_CLIENTES WHERE NOCL_ID = :IDNOTA INTO :NOTA;
        else
            NOTA = '';
        SUSPEND;
        END
    END
END
^

SET TERM ; ^

GRANT SELECT ON MOVIMIENTO_CLIENTES TO PROCEDURE CARTERA_CLIENTE;
GRANT EXECUTE ON PROCEDURE SALDO_DOC_CARTERA TO PROCEDURE CARTERA_CLIENTE;
GRANT SELECT ON TIPO_DOCUMENTO TO PROCEDURE CARTERA_CLIENTE;
GRANT SELECT ON NOTAS_DEBITO_CLIENTES TO PROCEDURE CARTERA_CLIENTE;
GRANT SELECT ON NOTAS_CREDITO_CLIENTES TO PROCEDURE CARTERA_CLIENTE;
GRANT SELECT ON ANTICIPOS_CLIENTE TO PROCEDURE CARTERA_CLIENTE;
GRANT SELECT ON FACTURAS TO PROCEDURE CARTERA_CLIENTE;
GRANT SELECT ON DEVOLUCIONES_VENTAS TO PROCEDURE CARTERA_CLIENTE;
GRANT SELECT ON RECIBO_PROVISIONAL_DETALLE TO PROCEDURE CARTERA_CLIENTE;
GRANT SELECT ON RECIBOS_CAJA_DETALLE TO PROCEDURE CARTERA_CLIENTE;
GRANT SELECT ON SALDOS_DOC_CARTERA TO PROCEDURE CARTERA_CLIENTE;
GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO PROCEDURE CARTERA_CLIENTE;
GRANT SELECT ON NOTAS_CLIENTES TO PROCEDURE CARTERA_CLIENTE;

/* 20080717 */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_MOVIMIENTO_CLIENTE(
    DESDE VARCHAR(20),
    HASTA VARCHAR(20),
    GRPINI VARCHAR(5),
    GRPFIN VARCHAR(5),
    FECINI DATE,
    FECFIN DATE,
    DETALLE CHAR(1),
    ORDEN CHAR(1),
    AGRUPA CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    NIT VARCHAR(20),
    NOMBRE VARCHAR(60),
    TELEFONO VARCHAR(40),
    CIUDAD VARCHAR(40),
    CODZONA VARCHAR(2),
    NOMZONA VARCHAR(60),
    CODCOBR INTEGER,
    NOMCOBR VARCHAR(60),
    SUCURSAL VARCHAR(10),
    NOMSUC VARCHAR(60),
    DV CHAR(1),
    CODCIUD CHAR(5),
    NOMCIUD VARCHAR(60),
    INICIAL NUMERIC(18,2),
    TIPODOC VARCHAR(8),
    TIPOREF INTEGER,
    IDDOC INTEGER,
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    VENCE DATE,
    CONCEPTO VARCHAR(60),
    DEBITO NUMERIC(18,2),
    CREDITO NUMERIC(18,2),
    SALDO NUMERIC(18,2),
    RTFTE NUMERIC(18,2),
    RTIVA NUMERIC(18,2),
    RTICA NUMERIC(18,2),
    CUPO NUMERIC(18,2))
AS
declare variable NITINI VARCHAR(20);
declare variable NITFIN VARCHAR(20);
declare variable NOMINI VARCHAR(20);
declare variable NOMFIN VARCHAR(20);
declare variable OK CHAR(1);
declare variable DB CHAR(1);
declare variable AB CHAR(1);
declare variable RETES CHAR(2);
declare variable ABONOS NUMERIC(18,2);
BEGIN
if (ORDEN = 'C') then
    BEGIN
    NITINI = DESDE;
    NITFIN = HASTA;
    NOMINI = '';
    NOMFIN = 'zz';
    END
ELSE
    BEGIN
    NOMINI = DESDE;
    NOMFIN = HASTA;
    NITINI = '';
    NITFIN = 'zz';
    END
  EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA', 'SALDOS', 'DESCONTAR RETENCIONES POR CAUSACION') returning_values (:RETES);
  /* Ubique el NIT */
  FOR select T.TERC_NIT, TERC_NOM, TERC_DV, CLSU_TEL, CLSU_CIUDAD, S.COBR_COD, S.ZONA_COD, T.CIUD_COD, CLIE_CUPO, CLCU_COD, CLSU_NOMBRE
    from terceros T, CLIENTES C, CLIENTE_SUCURSALES S
    where C.TERC_NIT = T.TERC_NIT AND TERC_CLIE = 'S' AND S.TERC_NIT = C.TERC_NIT AND T.TERC_NIT >= :NITINI AND T.TERC_NIT <= :NITFIN AND
        TERC_NOM >= :NOMINI AND TERC_NOM <= :NOMFIN
    INTO :NIT, :NOMBRE, :DV, :TELEFONO, :CIUDAD, :CODCOBR, :CODZONA, :CODCIUD, :CUPO, :SUCURSAL, :NOMSUC
    DO  
    BEGIN
    SELECT COBR_NOM FROM COBRADORES WHERE COBR_COD = :CODCOBR INTO :NOMCOBR;
    SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :CODZONA INTO :NOMZONA;
    SELECT CIUD_NOM FROM CIUDADES WHERE CIUD_COD = :CODCIUD INTO :NOMCIUD;
    OK = 'N';
    if (AGRUPA = 'Z') then
        BEGIN
        if (GRPINI = '') then
            BEGIN
            if ((CODZONA IS NULL) or (CODZONA >= :GRPINI AND CODZONA <= :GRPFIN)) then
                OK = 'S';
            END
        ELSE
            if (CODZONA >= :GRPINI AND CODZONA <= :GRPFIN) then
                OK = 'S';
        END
    if (AGRUPA = 'I') then
        BEGIN
        if (GRPINI = '') then
            BEGIN
            if ((CODCIUD IS NULL) or (CODCIUD >= :GRPINI AND CODCIUD <= :GRPFIN)) then
                OK = 'S';
            END
        ELSE
            if (CODCIUD >= :GRPINI AND CODCIUD <= :GRPFIN) then
                OK = 'S';
        END
    if (AGRUPA = 'N') then
        OK = 'S';
        
    if (OK = 'S') then
        BEGIN
        INICIAL = 0;
        FECINI = FECINI - 1;
        FOR SELECT MVCL_TIPOREF, MVCL_IDREF FROM MOVIMIENTO_CLIENTES
          WHERE TERC_NIT = :NIT AND MVCL_SUCURSAL = :SUCURSAL AND MVCL_FECHA <= :FECINI AND
            MVCL_ABONO = 'N' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
          INTO :TIPODOC, :IDDOC
          DO
            BEGIN
            EXECUTE PROCEDURE saldo_doc_cartera(TIPODOC, IDDOC, FECINI) returning_values (SALDO);
            INICIAL = INICIAL + SALDO;
            END
        SALDO = INICIAL;
        FECINI = FECINI + 1;
        if (DETALLE = 'S') then
          BEGIN
          FOR select mvcl_tiporef, tido_nomcorto, mvcl_idref, mvcl_prefref, mvcl_numref, mvcl_fecha, mvcl_conc, mvcl_monto, mvcl_debito, mvcl_rtefte, mvcl_rteiva, mvcl_rteica, mvcl_abono, mvcl_vence, cobr_cod
            from movimiento_clientes m, tipo_documento t
            where m.mvcl_tiporef = t.tido_cod and terc_nit = :NIT and MVCL_SUCURSAL = :SUCURSAL AND
                mvcl_fecha >= :FECINI and mvcl_fecha <= :FECFIN and mvcl_tiporef <> 45 AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
            order by mvcl_fecha, mvcl_tiporef, mvcl_idref
            into :TIPOREF, :TIPODOC, :IDDOC, :PREFIJO, :NUMERO, :FECHA, :CONCEPTO, :DEBITO, :DB, :RTFTE, :RTIVA, :RTICA, :AB, :VENCE, :codcobr
            DO
            BEGIN
            SELECT COBR_NOM FROM COBRADORES WHERE COBR_COD = :CODCOBR INTO :NOMCOBR;
            if (RTFTE IS NULL) then
                RTFTE = 0;
            if (RTIVA IS NULL) then
                RTIVA = 0;
            if (RTICA IS NULL) then
                RTICA = 0;
            if (DB = 'N') then
                BEGIN
                CREDITO = DEBITO;
                DEBITO = 0;
                RTFTE = rtfte * -1;
                RTIVA = rtiva * -1;
                RTICA = rtica * -1;
                END
            ELSE
                CREDITO = 0;
            IF (RETES = 'SI') then
                if (AB = 'N') then
                    SALDO = SALDO + DEBITO - CREDITO - RTFTE - RTIVA - RTICA;
                else
                    SALDO = SALDO + DEBITO - CREDITO;
            ELSE
                if (AB = 'N') then
                    SALDO = SALDO + DEBITO - CREDITO;
                else
                    SALDO = SALDO + DEBITO - CREDITO + RTFTE + RTIVA + RTICA;
            SUSPEND;
            END
          END
        ELSE
            BEGIN
            IF (RETES = 'SI') then
                BEGIN
                SELECT SUM(MVCL_MONTO-MVCL_RTEFTE-MVCL_RTEIVA-MVCL_RTEICA) FROM movimiento_clientes
                    WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA <= :FECFIN AND MVCL_DEBITO = 'S'
                        AND MVCL_SUCURSAL = :SUCURSAL AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA)) INTO :DEBITO;
                SELECT SUM(MVCL_MONTO-MVCL_RTEFTE-MVCL_RTEIVA-MVCL_RTEICA) FROM movimiento_clientes
                    WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA <= :FECFIN AND MVCL_DEBITO = 'N' and MVCL_ABONO = 'N' AND mvcl_tiporef <> 45
                        AND MVCL_SUCURSAL = :SUCURSAL AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA)) INTO :CREDITO;
                SELECT SUM(MVCL_MONTO) FROM movimiento_clientes WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI
                    AND MVCL_FECHA <= :FECFIN AND MVCL_DEBITO = 'N'  and MVCL_ABONO = 'S' AND MVCL_SUCURSAL = :SUCURSAL
                        AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA)) INTO :ABONOS;
                END
            ELSE
                BEGIN
                SELECT SUM(MVCL_MONTO) FROM movimiento_clientes WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA <= :FECFIN AND MVCL_DEBITO = 'S'
                    AND MVCL_SUCURSAL = :SUCURSAL AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA)) INTO :DEBITO;
                SELECT SUM(MVCL_MONTO) FROM movimiento_clientes WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA <= :FECFIN AND MVCL_DEBITO = 'N' and MVCL_ABONO = 'N' and mvcl_tiporef <> 45
                    AND MVCL_SUCURSAL = :SUCURSAL AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA)) INTO :CREDITO;
                SELECT SUM(MVCL_MONTO+MVCL_RTEFTE+MVCL_RTEIVA+MVCL_RTEICA) FROM movimiento_clientes WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND MVCL_FECHA <= :FECFIN AND MVCL_DEBITO = 'N'  and MVCL_ABONO = 'S'
                    AND MVCL_SUCURSAL = :SUCURSAL AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA)) INTO :ABONOS;
                END
            if (DEBITO IS NULL) then
                DEBITO = 0;
            if (CREDITO IS NULL) then
                CREDITO = 0;
            if (ABONOS IS NULL) then
                ABONOS = 0;
            CREDITO = CREDITO + ABONOS;
            SALDO = INICIAL + DEBITO - CREDITO;
            SUSPEND;
            END
        END
    if (AGRUPA = 'C') then
        BEGIN
        FOR SELECT DISTINCT COBR_COD FROM MOVIMIENTO_CLIENTES
            WHERE TERC_NIT = :NIT AND MVCL_SUCURSAL = :SUCURSAL AND MVCL_FECHA <= :FECINI AND
            ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
            INTO :codcobr
            DO
            BEGIN
            OK = 'N';
            if (GRPINI = '') then
                BEGIN
                if ((CODCOBR IS NULL) or (CODCOBR >= :GRPINI AND CODCOBR <= :GRPFIN)) then
                    OK = 'S';
                END
            ELSE
                if (CODCOBR >= :GRPINI AND CODCOBR <= :GRPFIN) then
                    OK = 'S';
            if (OK = 'S') then
                BEGIN
                SELECT COBR_NOM FROM COBRADORES WHERE COBR_COD = :CODCOBR INTO :NOMCOBR;
                INICIAL = 0;
                FECINI = FECINI - 1;
                FOR SELECT MVCL_TIPOREF, MVCL_IDREF FROM MOVIMIENTO_CLIENTES
                  WHERE TERC_NIT = :NIT AND MVCL_SUCURSAL = :SUCURSAL AND MVCL_FECHA <= :FECINI AND
                  COBR_COD = :CODCOBR AND MVCL_ABONO = 'N' AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                  INTO :TIPODOC, :IDDOC
                  DO
                    BEGIN
                    EXECUTE PROCEDURE saldo_doc_cartera(TIPODOC, IDDOC, FECINI) returning_values (SALDO);
                    INICIAL = INICIAL + SALDO;
                    END
                SALDO = INICIAL;
                FECINI = FECINI + 1;
                if (DETALLE = 'S') then
                  BEGIN
                  FOR select mvcl_tiporef, tido_nomcorto, mvcl_idref, mvcl_prefref, mvcl_numref, mvcl_fecha, mvcl_conc, mvcl_monto, mvcl_debito, mvcl_rtefte, mvcl_rteiva, mvcl_rteica, mvcl_abono, mvcl_vence
                    from movimiento_clientes m, tipo_documento t
                    where m.mvcl_tiporef = t.tido_cod and terc_nit = :NIT and MVCL_SUCURSAL = :SUCURSAL AND
                    mvcl_fecha >= :FECINI and mvcl_fecha <= :FECFIN and mvcl_tiporef <> 45 AND
                    COBR_COD = :CODCOBR AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA))
                    order by mvcl_fecha, mvcl_tiporef, mvcl_idref
                    into :TIPOREF, :TIPODOC, :IDDOC, :PREFIJO, :NUMERO, :FECHA, :CONCEPTO, :DEBITO, :DB, :RTFTE, :RTIVA, :RTICA, :AB, :VENCE
                    DO
                    BEGIN
                    if (RTFTE IS NULL) then
                        RTFTE = 0;
                    if (RTIVA IS NULL) then
                        RTIVA = 0;
                    if (RTICA IS NULL) then
                        RTICA = 0;
                    if (DB = 'N') then
                        BEGIN
                        CREDITO = DEBITO;
                        DEBITO = 0;
                        RTFTE = rtfte * -1;
                        RTIVA = rtiva * -1;
                        RTICA = rtica * -1;
                        END
                    ELSE
                        CREDITO = 0;
                    IF (RETES = 'SI') then
                        if (AB = 'N') then
                            SALDO = SALDO + DEBITO - CREDITO - RTFTE - RTIVA - RTICA;
                        else
                            SALDO = SALDO + DEBITO - CREDITO;
                    ELSE
                        if (AB = 'N') then
                            SALDO = SALDO + DEBITO - CREDITO;
                        else
                            SALDO = SALDO + DEBITO - CREDITO - RTFTE - RTIVA - RTICA;
                    SUSPEND;
                    END
                  END
                ELSE
                    BEGIN
                    IF (RETES = 'SI') then
                        BEGIN
                        SELECT SUM(MVCL_MONTO-MVCL_RTEFTE-MVCL_RTEIVA-MVCL_RTEICA)
                            FROM movimiento_clientes WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND
                            COBR_COD = :CODCOBR AND MVCL_FECHA <= :FECFIN AND MVCL_DEBITO = 'S' AND
                            MVCL_SUCURSAL = :SUCURSAL AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA)) INTO :DEBITO;
                        SELECT SUM(MVCL_MONTO-MVCL_RTEFTE-MVCL_RTEIVA-MVCL_RTEICA)
                            FROM movimiento_clientes WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND
                            COBR_COD = :CODCOBR AND MVCL_FECHA <= :FECFIN AND MVCL_DEBITO = 'N' and
                            MVCL_ABONO = 'N' AND mvcl_tiporef <> 45 AND MVCL_SUCURSAL = :SUCURSAL AND
                            ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA)) INTO :CREDITO;
                        SELECT SUM(MVCL_MONTO) FROM movimiento_clientes WHERE TERC_NIT = :NIT AND
                            COBR_COD = :CODCOBR AND MVCL_FECHA >= :FECINI AND MVCL_FECHA <= :FECFIN AND
                            MVCL_DEBITO = 'N'  and MVCL_ABONO = 'S' AND MVCL_SUCURSAL = :SUCURSAL AND
                            ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA)) INTO :ABONOS;
                        END
                    ELSE
                        BEGIN
                        SELECT SUM(MVCL_MONTO) FROM movimiento_clientes WHERE TERC_NIT = :NIT AND
                            COBR_COD = :CODCOBR AND MVCL_FECHA >= :FECINI AND MVCL_FECHA <= :FECFIN AND
                            MVCL_DEBITO = 'S' AND MVCL_SUCURSAL = :SUCURSAL AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA)) INTO :DEBITO;
                        SELECT SUM(MVCL_MONTO) FROM movimiento_clientes WHERE TERC_NIT = :NIT AND
                            COBR_COD = :CODCOBR AND MVCL_FECHA >= :FECINI AND MVCL_FECHA <= :FECFIN AND
                            MVCL_DEBITO = 'N' and MVCL_ABONO = 'N' and mvcl_tiporef <> 45 AND
                            MVCL_SUCURSAL = :SUCURSAL AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA)) INTO :CREDITO;
                        SELECT SUM(MVCL_MONTO+MVCL_RTEFTE+MVCL_RTEIVA+MVCL_RTEICA)
                            FROM movimiento_clientes WHERE TERC_NIT = :NIT AND MVCL_FECHA >= :FECINI AND
                            MVCL_FECHA <= :FECFIN AND COBR_COD = :CODCOBR AND MVCL_DEBITO = 'N' and
                            MVCL_ABONO = 'S' AND MVCL_SUCURSAL = :SUCURSAL AND ((:SUBEMPRESA = 0) or (SUCU_ID = :SUBEMPRESA)) INTO :ABONOS;
                        END
                    if (DEBITO IS NULL) then
                        DEBITO = 0;
                    if (CREDITO IS NULL) then
                        CREDITO = 0;
                    if (ABONOS IS NULL) then
                        ABONOS = 0;
                    CREDITO = CREDITO + ABONOS;
                    SALDO = INICIAL + DEBITO - CREDITO;
                    SUSPEND;
                    END
                END /* ok = S */
            END /* FOR COBRADOR */
        END /* AGRUPA C */
    END /* FOR NIT */
END
^

SET TERM ; ^

GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO PROCEDURE REP_MOVIMIENTO_CLIENTE;
GRANT SELECT ON TERCEROS TO PROCEDURE REP_MOVIMIENTO_CLIENTE;
GRANT SELECT ON CLIENTES TO PROCEDURE REP_MOVIMIENTO_CLIENTE;
GRANT SELECT ON CLIENTE_SUCURSALES TO PROCEDURE REP_MOVIMIENTO_CLIENTE;
GRANT SELECT ON COBRADORES TO PROCEDURE REP_MOVIMIENTO_CLIENTE;
GRANT SELECT ON ZONAS TO PROCEDURE REP_MOVIMIENTO_CLIENTE;
GRANT SELECT ON CIUDADES TO PROCEDURE REP_MOVIMIENTO_CLIENTE;
GRANT SELECT ON MOVIMIENTO_CLIENTES TO PROCEDURE REP_MOVIMIENTO_CLIENTE;
GRANT EXECUTE ON PROCEDURE SALDO_DOC_CARTERA TO PROCEDURE REP_MOVIMIENTO_CLIENTE;
GRANT SELECT ON TIPO_DOCUMENTO TO PROCEDURE REP_MOVIMIENTO_CLIENTE;


/* 20080718 */
/* diferencia con valor absoluto para poder diagnosticar por encima y por debajo del precio ideal */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE REVISA_PRECIOS(
    LISTA INTEGER,
    FECHA DATE)
RETURNS (
    ARTICULO VARCHAR(20),
    DESCR VARCHAR(60),
    FIJO NUMERIC(18,2),
    UNIDAD VARCHAR(8),
    PORC NUMERIC(9,4),
    SUGERIDO NUMERIC(18,2),
    DIFER NUMERIC(18,2),
    NUEVO NUMERIC(18,2),
    OK CHAR(1))
AS
declare variable marg numeric(9,4);
declare variable UOM VARCHAR(10);
declare variable BASE VARCHAR(10);
declare variable CAMBIO VARCHAR(10);
declare variable COSTO numeric(18,2);
declare variable COSTOP numeric(18,2);
declare variable COSTOU numeric(18,2);
declare variable DIFMAX numeric(18,2);
declare variable DIG INTEGER;
declare variable TARIVA NUMERIC(9,4);
declare variable IVAINC CHAR(1);
declare variable LISTAREF INTEGER;
begin
execute procedure lee_configuracion ('FACTURACION', 'ARTICULOS', 'SUGERIR PRECIOS CON PORCENTAJE DE MARGEN O UTILIDAD') returning_values (:UOM);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'ARTICULOS', 'REDONDEO AL MULTIPLO DE DIEZ EN PRECIOS') RETURNING_VALUES (:DIG);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','CAMBIO DE PRECIOS AUTOMATICO AL CAMBIAR COSTO O PRECIO') returning_values (CAMBIO);
EXECUTE PROCEDURE lee_configuracion('FACTURACION','ARTICULOS','COSTO BASE PARA CALCULO DE PRECIOS DE VENTA AUTOMATICOS') returning_values (:BASE);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','CODIGO DE LA LISTA DE PRECIOS BASE PARA CAMBIO DE PRECIOS AUTOMATICO') returning_values (LISTAREF);
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION','ARTICULOS','DIFERENCIA EN PESOS MAXIMA A PERMITIR PARA CAMBIAR PRECIOS') returning_values (DIFMAX);
for select A.arti_cod, A.arti_des, A.arti_unidad, prar_fijo, prar_margen, prar_util, TAIV_PORC
    from precios_articulo p, articulo a, tarifa_iva T
    where a.arti_cod = p.arti_cod and lipr_cod = :lista and a.taiv_cod = t.taiv_cod order by A.arti_cod
    into :articulo, descr, :unidad, :fijo, :marg, :porc, :tariva
    do
    begin
    if (UOM <> 'UTILIDAD') then
        PORC = MARG;
    if (CAMBIO = 'COSTO') then
        BEGIN
        EXECUTE PROCEDURE COSTO_PROMEDIO (:ARTICULO, :FECHA) RETURNING_VALUES(:COSTOP);
        EXECUTE PROCEDURE ULTIMO_COSTO (:ARTICULO, :FECHA, :UNIDAD) RETURNING_VALUES(:COSTOU);
        if (base = 'ULTIMO') then
            COSTO = COSTOU;
        ELSE
            BEGIN
            COSTO = COSTOP;
            if (base = 'MAYOR') then
                if (COSTOP < COSTOU) then
                    COSTO = COSTOU;
            END
        SELECT LIPR_MODIF FROM LISTA_PRECIOS WHERE LIPR_COD = :lista INTO :IVAINC;
        if (IVAINC = 'S') then
            COSTO = COSTO * (1 + TARIVA/100);
        if (UOM = 'UTILIDAD') then
            SUGERIDO = COSTO * (1 + :PORC/100);
        ELSE
            SUGERIDO = COSTO / (1 - :PORC/100);
        END
    ELSE
        if (LISTA <> LISTAREF) then
            BEGIN
            SELECT PRAR_FIJO FROM PRECIOS_ARTICULO WHERE ARTI_COD = :articulo AND LIPR_COD = :LISTAREF INTO :SUGERIDO;
            if (IVAINC = 'S') then
                SUGERIDO = SUGERIDO / (1 + TARIVA/100);
            if (UOM = 'UTILIDAD') then
                SUGERIDO = SUGERIDO * (1 + :PORC/100);
            ELSE
                SUGERIDO = SUGERIDO / (1 - :PORC/100);
            END
    EXECUTE PROCEDURE REDONDEE (SUGERIDO, DIG) returning_values (SUGERIDO);
    DIFER = SUGERIDO - FIJO;
    NUEVO = SUGERIDO;
    OK = 'S';
    if ((abs(DIFER) > DIFMAX) and (sugerido <> 0)) then
        suspend;
    end
end
^

SET TERM ; ^

GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO PROCEDURE REVISA_PRECIOS;
GRANT SELECT ON PRECIOS_ARTICULO TO PROCEDURE REVISA_PRECIOS;
GRANT SELECT ON ARTICULO TO PROCEDURE REVISA_PRECIOS;
GRANT SELECT ON TARIFA_IVA TO PROCEDURE REVISA_PRECIOS;
GRANT EXECUTE ON PROCEDURE COSTO_PROMEDIO TO PROCEDURE REVISA_PRECIOS;
GRANT EXECUTE ON PROCEDURE ULTIMO_COSTO TO PROCEDURE REVISA_PRECIOS;
GRANT SELECT ON LISTA_PRECIOS TO PROCEDURE REVISA_PRECIOS;
GRANT EXECUTE ON PROCEDURE REDONDEE TO PROCEDURE REVISA_PRECIOS;


/* 20080719 */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_FALTANTES_VENTA(
    TIPOORI INTEGER,
    FECINI DATE,
    FECFIN DATE,
    TIPODES INTEGER,
    CEROS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    NIT VARCHAR(20),
    NOMCLIENTE VARCHAR(60),
    VENCE DATE,
    ARTICULO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    CANTIDAD NUMERIC(18,4),
    UNIDAD VARCHAR(8),
    PRECIO NUMERIC(18,2),
    DESCUENTO NUMERIC(9,4),
    FALTANTE NUMERIC(18,4),
    OBS VARCHAR(255))
AS
declare variable ID INTEGER;
declare variable ITEM INTEGER;
declare variable FACTOR NUMERIC(18,4);
BEGIN
if (TIPOORI = 32) then
    FOR SELECT R.REVT_ID, R.PREF_PRE, REVT_NUMERO, REVT_FECHA, REVT_FECHA VENCE, RVDE_ITEM, R.TERC_NIT, REVT_NOMTERC, ARTI_COD, SUBSTR(RVDE_DESC,1,60), RVDE_UNIDAD, RVDE_CANT, RVDE_PRUNIT, RVDE_DTOPORC, SUBSTRING(REVT_OBS FROM 1 FOR 255)
      FROM REMISIONES_VENTA R, REMISIONES_VENTA_DETALLE D, PREFIJOS P
      WHERE R.REVT_ID = D.REVT_ID AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN and REVT_ANULADO = 'N'
       AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
      ORDER BY REVT_FECHA, R.PREF_PRE, REVT_NUMERO, RVDE_ITEM
      INTO :ID, :PREFIJO, :NUMERO, :FECHA, :VENCE, :ITEM, :NIT, :NOMCLIENTE, :ARTICULO, :DESCRIPCION, :UNIDAD, :CANTIDAD, :PRECIO, :DESCUENTO, :OBS
      DO
        BEGIN
        EXECUTE PROCEDURE FALTANTE(:TIPOORI, :TIPODES, :ID,  :ITEM) returning_values (:FALTANTE, :UNIDAD, :FACTOR);
        if ((CEROS = 'S') or (FALTANTE <> 0)) then
          SUSPEND;
        END
if (TIPOORI = 34) then
    FOR SELECT P.PEDI_ID, P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, (PEDI_FECHA + PEDI_VALIDEZ), PEDE_ITEM, P.TERC_NIT, PEDI_NOMTERC, ARTI_COD, SUBSTR(PEDE_DESC,1,60), PEDE_UNIDAD, PEDE_CANT, PEDE_PRUNIT, PEDE_DTOPORC, SUBSTRING(PEDI_OBS FROM 1 FOR 255)
      FROM PEDIDOS P, PEDIDOS_DETALLE D, PREFIJOS PR
      WHERE P.PEDI_ID = D.PEDI_ID AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND PEDI_ANULADO = 'N'
       AND PR.PREF_PRE = P.PREF_PRE AND PR.TIDO_COD = 34 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
      ORDER BY PEDI_FECHA, P.PREF_PRE, PEDI_NUMERO, PEDE_ITEM
      INTO :ID, :PREFIJO, :NUMERO, :FECHA, :VENCE, :ITEM, :NIT, :NOMCLIENTE, :ARTICULO, :DESCRIPCION, :UNIDAD, :CANTIDAD, :PRECIO, :DESCUENTO, :OBS
      DO
        BEGIN
        EXECUTE PROCEDURE FALTANTE(:TIPOORI, :TIPODES, :ID,  :ITEM) returning_values (:FALTANTE, :UNIDAD, :FACTOR);
        if ((CEROS = 'S') or (FALTANTE <> 0)) then
          SUSPEND;
        END
if (TIPOORI = 35) then
    FOR SELECT C.COTI_ID, C.PREF_PRE, COTI_NUMERO, COTI_FECHA, (COTI_FECHA + COTI_VALIDEZ), CTDE_ITEM, C.TERC_NIT, COTI_NOMTERC, ARTI_COD, SUBSTR(CTDE_DESC,1,60), CTDE_UNIDAD, CTDE_CANT, CTDE_PRUNIT, CTDE_DTOPORC, SUBSTRING(COTI_OBS FROM 1 FOR 255)
      FROM COTIZACIONES C, COTIZACIONES_DETALLE D, PREFIJOS P
      WHERE C.COTI_ID = D.COTI_ID AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND COTI_ANULADO = 'N'
       AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
      ORDER BY COTI_FECHA, C.PREF_PRE, COTI_NUMERO, CTDE_ITEM
      INTO :ID, :PREFIJO, :NUMERO, :FECHA, :VENCE, :ITEM, :NIT, :NOMCLIENTE, :ARTICULO, :DESCRIPCION, :UNIDAD, :CANTIDAD, :PRECIO, :DESCUENTO, :OBS
      DO
        BEGIN
        EXECUTE PROCEDURE FALTANTE(:TIPOORI, :TIPODES, :ID,  :ITEM) returning_values (:FALTANTE, :UNIDAD, :FACTOR);
        if ((CEROS = 'S') or (FALTANTE <> 0)) then
          SUSPEND;
        END
END
^

SET TERM ; ^

GRANT SELECT ON REMISIONES_VENTA TO PROCEDURE REP_FALTANTES_VENTA;
GRANT SELECT ON REMISIONES_VENTA_DETALLE TO PROCEDURE REP_FALTANTES_VENTA;
GRANT SELECT ON PREFIJOS TO PROCEDURE REP_FALTANTES_VENTA;
GRANT EXECUTE ON PROCEDURE FALTANTE TO PROCEDURE REP_FALTANTES_VENTA;
GRANT SELECT ON PEDIDOS TO PROCEDURE REP_FALTANTES_VENTA;
GRANT SELECT ON PEDIDOS_DETALLE TO PROCEDURE REP_FALTANTES_VENTA;
GRANT SELECT ON COTIZACIONES TO PROCEDURE REP_FALTANTES_VENTA;
GRANT SELECT ON COTIZACIONES_DETALLE TO PROCEDURE REP_FALTANTES_VENTA;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_FALTANTES_CLIENTES(
    TERINI VARCHAR(20),
    TERFIN VARCHAR(20),
    FECINI DATE,
    FECFIN DATE,
    DETALLE CHAR(1),
    TIPO INTEGER,
    DESTINO INTEGER,
    ARTINI VARCHAR(15),
    ARTFIN VARCHAR(15),
    ORDEN CHAR(1),
    CEROS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    NIT VARCHAR(20),
    SUCURSAL VARCHAR(10),
    NOMBRE VARCHAR(60),
    TELEFONO VARCHAR(40),
    CIUDAD VARCHAR(40),
    CODZONA VARCHAR(2),
    NOMZONA VARCHAR(30),
    NOMTIPO VARCHAR(50),
    ARTICULO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    CANTIDAD NUMERIC(18,4),
    UNIDAD VARCHAR(8),
    FALTANTE NUMERIC(18,4),
    BASE NUMERIC(18,2),
    IVA NUMERIC(18,2),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    OBS VARCHAR(255))
AS
declare variable ID INTEGER;
declare variable ITEM INTEGER;
declare variable CODINI VARCHAR(15);
declare variable CODFIN VARCHAR(15);
declare variable DESINI VARCHAR(15);
declare variable DESFIN VARCHAR(15);
declare variable FACTOR NUMERIC(18,4);
declare variable CANT NUMERIC(18,4);
declare variable MONTO NUMERIC(18,2);
declare variable artiaux VARCHAR(20);
BEGIN
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END
SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPO INTO :NOMTIPO;
/*FOR select T.TERC_NIT, TERC_NOM,  TERC_TEL, TERC_CIU, ZONA_COD
    from terceros T, CLIENTES C*/
FOR select c.terc_nit,s.clsu_nombre,s.clsu_tel,s.clsu_ciudad,s.zona_cod,s.clcu_cod
    from clientes c, cliente_sucursales s
    where C.TERC_NIT = s.TERC_NIT and C.TERC_NIT >= :TERINI AND C.TERC_NIT <= :TERFIN
    INTO :NIT, :NOMBRE, :TELEFONO, :CIUDAD, :CODZONA, :sucursal
    DO  
    BEGIN
    CANTIDAD = 0;
    FALTANTE = 0;
    BASE = 0;
    SELECT ZONA_NOM FROM ZONAS WHERE ZONA_COD = :CODZONA INTO :NOMZONA;
    if (DETALLE = 'N') then
        BEGIN
        ARTICULO = '';
        if (TIPO = 31) then
            FOR SELECT F.FACT_ID, FADE_ITEM, D.ARTI_COD, FADE_CANT * FADE_FACTOR, (FADE_PRUNIT-FADE_DTOMONTO)
                FROM FACTURAS_DETALLE D, FACTURAS F, ARTICULO A, PREFIJOS P
                WHERE F.FACT_ID = D.FACT_ID AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND TERC_NIT = :NIT AND FACT_ANULADO = 'N' AND
                      D.ARTI_COD = A.ARTI_COD AND D.ARTI_COD >= :CODINI AND D.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                      P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) and f.fact_sucursal = :sucursal 
                ORDER BY ARTI_COD, F.FACT_ID, FADE_ITEM INTO :ID, :ITEM, :ARTIAUX, :CANT,  :MONTO
                DO
                BEGIN
                if (artiaux <> articulo) then
                    begin
                    if (ARTICULO <> '') then
                        SUSPEND;
                    SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                        FROM articulo WHERE ARTI_COD = :ARTIAUX
                        INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                    SELECT GRUP_NOM FROM GRUPO WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    ARTICULO = ARTIAUX;
                    CANTIDAD = 0;
                    FALTANTE = 0;
                    BASE = 0;
                    end
                CANTIDAD = CANTIDAD + CANT;
                EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:CANT, :UNIDAD, :FACTOR);
                FALTANTE = FALTANTE + CANT;
                BASE = BASE + (MONTO * CANT);
                END
        if (TIPO = 32) then
            FOR SELECT R.revt_id, rvde_item, D.ARTI_COD, RVDE_CANT * RVDE_FACTOR, (RVDE_PRUNIT-RVDE_DTOMONTO)
                FROM REMISIONES_VENTA_DETALLE D, REMISIONES_VENTA R, ARTICULO A, PREFIJOS P
                WHERE R.REVT_ID = D.REVT_ID AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND TERC_NIT = :NIT AND REVT_ANULADO = 'N' AND
                      D.ARTI_COD = A.ARTI_COD AND D.ARTI_COD >= :CODINI AND D.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                      P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) and r.revt_sucursal = :sucursal
                ORDER BY ARTI_COD, R.REVT_ID, RVDE_ITEM INTO :ID, :ITEM, :ARTIAUX, :CANT, :MONTO
                DO
                BEGIN
                if (artiaux <> articulo) then
                    begin
                    if (ARTICULO <> '') then
                        SUSPEND;
                    SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                        FROM articulo WHERE ARTI_COD = :ARTIAUX
                        INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                    SELECT GRUP_NOM FROM GRUPO WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    ARTICULO = ARTIAUX;
                    CANTIDAD = 0;
                    FALTANTE = 0;
                    BASE = 0;
                    end
                CANTIDAD = CANTIDAD + CANT;
                EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:CANT, :UNIDAD, :FACTOR);
                FALTANTE = FALTANTE + CANT;
                BASE = BASE + (MONTO * CANT);
                END
        if (TIPO = 34) then
            FOR SELECT P.PEDI_ID, PEDE_ITEM, D.ARTI_COD, PEDE_CANT * PEDE_FACTOR, (PEDE_PRUNIT-PEDE_DTOMONTO)
                FROM PEDIDOS_DETALLE D, PEDIDOS P, ARTICULO A, PREFIJOS PR
                WHERE P.PEDI_ID = D.PEDI_ID AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND TERC_NIT = :NIT AND PEDI_ANULADO = 'N' AND
                      D.ARTI_COD = A.ARTI_COD AND D.ARTI_COD >= :CODINI AND D.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                      PR.PREF_PRE = P.PREF_PRE AND PR.TIDO_COD = 34 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) and p.pedi_sucursal = :sucursal
                ORDER BY ARTI_COD, P.PEDI_ID, PEDE_ITEM INTO :ID, :ITEM, :ARTIAUX, :CANT, :MONTO
                DO
                BEGIN
                if (artiaux <> articulo) then
                    begin
                    if (ARTICULO <> '') then
                        SUSPEND;
                    SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                        FROM articulo WHERE ARTI_COD = :ARTIAUX
                        INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                    SELECT GRUP_NOM FROM GRUPO WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    ARTICULO = ARTIAUX;
                    CANTIDAD = 0;
                    FALTANTE = 0;
                    BASE = 0;
                    end
                CANTIDAD = CANTIDAD + CANT;
                EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:CANT, :UNIDAD, :FACTOR);
                FALTANTE = FALTANTE + CANT;
                BASE = BASE + (MONTO * CANT);
                END
        if (TIPO = 35) then
            FOR SELECT C.COTI_ID, CTDE_ITEM, D.ARTI_COD, CTDE_CANT * CTDE_FACTOR, (CTDE_PRUNIT-CTDE_DTOMONTO)
                FROM COTIZACIONES_DETALLE D, COTIZACIONES C, ARTICULO A, PREFIJOS P
                WHERE C.COTI_ID = D.COTI_ID AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND TERC_NIT = :NIT AND COTI_ANULADO = 'N' AND
                      D.ARTI_COD = A.ARTI_COD AND D.ARTI_COD >= :CODINI AND D.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                      P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) and c.coti_sucursal = :sucursal
                ORDER BY ARTI_COD, C.COTI_ID, CTDE_ITEM INTO :ID, :ITEM, :ARTIAUX, :CANT, :MONTO
                DO
                BEGIN
                if (artiaux <> articulo) then
                    begin
                    if (ARTICULO <> '') then
                        SUSPEND;
                    SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                        FROM articulo WHERE ARTI_COD = :ARTIAUX
                        INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                    SELECT GRUP_NOM FROM GRUPO WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    ARTICULO = ARTIAUX;
                    CANTIDAD = 0;
                    FALTANTE = 0;
                    BASE = 0;
                    end
                CANTIDAD = CANTIDAD + CANT;
                EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:CANT, :UNIDAD, :FACTOR);
                FALTANTE = FALTANTE + CANT;
                BASE = BASE + (MONTO * CANT);
                END
        if (FALTANTE IS NULL) then
            FALTANTE = 0;
        if (BASE IS NULL) then
            BASE = 0;
        if (IVA IS NULL) then
            IVA = 0;
        if ((CEROS = 'S') or (FALTANTE <> 0)) then
            SUSPEND;
        END
    ELSE
        BEGIN
        if (TIPO = 31) then
            FOR SELECT F.FACT_ID, FADE_ITEM, F.PREF_PRE, FACT_NUMERO, FACT_FECHA, FADE_CANT * FADE_FACTOR, (FADE_PRUNIT-FADE_DTOMONTO), FADE_IVAMONTO, D.ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD, SUBSTRING(FACT_OBS FROM 1 FOR 255)
                FROM FACTURAS F, FACTURAS_DETALLE D, ARTICULO A, PREFIJOS P
                WHERE F.FACT_ID = D.FACT_ID AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN  AND TERC_NIT = :NIT AND FACT_ANULADO = 'N' AND
                      D.ARTI_COD = A.ARTI_COD AND D.ARTI_COD >= :CODINI AND D.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                      P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) and f.fact_sucursal = :sucursal 
                ORDER BY D.ARTI_COD, F.FACT_ID, FADE_ITEM
                INTO :ID, :ITEM, :PREFIJO, :NUMERO, :FECHA, :CANTIDAD, :BASE, :IVA, :ARTICULO, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :OBS
                DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:FALTANTE, :UNIDAD, :FACTOR);
                    if ((CEROS = 'S') or (FALTANTE <> 0)) then
                        SUSPEND;
                    END
        if (TIPO = 32) then
            FOR SELECT R.REVT_ID, RVDE_ITEM, R.PREF_PRE, REVT_NUMERO, REVT_FECHA, RVDE_CANT * RVDE_FACTOR, (RVDE_PRUNIT-RVDE_DTOMONTO), RVDE_IVAMONTO, D.ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD, SUBSTRING(REVT_OBS FROM 1 FOR 255)
                FROM REMISIONES_VENTA R, REMISIONES_VENTA_DETALLE D, ARTICULO A, PREFIJOS P
                WHERE R.REVT_ID = D.REVT_ID AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND TERC_NIT = :NIT AND REVT_ANULADO = 'N' AND
                      D.ARTI_COD = A.ARTI_COD AND D.ARTI_COD >= :CODINI AND D.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                      P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 33 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) and r.revt_sucursal = :sucursal
                ORDER BY D.ARTI_COD, R.REVT_ID, RVDE_ITEM
                INTO :ID, :ITEM, :PREFIJO, :NUMERO, :FECHA, :CANTIDAD, :BASE, :IVA, :ARTICULO, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :OBS
                DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:FALTANTE, :UNIDAD, :FACTOR);
                    if ((CEROS = 'S') or (FALTANTE <> 0)) then
                        SUSPEND;
                    END
        if (TIPO = 34) then
            FOR SELECT P.PEDI_ID, PEDE_ITEM, P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, PEDE_CANT * PEDE_FACTOR, (PEDE_PRUNIT-PEDE_DTOMONTO), PEDE_IVAMONTO, D.ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD, SUBSTRING(PEDI_OBS FROM 1 FOR 255)
                FROM PEDIDOS P, PEDIDOS_DETALLE D, ARTICULO A, PREFIJOS PR
                WHERE P.PEDI_ID = D.PEDI_ID AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND TERC_NIT = :NIT AND PEDI_ANULADO = 'N' AND
                      D.ARTI_COD = A.ARTI_COD AND D.ARTI_COD >= :CODINI AND D.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                      P.PREF_PRE = PR.PREF_PRE AND PR.TIDO_COD = 34 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) and p.pedi_sucursal = :sucursal
                ORDER BY D.ARTI_COD, P.PEDI_ID, PEDE_ITEM
                INTO :ID, :ITEM, PREFIJO, :NUMERO, :FECHA, :CANTIDAD, :BASE, :IVA, :ARTICULO, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :OBS
                DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:FALTANTE, :UNIDAD, :FACTOR);
                    if ((CEROS = 'S') or (FALTANTE <> 0)) then
                        SUSPEND;
                    END
        if (TIPO = 35) then
            FOR SELECT C.COTI_ID, CTDE_ITEM, C.PREF_PRE, COTI_NUMERO, COTI_FECHA, CTDE_CANT * CTDE_FACTOR, (CTDE_PRUNIT-CTDE_DTOMONTO), CTDE_IVAMONTO, D.ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD, SUBSTRING(COTI_OBS FROM 1 FOR 255)
                FROM COTIZACIONES C, COTIZACIONES_DETALLE D, ARTICULO A, PREFIJOS P
                WHERE C.COTI_ID = D.COTI_ID AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND TERC_NIT = :NIT AND COTI_ANULADO = 'N' AND
                      D.ARTI_COD = A.ARTI_COD AND D.ARTI_COD >= :CODINI AND D.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                      P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) and c.coti_sucursal = :sucursal
                ORDER BY D.ARTI_COD, C.COTI_ID, CTDE_ITEM
                INTO :ID, :ITEM, PREFIJO, :NUMERO, :FECHA, :CANTIDAD, :BASE, :IVA, :ARTICULO, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC, :OBS
                DO
                    BEGIN
                    SELECT GRUP_NOM FROM GRUPO WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:FALTANTE, :UNIDAD, :FACTOR);
                    if ((CEROS = 'S') or (FALTANTE <> 0)) then
                        SUSPEND;
                    END
        END
    END
END
^

SET TERM ; ^

GRANT SELECT ON TIPO_DOCUMENTO TO PROCEDURE REP_FALTANTES_CLIENTES;
GRANT SELECT ON CLIENTES TO PROCEDURE REP_FALTANTES_CLIENTES;
GRANT SELECT ON CLIENTE_SUCURSALES TO PROCEDURE REP_FALTANTES_CLIENTES;
GRANT SELECT ON ZONAS TO PROCEDURE REP_FALTANTES_CLIENTES;
GRANT SELECT ON FACTURAS_DETALLE TO PROCEDURE REP_FALTANTES_CLIENTES;
GRANT SELECT ON FACTURAS TO PROCEDURE REP_FALTANTES_CLIENTES;
GRANT SELECT ON ARTICULO TO PROCEDURE REP_FALTANTES_CLIENTES;
GRANT SELECT ON PREFIJOS TO PROCEDURE REP_FALTANTES_CLIENTES;
GRANT SELECT ON GRUPO TO PROCEDURE REP_FALTANTES_CLIENTES;
GRANT SELECT ON MARCAS TO PROCEDURE REP_FALTANTES_CLIENTES;
GRANT SELECT ON SUBGRUPO TO PROCEDURE REP_FALTANTES_CLIENTES;
GRANT EXECUTE ON PROCEDURE FALTANTE TO PROCEDURE REP_FALTANTES_CLIENTES;
GRANT SELECT ON REMISIONES_VENTA_DETALLE TO PROCEDURE REP_FALTANTES_CLIENTES;
GRANT SELECT ON REMISIONES_VENTA TO PROCEDURE REP_FALTANTES_CLIENTES;
GRANT SELECT ON PEDIDOS_DETALLE TO PROCEDURE REP_FALTANTES_CLIENTES;
GRANT SELECT ON PEDIDOS TO PROCEDURE REP_FALTANTES_CLIENTES;
GRANT SELECT ON COTIZACIONES_DETALLE TO PROCEDURE REP_FALTANTES_CLIENTES;
GRANT SELECT ON COTIZACIONES TO PROCEDURE REP_FALTANTES_CLIENTES;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_FALTANTES_VENDEDOR(
    VENINI VARCHAR(20),
    VENFIN VARCHAR(20),
    FECINI DATE,
    FECFIN DATE,
    DETALLE CHAR(1),
    TIPO INTEGER,
    DESTINO INTEGER,
    ARTINI VARCHAR(15),
    ARTFIN VARCHAR(15),
    ORDEN CHAR(1),
    CEROS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    CODVEND VARCHAR(20),
    NOMVEND VARCHAR(60),
    NOMTIPO VARCHAR(50),
    ARTICULO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    CANTIDAD NUMERIC(18,4),
    UNIDAD VARCHAR(8),
    FALTANTE NUMERIC(18,4),
    BASE NUMERIC(18,2),
    IVA NUMERIC(18,2),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    OBS VARCHAR(255))
AS
declare variable ID INTEGER;
declare variable ITEM INTEGER;
declare variable CODINI VARCHAR(15);
declare variable CODFIN VARCHAR(15);
declare variable DESINI VARCHAR(15);
declare variable DESFIN VARCHAR(15);
declare variable FACTOR NUMERIC(18,4);
declare variable CANT NUMERIC(18,4);
declare variable MONTO NUMERIC(18,2);
declare variable artiaux VARCHAR(20);
BEGIN
if (ORDEN = 'C') then
    BEGIN
    CODINI = ARTINI;
    CODFIN = ARTFIN;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = ARTINI;
    DESFIN = ARTFIN;
    CODINI = '';
    CODFIN = 'zz';
    END

  SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPO INTO :NOMTIPO;
  /*FOR select VEND_COD, VEND_NOMBRE
    from VENDEDORES where VEND_COD >= :VENINI AND VEND_COD <= :VENFIN
    INTO :CODVEND, :NOMVEND
    DO  
    BEGIN*/
    if (DETALLE = 'N') then
        BEGIN
        ARTICULO = '';
        if (TIPO = 31) then
            FOR SELECT F.FACT_ID, FADE_ITEM, D.ARTI_COD, FADE_CANT * FADE_FACTOR, (FADE_PRUNIT-FADE_DTOMONTO),f.vend_cod
                FROM FACTURAS_DETALLE D, FACTURAS F, ARTICULO A, PREFIJOS P
                WHERE F.FACT_ID = D.FACT_ID AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND VEND_COD >= :VENINI AND VEND_COD <= :VENFIN AND FACT_ANULADO = 'N' AND
                      D.ARTI_COD = A.ARTI_COD AND D.ARTI_COD >= :CODINI AND D.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                      P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY VEND_COD,ARTI_COD, F.FACT_ID, FADE_ITEM INTO :ID, :ITEM, :ARTIAUX, :CANT,  :MONTO,:CODVEND
                DO
                BEGIN
                select VEND_NOMBRE from VENDEDORES where  VEND_COD = :CODVEND INTO :NOMVEND;
                if (artiaux <> articulo) then
                    begin
                    if (ARTICULO <> '') then
                        SUSPEND;
                    SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                        FROM articulo WHERE ARTI_COD = :ARTIAUX
                        INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                    SELECT GRUP_NOM FROM GRUPO WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    ARTICULO = ARTIAUX;
                    CANTIDAD = 0;
                    FALTANTE = 0;
                    BASE = 0;
                    end
                CANTIDAD = CANTIDAD + CANT;
                EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:CANT, :UNIDAD, :FACTOR);
                FALTANTE = FALTANTE + CANT;
                BASE = BASE + (MONTO * CANT);
                END
        if (TIPO = 32) then
            FOR SELECT R.revt_id, rvde_item, D.ARTI_COD, RVDE_CANT * RVDE_FACTOR, (RVDE_PRUNIT-RVDE_DTOMONTO),R.vend_cod
                FROM REMISIONES_VENTA_DETALLE D, REMISIONES_VENTA R, ARTICULO A, PREFIJOS P
                WHERE R.REVT_ID = D.REVT_ID AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND VEND_COD >= :VENINI AND VEND_COD <= :VENFIN AND REVT_ANULADO = 'N' AND
                      D.ARTI_COD = A.ARTI_COD AND D.ARTI_COD >= :CODINI AND D.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                      P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY VEND_COD,ARTI_COD, R.REVT_ID, RVDE_ITEM INTO :ID, :ITEM, :ARTIAUX, :CANT, :MONTO,:CODVEND
                DO
                BEGIN
                select VEND_NOMBRE from VENDEDORES where  VEND_COD = :CODVEND INTO :NOMVEND;
                if (artiaux <> articulo) then
                    begin
                    if (ARTICULO <> '') then
                        SUSPEND;
                    SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                        FROM articulo WHERE ARTI_COD = :ARTIAUX
                        INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                    SELECT GRUP_NOM FROM GRUPO WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    ARTICULO = ARTIAUX;
                    CANTIDAD = 0;
                    FALTANTE = 0;
                    BASE = 0;
                    end
                CANTIDAD = CANTIDAD + CANT;
                EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:CANT, :UNIDAD, :FACTOR);
                FALTANTE = FALTANTE + CANT;
                BASE = BASE + (MONTO * CANT);
                END
        if (TIPO = 34) then
            FOR SELECT P.PEDI_ID, PEDE_ITEM, D.ARTI_COD, PEDE_CANT * PEDE_FACTOR, (PEDE_PRUNIT-PEDE_DTOMONTO),p.vend_cod
                FROM PEDIDOS_DETALLE D, PEDIDOS P, ARTICULO A, PREFIJOS PR
                WHERE P.PEDI_ID = D.PEDI_ID AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND VEND_COD >= :VENINI AND VEND_COD <= :VENFIN AND PEDI_ANULADO = 'N' AND
                      D.ARTI_COD = A.ARTI_COD AND D.ARTI_COD >= :CODINI AND D.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                      PR.PREF_PRE = P.PREF_PRE AND PR.TIDO_COD = 34 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY VEND_COD,ARTI_COD, P.PEDI_ID, PEDE_ITEM INTO :ID, :ITEM, :ARTIAUX, :CANT, :MONTO,:CODVEND
                DO
                BEGIN
                select VEND_NOMBRE from VENDEDORES where  VEND_COD = :CODVEND INTO :NOMVEND;
                if (artiaux <> articulo) then
                    begin
                    if (ARTICULO <> '') then
                        SUSPEND;
                    SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                        FROM articulo WHERE ARTI_COD = :ARTIAUX
                        INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                    SELECT GRUP_NOM FROM GRUPO WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    ARTICULO = ARTIAUX;
                    CANTIDAD = 0;
                    FALTANTE = 0;
                    BASE = 0;
                    end
                CANTIDAD = CANTIDAD + CANT;
                EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:CANT, :UNIDAD, :FACTOR);
                FALTANTE = FALTANTE + CANT;
                BASE = BASE + (MONTO * CANT);
                END
        if (TIPO = 35) then
            FOR SELECT C.COTI_ID, CTDE_ITEM, D.ARTI_COD, CTDE_CANT * CTDE_FACTOR, (CTDE_PRUNIT-CTDE_DTOMONTO),c.vend_cod
                FROM COTIZACIONES_DETALLE D, COTIZACIONES C, ARTICULO A, PREFIJOS P
                WHERE C.COTI_ID = D.COTI_ID AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND VEND_COD >= :VENINI AND VEND_COD <= :VENFIN AND COTI_ANULADO = 'N' AND
                      D.ARTI_COD = A.ARTI_COD AND D.ARTI_COD >= :CODINI AND D.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                      P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY VEND_COD,ARTI_COD, C.COTI_ID, CTDE_ITEM INTO :ID, :ITEM, :ARTIAUX, :CANT, :MONTO,:CODVEND
                DO
                BEGIN
                select VEND_NOMBRE from VENDEDORES where  VEND_COD = :CODVEND INTO :NOMVEND;
                if (artiaux <> articulo) then
                    begin
                    if (ARTICULO <> '') then
                        SUSPEND;
                    SELECT ARTI_DES, ARTI_UNIDAD, GRUP_COD, SUBG_COD, MARC_COD
                        FROM articulo WHERE ARTI_COD = :ARTIAUX
                        INTO :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC;
                    SELECT GRUP_NOM FROM GRUPO WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    ARTICULO = ARTIAUX;
                    CANTIDAD = 0;
                    FALTANTE = 0;
                    BASE = 0;
                    end
                CANTIDAD = CANTIDAD + CANT;
                EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:CANT, :UNIDAD, :FACTOR);
                FALTANTE = FALTANTE + CANT;
                BASE = BASE + (MONTO * CANT);
                END
        if (FALTANTE IS NULL) then
            FALTANTE = 0;
        if (BASE IS NULL) then
            BASE = 0;
        if (IVA IS NULL) then
            IVA = 0;
        if ((CEROS = 'S') or (FALTANTE <> 0)) then
            SUSPEND;
        END
    ELSE
        BEGIN
        if (TIPO = 31) then
            FOR SELECT F.FACT_ID, FADE_ITEM, F.PREF_PRE, FACT_NUMERO, FACT_FECHA, FADE_CANT * FADE_FACTOR, (FADE_PRUNIT-FADE_DTOMONTO), FADE_IVAMONTO, D.ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD,f.vend_cod, SUBSTRING(FACT_OBS FROM 1 FOR 255)
                FROM FACTURAS F, FACTURAS_DETALLE D, ARTICULO A, PREFIJOS P
                WHERE F.FACT_ID = D.FACT_ID AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN  AND VEND_COD >= :VENINI AND VEND_COD <= :VENFIN AND FACT_ANULADO = 'N' AND
                      D.ARTI_COD = A.ARTI_COD AND D.ARTI_COD >= :CODINI AND D.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                      P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY VEND_COD,ARTI_COD, F.FACT_ID, FADE_ITEM
                INTO :ID, :ITEM, :PREFIJO, :NUMERO, :FECHA, :CANTIDAD, :BASE, :IVA, :ARTICULO, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC,:CODVEND, :OBS
                DO
                    BEGIN
                    select VEND_NOMBRE from VENDEDORES where  VEND_COD = :CODVEND INTO :NOMVEND;
                    SELECT GRUP_NOM FROM GRUPO WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:FALTANTE, :UNIDAD, :FACTOR);
                    if ((CEROS = 'S') or (FALTANTE <> 0)) then
                        SUSPEND;
                    END
        if (TIPO = 32) then
            FOR SELECT R.REVT_ID, RVDE_ITEM, R.PREF_PRE, REVT_NUMERO, REVT_FECHA, RVDE_CANT * RVDE_FACTOR, (RVDE_PRUNIT-RVDE_DTOMONTO), RVDE_IVAMONTO, D.ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD,R.vend_cod, SUBSTRING(REVT_OBS FROM 1 FOR 255)
                FROM REMISIONES_VENTA R, REMISIONES_VENTA_DETALLE D, ARTICULO A, PREFIJOS P
                WHERE R.REVT_ID = D.REVT_ID AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND VEND_COD >= :VENINI AND VEND_COD <= :VENFIN AND REVT_ANULADO = 'N' AND
                      D.ARTI_COD = A.ARTI_COD AND D.ARTI_COD >= :CODINI AND D.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                      P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 33 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY VEND_COD,ARTI_COD, R.REVT_ID, RVDE_ITEM
                INTO :ID, :ITEM, :PREFIJO, :NUMERO, :FECHA, :CANTIDAD, :BASE, :IVA, :ARTICULO, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC,:CODVEND, :OBS
                DO
                    BEGIN
                    select VEND_NOMBRE from VENDEDORES where  VEND_COD = :CODVEND INTO :NOMVEND;
                    SELECT GRUP_NOM FROM GRUPO WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:FALTANTE, :UNIDAD, :FACTOR);
                    if ((CEROS = 'S') or (FALTANTE <> 0)) then
                        SUSPEND;
                    END
        if (TIPO = 34) then
            FOR SELECT P.PEDI_ID, PEDE_ITEM, P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, PEDE_CANT * PEDE_FACTOR, (PEDE_PRUNIT-PEDE_DTOMONTO), PEDE_IVAMONTO, D.ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD,P.vend_cod, SUBSTRING(PEDI_OBS FROM 1 FOR 255)
                FROM PEDIDOS P, PEDIDOS_DETALLE D, ARTICULO A, PREFIJOS PR
                WHERE P.PEDI_ID = D.PEDI_ID AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND VEND_COD >= :VENINI AND VEND_COD <= :VENFIN AND PEDI_ANULADO = 'N' AND
                      D.ARTI_COD = A.ARTI_COD AND D.ARTI_COD >= :CODINI AND D.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                      P.PREF_PRE = PR.PREF_PRE AND PR.TIDO_COD = 34 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY VEND_COD,ARTI_COD, P.PEDI_ID, PEDE_ITEM
                INTO :ID, :ITEM, PREFIJO, :NUMERO, :FECHA, :CANTIDAD, :BASE, :IVA, :ARTICULO, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC,:CODVEND, :OBS
                DO
                    BEGIN
                    select VEND_NOMBRE from VENDEDORES where  VEND_COD = :CODVEND INTO :NOMVEND;
                    SELECT GRUP_NOM FROM GRUPO WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:FALTANTE, :UNIDAD, :FACTOR);
                    if ((CEROS = 'S') or (FALTANTE <> 0)) then
                        SUSPEND;
                    END
        if (TIPO = 35) then
            FOR SELECT C.COTI_ID, CTDE_ITEM, C.PREF_PRE, COTI_NUMERO, COTI_FECHA, CTDE_CANT * CTDE_FACTOR, (CTDE_PRUNIT-CTDE_DTOMONTO), CTDE_IVAMONTO, D.ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD,C.vend_cod, SUBSTRING(COTI_OBS FROM 1 FOR 255)
                FROM COTIZACIONES C, COTIZACIONES_DETALLE D, ARTICULO A, PREFIJOS P
                WHERE C.COTI_ID = D.COTI_ID AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND VEND_COD >= :VENINI AND VEND_COD <= :VENFIN AND COTI_ANULADO = 'N' AND
                      D.ARTI_COD = A.ARTI_COD AND D.ARTI_COD >= :CODINI AND D.ARTI_COD <= :CODFIN AND A.ARTI_DES >= :DESINI AND A.ARTI_DES <= :DESFIN AND
                      P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND ((P.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
                ORDER BY VEND_COD,ARTI_COD, C.COTI_ID, CTDE_ITEM
                INTO :ID, :ITEM, PREFIJO, :NUMERO, :FECHA, :CANTIDAD, :BASE, :IVA, :ARTICULO, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC,:CODVEND, :OBS
                DO
                    BEGIN
                    select VEND_NOMBRE from VENDEDORES where  VEND_COD = :CODVEND INTO :NOMVEND;
                    SELECT GRUP_NOM FROM GRUPO WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
                    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
                    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
                    EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:FALTANTE, :UNIDAD, :FACTOR);
                    if ((CEROS = 'S') or (FALTANTE <> 0)) then
                        SUSPEND;
                    END
        END
   /* END*/
END
^

SET TERM ; ^

GRANT SELECT ON TIPO_DOCUMENTO TO PROCEDURE REP_FALTANTES_VENDEDOR;
GRANT SELECT ON FACTURAS_DETALLE TO PROCEDURE REP_FALTANTES_VENDEDOR;
GRANT SELECT ON FACTURAS TO PROCEDURE REP_FALTANTES_VENDEDOR;
GRANT SELECT ON ARTICULO TO PROCEDURE REP_FALTANTES_VENDEDOR;
GRANT SELECT ON PREFIJOS TO PROCEDURE REP_FALTANTES_VENDEDOR;
GRANT SELECT ON VENDEDORES TO PROCEDURE REP_FALTANTES_VENDEDOR;
GRANT SELECT ON GRUPO TO PROCEDURE REP_FALTANTES_VENDEDOR;
GRANT SELECT ON MARCAS TO PROCEDURE REP_FALTANTES_VENDEDOR;
GRANT SELECT ON SUBGRUPO TO PROCEDURE REP_FALTANTES_VENDEDOR;
GRANT EXECUTE ON PROCEDURE FALTANTE TO PROCEDURE REP_FALTANTES_VENDEDOR;
GRANT SELECT ON REMISIONES_VENTA_DETALLE TO PROCEDURE REP_FALTANTES_VENDEDOR;
GRANT SELECT ON REMISIONES_VENTA TO PROCEDURE REP_FALTANTES_VENDEDOR;
GRANT SELECT ON PEDIDOS_DETALLE TO PROCEDURE REP_FALTANTES_VENDEDOR;
GRANT SELECT ON PEDIDOS TO PROCEDURE REP_FALTANTES_VENDEDOR;
GRANT SELECT ON COTIZACIONES_DETALLE TO PROCEDURE REP_FALTANTES_VENDEDOR;
GRANT SELECT ON COTIZACIONES TO PROCEDURE REP_FALTANTES_VENDEDOR;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE FALTANTES_VENTAS_ARTICULO(
    DESDE VARCHAR(20),
    HASTA VARCHAR(20),
    FECINI DATE,
    FECFIN DATE,
    DETALLE CHAR(1),
    TIPO INTEGER,
    DESTINO INTEGER,
    ORDEN CHAR(1),
    CEROS CHAR(1),
    SUCURSAL INTEGER)
RETURNS (
    ARTICULO VARCHAR(15),
    DESCRIPCION VARCHAR(60),
    CODGRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    CODSUBG VARCHAR(3),
    NOMSUBG VARCHAR(30),
    CODMARC VARCHAR(3),
    NOMMARC VARCHAR(30),
    CANTIDAD NUMERIC(18,4),
    UNIDAD VARCHAR(8),
    FALTANTE NUMERIC(18,4),
    BASE NUMERIC(18,2),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    OBS VARCHAR(255))
AS
declare variable ID INTEGER;
declare variable ITEM INTEGER;
declare variable CANT NUMERIC(18,2);
declare variable CODINI VARCHAR(15);
declare variable CODFIN VARCHAR(15);
declare variable DESINI VARCHAR(15);
declare variable DESFIN VARCHAR(15);
declare variable MONTO NUMERIC(18,2);
declare variable FACTOR NUMERIC(18,4);
BEGIN
if (ORDEN = 'C') then
    BEGIN
    CODINI = DESDE;
    CODFIN = HASTA;
    DESINI = '';
    DESFIN = 'zz';
    END
ELSE
    BEGIN
    DESINI = DESDE;
    DESFIN = HASTA;
    CODINI = '';
    CODFIN = 'zz';
    END
  FOR SELECT ARTI_COD, ARTI_DES, ARTI_UNIDAD, A.GRUP_COD, A.SUBG_COD, A.MARC_COD FROM ARTICULO A
      WHERE ARTI_COD >= :CODINI AND ARTI_COD <= :CODFIN AND ARTI_DES >= :DESINI AND ARTI_DES <= :DESFIN
      INTO :ARTICULO, :DESCRIPCION, :UNIDAD, :CODGRUPO, :CODSUBG, :CODMARC
  DO
    BEGIN
    CANTIDAD = 0;
    faltante = 0;
    base = 0;
    SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :CODGRUPO INTO NOMGRUPO;
    SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :CODMARC INTO NOMMARC;
    SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :CODSUBG AND GRUP_COD = :CODGRUPO INTO :NOMSUBG;
    if (DETALLE = 'N') then
        BEGIN
        if (TIPO = 31) then
            BEGIN
            FOR SELECT F.FACT_ID, FADE_ITEM, FADE_CANT * FADE_FACTOR, (FADE_PRUNIT-FADE_DTOMONTO)
                FROM FACTURAS_DETALLE D, FACTURAS F, PREFIJOS P
                WHERE F.FACT_ID = D.FACT_ID AND ARTI_COD = :ARTICULO AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N' AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((SUCU_ID = :SUCURSAL) or (:SUCURSAL = 0))
                ORDER BY F.FACT_ID, FADE_ITEM INTO :ID, :ITEM, :CANT, :MONTO
                DO
                BEGIN
                CANTIDAD = CANTIDAD + CANT;
                EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:CANT, :UNIDAD, :FACTOR);
                FALTANTE = FALTANTE + CANT;
                BASE = BASE + MONTO * CANT;
                END
            END
        if (TIPO = 32) then
            BEGIN
            FOR SELECT R.revt_id, rvde_item, RVDE_CANT * RVDE_FACTOR, (RVDE_PRUNIT-RVDE_DTOMONTO)
                FROM REMISIONES_VENTA_DETALLE D, REMISIONES_VENTA R, PREFIJOS P
                WHERE R.REVT_ID = D.REVT_ID AND ARTI_COD = :ARTICULO AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND REVT_ANULADO = 'N' AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32  AND ((SUCU_ID = :SUCURSAL) or (:SUCURSAL = 0))
                ORDER BY R.REVT_ID, RVDE_ITEM INTO :ID, :ITEM, :CANT, :MONTO
                DO
                BEGIN
                CANTIDAD = CANTIDAD + CANT;
                EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:CANT, :UNIDAD, :FACTOR);
                FALTANTE = FALTANTE + CANT;
                BASE = BASE + MONTO * CANT;
                END
            END
        if (TIPO = 34) then
            BEGIN
            FOR SELECT P.PEDI_ID, PEDE_ITEM, PEDE_CANT * PEDE_FACTOR, (PEDE_PRUNIT-PEDE_DTOMONTO)
                FROM PEDIDOS_DETALLE D, PEDIDOS P, PREFIJOS R
                WHERE P.PEDI_ID = D.PEDI_ID AND ARTI_COD = :ARTICULO AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND PEDI_ANULADO = 'N' AND P.PREF_PRE = R.PREF_PRE AND R.TIDO_COD = 34  AND ((SUCU_ID = :SUCURSAL) or (:SUCURSAL = 0))
                ORDER BY P.PEDI_ID, PEDE_ITEM INTO :ID, :ITEM, :CANT, :MONTO
                DO
                BEGIN
                CANTIDAD = CANTIDAD + CANT;
                EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:CANT, :UNIDAD, :FACTOR);
                FALTANTE = FALTANTE + CANT;
                BASE = BASE + MONTO * CANT;
                END
            END
        if (TIPO = 35) then
            BEGIN
            FOR SELECT C.COTI_ID, CTDE_ITEM, CTDE_CANT * CTDE_FACTOR, (CTDE_PRUNIT-CTDE_DTOMONTO)
                FROM COTIZACIONES_DETALLE D, COTIZACIONES C, PREFIJOS P
                WHERE C.COTI_ID = D.COTI_ID AND ARTI_COD = :ARTICULO AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND COTI_ANULADO = 'N' AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35  AND ((SUCU_ID = :SUCURSAL) or (:SUCURSAL = 0))
                ORDER BY C.COTI_ID, CTDE_ITEM INTO :ID, :ITEM, :CANT, :MONTO
                DO
                BEGIN
                CANTIDAD = CANTIDAD + CANT;
                EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:CANT, :UNIDAD, :FACTOR);
                FALTANTE = FALTANTE + CANT;
                BASE = BASE + MONTO * CANT;
                END
            END
        if (CANTIDAD IS NULL) then
            CANTIDAD = 0;
        if (BASE IS NULL) then
            BASE = 0;
        if (FALTANTE IS NULL) then
            FALTANTE = 0;
        if (CEROS = 'S') then
            SUSPEND;
        ELSE
            if (FALTANTE <> 0) then
                SUSPEND;
        END
    ELSE
        BEGIN
        if (TIPO = 31) then
            FOR SELECT F.FACT_ID, FADE_ITEM, F.PREF_PRE, FACT_NUMERO, FACT_FECHA, FADE_CANT * FADE_FACTOR, (FADE_PRUNIT-FADE_DTOMONTO), SUBSTRING(FACT_OBS FROM 1 FOR 255)
                FROM FACTURAS F, FACTURAS_DETALLE D, PREFIJOS P
                WHERE F.FACT_ID = D.FACT_ID AND ARTI_COD = :ARTICULO AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN AND FACT_ANULADO = 'N' AND P.PREF_PRE = F.PREF_PRE AND P.TIDO_COD = 31 AND ((SUCU_ID = :SUCURSAL) or (:SUCURSAL = 0))
                ORDER BY F.FACT_ID, FADE_ITEM
                INTO :ID, :ITEM, :PREFIJO, :NUMERO, :FECHA, :CANTIDAD, :BASE, :OBS
                DO
                    BEGIN
                    EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:FALTANTE, :UNIDAD, :FACTOR);
                    if ((CEROS = 'S') or (FALTANTE <> 0)) then
                        SUSPEND;
                    END
        if (TIPO = 32) then
            FOR SELECT R.REVT_ID, RVDE_ITEM, R.PREF_PRE, REVT_NUMERO, REVT_FECHA, RVDE_CANT * RVDE_FACTOR, (RVDE_PRUNIT-RVDE_DTOMONTO), SUBSTRING(REVT_OBS FROM 1 FOR 255)
                FROM REMISIONES_VENTA R, REMISIONES_VENTA_DETALLE D, PREFIJOS P
                WHERE R.REVT_ID = D.REVT_ID AND ARTI_COD = :ARTICULO AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN AND REVT_ANULADO = 'N' AND P.PREF_PRE = R.PREF_PRE AND P.TIDO_COD = 32 AND ((SUCU_ID = :SUCURSAL) or (:SUCURSAL = 0))
                INTO :ID, :ITEM, :PREFIJO, :NUMERO, :FECHA, :CANTIDAD, :BASE, :OBS
                DO
                    BEGIN
                    EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:FALTANTE, :UNIDAD, :FACTOR);
                    if ((CEROS = 'S') or (FALTANTE <> 0)) then
                        SUSPEND;
                    END
        if (TIPO = 34) then
            FOR SELECT P.PEDI_ID, PEDE_ITEM, P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, PEDE_CANT * PEDE_FACTOR, (PEDE_PRUNIT-PEDE_DTOMONTO), SUBSTRING(PEDI_OBS FROM 1 FOR 255)
                FROM PEDIDOS P, PEDIDOS_DETALLE D, PREFIJOS R
                WHERE P.PEDI_ID = D.PEDI_ID AND ARTI_COD = :ARTICULO AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN AND PEDI_ANULADO = 'N' AND P.PREF_PRE = R.PREF_PRE AND R.TIDO_COD = 34 AND ((SUCU_ID = :SUCURSAL) or (:SUCURSAL = 0))
                INTO :ID, :ITEM, PREFIJO, :NUMERO, :FECHA, :CANTIDAD, :BASE, :OBS
                DO
                    BEGIN
                    EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:FALTANTE, :UNIDAD, :FACTOR);
                    if ((CEROS = 'S') or (FALTANTE <> 0)) then
                        SUSPEND;
                    END
        if (TIPO = 35) then
            FOR SELECT C.COTI_ID, CTDE_ITEM, C.PREF_PRE, COTI_NUMERO, COTI_FECHA, CTDE_CANT * CTDE_FACTOR, (CTDE_PRUNIT-CTDE_DTOMONTO), SUBSTRING(COTI_OBS FROM 1 FOR 255)
                FROM COTIZACIONES C, COTIZACIONES_DETALLE D, PREFIJOS P
                WHERE C.COTI_ID = D.COTI_ID AND ARTI_COD = :ARTICULO AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN AND COTI_ANULADO = 'N' AND P.PREF_PRE = C.PREF_PRE AND P.TIDO_COD = 35 AND ((SUCU_ID = :SUCURSAL) or (:SUCURSAL = 0))
                INTO :ID, :ITEM, PREFIJO, :NUMERO, :FECHA, :CANTIDAD, :BASE, :OBS
                DO
                    BEGIN
                    EXECUTE PROCEDURE FALTANTE(:TIPO, :DESTINO, :ID, :ITEM) returning_values (:FALTANTE, :UNIDAD, :FACTOR);
                    if ((CEROS = 'S') or (FALTANTE <> 0)) then
                        SUSPEND;
                    END
        END
    END
END
^

SET TERM ; ^

GRANT SELECT ON ARTICULO TO PROCEDURE FALTANTES_VENTAS_ARTICULO;
GRANT SELECT ON GRUPO TO PROCEDURE FALTANTES_VENTAS_ARTICULO;
GRANT SELECT ON MARCAS TO PROCEDURE FALTANTES_VENTAS_ARTICULO;
GRANT SELECT ON SUBGRUPO TO PROCEDURE FALTANTES_VENTAS_ARTICULO;
GRANT SELECT ON FACTURAS_DETALLE TO PROCEDURE FALTANTES_VENTAS_ARTICULO;
GRANT SELECT ON FACTURAS TO PROCEDURE FALTANTES_VENTAS_ARTICULO;
GRANT SELECT ON PREFIJOS TO PROCEDURE FALTANTES_VENTAS_ARTICULO;
GRANT EXECUTE ON PROCEDURE FALTANTE TO PROCEDURE FALTANTES_VENTAS_ARTICULO;
GRANT SELECT ON REMISIONES_VENTA_DETALLE TO PROCEDURE FALTANTES_VENTAS_ARTICULO;
GRANT SELECT ON REMISIONES_VENTA TO PROCEDURE FALTANTES_VENTAS_ARTICULO;
GRANT SELECT ON PEDIDOS_DETALLE TO PROCEDURE FALTANTES_VENTAS_ARTICULO;
GRANT SELECT ON PEDIDOS TO PROCEDURE FALTANTES_VENTAS_ARTICULO;
GRANT SELECT ON COTIZACIONES_DETALLE TO PROCEDURE FALTANTES_VENTAS_ARTICULO;
GRANT SELECT ON COTIZACIONES TO PROCEDURE FALTANTES_VENTAS_ARTICULO;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_COMPROBANTES_FAC(
    TIPO INTEGER,
    DETALLE CHAR(1),
    FECINI DATE,
    FECFIN DATE,
    PREFINI VARCHAR(4),
    PREFFIN VARCHAR(4),
    PTOINI INTEGER,
    PTOFIN INTEGER,
    ANULADOS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    NOMTIPO VARCHAR(30),
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    VENCE DATE,
    CODBOD VARCHAR(2),
    NOMBOD VARCHAR(30),
    AUTORIZA VARCHAR(20),
    PTVTID INTEGER,
    PTVTNOM VARCHAR(60),
    VENDCOD INTEGER,
    VENDNOM VARCHAR(60),
    COMIPORC NUMERIC(9,2),
    COMIMONTO NUMERIC(18,2),
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    PEDIDO VARCHAR(30),
    COTIZACI VARCHAR(30),
    REMISION VARCHAR(30),
    OBS VARCHAR(255),
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    UNIDAD VARCHAR(8),
    BODITEM VARCHAR(2),
    LOTE VARCHAR(15),
    REFERENCIA VARCHAR(60),
    PRECIO NUMERIC(18,2),
    DTOPORCIT NUMERIC(9,2),
    DTOMONTOIT NUMERIC(18,2),
    IVAPORCIT NUMERIC(9,2),
    IVAMONTOIT NUMERIC(18,2),
    CONSUMOIT NUMERIC(18,2),
    SUBTOTALIT NUMERIC(18,2),
    DTOPOR NUMERIC(9,2),
    DTOMONTO NUMERIC(18,2),
    ADICIONAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    RTFTEPOR NUMERIC(9,2),
    RTFTEMONTO NUMERIC(18,2),
    RTIVAPOR NUMERIC(9,2),
    RTIVAMONTO NUMERIC(18,2),
    RTICAPOR NUMERIC(9,2),
    RTICAMONTO NUMERIC(18,2),
    EXTRA NUMERIC(18,2),
    DTOFPOR NUMERIC(9,2),
    DTOFMONTO NUMERIC(18,2),
    DTOFFECHA DATE,
    TOTAL NUMERIC(18,2),
    ANULADO CHAR(1),
    VEHICULO VARCHAR(8))
AS
declare variable descaux varchar(255);
BEGIN
VEHICULO = '';
  /* DETERMINE LA TABLA A EXAMINAR */
  if (BIN_AND(TIPO, 1) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
    FOR SELECT FACT_ID, F.PREF_PRE, FACT_NUMERO, FACT_FECHA, FACT_VENCE, F.BODE_COD, B.BODE_NOM, F.AUTO_NUMERO, F.PTVT_ID, PTVT_NOM, F.VEND_COD, VEND_NOMBRE, F.FACT_COMIPORC, F.FACT_COMIMONTO, F.TERC_NIT, FACT_NOMCLIENTE, FACT_PEDIDO, FACT_COTIZACI, FACT_REMISION, FACT_DTOPOR, FACT_DTOMONTO, FACT_ADICIONAL, FACT_IVAMONTO, FACT_RTFTEPOR, FACT_RTFTEMONTO, FACT_RTIVAPOR, FACT_RTIVAMONTO, FACT_RTICAPOR, FACT_RTICAMONTO, FACT_EXTRA, FACT_DTOFPOR, FACT_DTOFMONTO, FACT_DTOFFECHA, FACT_TOTAL, FACT_ANULADO, VEHI_COD, SUBSTRING(FACT_OBS FROM 1 FOR 255)
        FROM FACTURAS F, BODEGA B, PUNTO_VENTA P, VENDEDORES V, PREFIJOS PR WHERE F.PTVT_ID >= :PTOINI AND F.PTVT_ID <= :PTOFIN AND
         F.BODE_COD = B.BODE_COD AND F.PTVT_ID = P.PTVT_ID AND F.VEND_COD = V.VEND_COD AND FACT_FECHA >= :FECINI AND FACT_FECHA <= :FECFIN
         AND PR.PREF_PRE = F.PREF_PRE AND PR.TIDO_COD = 31 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) AND
         F.PREF_PRE >= :prefini AND F.PREF_PRE <= :preffin
        ORDER BY FACT_FECHA, FACT_ID
        INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :CODBOD, :NOMBOD, :AUTORIZA, :PTVTID, :PTVTNOM, :VENDCOD, :VENDNOM, :COMIPORC, :COMIMONTO, :NIT, :NOMTERCERO, :PEDIDO, :COTIZACI, :REMISION, :DTOPOR, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTFTEPOR, :RTFTEMONTO, :RTIVAPOR, :RTIVAMONTO, :RTICAPOR, :RTICAMONTO, :EXTRA, :DTOFPOR, :DTOFMONTO, :DTOFFECHA, :TOTAL, :ANULADO, :VEHICULO, :OBS
        DO
        BEGIN
        if ((ANULADOS = 'S') or (ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
                BEGIN
                COMIPORC = 0;
                COMIMONTO = 0;
                DTOPOR = 0;
                DTOMONTO = 0;
                ADICIONAL = 0;
                IVAMONTO = 0;
                RTFTEPOR = 0;
                RTFTEMONTO = 0;
                RTIVAPOR = 0;
                RTIVAMONTO = 0;
                RTICAPOR = 0;
                RTICAMONTO = 0;
                EXTRA = 0;
                DTOFPOR = 0;
                DTOFMONTO = 0;
                TOTAL = 0;
                END
            if (DETALLE = 'S') then
                BEGIN
                if (anulado = 'S') then
                    BEGIN
                    ITEM = 0;
                    ARTICULO = '';
                    CODBAR = '';
                    ARTIDES = '';
                    CANT = 0;
                    UNIDAD = '';
                    BODITEM = '';
                    LOTE = '';
                    REFERENCIA = '';
                    PRECIO = 0;
                    DTOPORCIT = 0;
                    DTOMONTOIT = 0;
                    IVAPORCIT = 0;
                    IVAMONTOIT = 0;
                    CONSUMOIT = 0;
                    SUBTOTALIT = 0;
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    FOR SELECT FADE_ITEM, ARTI_COD, FADE_CODBAR, FADE_DESC, FADE_CANT, FADE_UNIDAD, BODE_COD, FADE_LOTE, FADE_REFERENCIA, FADE_PRUNIT, FADE_DTOPORC, FADE_DTOMONTO, FADE_IVAPORC, FADE_IVAMONTO, FADE_CONSUMO, FADE_TOTAL
                        FROM FACTURAS_DETALLE
                        WHERE FACT_ID = :ID
                        ORDER BY FADE_ITEM
                        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :REFERENCIA, :PRECIO, :DTOPORCIT, :DTOMONTOIT, :IVAPORCIT, :IVAMONTOIT, :CONSUMOIT, :SUBTOTALIT
                        DO
                        SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
            END
        END
    END
  if (BIN_AND(TIPO, 2) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
    FOR SELECT REVT_ID, R.PREF_PRE, REVT_NUMERO, REVT_FECHA, REVT_FECHA VENCE, R.BODE_COD, B.BODE_NOM, '', R.PTVT_ID, PTVT_NOM, R.VEND_COD, VEND_NOMBRE, 0, 0, R.TERC_NIT, REVT_NOMTERC, '', '', '', 0, 0, 0, REVT_IVAMONTO, 0, 0, 0, 0, 0, 0, 0, 0, 0, REVT_FECHA DTOF, REVT_TOTAL, REVT_ANULADO, SUBSTRING(REVT_OBS FROM 1 FOR 255)
        FROM REMISIONES_VENTA R, BODEGA B, PUNTO_VENTA P, VENDEDORES V, PREFIJOS PR WHERE R.PTVT_ID >= :PTOINI AND R.PTVT_ID <= :PTOFIN AND
         R.BODE_COD = B.BODE_COD AND R.PTVT_ID = P.PTVT_ID AND R.VEND_COD = V.VEND_COD AND REVT_FECHA >= :FECINI AND REVT_FECHA <= :FECFIN
         AND PR.PREF_PRE = R.PREF_PRE AND PR.TIDO_COD = 32 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) AND
         R.PREF_PRE >= :prefini AND R.PREF_PRE <= :preffin
        ORDER BY REVT_FECHA, REVT_ID
        INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :CODBOD, :NOMBOD, :AUTORIZA, :PTVTID, :PTVTNOM, :VENDCOD, :VENDNOM, :COMIPORC, :COMIMONTO, :NIT, :NOMTERCERO, :PEDIDO, :COTIZACI, :REMISION, :DTOPOR, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTFTEPOR, :RTFTEMONTO, :RTIVAPOR, :RTIVAMONTO, :RTICAPOR, :RTICAMONTO, :EXTRA, :DTOFPOR, :DTOFMONTO, :DTOFFECHA, :TOTAL, :ANULADO, :OBS
        DO
        BEGIN
        if ((ANULADOS = 'S') or (ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
                BEGIN
                COMIPORC = 0;
                COMIMONTO = 0;
                DTOPOR = 0;
                DTOMONTO = 0;
                ADICIONAL = 0;
                IVAMONTO = 0;
                RTFTEPOR = 0;
                RTFTEMONTO = 0;
                RTIVAPOR = 0;
                RTIVAMONTO = 0;
                RTICAPOR = 0;
                RTICAMONTO = 0;
                EXTRA = 0;
                DTOFPOR = 0;
                DTOFMONTO = 0;
                TOTAL = 0;
                END
            if (DETALLE = 'S') then
                BEGIN
                if (anulado = 'S') then
                    BEGIN
                    ITEM = 0;
                    ARTICULO = '';
                    CODBAR = '';
                    ARTIDES = '';
                    CANT = 0;
                    UNIDAD = '';
                    BODITEM = '';
                    LOTE = '';
                    REFERENCIA = '';
                    PRECIO = 0;
                    DTOPORCIT = 0;
                    DTOMONTOIT = 0;
                    IVAPORCIT = 0;
                    IVAMONTOIT = 0;
                    CONSUMOIT = 0;
                    SUBTOTALIT = 0;
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    FOR SELECT RVDE_ITEM, ARTI_COD, RVDE_CODBAR, RVDE_DESC, RVDE_CANT, RVDE_UNIDAD, BODE_COD, RVDE_LOTE, RVDE_REFERENCIA, RVDE_PRUNIT, RVDE_DTOPORC, RVDE_DTOMONTO, RVDE_IVAPORC, RVDE_IVAMONTO, RVDE_CONSUMO, RVDE_TOTAL
                        FROM REMISIONES_VENTA_DETALLE
                        WHERE REVT_ID = :ID
                        ORDER BY RVDE_ITEM
                        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :REFERENCIA, :PRECIO, :DTOPORCIT, :DTOMONTOIT, :IVAPORCIT, :IVAMONTOIT, :CONSUMOIT, :SUBTOTALIT
                        DO
                        SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
            END
        END
    END
  if (BIN_AND(TIPO, 4) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
    FOR SELECT DEVT_ID, D.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, DEVT_FECHA VENCE, D.BODE_COD, B.BODE_NOM, '', D.PTVT_ID, PTVT_NOM, D.VEND_COD, VEND_NOMBRE, DEVT_COMIPORC, DEVT_COMIMONTO, D.TERC_NIT, DEVT_NOMTERC, '', '', '', DEVT_DTOPOR, DEVT_DTOMONTO, DEVT_ADICIONAL, DEVT_IVAMONTO, DEVT_RTFTEPORC, DEVT_RTFTEMONTO, DEVT_RTIVAPORC, DEVT_RTIVAMONTO, DEVT_RTICAPORC, DEVT_RTICAMONTO, DEVT_EXTRA, 0, 0, DEVT_FECHA DTOF, DEVT_TOTAL, DEVT_ANULADO, SUBSTRING(DEVT_OBS FROM 1 FOR 255)
        FROM DEVOLUCIONES_VENTAS D, BODEGA B, PUNTO_VENTA P, VENDEDORES V, PREFIJOS PR WHERE D.PTVT_ID >= :PTOINI AND D.PTVT_ID <= :PTOFIN AND
         D.BODE_COD = B.BODE_COD AND D.PTVT_ID = P.PTVT_ID AND D.VEND_COD = V.VEND_COD AND DEVT_FECHA >= :FECINI AND DEVT_FECHA <= :FECFIN
         AND PR.PREF_PRE = D.PREF_PRE AND PR.TIDO_COD = 33 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) AND
         D.PREF_PRE >= :prefini AND D.PREF_PRE <= :preffin
        ORDER BY DEVT_FECHA, DEVT_ID
        INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :CODBOD, :NOMBOD, :AUTORIZA, :PTVTID, :PTVTNOM, :VENDCOD, :VENDNOM, :COMIPORC, :COMIMONTO, :NIT, :NOMTERCERO, :PEDIDO, :COTIZACI, :REMISION, :DTOPOR, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTFTEPOR, :RTFTEMONTO, :RTIVAPOR, :RTIVAMONTO, :RTICAPOR, :RTICAMONTO, :EXTRA, :DTOFPOR, :DTOFMONTO, :DTOFFECHA, :TOTAL, :ANULADO, :OBS
        DO
        BEGIN
        if ((ANULADOS = 'S') or (ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
                BEGIN
                COMIPORC = 0;
                COMIMONTO = 0;
                DTOPOR = 0;
                DTOMONTO = 0;
                ADICIONAL = 0;
                IVAMONTO = 0;
                RTFTEPOR = 0;
                RTFTEMONTO = 0;
                RTIVAPOR = 0;
                RTIVAMONTO = 0;
                RTICAPOR = 0;
                RTICAMONTO = 0;
                EXTRA = 0;
                DTOFPOR = 0;
                DTOFMONTO = 0;
                TOTAL = 0;
                END
            if (DETALLE = 'S') then
                BEGIN
                if (anulado = 'S') then
                    BEGIN
                    ITEM = 0;
                    ARTICULO = '';
                    CODBAR = '';
                    ARTIDES = '';
                    CANT = 0;
                    UNIDAD = '';
                    BODITEM = '';
                    LOTE = '';
                    REFERENCIA = '';
                    PRECIO = 0;
                    DTOPORCIT = 0;
                    DTOMONTOIT = 0;
                    IVAPORCIT = 0;
                    IVAMONTOIT = 0;
                    CONSUMOIT = 0;
                    SUBTOTALIT = 0;
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    FOR SELECT DVDE_ITEM, ARTI_COD, DVDE_CODBAR, DVDE_DESC, DVDE_CANT, DVDE_UNIDAD, BODE_COD, DVDE_LOTE, DVDE_REFERENCIA, DVDE_PRUNIT, DVDE_DTOPORC, DVDE_DTOMONTO, DVDE_IVAPORC, DVDE_IVAMONTO, DVDE_CONSUMO, DVDE_TOTAL
                        FROM DEVOLUCIONES_VENTAS_DETALLE
                        WHERE DEVT_ID = :ID
                        ORDER BY DVDE_ITEM
                        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :REFERENCIA, :PRECIO, :DTOPORCIT, :DTOMONTOIT, :IVAPORCIT, :IVAMONTOIT, :CONSUMOIT, :SUBTOTALIT
                        DO
                        SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
            END
        END
    END
  if (BIN_AND(TIPO, 8) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
    FOR SELECT PEDI_ID, P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, PEDI_FECHA VENCE, '', '', '', P.PTVT_ID, PTVT_NOM, P.VEND_COD, VEND_NOMBRE, 0, 0, P.TERC_NIT, PEDI_NOMTERC, '', '', '', PEDI_DTOPOR, PEDI_DTOMONTO, PEDI_ADICIONAL, PEDI_IVAMONTO, 0, 0, 0, 0, 0, 0, PEDI_EXTRA, 0, 0, PEDI_FECHA DTOF, PEDI_TOTAL, PEDI_ANULADO, SUBSTRING(PEDI_OBS FROM 1 FOR 255)
        FROM PEDIDOS P, PUNTO_VENTA PT, VENDEDORES V, PREFIJOS PR WHERE P.PTVT_ID >= :PTOINI AND P.PTVT_ID <= :PTOFIN AND
         P.PTVT_ID = PT.PTVT_ID AND P.VEND_COD = V.VEND_COD AND PEDI_FECHA >= :FECINI AND PEDI_FECHA <= :FECFIN
         AND PR.PREF_PRE = P.PREF_PRE AND PR.TIDO_COD = 34 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) AND
         P.PREF_PRE >= :prefini AND P.PREF_PRE <= :preffin
        ORDER BY PEDI_FECHA, PEDI_ID
        INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :CODBOD, :NOMBOD, :AUTORIZA, :PTVTID, :PTVTNOM, :VENDCOD, :VENDNOM, :COMIPORC, :COMIMONTO, :NIT, :NOMTERCERO, :PEDIDO, :COTIZACI, :REMISION, :DTOPOR, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTFTEPOR, :RTFTEMONTO, :RTIVAPOR, :RTIVAMONTO, :RTICAPOR, :RTICAMONTO, :EXTRA, :DTOFPOR, :DTOFMONTO, :DTOFFECHA, :TOTAL, :ANULADO, :OBS
        DO
        BEGIN
        if ((ANULADOS = 'S') or (ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
                BEGIN
                COMIPORC = 0;
                COMIMONTO = 0;
                DTOPOR = 0;
                DTOMONTO = 0;
                ADICIONAL = 0;
                IVAMONTO = 0;
                RTFTEPOR = 0;
                RTFTEMONTO = 0;
                RTIVAPOR = 0;
                RTIVAMONTO = 0;
                RTICAPOR = 0;
                RTICAMONTO = 0;
                EXTRA = 0;
                DTOFPOR = 0;
                DTOFMONTO = 0;
                TOTAL = 0;
                END
            if (DETALLE = 'S') then
                BEGIN
                if (anulado = 'S') then
                    BEGIN
                    ITEM = 0;
                    ARTICULO = '';
                    CODBAR = '';
                    ARTIDES = '';
                    CANT = 0;
                    UNIDAD = '';
                    BODITEM = '';
                    LOTE = '';
                    REFERENCIA = '';
                    PRECIO = 0;
                    DTOPORCIT = 0;
                    DTOMONTOIT = 0;
                    IVAPORCIT = 0;
                    IVAMONTOIT = 0;
                    CONSUMOIT = 0;
                    SUBTOTALIT = 0;
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    FOR SELECT PEDE_ITEM, ARTI_COD, PEDE_CODBAR, PEDE_DESC, PEDE_CANT, PEDE_UNIDAD, '', '', PEDE_REFERENCIA, PEDE_PRUNIT, PEDE_DTOPORC, PEDE_DTOMONTO, PEDE_IVAPORC, PEDE_IVAMONTO, PEDE_CONSUMO, PEDE_TOTAL
                        FROM PEDIDOS_DETALLE
                        WHERE PEDI_ID = :ID
                        ORDER BY PEDE_ITEM
                        INTO :ITEM, :ARTICULO, :CODBAR, :descaux, :CANT, :UNIDAD, :BODITEM, :LOTE, :REFERENCIA, :PRECIO, :DTOPORCIT, :DTOMONTOIT, :IVAPORCIT, :IVAMONTOIT, :CONSUMOIT, :SUBTOTALIT
                        DO
                         begin
                          if (STRLEN(descaux)> 60 ) then
                            ARTIDES = SUBSTR(descaux,1,60);
                          ELSE
                            ARTIDES = :descaux;
                         end
                        SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
            END
        END
    END
  if (BIN_AND(TIPO, 16) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
    FOR SELECT COTI_ID, C.PREF_PRE, COTI_NUMERO, COTI_FECHA, COTI_FECHA VENCE, '', '', '', C.PTVT_ID, PTVT_NOM, C.VEND_COD, VEND_NOMBRE, 0, 0, C.TERC_NIT, COTI_NOMTERC, '', '', '', COTI_DTOPORC, COTI_DTOMONTO, COTI_ADICIONAL, COTI_IVAMONTO, 0, 0, 0, 0, 0, 0, COTI_EXTRA, 0, 0, COTI_FECHA DTOF, COTI_TOTAL, COTI_ANULADO, SUBSTRING(COTI_OBS FROM 1 FOR 255)
        FROM COTIZACIONES C, PUNTO_VENTA P, VENDEDORES V, PREFIJOS PR WHERE C.PTVT_ID >= :PTOINI AND C.PTVT_ID <= :PTOFIN AND
         C.PTVT_ID = P.PTVT_ID AND C.VEND_COD = V.VEND_COD AND COTI_FECHA >= :FECINI AND COTI_FECHA <= :FECFIN
         AND PR.PREF_PRE = C.PREF_PRE AND PR.TIDO_COD = 35 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0)) AND
         C.PREF_PRE >= :prefini AND C.PREF_PRE <= :preffin
        ORDER BY COTI_FECHA, COTI_ID
        INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :CODBOD, :NOMBOD, :AUTORIZA, :PTVTID, :PTVTNOM, :VENDCOD, :VENDNOM, :COMIPORC, :COMIMONTO, :NIT, :NOMTERCERO, :PEDIDO, :COTIZACI, :REMISION, :DTOPOR, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTFTEPOR, :RTFTEMONTO, :RTIVAPOR, :RTIVAMONTO, :RTICAPOR, :RTICAMONTO, :EXTRA, :DTOFPOR, :DTOFMONTO, :DTOFFECHA, :TOTAL, :ANULADO, :OBS
        DO
        BEGIN
        if ((ANULADOS = 'S') or (ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
                BEGIN
                COMIPORC = 0;
                COMIMONTO = 0;
                DTOPOR = 0;
                DTOMONTO = 0;
                ADICIONAL = 0;
                IVAMONTO = 0;
                RTFTEPOR = 0;
                RTFTEMONTO = 0;
                RTIVAPOR = 0;
                RTIVAMONTO = 0;
                RTICAPOR = 0;
                RTICAMONTO = 0;
                EXTRA = 0;
                DTOFPOR = 0;
                DTOFMONTO = 0;
                TOTAL = 0;
                END
            if (DETALLE = 'S') then
                BEGIN
                if (anulado = 'S') then
                    BEGIN
                    ITEM = 0;
                    ARTICULO = '';
                    CODBAR = '';
                    ARTIDES = '';
                    CANT = 0;
                    UNIDAD = '';
                    BODITEM = '';
                    LOTE = '';
                    REFERENCIA = '';
                    PRECIO = 0;
                    DTOPORCIT = 0;
                    DTOMONTOIT = 0;
                    IVAPORCIT = 0;
                    IVAMONTOIT = 0;
                    CONSUMOIT = 0;
                    SUBTOTALIT = 0;
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    FOR SELECT CTDE_ITEM, ARTI_COD, CTDE_CODBAR, CTDE_DESC, CTDE_CANT, CTDE_UNIDAD, '', '', CTDE_REFERENCIA, CTDE_PRUNIT, CTDE_DTOPORC, CTDE_DTOMONTO, CTDE_IVAPORC, CTDE_IVAMONTO, CTDE_CONSUMO, CTDE_TOTAL
                        FROM COTIZACIONES_DETALLE
                        WHERE COTI_ID = :ID
                        ORDER BY CTDE_ITEM
                        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :REFERENCIA, :PRECIO, :DTOPORCIT, :DTOMONTOIT, :IVAPORCIT, :IVAMONTOIT, :CONSUMOIT, :SUBTOTALIT
                        DO
                        SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
            END
        END
    END
END
^

SET TERM ; ^

GRANT SELECT ON TIPO_DOCUMENTO TO PROCEDURE REP_COMPROBANTES_FAC;
GRANT SELECT ON FACTURAS TO PROCEDURE REP_COMPROBANTES_FAC;
GRANT SELECT ON BODEGA TO PROCEDURE REP_COMPROBANTES_FAC;
GRANT SELECT ON PUNTO_VENTA TO PROCEDURE REP_COMPROBANTES_FAC;
GRANT SELECT ON VENDEDORES TO PROCEDURE REP_COMPROBANTES_FAC;
GRANT SELECT ON PREFIJOS TO PROCEDURE REP_COMPROBANTES_FAC;
GRANT SELECT ON FACTURAS_DETALLE TO PROCEDURE REP_COMPROBANTES_FAC;
GRANT SELECT ON REMISIONES_VENTA TO PROCEDURE REP_COMPROBANTES_FAC;
GRANT SELECT ON REMISIONES_VENTA_DETALLE TO PROCEDURE REP_COMPROBANTES_FAC;
GRANT SELECT ON DEVOLUCIONES_VENTAS TO PROCEDURE REP_COMPROBANTES_FAC;
GRANT SELECT ON DEVOLUCIONES_VENTAS_DETALLE TO PROCEDURE REP_COMPROBANTES_FAC;
GRANT SELECT ON PEDIDOS TO PROCEDURE REP_COMPROBANTES_FAC;
GRANT SELECT ON PEDIDOS_DETALLE TO PROCEDURE REP_COMPROBANTES_FAC;
GRANT SELECT ON COTIZACIONES TO PROCEDURE REP_COMPROBANTES_FAC;
GRANT SELECT ON COTIZACIONES_DETALLE TO PROCEDURE REP_COMPROBANTES_FAC;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_CONSECUTIVOS_FAC(
    TIPO INTEGER,
    DETALLE CHAR(1),
    PREINI VARCHAR(4),
    PREFIN VARCHAR(4),
    NUMINI VARCHAR(6),
    NUMFIN VARCHAR(6),
    PTOINI INTEGER,
    PTOFIN INTEGER,
    ANULADOS CHAR(1),
    SUBEMPRESA INTEGER)
RETURNS (
    NOMTIPO VARCHAR(30),
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    VENCE DATE,
    CODBOD VARCHAR(2),
    NOMBOD VARCHAR(30),
    AUTORIZA VARCHAR(20),
    PTVTID INTEGER,
    PTVTNOM VARCHAR(60),
    VENDCOD INTEGER,
    VENDNOM VARCHAR(60),
    COMIPORC NUMERIC(9,2),
    COMIMONTO NUMERIC(18,2),
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    PEDIDO VARCHAR(30),
    COTIZACI VARCHAR(30),
    REMISION VARCHAR(30),
    OBS VARCHAR(255),
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    UNIDAD VARCHAR(8),
    BODITEM VARCHAR(2),
    LOTE VARCHAR(15),
    REFERENCIA VARCHAR(60),
    PRECIO NUMERIC(18,2),
    DTOPORCIT NUMERIC(9,2),
    DTOMONTOIT NUMERIC(18,2),
    IVAPORCIT NUMERIC(9,2),
    IVAMONTOIT NUMERIC(18,2),
    CONSUMOIT NUMERIC(18,2),
    SUBTOTALIT NUMERIC(18,2),
    DTOPOR NUMERIC(9,2),
    DTOMONTO NUMERIC(18,2),
    ADICIONAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    RTFTEPOR NUMERIC(9,2),
    RTFTEMONTO NUMERIC(18,2),
    RTIVAPOR NUMERIC(9,2),
    RTIVAMONTO NUMERIC(18,2),
    RTICAPOR NUMERIC(9,2),
    RTICAMONTO NUMERIC(18,2),
    EXTRA NUMERIC(18,2),
    DTOFPOR NUMERIC(9,2),
    DTOFMONTO NUMERIC(18,2),
    DTOFFECHA DATE,
    TOTAL NUMERIC(18,2),
    ANULADO CHAR(1),
    VEHICULO VARCHAR(8))
AS
declare variable descaux varchar(255);
BEGIN
VEHICULO = '';
  /* DETERMINE LA TABLA A EXAMINAR */
  if (BIN_AND(TIPO, 1) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 31 INTO :NOMTIPO;
    /* FACTURA */
    FOR SELECT FACT_ID, F.PREF_PRE, FACT_NUMERO, FACT_FECHA, FACT_VENCE, F.BODE_COD, B.BODE_NOM, F.AUTO_NUMERO, F.PTVT_ID, PTVT_NOM, F.VEND_COD, VEND_NOMBRE, F.FACT_COMIPORC, F.FACT_COMIMONTO, F.TERC_NIT, FACT_NOMCLIENTE, FACT_PEDIDO, FACT_COTIZACI, FACT_REMISION, FACT_DTOPOR, FACT_DTOMONTO, FACT_ADICIONAL, FACT_IVAMONTO, FACT_RTFTEPOR, FACT_RTFTEMONTO, FACT_RTIVAPOR, FACT_RTIVAMONTO, FACT_RTICAPOR, FACT_RTICAMONTO, FACT_EXTRA, FACT_DTOFPOR, FACT_DTOFMONTO, FACT_DTOFFECHA, FACT_TOTAL, FACT_ANULADO, VEHI_COD, SUBSTRING(FACT_OBS FROM 1 FOR 255)
        FROM FACTURAS F, BODEGA B, PUNTO_VENTA P, VENDEDORES V, PREFIJOS PR WHERE F.PTVT_ID >= :PTOINI AND F.PTVT_ID <= :PTOFIN AND
         F.BODE_COD = B.BODE_COD AND F.PTVT_ID = P.PTVT_ID AND F.VEND_COD = V.VEND_COD AND F.PREF_PRE >= :PREINI AND F.PREF_PRE <= :PREFIN AND FACT_NUMERO >= :NUMINI AND FACT_NUMERO <= :NUMFIN
         AND PR.PREF_PRE = F.PREF_PRE AND PR.TIDO_COD = 31 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY F.PREF_PRE, FACT_NUMERO
        INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :CODBOD, :NOMBOD, :AUTORIZA, :PTVTID, :PTVTNOM, :VENDCOD, :VENDNOM, :COMIPORC, :COMIMONTO, :NIT, :NOMTERCERO, :PEDIDO, :COTIZACI, :REMISION, :DTOPOR, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTFTEPOR, :RTFTEMONTO, :RTIVAPOR, :RTIVAMONTO, :RTICAPOR, :RTICAMONTO, :EXTRA, :DTOFPOR, :DTOFMONTO, :DTOFFECHA, :TOTAL, :ANULADO, :VEHICULO, :OBS
        DO
        BEGIN
        if ((ANULADOS = 'S') or (ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
                BEGIN
                COMIPORC = 0;
                COMIMONTO = 0;
                DTOPOR = 0;
                DTOMONTO = 0;
                ADICIONAL = 0;
                IVAMONTO = 0;
                RTFTEPOR = 0;
                RTFTEMONTO = 0;
                RTIVAPOR = 0;
                RTIVAMONTO = 0;
                RTICAPOR = 0;
                RTICAMONTO = 0;
                EXTRA = 0;
                DTOFPOR = 0;
                DTOFMONTO = 0;
                TOTAL = 0;
                END
            if (DETALLE = 'S') then
                BEGIN
                if (anulado = 'S') then
                    BEGIN
                    ITEM = 0;
                    ARTICULO = '';
                    CODBAR = '';
                    ARTIDES = '';
                    CANT = 0;
                    UNIDAD = '';
                    BODITEM = '';
                    LOTE = '';
                    REFERENCIA = '';
                    PRECIO = 0;
                    DTOPORCIT = 0;
                    DTOMONTOIT = 0;
                    IVAPORCIT = 0;
                    IVAMONTOIT = 0;
                    CONSUMOIT = 0;
                    SUBTOTALIT = 0;
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    FOR SELECT FADE_ITEM, ARTI_COD, FADE_CODBAR, FADE_DESC, FADE_CANT, FADE_UNIDAD, BODE_COD, FADE_LOTE, FADE_REFERENCIA, FADE_PRUNIT, FADE_DTOPORC, FADE_DTOMONTO, FADE_IVAPORC, FADE_IVAMONTO, FADE_CONSUMO, FADE_TOTAL
                        FROM FACTURAS_DETALLE
                        WHERE FACT_ID = :ID
                        ORDER BY FADE_ITEM
                        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :REFERENCIA, :PRECIO, :DTOPORCIT, :DTOMONTOIT, :IVAPORCIT, :IVAMONTOIT, :CONSUMOIT, :SUBTOTALIT
                        DO
                        SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
            END
        END
    END
  if (BIN_AND(TIPO, 2) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 32 INTO :NOMTIPO;
    /* REMISION */
    FOR SELECT REVT_ID, R.PREF_PRE, REVT_NUMERO, REVT_FECHA, REVT_FECHA, R.BODE_COD, B.BODE_NOM, '', R.PTVT_ID, PTVT_NOM, R.VEND_COD, VEND_NOMBRE, 0, 0, R.TERC_NIT, REVT_NOMTERC, '', '', '', 0, 0, 0, REVT_IVAMONTO, 0, 0, 0, 0, 0, 0, 0, 0, 0, REVT_FECHA, REVT_TOTAL, REVT_ANULADO, SUBSTRING(REVT_OBS FROM 1 FOR 255)
        FROM REMISIONES_VENTA R, BODEGA B, PUNTO_VENTA P, VENDEDORES V, PREFIJOS PR WHERE R.PTVT_ID >= :PTOINI AND R.PTVT_ID <= :PTOFIN AND
         R.BODE_COD = B.BODE_COD AND R.PTVT_ID = P.PTVT_ID AND R.VEND_COD = V.VEND_COD AND R.PREF_PRE >= :PREINI AND R.PREF_PRE <= :PREFIN AND REVT_NUMERO >= :NUMINI AND REVT_NUMERO <= :NUMFIN
         AND PR.PREF_PRE = R.PREF_PRE AND PR.TIDO_COD = 32 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY R.PREF_PRE, REVT_NUMERO
        INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :CODBOD, :NOMBOD, :AUTORIZA, :PTVTID, :PTVTNOM, :VENDCOD, :VENDNOM, :COMIPORC, :COMIMONTO, :NIT, :NOMTERCERO, :PEDIDO, :COTIZACI, :REMISION, :DTOPOR, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTFTEPOR, :RTFTEMONTO, :RTIVAPOR, :RTIVAMONTO, :RTICAPOR, :RTICAMONTO, :EXTRA, :DTOFPOR, :DTOFMONTO, :DTOFFECHA, :TOTAL, :ANULADO, :OBS
        DO
        BEGIN
        if ((ANULADOS = 'S') or (ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
                BEGIN
                COMIPORC = 0;
                COMIMONTO = 0;
                DTOPOR = 0;
                DTOMONTO = 0;
                ADICIONAL = 0;
                IVAMONTO = 0;
                RTFTEPOR = 0;
                RTFTEMONTO = 0;
                RTIVAPOR = 0;
                RTIVAMONTO = 0;
                RTICAPOR = 0;
                RTICAMONTO = 0;
                EXTRA = 0;
                DTOFPOR = 0;
                DTOFMONTO = 0;
                TOTAL = 0;
                END
            if (DETALLE = 'S') then
                BEGIN
                if (anulado = 'S') then
                    BEGIN
                    ITEM = 0;
                    ARTICULO = '';
                    CODBAR = '';
                    ARTIDES = '';
                    CANT = 0;
                    UNIDAD = '';
                    BODITEM = '';
                    LOTE = '';
                    REFERENCIA = '';
                    PRECIO = 0;
                    DTOPORCIT = 0;
                    DTOMONTOIT = 0;
                    IVAPORCIT = 0;
                    IVAMONTOIT = 0;
                    CONSUMOIT = 0;
                    SUBTOTALIT = 0;
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    FOR SELECT RVDE_ITEM, ARTI_COD, RVDE_CODBAR, RVDE_DESC, RVDE_CANT, RVDE_UNIDAD, BODE_COD, RVDE_LOTE, RVDE_REFERENCIA, RVDE_PRUNIT, RVDE_DTOPORC, RVDE_DTOMONTO, RVDE_IVAPORC, RVDE_IVAMONTO, RVDE_CONSUMO, RVDE_TOTAL
                        FROM REMISIONES_VENTA_DETALLE
                        WHERE REVT_ID = :ID
                        ORDER BY RVDE_ITEM
                        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :REFERENCIA, :PRECIO, :DTOPORCIT, :DTOMONTOIT, :IVAPORCIT, :IVAMONTOIT, :CONSUMOIT, :SUBTOTALIT
                        DO
                        SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
            END
        END
    END
  if (BIN_AND(TIPO, 4) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 33 INTO :NOMTIPO;
    /* DEVOLUCIONES */
    FOR SELECT DEVT_ID, D.PREF_PRE, DEVT_NUMERO, DEVT_FECHA, DEVT_FECHA, D.BODE_COD, B.BODE_NOM, '', D.PTVT_ID, PTVT_NOM, D.VEND_COD, VEND_NOMBRE, DEVT_COMIPORC, DEVT_COMIMONTO, D.TERC_NIT, DEVT_NOMTERC, '', '', '', DEVT_DTOPOR, DEVT_DTOMONTO, DEVT_ADICIONAL, DEVT_IVAMONTO, DEVT_RTFTEPORC, DEVT_RTFTEMONTO, DEVT_RTIVAPORC, DEVT_RTIVAMONTO, DEVT_RTICAPORC, DEVT_RTICAMONTO, DEVT_EXTRA, 0, 0, DEVT_FECHA, DEVT_TOTAL, DEVT_ANULADO, SUBSTRING(DEVT_OBS FROM 1 FOR 255)
        FROM DEVOLUCIONES_VENTAS D, BODEGA B, PUNTO_VENTA P, VENDEDORES V, PREFIJOS PR WHERE D.PTVT_ID >= :PTOINI AND D.PTVT_ID <= :PTOFIN AND
         D.BODE_COD = B.BODE_COD AND D.PTVT_ID = P.PTVT_ID AND D.VEND_COD = V.VEND_COD AND D.PREF_PRE >= :PREINI AND D.PREF_PRE <= :PREFIN AND DEVT_NUMERO >= :NUMINI AND DEVT_NUMERO <= :NUMFIN
         AND PR.PREF_PRE = D.PREF_PRE AND PR.TIDO_COD = 33 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY D.PREF_PRE, DEVT_NUMERO
        INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :CODBOD, :NOMBOD, :AUTORIZA, :PTVTID, :PTVTNOM, :VENDCOD, :VENDNOM, :COMIPORC, :COMIMONTO, :NIT, :NOMTERCERO, :PEDIDO, :COTIZACI, :REMISION, :DTOPOR, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTFTEPOR, :RTFTEMONTO, :RTIVAPOR, :RTIVAMONTO, :RTICAPOR, :RTICAMONTO, :EXTRA, :DTOFPOR, :DTOFMONTO, :DTOFFECHA, :TOTAL, :ANULADO, :OBS
        DO
        BEGIN
        if ((ANULADOS = 'S') or (ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
                BEGIN
                COMIPORC = 0;
                COMIMONTO = 0;
                DTOPOR = 0;
                DTOMONTO = 0;
                ADICIONAL = 0;
                IVAMONTO = 0;
                RTFTEPOR = 0;
                RTFTEMONTO = 0;
                RTIVAPOR = 0;
                RTIVAMONTO = 0;
                RTICAPOR = 0;
                RTICAMONTO = 0;
                EXTRA = 0;
                DTOFPOR = 0;
                DTOFMONTO = 0;
                TOTAL = 0;
                END
            if (DETALLE = 'S') then
                BEGIN
                if (anulado = 'S') then
                    BEGIN
                    ITEM = 0;
                    ARTICULO = '';
                    CODBAR = '';
                    ARTIDES = '';
                    CANT = 0;
                    UNIDAD = '';
                    BODITEM = '';
                    LOTE = '';
                    REFERENCIA = '';
                    PRECIO = 0;
                    DTOPORCIT = 0;
                    DTOMONTOIT = 0;
                    IVAPORCIT = 0;
                    IVAMONTOIT = 0;
                    CONSUMOIT = 0;
                    SUBTOTALIT = 0;
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    FOR SELECT DVDE_ITEM, ARTI_COD, DVDE_CODBAR, DVDE_DESC, DVDE_CANT, DVDE_UNIDAD, BODE_COD, DVDE_LOTE, DVDE_REFERENCIA, DVDE_PRUNIT, DVDE_DTOPORC, DVDE_DTOMONTO, DVDE_IVAPORC, DVDE_IVAMONTO, DVDE_CONSUMO, DVDE_TOTAL
                        FROM DEVOLUCIONES_VENTAS_DETALLE
                        WHERE DEVT_ID = :ID
                        ORDER BY DVDE_ITEM
                        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :REFERENCIA, :PRECIO, :DTOPORCIT, :DTOMONTOIT, :IVAPORCIT, :IVAMONTOIT, :CONSUMOIT, :SUBTOTALIT
                        DO
                        SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
            END
        END
    END
  if (BIN_AND(TIPO, 8) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 34 INTO :NOMTIPO;
    /* PEDIDO */
    FOR SELECT PEDI_ID, P.PREF_PRE, PEDI_NUMERO, PEDI_FECHA, PEDI_FECHA, '', '', '', P.PTVT_ID, PTVT_NOM, P.VEND_COD, VEND_NOMBRE, 0, 0, P.TERC_NIT, PEDI_NOMTERC, '', '', '', PEDI_DTOPOR, PEDI_DTOMONTO, PEDI_ADICIONAL, PEDI_IVAMONTO, 0, 0, 0, 0, 0, 0, PEDI_EXTRA, 0, 0, PEDI_FECHA, PEDI_TOTAL, PEDI_ANULADO, SUBSTRING(PEDI_OBS FROM 1 FOR 255)
        FROM PEDIDOS P, PUNTO_VENTA PT, VENDEDORES V, PREFIJOS PR WHERE P.PTVT_ID >= :PTOINI AND P.PTVT_ID <= :PTOFIN AND
         P.PTVT_ID = PT.PTVT_ID AND P.VEND_COD = V.VEND_COD AND P.PREF_PRE >= :PREINI AND P.PREF_PRE <= :PREFIN AND PEDI_NUMERO >= :NUMINI AND PEDI_NUMERO <= :NUMFIN
         AND PR.PREF_PRE = P.PREF_PRE AND PR.TIDO_COD = 34 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY P.PREF_PRE, PEDI_NUMERO
        INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :CODBOD, :NOMBOD, :AUTORIZA, :PTVTID, :PTVTNOM, :VENDCOD, :VENDNOM, :COMIPORC, :COMIMONTO, :NIT, :NOMTERCERO, :PEDIDO, :COTIZACI, :REMISION, :DTOPOR, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTFTEPOR, :RTFTEMONTO, :RTIVAPOR, :RTIVAMONTO, :RTICAPOR, :RTICAMONTO, :EXTRA, :DTOFPOR, :DTOFMONTO, :DTOFFECHA, :TOTAL, :ANULADO, :OBS
        DO
        BEGIN
        if ((ANULADOS = 'S') or (ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
                BEGIN
                COMIPORC = 0;
                COMIMONTO = 0;
                DTOPOR = 0;
                DTOMONTO = 0;
                ADICIONAL = 0;
                IVAMONTO = 0;
                RTFTEPOR = 0;
                RTFTEMONTO = 0;
                RTIVAPOR = 0;
                RTIVAMONTO = 0;
                RTICAPOR = 0;
                RTICAMONTO = 0;
                EXTRA = 0;
                DTOFPOR = 0;
                DTOFMONTO = 0;
                TOTAL = 0;
                END
            if (DETALLE = 'S') then
                BEGIN
                if (anulado = 'S') then
                    BEGIN
                    ITEM = 0;
                    ARTICULO = '';
                    CODBAR = '';
                    ARTIDES = '';
                    CANT = 0;
                    UNIDAD = '';
                    BODITEM = '';
                    LOTE = '';
                    REFERENCIA = '';
                    PRECIO = 0;
                    DTOPORCIT = 0;
                    DTOMONTOIT = 0;
                    IVAPORCIT = 0;
                    IVAMONTOIT = 0;
                    CONSUMOIT = 0;
                    SUBTOTALIT = 0;
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    FOR SELECT PEDE_ITEM, ARTI_COD, PEDE_CODBAR, PEDE_DESC, PEDE_CANT, PEDE_UNIDAD, '', '', PEDE_REFERENCIA, PEDE_PRUNIT, PEDE_DTOPORC, PEDE_DTOMONTO, PEDE_IVAPORC, PEDE_IVAMONTO, PEDE_CONSUMO, PEDE_TOTAL
                        FROM PEDIDOS_DETALLE
                        WHERE PEDI_ID = :ID
                        ORDER BY PEDE_ITEM
                        INTO :ITEM, :ARTICULO, :CODBAR, :descaux, :CANT, :UNIDAD, :BODITEM, :LOTE, :REFERENCIA, :PRECIO, :DTOPORCIT, :DTOMONTOIT, :IVAPORCIT, :IVAMONTOIT, :CONSUMOIT, :SUBTOTALIT
                        DO
                         begin
                          if (STRLEN(descaux)> 60 ) then
                            ARTIDES = SUBSTR(descaux,1,60);
                          ELSE
                            ARTIDES = :descaux;
                         end
                        SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
            END
        END
    END
  if (BIN_AND(TIPO, 16) <> 0) then
    BEGIN
    SELECT TIDO_NOMLARGO FROM TIPO_DOCUMENTO WHERE TIDO_COD = 35 INTO :NOMTIPO;
    FOR SELECT COTI_ID, C.PREF_PRE, COTI_NUMERO, COTI_FECHA, COTI_FECHA, '', '', '', C.PTVT_ID, PTVT_NOM, C.VEND_COD, VEND_NOMBRE, 0, 0, C.TERC_NIT, COTI_NOMTERC, '', '', '', COTI_DTOPORC, COTI_DTOMONTO, COTI_ADICIONAL, COTI_IVAMONTO, 0, 0, 0, 0, 0, 0, COTI_EXTRA, 0, 0, COTI_FECHA, COTI_TOTAL, COTI_ANULADO, SUBSTRING(COTI_OBS FROM 1 FOR 255)
        FROM COTIZACIONES C, PUNTO_VENTA P, VENDEDORES V, PREFIJOS PR WHERE C.PTVT_ID >= :PTOINI AND C.PTVT_ID <= :PTOFIN AND
         C.PTVT_ID = P.PTVT_ID AND C.VEND_COD = V.VEND_COD AND C.PREF_PRE >= :PREINI AND C.PREF_PRE <= :PREFIN AND COTI_NUMERO >= :NUMINI AND COTI_NUMERO <= :NUMFIN
         AND PR.PREF_PRE = C.PREF_PRE AND PR.TIDO_COD = 35 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        ORDER BY C.PREF_PRE, COTI_NUMERO
        INTO :ID, :PREF, :NUMERO, :FECHA, :VENCE, :CODBOD, :NOMBOD, :AUTORIZA, :PTVTID, :PTVTNOM, :VENDCOD, :VENDNOM, :COMIPORC, :COMIMONTO, :NIT, :NOMTERCERO, :PEDIDO, :COTIZACI, :REMISION, :DTOPOR, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTFTEPOR, :RTFTEMONTO, :RTIVAPOR, :RTIVAMONTO, :RTICAPOR, :RTICAMONTO, :EXTRA, :DTOFPOR, :DTOFMONTO, :DTOFFECHA, :TOTAL, :ANULADO, :OBS
        DO
        BEGIN
        if ((ANULADOS = 'S') or (ANULADO = 'N')) then
            BEGIN
            if (anulado = 'S') then
                BEGIN
                COMIPORC = 0;
                COMIMONTO = 0;
                DTOPOR = 0;
                DTOMONTO = 0;
                ADICIONAL = 0;
                IVAMONTO = 0;
                RTFTEPOR = 0;
                RTFTEMONTO = 0;
                RTIVAPOR = 0;
                RTIVAMONTO = 0;
                RTICAPOR = 0;
                RTICAMONTO = 0;
                EXTRA = 0;
                DTOFPOR = 0;
                DTOFMONTO = 0;
                TOTAL = 0;
                END
            if (DETALLE = 'S') then
                BEGIN
                if (anulado = 'S') then
                    BEGIN
                    ITEM = 0;
                    ARTICULO = '';
                    CODBAR = '';
                    ARTIDES = '';
                    CANT = 0;
                    UNIDAD = '';
                    BODITEM = '';
                    LOTE = '';
                    REFERENCIA = '';
                    PRECIO = 0;
                    DTOPORCIT = 0;
                    DTOMONTOIT = 0;
                    IVAPORCIT = 0;
                    IVAMONTOIT = 0;
                    CONSUMOIT = 0;
                    SUBTOTALIT = 0;
                    SUSPEND;
                    END
                ELSE
                    BEGIN
                    FOR SELECT CTDE_ITEM, ARTI_COD, CTDE_CODBAR, CTDE_DESC, CTDE_CANT, CTDE_UNIDAD, '', '', CTDE_REFERENCIA, CTDE_PRUNIT, CTDE_DTOPORC, CTDE_DTOMONTO, CTDE_IVAPORC, CTDE_IVAMONTO, CTDE_CONSUMO, CTDE_TOTAL
                        FROM COTIZACIONES_DETALLE
                        WHERE COTI_ID = :ID
                        ORDER BY CTDE_ITEM
                        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :REFERENCIA, :PRECIO, :DTOPORCIT, :DTOMONTOIT, :IVAPORCIT, :IVAMONTOIT, :CONSUMOIT, :SUBTOTALIT
                        DO
                        SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
            END
        END
    END
END
^

SET TERM ; ^

GRANT SELECT ON TIPO_DOCUMENTO TO PROCEDURE REP_CONSECUTIVOS_FAC;
GRANT SELECT ON FACTURAS TO PROCEDURE REP_CONSECUTIVOS_FAC;
GRANT SELECT ON BODEGA TO PROCEDURE REP_CONSECUTIVOS_FAC;
GRANT SELECT ON PUNTO_VENTA TO PROCEDURE REP_CONSECUTIVOS_FAC;
GRANT SELECT ON VENDEDORES TO PROCEDURE REP_CONSECUTIVOS_FAC;
GRANT SELECT ON PREFIJOS TO PROCEDURE REP_CONSECUTIVOS_FAC;
GRANT SELECT ON FACTURAS_DETALLE TO PROCEDURE REP_CONSECUTIVOS_FAC;
GRANT SELECT ON REMISIONES_VENTA TO PROCEDURE REP_CONSECUTIVOS_FAC;
GRANT SELECT ON REMISIONES_VENTA_DETALLE TO PROCEDURE REP_CONSECUTIVOS_FAC;
GRANT SELECT ON DEVOLUCIONES_VENTAS TO PROCEDURE REP_CONSECUTIVOS_FAC;
GRANT SELECT ON DEVOLUCIONES_VENTAS_DETALLE TO PROCEDURE REP_CONSECUTIVOS_FAC;
GRANT SELECT ON PEDIDOS TO PROCEDURE REP_CONSECUTIVOS_FAC;
GRANT SELECT ON PEDIDOS_DETALLE TO PROCEDURE REP_CONSECUTIVOS_FAC;
GRANT SELECT ON COTIZACIONES TO PROCEDURE REP_CONSECUTIVOS_FAC;
GRANT SELECT ON COTIZACIONES_DETALLE TO PROCEDURE REP_CONSECUTIVOS_FAC;

/* 20080721 */

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('CAJA', 'EGRESOS', 'SINCRONIZAR PREFIJOS DE EGRESOS Y DOCUMENTOS CANCELADOS', 'NO', 'SI,NO', 'SI:Obliga que el prefijo del egreso coincida con los prefijos de los documentos abonados. Evita que se paguen documentos de diferentes agencias por error.');
commit work;


/* 20080726 */
CREATE INDEX COMPROBANTE_DETALLE_IDX2
ON COMPROBANTE_DETALLE (TERC_NIT);

/* 20080728 - REPORTE DE CLIENTES EN FACTURACION */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE REP_CLIENTES(
    DESDE VARCHAR(20),
    HASTA VARCHAR(20),
    ZONINI VARCHAR(5),
    ZONFIN VARCHAR(5),
    VENINI INTEGER,
    VENFIN INTEGER,
    AGRUPA CHAR(1),
    ORDEN CHAR(1),
    INACTIVOS CHAR(1))
RETURNS (
    NIT VARCHAR(20),
    NOM VARCHAR(60),
    DIR VARCHAR(60),
    CIU VARCHAR(40),
    TEL VARCHAR(40),
    CONTACTO VARCHAR(60),
    OBS VARCHAR(255),
    EMAIL VARCHAR(100),
    FAX VARCHAR(25),
    CEL VARCHAR(25),
    CODCLIE VARCHAR(20),
    CODCIU VARCHAR(6),
    ZONA VARCHAR(2),
    ESTADO CHAR(1),
    RTEFTE NUMERIC(9,4),
    RTEIVA NUMERIC(9,4),
    RTEICA NUMERIC(9,4),
    RTFTEBASE NUMERIC(18,2),
    DTOMAX NUMERIC(9,4),
    CUPO NUMERIC(18,2),
    COBR INTEGER,
    VEND INTEGER,
    ANIV DATE,
    CLIDESDE DATE,
    LISTA INTEGER,
    DIAS INTEGER,
    DIASBLOQ INTEGER,
    DETALLE CHAR(1),
    NOMLISTA VARCHAR(30),
    NOMVEND VARCHAR(60),
    NOMCOBR VARCHAR(60),
    NOMZONA VARCHAR(60),
    NOMCIUD VARCHAR(60),
    CTACLIE VARCHAR(20),
    CTAVNTA VARCHAR(20),
    CTARTFTE VARCHAR(20),
    CTARTIVA VARCHAR(20),
    CTARTICA VARCHAR(20))
AS
declare variable NITINI VARCHAR(20);
declare variable NITFIN VARCHAR(20);
declare variable NOMINI VARCHAR(20);
declare variable NOMFIN VARCHAR(20);
begin
if (ORDEN = 'C') then
    BEGIN
    NITINI = DESDE;
    NITFIN = HASTA;
    NOMINI = '';
    NOMFIN = 'zz';
    END
ELSE
    BEGIN
    NOMINI = DESDE;
    NOMFIN = HASTA;
    NITINI = '';
    NITFIN = 'zz';
    END

for select t.terc_nit,terc_nom,terc_dir,terc_ciu,terc_tel,terc_contacto,SUBSTRING(TERC_OBS FROM 1 FOR 255),
    terc_email,terc_fax,terc_cel,c.clie_cod,c.zona_cod,c.clie_estado,c.clie_rtefte,c.clie_rteiva,c.clie_rteica,c.clie_rtftebase,c.clie_dtomax,
    c.clie_cupo,c.vend_cod, c.cobr_cod, c.clie_aniv, c.clie_fecha, c.lipr_cod, c.clie_dias, c.clie_diasbloq, c.clie_detalle,
    terc_ctartfte,terc_ctartiva,terc_ctartica,terc_ctaventa,terc_ctacliente, T.ciud_cod
    from terceros t,clientes c where t.terc_nit = c.terc_nit and t.terc_nit >= :nitini and t.terc_nit <= :nitfin and terc_nom >= :nomini and terc_nom <= :nomfin
    into :nit, :nom, :dir, :ciu, :tel, :contacto, :obs,
    :email, :fax, :cel, :codclie, :zona, :estado, :rtefte, :rteiva, :rteica,
    :rtftebase, :dtomax, :cupo, :vend, :cobr, :aniv, :clidesde, :lista, :dias, :diasbloq, :detalle,
    :ctartfte, :ctartiva, :ctartica, :ctavnta, :ctaclie, :codciu
    do
    begin
    if ((inactivos = 'S') or (estado <> 'I'))  then
        begin
        nomzona = '';
        nomcobr = '';
        nomciud = '';
        nomvend = '';
        nomlista = '';
        select zona_nom from zonas where zona_cod = :zona into :nomzona;
        select cobr_nom from cobradores where cobr_cod = :cobr into nomcobr;
        select vend_nombre from vendedores where vend_cod = :vend into nomvend;
        select ciud_nom from ciudades where ciud_cod = :nomcobr into nomciud;
        select lipr_nom from LISTA_PRECIOS where lipr_cod = :lista into nomlista;
        if (AGRUPA = 'V') then
          begin
          if ((vend >= :venini) and (vend <= :venfin)) then
            suspend;
          end
        else
          if (AGRUPA = 'B') then
            begin
            if ((cobr >= :venini) and (cobr <= :venfin)) then
                suspend;
            end
          else
            if (AGRUPA = 'Z') then
              begin
              if ((zona >= :zonini) and (zona <= :zonfin)) then
                suspend;
              end
            else
              if (AGRUPA = 'C') then
                begin
                if ((codciu >= :zonini) and (codciu <= :zonfin)) then
                  suspend;
                end
              else
                suspend;
        end
    end
end
^

SET TERM ; ^

GRANT SELECT ON TERCEROS TO PROCEDURE REP_CLIENTES;
GRANT SELECT ON CLIENTES TO PROCEDURE REP_CLIENTES;
GRANT SELECT ON ZONAS TO PROCEDURE REP_CLIENTES;
GRANT SELECT ON COBRADORES TO PROCEDURE REP_CLIENTES;
GRANT SELECT ON VENDEDORES TO PROCEDURE REP_CLIENTES;
GRANT SELECT ON CIUDADES TO PROCEDURE REP_CLIENTES;
GRANT SELECT ON LISTA_PRECIOS TO PROCEDURE REP_CLIENTES;
grant execute on procedure rep_clientes to PUBLIC;


/* 20080729 COMISIONES COBRO CON RETENCIONES, DESCUENTO Y FECHA DE VENCIMIENTO */

SET TERM ^ ;

CREATE OR ALTER PROCEDURE COMISIONES_COBRO(
    DESDE INTEGER,
    HASTA INTEGER,
    FECINI DATE,
    FECFIN DATE,
    DETALLE CHAR(1))
RETURNS (
    CODVEND INTEGER,
    NOMVEND VARCHAR(60),
    NIT VARCHAR(20),
    CLIENTE VARCHAR(60),
    NOMTIPO VARCHAR(8),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECDOC DATE,
    PREFREC VARCHAR(4),
    NUMREC VARCHAR(6),
    FECREC DATE,
    DIAS INTEGER,
    ABONO NUMERIC(18,2),
    BASE NUMERIC(18,2),
    COMIMONTO NUMERIC(18,2),
    COMIPORC NUMERIC(9,2),
    ARTICULO VARCHAR(20),
    CODGRP VARCHAR(2),
    CANT NUMERIC(18,4),
    DTOFIN NUMERIC(18,2),
    VENCE DATE,
    RTFTE NUMERIC(18,2),
    RTIVA NUMERIC(18,2),
    RTICA NUMERIC(18,2))
AS
DECLARE VARIABLE TIPO INTEGER;
DECLARE VARIABLE ID INTEGER;
DECLARE VARIABLE IVAMONTO NUMERIC(18,2);
DECLARE VARIABLE TOTAL NUMERIC(18,2);
DECLARE VARIABLE SITOT CHAR(2);
DECLARE VARIABLE VENTA CHAR(2);
DECLARE VARIABLE COMIV NUMERIC(18,2);
DECLARE VARIABLE PORCV NUMERIC(18,2);
DECLARE VARIABLE CONSUMO NUMERIC(18,2);
declare variable ALFINAL CHAR(2);
declare variable SALDO NUMERIC(18,2);
declare variable COMISION VARCHAR(10);
declare variable porcaux NUMERIC(9,2);
declare variable BASEAUX DOUBLE PRECISION;
declare variable SUCURSAL VARCHAR(20);
BEGIN
EXECUTE PROCEDURE LEE_CONFIGURACION('FACTURACION', 'VENDEDORES', 'COMISIONES EN VENTA INCLUYENDO IMPUESTOS') returning_values (:SITOT);
EXECUTE PROCEDURE LEE_CONFIGURACION('CARTERA','COMISIONES','COMISION POR COBRO PAGADERA SOLO EN EL COBRO TOTAL') returning_values (:ALFINAL);
execute procedure lee_configuracion('CARTERA','COMISIONES','COMISION POR COBRO COMO PORCENTAJE DE LA COMISION VENTA') returning_values (:venta);
EXECUTE PROCEDURE lee_configuracion('CARTERA', 'COMISIONES', 'LIQUIDAR COMISION COBRO CON COBRADOR DEL DOCUMENTO O DEL RECIBO') returning_values (:COMISION);
FOR SELECT RCDE_TIPODOC, RCDE_IDDOC, RCDE_PREFIJO, RCDE_NUMERO, R.TERC_NIT, TERC_NOM, RECA_FECHA, (RCDE_ABONO+RCDE_RTFTE+RCDE_RTIVA+RCDE_RTICA), PREF_PRE, RECA_NUMERO, COBR_COD, RCDE_DTOF, RCDE_RTFTE, RCDE_RTIVA, RCDE_RTICA
    FROM RECIBOS_CAJA R, RECIBOS_CAJA_DETALLE RD, TERCEROS T
    WHERE R.RECA_ID = RD.RECA_ID AND RECA_FECHA >= :FECINI AND RECA_FECHA <= :FECFIN AND R.TERC_NIT = T.TERC_NIT AND RECA_ANULADO = 'N'
    ORDER BY TERC_NIT, RECA_FECHA
    INTO :TIPO, :ID, :PREFIJO, :NUMERO, :NIT, :CLIENTE, :FECREC, :ABONO, :PREFREC, :NUMREC, :codvend, :DTOFIN, :rtfte, :RTIVA, :RTICA
    DO
    BEGIN
    SELECT TIDO_NOMCORTO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPO INTO :NOMTIPO;
    if (COMISION = 'DOCUMENTO') then
        SELECT MVCL_FECHA, COBR_COD, MVCL_VENCE FROM MOVIMIENTO_CLIENTES WHERE MVCL_TIPOREF = :TIPO AND MVCL_IDREF = :ID
            INTO :FECDOC, :codvend, :VENCE;
    else
        SELECT MVCL_FECHA, MVCL_VENCE FROM MOVIMIENTO_CLIENTES WHERE MVCL_TIPOREF = :TIPO AND MVCL_IDREF = :ID
            INTO :FECDOC, :VENCE;
    if (FECDOC IS NOT NULL) then
        DIAS = FECREC - FECDOC;
    ELSE
        DIAS = 999;
    if ((codvend >= :DESDE) AND (codvend <= :hasta)) then
        BEGIN
        /* TRAIGA EL PORCENTAJE DE ACUERDO A LOS DIAS */
        COMIPORC = 0;
        SELECT CMCB_PORC FROM COMISION_COBRO WHERE CMCB_DIASINI <= :dias AND CMCB_DIASFIN >= :DIAS AND COBR_COD = :CODVEND INTO :COMIPORC;
        if (COMIPORC IS NULL) THEN
            COMIPORC = 0;
        if (VENTA = 'NO') then
            BEGIN
            if (TIPO = 31) then
                BEGIN
                if (DETALLE = 'N') then
                    SELECT MAX(FACT_TOTAL), MAX(FACT_IVAMONTO), SUM(FADE_CONSUMO) FROM FACTURAS F, FACTURAS_DETALLE D
                        WHERE F.FACT_ID = D.FACT_ID AND F.FACT_ID = :ID INTO :TOTAL, :IVAMONTO, :CONSUMO;
                ELSE
                    FOR SELECT D.ARTI_COD, FADE_CANT, FADE_TOTAL, FADE_IVAMONTO, FADE_CONSUMO, GRUP_COD
                        FROM FACTURAS F, FACTURAS_DETALLE D, ARTICULO A
                        WHERE F.FACT_ID = D.FACT_ID AND D.arti_cod = A.arti_cod AND F.FACT_ID = :ID
                        INTO :ARTICULO, :CANT, :TOTAL, :IVAMONTO, :CONSUMO, :CODGRP
                        DO
                        BEGIN
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = (TOTAL - IVAMONTO - CONSUMO);
                        BASE = BASEAUX;
                        COMIMONTO = BASE / 100 * COMIPORC;
                        SUSPEND;
                        END
                END
            if (TIPO = 33) then
                if (DETALLE = 'N') then
                    SELECT MAX(DEVT_TOTAL*-1), MAX(DEVT_IVAMONTO*-1), SUM(DVDE_CONSUMO) FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D
                        WHERE V.DEVT_ID = D.DEVT_ID AND V.DEVT_ID = :ID INTO :TOTAL, :IVAMONTO, :CONSUMO;
                ELSE
                    FOR SELECT D.ARTI_COD, DVDE_CANT, DVDE_TOTAL*-1, DVDE_IVAMONTO*-1, DVDE_CONSUMO*-1, GRUP_COD
                        FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D, ARTICULO A
                        WHERE V.DEVT_ID = D.DEVT_ID AND D.arti_cod = A.arti_cod AND V.DEVT_ID = :ID
                        INTO :ARTICULO, :CANT, :TOTAL, :IVAMONTO, :CONSUMO, :codgrp
                        DO
                        BEGIN
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = TOTAL - IVAMONTO - CONSUMO;
                        BASE = BASEAUX;
                        COMIMONTO = BASE / 100 * COMIPORC;
                        SUSPEND;
                        END
            if (TIPO = 41) then
                SELECT NDCL_MONTO, NDCL_IVAMONTO, 0 FROM NOTAS_DEBITO_CLIENTES WHERE NDCL_ID = :ID INTO :TOTAL, :IVAMONTO, :CONSUMO;
            if (TIPO = 42) then
                SELECT NCCL_MONTO*-1, NCCL_IVAMONTO*-1, 0 FROM NOTAS_CREDITO_CLIENTES WHERE NCCL_ID = :ID INTO :TOTAL, :IVAMONTO, :CONSUMO;
            if (TIPO = 77) then
                SELECT DVCH_MONTO, 0, 0 FROM DEVOLUCION_CHEQUES WHERE DVCH_ID = :ID INTO :TOTAL, :IVAMONTO, :CONSUMO;
            if (SITOT = 'SI') then
                BASEAUX = ABONO;
            ELSE
                if ((TOTAL - IVAMONTO - CONSUMO) <> 0) then
                    BASEAUX = (ABONO / TOTAL) * (TOTAL - IVAMONTO - CONSUMO);
                ELSE
                    BASEAUX = 0;
            BASE = BASEAUX;
            COMIMONTO = BASE / 100 * COMIPORC;
            END
        ELSE
            BEGIN
            if (TIPO = 31) then
                if (DETALLE = 'N') then
                    SELECT MAX(FACT_TOTAL), MAX(FACT_IVAMONTO), MAX(FACT_COMIPORC), SUM(FADE_CONSUMO)
                        FROM FACTURAS F, FACTURAS_DETALLE D WHERE F.FACT_ID = D.FACT_ID AND F.FACT_ID = :ID
                        INTO :TOTAL, :IVAMONTO, :PORCV, :CONSUMO;
                ELSE
                    FOR SELECT D.ARTI_COD, FADE_CANT, FADE_TOTAL, FADE_IVAMONTO, FADE_CONSUMO, FACT_COMIPORC, GRUP_COD
                        FROM FACTURAS F, FACTURAS_DETALLE D, ARTICULO A
                        WHERE F.FACT_ID = D.FACT_ID AND D.arti_cod = A.arti_cod AND F.FACT_ID = :ID
                        INTO :ARTICULO, :CANT, :TOTAL, :IVAMONTO, :CONSUMO, :porcv, :codgrp
                        DO
                        BEGIN
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = (TOTAL - IVAMONTO - CONSUMO);
                        COMIV = PORCV / 100 * BASEAUX;
                        COMIMONTO = COMIV / 100 * COMIPORC;
                        porcaux = comiporc;
                        comiporc = PORCV / 100 * COMIPORC;
                        BASE = BASEAUX;
                        SUSPEND;
                        END
            if (TIPO = 33) then
                if (DETALLE = 'N') then
                    SELECT MAX(DEVT_TOTAL), MAX(DEVT_IVAMONTO), MAX(DEVT_COMIPORC), SUM(DVDE_CONSUMO)
                        FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D WHERE V.DEVT_ID = D.DEVT_ID AND D.DEVT_ID = :ID
                        INTO :TOTAL, :IVAMONTO, :PORCV, :CONSUMO;
                ELSE
                    FOR SELECT D.ARTI_COD, DVDE_CANT, DVDE_TOTAL*-1, DVDE_IVAMONTO*-1, DVDE_CONSUMO*-1, DEVT_COMIPORC, GRUP_COD
                        FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D, ARTICULO A
                        WHERE V.DEVT_ID = D.DEVT_ID AND D.arti_cod = A.arti_cod AND V.DEVT_ID = :ID
                        INTO :ARTICULO, :CANT, :TOTAL, :IVAMONTO, :CONSUMO, :porcv, :codgrp
                        DO
                        BEGIN
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = (TOTAL - IVAMONTO - CONSUMO);
                        COMIV = PORCV / 100 * BASEAUX;
                        COMIMONTO = COMIV / 100 * COMIPORC;
                        porcaux = comiporc;
                        comiporc = PORCV / 100 * COMIPORC;
                        BASE = BASEAUX;
                        SUSPEND;
                        END
            if (TIPO = 41) then
                SELECT NDCL_MONTO, NDCL_IVAMONTO, NDCL_COMIPORC, 0 FROM NOTAS_DEBITO_CLIENTES
                    WHERE NDCL_ID = :ID INTO :TOTAL, :IVAMONTO, :PORCV, :CONSUMO;
            if (TIPO = 42) then
                SELECT NCCL_MONTO, NCCL_IVAMONTO, NCCL_COMIPORC, 0  FROM NOTAS_CREDITO_CLIENTES
                    WHERE NCCL_ID = :ID INTO :TOTAL, :IVAMONTO, :PORCV, :CONSUMO;
            if (TIPO = 77) then
                SELECT DVCH_MONTO, 0, 0, 0 FROM DEVOLUCION_CHEQUES WHERE DVCH_ID = :ID INTO :TOTAL, :IVAMONTO, :PORCV, :CONSUMO;
            if (SITOT = 'SI') then
                BASEAUX = ABONO;
            ELSE
                if ((total <> 0) AND (ABONO <> 0)) then
                    BASEAUX = (TOTAL - IVAMONTO - CONSUMO) / TOTAL * ABONO;
                ELSE
                    BASEAUX = 0;
            COMIV = PORCV / 100 * BASEAUX;
            COMIMONTO = COMIV / 100 * COMIPORC;
            porcaux = comiporc;
            comiporc = PORCV / 100 * COMIPORC;
            BASE = BASEAUX;
            END
        select COBR_NOM from COBRADORES where COBR_COD = :codvend INTO :nomvend;
        if (DETALLE = 'N') then
            if (ALFINAL = 'SI') then
                BEGIN
                /* VERIFIQUE EL SALDO DEL DOCUMENTO, SI ES CERO LIQUIDE COMISION SOBRE EL TOTAL */
                EXECUTE PROCEDURE saldo_doc_cartera(:tipo, :ID, :FECREC) returning_values (:SALDO);
                if (SALDO = 0) then
                    BEGIN
                    if (VENTA = 'NO') then
                        begin
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = TOTAL - IVAMONTO - CONSUMO;
                        COMIMONTO = BASEAUX * COMIPORC / 100;
                        end
                    ELSE
                        BEGIN
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = TOTAL - IVAMONTO - CONSUMO;
                        COMIV = PORCV * BASEAUX / 100;
                        COMIMONTO = COMIV / 100 * porcaux;
                        comiporc = PORCV / 100 * porcaux;
                        END
                    BASE = BASEAUX;
                    SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
        ELSE
            if ((TIPO <> 31) AND (TIPO <> 33)) then
                SUSPEND;
        END
    END
FOR SELECT EGCC_TIPODOC, EGCC_IDDOC, EGCC_PREFIJO, EGCC_NUMERO, E.TERC_NIT, TERC_NOM, EGRE_FECHA, (EGCC_ABONO+EGCC_RTFTE+EGCC_RTIVA+EGCC_RTICA), PREF_PRE, EGRE_NUMERO, EGCC_SUCURSAL
    FROM EGRESOS E, EGRESOS_CRUCEC C, TERCEROS T
    WHERE E.EGRE_ID = C.EGRE_ID AND EGRE_FECHA >= :FECINI AND EGRE_FECHA <= :FECFIN AND E.TERC_NIT = T.TERC_NIT AND EGRE_ANULADO = 'N'
    ORDER BY TERC_NIT, EGRE_FECHA
    INTO :TIPO, :ID, :PREFIJO, :NUMERO, :NIT, :CLIENTE, :FECREC, :ABONO, :PREFREC, :NUMREC, :SUCURSAL
    DO
    BEGIN
    SELECT COBR_COD FROM cliente_sucursales WHERE TERC_NIT = :NIT AND CLCU_COD = :sucursal INTO :codvend;
    SELECT TIDO_NOMCORTO FROM TIPO_DOCUMENTO WHERE TIDO_COD = :TIPO INTO :NOMTIPO;
    if (COMISION = 'DOCUMENTO') then
        SELECT MVCL_FECHA, COBR_COD, MVCL_VENCE FROM MOVIMIENTO_CLIENTES WHERE MVCL_TIPOREF = :TIPO AND MVCL_IDREF = :ID
            INTO :FECDOC, :codvend, :VENCE;
    else
        SELECT MVCL_FECHA, MVCL_VENCE FROM MOVIMIENTO_CLIENTES WHERE MVCL_TIPOREF = :TIPO AND MVCL_IDREF = :ID
            INTO :FECDOC, :VENCE;
    if (FECDOC IS NOT NULL) then
        DIAS = FECREC - FECDOC;
    ELSE
        DIAS = 999;
    if ((codvend >= :DESDE) AND (codvend <= :hasta)) then
        BEGIN
        /* TRAIGA EL PORCENTAJE DE ACUERDO A LOS DIAS */
        COMIPORC = 0;
        SELECT CMCB_PORC FROM COMISION_COBRO WHERE CMCB_DIASINI <= :dias AND CMCB_DIASFIN >= :DIAS AND COBR_COD = :CODVEND INTO :COMIPORC;
        if (COMIPORC IS NULL) THEN
            COMIPORC = 0;
        if (VENTA = 'NO') then
            BEGIN
            if (TIPO = 31) then
                BEGIN
                if (DETALLE = 'N') then
                    SELECT MAX(FACT_TOTAL), MAX(FACT_IVAMONTO), SUM(FADE_CONSUMO) FROM FACTURAS F, FACTURAS_DETALLE D
                        WHERE F.FACT_ID = D.FACT_ID AND F.FACT_ID = :ID INTO :TOTAL, :IVAMONTO, :CONSUMO;
                ELSE
                    FOR SELECT D.ARTI_COD, FADE_CANT, FADE_TOTAL, FADE_IVAMONTO, FADE_CONSUMO, GRUP_COD
                        FROM FACTURAS F, FACTURAS_DETALLE D, ARTICULO A
                        WHERE F.FACT_ID = D.FACT_ID AND D.arti_cod = A.arti_cod AND F.FACT_ID = :ID
                        INTO :ARTICULO, :CANT, :TOTAL, :IVAMONTO, :CONSUMO, :CODGRP
                        DO
                        BEGIN
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = (TOTAL - IVAMONTO - CONSUMO);
                        BASE = BASEAUX;
                        COMIMONTO = BASE / 100 * COMIPORC;
                        SUSPEND;
                        END
                END
            if (TIPO = 33) then
                if (DETALLE = 'N') then
                    SELECT MAX(DEVT_TOTAL*-1), MAX(DEVT_IVAMONTO*-1), SUM(DVDE_CONSUMO) FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D
                        WHERE V.DEVT_ID = D.DEVT_ID AND V.DEVT_ID = :ID INTO :TOTAL, :IVAMONTO, :CONSUMO;
                ELSE
                    FOR SELECT D.ARTI_COD, DVDE_CANT, DVDE_TOTAL*-1, DVDE_IVAMONTO*-1, DVDE_CONSUMO*-1, GRUP_COD
                        FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D, ARTICULO A
                        WHERE V.DEVT_ID = D.DEVT_ID AND D.arti_cod = A.arti_cod AND V.DEVT_ID = :ID
                        INTO :ARTICULO, :CANT, :TOTAL, :IVAMONTO, :CONSUMO, :codgrp
                        DO
                        BEGIN
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = TOTAL - IVAMONTO - CONSUMO;
                        BASE = BASEAUX;
                        COMIMONTO = BASE / 100 * COMIPORC;
                        SUSPEND;
                        END
            if (TIPO = 41) then
                SELECT NDCL_MONTO, NDCL_IVAMONTO, 0 FROM NOTAS_DEBITO_CLIENTES WHERE NDCL_ID = :ID INTO :TOTAL, :IVAMONTO, :CONSUMO;
            if (TIPO = 42) then
                SELECT NCCL_MONTO*-1, NCCL_IVAMONTO*-1, 0 FROM NOTAS_CREDITO_CLIENTES WHERE NCCL_ID = :ID INTO :TOTAL, :IVAMONTO, :CONSUMO;
            if (TIPO = 77) then
                SELECT DVCH_MONTO, 0, 0 FROM DEVOLUCION_CHEQUES WHERE DVCH_ID = :ID INTO :TOTAL, :IVAMONTO, :CONSUMO;
            if (SITOT = 'SI') then
                BASEAUX = ABONO;
            ELSE
                if ((TOTAL - IVAMONTO - CONSUMO) <> 0) then
                    BASEAUX = (ABONO / TOTAL) * (TOTAL - IVAMONTO - CONSUMO);
                ELSE
                    BASEAUX = 0;
            BASE = BASEAUX;
            COMIMONTO = BASE / 100 * COMIPORC;
            END
        ELSE
            BEGIN
            if (TIPO = 31) then
                if (DETALLE = 'N') then
                    SELECT MAX(FACT_TOTAL), MAX(FACT_IVAMONTO), MAX(FACT_COMIPORC), SUM(FADE_CONSUMO)
                        FROM FACTURAS F, FACTURAS_DETALLE D WHERE F.FACT_ID = D.FACT_ID AND F.FACT_ID = :ID
                        INTO :TOTAL, :IVAMONTO, :PORCV, :CONSUMO;
                ELSE
                    FOR SELECT D.ARTI_COD, FADE_CANT, FADE_TOTAL, FADE_IVAMONTO, FADE_CONSUMO, FACT_COMIPORC, GRUP_COD
                        FROM FACTURAS F, FACTURAS_DETALLE D, ARTICULO A
                        WHERE F.FACT_ID = D.FACT_ID AND D.arti_cod = A.arti_cod AND F.FACT_ID = :ID
                        INTO :ARTICULO, :CANT, :TOTAL, :IVAMONTO, :CONSUMO, :porcv, :codgrp
                        DO
                        BEGIN
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = (TOTAL - IVAMONTO - CONSUMO);
                        COMIV = PORCV / 100 * BASEAUX;
                        COMIMONTO = COMIV / 100 * COMIPORC;
                        porcaux = comiporc;
                        comiporc = PORCV / 100 * COMIPORC;
                        BASE = BASEAUX;
                        SUSPEND;
                        END
            if (TIPO = 33) then
                if (DETALLE = 'N') then
                    SELECT MAX(DEVT_TOTAL), MAX(DEVT_IVAMONTO), MAX(DEVT_COMIPORC), SUM(DVDE_CONSUMO)
                        FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D WHERE V.DEVT_ID = D.DEVT_ID AND D.DEVT_ID = :ID
                        INTO :TOTAL, :IVAMONTO, :PORCV, :CONSUMO;
                ELSE
                    FOR SELECT D.ARTI_COD, DVDE_CANT, DVDE_TOTAL*-1, DVDE_IVAMONTO*-1, DVDE_CONSUMO*-1, DEVT_COMIPORC, GRUP_COD
                        FROM DEVOLUCIONES_VENTAS V, DEVOLUCIONES_VENTAS_DETALLE D, ARTICULO A
                        WHERE V.DEVT_ID = D.DEVT_ID AND D.arti_cod = A.arti_cod AND V.DEVT_ID = :ID
                        INTO :ARTICULO, :CANT, :TOTAL, :IVAMONTO, :CONSUMO, :porcv, :codgrp
                        DO
                        BEGIN
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = (TOTAL - IVAMONTO - CONSUMO);
                        COMIV = PORCV / 100 * BASEAUX;
                        COMIMONTO = COMIV / 100 * COMIPORC;
                        porcaux = comiporc;
                        comiporc = PORCV / 100 * COMIPORC;
                        BASE = BASEAUX;
                        SUSPEND;
                        END
            if (TIPO = 41) then
                SELECT NDCL_MONTO, NDCL_IVAMONTO, NDCL_COMIPORC, 0 FROM NOTAS_DEBITO_CLIENTES
                    WHERE NDCL_ID = :ID INTO :TOTAL, :IVAMONTO, :PORCV, :CONSUMO;
            if (TIPO = 42) then
                SELECT NCCL_MONTO, NCCL_IVAMONTO, NCCL_COMIPORC, 0  FROM NOTAS_CREDITO_CLIENTES
                    WHERE NCCL_ID = :ID INTO :TOTAL, :IVAMONTO, :PORCV, :CONSUMO;
            if (TIPO = 77) then
                SELECT DVCH_MONTO, 0, 0, 0 FROM DEVOLUCION_CHEQUES WHERE DVCH_ID = :ID INTO :TOTAL, :IVAMONTO, :PORCV, :CONSUMO;
            if (SITOT = 'SI') then
                BASEAUX = ABONO;
            ELSE
                if ((total <> 0) AND (ABONO <> 0)) then
                    BASEAUX = (TOTAL - IVAMONTO - CONSUMO) / TOTAL * ABONO;
                ELSE
                    BASEAUX = 0;
            COMIV = PORCV / 100 * BASEAUX;
            COMIMONTO = COMIV / 100 * COMIPORC;
            porcaux = comiporc;
            comiporc = PORCV / 100 * COMIPORC;
            BASE = BASEAUX;
            END
        select COBR_NOM from COBRADORES where COBR_COD = :codvend INTO :nomvend;
        if (DETALLE = 'N') then
            if (ALFINAL = 'SI') then
                BEGIN
                /* VERIFIQUE EL SALDO DEL DOCUMENTO, SI ES CERO LIQUIDE COMISION SOBRE EL TOTAL */
                EXECUTE PROCEDURE saldo_doc_cartera(:tipo, :ID, :FECREC) returning_values (:SALDO);
                if (SALDO = 0) then
                    BEGIN
                    if (VENTA = 'NO') then
                        begin
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = TOTAL - IVAMONTO - CONSUMO;
                        COMIMONTO = BASEAUX * COMIPORC / 100;
                        end
                    ELSE
                        BEGIN
                        if (SITOT = 'SI') then
                            BASEAUX = TOTAL;
                        ELSE
                            BASEAUX = TOTAL - IVAMONTO - CONSUMO;
                        COMIV = PORCV * BASEAUX / 100;
                        COMIMONTO = COMIV / 100 * porcaux;
                        comiporc = PORCV / 100 * porcaux;
                        END
                    BASE = BASEAUX;
                    SUSPEND;
                    END
                END
            ELSE
                SUSPEND;
        ELSE
            if ((TIPO <> 31) AND (TIPO <> 33)) then
                SUSPEND;
        END
    END
FOR SELECT 'DEVOCHEQ', DVCH_MONTO*-1, DVCH_FECHA, PRBA_PREF, DVCH_NUMDOC, DVCH_FECHA, D.TERC_NIT, DVCH_NOMTERC, '', '', D.COBR_COD
    FROM DEVOLUCION_CHEQUES D, CLIENTES C
    WHERE DVCH_FECHA >= :FECINI AND DVCH_FECHA <= :FECFIN AND D.TERC_NIT = C.TERC_NIT AND D.COBR_COD = :CODVEND
    INTO :NOMTIPO, :BASE, :FECDOC, :PREFIJO, :NUMERO, :FECREC, :NIT, :CLIENTE, :PREFREC, :NUMREC, :codvend
    DO
    BEGIN
    COMIPORC = 0;
    COMIMONTO = 0;
    VENCE = fecdoc;
    RTFTE = 0;
    RTIVA = 0;
    RTICA = 0;
    DTOFIN = 0;
    if ((codvend >= :DESDE) AND (codvend <= :hasta)) then
        BEGIN
        select COBR_NOM from COBRADORES where COBR_COD = :codvend INTO :nomvend;
        /* SELECT CMCB_PORC FROM COMISION_COBRO WHERE CMCB_DIASINI <= 1 AND CMCB_DIASFIN >= 1 AND COBR_COD = :CODVEND INTO :COMIPORC;
        if (COMIPORC IS NULL) THEN
            COMIPORC = 0;
        COMIMONTO = BASE * COMIPORC / 100; */
        SUSPEND;
        END
    END
END
^

SET TERM ; ^

GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO PROCEDURE COMISIONES_COBRO;
GRANT SELECT ON RECIBOS_CAJA TO PROCEDURE COMISIONES_COBRO;
GRANT SELECT ON RECIBOS_CAJA_DETALLE TO PROCEDURE COMISIONES_COBRO;
GRANT SELECT ON TERCEROS TO PROCEDURE COMISIONES_COBRO;
GRANT SELECT ON TIPO_DOCUMENTO TO PROCEDURE COMISIONES_COBRO;
GRANT SELECT ON MOVIMIENTO_CLIENTES TO PROCEDURE COMISIONES_COBRO;
GRANT SELECT ON COMISION_COBRO TO PROCEDURE COMISIONES_COBRO;
GRANT SELECT ON FACTURAS TO PROCEDURE COMISIONES_COBRO;
GRANT SELECT ON FACTURAS_DETALLE TO PROCEDURE COMISIONES_COBRO;
GRANT SELECT ON ARTICULO TO PROCEDURE COMISIONES_COBRO;
GRANT SELECT ON DEVOLUCIONES_VENTAS TO PROCEDURE COMISIONES_COBRO;
GRANT SELECT ON DEVOLUCIONES_VENTAS_DETALLE TO PROCEDURE COMISIONES_COBRO;
GRANT SELECT ON NOTAS_DEBITO_CLIENTES TO PROCEDURE COMISIONES_COBRO;
GRANT SELECT ON NOTAS_CREDITO_CLIENTES TO PROCEDURE COMISIONES_COBRO;
GRANT SELECT ON DEVOLUCION_CHEQUES TO PROCEDURE COMISIONES_COBRO;
GRANT SELECT ON COBRADORES TO PROCEDURE COMISIONES_COBRO;
GRANT EXECUTE ON PROCEDURE SALDO_DOC_CARTERA TO PROCEDURE COMISIONES_COBRO;
GRANT SELECT ON EGRESOS TO PROCEDURE COMISIONES_COBRO;
GRANT SELECT ON EGRESOS_CRUCEC TO PROCEDURE COMISIONES_COBRO;
GRANT SELECT ON CLIENTE_SUCURSALES TO PROCEDURE COMISIONES_COBRO;
GRANT SELECT ON CLIENTES TO PROCEDURE COMISIONES_COBRO;

/* 20080729B */
/* generador de puntos estaba cruzado con el de clientes */
SET TERM ^ ;

CREATE OR ALTER TRIGGER PUNTOS_VENDEDOR_BI FOR PUNTOS_VENDEDOR
ACTIVE BEFORE INSERT POSITION 0
as
declare variable ID INTEGER;
declare variable fec DATE;
declare variable SALDOANT NUMERIC(18,2);
declare variable MOV NUMERIC(18,2);
begin
  /* Trigger text */
new.ptvt_id=gen_id(id_puntosvend,1);
SELECT MAX(PTVT_ID) FROM puntos_vendedor WHERE VEND_COD = NEW.vend_cod AND PTVT_FECHA < NEW.ptvt_fecha INTO :ID;
if (ID IS NULL) then
    NEW.ptvt_saldo = 0;
ELSE
    BEGIN
    SELECT PTVT_FECHA, PTVT_SALDO FROM puntos_vendedor WHERE VEND_COD = NEW.vend_cod AND PTVT_ID = :id INTO :fec, :saldoant;
    SELECT SUM(PTVT_DB - PTVT_CR) FROM puntos_vendedor WHERE VEND_COD = NEW.vend_cod AND PTVT_FECHA = :fec INTO :mov;
    NEW.ptvt_saldo = saldoant + mov;
    END
end
^

SET TERM ; ^

GRANT SELECT,UPDATE,REFERENCES ON PUNTOS_VENDEDOR TO TRIGGER PUNTOS_VENDEDOR_BI;


/* 20080729C - 3 DESCUENTOS POR ITEM Y NUMERO DE CAJAS EN FACTURA Y REMISION EN VENTA */
/* modificaciones DICOM */
/* 3 descuentos por item */
INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('FACTURACION', 'FACTURAS', 'COLUMNAS DE DESCUENTO POR ITEM ADICIONALES', 'NO', 'SI,NO', 'SI:Separa el descuento por item en tres columnas independientes con su total respectivo en la liquidacin. NO:Toma un solo descuento por item por artculo');
commit work;

ALTER TABLE FACTURAS_DETALLE
ADD FADE_DTO1 T_PORCENTAJE;
ALTER TABLE FACTURAS_DETALLE
ADD FADE_DTO2 T_PORCENTAJE;
ALTER TABLE FACTURAS_DETALLE
ADD FADE_DTO3 T_PORCENTAJE;

ALTER TABLE FACTURAS_DETALLE
ADD FADE_DTOM1 T_MONTO;
ALTER TABLE FACTURAS_DETALLE
ADD FADE_DTOM2 T_MONTO;
ALTER TABLE FACTURAS_DETALLE
ADD FADE_DTOM3 T_MONTO;

ALTER TABLE FACTURAS
ADD FACT_DTOIT1 T_MONTO;
ALTER TABLE FACTURAS
ADD FACT_DTOIT2 T_MONTO;
ALTER TABLE FACTURAS
ADD FACT_DTOIT3 T_MONTO;

/* numero de cajas */
INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('FACTURACION', 'DOCUMENTOS', 'PREGUNTAR NUMERO DE CAJAS POR ITEM', 'NO', 'SI,NO', 'SI:El usuario podr digitar el nmero de paquetes o cajas que conforman la cantidad facturada.');
commit work;

ALTER TABLE FACTURAS_DETALLE
ADD FADE_CAJAS T_CANTIDAD;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE IMPR_FACTURA(
    ID INTEGER)
RETURNS (
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    VENCE DATE,
    DIASVENCE INTEGER,
    CONTCRED CHAR(17),
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    VENDEDOR INTEGER,
    NOMVENDEDOR VARCHAR(60),
    PUNTOVTA INTEGER,
    NOMPUNTOVTA VARCHAR(30),
    CODBODEGA VARCHAR(2),
    NOMBODEGA VARCHAR(30),
    AUTORIZACION VARCHAR(20),
    DESPACHO VARCHAR(255),
    TRANSPORTADOR VARCHAR(60),
    COTIZACION VARCHAR(30),
    PEDIDO VARCHAR(30),
    REMISION VARCHAR(30),
    PACIENTE VARCHAR(20),
    NOMPACIENTE VARCHAR(60),
    COMIPORC NUMERIC(9,2),
    COMIMONTO NUMERIC(18,2),
    SUBTOTAL NUMERIC(18,2),
    DTOPORC NUMERIC(9,2),
    DTOMONTO NUMERIC(18,2),
    ADICIONAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    RTEFTEPORC NUMERIC(9,2),
    RTEFTEMONTO NUMERIC(18,2),
    RTEIVAPORC NUMERIC(9,2),
    RTEIVAMONTO NUMERIC(18,2),
    RTEICAPORC NUMERIC(9,2),
    RTEICAMONTO NUMERIC(18,2),
    EXTRA NUMERIC(18,2),
    DTOFPORC NUMERIC(9,2),
    DTOFMONTO NUMERIC(18,2),
    FECHADTO DATE,
    TOTALFAC NUMERIC(18,2),
    TOTALPAGAR NUMERIC(18,2),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    LOTE VARCHAR(15),
    VLOTE DATE,
    UNIDAD VARCHAR(8),
    CAJAS NUMERIC(18,4),
    FACTOR INTEGER,
    LISTAPR INTEGER,
    REFITEM VARCHAR(60),
    BODITEM VARCHAR(2),
    PRUNIT NUMERIC(18,2),
    DTOITPORC NUMERIC(9,2),
    DTOITMONTO NUMERIC(18,2),
    PRNETO NUMERIC(18,2),
    IVAPORC NUMERIC(9,2),
    IVAITMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    SUBTOTIT NUMERIC(18,2),
    SUBTOTITCON NUMERIC(18,2),
    DTOIT1 NUMERIC(9,2),
    DTOIT2 NUMERIC(9,2),
    DTOIT3 NUMERIC(9,2),
    TOTAL NUMERIC(18,2),
    CODIGOCL VARCHAR(20),
    ZONACOD VARCHAR(2),
    ZONANOM VARCHAR(60),
    DV CHAR(1),
    DIRECCION VARCHAR(60),
    CIUDAD VARCHAR(40),
    TELEFONO VARCHAR(40),
    CONTACTO VARCHAR(60),
    FAX VARCHAR(25),
    GRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    SUBGRUPO VARCHAR(3),
    NOMSUBG VARCHAR(30),
    MARCA VARCHAR(3),
    NOMMARCA VARCHAR(30),
    PESO NUMERIC(18,4),
    ANCHO NUMERIC(18,4),
    ALTO NUMERIC(18,4),
    LARGO NUMERIC(18,4),
    SUMA1 NUMERIC(18,2),
    SUMA2 NUMERIC(18,2),
    SUMA3 NUMERIC(18,2),
    IVA1 NUMERIC(18,2),
    IVA2 NUMERIC(18,2),
    IVA3 NUMERIC(18,2),
    SUMAEX NUMERIC(18,2),
    SUMAGR NUMERIC(18,2),
    TOTCONSUMO NUMERIC(18,2),
    DTOIT1M NUMERIC(18,2),
    DTOIT2M NUMERIC(18,2),
    DTOIT3M NUMERIC(18,2),
    TOTCAJAS NUMERIC(18,2),
    VEHICULO VARCHAR(8),
    RECIBIDO NUMERIC(18,2),
    CAMBIO NUMERIC(18,2),
    HORA TIME,
    FORMAPAGO1 VARCHAR(30),
    MONTOPAGO1 NUMERIC(18,2),
    FORMAPAGO2 VARCHAR(30),
    MONTOPAGO2 NUMERIC(18,2),
    FORMAPAGO3 VARCHAR(30),
    MONTOPAGO3 NUMERIC(18,2),
    PUNTOS INTEGER,
    PUNTOSACUM INTEGER,
    PUNTOSVENC INTEGER,
    OBSITEM BLOB SUB_TYPE 1 SEGMENT SIZE 80)
AS
DECLARE VARIABLE IMPTOS CHAR(1);
DECLARE VARIABLE TARIFA INTEGER;
declare variable DEVUELTO NUMERIC(18,2);
/*DECLARE VARIABLE NROCOPIA INTEGER;*/
declare variable ORDENCOD CHAR(2);
declare variable IMPRDEV CHAR(2);
declare variable IMPR CHAR(1);
declare variable ITEMFP INTEGER;
declare variable FORMAP VARCHAR(30);
declare variable MONTOP NUMERIC(18,2);
declare variable SUCUR VARCHAR(10);
BEGIN
  SELECT F.PREF_PRE, FACT_NUMERO, FACT_FECHA, FACT_VENCE, F.BODE_COD, BODE_NOM, F.TERC_NIT, FACT_NOMCLIENTE, F.VEND_COD, VEND_NOMBRE, F.PTVT_ID, PTVT_NOM,
    AUTO_NUMERO, FACT_DESPACHO, FACT_TRANSP, FACT_COTIZACI, FACT_PEDIDO, FACT_REMISION, FACT_COMIPORC, FACT_COMIMONTO, FACT_IVAINC, 
    FACT_DTOPOR, FACT_DTOMONTO, FACT_ADICIONAL, FACT_IVAMONTO, FACT_RTFTEPOR, FACT_RTFTEMONTO, FACT_RTIVAPOR, FACT_RTIVAMONTO, FACT_RTICAPOR, FACT_RTICAMONTO, FACT_EXTRA, FACT_DTOFPOR, FACT_DTOFMONTO, FACT_DTOFFECHA, FACT_TOTAL,
    TERC_DIR, TERC_CIU, TERC_TEL, TERC_CONTACTO, TERC_FAX, TERC_DV, FACT_DTOIT1, FACT_DTOIT2, FACT_DTOIT3,
    FACT_OBS, VEHI_COD, /*FACT_NROCOPIA,*/ FACT_RECIBIDO, FACT_SUCURSAL, FACT_DETCLI, FACT_DETCLINOM
    FROM FACTURAS F, BODEGA B, VENDEDORES V, PUNTO_VENTA P, TERCEROS T
    WHERE F.BODE_COD = B.BODE_COD AND F.VEND_COD = V.VEND_COD AND F.PTVT_ID = P.PTVT_ID AND F.TERC_NIT = T.TERC_NIT AND F.FACT_ID = :ID
    into :PREF, :NUMERO, :FECHA, :VENCE, :CODBODEGA, :NOMBODEGA, :NIT, :NOMTERCERO, :VENDEDOR, :NOMVENDEDOR, :PUNTOVTA, :NOMPUNTOVTA,
    :AUTORIZACION, :DESPACHO, :TRANSPORTADOR, :COTIZACION, :PEDIDO, :REMISION, :COMIPORC, :COMIMONTO, :IMPTOS,
    :DTOPORC, :DTOMONTO, :ADICIONAL, :IVAMONTO, :RTEFTEPORC, :RTEFTEMONTO, :RTEIVAPORC, :RTEIVAMONTO, :RTEICAPORC, :RTEICAMONTO, :EXTRA, :DTOFPORC, :DTOFMONTO, :FECHADTO, :TOTALFAC,
    :DIRECCION, :CIUDAD, :TELEFONO, :CONTACTO, :FAX, :DV, :dtoit1m, :dtoit2m, :dtoit3m,
    :OBS, :VEHICULO,/* :NROCOPIA,*/ :RECIBIDO, :SUCUR, :paciente, :nompaciente;

  /* ACUMULE LOS PUNTOS, SE HACE ACA POR SER POSTERIOR AL DETALLE */
  EXECUTE PROCEDURE acumula_puntos_cliente (31, :id, :nit, :fecha) returning_values (:PUNTOS);
  EXECUTE PROCEDURE consulta_puntos_cliente (:id, :nit, :fecha) returning_values (:puntos, :puntosacum, :puntosvenc);

  SELECT CLIE_COD, C.ZONA_COD, ZONA_NOM
    FROM CLIENTES C, ZONAS Z
    WHERE TERC_NIT = :NIT AND C.ZONA_COD = Z.ZONA_COD
    INTO :CODIGOCL, :ZONACOD, :ZONANOM;
  /*SELECT NOCO_NOMBRE FROM NOMBRES_COPIAS where NOCO_ID = :NROCOPIA INTO :NOMCOPIA;*/
  SELECT CLSU_DIR, CLSU_CIUDAD, CLSU_TEL FROM CLIENTE_SUCURSALES WHERE TERC_NIT = :NIT AND CLCU_COD = :SUCUR
    INTO :DIRECCION, :CIUDAD, :TELEFONO;
  /*if (NOMCOPIA IS NULL) then
    NOMCOPIA = 'COPIA No. ' || NROCOPIA;**/
  DIASVENCE = VENCE - FECHA;
  if (DIASVENCE > 0) then
    CONTCRED = 'CREDITO ' || CAST(DIASVENCE AS VARCHAR(3)) || ' DIAS';
  ELSE
    CONTCRED = 'CONTADO';
  SUBTOTAL = TOTALFAC - EXTRA - IVAMONTO - ADICIONAL + DTOMONTO;
  TOTALPAGAR = TOTALFAC - RTEFTEMONTO - RTEIVAMONTO - RTEICAMONTO;
  if (RECIBIDO <> 0) then
      CAMBIO = RECIBIDO - totalpagar;
  ELSE
    CAMBIO = 0;
  SUMAEX = 0;
  SUMA1 = 0;
  SUMA2 = 0;
  SUMA3 = 0;
  IVA1 = 0;
  IVA2 = 0;
  IVA3 = 0;
  TOTCONSUMO = 0;
  MONTOPAGO1 = 0;
  SELECT MAX(AUDI_HORA) FROM AUDITORIA WHERE TIDO_COD = 31 AND AUDI_IDDOC = :ID AND AUDI_OPER = 'I' INTO :HORA;
  /* AHORA LAS FORMAS DE PAGO, BUSQUE EL ABONO DE HOY A LA FACTURA */
  ITEMFP = 1;
  MONTOPAGO1 = 0;
  MONTOPAGO2 = 0;
  MONTOPAGO3 = 0;
  FOR SELECT FOPA_NOM, RCPA_MONTO FROM RECIBOS_CAJA_PAGO P, FORMAS_PAGO F, RECIBOS_CAJA R, RECIBOS_CAJA_DETALLE D
    WHERE R.RECA_ID = P.RECA_ID AND R.RECA_ID = D.RECA_ID AND P.FOPA_ID = F.FOPA_ID AND RECA_FECHA = :FECHA AND RCDE_TIPODOC = 31 AND RCDE_IDDOC = :ID
    INTO :formap, :MONTOP
    DO
    BEGIN
    if (ITEMFP = 1) then
        BEGIN
        FORMAPAGO1 = FORMAP;
        MONTOPAGO1 = MONTOP;
        END
    if (ITEMFP = 2) then
        BEGIN
        FORMAPAGO2 = FORMAP;
        MONTOPAGO2 = MONTOP;
        END
    if (ITEMFP = 3) then
        BEGIN
        FORMAPAGO3 = FORMAP;
        MONTOPAGO3 = MONTOP;
        END
    ITEMFP = ITEMFP + 1;
    END
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','DOCUMENTOS','ORDENAR ITEMS POR CODIGO DE ARTICULO') returning_values (:ORDENCOD);
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','POS', 'IMPRIMIR DEVOLUCIONES DE ARTICULOS NEGATIVOS') returning_values (:imprdev);
  totcajas = 0;
  if (ORDENCOD = 'SI') then
    BEGIN
    FOR SELECT FADE_ITEM, D.ARTI_COD, FADE_CODBAR, SUBSTR(FADE_DESC,1,60), FADE_CANT, FADE_UNIDAD, FADE_FACTOR, BODE_COD, FADE_LOTE, LIPR_COD, FADE_PRUNIT, FADE_DTOPORC, FADE_DTOMONTO, FADE_IVAPORC, FADE_IVAMONTO, FADE_CONSUMO, FADE_TOTAL, FADE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, FADE_DEVUELTO, FADE_OBS, FADE_DTO1, FADE_DTO2, FADE_DTO3, FADE_CAJAS
        FROM FACTURAS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.FACT_ID = :ID
        ORDER BY D.ARTI_COD
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :FACTOR, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem,
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :devuelto, :obsitem, :dtoit1, :dtoit2, :dtoit3, :cajas
        DO
          BEGIN
          if (ARTICULO = CODBAR) then
            SELECT FIRST 1 COBA_COD FROM barras_articulo WHERE ARTI_COD = :articulo INTO :CODBAR;
          if (IMPRDEV <> 'SI') then
            BEGIN
            if ((CANT >= 0) AND (DEVUELTO = 0)) then
                IMPR = 'S';
            ELSE
                IMPR = 'N'; /* ES DEVOLUCION */
            END
          ELSE
            IMPR = 'S';
          if (IMPR = 'S') then
            BEGIN
            if (IMPTOS = 'S') then
                if (cant <> 0) then
                    PRNETO = PRUNIT - DTOITMONTO - ((IVAITMONTO+CONSUMO) / CANT);
                else
                    PRNETO = PRUNIT - DTOITMONTO;
            ELSE
                PRNETO = PRUNIT - DTOITMONTO;
            SUBTOTIT = TOTAL - IVAITMONTO - CONSUMO;
            SUBTOTITCON = TOTAL;
            TOTCONSUMO = TOTCONSUMO + CONSUMO;
            SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO AND BODE_COD = :boditem INTO :vlote;
            if (TARIFA = 0) then
                SUMAEX = SUMAEX + TOTAL;
            if (TARIFA = 1) then
                BEGIN
                SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
                IVA1 = IVA1 + IVAITMONTO;
                END
            if (TARIFA = 2) then
                BEGIN
                SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
                IVA2 = IVA2 + IVAITMONTO;
                END
            if (TARIFA = 3) then
                BEGIN
                SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
                IVA3 = IVA3 + IVAITMONTO;
                END
            SUMAGR = SUMA1 + SUMA2 + SUMA3;
            if (IMPTOS = 'N') then
                TOTAL = TOTAL - IVAITMONTO - CONSUMO;
            if (ANCHO IS NULL) then
                ANCHO = 0;
            if (ALTO IS NULL) then
                ALTO = 0;
            if (LARGO IS NULL) then
                LARGO = 0;
            if (PESO IS NULL) then
                PESO = 0;
            PESO = PESO * CANT;
            totcajas = totcajas + cajas;
            SUSPEND;
            END
          END
    END
ELSE
    BEGIN
    FOR SELECT FADE_ITEM, D.ARTI_COD, FADE_CODBAR, SUBSTR(FADE_DESC,1,60), FADE_CANT, FADE_UNIDAD, FADE_FACTOR, BODE_COD, FADE_LOTE, LIPR_COD, FADE_PRUNIT, FADE_DTOPORC, FADE_DTOMONTO, FADE_IVAPORC, FADE_IVAMONTO, FADE_CONSUMO, FADE_TOTAL, FADE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, FADE_DEVUELTO, FADE_OBS, FADE_DTO1, FADE_DTO2, FADE_DTO3, FADE_CAJAS
        FROM FACTURAS_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.FACT_ID = :ID
        ORDER BY FADE_ITEM
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :FACTOR, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem, 
        :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :devuelto, :obsitem, :dtoit1, :dtoit2, :dtoit3, :cajas
        DO
          BEGIN
          if (IMPRDEV <> 'SI') then
            BEGIN
            if ((CANT >= 0) AND (DEVUELTO = 0)) then
                IMPR = 'S';
            ELSE
                IMPR = 'N'; /* ES DEVOLUCION */
            END
          ELSE
            IMPR = 'S';
          if (IMPR = 'S') then
            BEGIN
            SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
            SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
            SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
            if (IMPTOS = 'S') then
              PRNETO = PRUNIT - DTOITMONTO - ((IVAITMONTO+CONSUMO) / CANT);
            ELSE
              PRNETO = PRUNIT - DTOITMONTO;
            SUBTOTIT = TOTAL - IVAITMONTO - CONSUMO;
            SUBTOTITCON = TOTAL;
            TOTCONSUMO = TOTCONSUMO + CONSUMO;
            SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO AND BODE_COD = :boditem INTO :vlote;
            if (IVAPORC = 0) then
                SUMAEX = SUMAEX + TOTAL;
            if (TARIFA = 1) then
                BEGIN
                SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
                IVA1 = IVA1 + IVAITMONTO;
                END
            if (TARIFA = 2) then
                BEGIN
                SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
                IVA2 = IVA2 + IVAITMONTO;
                END
            if (TARIFA = 3) then
                BEGIN
                SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
                IVA3 = IVA3 + IVAITMONTO;
                END
            SUMAGR = SUMA1 + SUMA2 + SUMA3;
            if (IMPTOS = 'N') then
                TOTAL = TOTAL - IVAITMONTO - CONSUMO;
            if (ANCHO IS NULL) then
                ANCHO = 0;
            if (ALTO IS NULL) then
                ALTO = 0;
            if (LARGO IS NULL) then
                LARGO = 0;
            if (PESO IS NULL) then
                PESO = 0;
            PESO = PESO * CANT;
            totcajas = totcajas + cajas;
            SUSPEND;
            END
          END
    END
END
^

SET TERM ; ^

GRANT SELECT ON FACTURAS TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON BODEGA TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON VENDEDORES TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON PUNTO_VENTA TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON TERCEROS TO PROCEDURE IMPR_FACTURA;
GRANT EXECUTE ON PROCEDURE ACUMULA_PUNTOS_CLIENTE TO PROCEDURE IMPR_FACTURA;
GRANT EXECUTE ON PROCEDURE CONSULTA_PUNTOS_CLIENTE TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON CLIENTES TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON ZONAS TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON CLIENTE_SUCURSALES TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON AUDITORIA TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON RECIBOS_CAJA_PAGO TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON FORMAS_PAGO TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON RECIBOS_CAJA TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON RECIBOS_CAJA_DETALLE TO PROCEDURE IMPR_FACTURA;
GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON FACTURAS_DETALLE TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON ARTICULO TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON BARRAS_ARTICULO TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON LOTES TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON GRUPO TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON MARCAS TO PROCEDURE IMPR_FACTURA;
GRANT SELECT ON SUBGRUPO TO PROCEDURE IMPR_FACTURA;

ALTER TABLE REMISIONES_VENTA_DETALLE
ADD RVDE_CAJAS T_CANTIDAD;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE IMPR_REMISION(
    ID INTEGER)
RETURNS (
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA DATE,
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    VENDEDOR INTEGER,
    NOMVENDEDOR VARCHAR(60),
    PUNTOVTA INTEGER,
    NOMPUNTOVTA VARCHAR(30),
    CODBODEGA VARCHAR(2),
    NOMBODEGA VARCHAR(30),
    COTIZACION VARCHAR(30),
    PEDIDO VARCHAR(30),
    FACTURA VARCHAR(30),
    SUBTOTAL NUMERIC(18,2),
    IVAMONTO NUMERIC(18,2),
    TOTALFAC NUMERIC(18,2),
    DESPACHO VARCHAR(255),
    TRANSPORTADOR VARCHAR(60),
    OBS BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITEM INTEGER,
    ARTICULO VARCHAR(15),
    CODBAR VARCHAR(15),
    ARTIDES VARCHAR(60),
    CANT NUMERIC(18,4),
    LOTE VARCHAR(15),
    VLOTE DATE,
    UNIDAD VARCHAR(8),
    CAJAS NUMERIC(18,4),
    DEVUELTO NUMERIC(18,4),
    LISTAPR INTEGER,
    REFITEM VARCHAR(60),
    BODITEM VARCHAR(2),
    PRUNIT NUMERIC(18,2),
    DTOITPORC NUMERIC(9,2),
    DTOITMONTO NUMERIC(18,2),
    SUBTOTALITEM NUMERIC(18,2),
    PRNETOSINIVA NUMERIC(18,2),
    PRNETO NUMERIC(18,2),
    IVAPORC NUMERIC(9,2),
    IVAITMONTO NUMERIC(18,2),
    CONSUMO NUMERIC(18,2),
    TOTAL NUMERIC(18,2),
    CODIGOCL VARCHAR(20),
    ZONACOD VARCHAR(2),
    ZONANOM VARCHAR(60),
    DV CHAR(1),
    DIRECCION VARCHAR(60),
    CIUDAD VARCHAR(40),
    TELEFONO VARCHAR(40),
    CONTACTO VARCHAR(60),
    FAX VARCHAR(25),
    GRUPO VARCHAR(2),
    NOMGRUPO VARCHAR(30),
    SUBGRUPO VARCHAR(3),
    NOMSUBG VARCHAR(30),
    MARCA VARCHAR(3),
    NOMMARCA VARCHAR(30),
    PESO NUMERIC(9,4),
    ANCHO NUMERIC(18,4),
    ALTO NUMERIC(18,4),
    LARGO NUMERIC(18,4),
    SUMA1 NUMERIC(18,2),
    SUMA2 NUMERIC(18,2),
    SUMA3 NUMERIC(18,2),
    IVA1 NUMERIC(18,2),
    IVA2 NUMERIC(18,2),
    IVA3 NUMERIC(18,2),
    SUMAEX NUMERIC(18,2),
    SUMAGR NUMERIC(18,2),
    TOTCAJAS NUMERIC(18,2),
    OBSITEM BLOB SUB_TYPE 1 SEGMENT SIZE 80)
AS
DECLARE VARIABLE IMPTOS CHAR(1);
DECLARE VARIABLE TARIFA INTEGER;
declare variable ORDENCOD CHAR(2);
declare variable SUCUR VARCHAR(10);
BEGIN
  /*  */
  SELECT F.PREF_PRE, REVT_NUMERO, REVT_FECHA, F.BODE_COD, BODE_NOM, F.TERC_NIT, REVT_NOMTERC, F.VEND_COD, VEND_NOMBRE, F.PTVT_ID, PTVT_NOM,
    REVT_COTIZACI, REVT_PEDIDO, REVT_FACTURA, REVT_IVAINC,
    REVT_IVAMONTO, REVT_TOTAL, REVT_DESPACHO, REVT_TRANSP,
    TERC_CONTACTO, TERC_FAX, TERC_DV, REVT_OBS, REVT_SUCURSAL
    FROM REMISIONES_VENTA F, BODEGA B, VENDEDORES V, PUNTO_VENTA P, TERCEROS T
    WHERE F.BODE_COD = B.BODE_COD AND F.VEND_COD = V.VEND_COD AND F.PTVT_ID = P.PTVT_ID AND F.TERC_NIT = T.TERC_NIT AND F.REVT_ID = :ID
    into :PREF, :NUMERO, :FECHA, :CODBODEGA, :NOMBODEGA, :NIT, :NOMTERCERO, :VENDEDOR, :NOMVENDEDOR, :PUNTOVTA, :NOMPUNTOVTA,
    :COTIZACION, :PEDIDO, :FACTURA, :IMPTOS,
    :IVAMONTO, :TOTALFAC, :DESPACHO, :transportador, 
    :CONTACTO, :FAX, :DV, :OBS, :SUCUR;
  SUBTOTAL = TOTALFAC - IVAMONTO;

  SELECT CLIE_COD, C.ZONA_COD, ZONA_NOM
    FROM CLIENTES C, ZONAS Z
    WHERE TERC_NIT = :NIT AND C.ZONA_COD = Z.ZONA_COD
    INTO :CODIGOCL, :ZONACOD, :ZONANOM;
  SELECT CLSU_DIR, CLSU_CIUDAD, CLSU_TEL FROM CLIENTE_SUCURSALES WHERE TERC_NIT = :NIT AND CLCU_COD = :SUCUR
    INTO :DIRECCION, :CIUDAD, :TELEFONO;
    
  SUMAEX = 0;
  SUMA1 = 0;
  SUMA2 = 0;
  SUMA3 = 0;
  IVA1 = 0;
  IVA2 = 0;
  IVA3 = 0;
  ITEM = 0;
  totcajas = 0;
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','DOCUMENTOS','ORDENAR ITEMS POR CODIGO DE ARTICULO') returning_values (:ORDENCOD);
  if (ORDENCOD = 'SI') then
    BEGIN
    FOR SELECT D.ARTI_COD, RVDE_CODBAR, SUBSTR(RVDE_DESC,1,60), RVDE_CANT, RVDE_UNIDAD, BODE_COD, RVDE_LOTE, LIPR_COD, RVDE_PRUNIT, RVDE_DTOPORC, RVDE_DTOMONTO, RVDE_IVAPORC, RVDE_IVAMONTO, RVDE_CONSUMO, RVDE_TOTAL, RVDE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, RVDE_DEVUELTO, RVDE_OBS, RVDE_CAJAS
        FROM REMISIONES_VENTA_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.REVT_ID = :ID
        ORDER BY RVDE_CODBAR
        INTO :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem,
            :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :DEVUELTO, :obsitem, :CAJAS
        DO
        BEGIN
        if (ARTICULO = CODBAR) then
            SELECT FIRST 1 COBA_COD FROM barras_articulo WHERE ARTI_COD = :articulo INTO :CODBAR;
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
        SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO AND BODE_COD = :boditem INTO :vlote;
        ITEM = ITEM + 1;
        PRNETO = PRUNIT - DTOITMONTO;
        if (IVAPORC = 0) then
            SUMAEX = SUMAEX + TOTAL;
        if (TARIFA = 1) then
            BEGIN
            SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
            IVA1 = IVA1 + IVAITMONTO;
            END
        if (TARIFA = 2) then
            BEGIN
            SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
            IVA2 = IVA2 + IVAITMONTO;
            END
        if (TARIFA = 3) then
            BEGIN
            SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
            IVA3 = IVA3 + IVAITMONTO;
            END
        SUMAGR = SUMA1 + SUMA2 + SUMA3;

        if (IMPTOS = 'N') then
            TOTAL = TOTAL - IVAITMONTO;
        ELSE
           BEGIN
           PRNETOSINIVA = PRUNIT / (1 + ivaporc/100);
           SUBTOTALITEM = PRNETOSINIVA * :CANT;
           END
        totcajas = totcajas + cajas;
        SUSPEND;
        END
    END
ELSE
    BEGIN
    FOR SELECT RVDE_ITEM, D.ARTI_COD, RVDE_CODBAR, SUBSTR(RVDE_DESC,1,60), RVDE_CANT, RVDE_UNIDAD, BODE_COD, RVDE_LOTE, LIPR_COD, RVDE_PRUNIT, RVDE_DTOPORC, RVDE_DTOMONTO, RVDE_IVAPORC, RVDE_IVAMONTO, RVDE_CONSUMO, RVDE_TOTAL, RVDE_REFERENCIA,
        GRUP_COD, SUBG_COD, MARC_COD, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, TAIV_COD, RVDE_DEVUELTO, RVDE_OBS, RVDE_CAJAS
        FROM REMISIONES_VENTA_DETALLE D, ARTICULO A
        WHERE D.ARTI_COD = A.ARTI_COD AND D.REVT_ID = :ID
        ORDER BY RVDE_ITEM
        INTO :ITEM, :ARTICULO, :CODBAR, :ARTIDES, :CANT, :UNIDAD, :BODITEM, :LOTE, :LISTAPR, :PRUNIT, :DTOITPORC, :DTOITMONTO, :IVAPORC, :IVAITMONTO, :CONSUMO, :TOTAL, :refitem,
            :GRUPO, :SUBGRUPO, :MARCA, :PESO, :ANCHO, :ALTO, :LARGO, :TARIFA, :DEVUELTO, :obsitem, :CAJAS
        DO
        BEGIN
        SELECT GRUP_NOM FROM GRUPO G WHERE GRUP_COD = :GRUPO INTO NOMGRUPO;
        SELECT MARC_NOM FROM MARCAS WHERE MARC_COD = :MARCA INTO NOMMARCA;
        SELECT SUBG_NOM FROM SUBGRUPO WHERE SUBG_COD = :SUBGRUPO AND GRUP_COD = :GRUPO INTO :NOMSUBG;
        SELECT LOTE_VENCE FROM LOTES WHERE LOTE_NRO = :lote AND ARTI_COD = :ARTICULO AND BODE_COD = :boditem INTO :vlote;
        ITEM = ITEM + 1;
        PRNETO = PRUNIT - DTOITMONTO;
        if (IVAPORC = 0) then
            SUMAEX = SUMAEX + TOTAL;
        if (TARIFA = 1) then
            BEGIN
            SUMA1 = SUMA1 + TOTAL - IVAITMONTO;
            IVA1 = IVA1 + IVAITMONTO;
            END
        if (TARIFA = 2) then
            BEGIN
            SUMA2 = SUMA2 + TOTAL - IVAITMONTO;
            IVA2 = IVA2 + IVAITMONTO;
            END
        if (TARIFA = 3) then
            BEGIN
            SUMA3 = SUMA3 + TOTAL - IVAITMONTO;
            IVA3 = IVA3 + IVAITMONTO;
            END
        SUMAGR = SUMA1 + SUMA2 + SUMA3;
        SUBTOTALITEM = TOTAL - IVAITMONTO;
        if (IMPTOS = 'N') then
            TOTAL = TOTAL - IVAITMONTO;
        ELSE
           BEGIN
             PRNETOSINIVA = PRUNIT / (1 + ivaporc/100);
             SUBTOTALITEM = PRNETOSINIVA * :CANT;
           END
        totcajas = totcajas + cajas;
        SUSPEND;
        END
    END
END
^

SET TERM ; ^

GRANT SELECT ON REMISIONES_VENTA TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON BODEGA TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON VENDEDORES TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON PUNTO_VENTA TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON TERCEROS TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON CLIENTES TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON ZONAS TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON CLIENTE_SUCURSALES TO PROCEDURE IMPR_REMISION;
GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON REMISIONES_VENTA_DETALLE TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON ARTICULO TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON BARRAS_ARTICULO TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON GRUPO TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON MARCAS TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON SUBGRUPO TO PROCEDURE IMPR_REMISION;
GRANT SELECT ON LOTES TO PROCEDURE IMPR_REMISION;

/* 20080730 RUTEROS DE FACTURAS */
CREATE TABLE RUTAS_ENTREGA (
    RUTA_ID T_ID NOT NULL,
    RUTA_NOM T_CONCEPTO);
alter table RUTAS_ENTREGA
add constraint PK_RUTAS_ENTREGA
primary key (RUTA_ID);

CREATE TABLE RUTERO_FAC (
    TIDO_COD T_ID NOT NULL,
    RUTA_ID T_ID NOT NULL,
    RUTA_FECHA DATE NOT NULL,
    RUTA_IDDOC T_ID,
    RUTA_OK T_BOOLEANO);
alter table RUTERO_FAC
add constraint PK_RUTERO_FAC
primary key (TIDO_COD,RUTA_ID,RUTA_FECHA);

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('FACTURACION', 'DOCUMENTOS', 'NUMERO DE DIAS MAXIMO PARA ASIGNAR DOCUMENTO A UNA RUTA', '5', '1,2,3,4,5,15,30', 'Indique el nmero de das mximo a tener en cuenta al asignar rutas a los documentos a entregar');
commit work;

ALTER TABLE RUTERO_FAC
ADD RUTA_RAZON T_ID;
ALTER TABLE RUTERO_FAC
ADD RUTA_EXPLICA T_CONCEPTO;

CREATE TABLE RUTERO_RAZON (
    RAZO_ID T_ID NOT NULL,
    RAZO_NOM T_CONCEPTO);
alter table RUTERO_RAZON
add constraint PK_RUTERO_RAZON
primary key (RAZO_ID);


INSERT INTO RUTERO_RAZON (RAZO_ID, RAZO_NOM) VALUES (1, 'DIRECCION DEFICIENTE');
INSERT INTO RUTERO_RAZON (RAZO_ID, RAZO_NOM) VALUES (2, 'CLIENTE DESCONOCIDO');
INSERT INTO RUTERO_RAZON (RAZO_ID, RAZO_NOM) VALUES (3, 'CAMBIO DE DOMICILIO');
INSERT INTO RUTERO_RAZON (RAZO_ID, RAZO_NOM) VALUES (4, 'PEDIDO RECHAZADO');
INSERT INTO RUTERO_RAZON (RAZO_ID, RAZO_NOM) VALUES (5, 'ESTABLECIMIENTO CERRADO');
INSERT INTO RUTERO_RAZON (RAZO_ID, RAZO_NOM) VALUES (6, 'SIN CONDICIONES DE PAGO');
COMMIT WORK;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE ASIGNA_RUTERO_FAC(
    TIPO INTEGER,
    FECFIN DATE,
    SUBEMPRESA INTEGER)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECDOC DATE,
    VENDCOD INTEGER,
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    PEDIDO VARCHAR(30),
    REMISION VARCHAR(30),
    CANT NUMERIC(18,4),
    CAJAS NUMERIC(18,4),
    TOTAL NUMERIC(18,2),
    OK CHAR(1),
    ENTREGADO CHAR(1),
    RAZON INTEGER,
    EXPLICA VARCHAR(60))
AS
declare variable FECINI DATE;
declare variable DIAS INTEGER;
BEGIN
OK = 'N';
ENTREGADO = 'N';
RAZON = 0;
EXPLICA = '';
EXECUTE PROCEDURE lee_configuracion('FACTURACION', 'DOCUMENTOS', 'NUMERO DE DIAS MAXIMO PARA ASIGNAR DOCUMENTO A UNA RUTA') returning_values (DIAS);
FECINI = FECFIN - DIAS;
/* DETERMINE LA TABLA A EXAMINAR */
if (TIPO=31) then
    BEGIN
    FOR SELECT FACT_ID, F.PREF_PRE, FACT_NUMERO, FACT_FECHA, F.VEND_COD, F.TERC_NIT, FACT_NOMCLIENTE, FACT_PEDIDO, FACT_REMISION, FACT_TOTAL
        FROM FACTURAS F, PREFIJOS PR
        WHERE FACT_FECHA >= :fecini AND FACT_FECHA <= :fecfin AND PR.PREF_PRE = F.PREF_PRE AND PR.TIDO_COD = 31 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
            AND FACT_ANULADO = 'N' AND NOT EXISTS (SELECT RUTA_ID FROM RUTERO_FAC WHERE TIDO_COD = 31 AND RUTA_IDDOC = F.fact_id)
        ORDER BY FACT_FECHA, FACT_ID
        INTO :ID, :PREF, :NUMERO, :FECDOC, :VENDCOD, :NIT, :NOMTERCERO, :PEDIDO, :REMISION, :TOTAL
        DO
        BEGIN
        SELECT SUM(FADE_CANT), SUM(FADE_CAJAS) FROM FACTURAS_DETALLE WHERE FACT_ID = :ID INTO :CANT, :CAJAS;
        SUSPEND;
        END
    END
if (TIPO=32) then
    BEGIN
    FOR SELECT REVT_ID, R.PREF_PRE, REVT_NUMERO, REVT_FECHA, R.VEND_COD, R.TERC_NIT, REVT_NOMTERC, REVT_PEDIDO, REVT_FACTURA, REVT_TOTAL
        FROM REMISIONES_VENTA R, PREFIJOS PR
        WHERE REVT_FECHA >= :fecini AND REVT_FECHA <= :fecfin AND PR.PREF_PRE = R.PREF_PRE AND PR.TIDO_COD = 32 AND ((PR.SUCU_ID = :SUBEMPRESA) or (:SUBEMPRESA = 0))
        AND REVT_ANULADO = 'N' AND NOT EXISTS (SELECT RUTA_ID FROM RUTERO_FAC WHERE TIDO_COD = 32 AND RUTA_IDDOC = R.revt_id)
        ORDER BY REVT_FECHA, REVT_ID
        INTO :ID, :PREF, :NUMERO, :FECDOC, :VENDCOD, :NIT, :NOMTERCERO, :PEDIDO, :REMISION, :TOTAL
        DO
        BEGIN
        SELECT SUM(RVDE_CANT), SUM(RVDE_CAJAS) FROM REMISIONES_VENTA_DETALLE WHERE REVT_ID = :ID INTO :CANT, :CAJAS;
        SUSPEND;
        END
    END
END
^

SET TERM ; ^

GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO PROCEDURE ASIGNA_RUTERO_FAC;
GRANT SELECT ON FACTURAS TO PROCEDURE ASIGNA_RUTERO_FAC;
GRANT SELECT ON PREFIJOS TO PROCEDURE ASIGNA_RUTERO_FAC;
GRANT SELECT ON RUTERO_FAC TO PROCEDURE ASIGNA_RUTERO_FAC;
GRANT SELECT ON FACTURAS_DETALLE TO PROCEDURE ASIGNA_RUTERO_FAC;
GRANT SELECT ON REMISIONES_VENTA TO PROCEDURE ASIGNA_RUTERO_FAC;
GRANT SELECT ON REMISIONES_VENTA_DETALLE TO PROCEDURE ASIGNA_RUTERO_FAC;
GRANT EXECUTE ON PROCEDURE asigna_rutero_fac TO PUBLIC;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE CONFIRMA_RUTERO_FAC(
    TIPO INTEGER,
    RUTA INTEGER,
    FECHA DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECDOC DATE,
    VENDCOD INTEGER,
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    PEDIDO VARCHAR(30),
    REMISION VARCHAR(30),
    CANT NUMERIC(18,4),
    CAJAS NUMERIC(18,4),
    TOTAL NUMERIC(18,2),
    OK CHAR(1),
    ENTREGADO CHAR(1),
    RAZON INTEGER,
    EXPLICA VARCHAR(60))
AS
BEGIN
ENTREGADO = 'N';
RAZON = 0;
EXPLICA = '';
FOR SELECT FACT_ID, F.PREF_PRE, FACT_NUMERO, FACT_FECHA, F.VEND_COD, F.TERC_NIT, FACT_NOMCLIENTE, FACT_PEDIDO, FACT_REMISION, FACT_TOTAL
    FROM FACTURAS F, rutero_fac R WHERE R.ruta_fecha = :FECHA AND R.ruta_id = :RUTA AND R.tido_cod = :tipo AND R.ruta_iddoc = F.fact_id AND FACT_ANULADO = 'N'
    ORDER BY F.pref_pre, FACT_NUMERO
    INTO :ID, :PREF, :NUMERO, :FECDOC, :VENDCOD, :NIT, :NOMTERCERO, :PEDIDO, :REMISION, :TOTAL
    DO
    BEGIN
    SELECT SUM(FADE_CANT), SUM(FADE_CAJAS) FROM FACTURAS_DETALLE WHERE FACT_ID = :ID INTO :CANT, :CAJAS;
    SUSPEND;
    END
END
^

SET TERM ; ^

GRANT SELECT ON FACTURAS TO PROCEDURE CONFIRMA_RUTERO_FAC;
GRANT SELECT ON RUTERO_FAC TO PROCEDURE CONFIRMA_RUTERO_FAC;
GRANT SELECT ON FACTURAS_DETALLE TO PROCEDURE CONFIRMA_RUTERO_FAC;
GRANT EXECUTE ON PROCEDURE confirma_rutero_fac TO PUBLIC;

ALTER TABLE RUTERO_FAC DROP CONSTRAINT PK_RUTERO_FAC;
update RDB$RELATION_FIELDS set
RDB$NULL_FLAG = 1
where (RDB$FIELD_NAME = 'RUTA_IDDOC') and
(RDB$RELATION_NAME = 'RUTERO_FAC');

alter table RUTERO_FAC
add constraint PK_RUTERO_FAC
primary key (TIDO_COD,RUTA_ID,RUTA_FECHA,RUTA_IDDOC);


SET TERM ^ ;

CREATE OR ALTER PROCEDURE CONFIRMA_RUTERO_FAC(
    TIPO INTEGER,
    RUTA INTEGER,
    FECHA DATE)
RETURNS (
    ID INTEGER,
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECDOC DATE,
    VENDCOD INTEGER,
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    PEDIDO VARCHAR(30),
    REMISION VARCHAR(30),
    CANT NUMERIC(18,4),
    CAJAS NUMERIC(18,4),
    TOTAL NUMERIC(18,2),
    OK CHAR(1),
    ENTREGADO CHAR(1),
    RAZON INTEGER,
    EXPLICA VARCHAR(60))
AS
BEGIN
OK = 'S';
FOR SELECT FACT_ID, F.PREF_PRE, FACT_NUMERO, FACT_FECHA, F.VEND_COD, F.TERC_NIT, FACT_NOMCLIENTE, FACT_PEDIDO, FACT_REMISION, FACT_TOTAL, R.ruta_ok, R.ruta_razon, R.ruta_explica
    FROM FACTURAS F, rutero_fac R WHERE R.ruta_fecha = :FECHA AND R.ruta_id = :RUTA AND R.tido_cod = :tipo AND R.ruta_iddoc = F.fact_id AND FACT_ANULADO = 'N'
    ORDER BY F.pref_pre, FACT_NUMERO
    INTO :ID, :PREF, :NUMERO, :FECDOC, :VENDCOD, :NIT, :NOMTERCERO, :PEDIDO, :REMISION, :TOTAL, :entregado, :razon, :explica
    DO
    BEGIN
    SELECT SUM(FADE_CANT), SUM(FADE_CAJAS) FROM FACTURAS_DETALLE WHERE FACT_ID = :ID INTO :CANT, :CAJAS;
    SUSPEND;
    END
END
^

SET TERM ; ^

GRANT SELECT ON FACTURAS TO PROCEDURE CONFIRMA_RUTERO_FAC;
GRANT SELECT ON RUTERO_FAC TO PROCEDURE CONFIRMA_RUTERO_FAC;
GRANT SELECT ON FACTURAS_DETALLE TO PROCEDURE CONFIRMA_RUTERO_FAC;


/* 20080730B CONTABILIZACION DE ACTIVOS */
CREATE TABLE SALDOS_ACTIVO (
    ACFJ_COD T_COD_ARTICULO NOT NULL,
    CUEN_COD T_CTA_CONTABLE NOT NULL,
    SAAC_FECHA CHAR(8) NOT NULL,
    SAAC_SALDO T_MONTO,
    SAAC_DEBITOS T_MONTO,
    SAAC_CREDITOS T_MONTO);
alter table SALDOS_ACTIVO
add constraint PK_SALDOS_ACTIVO
primary key (ACFJ_COD,CUEN_COD,SAAC_FECHA);

CREATE EXCEPTION FALTA_ACTIVO 'Debe indicar el cdigo del activo a mover';
SET TERM ^ ;

CREATE OR ALTER TRIGGER COMPROBANTE_DETALLE_BI FOR COMPROBANTE_DETALLE
ACTIVE BEFORE INSERT POSITION 1
AS
DECLARE VARIABLE OK CHAR(1);
DECLARE VARIABLE TERCERO CHAR(1);
DECLARE VARIABLE RETENCION CHAR(1);
DECLARE VARIABLE CENTRO CHAR(1);
declare variable TIPO CHAR(1);
declare variable TICO VARCHAR(3);
declare variable NUMCOMP VARCHAR(10);
BEGIN
SELECT TICO_COD, PRCO_PREF || ENCO_NUMERO FROM COMPROBANTE_ENCABEZADO WHERE ENCO_CONSEC = NEW.enco_consec INTO :TICO, :numcomp;
/* VERIFIQUE QUE LA CUENTA EXISTA Y QUE SEA AFECTABLE */
EXECUTE PROCEDURE VALIDE_CUENTA (NEW.CUEN_COD) RETURNING_VALUES (:OK);
IF (OK = 'S') THEN
  BEGIN
  IF (NEW.CODE_DEBITO IS NULL) THEN
    NEW.CODE_DEBITO = 0;
  IF (NEW.CODE_CREDITO IS NULL) THEN
    NEW.CODE_CREDITO = 0;
  if (NEW.code_base IS NULL) then
    NEW.CODE_BASE = 0;
  if (NEW.code_porc IS NULL) then
    NEW.CODE_PORC = 0;
  if ((NEW.code_base <> 0) AND (NEW.CODE_PORC = 0) AND ((NEW.code_debito <> 0) or (NEW.code_credito <> 0))) then
    NEW.code_porc = (NEW.code_debito - NEW.code_credito) * 100 / NEW.code_base;
  IF ((NEW.TERC_NIT IS NULL) or (new.terc_nit = '')) THEN
    EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'NIT COMPAIA') RETURNING_VALUES (NEW.TERC_NIT);
  IF ((NEW.PROY_COD IS NULL) or (new.proy_cod = '')) THEN
    EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'PROYECTO UNICO') RETURNING_VALUES (NEW.PROY_COD);
  IF ((NEW.CENT_COD IS NULL) or (new.cent_cod = '')) THEN
    EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'CENTRO DE COSTOS UNICO') RETURNING_VALUES (NEW.CENT_COD);
  SELECT CUEN_TERCERO, CUEN_RETENCION, CUEN_CENTRO, CUEN_TIPO FROM CUENTAS WHERE CUEN_COD = NEW.CUEN_COD INTO :TERCERO, :RETENCION, :CENTRO, :TIPO;
  /* VERIFIQUE QUE LA CUENTA PERMITA RETENCION Y VERIFIQUE EL TERCERO */
  IF (TERCERO = 'S' OR RETENCION = 'S') THEN
    EXECUTE PROCEDURE EXISTE_TERCERO (NEW.TERC_NIT) RETURNING_VALUES (:OK);
  ELSE
    EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'NIT COMPAIA') RETURNING_VALUES (NEW.TERC_NIT);
  IF (OK = 'S') THEN
    BEGIN
    /* SI LA CUENTA ES DE RETENCION ASEGURECE QUE TENGA BASE Y PORCENTAJE */
    IF (RETENCION = 'S') THEN
      BEGIN
      IF ((NEW.CODE_BASE = 0) OR (NEW.CODE_PORC = 0)) THEN
        EXCEPTION FALTA_BASE :tico || '-' || :numcomp || ' FALTA INDICAR LA BASE PARA LA CUENTA ' || NEW.cuen_cod;
      END
    ELSE
       BEGIN
      IF (CENTRO = 'S') THEN
        EXECUTE PROCEDURE EXISTE_CENTRO (NEW.PROY_COD, NEW.CENT_COD) RETURNING_VALUES (:OK);
        ELSE
        BEGIN
        EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'PROYECTO UNICO') RETURNING_VALUES (NEW.PROY_COD);
        EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD', 'GENERAL', 'CENTRO DE COSTOS UNICO') RETURNING_VALUES (NEW.CENT_COD);
          END
        END
    END
  if (:TIPO = 'I') then
    BEGIN
    if (NEW.ARTI_COD IS NULL) then
        EXCEPTION FALTA_ARTICULO :tico || '-' || :numcomp || ' FALTA INDICAR EL ARTICULO PARA LA CUENTA ' || NEW.cuen_cod;
    END
  if (:TIPO = 'A') then
    BEGIN
    if (NEW.ARTI_COD IS NULL) then
        EXCEPTION FALTA_ACTIVO :tico || '-' || :numcomp || ' FALTA INDICAR EL ACTIVO PARA LA CUENTA ' || NEW.cuen_cod;
    END
  END
END
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON COMPROBANTE_DETALLE TO TRIGGER COMPROBANTE_DETALLE_BI;
GRANT SELECT ON COMPROBANTE_ENCABEZADO TO TRIGGER COMPROBANTE_DETALLE_BI;
GRANT EXECUTE ON PROCEDURE VALIDE_CUENTA TO TRIGGER COMPROBANTE_DETALLE_BI;
GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO TRIGGER COMPROBANTE_DETALLE_BI;
GRANT SELECT ON CUENTAS TO TRIGGER COMPROBANTE_DETALLE_BI;
GRANT EXECUTE ON PROCEDURE EXISTE_TERCERO TO TRIGGER COMPROBANTE_DETALLE_BI;
GRANT EXECUTE ON PROCEDURE EXISTE_CENTRO TO TRIGGER COMPROBANTE_DETALLE_BI;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE SALDO_ACTIVO(
    CUENTA VARCHAR(20),
    ACTIVO VARCHAR(15),
    FECHA CHAR(8))
RETURNS (
    SALDO NUMERIC(18,2))
AS
DECLARE VARIABLE FEC CHAR(8);
BEGIN
/* Busca la fecha del ltimo movimiento de la cuenta-ARTICULO antes de la fecha */
SELECT  MAX(SAAC_FECHA) FROM saldos_activo
  WHERE (CUEN_COD = :CUENTA) AND (ACFJ_COD = :activo) AND (SAAC_FECHA <= :FECHA) INTO :FEC;
IF (FEC IS NULL) THEN
  SALDO = 0;
ELSE
  /* Con la fecha mxima calcule el nuevo saldo */
  SELECT MAX(SAAC_SALDO+SAAC_DEBITOS-SAAC_CREDITOS) FROM saldos_activo
    WHERE (CUEN_COD = :CUENTA) AND (ACFJ_COD = :activo) AND (SAAC_FECHA = :FEC) INTO :SALDO;
SUSPEND;
END
^

SET TERM ; ^

GRANT SELECT ON SALDOS_ACTIVO TO PROCEDURE SALDO_ACTIVO;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE ACTUALICE_SALDO_ACTIVO(
    CUENTA VARCHAR(20),
    ACTIVO VARCHAR(15),
    FECHA CHAR(8),
    DEBITO NUMERIC(18,2),
    CREDITO NUMERIC(18,2))
AS
DECLARE VARIABLE EXISTE CHAR(1);
DECLARE VARIABLE SALDOA NUMERIC(18,2);
BEGIN
  EXISTE = 'N';
  IF (:ACTIVO <> '') THEN
    BEGIN
    /* Busque en saldos_Articulo la cuenta-Articulo y la fecha, si la encuentra actualice db y cr, si no inserte un registro */
    SELECT 'S' FROM saldos_activo
        WHERE (CUEN_COD = :CUENTA) AND (ACFJ_COD = :ACTIVO) AND (SAAC_FECHA = :FECHA) INTO :EXISTE;
    IF (EXISTE = 'N') THEN
      BEGIN
      /*  traiga el saldo anterior y registre uno nuevo */
      EXECUTE PROCEDURE saldo_activo(:CUENTA, :activo, :FECHA) RETURNING_VALUES :SALDOA;
      INSERT INTO saldos_activo(CUEN_COD, ACFJ_COD, SAAC_FECHA, SAAC_SALDO, SAAC_DEBITOS, SAAC_CREDITOS)
        VALUES (:CUENTA, :activo, :FECHA, :SALDOA, :DEBITO, :CREDITO);
      END
    ELSE
        BEGIN
        UPDATE saldos_activo
          SET SAAC_DEBITOS = SAAC_DEBITOS + :DEBITO,
             SAAC_CREDITOS = SAAC_CREDITOS + :CREDITO
          WHERE (CUEN_COD = :CUENTA) AND (ACFJ_COD = :activo) AND (SAAC_FECHA = :FECHA);
        END
    /* Actualice los saldos de fechas posteriores */
      UPDATE saldos_activo
        SET SAAC_SALDO = SAAC_SALDO + :DEBITO - :CREDITO
        WHERE (CUEN_COD = :CUENTA) AND (ACFJ_COD = :activo) AND (SAAC_FECHA > :FECHA);
    END
END
^

SET TERM ; ^

GRANT SELECT,INSERT,UPDATE ON SALDOS_ACTIVO TO PROCEDURE ACTUALICE_SALDO_ACTIVO;
GRANT EXECUTE ON PROCEDURE SALDO_ACTIVO TO PROCEDURE ACTUALICE_SALDO_ACTIVO;

SET TERM ^ ;

CREATE OR ALTER TRIGGER COMPROBANTE_DETALLE_AI FOR COMPROBANTE_DETALLE
ACTIVE AFTER INSERT POSITION 0
AS
DECLARE VARIABLE FECHA CHAR(8);
declare variable TIPO CHAR(1);
BEGIN
SELECT ENCO_FECHA FROM COMPROBANTE_ENCABEZADO WHERE ENCO_CONSEC = NEW.ENCO_CONSEC INTO :FECHA;
/* ACTUALICE LOS SALDOS */
EXECUTE PROCEDURE ACTUALICE_SALDO_CUENTA(NEW.CUEN_COD, FECHA, NEW.CODE_DEBITO, NEW.CODE_CREDITO);
EXECUTE PROCEDURE ACTUALICE_SALDO_TERCERO(NEW.CUEN_COD, NEW.TERC_NIT, FECHA, NEW.CODE_DEBITO, NEW.CODE_CREDITO);
if (NEW.ARTI_COD IS NOT NULL) then
  BEGIN
  SELECT CUEN_TIPO FROM CUENTAS WHERE CUEN_COD = NEW.CUEN_COD INTO :TIPO;
  if (TIPO = 'I') then
    EXECUTE PROCEDURE ACTUALICE_SALDO_ARTICULO(NEW.CUEN_COD, NEW.ARTI_COD, FECHA, NEW.CODE_DEBITO, NEW.CODE_CREDITO);
  else
    if (TIPO = 'A') then
      EXECUTE PROCEDURE actualice_saldo_activo(NEW.CUEN_COD, NEW.ARTI_COD, FECHA, NEW.CODE_DEBITO, NEW.CODE_CREDITO);
  END
EXECUTE PROCEDURE ACTUALICE_SALDO_CENTRO(NEW.CUEN_COD, NEW.PROY_COD, NEW.CENT_COD, FECHA, NEW.CODE_DEBITO, NEW.CODE_CREDITO);
EXECUTE PROCEDURE ACTUALICE_SALDO_CENTRO_TERCERO(NEW.CUEN_COD, NEW.PROY_COD, NEW.CENT_COD, NEW.TERC_NIT, FECHA, NEW.CODE_DEBITO, NEW.CODE_CREDITO);
END
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON COMPROBANTE_DETALLE TO TRIGGER COMPROBANTE_DETALLE_AI;
GRANT SELECT ON COMPROBANTE_ENCABEZADO TO TRIGGER COMPROBANTE_DETALLE_AI;
GRANT EXECUTE ON PROCEDURE ACTUALICE_SALDO_CUENTA TO TRIGGER COMPROBANTE_DETALLE_AI;
GRANT EXECUTE ON PROCEDURE ACTUALICE_SALDO_TERCERO TO TRIGGER COMPROBANTE_DETALLE_AI;
GRANT SELECT ON CUENTAS TO TRIGGER COMPROBANTE_DETALLE_AI;
GRANT EXECUTE ON PROCEDURE ACTUALICE_SALDO_ARTICULO TO TRIGGER COMPROBANTE_DETALLE_AI;
GRANT EXECUTE ON PROCEDURE ACTUALICE_SALDO_ACTIVO TO TRIGGER COMPROBANTE_DETALLE_AI;
GRANT EXECUTE ON PROCEDURE ACTUALICE_SALDO_CENTRO TO TRIGGER COMPROBANTE_DETALLE_AI;
GRANT EXECUTE ON PROCEDURE ACTUALICE_SALDO_CENTRO_TERCERO TO TRIGGER COMPROBANTE_DETALLE_AI;

SET TERM ^ ;

CREATE OR ALTER TRIGGER COMPROBANTE_DETALLE_AU FOR COMPROBANTE_DETALLE
ACTIVE AFTER UPDATE POSITION 0
AS
DECLARE VARIABLE FECHA CHAR(8);
DECLARE VARIABLE DIF_DB NUMERIC(15,2);
DECLARE VARIABLE DIF_CR NUMERIC(15,2);
declare variable TIPO CHAR(1);
BEGIN
/* DESHAGA LO VIEJO */
SELECT ENCO_FECHA FROM COMPROBANTE_ENCABEZADO WHERE ENCO_CONSEC = NEW.ENCO_CONSEC INTO :FECHA;
DIF_DB = - OLD.CODE_DEBITO;
DIF_CR = - OLD.CODE_CREDITO;
EXECUTE PROCEDURE ACTUALICE_SALDO_CENTRO_TERCERO(OLD.CUEN_COD, OLD.PROY_COD, OLD.CENT_COD, OLD.TERC_NIT, FECHA, DIF_DB, DIF_CR);
EXECUTE PROCEDURE ACTUALICE_SALDO_CENTRO(OLD.CUEN_COD, OLD.PROY_COD, OLD.CENT_COD, FECHA, DIF_DB, DIF_CR);
EXECUTE PROCEDURE ACTUALICE_SALDO_TERCERO(OLD.CUEN_COD, OLD.TERC_NIT, FECHA, DIF_DB, DIF_CR);
EXECUTE PROCEDURE ACTUALICE_SALDO_CUENTA(OLD.CUEN_COD, FECHA, DIF_DB, DIF_CR);
if (OLD.ARTI_COD IS NOT NULL) then
  BEGIN
  SELECT CUEN_TIPO FROM CUENTAS WHERE CUEN_COD = NEW.CUEN_COD INTO :TIPO;
  if (TIPO = 'I') then
    EXECUTE PROCEDURE ACTUALICE_SALDO_ARTICULO(OLD.CUEN_COD, OLD.ARTI_COD, FECHA, DIF_DB, DIF_CR);
  ELSE
    EXECUTE PROCEDURE actualice_saldo_activo(OLD.CUEN_COD, OLD.ARTI_COD, FECHA, DIF_DB, DIF_CR);
  END
/* GRABE LOS NUEVOS */
EXECUTE PROCEDURE ACTUALICE_SALDO_CUENTA(NEW.CUEN_COD, FECHA, NEW.CODE_DEBITO, NEW.CODE_CREDITO);
EXECUTE PROCEDURE ACTUALICE_SALDO_TERCERO(NEW.CUEN_COD, NEW.TERC_NIT, FECHA, NEW.CODE_DEBITO, NEW.CODE_CREDITO);
EXECUTE PROCEDURE ACTUALICE_SALDO_CENTRO(NEW.CUEN_COD, NEW.PROY_COD, NEW.CENT_COD, FECHA, NEW.CODE_DEBITO, NEW.CODE_CREDITO);
EXECUTE PROCEDURE ACTUALICE_SALDO_CENTRO_TERCERO(NEW.CUEN_COD, NEW.PROY_COD, NEW.CENT_COD, NEW.TERC_NIT, FECHA, NEW.CODE_DEBITO, NEW.CODE_CREDITO);
if (NEW.ARTI_COD IS NOT NULL) then
  BEGIN
  SELECT CUEN_TIPO FROM CUENTAS WHERE CUEN_COD = NEW.CUEN_COD INTO :TIPO;
  if (TIPO = 'I') then
    EXECUTE PROCEDURE ACTUALICE_SALDO_ARTICULO(NEW.CUEN_COD, NEW.ARTI_COD, FECHA, NEW.code_debito, NEW.code_credito);
  ELSE
    EXECUTE PROCEDURE actualice_saldo_activo(NEW.CUEN_COD, NEW.ARTI_COD, FECHA, NEW.code_debito, NEW.code_credito);
  END
END
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON COMPROBANTE_DETALLE TO TRIGGER COMPROBANTE_DETALLE_AU;
GRANT SELECT ON COMPROBANTE_ENCABEZADO TO TRIGGER COMPROBANTE_DETALLE_AU;
GRANT EXECUTE ON PROCEDURE ACTUALICE_SALDO_CENTRO_TERCERO TO TRIGGER COMPROBANTE_DETALLE_AU;
GRANT EXECUTE ON PROCEDURE ACTUALICE_SALDO_CENTRO TO TRIGGER COMPROBANTE_DETALLE_AU;
GRANT EXECUTE ON PROCEDURE ACTUALICE_SALDO_TERCERO TO TRIGGER COMPROBANTE_DETALLE_AU;
GRANT EXECUTE ON PROCEDURE ACTUALICE_SALDO_CUENTA TO TRIGGER COMPROBANTE_DETALLE_AU;
GRANT SELECT ON CUENTAS TO TRIGGER COMPROBANTE_DETALLE_AU;
GRANT EXECUTE ON PROCEDURE ACTUALICE_SALDO_ARTICULO TO TRIGGER COMPROBANTE_DETALLE_AU;
GRANT EXECUTE ON PROCEDURE ACTUALICE_SALDO_ACTIVO TO TRIGGER COMPROBANTE_DETALLE_AU;

SET TERM ^ ;

CREATE OR ALTER TRIGGER COMPROBANTE_DETALLE_AD FOR COMPROBANTE_DETALLE
ACTIVE AFTER DELETE POSITION 0
AS
DECLARE VARIABLE FECHA CHAR(8);
DECLARE VARIABLE DIF_DB NUMERIC(15,2);
DECLARE VARIABLE DIF_CR NUMERIC(15,2);
declare variable TIPO CHAR(1);
BEGIN
/* DESHAGA LO VIEJO */
SELECT ENCO_FECHA FROM COMPROBANTE_ENCABEZADO WHERE ENCO_CONSEC = OLD.ENCO_CONSEC INTO :FECHA;
DIF_DB = - OLD.CODE_DEBITO;
DIF_CR = - OLD.CODE_CREDITO;
EXECUTE PROCEDURE ACTUALICE_SALDO_CENTRO_TERCERO(OLD.CUEN_COD, OLD.PROY_COD, OLD.CENT_COD, OLD.TERC_NIT, FECHA, DIF_DB, DIF_CR);
EXECUTE PROCEDURE ACTUALICE_SALDO_CENTRO(OLD.CUEN_COD, OLD.PROY_COD, OLD.CENT_COD, FECHA, DIF_DB, DIF_CR);
EXECUTE PROCEDURE ACTUALICE_SALDO_TERCERO(OLD.CUEN_COD, OLD.TERC_NIT, FECHA, DIF_DB, DIF_CR);
EXECUTE PROCEDURE ACTUALICE_SALDO_CUENTA(OLD.CUEN_COD, FECHA, DIF_DB, DIF_CR);
if (OLD.ARTI_COD IS NOT NULL) then
  BEGIN
  SELECT CUEN_TIPO FROM CUENTAS WHERE CUEN_COD = OLD.CUEN_COD INTO :TIPO;
  if (TIPO = 'I') then
    EXECUTE PROCEDURE ACTUALICE_SALDO_ARTICULO(OLD.CUEN_COD, OLD.ARTI_COD, FECHA, DIF_DB, DIF_CR);
  ELSE
    EXECUTE PROCEDURE actualice_saldo_activo(OLD.CUEN_COD, OLD.ARTI_COD, FECHA, DIF_DB, DIF_CR);
  END
END
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON COMPROBANTE_DETALLE TO TRIGGER COMPROBANTE_DETALLE_AD;
GRANT SELECT ON COMPROBANTE_ENCABEZADO TO TRIGGER COMPROBANTE_DETALLE_AD;
GRANT EXECUTE ON PROCEDURE ACTUALICE_SALDO_CENTRO_TERCERO TO TRIGGER COMPROBANTE_DETALLE_AD;
GRANT EXECUTE ON PROCEDURE ACTUALICE_SALDO_CENTRO TO TRIGGER COMPROBANTE_DETALLE_AD;
GRANT EXECUTE ON PROCEDURE ACTUALICE_SALDO_TERCERO TO TRIGGER COMPROBANTE_DETALLE_AD;
GRANT EXECUTE ON PROCEDURE ACTUALICE_SALDO_CUENTA TO TRIGGER COMPROBANTE_DETALLE_AD;
GRANT SELECT ON CUENTAS TO TRIGGER COMPROBANTE_DETALLE_AD;
GRANT EXECUTE ON PROCEDURE ACTUALICE_SALDO_ARTICULO TO TRIGGER COMPROBANTE_DETALLE_AD;
GRANT EXECUTE ON PROCEDURE ACTUALICE_SALDO_ACTIVO TO TRIGGER COMPROBANTE_DETALLE_AD;

SET TERM ^ ;

CREATE OR ALTER TRIGGER TI_COMPROBANTE_DETALLE FOR COMPROBANTE_DETALLE
ACTIVE BEFORE INSERT POSITION 0
AS
DECLARE VARIABLE NUMROWS INTEGER;
BEGIN
    /*  PARENT 'CUENTAS' MUST EXIST WHEN INSERTING A CHILD IN 'COMPROBANTE_DETALLE'  */
    IF (NEW.CUEN_COD IS NOT NULL) THEN
    BEGIN
       SELECT COUNT(*)
       FROM   CUENTAS
       WHERE  CUENTAS.CUEN_COD = NEW.CUEN_COD
       INTO   :NUMROWS;
       IF (NUMROWS = 0) THEN
        BEGIN
        EXCEPTION CUENTA_NO_EXISTE 'La cuenta ' || new.cuen_cod || ' no existe.';
        END
    END
    /*  PARENT 'COMPROBANTE_ENCABEZADO' MUST EXIST WHEN INSERTING A CHILD IN 'COMPROBANTE_DETALLE'  */
    IF (NEW.ENCO_CONSEC IS NOT NULL) THEN
    BEGIN
       SELECT COUNT(*)
       FROM   COMPROBANTE_ENCABEZADO
       WHERE  COMPROBANTE_ENCABEZADO.ENCO_CONSEC = NEW.ENCO_CONSEC
       INTO   :NUMROWS;
       IF (NUMROWS = 0) THEN
       BEGIN
          EXCEPTION COMPROBAENCABEZA_NO_EXISTE;
       END
    END
    IF (NEW.TERC_NIT IS NOT NULL) THEN
    BEGIN
       SELECT COUNT(*)
       FROM   TERCEROS
       WHERE  TERCEROS.TERC_NIT = NEW.TERC_NIT
       INTO   :NUMROWS;
       IF (NUMROWS = 0) THEN
       BEGIN
          EXCEPTION tercero_no_existe 'El NIT ' || new.terc_nit || ' no existe.';
       END
    END
    IF (NEW.PROY_COD IS NOT NULL) THEN
    BEGIN
       SELECT COUNT(*)
       FROM   PROYECTOS
       WHERE  PROYECTOS.PROY_COD = NEW.PROY_COD
       INTO   :NUMROWS;
       IF (NUMROWS = 0) THEN
       BEGIN
          EXCEPTION proyecto_no_existe 'El proyecto ' || new.proy_cod || ' no existe.';
       END
    END
    IF (NEW.CENT_COD IS NOT NULL) THEN
    BEGIN
       SELECT COUNT(*)
       FROM   CENTROS
       WHERE  CENTROS.CENT_COD = NEW.CENT_COD AND CENTROS.PROY_COD = NEW.PROY_COD
       INTO   :NUMROWS;
       IF (NUMROWS = 0) THEN
       BEGIN
          EXCEPTION centro_no_existe 'El centro ' || new.proy_cod || '-' || new.cent_cod || ' no existe.';
       END
    END
END
^

SET TERM ; ^

GRANT UPDATE,REFERENCES ON COMPROBANTE_DETALLE TO TRIGGER TI_COMPROBANTE_DETALLE;
GRANT SELECT ON CUENTAS TO TRIGGER TI_COMPROBANTE_DETALLE;
GRANT SELECT ON COMPROBANTE_ENCABEZADO TO TRIGGER TI_COMPROBANTE_DETALLE;
GRANT SELECT ON TERCEROS TO TRIGGER TI_COMPROBANTE_DETALLE;
GRANT SELECT ON PROYECTOS TO TRIGGER TI_COMPROBANTE_DETALLE;
GRANT SELECT ON CENTROS TO TRIGGER TI_COMPROBANTE_DETALLE;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE IMPR_COMPROBANTE(
    ID INTEGER)
RETURNS (
    TIPO VARCHAR(3),
    PREF VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA CHAR(8),
    CONCEPTO VARCHAR(60),
    REFER VARCHAR(8),
    NOMTIPO VARCHAR(60),
    ITEM INTEGER,
    CUENTA VARCHAR(20),
    NOMCUENTA VARCHAR(60),
    NIT VARCHAR(20),
    NOMTERCERO VARCHAR(60),
    PROYECTO VARCHAR(4),
    CENTRO VARCHAR(4),
    NOMPROY VARCHAR(60),
    NOMCENT VARCHAR(60),
    ITCONCEPTO VARCHAR(60),
    ITREFER VARCHAR(8),
    ARTICULO VARCHAR(15),
    NOMARTIC VARCHAR(60),
    DEBITO NUMERIC(18,2),
    CREDITO NUMERIC(18,2),
    BASE NUMERIC(18,2),
    PORC NUMERIC(9,4),
    NUMDOC VARCHAR(8),
    NUMAPLICA VARCHAR(8),
    VENCE CHAR(8),
    TIPODOC VARCHAR(8),
    TIPODOCAP VARCHAR(8))
AS
declare variable ITEMS INTEGER;
declare variable MAX_COMPROBA INTEGER;
declare variable TIPOCUEN CHAR(1);
BEGIN
  /*  */
  SELECT E.TICO_COD, PRCO_PREF, ENCO_NUMERO, ENCO_FECHA, ENCO_CONCEPTO, ENCO_REFER, TICO_NOM
    FROM COMPROBANTE_ENCABEZADO E, TIPO_COMPROBANTE T WHERE E.TICO_COD = T.TICO_COD AND E.ENCO_CONSEC = :ID into
    :TIPO, :PREF, :NUMERO, :FECHA, :CONCEPTO, :REFER, NOMTIPO;
  FOR
    SELECT CODE_ITEM, D.CUEN_COD, C.CUEN_NOM, D.TERC_NIT, TERC_NOM, D.PROY_COD, D.CENT_COD, PROY_NOM, CENT_NOM, CODE_CONCEPTO, CODE_REFER, D.ARTI_COD, CODE_DEBITO, CODE_CREDITO, CODE_BASE, CODE_PORC, CNDE_DOCNUMERO, CNDE_DOCAPLICA, DOCO_VENCE, CODE_TIPONUE, CODE_TIPOAPL
    FROM COMPROBANTE_DETALLE D, CUENTAS C, TERCEROS T, PROYECTOS P, CENTROS CE
    WHERE D.CUEN_COD = C.CUEN_COD AND D.TERC_NIT = T.TERC_NIT AND D.PROY_COD = P.PROY_COD AND D.CENT_COD = CE.CENT_COD AND P.PROY_COD = CE.PROY_COD AND D.ENCO_CONSEC = :ID
    ORDER BY CODE_ITEM
    INTO
    :ITEM, :CUENTA, :NOMCUENTA, :NIT, :NOMTERCERO, :PROYECTO, :CENTRO, :NOMPROY, :NOMCENT, :ITCONCEPTO, :ITREFER, :ARTICULO, :DEBITO, :CREDITO, :BASE, :PORC, :NUMDOC, :NUMAPLICA, :VENCE, :TIPODOC, :TIPODOCAP
    DO
    begin
    SELECT CUEN_TIPO FROM CUENTAS WHERE CUEN_COD = :cuenta INTO :tipocuen;
    if (tipocuen = 'I') then
        select ARTI_DES from ARTICULO where ARTI_COD = :articulo into :NOMARTIC;
    ELSE
        if (tipocuen = 'A') then
            select ACFJ_DESC from activos_fijos where ACFJ_COD = :articulo into :NOMARTIC;
    select TIDO_NOMCORTO from TIPO_DOCUMENTO where TIDO_COD = :tipodoc INTO :tipodoc;
    select TIDO_NOMCORTO from TIPO_DOCUMENTO where TIDO_COD = :tipodocap INTO :tipodocap;
    SUSPEND;
    end
  SELECT COUNT(*) FROM COMPROBANTE_DETALLE WHERE ENCO_CONSEC = :ID INTO :ITEMS;
  EXECUTE PROCEDURE LEE_CONFIGURACION('CONTABILIDAD','GENERAL','NUMERO DE ITEMS EN IMPRESION DE COMPROBANTES') returning_values :MAX_COMPROBA;
  ITEM = NULL;
  CUENTA = NULL;
  NOMCUENTA = NULL;
  NIT = NULL;
  NOMTERCERO = NULL;
  PROYECTO = NULL;
  CENTRO = NULL;
  NOMPROY = NULL;
  NOMCENT = NULL;
  ITCONCEPTO = NULL;
  ITREFER = NULL;
  ARTICULO = NULL;
  NOMARTIC = NULL;
  DEBITO = NULL;
  CREDITO = NULL;
  BASE = NULL;
  PORC = NULL;
  NUMDOC = NULL;
  NUMAPLICA = NULL;
  VENCE = NULL;
  TIPODOC = NULL;
  TIPODOCAP = NULL;
  WHILE (ITEMS < MAX_COMPROBA) DO
    BEGIN
    ITEMS = ITEMS + 1;
    SUSPEND;
    END
END
^

SET TERM ; ^

GRANT SELECT ON COMPROBANTE_ENCABEZADO TO PROCEDURE IMPR_COMPROBANTE;
GRANT SELECT ON TIPO_COMPROBANTE TO PROCEDURE IMPR_COMPROBANTE;
GRANT SELECT ON COMPROBANTE_DETALLE TO PROCEDURE IMPR_COMPROBANTE;
GRANT SELECT ON CUENTAS TO PROCEDURE IMPR_COMPROBANTE;
GRANT SELECT ON TERCEROS TO PROCEDURE IMPR_COMPROBANTE;
GRANT SELECT ON PROYECTOS TO PROCEDURE IMPR_COMPROBANTE;
GRANT SELECT ON CENTROS TO PROCEDURE IMPR_COMPROBANTE;
GRANT SELECT ON ARTICULO TO PROCEDURE IMPR_COMPROBANTE;
GRANT SELECT ON ACTIVOS_FIJOS TO PROCEDURE IMPR_COMPROBANTE;
GRANT SELECT ON TIPO_DOCUMENTO TO PROCEDURE IMPR_COMPROBANTE;
GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO PROCEDURE IMPR_COMPROBANTE;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE COMPROBANTES_ACTIVO(
    ACTIVO VARCHAR(20))
RETURNS (
    ID INTEGER,
    TIPO VARCHAR(3),
    PREFIJO VARCHAR(4),
    NUMERO VARCHAR(6),
    FECHA CHAR(8),
    CONCEPTO VARCHAR(60),
    REF VARCHAR(20),
    TIPOREF INTEGER)
AS
BEGIN
  /* TRAE LOS COMPROBANTES SEGUN EL RANGO DADO */
    FOR SELECT MAX(E.ENCO_CONSEC), MAX(TICO_COD), MAX(PRCO_PREF), MAX(ENCO_NUMERO), MAX(ENCO_FECHA), MAX(ENCO_CONCEPTO), MAX(ENCO_REFER), MAX(ENCO_TIPOREF)
        FROM COMPROBANTE_ENCABEZADO E, COMPROBANTE_DETALLE D, CUENTAS C
        WHERE E.ENCO_CONSEC = D.ENCO_CONSEC AND ARTI_COD = :activo AND C.cuen_cod = D.cuen_cod AND C.cuen_tipo = 'A'
        GROUP BY ENCO_FECHA, TICO_COD, E.ENCO_CONSEC
        ORDER BY ENCO_FECHA, TICO_COD, E.ENCO_CONSEC
        INTO :ID, :TIPO, :PREFIJO, :NUMERO, :FECHA, :CONCEPTO, :REF, :TIPOREF
        DO
            SUSPEND;
END
^

SET TERM ; ^

GRANT SELECT ON COMPROBANTE_ENCABEZADO TO PROCEDURE COMPROBANTES_ACTIVO;
GRANT SELECT ON COMPROBANTE_DETALLE TO PROCEDURE COMPROBANTES_ACTIVO;
GRANT SELECT ON CUENTAS TO PROCEDURE COMPROBANTES_ACTIVO;
grant EXECUTE on PROCEDURE comprobantes_activo to PUBLIC;

grant ALL ON RUTAS_ENTREGA TO PUBLIC;
grant ALL ON RUTERO_FAC  TO PUBLIC;

/* 20080731 */

INSERT INTO IMPORTACION_INVENTARIO (IMIN_TIPO, IMIN_DATO, IMIN_COLUMNA, IMIN_ANCHO) VALUES (10, 'TERC_TIPOID', 15, 1);
INSERT INTO IMPORTACION_INVENTARIO (IMIN_TIPO, IMIN_DATO, IMIN_COLUMNA, IMIN_ANCHO) VALUES (10, 'TERC_APELLIDO1', 16, 60);
INSERT INTO IMPORTACION_INVENTARIO (IMIN_TIPO, IMIN_DATO, IMIN_COLUMNA, IMIN_ANCHO) VALUES (10, 'TERC_APELLIDO2', 17, 60);
INSERT INTO IMPORTACION_INVENTARIO (IMIN_TIPO, IMIN_DATO, IMIN_COLUMNA, IMIN_ANCHO) VALUES (10, 'TERC_NOMBRE1', 18, 60);
INSERT INTO IMPORTACION_INVENTARIO (IMIN_TIPO, IMIN_DATO, IMIN_COLUMNA, IMIN_ANCHO) VALUES (10, 'TERC_NOMBRE2', 19, 60);

INSERT INTO IMPORTACION_INVENTARIO (IMIN_TIPO, IMIN_DATO, IMIN_COLUMNA, IMIN_ANCHO) VALUES (14, 'TERC_TIPOID', 11, 1);
INSERT INTO IMPORTACION_INVENTARIO (IMIN_TIPO, IMIN_DATO, IMIN_COLUMNA, IMIN_ANCHO) VALUES (14, 'TERC_APELLIDO1', 12, 60);
INSERT INTO IMPORTACION_INVENTARIO (IMIN_TIPO, IMIN_DATO, IMIN_COLUMNA, IMIN_ANCHO) VALUES (14, 'TERC_APELLIDO2', 13, 60);
INSERT INTO IMPORTACION_INVENTARIO (IMIN_TIPO, IMIN_DATO, IMIN_COLUMNA, IMIN_ANCHO) VALUES (14, 'TERC_NOMBRE1', 14, 60);
INSERT INTO IMPORTACION_INVENTARIO (IMIN_TIPO, IMIN_DATO, IMIN_COLUMNA, IMIN_ANCHO) VALUES (14, 'TERC_NOMBRE2', 15, 60);
COMMIT WORK;

/* 20080731B DISCRIMINAR TARIFAS DE IVA DE ENSAMBLES AL FACTURAR */

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('FACTURACION', 'DOCUMENTOS', 'FACTURAR ENSAMBLES DISCRIMINANDO TARIFAS DE IVA DE LOS COMPONENTES', 'NO', 'SI,NO', 'SI: Factura independientemente el total de cada tarifa de IVA y omite la tarifa del producto. NO: Factura el producto con la tarifa de iva definida al producto');
COMMIT WORK;

SET TERM ^ ;

CREATE OR ALTER procedure TARIFAS_ENSAMBLE (
    PRODUCTO VARCHAR(20),
    PRECIO NUMERIC(18,2),
    FECHA DATE)
returns (
    T0 NUMERIC(18,2),
    T1 NUMERIC(18,2),
    T2 NUMERIC(18,2),
    T3 NUMERIC(18,2),
    T4 NUMERIC(18,2),
    TC NUMERIC(18,2))
as
declare variable COSTO NUMERIC(18,2);
declare variable TOTAL NUMERIC(18,2);
declare variable TARIFA INTEGER;
declare variable COMPON VARCHAR(20);
declare variable CANT NUMERIC(18,4);
declare variable UNIDAD VARCHAR(8);
declare variable CONSUMO NUMERIC(18,2);
begin
T0 = 0;
T1 = 0;
T2 = 0;
T3 = 0;
T4 = 0;
TC = 0;
TOTAL = 0;
FOR SELECT ARPR_COMP, ARPR_CANT, ARPR_UNIDAD, TAIV_COD, ARTI_CONSUMO
    FROM articulos_producto P, ARTICULO A WHERE P.ARTI_COD = :PRODUCTO AND P.arpr_comp = A.arti_cod
    INTO :COMPON, :CANT, :UNIDAD, :TARIFA, :CONSUMO
    DO
    BEGIN
    EXECUTE PROCEDURE cantidad_por_factor (:COMPON, :CANT, :UNIDAD) returning_values (:cant);
    EXECUTE PROCEDURE costo_promedio (:COMPON, :FECHA) returning_values (:COSTO);
    TOTAL = TOTAL + COSTO * CANT;
    TC = TC + CONSUMO * CANT;
    if (TARIFA = 0) then
        T0 = T0 + COSTO * CANT;
    if (TARIFA = 1) then
        T1 = T1 + COSTO * CANT;
    if (TARIFA = 2) then
        T2 = T2 + COSTO * CANT;
    if (TARIFA = 3) then
        T3 = T3 + COSTO * CANT;
    if (TARIFA = 4) then
        T4 = T4 + COSTO * CANT;
    END
if (TOTAL <> 0) then
    BEGIN
    T0 = T0 * PRECIO / TOTAL;
    T1 = T1 * PRECIO / TOTAL;
    T2 = T2 * PRECIO / TOTAL;
    T3 = T3 * PRECIO / TOTAL;
    T4 = T4 * PRECIO / TOTAL;
    END
ELSE
    BEGIN
    T0 = 0;
    T1 = 0;
    T2 = 0;
    T3 = 0;
    T4 = 0;
    END
suspend;
end
^

SET TERM ; ^

GRANT SELECT ON ARTICULOS_PRODUCTO TO PROCEDURE TARIFAS_ENSAMBLE;
GRANT SELECT ON ARTICULO TO PROCEDURE TARIFAS_ENSAMBLE;
GRANT EXECUTE ON PROCEDURE CANTIDAD_POR_FACTOR TO PROCEDURE TARIFAS_ENSAMBLE;
GRANT EXECUTE ON PROCEDURE COSTO_PROMEDIO TO PROCEDURE TARIFAS_ENSAMBLE;
grant EXECUTE on PROCEDURE TARIFAS_ENSAMBLE to PUBLIC;


INSERT INTO GRUPO (GRUP_COD, GRUP_NOM, GRUP_CTAINVENT, GRUP_CTAVENTAS, GRUP_CTACOSTOS, GRUP_CTAIVACMP, GRUP_CTAIVAVNT, GRUP_COMIPOR, GRUP_COMIMONTO, GRUP_CTACOMP, GRUP_CTADEV, GRUP_CTARTFTEV, GRUP_CTARTFTEC, GRUP_RTFTEB, GRUP_RTFTEP) VALUES ('.t', 'INTERNO', NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, NULL, 0, 0);
INSERT INTO ARTICULO (ARTI_COD, GRUP_COD, SUBG_COD, MARC_COD, ARTI_DES, ARTI_DESVAR, ARTI_TIPO, ARTI_EXIST, ARTI_FECHA, ARTI_UNIDAD, ARTI_PRECIO, ARTI_CONSUMO, ARTI_IMPOTRO, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, ARTI_OBS, ARTI_FOTO, ARTI_MAX, ARTI_MIN, ARTI_DIAS, ESAR_COD, ARTI_USUARIO, TAIV_COD, ARTI_CLASE, ARTI_DIANALIS) VALUES ('.t', '.t', NULL, NULL, '', 'S', 'A', 'N', '21-JUL-2008', '', 0, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 'A', NULL, 0, 'A', NULL);
INSERT INTO ARTICULO (ARTI_COD, GRUP_COD, SUBG_COD, MARC_COD, ARTI_DES, ARTI_DESVAR, ARTI_TIPO, ARTI_EXIST, ARTI_FECHA, ARTI_UNIDAD, ARTI_PRECIO, ARTI_CONSUMO, ARTI_IMPOTRO, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, ARTI_OBS, ARTI_FOTO, ARTI_MAX, ARTI_MIN, ARTI_DIAS, ESAR_COD, ARTI_USUARIO, TAIV_COD, ARTI_CLASE, ARTI_DIANALIS) VALUES ('.t0', '.t', NULL, NULL, 'ARTICULOS EXENTOS', 'S', 'A', 'N', '31-JUL-2008', '', 0, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 'A', NULL, 0, 'A', NULL);
INSERT INTO ARTICULO (ARTI_COD, GRUP_COD, SUBG_COD, MARC_COD, ARTI_DES, ARTI_DESVAR, ARTI_TIPO, ARTI_EXIST, ARTI_FECHA, ARTI_UNIDAD, ARTI_PRECIO, ARTI_CONSUMO, ARTI_IMPOTRO, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, ARTI_OBS, ARTI_FOTO, ARTI_MAX, ARTI_MIN, ARTI_DIAS, ESAR_COD, ARTI_USUARIO, TAIV_COD, ARTI_CLASE, ARTI_DIANALIS) VALUES ('.t1', '.t', NULL, NULL, 'ARTICULOS GRAVADOS 16%', 'S', 'A', 'N', '31-JUL-2008', '', 0, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 'A', NULL, 1, 'A', NULL);
INSERT INTO ARTICULO (ARTI_COD, GRUP_COD, SUBG_COD, MARC_COD, ARTI_DES, ARTI_DESVAR, ARTI_TIPO, ARTI_EXIST, ARTI_FECHA, ARTI_UNIDAD, ARTI_PRECIO, ARTI_CONSUMO, ARTI_IMPOTRO, ARTI_PESO, ARTI_ANCHO, ARTI_ALTO, ARTI_LARGO, ARTI_OBS, ARTI_FOTO, ARTI_MAX, ARTI_MIN, ARTI_DIAS, ESAR_COD, ARTI_USUARIO, TAIV_COD, ARTI_CLASE, ARTI_DIANALIS) VALUES ('.t2', '.t', NULL, NULL, 'ARTICULOS GRAVADOS 10%', 'S', 'A', 'N', '31-JUL-2008', '', 0, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, 'A', NULL, 2, 'A', NULL);
commit work;

/* 20080801 : BUSQUEDA ARTICULOS */

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('INVENTARIO', 'ARTICULOS', 'FORMA DE HACER LAS BUSQUEDAS DE ARTICULOS DE VARIAS PALABRAS', 'EXACTA', 'EXACTA,TODAS,CUALQUIERA', 'EXACTA: Trae los artculos con exactamente las palabras en el orden dado. TODAS: Trae los artculos con todas las palabras sin importar el orden. CUALQUIERA: Trae los artculos que tengan al menos una de las palabras');
commit work;

SET TERM ^ ;

CREATE OR ALTER PROCEDURE CONSULTA_ARTICULOS_VTAS(
    FECHA DATE,
    INACTIVOS CHAR(1),
    MODULO VARCHAR(20))
RETURNS (
    CODIGO VARCHAR(20),
    DES VARCHAR(60),
    REF VARCHAR(20),
    GRUPO VARCHAR(30),
    MARCA VARCHAR(30),
    UNIDAD VARCHAR(8),
    ESTADO VARCHAR(30),
    IVA NUMERIC(9,2),
    EXISTEN NUMERIC(18,4),
    PRECIO NUMERIC(18,2),
    CLASE CHAR(1),
    OBS VARCHAR(255))
AS
DECLARE VARIABLE LISTA INTEGER;
DECLARE VARIABLE EXIST CHAR(2);
DECLARE VARIABLE SINEXIST CHAR(2);
declare variable DIG INTEGER;
BEGIN
EXISTEN = 0;
EXECUTE PROCEDURE lee_configuracion ('FACTURACION','ARTICULOS', 'VER EXISTENCIA EN CONSULTA ARTICULOS') returning_values (:EXIST);
EXECUTE PROCEDURE lee_configuracion ('FACTURACION','FACTURAS', 'CODIGO DE LA LISTA DE PRECIOS A MOSTRAR EN ARTICULOS') returning_values (:LISTA);
if (modulo = 'FACTURACION') then
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','ARTICULOS','VER ARTICULOS SIN EXISTENCIA EN CONSULTA DE ARTICULOS') returning_values (:sinexist);
else
  sinexist = 'SI';
EXECUTE PROCEDURE LEE_CONFIGURACION ('FACTURACION', 'ARTICULOS', 'REDONDEO AL MULTIPLO DE DIEZ EN PRECIOS') returning_values (DIG);
if (LISTA > 0) then
    BEGIN
    FOR select a.arti_cod, arti_des, grup_cod, arti_unidad, esar_cod, taiv_porc, marc_cod,arti_clase, SUBSTRING(ARTI_OBS FROM 1 FOR 255)
        from articulo a, tarifa_iva t
        where a.taiv_cod = t.taiv_cod and substring(a.arti_cod from 1 FOR 2) <> '.t' and
        ((:INACTIVOS = 'S') or (esar_cod = 'A') or ((:INACTIVOS = 'C') AND (esar_cod = 'N')))
        INTO :CODIGO, :DES, :GRUPO, :UNIDAD, :ESTADO, :IVA, :MARCA, :CLASE, :OBS
        do
        begin
        PRECIO = 0;
        SELECT prar_fijo PRECIO FROM precios_articulo WHERE arti_cod = :CODIGO and lipr_cod = :LISTA INTO :PRECIO;
        EXECUTE PROCEDURE redondee(PRECIO, DIG) returning_values (PRECIO);
        if (EXIST = 'SI') then
            BEGIN
            EXECUTE PROCEDURE saldo_total_inventario (:CODIGO, :FECHA) returning_values (:EXISTEN);
            if ((SINEXIST = 'SI')  or (existen <> 0)) then
                SUSPEND;
            END
        ELSE
            SUSPEND;
        select first 1 coba_cod from barras_articulo where arti_cod = :codigo into :ref;
        end
    END
ELSE
    FOR select arti_cod, arti_des, grup_cod, arti_unidad, esar_cod, taiv_porc, arti_precio, marc_cod, arti_clase, SUBSTRING(ARTI_OBS FROM 1 FOR 255)
        from articulo a, tarifa_iva t
        where a.taiv_cod = t.taiv_cod and substring(a.arti_cod from 1 FOR 2) <> '.t' and
        ((:INACTIVOS = 'S') or (esar_cod = 'A') or ((:INACTIVOS = 'C') AND (esar_cod = 'N')))
        INTO :CODIGO, :DES, :GRUPO, :UNIDAD, :ESTADO, :IVA, :PRECIO, :MARCA, :CLASE, :OBS
        do
        begin
        if (EXIST = 'SI') then
            BEGIN
            EXECUTE PROCEDURE saldo_total_inventario (:CODIGO, :FECHA) returning_values (:EXISTEN);
            if ((SINEXIST = 'SI') or (existen <> 0)) then
                SUSPEND;
            END
        ELSE
            SUSPEND;
        select first 1 coba_cod from barras_articulo where arti_cod = :codigo into :ref;
        end
END
^

SET TERM ; ^

GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO PROCEDURE CONSULTA_ARTICULOS_VTAS;
GRANT SELECT ON ARTICULO TO PROCEDURE CONSULTA_ARTICULOS_VTAS;
GRANT SELECT ON TARIFA_IVA TO PROCEDURE CONSULTA_ARTICULOS_VTAS;
GRANT SELECT ON PRECIOS_ARTICULO TO PROCEDURE CONSULTA_ARTICULOS_VTAS;
GRANT EXECUTE ON PROCEDURE REDONDEE TO PROCEDURE CONSULTA_ARTICULOS_VTAS;
GRANT EXECUTE ON PROCEDURE SALDO_TOTAL_INVENTARIO TO PROCEDURE CONSULTA_ARTICULOS_VTAS;

/* 20080804 */
ALTER TABLE GRUPO ADD GRUP_DTO T_PORCENTAJE;

/* 20080805 */
SET TERM ^ ;

CREATE OR ALTER PROCEDURE CONSULTA_ARTICULOS_VTAS(
    FECHA DATE,
    INACTIVOS CHAR(1),
    MODULO VARCHAR(20))
RETURNS (
    CODIGO VARCHAR(20),
    DES VARCHAR(60),
    REF VARCHAR(20),
    GRUPO VARCHAR(30),
    MARCA VARCHAR(30),
    UNIDAD VARCHAR(8),
    ESTADO VARCHAR(30),
    IVA NUMERIC(9,2),
    EXISTEN NUMERIC(18,4),
    PRECIO NUMERIC(18,2),
    CLASE CHAR(1),
    OBS VARCHAR(255))
AS
DECLARE VARIABLE LISTA INTEGER;
DECLARE VARIABLE EXIST CHAR(2);
DECLARE VARIABLE SINEXIST CHAR(2);
declare variable DIG INTEGER;
BEGIN
EXISTEN = 0;
EXECUTE PROCEDURE lee_configuracion ('FACTURACION','ARTICULOS', 'VER EXISTENCIA EN CONSULTA ARTICULOS') returning_values (:EXIST);
EXECUTE PROCEDURE lee_configuracion ('FACTURACION','FACTURAS', 'CODIGO DE LA LISTA DE PRECIOS A MOSTRAR EN ARTICULOS') returning_values (:LISTA);
if (modulo = 'FACTURACION') then
  EXECUTE PROCEDURE lee_configuracion ('FACTURACION','ARTICULOS','VER ARTICULOS SIN EXISTENCIA EN CONSULTA DE ARTICULOS') returning_values (:sinexist);
else
  sinexist = 'SI';
EXECUTE PROCEDURE LEE_CONFIGURACION ('FACTURACION', 'ARTICULOS', 'REDONDEO AL MULTIPLO DE DIEZ EN PRECIOS') returning_values (DIG);
if (LISTA > 0) then
    BEGIN
    FOR select a.arti_cod, arti_des, grup_cod, arti_unidad, esar_cod, taiv_porc, marc_cod,arti_clase, SUBSTRING(ARTI_OBS FROM 1 FOR 255)
        from articulo a, tarifa_iva t
        where a.taiv_cod = t.taiv_cod and substring(a.arti_cod from 1 FOR 2) <> '.t' and
        ((:INACTIVOS = 'S') or (esar_cod = 'A') or ((:INACTIVOS = 'C') AND (esar_cod = 'N')))
        INTO :CODIGO, :DES, :GRUPO, :UNIDAD, :ESTADO, :IVA, :MARCA, :CLASE, :OBS
        do
        begin
        PRECIO = 0;
        SELECT prar_fijo PRECIO FROM precios_articulo WHERE arti_cod = :CODIGO and lipr_cod = :LISTA INTO :PRECIO;
        EXECUTE PROCEDURE redondee(PRECIO, DIG) returning_values (PRECIO);
        select first 1 coba_cod from barras_articulo where arti_cod = :codigo into :ref;
        if (EXIST = 'SI') then
            BEGIN
            EXECUTE PROCEDURE saldo_total_inventario (:CODIGO, :FECHA) returning_values (:EXISTEN);
            if ((SINEXIST = 'SI')  or (existen <> 0)) then
                SUSPEND;
            END
        ELSE
            SUSPEND;
        end
    END
ELSE
    FOR select arti_cod, arti_des, grup_cod, arti_unidad, esar_cod, taiv_porc, arti_precio, marc_cod, arti_clase, SUBSTRING(ARTI_OBS FROM 1 FOR 255)
        from articulo a, tarifa_iva t
        where a.taiv_cod = t.taiv_cod and substring(a.arti_cod from 1 FOR 2) <> '.t' and
        ((:INACTIVOS = 'S') or (esar_cod = 'A') or ((:INACTIVOS = 'C') AND (esar_cod = 'N')))
        INTO :CODIGO, :DES, :GRUPO, :UNIDAD, :ESTADO, :IVA, :PRECIO, :MARCA, :CLASE, :OBS
        do
        begin
        select first 1 coba_cod from barras_articulo where arti_cod = :codigo into :ref;
        if (EXIST = 'SI') then
            BEGIN
            EXECUTE PROCEDURE saldo_total_inventario (:CODIGO, :FECHA) returning_values (:EXISTEN);
            if ((SINEXIST = 'SI') or (existen <> 0)) then
                SUSPEND;
            END
        ELSE
            SUSPEND;
        end
END
^

SET TERM ; ^

GRANT EXECUTE ON PROCEDURE LEE_CONFIGURACION TO PROCEDURE CONSULTA_ARTICULOS_VTAS;
GRANT SELECT ON ARTICULO TO PROCEDURE CONSULTA_ARTICULOS_VTAS;
GRANT SELECT ON TARIFA_IVA TO PROCEDURE CONSULTA_ARTICULOS_VTAS;
GRANT SELECT ON PRECIOS_ARTICULO TO PROCEDURE CONSULTA_ARTICULOS_VTAS;
GRANT EXECUTE ON PROCEDURE REDONDEE TO PROCEDURE CONSULTA_ARTICULOS_VTAS;
GRANT SELECT ON BARRAS_ARTICULO TO PROCEDURE CONSULTA_ARTICULOS_VTAS;
GRANT EXECUTE ON PROCEDURE SALDO_TOTAL_INVENTARIO TO PROCEDURE CONSULTA_ARTICULOS_VTAS;


/* 20080806 */

INSERT INTO CONFIGURACION (CONF_MODULO, CONF_CATEGORIA, CONF_PROPIEDAD, CONF_VALOR, CONF_POSIBLES, CONF_AYUDA) VALUES ('FACTURACION', 'DOCUMENTOS', 'PERMITIR MODIFICAR MANUALMENTE EL MONTO DE LAS RETENCIONES', 'NO', 'SI,NO', 'SI: Permite digitar un valor manual en el monto de las retenciones, el porcentaje se deja en cero. NO: Slo se permite digitar un porcentaje y con ese se calcula el monto.');
commit work;

GRANT EXECUTE ON PROCEDURE BUSQUEDA_REMISIONES TO PUBLIC;

GRANT ALL ON PUNTO_EQUILIBRIO TO PUBLIC;
GRANT ALL ON ACTIVOS_FIJOS TO PUBLIC;

update revision set revi_FECHA = '2008/08/06';
COMMIT WORK;

